Welcome to PC-DMIS

Welcome to PC-DMIS 4.3 MR1

In This File
 | Explore the new features offered in this version
 | Browse the Core help file

On the Internet
 | Download a printable manual
 | Visit WAI's web site
 | Submit Feedback
 | Visit WAI's technical support page
 | Download the most recent help files

Available Help Systems:

PC-DMIS Core

PC-DMIS CMM

PC-DMIS Vision

PC-DMIS Laser

PC-DMIS Portable

PC-DMIS/NC

PC-DMIS IP

Direct CAD Interfaces

Flexible Fixturing

TutorTranslator

PCDBASIC

PC-DMIS Settings Editor

PC-DMIS Web Reporter

PC-DMIS DataPage/RT

New To Reporting?

Follow the reporting tutorials here!

View Additional Reporting Tutorials Online

For ways on finding information in this help file, see the "Using the Online Help" section.

Help Last Updated: December 1, 2008


Copyright and Legal Information

Copyright, Trademarks, and Legal Information

Copyrights

Copyright © 1999-2001, 2002-2008 Hexagon Metrology and Wilcox Associates Incorporated. All rights reserved.

Trademarks

PC-DMIS, Direct CAD, Tutor for Windows, Remote Panel Application, DataPage, and Micro Measure IV are either registered trademarks or trademarks of Hexagon Metrology and Wilcox Associates, Incorporated.

SPC-Light is a trademark of Lighthouse.

HyperView is a trademark of Dundas Software Limited and HyperCube Incorporated.

Orbix 3 is a trademark of IONA Technologies.

I-DEAS and Unigraphics are either trademarks or registered trademarks of EDS.

Pro/ENGINEER is a registered trademark of PTC.

CATIA is either a trademark or registered trademark of Dassault Systemes and IBM Corporation.

ACIS is either a trademark or registered trademark of Spatial and Dassault Systemes.

3DxWare is either a trademark or registered trademark of 3Dconnexion.

lp_solve is a free software package licensed and used under the GNU LGPL.

lpsolve information

PC-DMIS for Windows version 4.0 and beyond uses a free, open source package called lp_solve (or lpsolve) that is distributed under the GNU lesser general public license (LGPL).

lpsolve citation data

----------------------

Description: Open source (Mixed-Integer) Linear Programming system

Language: Multi-platform, pure ANSI C / POSIX source code, Lex/Yacc based parsing

Official name: lp_solve (alternatively lpsolve)

Release data: Version 5.1.0.0 dated 1 May 2004

Co-developers: Michel Berkelaar, Kjell Eikland, Peter Notebaert

Licence terms: GNU LGPL (Lesser General Public Licence)

Citation policy: General references as per LGPL

Module specific references as specified therein

You can get this package from:

http://groups.yahoo.com/group/lp_solve/


PC-DMIS Core

PC-DMIS Core Help File

Using the Online Help

Getting Started: An Overview

Navigating the User Interface

Using Basic File Options

Using Advanced File Options

Setting Your Preferences

Editing the CAD Display

Editing a Part Program

Using the Edit Window

Using Other Windows, Editors, and Tools

Using Toolbars

Defining Hardware

Creating Auto Features

Creating Measured Features

Constructing New Features from Existing Features

Creating Generic Features

Creating and Using Alignments

Dimensioning Features

Using Feature Control Frames

Scanning Your Part

Inserting Move Commands

Branching by Using Flow Control

Tracking Statistical Data

Reporting Measurement Results

Inserting Report Commands

Using File Input / Output

Using Expressions and Variables

Adding External Elements

Using Multiple Arm Mode

Navigating and Displaying Multiple Windows

Working in Off-line Mode

Translating DOS/AVAIL into PC-DMIS

Using a Wrist Device

Working in Operator Mode

Using Shortcut Keys and Shortcut Menus

Error Codes

Modifying Registry Entries


Using the Online Help

Using the Online Help: Introduction

An Overview of the Help File's Interface

Getting Help by Pressing the F1 Function Key

Searching the Help by Browsing Contents and Topics

Searching the Help for Matching Text

Searching the Help with Index Terms

Using the Dynamic Roadmap

Storing Favorite Help Topics

Changing Help File Options

Troubleshooting the Help File

Connecting to Internet Support


Using the Online Help: Introduction

This section describes how to use the PC-DMIS help files that are installed with PC-DMIS.

Display Menu Roadmap

The following major topics are available in this section:

  • An Overview of the Help File's Interface

  • Getting Help by Pressing the F1 Function Key

  • Searching the Help by Browsing Contents and Topics

  • Searching the Help for Matching Text

  • Searching the Help with Index Terms

  • Using the Dynamic Roadmap

  • Storing Favorite Help Topics

  • Changing Help File Options

  • Troubleshooting the Help File

  • Connecting to Internet Support


An Overview of the Help File's Interface

An Overview of the Help File's Structure and Interface

When you install PC-DMIS, you are supplied with a compiled HTML Help file (a file with a .chm extension) that resides in the same directory as the PC-DMIS executable. Double clicking on this file, or pressing F1 at any time inside PC-DMIS, launches the core PC-DMIS Help File inside of an HTML Help viewer. The PC-DMIS Help file initially shows a welcome topic. This topics contains links to all the other installed help files as well as information to get you started with that particular version of PC-DMIS:

The PC-DMIS Help File

Toolbar:

The Toolbar contains these buttons:

  • Show / Hide – This button shows and hides the Search Pane. The Search Pane contains the Contents, index, Search, Favorites, and Glossary tabs used to browse through or search for topics. (In non-English versions, the Glossary is sometimes displayed in toolbar.)

  • Locate – This button synchronizes the topic you're currently viewing in the Topic Pane with the expandable and collapsible view of the topics in the Contents tab, essentially locating the topic in the Contents tab. Synchronization with the Contents tab is usually done automatically without needing to click this button, but there are times when it is needed. See "Searching the Help by Browsing Contents and Topics" for more information.

  • Back / Forward – These buttons act just like the back and forward buttons on an internet browser. They store the topics you are visiting when browsing through the help file and you can easily cycle backward to topics viewed in the past or forward to the most recently viewed topics.

  • Home – This button opens the introductory welcome topic for the PC-DMIS Help Files. From the welcome topic you can get links to all the installed help files.

  • Print – This button lets you print the contents of the Topic Pane. Clicking this will display a standard Print dialog box where you can choose the printer to accept the topic's content. This is good for quick printouts of one or two topics. If you need several topics printed in a printable manual format you might want to consider downloading a printable manual. To do this, follow the link on the welcome topic.

  • Options – Allows you to set miscellaneous options for the Help file.

Search Pane: Clicking the Show button opens the Search Pane. This pane displays the following tabs that are used to search for and store topics (clicking Hide hides this pane):

  • Contents – This tab allows you to search by contents. See "Searching the Help by Browsing Contents and Topics".

  • Index – This tab allows you to search by index entry. See "Searching the Help with Index Terms"

  • Search – This tab allows you to search for matching text. See "Searching the Help for Matching Text"

  • Favorites – This tab allows you to store favorite topics for later use. See "Storing Favorite Help Topics"

  • Glossary – This tab displays descriptions of various terms used in the help file.

The rest of this section discusses how to search for topics and store topics.

Browse Sequences: Browse sequences exist in a special area between the Toolbar area and Topic Pane:

They provide you with a an alternate way to browse between a series of topics. Note, that it only goes through items at the topic's current tree level in the Contents tab. (Browse sequences are not available for non-English help systems.)

Topic Pane: The Topic Pane displays is the main part of the Help File. It displays the content for selected topics.


Getting Help by Pressing the F1 Function Key

You can press the F1 function key at any time to bring up the online Help. You can also use the F1 function key in different contexts to find specific topics more quickly:

  • Dialog Boxes: Access a dialog box. Press F1 while it's open and has the program focus. PC-DMIS displays the Help topic associated with that dialog box.

  • Toolbar Icons: Hover your mouse over a toolbar icon in the main toolbar area until the yellow ToolTip appears. Press F1. PC-DMIS displays the Help topic that discusses that icon.

Hint: With toolbar icons, if either the yellow ToolTip or the help topic doesn't readily appear, click on the main PC-DMIS window a couple of times to give it the focus and try again.

  • Menu Items: Hover your mouse over a menu item (not over a menu heading) on the menu bar. Press F1. PC-DMIS displays the Help topic associated with that menu option.

  • Commands: Access the Edit window. Place it into Command Mode. Click on a command and press F1. PC-DMIS displays the Help topic associated with that command.


Searching the Help by Browsing Contents and Topics

Display Menu Roadmap

T [image] he help file lets you browse through the help by links in the topics or by the clicking on expanding entries within the Contents tab.

To use the Contents tab:

  1. Select Help | Index to access the PC-DMIS Help File.

  2. If the Index tab isn't already displayed, click the Show button to display the Search Pane.

  3. Click on the Contents tab on the Search Pane. The Help file displays a list of sections.

  4. Find the main topic you want to view and click the Plus Sign (+) next to the topic you want to view. The list expands showing subtopics.

  5. Select a topic to view and its contents will appear. You can also cycle through the topics by using Browse Sequences within the topics themselves.

Using the Locate Button

When you click on a link within a topic, the Contents tab usually synchronizes with the topic. Sometimes, however, when you use F1 on a specific item, or when you call a stored topic from the Favorites tab, the topic doesn’t automatically get synchronized with the item in the Contents tab. Use the Locate button on the toolbar in those cases.

Hint - Use the Locate Button to View a Topic in Context: Often when pulling up a topic using the Index tab or the Search tab, you may want to find out the current topic's context or maybe find its parent topic. You can view other topics around the current topic by clicking the Locate button on your toolbar. PC-DMIS will automatically display the Contents tab and will locate the topic within the tree view. This helps you know where your current topic is within the overall documentation structure and can also provide you with needed contextual information.


Searching the Help with Index Terms

Display Menu Roadmap

The Index tab lets you search for topics by using predefined keywords. If you can't readily find a topic in the Index tab, consider using the Search tab. See "Searching the Help for Matching Text".

To use the Index tab.

  1. Select Index | Help to access the PC-DMIS Help File.

  2. If the Index tab isn't already displayed, click the Show button to display the tabs.

  3. Click on the Index tab. Type a possible index term in the Type in the keyword to find: box. If you can't find a topic for the term you're using, try using a different but similar word.

  4. When you find the topic you want to view click the Display button or double-click on the topic. Often, a topic contains a list of subtopics. In this case, a Topics Found dialog box will appear allowing you to select a subtopic for display.


Searching the Help for Matching Text

Display Menu Roadmap

Often you will search first for information using the Index tab on the Search Pane. However, this may not yield the desired topic because Index are created based on defined keywords. You may be thinking a topic should be using a different keyword than it actually does. If you can't find what you're looking for in the Index tab, use the Search tab.

Using this tab, you can search within titles and topic text for a specific word or phrase and even exclude words.

To use the Search tab:

  1. Access the PC-DMIS Help File.

  2. Click the Show button to display the tabs.

  3. Click on the Search tab. Type the text to search for in the Type in the word(s) to search for: box. If you place the text in quotation marks, the help file will attempt to find that exact phrase; otherwise, the help file will try to find all the words in any order. A list of topics appears in the Topics list below.

  4. Double-click on the topic to view or click Display. The selected topic appears. The Help file will highlight all the terms that match your typed selection. To turn off this highlight, access the Options button from the PC-DMIS Help File toolbar.

These check boxes at the bottom of the Search tab help to limit or expand your search.

  • Search previous results – This check box allows you to search within the existing results. This is helpful if the help returned numerous topics and you want to limit the search.

  • Match similar words – This check box allows you to expand your search to similar word forms. For example if you're looking for Export and select this check box, the Help file would return topics with Export-ed, Export-ing etc.

  • Search Titles Only – This check box limits your search by only searching within topic titles and not subject matter.

Some Searching Tips:

Are you looking for information on a particular dialog box? One way of course is to open the dialog box and press F1. Another way is to type the dialog box's title followed by the term "dialog box" all in quotation marks. So, to find topics where the View Setup dialog box is listed, type "view setup dialog box".

You can also do this for buttons, check boxes, option buttons, toolbar icons and so on.

So, to find information on the Scale to Fit icon, you could just type "Scale to Fit" in the Search box. Or to limit it even further, you could type:

"Scale to Fit" icon

This finds the phrase "Scale to Fit" along with the word "icon" somewhere in the topic.

Expanding or Limiting Your Searching Using AND, NEAR, OR, and NOT Keywords:

You can use special keywords to limit or expand your search results.

  • AND - Use this keyword to limit your search, returning topics that contain all your search terms.

  • NEAR - Use this to limit your search to find a word or phrase near in proximity to your other search terms.

  • OR - Use this to expand your search, returning topics that contain either one search term OR other search terms.

  • NOT - Use this to limit your search, returning topics that do NOT include the specified search term.

These are probably best explained by providing you with an example.

Suppose you want to find topics that discuss the View Setup dialog box.

You could start with both terms. Maybe you want to find all the topics containing either "View" or "Setup". To do this you would use the OR keyword. It expands your search to include topics that contained either search term. For example, if you typed:

View OR Setup

The help file would list all topics containing either the word "View" or the word "Setup".

But you'll end up with the maximum number of search results of 500 topics. That's way too many to search through. You need to limit your search. You could then type:

View AND Setup

The AND keyword searches for topics that have both the word "View" and the word "Setup" somewhere in that topic. Alternately, you simply remove the AND keyword, using this instead:

View Setup

This gives you the same results as if you used the AND keyword between the two words.

To further limit your search, you could instead search for terms near in proximity to each other, by using the use NEAR keyword:

View NEAR Setup

This finds the word "View" in close proximity (within a few lines) of the word "Setup". If the two words were separated by several lines or pages of text, that topic would be excluded.

To further limit your search, you can search for an exact match, by placing the search terms within quotation marks:

“View Setup”

This would return any topic containing the exact phrase "View Setup". This is better, but you'll still get some topics that discuss the "Live View Setup".

To exclude topics containing a word or phrase, use the NOT keyword. For example, if you don't want the word "Live" because the Live View is a PC-DMIS Vision functionality, you could type:

“View Setup” NOT Live

This will find all topics with the exact phrase “View Setup” but excluding anything about the Live View Setup dialog box covered in PC-DMIS Vision.

You can also combine these keywords together, providing you with even more powerful search phrases. For example, if you wanted to see all topics that discussed either the View Setup dialog box or the Live View Setup but didn't want any Settings Editor information, you could type:

"View Setup dialog" OR Live NEAR "View Setup" NOT "Settings Editor"

Understanding the search tools available to you will help you more quickly find the information you need.


Using the Dynamic Roadmap

Starting with PC-DMIS 3.5, some versions of the PC-DMIS Help File dynamically show the menu selections your should take to access a dialog box, menu item, or Edit window command discussed in a particular help topic.

  • In the PC-DMIS 3.5, the dynamic roadmap automatically appeared at the top of specific topics:

  • In the PC-DMIS 3.6 and later, the dynamic roadmap appears in a separate pop-up window when you click a small yellow icon [image] found within specific topics:

V3.5 Dynamic Roadmap Example | V3.6 and later Dynamic Roadmap Example

Roadmaps are probably most useful if you work with a customized menu layout. Since the menu pathway text found directly in the topic is static, in an environment that uses customized menu layouts, you likely wouldn't be able to use the static text to get at the desired functionality. But, by using roadmaps, you can click on the roadmap icon and the help file will query PC-DMIS and then return the menu pathway for that functionality dynamically within a pop-up window.

Important: In order for the roadmap to return the menu pathway, you must have Internet Explorer browser installed on your computer, and an instance of PC-DMIS must be running.


Storing Favorite Help Topics

You can easily store favorite topics for later use by using the Favorites tab. You may find this useful, for example, if you are frequently referring to the same topic. Perhaps this is something like the File Input / Output topics or if you do scripting inside PC-DMIS Reporting functionality, maybe the topic on Reporting Expressions. If you find yourself frequently accessing a topic, consider storing it as a favorite topic. You can then easily access it later even after closing your Help file.

To use the Favorites tab:

  1. Access the PC-DMIS Help File.

  2. Click the Show button to display the tabs.

  3. Use a search method to find a topics you want to save.

  4. Click the Favorites tab. In the Current Topic box you'll see the topic title for the topic displayed in the right-hand Topic Pane.

  5. Click the Add button. PC-DMIS adds the topic to the Topics list in the Favorites tab.

  6. To view a stored favorite topic, simply double-click the topic in the Topics list or click the Display button.

  7. To remove stored topics, select the topic and click Remove.

Hint: You can even rename your stored favorites to whatever you like by right-clicking on the topic from the Topics list and selecting Rename.


Changing Help File Options

Using the Options button from the toolbar, you can change various options on the Help file.

  • Hide Tabs / Show Tabs - This acts as the Hide / Show buttons on the toolbar.

  • Locate - This acts as the Hide / Show buttons on the toolbar.

  • Back / Forward - This acts as the Back / Forward buttons on the toolbar.

  • Home - This goes to the home page associated with the Help file.

  • Stop - This stops the current process. Usually when accessing an external web page within the Help file browser, this will stop that process.

  • Refresh - Refreshes the current topic. If accessing an external web page and the content has changed since you last visited it, selecting this will display the latest content.

  • Internet Options - This accesses the Internet Options dialog box. See the help for the internet explorer.

  • Print - This sends the current topic to your printer.

  • Search Highlight Off - This turns off highlighted text in displayed topics when using the Search tab.


Troubleshooting the Help File

This topic lists some common errors you may receive when viewing the online Help file.

When viewing a Dynamic Roadmap, you get a script error:

Make sure helpmap.ocx exists and is registered on your computer system. This ActiveX component is needed to view the dynamic roadmap. Re-installing PC-DMIS or manually registering this component should fix this problem.

To manually fix this problem,

  1. Download the .ocx file from here:
    ftp://ftp.wilcoxassoc.com/docs/onlinehelp/OCX/helpmap.zip

  2. Extract the helpmap.ocx file into the directory where your PC-DMIS executable resides.

  3. Navigate in a Command Prompt window to the directory containing the .ocx file.

  4. Type "regsvr32 helpmap.ocx".

When viewing a Dynamic Roadmap, the pop-up window doesn't display:

The dynamic roadmap only works with the Internet Explorer browser. On some computer systems, if you don't have Internet Explorer 6.0 or higher installed, the pop-up windows used in version 3.6 and later don't work and you may receive a script error.

To fix this problem, try installing the latest version of Internet Explorer with any patches or service packs.

Also, make sure an instance of PC-DMIS is running to view the roadmap.

When viewing a Dynamic Roadmap, a message appears telling you that it cannot display the menu roadmap because either PC-DMIS isn't running or the string isn't getting properly passed from PC-DMIS.

Make sure an instance of PC-DMIS is running. If you still get this error then there's a problem with the code used to query PC-DMIS for the dynamic roadmap display on that particular topic. Make a note of the topic title and the message and follow the proper technical support channels to get the problem resolved.


Connecting to Internet Support

Display Menu Roadmap

PC-DMIS v4.0 and later lets you connect to an internet support session, powered by WebEx, where you and a live technician can use a browser-based interface, to discuss problems, transfer files, view applications, or even share application control to more easily locate and solve your specific problem all in real time.

Important: Before you can join a remote internet support session, you must obtain the unique support session number from the support technician.

To join a remote internet support session:

  1. Select Help | Internet Support. The Internet Support dialog box appears.

  2. Fill out the fields in the dialog box: First Name, Last Name, Email Address, and Support Session Number.

  3. Click OK. PC-DMIS will launch your internet browser. If you are not already connected to the internet, your browser will prompt you to connect.

  4. Once connected, the WebEx interface launches where you and the technician can proceed to solve your specific problem.


Getting Started: An Overview

Overview: Introduction

Version Enhancements

Organization of Manual

Conventions

Mouse Terminology

Boldface Text

Italicized Text

Uppercase Text

Underlined Text

Bulleted Text

Numbered Lists

CAD Links

Using a Mouse or Motion Controller

Configuring a ZMouse

Configuring a SpaceBall or SpaceMouse Device

Available PC-DMIS Functions for SpaceMouse or SpaceBall

Assigning PC-DMIS Functions to buttons on the SpaceMouse or SpaceBall

S paceBall or SpaceMouse Modes

Automating PC-DMIS

Software Configurations

Comparison of Off-Line and On-Line Versions

On-Line Part Programming

Off-Line Part Programming

PC-DMIS Vision

PC-DMIS/NC

PC-DMIS Laser

PC-DMIS Gear


Overview: Introduction

The term "PC-DMIS" is derived from the acronym "DMIS" which stands for: Dimensional Measuring Interface Standard.

PC-DMIS for Windows is a full-featured, geometric measurement package. It translates the high-level commands required to measure parts into the detailed steps necessary to drive a Coordinate Measuring Machine (CMM). PC-DMIS for Windows incorporates Microsoft's Windows interface to create, as well as execute part programs. The user can easily begin the measurement process by taking advantage of the drop-down menus, dialog boxes, and icons. The versatility of PC-DMIS's interface also provides an easy way to customize the software to meet individual specifications.

The primary goals driving the design of PC-DMIS for Windows were flexibility and user friendliness. To meet these goals, PC-DMIS provides a flexible environment allowing for real-time error correction as opposed to the long, tedious debugging process characteristic of other geometric software packages. It is dimension oriented to reduce the need to analyze and interpret the results of CMM measurements. The techniques used for part programming on a CMM are straightforward and, with practice, systematic. This help file does not attempt to completely describe the dimensional inspection process. If additional information is needed on the fundamentals of dimensional inspections, please contact your software representative.

We hope you will enjoy using PC-DMIS and find it a useful and powerful tool. If you have any suggestions or comments, please let us know. We are always looking for ways to improve our product.

The main topics in this section include:

  • Version Enhancements

  • Organization of Manual

  • CAD Links

  • Using a Mouse or Motion Controller

  • Automating PC-DMIS

  • Software Configurations

Note: This help file contains the core documentation needed to operate PC-DMIS for Windows. However, due to PC-DMIS's modular nature, additional help files may be installed on your computer system. Click the Contents tab on your help file to view the other files installed.


Version Enhancements

The readme.txt file in your PC-DMIS installation directory lists all the bug fixes and enhancements made in this version. The major enhancements from that text file are listed here with links to the topics that describe them where applicable:

Main Enhancements

Probes

  • New algorithm for SP25 Probes (now uses CoScanning.dll file instead of older CALRSP.dll)

  • Ability to easily switch between TRAX and PMM calibration types

  • Support for Disk Styli on SP25 probes

  • New Partial Calibration procedure available for an SP25 that has been fully calibrated at least once

  • Support for LSP-X1 family of analog scanning probes

See the "Defining Hardware" section.

Auto Features

  • Ability to toggle circular moves for a plane feature

  • Ability to insert MOVE/CLEARPLANE or Stored Moves in-between an Auto Feature's basic hits

  • Ability to turn on Gap Only by default

  • Ability to use "Read Vector from Machine" icon for all Auto Features

See the "Creating Auto Features" and "Inserting Move Commands" sections.

Dimensioning

  • Selecting the "Auto" option in the Location Dimension dialog box, will indicate the automatic choices with grayed out check boxes.

  • New dimension for Length of spline

  • New True Position In-Between

  • Support for 'A' Axes and Angle Point Feature

See the "Dimensioning Features" and "Constructing New Features from Existing Features" sections.

Graphics Display

  • Ability to show the distance between two features using the CAD Info dialog

  • New DCI connection status indicator

  • Ability to toggle the display of transparency

  • Ability to alter parameters for display elements (radius, size of path lines and so forth) from a new Display Symbols dialog box.

  • Option to Auto Arrange Labels CAD Window Label

  • Tooltips functionality for features in the graphics display window

See the "Editing the CAD Display", "Using Toolbars", and "Using Shortcut Keys and Shortcut Menus" sections.

Languages

  • PC-DMIS now supports the following additional languages: Polish, Russian, and Turkish

Reporting

  • Ability to perform automation tasks with new properties of Report and Section objects

  • Ability to perform automation tasks on Custom Reports

  • Ability to report if a feature has been skipped during execution

  • Ability to have Label Layout Wizard's color ball to show dimension color for selected range of axes

  • Ability to use mouse wheel to zoom in and out on a CADReportObject inside the Report Window.

  • Ability to show dimension labels for a point cloud on the report

  • Ability for AudiDraw Converter to generate PPM and PLT(HPGL) files

  • Ability to show CAD layers on the CadReportObject

  • Ability to Mirror the CadReportObject

  • Leader Lines now terminate at two features for Distance and Angle dimensions inside a Custom Report's CadReportObject

  • Ability to control the size of text in the GridControlObject

  • Ability to scale the section cut object

  • Ability to toggle between shaded and wireframe views of a CadReportObject

  • Ability to toggle transparency for a GridControlObject

  • New report expression functions allowing the user to see the report-level OOT statistics

  • Ability to duplicate pages in a Custom Report

  • Ability to edit leader lines in the report

  • Ability to change font and size for the DimensionColorKey object

  • Ability to re-order pages on the Report Window

See the "Reporting Measurement Results" and "Inserting Report Commands" sections. For automation, see the "PCDBASIC" documentation.

Inspection Planner

  • Path Optimization now accounts for the machine volume

See the "PC-DMIS IP" documentation.

Laser

  • Ability to filter data in a laser stripe

  • Ability to scan points in learn mode from an arm or laser tracker

  • Ability to play sound events for laser events

  • Ability to do real-time shading of laser scanned data

  • Ability to extract measurement data from laser scans for laser Auto Features

  • Laser Auto Features now show measured stripe data in CAD

  • Greysum material list with associated min and max pixel intensity values

  • New Cylinder Laser Auto Feature

See the "PC-DMIS Laser" documentation.

Portable

  • Ability to indicate if they are building or inspecting to points

  • Measured points now display location for all axes

  • Ability to construct a Hidden Point

  • Probe Readouts window improvements can now report the current feature based on the location of the probe/reflector when executing

  • Ability to control if the data is displayed as probe compensated or not

  • Deviations in the Probe Readout window are now colored according to the dimension tolerance color

  • New stable point probing for Leica trackers

  • New Alignment allows you to specify which axes of the input feature to use during the alignment

  • New Edge Point Mode allows for walk-up measurement of sheet metal features without using the auto features dialog box

  • New Auto-Inspect mode provides automated inspection of a sequence of points using a Leica tracker

See the "PC-DMIS Portable" documentation.

Vision Measurements

  • New Polygon, Notch, Ellipse, and Angle Point Vision Auto Features

  • New Auto Feature Guess mode for Vision

  • New Quick Start support for Vision

  • Full scanning support for contact and laser probes

  • Speed improvements in edge detection

  • Speed improvements in focus

  • Ability to do selective sampling (e.g. measure 30% of feature) for speed

  • New auto sensing for focus automatically performs a focus when the edge is blurred (CAD++)

  • Ability to draw Gage arcs as arcs, not full circles

  • Ability to change Protractor Gage length without changing the angle

  • New Auto Feature button to adjust surface vector to current probe vector

See the "PC-DMIS Vision" documentation.

Vision Live View

  • New quick access toolbar buttons (Snap To Edge, AutoShutter On/Off, Compass On/Off, Show Target)

  • Additional user control added when AutoShutter and Compass features are used

  • New easy-access right-click menu items let you quickly edit or move to nearest 10 programmed features

  • New easy-access right-click menu items let you set additional edge detection parameters

See the "PC-DMIS Vision" documentation.

Vision Illumination

  • Intensity value for current mouse position now shown on live view overlay

  • SensiLight auto illumination adjustment now takes place prior to edge detection

  • Ability added to switch off illumination on vision machines at end of execution

  • Ability added to restore illumination to previous settings at PC-DMIS startup

See the "PC-DMIS Vision" documentation.

Vision Hardware

  • TESA VISIO 500 support

  • New functionality added to optionally use a projected grid during focus

  • Ability to do Temp Comp for Vision machines that support this (Visio 500 & Mycrona)

  • Added support for VISIO 300 red LED ring light

  • Stacked Rotary Table support

  • Dual Camera support

  • Matrox Solios support

  • Matrox MIL8 imaging library support

See the "PC-DMIS Vision" documentation.


Organization of Manual

Organization of the PC-DMIS Core Documentation

This help file is divided into numerous main sections and some supplemental sections.

To give you an idea of the online help's layout, the following list provides a brief description of each section.

  • "Using the Online Help" describes how to find the help you need by using the Help menu.

  • "Getting Started: An Overview" is the section you are currently reading. It gives a brief overview of the contents of the PC-DMIS Help file.

  • "Navigating the User Interface" describes the PC-DMIS user interface and how it can be customized to suit your needs.

  • "Using Basic File Options" discusses the basic file operations you can perform using PC-DMIS, such as starting a new part program, saving, and exiting PC-DMIS.

  • "Using Advanced File Options" discusses the more advanced file operations such as importing and exporting CAD files and executing your part program.

  • "Setting your Preferences" describes how you can use the setup options in the Edit menu to set your desired preferences. It also describes how to insert and modify part program parameters.

  • "Editing the CAD Display" describes how you can use the options in the Graphics menu with the Graphics Display window to edit the display of your CAD file.

  • "Editing a Part Program" describes how you can use the options in the Edit menu with the Edit window to edit your part program.

  • "Using the Edit window" describes how to use PC-DMIS's built in editor to create, debug, edit, and execute your part program

  • "Using Other Windows, Editors, and Tools" discusses some additional windows, editors, and tools available from the View menu.

  • "Using Toolbars" discusses the toolbars available to the Graphics Display window and how each toolbar icon can aid you in the various aspects of creating or editing your part programs.

  • "Defining Hardware" covers the Hardware Definition submenu found on the Insert menu. Using the Hardware Definition submenu you can define Probes, Machines, or Quick Fixtures to use with PC-DMIS. This section also describes tip calibration.

  • "Creating Auto Features" describes how to use the Insert | Feature | Auto option to create Auto Features and then measure those auto features in your part program.

  • "Creating Measured Features" describes how to use the Insert | Feature | Measured option to create measured features into your part program.

  • "Constructing New Features from Other Features" describes how to construct features and put them into the part program by using the Insert | Feature | Constructed option.

  • "Creating Generic Features" describes how to insert a ReadPoint command and how to create Generic Features by using the Insert | Feature | Readpoint and Insert | Feature | Generic options.

  • "Creating and Using Alignments" describes how to create and save alignments by using the Insert | Alignment submenu.

  • "Dimensioning Features" describes how to dimension your features by using the Insert | Dimension submenu.

  • "Using Feature Control Frames" describes how to dimension your features using Feature Control Frames and symbols from the GD&T standard.

  • "Scanning Your Part" describes scanning and how to create basic or advanced scans by using the Insert | Scan submenu.

  • "Inserting Move Commands" discusses various move commands that can be placed in your part program by using the Insert | Move submenu.

  • "Branching by Using Flow Control" discusses a myriad of commands that can be used to control the flow of your part program by using the Insert | Flow Control submenu.

  • "Tracking Statistical Data" explains how to track and use statistics in your part program.

  • "Reporting Measurements Results" walks you through the creation of Report and Label Templates, Custom Reports, and the usage of Forms.

  • "Inserting Report Commands" discusses the report commands you can insert into your part program by using the Insert | Report Command submenu.

  • "Using File Input / Output" explains how to work with file input / output in your part program, allowing you to open files for either reading, writing, and other operations by using the Insert | File I/O Command submenu.

  • "Using Expressions and Variables" describes how to create expressions and how to assign expression results to variables.

  • "Adding External Elements" covers using external applications, scripts, part programs, and other objects in your part program to further enhance its capability.

  • "Using Multiple Arm Mode" describes how to use PC-DMIS with dual arm CMMs.

  • "Navigating and Displaying Multiple Windows" describes how to easily navigate between and view the open windows by using the Window menu.

In addition to the above sections, PC-DMIS provides several supplemental sections documenting the following:

  • "Working in Off-line Mode"

  • "Translating a Part Program into PC-DMIS"

  • "Using a Wrist Device"

  • "Working in Operator Mode"

  • "Using Shortcut Keys and Shortcut Menus"

  • "Error Codes"

More:

Conventions


Conventions

The following conventions have been used throughout the online help:

More:

Mouse Terminology

Boldface Text

Italicized Text

Uppercase Text

Underlined Text

Bulleted Text

Numbered Lists


Mouse Terminology

Clicking the Mouse - Throughout this help file, the phrase "click the mouse button" is used. This refers to depressing and quickly releasing the mouse button. For example, if you are instructed to click on a menu choice, use the mouse to move the mouse pointer (arrow shape) to the desired menu choice, then depress and quickly release (click) the left mouse button. Clicking the left mouse button activates most options. Therefore, whenever there is an instruction to "click on" an item (without reference to a specific button), assume the left mouse button is to be used unless instructed otherwise.

Holding Down the Mouse Button - Throughout this help file , the phrase "Hold down the mouse button" is used. This phrase refers to pressing and holding down the mouse button while performing another action. Unless it specifies otherwise, this refers to the left mouse button. Note that some functions require you to hold down both left and right mouse buttons. In these cases, if your pointing device utilizes a middle mouse button or mouse wheel, you can hold that button instead of holding down both mouse buttons.


Boldface Text

Boldface is used primarily when referring to:

  • Dialog box elements.

  • Dialog box titles

  • Command buttons

  • Icons

  • Menus and menu items

  • Toolbars

For example:

  1. Select the File | New menu item.

  2. Access the Open dialog box.

  3. Click the Save button

Boldface may also be used on Notes, Warnings, Hints, and Examples.

When referring to menus and menu items inside procedures and other topics, the documentation will direct you to a menu in this fashion:

Menu | Submenu or Menu Item | Menu Item

However, since you can customize your menu locations and names, this documentation only displays the default locations for menu items.

The online help file, however, has a menu roadmap icon within several topics. Clicking this icon will display the pathway to the menu item (or items) discussed in that topic.


Italicized Text

Italicized text is primarily used for emphasis. For example, "If. . .the probe hits an obstruction, it will not automatically stop".

Italicized text may also be used for:

  • Book or Manual titles

  • Predefined Arguments (in programming)

  • Parameters (in programming)

  • Place holders (in programming)

  • User Input (in programming)


Uppercase Text

Uppercase text is generally used when referring to:

  • Acronyms (such as VDAFS , DMIS)

  • Time (such as A.M. and P.M.)

  • Device names (such as LPT1, or COMM PORT 2)

In those instances where elements of computer programming are displayed, the following items also use uppercase:

  • Control classes

  • Data formats

  • Environment variables

  • Handles

  • Hooks

  • Indexes

  • Macros

  • Statements

  • Structures

  • System Commands

  • Values


Underlined Text

Underline is used for emphasis when appropriate, but usually emphasis uses italicized text.


Bulleted Text

Bullets "·" are used to show a list of options, or commands, available to a certain program features or items discussed in a topic or section.


Numbered Lists

Numbered lists show a series of steps in instructions and procedures. For example,

  1. Choose File.

  2. Select New.

  3. Fill in the New Part Program dialog box.


CAD Links

PC-DMIS provides several methods for transmitting CAD geometry, part programs, and measurement data from and/or to CAD systems. Working with CAD data is one of PC-DMIS's strengths.

CAD geometry can be imported into, and measurement results exported from, PC-DMIS via:

  • IGES 5.3

  • STEP AP203 & AP214

  • VDAFS

  • DES (2/78)

  • XYZIJK format

PC-DMIS allows you to import the following for use in generating part programs and as a guide in program execution:

  • Two-dimensional wire frame

  • Two and one-half dimensional wire frame

  • Three-dimensional wire frame

  • B-spline curves and surfaces CAD models

See the "Working in Off-line Mode" section for a list of supported IGES entities.

Part programs created in CAD systems can be imported into PC-DMIS by way of DMIS 3.0. PC-DMIS part programs can be exported into DMIS for running in other CMM software.

PC-DMIS measurement results can also be exported as a DMIS results file.


Using a Mouse or Motion Controller

One of the objectives of PC-DMIS is to be flexible and user friendly. To meet this objective, PC-DMIS allows you to use pointing devices and motion controllers. The speed and accuracy of a mouse, for example, make it an indispensable part of the PC-DMIS work environment. With a mouse you can execute all PC-DMIS functions. (Keyboard commands can also be used to access most PC-DMIS functions.)

More:

Configuring a ZMouse

Configuring a SpaceBall or SpaceMouse Device


Configuring a ZMouse

Certain systems offer a track ball style of mouse referred to as a ZMouseÒ. This enables the user to control the movement of the mouse pointer from the z rail.

The last line of the parameter file (DOWNLOAD) should read:

N1000 ZMOUSE2
or
N500 ZMOUSE2

To enable the ZMouseÒ please verify that the last line of the DOWNLOAD file reflects the above statement. Modify the line, if necessary.


Configuring a SpaceBall or SpaceMouse Device

PC-DMIS 3.7 and above supports these motion controllers from 3DConnexion:

  • SpaceBall®

  • SpaceMouse®

These devices communicate with PC-DMIS via the 3DxWare interface. This interface uses a configuration file that may ship with PC-DMIS or with your 3DConnexion CD. This configuration file defines the available PC-DMIS application functions that you can assign to the various buttons on these devices. It also defines the default configuration and button assignments.

To get the latest configuration file, you can download it from the Wilcox Associates, Inc. FTP site here:

Download the Install_PCDMIS_400_3Dconnexion.exe Configuration File

More:

Available PC-DMIS Functions for SpaceMouse or SpaceBall

Assigning PC-DMIS Functions to button on the SpaceMouse or SpaceBall

SpaceBall or SpaceMouse Modes


Available PC-DMIS Functions for SpaceMouse or SpaceBall

This topic describes the functions that you can assign to buttons on your SpaceMouse or SpaceBall devices. These functions include:

>Ignore motion – Ignores all translation and rotation information from the motion controller.

>Next view – Forces the focus of the motion controller to the next view when multiple views are available.

>Hide/Show IDs – Toggles the display of feature text box label IDs.

>Scale to fit – Performs the standard PC-DMIS scale to fit operation.

>Show cursor – Displays an Auxiliary Cursor on the screen. Used with Center by cursor, PCDMIS zoom, PCDMIS rotate 2D, and PCDMIS rotate 3D.

>Center by cursor – Makes the Show cursor active if it isn't already. Otherwise, wherever the Auxiliary Cursor is located, that will become the center of the screen.

>PCDMIS pan – Pans the Graphics Display window. You can slide the device left or right to PAN LEFT or PAN RIGHT and slide it up or down to PAN UP or PAN DOWN, thereby matching the PAN configuration in the “>CAD PZR” setting. The motion device emulates a joystick type device with this setting.

>PCDMIS zoom – If you have an Auxiliary Cursor active, then the center point of the zoom will be fixed at the Auxiliary Cursor location. If not, PC-DMIS performs a standard zoom operation. You can slide the device forward or backward. Moving the device forward zooms out and moving it backward zooms in. This matches the zoom configuration in the “>CAD PZR” setting.

>PCDMIS rotate 2D – If you have an Auxiliary Cursor active, then the point used to calculate the rotation angle will be fixed at the Auxiliary Cursor location (similar to a right-mouse button 2D rotate). Otherwise, the point used to calculate the rotation angle will be just to the top right of the screen center. In either case, PC-DMIS performs a standard PC-DMIS 2D rotation.

>PCDMIS rotate 3D – If you have an Auxiliary Cursor active, then the point used as the center of rotation will be fixed at the Auxiliary Cursor location (similar to a right-mouse button 3D rotate). Otherwise, the center of rotation will be the screen center. In either case, PC-DMIS performs a standard 3D rotation.

>CAD PZR – Pan, zooms, and rotates (PZR) the part image in the Graphics Display window all at the same time. The center of rotation is always the CAD model, and the zoom reference point is the center of the CAD model. When you start a part program, PC-DMIS turns this function on by default.

>CAD PZR Dominant – Toggles the dominant function of CAD PZR based on the greatest deflection of the SpaceBall axes. This lets you have better control because it filters out less dominant functions. For example, in this mode, if you rotate the axes and a small amount of deflection occurs in pan or zoom, only the dominant function, rotation in this case, will take place. When you start a part program, PC-DMIS turns this function off by default.

>PZR 2sided lighting – Toggles 2 sided lighting when doing a pan, zoom, or rotate (PZR). This attribute is also part of the PZR Options dialog box.

>PZR 1/5th of objects – Toggles the state of displaying only 1/5th (20%) of the objects when doing a PZR. This attribute is also part of the PZR Options dialog box.

>PZR in wireframe – Toggles wireframe mode when doing a PZR. This attribute is also part of the PZR Options dialog box.

>Dialog: PZR options – Displays the PZR Options dialog box.

>Dialog: Cad info – Displays the Cad Information dialog box.

>Dialog: View setup – Displays the View Setup dialog box.

For information on the PZR dialog box see the "Changing Rotation and other Motion Options" topic in the "Editing the CAD Display" section.


Assigning PC-DMIS Functions to buttons on the SpaceMouse or

Assigning PC-DMIS Functions to buttons on the SpaceMouse or SpaceBall

Use the 3Dconnexion Control Panel to define views associated with button actions and to assign PC-DMIS functions to your device.

  1. Double-click on the 3DxWare symbol located in your System Tray. The 3DxWare configuration application, 3Dconnexion Control Panel, appears.

3Dconnexion Control Panel showing the SpaceBall Device

  2. Select PC-DMIS from the Configuration for: list. PC-DMIS shows the default functions for the various buttons.

  3. In the button list boxes, select the PC-DMIS functions you want to assign.

  4. Make any other changes as needed.

  5. Click Close to accept your configuration and close the control panel.

Consult the 3Dconnexion Control Panel help file if you run into problems.


SpaceBall or SpaceMouse Modes

SpaceBall / SpaceMouse Modes

These devices are always in a certain mode. A symbol appears in the lower right corner of the Graphics Display window to indicate the current mode for CAD PZR, PCDMIS pan, or PCDMIS Zoom.

Standard Modes

  • Show cursor

  • CAD PZR

  • PCDMIS rotate

  • PCDMIS pan

  • PCDMIS zoom

  • CAD PZR dominant - The image in the lower right corner of the Graphics Display window displays a ”1” to signify that only 1 of the three functions (Pan, Zoom, or Rotate) will be used at a time.

Demo Mode

These devices can also place the Graphics Display window into a demo mode. This mode causes the Graphics Display window to rotate automatically several times a second. To enter or exit the demo mode, press the CTRL key and press the programmed Scale to Fit button on the device.


Automating PC-DMIS

PC-DMIS comes fully supported of being controlled by any third party software. For example you can create your own customized application and using automation commands, you can launch and use PC-DMIS via that application.

For complete information on the automation commands that control PC-DMIS, and on supported BASIC language commands, see your PC-DMIS Basic Language Help File for additional information.


Software Configurations

Assuming you have purchased the necessary modules, and your port lock is properly configured, you can launch PC-DMIS in different configurations. To do this, you can add these switches to the shortcut command line that launches the application.

Available Software Configuration Switches

/f for offline mode

/u for user privilege level when you are logged onto the system as an administrator

/o for operator mode

/r for reverse axes mode on the slave arm of a dual arm system

/p for pro mode (cannot use with /c switch)

/c for cad mode (cannot use with /p switch)

/d for debug mode for this session

/nc0 to run PC-DMIS without the CNC functionality

/5unique to run PC-DMIS without this functionality

/cmt to run PC-DMIS without this functionality

/dccscanning to run PC-DMIS without this functionality

/displaycad to run PC-DMIS without this functionality

/laserprobe to run PC-DMIS without this functionality

/masterslave to run PC-DMIS without this functionality

/nocontactprobe to run PC-DMIS without this functionality

/remotepanel to run PC-DMIS without this functionality

/rotarytable to run PC-DMIS without this functionality

/sheetmetal to run PC-DMIS without this functionality

/statsoutput to run PC-DMIS without this functionality

/systemv to run PC-DMIS without this functionality

/toolchanger to run PC-DMIS without this functionality

/valisys to run PC-DMIS without this functionality

/vision to run PC-DMIS without this functionality

/wrist to run PC-DMIS without this functionality

Routine of Shortcut Modification with Switches

  1. Access the directory where the PC-DMIS executable shortcut is located (generally this is located at C:\Documents and Settings\All Users\Start Menu\Programs\PC-DMIS for Windows).

  2. Right-click in the directory and select New | Shortcut.

  3. Follow the on-screen instructions to have the shortcut point to where the PC-DMIS executable, pcdlrn.exe, is located (wherever you installed it).

  4. Add any of the command line switches (or arguments), following the shortcut's full path to the executable:

So if you want to run PC-DMIS pro in offline mode, the target location would look something like this:

"C:\Program Files\pcdmisw\PCDLRN.exe" /p /f

You can also tell PC-DMIS to automatically open a specific part program (or part programs) by appending a pathway string pointing to a part program as a command line argument.

  • When specifying a part program to load, however, you do not need the / character required for the other arguments discussed above.

  • To open more than one part program, type a space between each additional pathway.

  • If your filename contains spaces, put the pathway within quotation marks.

For example, if you wanted to launch two part programs named test.prg and test2.prg in offline mode from a directory called "My Part Programs", the target locations might look something like this:

"C:\Program Files\PCDLRN.exe" /f "d:\my part programs\test.prg" "d:\my part programs\test2.prg"

The most common modes are Off-line and On-line modes. These two distinct products are designed to meet particular needs. They can be used together to create a complete part program, measurement analysis and reverse engineering system.

These and other configurations are explained below in greater detail.

More:

Comparison of Off-Line and On-Line Versions

PC-DMIS CMM

PC-DMIS Vision

PC-DMIS/NC

PC-DMIS Laser

PC-DMIS Portable

PC-DMIS IP

PC-DMIS Gear


Comparison of Off-Line and On-Line Versions

Since both the on-line and off-line versions share the same features and functions, this help file describes the use of both products. However, in some instances a particular feature of the on-line software does not apply to the off-line software. These cases have been noted where appropriate.

More:

On-Line Part Programming

Off-Line Part Programming


On-Line Part Programming

Using on-line PC-DMIS, the user can execute existing part programs, quickly inspect parts (or sections of parts), and develop part programs directly on the CMM. On-line PC-DMIS will not function unless it is connected to a CMM. Off-line programming techniques will work while on-line.

CMM Startup and Homing Procedure for PC-DMIS Online:

  1. Turn on the air to the CMM.

  2. Power on the controller.

  • Depending on the machine model this may be a large rotary switch, an on/off key, or a small rocker switch on the controller mounted on the back of the machine or workstation.

  • All of the LEDs on the hand control (jog box) will be illuminated for about 45 seconds. After that time, several LEDs will turn off.

  3. Turn the power onto your computer and all its peripherals and log on to your computer.

  4. Start PC-DMIS Online by double clicking with the left mouse button on the ONLINE icon in PC-DMIS's Program Group.

  5. Home the CMM. Once PC-DMIS opens a message will appear on the screen:

  • Press the Mach Start button on your jog box for several seconds. Its LED will illuminate.

  • The CMM needs to be ”homed” to properly set the machine zero and enable the machine parameters (speeds, size limits, etc.). Press the OK button from the PC-DMIS message mentioned above. The CMM will slowly travel to the home position and establish this position as zero for all the axes.

  6. Use PC-DMIS to program and execute your part measurement routines. See the "Getting Started with a Simple Tutorial" section if you are new to PC-DMIS.


Off-Line Part Programming

Using off-line PC-DMIS, you can develop and debug part programs away from the CMM by editing a part created on-line, by importing a CAD input file, or through a DMIS, or AVAIL part program. The part program then can be directly executed using on-line PC-DMIS, or exported (post processed) into either DMIS or one of several vendor-specific formats. Off-line PC-DMIS cannot be used to directly drive a CMM.

The "Working in Off-line Mode" section describes the particulars of the off-line version.

PC-DMIS Startup in Offline Mode

  1. Turn the power onto your computer and all its peripherals and log on to your computer.

  2. Start PC-DMIS Offline by double clicking with the left mouse button on the OFFLINE icon in PC-DMIS's Program Group.

  3. Use PC-DMIS to program your part's measurement routines. See the "Getting Started with a Simple Tutorial" section if you are new to PC-DMIS.


PC-DMIS CMM

PC-DMIS CMM works with your Coordinate Measuring Machine (CMM) to inspect your parts. It was the first CMM software to:

  • Use CAD models in the inspection process.

  • Directly link CAD systems and measurement software through its Direct CAD interface (DCI) technology.

  • Implement a full set of sheet metal measurement routines tailored for the automotive industry.

  • Digitally simulate measurement in an offline virtual CMM environment.

  • Easily align complex, contoured parts using our breakthrough iterative alignment technology.

  • And many, many more.

PC-DMIS CMM comes in various standard configurations. Each is carefully tailored to meet the needs of a specific group of customers. Also, PC-DMIS offers a wide range of optional modules for doing specific tasks. This means that users can fine-tune the software to meet specific needs.

PC-DMIS Pro – The baseline PC-DMIS CMM package offers customers who don’t need to integrate CAD into their inspection process a powerful, easy-to-use metrology software package. PC-DMIS Pro, with its built-in Quick Start routines, lets users get up and running on their CMMs with a minimum of fuss.

PC-DMIS CAD – Brings CAD to the inspection process. PC-DMIS CAD lets customers create inspection programs and evaluate measurement results taking full advantage of their CAD models. The software provides the tools need to work with CAD files ranging from simple 2D drawings through complex 3D solid models.

PC-DMIS CAD++ – Enhances the capabilities of PC-DMIS CAD with sophisticated tools for high speed scanning, sheet metal measurement, part alignment and the like. PC-DMIS CAD++ makes measuring complex shapes easy.

Most of the PC-DMIS CMM items are discussed in the "PC-DMIS Core" documentation. Items that are specific to contact probes and CMMs are discussed in the "PC-DMIS CMM" documentation.


PC-DMIS Vision

This special version of PC-DMIS allows you to use certain optical probing devices to measure features. If you've purchased this module, see your "PC-DMIS Vision" help file for additional information.


PC-DMIS/NC

This special version of PC-DMIS allows you to perform part measurements using NC machine tools. These machine tools are also referred to as CNC (Computer Numerical Control) machines. If you've purchased this module, see your "PC-DMIS/NC" help file for additional information.


PC-DMIS Laser

This module of PC-DMIS lets you use a laser probe to easily measure your parts by passing a laser stripe over the part to collect large amounts of points which are then interpreted and defined into features. If you've purchased this module, see your "PC-DMIS Laser" help file for additional information.


PC-DMIS Portable

The PC-DMIS Portable configuration works with portable measuring devices to inspect your parts. Portable devices are manually operated measuring machines that are relatively easy to move to new locations due to their size and design. See the "PC-DMIS Portable" documentation for more information.


PC-DMIS IP

PC-DMIS Inspection Planner (IP) is an add-in module that works in conjunction with a supported CAD package and PC-DMIS to aid the Design Engineer or Quality Engineer in designing a plan that determines which features of the geometry and GD&T/dimension to use in the inspection process. Since IP runs inside your CAD package, it cuts your learning curve since you will only need to use a small portion of PC-DMIS for Windows to generate the part program.

If you've purchased this module, see your "PC-DMIS IP" help file for additional information.


PC-DMIS Gear

PC-DMIS Gear is a software product that works in conjunction with PC-DMIS to allow you to quickly and easily measure any gear parts you have. If you've purchased this module, see the "PC-DMIS Gear" help file that gets installed with the PC-DMIS Gear application for more information.


Command Line Installation

You can install PC-DMIS from the command line rather than simply double-clicking on the Setup.exe icon. The command line approach can speed up the install process by allowing you to turn different options on and off.

Command line Install Switches

/InstallDir:"<DRIVE>:\PATH\" - specify the target installation drive and path

/NoBackup - do not make a backup copy, just install over the top

/ProgramGroup:"Program Group Name" - specify the program group name where the icons for PC-DMIS will be created

/Language:<n> - specify the language to install. Currently the numbers are:

0 - English

1 - Italian

2 - French

3 - German

4 - Spanish

5 - Portuguese

6 - Japanese

7 - Chinese

/NoStartup - Do not automatically run startup.exe. If this is enabled then the "Launch PC-DMIS after the install exists" checkbox will be disabled, since it needs to run after startup.exe is executed.

/NoPCDMIS - Do not check the "Launch PC-DMIS after the install exits" checkbox. This is ignored if /B is specified.

/B Run in batch mode. Use this with the other options above and you can have a completely unattended install, suitable for running via a batch file or other script. PC-DMIS is not automatically launched if /B is specified.

These options are all case-sensitive.

Unattended Installation Example

So, to do to a fully unattended install in English, for example, you would use something like this in your command line:

setup.exe /B /Language:0 /InstallDir:"C:\PCDMISW" /ProgramGroup:"PC-DMIS for Windows"

You could also easily add the /NoBackup or /NoPCDMIS options to this to speed up the options.


Navigating the User Interface

Navigating the User Interface: Introduction

The Screen Appearance

The Menu Bar

The Toolbar Area

The Graphics Display Window

The Status Bar

Dialog Box Description

Customizing the User Interface


Navigating the User Interface: Introduction

This section provides an introduction to using PC-DMIS for Windows. It documents the fundamental actions needed to operate the software. To fully exercise the capabilities of PC-DMIS and make your part programming as easy as possible, please read through this entire section and follow along on your computer.

This section also highlights ways to customize some of PC-DMIS's graphical options to best meet individual needs. (Additional information on these available options can be found in the "Editing the CAD Display" section.)

Each topic listed below illustrates a specific feature of the interface. The following are covered in this section:

  • The Screen Appearance

  • The Menu Bar

  • The Toolbar Area

  • The Graphics Display Window

  • The Status Bar

  • Dialog Box Description

  • Customizing the User Interface

PC-DMIS provides the flexibility of using the mouse or keyboard to enter commands or select options. Shortcut menus and shortcut keys have been assigned to frequently used commands. See the "Using Shortcut Keys and Shortcut Menus" section.


The Screen Appearance

PC-DMIS presents a consistent screen appearance to the user.

The screen is divided into several distinct areas, each of which fulfills a specific function or supplies needed information. A brief description of each screen area can be found below. (Additional information is located throughout the help file as indicated.)

Screen Appearance of PC-DMIS's Graphical User Interface

  1. The Title bar displays the title of the current part program. It also contains the maximize and minimize buttons.

  2. The Menu bar contains the menu selections available from the main PCDLRN application. See "The Menu Bar".

  3. The Toolbar area contains toolbars with frequently used commands. These toolbars are easily accessible by right-clicking on the Toolbar area. See "The Toolbar Area".

  4. The Graphics Display window (see "The Graphics Display Window") presents graphic representations of the part (the top view is shown in the illustration). The size of this area remains constant. However, the display area can be divided into as many as four different views of the part.

  5. Dialog boxes are the main communication channels between PC-DMIS and the user. Available features appear in the dialog box, and most input data is entered through it. See "Dialog Box Description.

  6. The Edit window displays the part program. This window allows you to access specific commands within the part program and make changes to meet individual specifications. See the "Editing a Part Program" and "Using the Edit Window" sections for fully documented operations of the Edit window.

  7. The Status Bar displays information important to the current operation (i.e., current probe calibration data, standard deviation of the last feature measured) and number of hits. It also contains a message box that displays pertinent information about the operation in progress. See "The Status Bar" for more information.


The Menu Bar

To open a menu and browse through the options using the keyboard, press the ALT key followed by the underlined letter in the name of the menu to be opened. (The mouse can also be used, as described in "Selecting Options from the Menu Bar with the Mouse".) This document has been created to provide information for each menu option. See the appropriate section as needed. This section gives a brief description of each of the other menu options.

PC-DMIS also provides a variety of shortcut menus. These are discussed in the "Using Shortcut Keys and Shortcut Menus" section.

More:

File

Edit

View

Insert

Operation

Window

Help

Selecting Options from the Menu Bar with the Mouse

Selecting Options from the Menu Bar with the Keyboard


File

The File menu lets you open, save, and print files, access the Edit window, run part programs with the Execute Mode, and exit out of current part programs. See the "Using Basic File Options" and "Using Advanced File Options" sections for more information.


Edit

The Edit menu allows you to edit your program preferences, your part program, or the CAD display.

  • To edit your preferences, see the "Setting Your Preferences" section for complete information.

  • To edit your part program via the Edit window, see the "Editing a Part Program" and "Using the Edit Window" sections for complete information.

  • To edit the display of the CAD drawing, see the "Editing the CAD Display" section for complete information.


View

The view menu allows you to access all the windows, editors, and toolbars available to PC-DMIS. See the "Using Other Windows, Editors, and Tools" section for complete information.


Insert

The bulk of a part program's commands can be accessed from the Insert menu.

Most of the sections comprising this help file come from the options and submenus displayed on this menu.

  • Options on the Hardware Definition submenu are discussed in the "Defining Hardware" section.

  • Options on the Feature submenu are discussed in these sections: "Creating Auto Features", "Creating Measured Features", "Constructing New Features from Existing Features", "Creating Generic Features".

  • Options on the Alignment submenu are discussed in the "Creating and Using Alignments" section.

  • Options on the Dimension submenu are discussed in the "Dimensioning Features" section.

  • Options on the Scan submenu are discussed in the "Scanning your Part" section.

  • Options on the Move submenu are discussed in the "Inserting Move Commands" section.

  • Options on the Flow Control Command submenu are discussed in the "Branching by Using Flow Control" section.

  • Options on the Statistics Command submenu are discussed in the "Tracking Statistical Data" section.

  • Options on the Report Command submenu, including the ability to add Diminfo and Pointinfo boxes onto your CAD display and into your part program, are discussed in the "Inserting Report Commands" section.

  • Options on the File I/O Command submenu are discussed in the "Using File Input / Output" section.

  • The remaining options on the Insert menu are discussed in the "Using Expressions and Variables" section and the "Adding External Elements" section.


Operation

The items on the Operation menu are discussed in various topics of the documentation.


Window

The Window menu allows you to manage the display of all open part programs. See "Navigating and Displaying Multiple Windows" section.


Help

The items on the Help menu are discussed in the "Using the Online Help" section.

The Help menu provides information about PC-DMIS commands, dialog boxes, messages, and keys.

To activate PC-DMIS's online help, select any of the items on the Help menu or press F1 at any time. PC-DMIS will launch the PC-DMIS online Help file.


Selecting Options from the Menu Bar with the Mouse

Options can be selected from any drop-down menu in the same manner as the menu bar.

To open a menu and browse through the options using the mouse:

  1. Move the pointer to the desired menu name.

  2. Click the left mouse button.

When an ellipsis follows an option name, choosing the function will display a dialog box. For example "File | Open…" lets you know that there is an Open File dialog box. Dialog boxes display various options, boxes, and buttons (called controls) for specifying commands that will be carried out by PC-DMIS. Sometimes a dialog box will show default settings already selected, which if satisfactory, can be left as they are. In general, after all the controls in the dialog box have been set, click the OK button to carry out the command. To cancel the command and close the dialog box, click the Cancel button.


Selecting Options from the Menu Bar with the Keyboard

To open a menu and browse through the options using the keyboard, press the ALT key followed by the underlined letter in the name of the menu to be opened.

For example: to open the View menu using the keyboard, press ALT and V (the underlined letter). Options can be selected from the menu in a similar manner. Simply press the underlined letter to the corresponding option (i.e., Cut: press the T key).

Menus also can be opened using the arrow keys.

To do this:

  1. Press the ALT key to switch to the menu bar.

  2. Use the LEFT/RIGHT ARROW keys to move to the desired menu.

  3. Use the UP/DOWN ARROW keys to select an option.

  4. When the desired option is highlighted, press the ENTER key.

Shortcut keys also have been assigned to many of the options. The shortcut key is shown to the right of the command or option.

See the "Using Shortcut Keys and Menus" section for more information.


The Toolbar Area

Display Menu Roadmap

PC-DMIS provides you a variety of toolbars composed of frequently used commands. These toolbars can be accessed in one of these two ways.

  1. Select the View | Toolbars submenu and select a toolbar from the menu provided.

  2. Right-click on PC-DMIS's Toolbar area and select a toolbar from the shortcut menu provided.

Once you have a toolbar in the toolbar area, you can easily move the toolbar by first clicking on the space between the left or right edge and a button and then dragging the toolbar to a different location.

For in-depth information on all of PC-DMIS toolbars, see the "Using Toolbars" section.


The Graphics Display Window

Display Menu Roadmap

The Graphics Display window, quite simply, displays graphics. This window is opened by default when you create or access a part program. To hide or view this window, select the View | Graphics Display Window menu option.

  • It displays a multi-paned graphical representation of an imported CAD part, the probe, and any simulated machines or fixtures.

  • It shows measured, auto, and constructed features and their ID labels.

  • It displays scans, dimensions, text box displays.

The Graphics Display window is an integral part of PC-DMIS. For information on Editing the Graphics Display window, and altering the screen display, see "Editing the CAD Display" section.


The Status Bar

The status bar displays the following:

1 - SD: This shows the standard deviation of the last feature measured.

2 - Line: This box displays a number that indicates the current line where the cursor is located in the Edit report. Col: This box displays a number that indicates the current column where the cursor is located in the Edit report.

3 - W: Angle of Rotary Table:

4 - Message Box: The left-most box displays instructions and other information regarding the current procedure or command.

5 - X, Y, and Z boxes: These boxes show the X, Y, and Z position of the probe. Clicking on any of the three coordinate displays within the status bar will cause the Auto Move Point dialog box to appear. (See "Inserting a Move Point Command" in the "Inserting Move Commands" section for additional information regarding DCC Move Point.)

6 - # of Hits: This shows the number of hits currently taken.

7 - IN/MM: This shows the current unit of measurement used for the part program.

8 - INS/OVR: - This box indicates the current editing function of the Edit report. It will display INS (for INSERT, meaning it inserts text at the cursor) or OVR (for OVERWRITE, meaning it overwrites any text encountered by the cursor).

Status Bar Manipulations

  • To increase the size of the status bar, select View | Statusbar | Large. Display Menu Roadmap Due to its increased size, this large status bar will only display the Message and the XYZ boxes.

  • To put the status bar back to its normal size, select View | Statusbar | Normal. Display Menu Roadmap

  • To show or hide the Status bar, select View | Statusbar | None. Display Menu Roadmap


Dialog Box Description

A dialog box provides various boxes and buttons (called controls) that can be selected to tell PC-DMIS how to carry out a command. Sometimes a dialog box will show default settings already selected, which if satisfactory can be left as they are. After all the controls in the dialog box have been set, select OK to carry out the command. To cancel the command and close the dialog box, click the Cancel button.

The graphics illustrate some features common to most dialog boxes in PC-DMIS.

A - Edit Boxes or Fields

B - List Box

C - Options Buttons

D - Check Boxes

E - Command Buttons

F - Tabs

G - Drop Down List Box

More:

Accessing Dialog Boxes

Scrolling the Edit Window

Moving Dialog Boxes


Edit Box:

An edit box allows you to type in a desired value or name. In this manual edit boxes are simply referred to as "boxes". Edit boxes common to many of PC-DMIS's dialog boxes are listed here:

More:

ID- [Feature]

Search ID

Select Last #


ID= [Feature]

This box shows the Feature or Dimension ID for the features or dimensions to be created.

To change the ID:

  1. Select the previous ID.

  2. Type a new ID.

  3. Press the TAB key.

For a Dimension ID:

  • You can change only the number portion of the ID and reset the dimension counter to a desired count.

  • You can change the text portion of the ID and set it as the default text for subsequent dimensions. (See the ID Setup tab of the Setup Options dialog box in the "Setting Your Preferences" section.)


Search ID

In the Search ID box you can key in feature (or dimension) IDs to be used in the current operation. You can use this box to search using meta-character search options. The feature or dimension IDs will be highlighted in the appropriate Feature List box (or Dimension List box).


Select Last #

In the Select Last # box you can select the last of a certain number of features (or dimensions). For example, if you wanted to select the last four features that were created, simply type 4 and press the TAB key. PC-DMIS will highlight the features selected in the Feature List box.


List Box:

A list box is similar to an edit box; however changes cannot be made to the listed values. This manual refers to either "list" or "box" for the list box. Lists common to many of PC-DMIS's dialog boxes are listed here:

More:

Feature List box

Dimension List box


Feature List box

The Feature List box contains a list of the available features within a part program. PC-DMIS uses selected features to define alignments, construct new features, create dimensions, and other such tasks. You can select features by following the instructions given in the "Selecting Features Using the Graphics Display Window" topic in the "Editing the CAD display" section.

Selected (highlighted) features can be deselected using the Clear or Clear List button.

If you are attaching an external part program (see "Attaching an External Part Program" in the "Adding External Elements" section), PC-DMIS also lists the variable (or pointer) used to reference the attached part program. A plus sign (+) appears to the left of the pointer. Clicking this plus sign expands or collapses a view of all the features in the attached part program.


Dimension List box

The Dimension List box contains a list of all the dimensions that were created within a part program. You can easily select the dimension(s) you would like to edit or analyze by simply selecting the desired dimension(s) in the list box and selecting the desired changes or options in the associated dialog box.

Inside the Edit Dimension Info dialog box, if the dimension already has a Dimension Info box associated with it, PC-DMIS shows an asterisk (*) symbol next to the dimension ID in the list. If the dimension info is hidden in all current views, it adds a number sign (#) symbol next to the ID.

For example, suppose you have a roundness dimension named RND1 for a circle named CIR4. If the roundness dimension already had a DIMINFO box associated with it, yet that DIMINFO box was hidden from all views in the Graphics Display window, the ID in the list would look like this:

Example of asterisk and number sign symbols


Option Buttons:

The area containing option buttons displays available choices for the dialog box. Switch between available choices by clicking on the desired button. When an option is chosen, a black dot appears to the left of the selected option and all other options are cleared. You can only select one option button.


Check Boxes:

Click on check boxes to turn options on or off. The option is considered "on" when a check mark appears inside the box. You can select multiple check boxes.


Command Buttons:

A command button carries out an action. The command buttons common to most dialog boxes in PC-DMIS are listed here:

More:

Apply

OK

Cancel

Delete

Last

Last Two

Select All

Default

Recall

Create

Close

Clear

Undo

Help


Apply

The Apply button applies your selections to the dialog box but keeps the dialog box open for further changes.


OK

The OK button saves and applies the changes and closes the dialog box. On some dialog boxes, clicking the OK button inserts commands into the Edit window.


Cancel

The Cancel button ignores any changes and closes the dialog box.


Delete

The Delete button removes items (such as created features, dimensions, probe files, alignment information etc.) from certain list boxes.

In the Delete CAD dialog box, the Delete command button deletes selected nominal features.


Last

The Last button selects the last item in the associated list box.


Last Two

The Last Two button selects the last two items in the associated list box.


Select All

The Select All button selects all the items in the associated list box.


Default

The Default button allows you to update the default settings of several parameters. When a new part program is created, it will reflect any changes stored as the default.

The default values are stored in the system registry. These parameters can be updated through the appropriate dialog box or by editing the registry itself by using the PC-DMIS Settings Editor. This application is included with your PC-DMIS install set. See the "Modifying Registry Entries" section for more information.

  • If the OK button is selected (without the Default button being pressed) the defined parameters will only apply to the active part program and will not affect the registry entries.

  • If any of the parameters are changed and the Default button is pressed, PC-DMIS will update the registry entries, redefining the default to the current entry.

The Default button allows you to store and apply new default values to new part programs created later on.


Recall

The Recall button allows you to call back original factory settings as long as the original values haven't changed through clicking the Default button. In that case, PC-DMIS will return the stored values in the registry.

For information on using the Machine Options dialog box to restore original factory settings by reading them from the controller, see the "Setting Up the Machine Interface" topic in the "Setting your Preferences" section.


Create

The Create button applies changes made in certain dialog boxes and creates constructed features, dimensions, auto features, scans etc. and places the created item into the Edit window and the Graphics Display window.

The Create button won't close the dialog box. Only clicking the Close button closes the dialog box.


Close

The Close button closes the dialog box. With some dialog boxes (where you may want to select further options) just pressing the OK, Apply, or the Create button doesn't automatically close the dialog box.


Clear

The Clear command button allows you to clear the highlight of any selected item from list boxes. In some cases, the Clear button removes items completely from certain list boxes (such as AB positions from the New Angles List box).

In some dialog boxes and tabs, the Clear button clears any values that were entered or changed before either the Apply or the OK button is clicked and restores the "built in" values present in PC-DMIS. If you have used the Default button to store default values, then PC-DMIS restores those values.


Undo

The Undo button reverses changes made using the Apply button (or the Generate button in DCC scans). It cannot reverse changes made once the OK button is clicked.


Help

The Help button opens the online help topic associated with the current dialog box.


Dialog Box Tabs:

Some dialog boxes contain tabs. These tabs act as identifying markers much like a folder's name in a filing cabinet would. Simply click on a tab to bring a desired window or options in front of the other tabs. Any options or commands associated with that tab will then be displayed.


Drop Down List Box

A drop-down list box works like menus. Click on the drop-down arrow icon [image] to the right of the current choice, or press ALT and the UP ARROW or DOWN ARROW key on the keyboard consecutively. Pressing F4 will also display the available options. Press the key(s) again to close the list. The current choice is shown in the highlighted box.


Accessing Dialog Boxes

The mouse or keyboard can be used to access options within the dialog box. To access an option using the mouse, simply point to the desired option and click. The keyboard offers a variety of ways to move between available options.

PRESS: | TO
TAB: | Move to the next available option.
SHIFT + TAB: | Move to the previous available option.
ARROW key: | Display a current drop-down list.
ENTER: | Select the current command.
SPACE BAR: | Select the current check box or button.


Scrolling the Edit Window

The Edit window can be moved in the same manner as a dialog box. See "Moving Dialog Boxes"

The Edit window has scroll bars for viewing additional data in the window.

To scroll:

  1. Place the mouse pointer on one of the scroll arrows.

  2. Click or hold the left mouse button.

PC-DMIS will scroll the text in the scroll arrow's pointed direction. For example, to scroll down, select the down scroll arrow with the pointer and click the left mouse button.

See "Editing a Part Program" and "Using the Edit Window" for complete information regarding the Edit window.


Moving Dialog Boxes

The mouse can be used to control window and dialog box placement within the Graphics Display window.

To move a dialog box or window:

  1. Place the mouse pointer over the title.

  2. Hold down the left mouse button.

  3. Drag the dialog or window to the position in the Graphics Display window where desired.

  4. Release the mouse button.

PC-DMIS re-draws the dialog box or window in its new location.

Some dialog boxes may be docked inside the rest of the user interface. You may need to undock these items before moving them. See "Docking and Undocking User Interface Elements".


Customizing the User Interface

Display Menu Roadmap

In version 3.5 the user interface used in previous versions was improved with a more organized approach to the various options available. In addition, you can now customize this user interface to meet your specific needs.

Now you can easily reorganize menus, add your own programs to menus, or simply create new menus and options altogether. PC-DMIS also allows you to link commands native to PC-DMIS and customized commands to toolbars. Instructions on how to modify the user interface are given in the following topics:

  • To Restore the Default User Interface

  • To Customize User Interface Fonts

  • Customizing Menus

  • Customizing Toolbars

  • Customizing Shortcut Keys

Note: The organization of this help file is based on the default user interface shipped with this version PC-DMIS, be aware that customizing the user interface may make existing documentation difficult to follow.


To Restore the Default User Interface

If you want to restore PC-DMIS's appearance to the default user interface shipped with this version of PC-DMIS, follow this procedure:

  1. Close PC-DMIS.

  2. Navigate to the directory where you installed PC-DMIS.

  3. Access the directory that corresponds to your Windows user profile.

  4. Delete the file named menu_xxx.dat where xxx refers to the three letter code for the language you're running. For English, delete menu_eng.dat.

  5. Restart PC-DMIS. It will use the default user interface.


To Customize User Interface Fonts

Display Menu Roadmap

Change all the fonts dialog box

Change all the fonts dialog box

To modify font attributes, access the Changes all the fonts dialog box by selecting the Edit | Preferences | Fonts menu option. Using this dialog box you can change font attributes¾including font, size, and style¾for the main user interface, for the Graphics Display window and for the Edit window.

To change the font:

  1. Select one of these option buttons and the standard Font dialog box appears:

  • Edit Application Font – This changes the font of the lists on the Settings toolbar, the Preview window, the Readout window, the status bar, and any message boxes etc.

  • Edit Graphic Font – This changes the font of text displayed on the Graphics Display window, mainly affecting feature labels, Dimension Info and Point Info text boxes, etc.

  • Edit Edit Window Font – This changes the font on the Edit window. See the note below.

  2. Select your font changes from the available lists.

  3. Click OK to close the Font dialog box.

  4. Click OK at the Changes all the fonts dialog box to accept your change.

Important: You can use any font available on your computer system, however be aware that some fonts don't have a uniform spacing and may make some components more difficult to read. When viewing or printing the Edit window text, for example, we recommend that you use a monospace (or fixed-width) font (such as the Courier New font), otherwise characters, lines, and headings may not line up as expected.


Customizing Menus

Display Menu Roadmap

To customize the menus on the menu bar:

  1. Access the Customize dialog box by selecting the View | Toolbars | Customize menu option.

  2. Select the Menu tab.

Customize dialog box – Menu tab

You can use this tab to add new menu items, move existing menu items, or remove menu items from the menu bar altogether.

More:

To Move A Menu Item

To Remove/Restore A Menu Item

To Edit an Existing Menu Item

To Add a New Menu Item


To Move A Menu Item

Display Menu Roadmap

To move a menu item to a new location on the menu bar:

  1. With the Customize dialog box open and the Menu tab selected, navigate to the menu item you want to move on PC-DMIS's actual menu bar (not the tree view menu list in the Menu tab).

  2. Select the desired menu item.

  3. Drag it to the new position. As you drag the item through the menu structure, a small red arrow [image] will appear indicating where the item will be added.

  4. Release the mouse button, and the menu item is copied from its original location to the new location.

  5. Click OK to accept your changes and close the Customize dialog box.


To Remove A Menu Item

To Remove/Restore A Menu Item

Display Menu Roadmap

To Remove a Menu Item from the Menu Bar:

  1. With the Customize dialog box open and the Menu tab selected, navigate to the menu item you want to remove on PC-DMIS's actual menu bar (not the tree view menu list in the Menu tab).

  2. Select the desired menu item.

  3. Drag it off of the menu bar area.

  4. Release the mouse button, and the menu item is removed from the menu.

  5. Click OK to accept your changes and close the Customize dialog box.

To Restore a Removed Menu Item:

  1. With the Customize dialog box open and the Menu tab selected, navigate in the Menu tree view list to the menu item you want to restore.

  2. Select the menu item and drag it up onto PC-DMIS's actual menu bar. As you drag the item through the menu structure, a small red arrow [image] will appear indicating where the item will be added when you release the mouse button.

  3. Release the mouse button to insert the menu item.


To Edit an Existing Menu Item

Display Menu Roadmap

You can edit existing menu items, including menu item names, descriptions, and ToolTips. To do this:

  1. Access the Customize dialog box by selecting the View | Toolbars | Customize menu option.

  2. With the dialog box open, click on PC-DMIS's menu bar.

  3. Select a menu and then right-click on the menu item you want to change on PC-DMIS's actual menu bar (not the tree view menu list in the Menu tab). The Edit Menu Item dialog box appears.

Edit Menu Item dialog box

  4. Modify the menu item using this dialog box and then click OK.

  5. Click OK on the Customize dialog box.

  6. Verify your change.

Note: In the Menu Text box, the letter that follows the ampersand sign (&) indicates that the letter is used with the ALT key to quickly select that menu item (for example selecting ALT + F + N will access the New menu item from the File menu).


To Add a New Menu Item

Display Menu Roadmap

You can create your own custom menu item and tie an external program or batch file to it. To do this:

  1. Access the Customize dialog box by selecting the View | Toolbars | Customize menu option, and select the Menu tab.

  2. Click the Create Item button. The Custom Wizard / Script / Tool dialog box appears.

  3. Click the ‘…’ button. An Open dialog box appears.

  4. From the Files of Type list, select the type of file you will be inserting.

  5. Navigate to the directory containing the custom application, batch file, BASIC script, Macro file, etc.

  6. Select the file to insert, and click Open. The Open dialog box closes and the Custom Wizard / Script / Tool dialog box displays the default information associated with the custom program you selected.

Custom Wizard / Script / Tool dialog box showing a sample application

Command File:
This box shows the pathway to the command.

Menu Text:
This box allows you to specify the name used on the menu for this item.

Help Desc:
This box allows you to define information that PC-DMIS displays in the status bar when you move your mouse over the item.

Tool Tip:
This box allows you to specify the tooltip text displayed for this item when you hover your mouse over it. This only works if the custom item is added to a toolbar, not a menu.

Function:
This box remains unavailable for selection unless you are using a custom BASIC script. Once the box becomes enabled, you can use it to define the function or subroutine that will run from the loaded .bas file. Simply type the routine name without parenthesis. For example, typing "TestFunction" would launch the TestFunction routine when the BASIC script was executed.

Change Icon:
This button allows you to change the icons displayed for this menu item.

  7. Make any additional changes to this dialog box.

  8. Click OK to accept your changes. PC-DMIS inserts the newly created command into the User Defined Commands tree view list in the Menu tab of the Customize dialog box.

  9. Expand User Defined Commands tree view list.

  10. Select newly created command and drag it up onto PC-DMIS's actual menu bar. As you drag the item through the menu structure, a small red arrow [image] will appear indicating where the item will be added when you release the mouse button.

  11. Release the mouse button to insert the command.

  12. Close the Customize dialog box. The newly inserted menu item now resides in your menu bar.


Customizing Toolbars

Display Menu Roadmap

To customize the toolbars that appear on the toolbar menu:

  1. Access the Customize dialog box by selecting the View | Toolbars | Customize menu option.

  2. Select the Toolbars tab.

Customize dialog box – Toolbar tab

You can use this tab to add new toolbars, and new toolbar icons, remove custom toolbars, remove toolbar icons, and reorder toolbar icons on existing toolbars.

More:

To Modify an Existing Toolbar

To Create a Custom Toolbar

To Delete a Custom Toolbar


To Modify an Existing Toolbar

This table shows how to use the Customize dialog box's, Toolbar tab to modify existing toolbars.

Desired Modification

Procedure

Add a menu item to a toolbar.

  1. Select the toolbar from the Toolbar Definition list.

  2. Find the item you want to add in the Available Items list.

  3. Select it, and press the Addà button. The item appears on the desired toolbar.

  4. Click Apply and then OK to accept your changes.

Remove a toolbar icon.

  1. Select the toolbar from the Toolbar Definition list.

  2. Find the item in the list to remove (right side of dialog).

  3. Select it and press the ß Remove button.

  4. Click Apply and then OK to accept your changes.

Note: Existing toolbars must have at least one icon on them. If you remove the last icon and click Apply or OK, the icon still remains on the toolbar.

Erase any changes.

Click the Reset button. As long as the OK or Apply buttons haven't been clicked, the toolbar will revert to its previous state.

Remove all customized toolbars and restore the layout shipped with this version.

Click the Default button.

Create a new toolbar item.

Click New. The Custom Wizard / Script / Tool dialog box appears. Select item to add. This help file covers the process of adding custom items in the "To Add a New Menu Item" topic.

Rearrange item order on a toolbar.

  1. Select the toolbar from the Toolbar Definition list.

  2. Select the item you wish to move.

  3. Click these up arrow [image] or down arrow [image] buttons to move the item up or down respectively among the other toolbar icons in the list.

Rename a toolbar

  1. Select the toolbar from the Toolbar Definition list.

  2. Click Rename. A New Toolbar Name box appears.

  3. Type a name in the box and click OK.

PC-DMIS also allows another way to rearrange or delete items from any custom toolbar on the fly. This is by using the SHIFT key. Consider the following:

To delete or rearrange a toolbar's icons:

  1. Access the Customize dialog box.

  2. Press and hold the SHIFT key.

  3. Click and hold the mouse over the icon. The icon becomes movable.

  4. If rearranging the icon, drag it to a new spot on the toolbar.

  5. If deleting the icon, drag it outside of the toolbar's boundaries.

  6. Release the mouse button. The change is made.

Note: Since existing toolbars must have at least one icon on them, if you remove the last icon in this fashion, it will only remain removed until you restart PC-DMIS. After restarting, the icon will reappear.

To add a separator:

  1. Access the Customize dialog box.

  2. Press and hold the SHIFT key.

  3. Click and hold the mouse over the icon. The icon becomes movable.

  4. Drag it a small distance to the right (not far enough to rearrange its position).

  5. Release the mouse button. The separator appears at its left.

To delete a separator:

  1. Access the Customize dialog box.

  2. Press and hold the SHIFT key.

  3. Click and hold the mouse over the icon to the right of the separator. The icon becomes movable.

  4. Drag it on top of the separator to its left.

  5. Release the mouse button.


To Create a Custom Toolbar

Display Menu Roadmap

  1. Access the Customize dialog box and select the Toolbars tab.

  2. Click New and select Toolbar. An input box appears requesting a toolbar name.

  3. Type the name of the toolbar and click OK. Your new toolbar now appears in the Toolbar Definition list. You can now modify the toolbar to accept new toolbar icons (see "To Modify an Existing Toolbar").


To Delete a Custom Toolbar

Display Menu Roadmap

  1. Access the Customize dialog box and select the Toolbars tab.

  2. Select the toolbar from the Toolbar Definition list.

  3. Click the Delete button.

  4. Click Apply to apply your changes.


Customizing Shortcut Keys

Display Menu Roadmap

To customize the shortcut keys used for menu items and commands in PC-DMIS:

1. Access the Customize dialog box by selecting the View | Toolbars | Customize menu option.

2. Select the Keyboard tab.

Customize dialog box – Keyboard tab

You can use this tab to modify the shortcut keys used to call commands within PC-DMIS and add new shortcut keys for custom menu and toolbar items.

More:

To Add Shortcut Keys to a Command

To Remove Shortcut Keys from a Command


To Add Shortcut Keys to a Command

Display Menu Roadmap

  1. Access the Customize dialog box, and select the Keyboard tab.

  2. Select the command you wish to modify by using the Category and Menu Selection lists. Once you have selected a command in the Commands list, the current shortcut key(s), if any are assigned to that command, will be displayed in the Current Shortcuts box.

  3. Highlight the command for which you will assign new shortcut keys.

  4. Click in the New Shortcut box.

  5. Type the keys you want to assign to this command. The keys you pressed will appear as you type them.

  6. Click the Assign button, and the new shortcut keys will appear in the Current Shortcuts box with any other shortcut keys currently assigned to the command.

  7. Click Apply to accept your changes.

Note: As in the other tabs, you can use the Create button to first create a command and tie it to a custom program. You can then select this command by clicking on User Defined from the Menu Selection list. All user-defined commands will appear in the Commands list.


To Remove Shortcut Keys from a Command

Display Menu Roadmap

  1. Access the Customize dialog box, and select the Keyboard tab.

  2. Select the command you wish to modify by using the Category and Menu Selection lists. Once you have selected a command in the Commands list, the current shortcut key(s), if any are assigned to that command, will be displayed in Current Shortcuts box.

  3. Select the command for which you will assign new shortcut keys.

  4. Select the shortcut key to remove.

  5. Click the Remove button.

  6. Click Apply to accept your changes.


Docking and Undocking User Interface Elements

Some user interface elements (such as toolbar and some dialog boxes) will dock themselves into the Edit window or the toolbar area when drag and drop the item on top of one of those areas. If you don't want this, hold down the CTRL key while you release the mouse button. The dialog box will then hover over the dockable background instead.

Some items, such as the Edit window, contain a right-click menu item that allows you to dock or undock that item. If the right-click menu item is not selectable, close down any open dialog boxes and try again.


Using Basic File Options

Using Basic File Options: Introduction

Creating New Part Programs

Opening Existing Part Programs

Saving Part Programs

Performing File Operations

Changing the Language

SetTING PRINTER OPTIONS

Printing the Graphics Display Window

Printing from the Edit Window

P rinting the Inspection Report

Launching Legacy Applications

Closing or Quitting Part Programs

Exiting PC-DMIS


Using Basic File Options: Introduction

PC-DMIS provides you with many options to manipulate part programs and manage your essential files. As with most Windows based programs, you can perform basic file management using standard Windows dialog boxes; these include creating, opening, copying, renaming, and deleting files. Additionally, through PC-DMIS you can perform more advanced operations, such as importing and exporting CAD data, or executing completed part programs.

This chapter specifically deals with Basic File Options. For more advanced options, see the "Using Advanced File Options" section.

The options discussed in this section include:

  • Creating New Part Programs

  • Opening Existing Part Programs

  • Saving Part Programs

  • Performing File Operations

  • Changing the Language

  • Printing the Graphics Display window

  • Printing the Inspection Report

  • Closing or Quitting Part Programs

  • Exiting PC-DMIS


Creating New Part Programs

Display Menu Roadmap

If you don't have any existing part programs to open, then you must create a new part program using the New Part Program dialog box, accessible by selecting the File | New menu option.

New Part Program dialog box

Here you can create a new part. You will be prompted to enter a part name, serial number, revision number, interface type, and units of measurement type. The part is only in memory until you save the part. The CMM interface type is also chosen here.

Note: PC-DMIS only requires the Part Name box to have a value in order to create a new part program. Information entered in the Revision Number and Serial Number boxes is optional.


Opening Existing Part Programs

Display Menu Roadmap

If you have previously created a part program using the New Part Program dialog box (see "Creating New Part Programs"), you can open it by selecting it from the Open dialog box by selecting File | Open.

Important: Be aware that if you open a program created in a version prior to version 3.2 it will no longer be useable in the old version used to create it.

Open dialog box

This is a standard Windows Open dialog box with the following additions:

  • There is an Interface list. If PC-DMIS is running ONLINE, you can select which CMM (if you have multiple CMMs) to use for this part program, or you can run offline by selecting the OFFLINE machine.

  • A Preview area of the dialog box shows the CAD image for the last view of your part in the Graphics Display window (without labels). If your part doesn't have CAD data, the image will display measured geometry. This area also displays the name of the part program and the date it was last modified.

  • You can import data to or export data from a part program by right-clicking on the part program’s file name and selecting Import or Export, respectively (see "Importing CAD or Program Data" and "Exporting CAD or Program Data" from the "Using Advanced File Options" section if you want more information).

  • You can also examine and modify a part’s name, serial number, or revision number and change the file’s name to one made from the file's properties.

    To do this:

1. Right-click on the part program’s file name. A shortcut menu will appear.

2. Select the Properties command.

3. Select the PC-DMIS tab.

These same right mouse features are also available from within Windows Explorer.

Note: The Open dialog box automatically opens each time you start PC-DMIS, allowing you to open existing part programs. However, if you want this feature disabled, simply clear the Show Startup Dialog check box found in the Setup Options dialog box, on the General tab.

Probe Conversion Messages When Opening:

When opening a part program from a previous version, you may receive a warning message that asks you if you want to convert probe files for any probes used in the part program to the latest format.

Warning dialog box asking to convert a probe file

If you plan on using the probe with older versions of PC-DMIS, you may not want to update the probe file. However, note that until you update the probe file to the latest format, some newer functionality for that probe may not be available in this version of PC-DMIS.

If you continue to receive this message whenever you open your part program, even after clicking Yes, you should perform a File | Save As operation, and save the part program so that it is compatible with this version of PC-DMIS. See the "Save As" topic for more information.

Viewing Program Files In an Explorer Window:

When viewing part program and cad files inside of Window's Explorer, you have these viewing options:

  • Explorer's View | List, View | Details, and View | Icon menu items will display icons for part program and CAD files (.PRG and .CAD files). Note that the underlying code for these files points to different icons for each PC-DMIS version, so, if you have the proper tools, you could modify these icons to display something different for each version, if desired.

View | Icons example

  • Explorer's View | Tiles menu item shows an icon displaying the PC-DMIS version in which the .PRG or .CAD file was last used. You can also modify these icons for each version as well.

View | Tiles example showing V4.0 and V3.6 part programs

  • View | Thumbnails shows non V4.0 part programs with icons similar to how View | Tiles displays them. However, for part program files last used in v4.0 and above, View | Thumbnails displays an image of the last Graphics Display window for that .PRG file.

View | Tiles example showing V4.0 Part Programs


Saving Part Programs

Display Menu Roadmap

Selecting the File | Save option will save any work that has been done in the current program. The first time you save a file the Save As dialog box appears. This dialog box allows you to choose where to save your part program (see "Save As" for additional information).

If you have already saved a part program to a previous version of PC-DMIS (from the Save As dialog box), PC-DMIS will display a message on subsequent saves asking if you want to save the part program to the old version selected previously. If you click,

  • Yes, PC-DMIS saves the part program to the old version.

  • No, PC-DMIS saves the part program to the current version.

  • Cancel, PC-DMIS ends the save processes without saving.

If you want to stop displaying this message, see "Warnings" in the "Setting Your Preferences" section.

More:

Save As


Save As

Display Menu Roadmap

Selecting the File | Save As option will display the Save As dialog box.

Save As Dialog box

This allows you to store the current part program under a new file name or under a previous version.

Using the PC-DMIS part program list you can choose to save the part program in a format usable by the current version and previous versions of PC-DMIS. Available formats include version 3.202 and above. If you are saving the part program to a previous version of PC-DMIS that doesn't support newer commands in the current version, PC-DMIS will store unsupported commands inside of DOCUMENT comments. See "Document" in the "Using the Edit Window" section.

Click the Save button to save the part program. The Cancel button closes the dialog box without saving.

Save CAD as Reference - This check box lets you save the CAD file as a reference to the original CAD file. Use this check box to reference your CAD model instead of copying a new one. This helps save disk space. This option becomes available for selection whenever you have a CAD model loaded for your part program and access the Save As dialog box. If the original CAD file that is being referenced is ever deleted, moved, or renamed, PC-DMIS will prompt you to locate it.


Performing File Operations

Using PC-DMIS's file operations, you can mirror, copy, delete, and rename part program files.

More:

Mirror

Copy

Delete

Rename


Mirror

Display Menu Roadmap

The Mirror command (File | Operations | Mirror) allows you to create a mirror image copy in the X, Y, or Z axis of a part program. When you select this command, the Choose Part to Mirror dialog box appears:

Choose Part to Mirror dialog box

The following table describes the items available for selection on the dialog box:

Item

Description

Part Program list

This displays all the available part programs in the current directory.

File name list

This defines the part program to mirror.

Files of type list

This filters the display of the current directory to only show Part Program files (.PRG).

Part Mirror Axis area

This defines the axis in which you want to mirror the part program:

    • Mirror in X - Mirrors the part in the X axis

    • Mirror in Y - Mirrors the part in the Y axis

    • Mirror in Z - Mirrors the part in the Z axis

Reporting Mirror Option area

This defines how PC-DMIS should mirror CAD images in reports:

    • Don't Mirror - Does not mirror at all.

    • Horizontal - Mirrors CAD images horizontally.

    • Vertical - Mirrors CAD images vertically.

This affects reporting objects such as CADReportObjects, CADImageObjects, Analysis objects, and SectionCutObjects, as well as any defined viewsets in the part program.

Machine Mirror Axis area

Defines how PC-DMIS positions the mirrored part on a virtual machine displayed in the Graphics Display window. Available options include:

    • Mirror Machine Position in X - Mirrors the virtual machine's X axis.

    • Mirror Machine Position in Y - Mirrors the virtual machine's Y axis.

    • Mirror Machine Position in Z - Mirrors the virtual machine's Z axis.

Prior to version 4.3, when viewing the part on the virtual machine, PC-DMIS mirrored the part about the part origin and you had to define the location and orientation of the mirrored part using the Quick Fixture's shortcut menu. Now, in version 4.3 and later, PC-DMIS mirrors the part at the same location as the original part. Using the Machine Mirror Axis area you can define the orientation of the mirrored part on the virtual machine. You only need to shift the part on the machine to the place it should get measured.

For a description of how these options will position your part, consider the following description:

Graphical Description

Key

1 | Machine's Origin
 | Original Part
 | Part Mirrored in Y with Mirror Machine Position in Y
 | Part Mirrored in Y with Mirror Machine Position in X

(Maximize your help viewer)

Reference Part area

This pulls out any quick fixture alignment data from the reference part and uses that information in the mirroring operation.

If you define a reference part using this area then PC-DMIS will not use the Machine Mirror Axis area. Instead, the location and orientation of the mirrored part is loaded from the existing (and already mirrored) reference part program.

This option is especially useful if you have multiple part programs that belong to the same physical part and need to get mirrored. In this case you would only need to define the location and orientation of the mirrored part in the first mirrored part program. You could then easily mirror other part programs by selecting the first mirrored part program as the reference part.

To Mirror a Part Program:

  1. If you use an infinite wrist in the part program, you should first set the AlternateTipMirror registry entry to TRUE. This entry is located in the USER_Option section of the PC-DMIS Settings Editor. This entry helps PC-DMIS choose the correct AB angle in cases where the probe head offers more than one possible combination of AB angles to produce the mirrored tip vector.

  2. Select the File | Operations | Mirror option. The following Choose Part to Mirror dialog box will appear:

  2. Select the part program file to mirror.

  3. From the Part Mirror Axis area, select the axis in which you want to mirror.

  4. From the Reporting Mirror Option area, choose how you want to mirror CAD images in reports.

  5. From the Machine Mirror Axis area, choose how you want to position the mirrored part on a virtual machine displayed in the Graphics Display window.

  6. If you have an already mirrored reference part, use the Browse button in the Reference Part area to select that part. This pulls out any quick fixture alignment data from the reference part and uses that information in the mirroring operation.

  7. Click the Mirror button. The Save mirrored part as dialog box will appear with the file name of the part program you selected to mirror:

Save mirrored part as dialog box

  8. Navigate to the directory where you want the program to be saved and click the Save button. PC-DMIS will mirror the part program. Note that it may take a little while to copy the necessary files.

Important: PC-DMIS also attempts to mirror your probe's AB tip angles. If your probe does not have the exact mirrored tip angles already defined and calibrated, PC-DMIS may choose the closest calibrated tip angles. It chooses closely calibrated tip angles if the calibrated tip angles exist, and are within the wrist angle amount specified in the Wrist Warning Delta box on the Part/Machine tab of the SetUp Options dialog box. If no closely calibrated AB tip angles exist, then PC-DMIS will create perfectly mirrored yet non-calibrated AB tip angles. See the "Setup Options: Part / Machine tab" topic in the "Setting Your Preferences" section.


Copy

Display Menu Roadmap

The Copy command allows the user to copy all the files associated with a given part program.

To copy a part program:

  1. Select the File | Operations | Copy menu item. The Copy Part Files From dialog box appears asking which file you wish to copy and from which folder.

  2. Navigate through the directory structure and select a part program.

  3. Click the Open button. The Copy Part Files To dialog box appears next.

  4. Click on the part program you want to copy so that its filename and extension appears in the File name box.

  5. Navigate to the folder to which you want to copy the program.

  6. Click the Open button.

The files that will be copied are the ".PRG" file, the ".CAD" file, and any file with the same base name and an extension in the range .001, .002, …, .999.


Delete

Display Menu Roadmap

The Delete command allows the user to delete all the files associated with a given part program.

To delete a part program:

  1. Select the File | Operations | Delete menu item. A Delete Part files dialog box will appear

  2. Choose which part program to delete.

  3. Click the Open button. PC-DMIS will bring up another box, asking if you are sure that you want to send the files to the Recycle Bin.

  4. Click the Yes button.

The files that will be deleted are the ".PRG" file, the ".CAD" file, and any file with the same base name and an extension in the range .001, .002, …, .999. Any deleted files will be sent to the Recycle Bin.


Rename

Display Menu Roadmap

The Rename command allows the user to rename all the files associated with a given part program.

To rename a part program:

  1. Select the File | Operations | Rename menu item. The Rename Part Files From dialog box will appear, asking you which file you want to rename.

  2. Select which part program to rename.

  3. Click the Open button. The Rename Part Files To dialog box will appear, asking you for the new name of the file.

  4. Type in the new name for the file in the File name box.

  5. Click the Open button. The name change will immediately be applied.

The files that will be renamed are the ".PRG" file, the ".CAD" file, and any file with the same base name and an extension in the range .001, .002, …, .999.


Changing the Language

Display Menu Roadmap

Selecting File | Language displays the languages that are available to PC-DMIS users. A check mark indicates the language that is currently being used. To switch to a new language, simply select the desired language. PC-DMIS will automatically save your part program, exit from PC-DMIS and then restart it. Once restarted, PC-DMIS will run in the newly selected language. Grayed out languages cannot be selected. A given language may be available but not installed on your current system.


Setting Printer Options

The Printer Setup button and menu item allow you access the standard Windows Print Setup dialog box. This dialog box lets you switch between available printers, choose paper size, page orientation, and access other printer properties. PC-DMIS will then use these options when printing the Edit window, the Inspection Report, or the Graphics Display window.

A Sample Print Setup Dialog Box

For information on this dialog box and the options available, consult the help file that came with your Windows operating system. For any advanced printer-specific properties, you may need to consult documentation specific to your printer.


Printing the Graphics Display Window

Display Menu Roadmap

PC-DMIS lets you send the current contents of the Graphics Display window to your printer. Select the File | Printing | Graphics Window Print menu option to do this. PC-DMIS will display a Windows Print Setup dialog box. Click OK to send the report to the printer shown in the dialog box.

Before printing, you can set the output options, and preview your print job.

More:

Setting Output and Printer Options

Previewing the Print Job


Setting Output and Printer Options for the Graphics Display Window

Display Menu Roadmap

Selecting the File | Printing | Graphics Window Print Setup menu option will display the Printer Setup and Output Options dialog box.

Printer Setup and Options dialog box

This dialog box is used to set up your printer and determine various display option. The options available in the Printer Options area, allow you to select the type of graphical view that will be printed. These include:

Scale to Fit on a Single Page - This option scales any graphical image to fit on a single page.

Print Visible Screen Area - This option prints only the current visible screen area. If you're zoomed in on a feature, it will print only what's on the screen and not the entire part.

Print Complete Views - This option prints each view you have defined using the View Layout area of the View Setup dialog box on its own page. For example, if you're showing the Z+ view and the Y- view of a part in your Graphics Display window, PC-DMIS will print two separate pages, one with the Z+ view and one with the Y- view.

Print Complete Views w/Current Scale - This option acts like the Print Complete Views option, except that it prints at the current scale. If you have zoomed in on the image, PC-DMIS will still print the entire view, but will split the image among various pages.

The Draw Rulers check box will also print any rulers you may have displayed on the Graphics Display window. To display rulers, use the View Setup dialog box (Edit | Graphics Display Window | View Setup). See "Setting up the Screen View" in the "Editing the CAD Display" section. Display Menu Roadmap

Click the OK button to save any changes.


Previewing the Print Job

Display Menu Roadmap

You can easily preview what will be printed from the Graphics Display window by selecting the File | Printing | Graphics Window Print Preview menu option. A Print Preview window appears.

Print Preview window showing contents of Graphics Display window

The buttons at the top of the window perform these functions:

The Print button opens up a standard Print Setup dialog box that will allow you to send the print job to the printer.

The Next Page and Prev Page buttons cycle through a print job that has multiple pages.

The One Page or Two Pages toggle button determines how many pages are displayed at one time in the preview window.

The Zoom In and Zoom Out buttons allow you to take a quick closer look at a page in the preview window. It doesn't affect the display of what's sent to the printer.

The Close button closes the preview window.


Printing the Edit Window

PC-DMIS lets you easily and quickly print the contents of your Edit window. You can send the contents of the Edit window to your printer in these ways:

  • Select File | Printing | Edit Window Print. Display Menu Roadmap

  • Click the Print icon from the Edit Window toolbar.

  • Press F4.

Previewing the Print Job

To preview what the printout will look like, select File | Printing | Edit Window Print Preview. Display Menu Roadmap

A Print Preview window appears:

Print Preview Window of the Edit Window

Print Preview window showing contents of the Edit window

The buttons at the top of the window, perform these functions:

  • The Print button opens up a standard Print Setup dialog box that will allow you to send the print job to the printer.

  • The Next Page and Prev Page buttons cycle through a print job that has multiple pages.

  • The One Page or Two Pages toggle button determines how many pages are displayed at one time in the preview window.

  • The Zoom In and Zoom Out buttons allow you to take a quick closer look at a page in the preview window. It doesn't affect the display of what's sent to the printer.

  • The Close button closes the preview window.

Important: When printing the Edit window's contents, you should use a True Type font (such as Courier New), otherwise characters or lines may not line up as expected. To change the fonts used in the Edit window and in your reports, see the "To Customize User Interface Fonts" topic in the "Navigating the User Interface" section.

Setting Output Options

You can set the output options for Edit window print tasks by using the same Print Options dialog box used for the output of your Inspection Report. See "Printing the Inspection Report" for information. To change printers, set page orientation, or modify other printer options use the File | Printer Setup menu item.


Printing the Inspection Report

Display Menu Roadmap

PC-DMIS lets you send your text-based inspection report to a variety of output devices or to a file. PC-DMIS supports a wide variety of printers and plotters. Please contact your PC-DMIS sales representative if you have any questions concerning hardware compatibility.

Use this capability to print inspection reports that include a graphical representation of the part. To do this, select the File | Printing | Print Report menu option. Before printing, you can set the output options for your print job.

Important: When printing the Inspection Report, you should use a True Type font (such as Courier New), otherwise characters or lines may not line up as expected. To change the fonts used in the Edit window and in your reports, see the "To Customize User Interface Fonts" topic in the "Navigating the User Interface" section.

More:

Setting Output and Printer Options


Setting Output and Printer Options for the Edit Window

Display Menu Roadmap

Selecting the File | Printing | Report Print Setup menu option will display the Report Print Options dialog box.

Report Print Options dialog box

You can use this dialog box to tell PC-DMIS where you want to send the inspection report. You can send it to a file, the printer, or output it as a DMIS file or any combination of the three. To do this:

  1. Select the File check box, the Printer check box, the DMIS Output check box, or any combination of the three.

  2. Next to each check box certain options will become available depending on what you selected in the previous step.

  3. Click the OK button (or press ENTER). The Print Options dialog box closes.

Setting Printing Options for Marked Sets

PC-DMIS also displays an instance of the Report Print Options dialog box whenever a Marked Set is created. (See "Creating and Executing Marked Sets" in "Editing a Part Program".) This allows you to define printing options specific only to the newly created Marked Set. Alternately, if you would rather use already defined print settings used by your part program at large, you can select the Use Global Print Settings check box.

To define printing options for existing Marked Sets, select the set in the Marked Sets window then select File | Printing | Report Window Print Setup.

More:

Output to a File:

Output to a File Using Expressions

Output to the Printer:

Output as a DMIS Output File:


Output to a File Using Expressions

PC-DMIS 3.6 and higher allows you to use expressions in the File box of the Print Options dialog box. With this functionality, you can use your part program code along with the Print Options dialog box to dynamically change the destination directory for the output file.

For example, suppose two users, John and Amy, want to send the same part program's inspection report to an existing sub directory based off of the user name. Instead of opening the Print Options dialog box for each user, and changing the destination directory and the name of the report, you can simply have the user type their name into a Comment and then use assignment and flow control commands to store the different destination directories and report names in a variable, like this:

C1 =COMMENT/INPUT,YES,Type your name:

IF/C1.INPUT == "John"

ASSIGN/VAR_FILENAME = "C:\\inspectionreports\\John\\John.rtf "

COMMENT/OPER,NO,VAR_FILENAME

END_IF/

ELSE_IF/C1.INPUT == "Amy"

ASSIGN/VAR_FILENAME = "C:\\inpectionreports\\Amy\\Amy.rtf"

COMMENT/OPER,NO,VAR_FILENAME

END_ELSEIF/

ELSE/

ASSIGN/VAR_FILENAME = "C:\\inspectionreports\\" + C1.INPUT + ".rtf"

COMMENT/OPER,NO,VAR_FILENAME

END_ELSE/

Then inside the File box of the Print Options dialog box, you can type the VAR_FILENAME variable as shown here:

VAR_FILENAME in File box

VAR_FILENAME in File box

Thereafter, whenever you execute the part program, if John is the user, the report, John.rtf will get saved to his directory; if Amy is the user, Amy.rtf will get saved to her directory; if some other user types his name, it will go to the default C:\Inspectionreports\ directory.

  • For information on comments, see the "Inserting Programmer Comments" topic in the "Inserting Report Commands" section

  • For information on expressions and variables, see the "Using Expressions and Variables" section.

  • For information on flow control statements, see the "Branching by Using Flow Control" section


Note: If not already installed on your computer, you will need to install the free Adobe® Acrobat® Reader™ in order to view .pdf files. You can download it from Adobe's Web site at: http://www.adobe.com/products/acrobat/readstep.html

Output to a File:

If the output is sent to a file, it can be saved in either a Rich Text Format (.rtf) or Portable Document Format (.pdf) file. The filename is initially generated and formatted to have the same name as the part program plus an appended numerical index before the extension. Although PC-DMIS generates this initial file name, the name does not need to follow the default format and may be changed.

Appending a File:
If Append is selected, PC-DMIS adds the current data from the inspection report to the selected file. Note that the complete path must be specified; otherwise, PC-DMIS will assume the same directory as the part program. Also, if the file does not exist, it will be created when generating the report.

RTF Limitations: Due to a limitation with how the RTF driver works with PC-DMIS's template approach to reporting, when appending to an RTF file, PC-DMIS only sends the contents of the TextReporting object, regardless of any other objects that may exist in your current report template.

Additionally, if you choose to append to an RTF file, it must be to a file that you have always used with the Append option. You cannot append to an RTF file that you first used with Overwrite or Auto.

Overwriting a File:
PC-DMIS overwrites the selected file with the current inspection report data. Note that the complete path must be specified; otherwise, PC-DMIS will assume the same directory as the part program. Also, if the file does not exist, it will be created when generating the report.

Prompting for a Destination:
If Prompt is selected, PC-DMIS will display a Save As dialog box through which you can choose the destination file for the report.

Using the Auto Option:
PC-DMIS generates the report filename automatically using the number in the Index box. The name of the generated file name will have the same name as the part program appended by the numerical index and extension. Also, the generated file will be located in the same directory as the part program. If a file exists with the same name as the generated filename, the Auto option will increment the index value until a unique file name is found.

Note: After the report prints, PC-DMIS internally updates the value in Index to the next number. It also changes the filename in the Print Options dialog box, so that it shows the newly incremented filename.

Rich Text Format (RTF):
If the Rich Text Format (RTF) option is selected, PC-DMIS generates the report using the Microsoft Rich Text Format (.rtf file) for interchanging documents. Images in RTF reports will have a light border around them.

By default, PC-DMIS generates RTF reports using an Amyuni RTF converter. This essentially orders information inside several text boxes inside the RTF file. This is needed for accurate positioning of report template elements inside the RTF report. To properly view the report, you should use Microsoft Word and set the document's view to Print Layout. If you find editing the report in this format difficult to work with, you might want to consider generating an old style RTF report.

Generating an Old Style RTF Report

PC-DMIS provides a way to generate an old style RTF report, such as used in version 3.7 and earlier. To do this, follow this procedure:

    1. Close down PC-DMIS.

    2. Launch the PC-DMIS Settings Editor.

    3. Inside the Settings Editor, expand the Printing section, and find the DoNotUseAmyuniRTF setting.

    4. Set the Current Value to 1, click Save Setting, and click OK.

Note: This setting only works if the RTF output is done using the File | Printing | Report Window Print Setup menu option. If you have inserted a PRINT/REPORT command (Insert | Report Command | Print Command) and you want that command to generate your RTF output, set the value to 2.

    5. Restart PC-DMIS.

    6. Make sure the Report window is set to print the report in a text-only format. To do this, right-click on the white-space at the end of the Report window and select the Use Text Mode Dimension Reporting check box. See " Changing the Report Window's Contents" in the "Reporting Measurement Results" section for more information.

Portable Document Format (PDF):
If the Portable Document Format (PDF) option is selected, PC-DMIS generates the report using the Adobe Portable Document Format (.pdf file) for electronic file sharing. Dimensions in PDF format will not have the default blue background color or display the dimension symbol.

Use Global Print Settings:
This check box becomes available if you first select a marked set from the Marked Sets window and then access this dialog box. The Use Global Print Settings check box determines whether or not PC-DMIS uses global output file parameters for the marked set. Selecting this check box overrides the very specific default printing options used for marked sets, with the part program's global settings, giving you greater control over the output. Selecting this check box will give you more control over the print-to-file naming schemes used with marked sets.

Note: The Hyper Reports Inline check box has been removed from this dialog box because the ability to create HyperView reports inline was a function of the old Report mode that existed prior to version 4.0. While you can still execute HyperView reports by inserting them into your part program, you cannot edit them in versions later than 4.0. For more information, see the "Reporting Measurement Results" section.

Controlling File Size by Changing the Print Resolution

In version 4.2 and higher if your report contains images of your part model, PC-DMIS by default prints these images at your printer's highest resolution capacity. This means reports showing part models and sent to a file may have a larger file size than expected.

You can control the resolution, and in turn control the report's file size, by changing the value of the MaxPrintResoution entry in the Printing section of the PC-DMIS Settings Editor. See Modifying Registry Entries" for information on how to change registry entries.

MaxPrintResolution defines the dots per inch (dpi) that your printing device will generate when printing CAD images. You can change this value to define the proper balance between file size and image quality to suit your needs. The default value is 1,000,000 dpi thereby effectively using any printer's maximum print resolution capacity. If you define a value less than your printer's maximum print resolution you will see a decrease in file size. For example, if your printer can print up to 500 dpi but you change the entry to a smaller value, like 70 dpi, you will notice a decrease in file size. Note that older versions of PC-DMIS (before version 4.2) used the screen resolution of 96 dpi."


Output as a DMIS Output File:

If the DMIS Output check box is selected, PC-DMIS allows you to save the inspection report's information as a DMIS Output file. Three check boxes (Overwrite Output File, Output Theoretical Values, and Output Features with Dimensions) and a Save As button become available. By default PC-DMIS will automatically generate the output file whenever you execute the part program, incrementing the number on the filename each time it is executed.

Save As

  • Clicking the Save As button opens a Save As dialog box. This allows you to save the inspection report or Edit window information to a file and directory of your choice in a DMIS output format. Available file formats use the .dmo, .dms, .dmi, and .dmis extensions. PC-DMIS does not save the file once you click Save from the Save As dialog box. Instead, it will create the output file with the specified name the next time you execute the part program.

Note: It doesn't matter what file format you choose since they all produce identical outputs anyway. These different extensions merely provide customers that work with DMIS files, a file type with which they are familiar.

However, do not confuse a .dms or .dmi measurement report from this dialog box with a .dms or .dmi file created from the DMIS Export functionality. Exporting an entire part program so that it runs in a DMIS enabled software is quite different from viewing an inspection report saved in the DMIS Output standard.

Overwrite Output File

  • If you select Overwrite Output File, PC-DMIS will simply overwrite the old output file with the new one. If you don't select this check box, PC-DMIS automatically increments the file name specified in the Save As dialog box without overwriting any previous file.

    For example, if you had previously selected "test.dmo" as your output file and Overwrite Output File was not selected, the next time the part program was executed, PC-DMIS would save a new file as "test1.dmo". New executions of the part program would be saved as files incremented in this manner.

  • If you place Overwrite Output File in its third state (light gray check mark), PC-DMIS will open the specified file in append mode. This follows the DMIS convention that allows you to enable, disable, and enable again the output to the same file. In PC-DMIS, this will function correctly only if the file was initially opened with Overwrite Output File selected.

Output Theoretical Values

  • If you select Output Theoretical Values, PC-DMIS outputs all theoretical values along with the measured values to the output DMIS file. If you don't select this check box, no theoretical values are included in the report.

  • If you place the Output Theoretical Values check box in its third state (light gray check mark), only those theoretical values explicitly output by the original DMIS program are output in the report. This third state is useful when the part program is created by a DMIS import process, and you need to maintain the same DMIS output format.

Output Features with Dimensions

  • If you select Output Features with Dimensions, PC-DMIS will keep the measured features and associated tolerances together in the output file. PC-DMIS will write the measurement results immediately before their associated tolerance results for each dimension associated to the feature itself.

    If a feature is not associated with any tolerance, PC-DMIS will not generate any output.

  • If you don't select Output Features with Dimensions, the measurement results are written exactly when the feature is measured and not later when PC-DMIS executes the associated dimensions.

Note: The numeric portion of the file name should not exceed more than 10 digits. Otherwise, you run the risk of overwriting older output files.


Output to the Printer:

This sends the output to your current default printer.

The Print Background Colors check box lets you determine whether or not the report prints background colors. By default, PC-DMIS selects this check box and prints the background colors. If you clear this check box, PC-DMIS will not print any background colors. If you want to clear or display the background color from a report already in the Report window, make sure you click the Redraw the Report icon from the Reporting toolbar.

Sample Report with Background Colors Printed

Sample Report without Background Colors Printed

Note: In certain cases you may continue to see some background colors in your report even if you've turned off the display of background colors here. This is due to a special background color setting that exists inside certain report template objects and is not controlled by this check box. By default, the TextReportObject and the Report object that exist in PC-DMIS report templates have a faint light-green background color in their color scheme. For the TextReportObject this exists to help show the limits of the object inside the template. If this background color poses a problem, access the Color property for these objects inside the report template, and change these objects' background colors to white. See "Changing the Report's Text Colors" in the "Reporting Measurement Results".


Output as a DML File

If the DML Output check box is selected, PC-DMIS allows you to save the inspection report's information as a DML file. DML stands for Dimensional Markup Language. A DML output file is actually just a text file (very similar to an XML file) containing your report's data. You can then plug this type of file into any other reporting application that accepts a DML output.

While, you can view this file in any text editor, such as Notepad, it isn't very readable. A better approach would be to download a dedicated XML viewer or editor. There are several such applications freely available on the Internet.

For additional information on DML see http://www.dmlspec.org/.


Launching Legacy Applications

PC-DMIS allows you to launch existing Legacy applications from within PC-DMIS. Simply select the appropriate menu option from the File | Launch submenu.

  • MM4

  • Tutor

  • Chorus

  • Master

  • Quindos

  • MeasureMax

Once you exit from a Legacy application, Windows returns the focus to PC-DMIS.


Closing or Quitting Part Programs

Display Menu Roadmap

  • Selecting Close will save and close the active part program. If the part has never been saved, you will be prompted to name and save your file.

Display Menu Roadmap

  • Selecting Quit will quit the current part program without saving any changes. Only data that has been previously saved will be retrievable. If quit is chosen, a message appears, asking if you want to quit the program without saving. To save the part program, choose NO in the message box, and follow the instructions under "Saving Part Programs".

Note: If you close down the Report window, the Edit window, and the Graphics Display window by clicking on each window's X, PC-DMIS immediately saves the part program and then closes it. If you simply hide the windows using the View menu, the part program remains open.


Exiting PC-DMIS

Display Menu Roadmap

To quit the current part program and exit PC-DMIS, choose the File | Exit command. Unlike the File | Quit command, when File | Exit is chosen, PC-DMIS automatically saves the current part program before exiting.


Using Advanced File Options

Using Advanced File Options: Introduction

Importing CAD Data or Program Data

E xporting CAD Data or Program Data

Altering the Imported / Exported Image Display

Setting Import Options

Executing Part Programs


Using Advanced File Options: Introduction

PC-DMIS provides you with many options to manipulate part programs and manage your essential files. As with most Windows based programs, you can perform basic file management using standard Windows dialog boxes; these include creating, opening, copying, renaming, and deleting files. Additionally, through PC-DMIS you can perform more advanced operations, such as importing and exporting CAD data, or executing completed part programs.

This chapter specifically deals with advanced file options. For more basic options, see the "Using Basic File Options" section.

The options discussed in this section include:

  • Importing CAD or Program Data

  • Exporting CAD or Program Data

  • Altering Imported / Exported Image Display

  • Setting Import Options

  • Executing Part Programs

These options and commands are described in detail throughout this section.


Importing CAD Data or Program Data

Display Menu Roadmap

Using the File | Import menu option, PC-DMIS displays a sub menu of data types that you can import into the current part program. Data types are either CAD data that is imported in the CAD file or Part Program data that is imported into the Part Program. Selecting a menu item displays an Open dialog box.

The input data files that can be used can be any of these file types:

  • CAD Import - CAD (PC-DMIS),CATIA, CATIA5, DES, DXF, IGES, Parasolid, Pro/E, STEP, STL, Unigraphics, VDAFS, or XYZIJK,

  • Part Program Import - AVAIL, Chorus DMIS, DMIS, MMIV, Inspection Plan, Tutor, MeasureMax

  • Direct CAD - CATIA, Unigraphics,Pro/E, ACIS, I-DEAS, CATIA5, SolidWorks, and Solid Edge

PC-DMIS keeps track of the CAD data as a separate file. This file will have the same OS file name as the part program, but will have the ".CAD" extension. All operations, such as RENAME, DELETE, and COPY are also done on the associated CAD file (if one exists).

Example: A part program using the OS file name of TEST.PRG is being used. If CAD data is added to this part program, PC-DMIS will create a CAD file named, TEST.CAD, and file it in the same directory. If the TEST.PRG part program is later deleted using the Operations sub-menu, PC-DMIS will also delete the TEST.CAD file.

In version 3.5 and higher, PC-DMIS allows you to use import existing .CAD files for use with multiple part programs. This is discussed in "Referencing One CAD file for Multiple Part Programs".

More:

To Import a Data File into a Part Program:

Merge/Replace

Importing a CAD file

Importing a CATIA File

Importing a CATIA5 File

Importing a DES File

Importing DXF/DWG Files

Importing an IGES File

Importing an IGES (Alternate) File

Importing a Pro/ENGINEER File

Importing a STEP File

Importing an STL File

Importing a Unigraphics or Parasolid File

Importing a VDAFS File

Importing an XYZIJK File

Importing an Avail or MMIV Program

Importing a ChorusNT Program

Importing a DMIS Program

Importing a Tutor Program

Importing a Direct CAD File


To Import a Data File into a Part Program:

  1. Display Menu Roadmap Select the File | Import menu option and then select a data type to import. An Open dialog box appears.

  2. Navigate through the available directories until you find the directory containing the data files.

  3. Choose the desired input data file type from the Files of Type drop-down list at the bottom of the dialog box and then select the file to input. If the selected part program already has CAD data associated with it, disregard this step.

  4. Click the Import button. If you already have CAD data imported for your current part program, then PC-DMIS asks if you want to replace the existing CAD data or merge the CAD data together. Click either Merge or Replace. See the Merge/Replace topic for more information.

  5. Follow the remaining dialogs depending on the data type that you have chosen.

  6. The CAD file will be imported.

CAD data can be added and merged at anytime during the cycle of the part program by following the steps described in "Merge/Replace".

Note: The Import option will also allow you to "post-in" a translated DOS file. See the "Translating a Part Program into PC-DMIS" section.

More:

Importing Multiple CAD Files


Importing Multiple CAD Files

Display Menu Roadmap

PC-DMIS allows you to easily import multiple CAD files at the same time. This is useful if you want to import the same part model as both a wireframe and a solid. To do this, click on the CAD Import icon from the Wizards toolbar. A dialog box opens. Select the files to import and select Open. You can then choose to merge the data.

For more information, see the "Wizards Toolbar" topic in the "Using Toolbars" section.


Merge/Replace

When importing a CAD file, PC-DMIS will display the Merge Import Data dialog box if the selected part program already has CAD data associated with it. You can choose to either Merge or Replace the CAD data.

  • If you select the Merge (new data) option, PC-DMIS will add the input data to the part program without deleting the existing data.

  • If you select the Replace option, PC-DMIS will delete the existing data and replace it with the new input data.

Clicking Back returns you to the Open dialog box.

Note: Some imported file types automatically replace old existing CAD data with the imported data. In those cases, you won't be presented with the Merge Import Data dialog box.


Importing an ASCII File

ASCII files are text files that contain part program information output from virtually any third party CMM software. You can import these file types into PC-DMIS by using File | Import | ASCII to automatically create a part program.

For this menu item to appear, your port lock must have been programmed to support the "Inspection Planner" module.

See "Using the Generic Parser to Import ASCII Files" in the Inspection Planner documentation for in-depth information on how to import these files.


Importing a CAD File

  1. Display Menu Roadmap Select the File | Import | CAD... menu option. An Open dialog box appears.

  2. Navigate to the directory containing the file to import.

  3. Click Import when ready to import the file. PC-DMIS will import the CAD file.

You reference one CAD file from multiple Part Programs. See the "Referencing One CAD file for Multiple Part Programs" section for more information on how to do this.


Referencing One CAD file for Multiple Part Programs

In previous versions of PC-DMIS, creating a new part program that used the same IGES file as other part programs automatically created a new .CAD file. In version 3.5 and above you can have multiple parts reference a single .CAD file. This is especially useful for multiple part programs that use the same CAD model. If you are using large CAD models, you can save a substantial amount of disk space by referencing just one CAD file for multiple part programs.

To reference a .CAD file used in another part program:

  1. Display Menu Roadmap Select the File | Import | CAD By Reference... menu option. An Open dialog box appears.

  2. Navigate to the directory containing the file to import.

  3. Click Import when ready to import the file. PC-DMIS will import the CAD file.

  4. Follow the instructions in the "To Import a Data File into a Part Program" topic in this section, and when the Import Data dialog box appears, select CAD Reference as the data type for importation, then continue with the importation process.

Note: Circular references to .CAD files aren't possible and will always display an error message. An error would occur, for example, if you created a new part program, imported an IGES file, saved the part program, and then later attempted to import its own .CAD file.

Once imported, using the View | CAD Info menu option to view information about a CAD element will display the file path for the referenced CAD file (see "Viewing CAD Information" in the "Editing the CAD Display" section. Display Menu Roadmap

Note: Be aware that modifications made to the CAD model¾either the original CAD model or a referenced CAD model¾will be made to all other part programs based on that CAD model. For example, if you make changes to the original CAD model, any models referenced from the original will have the same changes made. Conversely, if you make changes to a referenced model, then the original model also has the same changes made.


Importing a CATIA File

Importing a CATIA or CATIA5 File

PC-DMIS allows you to translate a CATIA or CATIA5 file and import it into a PC-DMIS part program. This type of importation differs from interfacing directly with the CATIA CAD file as described in "Installing and Using CATIA Direct CAD Interface" in the "Directly Interfacing a CAD File" section.

To import a CATIA file:

  1. Open the part program in PC-DMIS into which you are going to import the CATIA file.

  2. Display Menu Roadmap Select the File | Import | CATIA or CATIA5 menu option. An Open dialog box will appear.

  3. Choose CATIA4 Files or CATIA5 Files from the Files of Type list at the bottom of the dialog box. PC-DMIS lists program files ending with extensions according to what you selected.

    • If you selected CATIA4 Files, then PC-DMIS lists files with .mod, .exp, .iso, and .cat filename extensions.

    • If you selected CATIA5 Files, then PC-DMIS lists files with .CATPart and .CATProduct filename extensions.

  4. Navigate through the available directories until you find the directory containing the desired CATIA file and select that file from the list.

  5. Click the Import button. PC-DMIS imports the CAD file, and a progress bar appears indicating its progress.


Importing a DES File

  1. Display Menu Roadmap Select the File | Import | DES... menu option. The File Open dialog box appears.

  2. Browse through your hard drive, and select a DES (Data File Exchange) file.

  3. Click the Import button. The Des File dialog box appears.

DES File dialog box
DES File dialog box

  4. Select either Feature or Fixture to specify what type of data is imported. If you select Feature you can select the Use Symbols check box to use feature labels.

  5. Select the XYZ(LWH) or XZY(LHW) option to specify the orientation for the imported data.

  6. Select the Metric option if the needed units are not specified in the DES file.

  7. Select the Explode polylines to points option to convert imported lines into points. Additionally, you can choose to keep the imported polylines by selecting the Keep polylines option.

  8. Click Process to import the DES file.

  9. Click OK to accept the processed file.


Importing a DXF File

Importing a DXF/DWG File

  1. Display Menu Roadmap Select the File | Import | DXF... menu option. An Open dialog box appears.

  2. Select the data type you want to import from the Files of Type list.

  3. Navigate to the directory containing the file to import.

  4. Click Import when ready to import the file. PC-DMIS will display the DXF/DWG Import Status dialog box.

DXF/DWG Import Status dialog box

  5. Click OK when the DXF or DWG file has been translated. If the translation fails, the OK button will not be available. Click Cancel to decline the addition of the imported file.


Importing an IGES File

  1. Display Menu Roadmap Select the File | Import | IGES menu option. An Open dialog box appears.

  2. Navigate through the available directories to the directory containing your part file.

  3. Select the file.

  4. Click the Import button. PC-DMIS next displays the IGES File dialog box. The IGES File dialog box displays all of the pertinent information regarding the indicated data file.

IGES File dialog box
IGES File dialog box

  5. If you want to determine what CAD data gets processed and displayed, click the Setup button (see "Altering the Imported / Exported Image Display").

  6. To view specific IGES feature data, click the Data button (see "Using the IGES Data Dialog Box").

  7. To attach this file to the selected part program, simply click the Process command button. PC-DMIS will indicate when the file is 100% processed.

  8. If you want to manipulate a 2D CAD drawing three-dimensionally, thereby creating desired 3D levels, click the Make 3D button. If you do this, your original data should be defined in a single plane parallel to the Z (= 0) plane. For complete information on this option, see the "Making CAD 3D by using the Create Levels window " topic in the "Editing the CAD Display" section.

  9. To complete the action, click the OK button, and PC-DMIS will return open the part program.

Selecting the Cancel button will terminate the entire operation and close the IGES File dialog box.

See "Working in Off-line Mode" for information regarding the different input file formats.

More:

Using the IGES Data Dialog Box

Make 3D


Using the IGES Data Dialog Box

The IGES Data dialog box allows you to click on a specific feature in the list box to display information regarding that feature's diameter, XYZ nominal, etc.

IGES Data dialog box

To view information about the CAD data you're importing inside the IGES Data dialog box, follow this procedure:

  1. Begin importing a CAD or IGES file (see "Importing an IGES File".

  2. Once the IGES File dialog box appears, click Process to import the data.

  3. Once it's complete, click the Data button. The IGES Data dialog box appears.


Make 3D

The Make 3D button tells PC-DMIS to manipulate a 2D CAD drawing three-dimensionally, creating desired 3D levels. The original data should be defined in a single plane parallel to the Z (= 0) plane.

For complete information on this option, see the "Editing the CAD Display" section.


Importing an IGES (Alternate) File

PC-DMIS provides an alternate method for importing an IGES file aside from the standard IGES import option. Files are processed similar method used for GDX, DXF, etc.

To import an IGES file:

  1. Display Menu Roadmap Select the File | Import | IGES (Alternate)... menu option. An Open dialog box appears.

  2. Select the data type you want to import from the Files of Type list.

  3. Navigate to the directory containing the file to import.

  4. Click Import when ready to import the file. PC-DMIS will display the IGES Import Status dialog box.

IGES Import Status dialog box

  5. Click OK when the IGES file has been translated. If the translation fails, the OK button will not be available. Click Cancel to decline the addition of the imported file.


Importing a Pro/ENGINEER File

PC-DMIS allows you to translate a Pro/ENGINEER file and import it into a PC-DMIS part program. This type of importation differs from interfacing directly with the Pro/ENGINEER CAD file as described in the "Installing and Using Pro/ENGINEER Direct CAD Interface" in the "Directly Interfacing with a CAD File" section.

To import a Pro/ENGINEER file:

  1. Open the part program in PC-DMIS into which you are going to import the Pro/ENGINEER file.

  2. Display Menu Roadmap Select the File | Import | Pro-Engineer menu option. An Open dialog box will appear.

  3. Choose Pro/ENGINEER Files from the Files of Type list at the bottom of the dialog box. PC-DMIS lists program files ending with these extensions: .prt and .asm.

  4. Navigate through the available directories until you find the directory containing the desired Pro/ENGINEER file and select that file from the list.

  5. Click the Import button. PC-DMIS imports the CAD file, and a progress bar appears indicating its progress.


Importing a STEP File

  1. Display Menu Roadmap Select the File | Import | STEP... menu option. An Open dialog box appears.

  2. Select the data type you want to import from the Files of Type list.

  3. Navigate to the directory containing the file to import.

  4. Click Import when ready to import the file. PC-DMIS will display the STEP Import Status dialog box.

STEP Import Status dialog box

  5. Click OK when the STEP file has been translated. If the translation fails, the OK button will not be available. Click Cancel to decline the addition of the imported file.


Importing an STL File

The stereolithography (STL) format, an ASCII or binary file used in manufacturing, provides a list of the triangular facets that describe a computer generated solid model. This format is the standard input for most rapid prototyping machines.

Sample Imported STL File

To import an STL file,

  1. Open the part program in PC-DMIS into which you are going to import the DMIS program file.

  2. Display Menu Roadmap Select the File | Import | STL... menu option. An Open dialog box will appear.

  3. Navigate through the available directories until you find the directory containing the desired STL file and select that file from the list. The STL file can be in ASCII or binary format.

  4. Click the Import button. PC-DMIS imports the data as a list of facets that form a solid model.


Importing a Unigraphics or Parasolid File

PC-DMIS allows you to translate a Unigraphics or Parasolid file and import it into a PC-DMIS part program. This type of importation differs from interfacing directly with the Unigraphics CAD file described in the Direct CAD Interfaces help file.

To import a Unigraphics or Parsolid file:

  1. To import a Unigraphics or Parasolid file:

  2. Open the part program in PC-DMIS into which you are going to import the Unigraphics or Parasolid file. Your hardware key (portlock) must be programmed with the Unigraphics option to import Parasolid files.

  3. Display Menu Roadmap Select File | Import | Unigraphics or File | Import | Parasolid. An Open dialog box will appear.

  4. Navigate through the available directories until you find the directory containing the desired Unigraphics or Parasolid file and select that file from the list.

  5. Click the Import button. PC-DMIS imports the CAD file, and a progress bar appears indicating its progress.


Importing a VDAFS File

  1. Display Menu Roadmap Select the File | Import | VADFS... menu option. An Open dialog box appears.

  2. Select the data type you want to import from the Files of Type list.

  3. Navigate to the directory containing the file to import.

  4. Click Import when ready to import the file. PC-DMIS will display the VDAFS Import Status dialog box.

VDAFS Import Status dialog box

  5. Click OK when the VDAFS file has been translated. If the translation fails, the OK button will not be available. Click Cancel to decline the addition of the imported file.


Importing an XYZIJK File

XYZIJK file types are simple files with feature information in the form of xyz coordinates with or without a vector.

To import an XYZIJK file:

  1. Display Menu Roadmap Select the File | Import | XYZ... menu option. An Open dialog box appears.

  2. Navigate to the directory containing the file to import.

  3. Click Import when ready to import the file. PC-DMIS interprets and imports the selected XYZIJK file.

How many numbers there are on each line determine what feature is created. PC-DMIS reads the rows of the .xyz data file and converts the points to the following feature depending on the amount of numbers per row:

Numbers per Row

Description

CAD Feature Generated

3

1st number=X value
2nd number=Y value
3rd number=Z value

Point with no vector

4

1st number=X value
2nd number=Y value
3rd number=Z value
4th number=diameter

CAD circle with a workplane based vector

5

1st number=X value
2nd number=Y value
3rd number=Z value
4th number=nothing
5th number=nothing

Point with no vector

6

1st number=X value
2nd number=Y value
3rd number=Z value
4th number=I value
5th number=J value
6th number=K value

Point with a vector

7

1st number=X value
2nd number=Y value
3rd number=Z value
4th number=I value
5th number=J value
6th number=K value
7th number=diameter

Circle with vector

8+

1st number=X value
2nd number=Y value
3rd number=Z value
4th number=I value
5th number=J value
6th number=K value
7th number=nothing
8th number=nothing

Point with a vector

Example: If your XYZ file contained a line with 25,280,750,25 PC-DMIS would create a circle with the centered at x=25, y=280, and z=750 with a diameter of 25.

After selecting the file to import, PC-DMIS displays the features constructed from the XYZ file in the XYZ File dialog box.

XYZ File dialog box

Note: Be aware that the order in which the features are created in the .xyz file and the order in which they are generated inside PC-DMIS may not be the same.

After clicking OK, PC-DMIS displays the created CAD features in the Graphics Display window.

More:

Notes on XYZIJK Files


Notes on XYZIJK Files

PC-DMIS will read in any text file that contains XYZ (and possibly IJK) data. The file should contain the nominal (theoretical) inspection points that need to be measured. The file must follow these rules:

  1. Columns 1 - 6 in the first line of the file must contain the characters "XYZIJK". This is the keyword that lets PC-DMIS distinguish this file type from DES and IGES files. It must be in capital letters.

In the first line of the file:
Col. 1 = X
Col. 2 = Y
Col. 3 = Z
Col. 4 = I
Col. 5 = J
Col. 6 = K

  2. If the file contains metric data, columns 11 - 16 of the first line must contain the word METRIC. That is:

Col. 11 = M
Col. 12 = E
Col. 13 = T
Col. 14 = R
Col. 15 = I
Col. 16 = C

The default, if the METRIC keyword is not present, is INCH.
The rest of the first line should be blank

  3. Each line thereafter must contain three to eight floating point numbers separated by a comma.

For example, suppose your XYZIJK file looked like this sample:

Sample XYZIJK file in a text editor

  • Line 1 contains the XYZIJK keyword, and since the keyword METRIC isn't on columns 11 through 16, this defaults to INCH.

  • Line 2 produces a point with a vector.

  • Line 3 produces a point with a vector.

  • Line 4 produces a point with a vector.

  • Line 5 produces a circle with a vector and a diameter.

Once imported, it will produce this result in the Graphics Display window:

Graphical Display window showing the sample XYZIJK file imported into PC-DMIS.


Importing a ChorusNT Program

The migration path from ChorusNT to PC-DMIS is based on PC-DMIS's ability to import a Chorus DMIS part program, converting the original DMIS program into equivalent PC-DMIS commands that make up a PC-DMIS part program file, a file with a .prg filename extension.

PC-DMIS already converts most DMIS commands into PC-DMIS commands, and Wilcox Associates, Inc. is working to fully support the many Chorus extensions, to maximize the automatic conversion and minimize the manual modifications needed after the automatic import.

In PC-DMIS 3.6 and above begin the import process of ChorusNT extensions by:

  1. Display Menu Roadmap Select the File | Import | Chorus DMIS... menu option. An Open dialog box appears.

  2. Select the appropriate DMIS file and click Open.

  3. PC-DMIS displays the Dmis Import Setup dialog box.

You can use this dialog box to set the following needed information during import phase:

  • Specify the probe file name used for each arm.

  • Enable the warning dialog at the end of the import phase.

  • Enable some options relating to specific customers and hardware configurations.

In the following topics taking the following basic steps will help you correctly import and translate your DMIS file into a PC-DMIS part program file:

More

Step 1: Configure PC-DMIS

Step 2: Create and Calibrate the Probe File inside PC-DMIS

Step 3: Create the PC-DMIS Program File and Import the DMIS file

Step 4: End of automatic Import Phase

Step 5: Manual Verification of the PC-DMIS Program

Things to Watch for and Some Helpful Tips and Suggestions


Step 1: Configure PC-DMIS

Verify PC-DMIS's setup, and check if the standard settings in PC-DMIS correspond to ChorusNT settings. For example verify the CMM axis conventions and probe head Orientation and Top Speed (CMM max move speed) value.

Use Settings Editor to set the following options in the DMIS section:

  • DMISMaxMeasurementVelocityMMPS = maximum measure speed

  • DMISFedratPcntOfMaxMachineSpeed = 0


Step 2: Create and Calibrate the Probe File inside PC-DMIS

  • Create a new part program and, when prompted, define a new probe. Name it MYPROBE.PRB and specify in the Probe Utility dialog box the components according to your specific needs.

  • Import the Chorus qualification part program using as your probe, the previously created MYPROBE.PRB file. PC-DMIS imports each SNSDEF statement and adds the corresponding TIP angles. Note that Chorus identifies each tip with the DMIS label that looks something like this. A tip with roll = 0 and pitch = 0 is named S(R000P000T1). PC-DMIS, names this as T1A0B0.

  • If in ChorusNT you used a self-calibrated probe, import into PC-DMIS a simple DMIS part program containing the definition of the ”Chief” probe, having the right label (the same used in the SNSLCT/S(label),90,90 for example) and Pitch and Roll equal to 0.

  • After you import the DMIS file, your MYPROBE.PRB probe file will contain all the needed tips. In PC-DMIS these AB tip angles will show an asterisk symbol ‘*’ meaning they are not yet calibrated.

  • Calibrate the tips. Do this in one of two ways: 1) Execute the part program. 2) Click the Measure button from the Probe Utilities dialog box.


Step 3: Create the PC-DMIS Program File and Import the DMIS file

  • Create a new PC-DMIS part program.

  • Import the measuring ChorusNT part program, specifying the MYRPOBE.PRB probe file created in the previous step.

  • Usually Chorus measuring programs contain SNSLCT/ S(label) or SNSLCT/SA(label) statements. For self-calibrated wrists, you can explicitly specify roll and pitch angles in the SNSLCT label.

After PC-DMIS imports the DMIS file, the final PC-DMIS part program will have at the beginning the LOADPROBE/MYPROBE.PRB command, and for each SNSLCT statement the corresponding TIP command will appear with the correct A and B angles.


Step 4: End of automatic Import Phase

PC-DMIS completes the Import phase, showing you a report in the Warning window.

For example you might see something like this:

L42: ---: DECL/CHAR,O_D_L[11]

L56: ---: DECL/REAL,TX,TY,TZ,MISX,MISY,MISZ,CXT,CYT,CZT,VX,VY,VZ

L57: ---: DECL/REAL,INVCXT,INVCYT,INVCZT

L112: !MAJOR :MMEDIA/ON,’C:\myfile.exe’

L150: !MAJOR :MRRPCS/D(MRR),0,1,0

L213: ERROR: !UNITS

L253: ERROR: !SNSLCT/S(S_103)

These messages are explained here:

  • L## - This represents the line number for that statement in the original DMIS program (## represents the number). For example L42 would indicate that on line 42 in the DMIS program you will find that DMIS statement.

  • ---: - This symbolizes that the statement was ignored, that is it was not converted into a corresponding PC-DMIS command because there is no equivalent PC-DMIS command. For example you will find that PC-DMIS always ignores the DECL statement because PC-DMIS doesn’t need explicit variable declaration.

  • !MAJOR - This means that the specified DMIS statement (Major DMIS Word) is not supported.

  • ERROR – This means the specified command was not correctly imported.


Step 5: Manual Verification of the PC-DMIS Program

Be sure to manually verify that the translation into PC-DMIS functions properly. Look through the part program in Command mode. Errors appear in red text.

Try executing the program in OFFLINE mode then try using the CMM in ONLINE mode at low speed to verify that the program imported without problems.


Things to Watch for and Some Helpful Tips and Suggestions

ChorusNT and PC-DMIS are different measuring systems, and some intrinsic characteristics need to be carefully considered. The following list contains some tips and suggestions:

Automatic Measuring Cycle

The DMIS Standard states that in a MODE/AUTO section the features are measured with the automatic cycle, ignoring any eventually present PTMEAS.

Since ChorusNT supplies automatic cycle for POINT, CIRCLE, SPHERE and SLOT (CPARLN), all these cases are translated into the corresponding AUTO feature. However, due to the intrinsic differences between Chorus and PC-DMIS, you should carefully verify their execution.

For example: In SLOT (round slot) automatic cycle, ChorusNT takes first two points on one of the straight sides. PC-DMIS however, takes the points on the rounded ends of the slot.

STAR TIP Probes

PC-DMIS recognizes the ChorusNT SNSDEF extension that defines a star probe. Be careful that the PC-DMIS setup for the Probe Head orientation corresponds to ChorusNT SNSMNT specification.

CW43, CW43L, and IW42 Wrist Mounting conventions

ChorusNT and PC-DMIS conventions for the roll angle are different. While PC-DMIS can correctly adjust it during the import of a Chorus DMIS program, to be safe, be careful the first time you execute the imported part program.

Theoretical values in FEAT statements

PC-DMIS always uses both Theo and Actual values, which should be correct (not too much off a deviation from actual values). If the deviation is great, you may have problems, especially with features used in alignments. This is because PC-DMIS defines two matrices for each alignment:

  • First, the CADTOPART matrix. Based on the theoretical values, this convert THEO values in features.

  • Second, the MACHINETOPART matrix. Based on actual measured values, this converts actual measured values in features.

Since ChorusNT doesn't have the CADTOPART matrix, it always uses the actual measured values. If you have the wrong nominal values, you only become aware of them if you execute an OUTPUT statement on that feature.

To verify correctness, you should therefore add into the original DMIS part program OUTPUT statements for your features, especially for the alignment features.

FILNAM

FILNAM in ChorusNT specifies the name of the output file when using the DISPLY/STOR command. PC-DMIS recognizes it but this command must appear after the DISPLY in the DMIS part program. Consult your DMIS manual for more information.

VFORM

The ChorusNT vendor format statement is V(label)=VFORM/ALL. It translates into a PC-DMIS FORMAT/TEXT command that has the following information:

  • MEASURED

  • NOMINAL

  • DEVIATION

  • UP_TOL

  • LO_TOL

  • CRIT/OOT

The final PC-DMIS FORMAT command will look like this:

FORMAT/TEXT,OPTIONS,ID,HEADINGS,SYMBOLS,SD;MEAS,NOM,DEV,TOL,OUTTOL, ,

DEFGRF

DEFGRF statement is a Chorus extension that lets you define dialog boxes with buttons and input fields. PC-DMIS imports this command and creates a script using the BASIC language (Cypress Enable). Due to different screen resolutions, it’s possible that the resulting dialog box may need some adjustment. You can modify the Basic Script file using PC-DMIS's Basic Script Editor.

FROM and GOHOME

ChorusNT's conventions move the head center not the tip's ball center. While the PC-DMIS import can make the necessary offsets, you should use a low feed the first time you execute the imported part program inside PC-DMIS.

MRRPCS

In ChorusNT this command defines the reference system to be used in a part program created with ChorusNT's MIRROR Utility. PC-DMIS does not support the import of Chorus mirrored program. You should instead use PC-DMIS's more powerful and complete mirror utility on a .prg file created by importing the "left side" Chorus program.

GAUGE

In ChorusNT this statement defines and measures a sphere gauge, specifying the name: G(label), the diameter, and the stem direction. It also optionally specifies the center position, the incidence angle, and the number of points used to measure it.

GAUGE/SPHERE,G(label), diam, i, j, k, [angle, x, y, z, npoints]

Because of the different parameters, PC-DMIS translates this into two commands. The AUTO/SPHERE and the CALIBRATE ACTIVE:

F(label)= AUTO/SPHERE

The AUTO/SPHERE command uses the same name, diameter, and direction as the GAUGE statement. If the center position was not specified and during execution you manually select the first point on the top of the pole, then init=1 and perm=1, otherwise init=0 and perm=0.

PC-DMIS can also adjust the orientation, angle_vec, and normal_vec values accordingly.

CALIBRATE ACTIVE TIP WITH FEAT_ID=F(label), QUALTOOL_ID=label, MOVED=YES

CALIB

In ChorusNT this statement calibrates the specified probe using the specified sphere gauge G(label)

CALIB/SENS, S(probe),G(label), [angle]

PC-DMIS translates this statement into these three commands:

TIP/ T1A..B..

The tip command will have the same AB angles as the S(probe) ) statement.

F(label) =AUTO/SPHERE

CALIBRATE ACTIVE TIP WITH FEAT_ID=F(label), QUALTOOL_ID=label, MOVED=NO


Importing DMIS Files

PC-DMIS can import generic DMIS files and DMIS programs created using extensions from specific vendor environments.

To import a DMIS program file:

  1. Open the PC-DMIS part program into which you are going to import the DMIS program file.

  2. Display Menu Roadmap Select the File | Import | DMIS...menu option. An Open dialog box appears.

  3. Choose Chorus DMIS Files or DMIS Files from the Files of Type list at the bottom of the dialog box. PC-DMIS lists program files ending with either the ".dmi" or ".dms" file extensions.

Note: Chorus NT programs follow the DMIS 3.0 Standard with extensions and are better managed. In most cases you should choose Chorus DMIS Files over normal DMIS Files. For notes on translating ChorusNT DMIS files into a PC-DMIS part program, see "ChorusNT to PC-DMIS Translation Notes".

  4. Navigate through the available directories until you find the directory containing the desired DMIS program file and select that file from the list.

  5. Click the Import button.

  6. PC-DMIS will make a first-pass translation of the input file. Once it completes this pass, the DMIS Import Setup dialog box appears. This dialog box allows you to select many options useful during the actual import phase.

  7. Select the necessary options from the DMIS Import Setup dialog box. See the topics below for information on using this dialog box.

  8. Click OK. PC-DMIS finishes the importation process.

In version 4.2 and higher, PC-DMIS inserts an RMEAS/LEGACY command into the imported part program. You can modify the DMISRmeasImport registry entry to change the default value for RMEAS commands on future imported DMIS files. See "Setting Up Relative Measure (RMEAS)" for information on this command.

More:

DMIS Import Setup – General tab

DMIS Import Setup – Modules tab

DMIS Import Setup – Error Log tab

DMIS Import Setup – Advanced tab


DMIS Import Setup

DMIS Import Setup – General tab

DMIS Import Setup dialog box – General tab

The General tab allows you to control probe file translation for the imported DMIS program. The controls used on this tab are described in this table here:

Control Name

Description

DMIS File

This box specifies the DMIS file to import. It automatically contains a pathway to the file selected from the Open dialog box described in the DMIS import procedure.

Merge / Replace

These options specify whether or not PC-DMIS replaces existing commands with the imported DMIS commands or merges the new commands with the existing commands.

Select Replace if you want the existing commands in the currently loaded part program to be replaced with new PC-DMIS commands during the import process.

Select Merge if you want PC-DMIS commands created during the import process will be appended at the end of the currently loaded .PRG file.

Arm

This list specifies the arm to use from a multiple arm system.

Probe File

This list specifies an existing probe file.

Use selected probe file(s)

This option uses an existing probe file selected from the Probe File list.

  1. Select the Arm that will use the displayed probe file from the drop down window.

  2. Select the probe file from the list.

  3. Click Apply. PC-DMIS will add any tips (sensors) referenced in the DMIS programs that are not already in the probe file.

Create new default probe file

This option creates a new probe file based on the SNSDEF statements in the DMIS program file. PC-DMIS generates a new probe file giving it the same name as the DMIS program filename and a ".prb" extension. The created probe configuration defaults to a PH9 wrist with a TP2 connection with a TIP2BY20MM tip. However, if no SNSDEF statements are detected in the DMIS program, a probe configuration will not be created.

Ignore SNSLCT/ statements

This option ignores SNSLCT statements in the DMIS program during.

Note: If the default probe configuration does not match the probe configuration of your machine, you should construct a probe file with the correct probe configuration using PC-DMIS prior to importing a DMIS program file. Then select the created probe file from within this tab and click Apply and then OK. This allows the translator to select the most appropriate tip(s) during translation of the SNSDEF statements.


DMIS Import Setup

DMIS Import Setup – Modules tab

The Modules tab is currently unavailable.


DMIS Import Setup

DMIS Import Setup – Error Log tab

DMIS Import Setup dialog box – Error Log tab

The Error Log tab causes PC-DMIS to store any warnings or errors at the end of the import process in a text file of your choice. Simply click the Browse button and select a text file.

If you want PC-DMIS to automatically display this error log at the end of the import process, click the Display log when translation is complete check box. The text file will open in a DMIS Import Results dialog box.


DMIS Import Setup

PN(label1) = PARTID/' part number'

PS(label2) = PARTSN/'2345'

MD(label3) = MFGDEV/'BRAVO1'

DI(label4) = DMEID/'PC-DMIS'

OP(label5) = OPERID/'My Name'

TRACEFIELD/DISPLAY,LIMIT=15 ; PN(LABEL1) : part number

TRACEFIELD/DISPLAY,LIMIT=15 ; PS(LABEL2) : 2345

TRACEFIELD/DISPLAY,LIMIT=15 ; MD(LABEL3) : BRAVO1

TRACEFIELD/DISPLAY,LIMIT=15 ; DI(LABEL4) : PC-DMIS

TRACEFIELD/DISPLAY,LIMIT=15 ; OP(LABEL5) : My Name

COMMENT/REPT,"PN(LABEL1)=' part number'"

COMMENT/REPT,"PS(LABEL2)='2345'"

COMMENT/REPT,"MD(LABEL3)='BRAVO1'"

COMMENT/REPT,"DI(LABEL4)='PC-DMIS'"

COMMENT/REPT,"OP(LABEL5)='My Name'"

DMIS Import Setup – Advanced tab

DMIS Import Setup dialog box – Advanced tab

The Advanced tab allows you to import specific customer requests and configurations. These requests may include non-standard commands or added / modified parameters of standard DMIS commands. PC-DMIS disables unnecessary options (and enables needed ones) when importing Chorus DMIS files. For information on the controls on this tab, see the descriptions in this table here:

Control Name

Description

Customer Support

This area contains specific check boxes for DMIS vendors. If your DMIS files are created using software from these companies, select the appropriate check box to enable extension support specific to those vendors. These include the following:

  • Volvo

  • Volkswagen

Configuration Support

This area contains check boxes that allow you to select different DMIS configurations. These include the following:

FEDRAT/ values are a percentage of maximum machine speed

DMIS commands don't automatically specify whether imported FEDRAT/ commands (commands that control the machine's speed) refer to maximum machine speed or maximum touch speed.

  • If you select this check box, imported FEDRAT/ statements are a percentage of the maximum machine speed.

  • If you deselect this check box, imported FEDRAT/ statements are a percentage of the maximum touch speed.

DEA wrist mounting and rotation as Chorus

If you're using a DEA CMM equipped with an IW42, CW43, or CW43L wrist and you select this check box, PC-DMIS follows Chorus conventions and adjusts the B rotation angle during the import of the SNSLCT statement.

This option is automatically used when performing a ChorusDMIS import.

Option

This area contains a User Defined Tracefield check box. This check box determines whether or not certain imported DMIS commands are transferred into user-defined tracefields.

According to the DMIS standard, you can query the operator for the following information during program execution with these DMIS commands:

Info | DMIS Command
Part Name | PN(label) = 'text'
Part Serial Number | PS(label) = 'text'
Manufacturing Device | MD(label) = 'text'
DME Name | DI(label) = 'text'
Operator Name | OP(label) = 'text'

Suppose the DMIS file you are to import has these DMIS commands:

If you select the User Defined Tracefield check box, PC-DMIS will support the same functionality required by the DMIS standard by importing DMIS commands into TRACEFIELD commands, like this:

Then when you execute our program, PC-DMIS will provide a small dialog box for each TRACEFIELD command, allowing you to type this information.

If you did not select the User Defined Tracefield check box, PC-DMIS will, by default, insert these DMIS commands into normal comment report commands, like this:

Default

This button sets your selection as the default to use when importing DMIS files.


Importing an AVAIL or MMIV Program

The AVAIL and MMIV file types are used by Micro Measure IV measurement package. PC-DMIS allows you to import this file type into PC-DMIS part programs.

To import an AVAIL or MMIV file,

  1. Open the part program in PC-DMIS into which you are going to import the MMIV program file.

  2. Select the File | Import menu option and then select either Display Menu Roadmap Avail... or Display Menu Roadmap MMIV... from the sub menu. An Open dialog box will appear.

  3. PC-DMIS lists program files beginning with AVAIL and MMIV’s ”llf” prefix.

  4. Navigate through the available directories until you find the directory containing the needed AVAIL or MMIV file and select that file from the list.

  5. Click the Import button. PC-DMIS displays the Choose Translation Method dialog box, asking the method to use to import the data into the part program.

Choose Translation Method dialog box

  6. Select one of the translation options and click OK. PC-DMIS processes your request.

  7. For each TOOLCHANGE command encountered in the MMIV file, PC-DMIS will prompt you to select a PC-DMIS probe file.

  8. For each TIPCHANGE command encountered in the MMIV file, PC-DMIS will prompt you to select a PC-DMIS probe tip from the Select Tip dialog box’s Tip to Use list.

Select Tip dialog box

  9. Click OK (or OK All) and, as directed by on-screen instructions, repeat the previous step. When the Select Tip dialog box closes, the Select Workplane dialog box will appear.

Select WorkPlane dialog box

  10. Select the workplane that matches your current setup and click OK. PC-DMIS imports the data into the part program.

Important: MMIV part programs that contain a BRANCH/TEST keyword or a BRANCH/LABEL command inside of a feature block will have the respective PC-DMIS commands (IF and GOTO) moved before the feature block once imported into PC-DMIS. This will be corrected in future versions of PC-DMIS.

A Note on Importing Auto Features

Be aware that PC-DMIS doesn't support the DONE/ or MEASURE/ commands in imported MMIV or AVAIL auto features. While translation still takes place, any MEASURE/; X,Y,Z,I,J,K commands will be turned into operator comments and DONE/ commands are ignored.
For example, suppose you are importing this auto feature in an AVAIL or MMIV file:

CIR2= AUTO/CIR; YZPL,OC,4,12.0,6.0,-12.0,103.0,295,330
MOVE/BY; 12,5,0
MOVE/BY; 0,0,20
MEASURE/; 12.0,56.0,-22.0,0.0,-1.0,0.0039
MEASURE/; 12.0,57.85,-16.0,0.0,-1.0,0.0
MEASURE/; 12.0,58.4,-6.0,0.0,-1.0,-0.0039
DONE/;

In PC-DMIS this would translate to an AUTO CIRCLE command followed by two MOVES and three comments saying that PC-DMIS ignores the MEASURE command.


Importing a Tutor Program

You can import part programs created by the Tutor application.

To import a Tutor file,

  1. Open the part program in PC-DMIS into which you are going to import the Tutor program file.

  2. Display Menu Roadmap Select the File | Import | Tutor... menu option. An Open dialog box will appear.

  3. Navigate through the available directories until you find the directory containing the desired tutor file and select that file from the list.

  4. Click the Import button. The Tutor translator begins the translation process, and the TutorPCDMIS Translator Options dialog box appears. This dialog box allows you to determine how items in the tutor file should be interpreted or displayed inside PC-DMIS.

TutorPCDmis Translator Options dialog box

  6. Fill out the dialog box as needed. The following areas are available:

PC-DMIS Part Program Settings area

These options come from PC-DMIS and cannot be modified.

Units – This shows the units of measurement (either Inch or Metric) of the PC-DMIS part program you are using to import the Tutor file. Unlike Tutor for Windows, PC-DMIS doesn’t allow you to change measurement units at execution time.

Angle Mode – This shows how angles are currently displayed (either Deg or DMS) in the PC-DMIS part program.

Tutor for Window Settings area

These options allow you to specify Tutor for Windows settings needed for a proper Tutor to PC-DMIS translation.

Read Wtutor.Ini – Click this button if you need to specify where the Tutor configuration (.ini) is located. By default, when translation starts, PC-DMIS searches for this configuration file in the C:\Winnt directory. This file contains Tutor for Windows configurations needed by the translator.

True Position Error – Select Radius if the importing part program requires the True Position error evaluated as radius, Select Diameter otherwise.

Form Error – Select Double if the importing part program requires the Double Form error or select Single otherwise.

Linearity Error – Select Radius if the importing part program requires the Linearity error evaluated as radius, select Diameter otherwise.

Tutor PC-DMIS Probes mapping area

This area allows you to map a Tutor probe to a PC-DMIS probe.

Tip Diameter – Type the default tip diameter for the probe that PC-DMIS will use in the part program.

Probe File – Use the … button to choose a PC-DMIS probe file (.PRB) to use.

ProbeMap File – Use the … button to choose an existing Tutor to PC-DMIS probe map file (.TP2). If you don't have a probe map file, you can create one by clicking the New button. The Edit button allows you to change the currently selected probe map file listed in this box. This map file allows you to tell the translator what PC-DMIS tip angles it should use when translating probe commands from the Tutor file into PC-DMIS.

Skip Comments – Select this check box if you don't want to import programmer comments found in the Tutor file.

  7. Click the OK button to continue. PC-DMIS displays the import process inside the Translation in progress window, displaying any warning messages inside the Translation messages list.

  8. Follow any on-screen instructions.

  9. When translation ends, the Translation in progress window allows you to inspect the messages in the Translation message list. You can then decide to continue (click Continue) or abort (click Abort) the import process. Whatever you choose, all translation messages are stored in a log file with the same name as the Tutor part program with a .log extension, stored in the same directory as the Tutor part program.

Note: The TutorPCDmis Translator Options dialog box appears every time PC-DMIS encounters a load probe command from the Tutor file. If you have correctly set up your probe map file, you can safely skip the translation of the current load probe command by clicking the Ignore button.

More:

Creating and Editing Tutor to PC-DMIS Probe Map Files


Creating and Editing Tutor to PC-DMIS Probe Map Files

To properly translate programs from Tutor into PC-DMIS, you will need a probe map file that relates the Tutor file's probes with PC-DMIS probes. A Tutor's probe command is identified by two numbers that refer to a specific head and tip respectively.

To create a new Tutor to PC-DMIS Probe Map File:

  1. Begin the import procedure as described in "Importing a Tutor File".

  2. When the TutorPCDMIS Translator Options dialog box appears, click the New button. The T2PFile dialog box appears.

T2PFile dialog box

  3. If you need to specify more information, click Add to add new rows.

  4. In the Head column for each row, type the value of 1 through 100 to identify the probe head in Tutor.

  5. In the Tip column for each row, type a value of one through five to identify the probe tip in Tutor.

  6. In the Name PRB column for each row, type the PC-DMIS probe tip angle that you want to use for the Head and Tip of that row. For example, the probe map information in the following table tells the Tutor translator to use PC-DMIS's T5A30B30 probe tip angle when it encounters a probe command of 2,2 in the Tutor file.

Head | Tip | Name PRB
2 | 2 | T5A30B30

  7. If you make a mistake, click the Clear All button. This clears the information from the dialog box allowing you to start over.

  8. Click the … button to save this Tutor to PC-DMIS probe map file to your computer.

  9. Click OK to return to the TutorPCDMIS Translator Options dialog box.

To edit an existing Tutor to PC-DMIS Probe Map File:

  1. Begin the import procedure as described in "Importing a Tutor File".

  2. When the TutorPCDMIS Translator Options dialog box appears, click the … button for the ProbeMap File box and select an existing T2P file.

  3. Click the Edit button. The T2PFile dialog box appears.

  4. Edit the values as needed.

  5. Click OK to return to the TutorPCDMIS Translator Options dialog box.


Importing a Direct CAD File

Instead of translating CAD data into the internal CAD format of PC-DMIS, the Direct CAD file types are accessed directly. That is, the CAD data of these file types remains in its native format after being imported. Routines native to the CAD type are used for all calculations done on the CAD data. Accessing the CAD data directly eliminates problems that can occur because of translation inaccuracies or limitations.

The "Direct CAD Interfaces " documentation discusses importing Direct CAD Files in detail.

More:

Tessellating a Part without a CAD License


Tessellating a Part without a CAD License

With version 3.5 and higher, you can now tessellate the image of a Direct CAD Interface part even if you don't have its CAD license currently available. The method for accessing this functionality varies by the Direct CAD Interface. In general, however, you simply need to access your Direct CAD Interface part program. PC-DMIS will then display the part, but some functionality will not be available. For example, you cannot create a measured vector point on the part.


Importing a UMESS File

Importing a Zeiss UMESS File

PC-DMIS can import a part program from UMESS (Zeiss), converting it to work with a PC-DMIS part program.

To import a UMESS file,

  1. Open the part program in PC-DMIS into which you are going to import the UMESS program file.

  2. Display Menu Roadmap Select the File | Import | Zeiss Umes... menu option. An Open dialog box will appear.

  3. Navigate through the available directories until you find the directory containing the desired UMESS file, and select that file from the list.

  4. Click Import. Follow any on-screen prompts to import the UMESS file into PC-DMIS.


Importing a MeasureMax Project

PC-DMIS can import a MeasureMax project, converting to work in a PC-DMIS part program.

To import a MeasureMax project,

  1. Open the part program in PC-DMIS into which you are going to import the MeasureMax project.

  2. Display Menu Roadmap Select the File | Import | MeasureMax Project... menu option. An Open dialog box will appear.

  3. Navigate through the available directories until you find the directory containing the desired MeasureMax file. Typically these are located in your C:\My Part Programs\ directory.

  4. Select the .vbp file from the directory.

  5. Click Import. PC-DMIS automatically converts the project and inserts the PC-DMIS commands at the end of your part program.

  6. Follow any on-screen prompts to import the MeasureMax project into PC-DMIS.


Exporting CAD Data or Program Data

Display Menu Roadmap

Similar to importing data, PC-DMIS also allows you to export part program data into one of these supported file formats:

  • AIMS Files (*.TDF)

  • DATAVIEW Files (*.AS3)

  • BASIC Files (*.BAS)

  • DES Files (*.DES)

  • DXF /DWG (*DXF or *DXG)

  • DMIS Files (*.DMI or *.DMS)

  • GENERIC Files (*.TXT)

  • EXCEL Files (*.XLS)

  • I-DEAS Files

  • IGES Files (*.IGS)

  • STEP AP203 (*.STP or *.STEP)

  • STEP AP214 (*.STP or *.STEP)

  • STEREOLITHOGRAPHY Files (*.STL)

  • VDAFS (*.VDA)

  • XYZ (*.XYZ)

  • GDS (*.GDS)

  • Inspection Planner

Note: Exporting your program as CAD data does not export previously imported CAD part models; instead, it generates a CAD file from existing feature commands found in your part program.

To export data out from the current part program:

  1. Select the File | Export menu option and then select the data to export from the sub menu (or right-click on a part program file name in Windows Explorer, then select Export). In most cases this action will display an Open dialog box.

    Open dialog box

  2. Select the desired data type from the Files of Type list. PC-DMIS will display the available files for the indicated data type.

  3. Type the name of the file to be created in the File Name box, or select an existing file from the list. If an existing file is selected, PC-DMIS will replace the current data in that file with the information generated by the Export operation.

  4. Click Export. The Open dialog box closes. Depending on your data type, PC-DMIS may display another dialog box that asks you for additional input. See the sub topics below for more information.

  5. Click Export. PC-DMIS generates the exported data file to the selected directory and gives it the extension defined in the Files of Type box.

More:

Exporting to AIMS

Exporting to a BASIC File

Exporting a DES File

Exporting a DXF or DWG File

Exporting to a DMIS File

Exporting to a Generic Text File

Exporting to Excel

Exporting to an I-DEAS DCI Model File

Exporting an IGES File

Exporting a STEP File

Exporting to an STL File

Exporting a VDAFS File

Exporting to an XYZ File

Exporting to a Gds File


Exporting to AIMS

Display Menu Roadmap

PC-DMIS lets you export your part program file to a .TDF file, the file type used by the AIMS (Advanced Integrated Mathematical Solutions) software. AIMS was developed by Boeing Company and Metronor Group, and it enables the sharing of CAD geometry, inspection plans, and measurement results back and forth between different hardwares and softwares.

Selecting the AIMS... menu item displays the AIMS Export dialog box:

AIMS Export dialog box

Important: The AIMS Export will only function is you are connected to an AIMS model through the AIMS Direct CAD Interface (DCI). See the "Direct CAD Interfaces" documentation.

Once you fill out the dialog box and click OK, PC-DMIS will export the part program as a .TDF file.


Exporting to a BASIC File

Display Menu Roadmap

PC-DMIS provides you with tools that help you to automate PC-DMIS. Exporting your part program as a BASIC script (*.BAS file) allows you to then automate that part program using any external application that supports the BASIC language. For more information on automating PC-DMIS, see these documentation topics:

  • PC-DMIS BASIC Language Reference help file.

  • "Inserting BASIC Scripts" in the "Adding External Elements" section.


Exporting to DataView

Exporting to a DataView (AS3) File

Display Menu Roadmap

You can easily export your CAD model to DataView's .AS3 file format and then load this information into DataView to view your CAD model there.

To export to DataView,

  1. Select File | Export | AS3... and then choose the directory where you want to export the file.

  2. Type a file name.

  3. Click Export.

  4. PC-DMIS creates the .AS3 file at the specified location.


Exporting a DES File

Display Menu Roadmap

When you click the Export button during the DES export process, PC-DMIS displays the DES File dialog box.

DES File dialog box

The DES File dialog box displays information on your selected DES export in the Header area; it also allows you to select additional options for your DES export.

  1. Select an alignment from the Alignment list.

  2. Select a coordinate system from the Coordinate System area.

  3. If desired, select the Marked Features Only check box to only export the marked features.

  4. If desired, select the Show Decimal Point check box to show the decimal point in the exported data.

  5. If desired, select the Output Nominal Values check box to cause PC-DMIS to create the export file from the nominal values in your part program. If you don't select this check box, PC-DMIS exports the measured feature results.

  6. Click on the Process button in the DES File dialog box to output the DES data from the selected part program. PC-DMIS will indicate when the file is 100% processed.

  7. Click the OK button to finish exporting the DES file.


Exporting a DXF or DWG File

Display Menu Roadmap

When you click the Export button during the DXF or DWG export process, PC-DMIS displays a DXF/DWG Export dialog box.

DXF/DWG Export dialog box

The DXF/DWG Export dialog box allows you to select additional options for the export of these file types.

  1. Select an alignment from the Alignment list.

  2. If desired, select the Marked Features Only check box to only export the marked features.

  3. If desired, select the Scans as Points check box to cause scan data to get converted to its scanned points.

  4. If desired, select the Output Nominal Values check box to cause PC-DMIS to create the export file from the nominal values in your part program. If you don't select this check box, PC-DMIS exports the measured feature results.

  5. Click the Export button to finish exporting the DXF or DWG file.


Exporting to a DMIS File

Exporting to DMIS

PC-DMIS lets you export your PC-DMIS part program file as a DMIS file. DMIS files adhere to the DMIS standards for DMIS commands and can executed on other computers by applications that use the DMIS language.

After choosing a filename and clicking Export from the Open File dialog box, PC-DMIS displays the DMIS Export Setup dialog box. This dialog box contains two tabs, the General tab and the Error Log tab.

After choosing your options on these tabs, click OK to complete the export process.

General tab

DMIS Export Setup dialog box - General tab

DMIS Export Setup dialog box - General tab

The General tab lets you choose one of three methods to convert your PC-DMIS part program into a DMIS file.

  • PC-DMIS Edit Window (DMIS Mode) - This method exports a DMIS file exactly as the part program looks in the Edit window when you are in DMIS mode.

  • Flexible DMIS - This method allows you to customize the exported file to match your specific DMIS version, measurement methods, or supported DMIS statements. When you select this option, a file selection box becomes enabled that allows you to browse to and select a specific BASIC script file (*.bas extension). You can create your own script file, or modify an existing script file to control exactly what PC-DMIS should export.

    PC-DMIS provides you with three ready-to-use .bas files that reside in your PC-DMIS installation directory. These files customize your export so that it uses a defined subset of supported DMIS statements for a specific DMIS version. The files are PCD2DMIS030.BAS, PCD2DMIS040.BAS, and PCD2DMIS050.BAS (for DMIS 3.0, 4.0, and 5.0 respectively). The commands which are not customized in the .bas file are exported as they are in the PC-DMIS Edit Window (DMIS Mode)

Note: If a function in the BASIC script returns an error when using this option, then the exported file gets written as if you had selected the PC-DMIS Edit Window (DMIS Mode) option above.

  • Legacy Postout - This method exports the file as it used to in older versions of PC-DMIS. Before version 4.0, needed to set the DMISUsePostoutCode entry to TRUE in the PC-DMIS Settings Editor to accomplish this. Now, you can simply select this option.

Error Log tab

DMIS Export Setup dialog box - Error Log tab

DMIS Export Setup dialog box - Error Log tab

The Error Log tab lets you view or save errors encountered during an export phase so that you can correct them in your script file or take some other appropriate action. You will receive errors or warnings in these instances:

  • When a function in the BASIC script returns a logical error, meaning you have a problem somewhere in your script that's causing an automation logic error. In this case, the BASIC Script function returns a text string with this header: $$ LOGERR |.

  • When a parameter in a PC-DMIS command cannot be converted into DMIS code. In this case, the BASIC Script function returns a text string with this header:
    $$ DMISERR |

Click the ... button to locate and select an existing text file to which PC-DMIS should send the errors.

Click the Display log when export is complete check box to display the text file in a text editor once PC-DMIS finishes the export process.


Exporting to a Generic Text File

CIR1, 93.486348, 19.488589, -1.269350, 0.000000, 0.000000, 1.000000, 14.997670

CIR1 HITS, 85.984616, 19.473057, -1.279984, 0.999998, 0.002070, 0.000000

CIR1 HITS, 93.479917, 11.992677, -1.287909, 0.000858, 1.000000, 0.000000

CIR1 HITS, 100.988033, 19.458504, -1.285809, -0.999992, 0.004010, 0.000000

CIR1 HITS, 93.486169, 26.984522, -1.265512, 0.000024, -1.000000, 0.000000

The format for the first line of the feature is:
[Feature Label], [X], [Y], [Z], [I], [J], [K], [D]

The format for the hits lines, lines 2 - 5, is:
[Hits Label], [X], [Y], [Z], [I], [J], [K]

LOC1 AX:X, 93.485000, 0.010000, 0.010000, 93.486348, 0.001348, 0.000000

LOC1 AX:Y, 19.500000, 0.010000, 0.010000, 19.488589, -0.011411, 0.001411

LOC1 AX:D, 15.000000, 0.010000, 0.010000, 14.997670, -0.002330, 0.000000

The format for the lines is:
[Dim Label]AX:[Axis Indicator], [Nominal], [+ Tol], [- Tol], [Measured], [Deviation], [Out of Tol]

Exporting to a Generic Text File

Display Menu Roadmap

PC-DMIS can export your part program's feature and dimension data to a simple text file as comma separated values. You can then import this data into other software applications, such as Microsoft Excel, as needed.

After choosing where to export the file and clicking the Export button, PC-DMIS displays a dialog box asking for you to choose the alignment to use when exporting the data and the type of data to export:

Generic Postout Options dialog box

Item | Description
Alignment list | This list lets you choose what alignment to apply to the data when exported.
Output Type area | This area lets you determine the type of data to export. You can choose to export dimensions and features.

An Example Exported Circle Feature:

An Example Exported Location Dimension:


Exporting to Excel

PC-DMIS allows you to export your part program's measurement data into a Microsoft Excel (.xls) file. To do this select File | Export | Excel. PC-DMIS then displays the PCD2Excel Wizard. You can also access this wizard from the Wizards toolbar. See "Wizards Toolbar" in "Using Toolbars".


Exporting to an I-DEAS DCI Model File

Display Menu Roadmap

To export to an I-DEAS part, follow these steps:

  1. Select the File | Export menu option from the main menu and select the I-DEAS data type from the sub menu. The I-DEAS Part Selection dialog box appears.

I-DEAS Part Selection dialog box

  2. Click the Connect To Server button. The I-DEAS Server Connection dialog box will appear. Use this dialog to connect to an I-DEAS server. For information on using the I-DEAS Server Connection dialog box, see the "Using the I-DEAS Server Connection dialog box" topic in the "Directly Interfacing with a CAD File" section. Once connected to an I-DEAS server, the I-DEAS Part Selection dialog box will become available. All the projects in the active I-DEAS data installation will be listed.

  3. Click Connect to connect to the server. The I-DEAS Part Selection dialog box appears.

  4. Select a project and the model file to which you want to export. To do this, select an existing part from the Parts in selected model file list. Or you can create a new part by typing values into the Bin, Name, and Part Number boxes.

Note: Surface geometry (cylinder, cone, or sphere features) cannot be created in an existing part. If you export to an existing part, these feature types will be ignored. To export surface feature types, specify a new part to be created.

Note: The following characters are invalid and cannot be used in the Bin, Part Name, or Part Number boxes:
:
;
,
"
*
?

  5. Click the Export To Part button after you have specified a part. If the part is new, a message box will appear asking if you want to create a part.

  6. Click Yes to create the I-DEAS part. The I-DEAS Export dialog box appears.

I-DEAS Export dialog box

  7. Select an alignment from the Alignment box.

  8. Select any additional export options. The options on this dialog box are the same as discussed in the "Exporting a STEP File".

  9. Click the Export button to finish exporting to the I-DEAS part. Once the exporting process is complete, PC-DMIS will automatically instruct the I-DEAS server to save the part’s model file.


Exporting an IGES File

Display Menu Roadmap

When you click the Export button during the IGES export process, PC-DMIS displays the IGES File dialog box.

IGES File dialog box

The IGES File dialog box displays information on your selected IGES export in the Start Section and Global Parameters areas; it also allows you to select additional options for your IGES export.

  1. Select an alignment from the Alignment list.

  2. If desired, click the Setup button to alter the display of the exported image (see "Altering the Imported / Exported Image Display".

  3. If desired, select the Marked Features Only check box to only export the marked features.

  4. If desired, select the Output Nominal Values check box to cause PC-DMIS to create the export file from the nominal values in your part program. If you don't select this check box, PC-DMIS exports the measured feature results.

  5. Click on the Process button in the IGES File dialog box to output the IGES data from the selected part program. PC-DMIS will indicate when the file is 100% processed.

  6. Click the OK button to finish exporting the IGES file.


Exporting a STEP File

Display Menu Roadmap Display Menu Roadmap

When you click the Export button during the STEP export process, PC-DMIS displays a STEP Export dialog box.

STEP Export dialog box

The STEP Export dialog box allows you to select additional options for your STEP export.

  1. Select an alignment from the list in the Alignment area.

  2. Select a coordinate system from the Alignment area.

  3. If desired, select the Marked Features Only check box to only export the marked features.

  4. If desired, select the Scans as Points check box to cause scan data to get converted to its scanned points.

  5. If desired, select the Output Nominal Values check box to cause PC-DMIS to create the export file from the nominal values in your part program. If you don't select this check box, PC-DMIS exports the measured feature results.

  6. Click the Export button to finish exporting the STEP file.


Exporting to an STL File

Display Menu Roadmap

You can export features or scans from your part program as a stereolithography ( STL) file. After choosing where to export the file and clicking the Export button, PC-DMIS displays the STL Export dialog box asking for you to determine what alignment you want to export and whether or not you want to export marked features and/or scans.

STL Export dialog box

Icon | Description
Alignment area | This area lets you choose what alignment to apply to the data when exported. If you select a custom alignment, the CAD Coordinates and Part Coordinates options become enabled, allowing you to determine in what coordinates your alignment is used.
Marked Features Only check box | Selecting this check box exports the marked features.
Scans as Points check box | Selecting this check box exports all scans as point features.


Exporting a VDAFS File

Display Menu Roadmap

When you click the Export button during the VDAFS export process, PC-DMIS displays the VDAFS Export dialog box.

VDAFS Export dialog box

The VDAFS Export dialog box allows you to select options for your VDAFS export. This dialog box has the exact same options as the STEP Export dialog box. See "Exporting a STEP File" for information.


Exporting to an XYZ File

Display Menu Roadmap

When you click the Export button during the XYZ export process, PC-DMIS displays the XYZ Export dialog box.

XYZ Export dailog box

XYZ Export dialog box

The XYZ Export dialog box allows you to select options for your XYZ export. This exports your part program as an .xyz file, a file type readable inside standard text editors. For information on the .xyz file type, see the "Importing an XYZIJK File" for a discussion of this file's characteristics.

This dialog box has the exact same options as the STEP Export dialog box. See "Exporting a STEP File" for information.


Exporting to a Gds File

Display Menu Roadmap

PC-DMIS can export an alignment from the part program into a .gds file format. This .gds format is the Romer France file format for alignments. This small alignment file is then used by Romer France's portable arms. It is also used to interface with other software packages like 3DReshaper.

By default, when you export to a .gds File, PC-DMIS will export the most recent alignment of the active part program. If desired, the Select Alignment to Output to a Gds File check box on the SetUp Options dialog box, allows you to select a specific alignment from a Select Alignment dialog box. See the "Select Alignment to Output to Gds" topic in "Setting Your Preferences".

The .gds filename defaults to index.gds and will be saved automatically to the armdata folder of the G-Scan software. If you do not have ROMSOFT software installed, a common Export dialog box appears, allowing you to select where to export the .gds file.


Altering the Imported / Exported Image Display

If, while importing or exporting, you click on the Setup button from the IGES File dialog box, either the IGES SETUP dialog box (importing) or the IGES Write Setup dialog box (exporting) appear. These dialog boxes allow you to alter how the IGES/DMIS image will be displayed.

More:

Altering Display of Imported CAD

Altering the Display of Exported CAD


Altering Display of Imported CAD

IGES Setup dialog box

To access the IGES Setup dialog box and alter how the IGES/DMIS image is displayed:

  1. Begin importing your CAD file (see "Importing an IGES File").

  2. When the IGES File dialog box appears, click the Setup button.

  3. Select the desired check box options from the IGES SETUP dialog box.

  4. Click the OK button.

PC-DMIS will draw the selected CAD image with the requested features.

More:

Understanding the Available Options


Understanding the Available Options

The Surface of Revolution check box is available if trimmed surfaces are being used that have a surface of revolution as a base surface and it is not being read in correctly. If this is the case, simply select the appropriate options in the Trimmed Surface area of the dialog box.

If the Default check box is selected, PC-DMIS will use the current setting to process all future entities.

The 'Process Entities with Use' Area

The Process Entities with Use area contains the following six check boxes that allow you to select the possible CAD image setup options. They are described in this table:

Check Box | Description
Geometry | Determines whether or not to import the geometric entities from the file. Geometric entities are the curves and surfaces that define the model.
Annotation | Determines whether or not to import the annotation entities from the file. These entities are used to add annotation or description to a file. These include angular dimension, diameter dimension, flag note, general label, linear dimension, ordinate dimension, point dimension, radius dimension, general symbol, and sectioned area entities.
Definition | Determines whether or not to import the definition entities from the file. These entities are used in definition structures of the file. These include general note, leader, associatively definition, line font definition, macro definition, subfigure definition, text font definition, text display template, and network subfigure definition entities.
Other | Determines whether or not to import the other entities from the file. These entities are used for other purposes such as defining features in the file. Currently, these include the color definition entity and the dimensioned geometry associatively.
Logical/Positional | Determines whether or not to import the logical/positional entities from the file. These entities are used as logical or positional reference by other entities. Currently, PC-DMIS does not process any entities that are of this type.
2-D Parametric | Determines whether or not to import the 2-D parametric entities from the file. These entities are positioned in two-dimensional XY parameter space, and are considered a subset of three-dimensional XYZ space, by ignoring the Z coordinate. This entity type is intended for use in defining trimming curves on surfaces. Currently, PC-DMIS ignores this check box. For more information, see "The 'Trimmed Surfaces' Area".

If you select all six check boxes, then all IGES entities in the IGES file will be imported.

The 'Process Entities If' Area

The Process Entities If area contains check boxes that allow you to process certain entities when they meet certain conditions. The following table describes the available conditions that are met and the description of each check box:

Condition | Description
Process entities if Physically Dependent | Determines whether or not the base surface of a Curve on Parametric Surface will be shown.
Process entities if Logically Dependent | Determines whether or not logically dependent entities will be imported from the IGES file.
Process entities if Blanked | Determines whether or not blanked entities will be imported.

The 'Trimmed Surfaces' Area

The Trimmed Surfaces area contains check boxes that you may use to properly process Trimmed Surfaces.

Check Box | Description
Show Trim | Shows the trimmed surface.
Show Base Surface | Shows the untrimmed surface (base surface).
Use ‘B’ Curves | If ‘B’ curves are present in the IGES file, select this check box to use them as the trim definition. You may also need to select this check box if the model has poorly defined ‘C’ trimming curves. By selecting this check box, the ‘C’ trimming curves will be regenerated from the ‘B’ trimming curves.
Use ‘C’ Curves | If ‘C’ curves are present in the IGES file, select this check box to use them as the trim definition. You may need to use this option if the model has poorly defined ‘B’ trimming curves. By selecting this check box, the ‘B’ trimming curves will be regenerated from the ‘C’ trimming curves.

If you select the Show Trim check box, the other check boxes under it become available for selection. You can use either 'B' or 'C' curves as your trim definition, depending on the attributes of the trimmed surface.

Note: Be aware that if you use 'C' curves as your trim definition, PC-DMIS will have to calculate the 'B' curves that can be quite time consuming.

Also, if the IGES file contains trimmed surfaces that have a surface of revolution as a base surface these check boxes become available for selection:

Check Box | Description
Reverse Params | Determines whether or not to fix ‘B’ trimming curves that reverse the U and V parameters.
V Param 0 to 1 | Determines whether or not to fix the ‘V’ parameter that gets defined in the range 0 to 1, instead of in radians.
U Param 0 to 1 | Determines whether or not to fix the 'U' parameter that gets defined with a range of 0 to 1 instead of in radians when the generatrix of the surface of revolution is an arc.
Show Base Surface | Determines whether or not to show the untrimmed surface.

Defining Trimming Curves

You can define trimming curves in two ways:

  • Using 3-dimensional coordinates in model space (the coordinates the surface is defined in). These are known as ‘C’ trimming curves because each coordinate requires three values to position it in model space (1, 2, 3; A, B, C). By definition, the curve must be defined so that it geometrically coincides with the surface. In other words, the curve must lie on the surface. However, a poorly defined ‘C’ trimming curve may break this rule.

  • Defining the position of the curve using relative positions on the surface. These are known as ‘B’ trimming curves because each coordinate requires two values to position it in parametric space. For example, a rectangular surface could have the parametric position (0,0) at one corner and (1,1) at the opposite corner. Every position on the surface could then be represented using two-value pairs between these two extremes. The parametric position (0.5,0.5) would be in the center of the surface. The parametrically defined curve is represented using these 2-dimensional parameter-space points. By definition, the curve must be defined so that it does not go outside the parameter-space of the surface it lies on. However, a poorly defined surface may break this rule.

Example of Showing Trim

IGES File with Show Trim check box selected

Example of not Showing Trim

Using the IGES file in the "Example of Showing Trim" topic above, if you deselect the Show Trim check box, you will end up with an empty model. This is because this particular IGES file contains only trimmed surfaces. However, if you deselect the Show Trim check box and select the Show Base Surface check box, this is the result:

IGES File with Show Trim check box not selected

Notice that all the holes in the surfaces are gone and that the outer boundaries of the surfaces are not trimmed.


Altering the Display of Exported CAD

The IGES Write Setup dialog box allows you to alter how the IGES/DMIS image will be displayed.

IGES Write Setup Dialog box

To access this dialog box and alter how the IGES/DMIS image is displayed:

  1. Begin exporting your CAD file (see "Exporting an IGES File").

  2. When the IGES File dialog box appears, click the Setup button.

  3. Select the desired check box options from the IGES Write Setup dialog box.

  4. Click the OK button.

PC-DMIS will draw the selected CAD image with the requested features.

More:

Understanding the Available Output Options


Understanding the Available Output Options

The various output options control how the IGES entities are exported.

Surfaces as Surfaces of Revolution – This check box causes cones, cylinders, and spheres to be exported as surface of revolution entities.

Surfaces as Arcs – This check box causes cones, cylinders, and spheres to be exported as arcs. A cone will be exported as a circle at its base and a point at its vertex. A cylinder will be exported as two circles: one circle at the top and one circle at the bottom of the cylinder. A sphere will be exported as a circle about its equator.

Surfaces as Surfaces of Revolution and Surfaces as Arcs – You can select both these check boxes. In this case, PC-DMIS exports, cones, cylinders, and spheres as surfaces of revolution and as arcs. If both check boxes are clear, cones, cylinders, and spheres will not be exported.

Scans as Copious Data Form 2 – This check boxes causes scans to be exported as the copious data IGES entity type; the format of the entity is points without vectors.

Scans as Copious Data Form 3 – This check boxes causes scans to be exported as the copious data IGES entity type; the format of the entity is points with vectors. The various forms control the format of the copious data entity.

Scans as Copious Data Form 12 – This check boxes causes scans to be exported as the copious data IGES entity type; the format of the entity is piecewise-linear curve without vectors. The various forms control the format of the copious data entity.

Scans as Copious Data Form 13 – This check boxes causes scans to be exported as the copious data IGES entity type; the format of the entity is piecewise-linear curve with vectors. The various forms control the format of the copious data entity.

Scans as Points – This check box causes scans to be exported as multiple point entities.

Scans as Copious Data and Scans as Points – You can select both these check boxes. PC-DMIS then exports scans as copious data and as points. If you deselect these check boxes, PC-DMIS does not export scans.


Setting Import Options

You can easily set import options to determine default colors for certain imported entity types, as well as how PC-DMIS displays imported curves.

Display Menu Roadmap To perform these manipulations, select the Edit | Preferences | Import Options menu item. This will display the Import Options dialog box.

Import Options dialog box

Import Options dialog box

This dialog box contains the Default Colors area as well as some check boxes.

Default Colors

This area lets you change the default colors for imported Points, Curves, Surfaces, and Datum entity types. If the entity types don't already have a defined color, they will use this default color. To change a color, simply click on a button in this area. A standard Color dialog box appears, allowing you to select a new color.

Color dialog box

Color dialog box

When you import the next feature, PC-DMIS will use the newly defined colors.

Check Boxes

Explode polylines to points - Usually, when you import curves entities, they appear as individual curves. In reality, however, each curve is really a polyline, a bunch of lines connected by a series of points. Selecting this check box makes imported polyline curve entities appear as a series of points, one point for each polyline vertex. Clearing this check box makes imported curves appear as normal.

Keep Polylines - Selecting this check box will allow the image to continue to display the original polyline along with the points when you select the Explode polyline to points check box. Clearing this check box will only show the series of points.

PC-DMIS will use these settings for all future import operations.


Executing Part Programs

Display Menu Roadmap

With PC-DMIS you can easily execute an entire part program or perform partial executions. This topic describes how to perform both full and partial executions. It also explains how to use the Execution Mode Options dialog box to execute your part programs and how to resize the dialog box.

When you choose to execute some or all of your part program by selecting File | Execute or a menu item from the File | Partial Execution submenu, and you don't have breakpoints in your part program, PC-DMIS displays a different layout of the screen display called the execution layout. This layout initially hides the Edit window and expands the Graphics Display window, to show more of the part. It also displays the Probe Readout window. You can change what windows appear during execution by pausing the execution and showing or hiding a window. Subsequent executions will use your updated execution layout.

When execution finishes, the screen layout returns to the learn time layout. Any window you show or hide during learn time becomes part of the learn time layout.

Note: If your program uses breakpoints and the Edit window is in Command mode when you choose to execute, PC-DMIS continues to display the Edit window during execution but highlights the current command to execute in red. If the Edit window is in Summary mode, with a breakpoint, PC-DMIS shows a green highlight in the Edit window for already executed commands, yellow for a feature about to be measured, blue for features currently undergoing execution, and orange for non-executed commands.

More:

Execute

Execute Feature

Execute From

Execute From Cursor

Execute Block

Execute From Start Points

Any Order Execution

Reset Execution List

Using the Execution Mode Options Dialog Box


Execute

Display Menu Roadmap

To execute all marked commands of the entire part program, select the File | Execute option.


Execute Feature

Display Menu Roadmap

To execute only the feature on which the cursor rests, select the File | Partial Execution | Execute Feature option.

PC-DMIS will display the Execution Mode Options dialog box. If PC-DMIS is set to manual mode (mode = MANUAL), it will prompt you to take the necessary hits. If PC-DMIS is set to DCC mode (mode = DCC), it will automatically move the probe based on the parameters set in the dialog box.

To maintain good execution speeds, PC-DMIS will not generate a report in the Report window if using the Execute Feature functionality. However, you can still view report-like information inside the Status Window.


Execute From

Display Menu Roadmap

To resume a previous cancelled execution, use the File | Partial Execution | Execute From menu option. This command executes the feature listed until the end of the part program. This menu option is only available when you have canceled a prior execute command by using the Execution Mode Options dialog box.

Example: If during a program execution, you click the Cancel button while measuring feature CIR1. The Execute From menu becomes available so that you can continue inspecting the part beginning at CIR1.


Execute From Cursor

Display Menu Roadmap

To execute the part program beginning at the cursor's current location, select the File | Partial Execution | Execute From Cursor menu command. The program will execute the part program beginning at the cursor's current location.


Execute Block

Display Menu Roadmap

To execute a block of commands, select the commands you want to execute, and then with the commands still selected, choose the File | Partial Execution | Execute Block menu command. PC-DMIS will execute only the selected block of commands.


Execute From Start Points'

Display Menu Roadmap

To begin execution at a specified start point, first set the start point by right-clicking inside Command mode and selecting Set Start Point from the shortcut menu, and then choose the Execute from Start Points menu command.

Important: Be aware that if the current tip for that location in the program does not match the current orientation of the probe head, PC-DMIS will not try and go back to execute the tip command above it in order to change the tip orientation.


Any Order Execution

PC-DMIS versions 4.0 and later allow you to execute manually measured part program features in any order. This is useful for portable arm machines.

This functionality becomes possible if the following conditions are met:

  • It only applies to features measured with manual hits.

  • The part programs cannot have any branching or loops.

  • The features you measure out of order must use the same alignment and probe as the feature PC-DMIS initially planned to measure (it will not search across LOAD PROBE or ALIGNMENT commands).

  • Out of order execution only works for features measured after a complete alignment. The initial alignment must be measured in order.

How It Works:

When you execute your part program, PC-DMIS asks you to take the first hit on the first feature. You can decide to take your first hit on a different feature instead. When you do this, PC-DMIS looks to see if you took that hit within a tolerance of the hit PC-DMIS expected. If your hit is more than a specified tolerance (usually 10 mm) away from the feature, then PC-DMIS will search backwards and forwards though the part program for the closest feature who's initial hit matches the initial hit that you took. You can define the tolerance in the Setup Options dialog box, General tab.

If you take a hit that is not in tolerance for any feature in your entire part program, the arm will sound a beep alert, and PC-DMIS will ignore the hit. An error message will also appear in the Execution Mode Options dialog box. Simply take a different hit closer to a part program feature to continue.

When PC-DMIS finds the appropriate feature, it passes your first hit into the feature. It then moves the arrow indicating where to take the next hit to the new feature. PC-DMIS only checks the tolerance on the first hit of the feature. After that, it assumes that you will continue taking hits until you finish measuring that feature.

Once you finish measuring a feature out of order, PC-DMIS attempts to go back to its initial order. It will continue to prompt you to measure the original feature each time you finish measuring something else out of order until you either skip the original feature or measure it. PC-DMIS tracks the features you measure out of order so that they aren't remeasured when PC-DMIS resumes its regular execution route.

If you remeasure a feature, PC-DMIS will recompute everything that uses that feature up until the current execution location.


Reset Execution List

As execution progresses, PC-DMIS maintains an internal list containing all the commands that have been executed. This is called the execution list. PC-DMIS uses the execution list for generating reports in the Report window. PC-DMIS always clears out the information in this list whenever you perform a full part program execution.

However, if you perform a partial execution (using execution menu items from the File | Partial Execution sub menu), it does not clear out the execution list. For example, if you perform a full execution, followed by a partial execution, the information from the full execution will remain in your execution list and will show up in your report along with the partial execution information.

If you don't want this, the File | Reset Execution List menu item immediately clears out the execution list.


Using the Execution Mode Options Dialog Box

All execution operations begin by displaying the Execution Mode Options dialog box.

Execution Mode Options dialog box

PC-DMIS will then execute all marked commands of the current part program.

  • If you are in Manual Mode, PC-DMIS will request you to take hits.

  • If you are in DCC Mode, PC-DMIS will automatically begin the measurement process.

More:

Machine Errors

Machine Commands

Continue

Stop

Erase Hit

Skip

Step-Next

Jump

Progress Bar

Manually Controlling a Feature's Measurement

Re-sizing the Execution Mode Options Dialog Box


Machine Errors

The Machine Errors list displays any errors that may occur during execution of the part program. Some possible errors are an unexpected probe hit or an unexpected end of move. You can view the errors by clicking on the drop down arrow.


Machine Commands

The Machine Commands list displays any moves and hits for the current feature (or the feature about to be measured). This information is only available if the program is stopped during execution, either by error or by the operator. Execution of the part program can be resumed by highlighting the desired hit (or move) from the Machine Commands list box and selecting the Continue button.

Example: If a clearance move command was programmed with the wrong X, Y, or Z, then during the execution of that move, you might get a motion error. To continue:
Pull down the Machine Commands drop-down list.
Select the command following the offending move.
Press the Continue button.


Continue

The Continue command button allows you to resume execution of a part program halted by a CMM motion error, or the Stop button. PC-DMIS allows you to select the specific location within the current feature where the probe is to resume measuring the part. The default location is displayed in the Machine Commands list. To select another location, simply pull down the drop-down arrow and select the desired line. PC-DMIS will continue the measurement process at the displayed location when the Continue button is pressed.


Stop

The Stop command button halts the probe at its current position and suspends execution of the part program.

Note: This option will not stop the part program execution if the current move is a PH9 orientation change. The program will stop after the PH9 has stopped.

The topic "Manually Controlling a Feature's Measurement" discusses using Stop to switch to manual mode during the execution process.


Erase Hit

To remove the currently highlighted hit in the Machine Commands list, simply press the Erase Hit button, located in the Execution Mode Options dialog box.

Most CMM jog boxes have a button assigned to erasing the last hit. Pressing that button on the CMM's jog box while in Execute mode, produces the same result as clicking the Erase Hit button on the dialog box.


Skip

The Skip command skips the next command displayed in the Machine Commands list. Any commands that depend on the skipped command are also skipped.


Step-Next

The Step Next command button continues with the measurement process but does so one step at a time, pausing the CMM after executing each step of any command that moves the CMM. While in Step Mode, hits can be inserted into features and new features can be inserted between existing features or commands. If you insert a new feature, PC-DMIS will display a dialog box allowing you to:

  • Skip to the HIT /BASIC command of the new feature,

  • Remeasure the new feature, or

  • Continue stepping through the part program, ignoring the new feature entirely.

Step Mode can also be simulated off-line.

Step Next appears on the dialog box when PC-DMIS pauses execution for a breakpoint (see "Using Breakpoints" in the "Editing a Part Program" section).


Jump

The Jump button automatically stops execution (if you're using a DCC machine) and displays the Jump to Feature List dialog box. From this list, you can select the next feature to execute, thereby deviating as needed from the automatically generated execution path.

Jump to Feature List dialog box

Jump to Feature List dialog box

After you select a feature from the list, click OK, and PC-DMIS will execute the selected feature. After it finishes, it will return to the pre-defined path and attempt to execute the next non-measured feature until you click Jump again and select a new feature.

Example:

Suppose you have seven circles, labeled CIR1 through CIR7 and they are programmed to execute in that order. If after CIR1, you click Jump and select CIR6, PC-DMIS will immediately measure CIR6. When finished, it will return and measure circles CIR2 through CIR5, and then it will finish by measuring CIR7.


Progress Bar

The Execution Mode options dialog box also includes a progress bar which indicates the percentage of the part program that has finished executing. The percentage is derived from the amount of executed commands and hits taken compared against the total number of marked commands and hits to take. The progress bar updates as it progresses through the part program. You may find this useful when you have a large program and want a general idea of how long it will take to complete.

Note: This functionality does not factor in individual scan hits or alterations to the number of executed items due to flow control statements.

Example Progress Bar Showing the Percentage of Program Execution

This button allows you to show or hide the progress bar as needed:

- Shows the progress bar

- Hides the progress bar


Manually Controlling a Feature's Measurement

To manually control the measurement of a feature:

  1. Click on the Stop command button in the Execution Mode Options dialog box.

  2. Click the Manual Mode icon. PC-DMIS will then allow you to control the measurement process on the current hit. (See "Continue".)

When the current feature is measured in MANUAL mode, PC-DMIS will automatically return the system to DCC mode and continue to measure the part under computer control. You can press the DCC mode icon to go back to DCC mode at any time.

PC-DMIS will not replace the original hits with any of the new hits. If a measurement value needs to be altered, it must be done in the Edit window.

Note: Some auto features will ask at the end of manual measurement if you want to save the new location of the feature as the target for future executions of the part program. Clicking YES in response to this prompt will save the currently measured position as the new target.


Re-sizing the Execution Mode Options Dialog Box

The Execution Mode Options dialog box is resizable. To re-size this dialog box:

  1. Place the mouse cursor on the outer edge of the dialog box. The general arrow icon will be replaced by a double arrow icon.

  2. Hold down the left mouse button.

  3. While holding down the left mouse button, drag the cursor to the desired location.

  4. Release the mouse button.

The box will be re-sized. This capability is useful when the execution data needs to be read from a distance.


Setting Your Preferences

Setting Your Preferences: Introduction

Selecting PC-DMIS Setup Options

Modifying Report and Motion Parameters

Setting Up the Edit Window

Setting Up the Readout Window

Setting up Multiple Arms

Defining the Rotary Table

Setting Up Probe Changer Options

Managing Multiple Probe Changers

Loading the Active Probe

Setting Up the Machine Interface

Compensating for Temperature

Specifying External Directories to Search

Changing OpenGL Options

Setting Import Options

Understanding the .DAT Files


Setting Your Preferences: Introduction

PC-DMIS allows you to set personal preferences that tailor the form and function of PC-DMIS to meet individual specifications. Using this section you will be able to control output format, screen graphics, machine parameters, and other options.

The main topics in this section include:

  • Selecting PC-DMIS Setup Options

  • Modifying Report and Motion Parameters

  • Setting Up the Edit Window

  • Setting Up the Readout Window

  • Setting Up Multiple Arms

  • Defining the Rotary Table

  • Setting Up Probe Changer Options

  • Loading the Active Probe

  • Setting Up the Machine Interface

  • Compensating for Temperature

  • Specifying External Directories to Search

  • Changing OpenGL Options

  • Setting Import Options

  • Understanding the .DAT Files

The following paragraphs describe the various system options and their functions.

More:

A Note on Storing Settings for Multiple Users

Switching Between Machine Profiles


A Note on Storing Settings for Multiple Users

Any changes made to PC-DMIS's settings, parameters, or user-interface customizations are now stored for each user. This is controlled internally by using the Windows NT / Windows 2000 user permissions. Logging onto the operating system by your specific user name automatically recalls your settings. These are stored inside named sub directories at the location where you installed PC-DMIS.


Switching Between Machine Profiles

Important: Your portlock must be programmed with the IP Measure option for the Save Machine Profile and Recall Machine menu items to appear.

These two menu items let you easily switch between machine profiles when creating part programs off-line.

Edit | Preferences | Save Machine Profile - This menu item displays a Save As dialog box that asks for a file name and records all the current settings for the virtual machine into a file with an "mpl" filename extension. PC-DMIS saves the following into the file for later recall:

  • Loaded machine model

  • Loaded tool changer model

  • Rotary table settings

  • Mount orientation for the probe

  • Starting default probe component (PH10, CW43 etc.)

  • Active probe file

  • Any "fixed" quick fixture components

  • The machine's speed settings and limits

Edit | Preferences | Recall Machine - This menu item lets you restore a machine's settings that were stored in an .mpl file. PC-DMIS displays an Open dialog box, and once you select the file to open, PC-DMIS restores the settings.


Selecting PC-DMIS Setup Options

Display Menu Roadmap

Selecting the Edit | Preferences | Setup menu option accesses the SetUp Options dialog box. This dialog box allows you to alter the form and function of PC-DMIS. Simply click on the desired tab. The available tabs include the following:

More:

Setup Options: General tab

Setup Options: Part/Machine tab

Setup Options: Dimension tab

Setup Options: ID Setup tab

Setup Options: NC-100 Setup tab


Setup Options: General tab

Display Menu Roadmap

SetUp Options dialog box —General tab

The General tab can be accessed by clicking on the General tab within the SetUp Options dialog box (Edit | Preferences | Setup). This option will allow you to change various functions controlling the measurement process.

More:

Edit Boxes for the General tab

Warnings

Password

Check Boxes for the General tab


Edit Boxes for the General tab

The edit boxes for the General tab allow you to edit the following options:

Scale Factor

The Scale Factor box scales the measured data by what ever factor is entered. For example, if a circle is measured and has a diameter of 1.0 inches and the scale factor is 0.95 then the measured value will be reported as 0.95 inches.

Minutes to Save

The Minutes to Save box allows you to enter the amount of minutes that PC-DMIS will wait before auto saving your part program. The least amount of minutes you can enter is one. The Minutes to Save box becomes available when you select the Automatic File Save check box.

Find Nominals Tolerance

This box becomes available when you first select the Find Nominals check box. See "Find Nominals".

The Find Nominals Tolerance box allows you to type the amount of tolerance that PC-DMIS uses when finding the nominals. The default is 10 mm.

When you initially set this value and click OK (and whenever you perform a find nominals operation in learn mode), PC-DMIS checks this value against the active tip's radius. If this value is less than the tip's radius, PC-DMIS will change it to match the diameter of the active tip.

Show Deviations Tolerance

The Show Deviations Tolerance box allows you to type the amount of tolerance that PC-DMIS uses when PC-DMIS is showing hit deviations. This option is only available when you first select the Show Hit Deviation check box.

Deviation Arrow Multiplier

The Deviation Arrow Multiplier box is only available when you first select the Show Hit Deviation check box. An arrow appears in the Graphics Display window marking each hit taken, showing the deviation. The larger the value entered in this field, the greater the size of the arrow.

Any Order Execute Tolerance

The Any Order Execute Tolerance box lets you define the tolerance that the hit must be within for PC-DMIS to measure that feature when executing your part program in any order execute mode.

If your initial hit is more than the specified tolerance away from the feature, PC-DMIS will search backwards and forwards through the part program for the closest feature whose initial hit matches your initial hit and execute that feature instead. See Any Order Execution in the "Using Advanced File Options" section for more information.

PC-DMIS stores the tolerance value with your part program. This allows you to have different search zones for different part programs if desired.

Thickness

The Thickness box works with the Thickness for Point Only Mode Points check box. If you select the Thickness for Point Only Mode Points check box, the thickness in this box will be applied to each point created by Point Only Mode.

See "Point Only Mode" and "Thickness for Point Only Mode Points" for additional information.

Execution FindNoms Tolerance

The Execution FindNoms Tolerance box allows you to type the amount of tolerance that PC-DMIS uses when finding the nominals during part program execution.

This box becomes available when you first select the Find Nominals during Execution check box.

See "Find Nominals During Execution".

Auto Circle Hits

The Auto Circle Hits box allows you to set the default number of hits PC-DMIS will take while learning circles using CAD data. The minimum number of hits that may be entered is three. It only changes the number of hits for circles about to be programmed, not for circles that have already been programmed.

The entry in the PC-DMIS Settings Editor for this option reads: AutoCirHits= [number of hits]. For information on modifying registry entries, please view the "Modifying Registry Entries" section.

Auto Line Hits

The Auto Line Hits box allows you to set the default number of hits PC-DMIS will take while learning lines using CAD data. The minimum number of hits that may be entered is two. It only changes the number of hits for lines about to be programmed, not for lines that have already been programmed.

The entry in the PC-DMIS Settings Editor for this option reads: AutoLineHits= [number of hits]. For information on modifying registry entries, please view the "Modifying Registry Entries" section.

Hits in U

The Hits in U box indicates the minimum number of rows that must be taken when scanning.

Note: This scanning option is only active when used with the Curves and Surfaces options.

Hits in V

The Hits in V box indicates the minimum number of hits per row that must be taken when scanning.

Note: This scanning option is only active when used with the Curves and Surfaces options.


Warnings

The Warnings button displays the Warnings Display Options dialog box.

Important: In order to better support the ability to turn off warnings in version 4.0 and above, warning messages will only appear in the Warnings Display Options dialog box once you have turned them off. If no warnings have been turned off the dialog box will be empty.

Warnings Display Options dialog box

This dialog box allows you to tell PC-DMIS to re-display warnings that you have already switched off as well as change the default actions for warning messages that are turned off. By default this dialog box is empty. When a warning message appears, PC-DMIS gives you the option of not receiving that warning again. When you choose to not receive the warning, the warning ends up in this dialog box.

To start receiving a warning message again:

  1. Access the SetUp Options dialog box (Edit | Preferences | Setup). Display Menu Roadmap

  2. Select the General tab.

  3. Click the Warnings button. The Warnings Display Options dialog box will open. It will show any warnings you have turned off.

  4. Select the warning in the dialog box.

  5. Clear its check box.

  6. Click OK. The warning is removed from the dialog box and you will start receiving that warning message again.

The Clear List button clears all the check boxes for all items in this dialog box, thereby returning PC-DMIS to its default mode of displaying all the warning messages.

To change the default action for a warning message:

  1. Make sure you have clicked the Don't ask me again check box when the warning appears. This causes it to go to the Warnings Display Options dialog box.

  2. Access the SetUp Options dialog box

  3. Select the General tab.

  4. Click the Warnings button. The Warnings Display Options dialog box will open. It will show any warnings you do not want to display.

  5. Double-click on the warning message whose default action you want to change. PC-DMIS displays the warning, allowing you to select the new default action.

  6. Select the new default action. The list will now be updated with the new action.

  7. Click the OK button to save your choice.


Password

The Password button allows you to password protect access to the Setup Options dialog box.

To password protect your setup options:

  1. Access the SetUp Options dialog box (Edit | Preferences | Setup). Display Menu Roadmap

  2. Select the General tab.

  3. Click the Password button. The Options Password dialog box appears.

    Options Password dialog box

  4. In the New Password box, type the desired password.

  5. In the Repeat entry box, re-type the same password to confirm your entry.

  6. Select the Use Password check box.

  7. Click OK.

The next time you attempt to access the Setup Options dialog box, you will be asked to type the password before proceeding.

If, at this request, you click Cancel you will have the option of viewing the currently selected options but will be unable to make any changes.


Check Boxes for the General tab

The check boxes listed in the General tab of the SetUp Options dialog box allow you to turn on or off a variety of different options. This is useful because you can customize the way much of PC-DMIS operates in order to fit your specific needs.

More:

Press End Key

Automatic File Save

Find Nominals

Point Only Mode

Edge Point Only Mode

Ignore Motion Error

Automatically Adjust Probe Head Wrist

Ignore CAD to Part

Reset global settings when branching

Move Feature to Reference Plane

Show Extended Sheet Metal Options

Fixed Dialog Positions

Lock Marked Sets

Automatically Scale to Fit

Show Hit Deviations

Use Circular Moves on Round Features

Thickness for Point Only Mode Points

Allow fine tuning of Alignment

Use CAD Provided ID's for Features

Find Nominals During Execution

Auto Continue Execution if FindHole Fails

Show Startup Dialog

Automatic Label Positioning

Animate Probe during Program Mode

Show Icon in Text Boxes

Pierce CAD on 3D Rotate

Save Part Program on Execute

Use DMIS Button in Edit Window

Patch Scans Maintain Last Increment

Use Automotive Deviation Letters

Use Find Nominals Override for Scans

Use ONLY Priority Surfaces for the Find Nominals During Scans

Display Outline of Plane

Treat Theo Values As if Stored in Part Coordinates

Make Variables Globally Visible

Pass Back Settings from Subroutine

Use DMIS Polar Convention

Use Program Layout for Execution

Force Part Alignment in Car Body

Keep Existing Dimension's Axes

Select Alignment to Output to Gds

Gap Only

Show tracker parameters in offline


Press End Key

The Press End Key check box controls whether or not PC-DMIS waits for you to press the END key before it accepts the last hit taken. Selecting this check box allows you to preview the last hit before you accept it. If you don't select this check box, the current hit that you take with the jog box is not stored in the hit buffer, but automatically becomes the last hit for the feature, even if you take the hit at the wrong spot.


Automatic File Save

The Automatic File Save check box allows you to automatically save the part program at predetermined time intervals. If this check box is selected, the default setting will save the program every minute. This amount of time can be changed simply by entering another value in the Minutes to Save box.

PC-DMIS stores the autosaved file under the title of "Autosave Copy of" plus the original file name. This autosaved copy can be opened in the same manner as a regular part program in case of some catastrophic failure of the original file. The entry in the PC-DMIS Settings Editor for this option reads: AutoSave = 0 or 1

For information on modifying registry entries, please view the "Modifying Registry Entries" section.


Find Nominals

The Find Nominals check box controls how PC-DMIS treats hits. When selected, PC-DMIS will then automatically consider each probe touch, finding the closest CAD nominal for that touch. It will continue to accumulate hits until the END key is pressed. The feature type will then be calculated and the CAD nominals applied.

Once selected, the Find Nominals Tolerance box becomes available. See "Find Nominals Tolerance".


Point Only Mode

The Point Only Mode check box controls how PC-DMIS responds to each probe hit. When selected, PC-DMIS automatically considers each probe hit to be a single point measurement and automatically creates an Auto Vector Point. If the check box is not selected, PC-DMIS will accumulate probe hits until the END key is pressed. Only then will it determine the type of feature just measured.

When you select this check box, the Thickness for Point only Mode Points check box becomes available. See "Thickness for Point Only Mode Points".


Edge Point Only Mode

The Edge Point Only Mode check box controls how PC-DMIS responds to each set of probe hits. In this case, a set is defined as two singular probe hits. The first hit should always be taken on the surface. The second hit should always be taken on the edge. When this check box is selected, PC-DMIS automatically considers each set of probe hits to be a single point measurement and automatically creates an Auto Edge Point. If the check box is not selected, PC-DMIS will accumulate probe hits until you press the END key. Only then will it determine the type of feature just measured.

PD-DMIS will use the options as displayed in the Hits, Auto, and Misc areas of the Edge Point dialog box when creating the Edge Point (See the "Creating an Auto Edge Point" topic in the "Creating Auto Features" section).

CAD nominals will be applied if the Find Noms option is checked.


Ignore Motion Error

Display Menu Roadmap

This option does not apply to all machine types. Some machines can utilize this option while on others it will have no effect.

Selecting the Ignore Motion Errors check box tells PC-DMIS to ignore collision errors. Selecting this check box and clicking OK inserts an IGNOREMOTIONERRORS/ON command into the Edit window. When PC-DMIS encounters this command and the probe collides with an obstruction, the probe will not automatically stop. This option is helpful when measuring materials such as clay or plastic, where some flexibility is necessary.

Setting this command to OFF within the Edit window will once more display collision errors.


Automatically Adjust Probe Head Wrist

If you select the Automatically Adjust Probe Head Wrist check box, then during execution when the software reaches a TIP command, it will, based on the geometry, automatically select the tip for which the IJK of the tip shank most closely approximates the IJK on the TIP command. The IJK on the TIP command is relative to part coordinates so the tip actually selected can vary based on the part alignment.

How it works with Non-Mapped Wrists

For non-mapped wrists PC-DMIS returns the closest theoretical position. If there is a calibrated tip that matches this theoretical position, it uses that calibrated tip. If PC-DMIS can find calibrated tips that fall within the angle tolerance defined in the Wrist Warning Delta box of the Part/Machine tab, it’ll use those tips over non-calibrated tips that have closer angle matches (see "Setup Options: Part/Machine tab").

If it cannot find what it thinks is a theoretical match, it gives an error "Illegal TIP command or TIP not qualified".

If it found a good theoretical match but that tip doesn't exist or isn't yet calibrated, it will wait until the machine catches up to the TIP statement so no machine motion is in progress, and then it will ask you if it should use the closest calibrated tip.

  • If you select YES, then it uses the calibrated tip.

  • If you select NO, then it adds a tip object to match the best theoretical fit and halts, but does not cancel, execution and a message appears on PC-DMIS's Status Bar that says to press continue when you're done calibrating the new probe. At this point, you should access the Probe Utilities dialog box, perform any calibration work as needed, and then click Continue to proceed.

How it works with Mapped Wrists:

With an infinite wrist that is actually mapped (and therefore calibrated) PC-DMIS automatically returns the best matching tip position and proceeds using that position.

Other Notes

This option can also be turned on for individual hits of Auto Features by using the Auto PH9 check box inside the Auto Feature dialog box. (See the "Creating Auto Features" section.)

The entry in the PC-DMIS Settings Editor for this option reads: AutoAdjustPh9 = 0 or 1. For information on modifying registry entries, please view the "Modifying Registry Entries"

Note: Be aware that if you use the Mark Used button on the Probe Utilities dialog box, PC-DMIS may not select all the probe tips for calibration (see the "Mark Used" topic in the "Defining Hardware" section). Display Menu Roadmap


Ignore CAD to Part

Each time you create an alignment (saved or otherwise) PC-DMIS creates two transformation matrices.

  1. Machine to part transformation matrix - Computed from the input features' measured values stored internally in machine coordinates.

  2. CAD to part transformation matrix - Computed from the input features' theoretical values stored internally in CAD coordinates.

When you don't have available CAD data, theoretical data usually comes from the measured values of the learned features. It is difficult to get consistent results using theoretical values. This can happen when some of these values are edited, while others are not.

If you have selected the Ignore CAD to Part check box when you save an alignment, PC-DMIS ignores the CAD to part matrix and instead only saves the machine to part alignment. All theoretical values will now be in the same coordinate system.

Generally, if you are not using CAD data, select this check box.

Effects on Cad Equals Part

You may want to execute an alignment from features measured without CAD data in DCC mode. If you will be using the CAD Equals Part menu option (or CAD = Part button), be sure to select the Ignore CAD to Part check box prior to setting the CAD equal to the part. For information on setting the CAD equal to the part, see the "CAD Equals Part" topic in the "Creating and Using Alignments" section.

Theoretical Values for Copied Features

  • If you clear this check box and copy a feature to a new location in the Edit window, the theoretical values of the feature will be associated with the alignment at the feature's original location.

  • If you select this check box and copy a feature to a new location in the Edit window, the theoretical values of the feature will be associated with the alignment at the feature's new location.

See "Changing Alignment Nominal Values" in the "Creating and Using Alignments" section.


Reset global settings when branching

If you select the Reset global settings when branching check box, PC-DMIS will reset the global values for state commands (see the list of commands below.) after encountering a branching statement. (For information on branching, see the "Branching by Using Flow Control " section for information on branching). Any state commands jumped over, because of a branching statement, will not be executed. This allows you to skip over sections of the program without having these settings change.

For example, suppose your part program has the following:

TIP /T1A0B0
MYLABEL=LABEL/

Measurements etc...

TIP/T1A90B90
GOTO/MYLABEL

If you select the check box,
When PC-DMIS reads the GOTO statement, it jumps to MYLABEL. And then searches up, using the first encountered TIP/ command: TIP/T1A0B0

If you deselect this check box,
When PC-DMIS reads the GOTO statement, it jumps to MYLABEL. PC-DMIS won't reset global settings when encountering a branching statement. Instead, it uses the last executed TIP/ command: TIP/T1A90B90

PC-DMIS defaults to selecting the check box. In versions prior to version 3.25, PC-DMIS automatically reset the global values of the state commands. Now, PC-DMIS gives you the option to turn this option On or Off.

Commands Reset After Branching:

  • Start/align

  • Recall/align

  • Mode/

  • Rmeas /

  • Workplane/

  • Tip/

  • Loadprobe/

  • Retract/

  • Check/

  • Touchspeed/

  • Movespeed/

  • Polarvectorcomp/

  • AutoTrigger/

  • Triggerplane/

  • TriggerTolerance/

  • Videosetup/

  • Displayprecision/

  • ManRetract/

  • Scanspeed/

  • Prehit/

  • Clamp/

  • Clearp /

  • Format/

  • 132column/

  • Gaponly/

  • Retrolinearonly/

  • Probecom/

  • Array_indices/

  • Fly/

  • Positivereporting/

  • Ignoremotionerrors/


Move Feature to Reference Plane

If you select the Move Feature to Reference Plane check box, PC-DMIS will automatically project the measured feature to the work plane. In general, this works for any of the following feature types as long as they use the best fit functionality internally:

  • Circles

  • Ellipses

  • Lines

  • Polygons

  • Slots

  • Measured points


Show Extended Sheet Metal Options

If you select the Show Extended Sheet Metal Options check box, PC-DMIS will display all of the available Sheet Metal options in the Auto Features dialog box. (See the various extended sheet metal topics in the ”Creating Auto Features" section.)

The entry in the PC-DMIS Settings Editor for this option reads: ShowExtendedSheetMetal = 0 or 1. For information on modifying registry entries, please view the "Modifying Registry Entries" section.


Fixed Dialog Positions

If you select the Fixed Dialog Positions check box, PC-DMIS will display dialog boxes in their default position. If this option is not check marked, PC-DMIS will display each dialog box wherever it was last positioned. This option becomes extremely helpful when using macros.

The entry in the PC-DMIS Settings Editor for this option reads: DialogFixedPosition = 0 or 1. For information on modifying registry entries, please view the "Modifying Registry Entries" section.


Lock Marked Sets

If you select the Lock Marked Sets check box, PC-DMIS will prevent users from accidentally deleting or otherwise modifying the current mark set configurations. PC-DMIS will only allow you to execute and activate marked sets. You must clear this check box to add or delete features from a marked set.


Automatically Scale to Fit

If you select the Automatically Scale to Fit check box, PC-DMIS will automatically scale the screen every time a feature is measured.

The entry in the PC-DMIS Settings Editor for this option reads: AutoScaleToFit = 0 or 1. For information on modifying registry entries, please view the "Modifying Registry Entries" section


Show Hit Deviations

If you select the Show Hit Deviations check box, PC-DMIS will draw an arrow whenever a hit is taken to show the measured value minus the nominal deviation.


Use Circular Moves on Round Features

If you select the Use Circular Moves on Round Features check box, and if you are "learning " a part program by taking hits on the part, PC-DMIS will automatically place circular move commands into the inside circular features as well as into the outside of circular features. This includes Circles, Cylinders, Cones, and Spheres. This state, however, is only relevant during learn mode. Once the circular/move commands are present inside features they remain there unless directly removed by the user.

The entry in the PC-DMIS Settings Editor for this option reads: UseCircularMoves = 0 or 1. For information on modifying registry entries, please view the "Modifying Registry Entries" section.


Thickness for Point Only Mode Points

When you select this check box, you can apply thickness to points created with Point Only Mode. Selecting this check box makes the Thickness box in this same dialog box available for editing. You can then type a thickness and apply that thickness to points created using Point Only Mode.

For additional information, see "Point Only Mode" and "Thickness".


Allow fine tuning of Alignment

Whenever you change an alignment, PC-DMIS asks if it should update the commands below with the changed alignment. If you have this check box selected, and you click the NO button at this prompt, PC-DMIS changes the MACHINETOPART transformation if required. If deselected, the MACHINETOPART transformation does not change.


Use CAD Provided ID's for Features

The Use CAD Provided IDs for Features check box allows you to import feature IDs from a CAD file. When you select this check box, PC-DMIS automatically inputs the given CAD ID into the Auto Feature dialog box when the CAD feature is selected with a left mouse click. If you decide to keep this value, then the feature created will have the given ID.


Find Nominals During Execution

If you select the Find Nominals during Execution check box, new nominals are found for both Surface and Vector points during part program execution. See "Execution FindNoms Tolerance" to define the tolerance values PC-DMIS will use. Also, see "Find Nominals Tolerance".


Auto Continue Execution if FindHole Fails

If you select the Auto Continue Execution if FindHole Fails check box, PC-DMIS allows you to automatically continue executing a part if the "FindHole" option found on the Auto Feature dialog box fails to find a hole.

In the past, when the ”FindHole” option failed, PC-DMIS prompted you to place the probe in the center of the hole to continue running the part program. However, with the Auto Continue Execution if FindHole Fails check box selected, PC-DMIS automatically prints an error message to the report and continues running the remaining part program.

For more specific information on Find Hole, see the "Find Hole Check Box" topic in the "Creating Auto Features" section.


Show Startup Dialog

The Show Startup Dialog check box allows you to determine whether or not PC-DMIS shows the Open File dialog box each time you start PC-DMIS. This dialog box shows a listing of available part programs to open.

When you clear the check box, PC-DMIS will disable this startup dialog.

See "Opening Existing Part Programs" in the "Using Basic File Options" section for additional information on the Open File dialog box.


Automatic Label Positioning

The Automatic label positioning check box tells PC-DMIS to automatically position feature labels around the part. Thereafter, feature ID labels will be repositioned whenever you perform pan, zoom, or rotate operations on the part model.

You can also turn on Automatic Label Positioning by right-clicking on a feature ID label and selecting Label Processing | Automatic Label Positioning from the shortcut menu.


Animate Probe during Program Mode

The Animate probe during Program Mode check box activates probe animation during Program mode. When you select this check box, the probe will animate the taking of hits in the Graphics Display window as the hits are generated from CAD.


Show Icon in Text Boxes

The Show icon in text boxes check box allows you to determine if icons depicting the feature or dimension type should appear in text boxes and inside feature ID labels. The text boxes include feature ID, dimension info, and point info text boxes.

For information on text boxes see "Text Box Mode" in the "Editing the CAD Display" section.


Pierce CAD on 3D Rotate

The Pierce CAD on 3D rotate check box allows you to determine the exact point about which PC-DMIS rotates when performing a 3D rotate by simply right-clicking in the Graphics Display window.

· If you select this check box and perform a 3D rotate by right-clicking in the Graphics Display window, PC-DMIS uses the point where you clicked as the point used about which to rotate.

· If you clear this check box and then right-click to 3D rotate, then PC-DMIS doesn't pierce the CAD.

Note: As always, however, if PC-DMIS detects a wire frame entity or surface edge close to the mouse cursor, then the point on the entity or edge closest to the mouse pointer will be used as the rotation point.

See "3D Rotate Mode" discussed in the "Editing the CAD Display" section for information on 3D rotating.


Save Part Program on Execute

The Save Part Program on Execute check box tells PC-DMIS to automatically save the current part program whenever it's executed.


Use DMIS Button in Edit Window

The Use DMIS Button in Edit Window check box determines whether or not the DMIS mode icon gets displayed on the Edit window toolbar.


Patch Scans Maintain Last Increment

The Patch Scans Maintain Last Increment check box forces each new line of the patch scan to use the last increment from the previous line. If you deselect this check box, the scan will revert to the minimum scan increment when taking the first hit on each line.


Use Automotive Deviation Letters

The Use Automotive Deviation Letters check box causes PC-DMIS to add a letter after the deviation number in Location and True Position dimension reports. PC-DMIS inserts the letter

· F when the feature deviates in the direction of the front of the car.

· B when the feature deviates in the direction of the back of the car.

· I when the feature deviates towards the centerline of the car (meaning the car is too narrow).

· O when the feature deviates away from the centerline of the car (meaning the car is too wide).

· H when the feature deviates towards the top of the car.

· L when the feature deviates towards the bottom of the car.

Map of Automotive Deviation Letters

These letters are added to the Location and True Position dimensions just following the deviation numbers reported. These deviation letters also appear inside the Report window for the appropriate dimensions.

Automotive Deviation Letters in Command Mode

Automotive Deviation Letters in Report Window


Use Find Nominals Override for Scans

The Use Find Nominals Override for Scans check box allows you to override found nominals when searching for nominal values for a scan's measured points when it executes.

Note: The execution must fail to find at least one of the measured nominal point values for you to override the found nominals.

See "Overriding Found Nominals" in the "Editing a Part Program" section.


Use ONLY Priority Surfaces for the Find Nominals During Scans

The Use ONLY Priority Surfaces for the Find Nominals During Scans check box causes PC-DMIS (during program execution) to search for nominal values for a scan's measured points on only the priority surfaces set in the Edit CAD Elements dialog box.

See "Editing CAD" in the "Editing the CAD Display" section.


Display Outline of Plane

The Display Outline of Plane check box determines whether or not PC-DMIS displays actual plane outlines in the Graphics Display window instead of the small symbolic triangle symbol typically used.

For example, if you select this check box and measure three points to construct a plane, the symbolic triangle for the plane will be sized so that its vertices are exactly where the measured points are.

Example of a constructed plane displayed with this check box selected

Note: Whether you select or clear this check box, existing outlines aren't redrawn; only planes created from that point on affected. To change existing outlines, you have to do it manually.

To switch the display of existing planes:

  1. Access the Edit window.

  2. Place it in Command mode.

  3. Go to the command for the plane's display you want to change. For example,

PLN1 = FEAT/PLANE,RECT,TRIANGLE

  4. Press the TAB key until you highlight the TRIANGLE or OUTLINE field.

  5. Press F7 or F8 to switch between the available values for this field.

  • TRIANGLE displays the small symbolic triangle symbol for the plane.

  • OUTLINE displays the actual outline for the points making up the plane.

  6. 6. Press the TAB key to see the result in the Graphics Display window.


Treat Theo Values As if Stored in Part Coordinates

The Treat theo values as if stored in part coordinates check box causes PC-DMIS to treat theoretical values as if they're stored in part coordinates. This check box was added for cases where part programs perform loops and the alignments are changing within the looping code.

The offset parameters of the LOOP/START command take care of this issue automatically. This is for looping programs that don't use the LOOP/START and LOOP/END commands, such as a WHILE - END/WHILE loop.

Consider this sample pseudo part program:

ASSIGN/COUNT = 4

ASSIGN/I = 1

WHILE/I<4

LOOPALIGN = START/ALIGN

ALIGN/TRANSLATION OFFSET, X, 50

END/ALIGN

MYCIRCLE = MEAS/CIRCLE

THEO/0,0,0

ASSIGN/I = I + !

END_WHILE/

You would expect that each time through the loop the X value would shift by 50 since the alignment is shifting by 50 each time. However, since PC-DMIS don't store feature data in part coordinates but in CAD and Machine coordinates, the effect is that the feature doesn't actually move in this situation even though the alignment is changing each time through the loop. This is because the CADTOPART and PARTTOMACHINE transform matrices of the alignment are both altered in the same way, the net effect is that the CADTOMACHINE transform remains unchanged. This means, by default (when this check box is not selected), PC-DMIS ends up measuring in the same spot all four times through the loop.

If PC-DMIS stored coordinates in part coordinates internally, then this would work as expected. This is where this check box comes into play. When you select this check box, PC-DMIS keeps track of the alignment that was used during the initial measurement. On subsequent measurements of a feature, it checks to see if the current alignment differs from the alignment used on the first pass. If it does, then PC-DMIS calculates the differences and shifts the feature by that difference, causing this to function as expected.

Rather than simply changing how PC-DMIS does things internally, this functionality was provided as a check box to preserve existing part programs.


Make Variables Globally Visible

Usually, when a subroutine is called, all variables go "out of scope" and are unavailable. The Make Variables Globally Visible check box makes any variables globally "visible", or usable, throughout the entire part program.

By default, this check box isn't selected so that variables in a subroutine won't replace data stored in variables with the same name in the main part program.

Example:

ASSIGN/V1 = 1

C1 = CALLSUB,MYSUB

.

.

.

SUBROUTINE/MYSUB

COMMENT/OPER,V1

END/SUB

If you deselect this check box, variables are not globally visible. The OPER comment will show a value of 0 since V1 cannot be seen from inside the subroutine.

If you select this check box, variables are globally visible, the OPER comment will show a value of 1 since V1 can be seen from inside the subroutine.

For information on variables, see the "Using Expressions and Variables" section.


Use DMIS Polar Convention

ith this option selected, polar angles will follow standard DMIS Polar Convention.

  • XY Plane (PLUS Z or MINUS Z) coordinate 'a' is the angle from the x-axis towards the y-axis.

  • YZ Plane (PLUS X or MINUS X) coordinate 'a' is the angle from the y-axis towards the z-axis.

  • ZX Plane (PLUS Y or MINUS Y) coordinate 'a' is the angle from the z-axis towards the x-axis.


Pass Back Settings from Subroutine

This check box allows alignment and other system changes that occur within a subroutine to be seen by the main program after the subroutine call.


Use Program Layout for Execution

Selecting this check box lets you use the same window layouts at execution time as you have for program time.


Force Part Alignment in Car Body

The Force Part Alignment in Car Body check box forces your alignment to be in car body alignment. If you select this check box, no matter what alignment method you choose, the alignment will always match that of the CAD. Selecting this check box acts as a secondary transformation after the initial alignment.

For example, if you translate to the center hole on the Hexagon Metrology test block and select this check box, the origin will still be in the corner, but when you report on that hole, it will be perfect since you used it to set your origin.

Alignment before using this check box

Alignment after using this check box


Keep Existing Dimension's Axes

The Keep Existing Dimension's Axes check box keeps existing axes for dimensioned features from getting updated even if you switch a dimensioned feature to a different feature type. If you don't select this check box, the related dimension axes will update according to the selected feature.

By default this is not selected.


Select Alignment to Output to Gds

This check box lets you determine whether or not PC-DMIS displays a dialog box allowing you to select the alignment to output as a .gds file. If you select this check box PC-DMIS lets you choose an alignment to output to the .gds file. If you don't select this check box, PC-DMIS will output the last used alignment automatically. See "Exporting to a Gds File" in "Using Advanced File Options".


Gap Only

This check box sets the default value for the Gap Only check box used in new Location dimensions for the current part program.

  • If you select Gap Only then, when the part program next starts, the GAPONLY/ON command will get added into the Edit window. In addition, the Feature Location dialog box for Location dimensions will automatically have its Gap Only check box selected by default whenever you create a new Location dimension.

  • If you deselect Gap Only then the Feature Location dialog box will have its Gap Only check box also deselected whenever you create a new Location dimension.


Show tracker parameters in offline

If you use a portable Leica Tracker device in online mode to generate feature commands, PC-DMIS automatically inserts the following information into the Edit window inside those feature commands:

  • RMS - Root Mean Squared value of each hit.

  • Probe Type - The type of probe used to measure the feature.

  • Time Stamp - The time the feature was executed or learned. PC-DMIS only updates this when it actually measures a feature in online mode.

  • Environmental Conditions - Information such as temperature, pressure, and humidity.

In offline mode PC-DMIS behaves differently. These Leica Tracker items only appear after you select the Show tracker parameters in offline check box, and they will only appear for new feature commands inserted into the part program after you have selected this option. Previously measured features will remain unaffected except for a permanent structure change adding in an empty Tracker Parameter group into each feature command.

Note: Selecting this check box performs a permanent change to your part program structure for inserted feature commands regardless of whether or not you later clear this check box. For example, if you clear this check box after you've already used it for some features, newly inserted features will still contain a Tracker Parameter group; although that group will not contain any group items.

For information on where and how these items appear in the feature commands, see the "PC-DMIS Portable" documentation.


Setup Options: Part/Machine tab

Display Menu Roadmap

Setup Options dialog box—Part/Machine tab

The Part/Machine tab lets you define the part setup on the CMM (or Machine) by changing the CAD axes relationship to the machine axes. This option can be accessed by clicking on the Part/Machine tab within the SetUp Option dialog box (Edit | Preferences | Setup).

This capability is needed when a program is being created using PC-DMIS, and the CAD coordinate system differs from the CMM part setup.

Example: A part is set up on the machine with its X+ CAD axis pointing in the same direction as the CMM's Z+ axis. The Z+ CAD axis is pointing in the same direction as the CMM's X- axis. This function can be used to create the proper relationships.

To equate the CAD setup to the part’s setup, simply select the appropriate axes from the drop-down lists. Once this relationship is established, it will be easier to program the part because PC-DMIS will properly display the probe in relation to the part.

More:

Machine

Part Setup

Table Avoidance

Default button


Machine

  1. Access the SetUp Options dialog box (Edit | Preferences | Setup).

  2. Select the Part/Machine tab.

  3. Click the Probe Head Orientation button. The Probe Head Wrist Angle Configuration dialog box will appear.

  4. Select the appropriate axes for the AB angles for both Master and Slave arms (if applicable).

  5. Click the OK button.

  1. Scroll to the location in the Edit window where you want the Fly command.

  2. Select the Active check box [image] .

  3. Type a radius value.

  4. Click the Create button.

  5. The Fly Mode will automatically be placed in the current part program at the designated location. The Edit window command line for this option reads:

FLY/TOG1,TOG2

TOG1
This toggle field switches between either ON or OFF. If ON then PC-DMIS activates the command. If OFF, PC-DMIS skips the command.

TOG2
This field lists the value for the radius.

If you have selected an illegal position, a message appears informing you that PC-DMIS cannot insert at the current line. The message then asks if it should insert the command at the next legal position.

  • If you click the Yes button, PC-DMIS will move the Fly command down to the end of the current feature in the Edit window.

  • If you click the No button, PC-DMIS will cancel the Fly command and return you to the Part/Machine tab.

When the part program is executed, PC-DMIS will move the probe a predetermined distance from the move point without any hesitation. The distance moved is the value entered in the Radius box.

Machine area

Machine area

Dialog Box Item

Description

Probe Head Orientation button

The Probe Head Orientation button allows you to configure the probe head wrist AB angles for both Master and Slave arms.

To configure the AB wrist angles for both Master and Slave arms:

Fly Mode area

The Fly Mode area provides a way to move the probe around the part in a smooth, non-stopping motion. A move point must be inserted into the part program before using this option. (See "Inserting a Move Point Command" in the "Inserting Move Commands" section.) The Fly command can only be inserted before or after any feature in the part program.

To use the Fly Mode:

Wrist Warning Delta box

This is a numerical value defining the minimum change in the wrist angle required before PC-DMIS requires you to change the current wrist position. This only affects users with a DCC CMM with a PH9 articulated wrist.

Manual Hit Retract box

This option is only available with certain DCC CMM types (such as LK and Mitutoyo).

The Manual Hit Retract box allows you to type the retract distance the CMM will automatically travel after a manual hit is taken.

If the Manual Hit Retract value is changed from either the default or from the last used value, then PC-DMIS places a retract command (shown as "MANRETRACT/" and then the value) in the current part program 's Edit window at the cursor's location. As manual hits are taken, the CMM will retract by the new value stated on this command.

For example, if you change the Manual Hit Retract value from the .1 default to .003 then the command "MANRETRACT/0.003" appears in the Edit window.

Scanning Min Time Delta box

This value allows PC-DMIS to reduce the amount of points that are scanned by deleting hits that are read in faster than the specified time delay in milliseconds.

Scanning Min Distance Delta box

This value allows you to reduce the measured data by deleting hits that are closer than the distance specified in millimeters. The reduction of hits happens as data comes from the machine. PC-DMIS only keeps the points that are set apart by more than the specified increments.

Display Absolute Speed box

If the Display Absolute Speed check box is selected, PC-DMIS will display the Move Speed as an absolute value instead of a percentage. This value corresponds to the set unit type of the part program (inches or millimeters).

Top Speed (mm/sec) box

The Top Speed (mm/sec) box allows you to reset the top speed that the machine can travel. The value that is specified cannot exceed the machine's designated top speed. The value that is set works in conjunction with the Move Speed option.


Part Setup

Adjust Part Setup dialog box

  1. Click on the appropriate box

  2. Type a new value. PC-DMIS dynamically shows the adjustment in the Graphics Display window.

  3. Click OK to accept the values and close the dialog box.

PC-DMIS will maintain this adjustment unless you re-import the part's CAD model.

Part Setup area

Part Setup area

The options in the Part Setup area are needed when a program is being created using PC-DMIS, and the CAD coordinate system differs from the CMM part setup.

Dialog Box Item

Description

CAD "+X" axis equals list

This drop-down list allows you to set the relationship between the CAD X+ axis and the machine axis.

CAD "+Y" axis equals list

This drop-down list allows you to set the relationship between the CAD Y+ axis and the machine axis.

CAD "+Z" axis equals list

'This drop down list allows you to set the relationship between the CAD Z+ axis and the machine axis.

X Off box

Y Off box

Z Off box

These boxes allow you enter the distance that PC-DMIS will offset the CAD drawing along the X, Y, or Z axis. PC-DMIS will shift the CAD drawing along the X, Y, or Z axis the specified distance. For example, if you enter in .5 in the X field, the entire CAD display in the Graphics Display window will shift the distance of .5 in the X direction.

Note: All features created in the part program will not shift along the axis with the CAD drawing.

Adjust button

The Adjust button opens the Adjust Part Setup dialog box.

You can use this dialog box to rotate or move the CAD in increments about and along the machine's XYZ axes.

  • If you're rotating the CAD, then the values will be in angle degrees. A value of 360 will have the same effect as 0.

  • If you're moving the CAD, then the values will be in the units of measurement that the part program is in, so a value of two would mean two inches or two millimeters, depending on the units of measurement used by your part program.

To adjust the CAD along or about an axis:

Apply button

The Apply button immediately applies any changes made in the X, Y, or Z Offset fields and shifts the drawing along the appropriate axis (axes) while keeping the dialog box open.

Auto Position button

The Auto Position button automatically positions the part onto the graphical representation of the machine. Auto position best guesses where to position the part on the graphical representation. You can either let PC-DMIS determine where to put the part in relation to the CMM by using this function, or you can key in your own positioning using the XYZ offset fields. (See "Defining Machines" in the "Defining Hardware" section for more information on setting up the graphical representation of the CMM.)


Table Avoidance

Table Avoidance area

The Table Avoidance area of the Part/Machine tab allows PC-DMIS to ascertain if the probe will come in contact with the table (or set plane) while in DCC mode.

Press the Measure button and PC-DMIS will ask you to take a hit where the table surface is to be defined. This location defines the threshold for the Z axis. The tolerance field defines a location in the positive Z direction for positive values and in the negative Z direction for negative values, relative to the set plane.

  • If a move goes beyond the indicated tolerance, PC-DMIS will display an error message indicating the potential danger.

  • If a wrist rotation is requested that will pass through the defined zone, PC-DMIS will display a message alerting you to the error.

Select either Cancel or Continue to terminate or finish the operation.

Example: A tolerance field of .25 will alert PC-DMIS to avoid the indicated threshold plus the tolerance value. If the threshold is on the table surface, PC-DMIS will alert you if the probe tip comes within one quarter inch (or millimeter depending on the set unit type) of the table.

Note: The Table Avoidance option is available with certain interface types only while in DCC mode.


Default button

The Default button allows you to update the default settings to several of the Part/Machine Setup parameters. When a new part program is created, it will reflect any changes made to the accessible parameters, only if the Default button is pressed. If the OK button is selected (without the Default button being pressed) the defined parameters will only apply to the active part program and will not affect PC-DMIS's registry entries. The default values are stored in the registry. These parameters can be updated in the appropriate dialog box or by using the PC-DMIS Settings Editor. See the "Modifying Registry Entries" section.

If any of the parameters are changed and the Default button is clicked, PC-DMIS will update the registry file, redefining the default to the current setting.


 Setup Options General Part Machine ID Setup NC-100 Setup Features Use Dimension Colors Minus Tols Show Negative check box CAD Nominal Places box Number of Decimal Places options Positive Reporting area Display Angle Degrees area Angle Degrees area Help button

Setup Options: Dimension tab

Display Menu Roadmap

Setup Options dialog box—Dimension tab

The Dimension tab lets you access the dimensional printout parameters.

To access the Dimension tab

  1. Access the SetUp Options dialog box (Edit | Preferences | Setup).

  2. Click the Dimension tab.

More:

Apply Defaults Based On

Default Feature Tolerance

Auto Stats

Features Use Dimension Colors

CAD Nominal Places

Minus Tols Show Negative

Number of Decimal Places

Default Tolerances

Positive Reporting

Display Angle Degrees

Angle Degrees

Auto Dimension Setup


Apply Defaults Based On

Apply Defaults Based on area

The Apply Defaults Based On area lets you apply default dimension tolerances either based on feature type or on the number of decimal places displayed.

  • Selecting the Feature Type option enables the Default Feature Tolerance area, allowing you to define dimension tolerances based on individual feature types. Whenever PC-DMIS creates a dimension automatically, either because the Auto option is selected in the Location dialog box or because you used the Auto Dimension Setup... button, the default dimension tolerance associated with that feature type will be used. See the "Default Feature Tolerance" topic.

  • Selecting the Decimal Place option enables the Default Tolerances area, allowing you to define dimension tolerances based on the number of decimal places. This is the old way that PC-DMIS determined dimension tolerances. See "Default Tolerances" topic.


Default Feature Tolerance

Default Feature Tolerance area

The Default Feature Tolerance area, enabled when you select the Feature Type option from the Apply Defaults Based On area, lets you define default dimension tolerances based on individual feature types. Whenever PC-DMIS creates a dimension automatically, either because the Auto option is selected in the Location dialog box or because you used the Auto Dimension Setup... button, the default dimension tolerance associated with that feature type will be used.

Item | Description
Type list | This list displays all the features for which you can set a default tolerance.
Tolerance box | This box defines the default tolerance used for the feature in the Type list.
Apply All button | This button lets you apply the current tolerance value in the Tolerance box to all feature types.


Auto Stats

Auto Stats area

ALWAYS Save Stats to File check box | The ALWAYS Save Stats to File check box allows you to bypass the prompt asking you to save stats data that appears whenever execution of a part program starts with a valid STATS/ON command. The statistical data will automatically be saved to the XSTATS11.tmp file if this option is check marked and a STATS/ON command exists in the part program when it is executed. See the "Tracking Statistical Data" section for more information.
ALWAYS Update Database check box | The ALWAYS Update Database check box allows PC-DMIS to update your statistical database software with the information in the XSTATS11.tmp file without the prompt asking to update the database now every time the part program is executed and statistical data is collected and saved. If this option is not check marked, PC-DMIS will continue displaying this prompt before updating the database software. See the "Tracking Statistical Data" section for more information.


Features Use Dimension Colors

The Features Use Dimension Colors check box tells PC-DMIS to color features that have an associated dimension. Features are drawn in the Graphics Display window with the same colors that the dimension uses to indicate deviation from the theoretical values.


CAD Nominal Places =

The CAD Nominal Places = box allows you to enter a numerical value that defines how many decimal places PC-DMIS will use before rounding when it uses CAD data. For example, if a CAD circle has a diameter of 3.9995, and the value is set to 3, PC-DMIS will round its value to 4.000. This option only affects the way PC-DMIS interprets CAD data in the SHEET METAL MEASUREMENT mode. If the value is set to 0, PC-DMIS will not round off any values.


Minus Tols Show Negative

The Minus Tols Show Negative check box controls whether or not the minus tolerances of the dimensions will be displayed with a minus sign. For example, if the dimension is specified as 5.0000 +0.3 (upper tolerance), -0.2 (lower tolerance), the dimension line may be displayed as follows if this check box is selected:

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
Y | 5.0000 | 0.3000 | -0.2000 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000

If this check box is cleared, the same example may be displayed as follows:

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
Y | 5.0000 | 0.3000 | 0.2000 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000

This check box does not affect how the values are stored or used in calculations. It only controls how the values are displayed according to user preference. This check box is not selected by default.

Important: If you have this check box cleared, you can still have a tolerance with a minus sign in front of it. Under usual circumstances, your lower and upper limits are on opposite sides of the nominal and without this check box selected will be shown as positive values. However, if the upper limit and lower limit are both greater than the nominal—for example, your values actually read +TOL 0.03 and –TOL –0.02 before using this check box—then your minus tol value shows a positive value when you select this check box.


Number of Decimal Places

Display Menu Roadmap

Number of Decimal Places area

The Number of Decimal Places area controls the number of decimal places printed on the inspection report by PC-DMIS

  • If the unit type is inch, the available options are one through five.

  • If the unit type is mm, the available options are zero through four.

Choose the desired option to determine the number of decimal places that will be printed.

Each time this is changed in a program PC-DMIS places a command: DISPLAYPRECISION/ # into the part program. This specifies the precision to be displayed at this section of the program. If this command is not used then the default value is automatically used. If this command is used the precision will stay as specified unless changed by another instance of the command.


Default Tolerances

Default Tolerances area

The Default Tolerances area, enabled when you select the Decimal Places option from the Apply Defaults Based On area, lets you define the default tolerances PC-DMIS will use when you modify a dimension's nominal value in the Edit window. The default tolerance used is based off of the number of decimal places in the nominal value.

For example, if you modify a nominal value to read 6.250, PC-DMIS will set the + and - tolerance to the 3 Places = default tolerance value, because three decimal places were used. If you instead entered 6.25, PC-DMIS would set the + and - tolerance to the 2 Places = value, because two decimal places were used.

Item | Description
0-5 Places = boxes | These boxes allow you to set different default tolerances that PC-DMIS will apply when you define a nominal value with 0 to 5 decimal places.


Positive Reporting

Display Menu Roadmap

The check boxes related to the Positive Reporting area control the reporting of features to the negative side of the origin that would normally have negative values to always be printed with positive values.

  • The X, Y, and Z check boxes determine on which axis (or axes) PC-DMIS will display positive numbers.

  • The All Data option tells PC-DMIS to display the measured and nominal values of the selected axis (or axes) as positive numbers.

  • The Deviations Only option tells PC-DMIS to display only the deviations of the selected axis (or axes) as positive numbers.

When these check boxes are selected, a POSITIVEREPORTING command is inserted into the part program at the current cursor position. This command has the following format in the Edit window:

POSITIVEREPORTING/ a, b, c, TOG1

Where:

a = X when the X check box is selected, or blank if the X check box is cleared.

b = Y when the Y check box is selected, or blank if the Y check box is cleared.

c = Z when the Z check box is selected, or blank if the Z check box is cleared.

TOG1 = ALLDATA or DEVONLY depending on whether you selected the All Data or Deviations Only option.

The X, Y, and Z direction may each have positive reporting turned on in any combination of the three. Multiple POSITIVEREPORTING commands may be used within the same part program, and any dimensions that are in the part program are displayed using the POSITIVEREPORTING command that precedes the dimensions. If no POSITIVEREPORTING command exists in the part program, all dimensions are reported with the options turned OFF in the X, Y, and Z directions.

The following diagram demonstrates how the tolerances are also affected by the positive reporting options:

Positive Reporting affecting tolerances

A) 0.3 +tol in X

B) 0.1 -tol in X

C) 0.2 deviation in X

D) Point 1

E) Point 2

F) 1.0 nominal

Purpose of Positive Reporting

Positive reporting allows you to report features in a symmetric manner, so that, regardless of which side of the origin the feature exists, deviations:

  • away from the origin are considered positive.

  • toward the origin are considered negative.

Thus, in the diagram above, both Point1 and Point2 will display positive deviations when positive reporting in the X axis. This also means, however, that:

  • plus tolerances are applied away from the origin.

  • minus tolerances are applied toward the origin.


Display Angle Degrees

Display Angle Degrees area

The Display Angle Degrees area allows you to display angle dimensions using decimal degrees or by degree/minute/second. Simply select the desired option. Any PA Location axes and Angle dimensions will change to display the selected option.


Angle Degrees

Angle Degrees area

The Angle Degrees area will also allow you to display the angle dimension from 0° -360° or 0° to +/- 180°. Any PA Location axes and Angle dimensions will change to lie within the selected angle degree range.


Auto Dimension Setup

The Auto Dimension Setup button opens the Auto Dimensioning dialog box.

Auto Dimensioning dialog box

Auto Dimensioning dialog box

This dialog box provides you with several options that allow you to determine whether or not PC-DMIS automatically dimensions features immediately after creating them and how it should create those dimensions.

To enable automatic dimension creation, select Auto Form Dimensions and/or Auto Location/Position Dimensions. After clicking OK PC-DMIS will then automatically begin creating the selected dimension type when you create features.

See the following table for information on the available options:

Dialog Box Option

Description

Auto Form Dimensions

This check box determines whether or not PC-DMIS automatically creates form dimensions for feature types that have a form dimension.

Feature | Associated Form Dimension
Circle | Roundness
Cylinder | Roundness
Cone | Roundness
Sphere | Roundness
Plane | Flatness
Line | Straightness

Auto Location/Position Dimensions

This check box determines whether or not PC-DMIS automatically creates location or position dimensions for feature types that have a location or position dimension.

Create Location Dimensions

If you select Auto Location/Position dimensions, this option button tells PC-DMIS to create those dimensions as Location dimensions.

Create True Position Dimensions

If you select Auto Location/Position dimensions, this option button tells PC-DMIS to create those dimensions as True Position dimensions.

Auto Textual Analysis ON

This check box controls whether or not PC-DMIS will automatically create textual analysis of the dimension. It is considered ON if the box is marked. See "Analysis Settings" in the "Dimensioning Features" section and "Analysis" in the "Inserting Report Commands" section.

Auto Graphical Analysis ON

This check box controls whether or not PC-DMIS will automatically create a graphical analysis of any dimension that is created with Auto Create Dimensions or Auto Roundness. See "Analysis Settings" in the "Dimensioning Features" section and "Analysis" in the "Inserting Report Commands" section.

Auto Dimension Info

This check box controls whether or not PC-DMIS will automatically create a Dimension Information check box for any dimension created with the Auto Create Dimensions check box or the Auto Roundness check box. See "Inserting Dimension Info Boxes" in the "Inserting Report Commands" section for information on how to set the default formats for this Dimension Info boxes.

Multiply

The Multiply value is a scaling factor that magnifies the arrow and tolerance zone for the graphical analysis mode. If a value of 2.0 is entered, PC-DMIS will scale the arrow two times the graphical image.

The Multiply box is used for viewing purposes only, and is not reflected in the text printout.

Note: PC-DMIS creates dimensions as either legacy dimensions or Feature Control Frame dimensions depending on whether or not a check mark exists next to the Use Legacy Dimensions menu option from the Insert | Dimension submenu.


Setup Options: ID Setup tab

 General Part Machine Dimension NC-100 Setup OK button Cancel button Default button Help button

Generic is the only method available for identifying alignments.

Generic is the only method available for identifying comments.

Dimensions can be identified using either the Generic or By Type method. If the By Type method is used, identifications can be similar to each dimension type, or different based on individual need.

Features can be identified using either the Generic or By Type method.

If the By Type method is selected, the color used to display the feature ID can also be altered.

If the Show All ID check box is selected and you click Apply, PC-DMIS will display all feature ID labels in the Graphics Display window for all features from the current cursor location to the end of the part program. Newly created features will also show their ID. If this check box is deselected and you click Apply, all features IDs from current cursor location to the end of the part program are hidden. Newly created features still get created in the Edit window, but the ID label doesn't appear in the Graphics Display window.

If the Color option is selected (marked) all features created after the Apply button is pressed will be effected. (Features created prior to the color change will not be replaced.)

Generic is the only method available for identifying labels.

Generic is the only method available for identifying variables.

Generic is the only method available for identifying Called Subroutines.

By Type lets you set the identification for each element type (circle, cone, cylinder, line, plane, point, and sphere).

Generic will apply the same identification system regardless of feature (dimension) type.

PC-DMIS has no inherent limit on the number of letters used for identifications. However, the Graphic Display area and Edit window have limits on the ID length. Even if the Edit window does not show the complete ID, PC-DMIS will internally keep track of the complete identification.

For example:
ID Length = 10, ID Letters = CIRCLE.
PC-DMIS will generate an ID = CIRCLE0001, etc. This is done only if the Length is set.

For example:
F1[3]=POINT MEASURED FROM 1 HIT

Shows that the feature, F1, is measured here for the third (designated by the number three in brackets) time.

The format of the bracketed expression can be controlled using the array_indices object. See "Array Indices Object" in the "Using Expressions and Variables" section.

Setup Options: ID Setup tab

Display Menu Roadmap

Setup Options dialog box—ID Setup tab

It is important to keep track of IDs already set when changing an identification. It is possible to have ID duplication through multiple changes to this option.

The ID Setup tab allows you to alter the format used to identify alignments, dimensions, features, comments, labels and variables.

To access this option:

1. Access the Setup Options dialog box (Edit | Preferences | Setup).

2. Select the ID setup tab.

The default ID Setup option is Generic. As each feature is created, PC-DMIS will assign it an ID beginning with the letter F, followed by a number (incrementally set from the starting number of one). You may choose to override this setting by selecting the following options:

Item

Description

Labels For list

The Labels For drop-down list allows you to select the identification that will be used for alignments, dimensions and features. (See "Labeling Method")

Alignments ID

Comments ID

Dimensions ID

Features ID

Labels ID

Variables ID

Call Subs ID

Labeling Method list

This drop down window allows you to select between By Type and Generic identification methods.

By Type

Generic

Starting Letters box

The Starting Letters box determines the first letter(s) that will be used in the identification process. PC-DMIS will always display the ID using capital letters. Up to 15 characters can be typed in.

Note: In various dialog boxes where the ID is displayed, changing the text portion of the ID the default text of the ID may also be set.

Starting Number box

The Starting Number box determines the first number that will be used in the identification process. Any number between 1 and 9999 can be entered.

Note: In various dialog boxes where the ID is displayed, changing only the number portion of an ID the counter may be reset to a desired count

Label Length check box

The Label Length check box determines the length of the identification. Up to 15 digits may be entered. The check box must be selected in order for this option to be active. If this length is set, PC-DMIS will append zeros to the ID letters to make up the necessary length.

Display Brackets for Feature Arrays check box

The Display Brackets for Feature Arrays check box determines whether array brackets are displayed with IDs for commands executed more than once.

When selected, the inspection report displays which instance of the command's execution is being referenced.

Apply button

The Apply button applies the changes described in "Labeling Method") to any feature identifications. These changes only apply to feature IDs.

If the Apply button is not pressed, PC-DMIS will continue to assign feature identifications using the previous method listed.

Note: If duplicate IDs are assigned, PC-DMIS will notify you that you must have a unique ID for any feature, dimension etc.

Default button

The Default button allows you to update the default settings to all of the ID Setup parameters. When a new part program is created, it will reflect any changes made to the parameters, only if the Default button is clicked.

For additional information on Default buttons, see the "Default" topic in the "Navigating the User Interface" section.

Note: Always press the Apply button after a change is made (before pressing the OK or Default buttons).


Setup Options: NC-100 Setup tab

Display Menu Roadmap

SetUp Options dialog box—NC-100 tab

The NC-100 tab (Edit | Preferences | Setup) allows you to use a NC-100 video probe. Once the Use NC-100 Video Probe check box is selected, the TCPIP Address, Port Number, and Computer Name boxes become available. Use these boxes to set up communication settings with the NC-100 computer system. These values are stored in the registry settings and are recalled each time you start PC-DMIS. See the "Modifying Registry Entries" section.

For information on using the NC-100 Video Probe to create Auto Features, see the appropriate section in the PC-DMIS Vision documentation.

Note: The NC-100 tab only appears in PC-DMIS if your portlock is programmed to accept CMT functionality.

Item | Description
Use NC-100 Video Probe check box | The Use NC-100 Video Probe check box determines if PC-DMIS is using the NC-100 video probe. If you select this check box, PC-DMIS assumes that the NC-100 is active.
TCPIP Address box | Use the TCPIP Address box to enter the address information for the NC-100 computer system. This value is required for the communication between the PC-DMIS computer system and the NC-100 computer system.
Port Number box | Use the Port Number box to enter the port number of the NC-100 computer system. This value is required for the communication between the PC-DMIS computer system and the NC-100 computer system.
Computer Name box | Use the Computer Name box to type the name of the NC-100 computer system. This value is required for the communication between the PC-DMIS computer system and the NC-100 computer system.


SetUp Options: Sound Events tab

Display Menu Roadmap

SetUp Options dialog box—Sound Events tab

The Sound Events tab (Edit | Preferences | Setup) contains a list of application events that you can associate with a sound file of your choice. When the event occurs, PC-DMIS automatically plays the associated sound.

Item | Description
Application Events list | This list shows the application events to which you can associate sound files.
Sounds box | This box lists the pathway to the sound file for the selected application event.
 | This button tests the specified sound file.
Browser... button | This button lets you browse to and select a sound file for the selected application event.

Associating a Sound File

To associate a custom sound file with an event:

  1. Select the event from the Applications Events list.

  2. Click the Browser... button.

  3. Navigate to the directory containing your sound file. PC-DMIS only supports the playing of .wav files.

  4. Select the .wav file and click Open. The Sounds list box displays the pathway to the selected sound file.

  5. Test the file by pressing the Play button.

  6. Click OK to save your changes.

Removing a Sound File

You can remove an associated sound file from an event. To do this:

  1. Select the event from the Applications Events list.

  2. Click the Sounds list box.

  3. Select (NONE). PC-DMIS removes the speaker icon to the left of the event, indicating that the event no longer is tied to a sound file.

  4. Click OK to save your changes.


Modifying Report and Motion Parameters

Display Menu Roadmap

The Edit | Preferences | Parameters menu option allows you to modify the content, form, and method of calculation used in any report. Additionally, it allows you to modify the machine motion parameters of a DCC CMM. This menu option opens the Parameter Settings dialog box.

In addition to accessing the Parameter Settings dialog box, you can insert the commands from this dialog box directly into the part program by selecting them from the Insert | Parameter Change submenu.

The following tabs are available on the Parameter Settings dialog box.

  • Parameter Settings: Dimension tab

  • Parameter Settings: ClearPlane tab

  • Parameter Settings: Probing tab

  • Parameter Settings: Motion tab

  • Parameter Settings: Rotate Table tab

  • Parameter Settings: Acceleration tab

  • Parameter Settings: Optional Probe tab

  • Parameter Settings: Probe Trigger Options tab

  • Parameter Settings: NC-100 Parameters tab

  • Parameter Settings: I/O Channels tab


 Default Output Format area Standard Deviation check box Deviation Symbols check box Dimension Headings check box Dmension Options check box OK button Cancel button I/O Channels NC-100 Parameters Probe Trigger Options Opt. Probe ClearPlane Acceleration Probing Motion Dimension Text check box RoTable Apply button Help button Recall button Clear button

Parameter Settings: Dimension tab

Display Menu Roadmap

The Dimension tab allows you to vary the format of the dimension output. It also provides a means for altering the printed report.

To access the Dimension tab:

  1. Access the Parameter Settings dialog box (Edit | Preferences | Parameters).

  2. Click the Dimension tab.

More:

D imension Output Format

Dimension Text

Dimension Options

Dimension Headings

Deviation Symbols

Standard Deviation


Dimension Output Format

This command controls the PC-DMIS dimension output format. To change the format, select the desired Format check box(es).

Available Formats: | Description
Nominal | Displays the nominal value for all dimensions.
Tolerance | Displays the tolerance values for all dimensions.
Measured | Displays the measured value for all dimensions.
MaxMin | Displays the max and min values for all dimensions.
Deviation | Displays the deviation value for all dimensions.
Out of Tol | Displays the out of tolerance value for all dimensions.
Dev Angle | Displays the deviation angle on the True Position dimensions.

When switching from box tolerancing to true position (and back), it is important to check the format for correctness.

PC-DMIS offers the same print formats for box tolerancing and true positioning tolerancing, although their columns will look slightly different due to additional columns for true position dimensions.

Example: When tolerancing the distance between two lines with the Max/Min check box selected, PC-DMIS will calculate the distance between the two points that were furthest apart or the two points that were closest together. It would then choose the worst case (most out of tolerance) of the two. If the Max/Min check box is not selected, PC-DMIS will calculate the dimension without displaying the Max/Min value.

PC-DMIS will indicate the order of the output selection by displaying a number to the right of the check box. This allows you to alter the order of the format to meet individual needs. A check box can be cleared simply by selecting it a second time.

The Edit window command line for this option reads:

FORMAT/TEXT,OPTIONS,HEADINGS,SYMBOLS, SD; "DIMENSION OUTPUT"

DIMENSION OUTPUT = The format of the output will be based on the order of selection. The default output will display the entire selection, in the order indicated.


Dimension Text

The Dimension Text check box controls whether or not the dimension text will be displayed in the Edit window for any dimensions that follow the command.

The Edit window command line for this option reads:

FORMAT/TEXT, , , , ;NOM,TOL,MEAS,MAXMIN,DEV,OUTTOL,DEVANG

For a description the options on this command, see "Dimension Output Format".


Dimension Options

The Dimension Options check box controls whether or not the dimension options will be displayed in the Edit window for any dimensions that follow the command.

These options include:

· Units (see "Units" in the "Dimensioning Features" section)

· Graphical analysis (see "Analysis Settings" in the "Dimensioning Features" section)

· Textual analysis (see "Analysis Settings" in the "Dimensioning Features" section)

· Arrow multiplier (see "Analysis Settings" in the "Dimensioning Features" section)

· Output options (see "Analysis Settings" in the "Dimensioning Features" section)

The Edit window command line for this check box reads:

FORMAT/OPTIONS, , , , ;NOM,TOL,MEAS,MAXMIN,DEV,OUTTOL


Dimension Headings

The Dimension Headings check box controls the column headings on the inspection report. If this check box is not selected, then PC-DMIS will not print any column headings.


Deviation Symbols

The Deviation Symbols check box shows the deviation within the set range. If the out of tolerance range is high, PC-DMIS will indicate the deviation using the "greater than" symbol (>) on the right side of the line. If the out of tolerance range is low, PC-DMIS will indicate the deviation using the "less than" symbol (<).

For example:
Nominal = 0.00
Measured = 0.02
Positive Tolerance = 0.10
Negative Tolerance = 0.20
Total Tolerance Range = (.10 - (-.20)) = .30
Percentage = 100*(.02 - (-.20))/.3 = 73.3 %
- - - - - - # - - looks at the % and shifts based on the %.

DIM D1= LOCATION OF CIR F5 GRAPH=OFF TEXT=OFF MULT=1.00

AX | NOM | +TOL | -TOL | MEAS | DEV | OUT-TOL |
x | 5.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | ----#----
y | 2.0000 | 0.0100 | 0.0100 | 2.0000 | 0.0000 | 0.0000 | ----#----
z | -0.2500 | 0.0100 | 0.0100 | -0.2500 | 0.0000 | 0.0000 | ----#----
d | 2.0000 | 0.0100 | 0.0100 | 2.0000 | 0.0000 | 0.0000 |
v | i | j | k |  |  |  |

END OF DIMENSION D1


Standard Deviation

The Standard Deviation check box displays the standard deviation of features.


Parameter Settings: ClearPlane tab

 OK button Cancel button I/O Channels NC-100 Parameters Probe Trigger Options Opt. Probe Dimension Acceleration Probing Motion RoTable Apply button Help button

The Active Plane area defines the plane (or axis) in which features lie when they are measured. The Value box defines the clearance plane as an offset distance in the current units of measurement away from the specified plane. To define a clearance plane, select the plane from the Axis list, then enter a new value in the Value box.

The Pass Through Plane defines a clearance plane that the probe will move to and then pass through to get to the next active clearance plane following a probe's TIP command. The new CLEARP definition command must immediately follow the TIP command to properly define the pass through plane. When PC-DMIS encounters the next MOVE/CLEARPLANE command, it will move to the pass through plane and remain at that offset distance until it reaches the next active clearance plane.

If you select the Clearance Plane Active (ON) check box PC-DMIS will automatically insert a MOVE/CLEARPLANE command before any Measured Features or Auto Features inserted into the Edit window from that point on.

Be aware of the sign of a clearance plane when entering its distance value. The sign must correspond to the positive or negative end of the normal axis defining the plane. For example, to define a top clearance plane, enter a positive value, and to define a bottom clearance plane, enter a negative value.

Movement from one clearance plane to another affects the position of the probe. Make sure that the set clearance plane is sufficient to clear the part.

A clearance plane is defined relative to the current coordinate system and part origin. Therefore, you must be careful when defining a clearance plane to ensure adequate clearance around the part.

Clearance Plane Example

Using the above drawing, suppose your part is ten inches long, and it is lined up close to the machine axes with the X origin at the bottom left-hand corner. You can set a one inch clearance from the right side of the part by setting the XPLUS clearance plane to 11 inches.

Always define clearance planes relative to the current coordinate system. When you create a new coordinate system, the clearance planes still relate to the first alignment. If you wish to associate the clearance planes with the new coordinate system, they must be redefined.

Clearance planes are not used when taking sample hits. It is therefore important when measuring pins to set the spacer value to a distance that will allow the probe to move around the pin.

You can insert MOVE/CLEARPLANE commands between auto features' HIT/BASIC commands. You will need to use the Insert | Move | Move Clearplane menu item to do this. Copying and pasting this command will not work. The Edit window must also be in Command mode.

Consider this example:

TIP/T1A0B0, SHANKIJK=0, 0, 1, ANGLE=0

CLEARP/ZPLUS,2,ZPLUS,0,ON (New clearance plane defined)

PLN1 =FEAT/PLANE,CARTESIAN,TRIANGLE

THEO/<0.3597,0.3544,-0.8268>,<0,0,1>

ACTL/<0.3597,0.3544,-0.8268>,<0,0,1>

MEAS/PLANE,3

MOVE/CLEARPLANE (Probe moves to the defined clearance plane)

HIT/BASIC,NORMAL,<0.2346,0.6411,-0.8268>,<0,0,1>,<0.2346,0.6411,-0.8268>,USE THEO = YES

HIT/BASIC,NORMAL,<0.2034,0.2502,-0.8268>,<0,0,1>,<0.2034,0.2502,-0.8268>,USE THEO = YES

HIT/BASIC,NORMAL,<0.6412,0.172,-0.8268>,<0,0,1>,<0.6412,0.172,-0.8268>,USE THEO = YES

ENDMEAS/

CON2 =FEAT/CONE,CARTESIAN,IN,LENG

THEO/<8.9134,0.4921,-0.9193>,<0,0,-1>,0.3964,0.5906,0.5906

ACTL/<8.9134,0.4921,-0.9193>,<0,0,-1>,0.3964,0.5906,0.5906

MEAS/CONE,8

MOVE/CLEARPLANE (Probe moves to the defined clearance plane)

HIT/BASIC,NORMAL,<9.2087,0.4921,-0.9193>,<-1,0,0>,<9.2087,0.4921,-0.9193>,USE THEO = YES

HIT/BASIC,NORMAL,<8.9134,0.7874,-0.9193>,<0,-1,0>,<8.9134,0.7874,-0.9193>,USE THEO = YES

HIT/BASIC,NORMAL,<8.6181,0.4921,-0.9193>,<1,0,0>,<8.6181,0.4921,-0.9193>,USE THEO = YES

HIT/BASIC,NORMAL,<8.9134,0.1969,-0.9193>,<0,1,0>,<8.9134,0.1969,-0.9193>,USE THEO = YES

HIT/BASIC,NORMAL,<9.2087,0.4921,-1.3158>,<-1,0,0>,<9.2087,0.4921,-1.3158>,USE THEO = YES

HIT/BASIC,NORMAL,<8.9134,0.7874,-1.3158>,<0,-1,0>,<8.9134,0.7874,-1.3158>,USE THEO = YES

HIT/BASIC,NORMAL,<8.6181,0.4921,-1.3158>,<1,0,0>,<8.6181,0.4921,-1.3158>,USE THEO = YES

HIT/BASIC,NORMAL,<8.9134,0.1969,-1.3158>,<0,1,0>,<8.9134,0.1969,-1.3158>,USE THEO = YES

ENDMEAS/

CIR1 =FEAT/CIRCLE,CARTESIAN,IN,LEAST_SQR

THEO/<6.0827,3.1693,-0.012>,<0,0,1>,0.5906

ACTL/<6.0827,3.1693,-0.012>,<0,0,1>,0.5906

MEAS/CIRCLE,4,WORKPLANE

MOVE/CLEARPLANE (Probe moves to the defined clearance plane)

HIT/BASIC,NORMAL,<6.378,3.1693,-0.012>,<-1,0,0>,<6.378,3.1693,-0.012>,USE THEO = YES

HIT/BASIC,NORMAL,<6.0827,3.4646,-0.012>,<0,-1,0>,<6.0827,3.4646,-0.012>,USE THEO = YES

HIT/BASIC,NORMAL,<5.7874,3.1693,-0.012>,<1,0,0>,<5.7874,3.1693,-0.012>,USE THEO = YES

HIT/BASIC,NORMAL,<6.0827,2.874,-0.012>,<0,1,0>,<6.0827,2.874,-0.012>,USE THEO = YES

ENDMEAS/

CLEARP/YMINUS,-3,ZPLUS,2,ON (New clearance plane defined, this time with a pass through plane)

TIP/T1A90B-180, SHANKIJK=0, -1, 0, ANGLE=180

CIR2 =FEAT/CIRCLE,CARTESIAN,IN,LEAST_SQR

THEO/<4.8819,0,-0.5906>,<0,1,0>,1.2362

ACTL/<4.9445,15.8342,-0.5906>,<0,0,1>,31.4282

MEAS/CIRCLE,4,WORKPLANE

MOVE/CLEARPLANE (Probe travels through the Pass Through Plane in ZPLUS to the YMINUS clearance plane)

HIT/BASIC,NORMAL,<4.8819,0.0623,-0.8406>,<-0.9999185,-0.012768,0>,<4.8224,0.0025,-0.8406>,USE THEO = YES

MOVE/CIRCULAR

HIT/BASIC,NORMAL,<5.1319,0.0623,-0.5906>,<-0.9999279,-0.012008,0>,<5.0733,0.0026,-0.5906>,USE THEO = YES

MOVE/CIRCULAR

HIT/BASIC,NORMAL,<4.8819,0.0623,-0.3406>,<-0.9999185,-0.012768,0>,<4.8224,0.0025,-0.3406>,USE THEO = YES

HIT/BASIC,NORMAL,<4.6319,0.0623,-0.5906>,<0.9999071,0.0136308,0>,<4.69,0.0041,-0.5906>,USE THEO = YES

ENDMEAS/

MOVE/CLEARPLANE

Click on the icon below to see the above example as it is executed:

See a brief demo on inserting and formatting a Text object

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

Parameter Settings: ClearPlane tab

Display Menu Roadmap

Parameter Settings dialog box—ClearPlane tab

The ClearPlane tab provides the means to define and add clearance planes. Clearance planes, in essence, create an envelope around a part where the probe will always travel when moving from one feature to another. PC-DMIS will move the probe out from the part a predetermined distance, relative to the coordinate system in which it was defined. After the last hit on the feature is measured, the probe will stay at probe depth until called to the next feature. This helps to reduce programming time because the need to define intermediate moves is minimized. In addition, using properly defined clearance planes can help protect your probe from accidental collisions with the part.

A sample part with an imaginary envelope from clearance planes

To use clearance planes:

  1. Access the Parameter Settings dialog box (Edit | Preferences | Parameters), then select the ClearPlane tab.

  2. Select the clearance plane using the Active Plane and Pass Through Plane areas, and specify the clearance distances using the respective Value boxes.

  3. Click OK to finish defining the clearance plane. PC-DMIS inserts a CLEARP command containing the clearance plane information into the Edit window. The finished command will look something like this:

CLEARP/ACTIVE_PLANE, n, PASS_THROUGH_PLANE, n,TOG1

ACTIVE_PLANE and PASS_THROUGH_PLANE refer to the axes selected. n refers to the offset distances specified. TOG1 is an ON/OFF toggle field determining whether or not the clearance plane is active and automatically used for newly created Measured and Auto Features.

  3. You can then insert MOVE/CLEARPLANE commands into your part program. When PC-DMIS encounters a MOVE/CLEARPLANE command, the probe will use the information from the CLEARP command above it in the Edit window and move to the specified distance away from the selected Active plane, moving through the Pass Through plane as appropriate prior to executing the next command.

Active Plane Area

Pass Through Plane Area

Clearance Plane Active (ON) Check Box

Notes on Clearance Planes

Code Example


 Polar Vector Compensation area Probe Compensation Active check box Active Tip Active Probe OK button Cancel button Dimension NC-100 Parameters Probe Trigger Options Opt. Probe ClearPlane Acceleration Motion IO Channels RoTable Apply button Help button

Parameter Settings: Probing tab

Parameter Settings dialog box—Probing tab

The Probing tab displays the current probe file, active tip, and probe slot (if being used). It also allows you to select the Probe Compensation Active (On) check box and select the Polar Vector Compensation from the drop-down list.

To access the Probing tab:

Display Menu Roadmap

  1. Access the Parameter Settings dialog box (Edit | Preferences | Parameters).

  2. Click the Probing tab from the available tabs.

More:

Active Probe

Active Tip

Probe Compensation

Polar Vector Compensation

Probe in Slot #


Active Probe

This line in the Probing tab displays the current probe file. See "Probe File Name" in the "Defining Hardware" section for more information on selecting a different probe file, or creating a new probe file name.


Active Tip

This line in the Probing tab displays the current active tip. See "Active Tip List" in the "Defining Hardware" section for more information on the displayed values and selecting, creating and deleting tips.

The Edit window command line for this option reads:
TIP/active_tip_name


Probe Compensation

Display Menu Roadmap

This option is only available while in DCC mode.

The Probe Compensation Active (On) check box allows PC-DMIS to compensate for the probe radius. If this option is on, PC-DMIS will compensate for the probe radius on each feature it measures.

Command line in the Edit window:
PROBECOM/ON


Polar Vector Compensation

Display Menu Roadmap

The Polar Vector Compensation drop-down list allows the measurement of Vector and Surface points to always be compensated along a Polar vector. The following options are available:

  • OFF - Vector and Surface points behave normally.

  • XYPL - Vector compensations for each Vector and Surface point will be 2D in the XY plane along a vector from the point to the current origin.

  • YZPL - Vector compensations for each Vector and Surface point will be 2D in the YZ plane along a vector from the point to the current origin.

  • ZXPL - Vector compensations for each Vector and Surface point will be 2D in the ZX plane along a vector from the point to the current origin.

  • 3D - Causes a polar vector compensation along a 3D vector from the point to the current origin.

The Edit window command lines for these options read:
POLARVECTORCOMP/ OFF
POLARVECTORCOMP/ XYPL
POLARVECTORCOMP/ YZPL
POLARVECTORCOMP/ ZXPL
POLARVECTORCOMP/ 3D


Probe in Slot #

This option indicates the slot number on the probe changer of the probe or stylus currently being used. This option is only available if a probe changer has been setup.

If you aren't using a probe changer or if your current probe isn't in a probe changer then PC-DMIS displays text informing you that your current probe or stylus isn't in the probe changer or that a probe changer isn't being used.

See "Slots" under the "Setting Up Probe Changer Options" topic for information on adding probes or styli to a probe changer.


Parameter Settings: Rotate Table tab

 Rotation Direction list Rotary Table Angle box OK button Cancel button Dimension NC-100 Parameters Probe Trigger Options Opt. Probe ClearPlane Acceleration Motion IO Channels RoTable Apply button Help button

Parameter Settings: RoTable (Rotary Table) tab

Parameter Settings dialog box—RoTable tab

The RoTable tab allows you to rotate the current active rotary table by a defined angle and direction, or you can use it to automatically set the rotation based on a defined vector and a specified feature.

The RoTable tab becomes available when you select Single Rotary Table, Dual Rotary Tables, or Stacked Rotary Tables from the Rotary Table Setup dialog box. See "Defining the Rotary Table".

  1. Access the Parameter Settings dialog box (Edit | Preferences | Parameters). Display Menu Roadmap

  2. Select the RoTable tab.

  3. Choose to rotate by a specific angle or to rotate to a feature.

    • If by a specific angle, fill out Rotary Table W or Rotary Table V areas, defining the Angle and the Rotation Direction.

    • If to a specific feature, fill out the Auto set from Vector area.

  4. If you want to rotate the table immediately, select the Rotate the Table(s) check box.

  5. Click the Apply button. PC-DMIS inserts a MOVE/ROTAB command into the Edit window.

The Edit window command line for this option reads:
MOVE/ ROTAB, angle, DIRECTION

If you have a stacked configuration, the Edit window command line for this option will read:
MOVE/ ROTAB, angle, DIRECTION, agle2, DIRECTION2

Additionally, the Rotary Table Setup menu option is only available if your port lock is programmed for rotary tables.

More:

Rotary Table W / Rotary Table V

Auto Set from Vector

Rotate the Table(s)


Rotary Table W / Rotary Table V

Rotary Table W area and Rotary Table V area

The Rotary Table W area and the Rotary Table V area let you control up to two rotary tables, table W and table V. PC-DMIS activates the area associated with the currently active rotary table. If you have a stacked rotary configuration, PC-DMIS activates both areas allowing you to type the angle and define the rotation direction for both tables at the same time. See Defining the Rotary Table

These areas contain the same options:

Item

Description

Angle box

This defines the angle of the table's rotation.

Rotation Direction list

In the Rotation Direction drop down list you can select the direction you want the table to rotate. Available options are:

Clock Wise: Rotates the table in a clockwise direction until it reaches the angle entered in the Rotate Table Angle box.

Counterclockwise: Rotates the table in a counterclockwise direction until it reaches the angle entered in the Rotate Table Angle box.

Shortest: Rotates taking the shortest route (either Clockwise or Counterclockwise) until it reaches the angle entered in the Rotate Table Angle box.


Auto Set from Vector

Auto set from Vector area

This area remains unavailable for selection until you select the Stacked Rotary Tables option from the Rotary Table Setup dialog box. See "Defining the Rotary Table".

The Auto set from Vector area lets you select a feature from the Feature ID list. The active rotary table will automatically rotate to the best angle in order to make the probe normal to that feature.

Item | Description
Feature ID list | This contains all the features in the part program and allows you to choose the feature to which the table will rotate.
Target Vector IJK boxes | These boxes show the surface normal IJK for the selected feature. Alternately, you can type in your own IJK value. The rotary table will automatically rotate to be as close to normal as possible to the IJK contained in these boxes.


Rotate the Table

Rotate the Table(s)

The Rotate the Table(s) check box allows the current table's rotation to be activated by the specified Angle value once either the Apply or the OK button is pressed.


 Scan Speed Clamping Value Touch Speed Move Speed Check Percent Check Distance Retract Distance Prehit Distance OK button Cancel button Dimension NC-100 Parameters Probe Trigger Options Opt. Probe ClearPlane Acceleration Probing IO Channels RoTable Apply button Help button Default button Recall button Clear button

Parameter Settings: Motion tab

Parameter Settings dialog box—Motion tab

The Motion tab allows you to change the distances that the probe will be allowed to travel when taking a hit. It will also allow you to set the speed that PC-DMIS will use to take a hit and move from point to point.

Note: You can determine whether the speed boxes (Move Speed, Touch Speed, and Scan Speed) list the values as either mm/sec or as a percentage of the total allowed speed, by selecting or deselecting the Display Absolute Speeds check box in the Part / Machine tab of the Setup Options dialog box.

To edit information in the Motion tab:

Display Menu Roadmap

  1. Access the Parameter Settings dialog box (Edit | Preferences | Parameters).

  2. Click on the Motion tab. You'll see a variety of boxes.

  3. Highlight the value you want to change.

  4. Type a new value.

  5. Click Apply or OK.

To reset the motion values to the original factory setting, press the Recall button. The Recall button will return the displayed motion values to the values stored in the PC-DMIS Settings Editor. If the Defaults button is selected, the displayed values will be saved to the Settings Editor.

For information on the PC-DMIS Settings Editor, view the "Modifying Registry Entries" section.

Changing Animation Speeds: If you want to modify your offline animation speeds, see "Executing and Debugging Part Programs Off-Line" in "Working in Off-line Mode".

More:

Prehit Distance

Retract Distance

Check Distance

Check Percent

Move Speed %

Touch Speed %

Clamping Value

Scan Speed %


Prehit Distance

Display Menu Roadmap

The Prehit Distance box lets you enter the value for the machine prehit distance. This is the distance away from the surface where PC-DMIS starts searching for the part. If necessary, it can be automatically changed by PC-DMIS when taking hits within an arc or circle.

The Edit window command line for this option reads:
PREHIT/ nnn.nnnn


Retract Distance

Display Menu Roadmap

The Retract Distance box lets you enter the distance the probe retracts from the surface after taking a hit. If necessary, it can be automatically changed by PC-DMIS when taking hits on an arc or circle.

The Edit window command line for this option reads:
RETRACT/ nnn.nnnn


Check Distance

Display Menu Roadmap

The Check Distance box lets you enter the distance in either inches or millimeters (depending on the measurement system used for the part) past the theoretical hit location that the machine will continue to search for the surface of the part until it determines the surface is not there.

The Edit window command line for this option reads:
CHECK/distance,percentage

Percentage Movement During Find Hole Operations

When defining the check distance for a Find Hole operation, you can tell PC-DMIS to move by a percentage of the check distance.

To do this:

  1. Access the Edit window and place it in Command mode.

  2. Click on the CHECK command in the Edit window.

  3. Press the TAB key to move to the second number.

  4. Type a new percentage value. The default value is 1 which means 100% of the check distance. Thus .1=10%, .2=20%, .3=30% etc.

For example, in the following code:
CHECK/20,.3, the .3 value represents 30% of the total check distance of twenty units.

For additional information on Find Hole, see the "Find Hole Check Box" topic in the "Creating Auto Features" section:


Check Percent

The Check Percent value determines the percent of the total distance moved when performing a Find Hole operation. Be aware that if you type 1, the value is equal to 100 percent. Thus, 100% would be entered as 1, 25% would be entered as .25, and 10% would be .10.


Move Speed %

Display Menu Roadmap

The Move Speed box lets you change the point to point positioning speed of the CMM. The value that is entered is a percentage of the maximum machine speed. It can be set to any value between 1 and 100% of full machine speed. (See the "Measure" topic under "Defining Probes" in the "Defining Hardware" section for information regarding the move speed option and probe calibration.)

The Edit window command line for this option reads:
MOVESPEED/ nnn.nnnn


Touch Speed %

Display Menu Roadmap

The Touch Speed box lets you change the speed at which the CMM takes hits. The value that is entered is a percentage of the maximum machine speed, and cannot exceed twenty percent.

The Edit window command line for this option reads:
TOUCHSPEED/ nnn.nnnn

To understand the effects of changing either PREHIT or RETRACT distances and MOVE or TOUCH SPEED, it's important to understand how the options interact during DCC feature measurement. The order of events is that the machine will move toward the feature at MOVE SPEED. When it reaches PREHIT distance, it will approach the feature at TOUCH SPEED to take the hit. After it takes the hit, it will back away at TOUCH SPEED until it reaches the RETRACT DISTANCE. At this point, it will go to the next location at MOVE SPEED.


Clamping Value

Display Menu Roadmap

The Clamping Value only works with the Leitz controller and the Leitz brand TTP. This value tells the controller how firmly to hold the probe on a Leitz CMM.

Depending on the weight of the probe tips, you may need to increase or decrease the clamping value.

  • For a large tip weight, you may need to increase the clamping value.

  • For a small tip weight, you may need to decrease the clamping value.


Scan Speed %

The Scan Speed box lets you change the speed at which the CMM will scan the part. The value that is entered is a percentage of the maximum machine speed.

The Edit window command line for this option reads:
SCANSPEED/ nnn.nnnn

When scanning using the DEFINED mode of execution (see "Defined" discussed in the "Exec Controls area" topic in the "Scanning your Part" section), Scan Speed plays an important role in getting back data at increments specified by you. When you specify a very high Scan Speed, the CMM may execute the scan at the speed you requested, but the data from the CMM may not be spaced at the increments you specify.

Example: Assume the CMM gathers data at the rate of one Hit per 20 milliseconds in the DEFINED mode. If you specify an increment (minimum distance between hits) of 0.5 mm and a Scan Speed of 75 mm/sec, the CMM would give back points at every 1.5 mm. To avoid this you could reduce the Scan Speed to 15 mm/sec or 20 mm/sec which, at the rate of 1hit/20ms, would satisfy your requirements.

PC-DMIS will warn you about this case by displaying a message informing you that the supplied increment couldn't be measured at the specified scan speed. You will then be required to reduce your Scan Speed or increase the increment.

You can then select the Scan Speed setting and change to a suitable scan speed.


Parameter Settings: Acceleration tab

Parameter Settings dialog box—Acceleration tab

The Acceleration tab displays additional editing capabilities for both CMM and Table motion.

To access the Acceleration tab:

Display Menu Roadmap

  1. Access the Parameter Settings dialog box from the main menu (Edit | Preferences | Parameters).

  2. Select the Acceleration tab.

More:

CMM Acceleration


CMM Acceleration

Display Menu Roadmap

The CMM Acceleration area of the Acceleration tab allows you to change the maximum acceleration (at mm/sec2) along the X, Y, or Z axis of the CMM. Available options are:

Maximum X Axis Acceleration: | The number in this box represents the maximum acceleration that the CMM will take when traveling along the X axis.
Maximum Y Axis Acceleration: | The number in this box represents the maximum acceleration that the CMM will take when traveling along the Y axis.
Maximum Z Axis Acceleration: | The number in this box represents the maximum acceleration that the CMM will take when traveling along the Z axis.


Parameter Settings: Optional Probe tab

 Check Percent Clear button Recall button Default button Manual Fine Probing check box Probing Mode box Upper Force box Low Force box Positioning Accuracy box Trigger Force box Probing Accuracy Max Force box # Return Data box Return Speed box OK button Cancel button Dimension Probe Trigger Options NC-100 Parameters ClearPlane Acceleration Probing IO Channels RoTable Apply button Help button Motion

Parameter Settings: Opt. Probe (Optional Probe) tab

Parameter Settings dialog box—Opt. Probe tab

The Opt. Probe tab gives you additional capabilities for controlling analog probes. These capabilities include the following probing related values:

  • Max Force

  • Low Force

  • Upper Force

  • Trigger Force

  • # Return Data

  • Return Speed

  • Positioning Accuracy

  • Probing Accuracy

  • Probing Mode

  • Manual Fine Probing

It also includes the following Scan related values and general purpose buttons:

  • Point Density

  • Offset Force

  • Acceleration

  • Default button

  • Recall button

  • Clear button

Each of these is described below in greater detail.

To access the Opt. Probe tab:

Display Menu Roadmap

  1. Access the Parameter Settings dialog box from the main menu (Edit | Preferences | Parameters).

  2. Select the Opt. Probe tab.

Caution: The values on the Opt. Probe tab are machine specific. With the exception of the Manual Fine Probing check box and the Point Density box, they generally shouldn't be changed. Check with your machine's manufacturer before making changes.

Clicking Apply or OK on the Opt. Probe tab inserts an OPTIONPROBE command into the Edit window.

For information on using the OPTIONPROBE command with analog probes during calibration, see the "Notes on SP600 Upper Level Matrix (Regular Calibration):" topic in the "Defining Hardware" section.

More:

Max Force

Low Force

Upper Force

Trigger Force

# Return Data

Return Speed

Positioning Accuracy

Probing Accuracy

Probing Mode

Manual Fine Probing

Point Density

Offset Force

Acceleration


Max Force

The Max Force box allows you to enter the maximum force that a probe will take before an error occurs, thus stopping measurement.

A "newton" is a unit of force. One newton is the force needed to accelerate a mass of 1 kilogram to a speed of 1 meter per second per second.

During an analog probing cycle, when the probe first touches the part it continues to move into the part until it reaches this Max Force value. It then reverses direction and moves away from the part. This movement into the part, after touching the part, is sometimes referred to as the contact force. The value is specified in newtons. In a normal deflection mode (DFL) probing cycle, the controller collects data as the probe moves away from the part.


Low Force

The Low Force box allows you to enter the minimum force required to determine when the machine is in contact with the object being measured.

For a normal deflection mode (DFL) probing cycle, this is the force at which the controller stops collecting data. The value is specified in newtons.


Upper Force

The Upper Force box is the upper limit for a measurement. When this force is reached the machine moves back, away from the object being measured.

For a normal deflection mode (DFL) probing cycle, this is the force at which the controller starts collecting data. The value is specified in newtons.


Trigger Force

The Trigger Force box allows you to enter the force at which a measurement reading is taken.

For a normal deflection mode (DFL) probing cycle, this is the force at which the Actual Point (APT) will be calculated and returned to PC-DMIS. The value is specified in newtons. Not all analog probes/controllers use this input.


# Return Data

The # Return Data box allows you to enter the number of readings taken when the machine is moving away from the object being measured.

This value defines the minimum number of data to be collected within the probing window defined by the Upper Force and Lower Force values.


Return Speed

The Return Speed box allows you to set the value, which determines the speed at which the probe comes off the object being measured. This is specified in mm/sec.


Positioning Accuracy

The Positioning Accuracy box is a parameter specific to the Leitz interface. The value submitted tells the CMM how carefully it should remain on the approach vector as the probe is moved into the part for a measurement.

With smaller values the difficulty for the machine to acquire the desired location increases. However, using a smaller value provides a more accurate measurement. This value is always in millimeters.

This should normally be left at the default value.


Probing Accuracy

The Probing Accuracy box allows you to determine the accuracy required to take a measurement. If this value is not met then no measurement is taken and an error is given. It is specified in mm and should normally be left at the default value.


Probing Mode

This specifies the type of probing cycle used. The most common cycle is deflection mode (DFL). Other cycles, such as soft probing (SFT), may also be supported by some analog probes/controllers. In some cases the probe /controller may not have multiple modes and this value is ignored.


Manual Fine Probing

If the Manual Fine Probing check box is selected, then when a manual probing point is taken, the controller automatically switches to DCC mode while moving away from the part in order to use the normal deflection probing cycle. This may result in slower manual probing but improves accuracy.

While recent machines with analog probing systems may support Manual Fine Probing, not all analog probes/controllers support this mode of manual probing. In those cases, PC-DMIS ignores this check mark. Your CMM controller's manufacturer will know if your controller supports this option.


Point Density

The Point Density box allows you to set the number of readings to take per millimeter of measurement during a scan.

If you give a scan increment smaller than the Point Density defined in the registry entry in the Settings Editor, PC-DMIS will display a warning explaining that the minimum increment is smaller than Point Density for scans. You will then be asked to verify increment settings in the dialog box.

You can then change the scan's Point Density value to a suitable number.


Offset Force

This allows you to specify what level of force to maintain during a scan. The value is specified in newtons.


Acceleration

This allows you to specify what acceleration to use during a scan. The value is specified in mm/sec/sec.


 Manual Point Trigger Tolerance area Sample Plan Auto Trigger area AutoTrigger area OK button Cancel button Dimension Opt. Probe NC-100 Parameters ClearPlane Acceleration Probing IO Channels RoTable Apply button Help button Motion

Parameter Settings: Probe Trigger Options tab

Parameter Settings dialog box—Probe Trigger Options tab

The Probe Trigger Options tab allows you to determine tolerance zones and then insert AUTOTRIGGER, TRIGGERTOLERANCE, and TRIGGERPLANE commands into the Edit window. These commands trigger a hit when certain conditions are met.

Note: Only manual CMM machines with certain interfaces support these probe trigger options. These interfaces currently include: BackTalk, Faro, Romer, Garda, GOM (Krypton), Axila, Leica, Polar, and SMXLaser.

To access this tab:

Display Menu Roadmap

  1. Access the Parameter Settings dialog box from the main menu (Edit | Preferences | Parameters).

  2. Select the Probe Trigger Options tab.

Supported Features

These trigger commands function with these supported features:

Auto Features: Circle, Ellipse, Edge Point, Round Slot, Square Slot, Notch Slot, and Polygon

Measured Features: Circle, Line, and Round Slot

In addition, the AUTOTRIGGER command supports the Auto Vector Point feature and the Measured Point feature.

More:

AutoTrigger area

Sample Plane Auto Trigger area

Manual Point Trigger Tolerance area


AutoTrigger area

Display Menu Roadmap

With the AutoTrigger area you can insert AUTOTRIGGER/ commands into the Edit window with a tolerance zone.

The AUTOTRIGGER/ command tells PC-DMIS to automatically take a hit when the probe enters a tolerance zone at a specified distance from the original hit location. For example, if the tolerance zone, the Radius value, is set to 2 mm, a hit is taken when the probe is within 2 mm of the hit location.

You can use this option with manual machines; instead of pressing a button to take a hit, you can place AUTOTRIGGER/ commands at any standard location in the Edit window.

On

Selecting On check box activates the autotrigger command. Commands in the Edit window that follow the inserted AUTOTRIGGER/ command and require you to take a hit will then have the hit automatically taken when the probe enters the defined tolerance zone.

If you do not select this check box and you click the Insert Command button, PC-DMIS inserts the command line into the Edit window but doesn't activate the command.

Beeping On

Selecting the Beeping On check box activates a beeping sound associated with your AUTOTRIGGER/ command. The closer you get to the target, beeps are heard more frequently.

Radius

The Radius box allows you to type a tolerance zone value. When the probe moves into this tolerance zone, it automatically and immediately takes a hit.

Insert Command

Clicking the Insert Command button inserts the AUTOTRIGGER/ command into the Edit window for the current part program. This command line reads:

AUTOTRIGGER/ TOG1, TOG2, RAD

TOG1 This toggle field corresponds to the Autotrigger On check box. It displays either ON or OFF.

TOG2 This toggle field corresponds to the Beeping On check box. It displays either ON or OFF.

RAD The radius field contains the value for the tolerance zone. This value is the distance from the actual point that PC-DMIS takes the hit.


TriggerPlane area

Display Menu Roadmap

With the TriggerPlane area you can insert a TRIGGERPLANE/ command into the Edit window. The TRIGGERPLANE/ command tells PC-DMIS to automatically take a hit when the probe passes the plane defined by the surface normal of a supported feature at the level of the defined depth. For auto features, this defined location will be adjusted based on options such as sample hits or RMEAS features. As the probe center passes from one side of the plane to the other, the probe will trigger and the hit will be taken.

You can use this command with manual machines; instead of pressing a button to take a hit, you can place TRIGGERPLANE/ commands at any standard location within the Edit window.

This command only works in online mode. If the AUTOTRIGGER/ command is used, it will take precedence over the TRIGGERPLANE/ command.

Note on Faro and Romer Machines: As defined above, PC-DMIS will automatically take a hit when the probe passes the plane. However, if you are using a Faro or a Romer machine, the probe will not trigger again until you press the Accept button (or Release button). You must press this button after each registered hit in order to continue.

On

Selecting the On check box activates the TRIGGERPLANE/ command. Commands in the Edit window that follow the inserted TRIGGERPLANE/ command and require you to take a hit will then have the hit automatically taken when the probe center passes the plane defined by the surface normal and depth of the feature.

If you do not select this check box and you click the Insert Command button, PC-DMIS inserts the command line into the Edit window but doesn't activate the command. The TRIGGERPLANE/ command will not function until the option is turned on.

Beeping On

Selecting the Beeping On check box activates a beeping sound associated with your TRIGGERPLANE/ command. The closer you get to the target, beeps are heard more frequently.

Insert Command

Clicking the Insert Command button inserts the triggerplane command into the Edit window for the current part program.

TRIGGERPLANE/ TOG1,TOG2

TOG1 This toggle field corresponds to the On check box. It displays either ON or OFF.

TOG2 This toggle field corresponds to the Beeping On check box. It displays either ON or OFF.


Manual Point Trigger Tolerance area

With the Manual Point Trigger Tolerance area you can insert a TRIGGERTOLERANCE/ command into the Edit window.

The TRIGGERTOLERANCE/ command tells PC-DMIS to only accept a manual hit when it is within the specified tolerance zone.

You can use this option with manual machines; when PC-DMIS prompts you to take a hit, trigger the probe as you wish. Each trigger will be evaluated to see if it is within the cylindrical trigger tolerance zone. If it is not, you will receive an error in the Machine Errors list of the Execution Mode Options dialog box. PC-DMIS will then ask you to take the hit again. You can place TRIGGERTOLERANCE/ commands at any standard location within the Edit window.

This option only works in online mode.

Use Trigger Tolerance

Selecting the Use Trigger Tolerance check box activates the TRIGGERTOLERANCE/ command. Commands in the Edit window that follow the inserted TRIGGERTOLERANCE/ command and require you to take a hit will then only accept the hit when the probe enters the defined tolerance zone.

If you do not select this check box and you click the Insert Command button, PC-DMIS inserts the command line into the Edit window but doesn't activate the command. The Trigger Tolerance capability is disabled until the option is turned on

Insert Command

Clicking the Insert Command button inserts the TRIGGERTOLERANCE/ command into the Edit window for the current part program with the following options.

TRIGGERTOLERANCE/ TOG1, RAD

TOG1 This toggle field corresponds to the Use Trigger Tolerance check box. It displays either ON or OFF.

RAD The radius field contains the value for the tolerance zone. This value is the distance from the actual point that PC-DMIS accepts the hit.

Tolerance Radius

The Tolerance Radius box allows you to type a tolerance radius value. When the probe is triggered, PC-DMIS will check to see if the probe is within this tolerance zone. If it is, the hit will be accepted. It is it not, you will be asked to take another hit.


 Video Setup button Y Segment box X Segment box ROI Top box Offset box Y End box ROI Bottom box Long Segment box Gain box ROI Width box Y Origin box OK button Cancel button Dimension Probe Trigger Options Opt. Probe ClearPlane Acceleration Probing IO Channels RoTable Apply button Help button Motion

Parameter Settings: NC-100 Parameters tab

Parameter Settings dialog box—NC-100 Parameters tab

The NC-100 Parameters tab only appears in the Parameter Settings dialog box if you have selected a NC-100 Video probe as your active probe.

The NC-100 Parameters tab allows you to change the parameters for the NC-100 Video Probe. These parameters are used to control the lighting, sizing etc. of the NC-100 vision area. If the values in the NC-100 tab are changed, then PC-DMIS inserts a new VIDEOSETUP command into the part program, and displays the cursor position in the Edit window. The Edit window command line for the VIDEOSETUP command reads:

VIDEOSETUP/GAIN = n, OFFSET = n, TOP = n, BOTTOM = n, WIDTH = n,YORIGIN = n,
YEND = n, LSEG = n, XSEG = n, YSEG = n

To edit information in the NC-100 Parameters tab:

Display Menu Roadmap

  1. Access the Parameter Settings dialog box (Edit | Preferences | Parameters).

  2. Click on the NC-100 Parameters tab.

  3. Select the value you want to change.

  4. Type a new value.

  5. Click Apply or OK.

The boxes contained in the NC-100 Parameters tab allow you to specify information that corresponds to settings on the NC-100 computer system See documentation from your NC-100 computer system for more detailed information on these settings.

More:

Gain

Offset Value

ROI Top

ROI Bottom

ROI Width

Y Origin

Y End

Long Segment

X Segment

Y Segment

Video Setup


Gain

The Gain value corresponds to the Gain value on the NC-100 computer system and is a vision sensor setting.


Offset Value

The Offset value corresponds to the Offset value on the NC-100 computer system and is a light sensor setting. See documentation from your NC-100 computer system for additional information.


ROI Top

The ROI Top value corresponds to the ROI Top value on the NC-100 computer system and is the top position of the ROI.


ROI Bottom

The ROI Bottom value corresponds to the ROI Bottom value on the NC-100 computer system and is the bottom position of the ROI.


ROI Width

The ROI Width value corresponds to the ROI Width value on the NC-100 computer system and is the horizontal dimension of the ROI.


Y Origin

The Y Origin value corresponds to the Y Origin value on the NC-100 computer system.


Y End

The Y End value corresponds to the Y End value on the NC-100 computer system.


Long Segment

The Long Segment value corresponds to the Long Segment value on the NC-100 computer system.


X Segment

The X Segment value corresponds to the X Segment value on the NC-100 computer system.


Y Segment

The Y Segment value corresponds to the Y Segment value on the NC-100 computer system.


Video Setup

The Video Setup button allows you to open the Video Setup Parameters on the NC-100 Video System. Clicking this button opens and closes this option.

Communication settings between the PC-DMIS computer system and the NC-100 computer system have to be configured before this option functions properly. See "NC-100 Setup tab" on the SetUp Options dialog box for this information.


Parameter Settings: I/O Channels tab

Parameter Settings dialog box—I/O Channels tab

Currently, the options on the I/O Channels tab only function on DEA machines. Other machine types may be added in the future.

With the I/O Channels tab you can select options related to the use of controller I/O channels and place an IOCHANNEL/ command into the Edit window that will define the state of the controller.

Some machine controllers are equipped with I/O channels that can be SET to an ON state (a value of 1) or RESET to an OFF state (a value of 0). The IOCHANNEL/ command tells PC-DMIS to set the state as specified.

To edit information in the I/O Channels tab:

Display Menu Roadmap

  1. Access the Parameter Settings dialog box (Edit | Preferences | Parameters).

  2. Click on the I/O Channels tab.

  3. Make any changes.

  4. Click Apply or OK.

More:

Channel

Set and Reset Options


Channel

This specifies the channel number that you will SET or RESET.


Set and Reset Options

Option | Description
Set | This option inserts an IOCHANNEL/SET command into the part program. When PC-DMIS executes this command the state of the specified channel number will be set to 1.
Reset | This option inserts an IOCHANNEL/RESET command into the part program. When PC-DMIS executes this command the state of the specified channel number will be set to 0.


Setting Up the Edit Window

PC-DMIS lets you determine the Edit window's appearance as well as what information to display within some the Edit window's modes.

More:

Defining Edit Window Colors

Defining the Edit window Layout


Defining Edit Window Colors

Display Menu Roadmap

Edit Window Colors dialog box

The Edit | Preferences | Edit Window Colors menu option displays the Color Editor dialog box. You must be in Command mode or DMIS mode to select this menu item.

The Color Editor dialog box allows you to define the colors used for the Edit window text and background when you have the Edit window in Command and DMIS modes. You can also export your color scheme to use on different computer systems or import external color schemes.

Note: The Color Editor dialog box only specifies the colors in textual modes of the Edit window such as the Command and DMIS.

There are four principal colors that can be configured for all commands or for individual commands. You can determine whether to show these colors as a highlighted background color or as text color by selecting or clearing the Enable Background Highlighting check box. These are listed in the four boxes in the Command Text Colors area.

  • Marked

  • Unmarked

  • Step Mode

  • Error

By default, the Enable Background Highlighting check box is selected, making the boxes appear with the following colors:

If you clear this check box to enable text coloring instead, PC-DMIS will show the boxes as follows:

Principal Colors

Marked Color: | Marked Color represents any feature that is marked for execution. Some features such as alignments are always executed and therefore always show up in the Marked color.
Unmarked: | Unmarked color is the default color. If no other condition is present then the default color is used.
Step Mode: | Step Mode color highlights the line upon which execution will occur next when executing a part program using breakpoints.
Error: | Error color shows commands that are in error or measurements that are outside of their tolerance limits. For example, if a tip is recalled but is not defined in the probe database, this tip text will be colored with the error color.

You can also change background colors for the Edit window, for dimensions, and for the highlight color.

Background Color: | Background Color of the Edit window can also be modified from within this dialog.
Dimension Background Color | Dimension Background Color sets the background color for a dimension's reporting boxes.
Highlight Background Color | Highlight Background Color sets the background color when dragging the mouse to select a command or group of commands.

More:

To change the text colors used:

To change the background colors used:

To export a color scheme:

To import and use a color scheme:


To change the text colors used:

To change the command text colors used:

Display Menu Roadmap

  1. Select Edit | Preferences | Edit Window Colors from the menu bar. The Color Editor dialog box opens.

  2. Click the Auto Preview check box. This allows you to preview your changes inside the Edit window as you make them.

  3. Select a specific command or a parent command from the list of commands in the Command Text Colors area. Click on the plus signs to expand the list to view additional sub commands. This allows you to set the principal colors (Marked, Unmarked, Step Mode, and Error) for specific commands or parent commands. To set the changes for all command text, select Default from the top of the list.

  4. Simply click the Edit button for the text or background color in the Command Text Colors area. A Color selection box will appear.

  5. Select the new color, or customize a color by selecting the Define Custom Colors button.

  6. Click the OK button. The Color selection box will close. If you selected a parent command, PC-DMIS presents you with an option to set all child commands under the parent command to use the same color as well. Select either Yes or No at this prompt.

  7. When finished defining your colors, click the Apply button to see the changes without closing the Colors dialog box.

  8. Click the OK button to apply the changes and close the Color Editor dialog box.

The color changes will immediately be made.


To change the background colors used:

Display Menu Roadmap

  1. Select Edit | Preferences | Edit Window Colors from the menu bar. The Color Editor dialog box opens.

  2. Click the Auto Preview check box. This allows you to preview your changes inside the Edit window as you make them.

  3. Simply click the Edit button for the background or highlight color from the Background Color area. A Color selection box will appear.

  4. Select the new color, or customize a color by selecting the Define Custom Colors button.

  5. Click the OK button. The Color selection box will close.

  6. When finished defining your colors, click the Apply button to see the changes without closing the Colors dialog box.

  7. Click the OK button to apply the changes and close the Color Editor dialog box.

The color changes will immediately be made.


To export a color scheme:

Display Menu Roadmap

  1. Select Edit | Preferences | Edit Window Colors from the menu bar. The Color Editor dialog box opens.

  2. Make changes to your color scheme as needed.

  3. Click the Export button. A Save As dialog box appears. This dialog box allows you to store your Edit window color scheme as a color file (a file with a .clr extension).

Save As dialog box

  4. Navigate to where you want to store this file.

  5. Type a name for the stored color file in the File name box.

  6. Click Save.


To import and use a color scheme:

Display Menu Roadmap

  1. Select Edit | Preferences | Edit Window Colors from the menu bar. The Color Editor dialog box opens. Click the Auto Preview check box. This will allow you to preview your changes inside the Edit window once you select the color scheme.

  2. Click the Import button. An Open dialog box appears.

  3. Navigate to the color scheme file (a file with a .clr extension).

  4. Select the file and click Open. The Open dialog box closes.

  5. Click Apply and then OK to use the color scheme you just imported.


Defining the Edit window Layout

Display Menu Roadmap

The Edit | Preferences | Edit Window Layout menu option brings up the Edit Window Layout dialog box. The dialog box contains a Command tab. This tab lets you hide or show certain commands in the Edit window.

More:

Command Mode Display Options


Command Mode Display Options

Edit Window Layout dialog box

Edit Window Layout dialog box—Command tab

Display Menu Roadmap

The Command tab allows you to choose which of the following display options are available for Command mode.

Show Features | This option displays the features measured by the part program.
Show Alignments | This option shows alignment changes as they occur during the part program. It will display all alignment changes that occur in the dimension or feature lists.
Show Moves | This option shows any moves that have been added to the part program.
Show Comments | This option shows any comments that have been added to the part program. (See "Inserting Programmer Comments" in the "Inserting Report Commands" section for additional information.)
Show Dimensions | This option displays the specified dimension for the features inspected by PC-DMIS. It will be displayed in the selected format using the FORMAT command described in the "Dimension Format" topic in the "Using the Edit Window" section.
Show Hits | This option displays each hit.
Show Header / Footer | This option displays the header / footer from the LOGO.DAT, HEADER.DAT, and ELOGO.DAT files. (See "Modifying Headers and Footers" in the "Using the Edit Window" section for information on altering these files.)
Show Tips | This option displays the tip file names used to inspect the part.

For information on working with Command mode, see the "Working in Command Mode" topic in the "Using the Edit Window" section.


Setting Up the Readout Window

Display Menu Roadmap

Probe Readout Setup dialog box

The Probe Readout Setup dialog box (Edit | Preferences | Probe Readout Setup) allows you to select the desired format of the Probe Readout window. Select the check boxes that meet your probe readout needs. When you next select the Probe Readout Window menu option it will reflect the chosen format.

Hint: You can also access the Probe Readout Setup dialog box by right-clicking on the Probe Readout window and clicking Setup.

For information on using the Probe Readout window, see "Using the Probe Readout window" in the "Using Other Windows, Editors, and Tools" section.

More:

Feature area

Probe/Hit area

Coordinates area

Axis to display area

Colors area

Tracker area

Graphical Representation area

Distance Target area

Prompt History area


Feature Area

Feature area

Show Feature ID check box | If in Learn Mode and there are CAD elements, this shows the text label of the nearest CAD element. If in Execute Mode and PC-DMIS is executing sequentially through the part program, this shows the ID of feature being executed. If PC-DMIS is executing in any order, and the Closest Feature option is selected from the Distance Target area, it will show the ID of the closest feature.
Show Feature Type check box | If in Execute Mode and PC-DMIS is executing sequentially through the part program, this displays the executing feature type. If PC-DMIS is executing in any order this displays the feature type of the closest feature.


Probe/Hit Area

Probe/Hit area

Probe Position check box | When you select the Probe Position check box, PC-DMIS displays the current position of the probe. The Probe Readout window will display the probe's position in the active coordinate system.
Last Hit check box | When you select the Last Hit check box, PC-DMIS will display the location of the last hit taken with the probe. If this option is not selected, PC-DMIS displays the current position of the probe.
Display error of last measured feature check box | When you select the Display error of last measured feature check box, PC-DMIS displays any deviations along the XYZ coordinates (and D for circular features) for the last measured feature in the Probe Readout window. Even if the deviation is 0 then only 0 is displayed.


Coordinates Area

Coordinates area

Machine Coordinate System (MCS) check box | When you select the Machine Coordinate System (MCS) check box, PC-DMIS displays the information in the machine's coordinate system, not the part coordinate system. This check box switches between these coordinate systems. Deselecting it will once again display the information in the part's coordinate system.
Use Polar Coordinates check box | When you select the Use Polar Coordinates check box, PC-DMIS switches between rectangular and polar coordinates. When polar coordinates are used, the normal direction of the workplane is also displayed.


Axis to Display Area

Axis to display area

X check box | This hides or displays the X axis in the Probe Readouts window
Y check box | This hides or displays the Y axis in the Probe Readouts window
Z check box | This hides or displays the Z axis in the Probe Readouts window


Colors Area

Colors area

Background list | This sets the background color of the Probe Readout window.
Text list | This sets the text color of the Probe Readout window.


Tracker Area

Tracker area

Show RMS check box | This shows the RMS value in the Probe Readouts window if the measure machine is a portable tracker device.
Inspect or Build option | These determine whether or not the information in the tracker is reported according to the Inspect mode or Build mode.

See the "PC-DMIS Portable" documentation for more information.


Graphical Representation Area

Graphical Representation area

Show current probe position on screen check box | The Show current probe position on screen check box differs from the Probe Position check box in that it shows a graphical representation of the probe on screen, relative to the machine. This is helpful when working on-line. When you move the probe by using the jog box, a graphical representation of the probe also moves within PC-DMIS's screen.
Show deviation arrow on screen check box | The Show deviation arrow on screen check box shows a 3D arrow on the Graphics Display window indicating the direction of deviation.
Center probe in graphic window check box | The Center probe in graphic window check box shifts the display in the Graphics Display window so that the animated probe always appears centered in the window whenever PC-DMIS executes motion commands or takes hits on the part. This is useful when you want to keep your view zoomed in close to your part model during execution yet visually follow the probes progress.


Distance Target Area

Distance Target area

Distance to Target check box

When you select the Distance to Target check box, PC-DMIS displays the distance of the probe to the target point. The probe's position is displayed in the active coordinate system. Manually drive the probe to the keyed in location. When the target point is reached, the Probe Readout window will display 0,0,0.

With Auto Zoom check box

When you select both the Distance to Target check box and the With Auto Zoom check box, PC-DMIS also displays the distance of the probe to the target point. The probe’s position is displayed in the active coordinate system. As the probe is manually driven to the keyed in location, PC-DMIS makes the target point the center of the screen and zoom in on the point in the Graphics Display window.

Distance area

This area contains these two option buttons:

  • Executing feature shows the distance to the feature being executed.

  • Closest feature shows the distance to the feature closest to the probe.

Target area

This area contains these two option buttons:

  • Surface/Edge calculates the distance to the actual target point on the surface or edge of the feature.

In the above example, while measuring the circle (CIR1), this option will cause the Probe Readout window to show the distance to the actual target point (see A).

  • Centroid calculates the distance to the feature's centroid.

In the above example, while measuring the circle (CIR1), this option will cause the Probe Readout window to show the distance to the feature's centroid (see A) instead of the actual target point.

Display distance to closest CAD check box

This check box shows the distance from probe to closest CAD element.

Apply dimension color check box

This check box changes the colors of the deviation values (Distance to Target values) to match the out of tolerance dimension colors.


Prompt History

Prompt History Area

When you select the Display prompt history check box, PC-DMIS will display the new Probe Readout comment type inside the Probe Readout window.

  • Using the Display lines at a time box, you can specify how many lines PC-DMIS should set apart for these comments on the Probe Readout window itself.

  • Using the Select Font button, you can also specify the font type and size that should be used for these comments on the Probe Readout window.

For information on inserting comments, see "Inserting Programmer Comments" in the "Inserting Report Commands" section.

For information on displaying the Probe Readout window, see "Using the Probe Readout window" in the "Using Other Windows, Editors, and Tools" section.


Always Track FOV Center

If this item is selected, PC-DMIS displays the FOV center of a non-contact video probe. This item only appears if you have a non-contact video probe defined.


Setting up Multiple Arms

See the "Using Multiple Arm Mode" section for information regarding setup procedures for multiple arms.


Defining the Rotary Table

Display Menu Roadmap

Selecting the Edit | Preferences | Rotary Table Setup menu option displays the Rotary Table Setup dialog box.

Rotary Table Setup dialog box

This dialog box allows you to define the rotary table. You can only accept one option per category.

  1. Select the type of table being used. If Dual Rotary Table or Stacked Rotary Tables is selected, indicate the active table (Table W or Table V). Selecting Dual Rotary Tables or Stacked Rotary Tables also displays the Active Rotary Table toolbar once you click the OK button. This toolbar contains two icons that allow you to select which rotary table is active.

  2. Define whether the table is indexable or infinite type, by selecting either Table is Index Type or Table is Infinite Type.

Note on Index Type Rotary Tables:
Index type rotary tables have a finite number of specific angles to which they can be positioned. Generally, they have a fixed increment (in degrees of rotation) from a given position to the next available position. The incremental amount will vary, based on your specific table. Please consult your Rotary table documentation if necessary. Infinite type rotary tables will accept any position (in degrees).

  3. Determine if the rotary table is Manual or DCC, and select either Table is Manual or Table is DCC as appropriate.

  3. From the Axis for Table list, select the machine axis closest to the axis of rotation for the table.

  4. From the Direction of Positive list, select whether or not the table has a positive rotation about the chosen axis in either the CLOCKWISE direction or the COUNTERCLOCKWISE direction.

  5. If known, key in the XYZ, IJK values

  6. Click Calibrate to begin the calibration process.

Note: The Rotary Table Setup menu option is unavailable until your portlock is configured to accept rotary tables.

More:

Calibrate Rotary Table


Calibrate Rotary Table

Depending on the options selected in the Rotary Table Setup dialog box (see " Defining the Rotary Table " ) one of two dialog boxes will open when you click the Calibrate button.

  • Selecting the Table is Infinite Type option and the Calibrate button opens the Calibrate Infinite Rotary Table dialog box.

  • Selecting the Table is Index Type option and the Calibrate button opens the Calibrate Indexable Rotary Table dialog box.

More:

C alibrate Indexable Rotary Table

Calibrate Infinite Rotary Table


Calibrate Indexable Rotary Table

Calibrate Indexable Rotary Table

Using the Calibrate Indexable Rotary Table dialog box you can select the options that will be used to calibrate the selected table. Once the options within the dialog box are satisfactory, click the Calibrate button to start the rotary table calibration process.

Usage Note: The indexable rotary table calibration must include the 0 position. Additionally, all the angles that will actually be used in a part program must also be calibrated. This calibration procedure calculates and stores a transformation for all other angles relative to the 0 position.

Calibration Note: The indexable rotary table calibration procedure requires a valid XYZ, IJK for the table in order to run properly. This can be accomplished in two ways.

1.) If the values are known, they can be manually typed into the Rotary Table Setup dialog box. This will usually not be the case.

2) Initially select the Table is Infinite Type option and complete an infinite rotary table calibration, which will calculate and save the XYZ, IJK. Then select the Table is Indexable Type and perform the indexable rotary table calibration. This is normally only an issue during the initial software installation/setup or if the rotary table has been moved or if something has happened to significantly alter the origin of the machine coordinate system. Once the XYZ, IJK is determined closely enough that the indexable rotary table calibration procedure can run successfully it is not necessary to go back and re-run the infinite rotary table calibration in order to re-run the indexable rotary table calibration.

Add Rotab Angles

The Add Rotab Angles area allows you to define the list of table angles that will be included in the calibration. You can define one angle at a time, or you can define an incremented range of angles. Defined angles are then placed in the Angles to Calibrate list. When you click Calibrate PC-DMIS will then calibrate the rotary table using the defined angles.

Example: If you want to calibrate all the angles between 5 and 95 degrees with a 10 degree increment between each angle, you would fill in the Start Angle, End Angle, and Increment boxes with 5, 95, and 10 respectively, and then click the Equally Space button.

Angles to Calibrate list

This list contains all the table angles for the calibration. You can add angles to this list from the Add Rotab Angles area. The Angles to Calibrate list must use the zero angle.

Other Dialog box Parameters

This dialog box also contains many of the same options described in the "Defining Hardware" section.

  • For information on Number of Hits, Prehit / Retract, Move Speed, Touch Speed, Manual / DCC, List of Available Tools, Add Tool, and Delete Tool, see the ”Measure” topic in the ”Defining Hardware” section.

  • For information on Active Probe File and Active Tip, see the ”Defining Probes” topic in the ”Defining Hardware” section.


Calibrate Infinite Rotary Table

Calibrate Infinite Rotary Table dialog box

The Calibrate Infinite Rotary Table dialog box differs from the Calibrate Indexable Rotary Table dialog box in these areas:

  • Instead of the Angles to Calibrate list, the dialog displays the Table Angles list.

  • You don’t have to use the 0.0 angle in the Table Angles list.

  • Instead of three calibration tools, the dialog box only displays one calibration tool.

See ”Calibrate Indexable Rotary Table” for information on the specific options contained in this dialog box


Setting Up Probe Changer Options

Display Menu Roadmap

Selecting the Edit | Preferences | Probe Changer menu option displays the Probe Changer dialog box.

Probe Changer dialog box

Probe Changer dialog box

This dialog box allows you to setup various options that can be used on a probe changer. Until you define a probe changer, this dialog will only display the Type tab. These other tabs may become available when you define your probe changer type.

Type | This allows you to select the probe changer type.
Calibrate | This allows you to choose which active tips to calibrate.
Mount Point | This allows you to change AB wrist values and also provide a safe location that the CMM can move to after each cycle.
Slots | This allows you to define probe or stylus configuration for existing slots in the probe changer rack.
Comm | This allows you to work with your computer's serial port connection to the probe changer.

These tabs are described below in greater detail.

See the "Defining Probe Changers" topic in the "Defining Hardware" section provides you with a step by step description of how to setup and calibrate a probe changer. It also describes how you to display an existing probe changer inside the Graphics Display window.

More:

Type

Comm

Calibrate

Mount Point

Slots


Type

Display Menu Roadmap

Probe Changer dialog box—Type tab

Before calibration can take place, the probe changer type must be chosen. Select the type of probe changer from the Probe Changer drop-down list. After a change of probe changer type, PC-DMIS must be restarted.

The docking speed can be altered to fine tune the operation of the change cycle. Simply type a new percentage value to set the docking speed.

More:

Active Probe Changer

Number of Probe Changers

Probe Changer Type

Docking Speed


Active Probe Changer

Depending on the value in the Number of Probe Changers box, the Active Probe Changer list contains numbered items (Probe Changer1, Probe Changer2, Probe Changer3 etc.) to which you can assign a probe changer and its associated values.

Initially PC-DMIS displays only one item in this list, usually "Probe Changer1". You can add additional items to the list by increasing the value in the Number of Probe Changers box.

PC-DMIS stores the probe changer type you selected and any other values for the numbered item in the Active Probe Changer list.


Number of Probe Changers

With the Number of Probe Changers box you can determine how many probe changers to use. The number you type in this box becomes the number of available probe changers in the Active Probe Changer list.


Probe Changer Type

The Probe Changer Type drop-down list contains a list of the various probe changer types.

Probe Changer dialog box showing the CW43L probe changer type

CW43L Probe Changers

The CW43L probe changer calibration procedure requires you to perform the calibration using a probe with the wrist map in order to properly calculate the port locations. Once calibrated, you can then use the probe changer to change probes regardless of whether or not they actually use the wrist map.


Docking Speed

The Docking Speed box allows you to determine the docking speed of the change cycle.


Comm

 Type Mount Point Calibrate Slots Ok button Cancel button Apply button Help button

Comm Display Menu Roadmap

Probe Changer Dialog box—Comm tab

For some types of probe changers there is a serial connection to the computer. This dialog will allow you to choose your communications port (COM port) and modify your COM port settings. For information on your COM port settings, check the documentation that came with your computer hardware.

If your probe changer does not have a serial connection the Comm tab will not appear.


Calibrate

Probe Changer dialog box—Calibrate tab

Before probe configurations can be loaded into the rack, consider the following:

  • The probe or stylus must be chosen from the Type tab and calibrated.

  • The rack should be squared to one of the CMM's axes.

  • The PS35R stylus that was supplied by Renishaw must be used to calibrate the probe changer.

  • Verify that the stylus has been calibrated before starting this process. (See "Defining Probes" in the "Defining Hardware" section.)

  • If calibrating a slot holding an extension, ensure that you have first defined the Probe Head Wrist Angle required for the change in the Mount Point tab. The probe head will rotate to this angle before measuring the wrist's joint on the datum sphere.

CAUTION: The optoelectronic infrared detection system is always active. If it is accidentally tripped, the PI200 (probe controller ) will deactivate the TP200.

Note: Generally, you should physically align probe changers along one of the machine’s axis. However, for the TP20, TP200, and SP600 probe changers this isn't required. For these probe changes, the rack still needs to be level, but you can now rotate it so that the length of the rack is no longer aligned along a machine axis.

More:

Active Probe Changer

Active Probe File

Active Tip

Full Calibration

Partial Calibration

Single Port Calibration

Calibrate Button


Active Probe Changer

From the Active Probe Changer list you can select what probe changer to calibrate.

See "Active Probe Changer" under the Type tab for information on this list.


Active Probe File

The Active Probe File drop-down list allows you to select a probe to use for the calibration process.


Active Tip

Display Menu Roadmap

The Active Tip drop-down list allows you to choose a tip configuration for the probe selected.


Full Calibration

If you select the Full Calibration option, PC-DMIS will measure the entire probe changer. This is the most often used method of calibration and for some the only method available. It is recommended that the operator use the full calibration method.


Partial Calibration

The Partial Calibration option will only calibrate a portion of the probe changer. This option only appears for those changer types that support it.


Single Port Calibration

Some probe changers, such as the ARC1, will allow you to measure only a single slot after a successful full calibration. The Single Slot Calibration option only appears for those changer types that support it.


Calibrate Button

The Calibrate button allows you to begin the calibration process by opening the Probe Changer dialog box. Follow any on-screen prompts to correctly calibrate your probe changer.

Probe Extension Calibration

When calibrating an extension module, after the measurements with the tip are completed and the joint on the wrist has been measured on the datum sphere without the extensions attached, for each slot configured to hold an extension you will be asked to attach the extension to that slot, and you will need to measure the end joint on those extensions as you did for the wrist itself.

SCR200 Probe Changer Calibration

The following procedure describes how to calibrate an SCR200 Probe Changer:

After clicking the Calibrate button, the first prompt appears.

  • Open lids 3 and 4, and remove any probes from those ports.

  • Click OK.

  • Take one hit on the front face of the probe changer's center post.

PC-DMIS Message:
Open lids 3 and 4 and remove any probe from ports 3 and 4. When ready, please take a hit on the front face of the divider between ports 3 and 4. The hit should be taken on the lower widest portion as close as possible to the outer edge next to port 3.

A second prompt appears asking you to take the second hit.

  • Click OK.

  • Take the second manual hit on the top of the center post.

PC-DMIS Message:
Please take a hit on the top of the middle of the rack. After completing this hit DCC calibration will begin.

A third prompt appears asking you to take the final hit.

  • Click OK.

  • Take the third manual hit again on the front face of the center post.

  • You should have taken all three hits similar to shown here:

  • PC-DMIS takes the remaining hits in DCC mode:

    1 hit each on the left and right inside sides of slot 3

    1 hit each on the left and right inside sides of slot 4.

PC-DMIS Message:
Please take a hit on the front face of the divider between ports 3 and 4. The hit should be taken on the lower widest portion as close as possible to the outer edge on the right-hand side next to port 4. After completing this hit DCC calibration will begin.

After calibration, the Probe Changer dialog box appears.

  • Select the Mount Point tab.

  • Confirm the wrist angle for the change cycle by typing in the angle in the Probe Head Wrist Angle A Angle and B Angle boxes.

  • Specify the rack's safe position (a position where probes can be swapped in and out safely) in machine coordinates. You can type this manually into the Machine Position X, Y, and Z boxes or click the Read Machine button.

  • Click the Slots tab.

  • Define the contents of each slot in the rack by expanding the plus sign (+) for each slot and then double-clicking the (no probe) item.

A list of available probes appears.

  • Select the probe file to add to the current slot.

  • If needed, adjust the slot position. Select the slot's position, and click the Edit Slot Data button.

The Probe Changer Slot Data dialog box appears.

  • Modify the X, Y, Z position of the slot.

  • Click OK to close the Probe Changer Slot Data dialog box.

  • Click OK to close the Probe Changer dialog box.


Mount Point

Display Menu Roadmap

Probe Changer dialog box—Mount Point tab

The Mount Point tab allows you to change the values for the AB wrist angle as well as define a safe position that the CMM can move to before each change cycle.

You can do this for as many probe changers as defined using the Type tab. Select the probe changer from the Active Probe Changer list and type the desired AB angles and CMM position.

More:

Active Probe Changer

Probe Head Wrist Angle

CMM Position


Active Probe Changer

From the Active Probe Changer list you can select the probe changer for which you want to define AB wrist angles and a CMM position.

See "Active Probe Changer" under the Type tabfor information on this list.


Probe Head Wrist Angle

The A Angle and B Angle boxes indicate the position of the probe head while sliding the probe configurations in place. In most cases the angle should indicate a straight down position. When calibrating slots holding extensions, the AB angle boxes should be defined prior to calibration. If you try to change the AB angle after the slot has already been calibrated, a warning will appear informing you that recalibration will be needed.

To change the AB angles from the straight down position:

  1. Place the cursor in the A Angle box or the B Angle box.

  2. Type the desired angle.


CMM Position

The CMM Position area of this dialog box allows you to indicate a safe location to which the CMM can move prior to each change cycle. Usually, this safe location is approximately two inches above and in front of the probe changer rack. However, you may find it necessary to move to some other location depending on the type of probe changer.

To change the values for the CMM Position:

  1. Select the previous value of the X, Y, or Z box you want to change.

  2. Type the correct value for the appropriate boxes or use the Read CMM button to insert the current location of the CMM.


Slots

Display Menu Roadmap

Probe Changer dialog box—Slots tab

The probe changer is a rack that provides slots for different probe configurations. The Slots tab allows you to define the probe configuration for each slot that will be used. The default for each slot is "no probe". You can define the probe configuration for each slot of the selected probe changer.

More:

To Define the Probe Configuration for Each Slot

To Manually Edit a Slot's Data

To Change a Defined Probe Back to the ‘no probe’ Default

To Add or Remove Slots from the Dialog Box

To Drop off a Probe without Picking up a New Probe


To Define the Probe Configuration for Each Slot

  1. Select the appropriate probe changer from the Active Probe Changer list.

  2. Click the plus sign (+) to the left of the slot number. You'll notice that PC-DMIS displays a "no probe" item as the default.

  3. Double-click or right-click on the "no probe" item. A list will appear.

  4. Assign the appropriate probe file or extension to each slot.

  5. Select the slot number, and then click the Edit Slot Data button. The Probe Changer Slot Data dialog box appears. See "To Manually Edit a Slot's Data".

  6. From the Slot Type list, specify what type of hardware the slot will hold. Select either Probe Attached if it will hold a probe or Extension Only if you only want it to hold a probe extension. If the slot is empty, select Undefined. On some probe changers you can select specific inserts from this list.

  7. Define the XYZ location for the slot by typing in the X, Y, and Z values for the Slot Number.

  8. If using an ARC1 or TESASTAR-R probe changer and you have defined the slot type as Extension Only, set the value for the Rotation Angle of Bottom Joint (degrees) box. If desired, you can also define the XYZ location of the bottom of the extension by defining the X,Y, and Z boxes in the With Empty Extension area.

  9. Click OK to accept your changes.

  10. Each probe configuration must be loaded into the rack using the CMM Arm and Load Active Probe option. (Do not insert the probe into the rack by hand.)

Note: Extensions are not manufactured within the necessary tolerances to be interchangeable without recalibration. Therefore, if you have already configured a slot for a specific extension, and you want that slot to hold a different extension (even an extension of the same size), you will need to recalibrate the slot for the new extension.


To Manually Edit a Slot's Data

  1. Select the appropriate slot from the Active Probe Changer list.

  2. Click the Edit Slot Data button. The Probe Changer Slot Data dialog box appears. For all probe changer types, the XYZ boxes should be available to edit. While you can use these boxes to manually enter a position if needed, these values are normally determined by measurements resulting from running the calibration procedure for the probe changer. You can use this dialog box to change a slot's type and XYZ location. For TESASTAR-R and Autochange(ACR1) probe changers, you can also use it to edit an extension's XYZ location and edit the rotation angle of the bottom joint.

    Probe Changer Slot Data dialog box for an ACR1 Probe Changer

  3. Some probe changer types support multiple possible configurations for each slot. Some example probe changer types that allow this include the Autochange(ACR1) and TESASTAR-R.

    • When using a changer with multiple possibilities for each slot, the Slot Type list will be active and filled with selections appropriate for that changer type.

    • To specify the appropriate configuration, choose the appropriate entry from the list. For more in-depth information on the meaning of the selections available for a particular changer type, consult your hardware documentation for the probe changer.

    • When slot type selections are available, you should set them before running the calibration procedure for the probe changer. Changing them later typically requires a re-calibration of the probe changer, or at least the individual slots that were changed.

  4. Some probe changer types have slot types that let you use empty extensions that do not have actual probes attached. Some example probe changer types that allow this include the Autochange(ACR1) and the TESASTAR-R.

    • When using a probe changer that supports empty extensions, and if you have defined a slot as Extension Only, the With Empty Extension and Rotation Angle Bottom Joint areas become active.

    • While you can manually enter the XYZ location for the empty extension, this will normally be determined from calibrating the probe changer.

    • Some extension bars have a bottom joint that is rotated by some amount relative to the top joint. If you use one of these extension bars, you must define the amount of rotation in the Rotation Angle of Bottom Joint box before calibrating the probe changer. Changing it later will require re-calibration of the probe changer, or at least the individual slots that were changed.

  5. When you have finished specifying the desired values, click OK. PC-DMIS closes the dialog box and shows a summary of the specifications for that slot in the Probe Changer dialog box. If any values were changed, it will also indicate "changes pending" for the slot.

  6. If you want to revert a slot to its previous value, you can select that slot, click the Edit Slot Data, and then from the Probe Changer Slot Data dialog box, click the Restore XYZ, Restore Type, or Restore Angle buttons inside the Probe Changer Slot Data dialog box as applicable. These buttons are only available for selection if changes have been made but you haven't yet clicked OK or Apply on the Probe Changer dialog box.

  7. If you're ready to accept your changes, click either the OK or Apply button on the Probe Changer dialog box.


To Change a Defined Probe Back to the

To Change a Defined Probe Back to the ‘no probe’ Default

  1. Select the appropriate probe changer from the Active Probe Changer list.

  2. Double-click on the slot to change. A list appears.

  3. Select "no probe" from the available list.


To Add or Remove Slots from the Dialog Box

With some types of probe changers you can define the number of slots.

  1. Select the appropriate probe changer from the Active Probe Changer list.

  2. Change the value in the Number of Slots box.

  3. Click the Apply button to immediately see the changes.

If your probe changer does not allow for a changing amount of slots then the Number of Slots box will be disabled.


To Drop off a Probe without Picking up a New Probe

You may want to drop off the current probe into the probe changer without picking up a new probe from the changer.

To do this:

  1. Create a dummy probe file in the Probe Utilities dialog box for a probe that doesn't exist. Name it something like "unload". See the "Defining Probes" topic in the "Defining Hardware" section.

  2. Click the Setup button. The Probe Setup dialog box appears.

  3. Select this probe file from the Probe File Used with Probe Changer to Force Unload Only list.

  4. Click OK to close the Probe Setup dialog box.

  5. Access the Slots tab in the Probe Changer dialog box and ensure that the probe is NOT assigned to any slot in the probe changer.

  6. Click OK to close the Probe Changer dialog box.


Managing Multiple Probe Changers

The topics below discuss the more popular probing systems used today (the TP2, ACR1, TP20 and TP200, and the SP600). The "Configuring Multiple Racks" and "SP25 Probe/Stylus Change system" topics then provide detailed examples of how to work with multiple probe changers.

More:

Background on TP2

Background on ACR1

Background on TP20 and TP200

Background on the SP600 Analog Probe

Configuring Multiple Racks

SP25 Probe/Stylus Change system


Background_on_TP2

When Renishaw developed the small touch trigger probe (TP2), it attached to the CMM ram via a probe head with a threaded M8 connection in line with the probe body itself. However, this design required a probe recalibration whenever it was removed or reattached.

To alleviate this need to recalibrate, Renishaw developed a quick-connect adapter (termed QuickConnect) which used a ¼ turn of a key to lock and unlock the adapter from the CMM. The TP2 screwed into this adapter. This adapter could be detached and re-attached very quickly and repeatably without the necessity of always recalibrating.


Background on ACR1

The ACR1 was the first probe changer introduced by Renishaw. It held up to eight of the quick-connect extensions, each with a separate TP2 probe body. Once the collection of probes were qualified and placed into the rack, they could be automatically dropped off and picked up by the CMM with simple move commands and coordinated with the locking/unlocking mechanisms of the rack. A software module was eventually developed which controlled the rack operations.


Background on TP20 and TP200

Over time, design evolution and electronic developments paved the way for alternatives to the TP2 probe body. In addition, for some customers, purchasing up to eight probe bodies proved prohibitive. New probe body designs were developed which allowed for removal and attachment of new stylus adapters. These took the place of the quick-connect joints. Individual stylus assemblies could then be removed and re-attached repeatedly and inexpensively.

Two of the better known probe types of this design from Renishaw include the TP20 and the TP200. Each is roughly equivalent to the TP2 in size and shape, but there are two main differences:

  • Due to their enhanced electronics, they can hold more weight and still produce more accurate and repeatable results.

  • They are designed with a magnetic ‘split’ between the upper probe body and the lower stylus holder. This allows them to be used with their own stylus change rack systems, the MCR20 and the SCR200 respectively.


Background on the SP600 Analog Probe

Another improvement is the popular SP600 analog probe. This probe can perform analog scans as well as touch trigger measurements. While its body design is much larger than the TP series of probes, a magnetic stylus holder can separate from the body. Accordingly, it also has its own rack system, the SCR600 tip changer.


Configuring Multiple Racks

While there are other probing systems on the market, the four most popular probing systems, as discussed, are the TP2, TP20, TP200, and SP600 systems. Each has its own rack system which can function on its own as a single rack. Alternately, you can use more than one rack with a CMM, and the PC-DMIS software has the ability to move between the racks to drop off and pick up probes and stylus holders as needed.

Important Notes:

  • Each rack has its own calibration method in PC-DMIS. While they share a lot of commonality, for calibration purposes, they are completely independent of each other.

  • The clearance move point for each rack is only related to that rack, except that some consideration must be given to where to will travel next. For this reason, the clearance move should be at such a location to allow free travel to any other rack which may be involved. Even when using a single rack, this clearance move must be sufficient to travel from and return to the part inspection operations.

  • Defining the slots' contents for multiple racks is the most critical part of configuring multiple racks for simultaneous use. Since each slot may contain multiple probe references (the contents of the slot can be used with multiple probes) each slot must identify all of the probes it will potentially use.

More:


Example of Multiple Probe References

Suppose you have these three probes configurations:

PROBE_01 | PROBE_02 | PROBE_03
QuickConnect AutoJoint | QuickConnect AutoJoint | QuickConnect AutoJoint
TP2 | TP20 | TP20
3mmx10mm stylus | 2mmx10mm stylus | 4mmx20mm stylus

The ACR1 will switch between the TP2 and the TP20 probes. The MCR20 will switch between the styli associated with the TP20 probe system(s).

A typical slot definition might look like this:

ACR1 |  | MCR20
Slot 1 | Slot 2 | Slot 1 | Slot 2
Probe_01 | Probe_02 | Probe_02 | Probe_03
 | Probe_03 |  |

In operation, suppose the system is using PROBE_01 and it needs to switch to PROBE_02. The system would:

  • Pause the measurement program.

  • Travel to the clearance location for the ACR1.

  • Return the currently loaded probe to slot #1 of the ACR1.

  • Move to slot #2 of the ACR1 and pick up the TP20 body for PROBE_02.

  • Use the respective Safety/Clearance points and move to the MCR20.

  • Move into slot #1 of the MCR20 to attach the stylus adapter with the desired stylus.

  • Return to the MCR20’s Clearance point.

  • Continue with the measurement program.

Suppose after measuring some features, the system then needs to use PROBE_03. The system would:

  • Pause the measurement process.

  • Travel to the clearance location for the MCR20.

  • Move into slot #1 to drop off PROBE_02’s stylus.

  • Travel out, over, and into slot #3 to pick up the stylus required for PROBE_03.

  • Travel to the clearance location.

  • Continue with the measurement program.

Now, suppose the system needs to switch from PROBE_03 (the TP20 with the 4mmx20mm stylus) back to Probe_01 (the TP2 with the 3mmx10mm stylus). The system would:

  • Pause the measurement program.

  • Move to the clearance point for the MCR20.

  • Go into slot #2 and drop off the stylus assembly.

  • Return to the MCR20’s clearance location

  • Move to the ACR1’s clearance location.

  • Go into slot #2 to drop off the TP20 assembly.

  • Move out and return to slot #1 to pick up the TP2 assembly (the TP2 probe already has the stylus attached).

  • Move to the clearance point for the ACR1.

  • Continue the measurement program.

Note that in this example, you only need one TP20 probe body. You use the MCR20 to switch between two different probe stylus assemblies for varied measurement requirements.


SP25 Probe/Stylus Change system

The SP25 rack is an extension of the same procedures used in other racks. This discussion covers the ARC1 and TP20 racks and then branches out to describe the SP25 rack system.

More:

U nderstanding the ARC1 Rack

Understanding the ARC1 with a TP20 Stylus Changer

Understanding the SP25 Rack System


Understanding the ARC1 Rack

When using the ACR1, the system uses the Quickened joint between the probe head and the probe body. All of the slots in the ACR1 are identical, so if you had an SP600 in slot1, it would connect directly to the probe head. If you wanted to put a TP2 into slot2, you would need to mount an adapter to the TP2 (as with TP20 and TP200 probing systems).

With this configuration in mind, you only need to define one probe name for each slot. Technically, the ACR1 is a probe changer, and each probe would have a stylus already attached to it when it sits in the rack.

Suppose you want to assign these probes to the ARC1 rack: "SP600", "TP2", "TP20", and "TP200". The slot definitions in the ARC1 rack would be:

SLOT1 | SLOT2 | SLOT3 | SLOT4
SP600 | TP2 | TP20 | TP200


Understanding the ARC1 with a TP20 Stylus Changer

Now, if you want to combine the ACR1 with a TP20 rack (a stylus changer), things get slightly more complicated. The ACR1 will switch between the SP600 and the TP20 probe bodies. Once the system picks up the TP20, it will go to the MCR20 rack to pick up an appropriate stylus for it.

Suppose you have 3 separate styli that you wanted to use with the TP20 and that the SP600 is used as a single probe (no stylus changing).

When you define the slots, you might call the SP600 probe "SP600_1", and the TP20 probes with the varied styli attached, you might call "TP20_1", "TP20_2", and "TP20_3".

The slots in the ACR1 probe changer would be defined as:

SLOT1 | SLOT2 | SLOT3 | SLOT4
SP600 | TP2 | TP20_1 | TP200
 |  | TP20_2 |
 |  | TP20_3 |

The slots in the TP20 stylus changer would be defined as:

SLOT1 | SLOT2 | SLOT3 | SLOT4
TP20_1 | TP20_2 | TP20_3 | empty


Understanding the SP25 Rack System

You can extend the logic from the above topics to the SP25 rack system. This rack can hold two different types of probe components. For one type the slot is calibrated empty, and for the other type a slot is calibrated with an insert.

This discussion will abandon the previous references to SP600, TP2, TP20, and TP200 since the SP25 rack system uses these components instead:

q SP25M

q SM25-x

q SH25-x

For information on the SP25M and FCR-25 systems, view information on the internet by clicking these icons:

  • SP25M

  • FCR-25

The SP25M system can adapt to any of three different SM25 modules for varied styli lengths/weights, and a 4th module for use with the TP20. They all use the same SP25M probe body.

  1. SM25-1 Module – This module can only accept the SH25-1 stylus holder, and is used for styli lengths between 20mm and 50mm.

  2. SM25-2 Module – This module can only accept the SH25-2 stylus holder, and is used for styli lengths between 50mm and 105mm.

  3. SM25-3 Module – This module can only accept the SH25-3 stylus holder, and is used for styli lengths between 120mm and 200mm. Any of these SM25-x modules are capable of touch trigger probing as well as scanning.

  4. TM25-20 Module – This module can only accept the TP20 stylus holder, and is only used for touch trigger probing.

More:


Example of SP25 with Multiple Probes

Suppose your SP25 rack has these six probe assemblies that are always attached to the probe head:

P1 | P2 | P3 | P4 | P5 | P6
SP25M | SP25M | SP25M | SP25M | SP25M | SP25M
SM25-1 | SM25-1 | SM25-2 | SM25-3 | TM25-20 | TM25-20
SH25-1 | SH25-1 | SH25-2 | SH25-3 | TP20 | TP20
2mm by 20mm stylus | 4mm by 30mm stylus | 6mm by 80mm stylus | 8mm by 100mm stylus | 2mm by 20mm stylus | 4mm by 20mm stylus

You would define the slots in the FCR25 rack to hold components making up the various probe configurations. This first table shows the slots that hold components for the above probe configurations.

SLOT 1 | SLOT 2 | SLOT 3 | SLOT4 | SLOT5 | SLOT6
P1 | P1 | P2 | P3 | P4 | P5*
P2 |  |  |  |  |

In detail, the slots would hold these components:

SLOT 1 | SLOT 2 | SLOT 3 | SLOT4 | SLOT5 | SLOT6
SM25-1 | SH25-1 | SH25-1 | SH25-2 | SM35-3 | TM25-20
 | 2mm by 20mm stylus | 4mm by 20 mm stylus | 6mm by 80mm stylus | SH25-3 | TP20*
 |  |  |  | 8mm by 100 mm stylus | 2mm by 20mm stylus*

Slot 1 contains the SM25-1 module only. It uses no insert for this. This component attaches directly to the SP25 and requires the addition of the SH25-1 with the 2mm stylus found in Slot 2 or the SH25-1 with the 4mm stylus found in slot 3.

Slot 2 contains the SH25-1 stylus holder with an attached 2mm by 20mm stylus. This requires an insert in the slot to adapt the physical characteristics of the slot for this component. This component requires an SM25-1 module (found in slot 1). Once it picks up the SM25-1, the probe assembly is complete.

Slot 3 contains the SH25-1 stylus holder with an attached 4mm by 30mm stylus. This requires an insert in the slot to adapt the physical characteristics of the slot for this component. This component requires an SM25-1 module (found in slot 1) Once it picks up the SM25-1, the probe assembly is complete.

Slot 4 contains the SH25-2 stylus holder and an attached 6mm by 80mm stylus. It uses no insert for this. Once this is picked up, the probe assembly is complete.

Slot 5 contains the SM25-3 with the SH25-3 stylus holder and an attached 8mm by 100mm stylus. It uses no insert for this. Once this is picked up, the probe assembly is complete.

Slot 6 contains the TM25-20 module only. It uses no insert for this. This component attaches directly to the SP25M.

* When used with a single stylus, the TP20 probe module and stylus can be attached to the TM25-20 module while in the slot, and requires no additional rack system. But when used with multiple styli (as in this example), the TM25-20 module has no other components attached while it sits in the slot, but requires the use of additional FCR25 slots with adapters specifically for the purpose of holding the TP20 module/stylus combinations. For this example, the added 3 ports would look like this:

SLOT 7 | SLOT 8 | SLOT 9
P5 | P6 | empty

SLOT 7 | SLOT 8 | SLOT 9
TP20 | TP20 | empty
2mm by 20mm stylus | 4mm by 20mm stylus |

When using P1, the CMM would drop off any existing components. Then it would pick up the SM25-1 found in slot 1 of the FCR25 and proceed to pick up the SH25-1 found in slot 2 of the same rack.

When using P2, the CMM would drop off any existing components. Then it would pick up the SM25-1 found in slot 1 of the FCR25 and proceed to pick up the SH25-1 found in slot 3 of the same rack.

When using P3, the CMM would drop off any existing components. Then it would pick up the SM25-2 and SH25-2 combination found in slot 4. With this, the probe assembly is complete.

When using P4, the CMM would drop off any existing components. Then it would pick up the SM25-3 and SH25-3 combination found in slot 5. With this, the probe assembly is complete.

When using P5, the CMM would drop off any existing components. It would then pick up the TM25-20 body in slot 6 of the FCR25 and proceed to pick up the TP20 module/stylus combination in slot 7 of the FCR25.

When using P6, the CMM would drop off any existing components. It would then pick up the TM25-20 body in slot 6 of the FCR25 and proceed to pick up the TP20 module/stylus combination in slot 8 of the FCR25.

As with other tool changers and probe assemblies, components are dropped off in reverse order from how they are picked up.


Loading the Active Probe

Display Menu Roadmap

The Operation | Load Active Probe menu option loads the active probe required by the part program. While in Learn mode, use the Probe Utility dialog box (Insert | Hardware Definition | Probe) to change the loaded probe file(s). The Probe Changer Setup dialog box (Edit | Preferences | Probe Changer) allows you to define the appropriate probe configurations for each slot that will be used. The Load Active Probe option can then be used to tell the machine to exchange the necessary probe configuration(s).


Setting Up the Machine Interface

Display Menu Roadmap

This option is only available when working in On-line mode.

The Edit | Preferences | Machine Interface Setup menu option invokes the Machine Options dialog box for the specific machine interface being used. While the content of the interface tabs on the dialog box can vary greatly from one interface to the next, the tabs usually contain information discussing the setup of the following:

  • Machine and probe head communication

  • Mechanical offsets

  • Axes orientation

  • Debug information

The Machine Interface Setup option is only available when working on-line.

Caution: In most cases you shouldn't change any of the values in this dialog box. Some items in this dialog box, such as the Mechanical Offsets area, permanently overwrite values stored for your machine on the controller's hard drive. For questions on how and when to use the Machine Options dialog box, you should contact your local service representative:

The parameters found in the Machine Options dialog box are discussed for the following machine interfaces:

Axila

Backtalk (B&S)*

Bright

Dea

Elm

Embboard (B&S)*

Faro

Federal

GOM

Johansson

Leica

Leitz

LKDriver

LKRS232

Manmiti

Manmora

Metrocom/Metromec

Metrolog

Mitutoyo

Mora

MZeizz

Numerex

Omnitech

Reflex

Renishaw

Romer

Sharpe

Sheffield

Tech80

Theodole

Wenzel

Zeiss

ZssGPIB

*B&S = Brown & Sharpe

For more complete information on how to install/setup the various interfaces, refer to your installation documentation (Machine_Interface_Installation_Manual.doc).

More:

Restoring Factory Settings from the Controller

Assigning the Machine Axes

Generating a Debug File

OIT Communication

PH9 Communication

Rotary Table Settings

Setting the Communication Protocol

Setting the Axes Scale Factor

Wrist Configuration


Restoring Factory Settings from the Controller

For machines using a Leitz interface, if you've saved over your CMM 's original factory settings by clicking a Default button on one of the tabs on the Parameter Settings dialog box (Edit | Preferences | Parameters), you can still restore them by following this procedure:

  1. Access the Machine Options dialog box (Edit | Preferences | Machine Interface Setup). Display Menu Roadmap

  2. From the first tab you see, select the Read Machine Defaults on Startup check box. This tells PC-DMIS to query the CMM's controller for the CMM defaults the next time you start PC-DMIS.

  3. Click OK to close the dialog box.

The next time you run PC-DMIS, it will replace the values stored in the PC-DMIS Settings Editor with the CMM's original factory values stored in the controller.

Note: This procedure does not restore original factory values if you have overwritten them on the controller's hard drive.


Assigning the Machine Axes

Machine Options dialog box - Axis tab

The Axis tab contains lists for the X, Y, and Z axes. Select from these drop down lists, the native machine axes that will be assigned to the PC-DMIS axes.

Items in the drop down lists on the right represent the Machine's axes. These are then assigned to the PC-DMIS axes on the left.

WARNING: the axis directions you define MUST form a right-handed coordinate system.

Caution: Changing the defaults on the Axis tab can invalidate the machine's volumetric compensation (depending on the type of controller and the volumetric compensation used)


Generating a Debug File

PC-DMIS has the ability to generate a special text file that contains all the communication that takes place between PC-DMIS and the CMM during part program execution. This file is called the debug file and is used by technical support to resolve certain problems involving the CMM.

The debug file lists all the commands PC-DMIS sends to the CMM, responses received, and error messages generated by the controller.

If you encounter repeatable problems that involve the movement of your CMM in online mode, you can generate a debug file by following this procedure:

  1. From the Machine Options dialog box (Edit | Preferences | Machine Interface Setup), select the Debug tab.

Display Menu Roadmap

Machine Options dialog box - Debug tab

  2. Select the Log check box.

  3. Choose a name for the debug file name in the box next to the Log check box. The default filename is debug.txt. If desired, you can also precede the filename with a full pathway to specify the drive and directory where PC-DMIS should send the debug file. By default PC-DMIS writes the debug file to the directory where you installed PC-DMIS.

  4. Click Apply and then OK. The dialog box closes.

  5. Execute your part program and when you encounter the error, immediately exit PC-DMIS.

  6. Navigate to the directory containing your debug file and rename the debug file. If you don't rename the debug file, the next time you start PC-DMIS it will automatically overwrite all existing data stored in the debug file.

You should then send the debug file, the part program file (.prg), the probe file (.prb), along with any other needed files to your technical support representative.

More:

Starting a Fresh Debug File

Setting Additional Debug Options


Starting a Fresh Debug File

To start a fresh debug file and clear out all existing data, select the Reset Log at Start of Execution check box from the Debug tab. PC-DMIS will then replace the contents of the existing debug file each time it begins part program execution.

If you deselect Reset Log at Start of Execution, PC-DMIS appends to the existing log file instead of erasing its contents.


Additional Debug Options

Setting Additional Debug Options

You can control what type of debug information is logged and where it is sent.

  • Click the Window check box and provide a name for the window in the box to the right. Debug information will be displayed in that window for review.

  • Specify None, Both, Log or Window next to Position Reports to log position reports from PC-DMIS.

  • Specify None, Both, Log or Window next to From Machine to log debug information that is sent from your machine to your computer. Not all interfaces support this option.

  • Specify None, Both, Log or Window next to From CPU to log debug information that is sent from your computer to your machine. Not all interfaces support this option.


OIT Communication

Machine Options dialog box - Oit tab

The Oit tab allows you to configure the serial connection that connects to your OIT device. You can choose your communications port (COM port) and modify your COM port settings. For information on your COM port settings, check the documentation that came with your controller. The available OIT types are TESA, VORNE, or GE.


PH9 Communication

Machine Options dialog box - PH9 tab

The PH9 tab allows you to configure the serial connection that connects to your PH9 device. You can choose your communications port (COM port) and modify your COM port settings. For information on your COM port settings, check the documentation that came with your controller.


Rotary Table Settings

Machine Options dialog box - Rotary tab

The Rotary tab allows you to configure rotary table options for your interface.

Acceleration - This is the maximum acceleration for the rotary table. Normally this value is read from the controller configuration.

Velocity - This is the maximum speed for the rotary table. Normally this value is read from the controller.

Resolution - This specifies the scale factor for the rotary table.

Offset - The home position for your rotary table may not be at the zero position. If you want the table to go to the true zero position after homing then this value is the angle that you want the table to rotate to after homing. The second box next to Offset is for a second rotary table.

Min. delta - This is the minimum difference between the current table position and newly requested table position. If the difference is below this amount the table rotation request will be ignored.

Table - Select this option if your machine has a rotary table.

Dual Table - Select this option if your machine has dual rotary tables.

Note: Remember, the portlock must be programmed for rotary table.


Setting the Communication Protocol

Machine Options dialog box - Controller tab

The Comm or Controller tab allows you to configure the serial connection that connects to your Interface's controller. You can choose your communications port (COM port) and modify your COM port settings. For information on your COM port settings, check the documentation that came with your controller.


Setting the Axes Scale Factor

Machine Options dialog box - Resolution tab

The Resolution tab allows you to specify the scale factor for the each axis of your machine. The scale factor is used for two reasons:

  • Some controllers do not return scales as real numbers (e.g. 637.24319876) but as whole numbers (e.g. 63724319876). In this case, the whole number returned from the controller would need to be divided by scale factor of 1,000,000.0 to get the correct real number.

  • These values may also be used to perform as volumetric compensation for your machine. For example, if you have a small linear error you would use a scale factor of 9,998 instead of 10,000.

Caution: These values should only be changed by a trained technician. Altering these values may give an undesired result.


Wrist Configuration

Machine Options dialog box - Wrist tab

The Wrist tab allows you to specify the scale factor for the A & B axes of your wrist device in the A & B Resolution boxes respectively. The scale factor is used to convert values from your wrist device to consistent value in PC-DMIS.

The A and B Offset values are used to "square up" the home position of your continuous motion wrist.

The Max Speed box provides the maximum allowable speed (percent) for movement of your continuous motion wrist.

Caution: These values should only be changed by a trained technician. Altering these values may give an undesired result.


Axila Interface

Documentation for this exists in the PC-DMIS Portable documentation.


Backtalk Interface1

Backtalk Interface

The Backtalk interface is used with Brown & Sharpe manual machines with a Man 3 (External Serial Interface). If your machine has a light pen, you will need to alter the controller settings under the MM2 Control in the Settings Editor. For information on modifying registry entries, please view the "Modifying Registry Entries" section.

A monitor needs to be hooked to your controller to configure your Backtalk controller. Before starting PC-DMIS, rename the backtalk.dll to interfac.dll.

Note: If the customer has a Man3 box and is using the Z rail mouse, a light pen is needed to disable the Z rail mouse.

The Machine Option dialog box has four tabs for the Backtalk interface:

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 4800 Baud, Even parity, 7 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=1.0, Y=1.0, Z=1.0.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Bright Interface

The Bright interface is used with Mitutoyo Euro C (Bright) machines. This interface communicates to the controller through a proprietary card developed by Mitutoyo. If this installation is using a new PC, then the card must be removed from the original machine and put in the new one. If the customer needs to be able to still use their old software together with PC-DMIS, they both must be installed on the same machine.

Before starting PC-DMIS, rename the bright.dll to interfac.dll.

The Machine Option dialog box has two tabs for the Bright interface:

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Leica Interface

Documentation for this exists in the PC-DMIS Portable documentation.


Dea Interface

The Dea interface is used with DEA GAMMA and newer DEA machines (with Tutor P & B3P Series controllers), Manual Mistral machines (with M Inside Card controller) and Swift Manual machines (with "White Box" (AKA CPM3) controllers).

If your PC has Tutor for Windows already installed, PC-DMIS will locate the WTUTOR.INI file and extract the relevant information regarding location of the compensation map, mechanical offsets, etc. and set the corresponding options in the registry. If you are installing on a computer that does not have Tutor installed then you will need to make the relevant changes to the registry.

Before starting PC-DMIS, rename the dea.dll to interfac.dll.

The Machine Option dialog box has seven tabs for the Dea interface:

Dea tab

See the "Using the Dea tab" topic.

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 9600 Baud, Even parity, 8 data bits, and 1 stop bit.

PH9 tab

See the "PH9 Communication" topic. Default value is Comm Port 2, 4800 Baud, No parity, 8 data bits, and 1 stop bit.

Wrist tab

See the ""Wrist Configuration topic. Default values are: A Resolution = 3600, B Resolution = 3600, A Offset - 0.0, B Offset 0.0, and Max Speed = 100.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=10000.0, Y=10000.0, Z=10000.0.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Using the Dea tab

Machine Options dialog box - Dea tab

The Dea tab allows you to configure the following settings that are specific to the DEA interface:

Buffer Size - The number of moves that can be sent to the controller buffer at one time. Some machines will give errors if we send too many moves in advance so reducing this will help. Decreasing this value will however reduce the system performance, if for example we set it to 1 then we will only send the next move command when the machine has finished the previous one, this will cause the machine to pause between moves as each command is sent.

XYZ Mechanical Offset - These values allow you to establish the mechanical offset for your machine. This should only be adjusted by a trained technician.

Button Assignments - You can specify to have the Record button either Erase the Last Hit or act as the end/done key.

Poll Controller Commport - When this check box is enabled, PC-DMIS will periodically poll the serial port to prevent loss of communication. Only select this option if you suspect communication problems.

Disengage Drives - This check box should be selected for DCC machines which have drives that can be disengaged that are going to be used manually.

Compensation Type - Select from the following Volcomp methods: NONE, DEA Standard, DEA DLL (wcompens32), ASI, or Brown & Sharpe.

Compensation Mode - Select from the following compensation modes: Standard Machine, Dual Drive, Horizontal Arm (Arm 1), or Horizontal Arm (Arm 2).

Use DEA Structural Thermal Compensation OCX - Select this option to use DEA Structural Thermal Compensation OCX.

OCX Path - Specifies the path for the DEA Structural Thermal Compensation OCX file.

Machine Type - Specify the type of machine: Arm or Robot

Caution: These values should only be changed by a trained technician. Altering these values may give an undesired result.


Elm Interface

The Elm interface is used with an Elm or Starrett interface machines. This interface communicates with a board in the PC manufactured by API (Automated Precision, Inc). All direct communication to the controller is performed through this board. The PC-DMIS interfac.dll communicates with the API dll (dccsim32.dll) that must be in the PC-DMIS directory.

The elmsetup.exe setup program can configure the machine parameters that PC-DMIS uses. This file is located on the Wilcox ftp site in elmsetup.zip file that also contains the data and resource files required by the setup utility.

Before starting PC-DMIS, rename the elm.dll to interfac.dll.

Note: On Starrett machines the API.INI file can be used for configuration. Just add a qualified file name to the INI entry – INI_Filename.

The Machine Option dialog box has two tabs for the Elm interface:

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


BSEmbed Interface

Embboard Interface

The Embboard interface is used with Brown & Sharpe manual machines with an internal embedded controller card. This is a full-length card located in your PC with the address set to 300h. You must ensure that this address is not used by another board in the system (some network cards use this address).

Before starting PC-DMIS, rename the embboard.dll to interfac.dll.

The Machine Option dialog box has three tabs for the Embboard interface:

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=1.0, Y=1.0, Z=1.0.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Faro Interface

Documentation for this exists in the PC-DMIS Portable documentation.


Federal Interface

The Federal interface is used with Federal/Renault machines. This interface just requires a single RS-232 comm port.

Before starting PC-DMIS, rename the federal.dll to interfac.dll.

The Machine Option dialog box has three tabs for the Federal interface:

Comm tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 9600 Baud, Even parity, 8 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


GOM Interface

Documentation for this exists in the PC-DMIS Portable Portabledocumentation.


Johansson Interface

The Johansson interface is used with Johansson machines. This interface requires Proto software that is installed as part of the JoWin installation. When PC-DMIS starts it will also start the Proto software and terminate Proto when you exit PC-DMIS. Proto detects the communication setting to communicate with the controller.

Before starting PC-DMIS, rename the johansson.dll to interfac.dll.

The Machine Option dialog box has two tabs for the Johansson interface:

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Leitz Interface

The Leitz interface is intended for use on any of the controllers that utilize the Leitz protocol. This includes Brown & Sharpe controllers (such as the Sharpe 32Z in Leitz mode) as well as actual Leitz machines and also the Brown & Sharpe Common Firmware controllers. No machine parameter file is needed from the original system to run this interface.

Some of the newer controllers allow the use of TCP/IP communications as an alternative to a serial port. This interface supports either method. Examination and/or modification of the controller communications configuration is generally performed using the service utilities for the machine. PC-DMIS should then be configured to match how the controller is configured.

Before starting PC-DMIS, rename the leitz.dll to interfac.dll.

The Machine Option dialog box has eight tabs for the Leitz interface:

Leitz Protocol Setup tab

See the "Leitz Protocol Setup tab" topic.

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 9600 Baud, No parity, 8 data bits, and 1 stop bit.

Wrist tab

See the "Wrist Configuration" topic. Default values are: A Resolution = 3600, B Resolution = 3600, A Offset = 0.0, B Offset = 0.0, and Max Speed = 100.

Rotary tab

See the "Rotary Table Settings" topic. Default values are: Acceleration = 0.0, Velocity = 20, Resolution = N/A, Offset = 0.0, Min delta = 0.5, Table = Unchecked, and Dual table = N/A.

Oit tab

See the "OIT Communication" topic. Default value is Comm Port 0, 9600 Baud, No parity, 8 data bits, and 1 stop bit.

Axis tab

See the "Setting the Axes Scale Factor" topic.

Params tab

See the "Leitz Params tab" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Leitz Protocol Setup tab

Machine Options dialog box - Leitz Protocol Setup tab

The Dea tab allows you to configure the following settings that are specific to the DEA interface:

Read Machine Defaults On Startup - When this check box is enabled, PC-DMIS will query the CMM's controller for the CMM defaults the next time you start PC-DMIS. The next time you run PC-DMIS, it will replace the values stored in the PC-DMIS Settings Editor with the CMM's original factory values stored in the controller. Note: This procedure does not restore original factory values if you have overwritten them on the controller's hard drive.

Use TCPIP link to drive Machine - Select this option if you are using TCP/IP to connect to your controller.

TCPIP Address - Specify the TCP/IP address for your machine controller

TCPIP Port Number - Specify the port number that the controller is configured to listen to. Typically this will be port 2001.

Terminal button - Clicking this will open a terminal session with you controller based on the TCPIP settings.

Disengage Drives - This check box should be selected for DCC machines which have drives that can be disengaged that are going to be used manually.

Compensation Type - Select from the following Volcomp methods: NONE, DEA Standard, DEA DLL (wcompens32), ASI, or Brown & Sharpe.

Compensation Mode - Select from the following compensation modes: Standard Machine, Dual Drive, Horizontal Arm (Arm 1), or Horizontal Arm (Arm 2).

Use DEA Structural Thermal Compensation OCX - Select this option to use DEA Structural Thermal Compensation OCX.

OCX Path - Specifies the path for the DEA Structural Thermal Compensation OCX file.

Machine Type - Specify the type of machine: Arm or Robot

Caution: These values should only be changed by a trained technician. Altering these values may give an undesired result.


Leitz Params tab

Machine Options dialog box - Params tab

Max Speeds - These values are the maximum speeds for the X, Y, and Z axes. Normally these values are read from the controller.

Mechanical Offset - These values allow you to establish the mechanical offsets for your XYZ axes for your machine. Volcomp is normally performed in the controller itself with this interface. If for any reason it was configured to require a probe reference point other than 0,0,0 the values can be input in these offsets.

Max Scan Speed - This value sets the maximum allowed scan speed. This is only used for analog scans such as that with an SP600 probe or WAB optical probe.

Caution: These values should only be changed by a trained technician. Altering these values may give an undesired result.


LKDriver Interface

The LKDriver interface is used with the LK machines with LK3000 or LK2000 controllers. The common driver software must be obtained directly from LK. It must be installed and configured prior to attempting to install/use the PC-DMIS interface that utilizes it. The common driver DLL itself is named something similar to LKCMMDRV53.DLL, depending on the version number of the driver. There are also various other DLL’s that LK provides with the driver that must be present for the driver to work properly. The earliest version that can be used with the PC-DMIS interface is LKCMM21.DLL. Earlier versions are not compatible.

Before starting PC-DMIS, rename the lkdriver.dll to interfac.dll.

The Machine Option dialog box has three tabs for the LKDriver interface:

LK Driver tab

See the "LK Driver tab" topic.

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


LK Driver tab

Machine Options dialog box - LK Driver tab

The LK Driver tab allows you to alter LK Driver specific parameters.

Readout Interval (mSec) - This determines the frequency with which the position readouts will be updated when in readout mode. The value is an integer number of milliseconds. The default is 500 milliseconds (i.e. one half second).

LK Driver DLL - This identifies the name of the common driver DLL file that PC-DMIS will use. This may change with time as LK releases newer versions of the driver.

XYZ Mechanical Offset - These values allow you to establish the mechanical offsets for your XYZ axes for your machine. You can only edit these values when the Volcomp Method is set to ASI.

Man Hit Tolerance - This value is used to help distinguish between a real manual hit vs. pressing the manual print button. If pressing the manual print button is frequently misinterpreted as a manual hit you can try increasing this value. If manual hits are frequently misinterpreted as pressing the manual print button (same as hitting the END key) you can try decreasing this value. NOTE: To use the manual print button as the END key the CMM must not be in motion when the button is pressed. If it is still moving it will almost certainly be interpreted as a manual hit.

Minimum Rotab Move - This defines a cutoff for rotary table movement. If the newly requested table angle is not greater than this amount away from the current angle the move request will be ignored.

Man Print Button - This option allows you to designate a PC-DMIS function to the Manual Print key on the jog box if desired. The available options are DONE (end key), Move Point (store a move), or Erase Hit (Erase the last hit).

Note: For this interface the function assignment is only applicable when in ”r;hit” mode. If the button is pressed while the interface is switched to ”r;readouts” mode it will be interpreted as an illegal touch regardless of the setting for ManualPrintButton.

Volcomp Method - Select the LK (via Driver) to use the Volumetric Compensation from the driver or select ASI to assign these compensation values in the XYZ Mechanical Offset boxes.

Common Driver Config button - This button will launch the LK driver configuration application.

Caution: These values should only be changed by a trained technician. Altering these values may give an undesired result.


LKRS232 Interface

The LKRS232 interface is used with eight different LK controllers: Cupe Serial, Cupe GPIB, Micron Drive, LK3000, LK2000/2002/2000+, LK4000, the ACT, and the AIM. The LK-3000 is older than both the LK-2000 and the LK-4000. The ACT is the replacement for the 2000 line and the AIM is the replacement for the 4000.

Before starting PC-DMIS, rename the lkrs232.dll to interfac.dll.

The Machine Option dialog box has seven tabs for the LKRS232 interface:

LK Direct tab

See the "LK Direct tab" topic.

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 9600 Baud, No parity, 8 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=10000.000000, Y=10000.000000, Z=10000.000000.

Rotary tab

See the "Rotary Table Settings" topic. Default values are: Acceleration = 0.0, Velocity = 0.0, Resolution = 10000, Offset = 0.000000, Offset 2 = 0.000000, Min delta = 0.5, Table = Unchecked, and Dual table = Unchecked.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


LK Direct tab

Machine Options dialog box - LK Direct tab

The LK Direct tab provides specific settings for your LKRS232 interface.

LK 2000 - If the controller is an LK2000 type then this option needs to be selected.

LK 3000 - If the controller is an LK3000 type then this option needs to be selected. You must also select the LK2000 if you select the LK3000 option.

Micron Drive - If this controller is a Micron Drive, then this option need to be selected. Note: The Micron Drive controller never uses GPIB communications.

GPIB - Select this option if your controller uses the GPIB protocol to communicate.

PH9 - Select this option if you are using a PH9.

SETPT - If you find that the machine will not register hits then you may want to select this option.

Homing Velocity - This value sets the homing speed. If the machine drives to the limits before reaching the home position then you should decrease this value, turn the controller off, and try again. It should reach the limits and then find the home position for each axis if this value is correctly set. Default is 1.

Move Speed - This value sets the overall move speed. If you find the move speed is too fast even when you set it to a slow speed inside of PC-DMIS then you should decrease this value. Default is 1.00000

Wait for prehit - This value should be left at 0.

Move buffer - The number of moves that can be sent to the controller buffer at one time. Some machines will give errors if we send too many moves in advance so reducing this will help. Decreasing this value will however reduce the system performance, if for example we set it to 1 then we will only send the next move command when the machine has finished the previous one, this will cause the machine to pause between moves as each command is sent.

No start button - If there is no Master Start button on the controller (or jog box) then you should select this option.

Auto speed optimization - Certain LK controllers support Auto Speed Optimization, a controller feature that will drive each axis at its maximum independent speed for each move. If you know that your controller supports this then you can select this option.

Caution: These values should only be changed by a trained technician. Altering these values may give an undesired result.


Manmiti Interface

The Manmiti interface is used with Mitutoyo Manual machines with MAG-1, MAG-2, or MAG-3 controllers that connect to the scales. This is a GPIB interface.

Before starting PC-DMIS, rename the manmiti.dll to interfac.dll.

The Machine Option dialog box has two tabs for the Manmiti interface:

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Manmora Interface

The Manmora interface is used with manual Mora machines. This machine has a GEMODEK type MR01 counter box with XYZ readout with some control/setup/send options. See the MIIM for additional configuration and testing information.

Before starting PC-DMIS, rename the Manmora.dll to interfac.dll.

The Machine Option dialog box has four tabs for the Manmora interface:

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 9600 Baud, No parity, 8 data bits, and 2 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=1.0, Y=1.0, Z=1.0.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Metrocom Interface

Metrocom/Metromec Interface

The Metrocom interface is used with Metrocom, Metromec (with Metrocom S V2 & V3), and older Wenzel (Wenzel 2000 with Metromec Emulator) machines. For PC-DMIS to perform correctly the original startup file (METROCON.DAT) from the Metrocom software must be copied into the PC-DMIS directory.

Older Wenzel machines (with a Metrocom S controller for example) only need the METROCON.DAT file to operate. However, if you are using one of the newer Wenzel WP series controllers then you must also have the following four files copied from the MetroSoft software directories: WPMACH.PMC, WPSW.PMC, WPDAT.PMC, and WPGO.PMC

Before starting PC-DMIS, rename the METROcom.dll to interfac.dll.

The Machine Option dialog box has five tabs for the Metrocom interface:

Metromec tab

See the "Metromec tab" topic.

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 38400 Baud, No parity, 7 data bits, and 1 stop bit.

PH9 tab

See the "PH9 Communication" topic. Default value is Comm Port 1, 38400 Baud, No parity, 7 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Metromec tab

Machine Options dialog box - Metromec tab

The Metromec tab allows you to configure the following settings for the Metromec interface.

PH9 - Select this option if you are using a PH9.

Max Speed - This option sets the maximum speed for your CMM.

Acceleration - This option sets the maximum acceleration for your CMM.

XYZ Mechanical Offset - These values allow you to establish the mechanical offset for your machine. This should only be adjusted by a trained technician.

Compensation Data - When you are using the DEA compensation types the compensation data file (typically compens.dat) is specified in this box. When using the new DEA comp there are three text files that must be in the PC-DMIS directory: FZYFILE.TXT, RCXFILE.TXT, and RMXFILE.TXT.

Compensation Type - Select from the following Volcomp methods: NONE, DEA Standard, or DEA DLL (wcompens32).

Compensation Mode - Select from the following compensation modes are supported for DEA DLL (wcompens32) Compensation type: Standard Machine, Horizontal Arm (Arm 1), or Horizontal Arm (Arm 2).

Caution: These values should only be changed by a trained technician. Altering these values may give an undesired result.


Metrolog Interface

The Metrolog interface is used with Metrologic controllers. PC-DMIS has two modes of driving the Metrologic controller.

  • The first mode is executed through a Metrologic supplied MTDIAL.DLL file. This DLL requires a separate port lock available only from Metrologic. In this mode PC-DMIS calls functions in the MTDIAL.DLL in order to drive the CMM. All vol comp is also taken care of inside the DLL. The DLL talks to the designated Comm port and communicates directly with the CMM.

  • The second mode of driving the Metrologic controller is direct through the Comm port bypassing the MTDIAL.DLL altogether. In this mode, there is no separate port lock needed from Metrologic. PC-DMIS will talk directly to the controller through the designated Comm port. Vol comp is provided in three formats 1) the DEA Tutor format, 2) the Wcompens32.dll format. 3) the BNS comp.dat format. Options one and two are typically what are used on a DEA controller machine. Option 3 is typically what is used on an Excel CMM. The only reason for using the first mode is to take advantage of the Metrologic supplied vol comp that might already be on an existing CMM.

Before starting PC-DMIS, rename the metrolog.dll to interfac.dll.

The Machine Option dialog box has three tabs for the Metrolog interface:

Comm tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 9600 Baud, Even parity, 8 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Mitutoyo Interface

The Mitutoyo interface is used with Mitutoyo machines. This is a GPIB interface and does not require any machine parameter file from the original Mitutoyo system. Mitutoyo considers these machines mechanically accurate so no native software compensation exists. Several compensation methods, however, are supported.

To take manual hits with these machines you need to push down the ‘MEAS’ button on the jog box.

Note: For machines with a PH9 or PH10 the normal machine startup sequence includes using the manual control to specifically position the head (usually to 0,0). This insures that all communications between the PH9/10 controller and the head itself are initialized and working properly. This should still be done even if it initially reads 0,0 and you want to position it to 0,0. Failure to initialize the head via the handset can lead to failures when trying to do a DCC rotation (it may not rotate all or in some cases may produce errors after it appears to finish rotating).

Before starting PC-DMIS, rename the mitutoyo.dll to interfac.dll.

The Machine Option dialog box has four tabs for the Mitutoyo interface:

Interface tab

See the "Mitutoyo Interface tab" topic.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=10000.0, Y=10000.0, Z=10000.0.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Mitutoyo Interface tab

Machine Options dialog box - Interface tab

The Interface tab allows you to configure the following settings for the Mitutoyo interface.

PH9 - Select this option if you are using a PH9.

Old Joystick - If the Jog box is an old type then this option must be set to 1. (If the jog box functions do not perform as set out below then you have an old joy stick)

BHN 706 - Select this option if you are connecting to a BHN 706 CMM.

Top Speed - This sets the overall top speed for the machine. If this value is too high then you will get intermittent ‘overspeed’ errors from the controller during DCC moves. Default is 60.

In Position Tolerance - This is the value that sets how close the machine has to get to a commanded position before it accepts that it is there. If the machine seems to pause between moves for excessive time then you could try increasing this value.

Caution: These values should only be changed by a trained technician. Altering these values may give an undesired result.


Mora Interface

The Mora interface is used with Mora CNC machines. This interface just requires a single RS232 comm port, no machine parameter file is needed from the original system.

Before starting PC-DMIS, rename the mora.dll to interfac.dll.

The Machine Option dialog box has three tabs for the Mora interface:

Comm tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 9600 Baud, No parity, 8 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


MZeizz Interface

The MZeiss interface is used with manual Zeiss machines.

Before starting PC-DMIS, rename the Mzeiss.dll to interfac.dll.

The Machine Option dialog box has four tabs for the MZeiss interface:

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 9600 Baud, Even parity, 8 data bits, and 2 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=1.0, Y=1.0, Z=1.0.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Numerex Interface

The Numerex interface is used with Numerex machines. There are two different types of Numerex interfaces available, one with a Digital Readout Unit (DRO) and one without. The DRO version is straightforward to install but if your machine has no DRO then a Tech80 card will be needed (to read the scales) as well as a special kit to connect the Tech80 to the Numerex controller. See the MIIM for installation information for these two interfaces.

No machine parameter file is needed from the original system to run this interface.

Before starting PC-DMIS, rename the Numerex.dll to interfac.dll.

The Machine Option dialog box has four tabs for the Numerex interface:

Numerex tab

See the "Mitutoyo Interface tab" topic.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=1.0, Y=1.0, Z=1.0. This scale factor is used if a DRO unit is present.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Numerex tab

Machine Options dialog box - Numerex tab

The Numerex tab allows you to configure the following settings for the Numerex interface.

DRO - Select this option if your system uses a DRO to read the scales.

DRO Comm - Specify the COM port for the DRO unit.

PH9 - Select this option if you are using a PH9.

4800 N 8 1 - Select this option if your PH9 unit need to use these communication settings rather than the default of 4800 baud NO parity 7 bits 2 stop bits (48007N2). Usually, you need to select this option if it is a ceramic CMM (a newer CMM). If the CMM is older, you will need to deselect this option.

PH9 Comm - Specify the COM port for the PH9 unit.

DCC Controller Comm - Specify the COM port for the DCC Controller.

Key Board Comm - Specify the COM port for the Keyboard.

Use Tech 80 - Select this option if your system uses a Tech 80 board to read the scales.

Tech 80 IRQ - This value sets the interrupt level for the Tech80 board. Make sure it matches the jumper setting and also the WNS27 registry settings.

Tech 80 XYZ Scale - These XYZ Scale options allow you to specify the scale factor for each axis if a Tech80 is used. This is normally a value of 200.0. A simple way to test if this value is correct is to measure the distance between to known points, if there is a difference between measured and true readings then you can work out the correction factor that you can use to determine the value, it is almost always a round value i.e. 100, 1000, 500 etc. A rudimentary form of linear error compensation (linear stretch) can be performed by slightly changing this value.

In Position Tolerance - This value sets how close the machine must get to a commanded position before it accepts that it is there. If the machine seems to pause between moves for excessive time then you could try increasing this value.

Acceleration - This option sets the acceleration of the CMM during DCC moves. The default value is 1500. If the CMM is a little too jerky in starting and stopping a move, lower the acceleration value.

Top Speed - This option is simply a multiplier of the machine speed allows you to govern the maximum speed of the machine. It should be adjusted so that 100% speed in PC-DMIS matches the full speed of the machine.

DCC Machine - The only time this option should NOT be selected is for debugging purposes when you wish to test the DRO without running this as a DCC machine. If this is a manual machine then the straight Tech80 interface should be used.

Has Home - Select this option if the machine has a home position. It must be selected if you are using a comp map.


Omnitech Interface

The Omnitech interface is used with Omnitech machines. This interface communicates to the controller through a standard RS-232 interface.

Before starting PC-DMIS, rename the omnitech.dll to interfac.dll.

The Machine Option dialog box has two tabs for the Omnitech interface:

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Reflex Interface

The Reflex interface is used with a Reflex controller. This interface is intended for use on a manual Gage 2000 machine with the Reflex box in Pass Through Mode. There are 2 ”smart cards” that are inserted in the controller. The upper one is the storage card, where the programs are stored. After turning on the Reflex Controller, you will notice the following screens:

Before starting PC-DMIS, rename the Reflex.dll to interfac.dll.

The Machine Option dialog box has four tabs for the Reflex interface:

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 9600 Baud, No parity, 8 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Renishaw Interface

The Renishaw interface communicates with the Renishaw installed software (V4.0 or later). There is also a special interface card (or USB module) that is used to communicate via optical link with the UCC1 controller. The software and interface card must be obtained from Renishaw.

Before starting PC-DMIS, rename the Renishaw.dll to interfac.dll.

The Machine Option dialog box has two tabs for the Renishaw interface:

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Romer Interface

Documentation for this exists in the PC-DMIS Portable documentation.


Sharpe Interface

The Sharpe interface includes the Sharpe, Sharpe 32, and Excel interfaces. PC-DMIS must have the DOWNL.OAD file from the original software package in order to run. If Software compensation is being used then the COMP.DAT file is also required. See the MIIM documentation for the Sharpe interface for more information about creating the DOWNL.OAD file.

For systems configured with dual rotary tables a second controller is used that controls only the second table. In that situation, PC-DMIS must have a DOWNL2.OAD file suitably configured for use on a controller with only the W axis being used. Currently there is no compensation for the table only so there is no need for a COMP2.DAT file.

Before starting PC-DMIS, rename the sharpe.dll to interfac.dll.

The Machine Option dialog box has seven tabs for the Sharpe interface:

Sharpe32 tab

See the "Sharpe32 tab" topic.

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 4800 Baud, Even parity, 7 data bits, and 1 stop bit.

Controller2 tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 0, 4800 Baud, Even parity, 7 data bits, and 1 stop bit.

Oit tab

See the "OIT Communication" topic. Default value is Comm Port 0, 9600 Baud, No parity, 8 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=0.0, Y=0.0, Z=0.0.

Rotary tab

See the "Rotary Table Settings" topic. Default values are: Acceleration = 46500.0, Velocity = 46500.0, Resolution = 5000.0, Offset = 0.0, Min delta = 0.5, Table = Unchecked, and Dual table = Unchecked.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Sharpe32 tab

Machine Options dialog box - Sharpe tab

The Sharpe32 tab allows you to configure the following settings for the Sharpe interface.

Buttons Print - You can specify to have the Record button Erase the Last Hit, Store a Move, or act as the end/done key.

Manual - Select this option if you are using a manual (no DCC capability) machine.

Verify PH9 - Some controllers do not reliably position the PH9 to the requested angle. When you select this option, the PH9 position will be checked after the requested rotation and if the position is not correct the PH9 move will be repeated.

Single EStop Message - If you select this option then when E-stop is pressed the E-stop warning message will only be shown once while still in the E-stop state instead of continuously repeating it. This allows the user to E-stop the machine and then manually move the probe (for scribing as an example) while still being able to access the normal PC-DMIS user interface functionality.

Circular moves - Select this option if your controller supports the use of circular moves.

Poll Controller Commport - When this option is selected, PC-DMIS will periodically poll the controller serial port to affirm communication. This is a useful option to try if you suspect problems with your PC's RS232 port.

Disable Auto Cancel - Some types of errors (example is some types of PH9 errors) can be immediately reset but keep recurring. The result is a situation where the error message window flashes too quickly to read and keeps repeating. When this option is selected, this will prevent the error message dialog from being ”auto cancelled” in order to provide sufficient time for the user to read the error message. Note that during homing of the machine, some dialogs will be auto-cancelled regardless of this setting.


Sheffield Interface

The Sheffield interface is used with Sheffield machines. No machine parameter file is needed from the original system to run this interface. On the Sheffield CMM, PC-DMIS does not control when the CMM is in manual control or DCC control. The buttons to control this are on the jog box. If the CMM has a rotary table, PC-DMIS requires a separate Tech80 card for the rotary table encoder.

Before starting PC-DMIS, rename the sheffield.dll to interfac.dll.

The Machine Option dialog box has four tabs for the Sheffield interface:

Interface tab

See the "Sheffield Interface tab" topic.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=1000, Y=1000, Z=1000.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Sheffield Interface tab

Machine Options dialog box - Interface tab

The Interface tab allows you to configure the following settings for the Sheffield interface.

RS232 - Select this option if you plan on using RS232 rather than GPIB. All newer Sheffield controllers, SMP3xx and SMP400, use serial communications.

LPT2 - Select this option if your system uses the MSI board to read the scales.

Tech80 - Select this option if this system uses the Tech80 board to read the scales.

Manual Machine - Select this option if this is a manual machine. Note: Use this option for testing purposes only, if this is to be a dedicated manual machine then the Tech80 interface should be installed.

RS50 - Select this option if this system uses RS50.

Machine Port - This value sets the RS232 comm port for the controller.

Tech80 IRQ - This option sets the interrupt value for the XYZ tech80 board. If you do change it, make sure that the jumper on the tech80 card is the same. Default is 5. Note: This does not apply to the rotary table Tech80board. It does not require an interrupt.

Hit Delay - This is the delay time before reading a hit from the MSI board. Default is 0.3. If this value is too small then the board will be read too quickly and get an incorrect reading. If you are having accuracy problems then you may want to try fractionally increasing this value. Note: If you are using the MP Hits option then changing this value will have no effect.

Reset Delay - Some MP units will hang if commands are sent too quickly. You can increase this value if you suspect this to be the case, however increasing this value will reduce system performance. Note: When running with SMP400, this value needs to be 1.0.

PH9 - Select this option if you are using a PH9.

PH9 Handbox (PH9D) - If the PH9 'pendant' hand held control unit is present then select this option.

PH9 Baud - This value sets the baud rate for the PH9. Valid values are 300, 1200, 4800, or 9600. By default the serial protocol used is No stop bits, 8 data bits, and 1 parity bit (N81).

PH9 Port - This option sets the RS232 comm port for the PH9.

MP Hits - Selecting this option will cause PC-DMIS to get its hit data from the Sheffield MP unit instead of the tech80 board. The advantage of this is that the MP unit provides compensated data so no ASI comp map needs to be created. The disadvantage is that this option disables the functionality of the Jog Box macro keys (End, Erase hit, store move, etc.) while in TakeHits mode (see the JogBoxToggle option below). Note: There is no need to use this option you are using the MSI board because this board already reports back compensated data, also make sure if you are using a Tech80 board that the probe cable is NOT connected to the probe signal in the MP unit.

MP Vectors - When this option is not selected, PC-DMIS will track the vectors of hits by reading the position of the probe before a hit is taken. Selecting this option will cause PC-DMIS to get the vectors directly from the MP unit. The disadvantage is that this option disables the functionality of the Jog Box macro keys (End, Erase hit, store move, etc.) while in TakeHits mode (see the JogBoxToggle option below). Note: Some of the older systems do not support this function. If you get an 'Invalid Parameter 21' error when you initialize with this option then your system does not support it. If you are using MP Hits then you should (if supported) use this option.


Tech80 Interface

The Tech80 This interface supports the manual Tech80 and Scazon Card interfaces. No machine parameter file is needed from the original system to run this interface.

Before starting PC-DMIS, rename the TECH80.dll to interfac.dll.

The Machine Option dialog box has four tabs for the Tech80 interface:

Connection tab

See the "Tech80 Connection tab" topic.

Axis tab

See the "Assigning the Machine Axes" topic.

Resolution tab

See the "Setting the Axes Scale Factor" topic. Default is X=1000.0, Y=1000.0, Z=1000.0.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Tech80 Connection tab

Machine Options dialog box - Connection tab

The Connection tab allows you to configure the following settings for the Tech80 interface.

Interrupt - This value sets the interrupt level for the Tech80 card, if you change it make sure the jumper on the card is set to the same level.

Request interval - This value controls the speed PC-DMIS tracks the position of the probe. This value is entered in milliseconds (e.g. 300 is 0.3 seconds) The default value of 300 will request the position roughly 3 times a second.

Hit interval - This value controls how much time must pass after a hit before a second hit is valid. It is useful to prevent 'double hits' as the probe retracts from the part. It is entered in milliseconds (e.g. 500 is 0.5 seconds.)

Zero counters on startup - Select this option to Zero the counters when PC-DMIS is started.

Zero counters button - Click this button to Zero the counters.


Theodole Interface

The Theodole interface is used with a Theodolite machine.

Before starting PC-DMIS, rename the theodole.dll to interfac.dll.

The Machine Option dialog box has four tabs for the Theodole interface:

Controller tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 1, 19200 Baud, Even parity, 7 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Wenzel Interface

The Wenzel interface is used with Wenzel machines with a Wenzel 2010 controller (Native Wenzel Protocol). This interface just requires a single RS232 comm port, no machine parameter file is needed from the original system.

Before starting PC-DMIS, rename the wenzel.dll to interfac.dll.

The Machine Option dialog box has two tabs for the Wenzel interface:

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


Zeiss Interface

The Zeiss interface is used with machines using IP-based Zeiss controllers. This new interface supports both TCP and UDP protocols. Because of the minor differences that we have observed among these controllers this interface was designed to allow modifications to a configuration file to accommodate these differences without requiring a new interfac.dll. Additionally, most of the configuration options for the controller have been moved to this configuration file as well to allow for future WAI utilities to communicate with the machine without having to run PC-DMIS.

Supported probes include the standard Zeiss probe, RDS, DSE, and Vast. The old jogboxes are supported (both the small one with the numeric pad as well as the larger keypad one) and the newer jogboxes (that are a laptop) can be supported with an additional IP based utility that allows basic function buttons to be used.

Before starting PC-DMIS, rename the Zeiss.dll to interfac.dll.

The Machine Option dialog box has four tabs for the Zeiss interface:

PH9 tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 0, 4800 Baud, No parity, 8 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


ZssGPIB Interface

ZssGPIBs Interface

The ZssGPIB interface is used with Zeiss machines with RS232 of GPIB based controllers. This interface supports the GPIB Zeiss controller (gray two feet square box). The PH9 is controlled through an RS232 port.

There is also support for a native RS232 connection (Zeiss C99 controller) with this interface whereas the ZSSRS232.DLL drives the ZEISS CMM through the ZEISS UMESS/COMET Software package. Whether PC-DMIS communicates with GPIB or RS232 is determined by the RS232CMM option in the ZEISS section of the Settings Editor. For the native RS232 this should be set to 1. For information on modifying registry entries, please view the "Modifying Registry Entries" section.

Before starting PC-DMIS, rename the zssgpib.dll to interfac.dll.

The Machine Option dialog box has four tabs for the ZssGPIB interface:

PH9 tab

See the "Setting the Communication Protocol" topic. Default value is Comm Port 0, 4800 Baud, No parity, 8 data bits, and 1 stop bit.

Axis tab

See the "Assigning the Machine Axes" topic.

Debug tab

See the "Generating a Debug File" topic.

Note: Additional information for this interface is provided in the Machine Interface Installation Manual (MIIM).


 Sensor Numbers boxes Material Coefficient boxes boxes Current Temp boxes Prev Temp boxes Ref Temp boxes High Threshold boxes Low Threshold boxes Origin boxes Qual Tool check box Show Temperatures in Celsius Temperature Compensation Enabled check box Compensation Method list Time Remaining Delay Before Reading Part Reset to Defaults button Get Current Temps button OK button Cancel button Default button

Compensating for Temperature

Display Menu Roadmap

Temperature Compensation Setup dialog box

Selecting the Edit | Preferences | Temp Comp Setup menu option opens the Temperature Compensation Setup dialog box. This dialog box allows you to compensate for room and part temperature, thus increasing accuracy of the inspection process.

To compensate for temperature during multiple arm calibration, see "Using Temperature Compensation with Multiple Arm Calibration" in the "Using Multiple Arm Mode" section.

More:

Using STP Files

Available Input Parameters

TEMP COMP Command in the Edit Window

Controller Support

Local Temperature Settings


Using STP Files

Each CMM uses machine-specific parameters for temperature compensation for each axis, such as thermal coefficients and sensor assignments. These parameters, along with embedded code that tells PC-DMIS if the file is a structural or linear compensation file, are stored inside special STP files (named for the .stp extension) created by your CMM vendor.

PC-DMIS requires these STP files to compensate for temperature.

Prior to compensating for temperature, ensure that these STP files reside in the appropriate locations on your hard drive:

  • The DEA Structural Thermal Compensation method expects to find the Serv1.stp file in the C:\Thermal_OCX directory.

  • The DEA Linear Thermal Compensation method expects to find the Serv1.stp file in the C:\Program Files\Thermal_OCX directory.

More:

Linear and Structural Temperature Compensation


Linear and Structural Temperature Compensation

Linear compensation = (Thermal Coefficient of Expansion) X (Displacement + Change in Temperature of Each Axis and the Part). If multiple temperature sensors exist on an axis, PC-DMIS averages the readouts to find the temperature change.

Structural compensation recognizes that a CMM 's various material components may have different temperatures (a single axis of the machine, for example, may have several different temperatures, which cause bending, bowing or skewing of the machine in some way). Structural compensation, then, applies the temperature corrections for specific areas of the CMM. When you select the Edit | Preferences | Temperature Compensation menu item, the Structural Thermal_OCX gets called and PC-DMIS calculates a new temporary volumetric compensation map.


 Sensor Numbers boxes Material Coefficient boxes boxes Current Temp boxes Prev Temp boxes Ref Temp boxes High Threshold boxes Low Threshold boxes Origin boxes Qual Tool check box Show Temperatures in Celsius Temperature Compensation Enabled check box Compensation Method list Time Remaining Delay Before Reading Part Reset to Defaults button Get Current Temps button OK button Cancel button Default button

Available Input Parameters

Display Menu Roadmap

The following explain the available input parameters on the Temperature Compensation Setup dialog box (Edit | Preferences | Temperature Compensation).

Temperature Compensation Setup dialog box

More:

Sensor Numbers boxes

Material Coefficient boxes

Current Temp boxes

Prev Temp boxes

Ref Temp boxes

High Threshold boxes

Low Threshold boxes

Origin boxes

Show Temperatures in Celsius

Temperature Compensation Enabled

Compe nsation Method

Time Remaining

Delay Before Reading Part

Reset to Defaults

Get Current Temps


Sensor Numbers boxes

The Sensor Numbers boxes contain a list of one or more sensor numbers to be used for the given axis or part. These values are very important when reading temperatures from the controller because they must correspond to how the sensors are actually configured.

  • Each sensor is a number in the range of 1 to 32.

  • Items in the list can be either a single number or a range from first to last.

  • Items are separated by either commas or left blank.

  • The input allows up to 32 values for any axis or the part.

For ”manual” mode these numbers are relatively meaningless but at least one sensor number must be assigned for each axis and the part.


Material Coefficient boxes

The Material Coefficient boxes contain numbers reflecting the material property, and are the fractional change in length per unit change in temperature.

  • Values vary depending on what type of material was used to make the scales on the machine axes and on what the part is made of.

  • Units are per degree C or per degree F, depending on the selection of the check box for displaying in Celsius or not.

  • This can be thought of as meters/meter/degree C or inches/inch/degree F but since the length in both the numerator and denominator are in the same units they divide out.

Example: A scale with a coefficient of 11.5 microns /meter/degree C becomes 0.0000115 meters/meter/degree C or just 0.0000115/degree C.

Qual Tool

This box allows you to specify the material coefficient for the probe qualification tool separately from the part.

Acceptable Part Values on Leitz Machines

In versions v42 MR2, v43 MR1 and later, if you are using a Leitz machine, PC-DMIS will force you to use an acceptable material coefficient value in the Part box. An acceptable value lies within the range of -.0001 through 0.001 Meters/Degrees Celsius (or -0.00056 through .00056 Inch/Degrees Fahrenheit).

  • If you enter a value outside this acceptable range in the Temperature Compensation Setup dialog box, a warning message will appear and the value in the Part box will be reset to 0.0.

  • If you open a part program created from an older version of PC-DMIS that permitted unacceptable values, a message box will now inform you of the unexpected material coefficient value and PC-DMIS will reset the value to 0.0.

  • If you attempt to manually edit the TEMPCOMP/ORIGIN command to use an unacceptable value, PC-DMIS will display an error message within the Execution Mode Options dialog box during execution. The message will inform you that the Part material coefficient value is out of range. The only option is to click Cancel and modify the command to contain an acceptable value.


Current Temp boxes

The Current Temp boxes contain the current temperatures in the appropriate units. You can either type these or read them in from the controller depending on the type of machine available and the selected options.


Prev Temp boxes

The Previous Temp boxes always contain the previously read temperatures. If no temperatures were previously read in, these values are either zero or left blank.


Ref Temp boxes

The Ref Temp boxes contain the reference temperature from which temperature compensation adjustments need to be applied.

  • The amount of correction to be applied is based on multiplying the material coefficient by the difference between the current and reference temperatures.
    Amount of Correction = Material Coefficient x (Current Temp – Reference Temp)

  • If the current temperature is the same as the reference temperature the net effect is that no thermal compensation adjustment is applied.

  • The value in these boxes is almost always 20 degrees C, or the Fahrenheit equivalent.


High Threshold boxes

The High Threshold boxes contain an upper limit (in the appropriate units) on the current temperature above which no further thermal compensation will be applied. PC-DMIS doesn't produce any warning or error message.

Example: With a reference temp of 20 degrees C, a current temp of 35 degrees C and a high threshold of 30 degrees C the amount of correction actually applied would be based on a difference of (30 – 20) instead of (35 – 20) because the current temperature exceeded the upper limit.


Low Threshold boxes

The Low Threshold boxes is conceptually like the high threshold except it provides a lower limit on the current temperature below which no further thermal compensation will be applied.


Origin boxes

The Origin boxes are used to determine the length of the item to which thermal compensation is being applied.

Length = Current Position Value – Origin Value

  • The X, Y, and Z values of the Origin boxes will be zero most of the time. However, some types of machines do not use zero for the origin of their scales.

  • The Part value will typically also be zero unless there is some special type of fixturing constraint.


Show Temperatures in Celsius

The Show Temperatures in Celsius check box affects both the temperatures and the material coefficient.

  • If you select this check box, the display will use degrees Celsius.

  • If you clear this check box, PC-DMIS will use degrees Fahrenheit.


Temperature Compensation Enabled

The Temperature Compensation Enabled check box tells PC-DMIS to use temperature compensation.

  • If not selected, PC-DMIS does not perform any temperature compensation, and the TEMPCOMP command (if present in the part program) will have no effect.

  • If selected, PC-DMIS behaves according to the input parameters.


Compensation Method

The following are the available compensation methods and their respective processes in PC-DMIS.

For Sheffield controllers, you must define the Material Coefficient and Ref Temperature boxes, and then click Default, regardless of the compensation method used.

Method

Process

Manual

ü Compensation is manual (controlled by your input) with no involvement from the machine controller.

ü PC-DMIS performs all compensation calculations.

ü During part program execution the Temperature Compensation Setup dialog box opens and you can edit the current settings before proceeding with the rest of the program.

Read Temperatures from Controller

ü When using a machine that supports this option, PC-DMIS reads the current temperatures from the controller automatically rather than you supplying the data.

ü PC-DMIS performs all compensation calculations. The controller only provides the current temperatures.

ü During part program execution the Temperature Compensation Setup dialog box does not open.

ü The part program does not pause for your confirmation.

For Sheffield controllers, you can retrieve the CTE (Coefficient of Thermal Expansion) values for the Axes by clicking the Get Current Temps button.

Controller Compensates Axes Only

ü The controller performs compensation of the machine axes itself.

ü The inputs for the axes will not be used.

ü Part input parameters apply since PC-DMIS still performs compensation for the part.

ü During part program execution the Temperature Compensation Setup dialog box does not open.

ü The program does not pause for your confirmation.

Controller Comps Axes and Part

ü The controller performs compensation of both the machine axes and the part.

ü The inputs for the axes are not used.

ü PC-DMIS does not perform any compensation calculations.

ü The input for the part for the material coefficient, reference temperature and origin must still be supplied because PC-DMIS must pass that information down to the controller.

ü During part program execution the Temperature Compensation Setup dialog box does not open.

ü The program does not pause for your confirmation.

For Sheffield controllers, you do not need to enter the CTE values for the Axes.


Time Remaining

The Time Remaining display shows the time remaining before the temperature reading takes place. This only displays if you set up a delay period for execution. See ”Delay Before Reading Part”.


Delay Before Reading Part

The Delay Before Reading Part box allows you to specify a period that PC-DMIS will wait during part program execution before reading the Sensors to obtain the current temperatures. If zero is entered then there is no pause.


Reset to Defaults

The Resets to Defaults button updates any previously modified values with the previously saved values. If this is on a DEA machine and a serv1.stp is available then PC-DMIS will read that file.


Get Current Temps

If you select the Read Temps from Controller method from the Compensation Method list, and if you use a machine that supports this option, the Get Current Temps button causes PC-DMIS to read the current temperatures from the controller and display them in the Temperature Compensation Setup dialog box.


TEMP COMP Command in the Edit Window

When you accept the inputs in the Temperature Compensation Setup dialog box by clicking the OK button PC-DMIS inserts a TEMPCOMP command into the part program.

Example of Inserted TEMPCOMP command

Normally a part program will only use one TEMPCOMP command The TEMPCOMP command should be placed near the top of the program prior to any measurements. When you execute the part program, it behaves according to the various input parameters.


Controller Support

Not all comp methods are supported by all controllers. The following are the supported controllers for the different compensation methods. See ”Compensation Method”.

Compensation Methods | Supported Controllers
Manual | All, there is no controller involvement with this method
Read Temps from Controller | DEA (only with DEAC family controllers), Sharpe32z using Leitz protocol, Sheffield
Controller Comps Axes Only | Sharpe32z using Leitz protocol
Controller Comps Axes and Part | Sharpe32z using Leitz protocol, Sheffield


Local Temperature Settings

When opening a part program containing a TEMPCOMP command, PC-DMIS will verify the part sensor number with the local settings.

  • If the values differ, PC-DMIS will automatically update the command to reflect the current settings, and a comment will be inserted into the part program reflecting the old and new values.

  • If no local setting is available for the part sensor, PC-DMIS will mark the TEMPCOMP command RED in the Edit Window.


Specifying External Directories to Search

Display Menu Roadmap

Search Path dialog box

The Edit | Preferences | Set Search Path menu option displays the Search Path dialog box. This dialog box allows you to specify the directories that PC-DMIS uses when:

  • Exporting CAD or Program files

  • Importing CAD or Program files

  • Loading Part Program Files (.prg)

  • Loading Probe Files (.prb)

  • Recalling alignments (.aln)

  • Calling Subroutines

To specify a default directory to use:

  1. Access the Search Path dialog box.

  2. Select an item from the Search For list.

  3. Type the directory pathway in the box (or use the Browse button to select a directory).

  4. Click the Apply button.

  5. As needed repeat these steps to set additional default directories for other items.

  6. Click the OK button. The changes will be made and the dialog box will close.

Note: If you selected Probe Directory, Recall Directory, or Subroutine Directory from the Search For list, additional check boxes become available for selection. These are described below.

The Search Path dialog box contains the following options:

More:

Search For

Search Current Directory

Search Current Directory First

Search Specified Directory

Browse Button


Search For

The Search for drop-down list lets you select one of these options:

  • Default Export Directory

  • Default Import Directory

  • Default Part Program Directory

  • Probe Directory

  • Recall Directory

  • Subroutine Directory

For each of these, you can define a directory that PC-DMIS will search in when the command for the selected option is encountered in the Edit window.


Search Current Directory

The Search Current Directory check box enables or disables searching within the current directory.


Search Current Directory First

When selected, (and if both the Search Current Directory and the Search Specified Directory check boxes are selected) this check box allows you search in both the current directory and the user specified directory. The order of the search depends on if this check box is selected:

  • If selected PC-DMIS will first access the current directory and then the user specified directory.

  • If cleared, the search order will be reversed, accessing first the user specified directory and then the current directory.


Search Specified Directory

The Search Specified Directory check box enables or disables searching in a directory you specify. The pathway for the directory you specify will be entered in the box just below the check box.


Browse Button

The Browse button allows you to browse for a user specified directory. When clicked, your system's directory structure will appear:

Example of one system's directory structure inside the Choose Directory dialog box.

The Choose Directory dialog box contains the folders and levels of folders available to you. Simply, highlight the directory you want PC-DMIS to search in and click the OK button. PC-DMIS returns you to the Search Path dialog box. Notice that the directory pathway now appears in the Search Specified Directory box.

Note: The directory structure in the Choose Directory dialog box varies from computer to computer. The above is only an example of what you may encounter.


Changing OpenGL Options

Display Menu Roadmap

OpenGL Options dialog box

The Graphics Display window must have the focus for this menu option to become available.

The Edit | Preferences | OpenGL menu option brings up the OpenGL Options dialog box. This dialog box allows you to change the OpenGL options that affect display of the model in solid view mode. To change the part to solid view, see ”Setting Up the Screen View” in the ”Editing the CAD Display” section.

More:

Desktop Settings

Options

Tessellation


Options

The Options area controls the display characteristics of the model in solid view mode. Some combinations of these options may not be available because of limitations of your graphics card. Also, depending on how your graphics card supports hardware acceleration, some combinations of options may result in lowered graphics performance. If the current option settings will result in lowered performance, a warning message will appear at the bottom of the dialog box.


Double Buffering

A display buffer is graphics memory used to store the image seen on your computer screen.

When you select the Double Buffering check box, there are actually two display buffers: a front and a back buffer. The front buffer is what you see on the screen. When the screen has to be redrawn, such as when the model is rotated, the image has to be erased from the screen and the image redrawn in its new state. The erasing and drawing is done on the back buffer. You cannot see the actual erasing and drawing of the graphics. Once the graphics are drawn to the back buffer, the back buffer is swapped with the front buffer. This happens quickly so that any transition between the two buffers is virtually undetectable.

When the Double Buffering check box is cleared, or in other words, when there is only one display buffer, you can actually see the screen being erased and redrawn (albeit very quickly). The erasing and redrawing of the screen causes a flickering.

In summary, double buffering produces a more visually pleasing graphical display than single buffering.


Z-Buffer Depth

The Z-Buffer Depth list controls how much graphics memory is used for the z-buffer. The z-buffer determines which parts of a 3D model lie in front of other parts of the model. If you use insufficient bits for the z-buffer, visual artifacts may appear on the model in solid view mode. These artifacts are areas on the model that are drawn in front of other parts of the model when they should actually be hidden. These artifacts do not affect the accuracy of PC-DMIS but are simply inaccuracies in the visual display of the model.


Color Depth

The Color Depth list controls how much graphics memory your system uses for the color information of each pixel. This number is usually dependent on the color depth of the Desktop Settings.


Tessellation

The tessellation value is the default value used to break up surfaces into patches for shading.

The Tessellation area controls the drawn image by setting a tessellation multiplier in the Multiplier Value box. PC-DMIS multiplies the Multiplier Value by the tessellation value for the given CAD system. These values are then used in the generation of the shaded image.


Desktop Settings

There can be different OpenGL options for each desktop display setting. The Desktop Settings area shows what the current desktop settings are.

Resolution Ratios of Different Monitor Sizes

Wide screen monitors need a 1.6 ratio instead of a 1.3333 ratio used by normal monitors. For example, a resolution of 1200x1600 has a 1.3333 ratio (1600/1200) and works well for a normal size monitor, while a resolution of 1680x1050 has a 1.6 ratio, good for a wide screen monitor. If you use a wide screen monitor and your screen appears stretched (perhaps your circle features appear as ellipses in the Graphics Display window), use a 1.6 resolution ratio to resolve this problem.


Understanding the .DAT Files

While the PC-DMIS registry entries store most of PC-DMIS's settings, several files with a .dat filename extension are also used by PC-DMIS to store information. While you can edit some if these files in a text editor, many you can only edit within PC-DMIS. You can, however, delete most of these files to return PC-DMIS to its original state for the deleted item. Items that should not be deleted are noted in the Description column.

The following table details the .dat files available:

Filename

Editable Text File

Location

Description

colors.dat

No

In the user's sub directory under PC-DMIS's install location.

This file stores your modified Edit window colors. PC-DMIS generates this file only if you modified Edit window colors. The file gets created when you exit PC-DMIS. Deleting this file reverts your Edit window colors to the default settings.

See "Defining Edit Window Colors".

custommenuitem.dat

No

In the user's sub directory under PC-DMIS's install location.

This file contains information for the default items and user-defined items found in the User Defined Commands list of the Menu tab of the Customize dialog box. Deleting this file removes any user-defined menu items. The default automation wizards that ship with PC-DMIS are regenerated in a new .dat file. If, after deleting the file, you have a toolbar.dat file from a previous version of PC-DMIS, you will get them back, regenerated after a next execution of PC-DMIS.

See "Customizing the User Interface" in "Navigating the User Interface".

elogo.dat

Yes

In the directory where PC-DMIS was installed.

This file controls the format of the Edit window's footer for the last page.

DO NOT DELETE THIS FILE. Doing so erases the footer on the last page of the Edit window.

See "Modifying Headers and Footers" in "Using the Edit Window".

execbarstate.dat

No

In the user's sub directory under PC-DMIS's install location.

This file contains the layouts of toolbars and dockable windows during part program execution. PC-DMIS switches back and forth reloading these two files (gbarstate and execbarstate) as well when you start and finish program execution. Deleting this file restores a default layout.

gbarstate.dat

No

In the user's sub directory under PC-DMIS's install location.

This file contains the layouts of toolbars and dockable windows within the part program (but not during execution). Deleting this file restores a default layout.

header.dat

Yes

In the directory where PC-DMIS was installed.

This file controls the format of the Edit window's header for all pages but the first. See "Modifying Headers and Footers" in "Using the Edit Window".

DO NOT DELETE THIS FILE. Doing so erases the header on the affected pages of the Edit window.

layouttoolbar.dat

No

In the user's sub directory under PC-DMIS's install location.

This file contains a list of any layouts when you save a layout using the Window Layouts toolbar. Deleting this file removes your window layouts from the Window Layouts toolbar.

layout#.dat

No

In the user's sub directory under PC-DMIS's install location.

These files store information about a specific layout stored in the Window Layouts toolbar. You will have one file for each stored layout. (similar to the gbarstate.dat). PC-DMIS automatically increments # for each newly created layout. Deleting a specific Layout#.dat file remove the related layout button from the Window Layouts toolbar.

logo.dat

Yes

In the directory where PC-DMIS was installed.

This file controls the format of the Edit window's header on the first page. See "Modifying Headers and Footers" in "Using the Edit Window".

DO NOT DELETE THIS FILE. Doing so erases the header from the first page of the Edit window.

menu_<language>.dat

No

In the user's sub directory under PC-DMIS's install location.

This file stores customized menus for the user. In the filename <language> is the three letter language code for the language you are using to display PC-DMIS. Deleting this file removes any menu customizations made.

messageboxoptions.dat

No

In the user's sub directory under PC-DMIS's install location.

This file stores a list of the warning messages you have turned off. Deleting this file causes all warning messages to appear again.

probe.dat

Yes

In the directory where PC-DMIS was installed.

This file displays all the probe components available within PC-DMIS. When you go to build your own probe file, PC-DMIS uses the information in this file to populate the Probe Utility dialog box.

DO NOT DELETE THIS FILE. Doing so erases the library of probe components available making it impossible to modify and create probes.

reportingtoolbar.dat

No

In the user's sub directory under PC-DMIS's install location.

This file contains a list of the saved report templates and custom reports on the Reporting toolbar. Deleting this file removes any saved items from the Reporting toolbar.

quickfix.dat

Yes

In the directory where PC-DMIS was installed.

This file displays all the quick fixture items available to add into the Graphics Display window.

DO NOT DELETE THIS FILE. Doing so erases the library of quick fixture items available making it impossible to work with these files.

templreppickerlist.dat

Yes

In the directory where PC-DMIS was installed as well as the in the user's sub directory. It's also in the UserDefaultFiles sub directory.

This file contains a list of report templates you have added to the Template Selection dialog box. Deleting this file removes those files from the Template Selection dialog box, but it does not delete the actual report templates themselves.

toolbar.dat

No

In the user's sub directory under PC-DMIS's install location.

This file contains all customized toolbars definitions (buttons) and names. PC-DMIS creates this file when you customize or create any toolbars. Deleting this file removes any customized toolbars.


Editing the CAD Display

Editing the CAD Display: Introduction

Setting Up the Screen View

Managing and Positioning On-Screen Elements

Switching Between Curve and Surface Modes

Drawing Surfaces

Highlighting Surfaces and Curves with the Mouse

Repainting the Screen

Changing Screen Modes

Changing Screen Colors

Scaling the Drawing

Rotating the Drawing

Changing Rotation and Other Motion Options

Showing and Hiding Graphics

W orking with Assemblies of Parts

Making CAD 3D by Using the Create Levels Window

Viewing CAD Information

VERIFYING CAD INFORMATION

Using Screen Captures of the Graphics Display Window

Editing CAD

Applying Lighting and Materials to the CAD Display

Selecting Features Using the Graphics Display Window

I dentifying Features by Using Tooltips

A utomatically Positioning Feature ID Labels

Editing Dimension Colors

E diting Features

Showing and Animating Path Lines

Deleting CAD

Deleting Features

Deleting Dimensions

Transforming a CAD Model

Working with CAD Coordinate Systems

Point Nominal Deviation

Modifying Display Symbols


Editing the CAD Display: Introduction

PC-DMIS lets you edit the display of the CAD in the Graphics Display window.

The main topics in this section describe how to edit the CAD display. These include:

  • Setting Up the Screen View

  • Managing and Positioning On-Screen Elements

  • Switching Between Curve and Surface Modes

  • Drawing Surfaces

  • Highlighting Surfaces or Curves with the Mouse

  • Repainting the Screen

  • Changing Screen Modes

  • Changing Screen Colors

  • Scaling the Drawing

  • Rotating the Drawing

  • Changing Rotation and Other Motion Options

  • Showing and Hiding Graphics

  • Working with Assemblies of Parts

  • Making CAD 3D by Using the Create Levels Window

  • Viewing CAD Information

  • Verifying CAD Information

  • Using Screen Captures of the Graphics Display Window

  • Editing CAD

  • Editing CAD Vectors

  • Applying Lighting and Materials to the CAD Display

  • Selecting Features Using the Graphics Display Window

  • Identifying Features by Using Tooltips

  • Automatically Positioning Feature ID Labels

  • Editing Dimension Colors

  • Editing Features

  • Showing and Animating Path Lines

  • Deleting CAD

  • Deleting Features

  • Deleting Dimensions

  • Transforming a CAD Model

  • Working with CAD Coordinate Systems

  • Point Nominal Deviation

  • Modifying Display Symbols


Setting Up the Screen View

Display Menu Roadmap

The Edit | Graphics Display Window | View Setup option opens the View Setup dialog box. This dialog box lets you specify the number of views (maximum of four) of the part that PC-DMIS will display in the Graphics Display window. You can also determine the orientation of each view and if the particular view is displayed as a wire frame or a solid.

View Setup dialog box

Hint: To quickly change how the part is displayed in the 'blue' view, you can click on the icons available from the Graphic View toolbar.

To store your view for later use, you can create and recall the view. See "Working with Viewsets" in "Inserting Report Commands".

More:

Changing Layout and Views

Adding a 3D Grid

Showing lines over surfaces

Displaying Rulers

Displaying, Creating, and Manipulating Levels


Changing Layout and Views

To change the screen layout and the orientation of the views:

  1. Access the View Setup dialog box (Edit | Graphics Display Window | View Setup). Display Menu Roadmap

  2. Select the desired screen style from the Layout area. For example, to split the screen into two different views of the part image, click on button two or three (in the first row). The window will be split horizontally or vertically, depending on the button that is chosen.

  3. Using the drop-down list box, select the desired view orientation for each window that will be displayed. For example, to view the part image from the Z+ direction, simply select Z+ from the drop-down list box. Or, to view the same image from the Y- axis, select Y-. All of the display options only affect how PC-DMIS displays the part image. They do not affect the measured data or inspection results.

  4. Select the Solid check box if you want to display your part in the selected view of your part as a solid. Leaving the check box blank will display the view of the part as a wire frame.

  5. Click either the Apply button or the Ok button.

    • If the Apply button is selected, PC-DMIS will re-draw the Graphics Display window to reflect the current settings, allowing you to preview your changes.

    • If the Ok button is selected, PC-DMIS will close the View Setup dialog box and apply the changes to the Graphics Display window. At any time before clicking Ok, you can click Cancel to close the dialog box and revert the views to what they were.

More:

Change Size of Views


Change Size of Views

PC-DMIS lets you redefine the sizes of the views in the Graphics Display window.

To change the size of a view window:

  1. Position the pointer on the line separating the windows. The single arrow cursor will change to a double arrow.

  2. Hold down the left mouse button.

  3. Drag the line to the desired location. The view size will change.

This procedure works in either the horizontal or vertical position. The drawing can then be re-scaled to fit within the new window by selecting the Scale To Fit option. See "Scaling the Drawing".

Note: PC-DMIS can be in any mode when changing the view size.


Adding a 3D Grid

Select a 3D Grid check box to turn on the 3D grid for the selected view. Unlike the rulers, the origin of the 3D grid will always be located at the part's current alignment.

The 3D Grid Setup button brings up the 3D Grid Setup dialog box. From here you can modify the grid spacing.

3D Grid Setup dialog box

Modify the grid line spacing by typing a value in the X Axis, Y Axis, and Z Axis boxes or select the Auto check boxes to have PC-DMIS automatically compute reasonable spacing.

Grid line labels are placed around the outside of the window. These lines follow the current alignment defined in the Edit window. They can be inset by the value shown in the Label Inset box. This value determines the pixel buffer size that PC-DMIS places between the outer edge of the Graphics Display window and the 3D grid labels.

Click OK and PC-DMIS displays the 3D grid in the Graphic's Display window.

Example of a 3D—Grid with Label Inset of 10 in the X-Y Plane

There are three possible grids that can be drawn:

X-Y

Y-Z

Z-X

PC-DMIS draws only one grid at a time. The grid drawn depends on the axis plane rotated closest to your screen (determined by the axis indicator). For example, the following axis indicator from the Graphics Display window shows the X-Y axis plane facing the user; PC-DMIS draws the X-Y axis grid.

Axis Indicator showing the X-Y plane.

Note: The color of the 3D grid can be modified from the Screen Color dialog box. See "Changing Screen Colors"


Showing lines over surfaces

This check box applies to solid view only. Select this check box to cause points and lines that hide behind surfaces to show through. This option is useful for looking at measured features that are behind surfaces. For example, suppose a measured line in your part is slightly underneath the CAD surface. Selecting this check box will force the measured line to be visible.


Displaying Rulers

Select the Rulers check box to turn on rulers in all views. The origin of the rulers will always be located at the CAD origin (not local part alignments).


Displaying, Creating, and Manipulating Levels

A CAD level consists of a group of related CAD geometries, which are identified by a level number. The level information in these files is imported into PC-DMIS when the files are 'imported'. You can then select which levels will be displayed in each Graphics Display 'view' using the View Setup dialog (Edit | Graphics Display Window | View Setup).

Display Menu Roadmap

Given the size and complexity of many CAD files, this option will greatly benefit your ability to restrict specific portions of the CAD model that will be visible as various PC-DMIS tasks are being performed. (See "Making CAD 3D" for more information.)

Note: This option is only available if levels have been incorporated into the IGES drawing file.

To view a level in the Graphics Display window:

Select the desired view (blue, red, yellow, or green view).

Select the appropriate level from the list.

Click the Apply button.

PC-DMIS will re-draw the Graphics Display window to reflect the current setting. The OK button must be pressed to save these changes.

The Create… button in the View Setup dialog box allows you to access the Level dialog box.

Level dialog box

The Level dialog box allows you to create, delete, or modify levels.

More:

Creating Levels

Deleting Levels

Modifying Levels


Creating Levels

Creating a level consists of a 3-step process.

  1. From the Level dialog box, type in the new level number in the box beneath the Create button.

  2. Choose the features that you want contained in the new level by selecting the desired feature type check boxes.

  3. Click the Finish button to complete the process.


Deleting Levels

Level deletion consists of a 3-step process:

  1. From the Level dialog box, select an existing level from the drop-down list.

  2. Click the Delete button.

  3. Select the Finish button to complete the process. All feature types that were assigned to the deleted level will be assigned to level '0.'


Modifying Levels

Level modification consists of a 5-step process:

  1. From the Level dialog box, select an existing level from the drop-down list.

  2. Click on the Modify button.

  3. Select the Assign button to add CAD to the chosen level, or select the Undo button to remove CAD from the chosen level.

  4. From the Feature Type check boxes, select the appropriate feature types to be 'added to' or 'removed from' the displayed level.

  5. Select the Finish button to complete the level modification process.

Level addition and level modification will require the selection of CAD data. You can restrict the selection to different types of geometry in the same way as selection is restricted in the Edit CAD and Delete CAD dialog boxes. Also, selection may be restricted to CAD of a given color by checking the 'Color' check box and selecting a geometry of the desired color. The selected color will then appear next to the 'Color' check box. To change a color, clear the 'Color' check box, then re-select the Color check box, selecting the geometry with the new color.

You can close the Level dialog box by clicking OK or Cancel. The Cancel button will not save the results of any operations in progress.


Managing and Positioning On-Screen Elements

The Graphics Display window holds more than just the CAD drawing of your part. It can also display feature ID and Datum Definition labels, Dimension Info and Point Info text boxes, and Feature Control Frames (FCFs). These elements all bring organization to your report, but with too many of them displayed your screen may cover up your part and tend to make your part drawing look cluttered.

Fortunately, you can easily reposition these elements by moving your mouse over an element. The mouse pointer changes to a cross-hair. Click on an element and drag it to a new location. PC-DMIS then draws a leader-line from the ID label or text box to its corresponding feature.

You can also have PC-DMIS dynamically reposition all your labels and text boxes around your part drawing even when changing the zoom level for your part's display. Select the Automatic Label Positioning check box from the General tab of the Setup Options dialog box. See "Automatic Label Positioning" in "Setting Your Preferences".

If things still look cluttered, you can also control the visibility state of these various elements using short-cut menus. See "Feature Shortcut Menu" and "Box-Select Shortcut Menu" in "Using Shortcut Keys and Shortcut Menus".

Note: Positioning elements is only done in the active view. If you have a split screen showing additional views of the part, the IDs remain as before in the other views.


Switching Between Curve and Surface Modes

Operation | Graphics Display Window | Change Curve/Surface Mode

The optional package “Curves and Surfaces” must have been purchased for your system in order to access these modes. You can use these modes with Program mode to take offline hits on your CAD model's wire frame or surface entities.

Curve Mode

The Curve mode option Display Menu Roadmap makes a wire frame's model of curves and lines selectable when clicking on the CAD data in the Graphics Display window. You must import a wire frame model for this option to become available. This mode works well for all Measured Features.

However, two graphic views are required to take hits in Curve mode. You can set up views using the View Setup dialog box. See "Setting Up the Screen View".

The picture to the right illustrates this. If your working plane is the Z+ plane, the top half of the screen (A) would be in the Z+ view and would be used to take hits while the bottom half of the screen (B) would be used to set the probe's depth.

Sample Graphics Display Window Split to Show Two Different Wire frame Views of the Part

The following table discusses the mouse operations you can use to set your probe's depth and take hits to insert measured features into your part program. The table below assumes that Z+ is your working plane. You must also be in Program Mode for these to work:

Curve Mode Mouse Operations | Split Screen to Use | Description
Right-click | Screen B in the above picture | This sets the approximate animated probe depth at the current mouse pointer position. Use this to create Move Points when programming in offline mode. See "Inserting a Move Point Command" in "Inserting Move Commands".
Right-click + drag | Screen B in the above picture | This sets the depth for your next inserted hits on the nearest wire frame entity when you release the mouse button. Use this to set the depth for measured lines, circles and cylinders.
Left-click | Screen A in the above picture | This selects the nearest line or circle and takes equally spaced hits at the current depth setting based on the settings in the General tab of the Setup Options dialog box. See "Edit Boxes for the General tab" in "Setting Your Preferences".
Left-click + drag | Screen A in the above picture | This takes a single hit at the current depth setting on a line, arc or circle. The hit direction depends on which side of the wire you release your mouse. Always approach from the side of the wire the machine would approach from.
Left-click + hold and release | Screen A in the above picture | This delayed click takes a hit at the pointer's position at the current depth setting. Use this method to take hits on a plane. Be sure to hold the mouse steady when holding down the button so that when you release it a valid hit is taken normal to the surface at the pointer's position.

For example, to define a Measured Cone feature in the Z+ view in Curve mode, perform a right-click + drag operation in screen A on the cone's top circle and then left-click on the circle to insert four hits. Right-click + drag again on the bottom circle again in screen A and then left-click again on the circle to insert four more hits. You should have eight hits each at different depths. Press END to create the Measured Cone feature.

View Demo of this Functionality

Surface Mode

The Surface mode option Display Menu Roadmap makes a solid model's surfaces selectable when clicking on the CAD data in the Graphics Display window. You must import a solid model for this option to become available. To take a hit, click on any surface. PC-DMIS pierces the surface, captures the X,Y,Z,I,J,K information, and the hit is recorded at the pointer's position. Select the correct number of hits to define the feature and then press the END key. PC-DMIS will guess the feature type. This mode works best for creating point, line, and plane features. While you can also use this mode with circular features (circles, cylinders, cones and spheres), you will find that—especially for inside features—it is often difficult to select hits at a constant cross section or depth. In these cases you may want to use Curve mode.

For information on using these modes with scans, see the "Scanning your Part" section.


Drawing Surfaces

Display Menu Roadmap

The Operation | Graphics Display Window | Draw Surfaces option allows you to display surfaces on the screen. Note that you must first select the Solid check box in the View Setup dialog box. For information on the View Setup dialog box, see the "Setting Up the Screen View" topic.

To turn off the display of surfaces, select this option again.


Highlighting Surfaces and Curves with the Mouse

PC-DMIS 3.6 and later gives you the ability to quickly and easily highlight CAD surfaces and wireframe elements by simply hovering over them with your mouse. This lets you get a quick overview of the available surfaces or curves on your part model. This is called Mouse Over Highlighting (MOHL).

Example of Mouse Over Highlighting

To use the MOHL functionality, hold down the SHIFT button and move the mouse over your part.

If you have selected Surface mode, PC-DMIS highlights in yellow the current surface under the mouse.

If you have selected Curve mode, PC-DMIS highlights the current curve or wireframe element under the mouse.

If using MOHL with a textured bitmap applied to surfaces of your part, you should set your Z-Buffer Depth to a value lower than 32 bits. A setting of 32 or higher may cause jagged highlight lines to remain on your image until your refresh the Graphics Display window. See "Changing OpenGL Options" in the "Setting Your Preferences" section.


Repainting the Screen

Display Menu Roadmap

This option will refresh the Graphics Display window whenever the Operation | Graphics Display Window | Repaint the Screen option is selected.


Changing Screen Modes

PC-DMIS allows you to switch between these Screen Modes. The different modes tell PC-DMIS how to interpret mouse clicks.

More:

Translate Mode

2D Rotate Mode

3D Rotate Mode

Program Mode

Text Box Mode


Translate Mode

Display Menu Roadmap

The Operation | Graphics Display Window | Change Screen Mode | Translate option places PC-DMIS into translate mode. This mode allows you to move and zoom in or out on the part while in the Graphics Display window. The following functions are available in the Translate Mode:

  • Shrink the size of the part within the Graphics Display window.

  • Enlarge the size of the part within the Graphics Display window.

  • Select a portion of the part within the Graphics Display window.

  • Reposition the part within the Graphics Display window.

More:

Shrinking the Part Image within the Graphics Display window

Enlarging the Part Image within the Graphics Display window

Enlarging a Portion of the Part Image within the Graphics Display window

Repositioning the Part Image within the Graphics Display window


Shrinking the Part Image within the Graphics Display window

To shrink the entire image of the part by clicking:

  1. Move the mouse pointer to a point above the imaginary, horizontal centerline of the graphic part display.

  2. Click the right mouse button.

The farther away the cursor is from the centerline, the more the drawing will shrink.

If you have a mouse with a mouse-wheel you scroll your mouse wheel away from you to shrink the drawing.


Enlarging the Part Image within the Graphics Display window

To enlarge the entire image of the part:

  1. Move the mouse pointer to a point below the imaginary, horizontal centerline of the graphic part display.

  2. Click the right mouse button.

The farther away the cursor is from the centerline, the more the drawing will grow.

If you have a mouse with a mouse-wheel you scroll your mouse wheel towards you to enlarge the part.


Enlarging a Portion of the Part Image within the Graphics

Enlarging a Portion of the Part Image within the Graphics Display window

To enlarge a specified section of the displayed part:

  1. Place the mouse pointer at a corner of the selection area.

  2. Hold both left and right mouse buttons simultaneously.

  3. Move (drag) the arrow icon over the portion of the Graphics Display window to be selected. PC-DMIS will begin drawing a box.

  4. When the box contains the proper geometry, release both mouse buttons. PC-DMIS will zoom in on the selected area.

Note: Once you reach a certain point, the image doesn't enlarge any further.


Repositioning the Part Image within the Graphics Display window

To change the position of the part image within the Graphics Display window:

  1. Place the mouse pointer over the image of the part.

  2. Hold down the right mouse button and drag it to a new position.

  3. Release the mouse button.


2D Rotate Mode

Display Menu Roadmap

Rotating a drawing in 2 dimensions only changes the display. It does not in any way change the actual part's origin or datums.

The Operation | Graphics Display Window | Change Screen Mode | 2D Rotate option rotates the part in two dimensions. The part can be rotated a full 360 degrees or any fraction thereof.

The following sections describe the different ways to rotate a drawing in two dimensions.

More:

Rotate 2D by Dragging

Rotate 2D to an Element (Square up the Drawing)

Rotate 2D by a Factor


Rotate 2D by Dragging

PC-DMIS redraws the image dynamically as the mouse is being moved.

A drawing can be rotated in two dimensions by dragging the drawing around the imaginary center of the Graphics Display window.

To rotate by dragging:

  1. From the Graphics Modes toolbar, click the 2D Rotate Mode icon.

  2. Position the mouse pointer in the Graphics Display window (in any area other than at the center).

  3. Hold down the right mouse button.

  4. Move the pointer about the imaginary center of the display window. PC-DMIS redraws the image dynamically as you move the mouse.

  5. Release the mouse button. PC-DMIS keeps your current rotation.

Hint: To quickly rotate your part from within any mode, press ALT + right-click and drag the mouse. Note that this does not work if you have the Rotate dialog box for 3D rotation open.


Rotate 2D to an Element (Square up the Drawing)

To "square-up" the part to the screen, from the Graphics Modes toolbar, select the 2D Rotate Mode icon [image], and then click on a feature with the right mouse button. (Do not hold down the button.) PC-DMIS will rotate the drawing so that the selected feature is parallel to the closest screen axis (vertical or horizontal).

Hint: You can square-up the drawing to the closest X, Y, or Z axis at any time, without having the Rotate dialog box open, by clicking twice on the Graphics Display window with your middle mouse button.


Rotate 2D by a Factor

To rotate by a precise factor, similar to the "Scaling the Model by a Factor" topic, do the following:

  1. Select the 2D Rotate Mode icon [image] from the Graphics Modes toolbar.

  2. Press SHIFT and then right-click in the Graphics Display window. PC-DMIS will display a small dialog box.

  3. Type the angle (in degrees) into the Angle of part coordinates X box.

  4. Click OK. PC-DMIS closes the box and performs a 2D rotate of the part in the Graphics Display window.


3D Rotate Mode

Display Menu Roadmap

The Operation | Graphics Display Window | Change Screen Mode | 3D Rotate menu option allows you to rotate a part drawing in three dimensions. The part can be rotated up to 45 degrees per rotation. Selecting this option opens the Rotate dialog box.

Rotate dialog box

The "Rotate 3D using Rotate Dialog Box", "Rotate 3D by Dragging", and "Rotate 3D to an Element" topics describe three different ways to rotate a drawing in three dimensions.

See the "Rotating the Drawing" topic for additional information on rotating the drawing.

More:

Rotate 3D using Rotate Dialog Box

Rotate 3D by Dragging

Rotate 3D to an Element (Square up the Drawing)


Rotate 3D by Dragging

Part rotation can also be accomplished by dragging the mouse. To do this:

  1. Access the 3D Rotate dialog box.

  2. Click and hold the right mouse button.

  3. Drag the mouse.

Hint: To quickly rotate your part with or without the Rotate dialog box open, press CTRL + right-click and drag the mouse, or if your mouse has a center mousewheel button, hold the mousewheel button and drag the mouse.

Determining the Point of Rotation

There are two ways to determine the point of rotation, depending on where the mouse is when you first click the right mouse button. Either the mouse is over the Graphics Display window background or it is over the part.

1.) If the mouse is over the Graphics Display background, the part will be rotated about the part's origin.

2.) If the mouse is over the part, the part will be rotated about the point on the part directly below the mouse pointer.


Rotate 3D using Rotate Dialog Box

To rotate the drawing using the dialog box:

  1. Select the view to be altered (numbered as 1-4 option buttons).

  2. Determine the amount of rotation by selecting the Degree Increment (1, 5, 10, or 45) option.

  3. Click on the desired axis buttons to rotate the drawing.

  4. Select the Close button. PC-DMIS displays the changes to the CAD image in the Graphics Display window.

Clicking the Reset button will snap the rotation of the drawing in the Rotate dialog box and in the Graphics Display window to the closest axis.

If you select the Animate check box, PC-DMIS dynamically re-draws the part in the Graphics Display window as it is rotated inside the dialog box. If you clear this check box, and then use a rotation button in the dialog box, the rotation of the actual part on the screen does not take place until you release the clicked button.


Rotate 3D to an Element (Square up the Drawing)

To "square-up " the part to the screen, from the Graphics Modes toolbar, select the 3D Rotate Mode icon, and then click on a feature with the right mouse button. (Do not hold down the button.) PC-DMIS will rotate the drawing so the selected feature will be parallel to the closest screen axis (vertical, horizontal, or perpendicular to the screen).

Hint: You can square-up the drawing to the closest X, Y, or Z axis at any time, without having the Rotate dialog box open, by clicking twice on the Graphics Display window with your middle mouse button.


Text Box Mode

Display Menu Roadmap

The Operation | Graphics Display Window | Change Screen Mode | Text Box menu option places PC-DMIS into a mode that lets you manipulate feature IDs, feature control frames, scan points, as well as quickly create and modify Dimension Info and Point Info text boxes.

You can create these text boxes by using shortcut menus that appear when you right-click or box-select feature IDs or features. See the "Inserting Dimension Info Boxes" and "Inserting Point Info Boxes" topics in the "Inserting Report Commands" section.

Note: Inside the Graphics Display window, notice that when you move the mouse over either a feature, or a feature's ID label, that PC-DMIS highlights the feature on the CAD drawing. This helps you quickly identify the feature associated with a particular label.

The following are the shortcut menus available inside Text Box Mode:

  • If you right-click on the feature, feature's ID label, or text box, PC-DMIS displays a shortcut menu for that feature. See "Feature Shortcut Menu" in the "Using Shortcut Keys and Shortcut Menus" section.

  • If you right-click on a Dimension info or Point Info box, PC-DMIS displays a shortcut menu for that text box. See "Feature Shortcut Menu" in the "Using Shortcut Keys and Shortcut Menus" section.

  • If you box-select one or more features, PC-DMIS displays a shortcut menu. See "Box-Select Shortcut Menu" in the "Using Shortcut Keys and Shortcut Menus" section.

  • If you right-click on a scan point you can use the Move Cursor To menu item to jump to that point. See "Locating Points in a Scan" in the "Scanning your Part" section.

Note: When your mouse isn't over a feature or text box, PC-DMIS allows you to perform the normal translate mode operations of zooming and rotating the part with the right mouse button. See "Translate Mode" for additional information.

Tip: For a quick way to create a DIMINFO or a POINTINFO box, simply double-click on a feature or feature ID label. PC-DMIS can be in any mode. PC-DMIS automatically creates an info box based on current Edit Dimension Info or Edit Point Info dialog box settings.

Example: Suppose you created a DIMINFO box for a feature. Double-clicking on subsequent feature labels will create additional DIMINFO boxes for those features using the same settings selected the last time the Edit Dimension Info dialog box was used.


Program Mode

Display Menu Roadmap

The Operation | Graphics Display Window | Change Screen Mode | Program menu option allows you to learn and edit part programs using CAD data from IGES files. Use Program Mode to create Measured features from a wireframe or surface CAD model. While in Program Mode you take hits on the model with an animated probe simulating taking hits with the CMM in Guess Mode. This capability is available in either the off-line or on-line versions of PC-DMIS.

For further information on programming using graphics, refer to the "Working in Off-line Mode" section.


Changing Screen Colors

Display Menu Roadmap

Screen Color dialog box

Screen Color dialog box

The Screen Color dialog box (Edit | Graphics Display Window | Screen Color) allows you to determine the colors to display within the Graphics Display window. These include the background color, a gradient color, highlight, and mouse-over-highlight colors, the 3D Grid color, and the Vision module's Field of View (FOV) color.

More:

To Change a Color:

Background

Highlight

Mouse Over Highlight

3D Grid

Vision FOV


To Change a Color:

To change the colors:

  1. Access the Screen Color dialog box (Edit | Graphics Display Window | Screen Color). Display Menu Roadmap

  2. Click on the Edit button for the Background, Gradient, Highlight, Mouse Over Highlight, 3D Grid, or Vision FOV. The Color dialog box will appear.

  3. Choose a new color for the option you selected.

  4. Click OK. The Color dialog box will close returning you to the Screen Color dialog box.

  5. Click the Apply button to save the changes you have made and continue working in the Screen Color dialog box.

  6. When finished, click the OK button.


Background

The Background area allows you to change the background screen color. This color is also used as the background color for any Feature Control Frames displayed in the Graphics Display window. Follow the directions discussed in "To Change a Color".

The Gradient settings area, lets you define a secondary background gradient color. When you set the gradient to something other than None in the list, an additional Edit... button appears. You can click that button to define a secondary gradient color. Then, when setting the screen's background, PC-DMIS will start from the setting location (for example the Bottom) and display the secondary gradient color, and then gradually change from that color to the primary gradient color as it draws the colors nears the other end of the screen.

For example, a Bottom gradient setting might look like this:

Gradient Colors Example

The available items in the Gradients settings list are:

  • None - No secondary gradient. The screen's background will be the solid primary color.

  • Bottom - The secondary gradient color starts at the bottom of the screen and gradually changes to the primary color as it nears the top.

  • Right - The secondary gradient color starts at the right side of the screen and gradually changes to the primary color as it nears the left side.

  • Bottom Right - The secondary gradient color starts at the bottom right side of the screen and gradually changes to the primary color as it nears the top left side.

  • Bottom Left - The secondary gradient color starts at the bottom left side of the screen and gradually changes to the primary color as it nears the top right side.

  • Top right - The secondary gradient color starts at the top right side of the screen and gradually changes to the primary color as it nears the bottom left side.

  • Top left - The secondary gradient color starts at the top left side of the screen and gradually changes to the primary color as it nears the bottom right side.


Highlight

The Highlight area allows you to change the color used for highlighting within the Graphics Display window of PC-DMIS. Follow the directions discussed in "To Change a Color".


Mouse Over Highlight

Mouse Over Highlight area

The Mouse Over Highlight area lets change the color that PC-DMIS uses as well as the mouse pointer's shape when you highlight surfaces or curves with your mouse using Mouse Over Highlighting (MOHL). Follow the directions discussed in "To Change a Color".

The Cursor area lets you display either an Arrow or a Cross shape for the mouse pointer when in MOHL mode:

Arrow Shape Mouse Pointer

Arrow Shape Mouse Pointer

Cross Shape Mouse Pointer

Cross Shape Mouse Pointer

See "Highlighting Surfaces and Curves with the Mouse" for information.


3D Grid

The 3D Grid area allows you to change the color used for the 3D grid in the Graphics Display window. Follow the directions discussed in "To Change a Color".

For more information on the 3D Grid, see "Adding a 3D Grid".


Vision FOV

The Vision FOV area lets you change the color used for the Field of View (FOV) when using the PC-DMIS Vision module. Follow the directions discussed in "To Change a Color". See the PC-DMIS Vision documentation for information on the FOV and on the Vision module.


Scaling the Drawing

You can scale the CAD drawing to fit the size of your selected view(s) in the Graphics Display window, or you can scale by a factor.

More:

Scaling the Model to the View

Scaling the Model by a Factor


Scaling the Model to Fit the View

Display Menu Roadmap

The Operation | Graphics Display Window | Scale To Fit menu option re-displays the part image to fit entirely within the Graphics Display window. This option is helpful whenever the image becomes too large or too small. To alter the part image so all features and CAD elements are visible, simply select the Scale To Fit menu option.


Scaling the Model by a Factor

Scale Drawing dialog box

The Scale Drawing option only functions when PC-DMIS is in Translate Mode. See "Changing Screen Modes".

The Scale Drawing option is not available from the menu bar. The Scale Drawing option lets you alter the part's image in the Graphics Display window. This option does not alter the CAD data in any way.

To use this option:

  1. Click the Translate mode icon from the Graphics Modes toolbar.

  2. Press the SHIFT key and while holding it down, click the right mouse button. The Scale Drawing dialog box will appear.

  3. Indicate the X, Y, Z part coordinates that are to be displayed in the center of the screen.

  4. Type the desired scaling factor.

Example: To reduce the size of the drawing elements by 50%, type 0.5. To double the size of the drawing elements, type 2.0. A scaling factor of 1.0 will not affect the size of the drawing.

You can also scale the graphical image within the Graphics Display window simply by right mouse clicking above or below an imaginary horizontal line that splits the Graphics Display window.


Rotating the Drawing

Display Menu Roadmap

Selecting the Operation | Graphics Display Window | Rotate menu option brings up the Rotate dialog box.

Rotate dialog box

This dialog allows you to rotate a part drawing in three dimensions. Each view of the part can be rotated up to 45 degrees per rotation. You can also activate this option by selecting the 3D Rotate mode icon on the Graphics Modes toolbar.

To rotate the drawing using the dialog box:

  1. Select the view to be altered (1-4).

  2. Determine the amount of rotation by selecting the degree increment (1, 5, 10, or 45).

  3. Click on the desired axis button to rotate the drawing in the indicated direction.

Clicking the Reset button will snap the rotation of the drawing in the Rotate dialog box and in the Graphics Display window to the closest axis.

If you select the Animate check box, PC-DMIS dynamically re-draws the part in the Graphics Display window as it is rotated.

See the "3D Rotate Mode" for additional information on rotating.

Hint: To quickly rotate your part with or without the Rotate dialog box open, press CTRL + right-click and drag the mouse, or if your mouse has a center mousewheel button, hold the mousewheel button and drag the mouse. Also, double-clicking the mousewheel button at any time does the same thing as the Reset button on the Rotate dialog box: it snaps the rotation to the closest axis.


Changing Rotation and Other Motion Options

You can modify how CAD models get displayed during rotation by accessing the Edit | Graphics Display Window | Rotate 2D/3D Options menu item. This displays the Rotate Options dialog box.

Display Menu Roadmap

Rotation Options icon

You can also access this dialog box by clicking the Rotation Options icon on the Graphics Mode toolbar.

Rotate Options dialog box

This dialog box controls whether or not certain items get drawn and how they get drawn inside the Graphics Display window when you rotate your part model using the right mouse button. The options on this dialog box can help speed up the display of your rotation.

Important: If you are using a SpaceBall or SpaceMouse device, this dialog box behaves just like the Pan, Zoom, Rotate Options dialog box and only has a different dialog box title. SpaceBall or SpaceMouse devices extend the functionality described for rotation to zooming and panning as well. See the "Configuring a SpaceBall or SpaceMouse Device" topic in the "Getting Started: An Overview" section. If you are using a standard mouse for your pointing device, then the Graphics Options dialog box only applies to rotation.

More:

Disable 2 sided lighting and back face culling

Disable materials, textures, and transparencies

Ignore these objects

Percentage of remaining objects to draw

How to draw objects – As Defined

How to draw ob jects – Wire Frame

How to draw objects – Points


Disable 2 sided lighting and back face culling

Selecting this check box disables two sided lighting and uses back face culling during rotation. The resulting lighting effects will roughly display only half of the CAD elements. See the comparison below.

Before Rotation

During Rotation – Disable 2 sided lighting and back face culling

More:

Disable materials, textures, and transparencies

Ignore these objects

Percentage of remaining objects to draw

How to draw objects - As Defined

How to draw objects - Wire Frame

How to draw objects - Points


Disable materials, textures, and transparencies

Selecting this check box disables the rendering of applied materials, textures, and transparencies during rotation. See the comparison below.

Before Rotation with Transparency

During Rotation - No transparencies


Ignore these objects

Selecting this check box disables the display of specified objects. Objects will be ignored during rotation for those object types that are selected using the associated check boxes. You can choose to ignore probes, machines, changers, or fixtures. The example below hides the probe during rotation.

Before Rotation

During Rotation - Ignore Probe


Percentage of remaining objects to draw

This area draws the specified percentage of CAD entities making up the remaining objects displayed in the Graphics Display Window. Choices are given for 100, 50, 20, and 10 percent. For example, if you selected 10% PC-DMIS would draw only 10% of the CAD entities that make up the entire model. The example below displays only 10% of the objects during rotation.

Before Rotation

During Rotation - Display only 10%


How to draw objects

How to draw objects - As Defined

Selecting this option draws objects as originally defined during rotation.


How to draw objects

How to draw objects - Wire Frame

Selecting this option draws objects as wire frames during rotation. See the comparison below.

Before Rotation

During Rotation - Draw Wire Frame


How to draw objects

How to draw objects - Points

Selecting this option draws objects as points. The Points option gives a representation of the objects using points. See the comparison below.

Before Rotation with Transparency

During Rotation – Draw Points


Showing and Hiding Graphics

You can choose to show or hide various kinds of graphical objects inside the Graphics Display window by selecting the Edit | Graphics Display window | Hide and Show Graphics menu option. This displays the Hide and show graphics dialog box.

Display Menu Roadmap

Graphics Categories icon

You can also access this dialog box by selecting the Graphics Categories icon from the Graphics Modes toolbar.

Hide and show graphics

This dialog box contains check boxes that determine whether or not the following items get displayed in the Graphics Display window:

  • Cad models

  • Probe

  • Machine

  • Tool Changer

  • Fixture

You will find that hiding some of these objects from time to time makes using the Graphics Display window even easier.

Check boxes are unavailable for models or hardware definitions that have not yet been inserted.


Working with Assemblies of Parts

The CAD Assembly dialog box contains a list of all imported and merged parts or assemblies used in the Graphics Display window. You can use this dialog box to view or edit assemblies of parts. Selecting the Assembly icon or selecting Edit | Graphics Display Widow | CAD Assembly displays the CAD Assembly dialog box.

Display Menu Roadmap

CAD Assembly dialog box

This dialog box contains the following options:

Information Box

The gray box at the top of the dialog box displays information about the item currently selected on the Assembly Tree View. The information changes depending on the item selected.

Assembly Tree View

The left side of the dialog box has a tree view of the assembly structure. This tree view shows each component part in the assembly.

When you select a component in the assembly, PC-DMIS highlights it in the Graphics Display window. Conversely, when you select a CAD object in the graphics view, PC-DMIS selects its corresponding component in the Assembly Tree View. This makes it easy to identify which CAD objects belong to which assembly component.

Selecting a part also displays pathway information to find that part on your computer in the gray box above the list.

The tree view also has a check box next to each component. You can show or hide that component in the Graphics Display window by selecting this check box. This is reflected immediately in the graphics window.

Selecting or clearing these check boxes performs the same functionality as clicking the Show or Hide buttons in the Visibility area.

Expand Descendants

The Expand Descendants button expands an assembly to show a list of child parts making up the assembly.

Visibility area

The Visibility area provides convenient buttons to change the hidden state of assembly component groups. Select the Hide button to hide the selected component.

  • Hide Siblings - Hides all of the components except the selected component at the same level on the assembly tree.

  • Show - Shows the selected component.

  • Hide - Hides the selected component.

  • Show Siblings - Shows all of the components except the selected component at the same level on the assembly tree.

  • Show All - Show all the components on the assembly tree.

Editing area

The Editing area provides buttons that allow you to make simple modifications to the assembly.

  • Delete - Deletes the selected component from the assembly and removes it from the Graphics Display window.

  • Transform - Display the CAD Transform dialog box. This dialog box allows you to transform a single component in the assembly. See "Transforming a CAD Model" for more information.

  • Coordinate System - Displays the CAD Coordinate System dialog box. This dialog box lets you create and manage different coordinate systems. See "Working with CAD Coordinate Systems" for more information.

You cannot edit the root-level component (usually the part name used in your part program) or DCI components. Selecting these types of components disables the buttons in the Editing area.

Saved Views area

The Saved Views area lets you manage different visibility states of the Assembly Tree View.

  • Save - Saves the current visibility state, giving it the name specified in the current Saved Views box. You must click the OK button to permanently save your view.

  • Delete - Deletes the stored visibility state of the name selected from the Saved Views box.

To load a stored visibility state, select it from the Saved Views list. The check boxes in the Assembly Tree View are immediately modified according to the loaded view.


Making CAD 3D by Using the Create Levels Window

Display Menu Roadmap

The Operation | Graphics Display Window | Make 3D menu option (or the Make 3D button on the Iges File dialog box) allows you to manipulate a 2D CAD drawing three-dimensionally. This option can also be accessed during the import phase of loading a CAD drawing.

After selecting the Make 3D menu option, PC-DMIS displays the Create Levels window. This window will initially display "Create Levels-OLD FILE" in its title bar.

Create Levels window

Note: Any changes made to the drawing are temporary. When the main PC-DMIS for Windows screen is reactivated, the alterations will no longer be valid.

Using the Create Levels-OLD FILE window you are able to create new levels, or views of the various geometrical elements that make up the CAD. Any changes made to the graphics are temporary until you select File | Save and Exit.

There are three menus associated with this window which are used to create the various levels:

  • File. This menu lets you save your changes, cancel your changes, and switch between the OLD FILE and NEW FILE windows. See "Create Levels – File menu" for a description of the options in the File menu.

  • View. This menu provides various options to manipulate the views of the various levels. See "Create Levels – View menu" for a description of the options in the View menu.

  • Level. This menu allows you to create, select, or position your levels. See "Create Levels – Level menu" for a description of the options in the Level menu.

More:

To Make CAD 3D

Create Levels – File menu

Create Levels – View menu

Create Levels – Level menu


To Make CAD 3D

Use of this program feature may require some experimentation to gain familiarity with the orientation options discussed in this procedure.

  1. Create a part program (see "Creating New Part Programs" in the "Using Basic File Options" section).

  2. Import the CAD model into the part program (see "Importing CAD Data" in the "Using Advanced File Options" section).

  3. Review the coordinate system of the model.

  4. Create your alignment (see the "Creating and Using Alignments" section).

  5. Select the Operation | Graphics Display Window | Make 3D menu option. The Create Levels window appears with the text "OLD FILE" displayed on the title bar. The window displays your imported CAD as a wire frame model. Display Menu Roadmap

  6. Hold down the left mouse button and draw a box around the entire model. PC-DMIS highlights the selected CAD model.

  7. Select Level | Create. PC-DMIS regenerates the model.

  8. Select Level | Position. The Position Level dialog box appears with the number 1 in the title bar. This shows how you will position the model for the first level.

  9. Select a view from which to re-orient the model from the Orientation area. The remaining dialog box options become available.

  10. Select other options as desired:

  • To rotate the model to your selected orientation, click Position.

  • To offset the model's orientation by a specific value in the horizontal or vertical direction, type the offset distance into the Offset (Horizontal) or Offset (Vertical) boxes.

  • To move the orientation to a specific element, click the Element 1 option and then click the desired CAD element in your Create Levels window. PC-DMIS shifts the orientation to the specified element. If you want to use a second element, do the same with the Element 2 option.

  • To offset the orientation from a defining element, select the Element option in the Offset Defining Element area and then type an offset distance in the Offset box.

  11. After completing your changes, click Apply, and then OK. The Position Levels dialog box closes and PC-DMIS regenerates the Create Levels window with your changes.

  12. Review your changes by using options from the View menu. Specifically, View | Change allows you to access the View Setup dialog box to specify the view for the Create Levels window.

  13. Select File | Save and Exit if you want to keep the new orientation. If not, select Cancel and Exit.


Create Levels

Create Levels - File menu

The Create Levels' File menu allows you to access the original file that was read in "OLD FILE" and the newly created file "NEW FILE". It also allows you to save any changes before exiting this option.

  • The "OLD FILE" always contains the unaltered data from the original file.

  • The "NEW FILE" file allows you to access the Position dialog box, situating the level 3-dimensionally.

Only one of the file windows can be accessed at a time. PC-DMIS allows you to switch between the opened windows using the File menu. PC-DMIS will automatically switch to the appropriate window when necessary for a specific function (such as creating a new level).

If, after creating or editing your levels, you want to save your changes, be sure to select the Save and Exit option, PC-DMIS does not automatically save your changes to the CAD display if you just close down the window.


Create Levels

Create Levels - View menu

The Create Levels' View menu allows you to temporarily alter the graphics displayed in the dialog box. This allows you to rotate, scale, or change the view to easily access the necessary CAD elements.

More:

View | Change View

View | Scale to Fit

View | Rotate

View | CAD Info

View | Screen Color


View | Change View

View | Change

The Change menu option lets you create new views from a CAD file. This function is helpful when a 2D IGES file is used that contains several views of a part in one plane and the views need to be associated with their correct orientation in the Graphics Display window.


View | Scale to Fit

The Scale to Fit menu option re-draws the part image to fit entirely within the Graphics Display window. This function is useful whenever the image becomes too large or small.


View | Rotate

The Rotate menu option displays the Rotate dialog box, allowing you to rotate the part image in three dimensions. See "Scaling the Drawing"


View | CAD Info

Display Menu Roadmap

The Cad Info menu option displays the CAD information dialog box. This dialog allows you to view information about a specific CAD Geometry. Anytime a single CAD geometry is selected, and the CAD information dialog box is open, then information about the specified CAD geometry will be displayed.

CAD Information dialog box

The selected element will also flash on the screen. At a minimum, the type of the geometry will be shown (circle, line, etc.). Also, if the CAD was imported with PC-DMIS version 3.2 or later, information about the CAD file (at the time of import) will be displayed. This includes the full path to file, the time the file was last modified, and the size (in bytes) of the file. If available, the sequence number of the element in the IGES, XYZ, etc. file will be displayed. Usually, there will be information about the geometry such as diameter, vector, or location. For complex elements such as trimmed surfaces, information about other geometries (base surface, bounding curves) will also be displayed. Selecting the View button will cause the geometry described to flash on the screen. You can select this dialog box by using the Cad Info menu option.


View | Screen Color

The Screen Color menu option displays the Screen Color dialog box. Like the Screen Color box discussed in "Changing Screen Colors", this allows you to alter the colors that will be viewed in the Create Levels window.


Create Levels

Create Levels - Level menu

The Create Levels' Level menu option allows you to select the desired CAD elements and create up to 18 different levels. As each level is created, it will be displayed at the bottom of the menu list, allowing you to re-select it.

A CAD level consists of a group of related CAD geometries that are identified by a level number. Levels are predefined in either an 'IGES ' or 'XYZ' CAD file. The level information in these files is imported into PC-DMIS when these files are 'imported'. You can then select which levels are displayed in each 'view' using the View Setup dialog box. Given the size and complexity of many CAD files, it will be a great benefit to have the ability to restrict which portions of the CAD model will be visible as various PC-DMIS tasks are performed.

A CAD geometry can belong to only one level. For example, geometry 'A' can belong to level 'x', or to level 'y', but not to both. This will not restrict your viewing capabilities, as multiple levels can be viewed simultaneously.

More:

Level | New

Level | Select

Level | Deselect

Level | Create

Level | Position

Additional Level Manipulations


Level | New

The New menu option allows you to create a new level once existing levels exist. (It is not necessary to use this option to create the first level since PC-DMIS automatically creates a new level once the Create Levels-OLD FILE window opens.)

More:

To Create a New Level:


To Create a New Level:

  1. Access the Create Levels window

  2. Select the New menu option. If the New menu option is already grayed out then it has been automatically selected upon opening the Create Level-OLD File window.

  3. Select the desired CAD elements. (CAD elements can be selected in the same manner available in PC-DMIS. These include, mouse selecting and box selecting.) Once a CAD element is selected it will be highlighted in the current highlight color.

  4. Select Level | Create from the drop-down menu.

PC-DMIS will create the new level and automatically switch to the Create Levels-NEW FILE window, displaying the selected elements.

You can also create new levels using the View Setup dialog box. See "Setting Up the Screen View" for information on this dialog box.


Level | Select

This option is only available after the NEW menu option has been selected.

The Select menu option allows you to select the CAD elements that will be viewed in the new level. Selected data will be displayed in the current highlight color. Elements can only be chosen when the Select menu option is chosen.

Note: Verify that the selected data is displayed exactly as needed. Once the Create menu option is chosen, the CAD elements cannot be changed. To modify a level (prior to selecting the Create menu option), choose the Deselect option. This will clear all highlighted data.


Level | Deselect

This option is only available after the NEW menu option has been selected.

The Deselect menu option allows you to clear any CAD elements that were selected for viewing.


Level | Create

The Create menu option creates a new level based on the selected CAD elements.

Once the CAD elements are selected and this option is chosen, PC-DMIS will move the selected elements from the "OLD File" to the "NEW File". The screen will automatically switch, displaying the "NEW File". The window will also show any previous levels that have been created. The elements selected for the new level will be drawn in black. Data from the previous levels will be displayed in gray.

To create another level, select the New menu option (discussed in "To Create a New Level:"). The "OLD File" will automatically be displayed, and the selection process can be repeated.


Level | Position

Position dialog box

Once a level has been created, selecting the Position menu option displays the Position Level dialog box. This dialog allows you to position the axes and change the orientation of that level.

More:

To Reposition a Level:

Orientation area

Position button

Origin Defining Element(s) area

Offset Defining Element area

Scale box


To Reposition a Level:

  1. Select the level from the Level menu.

  2. Select Level | Position.

  3. Select an orientation option (top, bottom, right, etc.) from the Orientation area of the dialog.

  4. Click the Position command button. The View from Orientation dialog box appears. With this you can position the level relative to the orientation

  5. Use the View from Orientation dialog box to move the level in 3-D so it will be in the correct position relative to the other levels.

  6. Click OK.

Levels can be repositioned in any order, and as many times as is necessary.


Orientation area

Only orientations that correspond to the six sides of a cube are currently supported. Select the orientation that corresponds to the desired portion of the 2-D data. If the 2-D data represents the part as seen from the right side of the part, select the 'RIGHT' orientation.

Example: If the data shows the left side of a car, select the 'LEFT' orientation. It is necessary that the data show the left side of the car as it would be seen standing next to the car. If the car appears upside down, or on end, select the Position button after selecting the orientation.


Position button

The Position button displays the View from Orientation dialog box.

View from Orientation dialog box

This option will show only the 2-D data for the current level. It will also display a box depicting the selected orientation. Use the Rotate option buttons and Mirror check boxes to change the data as required. This process can be done at any time during the positioning procedure.


Origin Defining Element(s) area

To move the data within the plane, an 'origin' can be selected using the Origin Definition Element (s) area in the View from Orientation dialog box. This is done either by selecting one ore more geometries within the level data, by specifying a numerical offset(s), or both.

  • To select a geometry:

  1. Select the Element 1 option.

  2. Select a geometrical feature in the Create Levels-NEW FILE window (for example, a line). If the Apply button is then pressed, one of the end points of the line will become the 'origin.'

  3. To make the other end point the origin, select the Point 2 check box.

  • To make the intersection of the two lines the origin:

  1. Select the Element 1 option.

  2. Select a line in the Create Levels-NEW FILE window.

  3. Next, select the Element 2 option.

  4. Select a second line in the Create Levels-NEW FILE window.

  5. Click the Apply button to move the level data to the new origin. (Any combination of lines, arcs, circles, and points can be used to select an origin.)

  • Numerical offsets can also be entered to move the origin in the horizontal and vertical directions (being defined relative to the orientation).


Offset Defining Element area

Once an origin is selected, it may be necessary to move the plane in a direction normal to itself in order to correctly position it relative to the other levels. This can be done by selecting a geometry in a level.

Example: A line in a Top orientation can be selected. The Right orientation levels will then be moved so that it is in the same plane as the line in the Top orientation level. Ideally the line selected should be parallel to the Right orientation level.


Scale box

The Scale box allows you to scale the part image in the Graphics Display window to the CAD drawing. This option differs from the Scale to Fit and Scale Drawing options in that the CAD data in the part program will actually reflect the changes. Type the desired scaling factor.

  • To reduce the size of the drawing elements by 50%, type 0.5 in the Scale box.

  • To double the size of the drawing elements, type 2.0.

  • To leave the drawing unchanged, type 1.0. (A scaling factor can be entered for any level.)

To 'apply' all of the changes click the Apply button. The Reset button allows you to undo all the changes made to the current level. The Cancel button will undo any changes made since the Position Level dialog box was displayed.

Note: All of the above positioning operations can be done in any order. They can be repeated as often as necessary. In most cases, the changes will not be shown until the Apply command button is selected.


Additional Level Manipulations

PC-DMIS allows you to perform these additional level manipulations using the View Setup dialog box:

  • Create a new level. See "Creating Levels".

  • Delete an existing level. See "Deleting Levels".

  • Modify an existing level. See "Modifying Levels".

Level additions and modifications require the selection of CAD. You can restrict selection to different types of geometry in the same way as selection is restricted in the Edit CAD and Delete CAD dialogs. Selection can also be restricted to an existing level that is selected.

See "Displaying, Creating, and Manipulating Levels" in the "Editing the CAD Display" section for detailed information on how levels are used with the View Setup dialog box.

You can also create levels using the Make CAD 3D menu option. See "Making CAD 3D".


Viewing CAD Information

Display Menu Roadmap

CAD Information display box

Selecting the View | Cad Info menu option displays the CAD Information dialog box. This dialog box lets you obtain CAD information simply by highlighting the desired CAD feature in the Graphics Display window. Once the CAD feature is selected, PC-DMIS will display any available CAD information.

Clicking the View button will confirm the selection of a feature by flashing the highlighted graphical image within the Graphics Display window.


Verifying CAD Information

Display Menu Roadmap

CAD Verify dialog box

You can use the View | CAD Verify menu item to verify that the CAD model is accurate. PC-DMIS will display a CAD Verify dialog box that allows you to perform different operations on the CAD model imported into the Graphics Display window. You can easily resize the CAD Verify dialog box to a larger size as needed.

The dialog box contains the following areas and items:

Input area

This area specifies the XYZ point and the IJK vector used to verify the CAD model. Some operations do not require the vector; PC-DMIS disables the IJK Vector boxes in those cases.

Options area

This area determines what operation PC-DMIS should perform on the CAD model. You can also specify options that control the behavior of the operations and the resulting output.

The input point and vector in these options refer to the information entered into the Input area.

Item

Description

Point projection

This projects the input point onto the CAD model. A closest distance algorithm is used to project the point.

Ray pierce

This option pierces the CAD model using a line. The input point and vector define the line.

Plane cut

This option intersects the CAD model using a plane. The input point defines a point on the plane and the vector specifies the plane's normal vector. For surfaces, only the surface boundaries are intersected with the plane.

Boundaries

This check box determines whether or not surface boundaries are used. If you select this check box and the CAD entity is a surface, only the surface boundaries will be used. This does not affect curve geometry.

All results

This check box determines whether or not to get results for all the CAD entities in the model.

If you don't select this check box, only the "best" result is displayed. The best result depends on the operation selected.

  • For Point projection, the best result is the CAD point closest to the input point.

  • For Ray pierce, the best result is either the intersection point farthest along the ray vector or closest to the input point. You can specify which intersection point is displayed. See "Farthest Along Vector" below.

  • For Plane cut, the best result is the intersection point closest to the input point.

Farthest Along Vector

This option displays the intersection point farthest along the ray vector.

Closest to Point

This option displays the intersection point closest to the input point.

Resolution

This box controls the precision of the result. The result will be within the resolution value. The minimum resolution is 0.0000001.

Note: For Direct CAD Interface models, the precision will only affect the number of displayed decimal places. The actual CAD system controls the precision of the operations and cannot be modified from within PC-DMIS.

Tolerance

This box defines a tolerance value that will limit the display to only those items that fall within the specified limits.

  • If you select Point projection and All results, you can specify a Tolerance value. PC-DMIS then displays all CAD entities within the tolerance distance.

  • If you select Ray pierce and All results, you can specify a Tolerance. For curve geometry and surface boundaries, PC-DMIS displays any curve within the tolerance distance of the ray vector.

Output Vector

This area controls the displayed vector for surface boundaries and curves. (For surface points within its boundaries, the displayed vector is always the surface normal.)

  • Select Tangent to display the curve point's tangent vector.

  • Select Normal to display the curve point's normal vector. For curves, the normal vector is the inverse of the second-derivative vector. For surfaces, the normal vector is simply the surface normal.

Input Cad area

This area lets you choose the CAD entities you want tested.

Item

Description

Entire CAD Model

This check box determines whether PC-DMIS will test the entire CAD model or only selected CAD entities.

  • If you select this check box, PC-DMIS enables other check boxes that allow you to define which entity types to test in the entire CAD Model: Points, Curves, Surfaces, or All.

  • If you clear this check box, only specific CAD entities will be tested. See "Sequence/ Source Seq." below.

Points

This check box tests for all points on the entire CAD model.

Curves

This check box tests for all curves on the entire CAD model.

Surfaces

This check box tests for all surfaces on the entire CAD model.

All

This check box tests for all points, curves, and surfaces on the entire CAD model.

Sequence / Source Seq.

These boxes let you define a single CAD entity. You can fill in these boxes and then click the Select CAD Object button. PC-DMIS will turn the item red and cause it to flash a few times.

Alternately, you can test multiple CAD entities by selecting them one at a time from the Graphics Display window, or by box-selecting a group of entities.

Output area

The Output area contains the results of the verification in a table format with points making up the rows. PC-DMIS displays all the points in the Graphics Display window. Selected points from this list are highlighted in the Graphics Display window. To update the information in the Output area, select a new option and press TAB.

This table describes the column headings in the Output area:

Column

Description

Point

This column shows the resulting CAD point from the input point and the CAD.

Vector

This column shows the resulting CAD vector from the input point and the CAD.

Result

This can be either Hit or Miss.

For Point projection,

  • Hit means that the projection point was on the interior of the CAD entity.

  • Miss means that the projection point was on the extremities of the CAD entity. For curves, the extremities are the end-points. For surfaces, the extremities are the boundaries.

For Ray pierce,

  • Hit means that the ray vector directly intersected the CAD entity.

  • Miss means that the ray vector passed close to, but did not directly intersect, the CAD entity.

For Plane cut,

  • Hit means that the plane directly intersected the CAD entity.

  • Miss means that the plane passed close to, but did not directly intersect, the CAD entity.

Sequence

This column shows which CAD entity the point is on. The sequence is a unique identifier assigned to each CAD entity.

Distance

This column shows the distance between the input point and the output point.

Copy to Clipboard

This button copies the Output area's results to the Windows Clipboard. If you selected specific points, only information for those points is copied. Otherwise, the entire output is copied.


Using Screen Captures of the Graphics Display Window

PC-DMIS allows you to take screen captures of the Graphics Display window and place them into your report or send them to the Clipboard.

More:

Sending Screen Captures to the Clipboard

Sending Screen Captures to the Report

Sending Screen Captures to a File

Editing Screen Captures


Sending Screen Captures to the Clipboard

Display Menu Roadmap

The image will remain on the clipboard until another screen is captured, or the part program is closed.

The Operation | Graphics Display window | Screen Capture To | Clipboard menu option will capture the Graphics Display window and copy the screen capture to the clipboard.

To view an image captured to the clipboard, "paste" it into any Windows application where the Paste option is available (i.e., Word for Windows).


Sending Screen Captures to the Report

See "Screen Captures" in the "Using the Edit Window" section.


Sending Screen Captures to a File

Display Menu Roadmap

The Operation | Graphics Display window | Screen Capture To | File menu option will capture the Graphics Display window and allow you to save the screen capture as a bitmap file to your computer's system.


Editing Screen Captures

By itself, PC-DMIS does not have the ability to edit or format the captured figure. However, you can use any image editor software to edit or format your screen captures. To do this, use the Insert | Report | External Object command and insert an object into the Edit window (such as a bitmap file).

Display Menu Roadmap

Then, inside the paint or drawing program associated with that bitmap file, paste the screen capture you just took. You should be able to use the drawing or painting options that come with the external object's program to do your editing.

For information on using the External Object command, see ”Inserting External Objects” in the ”Adding External Elements” section.


 Feature Types area Number Selected area Deselect button OK button Close button Apply button Set as Priority check box Show Name check box Change Name check box Change Color check box Edit Color Name box

Editing CAD

Display Menu Roadmap

Edit CAD dialog box

The Edit CAD Elements dialog box (Edit | Graphics Display Window | CAD Elements) allows you to alter the color of the imported CAD file.

Select the desired features to be changed. You can do this by moving the mouse pointer over the desired feature in the Graphics Display window and clicking the left mouse button.

To select multiple features, box-select the desired CAD elements. When the mouse button is released, PC-DMIS will highlight the current elements that were selected and indicate the number of features in the Number Selected box. Additional elements may be chosen in the same manner. The Deselect button will clear the screen of any highlighted elements.

Once the desired elements are selected, click on the Color button and select the appropriate color. The Apply button must be pressed to view the color change in the Graphics Display window.

Note: In order for this option to work, you must create CAD levels. See "Setting Up the Screen View" for more information.

More:

Feature Types

Number of Selected Features

Edit Color

Change Name

Change Color

Set as Priority

Show Name

Deselect

Name box for CAD Elements


Feature Types

This option tells PC-DMIS what type of feature(s) to alter. Available types include:

  • Points

  • Lines

  • Circles

  • Arcs

  • Curves

  • Surfaces

Note: To select surfaces, select the Surface Mode icon first. See "Switching Between Curve and Surface Modes".


Number of Selected Features

The Number Selected boxes display the number of features to be deleted. The numbers in these fields change depending on the features selected in the Feature Types area of the dialog.


Edit Color

The Color command button allows you to set the color for a specified CAD element. To do this:

  1. Select the Color command button. PC-DMIS displays the Color dialog box.

    Color dialog box

  2. Select the desired color.

  3. Click the OK button. PC-DMIS updates the Edit CAD Elements dialog box, displaying the selected color.


Change Name

The Change Name check box allows you to change the name of a selected CAD element. To do this:

  1. Access the Edit CAD Elements dialog box (Edit | Graphics Display Window | CAD Elements). Display Menu Roadmap

  2. Select the appropriate feature type check box. See "Feature Types".

  3. Click on the CAD element(s) inside the Graphics Display window. PC-DMIS will highlight your selection.

  4. Select the Change Name check box.

  5. Type the new name for the selected CAD element(s) in the Name box. See "Name box for CAD Elements".

  6. Click Apply. PC-DMIS changes the name. You can verify that the name has changed by using the Show Name check box (see "Show Name").


Change Color

The Change Color check box draws the selected CAD data in the color shown in the Color box at the bottom of the dialog box. The Apply button must be selected for this process to take place. To change the current color, select the Color button.


Set as Priority

You can select and store a set of CAD surfaces for Find Nom processing using the Set as Priority check box. This speeds up the calculation of nominal values as it allows PC-DMIS to determine which surfaces to check first. There is not a limit to the number of surfaces that can be selected. The order that the surfaces are selected in will determine the order of the search.

Whenever you open the Edit CAD Elements dialog box and select the Set as Priority check box, PC-DMIS will automatically select the previously stored set of surfaces.

More:

To store a new set of surfaces:


To store a new set of surfaces:

  1. Open the Edit CAD Elements dialog box (Edit | Graphics Display Window | CAD Elements). Display Menu Roadmap

  2. Select the Set as Priority check box. If you've previously defined a set of surfaces, PC-DMIS will select them in the Graphics Display window.

  3. With the Set as Priority check box selected, click the Deselect button and then click the Apply button. This essentially tells PC-DMIS to clear any stored surfaces.

  4. Deselect the Set as Priority check box.

  5. Select the new set of surfaces to store.

  6. Select the Set as Priority check box.

  7. Click the Apply button.

  8. Click OK.


Show Name

The Show Name check box allows you show or hide the feature IDs associated with any CAD elements selected.

If selected, PC-DMIS will display the feature names (if provided by the CAD designer) or feature types of specified features.

If not selected, PC-DMIS will hide the feature names.

More:

To Display or Hide Specific Feature Names:


To Display or Hide Specific Feature Names:

  1. Access the Edit CAD Elements dialog box (Edit | Graphics Display Window | CAD Elements). Display Menu Roadmap

  2. Click on the desired feature in the CAD display (or box select an area for multiple features). PC-DMIS will highlight selected CAD elements on the CAD model.

  3. Select or clear the Show Name check box

  4. Click OK.


Deselect

The Deselect command button tells PC-DMIS to clear any changes that were made with the Apply button before the OK button was clicked.


Name box for CAD Elements

The Name box allows you to specify a name for the selected CAD element(s). To do this, select the CAD element(s), type the name in this box, and click Apply.


Editing CAD Vectors

The Edit | Graphics Display Window | CAD Vectors... menu item displays the Edit CAD Vectors dialog box. This dialog box lets you view and manipulate surface vectors.

Edit CAD Vectors dialog box

Surfaces Selected

With the dialog box open, click on a CAD surface in the Graphics Display window to select or deselect that surface. You can also drag a box across a portion of your part to box select several surfaces at once. PC-DMIS highlights any selected surface and shows the number of selected surfaces in the Surfaces Selected box.

Deselect

The Deselect button clears all selected CAD surfaces.

Show Vectors

If you select the Show Vectors check box, PC-DMIS will display a green arrow on each selected CAD surface to represent its vector.

Flip Surface Vectors

The Flip Surface Vector button flips your surface vectors, causing the vector arrows to point in the opposite direction. PC-DMIS then clears the selected surfaces, and they will appear with the flipped surface vector the next time you select them.

Fix Surface Vectors

Some surfaces, when initially selected, will have improper vectors. A proper vector will point away from the part.

The Fix Surface Vectors button uses internal mathematical algorithms to correct selected surface vectors, automatically causing the vector arrows to point in the proper direction. PC-DMIS then clears the selected surfaces, and they will appear with the corrected surface vector the next time you select them.

To fix the surface vectors of the entire CAD model, follow these steps:

  1. Display your CAD model in Solid view by selecting the Toggle Graphic Window in Solid icon from the Graphic View toolbar.

  2. Select the Edit | Graphics Display Window | Lighting, Materials... menu item. The Lighting and Materials dialog box appears.

  3. Select the Lighting tab.

  4. A sample part showing surfaces with incorrect vectors in black. Clear the Two sided lighting check box.

  5. Click the OK button. In the graphics window, notice how some of the CAD surfaces appear dark. This is a visual indication that the surface normal for that surface is pointing in the wrong direction.

  6. Select Edit | Graphics Display Window | CAD Vectors. The Edit CAD Vectors dialog box appears.

  7. Box-select the entire CAD model.

  8. Click the Fix Vectors button. If the algorithm can fix all of the surface vectors, PC-DMIS will change the dark surfaces to the part's usual color, signifying that the surface vectors now point in the proper direction outside the part. If any of the surfaces remain with a dark shade, you can select those surfaces and manually flip their vectors by using the Flip Surface Vectors button.

Close

This button closes the dialog box and clears any selected vectors.


Applying Lighting and Materials to the CAD Display

CAD Lighting icon from the View | Toolbars | Graphics Modes toolbar

Selecting the CAD Lighting icon or the Edit | Graphics Display Window | Lighting, Materials menu option displays the Lighting and materials dialog box.

Display Menu Roadmap

Lighting and materials dialog box

The Lighting and materials dialog box gives you a set of tools that allow you to further manipulate the display of CAD models—including your part model, probe model, machine model, and other fixture models—inside PC-DMIS's Graphics Display window.

This dialog box contains these tabs:

Archive: This tab lets you save and recall these CAD configurations for later use.

Lighting: This tab lets you define and enable light sources, their colors, their directions, light models, and CAD transparency.

Material: This tab lets you apply texture mapping to the surfaces of your CAD models, you can also change the colors and brightness of the materials making up the textures.

Clip Plane: This tab lets you define up to four Clipping Planes that hide your part model in the clipped area. You can use this to cut your part model to show cross sections and cutaway views.

There are four buttons at the bottom of the dialog box:

OK – Accepts your changes and closes the dialog box.

Cancel – Rejects your changes and closes the dialog box.

Save System Defaults – Saves your changes as the new default lighting and material settings. This overwrites the default settings that came with PC-DMIS.

Restore System Defaults – This brings back the original lighting and material settings that came with PC-DMIS.

Note: Any modifications you make to the Lighting and materials dialog box take place in real time in the Graphics Display window. This lets you immediately see the effects of your selected changes. Until you click OK, however, the changes you make are only temporary.

More:

Archive Tab

Lighting Tab

Material Tab

Clip Planes Tab


Lighting Tab

The Lighting tab consists of three areas that allow you to define your light sources, your light model, and transparencies.

Light Source:

The Light source area defines up to four light sources, each specifying their respective light’s direction and colors. You can create a new light source by selecting the appropriate number and clicking the Enabled check box.

With the exception of the first light source, which remains always enabled, the Enabled check box lets you turn the current light source on or off.

Light Direction:

Once you enable a light source, an active light direction button becomes selected with a red outline. These buttons define the direction from which the light originates.

The center light direction button acts as if the light comes from the direction you are located as if shining through your computer screen onto the CAD part. The other direction buttons define light coming from other angles.

Light Colors:

You can change the Ambient, Diffuse, or Specular light for the current light source by simply clicking on the colored rectangle beneath each type of light and selecting the new color from the Color dialog box that appears.

Note: Be aware that light source 1 has white as the default color for Diffuse and Specular, while the other three light sources use black as the default color.

Ambient illumination is light that has been scattered so much by the environment that its direction is impossible to determine - it seems to come from all directions. Backlight in a room has a large ambient component, since most of the light that reaches your eye has bounced off many surfaces. A spotlight outdoors has a tiny ambient component; most of the light travels is the same direction, and since you are outdoors, very little of the light reaches your eye after bouncing off other objects. When ambient light strikes a surface, it’s scattered equally in all directions.

Diffuse light comes from one direction, so it's brighter if it comes squarely down on a surface than if it barely glances off the surface. Once it hits a surface, however, it’s scattered equally in all directions, so it appears equally bright, no matter where the eye is located. Any light coming from a particular position or direction probably has a diffuse component.

Specular light comes from a particular direction, and it tends to bounce off the surface in a preferred direction. A laser beam bouncing off a mirror produces almost 100 percent specular reflection. Shiny metal or plastic has a high specular component and chalk or carpet has almost none. You can think of specular light as "shininess".

If you disable a light source, the Light direction and Light colors buttons become unavailable for selection.

Light Model:

The Light Model area defines information applied to the entire scene, regardless of the light source.

Two sided lighting – This check box determines whether or not the front and back faces of surfaces should be lighted. You should select this check box for imported IGES files and for some other CAD formats when the surface normals are not correct.

Back face culling – This check box determines whether or not PC-DMIS should cull, or hide, the back faces of surfaces. You should select this check box for IGES files, and some other Cad formats, when the surface normals are not correct.

Ambient – This box defines the ambient color applied to the entire scene. Click on the box to change colors.

Transparency:

Working with simulated probes or machines on your screen can be difficult if they block your sight to your part model. The Transparency area reduces this problem by allowing you to make certain objects transparent inside the Graphics Display window. In this way, you can see your part model or other CAD objects even if your probe or machine is in the way.

You can make these display objects transparent inside the Graphics Display window:

  • Part model

  • Probe

  • Machine

Once you have enabled transparency for a simulated machine, you can then select features and other items on your part by clicking on your part model through the transparent machine.

Once you select the Enable transparency check box, you can select the other items in the Transparency area. When you enable transparency for an object, the other settings in this area control how the transparency is to be shown.

Read-only depth buffer - This check box changes how the lighting and color interact by making the depth buffer read-only. This will cause the graphics image to change, perhaps only in a small unnoticeable way, but perhaps in a more noticeable way. It is up to you to determine whether or not the results produce a better looking image. Consult an external resource on OpenGL for additional information on the depth buffer.

Back face culling - This check box causes PC-DMIS to not draw the back faces of surfaces for the selected transparent object.

% Trans - This slider lets you determine the percentage of transparency for the selected object. Moving the slider to the left makes the display object more opaque, while moving the slider to the right makes it more transparent.

Once you define transparencies here you can easily switch them on and off using the Toggle Graphic View Transparency icon from the Graphic View toolbar. See the "Graphic View Toolbar" topic for more information.


Archive Tab

This tab contains two areas, the System defined settings area and the User defined configurations area.

The System defined settings area lets you select from system defined lighting and material settings. These are stored in a configuration file named LightingMaterials.dat in the directory where you installed PC-DMIS.

The User defined configurations area lets you save and recall your own custom lighting and materials configurations. These are stored in \Models\LightingMaterials sub directory under the directory where you installed PC-DMIS.

To save a custom defined configuration:

  1. Make any changes you want in the other tabs of the Lighting and materials dialog box.

  2. Click in the Save as box. A Save Now button appears.

  3. Type a name for your saved configuration.

  4. Click the Save Now button.

To recall a user defined configuration, select the saved configuration from the Recall list.


Material Tab

The Material tab consists of settings that will be applied to CAD objects making up the imported CAD part model or the entire part model altogether.

The first area of this tab contains two option buttons that allow you to determine the "active selection", either Entire model or Cad objects.

Entire model – Selecting this option applies the settings to the entire CAD model.

Cad objects – Selecting this option applies the settings to specific selected CAD objects making up the entire model.

Texture mapping

The Texture mapping area defines the texture to be applied to the active selection. PC-DMIS automatically applies the texture image as often as necessary to cover the entire active selection.

The check box displays the current bitmap name once you select a bitmap file to use for the texture. This check box is always selected when the active selection is a Cad object.

The large gray square area under the check box displays the current texture.

To apply a texture to your part:

  1. Select click the gray square area. A standard Open dialog box appears.

  2. Use the Open dialog box to navigate to and select a valid bitmap file. It must have a width and height of 2 to some power. For example 2 to the 5th power is 32 and 2 to the 4th power is 16. So if your bitmap is 32 X 16 pixels, it would be a valid bitmap. If you had something like 32 X 20, however, PC-DMIS would display an error message.

  3. PC-DMIS displays a preview of the selected texture inside the gray square area.

  4. Click Open to accept the texture.

To apply the check box to the active selection, click the Enable check box as needed.

The other items in the Texture Mapping area determine how PC-DMIS should apply the texture and surface colors:

Decal prevents any of the surface’s color from being emitted, so you will only see the texture’s color.

Modulate and Blend use OpenGL algorithms to determine the final display colors.

Zoom controls the ”zoom” factor to be applied to the current texture Values greater than 1.0 zoom into the texture, repeating the texture less often. Values less than 1.0 zoom out of the texture, repeating the texture more often. For example, a value of 2.0 will make the bitmap twice the size (repeat half as often), and a value of 0.5 will make the bitmap half the size (repeat twice as often).

The buttons Flip T, Flip S, and Swap determine the orientation of the texture. The texture is a two dimensional image, the orientation is described in terms of S and T. A texture with an arrow drawn atop it helps visualize what happens:

The original texture looks like this, an arrow pointing to the right with the top half of the arrow red and the bottom half of the arrow green:

Clicking Swap on the original switches the orientation so that S becomes T and T becomes S. This causes the arrow to point up but to also flip the bottom and top of the arrow:

(Swap example)

Clicking Flip S on the original changes the direction of S. This cause the arrow to point the left:

(Flip S example)

Clicking Flip T on the original changes the direction of T. This causes the arrow to flip, making the top of the bottom and top switch places:

(Flip T example)

You can click these buttons in different combinations to get a variety of orientations for your texture.

Click Apply to see any changes you made to texture orientations or other material colors.

Material colors

The Material colors area defines the color information to be applied to the entire Cad Model.

The Ambient, Diffuse, and Specular function similarly to those already explained in the Light Colors area of the Lighting tab. See "Lighting Tab".

Emission - Materials may have an emissive color, which simulates light originating from an object. In the OpenGL lighting model, the emissive color of a surface adds intensity to the object, but is unaffected by any light sources. Also, the emissive color does not introduce any additional light into the overall scene.

Brightness of highlight - This slider controls the intensity of the highlight when looking at a curved surface.

More:

Applying Textures to the Entire CAD Model

Applying Textures to Selected CAD Objects

Removing Textures from Selected CAD Objects


Applying Textures to the Entire CAD Model

  1. Select the Entire model option.

  2. Select the gray square area. An Open dialog box appears.

  3. Select a valid bitmap file.

  4. Click Open. The texture appears in the dialog box.

  5. Click the check box for the bitmaps in the Texture mapping area. The texture covers the entire CAD model.

  6. Perform additional customization on the texture as needed from the other options on the dialog box.

  7. Click OK to accept the finished texture.


Applying Textures to Selected CAD Objects

  1. Select the Cad objects option. An empty list appears along with a Clear and a Remove button.

  2. Select the gray square area. An Open dialog box appears.

  3. Select a valid bitmap file.

  4. Click Open. The texture appears in the dialog box.

  5. Click on surfaces on the CAD model. PC-DMIS will apply the surfaces you clicked with the current texture. The previously empty list now shows the individual CAD items that have textures applied to them.


Removing Textures from Selected CAD Objects

Once you apply a texture to a CAD object, the number representing that CAD object appears in a list.

To remove textures from all selected CAD objects, click the Clear button.

To remove textures from individual CAD objects, select the objects from the list and click Remove.


Clip Planes Tab

Clip Planes tab

The Clip Planes tab allows you to define up to four planes, called "clipping planes" that you can use to hide the display your part model on one side of the plane. Your part model on the other side of the plane remains visible. These planes allow you to create cross sections of your part model.

Clipping planes when you have the Lighting and materials dialog box open, appear in the Graphics Display window as a round saw-like symbol.

Example of a clipping plane creating a cross section of the Hexagon test block

More:

Defining a Clipping Plane

Adjusting a Clipping Plane


Defining a Clipping Plane

You only need two pieces of information to define your clipping plane: An XYZ location and an IJK vector. The IJK vector points in the direction of what will remain visible.

There are two ways to define this information.

  • You can click on your part in the Graphics Display window and PC-DMIS will take the point that you clicked as the clipping plane's location. Once you click a location, PC-DMIS automatically enables your clipping plane and sets a default vector. You can then modify the IJK vector as desired.

  • You can click the Enabled check box and then manually type in the XYZ location and IJK vector.

Note: In version 4.0 and later, the XYZ and IJK values are in the active part alignment coordinate system, not the CAD coordinate system as was the case in earlier versions.

The Flip IJK button flips the vector so that it points in the opposite direction.

Once you have your clipping plane modified to where you want it, click the Apply button to see your changes. PC-DMIS will hide all portions of your part model pointing away from your chosen clipping plane vector.

Deselecting the Enabled check box disables the current clipping plane. Disabled clipping planes have a yellow color and the ability to place and move your clipping plane is also disabled. Enabled clipping planes red color.

You can define multiple clipping planes by selecting a new clipping plane option button and then following the above instructions.


Adjusting a Clipping Plane

Once you have the clipping plane inserted, you can adjust it by:

  • Clicking the Flip IJK push button to invert the IJK. This is useful when surface vectors from a Cad selection were incorrect, a relatively common problem with IGES files.

  • Manually editing XYZ location and IJK vector information by typing in new values.

  • Using the Move clipping plane along the above IJK area.

The Move clipping plane along the above IJK area contains two rows of boxes and left and right arrow buttons. The boxes define increments that the clipping plane will move along the defined vector when you click the right or left arrow buttons for that box.

The top row allows you to move the clipping plane along the IJK vector in small adjustments.

The bottom row allows you to also move the clipping plane along the IJK vector, in larger increments.


Selecting Features Using the Graphics Display Window

PC-DMIS recognizes feature selection by highlighting the indicated feature in the currently chosen highlight color.

PC-DMIS allows you to select features/elements in the Graphics Display window (i.e., to print out, create coordinate systems, construct new features, calculate dimensions, etc.). There are five basic ways to select features:

  1. Selecting Features Using the ID (s)

  2. Selecting Features Using Meta-Character Matching

  3. Selecting the Last ID(s)

  4. Box Selecting ID(s)

  5. Selecting Features On-line

More:

Selecting Features using the ID(s)

Selecting Features Using Meta-Character Matching

Selecting the Last ID(s)

Box Selecting ID(s)

Selecting Features On-Line

Editing a Feature ID


Selecting Features using the ID(s)

Select the desired feature using the ID. There are several alternative methods for selecting features in the feature list box, located in many dialog boxes.

  1. Type the ID(s) assigned to the feature(s) in the Search ID box.

  2. Click on the desired ID from the list of features. PC-DMIS will automatically assign each feature a number in order of selection that will be indicated to the right of the feature ID.

  3. While in the Graphics Display window, move the cursor over the feature desired and click the left mouse button. (Note that the feature you selected in the Graphics Display window is now highlighted (or selected) in the feature window.)


Selecting Features Using Meta-Character Matching

You can also select features using a meta-character. Meta-characters are characters that act as wildcards for other alphanumeric characters. There are two meta-characters available in PC-DMIS. They are the:

  1. Asterisk (*)

  2. Question mark (?)

Both are described below in greater detail.

More:

The Asterisk (*) Meta Character

The Question Mark (?) Meta Character


The Asterisk (*) Meta Character

* The asterisk meta-character (*) will match, or take the place, of any character or characters in a search. For example, imagine these features are available in the feature list:

PLN1
LINE1
LINE2
CIR1
CIR2

Asterisk (*) meta-character

If you want to select all the line features (LINE1 and LINE2). You would type "L*" (without quotation marks) in the Search ID box and then press the TAB key. PC-DMIS would then select all features beginning with "L". The asterisk (*) causes PC-DMIS only to look for characters either before or after the asterisk (*). Since in this case, the asterisk comes after the "L", PC-DMIS ignores anything coming after the "L" in the feature list.

To use the asterisk (*) meta-character in your feature selection:

  1. Place your cursor in the Search ID box.

  2. Enter your search criteria using the asterisk (*).

  3. Press the TAB key.

PC-DMIS selects the features that meet the search criteria.

Note: The asterisk (*) meta-character can be used multiple times in any one search. It can also be used in conjunction with the question mark (?) meta-character.


The Question Mark (?) Meta Character

? The question mark meta-character (?) acts in the same way as the asterisk (*), except that the question mark meta-character will match only 1 alphanumeric character. For example, suppose in your list of features, you have the following:

PLN1
LINE1
LINE2
CIR1
CIR2

Question mark (?) meta-character

If you wanted to select all the circle features (CIR1 and CIR2) using the question mark (?) meta-character you would enter "CIR?" in Search ID box. PC-DMIS would then look for all features that met the search criteria, which is a feature with an ID 4 characters long with the first 3 characters being "CIR".

To use the question mark (?) meta-character:

  1. Place your cursor in the Search ID box.

  2. Enter your search criteria using the question mark (?).

  3. Press the TAB key.

PC-DMIS selects the features that meet the search criteria.

Note: The question mark (?) meta-character can be used multiple times in any one search. It can also be used in conjunction with the asterisk (*) meta-character.


Selecting the Last ID(s)

This instructs PC-DMIS to use the last 'number' of features in the current operation.

To select the last number of features:

  1. From the dialog box, place your cursor in the Select Last # box.

  2. Enter the last number of features to be used. For example, to create a line from the last four features measured type 4 in the box.

Select Last ID


Box Selecting ID(s)

Another way to select features is to use the left mouse button to draw a "box" around the features. This is called "box-selecting". To do this:

  1. Place the mouse pointer at one corner of where the box is to be drawn and hold down the left mouse button.

  2. Next, drag the mouse pointer to the opposite corner of the "box." PC-DMIS will draw the box outline on the screen as the mouse is dragged.

  3. When the "box" is satisfactory, release the left mouse button. PC-DMIS will highlight all the elements in the box and list them in the feature list box.

Box Selecting CIR1 and CIR2

This option also allows you to modify the contents of the box as indicated in the list. To either add or delete a feature from the set, simply click on the feature to be changed (either in the Graphics Display window, or the dialog box's list of features).

More:

Overview of Box Selecting Sheet Metal Features ID’s


Overview of Box Selecting Sheet Metal Features IDs

PC-DMIS's ability to ‘box select’ feature identifications now allows a union of sheet metal features between two selected groups. This functionality makes the selection of multiple three-dimensional objects much easier. Additionally, if any CAD objects are box selected and then a CAD object is chosen without box selection, those objects that were box selected become permanent selections in addition to the single selection.

See "Box Selecting for Auto Feature ID's" in the "Creating Auto Features" section for specific information on using this capability.


Selecting Features On-Line

In the on-line mode, use the active tip as a pointer, and trigger the probe when the tip is close to the feature needed.


Editing a Feature ID

Edit ID dialog box

To change a feature's identification, double-click on the desired feature ID in the feature list. PC-DMIS will display the Edit ID dialog box. This dialog box allows you to rename the selected feature's ID.

Important: Never use any of the mathematical characters ( -, +, /, or * ) in an ID label. This will cause problems when you attempt to use the feature ID inside PC-DMIS Expressions.


Identifying Features by Using Tooltips

Identifying a Feature by Using Tooltips

PC-DMIS 4.3 and higher provides you with a way to identify a feature without having to turn on feature IDs. Instead, PC-DMIS can display a small tooltip that will appear when you briefly hover your mouse over the feature inside the Graphics Display window. The tooltip will remain visible until you move the mouse off of the tooltip.

Sample Tooltip of a Line Feature

You may find this useful when you have a large part program and you want to keep your feature ID labels turned off to improve performance, yet you still need a way of quickly identifying a feature.

  • Clicking on the tooltip will toggle the feature’s ID label in the current view.

  • Right-mouse clicking will display a short-cut menu with the same options available when right-clicking on a feature inside Text Box Mode.

Tooltips are not available when PC-DMIS is performing path operations (Animate Path, Edit Path, etc) or when in Quick Fixture mode, or in any mode where the mouse button or keyboard buttons are used at the same time (such as during a Pan, Zoom, or Rotate operation).

See a brief demo on this functionality.


Automatically Positioning Feature ID Labels

PC-DMIS provides you with these methods to automatically position feature ID labels in the Graphics Display window with leader lines so that they point to the features they reference instead of resting directly on the feature. This moves the labels to the edge of your CAD view so that you can more easily see the part or feature.

ID Labels Without Automatic Positioning | ID Labels With Automatic Positioning

Method 1 - Use the SetUp Options dialog box

Access the SetUp Options dialog box and enable the Automatic label positioning check box from the list of check boxes on the General tab. This method keeps repositioning your labels whenever you perform pan, zoom, or rotate operations on the part. It only functions with the main CAD view if you have multiple split views.

Method 2 - Use the Feature ID Label Shortcut Menu

Right-click on a feature ID label, and from the short-cut menu, select Label Processing | Automatic Label Positioning. This method, different from method 1, works in the current CAD view, not just the main CAD view. Also it only positions the labels once. So, if you perform pan, zoom, or rotate operations, the labels are not repositioned.


For example, if you gave this a value of 200% then the tolerance zone would be double its normal range:

Example Tolerance Zone Multiplier set to 200%

If you typed 50%, the zone would be half its normal range:

Example Tolerance Zone Multiplier set to 50%

Example of Tolerances Displayed in Two Directions

Example Color Wheel Selection showing the selected start and end colors

Editing Dimension Colors

Display Menu Roadmap

Selecting the Edit | Graphics Display Window | Dimension Color menu option brings up the Edit Dimension Color dialog box. This dialog box allows you to define colors and tolerance zones for your entire tolerance band.

Edit Dimension Color dialog box

Defining Dimension Colors

    1. Define the Number of Tolerance Zones.

    2. Set the Tolerance Zone Multiplier as needed.

    3. If desired, select the Show Colors in Two Directions check box to extend your color range to the -Tol value.

    4. Pick the colors for the tolerance zones in one of two ways:

      • Method 1 - Select each tolerance zone one at a time from the tolerance zone drop-down list, and click the Edit button to set a specific color for each zone.

      • Method 2 - Use the color wheel to select the start and end tolerance zone colors, and allow PC-DMIS to define colors for the other zones.

    3. Click Apply Colors.

    4. Modify the options for the Dimension Colors bar as desired.

    5. Click OK.

Dialog Box Description

Item

Description

Tolerance Zone Multiplier box

This increases the negative and positive tolerance by the percentage specified. If it is set to 200%, then the range of tolerance zones will become:

2.0*(-Tol) through 2.0*(+Tol)

This provides you with greater control over the tolerance range for your tolerance zone, allowing your range of colors to extend into the out of tolerance zone, letting you visually see how much out of tolerance something is.

The default value is 100%.

Number of Tolerance Zones box

This determines the tolerance zones for your part program. Tolerance zones essentially divide your entire tolerance band into these tolerance zones. Each tolerance zone has a unique color associated with it.

Tolerance Zones list

This list contains all the tolerance zones. You can select a specific zone from this list to manipulate its color in detail.

The Dimension Limits item from this list is used to create a border at the absolute positive or negative limit of the feature tolerance. The color used for this corresponds to color used to draw the tolerance band.

Show Tolerances in Two Directions check box

This determines whether or not your tolerance zones display the same color range in two directions, one heading towards the Positive Out of Tolerance range and the other heading towards the Negative Out of Tolerance range. This effectively expands the lower dimension color range to –Tol instead of zero.

You can then use the Edit button to define the negative dimension colors and positive dimension colors separately.

Recall button

This button returns the colors to the default setting.

Default button

This button lets you override the previous default color settings with the current values.

Edit Color button

This displays a Color dialog box letting you change the color associated with the currently selected tolerance zone.

Color Wheel

This provides you with a quick way to define colors for all your tolerance zones.

It lets you pick the colors for the first and last tolerance zones. A small x appears on the color wheel for each color selected:

The remaining tolerance zones will have colors spaced evenly between the start and end colors. The direction of the spacing depends upon the option selected.

Clockwise option

This sets the end color to have the same brightness as the start color, and will space the colors in a clockwise direction.

Counter Clockwise option

This sets the end color to have the same brightness as the start color, but will space the colors in the counter clockwise direction.

Straight Line option

This spaces the colors from the start color to the end color, regardless of the brightness, in a straight line direction.

Apply Colors button

This applies any color changes you made without closing the dialog box, allowing you to immediately test your color selection.

Visible check box

This check box lets you show or hide the Dimension Colors Bar once you click OK.

For information on the Dimension Colors Bar, see "Using the Dimensions Colors Window" topic in the "Using Other Windows, Editors, and Tools" section

Default Tolerance box

This edit box lets you change the default tolerance value for the Dimension Colors Bar.

Display Actual Deviation option

This displays tolerances as the actual deviation in the Dimension Colors Bar.

Display % Deviation option

This displays tolerances as a percentage of the deviation in the Dimension Colors Bar.


Editing Features

Display Menu Roadmap

Edit Feature Appearance dialog box

Edit Feature Appearance dialog box

Selecting the Edit | Graphics Display Window | Feature Appearance menu option brings up the Edit Feature Appearance dialog box. This dialog box allows you to alter feature identifications (termed feature IDs) within a part program, feature colors, and feature ID labels.

The following example shows a feature ID label and a feature that have been modified using the Edit Feature Appearance dialog box. Various colors demonstrate the different parts of the label.

  • Red - the Feature Color. By default, the colored bar at the top of the ID label also changes to match the color of the circle.

  • Gray - Background Color.

  • Green - the Line Color.

An enlarged screen shot of an example feature ID label, and feature with a modified appearance

Editing Feature IDs

A previously assigned feature name can be edited simply by double-clicking on the desired feature in the list box. An Edit ID dialog box will appear allowing you to key in a new identification.

Edit ID dialog box

Feature IDs can also be changed in the Edit window. Simply highlight the desired ID and type in a new identification. Be aware, however, that in the Edit window, PC-DMIS does not track feature identifications and therefore will not warn you if duplicate IDs are assigned. Use caution when making changes if you do not want identical IDs.

Important: Never use any of the mathematical characters ( -, +, /, or * ) in an ID label. This will cause problems when you attempt to use the feature ID inside PC-DMIS Expressions.

This dialog box contains two main areas:

  • The Features Options area - Used to modify the display of the part's features themselves.

  • The Text Labels Options area - Used to modify the feature ID labels in the Graphics Display window.

To change the graphic options for features or feature ID labels, select the desired options from the dialog box, and then click Apply and then OK.

More:

Features Options area

Text Labels Options area


Features Options area

To change the color of a feature:

    1. Select the feature to be altered from the List of Features.

    2. Select the Feature Color option. PC-DMIS will automatically display the Color dialog box.

    3. Click on the desired color, or define a new one using the Custom Color box.

    4. Click the OK button. PC-DMIS returns to the Edit Feature Appearance dialog box. The new color will be displayed in the Feature Color box.

    5. Click the Apply button and PC-DMIS will automatically change the color of the feature(s) in the Graphics Display window. The top border of the feature ID label also changes to match the feature color.

To determine the display of selected features:

    1. Select the feature(s) you want to turn on or off.

    2. Select either the ON or the OFF option located under the Display area of the dialog box.

    3. Click the Apply button. PC-DMIS will display or conceal the features.

    4. If the changes made are to your satisfaction, click the OK button. PC-DMIS will close the dialog box and save the changes.

To determine the display of selected feature ID labels:

    1. Select the feature label(s) that you want to turn on or off.

    2. Select either the ON or the OFF option located under the Label area of the dialog box.

    3. Click the Apply button. PC-DMIS will display (or conceal) the feature labels.

    4. If the changes made are to your satisfaction, click the OK button. PC-DMIS will close the dialog box and save the changes.

Features Options area

The Features Options area allows you to change the color of selected part features and whether or not selected features or feature ID labels are displayed in the Graphics Display window. To use the items in this area, you must first select one or more items from the List of Features and then click the Selected from the list option. This enables the other items in this area.

The Search ID and Select Last # boxes are discussed in the "Search ID" and "Select Last #" topics in the "Navigating the User Interface" section.

The Feature Color option allows you to set the color for a specified feature's identification. This option works in the same manner as the Edit Color option (see the Edit CAD dialog box found in "Editing CAD").

To Change the Color of a Feature:

The Display area contains ON/OFF options that control the display of features in the Graphics Display window. This option is useful when you want to focus on only a portion of geometrical features the part contains at a time.

To Determine the Display of Selected Features:

The Label area contains ON/OFF options that control the display of feature IDs in the Graphics Display window. This option is useful when a portion of the part drawing becomes cluttered with several feature IDs. Specific IDs can be turned off, allowing other IDs to be more easily viewed.

To Determine the Display of Selected Feature ID Labels:


Text Label Options area

The Text Label Options area allows you to determine for all feature ID labels the background color, line color, and whether or not a shadow appears around the border. To use the features in this area, you must first select the All features text labels option. PC-DMIS automatically selects all the features from the List of Features.

Background Color - This button displays a Color dialog box from which you can choose the background color for the feature ID labels.

Line Color - This button displays a Color dialog box from which you can choose line color for the feature ID labels. Changing the line color changes the right and bottom border color on the feature ID label.

Clicking the Default button causes all feature ID labels created thereafter to use the line, color, and shadow settings displayed when you clicked Default.

Hint: You can also change these items by right-clicking on a feature's ID label and selecting the appropriate item from the resulting shortcut menu. See "Feature Shortcut Menu" in "Using Shortcut Keys and Shortcut Menus"


Showing and Animating Path Lines

Display Menu Roadmap

PC-DMIS has the ability to generate colored lines on the CAD model in the Graphics Display window that show the path your probe will take on the part while the probe measures marked features. These lines are called path lines. Path lines will help you preview the path your probe will take and troubleshoot possible collision areas.

To view path lines, select View | Path Lines. PC-DMIS will check each command and draw the path lines accordingly. You can cancel this process at any time by pressing they ESC key on your keyboard.

This shows the probe's route drawn on the part's graphical image

Changing a Path Line's Size

You can control the size of your path lines by using the Display Symbols icon from the Graphics Modes toolbar and then modifying the Fixed Size value in the Display Symbols dialog box. Note, however, that during execution or collision detection operations, or during a part translation or rotation, PC-DMIS will draw the path lines as simple lines (without the defined diameter) in order to speed up these operations.

Changing a Path Line's Color

By default, path lines are displayed in a green color (RGB setting of 0,255,0). To change the color, you will need to modify the PathLinesColorRGB registry entry using the PC-DMIS Settings Editor. See the "Modifying Registry Entries" section for information on changing registry entries.

More:

Animating the Path

Regenerating the Path

Detecting Collisions


Animating the Path

The Animate Path option only simulates the movement of the probe. It does not execute the part program.

The Operation | Graphics Display Window | Animate Path menu option animates the path of the probe on the part, simulating the movement of the probe.

To make Animate Path accessible:

  1. Mark the desired features.

  2. Select the Path Lines menu command. The Animate Path option will then be available for selection. Display Menu Roadmap

  3. Select the Animate Path menu command. PC-DMIS will display the Execution Mode Options window and automatically begin animating the path with a simulated probe tip.

Animation can be stopped at any time by pressing the ESC key on the keyboard or the Stop command button within the Execution Mode window. (If the Stop command button is selected, pressing the ENTER key will also halt animation.)

To step through the part program, simply press the Continue button.

To stop the animation, press the Stop button.

Pressing the Cancel button will close the Execution Mode Options window without completing the execution of the part program.

Clicking on the path line using the arrow icon and left mouse button will move the cursor to the corresponding command line in the Edit window. The next available feature in the path line will be indicated.


Regenerating the Path

Display Menu Roadmap

If a move is inserted before a PH9 wrist change, the location of the wrist change will not move until REGENERATE PATH is chosen.

The Operation | Graphics Display Window | Regenerate Path menu option re-draws the part program path lines. PC-DMIS will erase the current path lines from the screen and re-draw them. This option is particularly useful when changes have been made to a part program and confirmation is needed that the path lines truly represent the current state of the part program.

You can cancel the regeneration at any time by pressing the ESC key.

Note: The Regenerate Path option is only accessible after features have been marked in the Edit window and the View | Path Lines option has been selected.


Detecting Collisions

Display Menu Roadmap

The Operation | Graphics Display Window | Collision Detection menu option (CD) displays the Collision Detection dialog box. The CD module is designed to detect collisions between the probe and CAD surfaces. All CAD curves, lines, and points are ignored. As a result, only CAD files that fully describe the part using surfaces are suitable for collision detection. (The CD algorithm doesn't use the actual surface definitions, but rather the surface tessellations (or graphical approximations), which are also used for rendering solid views using the OpenGL graphics language.)

Changing Animation Speeds: If you want to modify your offline animation speeds, see "Executing and Debugging Part Programs Off-Line" in "Working in Off-line Mode".

More:

To Enable Collision Detection Functionality:

To Configure a View to be in Opengl Mode:

Collision Detection Dialog box Options

Displaying a Collision List


To Enable Collision Detection Functionality:

  1. Import a part model that has surface data.

  2. Ensure that the Graphics Display window shows your part model in Surface mode. It will not work in Wireframe mode. See "To Configure a View to be in Opengl Mode:".

  3. Select the View | Path Lines menu option. PC-DMIS will perform this operation and display the probe's path lines inside the Graphics Display window. See "Showing and Animating Path Lines". Display Menu Roadmap

  4. Select the Operation | Graphics Display Window | Collision Detection menu option. PC-DMIS will display the Collision Detection dialog box. See "Collision Detection Dialog box Options". Display Menu Roadmap


To Configure a View to be in Opengl Mode:

To configure a view to be in OpenGL mode:

  1. Click the View Setup icon to bring up the View Setup dialog box. Display Menu Roadmap

  2. Select the Solids check box.

  3. Press the Apply button.

  4. Press the OK button.

  5. Click the Surface Mode icon in the Graphics Modes toolbar.


Collision Detection Dialog box Options

Collisions are shown in the Collision Detection dialog box.

Collision Detection dialog box

  • You can select the Stop On Collision check box so that probe animation collision detection will stop if a collision occurs.

  • The other options in the dialog function like those in the Execution Mode Options dialog box. (See "Executing Part Programs" in the "Using Advanced File Options" section)

When PC-DMIS has finished running Collision Detection, the path lines will be redrawn in the Graphics Display window. PC-DMIS will indicate where collisions have occurred by drawing affected path line segments in red (RBG color of 255,0,0). In addition, PC-DMIS displays a Collision List dialog box helping you to quickly locate collision problems in your part program.

Sample Graphics Display window showing path lines and collisions (red lines)

The Probe Display Area

The probe will be displayed in the Probe Display Area using a green color. If a collision occurs, the portion of the probe that collides will be shown in red. The same color scheme is used to draw the probe on the screen, as well as in the Collision Detection dialog box.

  • You can enlarge or shrink the drawing of the probe just as you would the part on the Graphics Display window by clicking the right mouse button above or below an imaginary horizontal line.

  • You can 3D rotate the drawing of the probe by holding down CTRL and dragging the mouse using the right mouse button.

The Scale to Fit button shrinks or enlarges the drawing of the probe so that it fits back into the Collision Detection dialog box’s Probe Display Area.


Displaying a Collision List

When the Collision Detection dialog box finishes testing the current part program for possible collisions, it displays the Collision List dialog box.

Collision List dialog box

This dialog box displays a list of collisions for the part program. The Graphics Display window will also highlight those path lines in red. Clicking on an item on the Collision List dialog box will jump to the Edit window command where the collision was detected. The Edit window must be in command mode for this to work. You can then modify the part program to fix the collision problem.

If you want to remove one or more items from the Collision List dialog box, select the item or items, and click the Clear button. You may find this useful if you want to remove an item you've already corrected or if you want to focus on a subset of a large list of detected collisions.


Deleting CAD

Delete Cad dialog box

The Edit | Delete | Cad Elements menu option displays the Delete CAD dialog box.

Display Menu Roadmap

This dialog box lets you permanently remove the nominal images of features from the Graphics Display window. This function is useful in simplifying an imported CAD file before building an inspection program. For example, a CAD file may contain text or other descriptive information that has no impact on the inspection of the part. The Delete CAD dialog box allows you to delete this extraneous data.

More:

Feature Types

Number of Selected Features

Number of Deleted Features

Delete CAD

Undo Deleted CAD

Deselect


Feature Types

The Feature Types area of the dialog contains various check boxes telling PC-DMIS what type of feature(s) to delete. The available selection consists of the following:

  • Points

  • Lines

  • Circles

  • Arcs

  • Curves

  • Surfaces


Number of Selected Features

This option displays the number of features that PC-DMIS will alter.


Number of Deleted Features

The Number Deleted boxes display the number of features that have been deleted. The numbers in these fields change depending on the features selected in the Feature Types area of the dialog.


Delete CAD

The Delete command button tells PC-DMIS to delete any nominal features that have been selected.


Undo Deleted CAD

The Undo command button tells PC-DMIS to restore any nominal features that have just been deleted.


Deselect

The Deselect command button tells PC-DMIS to deselect any features that were previously highlighted.


Deleting Features

Display Menu Roadmap

PC-DMIS allows you to delete existing features in three ways:

  • You can select features in the Edit window and press the DELETE key on your keyboard.

  • You can use the Delete Features dialog box. Discussed below.

  • You can place your cursor in the Edit window and select the Delete [Feature] menu option. Discussed below.

More:

Deleting using the Delete Features Dialog Box

Deleting using the Delete [Feature] Menu Option


Deleting using the Delete Features Dialog Box

Delete Features dialog box

Display Menu Roadmap

Selecting the Edit | Delete | Features menu option brings up the Delete Features dialog box. This dialog lets you permanently remove the measured or constructed features from the part program. This option should be used when a number of unnecessary features need to be removed.

The Delete Features dialog box allows you to key in the ID #, click on the feature, or select the last feature created by specifying a number. PC-DMIS also offers the ability to restore any feature that has just been deleted. When the OK command button is pressed, the indicated features will be deleted.

Note: When measured features are removed from the Graphics Display window, PC-DMIS will automatically remove any dimensions or datums associated with them from the part program.

More:

Delete Features

Undo Deleted Features

Clear List


Delete Features

The Delete command button deletes any features that were marked for deletion. This deletion is not permanent until the OK button is pressed.


Undo Deleted Features

The Undo command button allows you to restore all the deleted features that were deleted using the Delete button. This button will not restore deleted features once the OK button is pressed.


Clear List

The Clear List command button clears the list box of any marked features to be deleted.


Deleting using the Delete [Feature] Menu Option

Display Menu Roadmap

The Edit | Delete | Delete [Feature] menu option also allows you to delete the feature at the cursor's location in the Edit window. [Feature] indicates the ID of the feature to be deleted (i.e. Delete PNT1). Usually, when creating a part program, your cursor will be at the end of your part program, thus selecting the Delete [Feature] menu option deletes the last feature in your part program.


Deleting Dimensions

Delete Dimensions dialog box

Display Menu Roadmap

The Delete Dimensions dialog box (Edit | Delete | Dimension) lets you permanently remove any dimensions from the part program. This option should be used when a number of unnecessary dimensions need to be removed.

The Delete Dimensions dialog box allows you to key in the ID #, click on the dimension, select all the dimensions, or select the most recently created dimensions by typing a number in the Select Last # box. PC-DMIS also offers the ability to restore any deleted dimension by clicking the Undo button before you click the OK button. When you click the OK button, the indicated dimensions will be deleted permanently.

More:

Delete Dimensions

Undo Deleted Dimensions

Clear List


Delete Dimensions

The Delete command button places a text fragment of "del" after any dimensions that is selected form the list when you click Delete. You can select all the dimensions from the list by clicking Select All. This deletion is not permanent until the OK button is pressed.


Undo Deleted Dimensions

The Undo command button allows you to restore all the deleted dimensions that are marked for deletion using the Delete button. This button will not restore deleted dimensions once the OK button is pressed.


Clear List

The Clear List command button clears the list box of any marked dimensions to be deleted.


Right Hand Rule: If you extend the thumb on your right hand in the direction of the line vector, and curl your other fingers into your palm, your fingers indicate the direction of positive angle rotation.

You can select the Specify Rotate Matrix check box to type the values for the rotation matrix manually. The columns specify the axes for the rotation. These restrictions apply:

  • Each axis of the matrix must be orthogonal to the other two axes. Thus, each axis pair must form a 90-degree angle.

  • Each axis must be unit length. That is, the length of the axis must be one.

When you apply the transformation, if either of these restrictions is not met, a message appears indicating the problem, and PC-DMIS automatically corrects the rotation matrix.

Transforming a CAD Model

PC-DMIS 4.0 and later lets you transform (translate, scale and rotate) your CAD model, and if desired, keep a copy of the original unmodified CAD model, as well as create a new coordinate system for the transformed model.

Display Menu Roadmap

To transform your CAD model, access the CAD Transform dialog box by selecting Operation | Graphics Display Window | Transform. Once the dialog box appears, use the items on the dialog box as needed, and then click OK or Apply.

CAD Transform dialog box

CAD Transform dialog box

Dialog Box Item

Description

Keep Original

This check box lets you keep a copy of the original, unmodified CAD model.

Create new coordinate system

This check box lets you create a new coordinate system from the newly translated CAD model. See "Working with CAD Coordinate Systems" for more information.

Translate

This area defines the XYZ offsets to translate the model.

You can either type the specific location to which you want PC-DMIS to move the coordinate system, or if you don't know the coordinates, you can use the Select button to select a specific CAD entity to which the coordinate system will move. See "Transforming by Selecting" below.

Scale

This area defines how the CAD model will be scaled. This can be useful for fixing models that are not scaled correctly due to improper measurement unit identification. For example, if the model is sized for millimeter units but you know they should be inch units, you would scale the model by 25.4.

The Uniform check box uniformly scales the model. If you want to scale a selected axis of the model, clear the Uniform check box. Leave the value as 1 for axes that you don't want scaled, and change the axis that you want scaled. You can also scale axes by negative values. This is useful if you want to mirror an axis. In this case you would enter -1 for that axis.

Mirror

In this section you can mirror the CAD view of a part. Mirroring provides the same functionality that could be done using Scale with -1 specified for the mirroring axis.

Mirroring your CAD model is particularly useful when measuring automotive parts that have identical left and right-hand pieces. If CAD information is available for the right side of a part, you can mirror the appropriate axis and create a CAD view of the left side of the part.

Select the axis you want to mirror. If you want to keep your old CAD data so that after mirroring you'll have CAD data for both the symmetrical halves, click the Keep Original check box.

Once you click Apply or OK PC-DMIS will mirror the CAD drawing in the specified axis and display the image in the Graphics Display window.

The Mirror option does not create a new part program in the mirrored image. If you want to mirror your part program instead, see the "Mirror" topic in the "Using Basic File Options" section and follow the instructions available.

Rotate

This area controls how the CAD model will be rotated. Type the angle you want to rotate the model by in the Angle box.

You can either type the specific location to which you want PC-DMIS to move the coordinate system, or if you don't know the coordinates, you can use the Select button to select a specific CAD entity to which the coordinate system will move. See "Transforming by Selecting" below.

Rotate Axis

This area defines the line about which the CAD model will be rotated. The model will rotate about this line by the specified angle. The direction of rotation follows the right-hand rule.

You can use one of the coordinate system axes as the line to rotate about by selecting the appropriate X, Y, or Z axis option button.

If you don't want to rotate about one of the coordinate system axes, you can rotate about an arbitrary line by selecting the Line option button. This enables the Line Vector and Line Point areas. Fill these areas out to determine the point and vector that comprise the arbitrary line.

Rotate Matrix

As you determine your CAD model's new transformation, this area automatically gets filled out with the values to use in a 3x3 matrix. This 3x3 matrix rotates the CAD model.

Usually, you won't need to fill out anything in this area as it is generally for informational purposes only.

For the Advanced User:

Transforming by Selecting

When you click the Select button PC-DMIS displays the Select Points dialog box.

Select Points dialog box

Instead of typing an offset value, you can use this dialog box to select an offset by simply picking a CAD entity from the Graphics Display window.

Dialog Box Item

Description

Select point 1 option

This option defines the translation location. With this option selected, click on a desired CAD entity. This anchors the point to that location.

Select point 2 option

This option specifies the angle with respect to point 1 and the axis of rotation. With this option selected, click on a second CAD entity on your CAD model to define the angle.

Select line option

Instead of selecting two points for your translation, this option lets you select a single line. PC-DMIS then sets the values of the Point 1 and Point 2 areas to match the start and end point of the selected line.

Reverse Points button

This switches the XYZ values of Point 1 with the XYZ values of Point 2.

Point 1 and Point 2 areas

These areas define the XYZ center point of the CAD entity selected with the Select point 1 and Select point 2 options.

The check boxes in these areas allow you to selectively update the X, Y, or Z value of the point, enabling you to specify points where there is no actual geometry for you to click on. For example, for Point 1, suppose you wanted the X and Y value of one point but the Z value of a different point. To do this, you would clear the Z check box and then select one point. Then you would clear the X, Y check boxes, select the Z check box, and then select the other point.


Working with CAD Coordinate Systems

CAD Coordinate System dialog box

CAD Coordinate System dialog box

Display Menu Roadmap

The Edit | Graphics Display Window | CAD Coordinate System menu option displays the CAD Coordinate System dialog box. The CAD Coordinate System dialog box lets you create or select new coordinate systems for your CAD model.

The Coordinate System list on the left side of the dialog box shows all the coordinate systems in the CAD model. The coordinate systems listed first are the global coordinate systems. You will always see the Default coordinate system listed.

If the CAD model is an assembly of component parts, then following the global coordinate systems will be listed all the coordinate systems contained in that assembly. These are listed in a tree view structure. To expand the tree view, click on a plus symbol (+). PC-DMIS displays the component parts' assembly coordinate systems. You will always see a Default coordinate system listed for each part component in the assembly. This coordinate system defines the part's default local coordinate system.

When you first open the CAD Coordinate System dialog box, PC-DMIS checks to see if the current active coordinate system matches a coordinate system in the list:

  • If it finds a match, then PC-DMIS selects it from the list.

  • If it doesn't match any of the coordinate systems, then PC-DMIS uses the Default coordinate system at the top of the list. This can happen if you transformed the CAD without creating a coordinate system (see CAD Transform dialog section for more information).

To Select and use Coordinate Systems

To use an existing coordinate system,

  1. Select the coordinate system from the Coordinate System List. PC-DMIS shows that coordinate system in the Graphics Display window. If you select an assembly component, PC-DMIS selects the first coordinate system in that component instead.

  2. Click Apply or OK. The selected coordinate system becomes the new active coordinate system and PC-DMIS redraws the CAD to reflect its new position.

To Create a Coordinate System

To create a coordinate system at the current CAD model's position, click the Create button. The CAD model's position can be changed by using the CAD Transform dialog box. See the "Transforming a CAD Model" topic for more information on transforming the CAD model.

To Rename a Coordinate System

To rename a coordinate system, select the coordinate system from the list, and click the Rename button. Then type the new name.

You cannot rename the Default coordinate systems.

To Delete a Coordinate System

To delete a coordinate system, select the coordinate system from the list, and click the Delete button. PC-DMIS deletes the selected coordinate system.

You cannot delete the Default coordinate system or assembly coordinate systems.

To Replace a Coordinate System

To replace or overwrite an existing Coordinate System with the current CAD model's position, select a coordinate system from the list, and click the Replace button.

You cannot replace the Default coordinate system or assembly coordinate systems.


Point Nominal Deviation

Example of Points Copied to Windows Clipboard

Checking and Fixing Point Nominal Deviation

Display Menu Roadmap

Point Nominal Deviation dialog box

The Edit | Graphics Display Window | Point Nominal Deviation menu option displays the Point Nominal Deviation dialog box. This re-sizable dialog box lets you easily compare certain point measurements against a CAD model in order to check for changes or updates made to the CAD model. Essentially, you define a tolerance value, and PC-DMIS will look at the nominals for any point features in your part program and compare them against the CAD model. PC-DMIS will list all points. If any points deviate beyond the defined tolerance value, PC-DMIS will list those points in a red/orange color, allowing you to adjust them as needed.

The Point Nominal Deviation dialog box contains the following options:

Item

Description

Deviation cutoff box

This box filters which point features are displayed. The distance between a point feature's theoretical position and the CAD model nominal position is its deviation. Only points whose deviation is greater than or equal to the deviation cutoff will be listed.

Angle deviation cutoff box

This box controls the nominal CAD position. The CAD surface normal and the point vector must be within this angle. The range for this angle is 0-90 degrees.

Find Nominals Tolerance box

This defines the tolerance value that will be allowed for each point feature. Points with a deviation that exceeds this tolerance value will turn red.

Search Priority Surfaces Only check box

This check box determines whether or not PC-DMIS only uses priority surfaces when searching for a solution. You can define priority surfaces using the Set as Priority check box in the Edit CAD Elements dialog box. See the "Editing CAD" topic for more information on how to do this.

If you clear this check box, and PC-DMIS cannot find an acceptable value within the defined priority surfaces, it will then check all the other surfaces in the CAD model.

Move Checked Features

This button updates the XYZ and IJK values of those point features whose check boxes you have selected to match the CAD model's XYZ and IJK values.

Copy Checked to Clipboard

This button copies the information for all selected points to the Windows Clipboard. The information in the columns will be delimited by semi colons, as shown here:

Override

Sometimes the best point that the algorithm finds is incorrect. If you select a single feature, the Override button becomes available for selection. Clicking this button will display an Override dialog box. This dialog box lets you override the found point with a different point.

See the "Using the Override Dialog Box" topic below.

Feature column

This column displays the name of the ID of the feature. The column header contains a check box. Selecting or clearing this check box selects or clears the check boxes for all point features in the list.

Current XYZ

This column displays the feature's current theoretical position.

Current IJK

This column displays the feature's current theoretical vectors.

CAD XYZ

This column displays the feature's nominal position if it were moved onto the CAD.

CAD IJK

This column displays the feature's nominal vector if it were moved onto the CAD.

Deviation

This column displays the distance between the feature's current theoretical position and its corresponding nominal CAD position.

Angle Dev

This column displays the angle deviation between the feature's current theoretical vector and its corresponding nominal CAD vector.

Using the Override Dialog Box

The Override dialog box appears if you select the Override button from the Point Nominals Deviation dialog box.

It shows a list of all the CAD nominal points that correspond to the selected feature from all surfaces within the Find Nominals Tolerance search zone. PC-DMIS initially sorts these points from smallest to largest deviation. Usually the first point listed is the point used in the Point Nominals Deviation dialog box. Each point is graphically represented with a cross-hair in the Graphics Display window. Selecting a point in the list highlights that point as well as any curve or surface on which the point lies in the Graphics Display window. Once you find the desired point, click the Override button. The Override dialog box closes and the Point Nominals Deviation dialog box reappears, showing the updated point value.

Use Previous Surface check box - You should use this check box when overriding several points. For example, if you know that points for several features should all lie on the same surface but the algorithm incorrectly put the points on different surfaces, you would override the first feature as usual. Then on the second and subsequent overrides, you could select the Use Previous Surface check box. This would cause PC-DMIS to only show the points found on the surface of the previous override.

Find Nominals Tolerance - This box functions the same as the field of the same name found in the Point Nominal Deviation dialog box but with different results. PC-DMIS searches the CAD for nominal points that correspond to the selected feature. It searches in a spherical zone around the current theoretical position of the selected feature. This box defines the size of that spherical search zone. The value regulates the amount of CAD that PC-DMIS evaluates while generating this point override list.

The other items used in the Override dialog box are already discussed in the Point Nominals Deviation dialog box above.


Modifying Display Symbols

Selecting the Edit | Graphics Display Window | Display Symbols menu item (or the Display Symbols icon from the Graphics Modes toolbar) causes the Display Symbols dialog box to appear. Display Menu Roadmap

Display Symbols dialog box

This dialog box lets you change how different symbols are displayed in the Graphics Display window. The initial values for the settings in the Display Symbols dialog box come from the part program file (.PRG). If no settings information exists in the part program, then the initial values for the settings will come from the registry or hard-coded defaults.

Available symbols you can modify include the Point Symbol, the Arrow Symbol, and Path Lines. Whenever you make a change to one of the check boxes or option buttons, PC-DMIS will apply that change automatically so you can see what effect it will have. PC-DMIS will only save your changes once you click the OK button. To see changes to the symbols' sizes click the appropriate Apply button.

Dialog Box Item

Description

Point Symbol drop-down list

This list defines the type of Point to modify. You can choose either Scan Point, CAD Point, or Feature Point. The default item is Feature Point.

Diameter / Width in Pixels box

This box defines the size of the point symbol. Square Dot and Round Dot symbols use Width in Pixels; 3 Lines and Sphere use Diameter in part program units. Note that the maximum size for Round Dot is based on the computer's physical video card. If the size exceeds the limits of the current computer's video card, it will simply display the symbol at the largest size available to the current system's video card.

Square Dot option button

This option displays the point symbol as a square dot. This is the quickest symbol for PC-DMIS to draw.

Example Square Dot symbol

Round Dot option button

This option displays the point symbol as a round dot.

Example Round Dot symbol

Note: Square Dot and Round Dot symbols are drawn flat on the screen and may be clipped by the CAD model.

Three Lines option button

This option displays the point symbol as a three-lined cross hair.

Example Three Lines symbol

Sphere option button

This option displays the point symbols as a sphere. This is the slowest symbol for PC-DMIS to draw, especially if you have all the attributes selected.

These check boxes become available if you select the Sphere symbol. They provide you with additional attributes to further control the display of a sphere symbol in the Graphics Display window.

  • Shaded - This check box produces a shaded (opaque) sphere symbol.

  • Lighting - This check box adds OpenGL lighting to the sphere symbol.

  • High Quality - This check box produces a smoother looking sphere symbol.

While these check boxes improve the image quality of the sphere symbol, they will also cause a slight increase in the time it takes to draw the sphere symbols whenever the screen gets refreshed.

Some Examples:

- Shaded, High Quality

- Lighting, High Quality

- Shaded, Lighting, High quality

Arrow Symbol box

This box controls the diameter size (in part program units) of the arrows displayed in the Graphics Display window. The size of the actual arrow in the display will change only if the Shaded check box is selected. The value is in part program units.

Shaded - This check box shades arrow symbol, in essence drawing arrows as cylinder tubes with a set diameter. If not selected, arrows are drawn as simple lines without size.

Some Examples:

- Not Shaded

- Shaded

- Increased Diameter

Path Lines box

This area controls the fixed diameter size (in part program units) of the path lines displayed in the Graphics Display window. Fixed size means the path lines will not change size on the screen when zooming in or out on part model.

Some Examples:

- Default Size

- Increased Diameter


Editing a Part Program

Editing a Part Program: Introduction

Using Standard Edit Commands

Editing Patterns of Features

Finding and Replacing Text

Editing Data Fields

Jumping to Specified Line Numbers

Editing Nominal Values

Jumping to and from Referenced Commands

Overriding Guessed Features

Overriding Found Nominals

Marking Commands for Execution

Creating and Executing Marked Sets

Using Breakpoints

Setting Start Points

Using Bookmarks

Changing Fonts and Colors

Editing External Objects


Editing a Part Program: Introduction

PC-DMIS's main purposes are to allow you to create, edit, and execute part programs with ease. This section discusses using the Edit menu (with other menu options) to edit your part programs. While the Edit menu works with the commands that appear in the Edit window, a discussion of the Edit window itself is beyond the scope of this section. For an in-depth look at the Edit window see, the "Using the Edit window" section.

This section covers these topics:

  • Using Standard Edit Commands

  • Editing Patterns of Features

  • Finding and Replacing Text

  • Editing Data Fields

  • Jumping to Specified Line Numbers

  • Jumping to and from Referenced Commands

  • Overriding Guessed Features

  • Overriding Found Nominals

  • Marking Commands for Execution

  • Creating and Executing Marked Sets

  • Using Bookmarks

  • Using Breakpoints

  • Changing Fonts and Colors

  • Editing External Objects


Using Standard Edit Commands

PC-DMIS, like most Windows applications, allows you to use standard edit commands in your part program. The following standard menu options are available:

  • Undo

  • Redo

  • Cut

  • Copy

  • Paste

  • Delete

  • Select All


Undo

Display Menu Roadmap

The Edit | Undo menu option removes the last change you made to the Edit window. You can continue to select the Undo option to remove multiple changes to the Edit window.

Note: Be aware that switching to a different mode, completely removes all changes from memory.


Redo

Display Menu Roadmap

The Edit | Redo menu option reverses the last changes that took place when you used the Undo menu option. Like the Undo option, you can use the Redo option multiple times to replace multiple changes.

Note: Be aware that switching to a different mode, completely removes all changes from memory.


Cut

Display Menu Roadmap

The Edit | Cut menu option allows you to "cut" or move text from one area to another using the clipboard.

To cut text:

  1. Highlight the item(s) to be moved to another area.

  2. Select the Cut option. The text will be removed from the Edit window and stored on the clipboard.

  3. Select the Paste command to restore the cut text. (See "Paste".)

Note: When selecting the Cut command any previous clipboard contents will be replaced with the cut selection.


Copy

Display Menu Roadmap

The Edit | Copy menu option also allows you to copy and move text from one area to another using the clipboard. The only difference between this option and the Cut option is that the text will not be removed from the Edit window when it is copied.

To copy text:

  1. Highlight the desired text.

  2. Select the Copy command. The text will remain in its current location and will be stored on the clipboard as well.

  3. Select the Paste command to restore the cut text. (See "Paste".)

Note: When selecting the Copy command any previous clipboard contents will be replaced with the copied selection.


Paste

Display Menu Roadmap

The Edit | Paste menu option allows you to paste copied text from the clipboard into the Edit window at the cursor's location.


Delete

Display Menu Roadmap

The Edit | Delete | Selection menu option deletes the currently highlighted selection from the Edit window. The contents of the deleted selection are not placed on the clipboard.


Select All

Display Menu Roadmap

The Edit | Select All menu option allows you to select all the contents of the Edit window for editing purposes.


Editing Patterns of Features

Patterns of features are often encountered in parts. PC-DMIS provides you with ways to create patterned features. Consider these menu options:

  • Pattern

  • Paste with Pattern


Pattern

Display Menu Roadmap

The Edit | Pattern menu option brings up the Pattern Offsets dialog box.

Pattern Offsets dialog box

This dialog allows you to define the offsets that will be used when selecting the Edit | Paste With Pattern option.

To create a pattern:

  1. Access the Pattern Offset dialog box.

  2. Type any desired offset values.

  3. Select any desired mirror option.

  4. Type the number of times to offset in the Number of Times to Offset box.

  5. Press the OK command button.

  6. Optionally, press the Cancel button to close the dialog without making changes to the current settings.

More:

X, Y, Z Offset

Angle Offset

Number of Times to Offset

Flip X, Y, Z


X, Y, Z Offset

These fields allow you to set the X, Y, or Z Offset between pattern occurrences.

To change the X, Y, or Z Offset values:

  1. Select the desired X, Y, or Z Offset box.

  2. Type the desired change.

PC-DMIS will offset the nominal X, Y, and Z data of the pasted feature (or set of features) by these offset values.


Angle Offset

The Angle Offset box allows you to set the angular offset between pattern occurrences.

An angular offset might be useful when measuring the true position location of a number of holes in a bolt hole pattern, where the datum was a hole in the center of the pattern. PC-DMIS will rotate the offset around the origin.

Angular offsets can be used in conjunction with X, Y, and Z offsets and flips. The order of applying these offsets is flips, rotations, and lastly, translations.

To change the angle offset:

  1. Select the Angle Offset box in the dialog box.

  2. Type the desired value.


Number of Times to Offset

This option lets you set up the number of times PC-DMIS will offset a pattern. To change the current value, select this option and type a new value. The default value is one.


Flip X, Y, Z

The Flip X, Flip Y, or Flip Z options mirror the pattern around the X, Y, or Z axis, respectively. The original pattern is flipped about the X, Y, or Z axis before any translation or rotation.


Paste with Pattern

Display Menu Roadmap

The Edit | Paste With Pattern option takes any feature (or group of features) stored on the clipboard and pastes it to the Edit window at the current cursor location. When you do this, new features are created based on those copied to the clipboard. However, the newly created features will have the previously defined pattern offsets applied to them. See "Pattern" for more information.

To paste features using a pattern:

  1. Make sure the proper offsets have been defined using the Pattern Offset dialog box (select the Pattern menu option).

  2. Make sure the feature (or set of features) you want to offset has been highlighted and copied to the clipboard.

  3. Position the cursor at the location in the part program where the new features are to be inserted.

  4. Select the Edit | Paste With Pattern menu command.

PC-DMIS will paste the contents of the clipboard as many times as indicated by the value in the Number of Times to Offset of the Pattern Offset dialog box. Each time the clipboard contents are pasted, the newly created feature(s) will be offset with respect to the previously inserted feature(s) by the defined pattern offsets. The identifications for the new features will be incremented from the original feature ID. PC-DMIS will also draw the newly created features in the Graphics Display window.


Finding and Replacing Text

You can find and replace text in Edit window fields by using standard regular expressions described in these menu options:

  • Find

  • Replace


Find

Display Menu Roadmap

The Edit | Find and Replace | Find menu option opens the Find dialog box which allows you to find a specified keyword within the Edit window.

Find dialog box

More:

Using Wildcards

Using Predefined Character Sets

To search for a specific word or phrase:


Using Wildcards

To use wildcards to perform pattern matching, select the Pattern match check box.

This option also allows you to find text matching a variety of different search criteria. Consider the following table:

Text To Find

Wildcard to Use

Some Examples

Any one character

.

D.M matches "DIM" or "D4M".

Character set

[ ]

D[MI]S finds "DIS" and "DMS" but not "DMIS" or "DUS".

Any one character in a range

[-]

LINE[2-6] finds "LINE2" and "LINE3" but not "LINE1" or "LINE7". Ranges must be in ascending order.

Any one character except character(s) inside brackets

[^]

POINT[^32] finds "POINT1", "POINT5", and "POINT12", but not "POINT3", "POINT2", "POINT21", or "POINT30".

Any one character except range of characters inside brackets

[^x-z]

LINE[^2-5] finds "LINE6" and "LINEH", but not "LINE3"

Character sets that include the "-" character should have the "-" as the first or last character of the range. If the range excludes the "-" then the "-" should be the second character.

[-]

LINE[0-9-] matches "LINE4" and "LINE-". LINE[^-0-9] matches "LINEH" but not "LINE-".

0 or more instances of the preceding character, unless the following:

"*" starts a string

"*" follows a "^" that starts a string

"*" starts a parenthesized sub-expression

*

lo*p matches "lp" and "looooop".

^* matches a "*" if it starts a line.

Line beginning with a specified phrase or character. The "^" is special only at the beginning of a string.

^

^CIRCLE finds all lines that begin with the word "CIRCLE". Note that indented lines in PC-DMIS's Edit window begin with spaces.

Line ending with a specified phrase or character. The "$" is special only at the end of a string.

$

ENDMEAS/$ finds lines ending in "ENDMEAS/" but not "MEAS/"

Parentheses in the Find What box store what is within them to be recalled later in the Replace With box.

In the Replace With box a backslash "\" character, followed by a number would bring that defined pattern into the replace text.

() and \

Find What:
BO(BB)Y(RAY)

Replace With:
DO\1YP\2

Would Give:
DOBBYPRAY

\1 uses the first set of characters offset by parentheses, \2 the second set and so on.

Note: For pattern matches, you no longer need to precede parentheses with a backslash (\) character as you had to do in some earlier versions of PC-DMIS.


Using Predefined Character Sets

To match a predefined character set, select the Pattern match check box. You can then search the text by using these special predefined character sets:

Character set | Characters in set
[[:alnum:]] | ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789
[[:alpha:]] | ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz
[[:blank:]] | (The space character and the tab character)
[[:digit:]] | 0123456789
[[:graph:]] | ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789!"#$%&'()*+,-./:;<=>?@[\]^_`{|}~
[[:lower:]] | Abcdefghijklmnopqrstuvwxyz
[[:print:]] | ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz 0123456789!"#$%&'()*+,-./:;<=>?@[\]^_`{|}~
[[:punct:]] | !"#$%&'()*+,-./:;<=>?@[\]^_`{|}~
[[:upper:]] | ABCDEFGHIJKLMNOPQRSTUVWXYZ
[[:xdigit:]] | 0123456789ABCDEFabcdef

Example: To search for a string which consists of a letter, followed by some letters or numbers, followed by that same first letter, you would use a back reference, as shown here: ([[:alpha:]])[[:alnum:]]\{1,\}\1.


To search for a specific word or phrase:

Display Menu Roadmap

  1. Select Edit | Find and Replace | Find from the menu bar.

  2. Type in a keyword or phrase to search.

  3. Indicate the search path (up or down).

  4. Select the Match whole word only check box if you want PC-DMIS to match the entire word. For example, if you type "CIR", PC-DMIS will find "CIR" but not "CIRCLE".

  5. Select the Match Case check box if you want PC-DMIS to search based on upper or lower case.

  6. Press the Find button (or press ENTER).


Replace

Display Menu Roadmap

The Edit | Find and Replace | Replace option works much the same way as the Find option (see "Find"). Once the text is found, however, you can replace that text by using the Replace dialog box.

Replace dialog box

In versions prior to 3.6, you could only search and replace within editable fields in the edit window. For example you couldn't replace

SHOWHITS=NO

with

SHOWHITS=YES

because SHOWHITS= was a constant field. Only the editable portion of the command (the NO to the YES) could be replaced.

With PC-DMIS version 3.6 and above, however, you can now search and replace with any matching string as long as the last part of the string corresponds to an editable field, and as long as it is the only editable field in the string that will be changing.

A Find and Replace Example That Works:

=AUTO/CIRCLE,SHOWALLPARAMS = NO

replaced with

=AUTO/CIRCLE,SHOWALLPARAMS = YES

Notice that the end of the string corresponds to an editable field. Only the last editable field can be changed from the search string.

A Find and Replace Example That Will NOT Work:

You cannot, for example, replace two editable fields in one replace like this:

=AUTO/CIRCLE,SHOWALLPARAMS = NO

cannot be replaced with

=AUTO/LINE,SHOWALLPARAMS = YES

because both CIRCLE to LINE is one editable field and NO to YES is another editable field.

Neither can you do something like this:

=AUTO/CIRCLE,SHOWALLPARAMS

cannot be replaced with

=AUTO/CIRCLE,MYSHOWALL

because the part you want replaced is a constant field.

More:

F ind what

Replace with

Match whole word only

Match case

Pattern matching

Find Next bu tton

Replace button

Replace All button


Find what

This box allows you to enter the text for which PC-DMIS will search. You can use any of the various wild cards and search patterns discussed in the "Find" section. See "Find".


Replace with

This box allows you to indicate what text will replace the found text.


Match whole word only

If you select this check box, PC-DMIS will only look for an entire word containing that text. For example, if you type in "CIR" in the Find what box, and select this check box, PC-DMIS finds only "CIR". It will not find "CIRCLE" or "CIRCULAR".


Match case

This check box tells PC-DMIS to search for text matching the case (upper or lower) used in the Find what box. For example, if you typed "Point" in the Find what box and selected the Match case check box, PC-DMIS would find "Point" and "Points", but not "POINT".


Pattern matching

This check box tells PC-DMIS to look for specified patterns. You should select this check box when searching for pattern matches using wildcards or other special character matching.


Find Next button

The Find Next button tells PC-DMIS to find the next instance of the text for which you're searching.


Replace button

The Replace button replaces the found text with the text string in the Replace with box. This allows you to replace instances of found text one at a time.


Replace All button

The Replace all button tells PC-DMIS to instantly find all occurrences of text in the Find what box and replaces them with the text in the Replace with box.


Editing Data Fields

Edit Data Field wizard

The Edit Data Field wizard is an external program that works with PC-DMIS to let you change data inside specified data fields of certain command types inside the Edit window. To access this wizard, select the DataFieldEdit icon from the Wizards toolbar.

This wizard differs from the Replace dialog box. It allows you to change data items globally inside any mode of the Edit window, whereas the Replace dialog box only works inside of Command mode. Additionally, this will allow you to replace certain values that you cannot change using the Replace dialog box.

The Edit Data Field dialog box contains these items:

Choose Command Type – This list displays the available command types.

Choose Data Type – This list displays the data types for the selected command type. If you want to see all data types in this list, select All Command Types, from the Choose Command Type list.

Type Index – This box lets you specify an exact field you want to change by its numerical index. You will find this useful when you have more than one field of the same data type and you want to change only one of the fields. Typing an index value lets you determine which one to change. For example, the CLEARP command has two distance fields, one for the clearance distance and one for the pass distance. Typing an index of 1 would target the clearance distance while a value of 2 would target the pass distance.

Change From – This area contains the Use check box and a box that holds a value. This check box lets you specify a value you want to change from. This means that PC-DMIS will only target those fields that have the given value.

Change To – This box lets you determine the new value for the data field you want to update.

Verify Each Change – If you select this check box, PC-DMIS will display a message box showing the ID of the item to change, its current value, and whether or not you want to change that data field to the new value.

Change – This button begins the process of finding the data field and changing it to the new value.

Status – The box at the bottom of the dialog box displays any status or diagnostic messages during the change process.


Jumping to Specified Line Numbers

PC-DMIS can easily jump to specified line numbers. Use the Edit | Find and Replace | Go To menu option to jump to a specified line within the Edit window.

Display Menu Roadmap

Go To dialog box

To move the cursor to a specific line number in Command or DMIS mode:

  1. Select Edit | Go To from the menu. The Go To dialog box will appear.

  2. The current line marked by the cursor will be indicated in the Line Number box of the dialog box.

  3. Type the desired line number.

  4. Click the OK button (or press ENTER). PC-DMIS displays the specified line.


Jumping to and from Referenced Commands

In the Edit window's command mode, if one command in the Edit window references another command, you can jump to the referenced command, by highlighting the label to the referenced command and selecting the Edit | Find and Replace | Jump To menu option. Display Menu Roadmap

When you arrive at the referenced command you can quickly jump back to the previous feature by selecting the Edit | Find and Replace | Jump Back menu option. Display Menu Roadmap

Example: Suppose in an alignment block you have the following commands and you want to jump to the LIN2 feature referenced in the block:

A1 =ALIGNMENT/START,RECALL:STARTUP, LIST= YES

ALIGNMENT/LEVEL,ZPLUS,PLN1

ALIGNMENT/ROTATE,XPLUS,TO,LIN1,ABOUT,ZPLUS

ALIGNMENT/TRANS,XAXIS,LIN2

ALIGNMENT/TRANS,YAXIS,LIN1

ALIGNMENT/TRANS,ZAXIS,PLN1

ALIGNMENT/END

You would highlight LIN2 and select the Jump To menu option from the menu bar or right-click and select it from the shortcut menu. You can then jump back to the command you were just at by selecting Jump Back.

You can also select these menu options from a shortcut menu that appears when you right-click on the features in the Edit window's Command mode.


Editing Nominal and Target Values

Most of the time you can measure your features just fine, but sometimes, due to manufacturing errors, a feature won't be close to its theoretical (nominal) location, but rather shifted somehow. For Measured features, you need to adjust your theoretical values to handle this situation. However, using the more advanced Auto Features, you can modify the target instead. This will adjust the path accordingly, yet will allow dimensioning to take place relative to the original theoretical values.

Modifying Nominal Values (for both Measured and Auto Features)

PC-DMIS provides you with simple ways to modify the nominal value. You can easily modify the field itself inside Command mode, an alternate way is to place the cursor over the feature and press F9. This causes a dialog box to appear with the nominal information inside of it.

Modify the nominal information and click OK or Create. The dialog box closes.

  • If you are modifying a measured feature, PC-DMIS displays a prompt asking if you want to update measured values as well. If you click Yes, the measured values will get updated to match the newly entered nominal values. If you click No, the measured values remain what they were.

  • If you are modifying an auto feature, PC-DMIS asks if you want to update the target values to match the new theoretical values. If you click Yes, the target values will get updated to match the newly entered nominal values. If you click No, the target values remain what they were.

Modifying Target Values (for Auto Features only)

If you have an auto feature, you can choose to modify target values instead of the theoretical values. The target values determine the location where PC-DMIS will try to measure the auto feature. This lets you keep the theoretical values for dimensioning purposes, but still changes the location at which the software attempts measurement. To modify the target values, use the Edit window:

  • Modifying Target Values Summary Mode: Select the field, press ENTER, type a new a value and press ENTER again to store the change.

  • Modifying Target Values in Command Mode: Tab to the field to change, type a new value, and press TAB again to store the change.


Overriding Guessed Features

The Edit | Override Guess sub-menu allows you to change the type of feature last measured.

Display Menu Roadmap

For example, if a circle was the last feature measured and PC-DMIS guessed that it was a plane, this option can be used to convert the feature to the proper type. This option must be used before any other features are measured or constructed.

To use the Override feature:

  1. Access the Edit window.

  2. Place your cursor on the incorrect feature type in the Edit window.

  3. From the Override Guess sub-menu select the correct feature type.

You will see that the feature changes will be made in the Edit window.


Overriding Found Nominals

FindNoms Override dialog box

Display Menu Roadmap

The FindNoms Override dialog box (Edit | Override Find Noms) allows you to choose the appropriate nominal point from CAD surfaces for Auto Vector Points, Auto Surface Points, and individual hits inside other features (such as scans). It overrides the default FindNoms behavior of PC-DMIS during Learn mode and Execute mode.

When attempting to find a valid nominal point (within the FindNoms tolerance) by taking a manual hit, PC-DMIS will, most of the time, choose the correct point. However, there are exceptional circumstances when PC-DMIS cannot find an appropriate point and instead chooses an inaccurate point on the CAD model. In these situations, you can use the FindNoms Override dialog box to help PC-DMIS find the appropriate nominal point from the CAD surfaces.

To enable the Override Find Noms menu option, ensure that you have imported a valid CAD model that supports surfaces, select the Surface Mode icon, select the Program Mode icon, and then select both the Find Nominals and Point Only Mode check boxes from the SetUp Options dialog box, General tab (Edit | Preferences | Setup).

The following topics describe the FindNoms Override dialog box itself and how to use the dialog box in the different modes:

More:

Understanding the FindNoms Override Dialog Box

Using the FindNoms Override Dialog Box in Learn mode:

Using FindNoms Override in Execute Mode:

Using the FindNoms Override Dialog Box from the Edit window:


Understanding the FindNoms Override Dialog Box

FindNoms Override dialog box

The following topics describe this dialog box.

More:

The Priority Surface, Pierce Point, and Drop Point Columns

The Tolerance box

The Use Previous Surface check box

The Override button


The Priority Surface, Pierce Point, and Drop Point Columns

This area of the dialog box contains these three columns:

1.) Priority Surface

2.) Pierce Point

3.) Drop Point

A "T-value" is the distance of the measured hit from the nominal point along the nominal CAD surface vector.

They display the relevant nominal point values and their T-values (the value displayed to the left of the X, Y, and Z values in parentheses).

Priority Surface column – This column lists the surfaces that you have stored as priority surfaces in the Edit CAD Elements dialog box (Edit | Graphics Display Window | Cad Elements). Display Menu Roadmap

It displays the type of surface and a check box. The check box allows you to add or remove the surface from the list of priority surfaces maintained by PC-DMIS. If you select the check box, PC-DMIS adds the surface to the priority list. Deselecting the check box removes the surface from the list.

Pierce Point column – This column lists the nominal point values found using PC-DMIS's Pierce Point operation. If you see the text "Failed OP" in this column it means that the pierce point operation failed to find the nominal point on that surface. If PC-DMIS highlights a point in green, then that point is the best nominal point found by the selection algorithm. You can of course override this selected point.

Drop Point column – This column lists the nominal point values found using PC-DMIS's Drop Point operation.


The Tolerance box

The Tolerance box allows you to specify a new tolerance value to use when finding the nominal points using this dialog box.


The Use Previous Surface check box

The Use Previous Surface check box tells PC-DMIS to use the most recent surface to look for the nominal points. This check box becomes available for selection only after you take a hit on a surface with the dialog box open. After you take a hit, PC-DMIS then has a surface to work with for future hits.


The Override button

The Override button overrides an incorrect nominal point found by PC-DMIS with the nominal point data selected from the list containing the Priority Surface, Pierce Point, and Drop Point columns.


Using the FindNoms Override Dialog Box in Learn mode:

To access this dialog box in Learn mode:

  1. Select the Point Only Mode and Find Nominals check boxes from the General tab of the SetUp Options dialog box (Edit | Preferences | Setup). Display Menu Roadmap

  2. Ensure that you have imported a CAD's solid model.

  3. Select the Surface mode icon from the Graphics Modes toolbar.

  4. Select the Override FindNoms menu option. The FindNoms Override dialog box appears.

With the FindNoms Override dialog box open, when you take a manual hit, PC-DMIS follows its normal logic to choose as accurate a nominal point as possible by using the most recently measured hit coordinates and approach vector.

You can then use the FindNoms Override dialog box to perform additional procedures allowing you to override the found nominal point.

More:

Procedure 1: Finding Nominal Points on the Previous Surface

Procedure 2: Finding Nominal Points on Priority Surfaces

Procedure 3: Finding Nominal Points on All CAD Surfaces

Procedure 4: Choosing a Nominal Point Later

After Choosing the Best Nominal Point


Procedure 1: Finding Nominal Points on the Previous Surface

If you select the Use Previous Surface check box, the FindNoms Override dialog box attempts to find a nominal point from the most recent surface used. If the dialog box can find a point within FindNoms tolerance on the most recent surface it will select that nominal point and create an Auto Vector Point based on the nominal values.


Procedure 2: Finding Nominal Points on Priority Surfaces

If the FindNoms Override dialog box cannot find a nominal point on the recent surface (see "Procedure 1: Finding Nominal Points on the Previous Surface"), it tries to find a nominal point from the priority surfaces. Priority surfaces are surfaces that the user has selected as a subset of CAD surfaces to find nominal points. Priority surfaces can be selected or deselected using the Set as Priority check box in the Edit CAD Elements dialog box (see the "Editing CAD" topic in the "Editing the CAD Display" section). If PC-DMIS finds an appropriate point among the priority surfaces, it selects the point and creates an Auto Vector Point based on the nominal values. It also displays the valid nominal points within the FindNoms tolerance of all the priority surfaces in the FindNoms Override dialog box.


Procedure 3: Finding Nominal Points on All CAD Surfaces

If PC-DMIS still cannot find a valid nominal point by using the procedures discussed in procedures 1 and 2, (see the "Procedure 1: Finding Nominal Points on the Previous Surface" and "Procedure 2: Finding Nominal Points on Priority Surfaces" topics), it does the following:

  • Looks for the best nominal point on all the CAD surfaces within the FindNoms tolerance

  • Creates an Auto Vector Point based on the best available nominal point.

  • Displays all the CAD surfaces that had nominal points in the FindNoms Override dialog box.


Procedure 4: Choosing a Nominal Point Later

If PC-DMIS still cannot find an appropriate point on all the CAD surfaces, it asks if it can create the Auto Vector Point and you can choose a nominal point later. If you accept, then PC-DMIS creates an Auto Vector Point in the Edit window and you can select from these options:

Option 1. You can take a new hit and PC-DMIS will try to find a new nominal point. Essentially you're starting over if you do this.

Option 2. You can choose a different nominal point from the dialog box and click the Override button. PC-DMIS will then override its earlier chosen nominal point with the new selected point for the recently created Auto Vector Point.

You will usually want to do this if you don't like the nominal point that PC-DMIS attempted to find in the procedures discussed in these topics:

  • "Procedure 1: Finding Nominal Points on the Previous Surface"

  • "Procedure 2: Finding Nominal Points on Priority Surfaces"

  • "Procedure 3: Finding Nominal Points on All CAD Surfaces"

Options 3. You can select a CAD surface on the screen. PC-DMIS would then attempt to find nominal points on the selected surface and display those points in the FindNoms Override dialog box.

You can then override the previous found nominal, by selecting a point from this new surface and clicking Override.

Note: PC-DMIS ignores the FindNoms tolerance with this option. So, even if the selected CAD surface is out of FindNoms tolerance the dialog box still displays the points.

Option 4. You can increase the FindNoms tolerance by changing the value in the Tolerance box and clicking the Apply button. PC-DMIS will then apply these procedures again, using the higher tolerance value and display any appropriate points:

  • "Procedure 1: Finding Nominal Points on the Previous Surface"

  • "Procedure 2: Finding Nominal Points on Priority Surfaces"

  • "Procedure 3: Finding Nominal Points on All CAD Surfaces"

You can then choose a valid point and click Override to accept a nominal point for the recently created Auto Vector Point.

Increasing the FindNoms tolerance in the Tolerance box has the same effect as changing the FindNoms tolerance from the General tab of the SetUp Options dialog box.


After Choosing the Best Nominal Point

After choosing the best nominal point, PC-DMIS will remember the chosen surface for that feature.

During execution in manual mode, PC-DMIS will:

  1. Use the tolerance value held in the FindNoms During Execution box, available on the General tab of the SetUp Options dialog box (Edit | Preferences | Setup). Display Menu Roadmap

  2. You must select the Find Nominals During Execution check box (also available on the General tab) for this to work.

  3. Attempt to use the same surface and CAD operation (Pierce Point or Drop Point operation) to find the new nominals for the recently executed point.

If it cannot find a nominal point on that CAD surface, it will again access the FindNoms Override dialog box. See the "Using FindNoms Override in Execute Mode:" topic for execution time behavior.


Using FindNoms Override in Execute Mode:

As mentioned in the "After Choosing the Best Nominal Point" topic, the FindNoms Override dialog box, PC-DMIS displays this dialog box in execute mode upon meeting the following conditions:

  • You must import a solid model with surfaces and select the Surface Mode icon from the Graphic Modes toolbar.

  • You must select the Find Nominals During Execution check box from the General tab of the SetUp Options dialog box.

  • The Auto Vector Point or Auto Surface Point must have a valid nominal point found in Learn mode (see "Using the FindNoms Override Dialog Box in Learn mode:").

  • Execution must take place in Manual mode.

  • PC-DMIS must execute the Auto Vector Point or Auto Surface Point feature.

  • PC-DMIS must fail to find a nominal point for executed Auto Vector Point or Auto Surface Point.

Once the dialog box appears, execution stops and you can interact with the dialog box in ways already discussed in the "Using the FindNoms Override Dialog Box in Learn mode:" topic.

You can also choose to re-execute the recently measured point feature. In that case, PC-DMIS re-executes and attempts to find nominal values again. If it still can't find any nominal values for the point, PC-DMIS again displays the FindNoms Override dialog box.

You can then do one of the following:

  • Re-execute again.

  • Use the Override button as discussed in the "Procedure 4: Choosing a Nominal Point Later" topic

  • Close the dialog box by clicking the Cancel button. If you close without choosing an appropriate nominal, PC-DMIS replaces the measured data with the previous nominal values.


Using the FindNoms Override Dialog Box from the Edit window:

You can also access the FindNoms Override dialog box by right-clicking the mouse on one of these features and selecting Override FindNoms from the short-cut menu:

  • Vector point

  • Surface point

  • Individual Hit

The dialog box will then use the feature’s measured data (point and vector) to find an appropriate nominal point as discussed in the "Using the FindNoms Override Dialog Box in Learn mode:" topic.


Marking Commands for Execution

In order to execute PC-DMIS commands you must first mark them for execution. The following menu options and commands control marking:

More:

Mark

Mark All

Clear All

Parent Mode

Child Mode

New Alignment Mode


Mark

Display Menu Roadmap

The Edit | Markings | Mark menu option allows you to mark a specified feature or command for execution. PC-DMIS automatically marks commands that are always executed, such as the alignment, tip commands, etc.

There are several ways to mark features or commands. PC-DMIS will indicate a marked item using the current Marked Text Color (see "Defining Edit Window Colors" in the "Setting your Preferences" section) within the Edit window. It will also display an asterisk (*) next to the feature ID in the Graphics Display window. Ways to mark part program items are to:

  • Mark the desired feature or command in the Edit window. Position the cursor over the feature to be marked and select Mark. The marked command will be highlighted.

  • Mark multiple commands in the Edit window. Select the commands to be marked in the Edit window and select Mark. The marked commands will be highlighted.

  • Mark the desired feature in the Graphics Display window. Make sure PC-DMIS is in Translate mode. Click on the desired feature with the left mouse button while simultaneously holding down the SHIFT key

  • Mark Multiple features in the Graphics Display window. Make sure PC-DMIS is in Translate or Textbox mode. Hold down the SHIFT key while box selecting the desired features using the click and drag method.

If you have the Edit | Markings | Parent Mode menu option Display Menu Roadmap selected, and you mark a constructed feature or a dimension, PC-DMIS will also mark any related features used in the construction or dimension process.

If you have the Edit | Markings | Child Mode menu option Display Menu Roadmap selected, and you mark a feature used to construct a feature or used to create a dimension, PC-DMIS will mark any related child features.

Note: Features and commands can be unmarked by repeating one of the above procedures.

Once an item is marked, specific lines within some items can be unmarked. For example, features and dimensions can have some lines unmarked. When you unmark a line, PC-DMIS will not execute it.

If dimensions are marked, PC-DMIS will send the results to the printer with the proper output configuration in place, after the program is executed. (See "Output To" in the "Dimensioning Features" section .)


To unmark specific lines within a feature:

  1. Move the cursor to the desired line within the marked feature (such as the HIT /BASIC line).

  2. Re-select the Edit | Markings | Mark option Display Menu Roadmap to unmark the indicated line.


Mark All

Display Menu Roadmap

The Edit | Markings | Mark All menu option marks all of the features or commands in the Edit window. PC-DMIS will mark the selected items in the Edit window, displaying them in green colored text. PC-DMIS also displays an asterisk (*) next to each feature ID in the Graphics Display window that are marked for execution.

When you select Mark All, PC-DMIS will ask if you also want to mark manual alignment features.

  • If you select the Yes button, then PC-DMIS will mark the entire part program for execution, including the alignment features.

  • If you select the No button, PC-DMIS will mark the entire program for execution, but will not mark the alignment feature. Additionally, since move commands don't function in manual mode, they will remain unmarked as well.


Clear All

Display Menu Roadmap

The Edit | Markings | Clear All menu option clears (or un-marks) all the items in the Edit window that were earlier marked for execution.


Parent Mode

Display Menu Roadmap

Selecting Edit | Markings | Parent Mode marks the parent command (if this menu option has a check mark and the related command is marked in the Edit window). A ‘parent’ is a command (or information from a command) used in another command. For example, if you mark a dimension and select this option, the feature used in the dimension will also be marked. This was the default mode in PC-DMIS prior to version 3.25.

Note: If you unmark a marked child command, the parent command stays marked.


Child Mode

Display Menu Roadmap

Selecting Edit | Markings | Child Mode marks any children commands as long as the related parent command is also marked. A ‘child’ is a command that is dependent upon another command in order to function. For example, if you mark a feature that has a dimension, and you have this option selected, PC-DMIS will also mark the dimension for that feature.

Note: If you don't select either the Parent Mode or Child Mode options, PC-DMIS will mark only the selected items.

Note: If you unmark a marked parent command, the child command stays marked


New Alignment Mode

Display Menu Roadmap

The Edit | Markings | New Alignment Mode (indicated with a checkmark next to the menu option) marks corresponding alignment data every time a feature/dimension is marked for execution.


Creating and Executing Marked Sets

PC-DMIS allows you to organize marked features into groups called "sets". You can then execute your stored sets of features by using the Marked Sets window.

  • There can be up to thirty (30) marked sets defined for a part program.

  • There are no restrictions as to the number of features that can be associated with each marked set.

  • When executed, only features grouped within the active marked set will be executed.

  • Every marked set that is created within a part program will be displayed as an icon in the Marked Set window. Each icon graphically indicates all of the features that have been associated with the marked set that it represents.

The following topics describe how to create, modify, execute, reposition, lock, and delete marked sets.

More:

A Sample Marked Sets window


A Sample Marked Sets window

Display Menu Roadmap

Marked Sets window with two created marked sets (Set1 and Set2).

Note: When the Marked Sets window is hidden, all marked sets are disabled and the standard mode for executing a part program is followed.

Available Buttons

Open – This button accesses the standard Open dialog box, allowing you to open part programs and perform other minor file operations. See "Opening Existing Part Programs" in the "Using Basic File Options" section.

Print Full Report – This button sends the current report to the currently selected output. See "Printing from the Edit window" in the "Using Basic File Options" section

Calibrate tips – This button accesses the Probe Utilities dialog box, allowing you to calibrate your tips. PC-DMIS disables this button for the Gom (Krypton), Romer, and Garda interfaces. See "Defining Probes" in the "Defining Hardware" section.

More:

To Create New Marked Sets

To Add Features to Existing Marked Sets

To Remove Features to Existing Marked Sets

To Customize the Marked Set Icons

To Reposition Marked Sets

To Execute Marked Sets

To Lock Marked Sets

To Delete Marked Sets


To Create New Marked Sets

Display Menu Roadmap

  1. Select the Edit | Markings | New Marked Set option or double-click anywhere in the Marked Sets window, the New Mark Set dialog box appears requesting a name for the new marked set.

New Mark Set dialog box

  2. Type a name to identify the marked set. While there's no limit to the length of the name, short descriptive keywords improve readability.

  3. Click OK. Your new marked set is stored in the Marked Sets window. At this point PC-DMIS also displays a Report Print Options dialog box. This dialog box allows you to define printing options specific to this marked set. (See "Setting Output and Printer Options" in "Using Basic File Options" for information on the various options in this dialog box.)

A Sample Report Print Options dialog box for Set1

  2. Define specific printing options for this set. Or, if you want to use the existing print options defined for your entire part program, simply select the Use Global Print Settings check mark.

  3. Click OK. The dialog box closes.

  4. You will now need to access the newly Marked Set and add features to it. Follow the procedure in the "To Add Features to Existing Marked Sets" topic to accomplish this.


To Add Features to Existing Marked Sets

Display Menu Roadmap

  1. Select the Edit | Markings | Show Marked Sets option. The Marked Sets window appears.

  2. Ensure the marked set you want to modify is active (press TAB to cycle through the sets, or simply click on the set once to select it).

  3. Access the Edit window and mark the features you want to add to the marked set by selecting them and then choosing Edit | Markings | Mark (or press F3). The default icon drawing for the set changes dynamically to reflect your changes.

  4. Close the Marked Sets window when finished.


To Remove Features to Existing Marked Sets

Display Menu Roadmap

  1. Select the Edit | Markings | Show Marked Sets option. The Marked Sets window appears.

  2. Ensure the marked set you want to modify is active (press TAB to cycle through the sets, or simply click on the set once to select it).

  3. Access the Edit window and un-mark those features you want to remove from the marked set. The default icon drawing for the set changes dynamically to reflect your changes.

  4. Close the Marked Sets window when finished.


To Customize the Marked Set Icons

Marked sets can have user defined bitmap images, if desired, in place of the default graphics. To apply a user bitmap,

  1. Create a color bitmap using 'Paint' or some other bitmap editor program of your choice. The bitmap should be no larger than 48 x 48 pixels in size.

  2. Save the bitmap file in the same directory as the part program. The bitmap filenames must use the following naming convention in order to be recognized by PC-DMIS:

MARKST00.BMP for the first marked set

MARKST01.BMP for the second marked set

MARKST02.BMP for the third marked set

…

MARKST30.BMP for the thirty-first marked set

Example: If the bitmap file MARKST00.BMP is placed in the part program directory when the first marked set is created, the bitmap image contained in MARKST00.BMP will be displayed. If a marked set does not have a bitmap file the default graphics will be used. Also, it is not necessary to use consecutive bitmaps. In other words, you can use a bitmap for marked set 1 and marked set 5, but use the default graphics for marked sets 2, 3 and 4.


To Reposition Marked Sets

Marked sets can be repositioned. To reposition a marked set,

Display Menu Roadmap

  1. Select the Edit | Markings | Show Marked Sets option. The Marked Sets window appears.

  2. While holding down the SHIFT key, select the desired marked set with the left mouse button.

  3. Drag the marked set to the new location.

  4. Release the SHIFT key and left mouse button and PC-DMIS will update the Marked Set window with the change.

  5. Close the Marked Sets window when finished.


To Execute Marked Sets

Display Menu Roadmap

  1. Select the Edit | Markings | Show Marked Sets option. The Marked Sets window appears.

  2. Double-click on the set you want to execute. PC-DMIS executes the marked set.

  3. Close the Marked Sets window when finished.


To Lock Marked Sets

Once a marked set has been defined for a part program, a lock can be established to prevent anyone from accidentally deleting or otherwise modifying the current configuration. For more information on this option see the "Lock Marked Sets" topic in the "Setting your Preferences" section.


To Delete Marked Sets

You can easily delete any previously created marked sets. To do this:

Display Menu Roadmap

  1. Select the Edit | Markings | Show Marked Sets option. The Marked Sets window appears.

  2. Ensure the marked set you want to delete is active (press TAB to cycle through the sets, or simply click on the set once to select it).

  3. Press the DELETE key. A confirmation box will appear confirming the deletion of the marked set.

  4. Click the Yes button. The marked set is deleted and the icon is removed from the Marked Sets window.

  5. Close the Marked Sets window when finished.


Using Breakpoints

Edit window with BreakPoint (red icon)

The Edit | Breakpoints menu option is a useful debugging tool to be used when creating, testing, and running a part program. Generally, part programs are executed sequentially, line by line. By placing a breakpoint at a particular line in the part program, program execution will pause when it reaches that point. If the part program makes use of variable expressions and flow control, you can examine these variables to ensure that the program is functioning as desired.

Once PC-DMIS has paused for the breakpoint, you may want to use the Step Next button. This button continues with the measurement process but does so one step at a time, pausing the CMM after executing each step of any command creating movement of the CMM. While in Step Mode, hits can be inserted into features and new features can be inserted between existing features or commands. Step Mode can also be simulated off-line.

When you are ready to continue with normal program execution, simply press Continue on the Execution dialog. Several menu and keyboard commands are available for manipulating the placement and removal of breakpoints. Breakpoints are saved with the part program and are therefore available the next time the part program is opened.

Note: If your program uses breakpoints and the Edit window is in Command mode, PC-DMIS continues to display the Edit window during execution but highlights the current command to execute in red. If the Edit window is in Summary mode, with a breakpoint, PC-DMIS shows a green highlight in the Edit window for already executed commands, yellow for a feature about to be measured, blue for features currently undergoing execution, and orange for non-executed commands.

More:

Toggle Breakpoint

Insert Defaults

Remove Defaults

Remove All


Toggle Breakpoint

Display Menu Roadmap

The Edit | Breakpoints | Toggle Breakpoint menu option allows you to set or remove a breakpoint. The breakpoint will be set at or removed from the line in the Edit window where the cursor is currently positioned. A small circular red icon will appear in the left margin of the Edit window to indicate that a breakpoint has been set.


Insert Defaults

Display Menu Roadmap

The Edit | Breakpoints | Insert Defaults menu option allows you to set breakpoints throughout the part program at default locations. Default locations are defined as lines in the Edit window that contain commands which generate motion of the CMM or cause branching to occur as a result of a flow control command (such as IF THEN statements). See the "Branching by Using Flow Control" section for more information.


Remove Defaults

Display Menu Roadmap

The Edit | Breakpoints | Remove Defaults menu option allows you to remove breakpoints throughout the part program from default locations. Only those breakpoints that are set on default locations (See "Insert Defaults") will be removed. Any breakpoints that are set in non-default locations will remain in place.


Remove All

Display Menu Roadmap

The Edit | Breakpoints | Remove All menu option allows you to remove all breakpoints from a part program.


Setting Start Points

Edit window with start point (red arrow)

Start points can only be set when the Edit window is in Command Mode (see "Working in Command Mode" in the "Using the Edit Window" section).

When you insert a start point into the part program and then select the File | Partial Execution | Execute From Start Points menu option, PC-DMIS will begin the part program execution from the first start point instead of starting the program flow at the beginning of the part program.

Important: Be aware that if the current tip for that location in the program does not match the current orientation of the probe head, PC-DMIS will not try and go back to execute the tip command above it in order to change the tip orientation.

Start points are especially useful if you are working in Multiple Arm mode and you need to set a different start point for each arm (see the "Using Multiple Arm Mode" section).

To insert a start point into your part program, click the location in the Edit window where you want the start point to appear, and then select the Set Start Point icon from the Edit window toolbar or right-click in the Command mode and select Set Start Point from the shortcut menu.

For more information, see "Setting Start Points for Multiple Arms" in the "Using Multiple Arm Mode" section and "Edit Window Toolbar" in the "Using Toolbars" section.


Using Bookmarks

Edit window with bookmark (blue icon)

Bookmarks can be set when the Edit window is in Command Mode (see "Working in Command Mode" in the "Using the Edit Window" section) or, if enabled, in DMIS Mode. Bookmarks mark frequently accessed lines in a part program. Once a bookmark is set, you can use menu or keyboard commands to move to it. You can remove a bookmark when you no longer need it. Bookmarks are saved between editing sessions and are therefore available the next time the part program is opened.

Important: Be aware that bookmarks are assigned to line numbers, not commands. Thus, setting bookmarks in one mode and then switching to another mode may cause the bookmarks to show up on different commands even though they're on the same line numbers.

More:

Toggle Bookmark

Next Bookmark

Clear All Bookmarks


Toggle Bookmark

Display Menu Roadmap

The Edit | Bookmarks | Toggle Bookmarks menu option allows you to set or remove a bookmark. The bookmark will be set at or removed from the line in the Edit window where the cursor is positioned. A small blue icon will appear in the left margin to indicate that a bookmark has been set.


Next Bookmark

Display Menu Roadmap

The Edit | Bookmarks | Next Bookmark menu option allows you to move to the next bookmark in the Edit window. If no bookmark is found below the current cursor position, searching will resume at the top of the Edit window.


Clear All Bookmarks

Display Menu Roadmap

The Edit | Bookmarks | Clear All Bookmarks menu option allows you to remove all bookmarks from the Edit window.


Changing Fonts and Colors

You can easily edit the fonts and colors used in the Edit window by following instructions described in the "Setting up the Edit Window" topic of the "Setting your Preferences" section.


Editing External Objects

PC-DMIS allows you to edit embedded external objects in Command mode only. To do this, select the object in Command mode, and double-click on the selected object.

For information on creating and inserting external objects, see "Inserting External Objects" in the "Adding External Elements" section.


Using the Edit Window

Using the Edit Window: Introduction

U nderstanding Core Concepts

W orking in Summary Mode

Working in Command Mode

Working in DMIS Mode

Working with User-Defined Groups


Using the Edit Window: Introduction

Edit window

To access the Edit window select the View | Edit Window menu option.

Display Menu Roadmap

One of the principal tools for editing a part program is the powerful Edit window. The Edit window houses all the commands for the part program. It allows the part programmer to perform editing operations such as cutting, copying, pasting, and modifying existing Text and commands. The programmer can also use the Edit window to add new commands, execute existing commands, and debug code.

In this section you will learn about the Edit window and editing part programs in general by viewing the following topics:

  • Understanding Core Concepts

  • Working in Summary Mode

  • Working in Command Mode

  • Working in DMIS Mode

  • Working with User Defined Groups

Major Edit Window Changes with Version 3.5

  • The Edit window menus have been removed and placed in the new menu structure of the updated menu bar.

  • The Edit Window toolbar, providing quick access to many of the frequently accessed Edit window functions, has been removed from the Edit window and is now accessible from PC-DMIS's toolbar area. You can find information for this toolbar in the "Edit Window Toolbar" topic of the "Using Toolbars" section.

  • The Edit window is now dockable to the sides, top, or bottom of your screen. This means you can dock the Edit window onto the Graphics Display window.

  • The Edit window is also floatable over the Graphics Display window. You can float it over the Graphics Display window like it did in previous versions of PC-DMIS (versions 2.x through 3.25). To float the Edit window, right-click on the Edit window, and deselect the Docking View option. This opens up a new Edit window that behaves just as the old Edit window did. You can use the commands in the Window menu in this mode.

Major Edit Window Changes with Version 4.0

  • The Report Mode was removed from the Edit window, replaced by the newer Report window. See "About the Report Window" in the "Reporting Measurement Results" section.

Major Edit Window Changes with Version 4.2

  • The Edit window's Command and DMIS modes contain a new color and text formatting scheme to help you more easily recognize command blocks and editable fields. It also provides a new way to change values on editable fields. See "Understanding the Default Edit Window Colors and Formatting" for information.

These enhancements provide a set of tools for manipulating Edit window content in a way that is easy and intuitive to use.


Understanding Core Concepts

The Edit window allows you to easily access the current part program. Changes can easily be made to the part program using only the Edit window, the dialog boxes, or a combination of the Edit window with the applicable dialog boxes. The sections below provide core concepts that will aid you in learning to use the Edit window.

More:

Navigating the Edit window

Understanding the Default Edit Window Colors and Formatting

Inserting Commands

Editin g Values

Selecting Commands

Repositioning Commands

Deleting Commands

Accessing Dialog Boxes

Modifying Headers and Footers


Navigating the Edit window

The edit window houses all the commands making up your part program.

You can change the display of the Edit window by switching between different modes. The two most common modes are already enabled by default. These are Command mode and Summary mode. A third mode, called DMIS mode, is also available if enabled in the Setup Options dialog box.

  • Summary mode, simply put, provides a visual summary of your part program.

  • Command mode lets you view detailed code making up each command.

  • DMIS mode is similar to command mode, but the code language is written using the DMIS programming language, and you don't have all the editing functionality you have in Command mode. You can switch between these different modes by clicking the appropriate icon on the Edit window toolbar.

In each of these modes you can work with existing commands and add new commands, although the capabilities of each mode and the methods of working with commands differ somewhat. Commands can have both editable and non-editable fields. Editable fields are fields that take a value. Some editable fields are called toggle fields and allow you to switch between a predefined set of acceptable values.

  • If you're in Command mode or DMIS mode, pressing TAB moves the cursor to the next editable field. You know you're on an editable field when the value is highlighted in the highlight color (default is yellow).

  • If you're in Summary mode, expanding the command and then right-clicking on editable items will display an Edit command which when selected allows you to type a new value or select an existing value from a list.

Using the Edit Window Toolbar

The Edit Window toolbar lets you perform operations on your part program and switch between the different Edit window modes. For information on this toolbar, see the "Edit Window Toolbar" topic in "Using Toolbars".

Moving to a Feature using the Graphics Display Window

To move the cursor to a specific feature's location in the Edit window, click on that feature in the Graphics Display window while holding down the CTRL key.


Consider this example screen shot:

Edit window example showing version 4.2 coloring scheme

  1. A light-green background means the command has been marked for execution.

  2. The light-blue background means the command has not yet been marked for execution.

  3. A slightly darker background color (either darker green for marked commands or darker blue for unmarked commands) shows the current active command.

Understanding the Default Edit Window Colors and Formatting

Edit window in Command Mode

PC-DMIS uses different background colors, command text colors, and text characters to offset information in Command and DMIS modes. This coloring and text formatting may seem somewhat confusing at first, especially if you are used to previous versions of PC-DMIS and are suddenly barraged with a myriad of colors. However, rest easy; if you don't like them, you can easily revert PC-DMIS to its coloring scheme used in previous versions (see the "Defining Edit Window Colors" in the "Setting Your Preferences" section).

However, the colors and formatting are valuable tools that can increase your productivity. The following topics describe these tools.

Background Colors

Different background colors help you know what commands are marked, unmarked, have errors, are active, or are being stepped through. These background colors are defined in the Color Editor dialog box for the Edit window.

Edit window Background Color Information in the Edit Window's Color Editor

Command Text Colors

Black text - Any non-editable command text. You cannot change this text.

Blue text - Any editable command text.

Red text - For non-dimension commands this indicates an error in the command text. The command will be skipped during program execution. Errors come from unsupported commands, unsupported probe types, and syntax errors (usually while working with expression or scripting commands). For dimension commands, red text indicates that the dimension is out of tolerance.

Warning: If your part program contains unsupported commands (commands in red text), check it thoroughly before executing online. Since unsupported commands are skipped during program execution, in some cases this could cause a probe collision if you aren't careful.

Highlighted Text Shows the Active Command or Group

When you move your mouse over a command block, or command blocks that are grouped together, the entire command block, or the entire group, is highlighted with a slightly darker background color (see item C in example above). This helps you immediately see the extents of an entire command block. Doing this also makes the command "active". This means you don't need to click on the command to operate on it. For example, simply hover your mouse over a command and press F9. The associated dialog box, if one exists, will appear. To delete the command, you don't need to select the entire command, just hover your mouse over it until it becomes active, and press DELETE. You will find when editing large programs that shaving off a mouse click here and there increases your productivity.

"<" and ">" Characters Provide Enhanced Readability

If you have ever floundered in a sea of monochromatic text, fishing for a specific value, then you will be pleased with the addition of the "<" and ">" characters. These characters group like values together, thereby more easily delineating the different fields for various X, Y, Z and I, J, K values. These characters show where these pairs begin and end. This enhances readability and makes it much easier to locate needed values.

Popup Menu Provides Easier Toggle Field Selection

No longer do you have to cycle through a list of available commands on a toggle field...unless you really want to. Simply hover your mouse over the darker blue text for a moment, and the background color takes on a button-like quality. Click on the button. A drop-down list appears letting you select the desired value for that toggle field.

Easier Filename Fields

Certain fields take filename values. If the file moves to a new location there's an easier way to update it than arduously retyping a long directory pathway. Instead, hover your mouse over the field, the filename turns into a button. Clicking it will display a File Open dialog box allowing you to locate and update the file's location.


Inserting Commands

In many cases commands are automatically inserted when you take measurements or when you use dialog boxes to input information. However you can also add commands directly from within the Edit window. Depending on what mode you're in, PC-DMIS will give you different results:

  • If you're in Command mode, you can insert new commands by simply typing the first few letters of the command if you know them.

  • If you're in Summary mode, you can insert new commands by right-clicking and selecting Add Command from the shortcut menu. PC-DMIS displays you with a list of commands you can add.

  • If you're in DMIS mode, you can insert new commands by simply pressing RETURN on a line. A list will appear from which you can select the appropriate DMIS command to add.


Editing Values

Display Menu Roadmap
Display Menu Roadmap

Sometimes you may want to quickly change a command's settings directly in the Edit window.

  • If you're in Command or DMIS mode, press TAB to go to the editable field you want to change. Either type in a new value or press F7 or F8 to cycle forward or backward through a list of available values. You can also hold you mouse over a toggle field and click the drop down arrow to select from a pop-up list of available values.

  • If you're in Summary mode, expand the command. Then right-click on the line you want to edit, PC-DMIS will either display a list from which you can choose a preexisting value or an edit box into which you can type a new value.


Selecting Commands

You can select most commands in any of PC-DMIS's modes. You'll need to select a command before repositioning or copying it.

  • In Summary mode, click on a collapsed command to select the entire command block. All the data items associated with the command will also be selected.

  • In Command or DMIS modes, click at the beginning of the command, hold down the mouse, and drag it until the entire command is highlighted.

The Select All menu option allows you to select the entire report for editing purposes.


Repositioning Commands

Many commands in PC-DMIS can be repositioned. If you ever want to change a command's location you can easily do so.

If you're in Summary, Command or DMIS mode, you can reposition a command, by selecting the entire command block, then selecting the Edit | Cut menu option to remove the command from its current location and then selecting the Edit | Paste menu option to place it in it's new location. You can also use the Edit | Copy menu option to make a copy of a command, storing it in the Clipboard until you decide to paste the copy into another location.

Display Menu Roadmap

For information on these and other standard editing commands, see "Using Standard Editing Commands" in the "Editing a Part Program" section.


Deleting Commands

Display Menu Roadmap

You can easily delete commands from the Edit window by selecting them and pressing DELETE. You can restore any deleted command if you immediately click the Undo icon from the Edit Window toolbar.


Accessing Dialog Boxes

Display Menu Roadmap

When editing features or commands, you might want to access dialog boxes associated with a particular feature or command. You can easily do this in one of the editing modes by placing the cursor on the feature or command block and pressing F9. The dialog box associated with the feature will appear. You can then make any changes in the dialog box itself and after clicking OK, or Apply, the Edit window automatically gets updated with your changes.

On some commands, pressing F9 accesses the dialog box only if PC-DMIS is in Command mode.


Modifying Headers and Footers

Modifying the Edit Window's Headers and Footers

There are three files that are used to format the header / footer text in the Edit window. These files are LOGO.DAT, HEADER.DAT, and ELOGO.DAT. These files are located in your installation directory (for example, C:\Pcdmisw).

You can edit the Edit window's header or footer by making and saving changes to these text files using a standard text editor (such as Notepad).

Important: Due to improvements in how PC-DMIS reports measurement results in PC-DMIS 4.0 and greater, reports no longer use the Edit window. Instead, reports now appear inside their own Report window. Therefore, modifying the .DAT files as explained here will only affect the headers and footers within the Edit window, not the Report window output.

To modify the Report window's header, you will need to modify the label template used for the header. The standard label template used to control header information is file_header.lbl. See the Reporting Measurement Results section for information on modifying templates to control what gets displayed in the report window. Specifically see Modifying your Report's Header.

More:

The Header

The Footer

Header and Footer Formatting Keywords

Using Expressions and Tracefields to Customize Headers and Footers


The Header

There are two files you can modify to define the header in your Edit window. LOGO.DAT and HEADER.DAT.

LOGO.DAT – This file defines the header for the very first page of the Edit window. You can define a bitmap with your company's logo as well as specific date and time formats for the first page.

Edit window's Header Formatting Example

The corresponding LOGO.DAT file is displayed below:

Logo.dat Example in Notepad

Note: That PART NAME, REV NUMBER, SER NUMBER, and STATS COUNT are static fields and cannot be changed in the LOGO.DAT file.

HEADER.DAT – This file is used to format page headers for all other pages.

For information on modifying your Report's headers or footers, see "Modifying your Report's Header".


The Footer

ELOGO.DAT is used to format a footer for the last page only of your Edit window.

Edit window's Footer Formatting Example

The corresponding ELOGO.DAT file is displayed below:

Elogo.dat Example in Notepad

For information on modifying your Report's headers or footers, see "Modifying your Report's Header".


Header and Footer Formatting Keywords

The following is a list of the available formatting keywords and their functions. You can insert these keywords into the .DAT files to have them displayed in a header or footer in the Edit window.

Note: The keywords are case sensitive.

#DATE | Inserts the current date.
#TIME | Inserts the current time.
#PAGE | Inserts the current page number. This is ideal for use in the HEADER.DAT file.
#TRn | Inserts both the name and the value of trace field n, where n is the trace field number.
#PARTN | Inserts the part program name.
#DRWN | Inserts the revision number.
#SERIALN | Inserts the serial number.
#SEQUENCE | Inserts the sequence number.
#SHRINK | Inserts the scale factor.
#NMEAS | Inserts the total number of dimensions.
#NOUT | Inserts the total number of dimensions that are out of tolerance.
#ELAPSTIM | Inserts the time elapsed between start and end of execution. This is ideal for use in the FOOTER.DAT file.
#BMP=bitmappath | Inserts a bitmap with the specified name in the bitmappath variable . You must specify the full path the bit map file (i.e., D:\Files\Bmp\Pcdhead.bmp).

For information on modifying your Report's headers or footers, see "Modifying your Report's Header".


Using Expressions and Tracefields to Customize Headers and

Using Expressions and Tracefields to Customize Headers and Footers

You'll notice that the keywords themselves aren't customizable. For example the #DATE keyword in the logo.dat file only gives you one way to display the date—in mm-dd-yyyy format. For example May 5, 2005 is written as 5-5-2005 in your Edit window's header or footer.

The following example shows how you can use expressions and tracefields to change the format of your date on the Edit window.

  1. Type the following commands somewhere into your part program :

ASSIGN/V1 = SYSTEMDATE("MMM dd, yyyy")

This gives V1 the string value of "May 05, 2005" (or whatever your current date is).

TRACEFIELD/DISPLAY,LIMIT=15 ; DATE : V1

This assigns V1 to the TRACEFIELD.

  2. Assuming this is the first tracefield in your program, open up your logo.dat file inside a text editor and modify the DATE= field so that it looks like this:

DATE=#TR1

Notice that DATE field now references the first trace field by using #TR1.

  3. Save and close your logo.dat file.

  4. Access the Edit window. Assuming your Edit window is enabled to show headers and footers, the header now uses the formatted system date that was stored in the V1 variable and subsequently in the first trace field.

You can use trace fields and expressions to give you greater control over what you see in the Edit window.

For information on trace fields, see the "Using Trace Fields" topic in the "Tracking Statistical Data" section.

For information on expressions, see the "Using Expressions and Variables" section.

For information on modifying your Report's headers or footers, see "Modifying your Report's Header".


Working in Summary Mode

Display Menu Roadmap

To enter Summary mode, select View | Summary Mode.

The summary mode allows you to view the overall layout of the part program, as well as part program commands in different levels of detail. Through the intuitive interface you can also easily re-order and edit commands.

More:

Layout

Editing a Part Program from Summary Mode

Summary Mode Keyboard Functions


Layout

PC-DMIS's summary mode layout is in the form of expandable and collapsible pieces of data. At the top level, PC-DMIS displays command objects. You can expand these objects to view their groups and data items by clicking the plus sign (+) to the left of the command. Collapse them by clicking the minus sign (-). You can also expand and collapse commands or groups by pressing the RIGHT ARROW and LEFT ARROW keys respectively.

More:

Commands

Groups

Data Items


Commands

Summary Mode Showing Commands (unexpanded items)

PC-DMIS displays most part program commands at the top level. Some commands, such as basic hits, location dimensions, and certain alignment commands appear under their parent object. Also:

  • Each command has a unique icon associated with it to help you quickly identify needed commands.

  • If the command has an ID, PC-DMIS displays the ID displayed before the command description.

  • Commands marked to execute are displayed in green text.

  • Commands not set to execute are displayed in blue text.


Groups

Summary Mode displaying Groups (folder icons)

Groups are displayed with a folder icon and are composed of a command's similar data items. For example, the measured circle object has a theoreticals group, an actuals group, and a settings group.

  • The theoreticals group contains the theoretical values for the measured circle including the theoretical x, y, z, i, j, k and diameter.

  • The measured group contains the corresponding measured values of the circle.

  • The settings group contains information about the measured circle such as the ID, coordinate type, whether the circle is an inner/outer, the number of hits, etc.


Data Items

Summary Mode displaying Data Items (blue sphere icons)

Data items are the parameters or settings of the command object. Some data items can be edited and some are for information purposes only and cannot be changed. Data items are displayed with a blue sphere icon.


Editing a Part Program from Summary Mode

PC-DMIS gives you the ability to edit the part program while in Summary Mode. Using the Summary Mode interface you can select, add, remove, copy, cut, paste, mark, unmark, commands, as well as edit a command's data items.

More:

Selecting Commands

Adding Commands

Removing Commands

Copying, Cutting, and Pasting Commands

Marking / Unmarking Commands for Execution

Editing Data Items of a Command


Selecting Commands

Select commands by either left-clicking with the mouse or by navigating to them using the UP and DOWN ARROW keys.

  • To select multiple commands, hold down the CTRL key while left-clicking.

  • To select a group of items at once, select the first item in the block of objects, hold down the SHIFT key and selecting the last item in the block.

PC-DMIS highlights all selected items.


Adding Commands

When in summary mode, you can add commands to the part program by using PC-DMIS's standard menu options or by using a special shortcut menu.

  1. To access the shortcut menu, right-click on a command item. See "Summary Mode Command Shortcut Menu" in the "Using Shortcut Keys and Shortcut Menus" section for more information on the items available.

  2. From the shortcut menu, select Add Command. A scrollable blue list appears.

  3. Select the command to add. Once clicked, the pop-up list disappears and PC-DMIS inserts the command into the Edit window. If you want to close the list without adding a command press ESC on your keyboard until it closes.

Note: PC-DMIS generally inserts the new command after the currently selected item in the expandable/collapsible list.


Removing Commands

You can easily remove commands from the part program by selecting an object and pressing the DELETE key. If the command contains any sub-commands, those commands are also deleted.


Copying, Cutting, and Pasting Commands

To copy or cut a command:

  1. Select the desired command in the expandable/collapsible view

  2. Choose the copy or cut commands from any of these locations:

  • The Edit window's Edit menu

  • The Keyboard (CTRL + C for copy, CTRL + X for cut)

  • The short-cut menu's Cut or Copy option that appears from right-clicking on the command

Note: If the command contains any sub-commands, those commands are also cut or copied.

To paste a command that has been cut or copied:

  1. Select the command in the expandable/collapsible view that precedes the command to be pasted.

  2. Choose the paste command from any of these locations:

  • The Edit window's Edit menu.

  • The keyboard (CTRL + V)

  • The short-cut menu's Paste option that appears from right-clicking on the command.


Dragging and Dropping Commands

While you can cut and paste commands to rearrange them in Summary Mode, you can also rearrange commands by simply dragging and dropping one or more contiguous commands to a new location.

  1. Select one or more contiguous commands in the Edit window's Summary Mode.

  2. Use the left mouse button and drag the selected command(s) to a new location in the Edit window.

  3. Release the mouse button.

PC-DMIS moves the command(s) immediately below the command that was under the mouse pointer when you released the mouse button.


Marking / Unmarking Commands for Execution

To mark or unmark a command for execution:

  1. Select the command in the edit window.

  2. Press F3 (or right-click on the desired command and choose Mark from the short-cut menu).


Editing Data Items of a Command

To edit the data item of a command do one of the following:

  • Select the data item and press the ENTER key. Edit the information and press ENTER.

  • Double-click on the data item with the left mouse button. Edit the information and press ENTER.

  • Right-click on the data item and choose Edit | Value / Expression Text. Edit the information and press ENTER.

If the data item is a toggle field, a list of possible values appears from which you can choose the desired item. Press ENTER after selecting the desired choice or double-click on the desired choice.

If the data item can be edited and it is not a toggle field, a small edit field will pop-up with the current value which can then be edited via the keyboard. To cancel the editing of an item, press ESC.

To edit a command via the dialog box specific to that command:

  1. Select the command in the expandable/collapsible view.

  2. Press F9 (or right-click on the command and choose Edit from the pop-up menu).

The appropriate dialog box for the command appears. However, be aware that in some cases you can only edit a command if PC-DMIS is in Command mode.


Summary Mode Keyboard Functions

The following table lists the various keyboard functions available when PC-DMIS is in summary mode.

Key(s) | Function
SHIFT + TAB | Moves cursor backward to next item in the summary view
CTRL | Click on desired feature using left mouse button. PC-DMIS will move the cursor to the corresponding command item in the summary view.
CTRL + A | Selects all of the commands of the part program.
CTRL + C | Copies text or objects to the Clipboard.
CTRL + END | Moves the cursor to the end of the part program.
CTRL + HOME | Moves the cursor to the beginning of the part program.
CTRL + Q | Displays the Execute dialog box and allows you to execute the part program.
CTRL + V | Pastes text if in an edit control. If object has been cut or copied, pastes object after currently selected object.
CTRL + X | Cuts selected object or text if in an edit control.
CTRL + Y | Displays the Execute dialog box and allows you to execute the part program at a specified location.
DELETE | Deletes any highlighted characters when editing a value in an edit control. If nothing is highlighted, then both keystrokes function as in a normal editor.
Double-click | Double-clicking on a command item or group item will expand that item. Double-clicking on a data item that can be edited will bring up the edit control for the data item.
DOWN ARROW | Moves the cursor down one line.
F2 | Brings up the expression builder if the currently selected data item can have expressions.
F3 | Marks a single feature for execution.
F9 | Calls up dialog box for the currently selected command.
PAGE DOWN | Moves the cursor down one page.
PAGE UP | Moves the cursor up one page.
SHIFT | Used in conjunction with the left mouse button after selecting an initial object in order to facilitate selecting a block of objects.
TAB | Moves cursor forward to the next item in the summary view.
UP ARROW | Moves the cursor up one line.
LEFT ARROW | Collapses an expanded command or group.
RIGHT ARROW | Expands a collapsed command or group.


Working in Command Mode

Display Menu Roadmap

To enter Command mode, select View | Command Mode.

Selecting the Command Mode icon places the Edit window into command mode. This mode allows you to insert or edit a wide variety of PC-DMIS commands. The main features or commands that you can add to the Edit window include:

  • Constructed Features

  • Dimensions

  • Statistical Data

  • Alignment

  • Measured Features

  • Hits

  • Motion Commands

  • Move Commands

  • Sheet Metal Measurements

  • Probe

  • Comments

  • Trace Fields

  • Expressions

  • Screen Captures

  • Global Commands

  • Command Mode Keyboard Functions

PC-DMIS also provides some keyboard functions that you can use while the Edit window is in Command Mode. These are discussed in "Command Mode Keyboard Functions". Similarly, you can access several shortcut menu items by right-clicking on the commands within Command Mode. See "Command Mode Shortcut Menu" in the "Using Shortcut Keys and Shortcut Menus" section.

You can also determine which commands get displayed in Command mode. See "Command Mode Display Options" in the "Setting Your Preferences" section for additional information.


Constructed Features

PC-DMIS allows you to create specified features from existing features. Additional information including specific rules for constructing features can be found in the "Constructing New Features from Existing Features" section.

PC-DMIS supports the construction of the following features:

· POINT

· CIRCLE

· ELLIPSE

· SPHERE

· LINE

· CONE

· CYLINDER

· PLANE

· SLOT

· CURVE

· SURFACE

· FEATURE SET

· GAUSSIAN FILTER SET


Dimensions

Dimension commands allow you to dimension features or the relationship between features. Additional information regarding the calculation of dimensions can be found in the "Dimensioning Features" section.

More:

Dimension Format

Available Dimensions

Analysis


Dimension Format

Display Menu Roadmap

PC-DMIS's print capability is one of its most powerful features. A dimension can be calculated many different ways until the results are acceptable. Only if the dimension is marked for printing will the data appear on the inspection report.

The FORMAT command allows you to create more than one dimensional format within a part program. For some dimensions, you might not want the nominals printed.

Note: Certain types of zone tolerances always have a nominal of zero, so it is unnecessary to print the NOM. However, later in the part program you might want to use the nominals for a different type of dimension, such as location or true position.

The default FORMAT command will print out all of the columns and column headings. It will also create the statistics XSTATS11.TMP file.

Command line in the Edit window:
FORMAT/HEADINGS,SYMBOL;NOM,TOL,MEAS,MAXMIN,
DEV,OUTTOL

HEADINGS = This major command controls whether the dimensions that follow the FORMAT command will have column headings above the numbers.

SYMBOL = This minor command controls whether the deviation symbols will be printed. This field can be toggled on or off. A blank field indicates that this command is off.

When the cursor is in one of these fields you can use the F7 and F8 hot keys to toggle them on or off.

NOM,TOL,MEAS,MAXMIN,DEV,OUTTOL = These minor commands control which columns get printed for dimensions following the FORMAT command. You can toggle any combination of these columns on or off. To turn a flag off, place a blank in the field. They can also be displayed in any order. Simply type the desired command in the order needed. (The order will be numerically displayed in the Parameters Dimension dialog box.)

For more information consult the "Dimensioning Features" section.


Available Dimensions

To edit these dimensions, please view their individual sections in the "Dimensioning Features" section.


Analysis

To edit the Analysis information, see the "Inserting Report Commands" section.


Statistical Data

To include and edit statistical data, see the "Tracking Statistical Data" section.


Alignment

The Alignment option allows you to recall or create a new coordinate system.

More:

Alignment Commands

CAD Equals Part

Equate Alignment


Alignment Commands

For more information on how to use these alignment commands in the Edit window, see the individual topics in the "Creating and Using Alignments" section.


CAD Equals Part

For more information on how to use the CAD Equals Part command in the Edit window, see "Equating CAD to Measured Part Data" in the "Creating and Using Alignments" section.


Equate Alignment

For more information on how to use Equate Alignment command in the Edit window, see "Equating an Alignment" in the "Creating and Using Alignments" section.


Measured Features

You can insert commands that create the following measured features:

  • Measured Point

  • Measured Line

  • Measured Plane

  • Measured Sphere

  • Measured Cylinder

  • Measured Cone

  • Measured Circle

These features, along with information about measured features in general, are discussed in the "Creating Measured Features" section.


Hits

This command targets the location for actual touches by the probe.

More:

Basic Hit

Sheet Metal Hits

Adding Hit Lines

Deleting Blank Lines


Basic Hit

HIT/BASIC,x,y,z,i,j,k,x,y,z,USE_THEO=YES/NO

This is the simplest hit format. See "Understanding the Command Format" in the "Creating Measured Features" section for more information.


Sheet Metal Hits

HIT /type,x,y,z,i,j,k,x,y,z

type = VECTOR, SURFACE, EDGE, CORNER, ANGLE

There are five available types of sheet metal hits. The Sheet Metal package must be installed for this option to be available. (See "Sheet Metal Measurements".)


Adding Hit Lines

To add a hit line, place the cursor in the desired location and press the ENTER key. Begin by typing the command HIT. Press the TAB key. PC-DMIS adds the new line depending on where the cursor is located. If the cursor is in the middle of a command, a new line is created below the current line. If the cursor is placed anywhere within the first four lines PC-DMIS will create the new line immediately after the measured line.


Deleting Blank Lines

To delete a blank line press the DOWN ARROW or ENTER key. The line may also be highlighted and deleted. (See "Command Mode Keyboard Functions".)


Motion Commands

The various Motion commands control the movement of the machine. See the various motion commands discussed in the "Parameter Settings: Motion tab" and the "Parameter Settings: Optional Motion tab" topics of the "Setting Your Preferences" section.

More:

Mode - MAN / DCC

Prehit Distance

Move Speed

Touch Speed

Scan Speed

Retract Distance

Check Distance


Mode = MAN / DCC

Display Menu Roadmap

MODE/MAN (or DCC )

This command allows you to select between manual and DCC mode.


Prehit Distance

PREHIT/nnn.nnnn

This command determines the distance from the theoretical hit location that the machine will travel at touch speed.


Move Speed

MOVESPEED/nnn.nnnn

This command changes the point to point positioning speed of the CMM. The value that is entered (1 to 100) is a percentage of the maximum machine speed.


Touch Speed

TOUCHSPEED/nnn.nnnn

This command changes the speed at which the CMM takes hits. The value that is entered is a percentage of the maximum machine speed, and cannot exceed twenty percent.


Scan Speed

SCANSPEED/nnn.nnnn

This command changes the speed at which the CMM will scan the part. The value that is entered is a percentage of the maximum machine speed.


Retract Distance

RETRACT/nnn.nnnn

This command determines the distance the machine will move away from the actual hit location before going from "Touch Speed" to "Move Speed".


Check Distance

CHECK/nnn.nnnn,p.pp

This command determines the distance in inches or millimeters (depending on the system of measurement that was initially set up for the particular part program ) past the theoretical hit location that the machine will continue to search for the surface of the part until it determines the surface is not there.

nnn.nnnn:
The check distance

p.pp:
The percentage of the total check distance that PC-DMIS will move when performing a Find Hole operation. The default value is 1 which means 100% of the check distance. Thus .1=10%, .2=20%, .3=30% etc. This only functions with Find Hole operations.

  • If PC-DMIS finds a surface within the specified check distance, it takes a hit.

  • If no surface is found PC-DMIS displays an error message that it has encountered an unexpected end of move.

  • Example: If .3 inches is entered as the check distance, PC-DMIS will move .3 inches past the theoretical surface, searching for a surface on which to make the hit.

    See "Check Distance" in the "Setting your Preferences" section for additional information.


Move Commands

The commands listed below provide you with the ability to alter the movement of the probe between hits.

MOVE/POINT

MOVE/INCREMENT

MOVE/CLEARPLANE

MOVE/CIRCULAR

MOVE/SYNC

MOVE/SWEEP

MOVE/ROTAB

MOVE/EXCLUSIVE_ZONE

These are described in the "Inserting Move Commands" section.


Sheet Metal Measurements

Sheet metal measurements, also known as "Auto Features", are available only as an added option to the basic PC-DMIS geometric software package. (See the "Creating Auto Features" section.) This option provides you with several alternate choices for taking hits. The various sheet metal features are listed below. When applicable, Number of Hits, Number of Rows, Spacer , and Indent values can be updated. The required minimum number will be indicated as the default.

The following sheet metal measurements are available:

  • Auto Vector Point

  • Auto Line

  • Auto Plane

  • Auto Circle

  • Auto Ellipse

  • Auto Notch Slot

  • Auto Round Slot

  • Auto Angle Point

  • Auto Corner Point

  • Auto Edge Point

  • Auto High Point

  • Auto Surface Point

  • Auto Square Slot

  • Auto Cylinder

  • Auto Cone

  • Auto Sphere


Probe

The following commands allow you to access options that affect the probe. These commands allow you to change the active tip in a probe cluster or change the position of the rotating probe head. Probe compensation can also be turned on or off as needed.

More:

Load Probe

Probe Comp

Read Point

Tip


Load Probe

LOADPROBE/probe_file_name

The Load Probe command is a user editable field that allows you to load a file of qualified probe tips to be used within the part program.


Probe Comp

PROBECOM/ON (or OFF)

The Probe Comp command allows you to turn probe compensation on or off. It is considered ON if the command is displayed in the Edit window.


Read Point

F_ID= FEAT/ POINT, TOG1
THEO/ x, y, z, i, j, k
ACTL/ x, y, z, i, j, k
READPOINT

The Read Point command creates a point feature at the current location of the probe. PC-DMIS will then store the values of the point that is read.

See "Creating a ReadPoint from the Probe's Position" in the "Creating Generic Features" section for additional information.


Tip

TIP/T1A0B0, SHANKIJK=0, 0, 1, ANGLE=0

· The SHANKIJK is just another vector form of specifying the A and B angles for the tip.

· The ANGLE specifies the angle that the tip transformation matrix is rotated about the shank vector.


Comments

This option allows you to display comments during the execution of the part program, or to send the comments to the inspection report. These comments are created using the Insert | Report Command | Comment menu option. The Show Comments option also allows you to add, edit, or delete operator notes and inspection report comments within the Edit window. The COMMENT command switches between the options OPER, REPORT, YESNO, $$, INPUT, and READOUT.

When you open a part program that was saved from a later version, any commands that are not supported in the current version will show up as DOC comments.

See the "Inserting Programmer Comments" topic in the "Inserting Report Commands" section.

More:

Operator

Report

Input

$$

Yes / No

Readout


Operator

This option will display a user supplied message when executing the part program. Access this option by selecting Utilities | Comment from the menu bar and switching to OPER or enter the command COMMENT/OPER in the desired location of the Edit window. Type in the desired text. (Any length of text will be accepted.) Click the OK button (or press the ENTER key) when the comments are completed. When PC-DMIS executes the part program, a message displays the previously entered comments. Click on the OK button to close the message box.

Pressing the F9 key while the cursor is in a COMMENT/OPER command line will display the Comments dialog box allowing you to alter the displayed message.

Command line in the Edit window:
COMMENT/OPER, comment text


Report

This option allows you to send text to the inspection report. Access this option by selecting Utilities | Comment from the menu bar and switching to REPT or enter the command COMMENT/REPT in the desired location of the Edit window. Type in the desired text. (Any length of text will be accepted.) Click the OK button (or press the ENTER key) when the comments are completed. When PC-DMIS executes the part program, these messages will not be viewed. PC-DMIS will, however, send these comments to the inspection report when it is printed.

Pressing the F9 key while the cursor is in a COMMENT/REPT command line will display the Comments dialog box allowing you to alter the displayed message.

Command line in the Edit window:
COMMENT/REPT, comment text


Input

This option is similar to "OPER" in that it allows you to display text when executing a part program. In addition to displaying a message with the previously entered text, a comment box will appear. This allows you to enter numerical information that will be written to the inspection report. Access this option by selecting Utilities | Comment from the menu bar and switching to INPUT, or enter the command COMMENT/INPUT in the desired location of the Edit window. Type in the desired text. The input from the operator will be assigned to the Comment ID and is accessible via an expression reference (i.e. C1.INPUT).

Pressing the F9 key while the cursor is in a COMMENT/INPUT command line will display the Comments dialog box, allowing you to alter the displayed message.

Command line in the Edit window:
comment ID = COMMENT/INPUT, comment text


$$ (Document)

This option provides you with the ability to document (add programmer comments) to the internal program. It will not display any text when executing the part program. This command does not have the usual COMMENT prefix to the command. This is done for visibility purposes to better offset

Command line in the Edit window:
$$ NO, Please Edit Comment Text!

To type a document comment directly into the Edit window:

  1. Type COMMENT and press TAB. PC-DMIS highlights the OPER field.

  2. Type $$ and press TAB or ENTER.

When you open a part program that was saved from a later version into the current version, any commands that are not supported in the current version will show up as DOC comments. See "Save As" in the "Using Basic File Options" section.


Yes / No

This option allows you to display text when executing a part program. The message box will display any previously entered text and YES / NO buttons. The response to the YES / NO question will appear in the part program. The text 'YES' or 'NO' will be associated with the comment identification and is available in any expression via a reference to the Comment ID (i.e. C1.INPUT).

Command line in the Edit window
comment ID = COMMENT/YESNO, comment text


Readout

This option allows you to display text inside the Probe Readout window.

The Edit window command line for this option reads:
COMMENT/READOUT,comment text

For more information on setting up this option, see "Readout" in the "Inserting Report Commands" section.


Trace Fields

The Trace Field option lets you set up trace fields in the Edit Window. This information is useful in the STATS data base (see the XSTATS11.TMP file). The name of the field and the current value can be changed in the Edit window. This is done by selecting the field to be changed, and typing a new value.

To display the Trace Fields dialog box, select the Insert | Statistics Command | Trace Field menu option.

Display Menu Roadmap

Command line in the Edit window:
TRACEFIELD/field name : value

field name = string that represents the name of the trace field. There is a 15 character limit on the length of the field name.

value = the current value of the trace field. There is a 15 character limit on the length of the value.


Expressions

Display Menu Roadmap

You can insert expressions into most of PC-DMIS's editable fields. See the "Using Expressions and Variables" section.


Screen Captures

Display Menu Roadmap

You can insert a DISPLAY/METAFILE command to insert screen captures of the Graphics Display window into your report. See the "Inserting Screen Captures" topic in the "Inserting Report Commands" section.


Global Commands

The table below defines the list of global commands available in the Edit window. While you cannot alter these commands, the Edit window does allow you to select the minor commands following these major commands.

To select the minor commands:

  1. Place the cursor over a minor command in the Edit window.

  2. Clicking the left mouse button.

  3. Press F7 or F8. This toggles through the available choices.

This list serves as a comprehensive summary of the commands that can be added to a part program. See each specific section for more information as necessary.

Note: The maximum number of characters that PC-DMIS can manage within any line of the Edit window is 280.

MAJOR COMMAND | MINOR COMMAND
2DANGLE (see "Dimensioning Angle") | A
2DDISTANCE (see "Dimensioning Distance") | M
3DANGLE (see "Dimensioning Angle" | A
3DDISTANCE (see "Dimensioning Distance") | M
ALIGNMENT (see the "Creating and Using Alignments" section) | BF2D, BF3D, ITERATE, LEVEL, ROTATE, TRANS, ROTATE_OFFSET, TRANS_OFFSET, RECALL, RECALL_EXTERNAL
ANGULARITY (see "Dimensioning Angularity") | M
ANALYSISVIEW (see "Analysis") |
ARRAY INDICES (see "Arrays") |
ASSIGN (see "Using Variables with Expressions") |
ATTACH (see "IDs for features within subroutines, basic scripts, or external programs") |
AUTO (see "Sheet Metal Measurements") | VECTOR POINT, SURFACE POINT, EDGE POINT, CORNER POINT, ANGLE POINT, HIGH POINT, SPHERE, CIRCLE, CYLINDER, SQUARE SLOT, ROUND SLOT, CONE, ELLIPSE, NOTCH, CONE
AUTOTRIGGER (see "Parameter Settings: Probe Trigger Options tab") |
CAD EQUALS PART (see "CAD Equals Part") |
CALCULATION |
CALLSUB (see "Calling a Subroutine") |
CASE (see "Case / End Case") |
CHECK (see "Check Distance") |
CLEARP (see "Parameter Settings: ClearPlane tab") | "WORK PLANE VALUE"
CLAMP (see "Clamping Value") |
COLUMN132 (see "Dimensions") |
COMMENT (see "Comments") | OPER, REPORT
CONCENTRICITY (see "Dimensioning Concentricity") | M
CONST (see "Constructed Features") | CIRCLE, CONE, CURVE, CYLINDER, ELLIPSE, LINE, PLANE, POINT, SET, SURFACE, SPHERE
CIRCULARITY (see "Dimensioning Circularity") |
CYLINDRICITY (see "Dimensioning Cylindricity") |
DEFAULT_CASE (See "Default Case / End Default Case") |
DISPLAY (see "Screen Captures") | METAFILE
DO (see "Do / Until") |
ELSE (see "Else / End Else") |
END_ELSEIF (See "Else If / End Else If") |
ELSE_IF (see "Else If / End Else If") |
END_CASE (see "Case / End Case") |
END_DEFAULTCASE (see "Default Case / End Default Case" ) |
END_ELSE (see "Else / End Else") |
END_IF (see "If / End If"). |
END_SELECT (see "Select / End Select") |
END WHILE (see "While / End While") |
ENDSUB (see "Ending a Subroutine" ) |
EQUATE (see "Equate Alignment") |
EXTERNALCOMMAND (see "Inserting an External Command"). |
FILE (see the "Using File Input / Output" section) | OPEN, MOVE, EXISTS, DIALOG, DELETE, COPY, CLOSE, WRITE_CHARACTER, WRITE_BLOCK, WRITELINE, SAVE_POSITION, REWIND, RECALL_POSITION, READ_UPTO, READ_CHARACTER, READ_BLOCK, READLINE
FLATNESS (see "Dimensioning Flatness") | M
FLY (see "Fly Mode") |
FORMFEED (see "Inserting a Form Feed Command"). |
FORMAT (see "Dimension Format") | HEADINGS,STATS
GAPONLY (see "Dimensioning Location") | ON
GENERIC (see "Creating a Generic Feature") | POINT, PLANE, NONE, LINE, CYLINDER, CONE, CIRCLE, SQUARE_SLOT, SPHERE, ROUNDSLOT
GO TO (see "Jumping to a Label") |
HIT (see "Hits") | BASIC, ANGLE, VECTOR, SURFACE, EDGE, CORNER
IF (see "If / End If") |
KEYIN (see "Dimensioning through Keyboard Input") | M
LABEL (see "Creating Labels") |
LEITZPROBE |
LOADPROBE (see "Load Probe") | "FILE NAME"
LOCATION (see "Dimensioning Location") | A, D, M, PA, PR, R, T, X, Y, Z
LOOP (see "Creating Generic Loops" ) | START, END
MEAS (see "Measured Features") | CIRCLE, CONE, CURVE, CYLINDER, LINE, PLANE, POINT, SET, SLOT, SPHERE
MODE (see "Probe Mode toolbar") | DCC, MANUAL
MOVE (see "Move Commands") | POINT, ROTAB, CIRCULAR, CLEARPLANE, INCREMENT, PH9 (X,Y,Z)
MOVESPEED (see "Move Speed") | % of overall machine speed
ONERROR (see "Branching on a CMM Error") | Unexpected_hit, probe_miss
OPTIONMOTION (see "Parameter Settings: Optional Motion tab") |
PARALLELISM (see "Dimensioning Parallelism") | M
PD |
PERPENDICULARITY (see "Dimensioning Perpendicularity") | M
PREHIT (see "Prehit Distance") | "distance"
PROBECOMP (see "Probe Comp") | "ON, OFF"
PROFILE (see "Dimensioning Surface or Line Profile" ) |
PROGRAM | END "ends program at command location"
READPOINT (see "Read Point") | "xyz value of probe location"
RECALL (see "Recalling an Existing Alignment") | VIEWSET, ALIGNMENT (INTERNAL/EXTERNAL)
RETRACT (see "Retract Distance") | "distance"
RETROLINEARONLY (see "Location Options") | ON, OFF
RMEAS (see "Relative Measurement Area") |
RS |
RT |
RUNOUT (see "Dimensioning Runout") | M
S |
SAVE (see "Saving an Alignment") | ALIGNMENT
SCANSPEED (see "Scan Speed") | % of overall machine speed
SCRIPT (see "Inserting BASIC Scripts") |
SELECT (see "Select / End Select") |
STATS (see the "Tracking Statistical Data" section) | ON, OFF
STRAIGHTNESS (see "Dimensioning Straightness") | M
SUBROUTINE (see "Branching with Subroutines") |
TIP (see "Tip") | "file name"
TEMPCOMP (see "Compensating for Temperature") |
TOUCHSPEED (see "Touch Speed %") | "% of overall machine speed"
TRACEFIELD (see "Trace Fields") | (field name : value)
TRUEPOSITION (see "Dimensioning True Position") | A, D, M, PA, PR, R, T, V, X, Y, Z
UNTIL (see "Do / Until") |
WHILE (see "While / End While") |
WORKPLANE (see "Working Plane List") | TOP, BACK, BOTTOM, FRONT, LEFT, RIGHT


Command Mode Keyboard Functions

The following table lists the various keyboard functions available within the Edit window's Command Mode.

Key(s) | Function
ALT + F3 | Displays the Search dialog box.
SHIFT + TAB, CTRL + LEFT ARROW | Moves cursor backward to the last user-editable field.
CTRL | Click on desired feature in the Graphics Display window using left mouse button. PC-DMIS will move the cursor to the corresponding feature line in the Edit window. CTRL + double-clicking on a feature selects the entire feature.
CTRL + A | Selects all text in the window for highlighting.
CTRL + C | Copies text or objects to the Clipboard. If text from a single field is highlighted, this text is copied to the Clipboard. If more than one field is highlighted, then the entire object is copied to the Clipboard.
CTRL + E | Executes selected features (or the feature with the cursor).
CTRL + END | Moves the cursor to the end of the part program.
CTRL + TAB | Minimizes or restores the Edit window.
CTRL + HOME | Moves the cursor to the beginning of the part program.
CTRL + PAGE DOWN | Moves the cursor to the end of the file.
CTRL + PAGE UP | Moves the cursor to the beginning of the file.
CTRL + Q | Displays the Execute dialog box and allows you to execute the part program.
CTRL + T | Assigns the current command to the selected active arm.
CTRL + V | Pastes the Clipboard's contents at the insertion point. If text-only was copied, attempts to paste the text. If an entire object was copied to the Clipboard, attempts to paste the entire object. In the latter case, if the insertion point is in the first column of the edit window on the first line of a command, the Clipboard object is placed before this object. In all other cases, insertion is after the object.
CTRL + X | Cuts any highlighted characters.
CTRL + Y | Displays the Execute dialog box and resumes a paused execution.
DELETE or BACKSPACE | Deletes any highlighted characters. If nothing is highlighted, then both keystrokes function as in a normal editor.
double-click | double-clicking using the left mouse button when the cursor is on any editable field will highlight that field.
DOWN ARROW | Moves the cursor down one line.
F1 | Displays the Help topic for the command.
F2 | Inserts an expression.
F3 | Marks a single feature for execution. Multiple features can be marked simultaneously by highlighting them before selecting this command.
F4 | Prints the entire contents of the Edit window.
F5 | Displays the Setup Options dialog box.
F6 | Displays the Change all the fonts dialog box.
F7 | If the cursor is placed in a toggle field, this command switches the entry in the field forward to the next alphabetical entry in the list of allowed entries. It will cycle to the beginning of the list when the end is reached.
F8 | If the cursor is placed in a toggle field, this command switches the entry in the field backward to the last alphabetical allowed entry. It will cycle to the end of the list when the beginning is reached.
F9 | Calls up dialog box for the command on which the cursor is residing when the key is pressed.
F10 | Displays the Parameter Settings dialog box.
F12 | Displays the Fixture Setup dialog box.
LEFT ARROW | Moves the cursor left one character.
PAGE DOWN | Moves the cursor down one page.
PAGE UP | Moves the cursor up one page.
RIGHT ARROW | Moves the cursor right one character.
SHIFT | If the shift key is held down when arrow buttons are depressed, text is highlighted as the cursor moves. SHIFT + double-click on a start block or end block selects the entire block.
SHIFT + F10 | Displays the Jump To dialog box.
TAB + CTRL + RIGHT ARROW | Moves cursor forward to the next user-editable field.
UP ARROW | Moves the cursor up one line.
- (minus key) or ALT + - | Removes the last hit from the hit buffer.
END | Inserts the measured feature into the part program.


Working in DMIS Mode

Display Menu Roadmap

To enter DMIS mode, select View | DMIS Mode.

Selecting the DMIS Mode icon displays the Edit window commands in DMIS format. This means you can use the DMIS syntax to edit your part programs.

Most of the commands and features you can add to your part program using Command mode, you can add using DMIS mode. For information on how to insert or edit commands in DMIS mode, see "Understanding Core Concepts".

  • For information on how DIMS commands (PC-DMIS's standard command format) translate into DMIS commands, see the document titled, PC-DMIS Support Documentation for DMIS available from ftp://wilcoxassoc.com/docs/dmis_support.zip.

  • For information on DMIS, see http://www.dmis.com.


Working with User-Defined Groups

PC-DMIS lets you group contiguous Edit window commands together, placing them inside of a user-defined GROUP / ENDGROUP command pair (in DMIS mode groups are shown as DMISEW commands). Grouped commands help simplify user-interaction with the part program by allowing operations on commands inside the group to be applied at once on the entire group. In addition, the program appears less busy to the eye, allowing you to better visualize the overall structure of the part program.

For example, suppose you have several hundred points in your part program from a scan that you want to hide to make the overall structure of the part program more visible and easier to work with. You can select all the point commands, as long as they are all in one list, and then select the Insert | Group menu item to group those commands together. In any mode of the Edit window you can then show or hide the commands inside of the group as needed.

Sample Group of Several Points Expanded | Sample Group of Several Points Collapsed

Groups appear in this format inside the Edit window's Command mode:

GRP1 = GROUP/SHOWALLPARAMS = YES

... commands inside the group are listed

... between the two commands

ENDGROUP/

SHOWALLPARAMS = This YES / NO toggle field let you show or hide commands inside of the group in Command or DMIS modes. By default this command is set to YES and shows all commands held within the group. If you set it to NO, commands inside the group still exist but are hidden.

More:

Inserting Groups

Editing Groups

Removing Groups

Performing Operations on Groups

Using Multiple Arm Mode with Groups


Inserting Groups

When you insert your first group command into the part program, PC-DMIS gives it a default name of "GRP1" inside Command and DMIS modes or "GROUP - GRP1" inside Summary mode. PC-DMIS then increments the number in the ID for each additional Group. You can easily modify the name of the group to something more descriptive by simply typing a new ID in Command or DMIS modes, or by pressing F9 and editing the GROUP command that way.

There are several different ways to insert groups into the PC-DMIS part program:

  • The Insert | Group menu item.
    This inserts the GROUP and ENDGROUP commands. If you selected a group of commands before selecting this menu item, they would be placed inside of the group. In Command and DMIS modes, this means the GROUP command would precede the very first selected command and the ENDGROUP command would follow the last selected command. If you don't have any commands selected, PC-DMIS will display a dialog box asking if you want to insert the command pair without any features inside it. This menu item works in any mode of the Edit window.

  • The Right-click shortcut menu.
    Right-click inside Command or DMIS mode, and select Group from the shortcut menu. If you selected a group of commands before selecting this menu item, they would be placed inside of the group. In Command and DMIS modes, this means the GROUP command would precede the very first selected command and the ENDGROUP command would follow the last selected command.

  • Summary Mode.
    Right-click inside Summary mode, and select Add Command. From the list of commands, select Group. This will insert an empty GROUP / ENDGROUP command pair. Groups appear as folders inside Summary mode. Commands appear indented inside those folders. You can expand or collapse these groups by clicking on the plus (+) and (-) keys respectively. The ENDGROUP is hidden in Summary mode.

  • Type the Command.
    In Command or DMIS modes, simply type GROUP and press ENTER or TAB. PC-DMIS will insert an empty GROUP / ENDGROUP command pair.

PC-DMIS will make the Group menu item unavailable for selection if you try to group something that is not allowed, such as attempting to only group a portion of a command's block.


Editing Groups

You can edit your groups by using the Edit window directly or by pressing F9 and accessing the Group dialog box.

Group ID - This lets modify the group's ID to something different.

Hide Group - This sets SHOWALLPARAMS equal to NO.

Show Group - This sets SHOWALLPARAMS equal to YES.


Removing Groups

Removing Only Group Commands

To remove the GROUP / ENDGROUP commands, but retain the group's contents, do one of the following:

  • In the Edit window's Command mode, ensure that all the items in the group are visible, select either the GROUP or ENDGROUP command (but not the entire group), and press DELETE from your keyboard.

  • In the Edit window's Summary mode, expand the group, right-click on the GROUP command, and either select Delete from the shortcut menu or press DELETE from your keyboard.

Deleting both Group Commands and Contents

To delete the GROUP / ENDGROUP command and its contents, do one of the following:

  • In the Edit window's Command mode, hide all the features in the group, select either the GROUP or ENDGROUP command, and press DELETE from your keyboard.

  • In the Edit window's Summary mode, collapse the group, right-click on the GROUP command, and either select Delete from the shortcut menu or press DELETE from your keyboard.

If the items in the group are visible, you will need to select the entire GROUP / ENDGROUP command block before deleting.


Using Multiple Arm Mode with Groups

In Command or DMIS modes, groups that contain commands set for execution by a specific arm will have the same red and/or green Multiple Arm Mode margin markings as those commands.

  • If all the commands in a group are tied to one arm, then the GROUP command will also have the same margin color markings. If you then change the arm mode of the GROUP command, all commands inside will switch their margin color markings to the other arm.

  • If one or more commands are tied to both arms, then the GROUP command will also have the same margin color markings as both arms.

For information on Multiple Arm Mode, see the "Using Multiple Arm Mode" section.


Performing Operations on Groups

In general, all operations that can be performed on a single command in the edit window, when performed on a group, are performed on every item contained within the group.

The various operations you can perform on a group are described in detail below. Most are taken from the Command mode's shortcut menu. Right-click in the Command mode to see this shortcut menu. This shortcut menu is discussed in the "Command Mode Shortcut Menu" topic from "Using Shortcut Keys and Shortcut Menus". The information below only applies to how this menu works with GROUP commands or features inside of groups.

Shortcut Menu Operations on Groups

  • Select Command – When the group is collapsed and you choose Select Command, PC-DMIS selects every command contained in the group as a block. When the group is expanded, Select Command selects only the GROUP command itself.

  • Select Block – This menu item selects every command contained in the group as a block, regardless of the expanded/collapsed state of the group.

  • Execute From Cursor (CTRL + U) – This doesn't change from the usual operation.

  • Execute Block (CTRL + L) – If you select a block, PC-DMIS only executes the block. If you selected a group as the block, then PC-DMIS executes the group.

  • Jump To (CTRL + J) – This doesn't change from the usual operation.

  • Jump Back (ALT + J) – This doesn't change from the usual operation.

  • Edit (F9) – When the cursor is positioned on the GROUP command, a Group dialog box appears. You can modify the group's ID and display state. If you select Edit on the ENDGROUP command, nothing happens.

  • Mark (F3) – If you place the cursor on the GROUP command and select this menu item, all items contained within the group are Marked or Unmarked as a whole. If you have any unmarked commands within the group when you select this menu item, those commands become marked, and all other commands remain marked. If all commands within the group are already marked when you select Mark (F3), all commands become unmarked. The color of the GROUP command reflects the marked state of the commands contained within the group. If at least one command within the group is marked for execution, then the group displays as marked for execution. If no command is marked, then the group displays as unmarked.

  • Delete – This menu item only appears on the Summary Mode shortcut menu. If you select a GROUP command and then select Delete, PC-DMIS will delete the GROUP and ENDGROUP commands and everything in between. You cannot undo a GROUP deletion.

  • Group – If you select an existing GROUP command and then select the Group menu item, PC-DMIS creates a new GROUP command, nesting the selected group inside it.

  • Collapse Groups – This doesn't change from the usual operation.

  • Set as Start Point – This doesn't change from the usual operation.

  • Cut – Removes the GROUP command and ENDGROUP command. All items stored inside the group remain in the part program.

  • Copy and Paste – Copying and pasting doesn't work with a GROUP / ENDGROUP pair. You can only copy and paste commands found inside of the group.

Other Group Operations

  • File | Execute | Execute Feature (CTRL-E) – Selecting this menu item while selecting the GROUP command will execute all features inside the group.

  • Flow Control Statements – The ID can be used to control the flow of part program execution similar to how you can send program flow to a LABEL command. You can use GOTO or IF_GOTO flow control commands to send the program flow to a group based on defined conditions. For example:

IF_GOTO/VAR > 0, GOTO = GRP1

or

GOTO/GRP1


Using Other Windows, Editors, and Tools

Using Other Windows, Editors, and Tools: Overview

U sing the Report Window

Using the Basic Script Editor

USING THE FORM EDITOR

Viewing an Inspection Report

Using the Quick Start Interface

Using the Settings Window

Using the Preview Window

Using the Marked Sets Window

Using the Virtual Keyboard

Using the Probe Readout Window

Using the Status Window

Using the Probe Toolbox

Using the Dimensions Colors Window

Viewing Path Lines


Using Other Windows, Editors, and Tools: Overview

PC-DMIS provides you with an assortment of windows, editors, and other aids that help make your part programming easier and more productive. This section discusses how to access and use these tools.

These include:

  • The Edit window, which has already been discussed in the "Using the Edit window" section

  • A Report window for displaying measurement results (see "Using the Report Window")

  • A script editor that allows you to create scripts in the BASIC programming language (see "Using the Basic Script Editor")

  • An editor for creating and displaying interactive and forms and dialog boxes (see "Using the Form Editor")

  • An inspection report editor that allows you to quickly view and make small editing changes to your automatic generated inspection reports (see "Viewing an Inspection Report")

  • An interface for quick generation of simple part programs (see "Using the Quick Start Interface")

  • A settings window that lets you make quick edits to frequently used values (see "Using the Settings Window")

  • A preview window that allows you to preview your measurements before accepting them (see "Using the Preview Window")

  • A window used to create and store marked sets of features for future execution (see "Using the Marked Sets Window")

  • A customizable Virtual Keyboard that you can use in place of a real keyboard (see "Using the Virtual Keyboard")

  • A probe readout window that shows the current probe's location, and other information (see "Using the Probe Readout Window")

  • A status window that displays the current status of an operation or feature information (see "Using the Status Window")

  • A probe toolbox that allows you to perform probe manipulations (see "Using the Probe Toolbox")

  • A dockable color bar that shows the different tolerance zones and dimension colors (see "Using the Dimensions Colors Window")

  • A path viewer showing the path your probe will take during program execution (see "Viewing Path Lines")

  • A Cad Information dialog box to display information about a CAD element in the Graphics Display window (see "Viewing CAD Information" in the "Editing the CAD Display" section.


Using the Report Window

Display Menu Roadmap

Selecting the View | Report Window menu option displays the Report Window. This window, after part program execution, displays your measurement results and automatically configures the output according to a default report template. For detailed information, see the "About the Report Window" topic in the "Reporting Measurement Results" section.


Using the Basic Script Editor

Display Menu Roadmap

The Basic Script Editor can be used to create and edit BASIC scripts that can be used in Basic Script objects during execution or from the Basic Script Editor toolbar.

The View | Basic Script Editor menu option opens the Basic Script Editor and replaces PC-DMIS's main menu bar with these menus: File, Edit, Run, and Help. You can restore PC-DMIS's normal menu bar by minimizing or closing the Basic Script Editor.

The Basic Script Editor consists of the following:

  • Basic Script Editor Toolbar

  • File menu

  • Edit menu

  • Run menu

  • Help menu

These topics are discussed below.

More:

Basic Script Editor Toolbar

File Menu

Edit Menu

View Menu

Run Menu

Help Menu


Basic Script Editor Toolbar

The Basic Script Editor toolbar supports the following functions:

More:

New

Open

Save

Print

Print Preview

Find

Cut

Copy

Paste

Undo

Compile

Start


New

This button allows you to create a new basic script in the editor.


Open

This button brings up an Open File dialog box allowing you to open an existing basic script into the editor.


Save

This button saves the current basic script. If you have not already named the current script, a Save As dialog box asking for the name of the script will appear.


Print

This button prints the current basic script.


Print Preview

This button allows you to see the current basic script in the Print Preview window as it will appear when printed.


Find

This button allows you to search for text in the current basic script.


Cut

This button cuts currently selected text and put text on the clipboard.


Copy

This button copies currently selected text and put text on the clipboard.


Paste

This button pastes text from the clipboard into the editor at the current insertion point.


Undo

This button allows you to undo the last editing change.


Compile

The Compile icon compiles (makes the script understandable and ready to run on the computer system) the current BASIC script. You must compile a script before running it.


Start

This button compiles and runs the current basic script.

Note: Scripts ran from the editor using the PC-DMIS basic commands can insert objects into the current part program.


File Menu

The Basic Script Editor's File menu gives you the following commands and options:

More:

New

Open

Save

Save As

Print

Print Preview

Exit

Unicode


New

The File | New menu option opens a new Basic Script Editor in which you can write a new script.


Open

The File | Open menu option allows you to navigate to and open an existing script. In order for files to appear in the Basic Script Editor, files must be of file type *.bas.


Save

The File | Save menu option allows you to save a script. With a new script, the first time this option is selected, the Save As dialog box will appear allowing you to choose what to name your script and where you want to save it.


Save As

The File | Save As menu option allows you to save a new script, or an already existing script by a new file name. The Save As dialog box appears, allowing you to select the file name and the directory to which you will be saving the script.


Print

The File | Print menu option allows you to print the script in the Basic Script Editor from your system's printer.


Print Preview

The File | Print Preview menu option allows you to preview what will be sent to the printer when Print is selected from the Basic Script Editor's File menu.


Exit

The File | Exit menu option allows you to exit out of the Basic Script Editor without saving any changes you have made to any open scripts. Choosing File | Exit will return you the main user interface. The menu bar will return to normal PC-DMIS functions.


Unicode

The File | Unicode menu item specifies whether your basic script is a Unicode script or not. If it isn't a Unicode script, then the Basic Script Editor interprets the script as ASCII text.

The Basic Script Editor needs to know the format of your script in order to correctly display and interpret it. Unicode formatting allows the editor to handle more complex characters (such as those displayed in Chinese or Japanese).

Unless you're working in a language that uses multi-byte characters, you generally won't need to select this menu item.


Edit Menu

The Edit menu of the Basic Script Editor allows you to use basic Edit functions to manipulate the text displayed in the Basic Script Editor.

More:

Undo

Cut

Copy

Paste

Delete

Select All

Find

Find Next

Replace

Dialog Editor


Undo

The Edit | Undo menu option allows you to undo the most recent action taken in the Basic Script Editor.


Cut

The Edit | Cut menu option allows you to cut selected text from the Basic Script Editor. Cut text is stored in the Windows clipboard to later be pasted elsewhere.


Copy

The Edit | Copy menu option allows you to copy selected text. Copied text is stored in the Windows clipboard to later be pasted elsewhere.


Paste

The Edit | Paste command allows you to paste text that is stored in the Windows clipboard.


Delete

The Edit | Delete command allows you to delete highlighted text.


Select All

The Edit | Select All menu option automatically selects all the text within the Basic Script Editor. You can then Cut, Copy, or Delete the selected text.


Find

The Edit | Find menu option brings up the Find dialog box.

Find dialog box

This dialog box allows you to search for a specific word, or term within the Basic Script Editor.

  • If you choose the Match Whole Word Only check box the dialog will display only those words that match the entire word.

  • If you choose the Match Case check box, then the dialog will display only those terms that match the case (Uppercase or Lowercase) that you used in the Find what box.


Find Next

The Edit | Find Next will search in the Basic Script Editor for the next term that meets the qualifications specified in the Find dialog box (See Edit | Find above.)


Replace

The Edit | Replace menu option brings up the Replace dialog box.

Replace dialog box

The Replace dialog box is an extension of the Edit | Find command. It allows you to search for a specific term and then replace it with the term entered in the Replace with box.

The Match whole word only check box will only match whole words, not partial matches. For example, if you are looking for "point" and you do not have this check box selected, it may find the sequence of characters inside the words "points" or "pointer".

The Match case check box only finds instances that match the exact case typed into the Find what box. If you typed "point", it would not find "Point" or "POINT" because of their case differences.

The Find Next button searches through the Basic Script Editor and brings up the first instance that meets the qualifications entered in the dialog box.

The Replace button allows you to replace what has been found (using the Find Next button) with what is in the Replace with box.

The Replace All button allows you to replace all instances in the Basic Script Editor that meet the search qualifications with what is in the Replace with box.

The Cancel button closes the Replace dialog box.


Dialog Editor

The Edit | Dialog Editor option opens a window with a grid named Dialog One and also the MasQ Enable Dialog Designer toolbar. This toolbar and the Dialog One grid give you the necessary tools to design dialog boxes that can later be programmed for your scripts.

Clicking the "X" in the upper right-hand corner of the MasQ Enable Dialog Designer toolbar will close these tools.


View Menu

The View menu allows you to choose if the Basic Script Editor toolbar and Status Bar are being displayed. Select View | Toolbar to display or hide the toolbar. Select View | Status Bar to display or hide the status bar.

Using this menu you can also determine where to set tab stops. This option allows you to indent program statements a set number of characters, thus improving program readability. Select View | Set Tab Stops and type a number. PC-DMIS will then indent by the indicated number of characters whenever you press the TAB key. For example, if you want a tab stop at every five characters, type "5" in the Set Tab Stops dialog box.


Run Menu

The Run menu allows you to select the Compile or Start command. The compile command compiles the script—checking it for syntax errors—while the start command executes the script.


Help Menu

The Help menu allows you to access various options that aid you in using the Basic Script Editor.

More:

Basic Help

Syntax Help

Syntax Help File


Basic Help

The Help | Basic Help command brings up the on-line help file created for the add-on Basic Module.


Syntax Help

The Help | Syntax Help turns on or off the option to use the syntax help when using the Basic Script Editor. If this option is selected, a pop up scroll box appears within the Basic Script Editor whenever you type in a command or term used in the Basic programming language. You can use arrow keys to select the appropriate term. Once selected, press the TAB key and that term will appear in the Basic Script Editor. Pressing the SPACEBAR displays the syntax needed for the command.


Syntax Help File

The Help | Syntax Help File allows you to select the syntax file used in the Help | Syntax Help command. The Load Syntax Help File dialog box will appear. Navigate to the directory that contains PC-DMIS for Windows and select the "Pcdmis.syn" file.


Using the Form Editor

Display Menu Roadmap

Selecting the View | Form Editor menu option displays the Form Editor. This editor provides you with powerful tools to aid you in building interactive forms and dialog boxes that get activated during execution. For detailed information, see the "About Forms" topic in the "Reporting Measurement Results" section.


Viewing an Inspection Report

Display Menu Roadmap

The View | Inspection Report menu option allows you to select the desired text report to be displayed on the screen. The report will be in Rich Text Format (.rtf)

To open an inspection report:

  1. Choose the Inspection Report menu option. An Open File dialog box will appear.

    Open dialog box showing an available report (Test001.RTF)

  2. Navigate to where your reports are stored.

  3. Select the desired text file to be displayed on the screen.

If you don't have a word processor that supports .RTF files, the inspection report is opened in WordPad. The menus in a WordPad window allow you to:

  • Cut, copy, and paste sections of a report

  • Open an existing report

  • Save a new report

  • Print a report

  • Close the open report


Quick Start Interface

Example Quick Start Instruction on the left side of the Status Bar

Using the Quick Start Interface

Display Menu Roadmap

The Quick Start interface (View | Other Windows | Quick Start) is a dialog box with a connected toolbar down the side.

Quick Start interface

This interface helps you to quickly create a simple part program. It does this by providing dialog boxes or procedures that help you define or calibrate a probe, align your part, measure features, construct additional features, and dimension existing features.

To access any of these items, simply click on the desired toolbar icon. If the icon contains additional procedures, another toolbar will appear to the right of the selected icon. From the new toolbar you can select a specific procedure.

The Quick Start Toolbar Icons

The Quick Start toolbar contains these icons:

Calibrate / Edit - This icon doesn't display another toolbar. Instead it launches the Probe Utilities dialog box. You can then use this dialog box to define a probe and calibrate probe tips.

Align - This icon displays the Quick Start Align toolbar. From this toolbar you can select an alignment procedure.

Measure - This icon displays the Quick Start Measure toolbar. From this toolbar you can select a measurement procedure.

Construct - This icon displays the Quick Start Construct toolbar. From this toolbar you can select a construction procedure.

Dimension - This icon displays the Quick Start Dimension toolbar. From this toolbar you can select a desired dimension procedure.

Reset - This icon resets the Quick Start dialog box to guess mode.

Understanding the Quick Start Interface:

In versions 3.5 through 3.7, the Quick Start toolbar was separate from the Quick Start dialog box. Since version 4.0, however, to save screen real estate, the Quick Start toolbar is now tied to the Quick Start dialog box itself. This means whenever you select the Quick Start interface, both the toolbar and the dialog box automatically appear and are inseparable.

Quick Start dialog box and toolbar

In addition,

  • Hovering your mouse over a particular item on the dialog or toolbar tells what that item does in a yellow tool tip that will appear under your mouse.

  • You can dock or undock the Quick Start dialog box to or from the left side of the screen by clicking on the title bar and then dragging and dropping it.

  • Instructions for the various Quick Start procedures are no longer included in the Quick Start dialog box. Instead, they are displayed on the Status Bar at the bottom of your screen. If the instructions are too long for the Status Bar area, PC-DMIS scrolls the instructions from right to left. Moving your mouse over the Quick Start dialog box resets the scrolling of the current instructions to the beginning.

  • You can now select input features used in the different procedures by clicking on the feature from the Edit window or from the Graphics Display window.

  • PC-DMIS now includes a Status Window. This window lets you preview a dimension or, if in Guess Mode, preview a measured feature before clicking the Finish button and inserting the dimension or feature into the part program. See "Using the Status Window" in the "Using Other Windows, Editors, and Tools" section.

Important: When you enable the Quick Start interface certain commands are disabled. For example, you cannot delete, copy, or mark features; neither can you execute your part program. To perform these and other actions you need to first close the Quick Start interface.

More:

Using the Quick Start Dialog Box

Quick Start: Measure Toolbar

Quick Start: Construct Toolbar

Quick Start: Dimension Toolbar

Quick Start: Align Toolbar

Quick Start: Calibrate / Edit Toolbar


Using the Quick Start dialog box

The Quick Start interface contains a toolbar attached to the Quick Start dialog box. Many of the procedures on this toolbar use the Quick Start dialog box to perform their operations. The toolbar icons are discussed in the "Quick Start Interface" topic.

This topic focuses on describing the items you will encounter on the dialog box portion of the interface and how to use the dialog box to perform various operations.

Quick Start dialog box

Sample Quick Start Interface

Dialog Box Item

Description

Graphical Description

For all operations that use the Quick Start dialog box, PC-DMIS displays two icons. A current procedure on the left and the current step in that procedure, or the current guessed feature, on the right.

In the example screen shot to the left, the question mark icon shows that PC-DMIS is in a Guess Mode operation. The Point icon on its right shows that with a single hit, a point feature will get created. The icon on the right will change to a line if you take another hit.

Example Featur ID

ID

The unique ID for the feature. An ID appears in the box once you select an appropriate procedure.

See "ID" in the "Navigating the User Interface" section.

Feature Override list

Feature Override

This list lets you override the guessed feature measurement to the selected feature type. For example, if you take four hits and PC-DMIS guesses a plane, you can select Circle from this list to cause it to create a measured circle instead.

See "Overriding a Guessed Measured Feature" in the "Creating Measured Features" section.

Number of Hits Taken / Required

Number of Hits Taken

This display shows on the right of the slash, the minimum hits needed to measure the feature and on the left of the slash the hits currently taken. You can take more than the minimum number of hits in which case, the number to the left of the slash will be greater than the number on the right.

Store a Move

Store a Move

The Store a Move icon allows you to easily store move points into the part program. When you click this icon, PC-DMIS reads the current location of the probe and inserts a MOVE/POINT command into the Edit window.

See the "Inserting a Move Point Command" topic in the "Inserting Move Commands" section.

Guess

If you see this icon displayed in the dialog box you will know that PC-DMIS is in Guess Mode. PC-DMIS returns to this mode whenever you finish creating a Constructed feature or Alignment using the Quick Start dialog box.

Clicking the Guess Mode icon from the Quick Start: Measure toolbar will also place PC-DMIS into Guess Mode.

Depending on the number of points taken, this mode guesses the feature type you’re attempting to measure and will dynamically update the Quick Start dialog box to reflect this.

For example, if, while in Guess Mode, you select two points, the Quick Start dialog box updates to a line feature. If four points are taken, it updates to a circle feature, if eight, to a cylinder, and so on.

See the "Guessing a Measured Feature Type" in the "Creating Measured Features" section.

Example Results box

Results

The Results box shows the results of all steps in a measurement procedure taken thus far. For example, if a user wants to do a Plane - Line - Line alignment, the results box will show the following when he has selected or measured the second line:

Step 1:PLN1=Measured Plane
Step 2:LIN1=Measured Line
Step 3:LIN2=Measured Line

The Results box is tied to the buttons at the bottom of the dialog box. The buttons become enabled whenever you fulfill the requirements for a certain step in a procedure.

<Back and Next>

The <Back and Next> buttons cycle between lists of required features or inputs. These buttons become available when procedures used on the toolbars require the selection or creation of multiple features (such as the Dimension and Align toolbars) or user input (such as upper and lower tolerance values for dimensions).

Clicking the Done button on your jog box acts the same as clicking the Next> button when using the Quick Start dialog box.

Finish

The Finish button completes the procedure, inserts the appropriate command into the Edit window, and then, in most cases, PC-DMIS return to the initial step of the current procedure.

For alignments or constructed features, however, after you click Finish PC-DMIS returns you to the default Guess Mode.


Quick Start: Measure Toolbar

Quick Start Measure toolbar

This toolbar contains the icons relative to the following measuring functions:

Point | Line | Plane
Circle | Cylinder | Cone
Sphere | Round Slot | Square Slot
Guess Mode |  |

For more information on creating measured features see the "Creating Measured Features" section.

Scanning

The Scan icon lets you quickly perform a Fixed Time Manual Scan. PC-DMIS will prompt you with instructions in the Status bar. For more information on this type of scan, see "Performing a Fixed Distance Manual Scan" in the "Scanning your Part" section

More:

Creating Measured Features

Measuring a Point

Measuring a Line

Measuring a Plane

Measuring a Circle

Measuring a Cylinder

Measuring a Cone

Measuring a Sphere

Measuring a Round Slot

Measuring a Square Slot


Creating Measured Features

  1. From the Quick Start toolbar, select the Measure toolbar.

  2. Click the icon of the feature you will measure. The top left icon on the dialog box changes to display what you will measure in this procedure and instructions appear on the status bar.

  3. In offline mode, click the Program Mode icon from the PC-DMIS Modes toolbar. PC-DMIS draws a simulated depiction of the probe near the part in the Graphics Display window.

  4. In offline mode, right click, to set the depth for the probe or in online mode. In online mode, move the probe to the desired depth.

  5. Take the minimum number of hits on the part to measure the feature.

  6. Click Finish or press Done on your jog box when the measurement is complete. The Quick Start dialog box remains open and PC-DMIS automatically compensates for probe radius and places the measured feature on the part in the Graphics Display window.

  7. Follow steps four through six until you create all needed measured features.

  8. Click Close when finished. The Quick Start dialog box closes.


Measuring a Point

Display Menu Roadmap

Using the Point icon, you can measure the position of a point belonging to a plane aligned with a reference plane (shoulder) or a point in space.

To create a measured point you must take one hit on the part.

See the "Basic Measurement Format for a Point" topic for information on the associated Edit window command in the "Creating Measured Features" section.


Measuring a Line

Display Menu Roadmap

With the Line icon you can measure the orientation and linearity of a line belonging to a plane aligned with a reference plane, or a line in space.

To create a measured line you must take two hits on the part.

Measured Lines and Working Planes

When creating a measured line, PC-DMIS expects the hits for the line to be taken at a vector perpendicular to the current working plane.

For example, if your current working plane is ZPLUS (with a vector 0,0,1), and you have a block-like part, the hits for the measured line must be on a vertical wall of that part, such as the front or side.

If you then wanted to measure a line feature on the top surface of the part, you would need to switch the working plane to XPLUS, XMINUS, YPLUS, or YMINUS, depending on the direction of the line.

See the "Working Plane List" topic for information on how to change the working plane.

See the "Basic Measurement Format for a Line" topic for information on the associated Edit window command in the "Creating Measured Features" section.


Measuring a Plane

Display Menu Roadmap
 | Use the Plane icon to measure any flat or planar surface.
To create a measured plane you must take a minimum of three hits on any flat surface. If you only use the minimum of three hits, it's best to select the points in a large triangular pattern that cover the widest area of the surface.
Example Plane with 4 Points | Example Plane with 8 Points
See the "Basic Measurement Format for a Plane" topic for information on the associated Edit window command in the "Creating Measured Features" section.


Measuring a Circle

Display Menu Roadmap
 | The Circle icon is used to measure the diameter, roundness, and position of the center of a hole/stud parallel to a reference plane, i.e. the perpendicular section of a cylinder aligned with a reference axis.
To create a measured hole or stud you must take a minimum of three hits. The plane is automatically recognized and set by the system during measurement. The points to be picked must be uniformly distributed on the circumference.
Example Circle with 4 Points | Example Circle with 8 Points
See the "Basic Measurement Format for a Circle" topic for information on the associated Edit window command in the "Creating Measured Features" section.


Measuring a Cylinder

Display Menu Roadmap

Use the Cylinder icon to measure the diameter, cylindricity, and orientation of the axis of a cylinder oriented in space. The position of the baricenter of the points picked is also calculated.

To create a measured cylinder you must take a minimum of six hits on the cylinder. The points to be picked must be uniformly distributed over the surface. The first three points picked must lie on a plane perpendicular to the main axis.

Example Cylinder with eight points

See the "Basic Measurement Format for a Cylinder" topic for information on the associated Edit window command in the "Creating Measured Features" section.


Measuring a Cone

Display Menu Roadmap

Use the Cone icon to measure conicity, angle at the tip, and orientation in space of the axis of a cone. The position of the baricenter of the points picked is also calculated.

To create a measured cone, you must take a minimum of six hits. The points to be picked must be uniformly distributed on the surface. The first three points picked must lie on a plane perpendicular to the main axis.

Example Cone using eight points

See the "Basic Measurement Format for a Cone" topic for information on the associated Edit window command in the "Creating Measured Features" section.


Measuring a Sphere

Display Menu Roadmap
 | Use the Sphere icon to measure the diameter, sphericity, and position of the center of a sphere.
To create a measured sphere you must take a minimum of four hits. The points to be picked must be uniformly distributed over the surface. The first four points picked must not lie on the same circumference. The first point should be taken on the pole of the sphere's cup. The other three points are taken on a circumference.
Example Sphere with 5 Points | Example Sphere with 9 Points
See the "Basic Measurement Format for a Sphere" topic for information on the associated Edit window command in the "Creating Measured Features" section.


Measuring a Round Slot

Display Menu Roadmap

Use the Round Slot icon to create a measured round slot.

To create a measured round slot, you must take at least six hits on the slot, usually two points on each straight side and one point on each curve. Alternately, you could take three points on each curve.

Example Round Slot with Six Points

See the "Basic Measurement Format for a Round Slot" topic for information on the associated Edit window command in the "Creating Measured Features" section.


Measuring a Square Slot

Display Menu Roadmap

Use the Square Slot icon to create a measured square slot.

To create a measured square slot, you must take five hits on the slot, two on one of the long sides of the slot and then one hit on each of the three remaining sides. The hits must be taken in a strictly clockwise or counterclockwise direction.

Example Square Slot with Five Points in a Clockwise Direction

See the "Basic Measurement Format for a Square Slot" topic for information on the associated Edit window command in the "Creating Measured Features" section.


Quick Start: Construct Toolbar

Quick Start Construct toolbar

Quick Start Construct toolbar

Display Menu Roadmap

When constructing elements, instead of processing picked points, PC-DMIS processes the characteristic points of already measured elements or elements you will measure.

The range of elements that you can construct is identical to the range of the elements that you can measure using the Quick Start Measure toolbar. The most frequent application is the construction of the circle passing through the centers of a circular pattern of holes or bosses.

Typically, the elements used to construct other elements are points and circles (or spheres) which you may or may not been measured and stored already. If you have not already measured a needed feature, you can measure it during the construction procedure.

The features you can construct are:

Point Features

Line Features

  • Intersect Point

  • Mid Point

  • Projected Point

  • Best Fit Line

  • Intersect Line

  • Mid Line

Plane Features

Circle Features

  • Best Fit Plane

  • Mid Plane

  • Alignment Plane

  • Best Fit Circle

  • Intersect Circle

  • Height Circle

  • Diameter Circle

Slot Feature

Cylinder Feature

  • Slot Feature

  • Cylinder Feature

Cone Feature

  • Cone Feature

The links in the table above will take you to the appropriate topic in the "Constructing New Features from Existing Features" section of this help file for in-depth information.

More:

Creating Constructed Features


Creating Constructed Features

This procedure below contains very basic information on constructing features. For in-depth information, see the "Constructing New Features from Existing Features" section.

  1. From the Quick Start toolbar, select the Construct toolbar. Display Menu Roadmap

  2. Click the icon of the feature you will measure. The Quick Start dialog box shows an icon of the procedure and a second icon for the first needed feature type.

  3. Follow the instructions at the bottom of the toolbar, either filling in data into the dialog or selecting (or measuring) the needed features to use in the construction.

  4. Continue clicking Next and following instructions until the Finish button becomes available.

  5. Click Finish when ready. PC-DMIS places the newly constructed feature on the part in the Graphics Display window and also in the Edit window.


Quick Start: Dimension Toolbar

Quick Start Dimension Toolbar

Quick Start Dimension toolbar

The Dimension toolbar lets you perform geometric measurements and geometric tolerance checks. With the exception of the Key-In dimension, this toolbar contains all the dimensions from the normal PC-DMIS Dimension toolbar. See "Dimension Toolbar" in this section.

Important: The Quick Start Dimension toolbar only creates legacy dimensions. It does not create the new Feature Control Frame dimensions.

About Geometric Measurements

About Geometric Tolerance Checks

Geometric measurements are used in the following circumstances:

  • When dimensions involve two elements (such as distances and angles).

  • When dimension elements are not measurable (such as corners).

  • When dimension measurements can be obtained by using geometric calculation procedures (intersections, projections, and / or middle elements).

In each geometric relationship between two elements, a third element is created (point, circle, line, or plane). The default output format of the calculated element includes the most meaningful dimensions.

Note: Geometric relationships are not to be confused with geometric tolerances. Geometric tolerances are used to check the functional requirements of a feature. Functional requirements are feature characteristics that ensure sufficient assembly, safety, appearance, performance etc. Geometric relationships, as used in PC-DMIS, are not sufficient to ensure functional requirements because they do not utilize the full extent of datum theory.

Geometric tolerance checks test the location, orientation, profile, runout, or form error of a feature (checked feature) relative to a datum reference frame (as applicable).

The following checks are available:

  • Orientation checks: test for errors of parallelism, perpendicularity, and angularity.

  • Location checks: test for errors of coaxiality, and concentricity, location, and position.

  • Profile checks: test for errors of profile form or profile, relative to the current alignment.

  • Runout checks: test for errors of total runout of a circle, cylinder, or plane.

PC-DMIS inserts a dimension of the resulting geometric tolerance check between two elements into the Edit window.

Icon | Description | Quick Start Procedure
 | Creates a legacy Location dimension. | Select or measure the feature. Click Next, specify the plus and minus tolerances, and then click Finish to insert the Location dimension.
 | Creates a legacy True Position dimension. | Select or measure the feature, click Next, specify the plus and minus tolerances, and then click Finish to insert the True Position dimension.
 | Creates a legacy Distance dimension. | Select or measure the first feature, click Next. Select or measure the second feature. Click Next. Specify the plus and minus tolerances, type a nominal value, select either 2D or 3D, and then click Finish to insert the Distance dimension.
 | Creates a legacy Angle dimension. | Select or measure the first feature, click Next. Select or measure the second feature. Click Next. Specify the plus and minus tolerances, type a nominal value, select either 2D or 3D, and then click Finish to insert the Angle dimension.
 | Creates a legacy Concentricity dimension. | Select or measure the first circular feature, click Next. Select or measure the second circular feature. Click Next. Specify the plus tolerance. Click Next. Click Finish to insert the Concentricity dimension.
 | Creates a legacy Circularity dimension. | Select or measure the first circular feature, click Next. Select or measure the second circular feature. Click Next. Specify the plus tolerance. Click Next. Click Finish to insert the Roundness dimension.
 | Creates a legacy Cylindricity dimension. | Select or measure a Cylinder, click Next. Select or measure the second feature. Click Next. Specify the plus tolerance. Click Next. Click Finish to insert the Cylindricity dimension.
 | Creates a legacy Straightness dimension. | Select or measure a Cone, Line, or Cylinder. Click Next. Specify a plus tolerance. Click Next. Click Finish to insert the Straightness dimension.
 | Creates a legacy Flatness dimension. | Select or measure a Plane. Click Next. Specify a plus tolerance. Click Next. Click Finish to insert the Flatness dimension.
 | Creates a legacy Perpendicularity dimension. | Select or measure the first feature. Click Next. Select or measure the second feature. Specify a plus tolerance and a projection distance. Click Next. Click Finish to insert the Perpendicularity dimension.
 | Creates a legacy Parallelism dimension. | Select or measure a non-point feature. Click Next. Select or measure the second non-point feature. Specify a plus tolerance and a projection distance. Click Next. Click Finish to insert the Parallelism dimension.
 | Creates a legacy Total Runout dimension. | Select or measure a Cone, Cylinder, Line, or Plane. Click Next. Select or measure a Cone, Cylinder, Line, or Plane. Click Next. Specify a plus and minus tolerance. Click Next. Click Finish to insert the Total Runout dimension.
 | Creates a legacy Circular Runout dimension. | Select or measure a Cylinder, Cone, Cylinder, Line, or Sphere. Click Next. Select or measure a Cylinder, Cone, Cylinder, Line, or Sphere. Click Next. Specify a plus and minus tolerance. Click Next. Click Finish to insert the Circular Runout dimension.
 | Creates a legacy Surface Profile dimension. | Select or measure a feature. Click Next. Specify a plus and minus tolerance. Choose whether the profile is Form Only or Form and Location. Click Next. Click Finish to insert the Surface Profile dimension.
 | Creates a legacy Line Profile dimension. | Select or measure a feature. Click Next. Specify a plus and minus tolerance. Click Next. Click Finish to insert the Surface Profile dimension.
 | Creates a legacy Angularity dimension. | Select or measure any non-point or non-sphere feature. Click Next. Select a Cone, Cylinder, Line, or Plane. Click Next. Specify a plus tolerance, a distance, and angle. Click Next. Click Finish to insert the Angularity dimension.
 | Creates a legacy Symmetry dimension. | Select or measure a line or set for the first feature. Click Next. Select the second feature. Click Next. Select the third (or datum) feature. Click Next. Type a plus tolerance. Click Next. Click Finish to insert the Symmetry dimension.

More:

Dimensioning Features Using the Quick Start Interface


Dimensioning Features Using the Quick Start Interface

The procedure below provides basic instructions on how to use the Quick Start interface to create dimensions:

  1. From the Quick Start toolbar, select the Dimension toolbar. Display Menu Roadmap

  2. Select the desired dimension from the toolbar. The icon for the selected dimension procedure appears in the Quick Start dialog box and instructions appear in the Status Bar at the bottom of your screen.

  3. Follow the instructions on the Status Bar by selecting features from the Edit window or Graphics Display window (or by measuring them if they don't exist).

  4. Follow the instructions on the Status Bar to type values into the Quick Start dialog box.

  5. Continue following instructions and clicking Next until the Finish button becomes available.

  6. Click Finish. PC-DMIS inserts the dimension into the part program.


A Sample Best Fit Alignment Graphical Analysis

This graphical analysis of the 3D Best Fit alignment displays this information in the Report window:

  • Header - This contains various values used in the Best Fit alignment: Method, Standard Deviation, Mean, Translation offsets, Rotation offsets, Max iterations, Iterations.

  • Vertical Axis - This shows the amount of deviation after the alignment.

  • Horizontal Axis - This displays the IDs of the points used in the alignment.

Quick Start: Align Toolbar

Quick Start Align toolbar

Display Menu Roadmap

The Align toolbar allows you to create alignments from specific feature types by using these procedures.

Icon | Description | Quick Start Procedure
 | Plane, Line, Line alignment | Select or measure a Plane to level to, and click Next. Select or measure a Line to rotate to, and click Next. Select or measure a second Line. The origin is created by translating the part to the two lines. Click Finish to insert the alignment.
 | Plane, Line, Circle alignment | Select or measure a Plane to level to, and click Next. Select or measure a Line to rotate to, and click Next. Select or measure a Circle. The circle's center, projected onto the line is where PC-DMIS will set the alignment's origin. Click Finish to insert the alignment.
 | Plane, Circle, Circle alignment | Select or measure a Plane to level to, and click Next. Select or measure the first Circle feature. Click Next. Select or measure the second Circle feature. PC-DMIS rotates the alignment to the line created from the centers of the two circles. It then uses the first circle's center, to set the alignment's origin. Click Finish to insert the alignment.
 | Plane, Line, Point alignment | Select or measure a Plane to level to, and click Next. Select or measure a Line to rotate to. Click Next. Select or measure a Point for the alignment's origin. Click Finish to insert the alignment.
 | Cylinder, Line, Point alignment | Select or measure a Cylinder, and click Next. Select or measure a Line. Click Next. Select or measure a Point. PC-DMIS levels the alignment to the surface where you clicked the point, rotates the alignment to the line, and sets its XY origin in the center of the cylinder. Click Finish to insert the alignment.
 | Six Points Best Fit alignment | Follow the on-screen prompts to select or measure six points. A typical procedure would be to measure three points on the top surface to level to the Z Axis. Measure two points on the front surface to rotate to the X Axis. Then measure one point to define the origin for the Y axis. Click Finish. This will establish the correct origin for the alignment. PC-DMIS inserts the Best Fit 3D Alignment. Following execution, PC-DMIS will display a 3D Alignment Best Fit Graphical Analysis in the Report window.

For additional ways of creating alignments see the "Creating and Using Alignments" section.


Quick Start: Calibrate / Edit Toolbar

Quick Start Calibrate / Edit Toolbar

Quick Start Calibrate / Edit toolbar

The Quick Start Calibrate / Edit toolbar icon simply launches the Probe Utilities dialog box.

Probe Utilities dialog box

Probe Utilities dialog box

Using this dialog box you can create your probes and calibrate the different angles. For more information on using this dialog box, see "Defining Probes" in the "Defining Hardware" section.


Using the Settings window

This inserts a RECALL/ALIGNMENT command, to recall the alignment you select from the list.

This inserts a LOADPROBE command for the selected probe into the part program.

This setting inserts a PREHIT command that sets the distance away from the theoretical location that PC-DMIS will move the probe at Touch Speed.

This setting inserts a TOUCHSPEED command that changes the speed at which the CMM takes hits. Values include 1 - 20 percent.

This setting inserts a DISPLAYPRECISION command with a value equal to the value in the setting. Any features following this command will show decimal places to the specified value.

This inserts a RECALL/VIEWSET command for the saved view you selected from the list.

This defines the AB angle to use for the LOADPROBE command by inserting the selected TIP command into the part program.

This setting inserts a CHECK command that sets the distance past the theoretical hit location that the machine will continue to search for the surface of the part.

This inserts a MOVESPEED command that determines how fast the CMM moves in between taking hits. Values include 1 - 100 percent.

This setting inserts a POSITIVEREPORTING command into the part program. This command displays features on the negative side of the origin with positive values. You can choose this reporting on all data or only on deviations.

This inserts a MODE/DCC or MODE/MANUAL to place the measuring machine into either DCC or MANUAL mode respectively.

This turns probe compensation on or off by inserting the appropriate PROBECOM command.

This setting inserts a RETRACT command that sets the distance that the machine will move away from the actual hit location before going from Touch Speed to Move Speed.

This setting inserts a SCANSPEED command that determines how fast your machine will scan your part. Possible values include 1 - 100 percent.

This setting determines whether or not PC-DMIS displays the positive reporting on the X axis.

This changes your current workplane by inserting a new WORKPLANE command into the part program.

This inserts an IGNOREMOTIONERROR/ON or OFF command into the part program. If you turn this setting ON, PC-DMIS will not stop when the probe encounters a collision.

This setting inserts a MANRETRACT command that sets the retract distance your CMM will automatically travel whenever you take a manual hit.

This setting determines whether or not PC-DMIS displays the positive reporting on the Y axis.

This activates a clearance plane by inserting a CLEARP command. Pressing F9 on the inserted command allows you to change the affected plane.

This setting inserts a TRIGGERTOLERANCE command. This command tells PC-DMIS to only accept a hit if the hit is within the defined tolerance zone. You can use this with manual machines to take accurate hits.

This setting determines whether or not PC-DMIS displays the positive reporting on the Z axis.

Allows you to define what plane has the clearance plane. This remains unavailable for selection until the Clearance Plane Active setting is activated or until a cursor rests on a CLEARP command.

This value determines the tolerance radius for the Trigger Tolerance setting.

This setting inserts a GAPONLY command into the part program. When set to ON, and dimensioning edge point location, the location axes are calculated by projecting the measured point to the theoretical surface and then projecting this new point onto the theoretical approach vector. Any location axes are then calculated from this new point.

Lets you set the distance for the defined Clearance Plane.

This setting inserts a TRIGGERPLANE command. This tells PC-DMIS to automatically take a hit when the probe passes the plane defined by the surface normal of an auto feature at the level of the defined depth. You can use this command with manual machines; instead of pressing a button to take a hit, you can place TRIGGERPLANE commands at any standard location within the Edit window.

This setting inserts a RETROLINEARONLY command into the part program. When set to ON, and dimensioning surface or vector point locations, the location axes are calculated in this manner:

First, finding the largest component of the theoretical surface normal vector (largest in the X, Y, or Z direction).

Second, projecting the measured point to this largest component vector in a manner that the projection is perpendicular to the original theoretical surface normal vector.

The location axes are then calculated from this new projected point.

This indicates the plane that the probe will pass through to get to the next feature plane.

This setting inserts an AUTOTRIGGER command into your part program. When PC-DMIS detects that the probe moves into the defined tolerance zone, it automatically takes a hit.

This defines the distance for the pass through plane.

This setting determines whether or not PC-DMIS uses a beeping with your AUTOTRIGGER command. If this is ON, the closer the probe gets to the target, the more frequent the beeps.

This value tells the controller how firmly to hold the probe on a Leitz CMM. It only works with the Leitz controller and the Leitz brand TTP.

This setting defines the radius for the Auto Trigger tolerance zone.

This allows the measurement of Vector and Surface points to always be compensated along a Polar vector by inserting a POLARVECTORCOMP command.

This inserts a FLY command and sets it to either ON or OFF. A FLY command works with a MOVEPOINT command and moves the probe around the part in a smooth, non-stopping motion.

This setting sets the distance parameter for the FLY command. It determines the distance away from the MOVEPOINT command to which the probe will automatically move.

Using the Settings Window

Selecting View | Other Windows | Settings Window opens up the Settings window.

Settings window

This dockable window contains several tabs of frequently modified settings. Each tab contains color-coded, editable settings, specific to that tab. The settings are linked to your cursor's current location in the part program and will update their display to match the setting in the program at the cursor's location. For example, if you have multiple LOADPROBE commands, and you select each LOADPROBE command in the Edit window, PC-DMIS will update the Settings window to display the selected LOADPROBE command.

Editing a Setting

To edit a setting, simply click on the field to the right of the setting, and select a different option, or type a new value. When you change a setting, PC-DMIS will insert the appropriate parameter change into the part program at the cursor's location.

Available Settings

The following tabs and settings are available. The shaded background on the cells in the table below indicates the default color associated with those settings:

All | General | Probe | Distances | Speeds | Dimensions
This tab contains all the settings from all the tabs. | Alignment | Probe | Prehit | Touch Speed | Display Precision
 | Viewset | Tip | Check | Move Speed | Positive Reporting Display
 | Manual/DCC | Probe Compensation | Retract | Scan Speed | Positive Reporting Axis X
 | Workplane | Ignore Motion Error | Manual Retract |  | Positive Reporting Axis Y
 | Clearance Plane Active | Trigger Tolerance |  |  | Positive Reporting Axis Z
 | Clearance Plane | Trigger Tol. Zone |  |  | Gap Only
 | Clear Plane Dist. | Trigger Plane |  |  | Retrolinear Only
 | Pass Through Plane | Auto Trigger |  |  |
 | Pass Through Distance | Auto Beeping |  |  |
 | Clamping Value | Auto Tolerance Zone |  |  |
 | Polar Vector Compensation | Fly Mode |  |  |
 |  | Fly Radius Type |  |  |

For a brief description on these settings, click on a link in the table above, or for more in-depth documentation, find the specific options in one of these topics:

  • Settings Toolbar

  • Probe Mode Toolbar

  • Selecting PC-DMIS Setup Options

  • Modifying Report and Motion Parameters

You can also insert many of these settings from the Insert | Parameter Change submenu.

More:

Changing Settings Window Options


Changing Settings Window Options

You can change your settings window options, by right-clicking in the window and selecting Options from the shortcut menu.

Settings Window Shortcut menu

The Settings Window Options dialog box appears.

Settings Window Options

Settings Window Options dialog box

Using this dialog box, you can modify the colors used in the different categories and also control what category appears whenever you start the Settings Window.

Startup Area

This area contains two startup options for the Settings Window:

Using Active category - The Settings Window displays the last used category when it starts.

Always using - The Settings Window displays the category selected from the drop-down list when it starts.

Colors Area

The Enable colors for categories check box lets you disable or enable the color-coded display for the categories of settings.

The drop down arrows on the colored boxes let you modify the default color-coded display for the available categories.


Using the Preview window

Display Menu Roadmap

Selecting the View | Other Windows | Preview Window menu option opens a window that allows you to preview the results of a feature measurement before actually accepting the measurement. After taking probe hits and pressing the END key (or DONE on the jog box) PC-DMIS displays the feature in the Graphics Display window and dimension information for the feature in the Preview Window.

Preview Window for a measured circle showing the X, Y, Z, and Diameter values

The Preview Window uses the same color scheme used for dimensions to show the deviations from acceptable tolerances; these colors allow you to quickly determine whether or not a particular measurement falls within acceptable tolerances or not (see "Editing Dimension Colors" in the "Editing the CAD Display" section for information on how to change the tolerance colors used for dimensions).

Note: To determine which feature information is displayed in the Preview window, simply place your Edit window cursor on the command line for any feature in the Edit window. Generally the cursor rests on the last feature in the Edit window.

Below are the available options for the Preview Window.

More:

Preview Window Options

Sizing the Preview window


Preview Window Options

The Preview Window displays general information about a feature as well as more specific dimensional information.

Option

Description

ID

This box determines the name label for the measured feature or dimension.

SD

This box determines the Standard Deviation for the measured feature.

#Hits

The #Hits box determines the number of probe hits taken to measure the feature.

Hide

The Hide button closes the Preview Window. You can open the Preview Window by selecting View | Preview Window.

Accept

The Accept button accepts the measurement and creates an automatic dimension for the feature if you have selected to do so using the Auto Dimension Setup button.

View

The View button displays the Analysis window for the appropriate dimension for the measured feature. See " Inserting Commands Related to the Analysis Window " for a discussion on the Analysis window.

Auto Dimension Setup

Selecting the Auto Dimension Setup button displays the Auto Dimensioning dialog box.

For information on this dialog box, see " Auto Dimension Setup " in the " Setup Options: Dimension tab " topic discussed in the " Setting Your Preferences " section.

AX

An AX list displays the selected axis in the Preview Window. You can select these axes: X, Y, Z, D, R, A, T, PR, PA, M, V, L, PD, RS, RT, S, H.

You can view information on up to six axes at one time by selecting them from the various AX lists.

For information on these axes, see "Default Axes" and "Sheet Metal Axes" in the "Dimensioning Features" section.

Nominal

This box determines the nominal (or ideal) values for each axis.

+TOL

This box determines a tolerance value above the nominal value for which the measurement is still acceptable.

-TOL

This box determines a tolerance value below the nominal value for which the measurement is still acceptable.

MEAS

This box determines the actual measured values.

MAX

This box determines the maximum value you can have before your measurement goes out of tolerance.

MIN

This box determines the minimum value you can have before your measurement goes out of tolerance.

DEV

This box determines the measurement's deviation from the nominal value.

OUTTOL

This box determines the value by which the measured value is out of tolerance.


Sizing the Preview window

Like most windows, the Preview window can be sized to fit your current needs. If you need it larger or smaller, simply drag the edge of the window with the mouse and make it the desired size.

Note: The Preview window in Learn mode differs from the Preview window in Execute mode, and you can change the sizes for each.


Using the Marked Sets Window

Display Menu Roadmap

Selecting the View | Other Windows | Marked Sets Window menu option accesses the Marked Sets window. You can use this window to store a group of marked features that you want to execute. See the "Creating and Executing Marked Sets" topic in the "Editing a Part Program" section.


Using the Virtual Keyboard

Selecting the View | Virtual Keyboard menu option causes the Virtual Keyboard to appear. This keyboard functions as does any normal keyboard and can be used with a mouse or with a touch screen monitor. This is useful for certain shop floor environments where it's not convenient to use a physical keyboard.

Sample Virtual Keyboard – Keypad 1 Variation

You can easily select different variations of the Virtual Keyboard or customize and create your own keyboard variations.

PC-DMIS also provides you with a toolbar for easy access to the Virtual Keyboard. See the "Virtual Keyboard Toolbar" topic in the "Using Toolbars" section.

More:

Accessing Virtual Keyboard Variations

To Create a New Virtual Keyboard Variation

To Modify an Existing Virtual Keyboard Variation

To Delete an Existing Virtual Keyboard Variation

Joining or Merging Keys in a Keyboard Variation

Using Separators in the Virtual Keyboard for Visual Appeal

Viewing Path Lines


Accessing Virtual Keyboard Variations

You can right-click within the Virtual Keyboard at any time to see a popup menu allowing you to quickly select variations on the keyboard or customize it to fit your needs:

These menu items show the different default keyboard variations available for the Virtual Keyboard. You can, of course, customize these or create other variations to better fit your needs (see "To Modify an Existing Virtual Keyboard Variation").

KeyPad 1 | KeyPad 2 | KeyPad 3
StdKeyPad | Function Keys | Keyboard


To Create a New Virtual Keyboard Variation

  1. Access the Virtual Keyboard, right-click on it, and select Customize from the menu. The Customize Key pad dialog box appears.

Customize Key pad dialog box

  2. In the Layout Definition area, type a name for your keyboard in the Layout Name box.

  3. Type the number of rows and columns in the Rows and Columns boxes. This defines how many "keys" (or buttons) will appear on the keyboard.

  4. Click Create. PC-DMIS displays a keyboard layout window comprised of a blank grid, representing the number of keys on your newly created layout.

Example of an Empty 3x3 Grid Layout

  5. Size the grid of buttons to fit your needs by dragging the window's borders.

  6. In the Buttons Definition area, create a new button definition. Do this by selecting, Define Keys from the Mode list, then select the type of keystroke (or key code) from the Special Keystroke, Standard Keystroke, or System Keystroke lists. Most of the keystrokes are self-explanatory, and are synonymous with the name or symbology of the actual button on an English keyboard, with the possible exception of VK_PREVIOUS for the PAGEUP button and VK_NEXT for PAGEDOWN button.

  • If you want a label to appear for the keystroke you selected, select the Label option, and type a label in the Label box.

  • If you want a symbol to appear for the keystroke you selected, select the Symbol option, and select a symbol from the scrollable list of symbols.

  • If you want to define a button as nothing at all—representing a flat, empty key space on a real keyboard—select the No Button option for that button definition.

  7. From the layout window with the grid of buttons, select an undefined button that will take this definition, and then click the Set button from the Buttons Definition area of the Customize Key pad dialog box. Your change appears on the keyboard layout window.

  8. Continue repeating this procedure as needed until you have defined your keyboard to your liking.

Completed Keyboard Layout Example with the corner buttons set to No Button

  9. Once you have defined all your buttons, the Save button becomes available for selection. Click the Save button to save your keyboard.

  10. Click the New button to create additional layouts if needed; otherwise, click Close.

Note: If you incorrectly assign a button definition, you can select the No Button option, click the button on the layout grid, and then click the Set button. This will clear any previous values assigned to that button location.


To Modify an Existing Virtual Keyboard Variation

To modify an existing layout,

  1. Access the Virtual Keyboard, right-click on it, and select Customize from the menu. The Customize Key pad dialog box appears.

Customize Key pad dialog box

  2. Click the Open button.

  3. Select the keyboard from the drop-down menu.

  4. Use the procedure for assigning button definitions to the keyboard layout in the "To Create a New, Customized Virtual Keyboard Layout" topic. You may need to select the No Button option for a button to clear out a previous definition prior to assigning it a new definition.

  5. Click Save to save any modifications.


To Delete an Existing Virtual Keyboard Variation

To delete an existing layout,

  1. Access the Virtual Keyboard, right-click on it, and select Customize from the menu. The Customize Key pad dialog box appears.

Customize Key pad dialog box

  2. Click the Delete button.

  3. Select the keyboard from the drop-down menu. PC-DMIS asks if you want to delete the keyboard.

  4. Click Yes to delete it.

  5. Click Close.


Joining or Merging Keys in a Keyboard Variation

The Customize Key pad dialog box also allows you to join or merge more than one button on the keyboard layout grid to make larger buttons. This is useful if you want to have a button that's larger than the usual single button size (for example, if you're creating something that looks like the SPACEBAR key).

  1. Create or open for modification a keyboard layout by following the procedures already described in the "To Create a New Virtual Keyboard Variation" topic and in the "To Modify an Existing Virtual Keyboard Variation" topic.

  2. From the Mode list on the Customize Key pad dialog box, select Join Keys. Each button of the keyboard layout grid now contains a small, red-dotted border.

  3. Click one of the buttons. This becomes the start button. A bold red border appears on both the horizontal and vertical side from the starting button. If you click on different button, it changes the start button to that button.

  4. Right-click on the end button for the merge; it must be inside the drawn red area, and it must be to the right of, or below, the start button. If joined area doesn't conflict with an already existing joined area, the bold red border will become a green rectangle. This means that those grouped buttons will be shown as one button.

  5. If the joined area conflicts with another joined area, PC-DMIS will display a message saying it cannot perform the join.

  6. To delete one of the existing joined areas, left click inside the green bordered region (joined buttons).

Important: When you assign a button definition to a group of joined buttons, you must select the start button on that group: this is the leftmost button if it's an horizontal grouping; or the topmost button if it's a vertical grouping. You only need to do this when assigning a button definition to that group; when you actually use the Virtual Keyboard, this isn't needed.


Using Separators in the Virtual Keyboard for Visual Appeal

You can add or change where separators, empty space between buttons, appear on a virtual keyboard variation. This doesn't affect how the keyboard functions; it merely provides visual appeal and better organization to the keyboard's layout.

  1. Create or open for modification a keyboard layout by following the procedures already described in the "To Create a New Virtual Keyboard Variation" topic and in the "To Modify an Existing Virtual Keyboard Variation" topic.

  2. From the Mode list on the Customize Key pad dialog box, select Toggle Separators. Each button of the keyboard layout grid now contains a small, blue-dotted border.

  3. Left click between the blue dots to show or hide a separator. A red line appears showing where the separator will appear. If you select a horizontal line between rows, the separator will be a horizontal separator along that line. If you select a vertical line between rows, it will be a vertical separator along that line.

When you are working in the Define Keys mode, as discussed in the "To Create a New Virtual Keyboard Variation" topic, separators will appear as blue lines.


Using the Probe Readout window

Display Menu Roadmap

The View | Other Windows | Probe Readouts menu option allows you to access a readout of the current CMM position and other useful information. When this option is selected, PC-DMIS will display the Probe Readout window.

Sample Probe Window

Explanation

Probe Readout window

A - Feature ID (CIR1) and Feature type (CIRCLE)

B - Current XYZ probe position

C - XYZ position of the last hit

D - Distance to next location shown in out of tolerance dimension colors

E - Error of last measured feature

F - Rotary table angle

G - Number of hits taken

AB axis angles appear below the number of hits taken if you have an active wrist probe (such as a PHS or CW43 Light etc.).

H - Probe Readout comments. This comes from the Probe Readout comment type. See the "Inserting Programmer Comments" in the "Inserting Report Commands" section.

The Probe Readout window contains information from the table below depending on the options selected from the Probe Readout Setup dialog box (see "Setting Up the Readout Window" in the "Setting your Preferences" section).

Tip: You can access the Probe Readout Setup dialog box by right-clicking on the Probe Readout window and clicking Setup.

Sizing the Probe Readouts Window

You can alter the size of this window simply by ‘dragging’ the border of the window until the desired size is reached. Clicking on the maximize window icon [image] in the upper right portion of the window will expand the box to the full display of the screen. (Click on the icon a second time to return it to its previous size.) This allows you to view the selected Readout window when the CMM is located across the room from the monitor. To close the Probe Readout window you must click the X in the upper right hand corner.

Note: Each time the location or size of the Probe Readout window is altered, PC-DMIS will update the proper registry setting. The next time the option is accessed, the window will be displayed precisely as it was in the previous viewing.

On machines with an external DRO, this option is not available.

Multiple Arm Mode and the Probe Readout Window

If you have more than one arm measuring your part, PC-DMIS displays the probe readout information for each additional arm in a new column.

Example of the Probe Readout window showing multiple arms in two columns

You can right-click on this window to display a shortcut menu that allows you to show or hide information about a particular probe.

If the menu item displays a check mark next to it, its information appears in the Probe Readout window.


Using the Status Window

Display Menu Roadmap

Status Window

The View | Status Window menu option displays the Status window. This window lets you preview commands and features while creating them from the Quick Start toolbar, during feature execution, and also by simply clicking on the item in the Edit window with the Status window open. While similar in some ways to the Preview window, the Status window differs in these ways:

  • You don't specify tolerances or nominal values in this window. The window is for display only.

  • It provides a flexible way to display commands by tying into the new template-based Reporting functionality.

  • It displays a dynamic preview for any command or dimension type, not just Location dimensions, as long as those commands are properly assigned inside your report and label templates.

This window functions the same as other dockable and scrollable windows. It will display scroll bars if the content within the window exceeds the window's size. Additionally, you can dock and undock this window at the bottom or top of the Graphics Display window by double-clicking on the window's title bar, or by dragging the window, and then releasing it at the desired location.

The Status Window with the Quick Start Toolbar

The Status window displays the current status of any Guess Mode measurements, feature selection, and dimension creation when using the Quick Start toolbar. In the case of the screen shot shown above, this dimension has not yet been created, yet PC-DMIS lets you preview the dimension in this window prior to clicking Finish from the Quick Start toolbar.

The Status Window during Feature Creation or Execution

The Status window displays preview information of features not yet displayed in the Report window. This window utilizes the new reporting templates functionality to generate dynamic previews of commands during execution and creation. During feature creation it only previews the feature if PC-DMIS is in Guess mode. Once a feature or dimension is in the Edit window, you can preview it at any time by simply clicking on it.

Changing the Status Window Template

Since the Status window uses reporting templates to display its information, you can change what template it uses if you would like it to display different information. Any command can be displayed in the Status window as long as a label template is assigned to that command in the report template (.rtp) file. You assign what report template this uses from the ReportTemplate registry entry under the StatusWindow section of the PC-DMIS Settings Editor. The default template it uses is TEXTONLY.RTP.

Using the Status Window in Accumulation Mode

During execution, the Status window usually only displays the most recently executed feature and dimension. However, you can have PC-DMIS show a list of accumulated executed items by setting AccumulateStatusWindowResults under the Reporting section to True using the PC-DMIS Settings Editor. With this mode turned on, the contents in the Status window don't get removed until execution finishes. This allows you to show a running list of information during part program execution. Also, while in this mode, PC-DMIS follows the TextReportObject's properties used in the Status window's template to determine what information gets sent to the Status window (features, dimensions, alignments, and so forth).


Using the Dimensions Colors Window

Using the Dimensions Colors Window (Dimensions Color Bar)

Display Menu Roadmap

The View | Other Windows | Dimensions Colors Window menu option displays the Dimensions Color Bar. This dockable, non-sizable bar-like window shows the colors for dimension tolerances and their associated scale values.

Example Surface Profile Dimension and Associated Dimensions Color Bar

The color bar can be dragged and docked on either the right side or left side of the screen.

How it Displays

The top of the bar displays the current default tolerance value, represented simply by a label in a white band with its numerical scale value.

The remaining colored bands on the bar consist of the same number of defined tolerance zones as in the Edit Dimension Color dialog box with the addition of a colored band on top for the ”Negative Out of Tolerance” (labeled with a ”-“sign) and a colored band on the bottom for the ”Positive Out of tolerance” (labeled with a ”+” sign).

Right-Click to Access 'Edit Dimension Color' Dialog Box

A single right-click with the mouse on the color bar will cause the Edit Dimension Color dialog box to display:

This dialog box defines the dimension colors and tolerance zones used. It also contains some settings that determine how the color bar is displayed. For information on this dialog box, see the "Editing Dimension Colors" topic in the "Editing the CAD Display: Introduction" section.

Tooltips for Complete Info

If you move your mouse over a tolerance band, a yellow tooltip appears containing the complete range of values for that tolerance band (lower and higher) or the complete label ”Positive Out of Tolerance” or "Negative out of Tolerance" when hovering your mouse over the ”+” or "-" band respectively.


Using the Probe Toolbox

Display Menu Roadmap

The View | Probe Toolbox menu option displays the Probe Toolbox.

Probe Toolbox for a Contact Probe

This toolbox allows you to easily perform various probe-related manipulations. It presents tabs and information relative to the type of probe currently used. If you use an optical probe or a laser probe, for example, the tabs that appear will be different than for contact probes, and they will allow you to manipulate parameters specific to those probe types.

See the documentation sets that apply to your particular configuration for specific information on the Probe Toolbox:

  • PC-DMIS CMM (and Portable)

  • PC-DMIS Vision

  • PC-DMIS Laser

Note: Because the items in the Probe Toolbox are so frequently used when creating Auto Features, in version 4.3 the Probe Toolbox also functions as an embedded portion of the Auto Feature dialog box.

More:

Placing and Sizing the Toolbox


Placing and Sizing the Toolbox

Much like the Edit window or the various toolbars available in PC-DMIS, you can dock the Probe Toolbox to the sides of the PC-DMIS application window or you can cause it to float above other elements.

To cause it to dock:

  1. Ensure that the Probe Toolbox is in docking mode. Right-click on the title bar and select Dockable from the shortcut menu.

  2. Select the toolbox's title bar with the mouse.

  3. Drag the toolbox onto the left or right edges of the PC-DMIS application window.

  4. Release the mouse. PC-DMIS docks the toolbox at that location.

To cause it to float:

  1. Select the toolbox's title bar with the mouse.

  2. Drag the toolbox out of it's docked position on top of the Graphics Display window and release the mouse. While it floats above the Graphics Display window, it is still in docking mode.

  3. Right-click on the title and select Floating from the shortcut menu.

  4. Drag the toolbox to where you want to place it.

  5. Release the mouse. PC-DMIS floats the toolbox at that location.

You can also size the toolbox by selecting an edge of the toolbox and dragging the mouse to a new location.


Viewing Path Lines

Display Menu Roadmap

Selecting the View | Path Lines menu option draws the current path of the probe in the Graphics Display window. See "Showing and Animating Path Lines" in the "Editing the CAD Display" section for more information.


Using Toolbars

Using Toolbars: Introduction

G raphics Modes Toolbar

Graphic View Toolbar

Graphic Items Toolbar

Settings Toolbar

Probe Mode Toolbar

Edit Window Toolbar

Dimension Toolbar

Constructed Features Toolbar

Auto Features Toolbar

Measured Features Toolbar

File Operations Toolbar

Macro Play/Record Toolbar

Virtual Keyboard Toolbar

Touch Screen Mode Toolbar

Wizards Toolbar

Portable Toolbar

Active Arms Toolbar

Active Rotary Table Toolbar

Window Layouts Toolbar


Using Toolbars: Introduction

In an effort to decrease the time it takes to program your part, PC-DMIS 3.2 and above offers you a variety of toolbars composed of frequently used commands. These toolbars can be accessed in two ways.

  • Select the View | Toolbars submenu and select a toolbar from the menu provided. Display Menu Roadmap

  • Right-click on PC-DMIS's Toolbar area and select a toolbar from the shortcut menu provided.

The toolbars provided include:

  • Graphics Modes toolbar

  • Graphic View Toolbar

  • Settings toolbar

  • Probe Mode toolbar

  • Edit Window toolbar

  • Dimension toolbar

  • Constructed Features toolbar

  • Auto Features toolbar

  • Measured Features toolbar

  • File Operations toolbar

  • Macro Play/Record toolbar

  • Wizards toolbar

  • Portable Toolbar

  • Active Arms toolbar

  • Active Rotary Table toolbar

  • Quick Start toolbar

  • Window Layouts toolbar

If you're looking for the Guess Mode, Probe Readouts, and Manual/DCC toolbars, these are all on the new Probe Mode toolbar. See "Probe Mode Toolbar". The Guess Mode icons are also included on the Probe Toolbox, discussed in the "Using the Probe Toolbox" topic in the "Using Other Windows, Editors, and Tools" section.


Graphics Modes Toolbar

Display Menu Roadmap

Graphics Modes toolbar

The Graphics Modes toolbar allows you to easily alter the display of the part on the screen. It also allows you easy access to the available modes. This toolbar contains the following icons:

Icon |  | Description
 | View Setup | Alters the display of the part in the Graphics Display window. See "Setting up the Screen View" in the "Editing the CAD Display" section.
 | Save Viewset | Saves the view of the part as the current viewset which can later be recalled. See "Working with Viewsets" in the "Inserting Report Commands" section.
 | Create Viewset | Saves the view of the part as a separate viewset command which can later be recalled. See "Working with Viewsets" in the "Inserting Report Commands" section.
 | Scale to Fit | Enlarges or shrinks the views of the graphic in the Graphics Display window to fit your screen. See "Scaling the Drawing" in the "Editing the CAD Display" section.
 | Draw Surfaces | Turns on or off the display of solid CAD surfaces. See "Drawing Surfaces" in the "Editing the CAD Display" section.
 | Repaint the Screen | Refreshes and redraws all the views of the part. See "Repainting the Screen" in the "Editing the CAD Display" section.
 | Curve mode | Places PC-DMIS into Curve mode (for use with wire-frame). See "Switching Between Curve and Surface Modes" in the "Editing the CAD Display" section.
 | Surface mode | Places PC-DMIS into Surface mode (for use with surface data). See "Switching Between Curve and Surface Modes" in the "Editing the CAD Display" section.
 | Translate mode | Places PC-DMIS into translate mode. See "Translate Mode" in the "Editing the CAD Display" section.
 | 2D Rotate mode | Two dimensionally rotates the part for the selected view. See "2D Rotate Mode" in the "Editing the CAD Display" section.
 | 3D Rotate mode | Three dimensionally rotates the part for the selected view. See "3D Rotate Mode" in the "Editing the CAD Display" section.
 | Program mode | Uses the probe either offline or online to learn and edit your part program. See "Program Mode" in the "Editing the CAD Display" section.
 | Text Box mode | Accesses shortcut menu commands for Point Info and Dimension Info text boxes as well as other on-screen elements. See "Text Box Mode" in the "Editing the CAD Display" section.
 | Quick Fixture mode | Provides the ability to move quick fixtures and the part by clicking and dragging them with the mouse. See "Inserting Quick Fixtures" in the "Defining Hardware" section.
 | Assembly | Displays a window allowing you to display or hide parts inside an assembly (a collection of part models). See "Working with Assemblies of Parts" in the "Editing the CAD Display" section.
 | Coordinate System | Displays the CAD Coordinate System dialog box. This dialog box lets you create a new or select an existing coordinate system. See "Working with CAD Coordinate Systems" in the "Editing the CAD Display" section.
 | CAD Lighting | Applies lighting, textures, and transparencies to CAD models. See "Applying Lighting and Materials to the CAD Display" in the "Editing the CAD Display" section.
 | Graphics Categories | Shows and hides different items in the Graphics Display window. See "Showing and Hiding Graphics" in the "Editing the CAD Display" section.
 | Rotation Options | Changes how items are displayed in the Graphics Display window during part rotation. See "Changing Rotation and Other Motion Options" in the "Editing the CAD Display" section.
 | Display Symbols | Defines the symbol style and size used to represent CAD points, scanned points, and feature points in the Graphics Display window. See "Modifying Point Symbols" in the "Editing the CAD Display" section.


For example, if you divided your screen into three views by using this icon from the View Setup dialog box...

a view icon that divides your Graphics Display window into three parts, or panes to display different views in each one

...clicking icons from the Graphic View toolbar would only affect the top left (or blue) portion of the screen.

Graphic View Toolbar

Display Menu Roadmap

Graphic View toolbar

With the Graphic View toolbar you can quickly and easily change how your part is displayed inside the Graphics Display window. These icons act the same as if you had used the View Setup dialog box to affect your view. See the "Setting up the Screen View" topic in the "Editing the CAD Display" section for information on setting up your views.

If you configured the Graphics Display window to show more than one view, these toolbar icons only affect the blue pane in the Views area of the View Setup dialog box.

Icon | Description
 | Shows the X+ view of the part
 | Shows the X- view of the part
 | Shows the Y+ view of the part
 | Shows the Y- view of the part
 | Shows the Z+ view of the part
 | Shows the Z- view of the part
 | Shows an isometric view of the part
 | Shows the wireframe view of the part
 | Shows the surface/solid view of the part
 | Turns any predefined transparencies on or off. This icon becomes enabled once transparency is defined in the Lighting tab of the Lighting and Materials dialog box.
 | Displays or hides the 3D Grid.


Graphic Items

Graphic Items Toolbar

Display Menu Roadmap

Graphic Items toolbar

The Graphic Items toolbar lets you easily show or hide identification labels for Features, Dimension Info boxes, Point Info boxes, and Feature Control Frames (FCFs) in the Graphics Display window.

Icon | Description
 | Hides or displays Feature IDs.
 | Hides or displays Point Info boxes.
 | Hides or displays Feature Control Frame IDs.
 | Hides or displays Dimension Info boxes.


Settings Toolbar

Display Menu Roadmap

Settings toolbar

The Settings toolbar contains a variety of lists that provide an easy way for you to switch between these settings:

  • Saved views

  • Predefined alignments

  • Probe types

  • Predefined probe tips

  • Available work planes

  • Planes to project to

  • Active CMM interfaces

To change a display:

  1. Open the desired drop-down list.

  2. Select a previously defined ID or feature.

More:

Views List

Alignments List

Probes List

Probe Tips List

Working Plane List

Plane List


Views List

The Views list stores views that were created and saved with the active part program.

See "Setting Up the Screen View" in the "Editing the CAD Display" section and "Working with Viewsets" in the "Inserting Report Commands" section.

To use a saved view:

  1. Place the mouse pointer over the down arrow on the Views list.

  2. Click the left mouse button.

  3. Move the mouse pointer to the ID that is desired.

  4. Click the left mouse button.

While PC-DMIS is recalling a view, all other functions are temporarily inaccessible.

Command line in the Edit window:
RECALL/VIEWSET, view_set_name

View_set_name = the name of the view set to recall.


Alignments List

The Alignments list stores previously saved alignments. These alignments can then be inserted into the Edit window when selected.

See "Saving an Alignment" from the "Creating and Using Alignments" section for additional information on how to create and save alignments.

To change the alignment:

  1. Place the mouse arrow over the down arrow of the Alignments list.

  2. Click the left mouse button. A drop-down list will appear allowing you to select a new alignment.

You can control which alignments are displayed in this list by going to the Alignment in the Edit window and changing the value for the LIST= portion of the ALIGNMENT/START command (see the "Creating and Using Alignments" section for more information).


Probes List

The Probes list allows you to select probes already defined in your probe file. PC-DMIS inserts a LOADPROBE command into the Edit window.


Probe Tips List

The Probe Tips list stores previously defined probe tip angles. See "Add Angles" from the "Defining Hardware" section for information on how to create tip angles.

To change a tip number:

  1. Scroll through the available tips by clicking on down arrow of the Probe Tips list.

  2. Select the desired tip using the left mouse button.


Working Plane List

Display Menu Roadmap

The Working Plane drop-down list allows you to change the plane in which you are working. This will not change the view in the Graphics Display window, only the working plane.

The available working planes are:

A=TOP | Light gray | ZPLUS
B=RIGHT | Medium gray | XPLUS
C=BACK | Vertical lines | YPLUS
D=BOTTOM | Horizontal lines | ZMINUS
E=LEFT | Red | XMINUS
F=FRONT | Clear | YMINUS

For example, to change the current working plane to the back of the part image:

  1. Position the mouse pointer over the down arrow of the Working Plane list.

  2. Select YPLUS from the drop down list to get the new working plane.

Measured Lines and Working Planes

When creating a measured line, PC-DMIS expects the hits for the line to be taken at a vector perpendicular to the current working plane.

For example, if your current working plane is ZPLUS (with a vector 0,0,1), and you have a block-like part, the hits for the measured line must be on a vertical wall of that part, such as the front or side.

If you then wanted to measure a line feature on the top surface of the part, you would need to switch the working plane to XPLUS, XMINUS, YPLUS, or YMINUS, depending on the direction of the line.

See the "Measuring a Line" topic for information on creating measured lines.


Plane List

The Plane list contains a list of any plane features you have created in your part program. By default PC-DMIS projects each measured line and circle into your current workplane, so the default item on this list shows Workplane. However, you can select a different plane from this list. PC-DMIS will then project each measured line and circle into the newly selected plane.


Probe Mode Toolbar

Display Menu Roadmap

Probe Mode toolbar

Probe Mode toolbar

The Probe Mode toolbar contains icons that allow you to enter the different modes used by the current probe or CMM. The available mode icons are described in this table:

Icon |  | Description
 | Manual Mode | The Manual Mode icon allows you to place PC-DMIS in manual mode. Manual mode allows you to manually control your machine's movements and measurements. Manual mode is used on a manual CMM, or during the manual alignment portion of a program that will be run on an automatic CMM. Selecting this icon inserts a MODE/MANUAL command into the Edit window at the cursor's location. Edit window commands following this command are executed in Manual mode.
 | DCC Mode | The DCC Mode icon allows you to place PC-DMIS in DCC mode. DCC mode allows supported DCC machines to automatically take over the measurement of your part program. Selecting this icon inserts a MODE/DCC command into the Edit window at the cursor's location. Edit window commands following this command are executed in DCC mode.
 | Readouts Mode | The Readouts Mode icon becomes available only if you use an LK machine. It places the probe into readouts mode. See "Placing the Probe into Readouts and Hits Mode" in "Using Other Windows, Editors, and Tools" for more information.
 | Hits Mode | The Hits Mode icon becomes available only if you use an LK machine. It places the probe into hits mode. See "Placing the Probe into Readouts and Hits Mode" in "Using Other Windows, Editors, and Tools" for more information.
 | Surface Auto Trigger Mode | The Surface Auto Trigger Mode icon inserts an AUTOTRIGGER command into the part program. See the "Auto Trigger area" topic in the "Setting Your Preferences" section.
 | Edge Auto Trigger Mode | The Edge Auto Trigger Mode icon inserts a TRIGGERPLANE command into the part program. See the "Sample Plane Auto Trigger area" topic in the "Setting Your Preferences" section.
 | Find Nominals from CAD Mode | The Find Nominals from CAD Mode icon selects the Find Nominals check box in the General tab of the Setup Options dialog box. See "Find Nominals" topic in the "Setting Your Preferences" section.
 | Point Only Mode | The Point Only Mode icon selects the Point Only Mode check box in the General tab of the Setup Options dialog box. See "Point Only Mode" topic in the "Setting Your Preferences" section.

Note: Previous versions of PC-DMIS used to contain Flat Guess and Round Guess mode icons. Since the guess algorithm in PC-DMIS has improved in version 4.0 and higher, these icons have been removed from the toolbar and are no longer needed.


 Print Icon Redo Icon Undo Icon Paste with Pattern Past Icon Copy Icon Cut Icon DMIS Mode Icon Command Mode Icon Summary Mode Icon Clear All Bookmarks Next Bookmark Icon Insert Bookmark Icon Set Start Point Remove All Breakpoints Icon Insert/Remove Breakpoint Icon Clear Marked Mark All Icon Mark Current Feature Icon Execute Program Icon

Edit Window Toolbar

Edit window toolbar

Display Menu Roadmap

The Edit Window toolbar provides quick access to many frequently accessed Edit window functions.

The toolbar allows you to manipulating Edit window content in a way that is easy and intuitive to use The toolbar provides ready access to these commands important Edit window commands.

More:

Execute Program

Mark Current Feature

Mark All

Clear Marked

Set Start Point

Insert/Remove Breakpoint

Remove All Breakpoints

Insert Bookmark

Next Bookmark

Clear All Bookmarks

Summary Mode

Command Mode

DMIS Mode

Cut

Copy

Paste

Paste with Pattern

Undo

Redo

Print


Execute Program

The Execute Program toolbar icon runs (or executes) the measurement process for any currently marked feature(s). See "Executing Part Programs" in the "Using Advanced File Options" section.


Mark Current Feature

The Mark Current Feature toolbar icon highlights the feature under your cursor and prepares it for execution. See "Mark" in the "Editing a Part Program" section for more information.


Mark All

The Mark All toolbar icon highlights all features in the Edit window. PC-DMIS will ask you if you want to highlight features used for the alignment as well. See "Mark All" in the "Editing a Part Program" section for more information.


Clear Marked

The Clear Mark toolbar icon removes all highlights from currently marked features within the Edit window. See "Mark All" in the "Editing a Part Program" section for more information.


Set Start Point

The Set Start Point toolbar icon allows you to set the start point for the active learn arm. In the Edit window, click on the command that you want to use for the start point and then click on the Start Point toolbar icon. The start point for the current arm will be set to the command located at the insertion point. You can also set a start point, by right-clicking on a command and choosing Set Start Point. See "Using Multiple Arm Mode" section for more information on multiple arm mode.

See "Setting Start Points" in the "Editing a Part Program" section for more information.


Insert/Remove Breakpoint

The Insert Breakpoint toolbar icon inserts a breakpoint at the current cursor location in the part program. See "Using Breakpoints" in the "Editing a Part Program"section for more information.


Remove All Breakpoints

The Remove All Breakpoint toolbar icon removes the breakpoint(s) found in the part program. See "Remove All" in the "Editing a Part Program" section for more information.


Insert Bookmark

The Insert Bookmark toolbar icon places a bookmark at the current cursor location in the part program. See "Toggle Bookmark" in the "Editing a Part Program" section for more information.


Next Bookmark

The Next Bookmark toolbar icon jumps your cursor to the next location that contains a bookmark in the part program. See "Next Bookmark" in the "Editing a Part Program" section for more information.


Clear All Bookmarks

The Clear Bookmark toolbar icon removes the bookmark(s) from the part program. See "Clear All Bookmarks" in the "Editing a Part Program" section for more information.


Summary Mode

The Summary Mode toolbar icon places the Edit window in summary mode. This mode provides you with an expandable and collapsible graphical summary of all features and commands in your part program. You can also do some limited editing. See "Working in Summary Mode" in the "Using the Edit Window" section.


Command Mode

The Command Mode toolbar icon places the Edit window in command mode. This mode allows you to access the various commands that give you the capability to edit various aspects of the part program. See "Working in Command Mode" in the "Using the Edit Window" section.


DMIS Mode

The DMIS Mode toolbar icon displays the Edit window commands in the DMIS format. This mode allows you to work using the DMIS syntax if desired. If you don't see this icon on your toolbar, select the Use Dmis Button in Edit window check box from the Setup Options dialog box, General tab. See "Setup Options: General tab" in the "Setting your Preferences" section.

  • For information on how DIMS commands (PC-DMIS's standard command format) translate into DMIS commands, see the document titled, PC-DMIS Support Documentation for DMIS available from ftp://wilcoxassoc.com/docs/dmis_support.zip.

  • For information on DMIS, see http://www.dmis.com.

See "Working in DMIS Mode" in the "Using the Edit Window" section.


Cut

The Cut toolbar icon allows you to cut text and objects in the Edit window, placing the cut information temporarily in the Clipboard. See "Cut" in the "Editing a Part Program" section for more information.


Copy

The Copy toolbar icon allows you to copy text and objects in the Edit window and place them temporarily in the Clipboard to be pasted later. See "Copy" in the "Editing a Part Program" section for more information.


Paste

The Paste toolbar icon will paste information being held in the Clipboard into the Edit window at the cursor's current location. See "Paste" in the "Editing a Part Program" section for more information.


Paste with Pattern

The Paste with Pattern toolbar icon will paste patterned features with their offsets into the part program at your cursor's current location. See "Editing Patterns of Features" in the "Editing a Part Program" section for more information.


Undo

The Undo toolbar icon removes the last action you took in the Edit window. See "Undo" in the "Editing a Part Program" section for more information.


Redo

The Redo toolbar icon will redo an action that was removed when using Undo. See "Redo" in the "Editing a Part Program" section for more information.


Print

The Print toolbar icon allows you to immediately send a report of the current contents of the Edit window to your default printer without displaying any dialog boxes.


Dimension Toolbar

Display Menu Roadmap

Dimension toolbar

With the Dimension toolbar use icons to quickly access the options available from the Dimension menu.

Icon | Description
 | Location
 | True Position
 | Distance
 | Angle Between
 | Concentricity
 | Coaxiality
 | Circularity
 | Cylindricity
 | Straightness
 | Flatness
 | Perpendicularity
 | Parallelism
 | Total Runout
 | Circular Runout
 | Surface Profile
 | Line Profile
 | Angularity
 | Symmetry
 | Keyin


Constructed Features Toolbar

Display Menu Roadmap

Constructed Features toolbar

With the Constructed Features toolbar use icons to quickly access the feature construction options available from the Constructed submenu.

Icon | Description
 | Point
 | Line
 | Plane
 | Circle
 | Ellipse
 | Slot
 | Curve
 | Cylinder
 | Cone
 | Sphere
 | Surface
 | Feature Set
 | Gauss Filter
 | Generic

For information on these items, see the "Constructing New Features from Existing Features" section and the "Creating Generic Features" section.

For information on inserting Read Points, view the documentation available in the "Creating Generic Features" section.


Auto Features Toolbar

Display Menu Roadmap

Auto Features toolbar

With the Auto Features toolbar you can easily access the same auto feature available on the various tabs of the Auto Features dialog box, or you can have PC-DMIS guess the feature type based in the hits taken.

PC-DMIS determines which auto feature items are enabled in the toolbar and in the menu depending on the type of probe you have enabled and your portlock settings. Unless you have a non-contact probe enabled, the Characteristic Point and the Flush and Gap icons will remain unavailable for selection.

When you click on an auto feature icon, the tab for that feature opens with the Auto Features dialog box.

To create the auto feature, press the END key or the Create button on the Auto Feature dialog box. Before creating your feature, you can remove hits from the hit buffer by pressing the ALT + '-' key combination.

Tip: Click the minimize button for the Auto Feature dialog box. This allows you to hide the Auto Features dialog box and still create the selected sheet metal feature.

More:

Guessing Auto Features


Guessing Auto Features

With the Guess icon, you can speed up generation of the part program. You'll notice that no dialog box appears; instead, while this icon is selected, PC-DMIS guesses the feature type based on hits taken. For the Guess operation to work:

  • You must have CAD surface data.

  • You must select the Surface Mode icon.

  • You must use a contact probe. Feature guessing with optical probes isn't supported.

Note: CAD wire frame data can be very useful, speeding up feature generation. For example, if you are only using surface data, PC-DMIS requires three hits to recognize a circle. However, if you're using wire frame data, PC-DMIS only requires one hit.

More:

Guessing by Feature Type


Guessing by Feature Type

The following table defines the number of hits to take and where to take them for PC-DMIS to recognize the given feature type while using the Guess icon:

Icon | Feature Type | Number of Hits for Guessing this Feature Type | Hit Locations for Guessing this Feature Type
 | Vector Point | One |
 | Surface Point | Two |
 | Edge Point | Wire & Surface: One | One hit near the edge.
 | Angle Point | Two | One hit on one surface and one hit on the other surface, which are not 90 degrees apart.
 | Characteristic Point | Guess mode doesn't work for this feature type.
 | Corner Point | Three | Once on each of the three surfaces.
 |  | Surface Only: Two | One hit on the top surface. One hit on the edge surface approximately 90 degrees from the top.
 | High Point | One |
 | Line | Guess mode doesn't work for this feature type.
 | Plane | Guess mode doesn't work for this feature type.
 | Circle | Wire & Surface: One | One hit on the top surface near the edge of the circle or arc.
 |  | Surface Only: Three | Three hits on the top surface near the edge of the circle or arc.
 | Ellipse | Five | Five hits around the ellipse.
 | Square Slot | Four | Four hits on the top surface near the edge of the slot.
 | Round Slot | Wire & Surface: Two | One hit on the top surface near the edge of arc and one hit near the opposite arc.
 |  | Surface Only: Six | Three hits on the top surface near edge of arc and three hits near the opposite arc.
 | Notch | Five | Two hits on the side opposite the opening of the notch. One hit on one parallel side of the notch. One hit on the other side. One hit on the open edge.
 | Polygon | Wire & Surface: One | Once hit on the inside or outside of s polygon's side.
 | Cylinder | Wire & Surface: Two | One hit on the top surface near the edge of circle or arc and one hit on the side of the cylinder.
 |  | Surface Only: Four | Three hits on the top surface near edge of circle or arc and one hit on the side of the cylinder.
 | Cone | Wire and Surface or Surface Only: Four | Three hits on the top surface near edge of circle or arc and one hit on the side of the cone. If PC-DMIS detects an angle greater than 2 degrees from the forth hit to the circle calculated from the first three hits, then it guesses a cone; otherwise it guesses a cylinder.
 | Sphere | Five | Five hits on the sphere surface.
 | Flush and Gap | Guess mode doesn't work for this feature type.
 |  | Wire Only: Two | One hit near the first circle or arc (first end of cone). One hit near the second circle or arc (other end of cone). PC-DMIS checks to see if circles are on top of each other. If so, it guesses a cone; otherwise it guesses a Round Slot.
 | Guess | Variable. See the beginning of this topic for information on this icon. |


Measured Features Toolbar

Display Menu Roadmap

Measured Features toolbar

With the Measured Features toolbar you can have PC-DMIS automatically guess and display the feature type for which you are taking hits; or you can force PC-DMIS to accept a given feature type.

More:

Automatically Guessing a Feature Type

Forcing a Given Feature Type


Automatically Guessing a Feature Type

If you select the Guess Mode icon, PC-DMIS will display an icon depicting what the feature type would be after each hit that you take. This allows you to visually preview the feature type before it's actually created.

For example, when measuring a cylinder, you will take two sets of four hits, at two different levels along the height of the pin. When you take four hits at one level PC-DMIS displays a Circle icon on the Graphics Display window as the feature type. After taking the second level of hits, PC-DMIS displays a Cylinder icon.


Forcing a Given Feature Type

The feature type icons on this toolbar allow you to force PC-DMIS to accept the selected feature type.

Icon | Description
 | Forces PC-DMIS to accept the Point feature type
 | Forces PC-DMIS to accept the Line feature type
 | Forces PC-DMIS to accept the Plane feature type
 | Forces PC-DMIS to accept the Circle feature type
 | Forces PC-DMIS to accept the Cylinder feature type
 | Forces PC-DMIS to accept the Cone feature type
 | Forces PC-DMIS to accept the Sphere feature type

If you take hits while in Guess Mode (using the Guess Mode icon) and PC-DMIS displays the wrong feature type, click the correct feature icon to force PC-DMIS to accept that feature. The feature will not be added to the part program until it's created by pressing the END key You can remove hits by pressing the '-' or ALT + '-' keys.

For example, if you select the Circle icon, PC-DMIS forces PC-DMIS to accept the circle feature type as long as you take the minimum number of hits.


File Operations

File Operations Toolbar

Display Menu Roadmap

File Operations toolbar

The File Operations toolbar allows you to quickly perform some of the most popular file operations. The toolbar includes the following icons.

Icon |  | Description
 | Open | Opens an existing part program
 | New | Creates a new part program
 | Close | Close the active part program
 | Quit | Quits PC-DMIS
 | Save | Saves the current part program
 | Save As | Saves the current part program under a different name

For complete information on these file operations, see the "Using Basic File Options" and "Using Advanced File Options" sections.


Macro Play/Record Toolbar

Display Menu Roadmap

Macro Play/Record toolbar

The Macro Play/Record toolbar allows you to record, play, and stop macros with the click of an icon. You can easily record and play custom created macros to perform routine, repetitive tasks.

In PC-DMIS, a macro is simply a recording of keystrokes and mouse movements that can be played back to automate a task.

Hint: You may want to use the Fixed Dialog Positions check box when working with Macros. This check box keeps all dialog boxes in fixed, set locations. See "Fixed Dialog Positions" in the "Setting your Preferences" section.

More:

To Record a Macro

To Play a Pre-Recorded Macro:


To Record a Macro:

  1. Select the Record icon. PC-DMIS will display a Record to Macro File dialog box.

Record to Macro File dialog box

  2. Create a file name in the File Name box using the *.mac extension.

  3. Click the Open button. The Record To Macro File dialog box will close and the Record icon will begin to flash. This indicates that PC-DMIS is recording keyboard and/or mouse inputs.

  4. Create the desired macro by recording key strokes and/or mouse inputs.

  5. Click the Stop icon [image] when finished.


To Play a Pre-Recorded Macro:

  1. Select the Play icon [image]. PC-DMIS will display the Play Macro File dialog box.

Play Macro File dialog box

  2. Navigate to the folder that contains the Macro File.

  3. Select the desired macro.

  4. Click the Open button.

The Play icon [image] will begin to flash indicating that PC-DMIS is playing the requested macro. You will see PC-DMIS using mouse and keyboard options to run the selected macro.


Virtual Keyboard Toolbar

Display Menu Roadmap

Virtual Keyboard toolbar

The View | Toolbars | Virtual Keyboard toolbar allows you to use and customize a virtual keyboard in place of a real keyboard. It functions as does any normal keyboard and can be used with a mouse or with a touch screen monitor. This is useful for certain shop floor environments where it's not convenient to use a physical keyboard.

Sample Virtual Keyboard – Keypad 1 Variation

The Virtual Keyboard toolbar icons are described here:

Icon

Description

This icon shows and hides the Virtual Keyboard. The Virtual Keyboard automatically appears, floating on top of PC-DMIS's main display. PC-DMIS also displays a program icon on your Windows Task Bar:

As with any other Windows program, selecting this program icon will give the Virtual Keyboard program focus.

This icon displays the Customize Keyboard dialog box which allows you to create your customized version of the Virtual Keyboard. See the "To Create a New Virtual Keyboard Variation" topic for more information.

The drop-down arrow to the right of the Customize icon displays a drop down list similar to the pop-up menu discussed in the "Accessing Virtual Keyboard Variations" topic.

Consult the "Using the Virtual Keyboard" topic in the "Using Other Windows, Editors, and Tools" section for additional information.


Touch Screen Mode Toolbar

Display Menu Roadmap

Touch Screen Mode toolbar

The Touch Screen Mode toolbar allows you to determine how touches on your touch-screen monitor are interpreted. This is useful for certain shop floor environments where it's not convenient to use a mouse.

The Left Click mode icon, the default selection, interprets touches on the monitor as a left button mouse click.

The right-click mode icon interprets the next touch on the monitor as a right button mouse click. After you perform your screen-touch, the mode automatically switches back to the Left Click mode.

For information on using the Touch Screen Mode toolbar, see the on-screen tutorials that came with your Brown and Sharpe "One" shop-floor machine.


Wizards Toolbar

Display Menu Roadmap

Wizards toolbar

The icons on this toolbar are initially bound to external wizards that come installed with PC-DMIS. These wizards serve two purposes:

  1. To increase the usability for new users who are still learning how to use the application.

  2. To demonstrate the flexibility and customizability of PC-DMIS.

These wizards are:

Icon

Description

3-2-1 Alignment Wizard – This wizard walks you through two basic types of alignments: a 3-2-1 alignment and a two circle alignment.

CAD Import Wizard – This wizard allows you to import single or multiple CAD models into the current part program. Simply click the icon and a dialog box appears. Select one or more files to import and then click Open.

Data Field Edit Wizard – This wizard lets you replace certain fields in the Edit window that you cannot replace using the Replace dialog box. See "Editing Data Fields" in the "Editing a Part Program" section.

DMIS Out Wizard – This wizard helps you export a DMIS output file of your inspection report.

Iterative Alignment Wizard – This wizard walks you through the steps to create an iterative alignment and explains the rules behind the inputs to the alignment

Multiple Execute Wizard – This wizard lets you easily loop your part program execution indefinitely, or a specified number of times. You can also choose the specific message to display between iterations.

PCD2Excel Wizard – This wizard exports your PC-DMIS part program data into a Microsoft Excel file of your choice. To configure the wizard's options, click Configure. Most of the configuration options in the resulting dialog box are self explanatory.

If the Use STAT/ON and STAT/OFF check box is selected, you must include dimension (or Feature Control Frame dimension) commands between the STATS/ON and STATS/OFF commands in your program, otherwise the wizard will not export data to the excel file. If you clear this check box, all dimension commands get exported into the excel file. See the "Tracking Statistical Data" section.

Also, if you select the Ignore FCFs check box, PC-DMIS does not pass Feature Control Frame commands to the excel file. See the "Using Feature Control Frames" section.

Important: Excel 2003 or later is required for this Wizard to function properly.

Running the Wizard Unattended

You can tell PC-DMIS to run the PCD2Excel wizard without any human intervention. After configuring the wizard, insert EXTERNALCOMMAND into your part program and add an 'A' parameter to the command so that it looks something like this:

EXTERNALCOMMAND/DISPLAY ; C:\Program Files\WAI\PC-DMIS V42\Wizards\PCD2EXCEL.EXE A

This tells the wizard to run in unattended mode.

Probe Wizard – This wizard demonstrates how to define a probe and allows you to calibrate the newly defined probe

Database Wizard – This wizard helps you to easily create and register ODBC databases. This only appears if your portlock was configured with the Integrated Stats option.

More:

Wizard Source Code Available


Wizard Source Code Available

These wizards were developed using Microsoft Visual Basic© and the automation capabilities of PC-DMIS. The source code and project files used to create them are included in the Wizards sub directory of the directory containing your PC-DMIS installation. Should you desire to extend the capability of PC-DMIS or create your own custom application that interfaces with PC-DMIS, you may use the source code provided as a guide to assist you. You can also enhance the wizards to perform other functions not included with the original application.


Portable Toolbar

Portable toolbar

The Portable toolbar contains several icons that allow you to access various frequently used functions and windows that are helpful when programming or measuring with portable devices. For information on working with portable machines, see the "PC-DMIS Portable" documentation.

The available toolbar icons are described in this table:

Icon |  | Description
 | Execute | Executes the measurement process for any currently marked feature(s). See "Execute" in the "Using Advanced File Options" section.
 | Execute Feature | Executes the selected feature. See "Execute Feature" in the "Using Advanced File Options" section.
 | Execute from Cursor | Executes the part program starting at the selected feature and then working down the Edit window. See "Execute From Cursor" in the "Using Advanced File Options" section.
 | Mark | Marks the selected feature with the specified mark color and prepares it for execution. See "Mark" in the "Editing a Part Program" section.
 | Mark All | Marks all features in the Edit window. See "Mark All" in the "Editing a Part Program" section.
 | Clear Marked | Removes all highlights from currently marked features within the Edit window. See "Clear All" in the "Editing a Part Program" section.
 | Edit Dialog | Accesses the dialog box associated with the currently selected command if one exists.
 | Import IGES Files | Begins the import operation for the IGES CAD file type (.igs or .iges). See "Importing an IGES File" in the "Using Advanced File Options" section.
 | Set Alignment | Links the CAD data to the measured data. See "CAD Equals Part" in the "Creating and Using Alignments" section.
 | Leap Frog Alignment | Performs a Leapfrog operation. See "Performing a Leapfrog Operation" in the "Creating and Using Alignments" section.
 | Curve Mode | Places PC-DMIS into Curve mode (for use with wire-frame). See "Switching Between Curve and Surface Modes" in the "Editing the CAD Display" section.
 | Surface Mode | Places PC-DMIS into Surface mode (for use with surface data). See "Switching Between Curve and Surface Modes" in the "Editing the CAD Display" section.
 | Scale to Fit | Enlarges or shrinks the views of the graphic in the Graphics Display window to fit your screen. See "Scaling the Drawing" in the "Editing the CAD Display" section.
 | Translate Mode | Places PC-DMIS into translate mode. See "Translate Mode" in the "Editing the CAD Display" section.
 | 3D Rotate Mode | Three dimensionally rotates the part for the selected view. See "3D Rotate Mode" in the "Editing the CAD Display"
 | Program Mode | Uses the probe either in offline or online mode to learn and edit your part program. See "Program Mode" in the "Editing the CAD Display" section.
 | Virtual Keyboard | Displays a Virtual Keyboard. See "Using the Virtual Keyboard" in the "Using Other Windows, Editors, and Tools" section.
 | Probe Readouts | Displays or hides the Probe Readout window. See "Using the Probe Readout Window" in the "Using Other Windows, Editors, and Tools" section.
 | Large Status Window | Displays or hides the Status window. See "Using the Status Window" in the "Using Other Windows, Editors, and Tools" section.
 | Report Window | Displays or hides the Report window. See "About the Report Window" in the "Reporting Measurement Results" section.


Active Arms Toolbar

Display Menu Roadmap

Active Arms toolbar

The Active Arms toolbar contains icons depicting multiple arms. The Arm 1 Active icon (toolbar button with the number one) corresponds to the 'Master' arm. The Arm 2 Active icon indicates the 'Slave' arm. Only one arm can be active at a time. The selected icon is considered active.

You can also execute commands tied to a specific arm by clicking the colored check mark icon that corresponds to the active arm.

Currently, the Active Arms toolbar will only be available for selection if the Multiple Arm mode add-on package has been purchased for your system.

You can also display this toolbar by accessing the Operation | Enter Multiple Arm Mode menu option.

See the "Using Multiple Arm Mode" section for more information on setting up and using multiple arm CMMs. Also, see the "Assigning a Command to an Arm" topic from that section for additional information on using this toolbar.


Active Rotary Table Toolbar

Display Menu Roadmap

Active Rotary Table toolbar

The Active Rotary Table toolbar allows you to select which of the two rotary tables is the active table. Selection for this toolbar remains unavailable until you set up the rotary tables using the Edit | Preferences | Rotary Table Setup menu option. See "Defining the Rotary Table" in the "Setting Your Preferences" section for more information.


Window Layouts Toolbar

Display Menu Roadmap

Window Layouts toolbar

The Window Layouts toolbar allows you to store the layout of the any open windows, editors, and toolbars, and then restore them in your current part program by clicking on an icon.

Important: Be aware that layouts don't only store positions of toolbars and windows, but they also store settings and options associated with the windows and toolbars. If a layout has a certain setting selected, and you then save that layout, the setting gets saved with the layout. If you later deselect that window setting, without overwriting the stored layout, the next time you select the layout, PC-DMIS will restore the saved setting.

The Minimize icon minimizes the Edit window’s size

The Maximize icon maximizes the Edit window’s size.

The Save icon displays the Enter Window Layout Name dialog box that allows you to save the current position and size of any open windows, editors, or toolbars under a desired layout name:

The Window Layout Name box allows you to specify the name of the layout. PC-DMIS also displays this name as a ToolTip for the icon associated with the layout. If you don't include a layout name, PC-DMIS uses a default name of "Recall Window Layout".

Once you click OK, the layout gets saved and an icon representing that layout appears on the toolbar with your layout configuration.

You cannot overwrite an existing layout with a new layout by giving it the same name. If you want to overwrite an existing layout, first delete the existing layout, and then give it the same name.

The restore saved layout icon restores the stored layout. Any windows, editors, and toolbars are restored to their saved positions. Hovering your mouse over the icon shows the name of the stored layout.

Note: If you have multiple part programs open and have created a stored layout using one of the part programs, precedence is given to the part program on which the layout was created. The part program used to create the stored layout then becomes the active part program and displays the stored window layout.

More:

Deleting Saved User Layouts


Deleting Saved User Layouts

To delete a saved user layout:

  1. Right-click on the toolbar area, and select Customize. The Customize dialog box appears.

  2. Press and hold the SHIFT key.

  3. Click and hold the mouse over the icon on the Window Layouts toolbar. The icon becomes movable.

  4. Drag the icon outside of the toolbar's boundaries.

  5. Release the mouse button.

The icon and the layout associated with the icon are deleted.


Defining Hardware

Defining Hardware: Introduction

Defining Probes

Defining Machines

Inserting Quick Fixtures

Defining Probe Changers

Working with Rotary Tables


Defining Hardware: Introduction

This section describes all of the options associated with defining the hardware used to measure parts. These include the creation and calibration of your probe with its probe tips; the creation and use of a virtual machine, the creation, positioning, and use of quick fixtures; the calibration of probe changers and the creation animated probe changers; and information on working with rotary tables.

These are discussed in the following topics:

  • Defining Probes

  • Defining Machines

  • Inserting Quick Fixtures

  • Defining Probe Changers

  • Working with Rotary Tables


Defining Probes

One of the first steps in part programming is to define which probes will be used during the inspection process. Because probe definition and calibration processes are often different, depending on your specific configuration of PC-DMIS, this information is instead covered in the documentation set for your configuration. Consult the appropriate documentation set below for information on setting up, calibrating, and using an appropriate probe for your specific situation:

  • PC-DMIS CMM

  • PC-DMIS Vision

  • PC-DMIS Laser

  • PC-DMIS Portable

Defining probes uses the Probe Utilities dialog box.

Hint: Click this icon from the Wizards toolbar [image] to access the PC-DMIS's Probe Wizard.

More:

Understanding the Probe Utilities dialog box

Migrating Part Programs Between Machines Using PH10 and Tesa Start M Probes


 Probe File list Use Wrist Map If Available checkbox User Defned Calibration Order checkbox Active Tip List Probe Description OK button Cancel button Measure Tips Edit the Active Tip Define Collision Tolerance Probe Setup Print List Delete button Previewing Your Probe Configuration Add New Angles Results Mark Used Global Used File Format Use Unit Calibration Data

Understanding the Probe Utilities dialog box

Display Menu Roadmap

Select Insert | Hardware Definition | Probe... The Probe Utilities dialog box displays probe data for the active tip. It allows you to create new probe files, access previously defined files, and edit a probe file as needed. This option also allows you to calibrate probes.

Probe Utilities dialog box

More:

Probe File Name

Use Wrist Map If Available check box

Use Partial Calibration

Use TRAX Calibration

User Defined Calibration Order check box

Active Tip List

Probe Description

Measure

Add Tool

Edit Tool

Delete Tool

List of Available Tools

Edit

Add Angles

Results

Mark Used

Global Used

File Format

Use Unit Calibration Data

Available Tip Types

Collision Tolerance

Probe Setup

Print List

AutoCalibrate Probe


Probe File Name

The Probe File drop-down list displays the current probe file. Probe files are stored in the directory where PC-DMIS was installed. The default directory is the file name and directory in which you installed PC-DMIS (usually "PCDMISW" on the local "C:\" drive). When PC-DMIS searches for a probe file to load, it will search in this directory unless you've changed the search path. See "Specifying External Directories to Search" in the "Setting your Preferences" section of the PC-DMIS Core documentation for more information.

To create a new Probe File,

  1. Highlight the current name in the Probe File drop-down list.

  2. Type in a new name.

If a probe file has already been saved under the keyed in name, PC-DMIS will load the previously saved file into the current part program.


Use Wrist Map If Available check box

The Use Wrist Map If Available check box determines whether or not PC-DMIS uses a wrist map (also known as an "error map ") file when calibrating AB angle tips on probe configurations that use an indexable wrist. If you select this check box, PC-DMIS will search for the wrist map file (a file named abcomp.dat) on your computer, and if found, will compensate for the wrist's error data when calibrating the AB angle tips.

For information on creating the wrist map file, see the "Calculate Error Map" topic from the "Using a Wrist Device" section.


Use Partial Calibration

Use Partial Calibration check box

When using the Renishaw scan-based method to calibrate a Renishaw analog probe (such as the SP25, SP600, or SP80), the first time it's calibrated using the Scan method must be the full calibration that runs the whole series of scans. After this full calibration, you can choose a more simplified calibration if desired.

  • Full calibration calculates all the analog probing coefficients in addition to the tip offset and tip size.

  • Partial (simplified) calibration works just like a non-analog probe calibration: it consists of discrete hits (no scans) and only calculates the tip offset and tip size; the analog probing coefficients remain unchanged.

To perform the simplified calibration,

  1. Access the Probe Utilities dialog box.

  2. Load a Renishaw analog probe from the Probe File list.

  3. Select the Use Partial Calibration check box. This remains disabled for probes that do not apply.

  4. Select one or more already calibrated probe tips from Active Tips List.

  5. Click the Measure button. The Measure dialog box appears.

  6. Make changes as needed on the Measure dialog box. If you define any named parameter sets PC-DMIS will store the state of the Use Partial Calibration check box in the set for future use.

  7. Click Measure. Follow any on-screen prompts. PC-DMIS will perform the simplified calibration.

Note: A registry entry in the ProbeCal section called ProbeUsePartialCalibration stores the default for whether or not this check box is selected when you define a new probe file.


Use TRAX Calibration

When calibrating an analog probe on some machine types, particularly when using the Leitz interface, there is typically a choice of whether or not to use the TRAX calibration algorithm for calculating the calibration coefficients. You can choose which calibration algorithm is used by selecting or clearing the Use TRAX Calibration check box.

  • If you select this check box, PC-DMIS uses the TRAX calibration algorithm.

  • If you clear this check box, PC-DMIS uses the PMM calibration algorithm.

This check box does not change the actual calibration process in any way; instead, it defines to the math algorithm used to process the data after the discrete hit-based analog probe calibration process finishes.

Note: If you need to know when to switch calibration algorithms, you should consult with the creators of your particular machine. They can recommend the best practice for their particular machine for a particular situation.


User Defined Calibration Order check box

The User Defined Calibration Order check box allows you to determine the order PC-DMIS takes to measure selected tips.

If you select this check box, PC-DMIS will measure the tips in the order defined by the user when marking the tips for calibration in the Active Tip List. (See "Active Tip List") If no tips are chosen, PC-DMIS will use the I, J, K vectors defined in the Search I, J, K boxes in the Edit Tool or Add Tool dialog boxes to determine the most efficient order to measure all the tips.

If you do not select this check box, PC-DMIS will measure the tips in an order that it determines to be the most efficient. When this happens, PC-DMIS ignores the order that was given to selected tips in the Active Tip List. PC-DMIS will also use the calibration tool vector to determine the most efficient order to measure.


active tip list

 Tip ID Tip Rotation Tip Type XYZ Center Diameter and Thickness IJK Vector Calibration Date and Time Noncalibrated Tip

This is the permanent number that PC-DMIS assigns to a tip when it is loaded into memory.

This field displays the rotation of the tip in the vertical (A) and horizontal (B) direction

This field displays the probe type (BALL, DISK, TAPER, SHANK, OPTICAL).

These values describe the location of the tip. This location is in relation to the bottom of the Z rail.

These values describe the direction of the probe tip. This vector goes from the center of the probe tip towards the Z rail.

These values describe the diameter of the tip and the thickness of SHANK and DISK probes. PC-DMIS defines these values when the probe is loaded. (To change a field see "Edit Tool".)

These boxes indicate the most recent date and time the probe tip was calibrated. If a new tip is created without being calibrated, PC-DMIS will display "NEW" for the date and time values. If an old probe tip is loaded and the date and time information is unavailable, PC-DMIS will display "UNKNOWN" for the values. Only probe tips that are actually calibrated have their time and date values updated.

Only one tip may be edited at a time.

An asterisk (*) to the left of the tip identifies any noncalibrated tips.

Active Tip List

PC-DMIS allows you to store data describing a large number of probe tips. This data includes the probe tip's ID, rotation, type, location, direction, diameter and thickness, date and time of calibration, and any noncalibrated tips. These are all stored inside the Active Tip List.

Active Tip List

There can be as many as 32767 probe tips stored. This number may be limited by the amount of disk space available on your system.

PC-DMIS describes a probe according to the following criteria:

1. TIP ID#

2. Tip Rotation

3. Tip Type

4. X,Y,Z Location

5. I,J,K Direction

6. Diameter and Thickness

7. Date and Time

* (asterisk) - Noncalibrated Tip

Tip List Description

Adding Tips to the List

You can define new tips, adding them to the list, by using the Add Angles button. See the "Add Angles" topic.

Editing Tip Data

  1. Highlight the desired active tip in the Active Tip List.

  2. Press the Edit button.

An Edit dialog box will appear, allowing you to change the displayed values.

Note: noncalibrated tips have an asterisk before their Tip ID # in the Active Tip List.

Setting the Calibration Order

The calibration order is determined by the order in which the tips are chosen from the list box.

To set the calibration order:

  1. Select the User Defined option in the Measure Probe dialog box (See the "Measure" topic).

  2. Hold down the CTRL key.

  3. With your left mouse button, select the tips from the Active Tip List for calibration. A number representing the index of the tip measurement order appears next to each Tip ID as it is selected.

If no tips are chosen, PC-DMIS will ask you if you want to measure all tips.

Selecting a Tip to Use

You can define a specific probe tip to use in your part program in these ways:

  • Typing TIP in the Edit window's Command mode and pressing TAB.

  • Selecting the probe tip from the list on the Settings toolbar.

The Edit window command line for a sample tip would read:
TIP/T1A0B0, SHANKIJK=0, 0, 1, ANGLE=0

Until PC-DMIS encounters another TIP command in the program flow, it will use that tip.


Probe Description

Probe Description area

The Probe Description area (consisting of the drop-down list and subsequent box) allows you to define the probe, extensions and tip (s) that will be used in the part program. The Probe Description drop-down list displays the available probe options in alphabetical order.

More:

Edit Probe Components

Previewing your Probe Configuration


Edit Probe Components

Double-clicking on a line within the Probe Description area will access the Edit Probe Component dialog box.

Edit Probe Component dialog box

This option allows you to remove specific portions of the probe graphics from display and define a rotation angle about the connection. In cases where the part geometry is particularly dense, selecting this option allows you to temporarily remove some of the graphics providing a better view of the features.

To remove probe graphics:

  1. Double-click on the specific feature description (in the Probe Description box) that needs to be removed from view. PC-DMIS will display the Edit Probe Component dialog box.

  2. Clear the Draw this component check box.

  3. Click the OK button. The Edit Probe Component dialog box closes. Notice that PC-DMIS redraws the probe graphics without the indicated component and all other components above it in the Probe Utilities dialog box.

To change the rotation angle about the connection, type a value in the Default rotation angle about connection box. This is primarily used to manually define the angle of knuckle attachments. Type in the desired angle (any angle from +180° to -180°) and click OK. 0 is the default angle.


Previewing your Probe Configuration

Graphical view of a probe and sliders

The graphical view of the Probe Utilities dialog box provides you with the ability to preview graphically:

  • The components comprising your probe.

  • The various AB angle positions in the Active Tip List box.

  • A complete 3D rotation of the probe.

Viewing Components: Once selected as a part of the probe, a component of the probe’s configuration automatically appears in the graphical view of the Probe Utilities dialog box.

Viewing AB Angle Positions: Select an AB angle position from the Active Tip List and the graphical view of the probe dynamically changes to match what the current probe configuration would look like using the selected AB angle.

Rotating the Probe in 3D: Move the sliders located below and to the left of the probe’s graphical view to rotate the view of the probe. The slider below rotates the probe horizontally. The slider to the left rotates the probe vertically.

Horizontal Slider – Rotates display horizontally.

Vertical Slider – Rotates display vertically


Add Tool

The Add Tool button displays the Add Tool dialog box.

Add Tool dialog box

This dialog box allows you to store data describing the qualification tools. Each tool is assigned a sequential ID number. Along with the ID#, PC-DMIS displays the tool type (SPHERE, POLYHEDRAL or RING), the tool offset, shank vector, override vector, the diameter (for SPHERE) or length (for POLYHEDRAL).

Once you define a new tool, it will appear in the List of Available Tools drop-down list located in the Measure Probe dialog box.

At least one probe tip must be defined in the Active Tip List before measuring a tool.

To add a tool to the List of Available Tools drop-down list, click on the Add Tool button. The Add Tool dialog box appears, allowing you to edit any necessary information:

The Add Tool dialog box, gives you access to the same information used when you create a new tool. You can change the Tool ID, the Tool Type, the Offset values, the Shank Vector IJK, and the Diameter / Length of the tool.

More:

Tool ID

Tool Type

Offset X, Y, Z

Shank Vector I, J, K

Search Override I, J, K

Diameter / Length


Tool ID

This box allows you to name the tool you are defining.


Tool Type

This list lets you define the type of calibration tool you will use. Some items are available for selection only if you use a specific probing system:

  • SPHERE

  • SLAVESPHERE

  • POLYHEDRAL

  • SLAVEPOLYHEDRAL

  • RING

  • SLAVERING

Calibrating with Ring Tools

Ring Tools are only used with Vision probing systems. See the PC-DMIS Vision documentation for information on how to calibrate using this tool.


Offset X, Y, Z

These X, Y, and Z values give the location of the Calibration Tool in machine coordinates

To re-calibrate a tip, simply highlight the desired tip in the Active Tip list. Proceed to calibrate the probe tip using the Measure button. (See "Previewing your Probe Configuration".)


Shank Vector I, J, K

This box displays the vector of the shaft on the tool. PC-DMIS uses these values during calibration to avoid the shaft.

Item A depicts the shaft on a spherical tool


Search Override I, J, K

These boxes allow you to specify a vector used by PC-DMIS to determine the most efficient order to measure all the tips when you select the User Defined Calibration Order check box in the Probe Utilities dialog box. See "Calibration Order".


Diameter / Length

This box displays the diameter / length of a sphere tool.

To change this value:

  1. Select the Diameter / Length box.

  2. Enter in a new value.


Measure

The Measure command button allows you to calibrate probe tips selected from the Active Tips area of the Probe Utilities dialog box. See "Calibrating Probe Tips" for information on how to do this.


Edit Tool

The Edit Tool command button allows you to edit a tool that already exists in the "List of Available Tools". Simply click the Edit Tool button and this Edit Tool dialog box will appear:

Edit Tool dialog box

The Edit Tool dialog box has the same options as the Add Tool dialog box.


Delete Tool

The Delete Tool command button allows you to remove a tool that is no longer needed in the List of Available Tools drop-down list.

To remove a tool:

  1. Select the desired Tool ID.

  2. Click the Delete Tool button.


List of Available Tools

The List of Available Tools drop-down list displays the available tools, allowing you to specify which tool will be used in calibrating the probe. PC-DMIS only uses spherical tools.

More:

Spherical Tool and Ball Tip

Spherical Tool and Disk Tip

Spherical Tool and Taper Tip

Spherical Tool and Barrel/Shank Tip

Spherical Tool and Optical Tip


Spherical Tool and Ball Tip

PC-DMIS prompts you to enter the number of hits to be taken on the tool and then asks you to take the hits.


Spherical Tool and Disk Tip

If Mode = MANUAL, PC-DMIS will prompt you to take six hits on the calibration tool. Take three hits above the equator of the sphere and three below the equator.

If Mode = DCC, the location of the calibration tool must previously be known.


Spherical Tool and Taper Tip

PC-DMIS will prompt you to take six hits on the sphere with the tapered part of the probe. The spherical tool is, in effect, being used as the probe to measure the taper tip as a cone. The first three hits need to form a plane that is approximately perpendicular to the cone centerline. If a small taper probe is being used, it is best to use a small spherical tool to perform this operation.


Spherical Tool and Barrel/Shank Tip

PC-DMIS will prompt you to take four hits in a planar cross section of the sphere to form a circle. The hits must be made with the same part of the probe that will be used for inspection. When the four hits have been taken, PC-DMIS will prompt you to touch the sphere once with the bottom surface of the probe.


Spherical Tool and Optical Tip

This option is only available if the optical tip is defined as a hard probe.


Edit

Any active tip can be updated by simply highlighting the desired tip in the Active Tip List and selecting the Edit button. The Edit Probe Data dialog box will appear.

Edit Probe Data dialog box

You can make changes to the following information:

More:

TIP ID

DMIS Label

X, Y, and Z Center

Shank / Optical Vector I, J, K

Diameter of the ball tip

Thickness of the ball tip

PrbRdv

Calibration Date and Time

Nickname

To delete a tip from the Active Tip list:

To delete a wrist angle:


tip id1

TIP ID

This box contains the permanent number that PC-DMIS assigns to a tip when it is loaded into memory. You cannot edit this value. It is shown for display purposes only; however, you can define a more descriptive identification by using the Nickname box.


DMIS Label

This box displays the DMIS label. When importing DMIS files, PC-DMIS uses this value to identify any SNSDEF statement inside the imported DMIS file.


X, Y, and Z Center

These values describe the location of the tip. This location is in relation to the bottom of the Z rail.


Shank / Optical Vector I, J, K

These values describe the direction of the probe tip shank if you're using a probe tip. This vector goes from the center of the probe tip towards the Z rail. If you're using an optical probe, these values describe the direction of the optical device.


Diameter of the ball tip

This box contains diameter of the tip.


Thickness of the ball tip

This box contains the thickness of the tip. It defines the useable and graphical height/thickness of the ruby tip. PC-DMIS applies this value during the disk probe calibration procedure to move the probe north or south of the equator. In the case of a disk probe, for example, you might need to adjust this value down to make the probe qualify better.


PrbRdv

The PrbRdv box on the Edit Probe Data dialog box allows you to set a radial deviation for the calibrated size of the tip.

When you execute the probe calibration, PC-DMIS does one of two things:

  1. If you have a machine configuration where PrbRdv applies, the calibration process automatically sets the tip size to the theoretical value, calculates, and then saves a PrbRdv value.

  2. If your have a machine where PrbRdv does not apply, the calibration automatically sets the PrbRdv value to zero, calculates and then saves a tip size slightly different from the theoretical value.

The Edit Probe Data dialog box merely allows you to edit the tip size and/or PrbRdv if needed for some reason after calibration. If you re-calibrate, the resulting values will come from the calibration, not from whatever may have been manually entered into this dialog box prior to calibrating.

Note: This box is only available for selection if you use an analog probe on certain machines.


Calibration Date and Time

These values indicate the most recent date and time the probe tip was calibrated. These values are available for viewing in the Edit Probe Data dialog box. If a new tip is created without being calibrated, PC-DMIS will display NEW for the date and time values. If an old probe tip is loaded and the date and time information is unavailable, PC-DMIS will display UNKNOWN for the values. Only probe tips that are actually calibrated have their time and data values updated.


Nickname

The Nickname box on the Edit Probe Data dialog box lets you give a more descriptive name to the selected probe Tip ID. For example, if you named your probe tip, "MyTip" in the Nickname box, PC-DMIS would then use "MyTip" in the user interface for that probe tip in dialog boxes, messages, on reports, etc. If you don't define an ID, PC-DMIS will use the default generated Tip ID instead.


to delete a tip from the active tip list

To delete a tip from the Active Tip List:

  1. Select the item to be removed.

  2. Select the Delete button.

If there is only one tip highlighted, PC-DMIS will automatically delete it. Multiple items can be deleted if they are all highlighted when the Delete button is selected.

PC-DMIS also allows specific PH9 angles to be removed from the Active Tip List.


to delete a wrist angle

To delete a wrist angle:

  1. Select the angle to be removed.

  2. Select the Delete button.

If a tip or probe head is deleted, all related PH9 angles will also be deleted from the file.

Note: This option will delete the tip from the Active Tip List and remove it from the file of tips known to the system


Add Angles

When the Add Angles button is selected the Add Angles dialog box appears.

Add New Angles dialog box

Using the boxes and buttons available, PC-DMIS allows you to create a list of AB positions. Once a position has been calibrated it can be recalled at any time during any part program. Therefore, by calibrating frequently used positions, they can be recalled at will while learning or manually inspecting a part program.

AB positions are stored in part coordinates. Therefore, during Execute Mode, PC-DMIS will automatically find the closest calibrated AB position appropriate to the orientation of the part on the machine. The Automatically Adjust Probe Head Wrist check box (See "Automatically Adjust Probe Head Wrist" in the "Setting your Preferences" section of the PC-DMIS Core documentation) must be selected in order for the AB positions to be available. The Edit window must also reflect a probe change command prior to the feature.

Since the mechanical positioning of the probe will change over time, it is recommended that the probe be periodically re-calibrated. When the Add Angles button is selected, PC-DMIS displays the Add New Angles dialog box.

This dialog box allows you to specify singular AB orientations. PC-DMIS will also create a list of equally spaced AB orientations using the parameters specified in the boxes of the Equally Spaced Angles Data area.

The Add Angles dialog box provides the following parameters.

More:

New Angles List box

Individual Angle Data

Equally Spaced Angles Data

Working with the Angle Grid

Notes on the Add Angle option


New Angles List_box

The New Angles List box contains a listing of AB angles from either the Individual Angle Data area or Equally Spaced Angles Data area.


Individual Angle Data

The Individual Angle Data area allows you to add AB positions one at a time into the New Angles List box.

To add individual angles:

  1. Place your cursor in the box(es) you want to change

  2. Enter in a new angle.

  3. Click the Add Angles button.

The individual angle you specified will appear in the New Angles List box.


Equally Spaced Angles Data

The Add Angles button associated with these boxes automatically marks all of the requested equally spaced AB positions in the New Angles List box. The default position for the probe configuration is automatically included in the final list. A PH9 pointing straight down (A=0°, B=any°) is automatically defined and therefore doesn't need to be re-defined in this dialog box.

PC-DMIS easily allows you to measure all the AB positions from 0° to 90° in the A axis with 15° increments and from -180° to 180° in the B axis with 45° increments.

A axis angle range¾Front view of CMM with B = 90°.

B axis angle range¾top view with A = 90°

1 - Front

2 - B Axis

To add angles to the New Angles List box:

  1. Enter the necessary information in each available angle box (Starting A, Ending A, Increment in A, Starting B, Ending B, Increment in B).

  2. Click the Add Angles button and PC-DMIS will automatically display the requested AB orientations, in the New Angles List box.

AB orientations displayed in the New Angles List box


Working with the Angle Grid

PC-DMIS allows you to view and select angles for the defined wrist by using an angle grid from the Add New Angles dialog box. The angle grid displays all available A-angle positions down the side of the dialog box and the B-angle positions along the top of the dialog box.

A portion of the Add New Angles dialog box showing previously selected AB angles (dark grey) and AB angles inserted before the Add New Angles dialog box is closed (red)

To add new angles by clicking on the grid,

  1. Find the row of the A-angle you want to add. Then find the column with the appropriate B-angle.

  2. Click the box in the grid where the desired A and B angles intersect. The selected box turns red, and the selected AB angle positions are inserted into the New Angles list box.

To clear a selected AB angle position, simply click one of the red boxes again, PC-DMIS removes the AB angle positions associated with that box from the New Angles list box.

Understanding the Grid Colors

There are four possible grid box colors that you may see when working with the angle grid: dark grey, red, yellow, and green. Probe heads that have enough grid blocks to show the complete range of the probe head's angular adjustment, will only show angle grid boxes in dark grey or red. However, if you're using a wrist device (such as a PHS or CW43L) you may have angles with increments that exceed the number of angle increments used in the angle grid. In these cases PC-DMIS colors the closest matching angle grid location in green or yellow.

Color | Description
Dark Grey | A dark grey grid box indicates that the AB angle position already exists in the Active Tip list of the Probe Utilities dialog box. The AB angle perfectly matches the grid box's angle.
Red | A red grid box indicates that you have specified a new AB angle position using the Add Angles dialog box, but the angle hasn't yet been added to the Active Tip list. The AB angle perfectly matches the grid box's angle.
Yellow | A yellow grid box indicates that the AB angle position already exists in the Active Tip list of the Probe Utilities dialog box and that PC-DMIS chose the closest matching grid location for the AB angle.
Green | A green grid box indicates that you have specified a new AB angle position using the Add Angles dialog box, but the angle hasn't yet been added to the Active Tip list. PC-DMIS chooses the closest matching grid location for the AB angle.


Notes on the Add Angle option

  • Automatic probe calibration can only be done using a spherical probe and spherical qualification tool.

  • The X, Y, and Z coordinate of the center of the tool that is being used must reflect the current position of the tool on the table. If this is not the case, the response should be YES to the question "Has probe position moved?"

  • When measuring AB positions under operator control, PC-DMIS will automatically rotate the probe head to the next manual position when the current position is completed. Please be sure the probe clears the tool before pressing the END key.

  • If the calibration tool position has changed or new angles need to be appended to the list of tips, mark the needed angles in the New Angles List box. The default position of the probe tip (normal to the shaft of the tool) must also be marked. PC-DMIS will first execute the angle that is normal to the tool, and then execute the other marked angles.

  • If the automatic AB calibration is stopped before it has finished measuring all the appended positions, PC-DMIS will ask you if you want to keep the partial calibrated data before quitting.


Results

The Results button displays the results of the most recent probe calibration in the Calibration Results dialog box.

Results dialog box

In addition to displaying the probe's diameter and thickness, the dialog box also provides the actual angle and roundness of the sphere. These measured results let you verify the accuracy of the calibration.

In version 3.7 and above, PC-DMIS shows results up to six decimal places.


Mark Used

This option will automatically search the current part program for AB angles. PC-DMIS then adds any AB angles that are found to the current probe configuration.

Note: Be aware that if you select the Automatically Adjust Probe Head Wrist option (found in the General tab in the Setup dialog box) and click the Mark Used button, PC-DMIS may not select all the probe tips for calibration (see the "Automatically Adjust Probe Head Wrist" topic in the "Setting your Preferences" section).


Global Used

The Global Used button searches for tips used in other part programs by the currently active probe file. It then adds them to the Active Tip List and marks them for calibration.

By default, this button searches through any part program sub directories. You can control whether or not this searches sub directories of the defined search directory by using the ProbeGlobalUsedIsRecursive registry entry described in the "Modifying Registry Entries" section.


File Format

The File Format button saves the existing probe file into a format compatible with previous versions of PC-DMIS. When you click the File Format button, the Convert Probe File Format dialog box appears.

Convert Probe File Format dialog box

The dialog box contains these two items:

· Current Version box – This lists the current version of PC-DMIS.

· Version for Saving list – This contains the probe file format types you can save the probe file as.


Use Unit Calibration Data

The Use Unit Calib Data check box only appears on the dialog box if you have already performed a unit calibration. If this check box is not selected, PC-DMIS will use the standard calibration. Selecting this check box allows you to use the unit calibration data. See "Calibrate the Unit" in the "Calibrating Probe Tips" topic for additional information.


Available Tip Types

PC-DMIS provides the following types of tips in the Probe Description drop-down list:

If a tip needs to be added to the list of available tips, please contact your PC-DMIS software support representative. Only authorized personnel are allowed to create additional tip files.

More:

Ball

Disk

Optical

Shank


Ball

This defines a spherical probe. The user is able to edit the nominal diameter and thickness of the probe using the Edit button. The direction of the probe must also be defined.


Disk

This defines a disk probe. The user is able to edit the nominal diameter and thickness of the probe using the Edit button. The direction of the probe must also be defined.


Optical

This option is only available if the optical tip is defined as a hard probe.

This option defines an optical probe. The user is able to edit the nominal diameter of the probe using the Edit button. The direction of the probe must also be defined.


Shank

This defines a shank or barrel probe. The user is able to edit the nominal diameter and thickness of the probe using the Edit button. The direction of the probe must also be defined.


Collision Tolerance

The CD module in Avail/NT will not work unless there is an OPENGL (shaded) view on the screen.

Collision Detection (CD) in PC-DMIS is designed to detect collisions between the probe and CAD surfaces.

Collision tolerances are specified in the Collision Tolerances dialog box. This option can be accessed by clicking on the Tolerances button in the Probe Utilities dialog box.

Collision Tolerances dialog box

See "Detecting Collisions” in the "Editing the CAD Display" section for additional documentation regarding the Collision Detection option.

More:

Specifying Collision Tolerances


Specifying Collision Tolerances

Collision tolerances are specified in the Collision Tolerance dialog box. This dialog box can be activated by clicking the Tolerances button in the Probe Utilities dialog box.

In the edit box you can specify a positive or negative value for each probe component selected from the drop-down list. This effectively changes the size of that component.

  • A positive number will increase the size of the component so a collision will be detected if that component comes within the specified distance of the part.

  • A negative distance decreases the size of that portion of the probe, having the opposite effect of a positive distance.

You can also choose to ignore a probe component by selecting the Ignore check box. PC-DMIS will then ignore that probe component when checking for collisions. This may be useful with a tip, where collisions are expected to occur when taking hits.

Once you start collision detection by selecting the Collision Detection menu option, PC-DMIS's internal CAD engine performs all the calculations required to detect a collision. Any collisions detected are displayed in the Collision Detection dialog box. This dialog box reports the results in the Probe Display window of the dialog box, and saves them for later use in drawing the Edit Path lines.

See "Detecting Collisions" in the "Editing the CAD Display" section in the PC-DMIS Core documentation for additional documentation regarding the Collision Detection option.


Probe Setup

The Setup button on the Probe Utilities dialog box displays the Probe Setup dialog box.

Probe Setup dialog box

This dialog box allows you to further customize your probe settings. Using the options in this dialog box you can change or select the following information:

  • Give a warning when using tips that have not been calibrated in x days.
    Where x is the number of days.

  • Give a warning when using tips that were not all calibrated within x hours of each other.
    Where x is the number of hours.

  • Clearance distance along the qualification tool shank vector: x
    Where x is the clearance distance

  • Clearance distance along the qualification tool shank vector for continuous wrist probes: x
    Where x is the clearance distance

  • Clearance distance in Z when qualification tool shank is perpendicular to the Z axis : x
    Where x is the clearance distance

  • Give a warning during qualification when the standard deviation of the sphere is more than: x
    Where x is the standard deviation

  • Give a warning when the diameter error for the probe tip is more than: x.
    Where x is the diameter error

  • Don't ask operator for currently loaded probe file when using a probe changer.
    Currently loaded probe file: file
    Where file is the appropriate probe file

  • Append the calibration results to the results file.

  • Probe File Used with Probe Changer to Force Unload Only: file
    Where file is a dummy probe file
    This is used to force an unload of the current probe without loading a new probe from the probe changer. See the "To Drop off a Probe without Picking up a New Probe" topic in the "Setting Your Preferences" chaptersection.

Click OK to accept your changes.


Print List

The Print List button displays the Print dialog box. If you then click the OK button, PC-DMIS prints a list of calibrated and non-calibrated tip angles in a table. These are the same tip angles listed in the Active Tip List. Each row of the table contains a tip angle while the columns display the XYZ, IJK, diameter, and thickness values for each tip angle. It also displays the date and time of the calibrated tip angles.

If a tip angle hasn't been calibrated or if there's a Diameter, Date, or Time error, the list will show the tip in red text.

More:

Example Printout


Example Printout

Below you can see an example printout of the active tip list:

Example Printout of Active Tips for a PH9 probe


AutoCalibrate Probe

PC-DMIS provides a command that automatically calibrates the current probe during part program execution. PC-DMIS will begin the calibration routine once it executes the command.

To insert this command, select the Insert | Calibrate | AutoCalibrate Probe menu option

Display Menu Roadmap

The Edit window code for this command reads:

AUTOCALIBRATE/PROBE, PARAMETER_SET=, QUALTOOL_MOVED=Y/N, SHOW_SUMMARY=Y/N, OVERWRITE_RESULTSFILE=Y/N

PARAMETER_SET= This field specifies the name of a defined set of probe qualification parameters. A default set named ALL-TIPS-WITH-DEFAULTS is always available and will calibrate all tips defined in the current probe using the default set of qualification parameters, which are the last ones that were used interactively. To create your own parameter sets, see the "Parameter Sets".

QUALTOOL_MOVED= This YES / NO field sets your response to the computer’s query of whether or not the calibration tool has moved.

SHOW_SUMMARY= This YES / NO field determines whether or not PC-DMIS displays a summary of the calibration.

OVERWRITE_RESULTSFILE= This YES / NO field determines whether or not PC-DMIS overwrites or appends information sent to the results file. This is the same results file that’s referenced when calibrating interactively.

Pressing F9 on this command block allows you to edit the command block using the Calibrate Tip or Calibrate Probe dialog box.

You can also insert a command to automatically calibrate multiple arms. See "Performing an Automatic Calibration" in the "Using Multiple Arm Mode" section of the PC-DMIS Core documentation for more information.

More:

To Automatically Calibrate a Single Tip


To Automatically Calibrate a Single Tip

You can also perform an automatic calibration of the active tip by following this procedure:

  1. Make sure you have at least one sphere feature in your part program. PC-DMIS requires a sphere feature in order to do this type of calibration.

  2. Access the Edit window and place it into Command mode.

  3. From the Settings toolbar, select the tip you want to calibrate. A new TIP command appears in the Edit window. Make sure this new TIP command appears in the Edit window after the sphere feature you will use with this calibration.

  4. On any line following this TIP command, access the Insert | Calibrate | Single Tip menu option. Display Menu Roadmap

  5. PC-DMIS inserts a CALIBRATE ACTIVE TIP WITH FEAT_ID command block into the Edit window.

  6. Click anywhere on this command block, and press F9. The Calibrate Tip dialog box appears.

Calibrate Tip dialog box

  7. Select the sphere feature to use from the Sphere Feature list.

  8. Select the desired calibration tool from the Qualification Tool list.

  9. If the calibration tool has moved since your last calibration, select the Qualification Tool Has Moved check box.

  10. Click OK to update the calibration command block with your changes. For example, this example command block shows that the calibration tool is named MyTool, and that the sphere feature to use for this calibration is SPH1.

CALIBRATE ACTIVE TIP WITH FEAT_ID=SPH1, QUALTOOL_ID=MyTool, MOVED=NO
AXIS | THEO | MEAS | DEV | STD DEV
X | 0.0000 | 8.0080 | 8.0080 |
Y | 0.0000 | 1.0000 | 1.0000 |
Z | 0.0000 | 0.9500 | 0.9500 |
DIAM | 2.0000 | 1.0000 | 1.0000 | 0.0000

  11. Mark this command block, and execute the part program. PC-DMIS will calibrate the active tip when it reaches this command block.


Migrating Part Programs Between Machines Using PH10 and Tesa Star M Probes

In version 4.3 and higher, in the Option section of the PC-DMIS Settings Editor, PC-DMIS provides the AutoAdjustTesaM5Degrees registry entry to assist in migrating part programs between two machines that use a PH10 probe on one machine and a Tesa Star M probe on the other. Both machines must have probe files with the same name (although the probe files themselves will be different).

  • If the registry entry is set to 1, when a part program that was created initially on one of these machines is then loaded onto the other, PC-DMIS will convert any active TIP/ commands to the closest AB tip angle based on the index increment. If any angles are converted, a message box appears displaying them.

  • If the registry entry is set to 0, PC-DMIS will not perform this angle adjustment.

The default value is 1.


Defining Machines

Machine dialog box

The Insert | Hardware Definition | Machine menu option brings up the Machine dialog box.

Display Menu Roadmap

This dialog box allows you to select or create a virtual measuring machine that can be displayed and animated in the Graphics Display window along with the probe when in program mode.

The list of machines in this dialog box is created using the files "machine.dat" and "usermachine.dat" located in the directory where you installed PC-DMIS.

  • The file "machine.dat" contains machine descriptions supplied by PC-DMIS's developers.

  • The file "usermachine.dat" contains the machine descriptions of any machines the user has created and saved.

If you select an entry from the Machine Name list that was in the "machine.dat" file then the selection is displayed in the preview area (blank blue screen).

If there is no "machine.dat" file, the user will only have the No Machine item in the Machine Name list.

More:

Creating a New Machine for Display

Displaying Existing Machines in the Graphics Display Window

Removing the Animated Machine from the Graphics Display Window


Creating a New Machine for Display

To create a new machine:

  1. Type a name for the machine in the Machine Name list.

  2. Select the type of machine from a Machine Type list.

  3. Determine the dimensions of the machine by specifying the length, width, and height of the axes :

  • Specify the 1st axis by selecting X, Y, or Z from the 1st Axis list. Type the length of the machine's base in the 1st Axis box.

  • Specify the 2nd axis by selecting X, Y, or Z from the 2nd Axis list. Type the width of the machine's base second axis in the 2nd Axis box.

  • Specify the 3rd axis by selecting X, Y, or Z from the 3rd Axis list. Type the height of the machine in the 3rd Axis box.

  4. Specify the machine's home position by typing values in the Home Position area. This area is only editable for user-defined machines; you cannot use it for machines supplied by PC-DMIS.

  5. Click the Save button. PC-DMIS includes the newly created machine in the Machine Name list.

Note: The "usermachine.dat" file is not actually modified until you click Apply or OK. If you click Cancel all changes are ignored.

More:

Additional Information on the Machine's Axes

Additional Information on the Machine's Home Position area

Additional Information for Creating Multiple Arm Machines


Additional Information on the Machine's Axes

The 1st axis defines the length of the machine's base in the direction that the bridge moves (for bridge machines), or the length of the base in the direction that the vertical carriage moves (for horizontal arm machines). This is usually the X axis for most horizontal arm machines, and either the X or the Y axis for most vertical arm machines.

The 2nd axis defines the width of the base in the direction that the carriage moves (for a bridge machine) or the direction the arm moves (for a horizontal arm machine). This is the vertical Z axis for most horizontal arm machines and either the X or the Y axis for most vertical arm machines. This differs from the machine volume. The volume defines the distance the arm can reach. Most arm machines have a volume just over 50% of the width.

The 3rd axis defines the height of the machine from the top of the base to the bottom side of the bridge for a bridge machine, or the extent of the vertical axis for a horizontal arm machine. This is the vertical Z axis for most bridge machines and the Y axis for most horizontal arm machines. At this time only the following axis configurations are allowed:

  • Generic Bridge with Y, X, Z or X, Y, Z

  • Generic Arm with X, Y, Z


Additional Information on the Machine's Home Position area

These three boxes define the home position of the machine. The x, y, z values define where the home position is for the machine. The center of the machine base is 0,0,0. But these coordinates are not used to show the home position on most machines. The x,y,z values are offset from the 0,0,0 machine base position.

For example, if the machine's dimensions are 1000, 700, and 700 with the actual home position in the upper left corner in back, the machines offsets would be: -350, 500, 350 for the 1st, 2nd, and 3rd axes respectively.

Note: The Home Position area is only editable for user-defined machines; you cannot use it for machines supplied by PC-DMIS.


Additional Information for Creating Multiple Arm Machines

You can also create and place a simulated multiple arm machine into the Graphics Display window.

  1. Follow PC-DMIS multiple arm setup procedures.

  2. Enter multiple arm mode. The Active Arms toolbar appears. This enables the Dual Horizontal Arm option from the Machine Type area.

  3. Create a multiple arm part program.

  4. Follow the "Creating a New Machine for Display" procedure (make sure you select the Dual Horizontal Arm option button from the Machine Type area).

  5. The Graphics Display window should now show a dual arm machine when finished.


Displaying Existing Machines in the Graphics Display Window

To display a machine in the Graphics Display window, access the Machine dialog box, select a machine from the Machine Name list, and then click OK. The graphical representation of the selected machine appears in the Graphics Display window along with the CAD of the part.

PC-DMIS also inserts a LOADMACHINE/NAME command into the Edit window, where NAME is the machine's name.

More:

Creating a Relationship between the Machine and the Part


Creating a Relationship between the Machine and the Part

You can create a relationship between the machine model and the CAD model by changing the XYZ offsets and rotations to establish the proper orientation between the two models. You can do this by using the Quick Fixture Mode to change the part's orientation or by using the Part/Machine tab of the Setup Options dialog box. Or you can use a combination of the two approaches.

Using the Quick Fixture Mode

  1. Click the Quick Fixture Mode icon from the Graphics Modes toolbar.

  2. Use the mouse and Quick Fixture's shortcut menu to properly orient your part.

  • Right-click on your part model and select Level Object. This levels your part to the machine model's table surface.

  • Right-click on your part model and select Drop Object. This sets your part onto the machine model's table surface.

  • Right-click on your part model and rotate and move your part to further position it as needed.

  3. Switch to a different mode. The part model will remained fixed at its final position.

See the "Quick Fixture Mode's Mouse and Keyboard Commands" for information on using this mode to move your model.

Using the Part/Machine Tab

  1. Press F5 to access the SetUp Options dialog box.

  2. Select the Part/Machine tab.

  3. In the Part Setup area click the Auto Position button to have PC-DMIS automatically position your part model on the machine model's table surface.

  4. If you want more direct control over placement of your part model you can modify the items directly in the Part Setup area.

See "Setup Options Mode: Part / Machine tab" topic in the "Setting Your Preferences" section.


Removing the Animated Machine from the Graphics Display Window

You can get rid of the CMM's graphical display at any time by following one of these procedures:

More:

Selecting the 'No Machine' Item

Deleting the LOADMACHINE Command

Deleting the Machine


Selecting the 'No Machine' Item

To remove the animated display of the machine from the Graphics Display window by selecting the No Machine item, follow this procedure:

  1. Access the Machine dialog box. Display Menu Roadmap

  2. Select No Machine from the Machine Name list.

  3. Click Apply or OK. PC-DMIS removes the display of the machine.


Deleting the LOADMACHINE Command

To remove the animated display of the machine from the Graphics Display window by deleting the LOADMACHINE command, follow this procedure:

  1. Access the Edit window.

  2. Place it in Summary or Command mode.

  3. Delete the entire LOADMACHINE/ command. PC-DMIS removes the display of the machine.


Deleting the Machine

To remove the animated display of the machine from the Graphics Display window by permanently deleting the machine, follow this procedure:

  1. Access the Machine dialog box. Display Menu Roadmap

  2. Selecting the machine to delete from the Machine Name list.

  3. Click the Delete button.

  4. Click Apply or OK. PC-DMIS removes the machine from the Machine Name list and removes the display of the machine. This also deletes the machine from the "usermachine.dat" file.

Note: The "usermachine.dat" file is not actually modified until you click Apply or OK. If you click Cancel all changes are ignored.


Inserting Quick Fixtures

With PC-DMIS 3.6 MR1 and later you can quickly and easily insert a selection of predefined (or custom) fixtures into the Graphics Display window by using the QuickFix dialog box.

To access this dialog box, select the Insert | Hardware Definition | Quick Fixture menu item. Display Menu Roadmap

QuickFix dialog box

This dialog box contains these options:

Available Fixtures – This list displays available fixtures that you can import into the Graphics Display window. These fixtures are stored in the Models\QuickFix\ PC-DMIS installation sub directory.

Displayed Fixtures – This list displays fixtures currently displayed in the Graphics Display window. To reposition fixtures inside the Graphics Display window, see "Quick Fixture Mode's Mouse and Keyboard Commands".

Insert – This button moves the selected fixture from the Available Fixtures list into the Displayed Fixtures list, allowing you to display the selected feature in the Graphics Display window.

Remove – This button removes the selected fixture from the Displayed Fixtures list.

New Fixture – This area lets you add your own fixtures in to the Available Fixtures list. New fixtures must be an IGES file. The Filename box displays the complete pathway for the fixture you want to add, the Browse button lets you browse to the IGES file you want added and the Add button actually inserts to new fixture into the list of available fixtures.

Fixture Preview- The area below the New Fixture area gives you a preview of the fixture currently selected from the Available Fixtures list.

More:

Inserting and Removing Quick Fixtures

Adding Custom Fixtures

Quick Fixture Mode's Mouse and Keyboard Commands

Using Existing Quick Fixtures


Inserting and Removing Quick Fixtures

To insert a quick fixture into the Graphics Display window:

  1. Access the QuickFix dialog box.

  2. Select the fixture you want to add from the Available Fixtures list. PC-DMIS shows a display of the fixture in the fixture preview area of the dialog box

  3. Click the Insert button. The fixture name appears in the Displayed Fixtures list and the fixture's model appears in the Graphics Display window

To remove a quick fixture from the Graphics Display window:

  1. Access the QuickFix dialog box.

  2. Select the fixture you want to remove from the Displayed Fixtures list.

  3. Click the Remove button. PC-DMIS removes the quick fixture's model from the Graphics Display window.

To reposition quick fixtures, see the "Quick Fixture Mode's Mouse and Keyboard Commands"


Adding Custom Fixtures

To add your own custom fixtures into the Available Fixtures list:

  1. Access the QuickFix dialog box.

  2. In the New Fixture area, click the Browse button. An Open dialog box appears.

  3. Navigate to your fixture's model. It can be of any supported graphical formats. PC-DMIS defaults to showing an IGES file format in the Files of type list. You can change this to any of the selected formats.

  4. Select your model and click Open. The Open dialog box closes and PC-DMIS displays the full path to the file you selected inside the New Fixture area.

  5. Click the Add button. PC-DMIS adds the fixture into the Available Fixtures list. This fixture will appear in this list even for other part programs.


Quick Fixture Mode's Mouse and Keyboard Commands

To use the different mouse and keyboard commands for quick fixtures, first Place PC-DMIS into Quick Fixture mode by clicking the Quick Fixture Mode icon from the Graphics Modes toolbar.

  • Left Mouse Drag - Moves the fixture object underneath the mouse until you release the button. Nothing happens unless you start on top of the object. Only fixture objects and CAD objects move.

  • Press CTRL key + Left Mouse Drag - Rotates the object in 3D underneath the cursor in the direction you drag the mouse until you release the button. Only fixture objects and CAD objects rotate.

  • Right button click - Displays the quick fixture shortcut menu. See "Quick Fixture Shortcut Menu" in "Using Shortcut Keys and Shortcut Menus".


Using Existing Quick Fixtures

PC-DMIS stores quick fixture files with a .DRAW filename extension in the models\quickfix sub-directory where you installed PC-DMIS.

In addition, PC-DMIS stores a definition of each quick fixture in a special data file (.dat filename extension) located in the directory where you installed PC-DMIS.

  • If the quick fixture was originally shipped with PC-DMIS, it is stored in the QuickFix.dat file.

  • If the quick fixture is a user-created fixture, its definition is stored in the UserQuickFix.dat file.

A typical quick fixture data file consists of two lines for each quick fixture, an ITEM: line and a cadgeom line. In a text editor, this file might look something like this:

A Small Sample of the QuickFix.Dat File

A Small Sample of the QuickFix.Dat File

To Use Custom Quick Fixtures from a Previous Installation

  1. Close down PC-DMIS and open Windows Explorer.

  2. Before creating new custom fixtures for your new installation, copy the .DRAW files from the models\quickfix sub-directory of your previous installation, and paste them into the models\quickfix sub-directory of your current PC-DMIS installation.

  3. Copy the userquickfix.dat file from the directory of your previous installation and paste it into the directory of your current PC-DMIS installation.

  4. Restart PC-DMIS. The custom quick fixtures will now appear in the QuickFix dialog box along with the fixtures supplied by your current PC-DMIS installation.

Note: The .DRAW quick fixture files will not appear inside of the QuickFix dialog box unless the userquickfix.dat file contains the necessary definitions for the file. These definitions get added whenever you import your own custom IGES files as quick fixtures using the QuickFix dialog box (see Adding Custom Fixtures).

If you want to directly use the .DRAW files created by another user, but you don't want to overwrite your own quick fixtures by simply copying the other's data file, you would need to use a text editor to merge the necessary ITEM: and cadgeom lines for the other user's data file into your data file.


Defining Probe Changers

To begin using your probe changer, you must first define the changer's port locations through the following probe changer calibration procedure. While PC-DMIS supports a variety of probe changers, only the FCR25 calibration process is discussed here. If you have a different probe changer type, please use this procedure as a guide, as it will be similar enough for all supported types.

To begin this calibration process, you need to access the Probe Changer dialog box. Select Edit | Preferences | Probe Changer.

Terminology Note: While the Probe Changer dialog box uses the term "slot" instead of "port", the calibration prompts you will receive use the term "port". For this reason, this documentation will use the term "port" except when referring to Probe Changer dialog box items that use the term "slot".

More:

Calibrating the FCR25 Probe Changer

Calibrating the CW43 Probe Changer

Showing an Animated Probe Changer


Calibrating the FCR25 Probe Changer

The calibration process for Renishaw's FCR25 probe changer represents the steps that would be taken to prepare for using any of the probe changers supported by PC-DMIS. The process discussed here is specific to the FCR25 probe changer.

Two inserts are used with the FCR25 rack to accommodate different probe types, the PA25-SH and the PA25-20.

PA25-SH and PA25-20 Inserts

PA25-SH and PA25-20 Inserts

For example, the following image of an FCR25 probe changer shows three ports, two with inserts and one without (probes are also shown). The left port shows a PA25-SH insert and the port on the right shows a PA25-20 insert. The middle port does not have an insert.

FCR25 Probe Changer - Showing inserts and probe types

Important: The FCR25 Probe Changer must be mounted on the machine table parallel to either the X or Y axis for successful calibration. The FCR25 Probe Changer can be mounted to your table with the MRS rack or the 3 and 6 port stand-alone racks.

For mounting instructions, consult the documentation that came with your probe changer.

To Calibrate your FCR25 Probe Changer:

  • Step 1 - Select the FCR25 Probe Changer

  • Step 2 - Define the Mount Point

  • Step 3 - Define Ports

  • Step 4 - Begin Calibration

  • Step 5 - Prepare Probe Changer

  • Step 6 - Measuring Port 1/PA25-SH Insert

  • Step 7 - Measuring Port 3/PA25-20 Insert

  • Step 8 - Measuring Port 2/No Insert

  • Step 9 - Review Calibration Results


Step 1 - Select the FCR25 Probe Changer

To begin the calibration process, select Edit | Preferences | Probe Changer to open the Probe Changer dialog box. Display Menu Roadmap

Probe Changer dialog box - Type tab

To select the FCR25 Probe Changer, follow these steps:

  1. Select the Type tab from the Probe Changer dialog box.

  2. Select FCR25 from the Probe Changer Type list.

  3. Click Apply to make this probe changer active and to load settings that are relevant to this probe changer.

  4. Specify the number of different types of probe changers in the Number of Probe Changers box.

  5. Specify the Docking Speed. The default value of 5% is appropriate for most machine configurations.

  6. Click Apply to save your changes.

In the next step you will define the location your probe body will move to when using the probe changer to switch probe components.

Next Step...


Step 2 - Define the Mount Point

The Mount Point for your FCR25 Probe Changer is the location in front of your probe changer where the machine will move before it picks up or drops off a probe. You should determine a location that will avoid collision with the probe changer or part.

Probe Changer dialog box - Mount Point tab

To provide the Mount Point for your FCR25 Probe Changer, follow these steps:

  1. Select the Mount Point tab from the Probe Changer dialog box.

  2. Select TYPE=FCR25 from the Active Probe Changer list.

  3. Alter the Probe Head Wrist Angle for both A Angle and B Angle. Typically, but not always, these values will be 0 and 0 respectively. You need to use a calibrated probe rotation that will ensure that the probe has the ability to move in and out of the probe rack during the necessary steps of the probe rack calibration procedure.

  4. Using your jog box, manually move your machine to the desired mount point position.

  5. Click the Read Machine button. This will populate the X, Y, and Z Machine Position values with the current position. You may also manually type these values.

  6. Click Apply to save your changes.

In the next step you will define the ports used by your probe changer.

Next Step...


Step 3 - Define Ports

The example described in this documentation has a PA25-SH insert in Port 1(left), NO INSERT in Port 2 (middle), and a PA25-20 insert in Port 3 (right).

To define the ports of your FCR25 Probe Changer, follow these steps:

  1. Select TYPE=FCR25 from the Active Probe Changer list.

  2. In the Number of Slots box, specify in multiples of three the number of ports your FCR25 probe changer(s) will have. PC-DMIS then lists the specified number of ports as "slots" (for example Slot 1, Slot 2, Slot 3, and so forth). Until you define the ports these "slot" entries will display "UNDEFINED".

Probe Changer dialog box - Slots tab showing undefined slots

Probe Changer dialog box - Slots tab showing undefined slots

  3. Select a slot from the list and click Edit Slot Data. This opens the Probe Changer Slot Data dialog box.

Probe Changer Slot Data dialog box

  4. Select NO INSERT, PA25-SH, or PA25-20 from the Slot Type list.

  5. You may specify the XYZ values for the center position of the port or leave those values empty. In any case, PC-DMIS will automatically populate these values upon successful calibration. See "Step 9 - Review Calibration Results".

  6. Click OK to save changes to slot data. Repeat steps 3 through 5 for all ports in your changer.

Probe Changer dialog box - Slots tab

  7. Click Apply to save your changes.

You are now ready to begin calibration. In the next step you will start the calibration procedure.

Next Step...


Step 4 - Begin Calibration

Before you start calibration you must specify/verify the probes that will be used.

Probe Changer dialog box - Calibrate tab

To specify the probes used in the calibration of your FCR25 Probe Changer, follow these steps:

  1. Select the Calibrate tab from the Probe Changer dialog box.

  2. Select the TYPE=FCR25 from the Active Probe Changer list.

  3. Determine the type of calibration. Select either the Single Port Calibration option to calibrate one port or the Full Calibration option to calibrate all FCR25 ports. If you select the Single Port Calibration, you must also select the needed port from the Probe Changer Port list. This documentation describes the Full Calibration option.

  4. Select the currently attached probe that defines the current probe configuration from the Active Probe File list, and select the current tip from the Active Tip list.

  5. If any ports require a secondary probe file to pick up that type of stylus, select the required probe file that defines the secondary probe configuration from the Second Probe File list. Then select the needed tip from the Second Tip list. For example, a PA25-20 insert would require you to specify something like the SO25TP20_3 to accommodate the size of stylus used with the insert.

  6. Click Calibrate when you are ready to begin calibration.

In the next step, you will prepare the probe changer for calibration.

Next Step...


Step 5 - Prepare Probe Changer

Step 5 - Prepare for Calibration

Note: The Calibration process may vary slightly depending on the types and locations of the inserts for each port. The process described here is intended to show how PC-DMIS manages calibration for each port type.

Once you click Calibrate the following message box appears:

PC-DMIS MESSAGE:
Each FCR25 unit contains 3 ports. Different types of physical racks can hold varying numbers of FCR25 units. The current rack is configured to have a total of 3 ports, which means it should have 1 FCR25 units.

Please shim open all the lids and remove all modules and styli from the ports.

  1. Read the instructions from the preceding prompt, and verify that you have the correct number of ports and FCR25 units (a unit is a set of three ports).

  2. Open the lids to each port and insert shims to hold them open.

    A "shim" is a tapered piece of plastic that fits in between two ports to hold open their lids. The picture to the right shows a close-up view of a shim between ports 2 and 3, holding open their lids. Without a shim, the lids will shut, as you can see in port 1.

    Close up of a shim holding open lids on two ports

  3. With the lids open, remove all of the modules and styli by sliding them forward out of the ports as shown below.

  4. Click OK when you are ready to measure Port 1.

In the next step, PC-DMIS will measure Port 1.

Next Step...


Step 6 - Measuring Port 1

Step 6 - Measuring Port 1/PA25-SH Insert

You will be prompted through the process of measuring Port 1 (left-most port) through a series of message boxes. Follow the prompts and take the needed hits as shown in the pictures for each hit.

Hit 1 on Top surface

PC-DMIS MESSAGE:
Please take a hit on the top face of the front left corner for port 1 (which is local port 1 on FCR25 unit number 1).

Using your machine's jog box, measure the first hit on the top surface of Port 1 as shown in the image to the right.

When you click OK you will be prompted to take the hit with the Execution Mode Options dialog box.

Hit 2 on Front surface

PC-DMIS MESSAGE:
Please take a hit on the front face of the front left corner for port 1 (which is local port 1 on FCR25 unit number 1).

Using your machine jog box, measure the second hit on the front surface of Port 1 as shown in the image to the right.

When you click OK you will be prompted to take the hit with the Execution Mode Options dialog box.

Hit 3 on Inside surface

PC-DMIS MESSAGE:
Please take a hit on the inside face of the front left corner for port 1 (which is local port 1 on FCR25 unit number 1).

Using your machine's jog box, measure the third hit on the inside surface of Port 1 as shown in the image to the right.

When you click OK you will be prompted to take the hit with the Execution Mode Options dialog box.

This set of three hits establishes the location for the tool changer. These three hits would be the same if the port didn't have an insert. If you used a PA25-20 insert in this port, the hits would be taken on the insert in a similar fashion.

You will now be asked to complete a few steps via the following dialog box.

PC-DMIS MESSAGE:
Please do the following steps in the indicated order.

  1. Remove the current SH-1/2/3 stylus.

  2. Attach the SHSP (Stylus Holder Setting Piece).

  3. Jog the probe to a safe location with a clear line of approach to the port(s) being calibrated.

  4. Then click OK.

After you click OK the machine will begin DCC measurement.

Complete the instructions in the message box and remove the specified stylus (in this case the SH-1/2/3 stylus) and attach the SHSP as shown in the image to the right.

Note: Whenever the instructions direct that you should jog the probe to a "safe location" or a location "with a clear line of approach" you should move the probe to a position that is in front of and slightly above the rack.

When you have completed these steps, Click OK and DCC measurement will begin.

PC-DMIS will automatically measure the three hits with the SHSP that were previously taken with the SH-1/2/3 stylus. It will also take a hit on the opposite inside face. This completes the measurement of Port 1.

In the next step, PC-DMIS will measure Port 3.

Next Step...


Step 7 - Measuring Port 3

Step 7 - Measuring Port 3 / PA25-20 Insert

Before PC-DMIS can measure Port 3 (the right-most probe), you must first change the probe to the probe file you previously specified for the Second Probe File in Step 4.

When prompted, remove the current module, and add the TM25-20 module to the end of the probe body.

The image to the right shows the TM25-20 module and TP20 type stylus after this change.

Note: Changing probes may not be necessary depending on your FCR25 probe changer configuration. For example, if there are no inserts in any of the ports, then this probe change may not be necessary. The change specified in this step is only required to accommodate calibration of Port 3 with the PA25-20 insert.

After changing the probe, click OK. PC-DMIS will then display the following prompt:

PC-DMIS MESSAGE:
Please jog the probe to a safe location with a clear line of approach to the port(s) being calibrated, then click OK.

When you click OK the machine will begin DCC operation.

After moving the probe to a safe location, click OK, and PC-DMIS will begin automatic measurement of the insert in Port 3. The following images show the probe taking measurements. PC-DMIS will automatically take hits to determine the location of the insert.

This completes the measurement of Port 3. In the next step, PC-DMIS will measure Port 2.

Next Step...


Step 8 - Measuring Port 2

Step 8 - Measuring Port 2 / No Insert

Before measuring Port 2, you will be prompted to remove the module that was used for the measurement of Port 3.

PC-DMIS MESSAGE:
Please remove the module from the probe body, jog to a clear location and then click OK.

When you click OK the machine will begin DCC operation to move the probe body to a position above port 2.

Once you have removed the module and moved the probe to a safe location, click OK to continue the process.

PC-DMIS will move the probe body to a position that is centered above Port 2 as show in the image to the right. (The image also shows the module that PC-DMIS will have you add in the next prompt.)

Note: The procedure for measuring Port 2 would be used for all ports if you didn't have an insert in any of the ports. The ports would also be measured in a different order (Port 1 first, followed by Port 2, and then )Port 3)

PC-DMIS MESSAGE:
Place the desired module into the port and slowly lower the probe body towards the module while being careful not to collide with the port.

Continue lowering until the module jumps upwards slightly due to the magnetic attraction. Observe to see if the module jumps straight up (indicates good alignment) or tilts (indicates poor alignment).

Reposition and repeat as necessary until satisfied with the alignment, then click OK.

Follow the prompt to place the module into the port. Then, slowly lower the probe body towards the module until the magnetic attraction causes the module to jump up towards the probe body. If you have a poor alignment, use the jog box to reposition the probe body, and repeat this process until you get a good alignment.

The following images show the process described above.

Slowly Lowering the Probe Body

Module Jumps Upward for a Good Alignment

Module Tilted for a Poor Alignment

Click OK when a good alignment has been established. The following prompt is displayed.

PC-DMIS MESSAGE:
Slowly lower the probe body onto the module. IMMEDIATELY stop when the LED on the probe head illuminates and then click OK.

When you click OK the machine will begin a small DCC movement to finish seating the probe body into the module.

The image to the right shows the probe body that has been lowered just before the LED is lit.

Notice the slight gap between the probe body and the SM25-2 module. From this point, you would continue to lower the probe body and stop when the LED is lit. This will not close the gap completely. Click OK to finish the process.

At this point the probe body will automatically move down the rest of the way to seat the probe module and close the gap.

The following prompt appears:

PC-DMIS MESSAGE:
Moving in only the one axis (as much as possible) please move the probe clear from the port and then click OK.

Move the probe straight out from the port to a position in front of the port as shown in this image.

Click OK. This completes the measurement of Port 2.

You will then be prompted to set the configuration back to the original probe configuration.

PC-DMIS MESSAGE:
Please restore the probe configuration for probe SP25_4_X_50 and then click OK.

Remove the current module if needed and add the modules and tips that make up the requested probe file. Click OK when finished. The following prompt is displayed:

PC-DMIS MESSAGE:
This calibration procedure is now complete.

This completes the FCR25 probe changer's calibration. The next step discusses how to review your calibration.

Next Step...


Step 9 - Review Calibration Results

Select the Slots tab on the Probe Changer dialog box, and you will see that calibration information now exists for the location of each of the calibrated ports.

Probe Changer dialog box - Slots tab with calibration results

This calibration process only discusses the process for preparing ports for calibration. See the ”Setting Up Probe Changer Options” topic in the "Setting Your Preferences" section for information about adding probe definitions to each of the ports.

During part program execution, probe entities that are added to each of the ports will be automatically picked up from that location whenever PC-DMIS executes a LOADPROBE command for that probe. The probe body will move to the mount point, then into the port, pushing the lid backwards. Then, using the magnetic attraction, it will load the new module and will continue measurement.


Calibrating the CW43 Probe Changer

Vertical CW43 Probe Changer with Five Slots

A - Slot four in this picture shows a three axis slot.

B - Slot five in this picture shows a normal slot.

Solenoid Connection with Green and Amber LED Lights

Three Axis Probe Slot on a Vertical Rack

These two pictures provide examples of the surfaces where the three hits should be taken for both a three axis probe slot and a normal probe slot.

A - First hit on top surface

B - Second hit on the side closest to the ram (depending on where your CMM ram is located, this could be on the other side)

C - Third hit on front face

Normal Probe Slot on a Vertical Rack

Calibrating the CW43 Probe Changer

The following topics describe how to calibrate the CW43L Probe Changer. This documentation uses the term "slot" to refer to the "port", "station", or "garage" where different probes or extensions will be held.

The CW43 Probe Changer can hold two different kinds of slots: normal slots and three axis slots (slots that hold probes that can rotate in three axes).

Important: Before staring the calibration process, ensure that the installation personnel have mechanically aligned all of the slots so that the front face and the top of the slots are parallel to the movement of the machine's ram. If the slots are not properly aligned in this fashion, you will experience problems during a probe change operation.

Step 1 - Select the CW43 Probe Changer

  1. Select Edit | Preferences | Probe Changer Setup to access the Probe Changer dialog box. Display Menu Roadmap

  2. Select the Type tab.

  3. Specify the number of probe changers. Generally this will be 1.

  4. From the Probe Changer Type list, select CW43L.

  5. Click Apply. The Active Probe Changer list now reads: Probe Changer 1: Type=CW43L

Step 2 - Define Slots

In this step you will define the number of slots for your probe changer as well as the hardware held in each slot.

  1. Select the Slots tab.

  2. In the Number of Slots box, specify the number of slots used on your probe changer.

  3. Click Apply.

  4. Expand each slot in the list, and define the probe file names that correspond to the hardware (probe or extension) that each slot holds. You can do this now or anytime after this point.

  5. Click Apply when finished.

Getting Around Three Axis Slots

If you have a three axis slot, you will notice it sticks out from the rack a more than the normal slots. This may cause clearance problems when performing a probe change operation. To help avoid crashing into these slots, we recommend that you install this type of slot on the ends of the probe changer: either on the top or the bottom on a vertical probe changer or on the left or right sides of a horizontal probe changer. If you cannot do this due to space constraints in your environment, you will need to modify the default clearance distance that the probe uses when moving to and from the different slots. You can do this by accessing the PC-DMIS Settings Editor and modifying the TCRackClearance entry or the TCRack3AxisClearance entry in the next step.

  • TCRackClearance - This registry entry is the clearance distance in front of a normal slot. It has a default value of 150 mm.

  • TCRack3AxisClearance - This registry entry is the clearance distance in front of a three axis slot. It has a default value of 300 mm.

Step 3 - Define the Three Axis Slot and Change Clearance Distances

You only need to perform this step if you have a three axis slot (a slot capable of storing a three axis probe). If not, go to the next step. You can perform this step later, but we recommend doing it now. This step essentially tells PC-DMIS which slot is the three axis slot and whether or not you intend to perform load or unload operations automatically for that slot.

  1. Click OK to close down the Probe Changer dialog box.

  2. Exit from PC-DMIS.

  3. Launch the PC-DMIS Settings Editor.

  4. Navigate to the Leitz section.

  5. Select the CW43LThirdAxisTCSlot registry entry. By default, this entry has a value of -1 which means a three axis slot is not available on the probe changer.

    • If you plan on manually loading and unloading the three axis probe from the slot yourself, you should set this value to 0.

    • If you plan on having PC-DMIS automatically load and unload the probe, you should set this value to the slot number holding the three axis probe.

  6. Ensure that the CW43LTTest3AxisSlotTC registry entry is set to True. There are two LED lights in a magnetic relay located on the back of a three axis slot, a green light and an amber light. The green light means the slot relay has power. The amber light is only illuminated if the three axis joint is physically located in the slot. A True value for this entry checks for the amber light, and is an indication to the CMM controller that it is safe to apply the 24 volt DC motor power to the three axis joint.

Warning: During a Probe Changer operation, NEVER attempt to manually change the three axis probe while the green LED light on the top of the three axis joint is illuminated. An illuminated green LED light signifies that motor power (+24V DC) is present. If a probe change is done while there is motor power, it could cause a voltage spike that would damage the third axis motor. The same is possible for other voltage signals (+5V DC, +12V DC, and so on) needed for items that may attach to the third axis (Perceptron probe, NC100 video probe, and so forth). This applies only when the joint is connected to the probe head.

  7. If needed, you can also modify the clearance distances in the TCRackClearance and TCRack3AxisClearance. You should only need to do this if your three axis slot could not be placed on the ends of the rack.

  8. Save any changes made. Then close the PC-DMIS Settings Editor.

  9. Restart PC-DMIS and reload your part program.

  10. Select Edit | Preferences | Probe Changer Setup access the Probe Changer dialog box again.

Step 4 - Prepare for Calibration

In this step you will define the probe file and tip angle to use during the calibration process.

  1. Select the Calibrate tab.

  2. Select the probe to use from the Active Probe list.

  3. Select tip angle to use from the Active Tip list. The tip angle you use will depend on your specific machine. This tip angle will be used throughout the entire calibration process.

Step 5 - Begin Calibration

In this step you will decide to calibrate either a single slot in the probe changer or to calibrate all the slots. You will then start calibration.

  1. Decide the type of calibration to perform, either Single Port Calibration or Full Calibration.

    • If you selected Single Port Calibration, the Probe Changer Port list becomes available for selection. From the Probe Changer list, select the single probe to calibrate.

    • If you selected Full Calibration, PC-DMIS will calibrate all the available ports on your probe changer starting with the first slot and moving sequentially through all the slots.

  2. Click the Calibrate button. PC-DMIS will ask if it is OK to rotate to the previously defined probe angle.

  3. Click OK. The probe rotates to the defined angle and a message box appears asking you to take three hits.

Step 6 - Calibrate by Taking Three Hits

In this step you will manually move the probe to take three hits, one on three different faces of each slot being calibrated. For a full calibration you will take the hits on the first defined slot and then move sequentially to the second slot and so on until the last. For a single port calibration, you will only need to take the hits on the one slot being calibrated.

For a Vertical Probe Changer:

  • Take the first hit anywhere on the top of the top of the slot. Press Done.

  • Take the second hit anywhere on the side of the slot nearest the ram of the machine. Press Done.

  • Take the third hit anywhere on the front face of the slot. (If this is the three axis slot, take the hit on the face to which the hinges of the slot cover are attached). Press Done.

Example of Taking Three Hits on a Vertical Probe Changer:

For a Horizontal Probe Changer:

  • Take the first hit anywhere on the top of the top of the slot. Press Done.

  • Take the second hit anywhere on either side of the slot. Press Done.

  • Take the third hit anywhere on the front face of the slot. (If this is the 3 axis slot, take the hit on the face to which the hinges of the slot cover are attached). Press Done.

Step 7 - Define a Mount Point

In this step you will define a safe location and probe head angle in front of the rack where the CMM is able to reach all the slots. This is called the "Mount Point".

Important: The Mount Point location is NOT the same thing as the distance in front of the probe changer defined in the TCRackClearance and TCRack3AxisClearance registry entries.

  1. Click the Mount Point tab.

  2. In the Probe Head Angle boxes, use the A Angle and B Angle boxes to define the probe head angle to use when the probe head us at the Mount Point location.

  3. Use the jog box, and manually move the probe to where you want your mount point, then click the Read Machine button. PC-DMIS will pull in the XYZ location from the CMM.

  4. Click Apply and then click OK.

You are now done with the CW43 Probe Changer calibration and can now perform probe changes.

Warning: Remember, during a Probe Changer operation, NEVER attempt to manually change a three axis probe while the green LED light on the top of the three axis joint is lit. This applies only when the joint is connected to the probe head.


Showing an Animated Probe Changer

PC-DMIS allows you to display an animated graphical representation of a pre-defined probe changer inside the Graphics Display window.

Note: You can define a probe changer from the "Setting Up Probe Changer Options" topic in the "Setting Your Preferences" section.

Example of an animated probe changer shown in the Graphics Display window in the Z+ view (top picture) and the X+ view (bottom picture)

You will use the Animated Probe Changer dialog box to specify the position and orientation of the probe changer. Access this dialog box by selecting the Insert | Hardware Definition | Animated Probe Changer menu item. Display Menu Roadmap

Animated Probe Changer dialog box

The items in this dialog box are discussed in the "To Display the Probe Changer" procedure below.

More:

To Display the Probe Changer in the Graphics Display window:

To Delete the Probe Changer from the Graphics Display window:


To Display the Probe Changer in the Graphics Display window:

  1. Access the Animated Probe Changer dialog box (Insert | Hardware Definition | Animated Probe Changer). Display Menu Roadmap

  2. Select an existing pre-defined probe changer from the Active Probe Changer list. If you don't see any probe changers in this list, you can define a probe changer from the "Setting Up Probe Changer Options" topic in the "Setting Your Preferences" section.

  3. Define the location and orientation of the probe changer. You can do this by either using calibration data for the location and orientation or by specifying the XYZ location and orientation directly into the dialog box.

  • To use existing calibration data, select the Use Calibration Data check box. PC-DMIS fills in the location boxes with the XYZ values from the calibration.

  • To directly specify the location and orientation, type values into the X, Y, and Z boxes, and then select an orientation from the Orientation list.

  4. Click Apply. PC-DMIS draws the animated probe changer in the specified position and orientation in the Graphics Display window. PC-DMIS also inserts a LOADPROBECHANGER command into the Edit window.

  5. Click OK when you're satisfied with the orientation and position.


To Delete the Probe Changer from the Graphics Display window:

Access the Edit window and delete the LOADPROBECHANGER command. This doesn't delete your pre-defined changer, just the animation of it inside the Graphics Display window.


Working with Rotary Tables

Except where specified, the following Rotary Table commands were developed to support the PC-DMIS/NC (Numerical Control) for use on CNC machine tools. However, you can use them in regular CMM part programs as well. See the PC-DMIS/NC help file for more information on using CNC machines with PC-DMIS.

Ignore Rotary Table Display Menu Roadmap

The Insert | Parameter Change | Probe | Ignore Rotary Table menu item inserts an IGNOREROTAB command into the part program. The only two options are:

IGNOREROTAB/ON or IGNOREROTAB/OFF

When you have a rotary table defined for use, PC-DMIS usually assumes that you will place parts to measure on the rotary table. Essentially, PC-DMIS expects you to use the Rotary table. This means it is not ignoring the rotary table. And so IGNOREROTAB is set to OFF:

IGNOREROTAB/OFF

In this state, PC-DMIS adjusts any measured data collected from the machine by using the data from the rotary table's calibration.

If you insert IGNOREROTAB/ON command, PC-DMIS ignores the rotary table calibration data. Thus, measured data collected will not have a rotary table adjustment applied to it. The two most common cases where this might be used are

  • A part measurement where you want to measure the part without using the rotary table even though your table exists.

  • A part program where you want to execute a new table calibration and you need to ignore the old calibration results.

Calibrate the Rotary Table Display Menu Roadmap

The Insert | Calibrate | Rotary Table from Features menu item inserts a CALIBRATEROTAB command into the part program:

CALIBRATEROTAB/PLANE=TABLE_PLN, CIRCLE=TABLE_CIR,

MEAS/XYZ=0,0,0, MEAS/IJK=0,0,0

This command tells a suitable part program to calibrate the rotary table during program execution.

To use this command:

  1. Attach a proper calibration artifact (a sphere) to the table.

  2. Measure in an appropriate series of angular positions.

  3. You create a constructed plane and circle through the resulting sphere centers. Once you have a constructed the plane and circle, you can use them as inputs to this command.

  4. Insert the CALIBRATEROTAB command.

  5. Press F9 on the command and a Calibrate Rotab dialog box appears.

  6. From the Constructed Plane list, select the constructed plane. From the Constructed Circle list, select the constructed circle.

  7. Click OK. PC-DMIS updates the command to use the constructed features.

  8. When you execute the part program, PC-DMIS will use the constructed features to update the rotary table calibration data. The MEAS/XYZ and MEAS/IJK portions in the command block will show the result for the center point and plane of rotation for the table.

For information on setting up your rotary table, see "Defining the Rotary Table" in "Setting Your Preferences"

Rotate the Table to the Active Angle (Not Supported in PC-DMIS NC) Display Menu Roadmap

The actual rotary table angle on the machine and the active angle specified in your part program don't always match. The Operation | Rotate Table to Active menu item automatically causes the actual table to rotate until its angle matches the active angle in the program at your cursor's location.


Creating Auto Features

Creating Auto Features: Introduction

Quick Ways to Create Auto Features

The Auto Feature Dialog Box

Inserting Auto Features

Auto Feature Field Definitions

Setting Up Relative Measure (RMEAS)


Creating Auto Features: Introduction

PC-DMIS provides a library of functions and routines to facilitate the automatic measurement of parts. These functions and routines allow PC-DMIS to easily program for measurement a variety of part features, adding them into the part program as "Auto Features". In many cases this automatic feature recognition is as simple as single-clicking with your mouse on the appropriate feature in the Graphics Display window. While auto features have their history in measuring sheet metal or other thin-walled materials using PC-DMIS's Direct Computer Control (DCC), today you can use them in both DCC and Manual mode to measure parts constructed from a variety of different materials.

To work with auto features, select the appropriate item from the Insert | Feature | Auto submenu. The Auto Feature dialog box for the selected item will appear. You can then interact with this dialog box to create the necessary auto features.

Display Menu Roadmap

The main topics in this section include:

  • Quick Ways to Create Auto Features

  • The Auto Feature Dialog Box

  • Inserting Auto Features

  • Auto Feature Field Definitions

  • Setting Up Relative Measure

Note: Depending on your specific version of PC-DMIS, the Auto Feature functionality may only be accessible as an added option to your basic PC-DMIS geometric software package. Consult your PC-DMIS vendor to determine if your version supports this functionality.


Quick Ways to Create Auto Features

In addition to keying in values to create your auto features, you can also do the following:

  • Box Selecting - Click and then drag your mouse to box select several CAD entities. Once you click Create PC-DMIS will create at once multiple auto features from the selected set of features.

  • Single-Clicking - Click the mouse once on a supported CAD entity to populate the Auto Feature dialog box with the appropriate nominal values.

More:

Box Selecting to Create Multiple Auto Features

'Multi-Clicking' and 'Single-Clicking' Auto Feature Creation


Box Selecting to Create Multiple Auto Features

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

Example of Slightly Rotated Part

Example of a Slightly Rotated Part

Selecting in the Z+ view, this circle's vector is perpendicular to the workplane and therefore PC-DMIS would not generate a circle for it.

If you tilted the part and then box-selected, then PC-DMIS would select this feature.

This example uses the Brown and Sharpe wireframe block (Bsbwire.igs) with auto circles:

If you box select the entire model, which is not in a complete +Z orientation, you will notice that the top and bottom circles/arcs are selected because they are the visible objects which also satisfy the Auto Circle cad filter logic.

Click Create from the CAD Select Dialog box. You will get something like this:

Notice that:

  • Circles/Arcs of the same diameter and vector are merged into a single feature. So, the top and bottom circles for the two center bores are merged into only two features, CIR1 and CIR13 (as were all the other features computed using the top and bottom circles/arcs). For the cone feature, however, since the diameters are different PC-DMIS creates two features (CIR12 & CIR14).

  • A circle gets created for the back bore, CIR15. This is because the model was rotated slightly. If the view had remained in a +Z orientation, then CIR15 would not have been created.

This example uses the Brown and Sharpe wireframe block (Bsbwire.igs) with auto cylinders:

If you do the same as in Example 1, but use auto cylinders instead, you will get something like this:

Notice that no cylinder was created at the cone feature because a cylinder must have length and the same diameter.

This example uses the Brown and Sharpe solid block (Bsbsolid.igs) with auto circles and cylinders.

If you box select to create features with a model that only has surface data (no wireframe data), you will need to slightly rotate the model in the view so that the desired surfaces are visible, like this:

Once you click Create and PC-DMIS generates the features from the selected objects, you will get something like this:

Circle Features

Cylinder Features

Notice that because of the tilting, you will not get a circle/cylinder feature at one end of the slot, nor at the top right OD cylinder.

This example uses the Hexagon model that ships with PC-DMIS (Hexblock_Wireframe_Surface.igs) with Auto Cylinders.

Put the model into a Z+ orientation and box select the entire model.

Click Create. You will get something that looks like this:

If you flip the part over to a Z- orientation and then tilt the part slightly, and box select, PC-DMIS will show something like this:

Click Create. PC-DMIS will display something like this:

Notice that PC-DMIS generated both an ID & OD cylinder feature for most of the cylinders on the part, such as the top right CYL3 and CYL10.

Box Selecting to Create Multiple Auto Features

You can draw a box on top of a CAD image to automatically create multiple auto features for these supported feature types:

  • Auto Vector Point

  • Auto Surface Point

  • Auto Edge Point

  • Auto High Point

  • Auto Line

  • Auto Circle

  • Auto Ellipse

  • Auto Cone

  • Auto Sphere

  • Auto Cylinder

To Box Select and Create Features

To use the box select method to quickly create multiple auto features of either the circle or cylinder auto feature types, follow this procedure:

  1. Import the CAD model that has the auto features you want to box select.

  2. Rotate the part and select either wireframe or solid to select a view that best shows the features you want to include.

  3. Access the Auto Feature dialog box (Insert | Feature | Auto) Display Menu Roadmap for either circle or cylinder auto features.

  4. With the dialog box open, click the mouse, and drag a box around those feature types for which you want to create auto features. Release the mouse button. PC-DMIS will display the CAD Select dialog box, showing the number of objects selected.

  5. Click Create. Based on the objects selected PC-DMIS will generate multiple auto features of the selected type.

See a brief demo on box selecting and creating multiple auto features

Box Selecting Details

  • Box selecting only works on objects visible in the Graphics Display window. This prevents unseen objects from being used in the creation of features.

  • Models with little or no wire frame geometry should be slightly tilted (or rotated) in the Graphics Display window so that the desired surfaces and features are visible.

  • Because of tessellation and display accuracy, the bleeding of underlying surfaces and curves may result in extra unexpected objects used to create the features. While PC-DMIS attempts to minimize this bleeding by comparing the selected objects with each other to determine the minimum number of pixels necessary to be considered a valid selection, this is not a fool proof method, and some mostly hidden objects may get selected in order to minimize the likelihood of eliminating a valid object.

  • When creating the features from the selected objects, objects with vectors perpendicular to the current view are mostly ignored. For example. Using the Hexagon block displayed in +Z with the entire model box selected, PC-DMIS will not generate a feature for the front bore that intersects the center bore.

  • PC-DMIS performs filtering routines to ensure that it doesn't use the same cad object to create another feature in the same position.

  • As PC-DMIS generates the features after you click Create, you can see each item's information displayed in the Status bar.

Example 1: Box Selecting Auto Circles with Wireframe Data

Example 2: Box Selecting Auto Cylinders with Wireframe Data

Example 3: Box Selecting Auto Circles or Cylinders with Surface Data

Example 4: Box Selecting Auto Cylinders with Both Wireframe and Surface Data

More:

Understanding the CAD Select Dialog Box


Understanding the CAD Select Dialog Box

This dialog box appears after you box select on a CAD model while the Auto Features dialog box remains open. It displays the number of selected CAD elements that can be used to generate features of the selected type.

Create: This button creates auto features of the selected type (currently only Circle or Cylinder auto features) from the selected CAD elements. PC-DMIS will close the CAD Select dialog box, and from each box selected element, PC-DMIS will generate the appropriate feature. The vector will be determined using the method selected from the Vector Use area.

Close: Closes this dialog box, canceling the box selecting operation.

Display Arrows: This check box displays or hides colored arrows showing the direction of vectors used by the methods in the Vector Use area.

The Vector Use area lets you choose the methods PC-DMIS should use to determine the vectors for the nearly created auto features.

  • Workplane: This method uses the vector of the currently active work plane as the vector for each individual feature.

  • Last Used: This method uses the last vector that was placed in the dialog box for the Auto Feature. This lets you specify one vector to be used for all the selected features.

  • From CAD: This method uses the vector that is specified by the CAD feature. This method becomes available if vector data is available for each feature.

  • Find Vector: This method finds the vector using the CAD surface data that is closest to the feature. This method is only available if surface data is available.


'Single Clicking' Auto Feature Creation

  • With the Auto Feature dialog box open, click once near but not on where the two surfaces meet. If you are using surface mode, PC-DMIS generates the point on the angle of the two surfaces.

With the Auto Feature dialog box open, click once on the planar surface that contains the circle for a hole, on the feature's wall, or on a cylindrical end of a stud.

  • The edge closest to the mouse-click determines whether the circle feature is a hole or a stud. (See Note B). However, due to how the CAD is sometimes defined, PC-DMIS cannot always determine this on its own.

  • If the circle has a length (depth) like a cylinder, then PC-DMIS uses the circle closest to where you clicked the mouse to define the center position.

  • PC-DMIS automatically fills in the dialog box and determines the circle's vector.

With the Auto Feature dialog box open, click once on the planar surface that contains the cone's hole, on the feature's wall, or on a conical end of a cone.

  • The edge closest to the mouse-click determines whether the cone feature is an inner cone or an outer cone. (See Note B). However, due to how the CAD is sometimes defined, PC-DMIS cannot always determine this on its own.

  • The vector of the cone points away from its apex.

  • PC-DMIS automatically fills in the dialog box and determines the center point. Inner cones use the larger radius for the center point. Outer cones use the smaller radius. PC-DMIS does this to avoid shank collisions when measuring the cone.

With the Auto Feature dialog box open, click once on the planar surface that contains the cylinder, on the feature's wall, or on a cylindrical end of an outer cylinder.

  • The edge closest to the mouse-click determines whether the circle feature is a hole or a stud. (See Note B). However, due to how the CAD is sometimes defined, PC-DMIS cannot always determine this on its own.

  • PC-DMIS automatically fills in the dialog box and determines the cylinder's vector. It uses the center location of the cylinder end closest to where the user mouse clicked.

  • With the Auto Feature dialog box open, click once anywhere. PC-DMIS automatically fills in the dialog box.

    • If using surface mode, PC-DMIS generates the edge on the nearest edge where you clicked.

    • If using wire frame mode, the edge is only selected. PC-DMIS requires a second click to create the edge point on the wire.

  • Same as Round Slot.

With the Auto Feature dialog box open, click once close to the back edge the notch. Single-clicking to create notch features, always defines it as an inner notch. PC-DMIS automatically fills in the dialog box.

With the Auto Feature dialog box open, click once on a polygon feature that contains five or more sides. PC-DMIS automatically fills in the dialog box and determines the starting side by the edge closest to the mouse click.

You can click on a polygon with less than three sides, but doing so will require additional clicks.

With the Auto Feature dialog box open, click once near an edge containing the corner point.

  • The closest edge to the mouse click determines the closest end point to the mouse click. This end point becomes the corner point.

  • PC-DMIS automatically fills in the dialog box.

How it Works:

  • PC-DMIS finds adjacent edges relative to the first edge. It tests each edge to see if it has an end point coincident to the corner point. If so, then it finds a point on that edge very near the corner point. This continues until two edges (and two points) are found that have unique vectors (ideally perpendicular) to each other and the first edge.

  • Once PC-DMIS has three points near the corner point, these three points are all on different edges. Using the two different points near the corner point, and the corner point, PC-DMIS computes three planes. For example, In this image, the YELLOW corner point and the RED and WHITE points create a plane whose vector is the BLUE arrow. Similarly, the YELLOW, WHITE, and BLUE points give us the RED arrow and the YELLOW, BLUE, and RED points give us the WHITE arrow.

With the Auto Feature dialog box open, if an inner round slot, click once on the planar surface that contains the rounded edge or the feature's wall. If an outer round slot, click on the top edge of the rounded end, away from where the curve ends and the planar sides begin or on the feature's wall. (See Note A).

  • The edge closest to the click determines whether the feature is an inner round slot or an outer round slot. (See Note B). However, due to how the CAD is sometimes defined, PC-DMIS cannot always determine this on its own.

  • PC-DMIS automatically fills in the dialog box and determines the slot's vector and orientation.

  • With the Auto Feature dialog box open, if an inner square slot, click once on the planar surface near any edge of the slot or on the feature's wall. If an outer square slot, click on any top edge or on the feature's wall. (See Note A).

    • The edge closest to the click determines whether the feature is an inner square slot or an outer square slot. (See Note B). However, due to how the CAD is sometimes defined, PC-DMIS cannot always determine this on its own.

    • PC-DMIS automatically fills in the dialog box and determines the slot's vector and orientation.

With the Auto Feature dialog box open, click once on the sphere's edge. PC-DMIS automatically fills in the dialog box.

With the Auto Feature dialog box open, click once anywhere. PC-DMIS automatically fills in the dialog box.

With the Auto Feature dialog box open, click once anywhere. PC-DMIS automatically fills in the dialog box.

  • If using curve mode, PC-DMIS snaps the point to the nearest wire.

  • If using surface mode, PC-DMIS generates the point where you clicked.

'Multi-Clicking' and 'Single-Clicking' Auto Feature Creation

In older versions of PC-DMIS you often had to provide multiple mouse clicks for PC-DMIS to generate an auto feature. Over the years PC-DMIS has continually increased its capability to select auto features on the screen with less and less mouse clicks.

The following table details for both Curve and Surface modes the auto features you can select with a single mouse click. It also lists the number of mouse clicks needed for features that don't yet support the single-click capability.

Auto Feature Type | Curve mode | Surface mode
Angle Point | No (2 Clicks) | Yes
Circle | Yes | Yes
Cone | Yes | Yes
Corner Point | Yes | Yes
Cylinder | Yes | Yes
Ellipse | Yes | Yes
Edge Point | No (2 Clicks) | Yes
High Point | Yes | Yes
Line | No (2 Clicks) | No (2 Clicks)
Notch | Yes | Yes
Plane | Yes | Yes
Polygon | Yes | Yes
Round Slot | Yes | Yes
Square Slot | Yes | Yes
Sphere | Yes | Yes
Surface Point | Yes | Yes
Vector Point | Yes | Yes

Using Single-Click Mode

  • Angle Point Features:

  • Circle Features:

  • Cone Features:

  • Cylinder Features:

  • Edge Point Features:

  • Ellipse Features:

  • Notch Features:

  • Polygon Features:

  • Corner Point Features:

  • Round Slot Features:

  • Square Slot Features:

  • Sphere Features:

  • Surface Point Features:

  • Vector Point Features:

By default, PC-DMIS will attempt to interpret a single mouse click and generate the auto feature from that input. If for some reason this fails, PC-DMIS will automatically switch to the older multi-click mode of input.

Using Multi-click Mode

Follow the instructions on the status bar; it will walk you through what hits to take.

Temporarily Switching to Multi-Click Mode

If you want to switch to the multi-click mode of input temporarily, you can easily do so by taking two clicks within three pixels of each other. The Auto Feature dialog box must be open. When you take the second mouse click, PC-DMIS switches to multi-click mode and draws the cross-hairs at the location of the second mouse click. This becomes the first mouse click of the multi-click mode. PC-DMIS then waits for the remaining mouse clicks needed to generate the feature. Once the feature is generated PC-DMIS switches back to the single-click mode.

Permanently Switching to Multi-Click Mode

If you want to turn off the single-click mode functionality permanently, simply access the PC-DMIS Settings Editor, and set the SingleClickCadSelectionDisabled entry (located in the AutoFeatures section) to TRUE. When you restart PC-DMIS, the software will be in Multi-Click Mode.

More:

Note A

Note B


Note A

In this image:

  • The GREEN marks should work because the line/curve (or edge if it is a surface) that is closest to the marks is a line/curve that is in the plane that defines the slot.

  • The RED mark will not work because the line (or edge if it is a surface) that is closest to the mark is a line/curve that is not in the plane that defines the slot.

  • The YELLOW mark will work if the surface is a cylinder.


Note B

In this image, showing a flipped over, Z- orientation of the Hexagon model:

  • The RED marks will produce an Outer Diameter (OD) feature.

  • The WHITE marks will produce an Inner Diameter (ID) feature.


The Auto Feature Dialog Box

Auto Feature Dialog Box Notes

Auto features are created using an Auto Feature dialog box, accessible by selecting Insert | Feature | Auto Feature and then selecting an item from that menu.

Probe Deflection and CAD Click Behavior

If the Auto Feature dialog box is open and PC-DMIS detects a probe hit, it assumes you are trying to learn the currently selected auto feature type. It will then prompt you to measure the remaining hits (if any) to complete it.

Similarly, if you click on the CAD data while the Auto Feature dialog box is open, PC-DMIS will assume that the currently selected feature type is being learned and will populate the dialog box with the gathered information from the CAD model.

Changes in 4.2

In an effort to support the expanding role of auto features on a wider array of non-contact machines such as vision and laser machines, and to simplify the Auto Feature dialog box, the following changes were applied beginning with version 4.2:

  • Dialog box controls that were specific to contact probes such as Number of Hits, Number of Sample Hits, Depth, and so on, have been moved to the Probe Toolbox. See the "Using the Probe Toolbox" topic in the "Using Other Windows, Editors, and Tools" section for more information.

  • Several check boxes, options, and buttons are now depicted as clickable icons. You can hover your mouse over these icons, viewing their tool tips to determine their purpose, and then use them just as you did with the previous interface.

  • Several items, such as items specific to Vision or Laser, may not be supported by your current configuration. While they remain visible on the dialog box, they will be unavailable for selection. The requirements to make them available for selection are listed in their respective topics.

Changes in 4.3

  • Because the items in the Probe Toolbox are so frequently used when creating Auto Features, in version 4.3 the Probe Toolbox also functions as an embedded portion of the Auto Feature dialog box.

  • The Auto Feature dialog box docks into the left and right sides of the screen by default. If desired, you can easily change its state to hover over the user interface instead. To do this,

  1. Press the CTRL key, then drag the dialog box to a new location and release the mouse. The dialog box is now hovering over the interface.

  2. On the title bar, on the right side, click the left-most icon.

  3. From the resulting menu, choose Floating. The next time you open the dialog box, it will remain in this floating mode. To return the dialog box to a dockable mode, select Dockable from that menu instead.

Auto Feature Dialog Box - Version 4.1 and Previous:

Auto Feature Dialog Box - Version 4.3 and Later:

More:

Auto Feature Type list

ID box

Feature Properties area

Measurement Properties area

Advanced Measurement Options area

Auto Feature Command Buttons


Auto Feature Type list

The Auto Feature Type list shows the currently selected auto feature type. You can also use this list to change to a different auto feature type. All the supported auto features for your configuration are available from this list. If you change to a different auto feature type, the Auto Feature dialog box changes its content with items used to create the newly selected feature type.


ID box

The ID box shows the current ID for the auto feature being created. You can change the ID to something different by modifying this value.


Feature Properties area

The Feature Properties area of the Auto Feature dialog box contains some or all of the following items, depending on the auto feature being created.

XYZ Point boxes | IJK Surface boxes | IJK Edge boxes
IJK Surf 1 Vec boxes | IJK Surf 2 Vec boxes | IJK Surf 3 Vec boxes
IJK Line Vec boxes | IJK Angle boxes | XYZ Start Point boxes
XYZ Start / End boxes | XYZ Center boxes |

Some Examples:

Auto Line Vectors


XYZ Point boxes

For a High Point feature, the XYZ Point boxes display the X, Y, and Z nominal for the start point.

After the new value is created, PC-DMIS will draw the animated probe at the new location. This location indicates the beginning position of the search. After the execution is complete, the XYZ point will contain the high point in the current workplane. Subsequent executions however will use the original start point for the search.

For all other feature types, the XYZ Point boxes display the X, Y, and Z nominal for the location of the feature.

After the new value is created, PC-DMIS will draw the animated probe at the new location. This location indicates where it will be taking the hit on the part.

For information on the X, Y, and Z axes check boxes, see the "Find Nearest CAD Element" topic.

Icon | Description
 | Polar / Cartesian Toggle
 | Find Nearest CAD Element
 | Read Point from Machine


IJK Surface boxes

This is a user supplied I, J, K normal vector. The I, J, K should always point away from the surface. After the new value is created, PC-DMIS will normalize the vector, making its length one unit. This vector is used for probe compensation. PC-DMIS will display a corresponding colored arrow showing the surface vector.

If you can't see the vector arrow or it appears too small, try changing the value in the Pt. Size box in the Analysis area. Setting Pt. Size to 0 will generally set both the point and the arrow to a desirable size.

For Vector Point, Surface Point, and High Points, the IJK Surface boxes display the approach direction for the hit that was taken to create the auto feature.

For High Points, after execution, the IJK Normal Vector will display the approach vector for the high point in the current work plane

For Circle, Cylinder, Sphere, and Cone Features, the IJK Surface boxes define the feature centerline. A cone's vector is very important. The normal vector of a cone feature is the direction of the cone from its tip to its base. The height and depth of a cone are always relative to this vector.

For Square Slot, Round Slot, Ellipse, and Notch Features, the IJK Surface boxes define the surface normal vector of the plane that the feature lies in (the plane parallel to the feature).

For a Plane feature, the IJK Surface boxes define the approach direction for the plane's hits.

For a Line feature, the IJK Surface boxes help define the edge for the auto line hits. Specifically, it defines the surface perpendicular to the surface on which the hits for the line are taken. In other words, it is always perpendicular to the edge vector. See "Example of Auto Line Vectors".

Icon | Description
 | Find Vectors
 | Flip Vector
 | Use Thickness
 | Use Probe Vector


Polar / Cartesian Toggle

This icon lets you switch your coordinate system between either Cartesian or Polar modes. These choices allow you to select the coordinate system that will be used to display the point or center values for the auto feature.

  • In Cartesian mode, when the icon is depressed, the values are displayed in XYZ.

  • In Polar mode, when the icon is raised, the values are displayed as radius, angle and height (shown as R, A, and H in the dialog box). The height depends on the workplane currently being used. If the current workplane is ZPLUS, the height is the Z value.


Find Nearest CAD Element

The Find Nearest CAD Element icon tells PC-DMIS to find the nearest CAD element in the Graphics Display window based on the XYZ location and any selected axis (or axes). PC-DMIS allows you to either type or surface-select the pertinent information.

Understanding Axes Check Box Selecting

  • For Vector Points or Surface Points - If you select an X, Y, or Z axis check box, PC-DMIS interprets the selection as the axis that will be modified when you click the Find Nearest CAD Element icon.

  • For Edge Points or Angle Points - If you select an X, Y, or Z axis check box, PC-DMIS interprets the selection of the axis as a selection of the one axis that will NOT be modified when you click the Find Nearest CAD Element icon. For example, if you select the X check box, PC-DMIS will actually check mark the Y and Z check boxes signifying that the Y axis and Z axis values will be modified by the Find process.

Understanding the Find Operation without Selecting Axes Check Boxes

  • For Edge Points and Angle Points - If you click the Find Nearest CAD Element icon without an axis selection, PC-DMIS will find the closest CAD edge or angle point.

  • For Vector Points and Surface Points - If you click the Find Nearest CAD Element icon without an axis selection, PC-DMIS will find the closest CAD along the Normal vector specified in the dialog box. PC-DMIS will then populate the dialog box with the found vector.


Read Point from Machine

The Read Point from Machine icon immediately reads the probe's current position and fills its location into the XYZ of the feature.


Find Vector(s)

This icon is available only on these auto features: Vector Point, Surface Point, and Edge Point.

The Find Vector(s) icon will pierce all surfaces along the XYZ point and IJK vector looking for the closest point. The surface normal vector will be displayed as the IJK NOM VEC but the XYZ values will not change.


Flip Vector

The Flip Vector icon allows you to reverse the direction of the surface vectors. Click on Flip Vector to reverse the displayed values.


Use Thickness

The Use Thickness icon displays a T list (T for "thickness") and a box where you can type the part thickness value.

When measuring the side of the part that is modeled in PC-DMIS, the part thickness value should be set to zero. The part thickness option should only be used when measuring the side of the part that is not drawn in the CAD data.

Defining a thickness amount is primarily used for thin parts (plastic or sheet metal) where the CAD data only describes one side and you want to measure the other side.

Often with thin parts, the CAD engineer will only draw one side of the part, and then specify the material thickness. PC-DMIS will apply this material thickness automatically when using the CAD surface data.

Positive or negative values can be used. This thickness will be applied automatically along the surface normal vector each time CAD data is selected. If the feature has more than one normal vector (i.e. angle points and corner points), the thickness will be applied along the first normal vector.

The Edit window command line for this option would read:

THEO_THICKNESS = n

or

ACTL_THICKNESS = n

n: a numerical value indicating the thickness of the part.

From the T list, select Theo, and in the box below the T list, type the thickness value when the theoretical values need to be adjusted by a thickness because measurements are being done on opposite side of material.

From the T list, select Actual, and in the box below the T list, type the thickness value when measurements are being adjusted by the thickness back to the original theoretical XYZ locations. With this option it will appear that the theoretical and measured values have not been offset and the target is offset. You still need to modify your target so that PC-DMIS drives to the correct location.

Select the None option if you don't need to apply thickness. For most machines, a thickness of 0 or selecting None has the same effect. For portable arm machines, however, selecting None and specifying a value actually applies the thickness to a shank style measurement. In this type of measurement, you use the cylindrical shank of the probe to measure instead of the probe tip. To do this you need to first define sample hits. PC-DMIS can then determine the location of the supported feature (Circles, Ellipses, Slots, and Notches) using the shank.

Note: When switching between theoretical and actual thickness, the measurement location will not change. When using theoretical thickness, PC-DMIS modifies the theoretical, measured, and target locations to include the (theoretical) thickness. When using actual thickness, PC-DMIS modifies only the target location by adding the (actual) thickness value to the original theoretical location. Later, after feature measurement, PC-DMIS subtracts the (actual) thickness from the measured value. Both methods yield the same measurement location. It is simply how PC-DMIS reports the feature's theoretical, actual, and target values that changes.


Use Probe Vector

The Use Probe Vector icon appears for selection on the Auto Feature dialog box for an Auto Sphere feature. This icon tells PC-DMIS to use the probe's vector for the IJK Surface boxes used to define the surface vector.


IJK Edge boxes

These boxes are only available for the Edge Point and Line features.

The IJK Edge boxes display the approach direction (vector) for the edge hit or for the points of an auto line. This is a user supplied I, J, K measured vector. The I, J, K should always point away from the edge and be perpendicular to the edge that is being measured.

To change the approach vector:

  1. Select the existing value.

  2. Type a new value.

After a new value is created, PC-DMIS will normalize the vector, making its length one unit.

Icon | Description
 | Swap Vectors
 | Flip Vector
 | Use Thickness


Swap Vectors

The Swap Vectors icon causes the current Edge vector and Surface vector to switch vectors with each other.


IJK Surf 1 Vec boxes

These boxes are only available for these auto features: Angle Point or Corner Point

The IJK Surf 1 Vec boxes display the surface normal vector of the first surface that will be measured. The I, J, K vector is expected to point away from the surface that is being measured. PC-DMIS will display a corresponding colored arrow showing the surface vector.

If you can't see the vector arrow or it appears too small, try changing the value in the Pt. Size box in the Analysis area. Setting Pt. Size to 0 will generally set both the point and the arrow to a desirable size.

To change a value:

  1. Select a box to change.

  2. Type a new value.

After a new value is created, PC-DMIS will normalize the vector, making its length one unit.


IJK Surf 2 Vec boxes

These boxes are only available for these auto features: Angle Point or Corner Point

The IJK Surf 2 Vec boxes display the surface normal vector of the second surface that will be measured. The I, J, K vector is expected to point away from the surface that is being measured. PC-DMIS will display a corresponding colored arrow showing the surface vector.

If you can't see the vector arrow or it appears too small, try changing the value in the Pt. Size box in the Analysis area. Setting Pt. Size to 0 will generally set both the point and the arrow to a desirable size.

To change a value:

  1. Select the box to change.

  2. Type a new value.

After a new value is created, PC-DMIS will normalize the vector, making its length one unit.

Icon | Description
 | Flip Vector


IJK Surf 3 Vec boxes

These boxes are only available for the Corner Point feature.

The IJK Surf 3 Vec boxes display the surface normal vector of the third plane that will be measured. The I, J, K vector is expected to point away from the plane that is being measured. PC-DMIS will display a corresponding colored arrow showing the surface vector.

If you can't see the vector arrow or it appears too small, try changing the value in the Pt. Size box in the Analysis area. Setting Pt. Size to 0 will generally set both the point and the arrow to a desirable size.

To change this value:

  1. Select the Surf 3 Vec boxes to be changed

  2. Type a new value.

After a new value is created, PC-DMIS will normalize the vector, making its length one unit.

Icon | Description
 | Flip Vector


IJK Line Vec boxes

These boxes are only available for the Angle Point and Line features.

The IJK Line Vec boxes display the vector of the line on which the angle point or line lies. This is a user supplied I, J, K normal vector.

To change the approach vector:

  1. Select the existing value.

  2. Type a new value.

After a new value is created, PC-DMIS will normalize the vector, making its length one unit.

Icon | Description
 | Flip Vector


IJK Angle boxes

For Circle, Cylinder, Sphere, and Cone features, the Angle boxes define the 0° position about the normal vector. The start and end angles are calculated relative to this vector. If the vectors are not perpendicular, the angle vector is adjusted to the normal vector.

For Square Slot, Round Slot, and Ellipse features, the Angle boxes define the feature's secondary vector. This is a user supplied I, J, K normal vector. The feature centerline and normal vector must be perpendicular to each other.

For a Notch feature, the Angle boxes define the notch's secondary vector orientation. This is a user supplied I, J, K normal vector along the back side of the slot. The notch angle vector and notch normal vector must be perpendicular to each other.

For a Plane feature, the Angle boxes define the plane's secondary vector. This helps control the orientation of the plane's path.

To change the Angle Vector:

  1. Select the boxes you want to update.

  2. Type a new value.

After a new value is created, PC-DMIS will normalize the vector, making it a length of 1.

Icon | Description
 | Flip Vector


XYZ Start Point boxes

The XYZ Start Point boxes define the XYZ location where the search will begin for the highest point in the search region.

Icon | Description
 | Polar / Cartesian Toggle
 | Find Nearest CAD Element
 | Read Point from Machine


XYZ Start / End boxes

The XYZ Start and XYZ End boxes display the starting and ending points for an Auto Line feature. You can click on the Read Point from Machine icons to get the current probe's XYZ location. Or you can simply take hits points on the part to show the start and end point values.

Note that the End boxes only appear if you select Yes from the Bounded list from the Measurement Properties area.

See the "Bounded List" topic.

Icon | Description
 | Polar / Cartesian Toggle
 | Find Nearest CAD Element
 | Read Point from Machine


XYZ Center boxes

These boxes are only available with these auto feature types: High Point, Plane, Circle, Ellipse, Round Slot, Square Slot, Notch, Polygon, Cylinder, and Sphere

For Plane, Circle, Ellipse, Round Slot, Square Slot, Polygon, Cylinder, and Sphere, the XYZ Center boxes indicate the nominal center location of the feature.

For a Notch, these boxes indicate the midpoint of the notch along the non-parallel side.

For a High Point, these boxes indicate the center of the search region.

To change this value:

  1. Select the existing value.

  2. Type a new value

After the value is created, PC-DMIS will draw the animated probe at the new location.

Cylinder Note: It is important to remember that if a cylinder is defined as a hole, the center point must be defined at the top of the cylinder. If the cylinder is defined as a stud then the center point must be defined at the bottom of the cylinder.

Icon | Description
 | Polar / Cartesian Toggle
 | Find Nearest CAD Element
 | Read Point from Machine


Example of Auto Line Vectors

1 - IJK Surface, 2 - IJK Line Vec, 3 - IJK Edge


Measurement Properties area

The Measurement Properties area of the dialog box contains some or all of the following items, depending on the auto feature being created.

More:

Snap list

Measure Order list

Interior / Exterior list

Increment box

Tolerance box

Box / Circular list

Width box

Length box

Bounded list

Pattern list

Display list

Start and End Angles

Inner/Outer list

Diameter box

Meas Angle box

Meas Width list

Number of Sides list

Corner Rad box

Auto Feature Toggle Bar


Snap list

The Snap list only becomes enabled when working with a Vector Point or Surface Point. Because snap only functions well after a rough alignment, it is disabled until an alignment is established.

The Snap list determines whether or not measured values "snap to" the theoretical vector for a Vector Point or a Surface Point. This simulates a perfect machine staying exactly on the approach vector, not deviating by as much as a micron when measuring the point. If you set this to Yes, then the measured values snap to the theoretical vector with all the deviation along the vector of the point. This is useful for focusing on a deviation along one particular vector.

For example, suppose you want to measure the height (in Z) of a table's top. You don’t really care about your X and Y (secondary and tertiary) axis errors which can occur from machine drift (tunneling error). In this case, with Snap set to Yes, you will only be reporting the Z value. Any errors in X and Y will be ignored as the measured X and Y values will equal their theoretical counterparts.


Measure Order list

This is only available with the edge point feature. | The Measure Order list in the Measurement Properties area allows you to choose the order in which the sample points will be taken before the final hit is taken. The choices are: SURFACE, EDGE, or BOTH.
 | SURFACE | SURFACE measures the three hits, first on the surface, then on the edge.
 | EDGE | EDGE measures the two hits, first on the edge then the surface.
 | BOTH | BOTH measures the surface, then the edge, and then the surface again.


Interior / Exterior list

This list is available only on the Angle Point auto feature.

The Interior / Exterior list defines the angle as either interior or exterior.

Interior angles have the solid angle of the part less than 180°, while exterior angles are greater than 180°.

It is very important to make sure this option is set correctly because of the differences in measurement sequence for each type.


Increment box

This box is available only on the High Point auto feature.

The Increment box allows you to define the increment used when for the highest point in the search area. During execution PC-DMIS begins searching from the start point (or search point) by the amount specified in the Increment box.


Tolerance box

This box is available only on the High Point auto feature.

The Tolerance box allows you to define a tolerance value that essentially tells PC-DMIS when to stop searching for a high point within a given area. The tolerance value should always be less than the increment value. During the search process, PC-DMIS decreases the increment value until it is less than or equal to the Tolerance value supplied, indicating that the highest point in the current work plane has been located.


Box / Circular list

This list is only available for the High Point feature.

The Box / Circular list allows you to define the search mode that PC-DMIS will use to return the highest point. You can choose Box mode or a Circular mode.

Box Mode

Selecting Box defines a rectangular search region for the High Point feature. The rectangle is defined by the Width and Length values. PC-DMIS will report the highest point within that area.

Circular Mode

Selecting Circular switches the Width and Length boxes to Outer Rad and Inner Rad boxes. The search region for the High Point feature becomes a circular search band specified by the Outer Rad and Inner Rad values.

  • If a complete circular region is desired, set the inner radius to 0.

  • If a circular search line is desired, set the inner and outer radii to the same value.

The highest point along the circumference will be reported.

No matter which mode you select, the start point should lie within the defined search region. For the special cases of line searching, the start point will automatically be adjusted to be on the line.


Width box

High Point | The Width defines the width of the search region. If you have a value for Length but leave the Width value 0, then the Width value corresponds to the length along the major axis of the current work plane.
Square Slot, Round Slot, Ellipse, or Notch | The Width box displays the width of the feature.


Bounded list

This list is currently only available for the Line feature.

The Bounded list defines whether or not the auto line is bounded by an ending point or an unbounded, open line.

If you select Yes, then some End boxes will appear in the Feature Properties area with the XYZ values for the ending point. PC-DMIS automatically calculates the length of the line based off of the distance between the Start and End points and displays the line's length in the Length box.

If you select No, then PC-DMIS expects you to type a value in the Length box. It then calculates the line from the starting point, along the line vector for the distance specified in the Length box.

See "XYZ Start / End Point Boxes" and "Length box" for additional information.


Length box

High Point

The Length defines the length of the search region. If you have a value for Width, but leave the Length value 0, the Length value corresponds to the length along the minor axis of the current work plane.

Square Slot, Round Slot, Ellipse, Notch, or Line

The Length box displays the length of the feature.

Cone

The Length box displays the length of the cone.

A positive Length value indicates that the centroid is towards the cone's tip (the end of the cone feature that has the smaller diameter).

A negative Length value indicates that the centroid is towards the cone's base (the end of the cone feature that has the larger diameter).

Cylinder

For a hole, the Length box defines the nominal length of the feature. If you enter a Length value but do not define a depth, PC-DMIS equally divides the Length value by the number of rows indicated in the Levels box.

The probe then works its way down the cylinder in increments until it reaches the indicated length value.

If a depth value is defined, the actual measured feature becomes the length minus the depth value.

For a stud, if the Sample Hits list displays a non-zero value, PC-DMIS will take an extra hit on the top of the stud in the center as long as the length value is a non-zero positive value. It then will compute the length of the stud.


Pattern list

For the Auto Plane feature, the Square and Radial options in the Pattern list allow you to determine whether the hits for the plane feature are taken in a square or radial pattern.

If you select Radial, PC-DMIS will create the hits in rows coming from the plane center in a circular or radial pattern. PC-DMIS takes 360 degrees and divides it by the value in the # Rows box to determine the angle between each row. For example, if the # Rows box had 6 and your # Hits box had 3, PC-DMIS would generate a row of three hits every 60 degrees, for a total of 18 hits.

If you select Square, PC-DMIS will create the hits in a grid pattern about the center point of the plane. For example, if the # Rows box had 3 and the # Hits box had 4, PC-DMIS would take a total of 12 hits in a grid pattern with the plane center point at the center.


Display list

For an Auto Plane feature, the Display list determines how the plane will be displayed in the Graphics Display window.

  • Selecting Triangle will cause the plane to appear as a triangle symbol around the region where the plane hits will be taken.

  • Selecting Outline will cause the plane to appear as a square or rectangular outline around the region where the plane hits will be taken.


Suppose you have a sphere feature with a Start Angle of 0, an end angle of 90, and an IJK Angle Vector of 1,0,0 (along the X+ axis). The starting and ending angles are relative to the angle vector. Measurement will proceed in a counterclockwise manner, equally spaced between 0 and 90 degrees:

Screen capture of an Auto Sphere showing path lines and hit locations from Start Angle of 0 (at A) and End Angle of 90 (at B).

Suppose you have an external sphere that's halfway visible above the surrounding surface. If you use a Start Angle 2 value of 0 degrees, the probe would collide with the surrounding surface when it attempted to take the hits around the sphere's equator. A slight adjustment in the Start Angle 2 value will resolve this problem.

If you create the sphere with 20 hits, and give it a Start Angle of 45, an End Angle of 270, a Start Angle 2 of 20, and an End Angle 2 to 90, PC-DMIS would space 19 hits around the sphere 20 degrees up from the equator of the sphere like this:

A Top View of the Sphere | A Side View of the Sphere

This provides the probe with plenty of room to measure the sphere. The sphere's second level would only consist of one hit on top of the sphere.

If you adjusted End Angle 2 to something like 110 degrees, the second level of hits would have 5 hits adjusted 20 degrees down from the top of the sphere:

Start and End Angles

For a circular feature, the different Start Angle and End Angle boxes define where PC-DMIS probes the feature. For many situations the default values are sufficient, but there may be times when you need to measure a circular feature that is partially obstructed by another feature or otherwise only partially available for probing. In version 4.2 and later you should enter the start and end angles in a counter-clockwise manner.

Start and End Angle Examples

For example, if you measure a hole with six hits and a Start Angle of 0 and an End Angle of 360, it will look something like this:

Notice that the Start Angle and the End Angle are the same: 0 and 360. Also, the six points making up the circle feature are equally distributed between the two angles. In this case each point is taken at 60 degree intervals with the last point taken at 300 degrees.

However, changing the Start Angle to 45 (red arrow) and the End Angle to 270 (orange arrow) limits the hits to a certain portion of the circular feature:

Start and End Angle Boxes

Angle Type

Description

Notes

Start Angle and End Angle boxes

These boxes let you change the default starting and ending angles on the feature. This is a user supplied angle in decimal degrees. The starting and ending angles are relative to the values in the IJK Angle Vector boxes.

If you rotate the view of the feature so that you look down its center, PC-DMIS will space the desired number of hits beginning at the Start Angle in a counterclockwise direction around the centerline until it reaches the End Angle as shown in this example:

These boxes are only available for Circle, Cylinder, Ellipse, Cone, and Sphere auto features.

Start Angle 2 and End Angle 2 boxes

The Start Angle 2 and End Angle 2 boxes let you determine the secondary starting and ending angle on a sphere feature. This angle is in decimal degrees.

The secondary angle, if looking at a side view of a sphere, starts at the sphere's equator and then moves towards the top pole as the angle increases to 90 degrees and then back down to the equator on the opposite side of the sphere at 180 degrees.

These angles allow you to place the hits in an area where the probe can reach them without obstruction.

Consider this example:

This box is only available for Sphere auto features.

Offset Information: When generating an arc using one of the circular auto features (Circle, Cylinder, Cone, Sphere, or Round Slot), PC-DMIS will offset the start and end angles each by two degrees. This way arcs retrieved from the CAD aren't probed on their starting and ending angles, possibly catching a corner. This shouldn't be an issue for the most part unless you are attempting to generate a small arc of only a few degrees. For example, if you want to generate a four degree arc of an Auto Circle you will need to type in an eight degree arc parameter in the Start Angle and End Angle boxes, knowing that PC-DMIS will shorten the arc by two degrees on each angle.


Inner / Outer list

The Inner / Outer list tells PC-DMIS to construct the Auto Feature as either an internal feature or an external feature.

  • If you select Out, PC-DMIS constructs the circle as an external feature that protrudes from its surrounding surface.

  • If you select In, PC-DMIS constructs the feature as an internal feature that sinks into its surrounding surface.


Diameter box

This box is only available for these auto features: Circle, Cylinder, Sphere, Cone, Polygon

The Diameter box defines the diameter of the feature. In the case of a stud, the diameter box displays the nominal, user supplied value.

For a cone, this value represents the nominal diameter at the end of the cone where you've defined the X,Y, and Z location.

For a polygon, the diameter is the distance between two opposing sides of even-sided polygons. For other polygons, such as an equilateral triangle, it is twice the radius of the largest circle you can inscribe inside the polygon.

To change the feature's diameter:

  1. Select the existing value.

  2. Type a new value.

Once the feature is created, PC-DMIS updates the size of the feature in the Graphics Display window.


Direction list

The Direction list specifies the direction in which the hits are taken.


Meas Angle box

Meas Ang box

Round slots have two rounded ends, each having up to 180 degrees of measurement radius. The value in the Meas Ang box defines how much of the radius to measure. PC-DMIS takes the input value and divides it in two, measuring half on each side of the slot angle vector.

Example: Suppose you type 90 in this box. When creating the Round Slot, PC-DMIS would then measure 45 degrees to the left, and 45 degrees to the right of the angle vector (or vice versa depending on the angle vector).


Meas Width list

This list is available only on the Square Slot auto feature.

When you select Yes from Meas Width and then click the Create button, PC-DMIS will do the following during measurement:

  • Measure two hits on the side of the slot.

  • Adjust the angle vector.

  • Measure two hits on the opposite side to calculate the width.

  • Adjust the position of the last two hits at each end for the width.

Note: Generally, Square Slots only require five hits. With this option, however, taking six hits will yield a better measurement of the width.


Num Sides list

The Num Sides list defines the number of sides making up the polygon feature.


Corner Radius box

Corner Rad (Radius) Box

This box is only available for these feature types: Square Slot Notch, Polygon.

Square Slots, Notches, and Polygons are not always exactly square. They often have radii instead of corners. The Corner Rad box holds a value the size of that radius. The radius value controls where the hits take place on these features.

For a Square Slot, it is used to determine the location of each hit during the measurement of the slot to avoid hitting on the radii.

For a Notch Slot, hits along the edge opposite the open side will be adjusted off the radius.

For a Polygon, hits along the polygon edge are adjusted from the corners of the feature adjusted off the radius.


Auto Feature Toggle Bar

The Auto Feature dialog box in version 4.2 and higher contains a toggle bar—a series of toggle icons that allow you to turn certain functionality on or off. This bar appears in the Measurement Properties area and contains these icons.

Icon | Description
 | Measure Now Toggle
 | Re-Measure Toggle
 | Auto Wrist Toggle
 | Clear Plane Toggle
 | Circular Moves Toggle
 | Manual Pre-Position Toggle
 | Show Hit Targets Toggle
 | View Normal Toggle
 | View Perpendicular Toggle
 | Void Detection Toggle
 | Probe Toolbox Toggle
 | Show Measured Points Toggle
 | Show Filtered Points Toggle


Measure Now and Re-Measure Toggle icons

Measure Now Toggle and Re-Measure Toggle

Measure Now Toggle icon | If selected, this icon begins the measurement process for this auto feature immediately after you click the Create button. PC-DMIS will measure the part based on the values specified in the Auto Feature dialog box.
Re-Measure Toggle icon This icon is available for these auto features: Circle, Cylinder, Square Slot, Round Slot, and Notch. | If selected, this icon automatically re-measures the feature against the measured values obtained the first time the feature is measured.


Auto Wrist Toggle

This icon chooses the best wrist position to measure this Auto Feature's hits. Upon creation, it will automatically insert a tip command before the Auto Feature.

This icon tells PC-DMIS to choose the best wrist position to measure the Auto Feature. Upon feature creation, the software inserts the tip command before the Auto Feature.

  • If the this icon is selected, PC-DMIS will choose a position that most closely approximates the best approach direction:

    • For edge and angle point features, the best approach direction is the average of the two surface vectors.

    • For corner point features, the best approach direction is the average of the three surface vectors.

    • For all other auto types, the best approach direction is the feature surface vector.

  • If this icon is not selected, PC-DMIS will use the current wrist position for all hits made.

You can also turn this option on globally by selecting the Automatically Adjust Probe Head Wrist check box. See the "Automatically Adjust Probe Head Wrist" topic in the "Setting your Preferences" section.


Clear Plane Toggle

This icon lets you determine whether or not PC-DMIS inserts an automatic MOVE/CLEARPLANE command before measuring the first automatic hit of any auto features created after selecting the toggle icon.

Note: This icon only becomes available for selection if your part program is in DCC Mode and if you have a clearance plane already defined.

  • If selected, PC-DMIS will automatically insert a MOVE/CLEARPLANE command (relative to the current coordinate system and part origin) into the Edit window before the first automatic hit of the feature. This causes the probe to move to the defined clearance plane before measuring the feature. After the last hit on the feature is measured, the probe will stay at probe depth until called to the next feature.

  • If not selected, PC-DMIS creates Auto Features normally without inserting any MOVE/CLEARPLANE commands.

Using clearance planes reduces programming time because the need to define intermediate moves is reduced. It can also help protect your hardware from an inadvertent collision with the part. (See "Parameter Settings: Clear Plane tab" in the "Setting your Preferences" section for additional information on Clearance Planes.

Important: When measuring studs, be sure to set the spacer value to a distance that will allow the probe to move around the stud.


Circular Moves Toggle

This icon determines whether or not the probe will move along an arc as opposed to usually moving in a straight line when moving from one hit to the next. This option is particularly helpful when working with ring grooves.

This toggle icon is available for these auto features: Circle, Cylinder, Cone, Sphere, and Plane. For a Plane feature it becomes available if you are using a radial pattern for the feature's hits.

See "Inserting a Move Circular Command" in the "Inserting Moves" section for information on inserting circular moves into the Edit window.


Manual Pre-Position Toggle

This icon only functions if you have PC-DMIS Vision enabled on your portlock.

If selected, this icon prompts the user to move the camera to the position that is over the target before continuing. See the PC-DMIS Vision documentation for additional information.


Show Hit Targets Toggle

Clicking this icon shows the path lines and the hit locations for the current feature. If the Probe Toolbox is visible, it also displays the toolbox's Hit Targets tab. Deselecting it hides this information.

The path lines appear as green lines on the CAD model. The red line indicates the starting hit and the orange line, the ending hit. You can also modify hit locations by simply selecting and dragging the lines with your mouse.

You can also right-click on any path line or hit and use a shortcut menu to perform a variety of functions. See the "Auto Feature Path Lines Shortcut Menu" topic in the "Using Shortcut Keys and Shortcut Menus" chapter for more information.

The following table explains this functionality by using an auto circle feature as an example.

In this example, the starting and ending angles are set to measure only 180 degrees of the circle with four hits.

If you edit the starting or ending angle boxes, the hits display changes as well.

For example, changing the ending angle from 180 to 360, PC-DMIS then would then show the hits around the entire circle.

Alternately, with supported auto features, you can click on a hit target and drag it to a new location. The start or ending angle angles in the dialog box will update themselves accordingly.

You can click on a path line and drag any hit to a new location.

To modify a path line, move the mouse over the path line until PC-DMIS highlights it in red, then click and drag the hit to a new location.

Suppose your auto circle uses three sample hits to locate the surface around the circle. PC-DMIS shows these lines as well.

To modify sample hit path lines, click on and drag these lines to a new location.

  • If you don't have user-defined hits, PC-DMIS dynamically updates the Spacer value as well as the feature hits.

  • If you already have user-defined hits, PC-DMIS will modify only that one sample hit's location.


View Normal Toggle

This icon is unavailable for selection if your part program is in Manual mode.

Clicking this icon orients that CAD so that you look down on the feature. Deselecting it returns the CAD to the previous view. You can also select this by right-clicking on the path and selecting View Normal from the resulting menu.

Example Circle with View Normal


View Perpendicular Toggle

This icon is grayed out and unavailable for selection if your part program is in Manual mode.

Clicking this icon orients the CAD so that you look at the side of the feature. This is ideal for defining a feature's depth or adding additional rows of hits for features that support additional levels such as cones or cylinders. To set additional rows, right-click and select Add Row from the resulting menu.

Example Cylinder after View Perpendicular

Deselecting View Perpendicular Toggle returns the CAD to the previous view. You can also set the view to perpendicular, by right-clicking on the path and selecting View Perpendicular from the resulting menu.

With Show Path Toggle and View Perpendicular selected, you can view the feature in its perpendicular view and see at what depth PC-DMIS will take the hits.

To modify the depth, highlight the green line of hits in this view and then click and drag either up or down to set the new depth.


Void Detection Toggle

This icon only functions if you have Inspection Planner and IP Measure enabled on your portlock and if you are working with one of these supported features: Surface Point, Edge Point, Line, Plane, Circle, Cylinder, and Round Slot.

If selected, PC-DMIS detects hit targets that would normally occur in voids (empty spaces) on the CAD model and repositions them to a safe location, usually near the edge of the void.

This is often used with PC-DMIS Inspection Planner. See the "Void Detection" topic in the "PC-DMIS Inspection Planner" documentation for additional information.


Probe Toolbox Toggle

If selected, the Probe Toolbox gets displayed. PC-DMIS remembers the toolbox state so that thereafter, whenever you open or close that Auto Feature dialog box, the Probe Toolbox will also open and close respectively. You will find this toggle icon useful because starting with version 4.2 some items have been moved to the Probe Toolbox that used to be on the Auto Feature dialog box.

See the "Using the Probe Toolbox" topic in the "Using Other Windows, Editors, and Tools" section.


Show Measured Points Toggle

This icon only functions with features that are already measured. Until a feature is measured, either with the Test button on the Auto Feature dialog box or with the actual part program execution, the icon remains unavailable for selection.

Select this icon to show in the Graphics Display window a visual depiction of the data points used to measure the feature.

Example of Showing Measured Points for an Auto Line feature


Show Filtered Points Toggle

This icon only functions if you have PC-DMIS Vision enabled on your portlock.

Select this icon to show on the Live and CAD Views image processing data points that were acquired and then discarded by the current filter settings. See the PC-DMIS Vision documentation for additional information.


Extended Sheet Metal Options area

This area contains some of the less frequently used sheet metal options for supported auto features.

Showing Extended Sheet Metal Options

The Extended sheet metal options area remains hidden until the following conditions are met:

  • You must select the Show Extended Sheet Metal Options check box from the General tab of the SetUp Options dialog box (select Edit | Preferences | Setup).

  • The type of auto feature must support the extended options. Supported features include: Vector Point, Surface Point, Edge Point, Circle, Round Slot, and Square Slot

  • You must select the >> button on the Auto Feature dialog box for Show Advanced Sheet Metal Options.

  • You must select the >> button on the Auto Feature dialog box for Show Extended Sheet Metal Options. This button only appears for supported features.

This will display a rather tall Auto Feature dialog box with all available options visible.

The Extended Sheet Metal Options

Depending on the feature selected, the following items appear in the Extended sheet metal options area.

Item

Description

Supported Auto Features

IJK Edge Report boxes

These boxes display the vector used for reporting deviation. This is a user supplied I, J, K vector. The Location Dimension option RT will display the deviation calculated along this vector. After the new value is created, PC-DMIS will normalize the vector, making its length one unit.

Edge Point

IJK Update boxes

These boxes display the update vector to be used to pierce the CAD surface, if the option is active by setting the SET NOM AX mode. This is a user supplied I, J, K normal vector. The I, J, K should always point away from the surface. After the new value is created, PC-DMIS will normalize the vector, making its length one unit.

Vector Point

IJK Surf Rpt boxes

These boxes display the vector used for reporting deviation. This is a user supplied I, J, K vector.

After the new value is created and you exit the dialog box, PC-DMIS will normalize the vector, making its length one unit.

The Location dimension's RS check box displays the deviation calculated along this vector.

The Location dimension's RT check box displays the measured deviation in the surface vector direction along this defined report vector.

All

Use Pin list

By setting the Use Pin list to Yes, the IJK Punch and IJK Pin boxes become available for editing.

The default value for this for new Auto Features is No.

Circle, Square Slot, Round Slot

IJK Pin boxes

These boxes define the vector of the stud through the hole formed by the punch.

When pins are created on a sheet metal surface they are not always perpendicular to the surface. This naturally creates an elliptical shape at the surface of the metal, even though a round pin may have been used. The Pin vector then allows for more accurate measurement and data analysis in this situation.

Circle, Square Slot, Round Slot

IJK Punch boxes

These boxes define the vector of the punch through the sheet metal. This vector is positioned at the XYZ center, plus half the thickness along the surface normal vector.

The punches used to place holes in sheet metal are not always perpendicular to the surface. This naturally creates an elliptical shape at the surface of the metal, even though a round punch may have been used. The Punch vector then allows for more accurate measurement and data analysis in this situation.

For the Circle feature, the diameter of the feature is also along this vector.

Circle, Square Slot, Round Slot

For more information on these vector boxes see "Extended Sheet Metal Vector Diagrams".

Icon | Description
 | Flip Vector
 | Reset Vector to Use Surface Vector


Reset Vector to Surface Vector

The Reset Vector to Surface Vector icon will set the vector to match the normal IJK Surface vector values.


Extended Sheet Metal Vector Diagrams

This topic contains various diagrams illustrating the vectors that you can use when you choose the show extended sheet metal feature options:

Normal Vector: The normal vector is the vector perpendicular to the surface at a point feature’s location. See the diagram below:

= Normal Vector

= Surface

= Point Location

Diagram of a Normal Vector

Update Vector: The update vector is the vector used to determine the direction to follow when updating a point to a new surface. This update vector is derived from the reference line used in the initial creation of the feature. See the diagram below:

= Updated or new surface

= Original or old surface

= Original point location

= Updated point location

= Reference line used to generate point location. Also known the update vector.

Diagram of an Update Vector

Report Vector: The report vector lets you control the direction of the deviation by allowing you to define a vector onto which the deviation along the surface vector is then projected. The report vector may differ from the surface normal, such as along a specified axis (shown below as either Yr or Xr). See the diagrams below:

= Theoretical surface

= Nominal point location

= Actual point location

= Deviation in X axis

= Deviation in Y axis

Diagram of a Report Vector

= Theoretical surface

=Actual surface

=Surface vector

=Report vector

=Surface vector deviation projected to the report vector

=Probe tip contacting actual surface

Diagram depicting a surface vector deviation projected onto the report vector

Pin Vector: Applied to slots and holes, the pin vector specifies the vector of the pin as it locates the product. See the diagram below:

A

= Pin vector

Diagram of a Pin Vector

Punch Vector: Applied to slots and holes, the punch vector specifies the direction of the punch used to create the feature. This vector is usually close to the surface normal within a few degrees. See the diagram below:

A | = Punch vector. Close to the surface normal within + or - 5 degrees
B | = The Punch

Diagram of a Punch Vector


Advanced Measurement Options area

The Measurement Properties area of the dialog box contains some or all of the following items, depending on the auto feature being created.

More:

Calculation list

Nominals Mode list

Relative To

Analysis area


Calculation list

This list is only available for these auto features: Circle and Cylinder

The Calculation list in the Advanced Measurement Options area allows the user to specify how he or she would like the feature calculated from the measured hits. The available options are: LEAST_SQR, MIN_SEP, MAX_INSC, MIN_CIRCSC, and FIXED_RAD.

For legacy Circularity and Cylindricity dimensions as well as a Location dimension's RN Line, the feature solution is used to compute the dimension. By default this is Least Squares. However, you can choose to solve the feature using Minimum Separation, Maximum Inscribed, Minimum Circumscribed, or Fixed Radius regression algorithms.

FCF Circularity and Cylindricity dimensions on the other hand are computed using the Chebychev algorithm (Min/Max) as required by the Y14.5 standard. Because of the change in calculation, Circularity and Cylindricity FCF dimensions will generally compute to a slightly smaller value than their legacy counterparts.

These calculation types are already discussed in detail in the "Best Fit Type" topic in the "Constructing New Features from Existing Features" section


Nominals Mode list

Mode list

The Mode list in the Advanced Measurement Options area determines how the nominals will be computed for a given point. PC-DMIS allows you to choose between FIND NOMS, MASTER, and NOMINALS.

If MODE = NOMINALS is active, PC-DMIS will compare the measured feature with the theoretical data in the dialog box, using the measured data for calculations.

If MODE = MASTER is active, then PC-DMIS will use the measured feature as the nominal, but will not update the X, Y, Z and diameter data in the dialog box.

If MODE = VECTOR is active, then PC-DMIS will use your first three hits to calculate the appropriate vector to use for the feature. PC-DMIS will not adjust the location of the feature. You must take the hits with the Auto Features dialog box active.

Note: If a nominal value is not known, simply select FIND NOMS from the list. While this option is active, every time a value is selected to be changed, PC-DMIS will prompt you to take the appropriate measurements on the part to obtain the values needed.

List Item

Description

Find Noms

When you select FIND NOMS from the Mode list, PC-DMIS will pierce the CAD model to find the closest location on a CAD edge (or surface) to the measured point, and set the nominals to that location on the CAD element.

To find the nominals using CAD data:

  1. Verify that PC-DMIS is set to Curve mode or Surface mode (available from the Graphics Modes toolbar), as is appropriate for the particular part program.

  2. Click on the desired CAD element in the Graphics Display window. PC-DMIS will pierce the CAD element to obtain the location, but will not create a feature. Once the desired elements have been selected, PC-DMIS will automatically fill in the X, Y, Z and I, J, K values.

  3. If the values are satisfactory, select the Create command button.

CAUTION: If you select the Measure box, PC-DMIS will measure the part.

If a hit is taken on the part while in FIND NOMS mode, PC-DMIS will search through the CAD elements and find the nominal CAD information that is closest to the measured point. If necessary, PC-DMIS will prompt you to take any additional hits on the part.

The next time the part is measured, PC-DMIS will set the nominal data to the nearest CAD element it can find. The mode switch will then be reset to NOMINALS.

Using Find Noms with Fixed Probes:

Faro or Romer arms using a fixed probe don't generate good approach vectors. Because of this, PC-DMIS cannot easily determine where to look for the surfaces.

To improve vectors from fixed probes:

  1. Place the fixed probe on the part.

  2. Press the Hit button.

  3. Move the probe away from the part along the approximate surface vector.

  4. Press the End button.

PC-DMIS will calculate and then use the vector between the hit and the probe tip's position.

Also, because the default vector from a Faro arm uses the axis of the fixed probe, the more you position the vector normal to the surface the more useful the vector is for Find Noms operations.

Master

If a point is created when the Mode list is set to MASTER, then the next time the part is measured, PC-DMIS will set the nominal data equal to the measured data. The Mode list will then be reset to NOMINALS.

Nominals

The NOMINALS option also requires you to have nominal data before the measurement process begins. PC-DMIS will compare the measured feature with the theoretical data in the dialog box, using the measured feature for any necessary calculations.

Vector

The VECTOR option allows you to update only the feature's vector during learn mode; it will not update the nominal XYZ values.

This option helps you to set a feature's vector that you may not be able to obtain otherwise. With the dialog box open, take three hits on the feature. This will determine its vector.

You can use this mode as long as the dialog box remains open. Once you close the dialog box, the option is not available for the feature in the Edit window.

Supported Features: Vector Point, Surface Point, Corner Point, Line, Plane, Circle, Ellipse, Round Slot, Square Slot, Notch Slot, Polygon, Cylinder, Cone, Sphere


Relative To

Relative To allows you to keep the relative position and orientation between a given feature (or features) and the auto feature.

Before selecting a relative auto feature, you should first choose your relative measure mode. See "Setting Up Relative Measure".

Clicking the … button will display a Relative Feature dialog box:

Relative Feature dialog box

From this dialog box you can choose to select either:

  • A single feature from the list to the right

  • Multiple features (one for each axis ) from the lists to the right

After you select the feature(s) and click OK, the Relative To box will then display the selected feature(s). This option supports the DMIS V3.0 RMEAS formats 1, 3 and 6.


Analysis Area

The Analysis area allows you to determine how each measured hit/point is displayed and how analysis images are captured and displayed in reports.

This functionality was originally created for PC-DMIS Vision. For in-depth information on its usage, see the "Analysis Area" topic in the PC-DMIS Vision documentation.

A Note on Point and Arrow Vector Size

If your vector arrows for your Auto Point features seem too small, increasing the Pt. Size value will increase both the size of the point in the Graphics Display window and, correspondingly, the size of the vector arrow. Since Auto Features are used on widely differing machines, no one default size will work for all users. However you can decide what size works best for you. PC-DMIS will then default to your last entered value.

If your point appears like a large blob on your screen, you might want to simply set the size to 0. This generally produces a good-looking point size and vector arrow.


Command Buttons

Auto Feature Command Buttons

Command Buttons

Description

Move To button

Clicking the Move To button moves the field of view in the Graphics Display window and centers it on the current feature's XYZ location.

In some cases, such as a Vector Point, the XYZ location is actually offset along the normal vector by the pre-hit value. This prevents the probe from crashing into the part.

If a feature is composed of more than one point (such as a line), then clicking this button switches between the points making up the feature.

Test button

Clicking the Test button allows you to test a feature's creation and preview its dimensional data before it's actually created.

Clicking this button performs a measurement using the current parameters.

You can change parameters and click Test repeatedly until you have an acceptable measurement. Then when you click Create, the software converts the temporary feature into a normal feature in the part program.

Create button

Clicking the Create button inserts the defined Auto Feature into the Edit Window at the current position.

Close button

Clicking the Close button exits the Auto Feature dialog box.

Show Advanced Measurement Options

and

Hide Advanced Measurement Options

Clicking the >> button extends the dialog box and displays any advanced measurement options. The button then changes to <<.

Clicking the << button shortens the dialog box and only shows the basic options for that auto feature. The button then changes to >>.

Show Extended Sheet Metal Measurement Options

and

Hide Extended Sheet Metal Measurement Options

For supported features, clicking the << button hides the Extended Sheet Metal Options area. The button then changes to >>.

Clicking the >> button displays the Extended Sheet Metal Options area. The button then changes to <<.


Inserting Auto Features

Did you press F1 on the Auto Feature dialog box to get here? See "The Auto Feature Dialog Box" if you want to know what the different components of the dialog box do.

The PC-DMIS configurations that support Auto Features differ in which Auto Features they support as well as how those features are created. Because of this, information on creating and inserting Auto Features into your part program is not covered here. Instead, consult the documentation set for your PC-DMIS configuration from the list below:

Contact (PC-DMIS CMM) | Vision (PC-DMIS Vision) | Laser (PC-DMIS Laser)
Auto Vector Point |  |
Auto Surface Point | Auto Surface Point | Auto Surface Point
Auto Edge Point | Auto Edge Point | Auto Edge Point
Auto Angle Point |  |
Auto Corner Point |  |
Auto High Point |  |
Auto Line | Auto Line |
Auto Plane |  | Auto Plane
Auto Circle | Auto Circle | Auto Circle
Auto Ellipse | Auto Ellipse |
Auto Square Slot | Auto Square Slot | Auto Square Slot
Auto Round Slot | Auto Round Slot | Auto Round Slot
Auto Notch Slot | Auto Notch Slot |
Auto Polygon | Auto Polygon |
Auto Cylinder |  | Auto Cylinder
Auto Cone |  |
Auto Sphere |  | Auto Sphere
Probe Toolbox Information
Contact Probe Toolbox | Vision Probe Toolbox | Laser Probe Toolbox

Once an Auto Feature is created, its command appears inside the Edit window (see "Auto Feature Field Definitions"). You can then mark the command and have PC-DMIS execute it like any other command or feature.


Auto Feature Field Definitions

Auto Vector Point Field Definitions

The Edit window command block for an Auto Vector Point feature with extended options would read:

ID=FEAT/CONTACT/VECTOR POINT,CARTESIAN
THEO/ TX,TY,TZ,TI,TJ,TK
ACTL/ X,Y,Z,I,J,K
TARG/ targX,targY,targZ,targI,targJ,targK
REPORT VEC = I,J,K, UPDATE VEC = I,J,K
SURFACE/THEO_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
AVOIDANCE MOVE = BEFORE,DISTANCE = n
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Surface Point Field Definitions

The Edit window command block for an Auto Surface Point feature with extended options would read:

ID=FEAT/CONTACT/SURFACE POINT,CARTESIAN
THEO/ TX,TY,TZ,TI,TJ,TK
ACTL/ X,Y,Z,I,J,K
TARG/ targX,targY,targZ,targI,targJ,targK
REPORT VEC = I,J,K
SURFACE/THEO_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CLEARPLANE/YES
GRAPHICAL ANALYSIS/YES,n,n,n
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
SAMPLE HITS = n
SPACER = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Edge Point Field Definitions

The Edit window command block for an Auto Edge Point feature with extended options would read:

ID=FEAT/CONTACT/EDGE POINT,CARTESIAN
THEO/ TX,TY,TZ,TI,TJ,TK
ACTL/ X,Y,Z,I,J,K
TARG/ targX,targY,targZ,targI,targJ,targK
EDGE/THEO_THICKNESS,n
REPORT = I, J, K, SURFACE_REPORT = I, J, K
MEASURE ORDER = SURFACE
/THEO_THICKNESS,n
MEASURE MODE/FINDNOMS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
DEPTH = n
SAMPLE HITS = n, SPACER = n, INDENT1 = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
ONERROR = YES
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Angle Point Field Definitions

The Edit window command block for an Auto Angle Point would read:

ID=FEAT/CONTACT/ANGLE POINT,CARTESIAN
THEO/ TX,TY,TZ,TI,TJ,TK,TSI,TSJ,TSK,TS2I,TS2J,TS2K
MEAS/ X,Y,Z,I,J,K,SI,SJ,SK,S2I,S2J,S2K
TARG/ targX,targY,targZ,targI,targJ,targK
EXTERIOR
SURFACE2/THEO_THICKNESS,n
SURFACE/THEO_THICKNESS,n
MEASURE MODE/FINDNOMS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
SAMPLE HITS = n, SPACER = n, INDENT1 = n, INDENT2 = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
ONERROR = YES
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Corner Point Field Definitions

The Edit window command line for an Auto Corner Point feature would read:

ID=FEAT/CONTACT/CORNER POINT,CARTESIAN
THEO/ TX,TY,TZ,TSI,TSJ,TSK,TS2I,TS2J,TS2K,TS3I,TS3J,TS3K
MEAS/ X,Y,Z,I,J,K,SI,SJ,SK,S2I,S2J,S2K,S2I,S2J,S2K
TARG/ targX,targY,targZ,targI,targJ,targK
EXTERIOR
SURFACE2/THEO_THICKNESS,n
SURFACE3/THEO_THICKNESS,n
SURFACE/THEO_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
SPACER = n, INDENT1 = n, INDENT2 = n, INDENT3 = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
ONERROR = YES
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto High Point Field Definitions

The Edit window command line for an Auto High Point feature would read:

ID=FEAT/CONTACT/HIGH POINT,CARTESIAN
THEO/ TX,TY,TZ,TI,TJ,TK
MEAS/ X,Y,Z,I,J,K
TARG/ targX,targY,targZ,targI,targJ,targK
INCREMENT = n, TOL = n, CIRCULAR,OUTER RADIUS = n, INNER RADIUS = n
CENTER = X,Y,Z
SURFACE/THEO_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
AVOIDANCE MOVE = BEFORE,DISTANCE = n

Auto Line Field Definitions

The Edit window command line for an Auto Line feature would read:

ID=FEAT/CONTACT/LINE,CARTESIAN
THEO/ TX,TY,TZ,TI,TJ,TK,TLI,TLJ,TLK,TEI,TEJ,TEK,TSI,TSJ,TSK,TLENGTH
ACTL/ X,Y,Z,I,J,K,LI,LJ,LK,EI,EJ,EK,SI,SJ,SK,TLENGTH
TARG/ targX,targY,targZ,targI,targJ,targK
BOUNDED
REPORT VEC = I,J,K
EDGE/THEO_THICKNESS,n
SURFACE/THEO_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CLEARPLANE/YES
GRAPHICAL ANALYSIS/YES,n,n,n
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
NUMHITS = n, DEPTH = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Plane Field Definitions

The Edit window command line for an Auto Plane feature would read:

ID=FEAT/CONTACT/PLANE,CARTESIAN,TRIANGLE
THEO/ TX,TY,TZ,TI,TJ,TK
ACTL/ X,Y,Z,I,J,K
TARG/ targX,targY,targZ,targI,targJ,targK
ANGLEVEC = I, J, K, SQUARE
SURFACE/THEO_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
NUMHITS = n, NUMROWS = n
SPACER = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Circle Field Definitions

The Edit window command line for an Auto Circle feature with extended options would read:

ID=FEAT/CONTACT/CIRCLE,CARTESIAN,IN,LEAST_SQR
THEO/ TX,TY,TZ,TI,TJ,TK,TDIAM,TANG1,TANG2
ACTL/ X,Y,Z,I,J,K,DIAM,ANG1,ANG2
TARG/ targX,targY,targZ,targI,targJ,targK
ANGLEVEC = I,J,K
DIRECTION = CCW
REMEASURE = NO
PUNCH = I,J,K, PIN = I,J,K
SURFACE/ACTL_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CIRCULAR MOVES/NO
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
NUMHITS = n, DEPTH = n, PITCH = n
SAMPLE HITS = n, SPACER = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
FIND HOLE = DISABLED, ONERROR = NO, READ POS = NO
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Ellipse Field Definitions

The Edit window command line for an Auto Ellipse feature would read:

ID=FEAT/CONTACT/ELLIPSE,CARTESIAN,IN
THEO/ TX,TY,TZ,TI,TJ,TK,TDIAM,TDIAM2,TAI,TAJ,TAK
ACTL/ X,Y,Z,I,J,K,DIAM,DIAM2,AI,AJ,AK
TARG/ targX,targY,targZ,targI,targJ,targK,targAI,targAJ,targAK
START ANG = n,END ANG = n
SURFACE/ACTL_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CIRCULAR MOVES/NO
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
NUMHITS = n, DEPTH = n
SAMPLE HITS = n, SPACER = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
ONERROR = NO, READ POS = NO
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Round Slot Field Definitions

The Edit window command line for an Auto Round Slot feature with extended options would read:

ID=FEAT/CONTACT/ROUND SLOT,CARTESIAN,IN
THEO/ TX,TY,TZ,TI,TJ,TK,TAI,TAJ,TAK,TWIDTH,TLENGTH
ACTL/ X,Y,Z,I,J,K,AI,AJ,AK,WIDTH,LENGTH
TARG/ targX,targY,targZ,targI,targJ,targK,targAI,targAJ,targAK
MEAS ANGLE = n
REMEASURE = NO
PUNCH = I,J,K,PIN = I,J,K SURFACE/ACTL_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CIRCULAR MOVES/NO
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
NUMHITS = n, DEPTH = n
SAMPLE HITS = n, SPACER = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
FIND HOLE = DISABLED, ONERROR = NO, READ POS = YES
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Square Slot Field Definitions

The Edit window command line for an Auto Square Slot feature with extended options would read:

ID=FEAT/CONTACT/SQUARE SLOT,CARTESIAN,IN
THEO/ TX,TY,TZ,TI,TJ,TK,TAI,TAJ,TAK,TWIDTH,TLENGTH
ACTL/ X,Y,Z,I,J,K,AI,AJ,AK,WIDTH,LENGTH
TARG/ targX,targY,targZ,targI,targJ,targK,targAI,targAJ,targAK
MEAS WIDTH = YES, RADIUS = n
REMEASURE = NO
PUNCH = I,J,K,PIN = I,J,K SURFACE/ACTL_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CIRCULAR MOVES/NO
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
DEPTH = n
SAMPLE HITS = n, SPACER = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
FIND HOLE = DISABLED, ONERROR = NO, READ POS = YES
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Notch Slot Field Definitions

The Edit window command line for an Auto Notch Slot feature would read:

ID=FEAT/CONTACT/NOTCH SLOT,CARTESIAN
THEO/ TX,TY,TZ,TI,TJ,TK,TAI,TAJ,TAK,TWIDTH,TLENGTH
ACTL/ X,Y,Z,I,J,K,AI,AJ,AK,WIDTH,LENGTH
TARG/ targX,targY,targZ,targI,targJ,targK
REMEASURE = NO
SURFACE/ACTL_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CIRCULAR MOVES/NO
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
DEPTH = n
SAMPLE HITS = n, SPACER = n, INDENT1 = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
FIND HOLE = DISABLED, ONERROR = NO, READ POS = YES
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Cylinder Field Definitions

The Edit window command line for an Auto Cylinder feature would read:

ID=FEAT/CONTACT/CYLINDER,CARTESIAN,IN,LEAST_SQR
THEO/ TX,TY,TZ,TI,TJ,TK,TDIAM,TLENGTH
ACTL/ X,Y,Z,I,J,K,DIAM,LENGTH
TARG/ targX,targY,targZ,targI,targJ,targK
START ANG = n, END ANG = n
REMEASURE = NO, USE THEO = YES
ANGLE VEC = I, J, K
DIRECTION = CCW
SURFACE/ACTL_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CIRCULAR MOVES/NO
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
NUMHITS = n,NUMLEVELS = n, STARTING DEPTH = n, ENDING DEPTH = n, PITCH = n
SAMPLE HITS = n,SPACER = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
FIND HOLE = DISABLED, ONERROR = NO, READ POS = YES
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Cone Field Definitions

The Edit window command line for an Auto Cone feature would read:

ID=FEAT/CONTACT/CONE,CARTESIAN,IN
THEO/ TX,TY,TZ,TI,TJ,TK,TANGLE,TLENGTH,TDIAM
ACTL/ X,Y,Z,I,J,K,ANGLE,LENGTH,DIAM
TARG/ targX,targY,targZ,targI,targJ,targK
START ANG = n, END ANG = n
ANGLE VEC = I, J, K
SURFACE/ACTL_THICKNESS,n
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CIRCULAR MOVES/NO
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
NUMHITS = n,NUMLEVELS = n, STARTING DEPTH = n, ENDING DEPTH = n
SAMPLE HITS = n,SPACER = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
ONERROR = NO, READ POS = YES
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Sphere Field Definitions

The Edit window command line for an Auto Sphere feature would read:

ID=FEAT/CONTACT/SPHERE,CARTESIAN,IN,LEAST_SQR
THEO/ TX,TY,TZ,TI,TJ,TK,TDIAM
ACTL/ X,Y,Z,I,J,K,DIAM
TARG/ targX,targY,targZ,targI,targJ,targK
START ANG1 = n, END ANG1 = n
START ANG2 = n, END ANG2 = n
ANGLE VEC = I, J, K
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CIRCULAR MOVES/NO
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
NUMHITS = n,NUMLROWS = n,
SAMPLE HITS = n,
AVOIDANCE MOVE = BEFORE,DISTANCE = n
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Polygon Field Definitions

The Edit window command line for an Auto Polygon feature would read:

ID=FEAT/CONTACT/POLYGON,CARTESIAN,IN
THEO/ TX,TY,TZ,TI,TJ,TK,TAI,TAJ,TAK,TDIAM
ACTL/ X,Y,Z,I,J,K,AI,AJ,AK,DIAM
TARG/ targX,targY,targZ,targI,targJ,targK,targAI,targAJ,targAK
NUMSIDES = n, RADIUS = n
REMEASURE = NO,SURFACE/THICKNESS_NONE,0
MEASURE MODE/NOMINALS
RMEAS/NONE,NONE,NONE
AUTO WRIST/YES
CIRCULAR MOVES/NO
CLEARPLANE/NO
GRAPHICAL ANALYSIS/NO
SCREEN CAPTURE/CAD,OUTTOL,50%,HIGH
FEATURE LOCATOR/NO,NO,""
SHOW_CONTACT_PARAMETERS = YES
NUMHITS = n, DEPTH = n
SAMPLE HITS = n, SPACER = n
AVOIDANCE MOVE = BEFORE,DISTANCE = n
FIND HOLE = DISABLED,ONERROR = YES,READ POS = YES
SHOWHITS = YES
HIT/BASIC,TX,TY,TZ,I,J,K,X,Y,Z

Auto Feature Field Definitions

When you create an Auto Feature, PC-DMIS inserts the command for that feature into the Edit window. This topic documents the different fields that may appear in the Command mode of the Edit window for the different features.

Click on one of the hyper-linked features below to see a representation of its code in the Edit window. Click again on the hyper-linked text to hide the code. In the table below, locate the field or command line used in your Auto Feature to see what it does.

Vector Point | Surface Point | Edge Point | Angle Point | Corner Point | High Point | Line | Plane | Circle | Ellipse | Round Slot | Square Slot | Notch Slot | Cylinder | Cone | Sphere | Polygon

Field or Command

Extended Field

Used on Only these Features

Description

ID

This field shows the feature's identification label. See "ID box".

FEAT/CONTACT

This command displays the type of probing and the Auto Feature type. See "Auto Feature Type list".

POLAR or
CARTESIAN

This field switches between POLAR and CARTESIAN and displays the X,Y,Z,I,J,K values in the selected coordinate system. See "Polar / Cartesian Toggle".

TRIANGLE or
OUTLINE

PLANE

For a Plane feature, this field switches between TRIANGLE or OUTLINE. It determines how the plane gets displayed in the Graphics Display window. See "Display list".

IN or
OUT

CIRCLE, ELLIPSE, ROUND SLOT, SQUARE SLOT, CYLINDER, CONE, SPHERE, POLYGON

This field switches between IN or OUT. It determines whether or not the feature is an internal feature (such as a hole) or an external feature (such as a stud). See "Inner / Outer".

LEAST_SQR

CIRCLE, CYLINDER, SPHERE

This field determines the calculation routine used to create the feature from the measured hits. It can toggle between LEAST_SQR, MIN_SEP, MAX_INSC, MIN_CIRCSC, and FIXED_RAD. See "Calculation list".

THEO/

This stands for "theoretical".

TX, TY, TZ, TI, TJ, TK represent the theoretical (or nominal) hit location and vector.

TLI, TLJ, TLK represent the theoretical line vector.

TEI, TEJ, TEK represent the theoretical edge vector.

TSI, TSJ, TSK represent the surface theoretical vector. TS2I,TS2J,TS2K represent the theoretical vector for the second surface.

TLENGTH represents the feature's theoretical length.

TDIAM represents the feature's theoretical diameter. For ellipses, this is the major diameter. TDIAM2 is an ellipse's minor diameter. TANG1 represents the feature's theoretical starting angle. TANG2 represents the feature's theoretical ending angle.

TAI,TAJ,TAK represents the theoretical angle vector.

TWIDTH and TLENGTH represent the theoretical width and length of the feature.

TANGLE represents the feature's angle.

ACTL/

This stands for "actual".

X, Y, Z, I, J, K represent the actual measured hit location and vector.

SI, SJ, SK, represent the measured vector for the surface.

LI, LJ, LK represent the measured line vector.

EI,EJ,EK represent the measured edge vector.

LENGTH represents the feature's measured length.

DIAM represents the feature's measured diameter. ANG1 represents the feature's actual starting angle. TANG2 represents the feature's actual ending angle.

AI,AJ,AK represents the measured angle vector.

WIDTH and LENGTH represent the measured width and length of the feature.

ANGLE represents the feature's angle.

TARG/

This stands for "target". The fields targX, targY, targZ, targI, targJ, targK allow you to control the measurement location and vector approach direction for execution while having the ability to have a completely different THEO value.

The fields targAI, targAJ, targAK let you modify the target's angle IJK vector.

MEAS/

This stands for "measured". The fields X, Y, Z, I, J, K represent the actual measured hit location and vector.

SI,SJ,SK represent the measured vector for the surface. S2I,S2J,S2K represent the measured vector for the second surface.

NUMSIDES

POLYGON

This editable value must be an integer of three or higher. It defines how many sides are in the polygon. See "Num Sides list".

RADIUS

POLYGON, SQUARE SLOT

This editable value defines a radius for each corner in the polygon or square slot. When taking hits, PC-DMIS will move in along the side by that amount before taking hits. This helps avoid taking hits directly in the corner. See "Radius box".

START ANG

ELLIPSE, CONE, CYLINDER

This field defines the feature's starting angle. See "Start and End Angles".

START ANG1

SPHERE

This field defines the feature's starting angle horizontally, around the equator of a sphere. See "Start and End Angles".

START ANG2

SPHERE

This field defines the feature's starting angle vertically, around the poles of a sphere. See "Start and End Angles".

END ANG

ELLIPSE, CONE, CYLINDER

This field defines the feature's ending angle. See "Start and End Angles".

END ANG1

SPHERE

This field defines the feature's ending angle horizontally, around the equator of a sphere. See "Start and End Angles".

END ANG2

SPHERE

This field defines the feature's ending angle vertically, around the poles of a sphere. See "Start and End Angles".

MEAS ANGLE

ROUND SLOT

This field defines an angle value determining how much of the arc making up the rounded edges of the Round Slot to measure. See "Meas Angle box".

INCREMENT

HIGH POINT

This field defines the increment distance away from the start point that the probe will move when following its search pattern. See "Increment box".

TOL

HIGH POINT

This defines the tolerance value to use during the search process. See "Tolerance box".

CIRCULAR or
BOX

HIGH POINT

This field switches between CIRCULAR or BOX. It defines the search region. See "Box / Circular list".

OUTER RADIUS

HIGH POINT

For a CIRCULAR search region, this field defines the search region's outer radius. See "Inner/Outer list".

INNER RADIUS

HIGH POINT

For a CIRCULAR search region, this field defines the search region's inner radius. See "Inner/Outer list".

WIDTH

HIGH POINT

For a BOX search region, this field defines the width of the rectangular search region. See "Width box".

LENGTH

HIGH POINT

For a BOX search region, this field defines the length of the rectangular search region. See "Length box".

BOUNDED or
UNBOUNDED

LINE

This field appears for Line features. It determines the type of Line feature. It switches between BOUNDED and UNBOUNDED. See "Bounded list".

EXTERIOR or
INTERIOR

ANGLE POINT, CORNER POINT

This field switches between EXTERIOR and INTERIOR; it describes the type of angle. See "Interior / Exterior list".

REPORT VEC

LINE, SURFACE POINT, VECTOR POINT

This command indicates the vector used for reporting deviation. See "Extended Sheet Metal Options area".

UPDATE VEC

VECTOR POINT

This command indicates the update vector that will be used to pierce the CAD surface. See "Extended Sheet Metal Options area".

ANGLE VEC

This defines the angle vector for the feature. See "IJK Angle boxes".

REMEASURE

CIRCLE, NOTCH SLOT, SQUARE SLOT, ROUND SLOT, CYLINDER, POLYGON

This field if set to YES re-measures the feature against the feature's measured values. See "Measure Now and Re-Measure Toggle".

PUNCH

CIRCLE, SQUARE SLOT, ROUND SLOT

This field indicates the direction of the punch through the sheet metal. It is an editable value. See "Extended Sheet Metal Options area".

PIN

CIRCLE, SQUARE SLOT, ROUND SLOT

This field indicates the direction of the point through the hole formed by the punch. See "Extended Sheet Metal Options area".

REPORT

EDGE POINT

This field indicates the vector used for reporting deviation. See "Extended Sheet Metal Options area".

SURFACE_REPORT

EDGE POINT

This field indicates the vector used for reporting deviation. See "Extended Sheet Metal Options area".

MEASURE ORDER

EDGE POINT

This toggle field displays the order of measuring the sample hits. The available choices are SURFACE, EDGE or BOTH. See "Measure Order list".

SQUARE or
RADIAL

PLANE

For a Plane feature, this field switches between SQUARE and RADIAL. It defines the hit pattern for hits making up the feature. See "Pattern list".

SURFACE/
SURFACE2/
SURFACE3

Any of these command lines switches between either THEO_THICKNESS, ACTL_THICKNESS, or THICKNESS_NONE. If the latter then no thickness is used. Otherwise, this displays the thickness of the part for the Positive or negative values can be used. See "Use Thickness".

EDGE/

LINE

For a Line feature, this command determines the edge thickness of the line. See "Use Thickness".

MEASURE MODE/

This command switches between these measuring modes: FINDNOMS, VECTOR, NOMINAL, MASTER. See "Nominals Mode list".

RMEAS/

This command has three fields separated by commas. If you have a single RMEAS feature, it will occupy all three fields. If you have an RMEAS feature, one for each axis, they will occupy the three fields left to right: X axis RMEAS feature, Y axis RMEAS feature, and Z axis RMEAS feature. See "Setting Up Relative Measure (RMEAS)".

DIRECTION

CIRCLE, CYLINDER

This command defines the direction in which hits are taken. It switches between CCW (counterclockwise) and CW (clockwise). See "Direction List".

CIRCULAR MOVES/

CIRCLE, ELLIPSE, ROUND SLOT, SQUARE SLOT, NOTCH SLOT, CYLINDER, CONE, SPHERE, POLYGON

This command has a single YES/NO toggle field. If set to yes, then PC-DMIS will move the probe in a circular motion. See "Circular Moves Toggle".

AUTO WRIST/

This command has a single YES/NO toggle field. If set to YES, then during feature creation PC-DMIS will automatically choose the best probe angle to use for measuring the feature and will insert the appropriate TIP/ command before the feature. See "Auto Wrist Toggle".

CLEARPLANE/

This command has a single YES/NO toggle field. If set to YES, then during feature creation PC-DMIS will automatically insert a MOVE/CLEARPLANE command (relative to the current coordinate system and part origin) before the feature. See "Clear Plane Toggle".

GRAPHICAL ANALYSIS/

This command has a YES/NO toggle field. If set to YES, then PC-DMIS will display a graphical analysis of the feature in the Graphics Display window. Three other fields become enabled. These three fields, from left to right, allow you to determine the Graphical Analysis Point Size, the Plus Tolerance, and the Minus Tolerance. See "Analysis area".

SCREEN CAPTURE/

This command by default contains a single CAD/LIVE toggle field. If set to CAD, then PC-DMIS will take and insert screen captures of the current feature's graphical analysis into the report window. Three additional fields become available when the first field is set to CAD.

From left to right these do the following:

Field 2 - Determines what features get output. Those that are out of tolerance (OUTTOL) or all features (ALL).

Field 3 - Determines the size of the screen shot: 25%, 50%, 75%, or 100% of the current screen view, or TO FIT to fit the current window.

Field 4 - Determines the quality of the screen shot: LOW, MEDIUM, or GOOD. See "Analysis area".

FEATURE LOCATOR/

Initially, this command looks like this: FEATURE LOCATOR/NO,NO,"<text instructions>"

The left most YES/NO toggle field indicates whether or not the Feature Locator tab will display a bitmap image If you set this to YES, an additional field bounded by quotation marks becomes enabled, allowing you to type the full pathway to the bitmap image to display:

FEATURE LOCATOR/YES,"<pathway to bitmap file>",NO,"<text instructions>"

The next YES/NO toggle field indicates whether or not the Feature Locator tab will play an audio file (.wav). If you set this to YES, an additional field bounded by quotation marks becomes enabled, allowing you to type the full pathway to the audio file to play:

FEATURE LOCATOR/YES,"<pathway to bitmap file>",YES,"pathway to audio file","<text instructions>"

The final field, "<text instructions>", lets you display textual instructions in the Feature Locator tab. See "Feature Locator Tab" topic in the PC-DMIS Vision documentation.

SHOW_CONTACT_PARAMETERS

This YES/NO toggle field determines whether or not PC-DMIS displays additional contact parameters used with the auto feature in the Edit window. Setting this to YES will display the following fields if applicable to the auto feature: NUMHITS, NUMROWS, PITCH, DEPTH, STARTING DEPTH, ENDING DEPTH, SAMPLE HITS, SPACER, INDENT, AVOIDANCE MOVE, FIND HOLE, ON ERROR, READ POS.

SAMPLE HITS

SURFACE POINT, EDGE POINT, ANGLE POINT, CIRCLE, ELLIPSE, ROUND SLOT, SQUARE SLOT, NOTCH SLOT, CYLINDER, CONE, POLYGON

For features that support sample hits, this value defines the number of sample hits to take during feature measurement. Acceptable values depend on the type of feature. See "Working with Contact Sample Hits Properties"

SPACER

SURFACE POINT, EDGE POINT, ANGLE POINT, CORNER POINT, PLANE, CIRCLE, ELLIPSE, ROUND SLOT, SQUARE SLOT, NOTCH SLOT, CYLINDER, CONE, POLYGON

This field defines the distance from the nominal point location that PC-DMIS will use to measure a plane if sample hits are specified. See "Working with Contact Sample Hits Properties"

INDENT1
INDENT2
INDENT3

EDGE POINT, ANGLE POINT, CORNER POINT, NOTCH SLOT

This defines minimum offset distance from the feature's point or center location to the first sample hit. See "Working with Contact Sample Hits Properties".

NUMHITS

LINE, PLANE, CIRCLE, ELLIPSE, ROUND SLOT, CYLINDER, CONE, SPHERE, POLYGON

This field determines the number of hits to take when measuring the feature. See "Working with Contact Path Properties".

NUMROWS

PLANE

This field determines how many rows of hits to use when measuring the feature. See "Working with Contact Path Properties".

NUMLEVELS

CYLINDER, CONE

This field determines how many levels of hits to use when measuring features with multiple levels. See "Working with Contact Path Properties".

DEPTH

EDGE POINT, LINE, CIRCLE, ELLIPSE, ROUND SLOT, SQUARE SLOT, NOTCH SLOT, POLYGON

This field determines the offset distance either below a surface or up from the bottom of a feature where PC-DMIS will measure the feature. See "Working with Contact Path Properties".

STARTING DEPTH

CYLINDER, CONE

This field defines the starting depth of the first level of hits for features with multiple levels. This depth is offset from the top of the feature. See "Working with Contact Path Properties".

ENDING DEPTH

CYLINDER, CONE

This field defines the ending depth of the last level of hits for features with multiple levels. This depth is offset from the top of the feature. See "Working with Contact Path Properties".

PITCH

CIRCLE, CYLINDER

This field determines the distance between threads along the axis of the feature. See "Working with Contact Path Properties".

AVOIDANCE MOVE/

This command indicates when to apply an avoidance move and the amount to move. It contains two fields. The left field toggles between NO (no avoidance move), BOTH (move both before and after the feature is measured), BEFORE (move only before the feature is measured) and AFTER (move only after the feature is measured) and the right field (DISTANCE = n) lets you define a number value that determines the distance of the avoidance move. See "Working with Contact Auto Move Properties".

FIND HOLE

CIRCLE, ROUND SLOT, SQUARE SLOT, NOTCH SLOT, CYLINDER, POLYGON

This toggle field determines the method PC-DMIS uses to find hole features. Available options include: DISABLED, CENTER, SINGLE HIT, or NOCENTER. See "Working with Contact Find Hole Properties".

ONERROR

ANGLE POINT, CIRCLE, EDGE POINT, CORNER POINT, ELLIPSE, ROUND SLOT, SQUARE SLOT, NOTCH SLOT, CYLINDER, CONE, POLYGON

This YES/NO field determines whether or not PC-DMIS uses improved error checking when it detects an unexpected or missed hit.

If set to YES and a machine error (such as an unexpected hit) occurs, then PC-DMIS will display the Read Position dialog box. You can then use your jog box to move the machine to the feature's location and attempt to re-measure it.

If set to NO, the usual "Movement Interrupted" message appears instead.

See "Working with Contact Find Hole Properties".

READ POS

CIRCLE, ELLIPSE, ROUND SLOT, SQUARE SLOT, NOTCH SLOT, CYLINDER, CONE, POLYGON

This YES/NO field determines whether or not PC-DMIS pauses execution above the surface feature displaying a message, asking if you want to use the current data. See "Working with Contact Find Hole Properties".

SHOWHITS

This YES/NO toggle field determines whether or not PC-DMIS displays all the hits making up the feature. If set to YES, then PC-DMIS will display a HIT/BASIC command line for each hit.

If you want to see the hits in the Graphics Display window, see "Show Hit Targets Toggle".

HIT/BASIC

This command line displays the theoretical XYZ, the theoretical IJK, and the measured IJK values for the hit.


Setting Up Relative Measure

Setting Up Relative Measure (RMEAS)

Display Menu Roadmap

The Insert | Parameter Change | Auto Relative Measure menu option sets the relative measurement mode for auto features. When you select this menu option, PC-DMIS inserts an RMEAS command into the Edit window and by default sets it to use the DEFAULT (I,J,K, Z) mode. You can then change it to the LEGACY (I,J,K, X,Y,Z) mode if desired:

  • Default (I,J,K, Z) RMEAS Mode (previously called Absolute Mode) - uses the RMEAS feature’s measured position and vector, applying any positional offsets along that vector.

  • Legacy (I,J,K, X,Y,Z) RMEAS Mode (previously called Normal Mode) - uses the deviation of the RMEAS feature’s position and orientation.

Note: RMEAS is mostly used for adjusting feature orientation. Default (I,J,K, Z) mode should be selected in these cases. Legacy (I,J,K, X,Y,Z) mode should only be used in rare instances where adjustments in both orientation and position are needed.

You should insert the RMEAS command into the part program before using the Relative Measurement area in the Auto Feature dialog box. For more information, see "Relative Measurement area".

More:

Default (I,J,K, Z) RMEAS Mode

Math Process of the Default (I,J,K, Z) RMEAS Mode:

Legacy (I,J,K, X,Y,Z) RMEAS Mode

Math Process of the Legacy (I,J,K, X,Y,Z) RMEAS mode


Default RMEAS Mode

Default (I,J,K, Z) RMEAS Mode

When an Auto Feature has a relative measure feature associated with it (see "Relative Measurement area"), PC-DMIS measures the Auto Feature in a location that is adjusted to be on the plane of the RMEAS feature.

Example: Suppose you measured a plane (PLN), and an Auto Circle (CIR1) referenced the plane as its RMEAS feature. When you measure CIR1 PC-DMIS will measure it in the referenced plane (PLN). See "Math Process of the Default RMEAS Mode:".

The Edit window command for this option reads:

RMEAS/DEFAULT (I,J,K, Z)

This is the default and usual RMEAS mode for sheet metal features.

More:

Math Process of the Default (I,J,K, Z) RMEAS Mode:


Math Process of the Default RMEAS Mode:

Math Process of the Default (I,J,K, Z) RMEAS Mode:

This mode controls I, J, K, Z (T) and therefore works well with RMEAS features like planes.

Using the numerical values taken from the example features in the table below, follow these steps to understand how RMEAS/DEFAULT (I,J,K, Z) functions.

  1. Create a coordinate system (translation matrix) using the actual RMEAS feature's XYZ IJK.

  2. Move the nominal Auto Feature XYZ into the RMEAS coordinate system.

  3. Zero out the Z value and move the XYZ back into the PART coordinate system.

  4. Copy the RMEAS feature's IJK values to the Auto Feature if the RMEAS feature is plane reducible.

Example Feature | XYZ | IJK
Actual RMEAS feature (plane): | 2,2,1 | 0,0,1
Nominal Auto Feature (circle): | 0,0,0 | 0,.7071,.7071
New Nominal Auto Feature: | 0,0,1 | 0,0,1


Legacy RMEAS Mode

Legacy (I,J,K, X,Y,Z) RMEAS Mode

The Legacy (I,J,K, X,Y,Z) RMEAS mode takes into account the orientation of the reference feature.

To understand this, examine an Auto Circle with three sample hits. PC-DMIS first takes three hits on the surface around the circle and then measures the circle based on the plane's location and the surface normal vector's orientation. Therefore, if the plane is at a 45 degree angle, PC-DMIS also measures the Auto Circle at a 45 degree angle.

Similarly, if the relative measure feature is rotated from its original orientation, then the associated feature will also be measured with the same rotational offset.

Legacy mode is also slightly smarter than Default mode, because when it looks at the reference feature it only offsets the main feature by valid axes for the reference feature type. For example, for a plane it doesn't make much sense to shift in all directions, but only by the plane's normal vector.

The Edit window command line for this option reads:

RMEAS/LEGACY (I,J,K, X,Y,Z)

Legacy mode should only be used in rare instances where adjustments in both orientation and position are needed.

More:

Math Process of the Legacy (I,J,K, X,Y,Z) RMEAS mode


Math Process of the Legacy RMEAS mode

Math Process of the Legacy (I,J,K, X,Y,Z) RMEAS mode

This mode controls I, J, K, X,Y, Z (T) and therefore works well with 3d RMEAS features like circles with sample hits.

Using the numerical values taken from the example features in the table below, follow these steps to understand how RMEAS/LEGACY (I,J,K, X,Y,Z) functions.

  1. Create a coordinate system (translation matrix) given the nominal RMEAS feature XYZ IJK.

  2. Move the nominal Auto Feature XYZ and IJK into the RMEAS coordinate system.

  3. Create a new coordinate system given the actual RMEAS feature XYZ IJK.

  4. Now move the translated Auto Feature XYZ and IJK back into the PART coordinate system using the new RMEAS coordinate system.

  5. Use the new nominal XYZ and IJK to measure the Auto Feature.

Example Feature | XYZ | IJK
Nominal RMEAS feature (circle): | 0,0,2 | 0,0,1
Nominal Auto Feature (circle): | 2,1,0 | .7071,0,.7071
Actual RMEAS feature: | -1,0,1 | -.7071,0,.7071
New Nominal Auto Feature: | 1.8284,1,1 | 0,0,1


Creating Measured Features

Creating Measured Features: Introduction

Understanding the Command Format

Inserting a Measured Feature

Editing a Measured Feature

Overriding a Guessed Measured Feature

Creating Measured Feature SETS


Creating Measured Features: Introduction

Whenever you take hits on a part, PC-DMIS interprets those hits into different features depending on the number of the hits, their vectors, etc. PC-DMIS creates measured features from these hits. PC-DMIS supports the following measured features:

  • Measured Point

  • Measured Line

  • Measured Plane

  • Measured Circle

  • Measured Sphere

  • Measured Cone

  • Measured Cylinder

  • Measured Round Slot

  • Measured Square Slot

These features are described in detail in the "Understanding the Command Format" topic.

The following major topics are covered in this section.

  • Understanding the Command Format

  • Inserting a Measured Feature

  • Editing a Measured Feature

  • Overriding a Guessed Measured Feature

  • Creating Measured Feature Sets

Note: You can also use insert measured features into your part program by using the Quick Start toolbar. For information, see the "Quick Start: Measure Toolbar" topic in the "Using Toolbars" section.


Understanding the Command Format

All measured features are displayed in the following format in the Command mode of the Edit window. There will be slight variations that are explained more thoroughly in the following sections. The actual Edit report will be displayed using all CAPS.

For example;

feature_name=FEAT/FEATURE_TYPE,TOG1,TOG4
THEO/TX,TY,TZ,TI,TJ,TK,TD,TL
ACTL/X,Y,Z,I,J,K,D,L
MEAS/TOG2,TOG3,
HIT/TOG5,TX,TY,YZ,TI,TJ,TK,X,Y,Z,USE_THEO=TOG6
ENDMEAS/

feature_name: This displays the name of the feature. This is a user editable field.

FEATURE_TYPE: This denotes the type of feature and is the same as TOG2 but is non-editable and cannot be toggled.

......: This indicates that what follows is unique to each feature.

TOG1: This field is present in all features and can be toggled between RECT / POLR. If this feature is RECT, all points are represented in Cartesian system (x, y, z). If the field is POLR, all the points are displayed in polar system (x_radius, y_angle, z_height). Vectors do not change.

TOG2: This field is present in all measured features and can be switched between:
CIRCLE / CONE / CURVE / CYLINDER / LINE / PLANE / POINT / SET / SLOT / SPHERE

POINT is the default feature type when the measured command line is opened for the first time in a part program. The default feature type then becomes the last measured feature type.

TOG3: This field represents the number of hits that will be taken according to the type of feature displayed in TOG2. The HIT line is varied, based on the number of hits set up by the user. For example; 1 hit = 1 HIT/BASIC line, 3 hits = 3 HIT/BASIC lines. The required minimum number will be indicated as the default.

TOG4: This field also takes unique values according to the type of feature represented in TOG2. Linear features will allow you to toggle between BOUND/UNBOUND. Circular features will allow you to switch between IN/OUT. Angular features will allow you to switch between LENGTH/ANGLE.

TOG5: This field represents the type of hit that is to be taken:
BASIC.

TOG6: This field allows you to determine whether or not to use the theoretical vector as the approach vector for the hit. This defaults to YES. If set to NO, PC-DMIS calculates the approach vector by subtracting the theoretical hit point (X,Y,Z) from the current probe position.

TX,TY,TZ,TI,TJ,TK: These numbers (TX,TY,TZ) represent the theoretical target vector and the theoretical approach vector (TI,TJ,TK) and are editable by the user.

TD: For circular features this number is the theoretical diameter.

X,Y,Z,I,J,K: These numbers are non-editable and represent the measured point and measured approach vector.

D: For circular features this number is the measured diameter.

TL: This is the theoretical length of features that have a length.

L: This is the measured length of features that have a length.

More:

Basic Measurement Format for a Circle

Basic Measurement Format for a Cone

Basic Measurement Format for a Cylinder

Basic Measurement Format for a Line

Basic Measurement Format for a Plane

Basic Measurement Format for a Point

Basic Measurement Format for a Sphere


Basic Measurement Format for a Point

Display Menu Roadmap

The only number of hits for a point is one.

Feature_name=FEAT/POINT,TOG1
THEO/TX,TY,TZ,TI,TJ,TK
ACTL/X,Y,Z,I,J,K
MEAS/POINT,TOG3
HIT/…
ENDMEAS/

TOG1= This field can be toggled between RECT / POLR.

TOG3= This list the number of hits that PC-DMIS should take to measure this feature. Since a point can only have one point, you cannot edit this value for this feature.

...= A single hit is entered at the ellipsis.


Basic Measurement Format for a Line

Display Menu Roadmap

The minimum number of hits for a line is two.

Feature_name=FEAT/LINE,TOG1,TOG4
THEO/TX,TY,TZ,TI,TJ,TK
ACTL/X,Y,Z,I,J,K
MEAS/LINE,TOG3,TOG7
...
ENDMEAS/

TOG1= This field can be toggled between RECT / POLR.

TOG3= This value is user editable and is determined by the feature being measured. The HIT line is varied, based on the number of hits set up by the user. For example, 2 hits = 2 HIT/BASIC lines, 3 hits = 3 HIT/BASIC lines.

TOG4= This field can be toggled between BND / UNBND. If set to BND, the THEO and ACTL fields, no longer display the vector information, but instead show the XYZ values for the second point along with the first. See "Line Definition Format".

TOG7= This field switches between the various reference types. These include FEATURE, 3D, WORKPLANE, XPLUS, YPLUS, ZPLUS, XMINUS, YMINUS, ZMINUS.

...= As many hits as are necessary are entered at the ellipsis.

Measured Lines and Working Planes

When creating a measured line, PC-DMIS expects the hits for the line to be taken at a vector perpendicular to the current working plane.

For example, if your current working plane is ZPLUS (with a vector 0,0,1), and you have a block-like part, the hits for the measured line must be on a vertical wall of that part, such as the front or side.

If you then wanted to measure a line feature on the top surface of the part, you would need to switch the working plane to XPLUS, XMINUS, YPLUS, or YMINUS, depending on the direction of the line.

See the "Working Plane List" topic for information on how to change the working plane.


Basic Measurement Format for a Plane

Display Menu Roadmap

The minimum number of hits for a plane is three.

Feature_name=FEAT/PLANE,TOG1
THEO/TX,TY,TZ,TI,TJ,TK
ACTL/X,Y,Z,I,J,K
MEAS/PLANE,TOG3
...
ENDMEAS/

TOG1= This field can be toggled between RECT / POLR.

TOG3= This value is user editable and is determined by the feature being measured. The HIT line is varied, based on the number of hits set up by the user. For example, 3 hits = 3 HIT/BASIC lines, 8 hits = 8 HIT/BASIC lines.

...= As many hits as are necessary are entered at the ellipsis.


Basic Measurement Format for a Circle

Display Menu Roadmap

The minimum number of hits for a circle is three.

Feature_name=FEAT/CIRCLE,TOG1,TOG4,TOG6
THEO/TX,TY,TZ,TI,TJ,TK,TD
ACTL/X,Y,Z,I,J,K,D
MEAS/CIRCLE,TOG3,TOG7
...
ENDMEAS/

TOG1= This field can be toggled between RECT / POLR.

TOG3= This value is user editable and is determined by the feature being measured. The HIT line is varied, based on the number of hits set up by the user. For example, 3 hits = 3 HIT/BASIC lines, 5 hits = 5 HIT/BASIC lines.

TOG4= This field can be toggled between IN / OUT.

TOG6= This field switches between the various Best Fit types available. These include: LEAST_SQR, MIN_SEP, MAX_INSC, MIN_CIRCSC, FIXED_RAD

TOG7= This field switches between the various reference types. These include FEATURE, 3D, WORKPLANE, XPLUS, YPLUS, ZPLUS, XMINUS, YMINUS, ZMINUS.

...= As many hits as are necessary are entered at the ellipsis.


Basic Measurement Format for a Sphere

Display Menu Roadmap

The minimum number of hits for a sphere is four.

Feature_name=FEAT/SPHERE,TOG1,TOG4
THEO/TX,TY,TZ,TI,TJ,TK,TD
ACTL/X,Y,Z,I,J,K,D
MEAS/SPHERE,TOG3
...
ENDMEAS/

TOG1= This field can be toggled between RECT / POLR.

TOG3= This value is user editable and is determined by the feature being measured. The HIT line is varied, based on the number of hits set up by the user. For example, 4 hits = 4 HIT/BASIC lines, 7 hits = 7 HIT/BASIC lines.

TOG4= This field can be toggled between IN / OUT.

...= As many hits as are necessary are entered at the ellipsis.


Basic Measurement Format for a Cone

Display Menu Roadmap

The minimum number of hits for a cone is six.

Feature_name=FEAT/CONE,TOG1,TOG4,TOG5
THEO/TX,TY,TZ,TI,TJ,TK,TL,TD1,TD2
ACTL/X,Y,Z,I,J,K,L,D1,D2
MEAS/CONE,TOG3
...
ENDMEAS/

TOG1= This field can be toggled between RECT / POLR.

TOG3= This value is user editable and is determined by the feature being measured. The HIT line is varied, based on the number of hits set up by the user. For example, 6 hits = 6 HIT/BASIC lines, 11 hits = 11 HIT/BASIC lines.

TOG4= This field can be toggled between IN / OUT.

TOG5= This field can be toggled between LENGTH / ANGLE.

...= As many hits as are necessary are entered at the ellipsis.

TD1,TD2= These are the cone's two theoretical diameters.

D1,D2= These are the actual measured values for the cone's two diameters


Basic Measurement Format for a Cylinder

Display Menu Roadmap

The minimum number of hits for a cylinder is six.

Feature_name=FEAT/CYLINDER,TOG1,TOG4,TOG6
THEO/TX,TY,TZ,TI,TJ,TK,TD,TL
ACTL/X,Y,Z,I,J,K,D,L
MEAS/CYLINDER,TOG3
...
ENDMEAS/

TOG1= This field can be toggled between RECT / POLR.

TOG3= This value is user editable and is determined by the feature being measured. The HIT line is varied, based on the number of hits set up by the user. For example, 6 hits = 6 HIT/BASIC lines, 11 hits = 11 HIT/BASIC lines.

TOG4= This field can be toggled between IN / OUT.

TOG6= This field switches between the various Best Fit types available. These include: LEAST_SQR, MIN_SEP, MAX_INSC, MIN_CIRCSC, FIXED_RAD

...= As many hits as are necessary are entered at the ellipsis.

Note: If you create a measured cylinder with more than two rows, and later change the Number of Hits in the Measured Cylinder dialog box, PC-DMIS will keep the number of rows the same.


Basic Measurement Format for a Round Slot

Display Menu Roadmap

The minimum number of hits for a round slot is six.

Feature_name=FEAT/SLOT,TOG1,TOG2
THEO/TX,TY,TZ,TI,TJ,TK,SI,SJ,SK,TW,TL
ACTL/X,Y,Z,I,J,K,MI,MJ,MK,W,L
MEAS/SLOT,TOG3,TOG4
...
ENDMEAS/

T OG1= This field can be toggled between RECT / POLR.

TOG2= This field can be toggled between IN / OUT.

TX,TY,TZ - Theoretical XYZ

TI,TJ,TK - Theoretical IJK vector

SI,SJ,SK - Theoretical IJK slot vector

TW - Theoretical width

TL - Theoretical length

X,Y,Z - Actual measured XYZ

I,J,K - Actual measured IJK

MI, MJ,MK - Measured IJK slot vector

W - Actual measured width

L - Actual measured length

TOG3= This value is user editable and is determined by the feature being measured. The HIT line is varied, based on the number of hits set up by the user. For example, 6 hits = 6 HIT/BASIC lines, 8 hits = 8 HIT/BASIC lines.

TOG4= This value lets you choose the reference type for the slot.

...= As many hits as are necessary are entered at the ellipsis.


Basic Measurement Format for a Square Slot

Display Menu Roadmap

The minimum number of hits for a square slot is five.

Feature_name=FEAT/SLOT,TOG1,TOG2
THEO/TX,TY,TZ,TI,TJ,TK,SI,SJ,SK,TW,TL
ACTL/X,Y,Z,I,J,K,MI,MJ,MK,W,L
MEAS/SLOT,TOG3,TOG4
...
ENDMEAS/

T OG1= This field can be toggled between RECT / POLR.

TOG2= This field can be toggled between IN / OUT.

TX,TY,TZ - Theoretical XYZ

TI,TJ,TK - Theoretical IJK vector

SI,SJ,SK - Theoretical IJK slot vector

TW - Theoretical width

TL - Theoretical length

X,Y,Z - Actual measured XYZ

I,J,K - Actual measured IJK

MI, MJ,MK - Measured IJK slot vector

W - Actual measured width

L - Actual measured length

TOG3= This value is user editable and is determined by the feature being measured. The HIT line is varied, based on the number of hits set up by the user. For example, 5 hits = 6 HIT/BASIC lines.

TOG4= This value lets you choose the reference type for the slot.

...= As many hits as are necessary are entered at the ellipsis.


Inserting a Measured Feature

PC-DMIS allows you to insert measured features into your part program by interpreting your probe hits and guessing the correct feature type. If PC-DMIS guesses incorrectly, you can force PC-DMIS to choose the correct feature type as long as you have taken the minimum number of hits for the desired feature.

For information on creating the different feature types, consult the documentation set for your PC-DMIS configuration:

  • PC-DMIS CMM

The procedures given in the following topic assume that you are working in offline mode.

More:

Guessing a Measured Feature Type

To Force the Insertion of a Certain Measured Feature Type


To Force the Insertion of a Certain Measured Feature Type

If PC-DMIS guesses the wrong measured feature type, you can cause it to insert the desired type by selecting the correct measured feature from the Measured Features toolbar or submenu prior to pressing the END key. Once you press the END key, PC-DMIS will insert the selected feature type into the Edit window.


Guessing a Measured Feature Type

The following table shows the minimum number of hits PC-DMIS needs to guess a particular Measured Feature and that feature's dimension type.

Minimum # of Hits | Feature | Dimension
1 | Point | 1D
2 | Line | 2D
3 | Circle | 2D
3 | Plane | 3D
6 | Cylinder | 3D
6 | Cone | 3D
4 | Sphere | 3D

Measured Point - Rules:

  • Probe compensation is in the nearest axis (X, Y, or Z). This is determined based on the direction of machine motion at the time the hit is taken. Always approach normal to the surface.

  • Only measure points on surfaces perpendicular to the X, Y, or Z axis to ensure accurate probe compensation.
    Note:     Use Vector or Surface points for other surfaces (Auto Feature).

  • Measured Points are 1D, therefore dimensional information is only valid in one axis (X, Y, or Z).

Measured Line - Rules:

  • Measured Lines are 2D, therefore they are dependent on the active workplane for calculation purposes. You must activate the appropriate workplane before measuring a line.

  • You control the direction of the measured line. The direction will go from the first hit towards the second hit.

  • The dimensional information in the X, Y, or Z axis is from the centroid of the line.

Measured Circle - Rules:

  • Measured Circles are 2D, therefore they are dependent on the active workplane for calculation purposes. You must activate the appropriate workplane before measuring a circle.

  • A minimum arc of 90 degrees is required to accurately calculate a measured circle.

  • The dimensional information in the X, Y, or Z axis is from the centroid of the circle, and the diameter is the average diameter by default (least squares).

Measured Plane - Rules:

  • Measured Planes are 3D, therefore they are not dependent on the active workplane for calculation purposes.

  • The IJK vector for the plane is perpendicular to the plane, and its direction points away from the material of the part.

  • The dimensional information in the X, Y, or Z axis is from the centroid of the plane.

Measured Cylinder - Rules:

  • Measured Cylinders are 3D, therefore they are not dependent on the active workplane for calculation purposes.

  • You control the direction of the IJK vector for the cylinder. It goes from the first circular cross-section towards the second circular cross-section.
    Note:     You should take three circular cross-sections when possible to increase the hit data used to calculate the cylinder.

  • The dimensional information in the X, Y, or Z axis is from the centroid of the cylinder, and the diameter is the average by default (least squares).

Measured Cone - Rules:

  • Measured Cones are 3D therefore they are not dependent on the active workplane for calculation purposes.

  • You do not control the direction of the IJK vector for the cone. The IJK vector always points away from the vertex of the cone. Note: It is recommended to take three circular cross-sections when possible to increase the hit data used to calculate the cone.

  • The dimensional information in X,Y, or Z axis is from the centroid of the cone.

Measured Sphere - Rules:

  • Measured Spheres are 3D, therefore they are not dependent on the active workplane for calculation purposes.

  • In some cases it is not possible to take a hit on top of the sphere. In these cases take three circular cross-sections and the IJK vector direction will go from the first toward the last cross-section.

  • The dimensional information in the X, Y, or Z axis is from the centroid of the sphere and the diameter is the average.

Using Guess Mode

  1. Access the Edit window, and place it in either Command or Summary mode.

  2. Place PC-DMIS into Program Mode, and set the appropriate probe depth.

  3. Access the Measured Features toolbar, and then click the Guess Mode icon.

  4. Click on the model of the part at the location where you want to insert the feature.

  • If you're using an imported wire frame CAD model, PC-DMIS will automatically use the nearest wire as the basis for the feature you selected.

  • If you're using an imported solid CAD model, each mouse click is counted as an individual hit.

  5. Press the END key. PC-DMIS interprets your hits and places the guessed feature into the Edit window.

For information about the Guess Mode icon and the Measured Features toolbar, see the "Measured Features Toolbar" topic in the "Using Toolbars" section.


Editing a Measured Feature

PC-DMIS will allow you to select the desired measured feature in the Edit window and make any corrections directly to the Edit window. The Measured Feature dialog box was created to offer a user friendly alternative to editing the edit window.

To open a Measured Feature dialog box:

  1. Place the cursor within the first four lines of the desired measured feature.

  2. Press the F9 key.

A Sample Measured Circle dialog box

Note: Generally a Measured Feature dialog box will open based on the feature type. However, if the cursor is placed on a listed hit (i.e. HIT/BASIC) within the measured feature and the F9 key is pressed, PC-DMIS will instead display the Measured Hits dialog box for the selected hit.

More:

Measured Feature Dialog Box Description

Measured Hits Dialog Box Description


Measured Feature Dialog Box Description

The Measured Feature dialog box allows you to edit the selected measured feature. The following topics describe the Measured Feature dialog box.

More:

Feature Name

Number of Hits

Reference Type

Best Fit Math Type

Regenerate Hit Targets

Copy to Actuals

Coordinate System

Angular Definition Format

Circular Feature Type

Line Definition Format

Feature Theoreticals

Hit Targets


Feature Name

The Feature Name box allows you to change the name of the displayed feature. Simply highlight the feature ID in the Edit window, type in a new identification and press the ENTER key. PC-DMIS allows you to duplicate feature identifications. Caution should therefore be used in changing feature names if identical IDs are not desired.


Number of Hits

The Number of Hits box allows you to change the number of hits for a specified feature.

For example: Currently four hits are listed in the edit box. If you delete a hit, the last hit (#4) in the feature list will be deleted. If two hits are deleted, the last two hits (#4 and #3) will be deleted. PC-DMIS will renumber the remaining hits based on its current numbering assignment.

If you add a hit, PC-DMIS will increase the Hit Target list by one, displaying an extra hit at the end of the hit list. This hit will not indicate any x, y, z, i, j, k values until the program is executed. At that time PC-DMIS will prompt the operator to take the additional hit. PC-DMIS will ask if the hits are to be equally spaced.

  • Answer by clicking Yes, and PC-DMIS will take the hits in equally spaced intervals. On a cone, sphere, or cylinder feature, PC-DMIS displays a Levels dialog box. You can use this dialog box to specify the number of levels PC-DMIS will use to equally space the hits. The default is two.

  • If you click the No button, PC-DMIS will display the hit values as 0, 0, 0, 0, 0, 1. You will then need to manually enter the hit values.


Reference Type

The Reference Type list controls whether or not the measured feature is 3D, projected to the current workplane, projected to a specified plane, or projected relative to another feature. This affects mathematically how the final characteristics of the feature are derived.


Best Fit Math Type

This Best Fit Math Type list indicates the type of math algorithm that will be used to measure the feature. LEAST_SQR is the standard Best Fit method.

For legacy Circularity and Cylindricity dimensions as well as a Location dimension's RN Line, the feature solution is used to compute the dimension. By default this is Least Squares. However, you can choose to solve the feature using Minimum Separation, Maximum Inscribed, Minimum Circumscribed, or Fixed Radius regression algorithms.

FCF Circularity and Cylindricity dimensions on the other hand are computed using the Chebychev algorithm (Min/Max) as required by the Y14.5 standard. Because of the change in calculation, Circularity and Cylindricity FCF dimensions will generally compute to a slightly smaller value than their legacy counterparts.

See "Calculation List" in the "Creating Auto Features" section for a discussion on these types.


Regenerate Hit Targets

The Regenerate Hit Targets check box regenerates this feature's HIT/BASIC commands so that they are updated with changed data from the Feature Theoreticals area.


Copy to Actuals

The Copy to Actuals check box copies any changes made to the Feature Theoreticals area of the dialog box and applies the same changes to the actual measured data.


Coordinate System

The Coordinate System area allows you to choose between rectangle and polar coordinates. If the Rect option is selected, all points are represented in Cartesian system (x, y, z). If Polar is selected, all points are displayed in polar system (x_radius, y_angle, z_height). Vectors do not change.


Angular Definition Format

If an angular feature is displayed, PC-DMIS will allow you to choose between LENGTH and ANGLE.

· The length option displays the diameters of two circles. It also will display the length between the two circles.

· The angle option will display the nominal (x, y, z) and vector (i, j, k) of the point. It also will display the angle value.


Circular Feature Type

If a circular feature is displayed, PC-DMIS will allow you to choose between IN and OUT.


Line Definition Format

If a linear feature is displayed, PC-DMIS will allow you to choose between the Bound and Unbound options in the Linear Definition Format area.

Selecting Bound causes PC-DMIS to display the two end points that make up the line in the Feature Theoreticals area, like this:

X, Y, Z

and

X2 Nom, Y2 Nom, and Z2

For Bounded lines, the Length value is grayed out and unavailable for modification.

Selecting Unbound causes PC-DMIS to display the line's nominal information in the Feature Theoreticals area, like this:

X, Y, Z, and length

and

I Nom, J Nom, and K


Feature Theoreticals

This area contains the theoretical data for the feature. You can update this data by making changes and clicking OK. Note that this will only update the theoretical data. If you want to affect the hits and the actual measured data, select the Regenerate Hits and Copy to Actuals check boxes.


Hit Targets

Supported features:
Measured Circle
Measured Cylinder
Measured Point
Measured Plane
Measured Sphere
Measured Line
Measured Cone

For supported measured features, the Hit Targets button allows you to view or change hit data for the feature.

Clicking the Hit Targets button opens the Feature Hit Targets dialog box.

Feature Hit Targets dialog box

This dialog box lists the hit data by rows. The numbers to the left of the rows indicates the order of the hits. You can change the hit data by double-clicking on a row and editing its values in the resulting Measured Hits dialog box.

The Feature Hits Targets dialog box also lets you view and edit hit data by using the Graphics Display window. As long as the Feature Hit Targets dialog box remains open, you can do the following:

· View individual hits with red colored arrows. Click any of the rows with hit data listed in the Feature Hit Targets dialog box and the associated arrow in the Graphics Display area turns red.

· Click and drag for each hit to a new position. You can move a hit by selecting the red colored arrow on the Graphic Display area and dragging it to a new location. Releasing the mouse places the hit at that point and calculates the data, updating the Feature Hit Targets dialog box.

· Insert new hits. You can also insert new hits into an existing feature. Select a location within the hit list, and then take any desired hits. Once you press the END key, PC-DMIS asks if you want to insert the hit(s) at the current location. If you select Yes, PC-DMIS will insert the new hit(s) into that location of the current feature. If you select No, PC-DMIS will move the insert cursor to the next valid position in the part program (generally immediately below the current feature in the Edit window) and create a new feature.

Note: Data in the Feature Hit Targets dialog box and in the Edit window isn’t updated dynamically when you make changes using any of these methods. You need to first close the dialog box and then reopen it to see the changed hit data.

Delete Hit button

The Delete Hit button inside the Feature Hit Targets dialog box only becomes enabled when editing the hits for supported auto features. To delete an existing hit, select the hit and click Delete Hit. PC-DMIS removes the hit from the dialog box and from the part program. See the "Display Hits button" topic in the "Creating Auto Features" section.


Measured Hits Dialog Box Description

Sample Measured Hits dialog box

The Measured Hits dialog box allows you to edit individual hits of a measured feature. To access this dialog box, select one of the BASIC hits inside the Edit window and press F9. You can edit the following items:

  • Hit Type

  • X, Y, and Z position.

  • Various vectors

  • Spacer

  • Indent

  • Depth

  • Hits per Surface

Some items are unavailable unless you select a specific hit type. To update hit data for the selected measured feature, edit the values in this dialog box, and click OK.

More:

Editing Basic Hits by Probing:


Editing Basic Hits by Probing:

You can also update Basic hits by probing the part in online mode, or clicking on the CAD in offline mode with the Measured Hits dialog box open. PC-DMIS will automatically update the dialog box with the new results.

For Basic hits, these check boxes appear:

Use Theoretical Vector As Approach Vector | This check box allows you to specify whether or not the theoretical vector should be used as the approach vector. If deselected, PC-DMIS calculates the approach vector by subtracting the theoretical hit point (X,Y,Z) from the current probe position.
Learn Hit During Execution | This check box allows you to specify whether or not PC-DMIS should relearn the basic hit during part program execution.


Overriding a Guessed Measured Feature

The Override submenu allows you to change the type of feature that was guessed. For example, if the last feature you were attempting to measure was circle and PC-DMIS guessed that it was a plane, this option can be used to convert the feature to the proper type. If you intend to override a guessed feature, you must do so before you create any other features.

To use the Override feature:

  1. Access the Edit window.

  2. Place your cursor on the incorrect feature type in the Edit window.

  3. Access the Edit | Override Guess submenu to begin the Override process. Display Menu Roadmap

  4. Select the correct feature type.

You will see that the feature changes will be made in the Edit window.


Creating Measured Feature Sets

The Insert | Feature | Measured | Feature Set menu item inserts a Measured Feature Set command (also called a Point Set) into the Edit window. This command creates a scan of a single point that will measure the same point a defined number of times in order to obtain an averaged (and hopefully more accurate) representation of the point measurement.

Point Sets are most often used as inputs when performing Leapfrog alignment operations with a manual arm machine. See "Performing a Leapfrog Operation" in the "Creating and Using Alignments"section for more information.

In Command mode, the Measured Feature Set looks like this:

SCN1 =FEAT/SET,RECT

THEO/0,0,0,0,0,1

ACTL/0,0,0,0,0,1

MEAS/SET,0

ENDMEAS/

Pressing F9 while your cursor lies within this command displays the Measured Set dialog box:

Measured Set dialog box

Measured Set dialog box

For information on this dialog box, see the "Editing a Measured Feature" topic; this dialog box contains many of the same items are already discussed in that topic.

To Create a Measured Feature Set (Point Set):

  1. Press F9 on the inserted measure feature set command.

  2. In the dialog box, type in the point's theoretical XYZ location and IJK vector.

  3. In the Number of Hits box, specify the number of measurements you want PC-DMIS to take on this point. The higher the number, the better average you will receive.

  4. Select other options in the dialog box as desired.

  5. Click OK. PC-DMIS updates the command in the Edit window.

For example, a finished point set scan with 5 iterations might look like this:

SCN1 =FEAT/SET,RECT

THEO/107,11,21,0,0,1

ACTL/0,0,0,0,0,1

MEAS/SET,5

HIT/BASIC,NORMAL,107,11,21,0,0,1,0,0,0,USE THEO = YES

HIT/BASIC,NORMAL,107,11,21,0,0,1,0,0,0,USE THEO = YES

HIT/BASIC,NORMAL,107,11,21,0,0,1,0,0,0,USE THEO = YES

HIT/BASIC,NORMAL,107,11,21,0,0,1,0,0,0,USE THEO = YES

HIT/BASIC,NORMAL,107,11,21,0,0,1,0,0,0,USE THEO = YES

ENDMEAS/


Constructing New Features from Existing

Constructing New Features from Existing Features

Constructing New Features from Existing Features: Introduction

Understanding the General Command Format

S pecifying Feature Theoreticals

Constructing a Point Feature

Constructing a Circle Feature

C onstructing an Ellipse Feature

Constructing a Sphere Feature

Constructing a Line Feature

Constructing a Cone Feature

Constructing a Cylinder Feature

Constructing a Plane Feature

Constructing a Slot Feature

Constructing a Curve

Constructing a Surface

Constructing a Set of Features

Constructing a Filter Set

Constructing an Adjusted Filter


Constructing New Features from Existing Features: Introduction

The Insert | Feature | Constructed submenu is used when probing on a required element is not possible (for example, the intersection point of two edges). Display Menu Roadmap

The items from this menu allow you to create features (points, lines, circles, etc.) from existing features (ones already probed or constructed). The "Navigating the User Interface" section describes the several ways to specify the input feature(s). See the "Selecting Features Using the Graphics Display Window" topic in the "Editing the CAD Display" section for a description of the several ways to specify the input feature(s).

Features can be constructed by selecting features in the dialog boxes or the Edit window (see "To construct a feature from the Edit window" and "To construct a feature using the construction dialog boxes:"). The specific rules for constructing a feature from other features are found in the appropriate sections, and apply to both methods of construction. The default method for constructing a feature is Auto. In this case, PC-DMIS automatically determines the best construction type based on the input feature(s). The order of selection (unless noted otherwise) is usually not important. It is only necessary that the correct feature type(s) be chosen. For example, to construct an intersect point between a line and a slot, simply select the necessary line and slot. PC-DMIS will create a point where the line intersects the slot.

It is important to note that the documented conventions are simply a tool allowing you to become familiar with the rules governing the Edit window. The actual Edit report will be displayed using all CAPITAL LETTERS.

Example of the command line showing a constructed point in the Edit window:

CONSTR/POINT, INTOF, line_id, slot_id
or, CONSTR/POINT, INTOF, slot_id, line_id.

The main topics discussed in this section include:

  • Understanding the General Command Format

  • Specifying Feature Theoreticals

  • Constructing a Point Feature

  • Constructing a Circle Feature

  • Constructing an Ellipse Feature

  • Constructing a Sphere Feature

  • Constructing a Line Feature

  • Constructing a Cone Feature

  • Constructing a Cylinder Feature

  • Constructing a Plane Feature

  • Constructing a Slot Feature

  • Constructing a Curve

  • Constructing a Surface

  • Constructing a Set of Features

  • Constructing a Filter Set

  • Constructing an Adjusted Filter


To construct a feature from the Edit window

  1. Access the Edit window (View | Edit Window). Display Menu Roadmap

  2. Place the cursor where you want to construct the feature in the Edit window.

  3. Type the command CONSTR/... followed by the appropriate text. (See the example of the command line for a constructed point shown above.)


To construct a feature using the construction dialog boxes:

  1. Select the Insert | Feature | Constructed submenu. Display Menu Roadmap

  2. Select the type of feature to be constructed. Available options are:

  • Point

  • Circle

  • Ellipse

  • Sphere

  • Line

  • Cone

  • Cylinder

  • Plane

  • Slot

  • Curve

  • Surface

  • Feature Set

  • Filter Set

  3. Once the selection of the input features is completed within the dialog box, select the Create button.

PC-DMIS will construct the feature and display it on the screen. It will also display the feature's center point in the Edit window. PC-DMIS will construct the requested feature, leaving the dialog box open, adding the newly constructed feature into the dialog box. This allows you to construct multiple features based on newly constructed features.


Understanding the General Command Format

In the Edit window all constructed features are displayed in the following format. There will be slight variations that are explained more thoroughly in the following sections.

The actual Edit report will be displayed using all CAPS.

For example:

Feature_name=FEAT/TYPE OF FEATURE,TOG1,.....
THEO /x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,......
ACTL /x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,......
CONSTR/TOG2,TOG3,......

feature_name: name of feature. This is a user editable field.

TYPE OF FEATURE: This field denotes the feature type. This feature type is the same as TOG2 but is non-editable and is not a toggle field.

...... : This indicates that what follows is unique to each feature. This is explained more thoroughly in the necessary areas of the manualhelp file.

TOG1: This field is present in all features and can be switched between RECT / POLR. If this feature is RECT, all points are represented in Cartesian system (x, y, z). If field is POLR, all points are displayed in polar system (x_radius, y_angle, z_height). Vectors do not change.

TOG2: This field is present in all features and can be switched between the different types of features taking the following values:

CIRCLE / CONE / CYLINDER / LINE / PLANE / POINT / SPHERE / CURVE / SURFACE / SET /

POINT is the default feature type when the construct command line is opened for the first time in a part program. The default feature type then becomes the last constructed feature type.

TOG3: This field is also present in all features, but takes unique values according to the type of feature. (See specific feature type for additional information.)

More:

Accessing the Dialog Box

Decimal Placement Conventions


Accessing the Dialog Box

To access the corresponding construction dialog box from which an Edit window's feature was created:

  1. Make sure the Edit window is open.

  2. In the Edit window, click the mouse on the feature's name.

  3. Press F9. A construction dialog box will appear.

Using this dialog box you can make any desired changes, and when you click the Create button the updated changes will be made to the Edit window.


Decimal Placement Conventions

Please note the following information regarding decimal place conventions for constructed features:

  • All vectors (i_vect, j_vect, k_vect) are represented by a maximum of 5 places to the right of the decimal.

  • All lengths and distances (x_cord, y_cord, z_cord, diam, height, length, etc.) are represented by a maximum of 5 places to the right of the decimal.

  • All angles are represented by a maximum of 5 places to the right of the decimal.

  • If the decimal place is zero, then the number is represented as an integer.

Note: Decimal places can be changed through the Dimension tab (F5) on the Setup dialog box. Setting the decimal place limit inserts a DISPLAYPRECISION command in the Edit window. All features following this command conform to the number of decimal places specified.


Specifying Feature Theoreticals

PC-DMIS Version 4.2 and above provides the ability to specify theoretical information for most of the constructed feature types in PC-DMIS. Traditionally, PC-DMIS has used the theoretical values from the input features to calculate a theoretical value for the constructed feature. In some circumstances, however, you may not want this result. To make constructed features more flexible, you can override the traditional behavior and specify your own theoretical values for the feature.

At the bottom the constructed features dialog box you will see the new Feature Theoreticals area. This area remains unavailable for selection until you select the Specify Theos check box. This enables the other items in the area, allowing you to override the calculated theoretical values from the input features with specified theoretical values.

Feature Theoreticals area

The items that appear in the Feature Theoreticals area change depending on the feature you are constructing. Each feature will display at least the X, Y, and Z boxes (the location) and the I, J, and K boxes (the orientation). For features with characteristic sizes, such as circles, slots, cones, and so forth, additional items will appear in this area.

To Override Feature Theoreticals

To change an existing feature from the traditional method, to the new theoretical override:

  1. Open the feature by pressing F9. The dialog box for that constructed will appear.

  2. Select the Specify Theos check box. The Feature Theoretical area becomes enabled for edit.

  3. Change the theoretical values by editing the available items.

  4. Click the Create button when finished.

Alternately, you can edit the feature from the Edit window by changing the appropriate field.

  • In Command Mode you would set the last field on the first line of the feature to YES and then manually type the values in the THEO line.

  • In Summary Mode you would set the User Specified Theos value to YES and then modify the Theoreticals group.

To have PC-DMIS automatically calculate the feature information based on the input features (the traditional method), simply clear the Specify Theos check box in the dialog box or change the appropriate value in the Edit window. The features will update accordingly.

Because you are editing your feature theoretical values, PC-DMIS will ask if you want to update your measured values and the theoretical values of any associated dimensions. This is standard PC-DMIS behavior.

All constructed features have this capability except for:

  • Curve

  • Surface

  • Filter

  • Set

  • Adjust Filter


 Constructing a Cast Point Close button Create button Clear button Constructing an Offset Point Constructing an Auto Circle Feature List box Select Last # Search ID ID Constructing a Projected Point Constructing an Intersect Point Constructing a Point at the Origin Constructing a Drop Point Constructing a Mid Point Constructing a Corner Point Constructing a Pierce Point

Constructing a Point Feature

Construct Point dialog box

There are a number of ways to construct a point using PC-DMIS. The following table lists the various types of constructed points, along with their necessary inputs. Some features may require no inputs while others may require three inputs or more. In the table, the term 'Any' indicates that the construction can take any type of feature as input for construction. PC-DMIS allows the features to be selected in any order.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT FEATS | FEAT #1: | FEAT #2: | FEAT #3: | COMMENTS
Cast Point | CAST | 1 | Any | - | - | Constructs point at centroid of input feature
Corner Point | CORNER | 3 | Plane | Plane | Plane | Constructs point at the intersection of 3 planes
Drop Point | DROP | 2 | Any | Cone, Cylinder, Line, Slot | - | First feature is dropped onto the second line feature
Intersect Point | INTOF | 2 | Circle, Cone, Cylinder, Line, Slot | Circle, Cone, Cylinder, Line, Slot | - | Constructs point at the intersection of the linear attribute of 2 features
Mid Point | MID | 2 | Any | Any | - | Constructs Mid Point between centroids of the inputs
Offset Point | OFFSET | 1 | Any | - | - | Requires 3 offsets corresponding to X,Y, & Z
Origin Point | ORIGIN | 0 | - | - | - | Constructs point at alignment origin
Pierce Point | PIERCE | 2 | Cone, Cylinder, Line, Slot, Circle, Ellipse | Cone, Cylinder, Plane, Sphere, Circle, Ellipse | - | Constructs point where feat_1 pierces surface of feat_2. Order of selection is important. If first feature is line, direction is important.
Vector Distance Point | VECT_DIST | 2 | Any | Any | - | Constructs point at a distance from the second feature along the line from the two input features.
Project Point | PROJ | 1 or 2 | Any | Plane | - | 1 input feature will project point to work plane

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the Status Bar.

To construct a point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Input the desired features.

  3. Select the method of construction. Available options include:

  • Cast Point

  • Corner Point

  • Drop Point

  • Intersect Point

  • Mid Point

  • Offset Point

  • Origin Point

  • Pierce Point

  • Vector Distance Point

  • Project Point

  4. Click the Create button.

The Edit window command line for a sample point construction would read:
feature_name=FEAT/POINT,TOG1
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec
CONSTR/TOG2,TOG3,......\

Note: The actual Edit report will be displayed in all CAPS.

TOG1= POLR or RECT

TOG2 = POINT

TOG3 = CAST / CORNER / DROP / INTOF / MID / OFFSET / ORIG / PIERCE / PROJ

The first three lines displayed in the Edit window will be the same for all constructed points. The fourth line will be slightly different, according to the type of feature being constructed. You can switch between the different types of points by placing the cursor on TOG3 and pressing F7 or F8. (See "Command Mode Keyboard Functions" in the "Using the Edit Window" section.)

When two or more features are involved, PC-DMIS automatically determines the necessary order of the input features. This improves the accuracy of the measurement process.

AUTO is the default method of construction. This option automatically determines the best way to construct a point using the input feature(s). See "Auto Point Construction".

The following paragraphs describe the available options for constructing a point.

More:

Constructing a Cast Point

Constructing a Corner Point

Constructing a Drop Point

Constructing an Intersect Point

Constructing a Mid Point

Constructing an Offset Point

Constructing a Point at the Origin

Constructing a Pierce Point

Constructing a Vector Distance Point

Constructing a Projected Point

Auto Point Construction


Constructing a Cast Point

A point can be constructed by changing any given feature into the point. PC-DMIS will construct the point at the centroid of the input feature.

To construct a Cast Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the Cast option from the list of options.

  3. Select any feature.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/POINT,CAST,feat_1

Constructing a Cast Point from a Circle


Constructing a Corner Point

A point can be constructed from three planes. PC-DMIS creates a point at their intersection. The vector of the constructed corner point is the cross product of the second input vector into the third input vector.

To construct a Corner Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the Corner Point option from the list of options.

  3. Select three different planes.

  4. Click the Create button.

The Edit window command line for this option would read: CONSTR/POINT,CORNER,feat_1,feat_2,feat_3

Constructing a Corner Point from three Planes

A - Point constructed at the intersection of three planes (PLN1, PLN2, and PLN3).


Constructing a Drop Point

A point can be constructed from any feature and a line (cone, cylinder or slot). PC-DMIS will drop the centroid of the first feature onto the second feature. The "dropped" point will be dropped on a line that is perpendicular to the line, centerline, or plane. If two line features are selected, PC-DMIS will drop the centroid of the first line feature onto the second line feature.

Note: For this construction method you must select feature types in the correct order.

To construct a Drop Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the Drop Point option from the list of options.

  3. Select the first feature. It may be of any type.

  4. Select the second feature. It must be of cone, cylinder, line, or slot.

  5. Click the Create button.

The Edit window command line for this option would read:
CONSTR/POINT,DROP,feat_1,feat_2

Constructing a Drop Point from a Circle and a Line

A - Point is constructed by normally projecting circle, CIR1 (the designated point) to line, LINE1.

Note: If you select a slot as one of your input features, PC-DMIS will use the slot centerline vector when constructing this point instead of the slot normal vector (in versions 3.2 and earlier PC-DMIS used the slot normal vector). If you want to use the older slot normal vector, you will need to modify the value for the UseLegacySlotVector entry in the PC-DMIS Settings Editor. For information on how to do this, see the "Modifying Registry Entries" section.


Constructing an Intersect Point

A point can be constructed between a line (circle, cone, cylinder, or slot) and a line, (circle, cone, cylinder, or slot). The point is created where the lines (centerlines) of the two features intersect. It is also possible to intersect two circle features or a line feature and a constructed curve.

Constructing an Intersect Point from Two Lines

A - Point constructed from 2 lines (LINE1 and LINE2).

If you want to intersect or pierce a circle with a line, see "Constructing a Pierce Point".

To Construct an Intersect Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the Intersect option from the list of options.

  3. Select two features of this type (circle, cone, cylinder, line, slot, curve).

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/POINT,INTOF,feat_1,feat_2

If the two features do not intersect, the point is constructed midway between the two features at the apparent intersection. In other words, the intersect point is the mid-point of the shortest line connecting the two input features.

Constructing an Intersect Point from Two Lines That Do Not Intersect

You can intersect two circle features and as long as they have the same (or very similar) vectors, PC-DMIS will generate a constructed point feature at one of the intersection points. If you switch the order of the selected input features in the Construct Point Mode dialog box, PC-DMIS will construct a point at the other intersection point.

You can intersect a line feature with a constructed curve. The line and curve are first projected onto the current workplane, where the intersection is computed. If there is no intersection, an error message is displayed. Even though there may be many intersection points, only the one closest to the start of the curve is reported. To get the other intersection points it may be possible to subdivide the curve and compute intersections on the subcurves.

Note: If you select a slot as one of your input features, PC-DMIS will use the slot centerline vector when constructing this point instead of the slot normal vector (in versions 3.2 and earlier PC-DMIS used the slot normal vector). If you want to use the older slot normal vector, you will need to modify the value for the UseLegacySlotVector entry in the PC-DMIS Settings Editor. For information on how to do this, see the "Modifying the Registry" section.


Constructing a Mid Point

A point can be constructed from any two features without direction. PC-DMIS creates a mid-point between the centroids of the two input features.

To construct a Mid Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the Mid Point option from the list of options.

  3. Select any two features.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/POINT,MID,feat_1,feat_2

Constructing a Mid-Point from Two Circles

A - Point constructed midway between two circles, CIR1 and CIR2.


Constructing an Offset Point

A point can be constructed a specified distance from any input feature.

To construct an Offset Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the Offset Point option from the list of options.

  3. Select a feature from which to create the offset point.

  4. Click the Create button.

To create an offset point from the origin, select the At Origin option. To create an offset point relative to a particular feature, select the desired feature and key in the X, Y, and Z OFFSET.


XYZ Offset

These fields allow you to enter in offset distances for the X, Y, and Z, axes. These options are only available if the Offset option is selected first.

The Edit window command line for this option would read:
CONSTR/POINT,OFFSET,feat_1,dx,dy,dz


Constructing a Point at the Origin

A point can be constructed at the current alignment origin.

To construct an Origin Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the At Origin option.

  3. Do not select any input features.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/POINT,ORIG

Constructing a Point at the Origin

A - Point constructed at the origin (0,0,0).


Constructing a Pierce Point

A point can be constructed using a line (circle, cone, ellipse, slot, or cylinder) and a circle, ellipse or plane (cone, cylinder, or sphere). PC-DMIS will create a point where feat_1 pierces the surface of feat_2.

Note: For this construction method you must select feature types in the correct order.

  • If the pierced feature is a circle or an ellipse, PC-DMIS creates a cylindrical circumference about the centerline, and constructs the pierce point. If two similar features (two cylinders for example) are provided, PC-DMIS will pierce the second feature with the first feature.

  • If the pierced feature is a sphere, circle, cone, or cylinder the pierce point is constructed where the piercing input feature first intersects the surface of the pierced element. The first intersection point is determined by the direction of the line. It is important to know the direction in which the line was defined. If the wrong point is constructed, create a new, flipped line (see "Changing the Direction of a Line"), and use it to construct the point.

To construct a Pierce Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the Pierce option from the list of options.

  3. Select the first feature. It must be either a cone, cylinder, line, slot, circle, or ellipse.

  4. Select the second feature. It must be either an ellipse, circle, cone, cylinder, plane, or sphere.

  5. Click the Create button.

The Edit window command line for this option would read:

CONSTR/POINT,PIERCE,feat_1,feat_2

Constructing a Pierce Point from a Line and a Sphere

A - Point constructed at the intersection of a line and sphere

B - Sphere feature

C - Line (please note direction)


Constructing a Vector Distance Point

A point can be constructed at a specified distance along an imaginary line created from two input features. PC-DMIS constructs the point along the line from the first input to the second input at a specified distance from the second input.

For example, if your two input features were in order, PNT1 and PNT2, and you defined a distance of 10mm, PC-DMIS would construct the point (PNT3) like this:

Constructed Vector Distance Point, PNT3, Created from Input Features PNT1 and PNT2

To construct a Vector Distance Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the Vector Distance option from the list of options.

  3. Select the first feature.

  4. Select the second feature.

  5. Specify a distance in the Distance box. You can type a negative value to construct the point between the two input features.

  6. Click the Create button. PC-DMIS will construct a point at the specified distance from the second input feature along the line from the first feature to the second feature.

The Edit window command line for this option would read:
CONSTR/POINT,VECT_DIST,feat_1,feat_2,distance


Constructing a Projected Point

A point can be constructed from any feature and a plane. PC-DMIS will project the point where the plane intersects the point. If there is only one input feature, the projection will be to the work plane.

To construct a Projected Point:

  1. Access the Construct Point dialog box (Insert | Feature | Constructed | Point). Display Menu Roadmap

  2. Select the Projection option from the list of options.

  3. Select a feature from which to create the project point.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/POINT,PROJ,feat_1,(feat_2)

Constructing a Projected Point from a Point and a Plane

A - Projected point constructed from a point, PNT1, and a plane, PLN1.


Auto Point Construction

The following table indicates the type of point that will be constructed when the specified inputs are selected and the AUTO option is chosen. The order of the selected features is not important. If an incorrect input feature(s) is selected, PC-DMIS will display an error message and will not automatically construct the indicated feature type.

To allow PC-DMIS to automatically determine the best method of construction:

  1. Access the Construct Point dialog box.

  2. Select the Auto option from the list of options.

  3. Select the desired feature(s) based on the table below.

  4. Click the Create button.

Input Feature(s) | Constructs
Any 1 Feature = | Cast Point
Circle + Circle = | Mid Point
Circle + Cone = | Drop Point
Circle + Cylinder = | Drop Point
Circle + Ellipse | Mid Point
Circle + Line = | Pierce Point
Circle + Plane = | Project Point
Circle + Set = | Mid Point
Circle + Slot = | Mid Point
Circle + Sphere = | Mid Point
Cone + Cone = | Intersect Point
Cone + Cylinder = | Intersect Point
Cone + Ellipse | Drop Point
Cone + Plane = | Pierce Point
Cone + Set = | Drop Point
Cone + Slot = | Intersect Point
Cylinder + Ellipse | Drop Point
Cylinder + Plane = | Pierce Point
Cylinder + Set = | Drop Point
Cylinder + Slot = | Intersect Point
Ellipse + Ellipse | Mid Point
Line + Cone = | Intersect Point
Line + Cylinder = | Intersect Point
Line + Ellipse | Drop Point
Line + Line = | Intersect Point
Line + Plane = | Pierce Point
Line + Set = | Drop Point
Line + Slot = | Intersect Point
Line + Sphere = | Drop Point
Plane + Ellipse | Project Point
Plane + Plane = | Project Point
Plane + Set = | Project Point
3 Points = | Corner Point
Point + Circle = | Mid Point
Point + Cone = | Drop Point
Point + Cylinder = | Drop Point
Point + Ellipse = | Mid Point
Point + Line = | Drop Point
Point + Plane = | Project Point
Point + Point = | Mid Point
Point + Set = | Mid Point
Point + Slot = | Mid Point
Point + Sphere = | Mid Point
Set + Ellipse | Mid Point
Set + Set = | Mid Point
Slot + Ellipse | Mid Point
Slot + Plane = | Project Point
Slot + Set = | Mid Point
Slot + Slot = | Intersect Point
Sphere + Cone = | Drop Point
Sphere + Cylinder = | Drop Point
Sphere + Ellipse | Mid Point
Sphere + Plane = | Project Point
Sphere + Set = | Mid Point
Sphere + Slot = | Mid Point
Sphere + Sphere = | Mid Point


Constructing a Circle Feature

Construct Circle dialog box

There are several ways to construct a circle using PC-DMIS. The following table lists the various types of constructed circles, along with their necessary inputs. Some features may require no inputs while others may require three inputs or more. The term 'Any' in the following table indicates that the construction can take any type of feature as input for construction. PC-DMIS allows the features to be selected in any order.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT FEATS | FEAT #1: | FEAT #2: |  | COMMENTS
Best fit Circle | BF | At least 3 inputs are needed. | - | - |  | Constructs best fit circle using given inputs
Best fit with Recompensate Circle | BFRE | At least 3 inputs are needed. (1 must be a point) | - | - |  | Constructs best fit circle using given inputs
Cast Circle | CAST | 1 | Any | - |  | Constructs circle at centroid of input feature
Cone Circle (also known as Gage Diameter ) | CONE | 1 | Cone | - |  | Constructs circle at the specified diameter or height of the cone
Intersect Circle | INTOF | 2 | Circle, Sphere, Cone, or Cylinder | Plane |  | Constructs circle at the intersection of a circular feat with a plane, cone, or cylinder
 |  |  | Plane | Circle, Sphere, Cone, or Cylinder
 |  |  | Cone | Cone or Cylinder
 |  |  | Cylinder | Cone
Project Circle | PROJ | 1 or 2 | Any | Plane |  | 1 input feature will project circle to work plane
Reverse Circle | REV | 1 | Circle | - |  | Constructs circle with a reversed vector
Tangent 2 Lines | TANLINES | 2 | Line | Line | - | Constructs circle tangent to the two lines at a given diameter.
Tangent 3 Lines | TANLINES | 3 | Line | Line | Line | Constructs circle tangent to the three lines.
Tangent 3 Circles | TANCIRCLES | 3 | Circle | Circle | Circle | Constructs circle tangent to the three circles.
Scan Segment Circle | SCAN_SEGMENT | 1 | Scan | - |  | Constructs arc from a part of a Linear Open or Linear Close scan.

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the status bar.

To construct a circle:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Input the desired features.

  3. Select the In or Out option.

  4. Select the method of construction. Available options include:

  • Auto Circle

  • Best Fit or Best Fit Recompensate Circle

  • Intersect Circle

  • Cast Circle

  • Projected Circle

  • Reverse direction Circle

  • Scan Segment

  • Tangent 2 Lines

  • Tangent 3 Lines

  • Tangent 3 Circles

  • Circle from a Cone

  5. Click the Create button.

The Edit window command line for a sample Circle Construction would read:
feature_name=FEAT/CIRCLE,TOG1,TOG4,TOG5
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,diam
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,diam
CONSTR/TOG2,TOG3

If TOG2 = CIRCLE and TOG3 = BF or BFRE then the command has the following format:
feature_name=FEAT/CIRCLE,TOG1,TOG4,TOG5
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,diam
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,diam
CONSTR/CIRCLE,TOG3
OUTLIER_REMOVAL/TOG6, stdDevMultiplier
FILTER/TOG6, UPR =cutoffFrequency

Note: The actual Edit report will be displayed in all CAPS.

Auto is the default method of construction. See " Auto Circle Construction".

TOG1= POLR or RECT

TOG2 = CIRCLE

TOG3 = BF / BFRE / CAST / CONE / INTOF / PROJ / REV / TANLINES / TANCIRCLES / SCAN_SEGMENT

TOG4 = IN / OUT

TOG5 = LEAST_SQR / MAX_INSC / MIN_CIRCSC / MIN_SEP / FIXED_RAD (only for measured, BF and BFRE circles)

TOG6 = ON/OFF

stdDevMultiplier = This multiplier value determines whether or not a measured point is an outlier. If the point from the circle is further than the standard deviation multiplied by this, then it is an outlier and will be removed if you have selected the Remove Outlier option.

cutoffWavelength = This value controls the amount of data smoothing. The longer the wavelength the more the smoothing.

The first three lines displayed in the Edit window will be the same for constructed circles. The fourth line will be slightly different, according to the type of feature being constructed. You can switch between the different types of circles by placing the cursor on TOG3 and pressing F7 or F8. (See "Command Mode Keyboard Functions" in the "Using the Edit Window" section.)

When two or more features are involved, PC-DMIS automatically determines the necessary order of the input features. This improves the accuracy of the measurement process.

The following paragraphs describe the available options for constructing a circle:

More:

In / Out Circle

Auto Circle Construction

Constructing a Best Fit or Best Fit Recompensate Circle

Constructing an Intersect Circle

Constructing a Cast Circle

Constructing a Projected Circle

Changing the Direction of a Circle

Constructing a Tangent Circle

Constructing an Arc from Part of a Scan

Constructing a Circle at a Scan's Minimum Point

Constructing a Circle from a Cone


In / Out Circle

The In and Out options tell PC-DMIS whether to construct the circle as an internal or an external circle.

  • If you select In, PC-DMIS constructs the circle as an internal circle.

  • If you select Out, PC-DMIS constructs the circle as an external circle, or pin.


Auto Circle Construction

The following table indicates the type of circle that will be constructed when the specified inputs are selected and the AUTO option is chosen. The order of the selected features is not important. If an incorrect input feature(s) is selected, PC-DMIS will display an error message and will not automatically construct the indicated feature type.

To allow PC-DMIS to automatically determine the best method of construction:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Select the Auto option from the list of options.

  3. Select the desired feature(s) based on the table below.

  4. Click the Create button.

Input Feature(s) | Constructs
Any 1 Set = | Best Fit Circle
Any 1 Circle = | Reverse Circle
Any 1 Cone = (w/ Diameter ) | Cone Circle
Any 1 Feature = (except Circle/Cone/Set) | Cast Circle
Cone + Cone = | Intersect Circle
Cone + Cylinder = | Intersect Circle
Cone + Plane = | Intersect Circle
Cone + Sphere = | Intersect Circle
Cylinder + Sphere = | Intersect Circle
Plane + Circle = | Project Circle
Plane + Ellipse = | Project Circle
Plane + Line = | Project Circle
Plane + Plane = | Project Circle
Plane + Point = | Project Circle
Plane + Set = | Project Circle
Plane + Slot = | Project Circle
Plane + Sphere = | Intersect Circle


Constructing a Best Fit or Best Fit Recompensate Circle

A "best fit" circle can be constructed from three or more features. The constructed circle's vector is normal to the current working plane. The best fit construction method takes the actual measured points, rather than the ball's center (as is the case of best fit recompensate).

To construct a Best Fit Circle or a Best Fit Recompensate Circle:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Select either the Best Fit or Best Fit Recompensate option (shown as Best Fit and BF Recomp).

  3. Select the type of Best Fit construction from the Best Fit Type list.

  4. Select at least 3 features.

  5. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CIRCLE, BF, feat_1, feat_2, …
OUTLIER_REMOVAL/ (OFF | ON), stdDevMultiple
FILTER/(OFF | ON), UPR =cutoffFrequency

A - Best fit circle constructed from three or more features (in this example from three or more circle features)

Outlier removal and Filtering are described in these topics:

More:

Best Fit Type

Remove Outliers / Standard Deviation Multiple

Apply Gauss Filter / Cutoff Frequency


Best Fit Type

This list becomes available if you select Best Fit or BF Recomp options when constructing the circle. It allows you to specify the type of Best Fit construction used. Available types include:

  • LEAST_SQR

  • MAX_INSC

  • MIN_CIRCSC

  • MIN_SEP

  • FIXED_RAD

These types are discussed in the table below:

List Item | Description
LEAST_SQR | Least Squares – This calculation type provides a method of fitting in which the average squared radial distance from the data points to the circle is minimized. The square root of this quantity is the Root Mean Square (RMS) distance. Since the RMS distance is based on an average, some points may be further than the RMS distance from the computed circle.
MIN_SEP | Minimum Separation – This calculation type generates a circle that is halfway between two concentric circles containing the data points, with the difference of their radii as small as possible. The Min/Max math used by the MIN_SEP calculation minimizes the maximum error, or deviation, from the input data to the circle. The Min/Max error is one-half of the minimal separation. No input data points (or input features) lie farther than the Min/Max error from the Min/Max circle. This calculation determines whether or not all the input data (or input features) are within the given tolerances.
MAX_INSC | Maximum Inscribed – This calculation type generates an empty circle with the largest possible diameter that lies within the data. PC-DMIS first computes a Minimum Circumscribed circle and requires that the center of the Maximum Inscribed circle lies within it. This option could be used for a circular feature that requires a mating stud. For example, if the input data represents a hole, then this calculation returns a circle with the diameter of the largest stud that will fit inside the hole.
MIN_CIRCSC | Minimum Circumscribed – This calculation type generates a circle with the smallest possible diameter that encloses the input data (or input features). This option could be used when measuring a stud that would fit into a mating circular feature. The resulting feature would be the smallest hole into which the stud would fit.
FIXED_RAD | Fixed Radius – This calculation type creates a circle of a given diameter, positioned so that the maximal radial distance from the data points to the circle is minimized. It is similar to the Max/Min math used in the MIN_SEP calculation except that,since the diameter is known in advance, the radius cannot vary. Only the circle's position is allowed to vary.

For legacy Circularity and Cylindricity dimensions as well as a Location dimension's RN Line, the feature solution is used to compute the dimension. By default this is Least Squares. However, you can choose to solve the feature using Minimum Separation, Maximum Inscribed, Minimum Circumscribed, or Fixed Radius regression algorithms.

FCF Circularity and Cylindricity dimensions on the other hand are computed using the Chebychev algorithm (Min/Max) as required by the Y14.5 standard. Because of the change in calculation, Circularity and Cylindricity FCF dimensions will generally compute to a slightly smaller value than their legacy counterparts.


Remove Outliers / Standard Deviation Multiple

Remove Outliers / Standard Deviation Multiple for a Constructed Circle

For a best fit (BF) or best fit recompensate (BFRE) circle you can choose to remove outliers based on the distance from the best fit feature. This allows the removal of anomalies that arise in the measurement process.

PC-DMIS first fits a circle to the data, then determines which points are outliers based on the standard deviation multiple. It then does the following:

  • Recalculates the best fit circle with those outliers removed.

  • Checks for outliers again.

  • Recalculates the best fit circle.

  • Continues repeating this process until no more outliers exist or until PC-DMIS cannot compute the circle (PC-DMIS can't compute the circle if there are fewer than 3 data points).


Apply Gauss Filter / Cutoff Frequency

The Best Fit (BF) and Best Fit Recompensate (BFRE) constructed circles have the option of filtering the deviations of the measured data points from the best fit circle computed from the measured data. The Apply Gauss Filter check box is a Gaussian filter with a cutoff frequency input as undulations per revolution (UPR). Generally, a lower cutoff frequency produces smoother filtered data. If you've selected the Remove Outliers check box and are filtering the data, then outlier data is removed prior to filtering.


Constructing an Intersect Circle

A circle can be constructed between a cone (circle, cylinder, sphere) and a plane. It can also be created between two concentric cones or a concentric cone/cylinder combination.

PC-DMIS creates a circle at the intersection of the circular feature and the plane or between the cone/cone or cone/cylinder combinations.

  • In the case of a circular feature and a plane intersection, PC-DMIS always makes a true circle (not an ellipse) even if the circular feature is not exactly perpendicular to the plane. The center point of the new circle is at the pierce point of the circular feature's centerline and the plane. The vector of the circle is the vector of the piercing circular feature.

  • In the case of a cone/cone or cone/cylinder combination, a true circle is created even if the intersecting features do not form a true circle.

To construct an Intersect Circle:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Select the Intersect option.

  3. Select the first feature. It must be either a circle, cone, cylinder, or sphere.

  4. Select the second feature. It must be a plane.

  5. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CIRCLE,INTOF,feat_1,feat_2

Constructing a Circle from a Cone and a Plane

A - Circle Constructed from the intersection of a cone and a plane.

B - Cone feature

C - Plane feature


Constructing a Cast Circle

A circle can be constructed by changing any given feature into a circle. PC-DMIS will construct the circle at the centroid of the input feature. If a sheet metal point is used, the diameter will be the probe diameter. For some sheet metal features (such as slots and notches) the width will be used as the diameter. For features that do not have diameters (lines, points, etc.), a value that is four times the probe diameter will be used.

You can modify the diameter of the circle; this will change the circle from DEPENDENT to INDEPENDENT. This means that when the circle is executed, the diameter will not change based on the input feature but will be independent of the input feature, while the position and vector remain dependent on the input feature. This allows you to have control over the diameter in cases where the input feature doesn’t really have a diameter, such as a point. The DEPENDENT/INDEPENDENT field is a toggle field you may change.

PC-DMIS will use this diameter value for all calculations instead of using the default diameter value as described above.

To construct a Cast Circle:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Select the Cast option.

  3. Select at least one features of any type.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CIRCLE,CAST,feat_1, (DEPENDENT | INDEPENDENT)


Constructing a Projected Circle

A circle can be constructed from any feature and a plane. PC-DMIS will project the centroid of the given feature onto the plane, creating a circle. If there is only one input feature, the projection will be to the current work plane. The diameter of the projected circle will be four times the probe's diameter.

To construct a Projected Circle:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Select the Projection option.

  3. Select a feature of any type.

Note: A second feature can also be selected. It must be a plane.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CIRCLE,PROJ,feat_1,(feat_2)

Constructing a Circle from a Circle and a Plane

A - Circle constructed from the projection of a circle and a plane.

B - Plane feature.


Changing the Direction of a Circle

A circle can be constructed with a reversed vector.

To change the direction of a circle:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Select the Reverse option.

  3. Select one feature. It must be a circle.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CIRCLE,REV,feat_1


Constructing a Tangent Circle

Examples of a Circle Feature Constructed Tangent to 2 Lines

Circle 7 Constructed Tangent to Lines 5 and 6

Circle 7 Constructed Tangent to Lines 5 and 7

Circle 7 Constructed Tangent to Lines 6 and 7

Circle 7 Constructed Tangent to Lines 6 and 7.

Note the difference from the above example: Line 6's direction has changed, thereby changing the location of the constructed circle.

Example of a Circle Feature Constructed Tangent to 3 Lines

Example of a circumscribed circle tangent to three input circles

Example of an inscribed circle tangent to three input circles

Constructing a Tangent Circle

You can construct the following three types of tangent circles using the Construct Circle dialog box (Insert | Feature | Constructed | Circle): Display Menu Roadmap

  • Tangent 2 Lines - This option constructs a circle tangent to two lines. The exact location is determined by the size of the circle and the direction of the lines. Type a Diameter value for the constructed after selecting the two input lines, and then click Create. If the constructed circle doesn't appear were expected, try changing the direction of one of the lines.

  • Tangent 3 Lines - This option constructs a circle tangent to the three input lines that form a triangle. Select the three input lines, and then click Create.

  • Tangent 3 Circles - This option constructs a circle tangent to the three input circles. Select the three input circles, and then click Create. The tangent circle can either contain all three circles (circumscribed circle) or none of the three (inscribed circle).


Constructing an Arc from Part of a Scan

A circle can be constructed from a segment of a Linear Open, Linear Close, or Basic Circle scan. PC-DMIS will create an arc from part of the scan. The details of the construction are included further in this discussion.

To construct a Scan Segment Circle:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Select the Scan Segment option.

  3. Select a previously created Linear Open, Linear Close, or Basic Circle scan.

  4. Click the Segment Data button. The Scan Segment dialog will appear.

Scan Segment dialog box

  5. Select either the Best Fit or BF Recomp option.

  6. Select the portion of the scan used in the construction from this dialog box.

  7. Type the number of points to potentially discard by entering values in the Discard Start and Discard End Maximum boxes.

  8. Type a distance from the best fit circle into the Discard Tolerance box. This tolerance is a form tolerance; it allows you to control what end points are accepted as part of the arc. If the distance from the scan point to the best fit arc is greater than this tolerance value, then the end point will be discarded.

  9. Input the Approximate Start and End Points of the scan by marking the Select Points check box, and then clicking in the Graphics Display window to fill in the X, Y, and Z fields. You can click anywhere in the Graphics Display window, however, PC-DMIS will place the point on the scan nearest to where you clicked. You can also edit the point values by using the keyboard.

  10. Click OK to accept the data and close the Scan Segment dialog box.

  11. Click Create to construct the arc from the scan.

The Edit window command line for this option reads:

CONSTR/CIRCLE,SCAN_SEGMENT,fit_type,feat_1,start_x,start_y,start_z,end_x,end_y,end_z,discard_start,discard_end,tolerance

If you want more than one arc or line from a given scan, then you will need to add another command for a different section of the scan.

More:

Determining the Data Used to Construct the Arc


Determining the Data Used to Construct the Arc

The data used to construct the arc is determined as follows:

  • First, a segment of the scan is determined using a starting point and an ending point within the scan. The starting and ending points are chosen as the point in the scan nearest [start_x, start_y, start_z] and the point nearest [end_x, end_y, end_z] respectively.

  • Points are then discarded from the start and end points of the scan. The number of points discarded from the start is discard_start and from the end is discard_end. An arc is then fitted to this set of points.

  • Finally, the starting and ending points are added back in if they are within the defined tolerance. The arc is then re-fitted once more to the new set of points.

The value of fit_type may be BF (Best Fit) or BFRE (Best Fit Recompensate). This determines whether a best fit or best fit with recompensation is done when calculating the arc. For a description of Best Fit and Best Fit Recompensate, see "Constructing a Best Fit or Best Fit Recompensate Circle".


Constructing a Circle at a Scan's Minimum Point

This feature lets you construct a 2D circle of a given radius at a minimum point along a linear scan. PC-DMIS finds the minimum point by using a starting point and a downward direction vector (as shown in figure 1 below).

Figure 1: Minimum point of a circle along a scan with a defined downward vector and starting point.

A - Scan

B - Start Point

C - Down Vector

D - Final Position

PC-DMIS projects the scan to the current workplane and the circle will lie in a plane parallel to the workplane. The scan will be interpreted as a line between consecutive points (piecewise linear). Thus, the circle that is placed at the minimum point along the scan will not ”fall” between two consecutive scan points, but instead will be constrained to touch a line connecting the two points.

Valid Input Types

The input for this construction must be a line type scan. This excludes all scans designed to scan a surface: Patch, UV, Grid, Multisection, Manual Laser, and Cylinder.

Construction Procedure

To start this construction:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Select the Scan Minimum option.

  3. Select a linear scan from the feature list. You cannot use a surface scan.

  4. Click the Search Setup button.

  5. The Circle Minimum Search Setup dialog box appears:

  6. Define the circle’s start point, its down direction, and its diameter.

  7. Click OK to construct the circle. PC-DMIS constructs the circle and inserts the construction command into the Edit window.

More:

Rules for Construction

No Local Minimum

Edit Window Command

Additional Examples


Rules for Construction

A valid starting point and vector for will follow two rules:

First, a circle of the given diameter and starting point should not intersect the scan. Figure 2 shows a violation of this rule.

Figure 2: Invalid starting point due to intersection with the scan.

A - Scan

B - Start Point

C - Down Vector

Second, the circle projected from the start point along the down vector must intersect the scan. Figure 3 shows a violation of this rule.

Figure 3: Invalid starting point due to the circle missing the scan.

A - Scan

B - Start Point

C - Down Vector


No Local Minimum

If the scan has no local minimum, or a natural resting place for the circle, then the circle will follow the scan to it’s lowest point while still in contact with the scan (see figure 4).

Figure 4: A Scan without a local minimum.

A - Scan

B - Start Point

C - Down Vector


Edit Window Command

Edit Window Command for a Constructed Scan Minimum Circle

CIR1 =FEAT/CIRCLE,RECT,OUT

THEO/tx,ty,tz,ti,tj,tk,td

ACTL/mx,my,mz,mi,mj,mk,md

CONSTR/CIRCLE,SCAN_MINIMUM,Scan ID

START/xSP, xSP, xSP

DOWN/iDV, iDV, iDV

Where:

tx,ty,tz | is the theoretical circle position
ti,tj,tk | is the theoretical circle vector
td | is the theoretical circle diameter
mx,my,mz | is the measured circle position
mi,mj,mk | is the measured circle vector
md | is the measured circle diameter
Scan ID | is the id of the scan to be used
xSP, xSP, xSP | is the starting point for finding the minimum.
iDV, iDV, iDV | is the downward direction vector.


Additional Examples

Figure: Starting point inside of a scan

A - Scan

B - Starting Point

C - Down Vector

Figure: Scan where not all points are reachable given the circle size.

A - Scan

B - Starting Point

C - Down Vector


Constructing a Circle from a Cone

A circle can be constructed from a cone at a specified diameter of the cone, or it can be constructed at a given height from the current alignment plane. A Cone Circle feature at a given diameter is also commonly known as a Gage Diameter.

Understanding the Height Value

If constructing a circle at a given height, PC-DMIS calculates the circle in this way. It creates a plane from the reference point and the reference vector. It then creates a parallel offset plane from this plane by the height value. This parallel plane intersects with the cone axis, and the intersection creates the location of the resulting circle feature. The diameter of the circle is the diameter of the cone at that intersection point.

Available reference point (REF_POINT) options:

  • CONE_VERTEX

  • CONE_START

  • CONE_END

  • ORIGIN

Available reference vector (REF_VECTOR) options:

CONE_VECTOR

WORKPLANE

ZPLUS

ZMINUS

XPLUS

XMINUS

YPLUS

YMINUS

For example, if you use the origin as a reference point, and ZPLUS as your reference vector, PC-DMIS would create a plane from the origin point and the ZPLUS vector. Then it would create a parallel plane at the given height value, and where it intersects with the cone, it creates the circle feature. Your Edit window's code might look something like this:

CIR2 =FEAT/CIRCLE,RECT,OUT

THEO/-67.295,2.595,-7.152,0.0310723,-0.0214397,-0.9992872,29.411

ACTL/-67.295,2.595,-7.152,0.0310723,-0.0214397,-0.9992872,29.411

CONSTR/CIRCLE,CONE,CON2,HEIGHT,5,REF_POINT = ORIGIN,REF_VECTOR = ZPLUS

Procedure to Construct a Cone Circle:

  1. Access the Construct Circle dialog box (Insert | Feature | Constructed | Circle). Display Menu Roadmap

  2. Select the Cone option.

  3. Select one feature. The type must be a cone.

  4. Select either DIAMETER or HEIGHT from the Type drop-down list.

  5. Type a value for the diameter or height into the Value box.

  6. If you selected Height:

    • Select a reference point from the Point list.

    • Select a reference vector from the Vector list.

  7. Click the Create button.

The Edit window command line for this option would read:

CONSTR/CIRCLE,CONE,DIAMETER,feat_1

Or

CONSTR/CIRCLE,CONE,HEIGHT,value,REF_POINT=point,REF_VECTOR=vector,feat_1


 Constructing a Cast Ellipse Constructing a Projected Ellipse Changing the Direction of an Ellipse Constructing a BF or BFRE Recompensate Ellipse Close button Create button Clear button Feature List box Select Last # Search ID ID In / Out Ellipse Auto Ellipse Construction

Constructing an Ellipse Feature

Construct Ellipse dialog box

There are several ways to construct an ellipse using PC-DMIS. The following table lists the various types of constructed ellipses, along with their necessary inputs. Some features may require no inputs while others may require three inputs or more. The term 'Any' in the following table indicates that the construction can take any type of feature as input for construction. PC-DMIS allows the features to be selected in any order.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT FEATS | FEAT #1: | FEAT #2: | COMMENTS
Best fit Ellipse | BF | At least 4 inputs are needed or a scan or set with 4 points. | - | - | Constructs best fit ellipse using given inputs
Best fit with Recompensate Ellipse | BFRE | At least 4 inputs--with one input being a point--are needed or a scan or set comprised of at least 4 points. | - | - | Constructs best fit ellipse using given inputs
Intersection | INT | 2 | Cylinder | Plane | Constructs an ellipse at the intersection of the input features
Cast Ellipse | CAST | 1 | Any | - | Constructs ellipse at centroid of input feature
Project Ellipse | PROJ | 1 or 2 | Any | Plane | 1 input feature will project ellipse to work plane
Reverse Circle | REV | 1 | Circle | - | Constructs circle with a reversed vector

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the status bar.

To construct an ellipse:

  1. Access the Construct Ellipse dialog box (Insert | Feature | Constructed | Ellipse). Display Menu Roadmap

  2. Input the desired features.

  3. Select the In or Out option.

  4. Select the method of construction. Available options include:

  • Auto Circle

  • Best Fit or Best Fit Recompensate Ellipse

  • Cast Ellipse

  • Projection Ellipse

  • Reverse direction Ellipse

  5. Click the Create button.

The Edit window command line for a sample Ellipse Construction would read:
feature_name=FEAT/Ellipse,TOG1,TOG4
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,major diam,minor diam,i angle vec, j angle vec, k angle vec
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,major diam,minor diam,i angle vec,j angle vec,k angle vec
CONSTR/TOG2,TOG3

Note: The actual Edit report will be displayed in all CAPS.

Auto is the default method of construction. See "Auto Circle Construction".

TOG1= POLR or RECT

TOG2 = ELLIPSE

TOG3 = BF / BFRE / CAST / INT / PROJ / REV

TOG4 = IN / OUT

The first three lines displayed in the Edit window will be the same for constructed ellipses. The fourth line will be slightly different, according to the type of feature being constructed. You can switch between the different types of ellipses by placing the cursor on TOG3 and pressing F7 and F8. (See "Command Mode Keyboard Functions" in the "Using the Edit Window" section.)

When two or more features are involved, PC-DMIS automatically determines the necessary order of the input features. This improves the accuracy of the measurement process.

The following paragraphs describe the available options for constructing an ellipse:

More:

In / Out Ellipses

Constructing a Best Fit or Best Fit Recompensate Ellipse

Constructing an Intersect Ellipse

Constructing a Cast Ellipse

Constructing a Projected Ellipse

Changing the Direction of an Ellipse

Auto Ellipse Construction


In / Out Ellipse

The In and Out options tell PC-DMIS whether to construct the ellipse as an internal or an external ellipse.

· If you select In, PC-DMIS constructs the ellipse as an internal ellipse.

· If you select Out, PC-DMIS constructs the ellipse as an external ellipse, or pin.


Constructing a Best Fit or Best Fit Recompensate Ellipse

A "best fit" ellipse can be constructed from three or more features. The ellipse lies in the current working plane. The best fit construction method takes the actual measured points, rather than the ball's center (as is the case of best fit recompensate). In both cases PC-DMIS computes a least squares ellipse, one for which PC-DMIS minimizes the average squared distance from the data points to the ellipse.

To construct a Best Fit Ellipse or a Best Fit Recompensate Ellipse:

  1. Access the Construct Ellipse dialog box (Insert | Feature | Constructed | Ellipse). Display Menu Roadmap

  2. Select either the Best Fit or Best Fit Recompensate option (shown as Best Fit and BF Recomp).

  3. Select at least 4 features or a scan or a set comprised of at least four points.

  4. Click the Create button.

The Edit window command line for this option would read: CONSTR/ELLIPSE,BF,feat_1,feat_2,feat_3...
(Uses the actual measured points for construction.)
or
CONSTR/ELLIPSE,BFRE,feat_1,feat_2,feat_3...
(Uses the center of probe for measurement.)

More:

Remove Outliers / Standard Deviation Multiple for a Constructed Ellipse


Remove Outliers / Standard Deviation Multiple for a Constructed Ellipse

For a best fit (BF) or best fit recompensate (BFRE) ellipse you can choose to remove outliers based on the distance from the best fit feature. This allows the removal of anomalies that arise in the measurement process.

PC-DMIS first fits an ellipse to the data, then determines which points are outliers based on the standard deviation multiple. It then does the following:

  • Recalculates the best fit ellipse with those outliers removed.

  • Checks for outliers again.

  • Recalculates the best fit ellipse.

  • Continues repeating this process until no more outliers exist or until PC-DMIS cannot compute the ellipse (PC-DMIS can't compute the ellipse if there are fewer than 4 data points).


Constructing an Intersect Ellipse

An ellipse can be constructed from the intersection of a non-parallel plane and cylinder.

To construct an Intersect Ellipse:

  1. Access the Construct Ellipse dialog box (Insert | Feature | Constructed | Ellipse). Display Menu Roadmap

  2. Select the Intersect option.

  3. Select the first feature; it can be either a cylinder or a plane.

  4. Select the second feature.

    • If you selected a cylinder as the first feature, then this must be a plane.

    • If you selected a plane as the first feature, then this must be a cylinder.

  5. Click the Create button. PC-DMIS will construct the ellipse at the intersection of the two features. The constructed ellipse will have the plane's normal vector.

The Edit window command block for a sample ellipse would look something like this:

ID=FEAT/ELLIPSE,CARTESIAN,OUT,NO
THEO/X,Y,Z,I,J,K
ACTL/X,Y,Z,I,J,K
CONSTR/ELLIPSE,INT,feat1,feat2


Constructing a Cast Ellipse

An ellipse can be constructed by changing any given feature into an ellipse. PC-DMIS will construct the ellipse at the centroid of the input feature. If a sheet metal point is used, the major diameter will be the probe diameter. For some sheet metal features (such as slots and notches) the width will be used as the major diameter. For features that do not have a width (lines, points, etc.), a value that is four times the probe diameter will be used. The minor diameter will be the length of the input feature. For features that do not have a length (points, circles, etc) a default length of 1 will be used.

You can modify the major and minor diameters of the ellipse; this will change the ellipse from DEPENDENT to INDEPENDENT. This means that when the ellipse is executed that the major and minor diameters will not change based on the input feature but will be independent of the input feature, while the position and vector remain dependent on the input feature. This allows you to have control over the diameters in cases where the input feature doesn’t really have a diameter, such as a point. The DEPENDENT/INDEPENDENT field is a toggle field you may change.

PC-DMIS will use these diameter values for all calculations instead of using the default diameter values as described above.

To construct a Cast Ellipse:

  1. Access the Construct Ellipse dialog box (Insert | Feature | Constructed | Ellipse). Display Menu Roadmap

  2. Select the Cast option.

  3. Select at least one features of any type.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/ELLIPSE,CAST,feat_1,(DEPENDENT | INDEPENDENT)


Constructing a Projected Ellipse

An ellipse can be projected onto a plane. PC-DMIS projects the centroid of the given feature onto the plane, creating an ellipse. If there is only one input feature, the projection will be to the current work plane. The major diameter of the projected ellipse will be the width of the projected feature, or the probe's diameter (for feature without a defined width). The minor diameter will be the length of the input feature, or of unit 1 (for features without a length defined).

To construct a Projected Ellipse:

  1. Access the Construct Ellipse dialog box (Insert | Feature | Constructed | Ellipse). Display Menu Roadmap

  2. Select the Projection option.

  3. Select a feature of any type.

Note: A second feature can also be selected. It must be a plane.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/ELLIPSE,PROJ,feat_1,(feat_2)


Changing the Direction of an Ellipse

An Ellipse can be constructed with a reversed vector.

To change the direction of a ellipse:

  1. Access the Construct Ellipse dialog box (Insert | Feature | Constructed | Ellipse). Display Menu Roadmap

  2. Select the Reverse option.

  3. Select one feature. It must be an ellipse.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/ELLIPSE,REV,feat_1


Auto Ellipse Construction

The following table indicates the type of ellipse that will be constructed when the specified inputs are selected and the AUTO option is chosen. The order of the selected features is not important. If an incorrect input feature(s) is selected, PC-DMIS will display an error message and will not automatically construct the indicated feature type.

To allow PC-DMIS to automatically determine the best method of construction:

  1. Access the Construct Ellipse dialog box (Insert | Feature | Constructed | Ellipse). Display Menu Roadmap

  2. Select the Auto option from the list of options.

  3. Select the desired feature(s) based on the table below.

  4. Click the Create button.

Input Feature(s) | Constructs
Any 1 Set = | Best Fit Ellipse
Any 1 Ellipse = | Reverse Ellipse
Any 1 Feature = (except Ellipse /Set) | Cast Ellipse
Plane + Any Feature | Projected Ellipse
Set + Set | Best Fit Ellipse
3 or more Features | Best Fit Ellipse


 Constructing a Reverse Sphere Constructing a Cast Sphere Close button Create button Clear button Constructing a Best Fit or Best Fit Recompensate Sphere Creating an Auto Sphere In / Out Sphere Feature List box Select Last # Search ID ID Constructing a Projected Sphere

Constructing a Sphere Feature

Construct Sphere dialog box

There are several ways to construct a sphere using PC-DMIS. The following table lists the various types of constructed spheres, along with their necessary inputs. Some features may require no inputs while others may require five inputs or more. The term 'Any' indicates that the construction can take any type of feature as input for construction. PC-DMIS allows the features to be selected in any order.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT FEATS | FEAT #1: | FEAT #2: | COMMENTS
Best Fit Sphere | BF | At least 5 inputs are needed. | - | - | Constructs best fit sphere using given inputs
Best Fit with Recomp Sphere | BFRE | At least 5 inputs are needed. (1 must be a point) | - | - | Constructs best fit sphere using given inputs
Cast Sphere | CAST | 1 | Any | - | Constructs sphere at centroid of input feature
Project Sphere | PROJ | 1 or 2 | Any | Plane | 1 input feature will project sphere to work plane
Reverse Sphere | REV | 1 | Sphere | - | Constructs sphere with a reversed vector

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the status bar.

To construct a sphere:

  1. Access the Construct Sphere dialog box (Insert | Feature | Constructed | Sphere). Display Menu Roadmap

  2. Input the desired features.

  3. Select the method of construction. Available options include:

  • Best Fit or Best Fit Recompensate Sphere

  • Cast Sphere

  • Projected Sphere

  • Reversed direction Sphere

  • Auto Sphere

  4. Click the Create button.

The Edit window command line for a sample Sphere Construction would read:
feature_name=FEAT/SPHERE,TOG1,TOG4
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,diam
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,diam
CONSTR/TOG2,TOG3

Note: The actual Edit report will be displayed in all CAPS.

AUTO is the default method of construction. This option automatically determines the best way to construct a sphere using the input feature(s). See "Auto Sphere Construction".

TOG1= POLR or RECT

TOG2 = SPHERE

TOG3 = BF / BFRE / CAST / PROJ / REV

TOG4 = IN / OUT

The first three lines displayed in the Edit window will be the same for constructed spheres. The fourth line will be slightly different, according to the type of feature being constructed. You can switch between the different types of spheres by placing the cursor on TOG3 and pressing F7 or F8. (See "Command Mode Keyboard Functions" in the "Using the Edit Window" section.)

When two or more features are involved, PC-DMIS automatically determines the necessary order of the input features. This improves the accuracy of the measurement process.

The following paragraphs describe the available options for constructing a sphere.

More:

In / Out Sphere

Constructing a Cast Sphere

Constructing a Projected Sphere

Changing the Direction of a Sphere

Auto Sphere Construction


In / Out Sphere

The In and Out options tell PC-DMIS whether to construct the sphere as an internal or an external sphere.

  • If you select In, PC-DMIS constructs the sphere as an internal sphere.

  • If you select Out, PC-DMIS constructs the sphere as an external sphere.


Constructing a Best Fit or Best Fit Recompensate Sphere

A "best fit" sphere can be constructed using five or more features. The best fit construction method takes the actual measured points, rather than the ball's center (as is the case of best fit recompensate). In both cases PC-DMIS computes a least squares sphere, one for which PC-DMIS minimizes the average squared distance from the data points to the sphere.

To construct a Best Fit or a Best Fit Recompensate Sphere:

  1. Access the Construct Sphere dialog box (Insert | Feature | Constructed | Sphere). Display Menu Roadmap

  2. Select either the Best Fit or Best Fit Recompensate option (shown as Best Fit and BF Recomp).

  3. Select five or more features.

Note: On Best Fit Recompensate, one of the five features must be a point.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/SPHERE,BF,feat_1,feat_2,feat_3,feat_4,feat_5...
(Uses the actual measured points for construction.)
or
CONSTR/SPHERE,BFRE,feat_1,feat_2,feat_3,feat_4,feat_5...
(Uses the center of the probe for measurement.)

Constructing a Sphere from five or More Points

A - Best fit sphere constructed from five points.


Constructing a Cast Sphere

A sphere can be constructed by changing any given feature into a sphere. PC-DMIS will construct the circle at the centroid of the input feature. If a sheet metal point is used, the diameter will be the probe diameter. For some sheet metal features (such as slots and notches) the width will be used as the diameter. For features that do not have diameters (lines, points, etc.), a value that is four times the probe diameter will be used.

You can modify the diameter of the sphere; this changes the sphere from DEPENDENT to INDEPENDENT. This means that when the sphere is executed that diameter will not change based on the input feature but will be independent of the input feature, while the position and vector remain dependent on the input feature. This allows you to have control over the diameter in cases where the input feature doesn’t really have a diameter, such as a point. The DEPENDENT/INDEPENDENT field is a toggle field you may change.

PC-DMIS will use this diameter value for all calculations instead of using the default diameter value as described above.

To construct a Cast Sphere:

  1. Access the Construct Sphere dialog box (Insert | Feature | Constructed | Sphere). Display Menu Roadmap

  2. Select the Cast option.

  3. Select one feature of any type.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/SPHERE,CAST,feat_1, (Dependent | Independent)


Constructing a Projected Sphere

A sphere can be constructed by projecting any feature into the current working plane. PC-DMIS will project the point where the plane intersects the point. If there is only one input feature, the projection will be to the work plane. You should input the desired diameter when projecting a feature into the working plane; otherwise PC-DMIS will use the probes' diameter.

To construct a Projected Sphere:

  1. Access the Construct Sphere dialog box (Insert | Feature | Constructed | Sphere). Display Menu Roadmap

  2. Select the Projection option.

  3. Select either one or two features. The first feature can be of any type. The second feature must be a plane.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/SPHERE,PROJ,feat_1,(feat_2)


Changing the Direction of a Sphere

A sphere can be constructed with a reversed vector.

To construct a Reverse Sphere:

  1. Access the Construct Sphere dialog box (Insert | Feature | Constructed | Sphere). Display Menu Roadmap

  2. Select the Reverse option.

  3. Select one feature. It must be a sphere.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/SPHERE,REV,feat_1


Auto Sphere Construction

The following table indicates the type of sphere that will be constructed when the specified inputs are selected and the AUTO option is chosen. The order of the selected features is not important. If an incorrect input feature(s) is selected, PC-DMIS will display an error message and will not automatically construct the indicated feature type.

To allow PC-DMIS to automatically determine the best method of construction:

  1. Access the Construct Sphere dialog box (Insert | Feature | Constructed | Sphere). Display Menu Roadmap

  2. Select the Auto option from the list of options.

  3. Select the desired feature(s) based on the table below.

  4. Click the Create button.

Input Feature(s) | Constructs
4 or more Features = | Best Fit Sphere
Any 1 Feature = (except Sphere/Set) | Cast Sphere
Any 1 Set = | Best Fit Sphere
Plane + Any Feature = | Project Sphere
Sphere = | Reverse Sphere


Constructing a Line Feature

Construct Line dialog box

There are many methods to construct a line using PC-DMIS. The following table lists the various types of constructed lines, along with their necessary inputs. Some features may require no inputs while others may require three inputs or more. The term 'Any' in the table below indicates that the construction can take any type of feature as input for construction. PC-DMIS allows the features to be selected in any order.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT FEATS | FEAT #1: | FEAT #2: | COMMENTS
Alignment Line | ALIGN | 0 | - | - | Constructs line through alignment origin
Best Fit Line | BF | At least 2 inputs are needed. | - | - | Constructs best fit line using inputs
Best Fit with Recomp Line | BFRE | At least 2 inputs are needed. (1 must be a point) | - | - | Constructs best fit line using inputs
Cast Line | CAST | 1 | Any | - | Constructs line at centroid of input feature
Intersect Line | INTOF | 2 | Plane | Plane | Constructs line at the intersection of 2 planes
Mid Line | MID | 2 | Line, Cone, Cylinder, Slot, Plane | Line, Cone, Cylinder, Slot, Plane | Constructs a mid line between the input features
Offset Line | OFFSET | At least 2 inputs are needed. | Any | Any | Builds line through first feature and offset from second feature by specified amount
Parallel Line | PLTO | 2 | Any | Any | Constructs line parallel to first feature and passing through second feature
Perpendicular Line | PRTO | 2 | Any | Any | Constructs line perpendicular to first feature and passing through second feature
Project Line | PROJ | 1 or 2 | Any | Plane | Using 1 input feature will project line to work plane
Reverse Line | REV | 1 | Line | - | Constructs line passing through input with reversed vector
Scan Segment Line | SCAN_SEGMENT | 1 | Scan | - | Constructs line from a part of a Linear Open or Linear Close scan.

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the Status Bar.

To construct a line:

  1. Select Construct from the menu bar (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Access the Construct Line dialog box.

  3. Input the desired features.

  4. Select the method of construction. Available options include:

  • Auto Line

  • Alignment Line

  • Best Fit or Best Fit Recompensate Line

  • Cast Line

  • Intersect Line

  • Mid Line

  • Offset Line

  • Parallel Line

  • Perpendicular Line

  • Projected Line

  • Reversed direction Line

  • Scan Segment Line

  • Offset Line

  5. Click the Create button.

The Edit window command line for this option would read:
feature_name=FEAT/LINE,TOG1,TOG4
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,length
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,length
CONSTR/TOG2,TOG3,...

If TOG2 = LINE and TOG3 = BF or BFRE then the command has the following format:
feature_name=FEAT/LINE,TOG1,TOG4
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,length
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,length
CONSTR/LINE,TOG3
OUTLIER_REMOVAL/TOG5, stdDevMultiplier
FILTER/TOG5, WAVELENGTH=cutoffWavelength

Note: The actual Edit report will be displayed in all CAPS.

TOG1 = POLR or RECT

TOG2 = LINE

TOG3 = ALIGN / BF / BFRE / CAST / INTOF / MID / OFFSET / PLTO / PROJ / PRTO / REV / SCAN_SEGMENT

TOG4 = BND / UNBND

TOG5 = OFF / ON

Length = This value represents the theoretical or actual length of the line.

stdDevMultiplier = This multiplier value determines whether or not a measured point is an outlier. If the point from the line is further than the standard deviation multiplied by this, then it is an outlier and will be removed if you have selected the Remove Outlier option.

cutoffWavelength = This value controls the amount of data smoothing. The longer the wavelength the more smoothing there will be.

The first three lines displayed in the Edit window will be the same for constructed lines. The fourth line will be slightly different, according to the type of feature being constructed. You can switch between the different types of lines by placing the cursor on TOG3 and pressing F7 or F8. (See "Command Mode Keyboard Functions" in the "Using the Edit Window" section.)

When two or more features are involved, PC-DMIS automatically determines the necessary order of the input features. This improves the accuracy of the measurement process.

AUTO is the default method of construction. See "Auto Line Construction"

The following topics describe the available options for constructing a line:

More:

Variations

Auto Line Construction

Constructing an Alignment Line

Constructing a Best Fit or Best Fit Recompensate Line

Constructing a Cast Line

Constructing an Intersect Line

Constructing a Mid Line

Constructing a Parallel Line

Constructing a Perpendicular Line

Constructing a Projected Line

Changing the Direction of a Line

Constructing a Line from Part of a Scan

Constructing an Offset Line


Variations

The first example shown below is of the Edit window when the user switches TOG4 to BND. The first x, y, z indicates the first point on the line. The second x, y, z indicates the ending point on the same line. The last value represents the theoretical or actual length of the line.

The unbounded line format is displayed in the second example.

feature_name=FEAT/LINE,TOG1,BND
THEO/x_cord,y_cord,z_cord,x_cord,y_cord,z_cord,length
ACTL/x_cord,y_cord,z_cord,x_cord,y_cord,z_cord,length
CONSTR/TOG2,TOG3,...,length

feature_name=FEAT/LINE,TOG1,UNBND
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec
CONSTR/TOG2,TOG3,...


Auto Line Construction

The following table indicates the type of line that will be constructed when the specified inputs are selected and the AUTO option is chosen. The order of the selected features is not important. If an incorrect input feature(s) is selected, PC-DMIS will display an error message and will not automatically construct the indicated feature type.

To allow PC-DMIS to automatically determine the best method of construction:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Auto option from the list of options.

  3. Select the desired feature(s) based on the table below.

  4. Click the Create button.

Input Feature(s) | Constructs
3 or more Features = | Best Fit Line
Any 1 Feature (except line/set) = | Cast Line
Any 1 Set = | Best Fit Line
Any 2 Features + offset value = | Offset Line
Circle + Circle = | Best Fit Line
Circle + Ellipse | Best Fit Line
Circle + Point | Best Fit Line
Circle + Set = | Best Fit Line
Circle + Slot = | Best Fit Line
Circle + Sphere = | Best Fit Line
Cone + Circle = | Parallel to Line
Cone + Cone = | Mid Line
Cone + Cylinder = | Mid Line
Cone + Ellipse | Parallel to line
Cone + Point = | Parallel to Line
Cone + Set = | Parallel to Line
Cone + Sphere = | Parallel to Line
Cylinder + Circle = | Parallel to Line
Cylinder + Cylinder = | Mid Line
Cylinder + Ellipse | Parallel to Line
Cylinder + Point = | Parallel to Line
Cylinder + Set = | Parallel to Line
Cylinder + Sphere = | Parallel to Line
Ellipse + Ellipse |  | Best Fit Line
Ellipse + Set | Best Fit Line
Ellipse + Sphere | Best Fit Line
Line = | Reverse Line
Line + Circle = | Parallel to Line
Line + Cone = | Mid Line
Line + Cylinder = | Mid Line
Line + Ellipse | Parallel to Line
Line + Line = | Mid Line
Line + Point = | Parallel to Line
Line + Set = | Parallel to Line
Line + Slot = | Mid Line
Line + Sphere = | Parallel to Line
Point + Ellipse | Best Fit Line
Point + Point | Best Fit Line
Point + Sphere | Best Fit Line
Point + Slot | Best Fit Line
Point + Set | Best Fit Line
Plane + Any Feature (except plane)= | Project Line
Plane + Plane = | Intersect Line
Slot + Cone = | Mid Line
Slot + Cylinder = | Mid Line
Slot + Ellipse | Parallel to Line
Slot + Slot = | Best Fit Line


Constructing an Alignment Line

A line can be constructed through the current origin, normal to the current work plane. (Input features do not need to be provided.)

To Construct an Alignment Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Alignment option.

  3. Do not enter any features.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/LINE,ALIGN,length

Constructing a Line Normal to the Work Plane

A - Line through the current origin normal to the current work plane.

B - Current work plane.

C - Origin


Constructing a Best Fit or Best Fit Recompensate Line

Best Fit Recompensate is only accurate when constructing a line using points.

A 'best fit' 2 or 3-dimensional line can be constructed from two or more features. The best fit construction method takes the actual measured points while the best fit recompensate method takes the ball's center. In both cases the average squared error is minimized in the least squares method and the maximal error is minimized in the minmax method. You can also choose to remove outliers or apply a Gaussian filter to the constructed line.

  • The Best fit option compensates prior to fitting by using the ball center data shifted one tip radius in the direction of the negated hit vector.

  • The BF Recomp option uses the ball center data and the tip compensation is part of the fitting process.

To construct a Best Fit or Best Fit Recompensate Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select either the Best Fit or BF Recomp option.

  3. Enter in at least two features.

  4. Select either the 2D line or 3D line option.

Note: For Best Fit Recompensate, one feature must be a point.

  5. If desired, click the Remove Outliers check box and specify a value in the Standard Deviation Multiple box.

  6. If desired, click the Apply Gauss Filter check box and specify a value in the Cuttoff Wavelength box.

  7. Click the Create button.

The Edit window command line for this option would read:

CONSTR/LINE,BF,feat_1,feat_2, …
OUTLIER_REMOVAL/(ON | OFF), stdDevMultiple
FILTER/(ON | OFF),WAVELENGTH=ctfoffWavelength

(Uses the actual measured points for construction.)
or

CONSTR/LINE,BFRE,feat_1,feat_2, …
OUTLIER_REMOVAL/(ON | OFF), stdDevMultiple
FILTER/(ON | OFF),WAVELENGTH=cutoffWavelength

(Uses the center of the probe for measurement, recompensating after measuring the features.)

Constructing a Line from Two or More Features

More:

Remove Outliers / Standard Deviation Multiple

Apply Gauss Filter / Cutoff Frequency


Remove Outliers / Standard Deviation Multiple

For a best fit (BF) or best fit recompensate (BFRE) line you can choose to remove outliers based on the distance from the best fit feature. This allows the removal of anomalies that arise in the measurement process.

PC-DMIS first fits a line to the data, and then determines which points are outliers based on the value in the Standard Deviation Multiple box. It then does the following:

  • Recalculates the best fit line with those outliers removed.

  • Checks for outliers again.

  • Recalculates the best fit line.

  • Continues repeating this process until no more outliers exist or until PC-DMIS cannot compute the line (PC-DMIS can't compute the line if there are fewer than 3 data points).

For 2D lines, the deviation is calculated in a plane parallel to the workplane.

For 3D lines, the deviation is computed as the distance from the measured point to the nearest point along the line.


Apply Gauss Filter / Cutoff Wavelength

The Best Fit (BF) and Best Fit Recompensate (BFRE) constructed lines have the option of filtering the deviations of the measured data points from the best fit line computed from the measured data. The Apply Gauss Filter check box is a Gaussian filter with the smoothing controlled by the cutoff wavelength. Generally, a longer cutoff wavelength produces smoother filtered data. If you've selected the Remove Outliers check box and are filtering the data, then outlier data is removed prior to filtering.

For 2D lines, PC-DMIS filters the deviations in a plane parallel to the workplane.

For 3D lines, PC-DMIS filters the deviations in two planes perpendicular to each other, both planes containing the line. PC-DMIS filters these deviations in 3D.


Constructing a Cast Line

A line can be constructed by changing any given feature into a line. PC-DMIS will construct the line at the centroid of the input feature.

You can modify the length of the line; this changes the line from DEPENDENT to INDEPENDENT. This means that when the line is executed that the length will not change based on the input feature, but will be independent of the input feature, while the position and vector will remain dependent on the input feature. This allows you to have control over the line length in cases where the input feature doesn’t really have a length, such as a point. The DEPENDENT/INDEPENDENT field is a toggle field that you may change.

To change the length of a line:

  1. Open the Edit window.

  2. Click on the line feature.

  3. Press the TAB key until the length field is selected.

  4. Type in a new length.

  5. Press TAB. PC-DMIS will update the length.

PC-DMIS will use this length value for all calculations instead of using a default length.

To construct a Cast Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Cast option.

  3. Enter in one feature of any type.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/LINE,CAST,feat_1,length,(DEPENDENT | INDEPENDENT)

Constructing a Line from a Cylinder


Constructing an Intersect Line

A line can be constructed at the intersection of two planes.

To construct an Intersect Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Intersect option.

  3. Enter in the first feature. It must be a plane.

  4. Enter in the second feature. It must be a plane.

  5. Click the Create button.

The Edit window command line for this option would read: CONSTR/LINE,INTOF,feat_1,feat_2,length

Constructing a Line from Two Planes

A - Line constructed at the intersection of two planes (PLN1 and PLN2).


Constructing a Mid Line

A mid line can be constructed between a line (cone, slot, cylinder, or plane) and a line (cone, slot, cylinder or plane). PC-DMIS creates a line (mid line) such that each of its points is the same distance from both input lines. You can construct mid lines from lines that are parallel as well as lines with any angle between them. The lines do not have to intersect.

The mid line centroid is a point on the line segment between the centroids of the input lines that is the same distance from both lines (it is not necessarily the midpoint of the line segment).

The direction of the mid line vector depends on the location of the mid line centroid and on the two input vectors, with the sense of the mid line vector determined by the first line vector. Expressed mathematically, if the first line vector is V1 and the second line vector is V2 then the direction of the mid line vector is generally either V1 + V2 or V1 - V2.

To construct a Mid-Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Mid option.

  3. Enter in the first feature. It must be either a line, cone, cylinder, or slot.

  4. Enter in the second feature. It must be either a line, cone, cylinder, or slot.

  5. Click the Create button.

The Edit window command line for this option would read:
CONSTR/LINE,MID,feat_1,feat_2,length

Constructing a Mid Line from 2 Lines

A - Constructed line (a mid line) equally spaced between two lines (FRONT and BACK).

B - FRONT

C - BACK


Constructing a Parallel Line

A line can be constructed parallel to any two features. PC-DMIS creates a line parallel to the first input feature and passing through the center of the second input feature.

To construct a Parallel Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Parallel option.

  3. Select two features of any type.

  4. Click the Create button.

  5. The Edit window command line for this option would read:
    CONSTR/LINE,PLTO,feat_1,feat_2,
    length

Constructing a Parallel Line

A - Line constructed parallel to the first feature and through the second feature.

B - First feature

C - Second feature

D - FRONT


Constructing a Perpendicular Line

A line can be constructed perpendicular to the first input feature and passing through the centroid of the second input feature.

To construct a Perpendicular Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Perpendicular option.

  3. Select two features of any type.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/LINE,PRTO,feat_1,feat_2,length

Constructing a Perpendicular Line

A - Line constructed perpendicular to the first feature and through the center of the second feature.

B - First feature

C - Second feature

D - FRONT


Constructing a Projected Line

A line can be constructed from any feature and a plane. PC-DMIS will project the line where the plane intersects the line. If there is only one input feature, the projection will be to the work plane.

To construct a Projected Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Projection option.

  3. Select either one or two features. The first feature may be of any type. If two features are selected, the second feature must be a plane.

  4. Click the Create button.

Command line in the Edit window:
CONSTR/LINE,PROJ,feat_1,(feat_2),
length

Constructing a Line from a Line and a Plane

A - Constructed Line projected from the a line feature (LIN1) onto a plane feature (PLN1).


Changing the Direction of a Line

A line can be constructed with a reversed vector.

To construct a Reverse Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Reverse option.

  3. Select one feature. It must be a line.

  4. Click the Create button. PC-DMIS reverses the vector of the line and also flips the start and end points.

The Edit window command line for this option would read: CONSTR/LINE,REV,feat_1,length


Constructing a Line from Part of a Scan

A line can be constructed from a segment of a Linear Open or Linear Close scan. PC-DMIS will create a line from part of the scan. The details of the construction are included further in this discussion.

To construct a Scan Segment Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Scan Segment option.

  3. Select a previously created Linear Open or Linear Close scan.

  4. Click the Segment Data button. The Scan Segment dialog box will appear.

  5. Select either the Best Fit or BF Recomp option.

  6. Select the portion of the scan used in the construction from this dialog box.

  7. Type the number of points to potentially discard by entering values in the Discard Start and Discard End Maximum boxes.

  8. Type a distance from the best fit line into the Discard Tolerance box. This tolerance is a form tolerance; it allows you to control what end points are accepted as part of the line. If the distance from the scan point to the best fit line is greater than this tolerance value, then the end point will be discarded.

  9. Input the Approximate Start and End Points of the scan by marking the Select Points check box, and then clicking in the Graphics Display window to fill in the X, Y, and Z fields. You can click anywhere in the Graphics Display window, however, PC-DMIS will place the point on the scan nearest to where you clicked. You can also edit the point values by using the keyboard.

  10. Click OK to accept the data and close the Scan Segment dialog box.

  11. Click Create to construct the line from the scan.

The Edit window command line for this option reads:

CONSTR/LINE,SCAN_SEGMENT,fit_type,feat_1,start_x,start_y,start_z,end_x,end_y,end_z,discard_start,discard_end,tolerance

If you want more than one arc or line from a given scan, then you will need to add another command for a different section of the scan.

More:

Determining the Data Used to Construct the Line


Determining the Data Used to Construct the Line

The data used to construct the line is determined as follows:

  • First a segment of the scan is determined using a starting point and an ending point within the scan. The starting and ending point are chosen as the point in the scan nearest [start_x, start_y, start_z] and the point nearest [end_x, end_y, end_z], respectively.

  • Points are then discarded from the Start and End Points of the scan. The number of points discarded is discard_start and discard_end from the start and end, respectively. A line is then fitted to this set of points.

  • Finally, the starting and ending points are added back in if they are within the tolerance defined. The line is then re-fitted once more to the new set of points.

The value of fit_type may be BF (Best Fit) or BFRE (Best Fit Recompensate). This determines whether a best fit or best fit with recompensation is done when calculating the line. For a description of Best Fit and Best Fit Recompensate, see "Constructing a Best Fit or Best Fit Recompensate Line"


Constructing an Offset Line

A line can be constructed a specified distance from the input features.

To construct an Offset Line:

  1. Access the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Offset option.

  3. Select at least two features from which to create the offset line. They can be of any type.

  4. Click the Offsets button. The Line Offsets dialog box will appear.

Line Offsets dialog box

  5. Click the Calculate Noms option and enter the offset values for the desired features in the offset field or Click the Calculate Offsets option and change the nominal values (see the procedures below).

  6. Click the OK button. The Line Offsets dialog box will close.

  7. Click the Create button.

PC-DMIS will iterate and construct a line such that the shortest distance from each input feature to the line is the corresponding offset amount. PC-DMIS will make all offsets in a direction perpendicular to the given surface normal direction. PC-DMIS will apply negative offsets in the same general direction that the points are measured. Positive offset values will be applied opposite the probing direction. If there is no probing direction (i.e., the input points were constructed), PC-DMIS uses the current work plane to determine the general direction for applying the offsets. Positive offsets will be applied in the plus direction of the third axis of the current work plane. Negative offsets will be applied in the minus direction of the third axis of the current work plane.

Note: The sign (positive or negative) of the offset value, control on which side of the input features the line is constructed. If you get the opposite line than was expected, cancel the feature and reconstruct it, reversing the sign of the keyed in offsets. For example, if the offsets are 1.0, 2.5, 3.5, change them to -1.0, -2.5, -3.5.

The Edit window command line for this option would read:
CONSTR/LINE,OFFSET
SURFACE NORMAL = i_vec, j_vec, k_vec, TOG1
ID = id1, id2, …
OFFSET = val1, val2, …

Note: TOG1 = changes between MULTI POINT and TWO POINT. The TWO POINT algorithm is only available for parts created using PC-DMIS version 2.1 or earlier.

You can calculate the offset value in two ways:

  • Changing the offset directly for the input feature of your choice, and then click the Calculate button to updating the nominal values.

  • Change the nominal values for the selected feature, and then click the Calculate button to update the offset values.

These are described below.

More:

Changing Offsets Directly to Calculate Nominals

Example of Calculating Nominals

Changing Nominals Directly to Calculate Offsets

Example of Calculating Offsets


Changing Offsets Directly to Calculate Nominals

To enter new offset values:

  1. Open the Line Offsets dialog box by clicking the Offset button from the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

  2. Select the Calculate Noms option. The offsets portion of the dialog box becomes editable.

  3. In the Offset column, click on the "0.000000" value (or current value) to highlight it.

  4. Click again on the offset.

  5. Type a new value.

  6. Press the ENTER key.

  7. Click Calculate to update the nominal values based on any offset(s) you chose.

  8. Click OK to save the offset.


Example of Calculating Nominals

The Calculate button calculates the X, Y, and Z nominal values from new offsets entered.

For example, suppose you construct an offset line between two circles (CIR1 and CIR2). After selecting the features and clicking the Offsets button, you have X, Y, and Z nominals of:

X = 4.5040

Y = 3

Z = 0.1582

If you change the offset values by two for each circle and click the Calculate Noms button, the X, Y, and Z are updated to:

X = 4.5040

Y = 5

Z = 0.1582

If you then click OK and construct the offset line, you'll notice that the newly constructed line lies 2 units higher in the Y axis.

Only the Y axis is offset for Line Offsets.


Changing Nominals Directly to Calculate Offsets

To enter new offset values:

1. Open the Line Offsets dialog box by clicking the Offset button from the Construct Line dialog box (Insert | Feature | Constructed | Line). Display Menu Roadmap

2. Select the Calculate Offsets option. The Nominals portion of the dialog box becomes editable.

3. Change the XYZ, IJK, or surface IJK values.

4. Click Calculate to update the offset values based on any nominals you've changed.

5. Click OK to save the offset.


Example of Calculating Offsets

The Calculate Offsets button calculates the offset values appearing in the Offset column when you change the nominal value.

For example, suppose you construct an offset line between two circles (CIR1 and CIR2). After selecting the features and clicking the Offsets button, you have X, Y, and Z nominals of:

X = 4.5040

Y = 3

Z = 0.1582

If you change the X, Y, and Z nominals to:

X = 4.5040

Y = 4.5

Z = 0.1582

and click the Calculate Offsets button; the offsets for the two circles are updated to:

1.500000 CIR1

1.500000 CIR2

If you then click OK and construct the offset line, you'll notice that the line is constructed at 1.5 units higher in the Y axis.


 Constructing a Reverse Cone Constructing a Cast Cone Close button Create button Clear button Constructing a Best Fit or Best Fit Recompensate Cone Creating An Auto Circle In / Out Cone Feature List box Select Last # Search ID ID Constructing a Projected Cone

This stands for theoretical. It is the nominal size or location information.

This means Actual, meaning the "measured" size or location information as opposed to the "theoretical" size or location information.

Constructing a Cone Feature

Construct Cone dialog box

PC-DMIS allows several methods for constructing a cone. The following table lists the various types of constructed cones, along with their necessary inputs. Some features may require no inputs while others may require six inputs or more. The term 'Any' in the table below indicates that the construction can take any type of feature as input for construction. PC-DMIS allows the features to be selected in any order.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT FEATS | FEAT #1: | FEAT #2: | COMMENTS
Best Fit Cone | BF | At least 6 inputs are needed. | - | - | Constructs best fit cone using given inputs
Best Fit with Recomp Cone | BFRE | At least 6 inputs are needed. (1 must be a point) | - | - | Constructs best fit cone using given inputs
Cast Cone | CAST | 1 | Any | - | Constructs cone at centroid of input feature
Project Cone | PROJ | 1 or 2 | Any | Plane | Using 1 input feature will project cone to work plane
Reverse Cone | REV | 1 | Cone | - | Constructs cone with a reversed vector for the axis

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the status bar.

To construct a cone:

  1. Access the Construct Cone dialog box (Insert | Feature | Constructed | Cone). Display Menu Roadmap

  2. Input the desired features.

  3. Select the method of construction. Available options include:

  • Best Fit or Best Fit Recompensate Cone

  • Cast Cone

  • Projected Cone

  • Reversed direction Cone

  • Auto Cone

  4. Click the Create button.

The Edit window command line for this option would read:

feature_name=FEAT/CONE,TOG1,TOG4,ANG
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,ang
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,ang
CONSTR/TOG2,TOG3,......

feature_name=FEAT/CONE,TOG1,TOG4,LENG
THEO/x_cord,y_cord,z_cor,i_vec,j_vec,k_vec,leng,diam_1,diam_2
ACTL/x_cord,y_cord,z_cor,i_vec,j_vec,k_vec,leng,diam_1,diam_2
CONSTR/TOG2,TOG3,......

Note: The actual Edit report will be displayed in all CAPS.

TOG1= POLR or RECT

TOG2 = CONE

TOG3 = BF / BFRE / CAST / PROJ / REV

TOG4 = IN / OUT

TOG5 = ANG / LENG

The first three lines displayed in the Edit window are similar for constructed cones. If the feature is bound or unbound, the theoretical and actual values that are displayed will vary. The fourth line will be slightly different, according to the type of feature being constructed. You can switch between the different types of cones by placing the cursor on TOG and clicking the left mouse button. The keyboard can also be used to switch toggle fields. (See "Command Mode Keyboard Functions" in the "Using the Edit Window" section.)

When two or more features are involved, PC-DMIS automatically determines the necessary order of the input features. This improves the accuracy of the measurement process.

Auto is the default method of construction. This option automatically determines the best way to construct a cone using the input feature(s). See "Auto Cone Construction"

The following paragraphs describe the available options for constructing a cone:

More:

In / Out Cone

Variations

Constructing a Best Fit or Best Fit Recompensate Cone

Constructing a Cast Cone

Constructing a Projected Cone

Changing the Direction of a Cone

Auto Cone Construction


In / Out Cone

The In and Out options tell PC-DMIS whether to construct the cone as an internal or an external cone.

  • If you select In, PC-DMIS constructs the cone as an internal cone.

  • If you select Out, PC-DMIS constructs the cone as an external cone.


Variations

The first example shown below is of the Edit window when the user changes TOG5 to ANG. The unbounded cone format is displayed in this first example. The second example shows the display when you change TOG5 to LENG. Diam_1 is defined as the diameter of the height of the first three hits. Diam_2 is the diameter of the furthest point away from the first diameter. Length is the distance between the two diameters.

The bounded cone format is shown in the second example.
feature_name=FEAT/CONE,TOG1,TOG4,ANG
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,ang
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,ang
CONSTR/TOG2,TOG3,......

feature_name=FEAT/CONE,TOG1,TOG4,LENG
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,length,diam_1,diam_2
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,length,diam_1,diam_2
CONSTR/TOG2,TOG3,......


Constructing a Best Fit or Best Fit Recompensate Cone

A best fit cone can be constructed using six or more features. The first three inputs must be on an approximately planar cross section of the cone that is normal to its centerline. The remainder of the points should lie either above or below the plane defined by the first three points, but not on both sides of the plane. This method of measuring will yield the best results. The best fit construction method takes the actual measured points, rather than the ball's center (as in the case of best fit recompensate). In both cases PC-DMIS computes a least squares cone, one for which PC-DMIS minimizes the average squared distance from the data points to the cone.

To Construct a Best Fit or Best Fit Recompensate Cone:

  1. Access the Construct Cone dialog box (Insert | Feature | Constructed | Cone). Display Menu Roadmap

  2. Select either the Best Fit or BF Recomp option.

  3. Enter in at least six features.

Note: If you choose Best Fit Recompensate at least one feature must be a point.

  4. Click the Create button.

The Edit window command line for this option would read: CONSTR/CONE,BF,feat_1,feat_2,feat_3,feat_4,feat_5,feat_6
(Uses the actual measured points for construction.)
or
CONSTR/CONE,BFRE,feat_1,feat_2,feat_3,feat_4,feat_5,feat_6
(Uses the center of the probe for measurement.)

Constructing a Cone from Six or More Points

A - Best Fit cone constructed from nine points.


Constructing a Cast Cone

A cone can be constructed by changing any given feature into a cone. PC-DMIS will construct the cone at the centroid of the input feature. If the input feature is not a cone, PC-DMIS will use a default value for the included angle. If the input feature is not a line element (line, cylinder, or slot), PC-DMIS will use a default length for the axis length.

You can change the size of the cone; this changes the cone from DEPENDENT to INDEPENDENT. This means that when the cone is executed that the size will not change based on the input feature, but will be independent of the input feature, while the position and vector remain dependent on the input feature. This allows you to have control over the cone's size in cases where the input feature doesn't really have a size, such as a point. The DEPENDENT/INDEPENDENT field is a toggle field that you may change.

PC-DMIS will use the new attributes for all calculations (for example, if the half angle is changed) instead of the default values as described above.

To construct a Cast Cone:

  1. Access the Construct Cone dialog box (Insert | Feature | Constructed | Cone). Display Menu Roadmap

  2. Select the Cast option.

  3. Select one feature of any type.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CONE,CAST,feat_1, (DEPENDENT | INDEPENDENT)


Constructing a Projected Cone

A cone can be constructed by projecting any feature onto a plane. If the projected input feature is not a cone, PC-DMIS will use default values for the included angle and two axis lengths. The first length is the distance between the vertex and the first circle. The second length is the distance between the two circles. If there is only one input, the projection will be to the current work plane.

To construct a Projected Cone:

  1. Access the Construct Cone dialog box (Insert | Feature | Constructed | Cone). Display Menu Roadmap

  2. Select the Projection option.

  3. Select either one or two features. If one feature is selected, the feature can be of any type. If two features are selected, the first feature can be of any type. The second feature must be a plane.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CONE,PROJ,feat_1,(feat_2)


Changing the Direction of a Cone

A cone can be constructed with a reversed vector.

To construct a Reverse Cone:

  1. Access the Construct Cone dialog box (Insert | Feature | Constructed | Cone). Display Menu Roadmap

  2. Select the Reverse option.

  3. Select one feature. It must be a cone.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CONE,REV,feat_1


Auto Cone Construction

The following table indicates the type of cone that will be constructed when the specified inputs are selected and the AUTO option is chosen. The order of the selected features is not important. If an incorrect input feature(s) is selected, PC-DMIS will display an error message and will not automatically construct the indicated feature type.

To allow PC-DMIS to automatically determine the best method of construction:

  1. Access the Construct Cone dialog box (Insert | Feature | Constructed | Cone). Display Menu Roadmap

  2. Select the Auto option the list of options.

  3. Select the desired feature(s) based on the table below.

  4. Click the Create button.

Input Feature(s) | Constructs
6 or more Features = | Best Fit Cone
Plane + Any Feature = | Project Cone
Cone = | Reverse Cone
Any 1 Feature = (other than Cone/Set) | Cast Cone
Any 1 Set = | Best Fit Cone


 Constructing a Reverse Cylinder Constructing a Cast Cylinder Constructing a Projected Cylinder Constructing a BF or BFRE Cylinder Close button Create button Clear button Constructing an Auto Cylinder In / Out Cylinder Feature List box Select Last # Search ID ID

Constructing a Cylinder Feature

Cylinder Construction dialog box

PC-DMIS allows several methods for constructing a cylinder. The following table lists the various types of constructed cylinders, along with their necessary inputs. Some features may require no inputs while others may require six inputs or more. In the following table, the term 'Any' indicates that the construction can take any type of feature as input for construction. PC-DMIS allows the features to be selected in any order.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT FEATS | FEAT #1: | FEAT #2: | COMMENTS
Best Fit Cylinder | BF | At least 6 inputs are needed. See Note below. | - | - | Constructs best fit cylinder using given inputs
Best Fit Recomp Cylinder | BFRE | At least 6 inputs are needed. (1 must be a point) See Note below. | - | - | Constructs best fit cylinder using given inputs
Cast Cylinder | CAST | 1 | Any | - | Constructs cylinder at centroid of input feature
Project Cylinder | PROJ | 1 or 2 | Any | Plane | 1 input feature will project cylinder to work plane
Reverse Cylinder | REV | 1 | Cylinder, Cone, Line, Slot | - | Constructs a cylinder with a reversed vector

Note: Best Fit and Best Fit Recomp Cylinders can now be constructed from two circles. The input circles must be of type Constructed Best Fit (BF) / Best Fit Recompensate (BFRE) or Measured circles. The total amount of hits in each circle must be at least three.

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the status bar.

To construct a cylinder:

  1. Access the Construct Cylinder dialog box (Insert | Feature | Constructed | Cylinder). Display Menu Roadmap

  2. Input the desired features.

  3. Select the method of construction. Available options include:

  • Best Fit or Best Fit Recompensate Cylinder

  • Cast Cylinder

  • Projected Cylinder

  • Reversed direction Cylinder

  • Auto Cylinder

  4. Click the Create button.

The Edit window command line for a sample Cylinder Construction would read:
feature_name=FEAT/CYLINDER,TOG1,TOG4,TOG5
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,diam,length
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,diam,length
CONSTR/TOG2,TOG3,......

Note: The actual Edit report will be displayed in all CAPS.

AUTO is the default method of construction. This option automatically determines the best way to construct a cylinder using the input feature(s). See "Auto Cylinder Construction"

The following text is the basic format for cylinders.

TOG1= POLR or RECT

TOG2 = CYLINDER

TOG3 = BF / BFRE / CAST / PROJ / REV

TOG4 = IN / OUT

TOG5 = LEAST_SQR / MAX_INSC / MIN_CIRCSC / MIN_SEP / FIXED_RAD (only for measured, BF and BFRE circles)

length = is measured between the first measured circle (first three hits) and the furthest point away from the first three hits.

The first three lines displayed in the Edit window will be the same for constructed cylinders. The fourth line will be slightly different, according to the type of feature being constructed. You can switch between the different types of cylinders by placing the cursor on TOG3 and pressing F7 or F8. (See "Command Mode Keyboard Functions" in the "Using the Edit Window" section.)

When two or more features are involved, PC-DMIS automatically determines the necessary order of the input features. This improves the accuracy of the measurement process.

The following paragraphs describe the available options for constructing a cylinder:

More:

In / Out Cylinder

Constructing a Best Fit or Best Fit Recompensate Cylinder

Constructing a Cast Cylinder

Constructing a Projected Cylinder

Changing the Direction of a Cylinder

Auto Cylinder Construction


In / Out Cylinder

The In and Out options tell PC-DMIS whether to construct the cylinder as an internal or an external cylinder.

  • If you select In, PC-DMIS constructs the cylinder as an internal cylinder.

  • If you select Out, PC-DMIS constructs the cylinder as an external cylinder.


Constructing a Best Fit or Best Fit Recompensate Cylinder

A best fit cylinder can be constructed from six or more points. The first three points must be on an approximately planar cross section of the cylinder that is normal to its centerline. The best fit construction method takes the actual measured points, rather than the ball's center (as in the case of best fit recompensate). In both cases PC-DMIS computes a least squares cylinder, one for which PC-DMIS minimizes the average squared distance from the data points to the cylinder.

Note: Be aware that certain patterns of points (such as two rows of three equally spaced points or two rows of four equally spaced points) result in multiple ways to construct or measure a cylinder, and PC-DMIS's Best Fit algorithm may construct or measure the cylinder using an unexpected solution. For best results, measured or constructed cylinders should use a pattern of points that will eliminate unwanted solutions.

To Construct a Best Fit or Best Fit Recompensate Cylinder:

  1. Access the Construct Cylinder dialog box (Insert | Feature | Constructed | Cylinder). Display Menu Roadmap

  2. Select either the Best Fit or BF Recomp option.

  3. Enter your input features by either choosing at least two appropriate circle features or at least six features of any type.

For at least two circle features, they must be measured circles. The total amount of hits in each circle must be at least three.

For at least six features, they can be of any type. However, if you selected BF Recomp, at least one feature must be a point.

4. Click the Create button.

Note: The math routine that PC-DMIS uses to gets the points from the input features behaves differently depending on the type of input feature. Constructed features other than the appropriate input circles described above return a single point. The constructed BF circles, constructed BFRE circles, or measured circles described above return their input points.

The Edit window command line for this option would read:
CONSTR/CYLINDER,BF,feat_1,feat_2,feat_3,feat_4,feat_5,feat_6
(Uses the actual measured points for construction.)
or
CONSTR/CYLINDER,BFRE,feat_1,feat_2,feat_3,feat_4,feat_5,...
(Uses the center of the probe for measurement.)

Constructing a Cylinder from Six or More Points

A - Best Fit Cylinder constructed from eight points.

More:

Best Fit Type


Best Fit Type

This list becomes available if you select Best Fit or BF Recomp options when constructing the cylinder. It allows you to specify the type of Best Fit construction used. Available types include:

  • LEAST_SQR

  • MAX_INSC

  • MIN_CIRCSC

  • MIN_SEP

  • FIXED_RAD

These calculation types are already discussed in the "Best Fit Type".


Constructing a Cast Cylinder

A cylinder can be constructed by changing any given feature into a cylinder. PC-DMIS will construct the cylinder at the centroid of the input feature. If a sheet metal point is used, the diameter will be the probe diameter. For some sheet metal features (such as slots and notches) the width will be used as the diameter. For features that do not have diameters (lines, points, etc.), a value that is four times the probe diameter will be used.

You can change the size of the cylinder; this changes the cylinder from DEPENDENT to INDEPENDENT. This means that when the cylinder is executed that the length and diameter will not change based on the input feature but will be independent of the input feature, while the position and vector will remain dependent on the input feature. This allows you to have control over the cylinder size in cases where the input feature doesn’t really have a length and diameter, such as a point. The DEPENDENT/INDEPENDENT field is a toggle field that you may change.

PC-DMIS will use the new attributes for all calculations (for example, if the diameter is changed) instead of the default values as described above.

To construct a Cast Cylinder:

  1. Access the Construct Cylinder dialog box (Insert | Feature | Constructed | Cylinder). Display Menu Roadmap

  2. Select the Cast option.

  3. Select one feature. The feature can be of any type.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CYLINDER,CAST,feat_1, (DEPENDENT | INDEPENDENT)


Constructing a Projected Cylinder

A cylinder can be constructed from any feature and a plane. The diameter of the projected cylinder will be the diameter of the first input feature (if circular) or twice the probe diameter if not a circular feature. You will need to input the length and diameter for bound measurements. If there is only one input feature, the projection will be to the work plane.

To construct a Projected Cylinder:

  1. Access the Construct Cylinder dialog box (Insert | Feature | Constructed | Cylinder). Display Menu Roadmap

  2. Select the Projection option.

  3. Select either one or two features. If one feature is selected, the feature can be of any type. If two features are selected, the first feature can be of any type. The second feature must be a plane.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CYLINDER,PROJ,feat_1,(feat_2)


Changing the Direction of a Cylinder

A cylinder can be constructed with a reversed vector.

To construct a Reverse Cylinder:

  1. Access the Construct Cylinder dialog box (Insert | Feature | Constructed | Cylinder). Display Menu Roadmap

  2. Select the Reverse option.

  3. Select one feature. It must be a cylinder.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/CYLINDER,REV,feat_1


Auto Cylinder Construction

The following table indicates the type of cylinder that will be constructed when the specified inputs are selected and the AUTO option is chosen. The order of the selected features is not important. If an incorrect input feature(s) is selected, PC-DMIS will display an error message and will not automatically construct the indicated feature type.

Input Feature(s) | Constructs
5 or more Features = | Best Fit Cylinder
Any 1 Feature = (other than Cylinder/Set) | Cast Cylinder
Any 1 Set = | Best Fit Cylinder
Cylinder = | Reverse Cylinder
Plane + Any Feature = | Project Cylinder

Note: Be aware that certain patterns of points (such as two rows of three equally spaced points or two rows of four equally spaced points) result in multiple ways to construct or measure a cylinder, and PC-DMIS's Best Fit algorithm may construct or measure the cylinder using an unexpected solution. For best results, measured or constructed cylinders should use a pattern of points that will eliminate unwanted solutions.

To allow PC-DMIS to automatically determine the best method of construction:

  1. Access the Construct Cylinder dialog box (Insert | Feature | Constructed | Cylinder). Display Menu Roadmap

  2. Select the Auto option from the list of options.

  3. Select the desired feature(s) based on the table below.

  4. Click the Create button.


 Clear button Create button Close button Changing the Direction of a Plane Constructing a Perpendicular Plane Constructing a Cast Plane Constructing a Mid Plane ID Search ID Select Last # Auto Plane Construction Constructing a Plane from an Alignment Feature List box Constructing a High Point Plane Constructing a Parallel Plane

Constructing a Plane Feature

Plane Construction dialog box

There are several methods for constructing a plane using PC-DMIS. The following table lists the various types of constructed planes, along with their necessary inputs. Some features may require no inputs, while others may require three inputs or more. In the following table, the term 'Any' indicates that the construction can take any type of feature as input for construction. PC-DMIS allows the features to be selected in any order.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT FEATS | FEAT #1: | FEAT #2: | FEAT #3: | COMMENTS
Alignment Plane | ALIGN | 0 | - | - | - | Constructs plane at alignment origin
Best Fit Plane | BF | At least 3 inputs are needed. | - | - | - | Constructs best fit plane using inputs
Best Fit with Recomp Plane | BFRE | At least 3 inputs are needed. (1 must be a point) | - | - | - | Constructs best fit plane using inputs
Cast Plane | CAST | 1 | Any | - | - | Constructs plane at centroid of input feature
High Point Plane | HIPNT | Either 1 set (using a minimum of 3 features) or 1 scan. | If input is a set, use any; if input is a scan, use a Patch scan. |  |  | Constructs plane using the highest available points.
Mid Plane | MID | 2 | Any | Any | - | Constructs mid plane between centroids of the inputs
Offset Plane | OFFSET | At least 3 inputs are needed. | Any | Any | Any | Builds plane offset from each of the input features
Parallel Plane | PLTO | 2 | Any | Any | - | Constructs plane parallel to first feat and passing through second feature
Perpendicular Plane | PRTO | 2 | Any | Any | - | Constructs plane perpendicular to first feature and passing through second feature
Reverse Plane | REV | 1 | Plane | - | - | Constructs plane passing through input with reversed vector

To construct a plane:

  1. Select Construct from the menu bar (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select Plane. The Construct Plane dialog box will appear.

  3. Input the desired features.

  4. Select the method of construction. Available options include:

  • Alignment Plane

  • Best Fit or Best Fit Recompensate Plane

  • Cast Plane

  • High Point Plane

  • Mid Plane

  • Offset Plane

  • Parallel Plane

  • Perpendicular Plane

  • Reversed direction Plane

  • Auto Plane

  5. Click the Create button.

The Edit window command line for a sample Plane Construction would read:
feature_name=FEAT/PLANE,TOG1
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec
CONSTR/TOG2,TOG3,......

If TOG2 = PLANE and TOG3 = BF or BFRE then the command has the following format:
feature_name=FEAT/PLANE,TOG1
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec
CONSTR/PLANE,TOG3
OUTLIER_REMOVAL/TOG5,stdDevMultiplier
FILTER/TOG5,WAVELENGTH= cutoffWavelength

Note: The actual Edit report will be displayed in all CAPS.

AUTO is the default method of construction. This option automatically determines the best way to construct a plane using the input feature(s). See "Auto Plane Construction".

TOG1= POLR or RECT

TOG2 = PLANE

TOG3 = ALIGN / BF / BFRE / CAST / HIPNT / MID / OFFSET / PLTO / PROJ / PRTO / REV

TOG5 = ON / OFF

stdDevMultiplier = This multiplier value determines whether or not a measured point is an outlier. If the point from the plane is further than the standard deviation multiplied by this, then it is an outlier and will be removed if you have selected the Remove Outlier option.

cutoffWavelength = This value controls the amount of data smoothing. The longer the wavelength the more smoothing there will be.

The first three lines displayed in the Edit window will be the same for constructed planes. The fourth line will be slightly different, according to the type of feature being constructed. You can switch between the different types of planes by placing the cursor on TOG3 and pressing F7 or F8. (See "Command Mode Keyboard Functions" in the "Using the Edit Window" section.)

When two or more features are involved, PC-DMIS automatically determines the necessary order of the input features. This improves the accuracy of the measurement process.

The following paragraphs describe the available options for constructing a plane:

More:

Constructing a Plane from an Alignment

Constructing a Best Fit or Best Fit Recompensate Plane

Constructing a Cast Plane

Constructing a High Point Plane

Constructing a Mid Plane

Constructing an Offset Plane

Constructing a Parallel Plane

Constructing a Perpendicular Plane

Changing the Direction of a Plane

Auto Plane Construction


Constructing a Plane from an Alignment

A plane can be constructed through the current origin and parallel to the current work plane. (Input features do not need to be provided.)

To construct an alignment plane:

1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

2. Select the Alignment option.

3. Do not select any features.

4. Click the Create button.

The Edit window command line for this option would read: CONSTR/PLANE,ALIGN

Constructing a Plane from an Alignment

A - Plane constructed parallel to the top (XY+Z) work plane and through the origin.

B - Origin (0,0,0)

C - Current work plane


Constructing a Best Fit or Best Fit Recompensate Plane

A 'best fit ' plane can be constructed through three or more features. The best fit construction method takes the actual measured points, rather than the ball's center (as in the case of best fit recompensate). In both cases PC-DMIS computes a least squares plane, one for which PC-DMIS minimizes the average squared perpendicular distance from the data points to the plane.

To Construct a Best Fit or a Best Fit Recompensate Plane:

  1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select either the Best Fit or BF Recomp option.

  3. Select at least three features.

Note: If you choose Best Fit Recompensate at least one feature must be a point.

  4. Click the Create button.

The Edit window command line for this option would read:

CONSTR/PLANE,BF,feat_1,feat_2, …

OUTLIER_REMOVAL/(ON | OFF),stdDevMultiple

FILTER/(ON | OFF), WAVELENGTH=cufoffWavelength

(Uses the actual measured points for construction.)

or

CONSTR/PLANE,BFRE,feat_1,feat_2, …

OUTLIER_REMOVAL/(ON | OFF),stdDevMultiple

FILTER/(ON | OFF), WAVELENGTH=ctfoffWavelength

(Uses the probe's center for measurement purposes.)

Constructing a Plane from Three or More Points

A - Best fit plane constructed from four points (PNT1, PNT2, PNT3, and PNT4).

More:

Remove Outliers / Standard Deviation Multiple

Apply Gauss Filter / Cutoff Wavelength


Remove Outliers / Standard Deviation Multiple

For a Best Fit (BF) or Best Fit Recompensate (BFRE) plane you can choose to remove outliers based on the distance from the best fit feature. This allows the removal of anomalies that arise in the measurement process.

PC-DMIS first fits a plane to the data, then determines which points are outliers based on the standard deviation multiple. It then does the following:

  1. Recalculates the best fit plane with those outliers removed.

  2. Checks for outliers again.

  3. Recalculates the best fit plane.

  4. Continues repeating this process until no more outliers exist or until PC-DMIS cannot compute the plane (PC-DMIS can't compute the plane if there are fewer than 3 data points).


Apply Gauss Filter / Cutoff Wavelength

The Best Fit (BF) and Best Fit Recompensate (BFRE) constructed planes have the option of filtering the deviations of the measured data points from the best fit plane computed from the measured data. The Apply Gauss Filter check box lets you apply a Gaussian filter with a cutoff wavelength. Generally, a larger cutoff wavelength produces smoother filtered data. If you've selected the Remove Outliers check box and are filtering the data, then outlier data is removed prior to filtering. For additional information on Gaussian filtering, see the "Gaussian" topic under "Constructing a Filter Set".


Constructing a Cast Plane

A plane can be constructed by changing any feature into a plane. PC-DMIS will construct the plane at the centroid of the input feature.

  1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select the Cast option.

  3. Select one feature of any type.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/PLANE,CAST,feat_1


Constructing a High Point Plane

PC-DMIS is only able to construct a High Point Plane from a set of features. The set must contain at least three features.

A High Point plane can be constructed using features forming a set or a patch scan.

To construct a High Point Plane:

  1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select the High Point option.

  3. Select three or more features (any feature type may be used). A set using at least three features or a patch scan can also be used. See "Constructing a Set of Features" or "Performing a Patch Advanced" in the "Scanning Your Part" section.

  4. Click the Create button.

  5. First, PC-DMIS will construct a Best Fit plane from the input features. Next, PC-DMIS rotates to the Best Fit plane. It then finds the highest three points on this plane (from the selected features) and uses them to create the high point plane.

The centroid of the input features used to construct the high point plane defines the center of gravity. PC-DMIS automatically creates a second plane if the first high point plane doesn't include the center of gravity.

The Edit window command line for this option would read:
CONSTR/PLANE, HIPNT,feat_1, feat_2, feat_3, . . .

Constructing a High Point Plane

A - Input Features

B - High point plane (using highest points)

C - Second high point plane created to include center of gravity

D - Center of Gravity


Constructing a Mid Plane

A plane can be constructed from any two features. The resultant plane (mid plane) is equally spaced from the centroids of the two specified input features.

To construct a Mid Plane:

  1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select the Midplane option.

  3. Select two features of any type.

  4. Click the Create button.

The Edit window command line for this option would read: CONSTR/PLANE,MID,feat_1,feat_2

Constructing a Plane from Two Planes

A - Constructed plane equally spaced between two planes (PLN1 and PLN2).

The constructed plane and it's vector depends on the input features used:

· If you select planes for both input features, then the mid plane is located where it bisects the smaller included angle between the two input planes.

· If you don't select a plane for both input features, then the constructed mid-plane passes through the point midway between the centroids of the two input features. The constructed plane's vector runs from the first input feature's centroid to the second input feature's centroid.


Constructing an Offset Plane

A plane can be constructed a specified distance from the input features.

To construct an Offset Plane:

  1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select the Offset option.

  3. Select at least three features of any type.

  4. Select the Offsets button. The Plane Offsets dialog box will appear.

Plane Offsets dialog box

  5. Click the Calculate Noms option and enter the offset values for the desired features in the offset field or Click the Calculate Offsets option and change the nominal values (see the procedures below).

  6. Click Calculate to calculate either the nominal values or the offset values.

  7. Click the OK button. The Plane Offsets dialog box will close.

  8. Click the Create button.

PC-DMIS will iterate and construct a plane such that the shortest distance from each input feature to the plane is the corresponding offset amount. PC-DMIS will apply negative offsets in the same general direction that the points are measured. Positive offset values will be applied opposite the probing direction. If there is no probing direction (i.e., the input points were constructed), PC-DMIS uses the current work plane to determine the general direction for applying the offsets. Positive offsets will be applied in the plus direction of the third axis of the current work plane. Negative offsets will be applied in the minus direction of the third axis of the current work plane.

Note: The sign (positive or negative) of the offset value, control on which side of the input features the plane is constructed. If you get the opposite plane than was expected, CANCEL the feature and reconstruct it, reversing the sign of the keyed in offsets. For example, if the offsets are 1.0, 2.5, 3.5, change them to -1.0, -2.5, -3.5.

The Edit window command line for this option would read:

CONSTR/PLANE,OFFSET
ID=id1, id2, id3, …
OFFSET=val1, val2, val3, …

More:

Changing Offsets Directly to Calculate Nominals

Example of Calculating Nominals

Changing Nominals Directly to Calculate Offsets

Example of Calculating Offsets


Changing Offsets Directly to Calculate Nominals

To enter new offset values:

  1. Open the Plane Offsets dialog box by clicking the Offsets button from the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. In the Offset column, click on the "0.000000" value (or current value) to select it.

  3. Click again on the offset.

  4. Type a new value.

  5. Press the ENTER key.

  6. Click Calculate to update the nominal values based on any offset(s) you chose.

  7. Click OK to save the offset.


Example of Calculating Nominals

The Calculate Noms button calculates the X, Y, and Z nominal values from new offsets entered.

For example, suppose you construct an offset plane between three circles (CIR1, CIR2, and CIR3). After selecting the features and clicking the Offsets button, you have X, Y, and Z nominals of:

X = 6

Y = 2

Z = 0.95

If you change the offset values by 3.0 for each circle and click the Calculate Noms button, the X, Y, and Z are updated to:

X = 6

Y = 2

Z = 3.95

If you then click OK and construct the offset line, you'll notice that the newly constructed line lies 3.0 units higher in the Z axis.

Plane offsets only apply the offset in the Z axis.


Changing Nominals Directly to Calculate Offsets

To enter new offset values:

  1. Open the Plane Offsets dialog box by clicking the Offsets button from the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select the Calculate Offsets option. The Nominals portion of the dialog box becomes editable.

  3. Change the XYZ or IJK values.

  4. Click Calculate to update the offset values based on any nominals you've changed.

  5. Click OK to save the offset.


Example of Calculating Offsets

The Calculate Offsets button calculates the offset values appearing in the Offset column when you change the nominal value.

For example, suppose you construct an offset plane between three circles (CIR1, CIR2, and CIR3). After selecting the features and clicking the Offsets button, you have X, Y, and Z nominals of:

X = 6

Y = 2

Z = 0.95

If you change the X, Y, and Z nominals to:

X = 6

Y = 2

Z = 3.95

and click the Calculate Offsets button, the offsets for the three circles are updated to:

3.000000 CIR1

3.000000 CIR2

3.000000 CIR3

If you then click OK and construct the offset line, you'll notice that the plane is constructed at 3.0 units higher in the Z axis.


Constructing a Parallel Plane

A plane can be constructed parallel to any two features. PC-DMIS creates a plane parallel to the first input feature and passing through the centroid of the second input feature.

To construct a Parallel Plane:

  1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select the Parallel option.

  3. Select two features of any type.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/PLANE,PLTO,feat_1,feat_2,

Constructing a Parallel Plane Using Two Planes

A - Plane constructed parallel to the first feature, a plane (PLN1) and through the second feature, a circle (CIR2).

Constructing a Parallel Plane Using Two Lines

A - Plane constructed through the first feature, a line (LINE1) and parallel to a second line (LINE2).


Constructing a Perpendicular Plane

A plane can be constructed between any two features. PC-DMIS creates a plane perpendicular to the first input feature and passing through the centroid of the second input feature.

To construct a Perpendicular Plane:

  1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select the Perpendicular option.

  3. Select two features of any type.

  4. Click the Create button.

The Edit window command line for this option reads:
CONSTR/PLANE,PRTO,feat_1,feat_2

Constructing a Perpendicular Plane

A - Plane constructed perpendicular to the first feature and through the second feature.


Changing the Direction of a Plane

A plane can be constructed with a reversed vector.

To construct a Reverse Plane:

  1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select the Reverse option.

  3. Select one feature. It must be a plane.

  4. Click the Create button.

The Edit window command line for this option would read:
CONSTR/PLANE,REV,feat_1


Auto Plane Construction

To allow PC-DMIS to automatically determine the best method of construction:

  1. Access the Construct Plane dialog box (Insert | Feature | Constructed | Plane). Display Menu Roadmap

  2. Select the Auto option from the list of options.

  3. Select the desired feature(s) based on the table below.

  4. Click the Create button.

The following table indicates the type of plane that will be constructed when the specified inputs are selected and the AUTO option is chosen. The order of the selected features is not important. If an incorrect input feature(s) is selected, PC-DMIS will display an error message and will not automatically construct the indicated feature type.

Input Feature(s) | Constructs
3 or more Features that aren't all measured points = | Best Fit Plane
1 plane = | Reverse Plane
Any 1 feature = (except Plane/Set) | Cast Plane
Any 1 Set = | Best Fit Plane
All are measured points = | Best Fit Recompensate Plane


Constructing a Slot Feature

Construct Slot dialog box

There are two slot types in PC-DMIS: a slot created from two circles (Circles option), and a slot created from four or more inputs (Best Fit or BF Recomp option). The table below shows the inputs for the slot and the editor definitions.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT FEATS | FEAT #1: | FEAT #2: | COMMENTS
Slot | ROUND SLOT | 2 | Circle | Circle | Constructs a slot in the plane of the first circle from center to center.
Slot | BF | 4 or more |  |  | Constructs a Best Fit slot using the given inputs
Slot | BFRE | 4 or more |  |  | Constructs a Best Fit Recompensate slot using the given inputs

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the status bar.

To construct a Slot:

  1. Access the Construct Slot dialog box (Insert | Feature | Constructed | Slot). Display Menu Roadmap

  2. Select the In or Out option to define the constructed slot as a hole or stud slot respectively.

  3. Select one of the following construction methods: Circles, Best Fit, or BF Recomp.

  4. Select your inputs based on the type of slot you will construct.

  5. Click the Create button.

The Edit window command line for a sample Slot Construction would read:

feature_name=FEAT/SLOT,TOG1,TOG2
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,width,length
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,width,length
CONSTR/TOG3,TOG4,feat_1,feat_2, …

Note: The actual report will be displayed in all CAPS.

TOG1 = POLR or RECT

TOG2 = OUT or IN

TOG3 = SLOT

TOG4 = CIRCLES or BF or BFRE

More:

In / Out Slot

Constructing a Best Fit or Best Fit Recompensate Slot

Constructing a Circle Slot


In / Out Slot

The In and Out options tell PC-DMIS whether to construct the slot as an internal or an external slot.

· If you select In, PC-DMIS constructs the slot as an internal slot.

· If you select Out, PC-DMIS constructs the slot as an external slot.


Constructing a Circle Slot

The round slot constructed from two circles is defined mostly by the first circle selected. The slot is constructed in the same plane as the first circle. The width of the slot is also determined by the diameter of the first circle. The second circle is only used to determine the length of the slot. The length is the distance from the center of the first circle to center of the second plus the diameter of the first circle.

If the two input circles are not coplanar, the center of the second circle is projected perpendicularly onto the plane of the first circle. The distance is then calculated from the center of the first circle to the projected center of the second.

To construct a Round Slot from Circles:

  1. Access the Construct Slot dialog box (Insert | Feature | Constructed | Slot). Display Menu Roadmap

  2. Select In or Out.

  3. Select the Circles option.

  4. Select two Circle features for inputs.

  5. Click the Create button.

The Edit window command line for the Round Slot would read:

CONSTR/SLOT,CIRCLES,feat_1,feat_2


Constructing a Best Fit or Best Fit Recompensate Slot

The Best Fit (BF) and the Best Fit Recompensate (BFRE) are constructed from 4 or more features. The constructed slots vector is normal (perpendicular) to the working plane. The BFRE construction uses the ball center combined with the probe radius to compute the slot. The compensation is an integral part of the fitting. The BF construction compensates the measured points prior to fitting.

The height of the slot from the workplane is the average of all the input features.

To construct a BF or BFRE Slot:

  1. Access the Construct Slot dialog box (Insert | Feature | Constructed | Slot). Display Menu Roadmap

  2. Select In or Out.

  3. Select the BF or BFRE option.

  4. Select at least 4 features. They can be any feature type.

  5. Click the Create button.

The Edit window command line for the Best Fit or Best Fit Recompensate Slot would read:

CONSTR/SLOT,BF (or BFRE),feat_1,feat_2, …


Constructing a Curve

Construct Curve dialog box

Display Menu Roadmap

There are two types of constructed curves (Independent Curves and Dependent Curves) available in PC-DMIS. The following table displays the two curves, along with their necessary inputs. All curves require a set as input. The set can be a measured set, a constructed set, or a scan. The input set must contain at least four features (or input points in the case of a scan).

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT SETS | INPUT #1: | COMMENTS
Dependent Curve | DEPENDENT | 1 | Set containing at least 4 inputs | Curve will update as input feature changes Note: Editing a curve will change dependent curve to independent curve.
Independent Curve | INDEPENDENT | 1 | Set containing at least 4 inputs | Uses input feature for construction only. User can manually edit control points of curve.

The Edit window command line for a sample Curve Construction using a dependent curve type would read:

feature_name

=FEAT/CURVE, DEPENDENT, num_control_points, num_input_feats, thinning_parameter

CONSTR/CURVE,INPUT_TYPE, input_id

For an independent curve type the Edit window command line would read:

feature_name

=FEAT/CURVE, INDEPENDENT, num_control_points, num_input_feats, thinning_parameter

CONSTR/CURVE,

num_control_points = This is the number of control points defining the curve. More control points allow the curve to more closely pass through the features, but too may cause unexpected behavior

num_input_feats = This is the number of features that the curve is attempting to fit.

Note: These two parameters are not editable in the Edit window.

input_id = This is the ID of the set containing the features to be fitted.

thinning_parameter = This is described in the "Thinning Parameters" topic described below.

Note: The actual Edit report will be displayed in all CAPS

More:

Constructing a Dependent / Independent Curve

Determining the Length Between Two Points on a Scan


Constructing a Dependent / Independent Curve

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the status bar.

To construct a curve:

  1. Access the Construct Curve dialog box (Insert | Feature | Constructed | Curve). Display Menu Roadmap

  2. Input the desired set.

  3. Set the value in the Thinning Tolerance box.

  4. Edit the Control points if necessary.

  5. Click the Create button.

All constructed curves start out as DEPENDENT curves and must be created from a single input, a set. The set can be one of three types:

  • A measured set

  • A constructed set

  • A scan containing a single row of points. (See "Constructing a Set of Features".)

The input set must contain at least four features or points (in the case of a scan).

Note: The resulting curve depends on the order that the features are added to the set (first to last).

You can also construct a curve by simply selecting multiple features from the feature list box rather than selecting a constructed set from the list. In this case the command's INPUT_TYPE field will be empty when viewing the command in the Edit window.

The following paragraphs describe the available options for constructing a curve.

More:

Thinning Parameters

Edit Control Point

Control Point List


Thinning Parameters

You can use one of two types of thinning parameters, either Thinning Tolerance or Thinning Proportion. A User Tolerance check box on the Construct Surface and Construct Curve dialog boxes lets you switch between either tolerance or proportion:

  • Thinning tolerance controls the tightness (or exactness) of the curve or surface fit. Valid thinning tolerances range from 0.0 to 5.0, with the default being 0.01. The smaller the thinning tolerance, the closer the curve comes to passing through the centroids of the features included in the input set. If the thinning tolerance is 0.0, the curve or surface will pass through all of the centroids. A larger thinning tolerance will result in a curve or surface that has fewer fluctuations (at the expense of not lying near the input set's features). The see this, construct a curve or surface and then change the input tolerance and examine how its shape changes.

  • Thinning proportion, alternately, may be used to control the quality of the fit. Valid thinning proportions range from between 0.0 and 1.0, with a default value of 0.33. The thinning proportion determines the number of degrees of freedom available in fitting the curve or surface to the centroids. At the lower extreme of 0 the algorithm will attempt to fit a straight line or plane to the centroids. At 1 it will compute a fit that passes through all of the centroids.

To make a DEPENDENT curve an INDEPENDENT curve (so that it is no longer associated with the input set:

1. Open the Edit window

2. Select the curve feature you constructed.

3. Navigate to the DEPENDENT field of that feature.

4. Press F7. It will change from DEPENDENT to INDEPENDENT.

The shape of the curve can be changed by editing its control points.


Edit Control Point

If a preexisting curve is selected, the dialog box will also contain a list of control points within the Control Point list. Select one of the control points and PC-DMIS will place the corresponding values in the X, Y, and Z boxes so that they can be edited.

To edit these control points:

  1. Make sure a curve feature already exists.

  2. Open the Edit window.

  3. Select the curve in the Edit window.

  4. Press F9 to activate the Curve dialog box.

  5. Select the control point to be changed in the Control Point list.

  6. Edit the individual X, Y, Z components of the point.

  7. Click the OK button.

The curve will then be updated to reflect the changes.

Note: If the control points on a dependent curve are edited, it automatically becomes an independent curve because it is no longer based on the input set.


Control Point List

The Control Point list is only visible when there is an existing curve associated with the dialog box. If a curve exists and you want to edit the control points of that curve, the Control Point list will display all of the control points for that curve.


Determining the Length Between Two Points of a Scan

Determining the Length Between Two Points on a Scan

To determine the length between two points on a scan, do the following:

  1. Access the Construct Curve dialog box (Insert | Feature | Constructed | Curve). Display Menu Roadmap

  2. Select a previously created scan for your input.

  3. Click the Create button. PC-DMIS will insert a constructed curve into the Edit window.

  4. On the Edit window, in Command mode, locate the last line of the constructed curve code block:
    CONSTR/CURVE

  5. Press TAB until PC-DMIS highlights the ID for the scan you selected to use as the input.

  6. Change the input ID to use specific points from the scan by typing SCN1.HITS[n..m] where SCN1 represents your scan ID and n and m represent a range between two points (or hits) on the scan. For example, if you wanted to get the length between hits 50 and 80 of the scan with an ID of SCN12, you would type, SCN12.HITS[50..80].

  7. Create a Location dimension and use the constructed curve as the input. Use the dimension to report the L axis (L for Length). The location dimensions would then display the length of the spline between the two hits you specified.

If you omit steps 4, 5, and 6, PC-DMIS will report the entire length of the scan (or curve).


Constructing a Surface

Construct Surface dialog box

There are two types of constructed surfaces (Independent Surface and Dependent Surface) available in PC-DMIS. The following table shows the two surfaces, along with their necessary inputs. The only input that the surface will take is a patch scan. The scan must contain at least two rows of four points per row.

Note: A future release will allow for clouds of points when constructing a surface.

CONSTRUCT FEATURE TYPE | SYMBOL IN EDIT WINDOW | # OF INPUT SETS | INPUT #1: | COMMENTS
Dependent Surface | DEPENDENT | 1 | Patch scan containing at least 2 rows with 4 points per row | Surface will update as input feature changes
Independent Surface | INDEPENDENT | 1 | Patch scan containing at least 2 rows with 4 points per row. | Uses input feature for construction only

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the status bar.

To construct a Surface:

  1. Access the Construct Surface dialog box (Insert | Feature | Constructed | Surface). Display Menu Roadmap

  2. Input the desired patch scan.

  3. Select the various construction options.

  4. Click the Create button.

The Edit window command line for a sample Surface Construction would read:
feature_name=FEAT/SURFACE,TOG1,CONTROL POINTS U,
CONTROL POINTS V, NUM POINTS FIT,TOG2
THINNING PARAMETER U, THINNING PARAMETER V
CONSTR/SURFACE, INPUT TYPE, INPUT ID

Note: The actual Edit report will be displayed in all CAPS.

DEPENDENT is the default method of construction.

TOG1=Dependent or Independent.

TOG2=Tolerance or Proportion

The following paragraphs describe the available options for constructing a surface:

More:

Constructing a Dependent/Independent Surface

Thinning Parameters


Constructing a Dependent/Independent Surface

All constructed surfaces start out as dependent surfaces and must be created from a single input -- a patch scan. The patch scan must contain at least two rows with four points per row. Thinning tolerances are used to control the tightness of the surface fit.

  • Small tolerances: If the thinning tolerances are small, the algorithm will attempt to fit the surface through all of the points in the scan.

  • Large tolerances: If the thinning tolerances are large, the surface will be more of an approximation to the scan. The best way to see this is to construct a surface and then change the thinning tolerances and see how the shape of the surface changes.

Note: The smaller the thinning tolerance the longer it will take to create the surface. Be aware that the small tolerances (.01 - .05) may take a considerable amount of time (one hour) to create the surface if the input scan is large or not well behaved. Valid thinning tolerances range from 0.01 to 5.0 with the default being 0.5.

The appearance of the surface can be controlled by the surface grid density values. The surface will be displayed as an N x M mesh of polylines with the default being a 5x5 mesh and the lowest value being a 2x2 mesh. To make a dependent surface independent so that it is no longer associated with the input scan, change the DEPENDENT field in the Edit window.

Note: The shape of the surface cannot be changed.

To construct a Dependent / Independent Surface:

  1. Access the Construct Surface dialog box (Insert | Feature | Constructed | Surface). Display Menu Roadmap

  2. Set the value for the Thinning Tol U: box

  3. Set the value for the Thinning Tol V: box. This applies a tolerance value to the V axis.

  4. Set the values for the surface grid density.

  5. Checkmark the desired constructions options. These include:

  • Optimize Surface

  • Apply Tension Factor

  • Create Corners

  • Smooth Bad Data

  6. Select a patch scan feature set containing at least 2 rows with 4 points per row.

  7. Click the Create button.

More:

Thinning Tolerance

Thinning Tol U

Thinning Tol V

Surface Grid Density

Optimize Surface

Apply Tension Factor

Create Corners

Smooth Bad Data


Thinning Parameter U

This box allows you to set a thinning parameter value applying to the U axis of the surface.


Thinning Parameter V

This box allows you to set a thinning parameter value applying to the V axis of the surface.


Surface Grid Density

This box allows you to set the density of a surface scan. The higher the values, the more splines there will be.


Optimize Surface

Control Points are points that mark begin and end points of splines in a surface grid.

This check box will attempt to optimize the knots and control points of the initial splines from which the surface will be constructed.

Surface Grid with Control Points (A), Knots (B), and Splines (C)


Apply Tension Factor

Surfaces created using the Apply Tension Factor check box will tend to be tauter (tighter) and shorter, but may fit the data slightly less closely.


Create Corners

This check box allows for corners to be added to the surface at areas where the data appears to make an abrupt change in direction.


Smooth Bad Data

This check box attempts to throw out bad data. Bad data is evaluated as data that has an abrupt change in direction. This option is almost the opposite of the Create Corners.


Constructing a Set of Features

Construct Feature Set dialog box

The Set menu command allows you to construct a set of features. This is done by selecting (or keying in) all the features to be used in the set. When you click the Create button, PC-DMIS will average all the input centroids, and display a set marker along with the new ID for the set.

Note: If you select inappropriate feature types, PC-DMIS displays "Cannot construct [feature]. Combination of input features not accepted." on the status bar.

To construct a Feature Set:

  1. Access the Construct Feature Set dialog box (Insert | Feature | Constructed | Set). Display Menu Roadmap

  2. Select the features you want in your feature set.

  3. Click the Create button. The new feature set is given a feature ID and is placed in the Graphics Display window.

The Edit window command line for a sample Surface Construction would read:
feature_name=FEAT/SET,TOG1,
THEO/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,
ACTL/x_cord,y_cord,z_cord,i_vec,j_vec,k_vec,
CONSTR/TOG2,feat_1, feat_2, feat_3...

TOG1= POLR or RECT

TOG2 = SET

The first three lines displayed in the Edit window will be the same for constructed sets. The fourth line will be slightly different, according to the number of features used in the set.

There are currently two uses for sets in PC-DMIS for Windows:

More:

Profile Error from a Set

Average Values from a Set

Using a Range of Hits from a Scan as Inputs


Profile Error from a Set

If CAD data is being used, a set can be constructed from measured points on a surface. When you ask for the PROFILE of the feature set, PC-DMIS will report the zone between the minimum normal to surface error and the maximum normal to surface error. (See "Dimensioning Surface or Line Profile" in the "Dimensioning Features" section for more information.)


Average Values from a Set

When a set is made from input features, PC-DMIS averages the X, Y, and Z values of the input features. For example, the set can be used to get the average Z value of a series of measured points.


Using a Range of Hits from a Scan as Inputs

Version 3.6 and higher allows you to use a range of hits from an existing scan for your feature set inputs instead of selecting individual features.

To do this:

1. Access the Construct Feature Set dialog box.

2. Select a scan to use as the input.

3. Click OK. The command appears in the Edit window.

4. Place the Edit window into Command mode.

5. Navigate to the feature set command in the Edit window.

6. Select the scan ID on the CONSTR/SET command line.

7. Modify the scan ID to take a range of hits, using a syntax like this:

<ID>.HIT<STARTHIT>..<ENDHIT>

<ID> - Specifies the ID of the scan.

<STARTHIT> - Number that specifies the beginning hit in the range of hits.

<ENDHIT> - Number that specifies the ending hit in the range of hits.

For example, the following code shows a constructed set using hits 1 through 10 of a scan named SCN1 for its input features.

SET1 =FEAT/SET,RECT
THEO /2.2953,3.7467,0.95,0,0,1
ACTL /2.2953,3.7467,0.95,0,0,1
CONSTR/SET,BASIC,SCN1.HIT[1..10],,

You can use an actual expression (similar to the input code) to assign the X values of the first five features of the constructed set into an array. For example, the following code would assign just the X values of the first five hits to variable V2 and then display the values in an operator comment.

ASSIGN/V2 = SET1.HIT[1..5].X
COMMENT/OPER,YES,V2 is:
,V2

For information on using expressions to return a range of hits as an array, see the "Hit Arrays" topic in the "Using Expressions and Variables" section.


 Standard Deviation Multiple box Cutoff Wavelength box Smoothing Parameter box Polar option Cuttoff Frequency box Filter Width box Constructing a BF or BFRE Cylinder Close button Create button Clear button Remove Outliers check box Linear option Feature List box Select Last # Search ID ID

Constructing a Filter Set

Construct Filter Feature dialog box

This command allows you to construct a filter set from a scan, certain constructed features, or another filter set. This is done by selecting (or keying in) the input feature, the type of filter desired, and the parameters to be used with the filter. When you click the Create button, PC-DMIS will apply the filter routine to the data in the input feature and display a set marker along with the new ID for the set.

This command is typically used to smooth ball center data from a scan. PC-DMIS applies a lowpass Gaussian or another lowpass filter to smooth the data.

Note: If you select inappropriate feature types, PC-DMIS displays an error message saying it cannot construct the feature.

To construct a Filter Set:

  1. Access the Construct Filter Feature dialog box (Insert | Feature | Constructed | Filter). Display Menu Roadmap

  2. Select an input for the filter set.

  3. Select either the Polar or Linear option to smooth circle or linear data, respectively.

  4. Select the type of filter from the Filter Type list.

  5. Type in values for any of the filter parameters.

  6. If you want to remove outliers before filtering, select the Outlier Removal check box and the Standard Deviation Multiple check box.

  7. Click the Create button.

The Edit window command line for this option would read:
CONSTR/SET/FILTER,TOG1,TOG2,feat_1,
VAL1,VAL2,OUTLIER_REMOVAL/TOG3,VAL3

For example:

CONSTR/SET,FILTER,GAUSSIAN,POLAR,SCN1,
WIDTH=3,UPR =50,OUTLIER_REMOVAL/ON,3

TOG1 = Gaussian / Spline / Uniform / Triangle / Cylindrical

TOG2 = Polar / Linear

Feat_1 = This is the input feature for this filter.

VAL1 = Filter width.

VAL2 = Cutoff frequency in undulations per revolution (UPR).

TOG3 = This value switches between ON or OFF. It determines if outliers should be removed before filtering.

VAL3 = Standard deviation multiplier. If TOG3 is ON then all the points in the input that have more than this number of standard deviations from the least squares substitute feature (for example, circle, or line) will be removed before filtering.

The options supplied in this dialog box are discussed below.

More:

Linear option

Polar option

Filter Type list

Filter Width box

Cutoff Wavelength box

Cutoff Frequency box

Smoothing Parameter box

Remove Outliers check box

Standard Deviation Multiple box


Linear option

The Linear option allows you to filter the data in a feature that is not a circular scan. The deviations affected in this case are perpendicular to the workplane.

Note: For the linear filters, the number of points in the filter set may be less than the number of input points. PC-DMIS removes points at both ends for which not enough data (to the left or right) is available. To compute a valid output point, see the "Filter Width box".


Polar option

The Polar option allows you to apply a filter to data in a circular scan. PC-DMIS assumes that the data is periodic (meaning it forms one complete, closed circle). The deviations affected in this case are radial deviations.


Filter Type list

The Filter Type list allows you to select from the following filter types:

  • GAUSSIAN

  • SPLINE

  • UNIFORM

  • TRIANGLE

  • CYLINDRICAL.

If you select GAUSSIAN, UNIFORM, or TRIANGLE then the workplane is critical. For these three filter types, the following applies:

If you select the Linear option, the filtering occurs normal (i.e., perpendicular) to the workplane.

If you select Polar option then the filtering occurs in a radial direction within the workplane.

More:

Gaussian

Spline

Uniform

Triangle

Cylindrical


Gaussian

The Gaussian filter option is the most widely used filter option.

The Gaussian filter option allows you to smooth the data by applying a Linear or Polar Gaussian lowpass filter to it according to the ISO 11562 standard. The amount of smoothing is controlled by the Cutoff Wavelength, the Cutoff Frequency, or the Filter Width values.

For the polar Gaussian filter, the data should be a complete circle scan, with radial deviations. A partial circle scan will not work correctly with this filter. The appropriate filter for a partial circle scan is the cylindrical filter.

For the linear Gaussian filter, the data should nominally lie in a plane with the deviations perpendicular to the plane. For this filter, the cutoff wavelength is in units of length. The following paragraphs describe how a linear Gauss filter functions:

  • It estimates the point spacing delta as the average distance between the X,Y coordinates of the 3D points. These should be evenly spaced and coplanar. It will smooth the Z coordinates.

  • If the smoothing parameter is
    m = filter width     (i.e., the smoothed value is at the center of 2m+1 points used in a weighted average, starting at point m), then the cutoff wavelength lambda is computed as:

lambda = m * delta / const,(where const is a numerical constant.)

  • If the input parameter is lambda = cutoff wavelength, then the filter width m is computed as:

m = lambda * const / delta (actually, the next higher integer value).

So, the cutoff wavelength has the same units as the point spacing, but the filter width is a pure number.


Spline

The Spline filter option allows you to smooth the data by fitting a smoothing spline to it. The Smoothing Parameter value controls the amount of smoothing. However, if you want to use the "optimal" value computed by Generalized Cross-Validation (GCV) technique, you should set this value to 0. The Spline filter option is a 3D filtering option—deviations in all directions perpendicular to the line are affected.

How It Works: The spline filter fits a spline approximation to the data and resamples it. This way, it smoothes the data in all directions, not just radially or perpendicularly to the workplane. The fitted spline is a natural smoothing spline. It has a parameter that mediates between interpolating the data—trying to pass through every data point, which would retain all of the oscillations—and approximating the data with a successively smoother spline, in the sense that the oscillations are damped. The two limits of the smoothing parameter yield an interpolator (with all of the original oscillations) and a straight line. A zero value for the spline filter results in a spline that (asymptotically) minimizes the expected mean square error between it and the underlying, unknown, curve. You should usually use the zero value since this removes the noise yet leaves the underlying shape reasonably intact.

Math Information: Since the range of interest for the actual (internal) smoothing parameter lambda usually involves small values, the Construct Filter Feature dialog box accepts

-log10(lambda).

So, instead of 1-e-6, you just type 6. You get more smoothing for smaller values of the smoothing parameter. For example, a value of 5 for the spline filter would give you more smoothing than a value of 6.


Uniform

The Uniform filter option filters the data by averaging all the points in a moving window. The width of the window can be specified by either the Smoothing Parameter or the Filter Width values.

If the Filter Width value is m, then the window is 2m * delta wide, where delta is the point spacing.


Triangle

The Triangle filter option filters the data by a weighted moving average of all the points in a moving window. The weights are determined by a triangle function with the peak in the middle of the window. The width of the window can be specified by either the Smoothing Parameter or the Filter Width values.

If the Filter Width is m then the window is 2m·* delta wide, where delta is the point spacing.


Cylindrical

The Cylindrical filter option filters data in a spiral scan or a circular scan that spans more or less than a full circle. The deviations in this case are radial. As PC-DMIS does not consider the data to be periodic (meaning it does not form a complete, closed circle), a number of points equal to the filter width at the beginning and at the end of the scan will be absent from the filter set.


Filter Width box

The Filter Width value is an optional smoothing parameter for all of the filter types except the Spline filter. The value in this box determines the number of data points used for filtering to the right and to the left of each smoothed data point. For example, if the Filter Width value is m then the window is 2m * delta wide, where delta is the point spacing. The default value for this parameter is 3.

The value you type can be zero or any positive value.

  • If there's no value at all (or if the value is zero), either the Cutoff Frequency or the Cutoff Wavelength value will be used to set the amount of smoothing.

  • If either the Cutoff Frequency or the Cutoff Wavelength value is any non-zero, positive value, then the filter width corresponding to the cutoff frequency entered is displayed.

  • If the Filter Width and the Cutoff Frequency or Cutoff Wavelength don't have values (or are zero), PC-DMIS will not filter the data.

The Filter Width value also determines how many points will be absent from the filter set when doing linear filtering. PC-DMIS removes those points that don't have enough data to the right or left to fill up the data window.

Note: A lowpass filter, one that filters out high frequency noise but transmits the lower frequency form and waviness, works by replacing the value at a data point by a weighted average of the values at a sequence of its neighbors. For the Gauss filter, for instance, the Filter Width specifies how many points to the left and right of a point are included in the weighted average. The weights (which are positive and add up to 1) are values of a Gaussian distribution function (also known as a Bell Curve). If the Filter Width is equal to m, then the smoothed point is at the center of 2m+1 points used in the weighted average. If the data is periodic, then the points wrap around and there are always enough points to the left and right of a point to compute this average. This is the case for a Polar filter. But for a Linear filter, the first and last m points do not have enough neighbors to compute the full weighted average, so these points are left out of the filtered dataset.


Cutoff Wavelength box

The Cutoff Wavelength value determines the wavelength of the oscillations in the data below which the amplitudes of the oscillations will be reduced when applying a linear Gaussian filter.


Cutoff Frequency box

The Cutoff Frequency value determines the number of "undulations per revolution" (or UPR) in the circle data above which the amplitudes of the oscillations in the data will be reduced when applying a polar Gaussian filter or a cylindrical filter.


Smoothing Parameter box

The Smoothing Parameter value determines the degree of smoothing applied to the data for the spline, uniform, and triangle filters.

For the spline filter, it is best to set this value to 0 to indicate that the value computed via GCV should be used. The computed value then replaces the 0 in the edit window.

For uniform and triangle filters, the smoothing parameter represents one half of the width of the window used in the (weighted) moving average.


Remove Outliers check box

If you select the Remove Outliers check box, PC-DMIS attempts to remove all points a given number of standard deviations from the substitute feature (usually a circle or a line). You specify the number of standard deviations in the Standard Deviation Multiple box. See the "Standard Deviation Multiple box".

Outlier removal behaves similar to filtering:

If you select the Linear option, outlier removal is based on the 3d distance from the point in question to the line (best fit line through the data).

If you select the Polar option, outlier removal occurs in the radial direction (parallel to the workplane).


Standard Deviation Multiple box

The Standard Deviation Multiple value determines the number of standard deviations from the substitute (least squares) feature beyond which points are identified as outliers. The default value is 3.


Constructing an Adjusted Filter

The Adjust Filter construction type lets you adjust scan data that was gathered while scanning around these standard geometric features:

  • Sphere

  • Cone

  • Cylinder

Generally, you will perform these scans using an analog probe, such as an SP600. If you imagine a scan around the top quarter of a sphere, for example, you would ideally get points that lie within a plane that cuts through the sphere, like this:

A - Scan Path

However, in reality, as the probe scans around the sphere it is physically impossible for all the points to remain inside the cut plane due to a natural rise and fall floating motion of the CMM.

The Adjust Filter construction can take the pre-existing scanned points and, using the known mathematical properties of the feature, can better compensate the points gathered during the measurement process, adjusting them to lie more within the cut plane. You use the Adjust Filter dialog box to do this. To access this dialog box, select Insert | Feature | Constructed | Adjust Filter from the menu bar.

Adjust Filter dialog box

Adjust Filter dialog box

Dialog Box Item | Description
Feature Type | This defines the primitive (simple geometric feature) being scanned. You can only select Sphere, Cone, or Cylinder.
Filter Type | This defines the type of filter to use. You can select Axial or Radial (used for Cone and Cylinder feature).
Feature Info | This lets you define the information about the feature. XYZ – The feature's nominal position. IJK – The feature's normal vector. Radius/Angle – This sets the Radius of the Sphere or Cylinder or the angle of the Cone.
Cut Plane Info | This area defines the location and vector of the cut plane. XYZ – Location of the cut plane IJK – Vector of the cut plane

To Adjust Scan Data:

To correctly adjust the data in the scan, you need to give enough information to mathematically define the feature.

  1. Select the actual sphere, cone, or cylinder feature from the list of features in the Adjust Filter dialog box.

  2. Select a pre-existing scan feature from the list. Generally your scanned feature will be a pre-existing linear closed scan. The scan must be of a sphere, cone, or cylinder.

  3. Choose the feature type you scanned with the selected scan from the Feature Type list.

  4. From the Filter Type list, choose the correct filter type for a Cone or Cylinder feature. The filter indicates how to compensate the data.

    • If you are scanning perpendicular to the axis of the Cylinder or Cone, choose the Radial filter. This defines the circle that will be used to adjust the points.

    • If you are scanning parallel to the feature's axis, choose the Axial filter. This defines a line that will be used to adjust the points.

  5. Define the feature's nominal XYZ location by typing the values in the XYZ boxes.

  6. Define the feature's normal vector by typing the values in the IJK boxes.

  7. Define the feature's size by typing a value in the Radius or Angle box.

  8. In the Cut Plane Info area, define the scan's cut plane. Once you specify all the nominal information for the scanned feature, you can create the construction.

  9. Click Create. All the points are projected into the cut plane along the features theoretical definition (taking into account the known geometry) rather than a straight projection along the features normal vector.


Creating Generic Features

Creating Generic Features: Introduction

Generic Feature Command Format

Creating a Generic Feature

Creating a ReadPoint from the Probe's Position


Creating Generic Features: Introduction

This section covers the ability to add generic features into you part program and the ability to create point features at the probe's current position.

Generic features are often used to control the measured and theoretical values of a specific feature in order to perform calculations that PC-DMIS's constructed features don't currently support. For example, suppose you want to create the shortest line between two lines (3D) that don't intersect. PC-DMIS doesn't have that construction option. However, you can do the math yourself using the PC-DMIS Expression language and then assign the theoretical and measured values of a generic line to the appropriate values. In this way, you can create your own construction.

This section contains these major topics:

  • Generic Feature Command Format

  • Creating a Generic Feature

  • Creating a ReadPoint from the Probe's Position


Description of Generic Features

Usually when measuring features on your part, PC-DMIS guesses the correct feature type dependent on the number of hits taken and the inherent feature type available on the imported CAD model itself.

Generic features are not guessed by PC-DMIS, but are inserted and created by the user.


Purpose of Generic Features

Generic features are used to hold and transform values. These values can be used to create new constructed features or modify existing features via the CALCULATION command.

For information on creating new constructed features see the "Constructing New Features from Existing Features" section.


Generic Feature Command Format

All generic features have XYZ and IJK values, and may have ANGLE, DIAMETER /RADIUS or DISTANCE values depending on the type assigned to the feature.

The Nominal / Measured Values toggle button indicates the values that will be used in the generic feature.

Command line in the Edit window (a cone is shown):

feature_name=GENERIC/TOG1,TOG2, TOG3, TOG4
NOM/XYZ,x_cord,y_cord,z_cord
MEAS/XYZ,x_cord,y_cord,z_cord
NOM/IJK,i_cord,j_cord,k_cord
MEAS/IJK,i_cord,j_cord,k_cord
[RADIUS/radius] | [DIAMETER/diameter]
[ANGLE/ang]
[DISTANCE/dist]

TOG1 = POINT, PLANE, LINE, CIRCLE, SPHERE, CYLINDER, CONE, SLOT or NONE

TOG2 = indicates whether the generic feature is alignment dependent, or independent.

TOG3 = indicates whether the feature uses Polar or Rectangular coordinates

TOG4 = indicates whether the feature is an IN (hole) or OUT (stud) feature.

[ ] = options shown in brackets are discretionary and are available based on the type assigned to the feature by TOG1. RADIUS and DIAMETER are mutually exclusive representations for the value represented as the radius or the diameter.


Creating a Generic Feature

While it's entirely possible to create a generic feature by typing the word GENERIC and pressing TAB in the Edit window's Command mode, PC-DMIS provides a much easier way to create new generic features. The Construct Generic Feature dialog box (Insert | Feature | Generic) provides a much more intuitive way to create new generic features. Display Menu Roadmap

More:

To Add a Generic Feature

Description of the Construct Generic Feature Dialog Box


To Add a Generic Feature

To add a Generic Feature:

  1. Place your cursor in a new line of the Edit window.

  2. Access the Construct Generic Feature dialog box by one of the following:

  • Select the Insert | Feature | Generic menu item. Display Menu Roadmap

  • Type GENERIC in the Command mode of the Edit window.

  • Select Generic Feature from the list that appears in Summary mode after selecting Add Command.

  3. Make the changes you desire.

  4. Click the OK button to create the feature. PC-DMIS will save the generic feature and update the information for the feature in the Edit window and the Graphics Display window.


Description of the Construct Generic Feature Dialog Box

Construct Generic Feature dialog box

Use this dialog box to create new features. You can access this dialog box by selecting the Insert | Feature | Generic menu option. The following topics describe the options available on this dialog box. Display Menu Roadmap

More:

Feature Type

Data Type

XYZ Boxes

IJK Boxes

Alignment Dependent Generic Feature

Alignment Independent Generic Feature

Polar/Rect

Feature Name

Radius / Diameter

Angle

Distance


Feature Type

This area allows you to create these generic feature types:

  • Point

  • Plane

  • Line

  • Circle

  • Sphere

  • Cylinder

  • Round Slot

  • Square Slot

  • Cone

  • None

Depending on the type of feature selected other areas of this dialog box are disabled or enabled for selection.


Data Type

The Data Type area allows you to determine what values of the generic feature are affected by the changes made in the dialog box. The choices include Measured Values or the Nominal Values.


XYZ Boxes

The X, Y, and Z boxes allow you to determine the X, Y, and Z position for the generic feature.


IJK Boxes

The I, J, and K boxes allow you to determine the vector for the generic feature.


Alignment Dependent Generic Feature

Alignment dependent generic features have values dependent upon the alignment from which they are referenced. They change so that they are always relative to the current alignment. Their location is constant in 3D space.

Example in 2D: Suppose 0,0 is your machine origin. An alignment is set up that locates the origin at 5,5. Now, an alignment dependent feature is defined after the alignment with the values of 2 for x and 2 for y. Relative to the alignment, its values are 2 and 2. Relative to the origin, its values are 7 and 7. No matter what alignment the numbers are given relative to, the point will always be located at 7,7 relative to the true origin.


Alignment Independent Generic Feature

Independent generic features have values that remain the same regardless of which alignment they are referenced from (therefore considered "independent"). Their location in 3D space changes as the alignment changes.

Example in 2D: Next, consider the same example of 2,2 (as shown in the Alignment Dependent example) but this time with an alignment independent generic feature. If you ask for the x and y values relative to the alignment, the object will report 2,2. If you ask for its values relative to the origin, the object will still report 2,2. The set 2,2 relative to the alignment is located at 7,7 relative to the true origin. The set 2,2 relative to the origin is exactly that: 2,2. Thus, the point appears to move in 2D space.

Note: The independent option was added so that a generic feature named XAXIS, for example, could always be used as an input feature to a construction or a datum to a dimension and it would always have the values of 1,0,0 independent of the current alignment.


Polar/Rect

This list allows you to pick what type of coordinate system is used in the generic feature. You can select either POLAR or RECT.


Feature Name

This box allows you to name your feature. This is the ID that appears on the Feature ID label and inside the Edit window.


Radius / Diameter

This allows you to define either a radius or a diameter for a circular feature. Select either the Radius option or the Diameter option, and then type a value in the box provided.


Angle

The Angle box allows you to define the angle of a Cone. This box also becomes available if you selected None from the Feature Type area.


Distance

The Distance box allows you to define the height or length of any generic features that have a length or height.


Creating a ReadPoint from the Probe's Position

Display Menu Roadmap

The ReadPoint menu option tells PC-DMIS to read the probe's current position and to insert a point in the Edit window at the read in position.

The following syntax illustrates what's inserted into the Edit window.

F_ID= FEAT/ POINT, TOG1

THEO / x, y, z, i, j, k

ACTL / x, y, z, i, j, k

READPOINT

F_ID - This is the Feature ID.

TOG1 - This toggle field that allows you to switch between the POLR and RECT coordinate systems.

X, Y, Z - This is the X, Y, Z location for the constructed point.

I, J, K - This is the I, J, K approach vector of the probe.

READPOINT - Identifies this feature as a readpoint created from the probe's position.

Below is an example of a ReadPoint feature:

F7         =FEAT/POINT,RECT
            THEO/7.4982,2.0111,0.95,0,0,1
            ACTL/7.4982,2.0111,0.95,0,0,1
            READPOINT/


Creating and Using Alignments

Creating and Using Alignments: Introduction

Alignment Command Format

Description of the Alignment Utilities Dialog Box

Creating a 3-2-1 Alignment

Creating a Best Fit Alignment

Creating an Iterative Alignment

Saving an Alignment

Recalling an Existing Alignment

Using an Alignment Inside Loops

Equating an Alignment

Equating CAD to Measured Part Data

Performing a Leapfrog Operation

Changing Alignment Nominal Values

Creating a Bundle Alignment


Creating and Using Alignments: Introduction

Once a tip has been activated and features measured, a coordinate system (or alignment) can be created. PC-DMIS provides you with a variety of tools for creating and managing coordinate systems. To access the tools that allow you to work with alignments, select the desired menu options available from the Insert | Alignment submenu. Display Menu Roadmap

The major topics discussed in this section describe how to use these tools to effectively create and manage alignments in your part program . These topics include:

  • Alignment Overview

  • Alignment Command Format

  • Description of the Alignment Utilities Dialog Box

  • Creating a 3-2-1 Alignment

  • Creating a Best Fit Alignment

  • Creating an Iterative Alignment

  • Saving an Alignment

  • Recalling an Existing Alignment

  • Using an Alignment inside Loops

  • Equating an Alignment

  • Equating CAD to Measured Part Data

  • Performing a LeapFrog Operation

  • Changing Alignment Nominal Values

  • Creating a Bundle Alignment


Alignment Overview

An alignment allows you to define your part's location and orientation in 3D space. It allows your measuring machine to know where the part is located. A part without any alignment has six degrees of freedom:

  • Three degrees of rotation (about the X, Y, and Z axes).

  • Three degrees of translation (origin in X, Y, and Z axes).

A Datum Reference Frame (DRF) constrains the six degrees of freedom, fixing the part in 3D space.

A part alignment represents the DRF specified on the drawing. The primary, secondary, and tertiary datums define the DRF and identify the features to be measured and used to create the alignment.

  • The three degrees of rotation are constrained by the I, J, K vector(s) of the datum feature(s).

  • The three degrees of translation are constrained by the X,Y,Z location(s) of the datum feature(s).

Alignment Command | Definition | Notes
LEVEL | Constrains two degrees of rotation such that the leveled axis matches the vector of the selected feature. | This will always be the primary datum and must be a 3D feature with a vector. Typical Features: Plane, Cylinder, Cone or a constructed 3D feature.
ROTATE | Constrains one degree of rotation about the leveled axis such that the rotated axis matches the vector of the selected feature. | This will always be the secondary or tertiary datum and must be a 2D or 3D feature with a vector. Typical Features: Plane, Line, Cylinder, Cone or a constructed 2D/3D feature. You can also select any two-point type features to simulate a line that can be used to Rotate. For Example: two points, two circles, two spheres, or a combination thereof. The direction of the simulated line is based on the order of the selected features.
ORIGIN | Constrains three degrees of translation (origin) in X, Y and Z-axis. | This sets the origin on primary, secondary, and tertiary datums or as per drawing requirements. Typical Features: Any feature.

Alignment Tips:

  • LEVEL first, ROTATE second, and then set the ORIGIN for the X, Y, and Z axes. Never Rotate before Leveling!

  • Always LEVEL before measuring 2D features (lines and circles).

  • Always LEVEL and ROTATE before measuring points (measured point in X, Y or Z-axis)

  • There is no limit on the number of alignments saved in a program.

  • An alignment can be saved to a file using the SAVE ALIGNMENT command. This is typically done to create a fully automated program dependent on a holding fixture for the part.

For Example:

    1. Create a program that establishes an alignment on a fixture, and then save the alignment to a file.

    2. Create a part program, RECALL the alignment file at the beginning of program and set the program to run in DCC mode before measuring the first feature.

    3. During part program execution, the CMM pauses, prompts the operator to load part, then automatically measures the part (no manual alignment).

  • Right Hand Rule of Rotation - Point your right hand's thumb in the positive direction of the axis you are rotating about (+X, +Y, or +Z). The direction your hand naturally curls is the positive rotation about that axis. Negative rotation is the opposite direction.


Alignment Command Format

All alignments are displayed in the following format in the Edit window's command mode. There will be slight variations that are explained more thoroughly in the following sections.

For example;

A1=ALIGNMENT/START, RECALL:,LIST=YES/NO
ALIGNMENT/LEVEL,'feature_name'
ALIGNMENT/ROTATE,XPLUS,TO,feat_name,ABOUT,ZPLUS
ALIGNMENT/TRANS,XAXIS,feature_name
ALIGNMENT/TRANS,YAXIS,feature_name
ALIGNMENT/TRANS,ZAXIS,feature_name
ALIGNMENT/END

See "Conventions" for field rules.

Descriptions of the alignment commands are available at these locations:

  • For the Start command, see "Start Alignment Command".

  • For the End command, see "End Alignment Command".

  • For the Recall command, see "Recall".

  • For the Level command, see "Level".

  • For the Rotate command, see "Rotate".

  • For the Translate command, see "Origin".

More:

Start Alignment Command

End Alignment Command

Adding Lines

Deleting Lines

Conventions


Start Alignment Command

The line that starts the alignment is:

ALIGN_ID=ALIGNMENT/START,RECALL:ID, LIST=YES/NO

Changeable fields:
"Align_ID"
This is the ID the alignment will be stored as. The ID is assigned by the operator. A default name will be assigned if an ID is not specified. Example: A1.

"ID"
ID is a previous internal alignment that will be recalled to start a new alignment. Note that in version 3.6 and above you can also use the USE_ACTIVE_ALIGNMENT keyword in this field to cause PC-DMIS to use the active alignment instead of recalling a stored alignment. This is useful when using alignments with looping and conditional branching. See the "Using an Alignment Inside Loops" topic.

"LIST"
Setting this field to YES or NO lets you determine whether or not PC-DMIS should display the alignment ID in the Alignments list on the Settings toolbar for later insertion in the part program. The default setting is YES. Setting this field to NO is useful if you have a lot of temporary alignments and you don't want them all listed in the Alignments list on the Settings toolbar (see "Active Alignment List").


End Alignment Command

The Edit window command line for this option reads:
ALIGNMENT/END

There are no changeable fields in this command. This command must be used whenever the ALIGNMENT/START command has been used.


Adding Lines

To add a line, place the cursor in the desired location and press the ENTER key. Begin by typing the word ALIGNMENT. Press the TAB key. PC-DMIS adds the new line depending on where the cursor is located. If the cursor is in the middle of a command, a new line is created below the current line. If the cursor is placed at the beginning of a command line, PC-DMIS will place the new line above the current cursor position.

The first new line that is created will always display the minor command: LEVEL. Entering a new command can easily change this. Additional lines created after the initial line will display the most recent command.


Deleting Lines

To delete a blank line, press the DOWN ARROW or ENTER key. The line may also be highlighted and deleted. (See "Command Mode Keyboard Functions" in the "Using the Edit Window" section.)


Conventions

  • All alignment text commands are in a macro type format with a start and end command.

  • The ALIGNMENT/START command is always the first line and the ALIGNMENT/END command is the last line of the alignment statement.

  • All alignment functions must be inside the start and end commands. The one exception is the "ALIGNMENT/RECALL" command, in which the start and end commands are executed as one.

  • In each of the commands (except "Start," "End" and "Recall") the second field allows you to change from one choice to another. All of the other operator dependent fields will then change to represent the field that is currently active.


 Search ID Select Last # Feature List box Clear button OK button Cancel button ID Recall button Delete button Iterative button Best Fit button Active Alignment List Level button Drop Down Axes Rotate button Rotate by an Offset Origin Offset check boxes Set Origin Offset Distance Origin button Auto Align button CAD Equals Part button

Description of the Alignment Utilities Dialog Box

Alignment Utilities dialog box

If you are creating a new part program, the dialog box will display the STARTUP command the first time the Alignment Utilities dialog box is opened (Insert | Alignment | New). Display Menu Roadmap

If the cursor is located in the last line of the Edit window, the alignment ID will display a new identification and the current alignment.

For example, in Command mode, the Edit window reads:

Alignment ID=A5
Recall Alignment ID=A4

You also have the option of recalling any available alignment listed in the Recall drop-down box. Only alignments created prior to the current cursor’s position will be available.

The Edit window command line for this option reads:

ALIGNMENT/START
ALIGNMENT/BF2D,'feat_id'
ALIGNMENT/END

Note: An alignment is not considered completed until the OK button is selected and PC-DMIS updates the Active Alignment List box.

Once the alignment procedure is complete, PC-DMIS will indicate the rotation of the alignment in the left corner of the Graphics Display window. As the graphical image of the part is scaled to fit the screen, the alignment offset becomes accurate (once the axes reference leaves the corner of the window).

If any of your axes are not constrained on your created alignment, PC-DMIS will warn you by causing the red XY and Z origin symbol (or trihedron) to continually move between those axes on the Graphics Display window. Once the alignment is completely constrained, PC-DMIS displays the trihedron in a fixed location to represent the alignment position:

Alignment Trihedron

More:

Accessing the Dialog Box

Alignment ID

Active Alignment List

Drop Down Axes

Level

Rotate

Set Origin Offset Distance

Origin

Recall

Iterative

Best Fit

Auto Align

CAD Equals Part


Accessing the Dialog Box

PC-DMIS allows you to access the Alignment dialog box from within the Edit window. To do this:

  1. Open the Edit window (View | Edit Window). Display Menu Roadmap

  2. In the Edit window navigate to the Alignment block.

  3. Place your cursor on the first line.

  4. Press the shortcut key F9. The dialog box associated with the alignment block will appear.

The dialog box will display the current feature's alignment, allowing you to make changes.


Alignment ID

This box displays the ID for the current alignment.

To change this value:

  1. Highlight the previous value.

  2. Type in a new ID.

  3. Press the TAB key.


Active Alignment List

During alignment creation or anytime you wish to view or edit an alignment, this list box displays the various components making up the current alignment, such as the alignment's ID, any recall alignments used, the type of alignment, and the features used by the alignment's axes to perform its rotation and translation.

Editing an Alignment

While you can edit any alignment already created inside the Summary or Command modes of the Edit window, you can also edit an existing alignment by clicking on an element in this list and making the needed change. Once you select an item, the appropriate area of the Alignment Utilities dialog box becomes available to edit. After making your change, click OK to modify the alignment.

For example, if you wanted to modify the feature to which the alignment was leveled, you would select the "leveled to" line from the list. As shown in the following figure, PC-DMIS would display the current feature used for the leveling portion of the alignment, and then it would make the Level button and list of axes available.

Example of the Active Aligment list used to edit an existing aligment

Example of the Active Alignment list used to edit an existing alignment

Simply select the new feature, and axis, click Level, and PC-DMIS updates the Active Alignment list to reflect your change. Then click OK to save the change.


Drop Down Axes

These drop-down lists, allow you to select axes that are used in the different stages of creating a new alignment. The available axes for each drop down list are:

  • XPLUS

  • XMINUS

  • YPLUS

  • YMINUS

  • ZPLUS

  • ZMINUS


Level

The Level button allows you to establish the orientation of the normal axis of the current working plane.

To choose a feature to "level" to:

  1. Specify the feature to be used from the Feature List box.

  2. Click the Level option.

You may also specify the axis to be used in establishing the orientation by selecting it from the drop-down list.

The Edit window command line for this option reads:
ALIGNMENT/LEVEL,ZPLUS,'feat_id'

Changeable fields:
"ZPLUS"
This is a field that allows you to switch between the fields ZPLUS, XPLUS, YPLUS, ZMINUS, XMINUS, and YMINUS in the Edit window. This field represents the direction of the specified axis that the feature is leveled to.

"feat_id"
The alignment levels to the specified feature.
Example: PLANE1.


Rotate

The Rotate button allows you to rotate the defined axis of the work plane to the feature or parallel to the feature. PC-DMIS rotates the defined axis around the centroid used as the origin. You can define which axis to rotate and which axis to rotate around.

To choose a feature to rotate to:

  1. Select the proper reference feature from the Feature List box.

  2. Click the Rotate button.

The Edit window command line for this option reads:
ALIGNMENT/ROTATE,XPLUS,to,'feat_id',about,ZPLUS

Changeable fields:
"XPLUS","ZPLUS"
This is a toggle field that allows you to toggle between these fields in the Edit window:

ZPLUS

XPLUS

YPLUS

ZMINUS

XMINUS

YMINUS

PC-DMIS will set this axis parallel to the specified input feature. It will then rotate about the second axis.

"feat_id"
The alignment rotates parallel to the specified feature. Example: LINE1.

More:

Rotate by an Offset

Rotate to a Line between Two Circles


Rotate by an Offset

To rotate by an offset, select the OFFSET option by typing the desired angle in the Offset Angle box. The new value will replace the old rotation offset.

The Edit window command line for this option reads:
ALIGNMENT/ROTATE_OFFSET,'numeric_value'

Changeable field: "numeric_value"
This is the value the alignment will be rotated by in degrees of angle (for example; -14.36). The rotation will be about the axis, perpendicular to the active work plane. The rotation will be clockwise if the angle is negative and counter clockwise if the angle is positive.


Rotate to a Line between Two Circles

To rotate to the line between two circles, select two circles in the Feature List box and click the Rotate button. As in the other type of rotate, select the axis to rotate, the axis to rotate around, and enter the offset value (if desired).

The Edit window command line for this option reads:
ALIGNMENT/ROTATE_CIRCLE,ID, ID

Changeable fields: "ID"

This is one of the two ids to which to rotate.


Set Origin Offset Distance

The Offset Distance box allows you to set the origin by a specific offset distance.

To use the Set Origin Offset:

  1. Click in the Offset Distance box.

  2. Type a desired value for the offset distance.

  3. Press the TAB key.

  4. Click the Set Origin button.


Origin

The Origin button allows you to move the part origin to a specific location or by a specific offset.

To move the part origin:

  1. Choose the origin that is to be moved by selecting the appropriate check box (X, Y, Z, or AUTO).

  2. Click the Origin button. AUTO will choose the axes to move based on the feature type, the orientation of that feature, and the workplane.

More:

Move to a Feature

Move by an Offset


Move to a Feature

To move to a feature, simply select the feature.

The Edit window command line for this option reads:
ALIGNMENT/TRANS,ZAXIS,'feat_id'

Changeable fields:
"ZAXIS"
This is Edit window field allows you to switch between the fields ZAXIS, XAXIS, and YAXIS. This field represents the axis that the origin will be moved along to match the input 'feat_id'.

"feat_id"
This is the feature the alignment will set the origin to, along the given axis. Example: CIRCLE1.


Move by an Offset

To move by an offset, select the OFFSET option by entering a new offset value.

The Edit window command line for this option reads:
ALIGNMENT/TRANS_OFFSET,ZAXIS,'numeric_value'

Changeable fields:
"ZAXIS"
This Edit window field allows you to toggle between the fields ZAXIS, XAXIS, and YAXIS. These fields represent the axis that the origin will move along by the input 'numeric_value'.

"numeric_value"
This is the value the alignment will be offset by (for example: 5.12). The positive value moves in the positive direction, and the negative value moves in the negative direction.


Recall

The Recall button recalls saved alignments and uses them in your current part program . See the "Recalling an Existing Alignment".


Iterative

The Iterative button accesses the Iterative Alignment dialog box. Use this dialog box to create Iterative alignments. See the "Creating an Iterative Alignment".


Best Fit

The Best Fit button accesses the Best Fit dialog box. Use this dialog box to create Best Fit alignments. See the "Creating a Best Fit Alignment".


Auto Align

The Auto Align button allows you to select three features from which PC-DMIS will automatically create an alignment. The order in which the three features are selected is extremely important.

  • The first of the three features will be used to establish the orientation of the normal axis to the current working plane.

  • The current working plane will then be rotated to the second feature.

  • Lastly, the part origin will be set according to the third feature type.

For example, if you select a:

Plane, Line and a Point with a ZPLUS workplane:
The plane will establish the ZPLUS orientation of the part. The measured line becomes the XPLUS major axis. The origin is set with the Z zero equal to that of the plane. The Y is equal to that of the line and the X is equal to that of the point.

Plane, Line and a Measured Circle with a YMINUS workplane:
The plane will establish the YMINUS orientation of the part. The measured line becomes the ZMINUS major axis. The origin is set with the Y zero equal to that of the plane. The X and Z zeros (origins) are equal to the center of the circle.

If PC-DMIS is unable to create a new alignment based on the three selected features, a pop-window will appear with an error message.

Important: In an Auto Alignment the origin of the alignment is based on the third feature used.

¨ If it's a point, PC-DMIS sets the axes origin. If not, PC-DMIS checks the feature's default axes.

¨ If it's an Auto Line, PC-DMIS returns X, Y, and Z and sets the origin on the X, Y, and Z.

¨ If it's a Measured Line, PC-DMIS determines which axis the approach vector most closely follows and then zeros out the other two axes.

¨ If it's an Auto Circle, PC-DMIS sets all three axes.

¨ If it's a Measured Circle, PC-DMIS looks at the workplane and only sets two axes.


CAD Equals Part

The Cad Equals Part button is helpful when using CAD data on-line.

To set the CAD equal to the part:

  1. Measure features on the part or fixture.

  2. Use the alignment options (LEVEL, ROTATE and SET ORIGIN) to create an alignment.

  3. Select the Cad Equals Part button.

PC-DMIS will create a bridge between the CAD data and the measured data. This allows the measured data to be displayed on top of the CAD data. It also uses the CAD data to help inspect the part. This option is only available after a created alignment places the part origin/orientation at the same location as the CAD origin/orientation.

After the Cad Equals Part button is selected for a part, the CAD Equals Part menu item will be selected.


Creating a 3-2-1 Alignment

The information presented here describes the steps you'll need to take to create a standard 3-2-1 alignment.

Hint: Click this icon from the Wizards toolbar [image] to access PC-DMIS's 3-2-1 Alignment Wizard.

More:

Step 1: Measure the Alignment Features

Step 2: Level, Rotate, and Translate to the Features

Step 3: Completing the Alignment


Step 1: Measure the Alignment Features

The first thing you will need to do is measure the features used to create the 3-2-1 alignment. A 3-2-1 alignment uses three standard feature types for its creation. The numbers 3, 2, and 1 refer to the minimum number of hits you need to take on in order to measure these features.

  • Measure a Plane. The first feature is the leveling feature and should be a plane composed of three hits. PC-DMIS will level the part to this feature. This defines the origin and direction of the first axis (usually the Z axis).

  • Measure a Line. The second feature is the rotation feature and should be a line composed of two hits. PC-DMIS will rotate the part to this feature, orienting the second axis. The second hit of this feature should be in the positive direction of the axis, relative to your first hit. This feature defines the direction of the second axis (usually the X axis) and the origin of the third axis (usually the Y axis).

  • Measure a Point. The third and final feature is the origin feature composed of just one hit. Since PC-DMIS creates the origin for this axis from your first two features, the third point merely establishes the origin of the entire alignment. PC-DMIS will translate the part to this feature, making it the X=0, Y=0, and Z=0 location.

Once you've measured the necessary features, you're ready to create your alignment.

Go to the next step.


Step 2: Level, Rotate, and Translate to the Features

This step uses the Alignment Utilities dialog box to level, rotate, and translate your part to the features measured in the previous step.

At any time, click here to see the documentation about the Alignment Utilities dialog box.

  1. Display Menu Roadmap Access the Alignment Utilities dialog box (Insert | Alignment | New). Notice that the Feature list shows all the possible features that can be used to level, rotate, or translate the part.

  2. From the Feature list, click on the plane feature you created in the previous step. Once PC-DMIS selects the feature, select the axis to which PC-DMIS should level the part, and then click the Level button. PC-DMIS will display a line of text inside the Alignment Utilities dialog box informing you of the feature and axis to be used in the leveling process.

  3. From the Feature list, click on the line feature you created in the previous step. Once PC-DMIS selects the feature, select what axis to rotate to and what axis to rotate about, and then click the Rotate button. Again, PC-DMIS displays the feature and axis to be used for the rotation process.

  4. From the Feature list, click on the point feature you created in the previous step. Once PC-DMIS selects the feature, select the appropriate axis check box to determine which axis (or axes ) you want to move to this origin feature, and click the Origin button.

Note: Alternately, you can select all three of the features from the Feature list and click the Auto Align button to have PC-DMIS automatically level to the first feature selected, rotate to the second feature selected, and translate the axes to the third feature selected.

Now you're ready to complete the alignment creation process.

Go to the next step.


Step 3: Completing the Alignment

To complete the alignment:

  1. Ensure that the information in the dialog box is correct.

  2. When you're ready, click the OK button. PC-DMIS closes the dialog box. If this new alignment differs from the existing alignment, PC-DMIS will display a prompt asking if you want to update affected commands in the Edit window to use the new alignment. If the alignment doesn't change (or the change is too small to matter), PC-DMIS simply inserts the alignment without displaying the prompt or updating any commands.

  3. PC-DMIS inserts the code for the alignment into the Edit window, and graphically shows the alignment on the CAD model inside the Graphics Display window.

  4. You can edit the alignment's code at any time by using the techniques described in the "Using the Edit window" section.


 Select button Origin Rotate Search ID Select Last # Feature List box Clear button OK button Cancel button Level Measure All Once Measure All Always Max Iterations Start Label Point Target Radius Fixture Tolerance Error Label

Creating an Iterative Alignment

Iterative Alignment dialog box

In automotive terms, an Iterative Alignment will give "body" coordinates.

When the Iterative button is selected from the Alignment Utilities dialog box (Insert | Alignment | New) Display Menu Roadmap
, PC-DMIS will display the Iterative Alignment dialog box. This dialog box provides a way for you to three dimensionally "best fit " the measured data to the nominal points (or surfaces, if available). This technique requires at least three features to be measured. Certain feature types, such as points and lines, have poor three dimensional locations. If one of these types of features is selected, additional features are needed to provide accurate measured data.

  • The first set of features establishes the orientation of the normal axis of the current working plane by fitting a plane through the feature centroids. At least three features must be used in this section (LEVEL - 3 +).

  • The next set of features rotates the defined axis of the work plane to the features, fitting a line through the features. At least two features need to be used in this section (ROTATE - 2 + ).
    If no features have been marked, the alignment will use features from the LEVEL section. (The two features used from the LEVEL section are the second and third from last feature.)

  • The last set of features translates the part origin to a specific location (SET ORIGIN - 1 ).
    If no features have been marked, the alignment will use the last feature from the LEVEL section.

More:

Understanding Iterative Alignments

To Create an Iterative Alignment

Description of the Iterative Alignment Dialog Box


Understanding Iterative Alignments

To properly create your iterative alignment, first consider the information presented here; these topics will help you to understand important aspects of iterative alignments.

More:

Iterative Alignment Command Format

Iterative Alignment Rules


Iterative Alignment Command Format

The Edit window command line for this option reads:
ALIGNMENT/ITERATE,'feat_id'
, PNT TARGET RAD=n, START LABEL=label, FIXTURE TOL = n, ERROR LABEL=label
MEAS ALL FEAT=NO/ALWAYS/ONCE,
MAX ITERATIONS = n
LEVEL AXIS =axis, ROTATE AXIS=axis, ORIGIN AXIS=axis
LEVEL = id, id, id,…
ROTATE = id, id,…
ORIGIN = id,…

Changeable field: "feat_id"
These are the features that will be used to do the iterative alignment . Currently, at least three different features must be selected for the calibration. Features that can establish a datum axis in more than one direction (such as a circle or a slot) can be specified in more than one datum axis. For example, a circle could be used both to establish the level axis as well as the rotation axis. Typically, measured points (including vector and surface points) can only be used to establish one datum axis.

PNT TARGET RAD = This option specifies the target radius value for the measured point features used in the alignment. See "Point Target Radius" for complete information.

START LABEL = PC-DMIS starts at the label specified here when remeasuring alignment features. You must set MEAS ALL FEAT to ALWAYS for this to work. See "Start Label" for complete information.

FIXTURE TOL = This is the fitting tolerance that PC-DMIS uses to compare measured alignment features to their theoretical values. See "Fixture Tolerance" for complete information.

ERROR LABEL = PC-DMIS goes to the label specified here when the fixture tolerance level is exceeded. If you don't define a label, PC-DMIS will generate an error message showing the amount of error on each of the input features. See "Error Label" for complete information.

LEVEL AXIS = PC-DMIS uses the LEVEL input features to set the orientation and origin of the axis specified here. See "Level" for complete information.

ROTATE AXIS = PC-DMIS uses the ROTATE input features to set the rotation of the axis specified here about the level axis. The origin of the axis specified here is also set by PC-DMIS using the ROTATE input features. See "Rotate" for complete information.

ORIGIN AXIS = PC-DMIS uses the ORIGIN input features to set the origin of the axis specified here. See "Origin" for complete information.

MEASURE ALL FEATURES = This option determines how PC-DMIS proceeds by either re-measuring the input features or automatically re-executing a portion of the part program in DCC mode. There are three possible settings for this option. They are:

· NO. See "Point Target Radius" for complete information.

· ONCE. See "Meas All Once" for complete information.

· ALWAYS. See "Meas All Always" for complete information.

MAX ITERATIONS = This option determines the maximum number of iterations that PC-DMIS will perform for this iterative alignment. PC-DMIS only uses this value if the Meas All Always check box is selected.


Iterative Alignment Rules

There are some general rules when doing an iterative alignment :

PC-DMIS needs both the measured values and theoretical values for each of the elements in the sets. The normal vectors for the first set of elements must be approximately parallel. The one exception to this rule is if only three features are being used in the set.

If measured points (VECTOR, EDGE, or SURFACE) are being used, then all three sets of elements are needed (three features to Level, two features to Rotate, and one feature to Set Origin) to define the alignment. Any feature type can be used, but three-dimensional elements are better defined elements and therefore improve the accuracy. Some of the possible 3D elements are sheet metal circle, slot, cylinder, sphere, or a corner point.

Note: The sheet metal circle, slot, and cylinder need at least three sample hits.

The difficulty of using measured points lies in not knowing where to take the measurement until after the alignment. This poses a problem as the points must be measured before the alignment. Three dimensional elements, by definition for this use, are elements that can be measured precisely the first time.

Further, if measured points (VECTORS, EDGE, or SURFACE) are being used, the normal vectors of the features in the ROTATE set must have normal vectors that are approximately perpendicular to the vectors of the features in the LEVEL set. The features in the ORIGIN set must have a normal vector that is approximately perpendicular to both the vectors from the LEVEL set and the ROTATE set.

If measured points (VECTORS, EDGE or SURFACE) are being used as part of the set, PC-DMIS may ask that they be re-measured if they were taken too far from the nominal location. PC-DMIS first "best fits" the measured data to the nominal data. Next, PC-DMIS checks to see how far off each measured point is. If the distance is greater than the amount specified in the Point Target Radius box, PC-DMIS will request that the point be re-measured. PC-DMIS in effect puts a cylindrical tolerance zone around the theoretical location of each vector, surface, or edge point. The radius of this tolerance zone is the point tolerance specified in the dialog. PC-DMIS will continue to re-measure point features until all the measured points fall into 'tolerance'. The tolerance zone only affects measured points.

A special capability of PC-DMIS allows the center point of a slot to slide up or down the axis as needed. For this reason, an iterative alignment cannot converge when a slot is used as part of the ORIGIN set. It is possible to use a slot as part of the ORIGIN set by first constructing a point from the slot and then using that constructed point in the ORIGIN set.

A slot is not recommended as part of the ORIGIN set of an iterative alignment.

Type of Feature used: | Minimum # of Features needed:
Circle | 3 circles: | This method uses 3 DCC circles for the alignment.
Line | This feature type is not recommended.
Point | 6 points: | The points are used as a 3-2-1 alignment.
Slot | This feature type is not recommended as part of the ORIGIN set.
Sphere | 3 spheres: | This method uses 3 set spheres for the alignment.


To Create an Iterative Alignment

Hint: Click this icon from the Wizards toolbar to access PC-DMIS's Iterative Alignment Wizard.

To create an iterative alignment:

  1. Access the Alignment Utilities dialog box (Insert | Alignment | New). Display Menu Roadmap

  2. Click the Iterative button. The Iterative Alignment dialog box appears. You will use this dialog box to create the iterative alignment. See "Description of the Iterative Alignment Dialog Box" if you need information about the dialog box.

  3. From the Feature List box, select the first set of features (at least three features) to be used in establishing the orientation of the normal axis on the current working plane.

  4. Verify that the Level option is selected.

  5. Click the Select button.

  6. Select with the mouse the second set of features (at least two features) to be used in the rotation process.

  7. Verify that the Rotate option is selected.

  8. Click the Select button.

  9. Select the final set of features (at least one feature) that indicate the desired location of the part origin. (The same features may be used in more than one process.)

  10. Verify that the Origin option is selected.

  11. Click the Select button.

  12. Click the OK button. The Iterative Alignment dialog box closes.

  13. Click the OK button on the Alignment Utilities dialog box to complete the alignment. The dialog box closes. If this new alignment differs from the existing alignment, PC-DMIS will display a prompt asking if you want to update affected commands in the Edit window to use the new alignment. If the alignment doesn't change (or the change is too small to matter), PC-DMIS simply inserts the alignment without displaying the prompt or updating any commands.

Note: Selecting the Level, Rotation, or Origin options after they've already been assigned features will display the indicated input features for that option.

After this process is complete, PC-DMIS will three-dimensionally "best fit" the measured data and display the new alignment in the Graphics Display window and in the Edit window. See the "Iterative Alignment Command Format".


Description of the Iterative Alignment Dialog Box

The following describes the items included in the Iterative Alignment dialog box.

More:

Level

Rotate

Origin

Select

Meas All Once

Meas All Always

Point Target Radius

Fixture Tolerance

Max Iterations

Start Label

Error Label


Level

The Level - 3 option is used in conjunction with at least three features selected from the Feature List box. This set of features establishes the orientation of the normal axis of the current working plane by fitting a plane through the feature centroids.

At least three features must be used to level.


Rotate

The Rotate - 2 option is used in conjunction with at least two features selected from the Feature List box. This set of features rotates the defined axis of the work plane to the features, fitting a line through the features.

At least two features need to be used to rotate.

Note: If no features have been marked, the alignment will use features from the LEVEL section. (The two features used from the LEVEL section are the second and third from last feature.)


Origin

The Origin - 1 option is used in conjunction with one feature selected from the Feature List box. This feature set translates (or moves) the part origin to a specific location

One feature must be used to set the origin.

Note: If no features have been marked, the alignment will use the last feature from the LEVEL section.


Select

The Select button allows you to use selected features from the Feature List box to perform the Leveling, Rotating, and translating (or moving) to the Origin operations for an iterative alignment.


Meas All Once

If you select the Meas All Once check box,

  • PC-DMIS will remeasure all the input features at least once in DCC mode.

  • They will be measured in the order specified by the iterative alignment command in the Edit window.

  • PC-DMIS will display which feature is about to be measured in a message box.

  • Before accepting the move, ensure that the probe can reach the indicated feature(s) without colliding with the part.

  • Stored moves found before or after each feature will not be executed.

  • After all the features have been measured at least once, remeasurement of the features will continue for measured point types of features and those points that missed their Point Target Radius target (see "Point Target Radius").

Note: PC-DMIS will not measure circles more than one time while in this mode since their location never changes.


Meas All Always

If you select the Meas All Always check box, PC-DMIS will re-execute a portion of the current part program at least once in DCC mode. The portion that is re-executed depends on the Start Label (see "Start Label")

If you provide a start label,

  • PC-DMIS will re-execute from that defined label to the ALIGNMENT/START command that contains the currently executing iterative alignment command.

If you don't provide a start label,

  • PC-DMIS will begin this re-execution from the first feature measured in the program that is used by the iterative alignment command.

  • If the first feature has stored move points preceding it, then PC-DMIS will also execute these move points.

  • The re-execution will continue until the last measured feature used by the iterative alignment command.

  • If there are any stored moves after this command, they will not be executed.

Once the re-execution finishes, PC-DMIS will recalculate the alignment and test any measured input points to see if they are all within the tolerance radius specified in the Point Target Radius value.

  • If they are all in target, re-execution does not need to continue and PC-DMIS will consider the iterative alignment command complete.

  • If any points missed the target area, then the same portion of the program will be re-executed as described above.


Point Target Radius

The Point Target Radius box allows you to specify the target radius tolerance for measured point features used as inputs in the alignment. Measured input points include the following:

  • MEAS/POINT

  • AUTO/VECTOR

  • AUTO/EDGE

  • AUTO/SURFACE

  • AUTO/ANGLE

While you can easily see the location needed to measure a circle on a part, determining the exact location to measure a point on the surface isn't easily done. Without any visual indicators telling you where to measure the point, it is difficult to manually measure the point in an exact spot. The Point Target Radius allows you to specify an imaginary tolerance zone (or target) the size of the radius, around each point. This allows you to touch anywhere within the indicated tolerance. If the measured point did not touch within this zone, PC-DMIS will re-measure the point in DCC mode.

PC-DMIS will attempt to re-measure the input features based on the selected check boxes in the Iterative Alignment dialog box (See "Meas All Once" and "Meas All Always").

If you don’t select the Meas All Always or Meas All Once check box (or if you manually set MEASURE ALL FEAT=NO in the Edit window),

  • PC-DMIS will fit the datums and check to see if any measured input points missed their targets. If so, only these features will be re-measured in DCC mode.

  • PC-DMIS will display a dialog box indicating the feature that is about to be measured. This will let you ensure that the probe can reach the desired feature without colliding with the part.

  • Once all point features are in target, PC-DMIS considers the iterative alignment command complete.

  • If there are any measured point features that missed their targets, PC-DMIS will continue to re-measure these features until they are in target.

Note: It is important not to set the vector Point Target Radius value too small (for example 50 microns ). Many CMMs are unable to accurately position the probe to touch each measured point on a minuscule target. A better choice would be a tolerance of about .5 millimeters. If the re-measurement continues indefinitely, you should increase this value.


Fixture Tolerance

The Fixture Tolerance box allows you to type a fitting tolerance value against which PC-DMIS compares feature elements making up the iterative alignment to their theoretical values.

If after fitting the measurement values to the theoretical values, one or more of the input features have an error along their assigned datum axis that exceeds this tolerance value, PC-DMIS automatically goes to the error label (if one exists). See "Error Label".

If you don't provide an error label, PC-DMIS displays an error message showing the errors along each of the datums. You will have the choice to accept the datum as it is and continue with the rest of the part program, or to cancel the part program execution.

PC-DMIS can only use the fixture tolerance value if you used more than the minimum number of points needed to create the feature. For example, if you are measuring a plane, the minimum number of points needed for that plane is usually three points. However, if you wanted to use the fixture tolerance value, you would need to measure at least four points. If you use only three points then only one solution exists and PC-DMIS cannot adjust or re-iterate.


Max Iterations

This determines the maximum number of repetitions that PC-DMIS will perform when creating the iterative alignment. PC-DMIS only uses this value if the Meas All Always check box is selected.


Start Label

The Start Label box allows you to define a label that PC-DMIS will go to when remeasuring iterative alignment features as long as you select the Meas All Always check box.

  • PC-DMIS will re-measure in DCC mode, starting at the designated label and ending at the ALIGNMENT/START command (preceding the ALIGNMENT/ITERATE command). This is more consistent with how DMIS expects this command to function.

If you don't define a start label,

  • PC-DMIS goes to the first feature making up the iterative alignment and begins DCC measurement there (PC-DMIS also includes any moves just before this feature).

  • PC-DMIS will continue to re-execute part program commands in order until it reaches the last feature making up the iterative alignment. If there are any moves after this ending feature, they will not be executed.

To create a label, see "Creating Labels" in the "Branching by Using Flow Control" section.


Error Label

The Error Label box allows you to define a label that PC-DMIS will go to when the error along the datum for each of the input features exceeds the fixture tolerance level defined in the Fixture Tolerance box.

Note: If you supply the minimum number of inputs for each of the datum axes (three for the Level datum, two for the Rotate datum, and one for the Origin datum), PC-DMIS can fit the input feature measurement value to its theoretical values without errors. In this case PC-DMIS doesn't really need the fixture tolerance. If you supply more than the minimum number of inputs for any of the defined datums, then either part or fixture errors may make it impossible to fit the measurement values to the theoretical values with less error then the supplied fixture tolerance.

If you don't define an error label, PC-DMIS will generate an error message displaying the amount of error for each of the datum features, giving you the option to cancel or continue execution with the datums as they are.

To create a label, see "Creating Labels" in the "Branching by Using Flow Control" section.


Creating a Best Fit Alignment

Best Fit Alignment dialog box

When you click the Best Fit button from the Alignment Utilities dialog box, Display Menu Roadmap
PC-DMIS displays the Best Fit Alignment dialog box. This dialog box provides a way for you to "best fit" the measured data to the nominal points. With the exception of the Vector method, which requires at least two points, you need at least one point feature to create a best fit alignment.

More:

Understanding Best Fit Alignments

To Create a Best Fit Alignment

Description of the Best Fit Alignment Dialog Box


To Create a Best Fit Alignment

Example of a Best Fit Alignment's Graphical Analysis in the Report Window

A Sample of Best Fit Alignment Graphical Analysis in the Report Window

This graphical analysis of the 3D Best Fit alignment displays this information in the Report window:

  • Header - This contains various values used in the Best Fit alignment: Method, Standard Deviation, Mean, Translation offsets, Rotation offsets, Max iterations, Iterations.

  • Vertical Axis - This shows the amount of deviation before and after the alignment.

Red bars on bar graphs or red dots on circle graphs represent the deviation, the 3D distance between the actual and the theoretical, before the Best Fit alignment.

Green bars on bar graphs or green dots on circle graphs represent the deviation, the 3D distance between the actual and the theoretical, after the Best Fit alignment.

  • Horizontal Axis - This displays the IDs of the points used in the alignment.

Note that 3D alignments only use the bar graph.

To Create a Best Fit Alignment

To create a Best Fit alignment:

  1. Access the Alignment Utilities dialog box (Insert | Alignment | New). Display Menu Roadmap

  2. Click the Best Fit button. The Best Fit Alignment dialog box appears. You will use this dialog box to create the Best Fit alignment. See "Description of the Best Fit Alignment Dialog Box" if you need information about the dialog box.

  3. Select the features to be used out of the Feature List box. These will be displayed in the Input List box.

  4. Select the orientation of alignment by selecting either the 2D or 3D options in the Orientation area. For a 2D alignment, also select the correct active plane from the Active Plane drop-down list.

  5. Select the best fit type by choosing the appropriate options from the Best Fit Method area. In the case of a 3D alignment, also choose the appropriate constraint also from the Best Fit Method area.

  6. To edit the weights of the features, select the Create Weights button. Select the feature whose weight is to be changed. Click the Edit Weight button. Type the new weight in the New Value box in the Weight Editor area, and click the Enter button.

  7. To set the point of rotation about a given feature, select the feature from the Input List, and click the Rotate About button. Alternately, a value can be entered into the Theoretical and Measured boxes in the Rotate About area of the dialog box.

  8. Click the OK button. The Best Fit Alignment dialog box closes.

  9. Click the OK button on the Alignment Utilities dialog box. The dialog box closes. If this new alignment differs from the existing alignment, PC-DMIS will display a prompt asking if you want to update affected commands in the Edit window to use the new alignment. If the alignment doesn't change (or the change is too small to matter), PC-DMIS simply inserts the alignment without displaying the prompt or updating any commands. Following execution, PC-DMIS will display a 3D Alignment Best Fit Graphical Analysis in the Report window.

    View Example of Best Fit Alignment in the Report Window


Understanding Best Fit Alignments

To properly create your best fit alignment, consider the information presented here:

A best fit alignment is, first of all, an alignment that causes a set of measured points or a set of actual feature centroids to match, as closely as possible to its nominal location or theoretical counterpart. In certain cases it is also possible for a best fit alignment to optimally match a set of points to a CAD curve or surface.

The Least Squares best fit alignment algorithm aligns the two point sets by transforming one of the sets so that the sum of the squared distances between matching points in the two sets is minimal. To understand how the Least Squares alignment works, visualize a spring (of initial length zero) between each measured point and its nominal counterpart. The springs are stretched as the distance between the two points increases. The position the point set ends up in when you release it and let the springs act is the solution to the least squares alignment problem.

Similarly, the Min/Max algorithm aligns two point sets by minimizing the maximum distance between matching points in the two sets. After a Min/Max alignment, the maximum distance is exhibited by enough point pairs (usually three), in enough directions so that any change in the position of either set would cause an increase in distance between at least one pair of points. In PC-DMIS, Min/Max alignments are strictly 2D.

However, sometimes there might be preferred directions in which to align the two point sets. For instance, if the points are on the surface of a car hood or on its boundary, then motion along the surface or along the boundary is not as important as motion in a perpendicular direction. The Vector fit alignment gives you some control over preferred directions by minimizing the squared lengths of the distance vectors projected onto the given nominal vectors.

In all three cases (Min/Max, Least Squares, and Vector), weights can be specified by the user and/or generated from tolerances. A point with a larger weight is given more priority in optimizing the alignment.

These topics will help you to understand important aspects of Best Fit alignments.

More:

Comparing Best Fit Alignments

2D Best Fit Command Line Format

3D Best Fit Command Line Format

2D or 3D Best Fit Alignments

Available Best Fit Types

Constraints for 3D Best Fit Alignments

Feature Weights

Feature Sets as Best Fit Alignment Inputs

Scans as Best Fit Alignment Inputs

Tagged Features in a Feature Set or Scan

3D Alignment Center of Rotation

Point Set to CAD Alignments


Comparing Best Fit Alignments

Least Squares Fit

The Least Squares fit minimizes the sum of the squared errors, which is the same as minimizing the average squared error. A weighted Least Squares fit minimizes a weighted average of the squared errors. It can be 2D or 3D in PC-DMIS.

Vector Fit

The Vector fit is a kind of Least Squares fit, except that the error vectors are projected onto given direction vectors (usually the normals), and these projected distances are used in the Least Squares fit. If the normal vectors are used, then motion perpendicular to the normal is allowed without affecting the "goodness" of the fit. This can be used to mimic a hard gage.

Min Max Fit

Currently, PC-DMIS only allows 2D Min/Max fits. A Min/Max fit minimizes the maximum error. For this reason it can be used in an accept/reject procedure—if the maximal error is small then all errors are small, whereas a small least squares error, being an average, doesn't guarantee that all errors are small.

If weights based on tolerances are used then a Min/Max fit reduces the percentage of available tolerance used by each feature. The Least Squares fit reduces the "average" amount of tolerance used by all features. Since the weights generated are reciprocals of the tolerances, a feature with a relatively small weight (or lower priority) corresponds to a large tolerance zone, which gives it more freedom to move without affecting the other features. A feature with a relatively large weight (or small tolerance zone) gets a high priority in the alignment process.


2D Best Fit Command Line Format

The Edit window command line for the Best Fit 2D option reads:

ALIGNMENT/BF2D,TOG1,TOG2,CREATE WEIGHTS=YES,TOG3,0,0,0,0

CENTER OF ROTATION,MEAS_X,MEAS_Y,MEAS_Z,THEO_X,THEO_Y,THEO_Z

SHOWALLINPUTS=YES,SHOWALLPARAMS=YES

SHOWALLINPUTS=YES,SHOWALLPARAMS=YES

ID =

Available Fields:

"TOG1" This field allows you to switch between the available work planes. The current working plane should be displayed.

"TOG2" This field allows you to switch between the available types of best fits: LEASTSQR, VECFIT, and MINMAX. See "Available Best Fit Types" for information.

CREATE WEIGHTS= This option lets you determine whether or not PC-DMIS creates weights for the features used in the best fit alignment. Available options are YES or NO. See "Feature Weights".

"TOG3" This field determines the degrees of freedom for the 2D alignment. Available options are: ROTONLY (rotation only), ROTANDTRANS (rotation and translation), and TRANSONLY (translation only).

CENTER OF ROTATION This field and the measured and theoretical XYZ values associated with it, represent the center of rotation. They only appear if ROTONLY or ROTANDTRANS is used for the TOG2 field.

SHOWALLINPUTS= This option lets you determine whether or not the alignment code block displays the feature inputs used to create the alignment. Available options are YES or NO.

SHOWALLPARAMS= This option lets you determine whether or not the alignment code block displays all the parameters for the feature inputs. Available options are YES or NO.

If set to YES, then PC-DMIS will display this information for each input feature: Feature ID, Feature Type, Dimension ID, Feature Weight, Feature Use.

For example, it might look something like this.

ID = CIR2,Circles,LOC12,2.000000,YES

If set to NO, then PC-DMIS will display only the ID of the input feature

ID = CIR2

ID= Each line began with "ID=" represents an input feature used in the alignment.


3D Best Fit Command Line Format

The Edit window command line for the Best Fit 3D option reads:

ALIGNMENT/BF3D,TOG1,CREATE WEIGHTS=YES,TOG2,USE SCALING=YES,0,0,0,0,0,0,1

CENTER OF ROTATION,MEAS_X,MEAS_Y,MEAS_Z,THEO_X,THEO_Y,THEO_Z

SHOWALLINPUTS=YES,SHOWALLPARAMS=YES

ID =

Available Fields:

"TOG1" This field allows you to switch between the available types of best fits.

"TOG2" This field allows you to switch between the available types of constraints for the 3D alignment. Available options are: ROTONLY (rotation only), ROTANDTRANS (rotation and translation), and TRANSONLY (translation only). The six number values following USE SCALING are:

  • Translation in X

  • Translation in Y

  • Translation in Z

  • Rotation in the XY plane

  • Rotation in YZ plane

  • Rotation in ZX plane

Note that the values for translation and rotation are relative to the current active alignment, and the angles are always in degrees. If seven number values are visible then the seventh number is the scale factor.

CENTER OF ROTATION This field and the measured and theoretical XYZ values associated with it, represent the center of rotation. They only appear if ROTONLY or ROTANDTRANS is used for the TOG2 field.

SHOWALLINPUTS= This option lets you determine whether or not the alignment code block displays the feature inputs used to create the alignment. Available options are YES or NO.

SHOWALLPARAMS= This option lets you determine whether or not the alignment code block displays all the parameters for the feature inputs. Available options are YES or NO.

If set to YES, then PC-DMIS will display this information for each input feature: Feature ID, Feature Type, Dimension ID, Feature Weight, Feature Use.

For example, it might look something like this:

ID = CIR2,Circles,LOC12,2.000000,YES

If set to NO, then PC-DMIS will display only the ID of the input feature, like this:

D = CIR2

ID= Each line starting with "ID=" represents an input feature used in the alignment.


2D or 3D Best Fit Alignments

Best Fit Alignments can be either two or three dimensional. There is a very significant difference between a 2D and a 3D best fit.

  • A 2D Best Fit alignment requires an initial alignment. The alignment is created in the specified workplane and is based on the current alignment.

  • A 3D Best Fit alignment uses the raw (machine) data and correlates it to the theoretical values. It does NOT use a previous alignment but creates a completely new one.


Available Best Fit Types

There are several options available when creating a Best Fit Alignment. There are three different types of Best Fit options:

  1. Least Squares (default) – minimizes the average squared error of the fit among all of the features included in the best fit. This is the most common best fit type. The error value is the sum of the squared distances. Outliers don't have as bad an effect and direction of error plays no role in this fit.

  2. Vector (also known as Projected Least Squares) – also minimizes the average squared error among the features being fit; however, it first snaps (or projects) the points back onto the nominal vectors of the feature. Therefore, all error will be along the nominal vectors. The error value is the sum of the squared projected distances. This type of fit is typically used when a set of points is being fit to curves and / or surfaces. With this type of fit, PC-DMIS allows points to 'slide' along the surface but discourages them from pulling away from the surface.
    Example:     If the Nominal point is: 1.1.1 with the vector: 0,0,1, and Measure values 4,2,0.95, then the measured data will be adjusted to 1,1,0.95, snapped to the vector of 0,0,1.

  3. Min/Max – minimizes the maximum error (the largest distance) among the features being fit. Bad measurements can affect this error value drastically. You can use this kind of alignment to determine if there is an alignment that will allow all features input to the Best Fit alignment to be within the given tolerances. This type of fit is specified by Y14.5.

Note: The Min/Max option is only available for 2D Best Fit alignments.


Constraints for 3D Best Fit Alignments

There are also constraints that can be applied to 3D Best Fit alignments. The constraint options are:

  1. Rotate and Translate (default) – This allows the alignment full flexibility while correlating the machine data to the theoretical values.

  2. Rotate Only – This option restricts the alignment to rotation only, without applying any translations.

  3. Translate Only – This option restricts the alignment to translation only, without applying any rotations.


Feature Weights

Each feature used as an input has an associated weight. The default value for these weights is 1. You can modify the weights in the edit window or in the dialog box. The values of these weights affect the resulting alignment. The larger the weight of a particular feature, the more the resulting alignment will attempt to match the measured value of that feature to its theoretical value. This allows you to assign priorities to the features in the alignment. If the weights of all the input features are equal then the features will be treated equally, regardless of the value of the weight.

Any of the weights can be edited by selecting the feature in the Input List and clicking the Edit Weight button. The new weight will be assigned to that feature and used during the calculations.

Weights may also be assigned to each feature based on its associated dimension. If there is no associated dimension, it will be assigned a default tolerance. The weights are assigned by clicking the Create Weights button. A composite weight for the feature is then computed by multiplying the user defined weights with the tolerance weights.


Feature Sets as Best Fit Alignment Inputs

When using feature sets (constructed sets or scans) as inputs to the Best Fit alignment, a plus (+) sign will appear next to the feature ID in the Input List box. By clicking once on the plus (+) sign, the features that create that set will be displayed. Initially the weights for each feature will be the same as its parent feature (the original set).

Feature Set Expanded to Show Features in the Set

The weight for each child feature of the set can be edited in the same fashion as outlined above. To change the weight of all of the features in the set, simply edit the weight on the feature set itself, and that weight will be transferred to all of its children.


Scans as Best Fit Alignment Inputs

When working with a scan, there is one extra component than when working with a feature set. Scans are composed of basic scans. Each basic scan is composed of individual points. When clicking a plus (+) sign next to a scan, it will expose all of the basic scans associated with it. A plus (+) sign will appear next to each basic scan. By clicking the plus (+) sign next to each basic scan, it will expose all of the individual points associated with the basic scan. The weight for each point can be edited, the weight of the basic scan (and all of its points) can be edited, or the weight of the scan itself can be edited.


Tagged Features in a Feature Set or Scan

Also, individual members within a feature set can be tagged so that they are not used. To tag a member of a set to not be used in the best fit alignment, double-click it in the Input List box. This will change the "YES" in the Use column of the Input List box to "NO". If a basic scan is double-clicked, it and all of its associated points will be tagged with "NO" and will not get used in the calculations.


3D Alignment Center of Rotation

For certain Best Fit alignments, you can specify a center of rotation. This can be done one of two ways.

  1. Select a feature from the Input List box. Next click the Rotate button. The theoretical and measured values will automatically be entered into the appropriate boxes in the Rotate About area.

  2. If a specific coordinate is desired, the value can be entered manually by typing the XYZ coordinate into the Theoretical and Measured boxes. The value must be in a comma-delimited format in order to be valid. For example, Xtheo, Ytheo, Ztheo.


Point Set to CAD Alignments

By default, PC-DMIS matches the measured points in your best fit alignment to the original nominal point set. However, by enabling Iterate and RePierce CAD (see the Iterate and RePierce CAD area discussed in "Description of the Best Fit Alignment Dialog Box") you can have the best fit alignment match the measured points to CAD curves or surfaces instead. In this case, after the first best fit alignment is computed, updated nominal points on the CAD curve or surface, corresponding to the transformed measured points, are calculated. This process is repeated until convergence takes place. This alignment method changes the theoretical values of the points.


Description of the Best Fit Alignment Dialog Box

Best Fit Alignment dialog box

The following items appear on the Best Fit Alignment dialog box:

Item

Description

Features list

The Features list contains all the features in your part program.

Input List box

The Input List box contains the features that will be used in the creation of the Best Fit alignment. It is also used to edit the features before creation of the alignment.

Edit Weight button

The Edit Weight button puts the current weight of the selected feature into the New Value box of the Weight Editor area, allowing the weight to be changed.

Create Weights button

The Create Weights button automatically creates weights for each feature in the Input List box.

Rotate About button

The Rotate About button takes the theoretical and measured values from the selected feature in the Input List box and places them in the Theoretical and Measured boxes in the Rotate About area. This value is used as the center of rotation during the calculation of the Best Fit alignment.

Weight Editor area

The Weight Editor area remains unavailable for use unless you select a feature from the Input List box and click Edit Weight.

The new weight is entered into the New Value box. The Enter button applies the newly entered weight to the selected feature in the Input List box.

Rotate About area

The Rotate About area contains two boxes to define the theoretical and measured center of rotation:

The Theoretical box contains the theoretical center of rotation for 3D best fit alignments.

This Measured box contains the measured center of rotation for 3D best fit alignments.

Orientation area

The 3 dimensional option causes the resulting alignment to be a 3D alignment.

The 2 Dimensional option causes the resulting alignment to be a 2D alignment.

The Active Plane list sets the plane in which a 2D alignment will be calculated.

The Specified Constraints option lets you select which of the six degrees of freedom (rotation about X, Y, or Z axis, and translation in the X, Y, or Z direction) will constrain the 3D or 2D alignment. When you select this check box, PC-DMIS will display the Select Axes to be Constrained area in the place of the Best Fit Method area.

Best Fit Method area

The Best Fit Method area contains several methods you can use to compute the best fit alignment:

The Least Squares option causes the average squared error for the input features to be minimized in the alignment.

The Vector option snaps the errors in the input features onto the theoretical vectors before minimizing the average squared error.

The Min/Max option attempts to orient the part so that PC-DMIS minimizes the maximum error in all of the input features.

Note: Min/Max is only valid for 2D Best Fits.

The Rotate & Translate option allows maximum freedom in the calculation of the alignment, letting it rotate and translate freely.

The Rotate Only option limits the alignment to rotation only in its calculation.

The Translate Only option limits the alignment to translation only in its calculation.

Select Axes to be Constrained area

The Select Axes to be Constrained area lets you define the axes about which and along which the rotation and translation will be constrained.

This area only appears if you select the Specified Constraints option from the Orientation area.

The Rotate about X option constrains the alignment so that it does not rotate about the X axis.

The Rotate about Y option constrains the alignment so that it does not rotate about the Y axis.

The Rotate about Z option constrains the alignment so that it does not rotate about the Z axis.

The Translate along X option constrains the alignment so that it does not translate along the X axis.

The Translate along Y option constrains the alignment so that it does not translate along the Y axis.

The Translate along Z option constrains the alignment so that it does not translate along the Z axis.

For example, to rotate only about the Z axis and translate only in the X direction, you would need to select Rotate about X and Rotate about Y to constrain rotation to only the Z axis. Then you would need to select Translate along Y and Translate along Z to constrain translation to only the X direction.

Use Scaling check box

The Use Scaling check box becomes available for selection for 2D or 3D alignments when you select the Least Squares method. It is not available for alignments with specified constraints.

When you use scaling, PC-DMIS computes a transformation (rotation and translation) and a scale factor that optimally matches the nominal data to the scaled measured data.

The scaled alignment also scales all of the measured data and subsequent measured features in the part program, multiplying it by the computed scale factor. Note that once scaling has been applied to the measured data and features in a part program, it cannot be undone.

You may find this useful, for example, in compensating for expansion or contraction of a part due to temperature.

Iterate and RePierce CAD area

This area lets you perform an Iterative Best Fit alignment.

Enable - If selected, PC-DMIS performs an Iterative Best Fit alignment which pierces the CAD geometry and adjusts the feature nominals with each iteration using Tol and Max Iterations to control the result. If not selected, PC-DMIS does a single Best Fit alignment.

Tol - This box allows you to enter a tolerance which PC-DMIS uses in searching for CAD surfaces to pierce. The new nominal point will be the CAD point closest to the actual feature, provided it is within this tolerance. If no CAD surface is found within this distance from the actual feature, then that feature is ignored in subsequent iterations.

Max Iterations - This determines the maximum number of times the best fit alignment algorithm will iterate.


Saving an Alignment

Save Alignment dialog box

Display Menu Roadmap

The Insert | Alignment | Save menu option saves the current alignment in an external file that can be recalled by a different part program. The topics presented here describe the Save Alignment dialog box, and how to save the alignment so you can use it in other part programs.

More:

To Save an Alignment

Description of the Save Alignment Dialog Box


To Save an Alignment

Note that you only need to save the alignment using the following procedure if the alignment is going to be recalled into a different part program. All alignments are automatically saved when used within a part program.

To save an alignment,

  1. Select Insert | Alignment | Save from the menu bar. The Save Alignment dialog appears. Display Menu Roadmap

  2. Type an alignment name (maximum ten characters) in the File Name box.

  3. Select either the Inches or Millimeters option to save the alignment as either inches or millimeters. The default unit of measurement for any alignment will be the same unit of measurement used by the part program for which the alignment was created. To use an alignment in a different part program, it is not necessary that the alignment's units of measurement be saved in the units type of the new part program. The alignment will automatically convert to the same units as the new part program (see "Recall").

  4. Click the OK button.

If you don't type a name for the alignment ID, PC-DMIS will automatically duplicate the file name for external saving purposes. The alignment can be saved to any directory. However, to display the alignment on screen it must be saved in the same directory as the part program.

The Edit window command line for this option reads:
SAVE /ALIGNMENT,align_name,filename, TOG1

TOG1
This toggle field switches between BOTH and MACHINETOPARTS. Select BOTH to store both the machine to parts and the CAD to parts transformation matrices. Select MACHINETOPARTS to store only the machine to parts transformation.


Editing the Save/Alignment Command

You can edit the command line using a different Save Alignment dialog box by placing the mouse on the SAVE/ALIGNMENT command and pressing F9.

Save Alignment dialog box

This Save Alignment dialog box allows you to create new file names of the saved alignment. Simply select the alignment from the list, make the file name change in the File Name box, and click OK. PC-DMIS creates a new file name based off of the old one you changed and makes the change in the Edit window's SAVE/ALIGNMENT command.

The Show Root Directory and Show Work Directory check boxes are not editable from this dialog box; they merely mirror the settings in the Search Path dialog box for loading alignments. You can change these check boxes by following documentation described in the "Specifying External Directories to Search" in the "Setting Your Preferences" section.

If the Show Work Directory is selected, the list of alignments will display all the .aln files in the work directory like this:

WORK\filename1.aln

WORK\filename2.aln

WORK\filename3.aln

If Show Root Directory is selected, it should display all the .aln files in the root directory like this:

ROOT\filename1.aln

ROOT\filename2.aln

ROOT\filename3.aln


Description of the Save Alignment Dialog Box

The following topics describe the items used inside the Save Alignment dialog box.

More:

File Name

Directories

List Files of Type

Drives

Alignment Name

Units


File Name

The File Name box allows you to name the file of the alignment you are saving.


Directories

The directory structure allows you to navigate to the directory to which you will be saving the alignment.


List Files of Type

The List Files of Type drop-down list, shows all the files in the current directory based on a particular file type. The default file type is *.aln. This means that only those files with the alignment extension (*.aln) will be shown in the list.


Drives

The Drives drop-down list allows you to define which hard drive, or floppy drive the alignment is saved to.


Alignment Name

The Alignment Name box displays the Alignment ID of the alignment you are saving.

If an alignment ID is not entered, PC-DMIS will automatically duplicate the file name for external saving purposes. The alignment ID can be saved to any directory. However, to display the alignment on screen it must be saved in the same directory as the part program.

Use this option only if the alignment is going to be recalled into a different part program. All alignments are automatically saved when used within a part program.


Units

The Inches or Millimeters options in the Units area allow you to determine which unit of measurement the alignment will be saved as: inches or millimeters.


Recalling an Existing Alignment

The Alignment Block is the block of text in the Edit window that defines the alignment. It consists of the ALIGNMENT/START command and ends with the ALIGNMENT/END command.

The Insert | Alignment | Recall menu option allows you to recall an alignment that was previously created in the current program (Internal Alignment) or saved from another program (External Alignment).

Display Menu Roadmap

This command can only be inserted outside an alignment block.

Note: The Recall button inside the Alignment Utilities dialog box also allows you to recall an existing alignment, but it only allows you to recall alignments previously created in that part program (internal alignments).

Before an alignment can be recalled to another part program, it must be saved using the Insert | Alignment | Save menu option. See "Saving an Alignment" Display Menu Roadmap

If the alignment being recalled was saved with different units of measurement than the current part program, the alignment units will automatically be converted to the units of measurement of the current part program.

More:

To Recall an Alignment


To Recall an Alignment

To recall an alignment,

  1. Access the Insert | Alignment | Recall menu option (or access the Alignment Utilities dialog box and click the Recall button). A Select Alignment selection box appears. Display Menu Roadmap

  2. Type the 15 character (or less) saved alignment ID, or use the drop-down list to select the desired alignment.

  3. Click OK. PC-DMIS inserts the RECALL/ALIGNMENT command into the Edit window.

More:

Recall Alignment Command Line Format


Recall Alignment Command Line Format

The Edit window command line for this option reads:

RECALL/ALIGNMENT, INTERNAL, 'align_id'

RECALL/ALIGNMENT, EXTERNAL, 'align_id',

FILE_NAME:'align_id'

Code Used to Recall an Internal Alignment…

RECALL/ALIGNMENT, INTERNAL, 'align_id'

align_id
This is the internal alignment that will be recalled from within the current part program. PC-DMIS must first RECALL the specified alignment ID before any other alignment commands can function. This command does not need the ALIGNMENT/START or ALIGNMENT/END Edit window commands.

Code Used to Recall an External Alignment…

RECALL/ALIGNMENT, EXTERNAL, 'align_id', FILE_NAME:'align_id'

align_id
This is the external alignment that will be recalled from a part program other than the current part program. PC-DMIS must first RECALL the specified alignment ID before any other alignment commands can function. This command does not need the ALIGNMENT/START or ALIGNMENT/END Edit window commands.

FILE_NAME:
This is the .aln file name used for the saved external alignment.


Using an Alignment Inside Loops

PC-DMIS 3.6 and higher facilitates changing alignments inside a part program that uses looping or conditional branching by using the USE_ACTIVE_ALIGNMENT keyword.

If you look at the ALIGNMENT/START command line in Command mode, you'll see that the field immediately following the RECALL: text tells the program to use a stored starting alignment first. In the following example, alignment D_1 starts with the alignment from D_0 and then executes a 45 degree rotation about ZPLUS:

D_1 =ALIGNMENT/START,RECALL:D_0, LIST= YES
ALIGNMENT/ROTATE_OFFSET,45.0,ABOUT,ZPLUS
ALIGNMENT/END

However, if you use the USE_ACTIVE_ALIGNMENT keyword instead, you can cause PC-DMIS to rotate 45 degrees from the active alignment:

D_1 =ALIGNMENT/START,RECALL:USE_ACTIVE_ALIGNMENT, LIST= YES
ALIGNMENT/ROTATE_OFFSET,45.0,ABOUT,ZPLUS
ALIGNMENT/END

When you use this keyword for an alignment inside a loop:

  • The first time through the loop the active alignment will be the last executed alignment preceding the loop.

  • Additional times through the loop the active alignment will be itself and will rotate a further 45 degrees from the previous time through the loop.

When you use the USE_ACTIVE_ALIGNMENT keyword you should generally deselect the Reset global settings when branching check box and select the Treat theo values as if stored in part coordinates check box from the SetUp Options dialog box, General tab. Display Menu Roadmap
See the "Setting Your Preferences" section for information on specifying setup preferences.

For information on looping, see the "Creating Generic Loops" topic in the " Branching by Using Flow Control" section.


Equating an Alignment

Equate Alignment dialog box

Display Menu Roadmap

The Insert | Alignment | Equate option equates two alignments. This option provides the means to:

  • Change the position or orientation of a part while retaining previous dimensional information.

  • Re-align the part and save previously measured data if the part is accidentally bumped or moved during the inspection process.

Note: For Equate Alignment to function properly, the features referenced in your new alignment must be measured after you move your part. Additionally, you should reference all of the features for your new alignment in a single alignment block.

More:

To Change a Part's Position and Orientation

To Recover after Accidentally Moving a Part

Description of the Equate Alignment Dialog Box


To Change a Part's Position and Orientation

For example, to measure a dimension that references features on two sides of the part that are not accessible from a single part orientation:

  1. Measure the alignment features on the first side of the part.

  2. Create the original alignment.

  3. Measure all required features that can be reached from the first orientation of the part.

  4. Move the part to its new position.

  5. Measure the new alignment features. The origin must be the same and the axis must be in the same direction as the axis of the alignment you are equating to. It is easiest to understand this if you imagine that the original origin and axes ' arrows were glued onto the part before moving it. The new alignment places the origin and axes' arrows in the same position with respect to the part.

  6. Select the Insert | Alignment | Equate menu option. The Equate Alignment dialog box appears. Display Menu Roadmap

  7. In the Equate Original Alignment list, select the original alignment.

  8. In the With New Alignment list, select the new alignment.

  9. Click the OK button. The CAD model won't move relative to the alignment axes, but the measured values will move once PC-DMIS executes the equate alignment.


To Recover after Accidentally Moving a Part

If a part has been moved accidentally,

  1. Select the Insert | Alignment | Equate menu option. Display Menu Roadmap

  2. Enter the ID of the alignment to be re-measured as the first and second alignment ID.

  3. Re-measure the alignment features. When this is completed, all dimensional and feature information will be translated to the new position of the part. The CAD model won't move relative to the alignment axes, but the measured values will move once PC-DMIS executes the equate alignment.

If this command is used to equate the same alignment in a part program, PC-DMIS will not display the command line in the Edit window.

A command line will only be displayed in the Edit window if two different alignments are selected. An external alignment can be used if it is different from the equated alignment. The external alignment must be recalled using the RECALL/ALIGNMENT, EXTERNAL command before it will be displayed.

The Edit window command line for this option reads:
EQUATE/"name"TO ALIGNMENT,"alignment_name"


Description of the Equate Alignment Dialog Box

The following topics describe the items used in the Equate Alignment dialog box.

More:

Equate Original Alignment

With Alignment


Equate Original Alignment

The Equate Alignment drop-down list allows you to select the original alignment that you will be equating. This is a previously created alignment that you want to equate with an existing new alignment.


With Alignment

The With New Alignment drop-down list allows you to select the new alignment to which you are equating. This is an new alignment to which you will equate your original created alignment.


Equating CAD to Measured Part Data

Display Menu Roadmap

The Operation | Graphics Display Window | Cad Equals Part menu option (or the CAD = Part button on the Alignment Utilities dialog box) links CAD data to the measured data. This option is only available after a created alignment places the part origin/orientation at the same location as the CAD origin/orientation. PC-DMIS offers the CAD EQUALS PART option in two areas (also see "CAD Equals Part" within the Alignment option). Select this option and PC-DMIS will display the measured data on top of the CAD data. It will use the CAD data to help inspect the part.

Once the Cad Equals Part option has been used on a part program, the CAD Equals Part menu option will be selected.


Performing a Leapfrog Operation

Leapfrog / Relocation dialog box

Leapfrog / Relocation dialog box

Leapfrog is available for some portable machines. Currently these include FARO, ROMER, Garda, and GOM. Your hardware key (portlock) also needs to be programmed to support your portable machine.

The Insert | Alignment | Leapfrog menu option brings up the Leapfrog / Relocation dialog box.

Display Menu Roadmap

This dialog box allows you to move your portable CMM in order to measure parts that are too large for your CMM. You should be aware of machine accuracy limitations before using this method.

The basis for leapfrog is to measure a series of features, and then after moving the machine, re-measure the same features in the same order. This creates a transformation and makes the machine behave as if it were the same coordinate system before the move.

Prior to PC-DMIS version 4.2, Leapfrog transformation information was stored in a separate file and was thereby independent of all part programs. This meant the Leapfrog was still active in newly created part programs and you had to remove it by clicking the Reset button on the Leapfrog / Relocation dialog box. In version 4.2 and later, however, this has changed. Leapfrog transformation information is now stored with the part program that used the Leapfrog operation; you no longer have to remove the Leapfrog from new part programs.

A Leapfrog command is entered into the Edit window when the Accept button is clicked.

The command line in the Edit window would read:
LEAPFROG/TOG1, NUM, TOG2

TOG1: This first parameter in the Leapfrog command is a toggle field that relates to the different types of measurement options available in the dialog box. These include:

  1. SPHERES (Measure 3 Spheres option)

  2. PSETS (Measure 3 Point Sets option)

  3. POINTS (Measure 3 Points option)

  4. DATUMS (Measure Datums option)

There is also an OFF value for this parameter, in which case the other two parameters will not be displayed. The OFF value will turn off leapfrog translation

NUM: This second parameter in the Leapfrog command is the number of hits you want to take. This corresponds to the Hits box in the Leapfrog dialog box.

TOG2: This last parameter in the Leapfrog command is a toggle field allowing you to switch between either a FULL or PARTIAL leapfrog. This parameter corresponds to the Half Relocation option in the dialog box.

When this command is executed you will be prompted to take your hits, and after all the hits are taken, a leapfrog translation will be in effect.

More:

Measure Options

Number of Hits

Half Relocation

Datum Program File

Available and Used Lists

Measure Marked

Measure All

Results area

Reset

Accept

OK


Measure Options

The available Measure option buttons allow you to select what method PC-DMIS will use to perform the translation comparison.

  • The Measure 3 Spheres option tells PC-DMIS to use spheres as the features for translation comparison. This method uses the center of each measured sphere.

  • The Measure 3 Point Sets option tells PC-DMIS to use the centroid of a set of points. It is recommended that you use the bottom of an inverted cone with a hard probe. This method is slightly more accurate than the spheres method and much quicker for the operator.

  • The Measure 3 Points option tells PC-DMIS to use only three points and is the least accurate of the three methods.

  • The Measure Datums option tells PC-DMIS to use existing datum features from a part program of your choice. Because the datum features are already assumed to have been measured in your existing part program, you only need to measure them after relocating your machine.


Number of Hits

The Number of Hits box allows you to specify the number of hits you wish to use for each feature. Of course this will not be used in the point method.


Half Relocation

The Half Relocation check box lets you determine whether or not PC-DMIS performs a FULL RELOCATION (FULL LEAPFROG) operation (if not selected) or performs a PARTIAL RELOCATION (PARTIAL LEAPFROG) operation (if selected).

Relocation simply refers to moving the portable measuring machine to a new location.

  • Doing a full relocation (clearing this check box) means you would need to measure something before you move the portable machine and then re-measure some or all of those items after moving the machine. Remeasuring allows PC-DMIS to determine the new location of the machine.

  • A half relocation (selecting this check box) means you move the portable machine first and then measure the datum features.


Datum Program File

This area lets you specify what program file to use as the datum program file. This box becomes enabled when you click the Measure Datum Features option button. You can type the full pathway to the part program (.PRG) file or you can use the Browse button to navigate through your directory structure and select one that way.

Once you select a file, the features available for use in the Leapfrog operation appear in the Available list.


Available and Used Lists

Available and Used lists

Available and Used lists

The Available and Used lists display, respectively, datum features that are available for use or datum features that you have chosen to use in the Leapfrog operation.

Available List

When you select a program file to use in the Datum Program File area, the available features from that program file appear in the Available list. You can then assign features to the current Leapfrog operation by selecting them and then clicking the >>> button.

Used List

Assigned features that appear in the Used list will be measured when you click the Measure Marked or Measure All buttons in the order that they appear in the Used list. You can remove them from the Used list by clicking the <<< button. You can change a feature's order of execution by selecting a feature clicking the up or down arrow buttons.


Measure Marked

The Measure Marked button only functions when you use the Measure Datums option. It allows you to measure any selected features from the Used list. PC-DMIS will use these features in the Leapfrog operation. When you click this button, PC-DMIS displays the Execution Mode Options dialog box, prompting you to measure the selected features once you have moved the CMM, not before.

The results box will display the 3D distance between the features taken before the move and after the move of the CMM. If you find the results unsatisfactory then you may re-measure the last set of features again as the button will now read: Re-measure.

Note: After you move the CMM, there is not a way to revert to the previous alignment. If the Leapfrog results are unsatisfactory after the Re-measure process, you must reset the Leapfrog and restart the entire part inspection process by executing the part program from the initial alignment. The physical limitation of using a single CMM device makes this condition possible for all relocation methods. You should take great care during the execution of any relocation procedure.


Measure All

Similar to Measure Marked, the Measure All button also opens the Execution Mode Options dialog box.

  • If you are using Measure 3 Spheres, Measure 3 Point Sets, or Measure 3 Points, then this dialog box will first prompt you to measure the three features before prompting you to move the CMM. After moving the machine, you will be prompted to re-measure the same features in the same order.

  • If you are using Measure Datums, then the Execution Mode Options dialog box prompts you to measure all the datum features once you have moved the CMM, not before.

The results box will display the 3D distance between the features taken before the move and after the move of the CMM. If you find the results unsatisfactory then you may re-measure the last set of features again as the button will now read: Re-measure.

Note: If the re-measure process proves unsatisfactory, then you must reset the leapfrog and start again from the beginning. This is a problem with all leapfrog systems and should be remembered.


Results box

Results area

Results area

The Results area shows the deviations between the machine's first position and its subsequent position(s) by displaying the 3D distance between the features taken before the move and after the move of the CMM.


Accept

Once you have a filled out the Leapfrog / Relocation dialog box, you must click the Accept button from the Results area before the leapfrog transformation will be used. Clicking Accept will add the LEAPFROG command to the part program. If you don't click the Accept button but click the X in the upper-right corner or click OK first, the constructed leapfrog translation will be lost.


Reset

The Reset button removes any translation by adding a LEAPFROG/OFF command into the Edit window.


OK

Clicking OK closes the Leapfrog / Relocation dialog box. If you click this button before clicking the Accept button, the dialog box will close without inserting the LEAPFROG command.


Changing Alignment Nominal Values

If you modify an alignment feature's theoretical values during execute mode, PC-DMIS changes the CAD to Parts alignment. This means that features in your part program that come after the alignment, and are measured relative to the alignment features, shift by the amount of the changed theoretical values.

If you select the Ignore CAD to Part check box from the Setup Options dialog box, the CAD to Parts alignment does not change when your alignment feature theoretical values change. The features below the alignment are then measured in their same position. See "Ignore CAD to Part" in the "Setting Your Preferences" section.

Note: You cannot use the Ignore CAD to Part functionality if you use true position in your part program.

You can also control how PC-DMIS handles your features' nominal values when you update an alignment's theoretical values by using the UpdateBelowChangedAlignmentDuringExecution entry in the PC-DMIS settings editor. For additional information, please view the "Modifying Registry Entries" section.


Creating a Bundle Alignment

Bundle Alignments are used to establish the orientation of each tracker position (station) so that all measurements can be brought into the same coordinate system. Common points or features are measured between stations that are physically fixed in space to find the orientation of the stations. At the same time, as the common points are measured from different stations and the bundle alignment updates the location of the points. This allows PC-DMIS to extend the range of capability by using multiple stations to measure the features in a single part program.

A system may contain a single tracker which is moved to different stations, or you could have multiple trackers (currently not supported in PC-DMIS version 4.2) which may be moved to different stations. A station is defined as a location where the tracker is placed.

Note: Bundle Alignments are only used for Leica Tracker devices.

Select the Insert | Alignment | Bundle menu option to begin creating a Bundle Alignment. The following topics discuss the process of creating a Bundle Alignment:

  • Adding and Removing Stations

  • Setting Fit Options

  • Bundle Alignment Setup

  • Bundle Alignment Results

  • Bundle Alignment Command Text


Adding and Removing Stations

The Station Manager dialog box is accessed by clicking Station Manager from the Bundle Alignment dialog box, selecting the Tracker | Station Management menu item or clicking the active station name in the Tracker Status Bar.

Station Manager dialog box

  • Click Add to add a new station to the Stations list for inclusion in the Bundle alignment.

  • Select an existing station form the Stations list and click Remove to remove that station.

  • Oriented - When the value is YES in the Oriented column, the station location and orientation has been computed.

  • Locked - When the value is YES in the Locked column the station will not allow any further measurements. A station becomes locked when the Tracker is moved from that position.

Note: The asterisk next to the station name indicates that it is the active station.

Note: No more than 99 stations are allowed in a bundle alignment calculation.


Setting Fit Options

Click Fit Options from the Bundle Alignment dialog box to open the Fit Options dialog box.

Fit Options dialog box

Typically, the default options (shown above) will be used. Select from the following options to determine how the Bundle Alignment solution is calculated:

  • Normal Solution - Computes the orientation of each station and each common point based on the current orientation of the stations and common points.

  • Recalculate all - This recomputes the orientation of points and stations disregarding current orientation of stations and common points

  • Keep oriented stations fixed - Previously oriented stations will remain unchanged and only the last station will be recomputed. The common points will be recomputed.

  • Keep points and oriented stations fixed - Both previously measured stations and the common points will remain fixed.

  • Balanced network - This is used to ”balance” the system so that a single station is not constrained to be the origin.

  • Blunder Analysis - This used to compute situations where the user may have mistakenly measured the wrong point when measuring the common features.


Bundle Alignment Setup

Bundle Alignment dialog box - Setup tab

Setting up the Bundle alignment entails associating features that will be measured by multiple Leica Tracker stations. To do this:

  1. Click the check boxes next to the features that you would like to include in the Bundle Alignment for any previously oriented stations. Checked features will be included in the bundle calculation, not necessarily measured. If this is the first (reference) station, you would select all of the features that you will measure in Step 3. Only features that are added to the list on the right under the Active Station will be measured when you click Measure.

Note: By clicking the station name at the top of the column, you can either select of deselect all the features under that column.

  2. Select the reference station from the Active Station drop-down box.

Note: Stations that are locked can not be selected as the active station.

  3. To define the features that will be measured by the Active Station when you click Measure, select them from the Features list and click the Move Right button [image]. This will add them to the list for the Active Station. To remove features from the Active Station feature list, select the feature and click the Move Left button [image].

  4. Click Measure to begin measuring the selected features from the Active Station. The Bundle Alignment is compute after the measurement has completed.

  5. Once the station has been measured, move the machine (Leica Tracker) to a next location (Station).

  6. Now select the previously measured features plus any new features that will be measured by the new station location from the Features list by clicking the check boxes next to the features. These features are included in the Bundle alignment calculation.

  7. Select the name from the Active Station drop-down box that represents the new location where you have moved the Tracker.

  8. Repeat Step 3 and include any features measured by the previous station(s), plus any new features to be measured by the current Active Station.

  9. Click Measure to begin measuring the selected features from the Active Station. The Bundle Alignment is re-computed after the measurement has completed.

  10. Review the results via the Results tab (see "Bundle Alignment Results").

  11. To recompute the Bundle Alignment without having to remeasure features, click Compute. This is only needed, when you don't like the results (See the "Bundle Alignment Results")and want to modify parameters, such as which features to include (check boxes in the Features multi-column list box), or changing the Fit Options settings (like a balanced network). This will redo the computation based on the changed parameters without remeasuring.


Bundle Alignment Results

Bundle Alignment dialog box - Results tab

After you have measured and computed the configured Bundle alignment, you can verify the results on the Result tab. If you are satisfied with the results, then click Create to insert the alignment into the part program. The alignment will be executed as defined during normal part program execution.

Interpreting Bundle Alignment Results:

Stations

  • ID - Name of the Leica Tracker station

  • XYZ - Shows the translated position of the station with respect to the origin station.

  • Rx Ry Rz - Shows the rotations about the origin station x, y, and z axis.

Features

  • ID - Name of the Part Program feature name.

  • Source - Station name from which the feature was originally measured.

  • RMS - This is the root mean square error (average error) of the given point.

  • Apex Angle - This provides the largest angle between two observations of a measured point. If a point is measured from more than two trackers then the angle which is closest to 90 degrees is given as the Apex angle.

  • Pointing error - This is a measure of the angular error for a given point.

  • XYZ - Displays the XYZ location for the feature.

  • Dev XYZ - These values provide the deviation from the measurement taken from each individual station to the respective best-fitted value.

  • Dev 3D - This value provides the magnitude of the XYZ deviation.

Solution Status - This is either OK or FAILED indicating whether the algorithm was able to solve the bundle alignment.

RMS Error - The total RMS error of all of the points.

Variance - The variance of all the points combined.

Warnings - Specific messages are provided to assist in making adjustments to the Bundle Alignment Solution.


Bundle Alignment Command Text

BUNDLE ALIGN/ID = 1,SHOW DETAIL = TOG1

FIT OPTIONS/TYPE = TOG2,BALANCED = TOG3,BLUNDER ANALYSIS = TOG4

MEASURE FEATURES/PNT1,PNT2,PNT3,

BUNDLED FEATURES/

STATION = 1,PNT1,PNT2,PNT3,PNT4,

STATION = 2,PNT1,PNT2,PNT3,,

STATION = 3,PNT1,PNT2,PNT4,,

STATION =

  • ID - This field provides the active station number. This is the station from which features will be measured.

  • TOG1 (SHOW DETAIL = YES/NO) - When this value is set to YES, a detailed listing of the Bundle Alignment is displayed in the Edit Window. By default, this value is set to NO, which will not display the FIT OPTIONS.

  • TOG2 (FIT OPTIONS/TYPE = type) - Choose one of four available Fit Options: NORMAL, POINTS AND STATIONS FIXED, RECALCULATE ALL, and STATIONS FIXED. See "Setting Fit Options".

  • TOG3 (BALANCED = OFF/ON) - When this value is set to ON, a balanced network solution is used. By default, this value is set to OFF. See "Setting Fit Options".

  • TOG4 (BLUNDER ANALYSIS = OFF/ON) - When this value is set to ON, Blunder Analysis is used. By default, this value is set to OFF. See "Setting Fit Options".

  • MEASURE FEATURES - Lists features that will be measured for the active station number.

  • BUNDLED FEATURES - Lists stations and the features that are included in the Bundle Alignment computations.


Dimensioning Features

Dimensioning Features: Introduction

Dimension Command Format

Printing Dimensions to the Inspection Report

Common Dimension Dialog Box Options

Dimensioning Location

Dimensioning True Position

Dimensioning Distance

Dimensioning Angle

Dimensioning Concentricity

Dimensioning Coaxiality

Dimensioning CIRCULARITY

D imensioning Cylindricity

Dimensioning Straightness

Dimensioning Flatness

Dimensioning Perpendicularity

Dimensioning Parallelism

Dimensioning TOTAL OR CIRCULAR Runout

Dimensioning Surface Profile

Dimensioning Angularity

Dimensioning Symmetry

Dimensioning through Keyboard Input

Dimensioning Variables


Dimensioning Features: Introduction

Once features have been measured or constructed, the inspection report can be generated. The first step in preparing a report is to calculate dimensions according to specific requirements. While this section here covers PC-DMIS's legacy dimensions, understanding the information here may help you in creating the newer Feature Control Frame dimensions discussed in the next section.

Dimensions can be calculated immediately after a measurement has been made or later in the program. PC-DMIS displays the result of each dimensioning operation in the Edit window.

See the "Editing a Part Program” section for general information on how to modify the Edit window report.

PC-DMIS also allows you to specify nominal values, modify the output format, and/or print out the results of the calculations.

  • To change the nominal or tolerance values displayed in the Edit window, click on the value to be changed and type in a new one.

  • To show or hide nominals or tolerance fields in the Edit window, change the selected check boxes in the Dimension Output Format area of the Dimension tab in the Parameters dialog box (Edit | Preferences | Parameters). Display Menu Roadmap See the "Parameter Settings: Dimension tab" topic in the "Setting your Preferences" section.

  • To change the measured values of a feature (for example, to get the radius of a circle to print out) see the "Modifying Report and Motion Parameters" topic in the "Setting your Preferences" section.

To dimension a feature, select the Insert | Dimension submenu from the menu bar or access the Dimension toolbar and then select the desired dimension. This section covers the legacy dimensions found in the Dimension submenu.

The main topics in this section include:

  • Dimension Command Format

  • Printing Dimensions to the Inspection Report

  • Common Dimension Dialog Box Options

  • Dimensioning Location

  • Dimensioning True Position

  • Dimensioning Distance

  • Dimensioning Angle

  • Dimensioning Concentricity

  • Dimensioning Coaxiality

  • Dimensioning Roundness

  • Dimensioning Straightness

  • Dimensioning Flatness

  • Dimensioning Perpendicularity

  • Dimensioning Parallelism

  • Dimensioning Total or Circular Runout

  • Dimensioning Surface or Line Profile

  • Dimensioning Angularity

  • Dimensioning Symmetry

  • Dimensioning through Keyboard Input

  • Dimensioning Variables


Dimension Command Format

All dimensioned features are displayed in the following format. There will be slight variations that are explained more thoroughly in the following sections.

PC-DMIS will display dimensions that aren't linked to any features with the color you have defined for out of tolerance text.

For example, the Edit window displays dimensions as:
dimension_name = TYPE OF DIMENSION,feat_1 UNITS=IN,$
GRAPH=OFF  TEXT=OFF  MULT=1.00  OUTPUT=BOTH

AX

NOM

+TOL

-TOL

MEAS

MAX

MIN

DEV

OUT-TOL

x

8.0000

0.1000

0.1000

8.0000

8.5000

7.5000

0.0000

0.0000

y

3.0000

0.1000

0.1000

3.0000

3.5000

2.5000

0.0000

0.0000

z

0.4947

0.1000

0.1000

0.4947

0.1428

0.8466

0.0000

0.0000

d

1.0000

0.1000

0.1000

1.0000

1.0000

1.0000

0.0000

0.0000

v

0.0000

0.5938

0.8046

END OF DIMENSION dimension_name (for LOCATION only)

See "Conventions" for field rules.

TYPE OF DIMENSION: denotes the dimension type. This field cannot be changed except by changing the name of the feature.

feat_1: name of feature to be dimensioned. This is a user editable field.

All nominal and tolerance values in a dimension are editable. To edit the nominal and tolerance values:

  1. Move to the desired cell by pressing the TAB key, or double-click on the field using the left mouse button.

  2. Type in the desired value.

  3. Press the TAB key again or click outside of the dimension.

Pressing the ENTER key will add a line. (See "Dimensioning Location")

More:

Adding Lines

Deleting Lines

Editing Lines

Conventions

Accessing the Dialog Box


Adding Lines

In order to create an additional line within the location dimension:

  1. Place the cursor in the desired location.

  2. Press the ENTER key.

  3. Type in the desired axis (X, Y, Z, D, R, A, V, T, L, S, H, M, PR, PA, PD).

  4. Press the TAB or ENTER key.

PC-DMIS will then display the values for the added axis. PC-DMIS adds the new line depending on where the cursor is located. If the cursor is in the middle of a command, a new line is created below the current line. If the cursor is placed at the beginning of a command line, PC-DMIS will create the new line above the current cursor position.


Deleting Lines

To delete a single axis within a location dimension, highlight the desired axis and then press the BACKSPACE or DELETE key. (See ”Command Mode Keyboard Functions” in the "Using the Edit Window" section.)


Editing Lines

When the tolerances of a dimension are edited in the Edit window, a dialog box appears asking if you want to carry the changed tolerances forward to any of the same dimension types. If the response is Yes, PC-DMIS will search from that point forward in the part program to copy the tolerances into any dimensions that were of the same type and had the same original tolerances.

When the nominals of a dimension are edited in the Edit window, a dialog box appears asking if you also want to carry the changed nominals back to the dimension’s feature. If the response is Yes, PC-DMIS will change the feature nominals to the new nominal values.


Conventions

Display Menu Roadmap

The Dimension tab on the Setup Options dialog box (Edit | Preferences | Setup) allows you to define parameters for the displayed dimensions.

  • All angles can be represented 1-5 places to the right of the decimal. The actual number displayed is determined by the parameters set in the Dimension tab.

  • All lengths, distances (x_cord, y_cord, z_cord, diam, height, length, etc.), and vectors (i_vec, j_vec, k_vec) in the dimensions are represented 1-5 places to the right of the decimal. The actual nominal that will be displayed is determined by the parameters set in the Dimension tab.

For information on this Dimension tab, see the "Setup Options: Dimension tab" topic in the "Setting your Preferences" section.


Accessing the Dialog Box

To access the corresponding dimension dialog box from which an Edit window's dimension was created:

  1. Make sure the Edit window is open (View | Edit Window). Display Menu Roadmap

  2. In the Edit window, click the mouse on the dimension.

  3. Press F9. A dimension dialog box will appear.

Using this dialog box, you can make any desired changes to the existing dimension. When you click the Create button, changes will also be applied to the dimension’s text in the Edit window.


Printing Dimensions to the Inspection Report

You can easily generate dimensions inside the Edit window, which, in turn, will generate these dimensions inside your inspection report.

More:

To Automatically Create Dimensions in the Edit Window

To Modify the Dimension Prior to Printing

Displaying Dimensions in RTF and PDF Files


To Automatically Create Dimensions in the Edit Window

To have PC-DMIS automatically create dimensions in the Edit window:

  1. Access the Edit window (View | Edit Window). Display Menu Roadmap

  2. Place the cursor where you want the dimension information to appear.

  3. Type in the appropriate keyword.

OR

  1. Select Edit | Preferences | Setup menu option to access the Setup Options dialog box. Display Menu Roadmap

  2. Choose the Dimension tab from the dialog box.

  3. Select the Auto Create Dimension option.

  4. Select any other options.

  5. Click the OK button.

The next time you measure a feature an automatic dimension will be created and inserted into the Edit window.


To Modify the Dimension Prior to Printing

In many cases, the nominals, tolerances, or output format must be modified before printing the results.

To change the nominals or tolerances from the Edit window:

  1. Access the Edit window and place it in Command mode (View | Edit Window). Display Menu Roadmap

  2. Click on the dimension in the Edit window.

  3. Press TAB to move to the value you want to change

  4. Type a new value.

To edit the nominals or tolerances using the dimension's dialog box:

  1. Click on the dimension in the Edit window.

  2. Press F9 to access its dialog box.

  3. Change the necessary values.

  4. Click the Create button.

To change the contents of the dimension report, access the Dimension tab on the Parameter Settings dialog box (see "Parameter Settings: Dimension tab" topic in the "Setting your Preferences" section) and modify the dimension information PC-DMIS should display.

Note: The "Analysis Settings" section of each dimension's dialog box allows you to display the dimension printout in a format suitable for close examination.


Displaying Dimensions in RTF and PDF Files

You can send the inspection report with its dimensions to an external RTF (Rich Text Format) or PDF (Portable Document Format) file by selecting the output options in the Print Options dialog box for the Edit window. See "Printing from the Inspection Report" in the "Using Basic File Options" section.

Be aware that because of formatting limitations between the RTF and PDF outputs, dimensions are displayed somewhat differently in the two files.

  • In RTF files, dimensions are printed with a light border around the header, a blue background color, and the dimension symbol.

  • In PDF files, dimensions are printed without a border, there is no background color, and no dimension symbol. Dimensions are printed with a left margin.


Common Dimension Dialog Box Options

There are several options available to many of the Dimension dialog boxes.

More:

Material Conditions

Display Dimension Info

Edit Default Dimension Info

Units

Analysis Settings

Output To


Material Conditions

The Material Conditions area contains the following tolerancing methods:

Option button | Stands For | Description
M | MMC | Maximum material condition applied to either the feature or a datum.
R | RFS | Regardless of feature size applied to either the feature or a datum.
L | LMC | Least material condition applied to either the feature or a datum.

Currently you can select Material Condition modifiers for True Position, Parallelism, and Perpendicularity dimensions.

Be aware that for True Position dimensions, selecting the Use Datums check box will cause the XYZ output values to use the alignment of the datums.

More:

Recall Button


Recall Button

The Recall button in the Material Conditions area allows you to easily select the same datums used in a previous similar dimension. This button remains unavailable for selection until you select a feature to dimension from the Feature list.

For example, suppose you used four circles, as your datums in a previous True Position dimension. You can easily tell PC-DMIS to use these same circles as your features by selecting the feature to dimension from the Feature list, and clicking the Recall button. PC-DMIS will then select the datums from the Feature list.


Display Dimension Info

The Display check box will create a DIMINFO command in the Edit window after the dimension. This command will show all dimension information in the Graphics Display window next to the feature selected in the Feature List box. This DIMINFO command will also display the same dimension axes that are available in the Edit window for that particular dimension.

To use the Display option:

  1. Select the Display check box.

  2. Select the feature to dimension.

  3. Click the Create button.

Dimension information will then appear in the Graphics Display window.

Dimensional Data Displayed in the Graphics Display window.

For more in depth information on DIMINFO boxes and on rules governing their creation, see "Inserting Dimension Info Boxes" in the "Inserting Report Commands" section.


Edit Default Dimension Info

The Edit button will bring up the Edit Default Dimension Info dialog box.

Edit Default Dimension Info dialog box

These check boxes allow you to select the type of information displayed in the Graphics Display window for each dimension. The available check boxes are:

Auto | The Auto check box automatically displays the following information: Measured, Nominal, Tolerances, Deviation, MaxMin, OutTol.
Measured | This check box displays the actual measured dimensions.
Nominal | This check box displays the theoretical values for the dimension.
Tolerances | This check box displays the acceptable tolerance levels either greater than or less than the nominal.
Deviation | This check box displays the deviation of the measured value from the nominal.
MaxMin | This check box displays the maximum and minimum values for the dimension
OutTol | This check box displays how far out of tolerance the measured value is from the nominal and tolerance values.
Mean | This check box displays the average of all the deviations for the dimension.
StdDev | This check box displays the standard deviation of all the deviations for the dimension
Number of Points | This check box displays the number of points used to measure the feature of the dimension.

For more in depth information on editing dimensions and on rules governing their creation, see "Inserting Dimension Info Boxes" in the "Inserting Report Commands section. The following five buttons: OK, Cancel, Default, Recall, and Reset all deal with the Edit Default Dimension Info dialog box.

More:

Reset Button


Reset Button

The Reset button clears any selected check boxes in the Edit Default Dimension Info dialog box and selects the Auto check box.


Units

The Units area allows you to choose between the following two options:

  • Inch = Inches

  • MM = Millimeters

The unit of measurement selected will be used for dimensioning while the current dialog box is still open. The default selection is the current unit of measurement of the current part program


Analysis Settings

Analysis area for Location and True Position dimensions

Analysis area for all other dimensions

The Analysis area allows you to set the dimensional output analysis format to textual, graphical, or both when viewing a dimension's deviations.

Unique to Location and True Position dimensions, the Analysis area allows you to analyze not only a feature's location, but a feature's form as well.

Note: Use caution when interpreting a Location or True Position dimension's graphical data along with its integrated form dimension. You'll find that analysis tolerance lines will likely overlap and make distinguishing difficult.

More:

Textual

Graphical

Multiplier

Both Option (for True Position and Location)

Form Option (for True Position and Location)


Textual

When you select the Textual check box (or the On option for Location and True Position dimensions), PC-DMIS will print out the following in the inspection report for each individual hit used in the dimension:

  • Measured X, Y, and Z values

  • Measured I, J, and K values

  • Deviation of each individual hit

  • "MAX" or "MIN" marker at the end of the line whenever the hit produces either a maximum or minimum deviation.

Example of the Textual Analysis Report


Graphical

When you select the Graphical check box (or the On option for Location and True Position dimensions), PC-DMIS lets you output the dimensional printout in a format suitable for close examination.

When selected, PC-DMIS will graphically display the deviation of each individual hit for the dimensions used on the part in the Graphical Display window. The program displays the error in the form of individual arrows for each hit. These arrows, with their colors and directions, indicate the relative size of the error, as well as its direction.

Command line in the Edit window:
...GRAPH=ON TEXT=OFF MULT=1.00

Consider this example which uses the dimension information displayed in the textual analysis example in "Textual":

Example of a Roundness Dimension using Graphical Analysis with a multiplier of ten (on the left) and one (on the right)

The Roundness example above contains various colored lines, arrows, and circles. The following table describes the colored elements in the example and what they mean:

Colored Element | Description
Black Circle | Shows the nominal circle.
Red Circle | Shows the measured, out-of-tolerance circle.
Blue Circles | Show the tolerance bands.
Colored Lines | Show the lines between hits.
Colored arrows | Show the hits themselves (the tip of the arrow), the relative size of the deviation for each hit (by the colored arrow), and in which direction deviation occurs (the direction the arrow points).

The colors used in this example are the default dimension colors. You can easily change these colors if desired. The colors used will also correspond to the colors used on the bar graph on Dimension Info and Point Info boxes. See "Editing Dimension Colors" in the "Editing the CAD Display" section.


Multiplier

The Multiplier box is a scaling factor that magnifies the deviation arrows and tolerance zone by the value typed for the graphical analysis mode. If you type a 2.0 value, PC-DMIS will scale the arrows two times the calculated deviation for each feature hit.

This changes the arrow's size for viewing purposes only. It does not affect the size of the deviation in the text printout in any way.


Both Option (for True Position and Location)

  • Textual: Selecting Both displays deviations for both the location and the form axes in the inspection report.

  • Graphical: Selecting Both displays tolerancing lines for both a feature's location dimension and the integrated form dimension, possibly overlapping one another.


Form Option (for True Position and Location)

With the Form option you can analyze dimensional information for a feature's location and a feature's form at the same time (in versions earlier than 3.25 you would have to do a separate dimension to get a feature's form).

Remember: You must select the Form check box in the Axes area of the dialog box to use the Analysis area to report on a feature's form. See "Default Axes" for additional information.

Selecting Form, acts as if you automatically selected the Both option as well, since both a graphical and a textual analysis are generated.


Output To

Dimension output can be printed to either the inspection report or to statistical files used by statistics software, to both of these, or to none at all. This is controlled through the Output To area of the dialog box, which contains these options:

  • Statistics – sends output to statistical files

  • Report – sends output to inspection report

  • Both –sends output to both inspection report and statistical files

  • None – doesn't send dimension output anywhere

Upon the dimension's execution, the output will go to the inspection report, the stats file, both of these, or none of them (depending on the selection).

Note that if either the Stats option or the Both option is selected, a preceding STATS/ON command must exist inside the Edit window for this dimension to be sent to the stats file.


 Units area Analysis area Edit button Clear button Tolerances for Location Dimensions Close button Create button Display check box Feature List box ID Feature Search ID Output To area Axes area ISO Limits and Fits area Search Last # Sheet Metal Axes area Location Options area

Dimensioning Location

Feature Location dialog box

Display Menu Roadmap

The Insert | Dimension | Location menu option calculates the distance from the feature to the X, Y, Z origin, parallel to its respective axis. The feature's diameter, angle, and vector are also part of the calculation. This section relates only to location or coordinate dimensioning. For position dimensions, see "Dimensioning True Position".

Location can be calculated using Cartesian or Polar coordinates, True Position or box tolerancing.

  • To switch between Cartesian and Polar coordinates, select Pang or Prad in the Feature Location dialog box.

  • To switch between TRUE POSITION and RECT tolerancing methods see the "Dimensioning True Position" dimension option.

For legacy Circularity and Cylindricity dimensions as well as a Location dimension's RN Line, the feature solution is used to compute the dimension. By default this is Least Squares. However, you can choose to solve the feature using Minimum Separation, Maximum Inscribed, Minimum Circumscribed, or Fixed Radius regression algorithms.

FCF Circularity and Cylindricity dimensions on the other hand are computed using the Chebychev algorithm (Min/Max) as required by the Y14.5 standard. Because of the change in calculation, Circularity and Cylindricity FCF dimensions will generally compute to a slightly smaller value than their legacy counterparts.

More:

To Dimension a Feature Using the LOCATION Option:

Default Axes for Location Dimensions

Sheet Metal Axes

Location Options

Tolerances for Location Dimensions

ISO Limits and Fits


To Dimension a Feature Using the LOCATION Option:

  1. Select Insert | Dimension | Location from the submenu. The Feature Location dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Select the desired axes from the Axes area. The Auto check box is marked as the default.

If the Auto check box is marked, PC-DMIS will automatically determine the default axes to display in the dimension. The default axes are based on the feature type, as shown in the table below.

The default output format for the following features is:

CIRCLE | X, Y, D (based on the work plane).
CONE | X, Y, Z, A
CYLINDER | X, Y, Z, D, L (based on the work plane).
ELLIPSE | X, Y, Z, D, A, L
LINE | Based on the axis that is perpendicular to the axis closest to (and the axis related to) the work plane the line is measured in.
PLANE | Based on the axis most closely related to the plane.
POINT | X, Y, Z, T
SLOT | X, Y, D, R, L (based on the work plane).
SPHERE | X, Y, Z, D

  4. Select the axes from the Axes drop-down list to which you want to apply Plus and Minus tolerances.

  5. Type the Plus tolerance value in the Plus box.

  6. Type the Minus tolerance value in the Minus box.

  7. Type a value for the Nominal size in the Nominal Size box.

  8. Select a Tolerance Class from the Tolerance Class drop-down list.

  9. Select a Tolerance Grade from the Tolerance Grade drop-down list.

  10. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  11. Select either the Inch or MM option from the Units area of the dialog box.

  12. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  13. Select the desired Analysis options by selecting the Textual check box or the Graphical check box. If the Graphical check box was selected, type the Multiplier value in the Multiplier box.

  14. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  15. Click the Create button. If you did not select any check boxes from the Axes area, the Create button will be unavailable for selection.

The dimension will appear in the Edit window with this information:

dimension_name = TYPE OF DIMENSION,feat_1 UNITS=IN ,$
GRAPH=OFF TEXT=OFF MULT=1.00 OUTPUT=BOTH

 | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
x | 8.0000 | 0.1000 | 0.1000 | 8.0000 | 8.5000 | 7.5000 | 0.0000 | 0.0000
y | 3.0000 | 0.1000 | 0.1000 | 3.0000 | 3.5000 | 2.5000 | 0.0000 | 0.0000
z | 0.4947 | 0.1000 | 0.1000 | 0.4947 | 0.1428 | 0.8466 | 0.0000 | 0.0000
d | 1.0000 | 0.1000 | 0.1000 | 1.0000 | 1.0000 | 1.0000 | 0.0000 | 0.0000
v | 0.0000 | 0.5938 | 0.8046 |  |  |  |  |

END OF DIMENSION dimension_name (for LOCATION only)


Default Axes for Location Dimensions

When the Auto check box in the Axes area is checked, the axes displayed in the dimension are selected according to the default axes of the feature type, but are grayed out:

If you select multiple features of different types (for example a circle feature and a point feature), the Axes area will select the axes to use for the last selected feature:

In some circumstances it may be necessary to override the default setting. The Default check box remains available so you can alter the format of the default output.

To alter the default output:

  1. Select the feature(s) to dimension.

  2. Select the Default check box. The Auto check box is cleared and all axes become available for selection.

  3. Select the appropriate axes as needed.

X = prints X axis value.
Y = prints Y axis value.
Z = prints Z axis value.
Prad = prints the Polar Radius.
Pang = prints the Polar Angle.
D = prints Diameter value. For an ellipse, this is the minor diameter value
 (same as H).
R = prints Radius (half of Diameter) value.
A = prints Angle value.
L = prints Length (used for cylinder, cones, slots, and ellipses.) For
 an ellipse, L gives you the major diameter value.
H = prints the Height (used on cones, cylinders, and ellipses). For an
 ellipse, H gives you the minor diameter value.
V = prints the Vector location.
Form = prints the feature's integrated form dimension with the location
 dimension

  • For a circle, cylinder, or cone feature, this is the Roundness (RN) dimension.

  • For a plane feature this is the Flatness (FL) dimension.

  • For a line feature this is the Straightness (ST) dimension.

  3. Click the Create button.

Once the output values have been changed to something other than the default, PC-DMIS will use the new setting for all subsequent dimensions. If you want to PC-DMIS to then use the original default axes, you must reset the format to the default settings.

To reset the format to the default settings:

  1. Select the Default check box.

  2. Select the Auto check box. All the axes check boxes become grayed out.

  3. Select the feature(s) to dimension. The original default axes are selected.

  4. Click the Create button.

PC-DMIS will automatically reset the dimension to print the default axes according to feature type.


Sheet Metal Axes

The Sheet Metal Axes area contains check boxes only available when sheet metal features (Auto Features) are being dimensioned.

T = prints the deviation along the approach vector (for points on curved surfaces).
S = prints the deviation along the surface vector.
RT = prints the deviation along the report vector.
RS = prints the deviation along the surface report.
PD = prints the diameter of a circle (perpendicular to the pin vector).

If a T, RT, S, or RS axis is used, none of the other location dimensions is used for the analysis (graphical or textual).

For Location dimensions of Vector Point, Surface Point, Edge Point, and Angle Point features, the default Sheet Metal Axes output format is T. Location dimensions of all the other auto feature types do not initially have any of these axes selected.


Location Options

PC-DMIS also allows you to print two specialty axes :

  • Retrolinear Only

  • Gap Only

Either option can be selected in the Locations Options area of the Feature Location dialog box. All future locations of vector, surface, and edge points within the part program will be printed using the appropriate specialty axes until the option is turned OFF.

More:

Retrolinear Only for Location Dimensions

Gap Only for Location Dimensions


Retrolinear Only for Location Dimensions

Display Menu Roadmap

This check box is available when dimensioning vector and surface points. When the retrolinear only option has been selected for valid points, the location axes are calculated by:

· Finding the largest component of the theoretical surface normal vector (largest in x, y, or z direction).

· Projecting the measured point to this largest component vector in a manner that the projection is perpendicular to the original theoretical surface normal vector.

The location axes are then calculated from this new projected point.


Gap Only for Location Dimensions

Display Menu Roadmap

The Gap Only check box is available when dimensioning edge points. When you select the Gap Only check box, and an edge point is measured, the location axes are calculated by:

  • Projecting the measured point (1) to the theoretical surface.

  • Projecting this new point on to the theoretical approach vector.

Any location axes are then calculated from this new point.

A - Theoretical Surface Normal

B - Measured Point

C - Theo Point

D - Gap

E - Theoretical Approach Vector


Tolerances for Location Dimensions

The Tolerances area allows you to type plus and minus tolerances for each of the following axes found in the Axes drop-down list.

To Enter in plus and minus tolerances:

  1. Select the axis for which you will enter the tolerance from the Axes drop-down list.

  2. In the Plus box type the plus tolerance value for this axis.

  3. In the Minus box type the Minus tolerance value for this axis.

PC-DMIS allows positive-lower tolerances (or a positive tolerance in the negative range). This is done by entering in a minus sign before the value in the Minus box.

PC-DMIS also allows a negative-upper tolerance (or a minus tolerance in the positive range). This is done by entering in a minus sign before the value in the Plus box.

Example: If 1.000 is entered for the nominal, .003 is entered for the plus tolerance and .001 is entered for the minus tolerance it would be interpreted as 1.000 + .003 / –.001. To get the lower tolerance to be +.001 (sign change) simply type in 1.000 (nominal), .003 (plus tol) and –.001 (minus tol) thereby achieving a tolerance range of 1.000 + .003 / + .001.

Note: Negative lower tolerances may be displayed with a minus sign if the Minus Tols Show Negative option has been selected. See ”Minus Tols Show Negative” in the "Setting Your Preferences" section.

More:

Axes Drop Down list

Plus Tolerances

Minus Tolerances


Axes Drop Down list

The Axes drop-down list provides you with a list of available axes, to which you can apply Plus and / or Minus tolerances. The list contains the following:

ALL | All the axes and options displayed in the drop down list
X | X axis value
Y | Y axis value.
Z | Z axis value.
D | Diameter
R | Radius (half of Diameter)
A | Angle (for cones)
L | Length (used for cylinders, slots, cones and ellipses)
H | Height
PR | Polar Radius
PA | Polar Angle
T | Error along the approach vector (for points on curved surfaces)
RT | Deviation along the report vector
S | Deviation along the surface vector
RS | Deviation along the surface report
PD | Diameter of a circle (perpendicular to the pin vector)
FORM | Feature's integrated form dimension. · For a circle or cylinder feature, this is the Roundness (RN) dimension. * For a plane feature this is the Flatness (FL) dimension. · For a line feature this is the Straightness (ST) dimension.


Plus Tolerances

In the Plus box you can type the plus values for tolerances of the axis or axes selected from the Axes drop-down list.


Minus Tolerances

In the Minus box you can enter the minus values for tolerances of the axis or axes selected from the Axes drop-down list.


ISO Limits and Fits

The ISO Limits and Fits area of the dialog box allows you to apply ISO standardized tolerances to the diameter of circular features. When a tolerance class and grade have been selected, PC-DMIS will look up the appropriate tolerances for the diameter of a cylinder or circle from the International Organization for Standardization’s tables of Limits and Fits. These tables define the tolerances for various design classes and grades of diameters. Although PC-DMIS allows the calculation of ISO tolerances in English (Inch) and metric (mm) units, they are only defined by ISO to be applied with metric (mm) units. Also, because these tables use various classes and grades of diameters, cylinders and circles are the only appropriate features for this option. If no nominal diameter is entered, PC-DMIS uses the feature’s nominal diameter for the tolerance calculations.

More:

Nominal Size

Tolerance Class

Tolerance Grade


Nominal Size

The Nominal Size box allows you to enter the nominal diameter of the feature selected.


Tolerance Class

The Tolerance Class drop-down list allows you to select from the following ISO Tolerance classes:

A

B

C

CD

D

E

EF

F

FG

G

H

J

JS

K

M

N

P

R

S

T

U

V

X

Y

Z

ZA

ZB

ZC


Tolerance Grade

The Tolerance Grade drop-down list allows you to select from the following ISO Tolerance grades:

IT1 | IT7 | IT13
IT2 | IT8 | IT14
IT3 | IT9 | IT15
IT4 | IT10 | IT16
IT5 | IT11 | IT17
IT6 | IT12 | IT18


 ID Feature Search ID Feature List box Clear button Display check box Create button Close button Tolerances for True Position Dimensions Edit button Output To area Analysis area Units area Axes area Material Conditions area Deviation area For Axial Features area

Dimensioning True Position

True Position dialog box

Display Menu Roadmap

The Insert | Dimension | True Position menu option calculates the true position from the feature to the X, Y, or Z origin parallel to its respective axis. The feature's diameter, angle, and vector are also part of the calculation.

This section relates only to true position dimensions. Location or coordinate dimensioning is discussed in the "Dimensioning Location" section.

Important: If datums are used, the measured and deviation XYZ values are calculated with respect to the alignment of the datums, but are displayed in the current alignment in order to interpret the values. This means that a feature reported with one true position dimension can have different measured and deviation values than another true position dimension if the dimensions have different or no datums defined, even if they have the same nominal values.

More:

To Dimension a Feature Using the TRUE POSITION Option:

To Apply True Position on a Group of Circles or Cylinders

Using Datums

Default Axes for True Position Dimensions

Deviation

Axial Features

Tolerances for True Position Dimensions


To Dimension a Feature Using the TRUE POSITION Option:

  1. Select Insert | Dimension | True Position from the submenu. The True Position dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. If a datum is desired, select the Use Datums check box. Be aware that selecting this will cause the dimension to be calculated with respect to the datums. However, the XYZ output values will be displayed with respect to the current alignment in the part program.

  4. Select any desired datum features from the Feature List box.

  5. Set the Material Conditions for the feature(s) and datum(s) by selecting the appropriate options in the Material Conditions area.

  6. Select check boxes from the Deviation area as desired.

  7. If you're dimensioning an axial feature (such as a cylinder), type a value in the Reference Length box and select the appropriate option from the For Axial Features area.

  8. Select the desired axes from the Axes area. The Auto check box is selected as the default.

  9. Select the axes to which you want to apply plus and minus tolerances.

  10. Type the plus tolerance value in the Plus box.

  11. Enter the minus tolerance value in the Minus box.

  12. Select either the Inch or MM option in the Units area.

  13. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  14. Select the desired analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, enter the Multiplier value in the Multiplier box.

  15. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  16. Click the Create button. If you did not select any check boxes from the Axes area, the Create button will be unavailable for selection.

The dimension will appear in the Edit window with this information:

DIM dimension_name = TRUE POSITION OF FEAT_ID UNITS = IN/MM,
GRAPH=ON/OFF TEXT=ON/OFF MULT=n OUTPUT=REPORT/STATS/BOTH/NONE
FIT TO DATUMS=ON/OFF DEV PERPEN CENTERLINE=ON/OFF DISPLAY=DIAMETER/RADIUS

AX | NOM | MEAS | +TOL | -TOL | BON | DEV | DEVANG | OUTTOL
X | 0.7500 | .07500 | 0.0000 |  |  | 0.0000 |  |
Y | 3.0000 | 3.0000 | 0.0000 |  |  | 0.0000 |  |
DF | 1.0000 | 1.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000 |  | 0.0000
D1 D2 D3 TP | 1.0000 1.0000 MMC | 1.0000 1.0000 1.0000 | 0.0000 0.0000 0.0000 | 0.0000 0.0000 | 0.0000 0.0000 0.0000 | PLANE CIRCLE CIRCLE 0.0000 | P1 AT RFS C1 AT MMC C2 AT MMC 0.000 | 0.0000

END OF dimension_name


To Apply True Position on a Group of Circles or Cylinders

  1. Create a feature set of the holes from the Insert | Feature | Constructed | Set menu option (see "Constructing a Set of Features" from the "Constructing New Features from Existing Features" section for instructions on creating feature sets.). Display Menu Roadmap

  2. Select the True Position menu option. The True Position dialog box appears.

  3. From the True Position dialog box, select the created feature set as the input feature, and select any other options used for the dimension.

  4. Select the Textual check box from the Analysis area.

  5. Access the Report window (View | Report window) and from the Reporting toolbar, select the View Report Mode icon. You are now able to see the deviation of each feature and the translation and rotation required to bring the features into tolerance. Results are always shown using Regardless of Feature Size (RFS ) on Datum to see the maximum deviation.


Using Datums

Although there are many different combinations of features that may be used as datums for True Position dimensions, there are some general principles to follow when selecting datum features.

One common scenario for designs that utilize True Position dimensions is to use a circle or cylinder as the sole datum feature.

Another accepted practice is to select a set of datum features that follow 3-2-1 alignment principles. (Remember, the minimum definition for a datum is 3 datum points to describe the first datum, 2 datum points to describe the second datum and 1 datum point to describe the third datum.) This means that the selected features would be a plane, a line, and then a single point.

However, 3-2-1 alignment principles can also be used with plane/line/line, plane/line/circle, plane/cylinder/cylinder, and many other combinations.

When multiple circular features have been used with the Maximum Material Condition (MMC ) or Least Material Condition (LMC ),

  • The bonus tolerance from the TP axis will not likely be a simple addition of other bonus tolerances, as a best-fit calculation will occur to determine the correct bonus tolerance.

  • Any circular or slot features may be measured using MMC or LMC.

  • All non-circular features are measured Regardless of Feature Size (RFS ).

Note: When datum features have been selected, the True Position's X,Y,Z, PA, and PR axes are calculated with respect to the alignment of the datums, but are displayed in the current alignment in order to interpret the values. Also, the datum features must be selected using the general steps discussed in this topic or else the dimension is likely to give unexpected results.

General Rules for True Position Dimensions when Use Datums is Selected:

  • Select all the datums specified in the feature control frame so that proper fitting is performed. The features selected for datum 1, datum 2 and datum 3 represent the Primary, Secondary and Tertiary Datums and are used to constrain up to six degrees of freedom (3 degrees of translation and 3 degrees of rotation).

  • Ensure that all Measured Feature commands (datums and feature) contain the correct nominal values (X,Y,Z,I,J,K) in the THEO field (fitting references the measured feature commands to calculate datum constraints and the dimensional results).

  • The Measured Feature command and the associated True Position Dimension command must come from the same alignment (ensures the nominal values are correct and the same as what is called out as basic dimensions on the drawing).This is critical when programming without CAD as it will require editing measured feature commands (guess mode) to provide the correct nominal values (used for fitting).

  • DO NOT use Ignore CAD to Part option in the Setup Options dialog box General tab.

Note: We recommend that you use the newer True Position Feature Control Frame method of dimensioning when there are modifier(s) (MMC or LMC) on the Datum(s). The Legacy True Position command with Use Datums selected is available for program migration.

Bonus Refinement

When calculating the bonus on a datum, if there is a previous True Position dimension or orientation dimension on that datum feature, then the True Position and/or orientation tolerance is added to the datum bonus to calculate the virtual size of the datum.

More:

Using the Same Datums when Repeating Dimensions

Examples of Use Datums with Legacy True Position


Using the Same Datums when Repeating Dimensions

To use the same datums from a previous True Position dimension in your current True Position dimension, select the Feature to dimension, and click the Recall button available in the Material Conditions area. See "Recall Button".


Examples of Use Datums with Legacy True Position

Examples of Use Datums with Legacy True Position Dimension

The Use Datums option in the True Position dialog box allows the analysis to be performed in three ways.

  1. From the active Alignment. - See Option #1 Below

  2. From a mathematical Virtual Hard Gage simulation (Fit to Datums: ON). - See Option #2 Below

  3. From a Datum Reference Frame simulation (Fit to Datums: OFF). - See Option #3 Below

These are discussed in turn. All examples reference the illustration below (Features, Datums, and Alignment):

Option #1: Use Datums: OFF

Application: Use this method when there are no modifier(s) (MMC or LMC) on the datum(s) and when checking the True Position of one or multiple features (single feature or a pattern) from a Datum Reference Frame (DRF). Bonus tolerance is only available on the feature(s).

Results: The True Position of the selected feature(s) is evaluated in the active alignment. Therefore, the active alignment must be set up to reflect the specified DRF before creating the True Position dimension(s).

Example of True Position "Use Datums" Off:

Option #2: Use Datums: ON and Fit to Datums: ON

Application: Use this method when there are modifier(s) (MMC or LMC) on the datum(s) and when checking the True Position of a single feature (multiple features are not supported in legacy dimension mode).

Note: True Position of multiple features and MMC/LMC on the Datum feature(s) is supported when using the newer True Position Feature Control Frame method of dimensioning.

Results: A ”Virtual Hard Gage” simulation is performed mathematically by translating and rotating based on the amount of bonus tolerance from the datum(s). This results in the measured values for the feature changing by the amount of ”datum shift” which simulates the jiggling of the gage. In many cases, the measured values may be the same as the nominal values when there is sufficient bonus from the datum features. When the feature is out of tolerance, no fitting occurs, and the measured values and deviations reflect the actual location of the feature such that process adjustments can be made or an engineering analysis of the nonconformance can be performed.

Note: The results are representing ”Pass/Fail” analysis just as a functional gage does; therefore, it is not possible to monitor for process variation or perform statistical studies.

Bonus Column: The bonus column in the report shows the calculated amount of bonus of the feature (DF) and the calculated amount of bonus of each datum feature of size (D1 primary, D2 secondary, D3 tertiary). The total bonus value is determined based on the following conditions:

Condition #1A: In-Tolerance

When sufficient bonus tolerance from the datum(s) allows datum shift such that there is no deviation from the nominal values without utilizing up to 100% of the allowable bonus from the datum(s), the total bonus amount is the sum of the bonus from the feature and the unused amount of bonus from the datum(s).

Example of Condition #1A In-Tolerance:

The measured values changed based on the allowable datum shift derived from the bonus of datums D2 and D3 (simulates a functional gage). In this case the measured values check nominal resulting in zero deviation, and the total bonus is the sum of the bonus from the feature (.006) and the unused bonus from the datums (.002) for a total of .008 bonus tolerance.

  • Two degrees of freedom from bonus on D2 (.008 bonus): translation in X and Y axis

  • One degree of freedom from bonus on D3 (.008 bonus): rotation about Z axis

Condition #1B: In-Tolerance

When 100% of the bonus from the datum(s) is used then the total bonus amount is only the bonus from the feature. Typically this case would show some amount of deviation from the nominal values.

Example of Condition #1B In-Tolerance:

Note: The tolerance for D2 and D3 were changed to illustrate using 100% of the bonus from the datums where there is deviation from nominal yet still an In-Tolerance condition.

Condition #2: Out of Tolerance

When there is insufficient bonus from the datum(s) to allow datum shift such that the feature is In-Tolerance, no fitting is performed, the measured values are not altered and the total bonus is only the bonus from the feature.

Example of Condition #2 Out of Tolerance:

Note: The tolerance for the DF, D2, D3 and the TP were changed to illustrate the out of tolerance condition.

Option #3: Use Datums: ON and Fit to Datums: OFF

Application: Use this method when there are modifier(s) (MMC or LMC) on the Datum(s) and you do not want the measured data fitted (no datum shift). This option was added based on customer request to provide the ability to incorporate bonus from a Datum and still monitor for process variation (the measured values are not altered because no ”datum shift” is applied).

Note: This method is not compliant with Y14.5M 1994.

Results: A ”Datum Reference Frame” simulation is performed mathematically by Translating and Rotating based on the degrees of freedom constrained by the selected Datum(s). The X, Y, or Z measured values and deviations are from the active alignment and are not altered based on the bonus from the datum features (no datum shift).

Bonus Column: The bonus column in the report shows the calculated amount of bonus of the feature (DF) and the calculated amount of bonus of each datum feature of size (D1 primary, D2 secondary, D3 tertiary). The total bonus value is the sum of the bonus from the feature and the datum with the smallest amount of bonus amongst the selected datums.

Example of Condition #1 In-Tolerance:

Example of Condition #2 Out of Tolerance:

Note: The tolerance for the DF, D2, D3, and TP were changed to illustrate the out of tolerance condition.


Default Axes for True Position Dimensions

The Default check box allows you to alter the format of the default output. When the Auto check box is checked, the axes displayed in the dimension are selected according to the default axes of the feature type. However, in some circumstances it may be necessary to override the default setting. To do this you would select the Default check box and any other desired axes.

To alter the output, simply select the desired check boxes:

Auto = prints the default axes based on the feature type.
X = prints X axis value.
Y = prints Y axis value.
Z = prints Z axis value.
Form = prints the integrated form dimension for the feature.
· For a circle or cylinder feature, this is the Roundness (RN) dimension.
· For a plane feature this is the Flatness (FL) dimension.
· For a line feature this is the Straightness (ST) dimension.
Pang = prints polar angle (PA) value.
Prad = prints polar radius (PR) value.
Default = Alters the format of the default output.

Once the output values have been changed to something other than the default, PC-DMIS will use the new setting for all subsequent dimensions. If you want to PC-DMIS to then use the original default axes, you must reset the format to the default settings.

To reset the format to the default settings:

  1. Select the Auto check box.

  2. Select the Default check box.

  3. Click the Create button.

PC-DMIS will automatically reset the dimension to print the default axes according to feature type.

Note: If the Auto check box is marked, PC-DMIS will automatically determine the default axes to print. The default output format is based on the feature type. PC-DMIS will automatically determine the true position of the selected feature using the documented (see box above) axis format.


Deviation

The Deviation area allows you to select options that determine how you want deviations performed and how you want deviations displayed in the Edit window.

More:

Fit to Datums

Deviation Perpendicular to Centerline

Display As Radius


Fit to Datums

The Fit To Datums check box determines whether or not PC-DMIS calls the fitting algorithm when datums are used.

  • When selected, PC-DMIS calls the fitting algorithm when datums are specified. It reports the considered feature in the fitted position with the total bonus being the remaining available bonus after fitting.

  • When cleared, PC-DMIS analyses the True Position Dimension with features in their measured position with no fitting applied. The reported total bonus is the total available bonus from the considered feature and the datum according to the datum constraints.


Deviation Perpendicular to Centerline

The Deviation Perpto Centerline check box determines whether PC-DMIS calculates the deviation perpendicular to the feature's theoretical centerline or perpendicular to the direct X, Y, and Z values.

  • If selected, PC-DMIS calculates the deviation perpendicular to the feature's theoretical centerline, ignoring any deviation in the direction of the centerline.

  • If deselected, PC-DMIS calculates the deviation perpendicular to the X, Y, and Z values.

This check box is especially useful with sheetmetal points which may have approach vectors not oriented along the X, Y, or Z axis. This check box will allow the deviation to be found perpendicular to the approach vector.


Display As Radius

The Display As Radius check box determines whether or not PC-DMIS will display the radii of the features and datums instead of displaying their diameters.

  • If selected, PC-DMIS displays the radii in the DF, D1, D2, D3, and TP lines and places text in the Edit window's dimension field showing whether the dimension is displaying the features' radius or diameter.

  • If deselected, PC-DMIS displays the diameters as usual.

Important: If you use this check box, be aware that it is not compliant with ISO standards.


Axial Features

For axial features, such as cylinders, you can specify where along the axis PC-DMIS should create the True Position dimension. You can tell PC-DMIS to create the dimension at the axis' average (or centroid ), at the axis' start point, at the axis' end point, at the axis' worst end (the end with the greatest deviation), or at both ends of the axis. You can also create the dimension at a specified reference length away from the selected point on the axis.

To use the reference length with a True Position dimension:

  1. Type the desired value in the Reference Length box.

  2. Select one of the option buttons (From Axis Average, From Start Point Of Axis, From End Point Of Axis, From Worst End Of Axis, or From Both Ends Of Axis).

  3. Click the Create button. PC-DMIS locates the selected point (or points if you've selected From Both Ends Of Axis) and then moves along the axis the distance of the specified reference length and creates the dimension(s) there.

Option | Description
Reference Length | The value in this box specifies the length from the selected point or axis end where PC-DMIS will create the True Position dimension.
From Axis Average | This option tells PC-DMIS to dimension the axial feature, from the centroid (or average) of the axis.
From Start Point of Axis | This option tells PC-DMIS to dimension the axial feature from the Start Point of the axis.
From End Point of Axis | This option tells PC-DMIS to dimension the axial feature from the End Point of the axis.
From Worst End of Axis | This option tells PC-DMIS to dimension the axial feature from the start or end point that gives the worst-case scenario for the dimension. PC-DMIS creates the dimension at the axis end that deviates the farthest from the nominal. For example if your part contains a skewed cylinder, the start or end point along the cylinder's axis that deviates farthest from the nominal is the point that gives the worst-case scenario.
From Both Ends of Axis | This option tells PC-DMIS to dimension the axial feature, from both the start and end point of the axis selected. PC-DMIS creates a dimension at both ends of the axis.


Tolerances for True Position Dimensions

The Tolerances area allows you to type plus and minus tolerances for each axis found in the Axes drop-down list; it also lets you define certain material condition modifiers.

To enter in axes tolerances:

  1. Select the axis for which you will enter the tolerance.

  2. In the Plus box enter in the plus tolerance value for this axis.

  3. In the Minus box enter in the minus tolerance value for this axis.

  4. Select the materials condition modifiers from the Materials Condition area.

You can set tolerances for multiple axes from the list. PC-DMIS stores your defined tolerances with the selected list item. Even if you select a different item from the Axes list and give it different tolerances, you can switch between the available axes to view and set their individual stored tolerances.

More:

Axes

Plus

Minus


Axes

The Axes drop-down list provides you with a list of available axes, to which you can apply plus and / or minus tolerances. The list contains the following:

ALL | All the axes and options displayed in the drop down list
D1 | Diameter /Width of the first datum
D2 | Diameter/Width of the second datum
D3 | Diameter/Width of the third datum
DF | Diameter/Width of the feature
LF | Length of the feature if the feature is a slot
WF | Width of the feature if the feature is a slot
LD | Length of the datum if the datum is a slot
WD | Width of the datum if the datum is a slot
TP | True position tolerance and its associated deviation
FORM | The integrated form dimension for the feature. · For a circle or cylinder feature, this is the Roundness (RN) dimension. · For a plane feature this is the Flatness (FL) dimension. · For a line feature this is the Straightness (ST) dimension.


Plus

In the Plus box you can enter the plus values for tolerances of the axis or axes selected from the Axes drop-down list.


Minus

In the Minus box you can enter the minus values for tolerances of the axis or axes selected from the Axes drop-down list.


 Units Analysis area Edit button Clear button Tolerances for Concentricity Dimensions Close button Create button Display check box Last Two button Feature List box ID Feature Search ID Output To area Units Analysis area Edit button Clear button Tolerances for Distance Dimensions Close button Create button Display check box Last Two button Feature List box ID Feature Search ID Output To area Distance Type area Orientation area Relationship area Circle Options area

Dimensioning Distance

Distance dialog box

Display Menu Roadmap

The Insert | Dimension | Distance menu option calculates the distance between two features. You can select a third feature or an axis for the direction to use in the calculation.

Calculating distance is a bit more difficult to visualize than most of the other dimension calculations. Distance that is calculated between two features uses either the default or straight line method. Two-dimensional distances using a straight line will be parallel to the work plane. Three-dimensional distances using a straight line will be from centroid to centroid.

More:

To Dimension a Distance Using the DISTANCE option:

Tolerances for Distance Dimensions

General Rules for 2D and 3D Distance Dimensions

Relationship for Distance Dimensions

Orientation for Distance Dimensions

Circle Options


To Dimension a Distance Using the DISTANCE option:

  1. Select Insert | Dimension | Distance from the submenu. The Distance dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Enter the plus tolerance value in the Plus box.

  4. Enter the minus tolerance value in the Minus box.

  5. Select either the 2 Dimensional or 3 Dimensional option in order to specify the distance type.

  6. Select either Inch or MM in the Units area.

  7. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  8. Select either the To Feature, To X Axis , To Y Axis or To Z Axis option to determine the relationship that defines the distance.

  9. Select either the Perpen To or the Parallel To radio button.

  10. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  11. Select the desired analysis options by selecting the Textual check box or the Graphical check box. If the Graphical check box was selected, type the multiplier value in the Multiplier box.

  12. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  13. Click the Create button.

The dimension will appear in the Edit window with this information:

DIM dimension_name = 2D_DISTANCE FROM feat_1 TO feat_2 TOG1 TO TOG2, TOG3, UNITS=MM/IN,
GRAPH=ON/OFF TEXT=ON/OFF MULT=n OUTPUT=NONE/REPORT/STATS
or
DIM dimension_name = 3D_DISTANCE FROM feat_1 TO feat_2, TOG3, UNITS=MM/IN,
GRAPH=ON/OFF TEXT=ON/OFF MULT=n OUTPUT=NONE/REPORT/STATS

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 5.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000

TOG1 = PAR / PERP (Parallel or Perpendicular)

TOG2 = XAXIS / YAXIS / ZAXIS / feature

work plane = this field can be changed to any feature. The default is the current workplane.

TOG3= NO_RADIUS / ADD_RADIUS / SUB_RADIUS


Tolerances for Distance Dimensions

The Tolerances area allows you to type plus and minus tolerances for distances along the plus and minus directions.

More:

Plus Tolerance

Minus Tolerance

Nominal for Distance


Plus Tolerance

The Plus box allows you to enter a tolerance value along the plus direction. This means that any angle that measures more than your nominal or theoretical angle can still be a valid angle as long as it falls within the tolerance range specified.


Minus Tolerance

This Minus box allows you to enter a tolerance value along the minus direction. This means that any angle that measures less than your nominal or theoretical angle can still be a valid angle as long as it falls within the tolerance range specified.


Nominal for Distance

Nominal values for the distance between features aren't always based on CAD data or measured data. Often you will obtain them from a hard copy printout, you can use the Nominal box to enter the nominal distance value from the printout.


General Rules for 2D and 3D Distance Dimensions

2D and 3D distance dimensions apply the following rules according to the related features:

Treatment of Features

  • Spheres, Points, and Sets are treated as Points.

  • Slots, Cylinders, Cones, Lines, and Circles are treated as Lines.

  • Planes are treated normally, as Planes.

Other Rules

  • If both elements are points (as defined above), PC-DMIS gives the shortest distance from point to point.

  • If one element is a line (as defined above) and the other is a point, PC-DMIS gives the shortest distance between the line (or centerline) and the point.

  • If both elements are lines, and the Shortest check box is not selected, PC-DMIS gives the shortest distance between the centroid of the first line to the second line. See the "Shortest check box" topic for what happens when it is selected.

  • If one element is a plane and the other is a line, PC-DMIS gives the shortest distance between the centroid of the line and the plane

  • If one element is a plane and the other is a point, PC-DMIS gives the shortest distance between the point and the plane.

  • If both elements are planes, PC-DMIS gives the shortest distance between the centroid of the second plane to the first plane.

More:

2D Distance

3D Distance

Shortest check box


2D Distance

The maximum and minimum distance is the measured distance between two lines over the length of the lines.

The 2 Dimensional option calculates the two-dimensional distance between features. All features used to calculate the 2D distance are first projected into the current work plane before the distance is computed. PC-DMIS computes the maximum, minimum, and average distances between the two features. If the distance is between two lines or planes, the maximum, minimum and average are computed using the measurement point data. (Verify that the distance type is set to 2 Dimensional.)

2D distances that are calculated using three features will be either parallel or perpendicular to a datum feature. The datum feature can be any previously measured or constructed feature.

To calculate the distance using three features:

  1. Select the two features that will be used to calculate the distance.

  2. Select the third (datum) feature. (Using a line for the third feature will provide the best results.)

  3. Verify that the correct orientation is marked.

  4. Select the To Feature check box.

  5. Click the Create button.

PC-DMIS will calculate the distance between the first two features parallel or perpendicular to the third (datum) feature or axis.

Note: When the Close button is clicked, PC-DMIS will close the Distance dialog box without creating another dimension.


3D Distance

The 3 Dimensional option calculates the three-dimensional distance between two features.

  • If one of the input features is a line, centerline, or plane, PC-DMIS computes the 3D distance normal to that feature.

  • If both features are lines, centerlines, or planes the second feature is used for the datum.

  • If neither input feature is a line, centerline, or plane, PC-DMIS computes the shortest distance between the two features. (Verify that the mode is set to 3 Dimensional.)


Shortest Check Box

Distance Dimension showing Shortest check box

The Shortest check box, when selected, calculates the true shortest distance between two lines. This check box becomes enabled for selection when you choose 3 Dimensional from the Distance Type area and the input features for the dimension are two lines.

By default, assuming you are working on a dimension created in version 4.3 and later, PC-DMIS automatically selects the check box when the above conditions are met. However, if you access the Distance dialog box for a distance dimension created prior to 4.3, the check box will not be selected by default.

  • If you select the Shortest check box, PC-DMIS calculates the distance between two lines as the minimum distance between any point on the first line and any point on the second line.

  • If you do not select this check box, PC-DMIS behaves as it did prior to 4.3 and returns the shortest distance between the centroid of the first line to the second line.


Relationship for Distance Dimensions

The check boxes in the Relationship area of the dialog box allow you to specify whether the distance measured between two features will be perpendicular to or parallel to a specific axis, or perpendicular to or parallel to a selected feature:

More:

To Feature

To X Axis

To Y Axis

To Z Axis


To Feature check box

When you select the To Feature check box the Perpen To, or Parallel To options in the Orientation area become available for selection. These options tell PC-DMIS to compute the distance between the first selected feature and the second selected feature parallel to, or perpendicular to a certain feature.

If only two features are selected from the list, PC-DMIS computes the distance between feature 1 and feature 2, parallel or perpendicular to feature 2.

If three features are selected from the list, PC-DMIS computes the distance between feature 1 and feature 2, parallel or perpendicular to feature 3.

The feature used to establish the relationship should be a linear feature.


To X Axis check box

Select the To X Axis check box if you are measuring the distance from the first selected feature to the second selected feature, perpendicular to or parallel to the X axis.


To Y Axis check box

Select the To Y Axis check box if you are measuring the distance from the first selected feature to the second selected feature, perpendicular to or parallel to the Y axis.


To Z Axis check box

Select the To Z Axis check box if you are measuring the distance from the first selected feature to the second selected feature, perpendicular to or parallel to the Z axis.


Orientation for Distance Dimensions

When measuring the distance between two features you have the option of determining how the distance is to be measured by using these orientation options.

  • Measure the distance between the first selected feature parallel or perpendicular to either the second or another selected feature.

  • Measure the distance between the first selected feature and the second selected feature parallel to or perpendicular to a specific axis.

The Perpendicular To and the Parallel To options allow you to determine the orientation of the features.

More:

Perpendicular To

Parallel To


Perpendicular To

Select the Perpendicular To option if the distance between the two features is perpendicular to either the second feature, or perpendicular to a specified axis.


Parallel To

Select the Parallel To option if the distance between the two features is parallel to either the second feature, or parallel to a specified axis.


Circle Options

With the Circle Options area you can use the Add Radius and Subtract Radius options to tell PC-DMIS to either add or subtract the radius of the measured feature to the total distance that is measured. The amount that is added or subtracted will always be along the same vector that calculates the distance. Only one option is available at a time.

Using the No Radius option does not apply the radius of the feature to the distance measured.


 ID Feature Search ID Feature List box Last Two button Clear button Display check box Create button Close button Tolerances for Angle Dimensions Edit button Output To area Analysis area Relationship area Angle Type area

Dimensioning Angle

Angle dialog box

Display Menu Roadmap

The Insert | Dimension | Angle menu option calculates the angle between two selected features. (Verify that the option To Feature is selected.) If only one feature is specified, the angle is calculated between the major axis of the current working plane (the default axis is X) and the selected feature. If the angle reported by PC-DMIS is not in the correct quadrant (you want 0.0, not 180.0), just type the correct nominal angle in the Edit window. PC-DMIS will automatically convert the quadrant to match the nominal angle.

The direction of the lines determines the angle that is measured.

The Angle dimension calculates the angle between the specified features, and checks if the angle is within tolerances. The Angle dimension's tolerance band is in radians or degrees and forms an angle.

The measured value is an angle (blue). The Angle tolerance band is another angle (black).

Important Changes: In version 4.3, PC-DMIS improved its method of calculating Angle dimensions. If you load a part program from 3.7 or earlier into the current version, PC-DMIS will display a message informing you that the way Angle dimensions were calculated has changed and that all Angle dimensions in the program were updated.

More:

To Dimension the Angle Between Two Features:

Tolerances for Angle Dimensions

Angle Type

Relationship for Angle Between Dimensions


To Dimension the Angle Between Two Features:

  1. Select Insert | Dimension | Angle from the submenu. The Angle dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Type the plus tolerance value in the Plus box.

  4. Type the minus tolerance value in the Minus box.

  5. Select either the 2 Dimensional or 3 Dimensional option in order to specify the angle type.

  6. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  7. Select the To Feature, To X Axis, To Y Axis, or To Z Axis option to determine the relationship that defines the angle.

  8. Select the desired analysis options by selecting the Textual check box or the Graphical check box. If the Graphical check box was selected, type the multiplier value in the Multiplier box.

  9. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  10. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = 2D_ANGLE,FROM feat_1,TO feat_2,
or
dimension_name = 3D_ANGLE,FROM feat_1,TO feat_2

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
A | 5.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000

Editing Degrees, Minutes, and Seconds Values

When manually editing the Angle Between's Nominal or Tolerance value in the Edit window, and the angle value is displayed in Degrees, Minutes, and Seconds, you will need to type a comma between each value. For example, if you wanted 100°33'51" as your Nominal angle value, you would need to type 100,33,51 in the Nominal field and then press TAB for PC-DMIS to accept that value.

Note: To determine whether or not PC-DMIS displays Angle dimensions formatted in Degrees, Minutes, and Seconds, use the AngleDegMinSec registry entry in the Options section of the PC-DMIS Settings Editor. A value of 1 uses this format, while 0 uses the standard decimal value format.


Tolerances for Angle Dimensions

The Tolerances area allows you to type plus and minus tolerances along the plus and minus directions.

More:

Plus Tolerance

Minus Tolerance

Nominal for Angle Between


Plus Tolerance

The Plus box allows you to enter a tolerance value along the plus direction. This means that any profile that measures more than your nominal or theoretical profile can still be a valid measurement as long as it falls within the tolerance range specified.

PC-DMIS also allows a negative-upper tolerance (or a minus tolerance in the positive range). This is done by entering in a minus sign before the value in the Plus box.


Minus Tolerance

The Minus box allows you to enter a tolerance value along the minus direction. This means that any profile that measures less than your nominal or theoretical profile can still be a valid measurement as long as it falls within the tolerance range specified.

PC-DMIS allows positive-lower tolerances (or a positive tolerance in the negative range). This is done by typing a minus sign before the value in the Minus box.


Nominal for Angle Between

Nominal values for Angle dimensions aren't always based on CAD data or measured data. Often you will obtain them from a hard copy printout, you can use the Nominal box to enter the nominal angle value from the printout as a decimal value.


Angle Type

The Angle Type area determines whether or not the angle is 2 or 3 dimensional.

More:

2 Dimensional Angle Type

3 Dimensional Angle Type


2 Dimensional Angle Type

The 2 Dimensional option calculates the two-dimensional angle between features.


3 Dimensional Angle Type

The 3 Dimensional option calculates the three-dimensional angle between features. If only one feature is selected, the angle is calculated between the current working plane and the selected feature. See "Dimensioning Angle" for instructions on converting the quadrant of the reported angle.


Relationship for Angle Between Dimensions

The check boxes in the Relationship area of the dialog box allow you to specify whether the Angle dimension can calculate the angle between two features, or between one feature and a particular axis : X axis, Y axis, and Z axis.

More:

To Feature

To X Axis

To Y Axis

To Z Axis


To Feature

Select the To Feature check box if you are measuring the angle between two features.

The second feature will be the datum feature.


To X Axis

Select the To X Axis check box if you are measuring the angle between a feature and the X axis.


To Y Axis

Select the To Y Axis check box if you are measuring the angle between a feature and the Y axis.


To Z Axis

Select the To Z Axis check box if you are measuring the angle between a feature and the Z axis.


Dimensioning Concentricity

Concentricity dialog box

Display Menu Roadmap

If a sphere is selected as the first feature, the second feature must also be a sphere. PC-DMIS will then three-dimensionally calculate the concentricity between the two features.

The Insert | Dimension | Concentricity menu option calculates the concentricity of two circles or cylinders, cones, spheres. The second feature that is entered is always the datum feature and may be a line feature that represents an axis. If only one feature is selected, the current working plane becomes the datum feature. This dimension type is considered one sided, meaning a single positive value tolerance is applied.

More:

To Dimension a Feature Using the CONCENTRICITY Option:

Tolerance for Concentricity Dimensions


To Dimension a Feature Using the CONCENTRICITY Option:

  1. Select Insert | Dimension | Concentricity from the submenu. The Concentricity dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Type the plus tolerance value in the Plus box.

  4. Select either Inch or MM in the Units section.

  5. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  6. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  7. Select the desired analysis options by selecting the Textual check box or the Graphical check box. If the Graphical check box was marked, type the multiplier value in the Multiplier box.

  8. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  9. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = CONCENTRICITY,FROM feat_1,TO feat_2

or

dimension_name = CONCENTRICITY,FROM feat_1,TO THE ORIGIN

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 2.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000


Tolerance for Concentricity Dimensions

The Plus box allows you to enter a tolerance value along the plus direction. This means that any concentricity that differs from your nominal or theoretical concentricity can still be a valid measurement as long as it falls within the tolerance range specified.


 Projection area Units area Analysis area Edit button Clear button Plus Tolerance for Coaxiality Close button Create button Display check box Last Two button Feature List box ID Feature Search ID Output To area

Dimensioning Coaxiality

Coaxiality dialog box

Display Menu Roadmap

The Insert | Dimension | Coaxiality menu option calculates the coaxiality of a cylinder, cone, or line with a datum feature. The second feature that is entered is always the datum feature, and may be a cylinder, cone, line, or circle. If only one feature is selected, and you click Create, PC-DMIS will clear the list box and display a message informing you that it needs a second feature.

This dimension type is considered one sided, meaning a single positive value tolerance is applied.

More:

To Dimension a Feature Using the COAXIALITY Option:

Plus Tolerance for Coaxiality Dimensions

Projected Distance for Coaxiality


To Dimension a Feature Using the COAXIALITY Option:

  1. Select Insert | Dimension | Coaxiality from the submenu. The Coaxiality dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Type the plus tolerance value in the Plus box.

  4. Select either Inch or MM in the Units area.

  5. Select where to output the dimension information. Select the Statistics, Report, Both, or None options.

  6. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  7. Select the desired Analysis options by selecting one or both of the check boxes. If the Graphical check box was selected, enter the Multiplier value in the Multiplier box.

  8. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  9. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = COAXIALITY,FROM feat_1,TO feat_2
or
dimension_name = COAXIALITY,FROM feat_1,TO THE ORIGIN

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 2.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000

Note: After the dimension is created, the dialog box will remain open. If desired, use your Edit button at this time to edit aspects of your dimension's information. See "Edit Default Dimension Info".


Plus Tolerance for Coaxiality Dimensions

This Plus box allows you to enter a tolerance value along the plus direction. This means that any coaxiality that differs from your nominal or theoretical coaxiality can still be a valid measurement as long as it falls within the tolerance range specified.


Projected Distance for Coaxiality

PC-DMIS allows you to type a reference distance. This option is useful when you want to specify the points along the feature axis to be used in the coaxiality calculations. When this distance is zero, the two points used will be the endpoints of the feature's axis. When this distance is nonzero, the two points used will be the starting point of the axis, and along the axis vector the distance from the starting point.

Increasing the projected distance will magnify the error. Decreasing the distance lessens the error. For example, suppose two toothpicks lay on a table, sharing the same line and touching each other at one end. At the other end of the toothpicks, about two inches apart, the error between their centerlines might be 0.005 inches. Now imagine those toothpicks are 20 inches long, they would still touch at one end and the error would be 0.005 inches at 2 inches away, but at 20 inches away from the first end, the toothpicks might have a 0.05 inch error.

The value you type in the Distance box reflects the total length of the feature.


Dimensioning Circularity

Circularity dialog box

Display Menu Roadmap

One hit, plus the feature's minimum hit requirement is necessary to determine the roundness of that feature. Additional hits provide a better representation of the roundness of the entire feature.

The Insert | Dimension | Circularity menu option determines the roundness of a circle, sphericity of a sphere or the conicity of a cone. This dimension type is considered one sided, meaning a single positive value tolerance is applied.

For legacy Circularity and Cylindricity dimensions as well as a Location dimension's RN Line, the feature solution is used to compute the dimension. By default this is Least Squares. However, you can choose to solve the feature using Minimum Separation, Maximum Inscribed, Minimum Circumscribed, or Fixed Radius regression algorithms.

FCF Circularity and Cylindricity dimensions on the other hand are computed using the Chebychev algorithm (Min/Max) as required by the Y14.5 standard. Because of the change in calculation, Circularity and Cylindricity FCF dimensions will generally compute to a slightly smaller value than their legacy counterparts.

More:

To Dimension a Feature Using the CIRCULARITY Option:

Plus Tolerance for Circularity Dimensions


To Dimension a Feature Using the ROUNDNESS Option:

To Dimension a Feature Using the CIRCULARITY Option:

  1. Select Insert | Dimension | Circularity from the submenu. The Circularity dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Type the plus tolerance value in the Plus box.

  4. Select either Inch or MM in the Units section.

  5. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  6. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  7. Select the desired Analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, enter the Multiplier value in the Multiplier box.

  8. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  9. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = CIRCULARITY,OF feat_1

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000


Plus Tolerance for Circularity Dimensions

The Plus box allows you to enter a tolerance value along the plus direction. This means that any roundness that differs from your nominal or theoretical roundness can still be a valid measurement as long as it falls within the tolerance range specified.


Dimensioning Cylindricity

Cylindricity dialog box

Display Menu Roadmap

The Insert | Dimension | Cylindricity menu option determines the cylindricity of a cylinder. This dimension type is considered one sided, meaning a single positive value tolerance is applied.

For legacy Circularity and Cylindricity dimensions as well as a Location dimension's RN Line, the feature solution is used to compute the dimension. By default this is Least Squares. However, you can choose to solve the feature using Minimum Separation, Maximum Inscribed, Minimum Circumscribed, or Fixed Radius regression algorithms.

FCF Circularity and Cylindricity dimensions on the other hand are computed using the Chebychev algorithm (Min/Max) as required by the Y14.5 standard. Because of the change in calculation, Circularity and Cylindricity FCF dimensions will generally compute to a slightly smaller value than their legacy counterparts.

More:

To Dimension a Feature Using the CYLINDRICITY Option

Plus Tolerance for Cylindricity Dimensions


To Dimension a Feature Using the CYLINDRICITY Option

  1. Select Insert | Dimension | Cylindricity from the submenu. The Cylindricity dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box. You can only select cylinder features.

  3. Type the plus tolerance value in the Plus box.

  4. Select either Inch or MM in the Units section.

  5. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  6. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  7. Select the desired Analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, enter the Multiplier value in the Multiplier box.

  8. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  9. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = CYLINDRICITY,OF feat_1

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000


Plus Tolerance for Cylindricity Dimensions

The Plus box allows you to enter a tolerance value along the plus direction. This means that any cylindricity that differs from your nominal or theoretical cylindricity can still be a valid measurement as long as it falls within the tolerance range specified.


Dimensioning Straightness

Straightness dialog box

Display Menu Roadmap

A minimum of three hits are necessary to determine the straightness of a line.

The Insert | Dimension | Straightness option calculates the straightness of a line. This dimension type is considered one sided, meaning a single positive value tolerance is applied.

More:

To Dimension a Feature Using the STRAIGHTNESS Option:

Plus Tolerance for Straightness Dimensions


To Dimension a Feature Using the STRAIGHTNESS Option:

  1. Select Insert | Dimension | Straightness from the submenu. The Straightness dialog box appears. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Type the plus tolerance value in the Plus box.

  4. Select either Inch or MM in the Units section.

  5. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  6. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  7. Select the desired Analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, enter the Multiplier value in the Multiplier box.

  8. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  9. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = STRAIGHTNESS,OF feat_1

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000


Plus Tolerance for Straightness Dimensions

This Plus box allows you to enter a tolerance value along the plus direction. This means that any straightness that differs from your nominal or theoretical straightness can still be a valid measurement as long as it falls within the tolerance range specified.


Dimensioning Flatness

Flatness dialog box

Display Menu Roadmap

A minimum of four hits are necessary to determine the flatness of a plane.

The Insert | Dimension | Flatness menu option determines the flatness of a plane. This dimension type is considered one sided, meaning a single positive value tolerance is applied.

More:

To Dimension a Feature Using the FLATNESS Option:

Plus Tolerance for Flatness


To Dimension a Feature Using the FLATNESS Option:

  1. Select Insert | Dimension | Flatness from the submenu. The Flatness dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Type the plus tolerance value in the Plus box.

  4. Select either Inch or MM in the Units section.

  5. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  6. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  7. Select the desired Analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, enter the multiplier value in the Multiplier box.

  8. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  9. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = FLATNESS,OF feat_1

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000


Plus Tolerance for Flatness

The Plus box allows you to enter a tolerance value along the plus direction. This means that any flatness that differs from your nominal or theoretical flatness can still be a valid measurement as long as it falls within the tolerance range specified.


 Units area Analysis area Edit button Clear button Plus Tolerance for Perpendicularity Close button Create button Display check box Last button Feature List box ID Feature Search ID Output To area Projected Distance Material Conditions area

Dimensioning Perpendicularity

Perpendicularity dialog box

Display Menu Roadmap

The Insert | Dimension | Perpendicularity menu option measures the perpendicularity between two features. The second feature is always the datum feature. When only one feature is selected, the current working plane becomes the datum feature. This dimension type is considered one sided, meaning a single positive value tolerance is applied.

More:

To Dimension a Feature Using the PERPENDICULARITY Option:

Plus Tolerance for Perpendicularity Dimensions

Projected Distance for Perpendicularity Dimensions


To Dimension a Feature Using the PERPENDICULARITY Option:

  1. Select Insert | Dimension | Perpendicularity from the submenu. The Perpendicularity dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Select the appropriate Material Condition options for the feature(s) and datum.

  4. If a datum feature is desired, select the Use Datums check box and select another feature in the Feature List box.

  5. Select the appropriate Material Condition options for the feature(s) and datum.

  6. Type the plus tolerance value in the Plus box.

  7. Enter the projected distance in the Distance box.

  8. Select either Inch or MM in the Units section.

  9. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  10. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  11. Select the desired Analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, type the Multiplier value in the Multiplier box.

  12. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  13. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = PERPENDICULARITY,OF feat_1,TO feat_2

or

dimension_name = PERPENDICULARITY,OF feat_1,TOworkplane

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000


Plus Tolerance for Perpendicularity Dimensions

The Plus box allows you to enter a tolerance value along the plus direction. This means that any perpendicularity that differs from your nominal or theoretical perpendicularity can still be a valid measurement as long as it falls within the tolerance range specified.


Projected Distance for Perpendicularity Dimensions

PC-DMIS allows you to type a reference distance in the Distance box. This option is useful when the feature not only needs to be perpendicular to the datum feature, but needs to be calculated a certain distance away from the datum as well.


 Units area Analysis area Edit button Clear button Plus Tolerance for Parallelism Close button Create button Display check box Last button Feature List box ID Feature Search ID Output To area Projected Distance Material Conditions area

Dimensioning Parallelism

Parallelism dialog box

Display Menu Roadmap

The Insert | Dimension | Parallelism menu option measures the parallelism between two features. The second feature is always the datum feature. When only one feature is selected, the current working plane becomes the datum feature. This dimension type is considered one sided, meaning a single positive value tolerance is applied.

More:

To Perform a Dimension Using PARALLELISM:

Plus Tolerance for Parallelism Dimensions

Projected Distance for Parallelism Dimensions


To Perform a Dimension Using PARALLELISM:

  1. Select Insert | Dimension | Parallelism from the submenu. The Parallelism dialog box appears. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. If a datum feature is desired, select the Use Datums check box.

  4. If a datum feature is desired, select another feature in the Feature List box.

  5. Select the appropriate Material Condition options for the feature(s) and datum.

  6. Type the plus tolerance value in the Plus box.

  7. Type the projection distance in the Distance box.

  8. Select either the Inch or MM option in the Units area.

  9. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  10. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  11. Select the desired analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, enter the Multiplier value in the Multiplier box.

  12. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  13. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = PARALLELISM,OF feat_1,TOG1,TO feat_2,TOG1

or

dimension_name = PARALLELISM,OF feat_1,TOG1,TOworkplane

AX | NOM | +TOL | -TOL | BON | MEAS | MAX | DEV | OUT-TOL
DF D1 M | 1.0000 0.0000 0.0000 | 0.0100 0.0100 0.0100 | 0.0100 0.0100 0.0100 | 0.0000 0.0000 0.0000 | 1.0000 0.0000 0.0000 | 0.0000 | 0.0000 0.0000 0.0000 | 0.0000 0.0000 0.0000

TOG1= MMC / RFS / LMC

Explanation of Axes

DF is the Diameter/Width of the feature. This appears when you set LMC or MMC conditions.

D1 is the Diameter/Width of the first datum. This appears when you set a datum feature.

M is the measured value. This always appears.


Plus Tolerance for Parallelism Dimensions

The Plus box allows you to enter a tolerance value along the plus direction. This means that any parallelism that differs from your nominal or theoretical parallelism can still be a valid measurement as long as it falls within the tolerance range specified.


Projected Distance for Parallelism Dimensions

PC-DMIS allows you to type a reference distance in the Distance box. PC-DMIS uses this value with cylinder, cone, and line features to calculate the parallelism dimension.

For these features, the points used for the parallelism calculation are the end point of the axis and a point projected from this end point along the feature axis.

The distance between these two points is the referenced distance. For other features, this distance has no effect on the dimension. This option is useful when the dimension needs to be calculated a certain distance along the feature.

Understanding Parallelism's Distance Projection

Usually a parallelism dimension takes the datum line's vector, and checks the endpoints of the dimensioned feature to see if they are within tolerance as shown here:

A - Tolerance width (or cylinder).

B - Datum vector positioned at measured feature.

C - Datum line.

Sometimes, however, you can’t always measure right to the edge of the line, so you will need to extend the line out by a certain distance.

Since the extreme deviations are usually at the ends of the line, if you extend out the line to a distance longer than the actual length of the line you will usually get larger deviations. You can also extend the line's opposite direction by using a negative reference length.

An extended line may look like this:

A - Reference Length

B - Extended point, from reference length greater than line length

C - End point of line, or reference length same as line length.

D - Start point of line, or 0.0 reference length.

You can also use the Distance box to specify a reference length to check the axis of a cylinder.


Dimensioning Runout

 Units area Analysis area Edit button Clear button Plus Tolerance for Parallelism Close button Create button Display check box Last button Feature List box ID Feature Search ID Output To area Units area Analysis area Edit button Clear button Plus Tolerance for Parallelism Close button Create button Display check box Last button Feature List box ID Feature Search ID Output To area

Dimensioning Total or Circular Runout

Total Runout or Circular Runout dialog box

Display Menu Roadmap Display Menu Roadmap

The Insert | Dimension | Runout and Total Run menu options determine the runout of the first feature with respect to the second feature (i.e., the second feature becomes the datum feature). If only one feature is selected, the origin and the work plane become the datum feature. In this case, PC-DMIS uses the position from the origin and the direction from the workplane for the datum. The text in the Edit window for the datum feature will read "THE ORIGIN".

  • Circular Runout works for circles, cones, cylinders, and spheres.

  • Total Runout works for cylinders, cones, and planes.

This dimension type is considered one sided, meaning a single positive value tolerance is applied.

More:

Understanding Runout

To Dimension a Feature Using the RUNOUT Option:

Plus Tolerance for Runout Dimensions


Understanding Runout

Runout dimensioning is generally used in camshaft operations. A camshaft is designed to rotate around a center line. Since the separate cylinders comprising the camshaft are all on the same center line, you need to ensure that the centerline is not only parallel, but that the cylinders are also coaxial (or concentric).

Sample Camshaft

Additionally, you need to make sure the surface of the cylinders is round and straight (straight when compared to a separate datum axis, not just its own axis).

The main difference between runout and parallelism is that runout is checking points on a surface of a cylinder, and not just the axis of the cylinder. Runout also differs from a cylinder's straightness because it compares the surface of the cylinder to a datum axis, not just to itself. A runout dimension checks for these conditions.

More:

How Runout is Measured

Two Categories of Runout: Circular or Total

Using Runout to Check a Cylinder End


How Runout is Measured

The typical, non-CMM way to measure runout is to put a small dial indicator on the surface of the cylinder, zero-out the indicator, and then spin the cylinder. This indicator measures any difference along that circle as the cylinder rotates.

Runout with a Dial Indicator

A CMM essentially does the same thing. Instead of spinning the cylinder, however, the CMM's probe rotates around the cylinder and takes a finite number of hits.

The tolerance band for runout would look something like this:

Sample Runout Tolerance Band (Dotted Lines)

The tolerance band has these properties:

  • It has a width the size of the plus tolerance.

  • It is parallel to the datum vector (the axis of some other line or cylinder).

  • It is fixed at a certain radius from the cylinder’s axis.


Two Categories of Runout: Circular or Total

There are two categories for runout:

  • Circular Runout measures just one circle—one row of hits—around the cylinder.

  • Total Runout measures multiple circles up and down the entire surface of the cylinder with multiple rows of hits.

Obviously, you are somewhat limited using a CMM for total runout because you probably will not take 100 rows of hits around your cylinder, and something as little as 3 rows of hits clearly isn’t enough for determining total runout.

Nevertheless, PC-DMIS provides you with the ability to dimension both circular and total runout and lets you determine whether or not you've measured enough rows of the cylinder.


Using Runout to Check a Cylinder End

PC-DMIS also allows you to test for another case of runout specified in the standard: Checking the plane of one of the cylinder's ends. The tolerance for this type of runout is at a fixed orientation perpendicular to the datum axis.

Same Runout of a Cylinder's End


To Dimension a Feature Using the RUNOUT Option:

  1. Select Insert | Dimension | Total Runout or Circular Runout from the submenu. The Total Runout or Circular Runout dialog box appears. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Type the plus tolerance value in the Plus box.

  4. Select either Inch or MM in the Units area.

  5. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  6. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  7. Select the desired analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, enter the Multiplier value in the Multiplier box.

  8. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  9. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = RUNOUT,OF feat_1,TO feat_2

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000


Plus Tolerance for Runout Dimensions

The Plus box allows you to enter a tolerance value along the plus direction. This means that any runout that differs from your nominal or theoretical runout can still be a valid measurement as long as it falls within the tolerance range specified.


 ID Feature Search ID Feature List box Last button Clear button Display check box Create button Close button Tolerance for Straightness Dimensions Edit button Output To area Analysis area Units area Control Options area Best Fit Options area Units area Analysis area Edit button Clear button Tolerances for Line Profile Close button Create button Display check box Last Two button Feature List box ID Feature Search ID Output To area Control Options area Best Fit Options area

Dimensioning Surface or Line Profile

Surface Profile dialog box

Line Profile dialog box

The profile's Surface option computes the three-dimensional profile error of a surface or curve feature (Insert | Dimension | Profile | Surface). Display Menu Roadmap

The profile's Line menu option computes the two-dimensional profile error of a curve (Insert | Dimension | Profile | Line). Display Menu Roadmap

Note: The Profile dimension has changed from PC-DMIS 3.0 and earlier versions. You can now use any type of feature for a profile scan.

Important: By default PC-DMIS uses the 1983 ASME standard to calculate the measured value of a profile dimension. However, PC-DMIS 4.0 and higher allow you to switch between the current ASME standard and a newer ISO 1101 2004 standard. When doing a form and location profile dimension, the ISO standard calculates the measured value as 2 times the max deviation. The tolerance for this case is a diameter zone, all along the profile of the curve. This means the zone isn't just plus tolerance for one side and minus tolerance for the other. Additionally, the given single tolerance value is a diameter, not a radius.

To enable the ISO standard, access the PC-DMIS Settings Editor, navigate to the Option section and set UseISOCalculations to 1.

More:

To Dimension a Feature Using the Surface Profile Option:

To Dimension a 2D Feature Using the Line Profile Option:

Tolerances for Surface Profile Dimensions

Tolerances for Line Profile Dimensions

Control Options for Surface Profile Dimensions

Control Options for Line Profile Dimensions

Best Fit Options for Surface Profile Dimensions

Best Fit Options for Line Profile Dimensions


To Dimension a Feature Using the Surface Profile Option:

  1. Select Insert | Dimension | Profile | Surface from the submenu. The Surface Profile dialog box appears. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box. If a datum feature is selected, it must be a plane.

  3. Type the plus tolerance value in the Plus box.

  4. Type the minus tolerance value in the Minus box.

  5. Select either Inch or MM in the Units area.

  6. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  7. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  8. Select either Form Only or Form and Location in the Control Options area of the dialog box.

  9. If you selected Form Only, select the Use Best Fit check box. This causes the dimension to use the internal best fit alignment to allow the shape to rotate or translate until it finds the best fit for the feature.

  10. Select the desired analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, type the multiplier value in the Multiplier box.

  11. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  • If you've selected the Form and Location option earlier, be sure to select MaxMin check box from the Dimension Info Format area of the Edit Default Dimension Info dialog box.

  • If you've selected the Form Only option earlier, be sure to select the Measured check box from the Dimension Info Format area of the Edit Default Dimension Info dialog box.

  12. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = PROFILE,OF feat_1

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 5.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000

More:

Displaying Profile Contour Plots


Displaying Profile Contour Plots

PC-DMIS allows you to display a colored surface contour plot that will rest on the surface of the CAD model in the Graphics Display window when you use Patch scans or UV scans and create a profile dimension from them.

To do this:

  1. Import a solid CAD model.

  2. Access the View Setup dialog box. Display Menu Roadmap

  3. Click the Solid check box for one of your views and then close the dialog box.

  4. Place PC-DMIS in Surface mode.

  5. Create a Patch or UV scan (see "Performing a Patch Advanced Scan" or "Performing a UV Advanced Scan" in the "Scanning Your Part" section).

  6. Select the Insert | Report Command | Analysis menu option. The Analysis dialog box appears. Display Menu Roadmap

  7. Click View Window and then select Options | Dimension Options. The Dimension Analysis Options dialog box appears.

  8. Select the Show Contour Plot option, click OK until you return to the main PC-DMIS screen.

  9. Access the Surface Profile dialog box. Display Menu Roadmap

  10. Select the Patch or UV scan from the Feature List box.

  11. Select the Graphical check box from the Analysis area.

  12. Make any other desired changes to the Surface Profile dialog box.

  13. Click Create to generate the dimension.

You'll notice that PC-DMIS places a colored contour plot directly onto the model surface where the scan was.


To Dimension a Linear Feature Using the Line PROFILE Option:

To Dimension a 2D Feature Using the Line PROFILE Option:

  1. Select Insert | Dimension | Profile | Line from the submenu. The Line Profile dialog box appears. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box. You can select any 2D feature. If a datum feature is selected, it must be a plane.

  3. Type the plus tolerance value in the Plus box.

  4. Type the minus tolerance value in the Minus box.

  5. Select either Inch or MM in the Units area.

  6. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  7. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  8. Select either Form Only or Form and Location in the Control Options area of the dialog box.

  9. If you selected the Form Only option, select the Use Best Fit check box. This causes the dimension use the internal best fit alignment to allow the shape to rotate or translate until it finds the best fit for the feature.

  10. If you selected the Use Best Fit check box, select the desired workplane to allow rotation and translation. Using the workplane will restrict the alignment to be a two-dimensional alignment.

  11. Select the desired analysis options by marking the Textual check box or the Graphical check box. If the Graphical check box was marked, type the multiplier value in the Multiplier box.

  12. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  • If you've selected the Form and Location option earlier, be sure to select MaxMin check box from the Dimension Info Format area of the Edit Dimension Info dialog box.

  • If you've selected the Form Only option earlier, be sure to select the Measured check box from the Dimension Info Format area of the Edit Dimension Info dialog box.

  13. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = PROFILE,OF feat_1

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 5.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000

More:

Displaying Profile Contour Plots


Displaying Profile Contour Plots

PC-DMIS allows you to display a colored contour plot that will rest on the surface of the CAD model in the Graphics Display window for linear or curve features.

Follow the instructions listed in "Displaying Profile Contour Plots" for a Surface Profile, and simply substitute the input feature with the appropriate line or curve feature (or scan).


Tolerances for Surface Profile Dimensions

This dimension type is considered either one sided, meaning a single positive value tolerance is applied, or two sided, meaning upper and lower tolerance values are applied.

  • If the Form Only option has been selected, only a plus tolerance can be applied.

  • If the Form and Location has been selected, the profile dimension can be one sided or two sided.

More:

Plus Tolerance

Minus Tolerance


Tolerances for Line Profile Dimensions

This dimension type is considered either one sided, meaning a single positive value tolerance is applied, or two sided, meaning upper and lower tolerance values are applied.

  • If the Form Only option has been selected, only a plus tolerance can be applied.

  • If the Form and Location has been selected, the profile dimension can be one sided or two sided.

More:

Plus Tolerance

Minus Tolerance


Plus Tolerance

The Plus Tol box allows you to enter a tolerance value along the plus direction. This means that any measurement that measures more than your nominal or theoretical measurement can still be a valid measurement as long as it falls within the tolerance range specified.


Minus Tolerance

The Minus Tol box allows you to enter a tolerance value along the minus direction. This means that any measurement that measures less than your nominal or theoretical measurement can still be a valid measurement as long as it falls within the tolerance range specified.


Control Options for Surface Profile Dimensions

The options in this area determine if a profile matches the same form, or form and location as its nominal.

More:

Form Only

Form and Location


Form Only

When dimensioning a profile, selecting the Form Only option, you can tell PC-DMIS to only determine if a particular profile matches the same form as its nominal. This option ignores whether the location of the profile is outside of acceptable tolerances.

For a Form Only dimension, pay attention to the Measured values in the generated dimension.


Form and Location

When dimensioning a profile, using the Form and Location option, you can determine if a particular profile matches the same form and the same location as its nominal. This differs from the Form Only option, because the location of the profile must also be within acceptable tolerances.

For a Form and Location dimension, pay attention to Max / Min values in the generated dimension.


Control Options for Line Profile Dimensions

The options in this area determine if a profile matches the same form, or form and location as its nominal.

More:

Form Only

Form and Location


Best Fit Options for Surface Profile Dimensions

Note: This area only appears on the dialog box if you select the Form Only option from the Control Options area.

The Best Fit Options area lets you create an internal Best Fit alignment on the dimensioned feature using one of these available methods:

  • No Fit - No alignment is created.

  • Least Squares - This fit finds a position where the deviations are minimized. In this way, the Form Only option can ignore the location of the feature while checking that the curve is close to the nominal shape.

  • Vector - This fit snaps errors in the input features onto the theoretical vectors before minimizing the average squared error.

  • Min / Max - This fit minimizes the maximum error in all of the input features.

  • Optimized - This fit allows the measured data to shift and rotate within the tolerance domain until the data fits. You can also specify the lower tolerance value which typically is not allowed to change from 0.0 for the other fitting types.

See the "Creating a Best Fit Alignment" topic in the "Creating and Using Alignments" section.


Best Fit Options for Line Profile Dimensions

Note: This area only appears on the dialog box if you select the Form Only option from the Control Options area.

The Best Fit Options area lets you create an internal Best Fit alignment on the dimensioned feature using one of these available methods:

  • No Fit - No alignment is created.

  • Least Squares - This fit finds a position where the deviations are minimized. In this way, the Form Only option can ignore the location of the feature while checking that the curve is close to the nominal shape.

  • Vector - This fit snaps errors in the input features onto the theoretical vectors before minimizing the average squared error.

  • Min / Max - This fit minimizes the maximum error in all of the input features.

  • Optimized - This fit allows the measured data to shift and rotate within the tolerance domain until the data fits. You can also specify the lower tolerance value which typically is not allowed to change from 0.0 for the other fitting types.

Work Plane

When you use the line profile dimension, PC-DMIS creates an internal two-dimensional alignment that rotates and translates in all directions within the selected workplane to minimize the deviations of the individual hits. Selecting a workplane that differs from the two-dimensional projection of the curve results in an incorrect calculation.

See the "Creating a Best Fit Alignment" topic in the "Creating and Using Alignments" section.


 ID Feature Search ID Feature List box Last Two button Clear button Display check box Create button Close button Tolerances for Angle Dimensions Edit button Output To area Analysis area Units Projected Distance Reference Angle ID Feature Search ID Feature List box Last Two button Clear button Display check box Create button Close button Tolerances for Angle Dimensions Edit button Output To area Analysis area Units Projected Distance Reference Angle

Dimensioning Angularity

Angularity dialog box

Display Menu Roadmap

The Insert | Dimension | Angularity menu option computes the angularity error of a plane or line to a datum plane or line. (If only one feature is selected or keyed in, PC-DMIS uses the current working plane as the datum.)

Similar to perpendicularity or parallelism, the Angularity dimension allows you to specify an angle that isn't 90 degrees (perpendicularity) or 0 degrees (parallelism). For example, if you specify a 45 degree angle, PC-DMIS creates a tolerance band at 45 degrees, and checks that the hits are within that tolerance band.

The measured value is an angle (blue). The angularity's tolerance band is two parallel lines or planes (black) that never meet.

More:

To Compute the Angularity Error by Using the ANGULARITY Option:

Reference Angle

Plus Tolerance for Angularity Dimensions

Projected Distance for Angularity Dimensions


To Compute the Angularity Error by Using the ANGULARITY Option:

  1. Select Insert | Dimension | Angularity from the submenu. The Angularity dialog box will appear. Display Menu Roadmap

  2. Type the nominal angle from the datum in the Angle box.

  3. Select or type the plane/line, feature, and datum.

  4. Type the plus tolerance value in the Plus box.

  5. Type the projection distance in the Distance box.

  6. Select either Inch or MM in the Units area.

  7. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  8. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  9. Select either Form Only or Form and Location in the Control Options area of the dialog box.

  10. Select the desired analysis options by selecting the Textual check box or the Graphical check box. If the Graphical check box was selected, type the multiplier value in the Multiplier box.

  11. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  12. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = ANGULARITY FROM feat_1 TO feat_2 EXTENDLENGTH=n ANG=n UNITS=MM/IN

GRAPCH=ON/OFF TEXT=ON/OFF MULT=n OUTPUT=NONE/BOTH/STATS/REPORT

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000

feat_2: LINE or PLANE.

PC-DMIS then computes the angularity error and displays it in the current dimension window.


Reference Angle

The Angle box allows you to type the nominal angle from the datum feature. This is the angle between the two features. PC-DMIS then calculates the deviation of one feature from the angle.

Clicking the Find Theo Angle button calculates the nominal reference angle you should use from the theoretical values of the selected features. This makes it so you don't have to go and look up the angle in the Edit window.


Plus Tolerance for Angularity Dimensions

The Plus box allows you to type a tolerance value along the plus direction. This means that any angularity error that differs from your nominal or theoretical angularity error can still be a valid measurement as long as it falls within the tolerance range specified.


Projected Distance for Angularity Dimensions

PC-DMIS allows you to project a reference distance. This option is used with line features to calculate the angularity dimension.

For these features, the points used for the angularity calculation are the end point of the axis and a point projected from this end point along the feature axis.

The distance between these two points is the referenced distance. For other features, this distance has no effect on the dimension. This option is useful when the dimension needs to be calculated a certain distance along the feature.


Dimensioning Symmetry

Symmetry dialog box

Display Menu Roadmap

The Insert | Dimension | Symmetry menu option calculates the symmetry of a set of points with a datum feature, or two opposing lines with a datum feature.

  • If the first feature is a set, the second feature that is entered is the datum feature and must be either a plane or a line.

  • If the first feature is a line, the second feature must also be a line and the third feature that is entered is the datum feature. In this case the third feature must be a plane or a line. This dimension type is considered one sided, meaning a single positive value tolerance is applied.

  • If the third feature is a plane, the symmetry algorithm attempts to find a line on that plane that represents the datum. To find the correct line, it intersects (or crosses) the chosen plane with the work plane. For this reason, you should ensure that you are using the correct work plane.

According to the geometric dimensioning and tolerancing standard, the following graphic indicates how a symmetry dimension is interpreted and displayed.

Graphic Showing how PC-DMIS Interprets Symmetry Dimensions |
Explanation of Previous Graphic | 1 - The center plane of datum feature A. 2 - Order of point measurements. 3 - 0.8 wide tolerance zone. 4 - Opposed elements, with alternating points. 5 - Derived median points.
Within the limits of size and RFS, all median points of opposed elements of the slot must lie between two parallel planes 0.8 apart, the two planes being equally disposed about datum plane A. The specified tolerance and the datum reference can only apply on an RFS basis. |

Because of the way the symmetry is defined, PC-DMIS limits the features that can be used for the symmetry dimension. Since the points must be equally arranged about the datum in order to find midpoints between them, you must either select a feature set with alternating points or two opposing lines with the same number of points.

More:

To Dimension a Feature Using the SYMMETRY Option:

Plus Tolerance for Symmetry


To Dimension a Feature Using the SYMMETRY Option:

  1. Select Insert | Dimension | Symmetry from the submenu. The Symmetry dialog box will appear. Display Menu Roadmap

  2. Select the feature(s) to dimension from the Feature List box.

  3. Type the plus tolerance value in the Plus box.

  4. Select either Inch or MM in the Units area.

  5. Select where to output the dimension information. Select the Statistics, Report, Both, or None options.

  6. Select the optional Display check box if you want to view dimension information in the Graphics Display window.

  7. Select the desired Analysis options by selecting one or both of the check boxes. If the Graphical check box was selected, enter the multiplier value in the Multiplier box.

  8. If desired, select the Display check box in the Dimension Info area and click Edit to select the Dimension Info Format you would like displayed in the Graphics Display window.

  9. Click the Create button.

The dimension will appear in the Edit window with this information:

dimension_name = SYMMETRY,FROM feat_1 TO feat_2

or

dimension_name = SYMMETRY,FROM feat_1 AND feat 2 TO feat 3

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 0.0000 | 0.0100 | 0.0100 | 2.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000

Note: After the dimension is created, the dialog box will remain open. If desired, use your Edit button at this time to edit aspects of your dimension's information. See "Edit Default Dimension Info".

More:

Displaying Profile Contour Plots


Plus Tolerance for Symmetry

This Plus box allows you to enter a tolerance value along the plus direction. This means that any symmetry that differs from your nominal or theoretical symmetry can still be a valid measurement as long as it falls within the tolerance range specified.


Dimensioning through Keyboard Input

Dimensional Keyin dialog box

Display Menu Roadmap

The Insert | Dimension | Keyin menu option allows you to capture and "key in" through the keyboard data not measured with the CMM (for instance, adding a dimension that is measured with calipers). This option allows you to print out all inspection results on the inspection report (not just features measured with the CMM). It is also useful when collecting data for statistical analysis.

More:

To Add Dimensions Using the KEY IN Option:

Nominal

Actual

Tolerances for Keyboard Created Dimensions


To Add Dimensions Using the KEY IN Option:

  1. Select Insert | Dimension | Keyin from the submenu. The Dimensional Keyin dialog box will appear. Display Menu Roadmap

  2. Type the ID number for the dimension in the ID = box.

  3. Type the nominal value in the Nominal box.

  4. Type the actual value in the Actual box.

  5. Select where to output the dimension information. Select the Statistics, Report, Both, or None option.

  6. Click the Create button.

The dimension will then appear in the Edit window with this information:

dimension_name = KEYIN,feat_1

AX | NOM | +TOL | -TOL | MEAS | MAX | MIN | DEV | OUT-TOL
M | 5.0000 | 0.0100 | 0.0100 | 5.0000 | 0.0000 | 0.0000 | 0.0000 | 0.0000


Nominal

The Nominal box allows you to enter in the nominal (or theoretically perfect) measurement for a feature.


Actual

The Actual box allows you to enter in the actual measurement for a feature.


Tolerances for Keyboard Created Dimensions

You can type tolerances along the plus and minus directions of the newly generated dimension.

More:

Plus Tolerance

Minus Tolerance


Dimensioning Variables

There may be instances when working with expressions and variables that you want to create dimensions from variables that contain stored values. One popular way to do this is to first create a generic feature, populate the fields of the Generic Feature with the variable expressions you want to use, and then create a dimension of the Generic Feature.

For information on Generic Features, see the "Creating Generic Features" section. For information on variables, see the "Using Expressions and Variables" section.

More:

Dimensioning a Variable Example


Dimensioning a Variable Example

Suppose that you have these variables and you wanted to create a Location dimension using them:

ASSIGN/V_THEOX = 10

ASSIGN/V_THEOY = 5

ASSIGN/V_THEOZ = 1

ASSIGN/V_MEASX = 10.008

ASSIGN/V_MEASY = 5.035

ASSIGN/V_MEASZ = 0.997

Note: For ease of use, this example gives the variables constant values. In real life application, your variables will most likely have dynamic values that change based on user input or from other external sources.

To dimension these variables:

  1. Create a generic feature by selecting the Insert | Feature | Generic menu option. The Construct Generic Feature dialog box appears.

  2. Select the Point option.

  3. Select the Measured Values option and type zero values into the X, Y, and Z boxes, then select Nominal Values and do the same thing.

  4. Click OK. PC-DMIS will insert an empty Generic Feature (usually labeled F1 if it's your first Generic Feature) into the Edit window.

  5. Place the Edit window in Command mode and you will see this:

F1 =GENERIC/POINT,DEPENDENT,RECT ,$

NOM/XYZ,0,0,0,$

MEAS/XYZ,0,0,0,$

NOM/IJK,0,0,1,$

MEAS/IJK,0,0,1

  6. Now navigate to the line NOM/XYZ, and in the first three zero fields, type V_THEOX, V_THEOY, and V_THEOZ respectively. These are your nominal variables.

  7. Do the same thing on the MEAS/XYZ line, except type V_MEASX, V_MEASY, and VMEASZ into the three zero fields of that line. Your command should now look like this:

F1 =GENERIC/POINT,DEPENDENT,RECT,$

NOM/XYZ,V_THEOX,V_THEOY,V_THEOZ,$

MEAS/XYZ,V_MEASX,V_MEASY,V_MEASZ,$

NOM/IJK,0,0,1,$

MEAS/IJK,0,0,1

  8. Press F3 to mark the Generic Feature.

  9. Create a Location dimension using this feature. Give it a plus and minus tolerance of .02.

  10. Execute the part program.

You should get a dimension that looks something like this in your report:


Dimensioning True Position In-Between

Display Menu Roadmap

True Position In-Between

The Insert | Dimension | True Position In Between menu option computes the in-between true position deviation and deviation angle from two specified True Position dimensions. This dimension is useful when you have a set of true position dimensions on a pattern of holes and you want to report the true position deviation and deviation angle of one hole relative to another where each individual hole of the pattern has been dimensioned with a separate true position callout.

Note: The ANSI or ISO standards do not include True Position In-Between. This is special implementation unique to PC-DMIS.

To create this dimension:

  1. Access the True Position In Between menu option. The True Position In-Between dialog box appears.

  2. Select two dimensions from the True Position Dimensions list. This list includes both legacy and Feature Control Frame (FCF) True Position dimensions. If you select a composite FCF True Position or a FCF True Position with two single segments, PC-DMIS will only use the Primary Dimension to compute the True Position In-Between dimension.

  3. Type a label ID for the dimension by typing in the ID= box.

  4. Type a tolerance value for the dimension in the Tolerance box.

  5. Select the measurement units to use from the Units list.

  6. Click Create.

The dimension will appear in the Edit window with this information:

dimension_name =TRUE POSITION IN BETWEEN dim_1 AND dim_2, UNITS=IN/MM

AX NOMINAL MEAS +TOL -TOL BONUS DEV DEVANG OUTTOL

TP 0.0000 0.0000 0.0100 0.0000 -172.4842 0.0000 #-------

DEV is the deviation of the In-Between dimension. DEVANG is the deviation angle of the In-Between dimension.


Using Feature Control Frames

UsING Feature Control Frames: Introduction

What is a Feature Control Frame?

Rules for Using Feature Control Frame Dimensions

Creating a Feature Control Frame Dimension

Defining Datums

The GD&T Dialog Box

Feature Control Frame Command Block

Feature Control Frame Trihedron

Simultaneously Evaluating Feature Control Frames

Reporting True Position Feature Control Frames

Creating a Symmetry Feature Control Frame Dimension

Feature Control Frame Reporting Tables


Using Feature Control Frames: Introduction

PC-DMIS lets you insert valuable dimensioning information in the form of Feature Control Frames (FCFs) into your part program. FCFs are special, rectangular boxes that house standard GD&T symbols and information. When you insert a FCF into the Edit window, PC-DMIS also draws the actual frame in the Graphics Display window.

Sample Feature Control Frame Showing Perpedicularity Between LINE1 and LINE3

Sample Feature Control Frame (see FCF1)

To insert a FCF command, access the Insert | Dimension submenu, ensure that the Use Legacy Dimensions Display Menu Roadmap menu item is not selected, and then select the appropriate dimension. PC-DMIS displays the GD&T dialog box for that dimension. Once you create the FCF, PC-DMIS inserts it along with dimension information into the part program.

Note: FCFs provide you with a new way of dimensioning your part. All of the same options you had with previous Dimensioning functionality still exist with FCFs (see the Advanced tab in the GD&T dialog box). If you prefer the old way of doing dimensions, however, simply select the Use Legacy Dimensions menu item and PC-DMIS will insert dimensions the old way. See the "Dimensioning Features" section for information on legacy dimensions.

Also, since the Location , Distance , Angle , and Keyin dimensions are not part of the ASME and ISO standards, they are always created using legacy dimensions, even if you deselected the Use Legacy Dimensions menu item.

This section covers the following topics:

  • What is a Feature Control Frame?

  • Rules for Using Feature Control Frame Dimensions

  • Creating a Feature Control Frame Dimension

  • Defining Datums

  • The GD&T Dialog Box

  • Feature Control Frame Command Block

  • Feature Control Frame Trihedron

  • Simultaneously Evaluating Feature Control Frames

  • Feature Control Frame Reporting Tables

PC-DMIS and ASME Y14.5M-1994

PC-DMIS GD&T follows ASME (ANSI) Y14.5M-1994. The mathematics for this standard are described in "ASME Y14.5.1M-1994 Mathematical Definition of Dimensioning and Tolerancing Principles". This standard is similar to ISO 1101. The main difference is that Y14.5 requires True Position datum fitting to find the candidate datum reference frame that minimizes the deviation of the considered feature. PC-DMIS allows the user to turn this off with the Fit to Datums check box. In addition, the registry setting UseISOCalculations, found in the Options section of the PC-DMIS Settings Editor, can be set to 1 to report profile as two times the maximum deviation.

Some Calculation Differences

Legacy dimensions for roundness such as a Location dimension's RN line or a legacy Circularity dimension, are computed using the Least Square solution. On the other hand, FCF dimensions for roundness (Circularity and Cylindricity) in version 4.2 and higher are computed using the Chebychev algorithm (min/max) as required by the Y14.5 standard. Because of the change in calculation, Circularity and Cylindricity FCF dimensions will generally compute to a slightly smaller value than their legacy counterparts.


What is a Feature Control Frame?

A Sample Feature Control Frame

A feature control frame (FCF) is a rectangular graphic that represents specified dimension information for one or more features. It usually appears on a blueprint or cad file to define tolerance specifications for specific dimension types. The ASME Y14.5 – 1994 Geometric Dimensioning and Tolerancing describes appropriate use of feature control frames (FCFs).

When multiple features are selected in the FCF, PC-DMIS creates a constructed set internal to the FCF. This set uses the input features to create a pattern feature, where the primary dimension line will apply to the pattern feature, and the secondary dimension line will apply to the individual features. In the above example feature control frame, the pattern will have its position toleranced to within 0.01, while the individual features will have their positions toleranced to within 0.005. See ASME Y14.5 – 1994 Geometric Dimensioning and Tolerancing for more information about how these are applied.

The Elements of a FCF in PC-DMIS

A FCF in PC-DMIS has four different lines, as defined by the GD&T standards:

Elements of a Feature Control Frame

  1. Size tolerances – The top line has the number of features, X, diameter symbol, size nominal, plus tolerance, and minus tolerance.

  2. Primary dimensions – The second line (first row in the rectangular grid) must always exist, even though you may not use all of the fields. This line has the primary dimension symbol, diameter symbol, main tolerance, feature material condition, projected tolerance zone, projected tolerance zone material condition, primary datum, primary datum material condition, secondary datum, secondary datum material condition, tertiary datum, and tertiary datum material condition. Often, datums, material conditions, and projected tolerance zones are not required or available.

  3. Secondary dimensions - The third line (second row in the rectangular grid) only exists for True Position and profile types, and not all of the fields are necessary. It has the secondary dimension symbol, diameter symbol, main tolerance, feature material condition, projected tolerance zone, projected tolerance zone material condition, primary datum, primary datum material condition, secondary datum, secondary datum material condition, tertiary datum, and tertiary datum material condition.

  4. Notes – The fourth line contains a text field for where you can type further description or instructions of the FCF. By default, PC-DMIS places the FCF's ID into this field to help identify the FCF in the Graphics Display window. You can change this note to different text if you like.


Rules for Using Feature Control Frame Dimensions

Explanation:

While you can technically use these tools without CAD, it may require additional editing of commands to get them to function properly. Dimensions that use datums require correct nominal (THEO) values. When you do not create features from CAD data, you may have to edit the nominal (THEO) values of features to ensure that they are correct.

This rule also applies to legacy dimensions.

Explanation:

When creating a FCF dimension, you should not reference a 2D feature as a primary datum because it does not have vector information.

In versions 4.1 and above, when you use a circle as a primary datum, the created datum reference frame alignment will not level to the circle. PC-DMIS uses the circle only to position the Datum Reference Frame (DRF) alignment origin (X, Y). The DRF alignment level in this case is derived from the current active alignment.

However, if you want the DRF alignment to level to a primary datum circle (for example, the circle is an Auto Circle measured with sample points), you can use the PC-DMIS Settings Editor to set the DatumLevelToCircle parameter to 1 (by default, this is 0).

This also applies to legacy dimensions.

Explanation:

While this report functions well with Legacy dimensions, FCF dimensions will experience some data loss in this reporting mode.

To ensure that you display the report properly:

  1. Right-click on any white space of your report.

  2. Select Edit Object.

  3. In the Report dialog box, clear the Use Text Mode Dimension Reporting check box.

Explanation:

Ensure that you are looking at the Min/Max value for Profile dimensions, not the Measured value.

To turn on Min/Max reporting:

  1. Press F10 to access the Parameters dialog box.

  2. Select the Dimension tab, and then select the Min/Max check box.

Explanation:

Nominal data is needed for Deviation Perp to Centerline functionality to work properly. If you are using CAD, this happens automatically. If not, you will need to type in the needed nominal values into the THEO field.

FCF True Position dimensions always use the Deviation Perp to Centerline functionality and with the Axis set to WORST; you cannot modify this.

Explanation:

The features selected for datum 1, datum 2, and datum 3 represent the primary, secondary and tertiary datums and are used to constrain up to six degrees of freedom (3 degrees of translation and 3 degrees of rotation).

  • The primary datum constrains as many of the six degrees of freedom as the primary datum feature allows.

  • The secondary datum constrains as many of the remaining degrees of freedom as the secondary datum feature allows.

  • The tertiary datum constrains whatever degrees of freedom remain.

Therefore, the order of precedence of the datums is essential.

Consider these examples:

Example 1: Suppose for your datums you have a primary plane, a secondary line, and a tertiary circle (assume that the line and circle lie in the plane). The plane constrains rotation about X and Y and translation in Z. The line, constrains rotation about Z and translation in Y. The circle constrains only translation in X.

Example 2: Now, suppose for your datums you have a primary plane, secondary circle, and tertiary line (again, assume that the circle and line lie in the plane). The plane still constrains rotation about X and Y and translation in Z. The circle now constrains translation in X and Y. The line constrains only rotation about Z.

Explanation:

These commands must contain the correct nominal values (X,Y,Z,I,J,K) in the THEO field. For proper fitting to occur, PC-DMIS references these commands to calculate datum constraints and the dimensional results.

Explanation:

This ensures that the nominal values are correct and the same as the basic dimension callouts from the drawing. When using CAD, the nominal values are automatically calculated. Without CAD, you will need to edit all the measured feature commands with their correct nominal values.

Rules for Using Feature Control Frame Dimensions

In order to properly use the GD&T / Feature Control Frame (FCF) tools provided in PC-DMIS, please follow these rules:

  • For best results, use CAD data.

  • Use 3D features with vectors for primary datums.

  • DO NOT use the oldstyle text report with FCF dimensions.

  • Use Min/Max reporting for Profile FCF dimensions.

  • Use correct nominal X,Y,Z,I,J,K data for Deviation Perp to Centerline functionality.

General Rules for True Position FCF Dimensions:

  • Select all the specified datums so that proper fitting is performed.

  • Ensure that feature commands used for the datums and the dimension contain correct nominal values.

  • Ensure that the measured feature command and the associated TP dimension come from the same alignment.


Creating a Feature Control Frame Dimension

The following procedure shows you how to create a Feature Control Frame (FCF) dimension:

  1. Create the features that will be datum features. These can be measured features, auto features, or constructed features.

  2. Select Insert | Dimension | Datum Definition Display Menu Roadmap . The Datum Definition dialog box appears.

  3. Use the dialog box to select the datum features and associate them with datum letters. See "Defining Datums" for information on how to do this.

  4. When finished defining datums, close the dialog box.

  5. Make sure the Insert | Dimension | Use Legacy Dimensions Display Menu Roadmap menu option does not display a check mark. If it does, select the menu item to clear this check mark.

  6. Select the appropriate dimension from the Insert | Dimension Display Menu Roadmap submenu. The GD&T dialog box for that dimension appears.

  7. In the dialog box, select the Feature Control Frame tab.

  8. Use this tab to select the features to dimension and to construct your FCF. See "Feature Control Frame Tab" for information on the available options in this tab.

  9. Select the Advanced tab.

  10. Select the appropriate options from this tab to define how the dimension information should be displayed. See "Advanced Tab" for information on the available options in this tab.

  11. Click Create. PC-DMIS inserts a FCF command into the part program and a FCF graphic appears in the Graphics Display window. The graphic will have a transparent background. You can click and drag the FCF to a new location as needed.

FCF Creation Conditions

In order for PC-DMIS to properly create a FCF dimension, it must meet the appropriate conditions for the type of dimension you want to create. Consult the following table as needed:

Dimension Type | Conditions to Meet
Form dimensions: | No datums. No material conditions. No projected zones.
Profile dimensions: | May or may not have datums. No material conditions. No projected zones.
Orientation dimensions: | Must have datums. May have material conditions. May have projected zones.
Runout dimensions: | Must have datums. No material conditions. No projected zones.
Position dimensions: | May have datums. May have material conditions. May have projected zones.
Other location dimensions (these include symmetry concentricity, coaxiality): | Must have datums. No material conditions. No projected zones.


Defining Datums

A Datum is a theoretically perfect plane, point, or axis reference feature. A Dimensional measurement is made from a datum. Datums are used by Feature Control Frames (FCFs) when displaying GD&T information. In order to define the datums used in FCFs, you should first create the features that will become the datums. These features can come from auto features, measured features, or constructed features. Once you create the features, use Datum Definition (DATDEF) commands to define them as datums. Each DATDEF command associates a datum letter (for example, datum A) with a feature in your program.

Creating a Datum Definition

To define a datum, select Insert | Dimension | Datum Definition Display Menu Roadmap or click the Datum Definitions button on the GD&T dialog box. PC-DMIS will display the Datum Definition dialog box.

Datum Definition dialog box

Datum Definition dialog box

The datum letter (in the above example "A"), defaults to the next available datum letter. PC-DMIS labels datums from "A" to "Z" and then from "AA" to "ZZ". Simply select a feature to be associated with this datum letter from the List of Features, and click Create. The Create button becomes activated whenever you select a feature from the list. When you create a definition, PC-DMIS inserts a DATDEF command into the Edit window. For example, if you had selected PLN1 and associated it with the letter "A", the Edit window command would read:

DATDEF/FEATURE=PLN1,DATUM=A

In the Datum Definition dialog box, the Datum box automatically updates to the next available datum letter, and the feature you selected will appear in the List of Features with the associated datum letter in parentheses. From the above PLN1 example, it would now appear in the list as PLN1(A).

To create additional DATDEF commands, continue to select features and click Create. If you don't want to create your datums in the default alphabetical sequence, you can easily modify the letter in the Datum box before clicking Create.

Once you have created all your datums using the Datum Definition dialog box, you can then create Feature Control Frame (FCF) dimensions using the GD&T dialog box and assign your defined datum features to those dimensions.

Bonus Refinement

When calculating the bonus on a datum, if there is a previous True Position dimension or orientation dimension on that datum feature, then the True Position and/or orientation tolerance is added to the datum bonus to calculate the virtual size of the datum.

Specifying Compound Datums in the FCF

A drawing's callout will show a compound datum using the format A-B (where the datums are labeled A and B). This indicates that the specified datums should be used together as if they were a single datum.

Note: Compound datums only function with a True Position FCF dimension or Profile FCF dimension.

To specify compound datums:

  1. Create the individual datums. See "Defining Datums" for information on how to do this.

  2. Select the menu item or toolbar icon to create a True Position or Profile FCF. The GD&T dialog box appears.

  3. Specify the compound datum in the <dat> field of the Feature Control Frame Editor area. While the drop down list only shows individual datums, you can, however, type the required datum combination directly. Do this by selecting or typing the first datum's ID, type a dash, and then type the ID for the last datum in the combination. If your compound datum used datums A and B, it would look like this:

  4. Select the feature (or features) for your FCF.

  5. Fill out anything else needed for your FCF.

  6. Click Create.

How Bonuses are Applied for Compound Datums at MMC

Suppose you define a True Position FCF for a hole using a compound datum D-E at MMC like this:

Datum A is a surface.
Datum D is a hole.
Datum E is a another hole.

PC-DMIS will calculate the bonus for each of the datums in the compound datum based on the measured size of each datum as well as the plus and minus tolerances for the D2 axis (secondary datum) as specified in the Advanced tab of the dialog box:

Advanced tab showing D2 Axis with +Tol and -Tol Values

The bonus for datum D may be different than the bonus for datum E based on the measured sizes of the two holes. The fitting process will take this into consideration.


The GD&T Dialog Box

GD&T dialog box

GD&T dialog box

With the GD&T dialog box, you can create Feature Control Frame (FCF) dimensions and insert them into your part program. This dialog box appears whenever you select a supported FCF dimension from the Insert | Dimension Display Menu Roadmap submenu and the Use Legacy Dimensions menu item is not selected.

The dialog box consists of two tabs, Feature Control Frame and Advanced, each with several controls that allow you to construct the FCF and its associated dimension information.

More:

Feature Control Frame Tab

Advanced Tab

Using Flatness Per Unit Area


Feature Control Frame Tab

GD&T Dialog Box - Feature Control Frame tab

GD&T dialog box

GD&T dialog box - Feature Control Frame tab

The Feature Control Frame tab gives helps you construct a Feature Control Frame (FCF). It provides you with the tools to define datum features, select the features used in the FCF dimension, an editor to define the specific symbols, tolerances, and datums used in your FCF, and a preview area to see the current state of the FCF as you build it. For information on the various items in this tab, see the list of controls below:

ID - This box displays the name for the FCF. You can edit it if you want something different.

Features - This list displays available features for the particular FCF type. Some features may exist in the part program, but are not available to the feature control frame. For example, a plane feature is not available to Circularity. PC-DMIS updates this list after you select the first feature. This ensures that when you create a pattern of features for the FCF, those features are compatible features.

Datums - The Datums shows all the datums defined with DATDEF commands. It only lists datum features above the current cursor position in the Edit window.

Leader Lines - This list shows the same features that you selected from the Features list. Each feature has a check box associated with it. When you select a check box, PC-DMIS draws a leader line in the Graphics Display window from the FCF to that feature. By default, PC-DMIS initially displays all possible leader lines, but you can clear check boxes to turn off leader lines as well.

Feature Control Frame Editor - This area lets you apply changes to the FCF. You can select fields with the mouse or by pressing TAB and then ENTER to place the field into edit mode. If the field is editable, it will either display a drop-down list of available options, or it will display a box into which you can type text. When finished editing a field, press ENTER, TAB, or click on a different field to exit the edit mode. Pressing SHIFT + TAB will move backwards to the previous field.

When a field is empty a short description is displayed with brackets around it for identification. These descriptions correspond to these fields:

<MC> - Material condition

<D> - Diameter

<Dim> - Dimension or feature control frame type

<PZ> - Projected zone

<num> - Number of features

<nom> - Nominal of feature size

<+tol> - Plus tolerance

<-tol> - Minus tolerance

<tol> - Tolerance

<dat> - Datum

<sym> - Dimension symbol

<add notes here> - Note field in the first line

<add optional design notes> - Optional design notes in the last line

Spherical Zone - You can use a spherical tolerance zone if you have a True Position FCF for a point or sphere feature. To enable a spherical tolerance zone, select the feature to dimension, then in the FCF editor, select the diameter symbol and change it to the spherical zone symbol as shown here:

Planar Zone - This button appears in the Feature Control Frame Editor area of this tab, if you have a True Position FCF and the tolerance zone is set to a planar zone. To enable this button, select the diameter symbol from the FCF editor and set it to blank as shown here:

Once the Planar Zone button appears, you can click it to open the Planar Zone Direction dialog box.

The Planar Zone Direction dialog box lets you specify the direction vector for the planar zone in one of two ways:

  • Select the Axis option. Then from the Axis list, select an axis from the list: X, Y, or Z.

  • Select the Vector option. Then in the I, J, and K boxes, type the direction vector.

Datum Definitions - This button provides you with easy access to the Datum Definitions dialog box, allowing you to define datums for your current FCF dimension.

Feature Control Frame Options - This area contains the Composite check box. This check box controls whether or not the primary dimension row and secondary dimension row should use the same symbol in a single merged cell that spans both rows. When you select this check box, the symbol displays like this:

If you clear the check box, the primary and secondary rows display with separate symbols, even if the symbol represents the same thing.

The ASME Y14.5 – 1994 Geometric Dimensioning and Tolerancing describes the differences in interpreting these conditions.

The Form Only or Form and Location options are available from this area for profile dimensions:

Form Only - Select this option when you only want to determine if a particular profile matches the same form as its nominal. This option ignores whether the location of the profile is outside of acceptable tolerances. For a Form Only dimension, pay attention to the measured values in the generated dimension. Also, define the Best Fit Algorithm in the Profile area of the Advanced tab. See the "Advanced Tab" topic.

Form and Location - Select this option when you want to determine if a particular profile matches the same form and the same location as its nominal. This differs from the Form Only option, because the location of the profile must also be within acceptable tolerances defined by the Plus and Minus Tolerances. For a Form and Location dimension, pay attention to Max / Min values in the generated dimension.

Actions and Procedures - This section displays hints and instructions to assist you in building valid FCFs.

Preview - This section displays a preview of the FCF with the current settings. It will not include any of the empty fields or empty descriptions that appear in the Feature Control Frame Editor section, for example fields that have brackets, such as "
"<dat>".

Notes on the Feature Control Frame Editor

In the Feature Control Frame Editor area be aware that some of the icon fields, if they are not supported will not appear for certain dimensions. For example, if you have a Circularity dimension, PC-DMIS displays the tolerance field, but hides any datum or modifier fields.

Form dimensions (Circularity, Cylindricity, Flatness) - These don't support datums or modifies, so these fields will not appear. Profile in some cases will fall in this category when checking for "Form Only". But "Form and Location" for Profile dimensions allows the display of modifiers.

Orientation dimensions (Parallelism, Perpendicularity, Angularity, Runout, Concentricity, Coaxiality) - These allow datums and modifiers.

Position dimensions (True Position, Profile with Form and Location) - These allow datums and modifiers.

Other dimensions (Distance and Angle Between) - These don't allow datums. Symmetry is a lot like the form dimensions, and doesn't use datums.

Also, only these dimensions can have multiple lines in the editor:

  • True Position

  • Parallelism

  • Perpendicularity


Advanced Tab

GD&T Dialog Box - Advanced tab

GD&T dialog box - Advanced tab

GD&T dialog box - Advanced tab

The Advanced tab provides you with the ability to set output and analysis options for your Feature Control Frame (FCF) dimensions. For documentation on this tab, see the list of dialog box items discussed below. Also, note that much of this functionality already exists in the legacy dimensions and is discussed in detail in the "Dimensioning Features" section.

Output Area - The Report and Statistics list allows the feature control frame output to be printed to either the inspection report or to statistical files used by statistics software (such as DataPage), to both of these, or to none at all.

· Statistics – sends output to statistical files

· Report – sends output to inspection report

· Both – sends output to both inspection report and statistical files

· None – doesn’t send output anywhere

When PC-DMIS executes a FCF command, the output will go to the inspection report, the stats file, both of these, or none of them, depending on what you selected.

Note: If either the Stats option or the Both option is selected, a preceding STATS/ON command must exist inside the Edit window for the FCF to be sent to the stats file.

The Units list allows you to determine the units of measurement your FCF should use. You can choose between these options:

· Inch = Inches

· MM = Millimeters

PC-DMIS uses the selected unit of measurement for dimensioning as long as the dialog box remains open. By default, PC-DMIS uses the same unit of measurement used by the current part program.

Analysis area - This area sets the dimensional output analysis format for the FCF.

Report Textual Analysis - When you select On (or Both for True Position FCFs), PC-DMIS will print out the following in the standard inspection report and the Report window for each individual hit used in the FCF:

  • Measured X, Y, and Z values

  • Measured I, J, and K values

  • Deviation of each individual hit

  • ”MAX” or ”MIN” marker at the end of the line whenever the hit produces either a maximum or minimum deviation.

Report Graphical Analysis - This list displays the output for the FCF in your report. It uses a format suitable for close examination. When you select On (or Both), PC-DMIS will display, in a graphical format that uses colored arrows, the deviation of each individual hit for the FCF used on the part in the report. These arrows, with their colors and directions, indicate the relative size of the error, as well as its direction.

CAD Graphical Analysis - This list works the same as the Report Graphical Analysis list, except that it displays the graphical analysis inside the Graphics Display window.

Arrow Multiplier - The Multiplier box let you set a scaling factor that magnifies the deviation arrows and tolerance zone for the CAD Graphical Analysis mode. If you type a 2.0 value, PC-DMIS will scale the arrows two times the calculated deviation for each feature hit. The Multiplier box is used for viewing purposes only, and is not reflected in the text printout.

Dimension Info area - This area lets you create a Dimension Info text box for the FCF. When you select the Create Dimension Info when this dialog closes check box, PC-DMIS enables the Edit button. You can click the Edit button to open up a dialog box that lets you set default options for the Dimension Info command (DIMINFO). See ”Edit Default Dimension Info” for more information.

When you create your FCF, the dialog box closes and PC-DMIS creates a DIMINFO command in the Edit window after the FCF. This DIMINFO command displays all dimension information in the Graphics Display window next to the feature selected from the Feature list in the Feature Control Frame tab. It also displays the same available dimension axes used in the Edit window for that particular FCF.

For more in-depth information on DIMINFO boxes and on rules governing their creation, see ”Inserting Dimension Info Boxes” in the ”Inserting Report Commands” section.

True Position area - This area become available only when creating a True Position FCF. For other FCF types it remains grayed out. It contains these items:

Alignment - Sometimes when you view dimension information relative to the current alignment, the calculations of the datums can sometimes be hard to decipher. This list lets you determine how this information should get displayed: relative to a particular alignment or relative to the datum reference frame.

Fit to Datums - This check box determines whether or not the FCF uses a best fit calculation to find the optimal position of the datum reference frame that minimizes the error.

Nominals and Axes - This portion lets you customize the output by controlling which axes PC-DMIS should display in the report and allowing you to manually type the nominal values.

Feature List - The list to the left of the Nominals and Axes columns displays all the features used in the True Position FCF. Select a Feature Set or feature from this list. PC-DMIS then displays the possible axes for that feature.

Report Axis - This column contains check boxes for each axis. A selected check box sends that axis to the report.

Axis - This column lists available axes for the selected feature.

Nominal - This column contains nominal values. You can overwrite them by clicking on them and typing different values.

+Tol / -Tol - The plus and minus tolerance columns provide fields into which you can type tolerances for the various axes used in your FCF. PC-DMIS only applies these tolerance values to axes that relate to size, since the axes that control position use the main tolerance in the FCF.

Update Feature Nominal - This column lets you specify whether or not any changes you made to the nominal values should get applied not only to the FCF but to the feature as well.

Profile area - This area lets you define the Best Fit Algorithm to be used for Profile dimensions. This is only enabled when you are creating a Profile Line or Surface Dimension and you have select the Form Only option on the "Feature Control Frame tab"

  • No Fit - No alignment is created.

  • Least Squares - This fit finds a position where the deviations are minimized. In this way, the Form Only option can ignore the location of the feature while checking that the curve is close to the nominal shape.

  • Vector - This fit snaps errors in the input features onto the theoretical vectors before minimizing the average squared error.


Using Flatness Per Unit Area

Display Menu Roadmap

The XactMeasure GD&T - Flatness Dimension dialog box contains a Per Unit check box that lets you specify a flatness per unit area:

Per Unit check box

When you select the Per Unit check box, PC-DMIS changes the Feature Control Frame Editor area, adding an additional line where you can enter a tolerance value as well as the unit area values:

Feature Control Frame Editor

PC-DMIS now automatically uses a step increment that ensures that the "per unit window" will include maximum overlap as it "slides" over all the point data.

Once you enter in the desired information and create the Feature Control Frame, PC-DMIS also applies the flatness per unit area in the Feature Control Frame:

Example of a Finished Flatness FCF


Feature Control Frame Command Block

The following shows the syntax of a sample Feature Control Frame (FCF) command block using the Edit window's command mode:

FCF6 = TRUE POSITION OF CIR1,CIR2,CIR3,...

FEATCTRLFRAME/SHOWNOMS=YES,SHOWPARAMS=YES,SHOWEXPANDED=YES

          CADGRAPH=BOTH
REPORTGRAPH=OFF  TEXT=BOTH
MULT=10.00  OUTPUT=BOTH  UNITS=IN

COMPOSITE=NO,FIT TO DATUMS=YES,OUTPUT ALIGNMENT=Datum Reference Frame

SIZE TOLERANCES/4,DIAMETER,0.375,0.01,0.01

PRIMARY DIMENSION/TRUE POSITION,DIAMETER,0.01,MMC,A,<MC>,B,MMC,C,<MC>

SECONDARY DIMENSION/TRUE POSITION,DIAMETER,0.005,MMC,<PZ>,<len>,A,<MC>,B,MMC,<dat>,<MC>

NOTE/FCF6

FEATURES/CIR1,CIR2,CIR3,CIR4,,

FEATURE SET

X:NOM=-1

Y:NOM=6.0235

Z:NOM=0

<NEW>

CIR1

X:NOM=-1

Y:NOM=5.07

Z:NOM=0

<NEW>

CIR2

X:NOM=-2

Y:NOM=6.008

Z:NOM=0

<NEW>

CIR3

X:NOM=-1

Y:NOM=7.008

Z:NOM=0

<NEW>

CIR4

X:NOM=0

Y:NOM=6.008

Z:NOM=0

<NEW>

DATUMS

D2:NOM=1,+TOL=0.01,-TOL=0.01

Feature Control Frame name = Feature Control Frame (FCF) type (Dimension type) OR feature list.

Feature List = List of features. If there are more than three features, then the list prints out a set of ellipses to ensure that the line will fit. For example, FEAT1, FEAT2, FEAT3, and so on. If there is more than one, it is treated as a pattern set, and all features must be the same feature type.

SHOWNOMS = YES/NO. When set to YES, the FCF types that have nominals will display them These include true position, distances, angle between, and angularity.

SHOWPARAMS = YES/NO. When set to YES, the following parameters will be displayed with the text: CADGRAPH, REPORTGRAPH, TEXT, MULT, OUTPUT, UNITS, COMPOSITE, FIT TO DATUMS, OUTPUT ALIGNMENT. When off, these same options will not be displayed.

SHOWEXPANDED = YES/NO. When set to YES, the feature control frame will display empty fields with a description inside brackets. When off, the empty fields will display as blank.

<MC> - Material condition

<D> - Diameter

<Dim> - Dimension or feature control frame type

<PZ> - Projected zone

<num> - Number of features

<nom> - Nominal of feature size

<+tol> - Plus tolerance

<-tol> - Minus tolerance

<tol> - Tolerance

<dat> - Datum

<sym> - Dimension symbol

<add notes here> - Note field – first line

<add optional design notes> - Optional design notes – last line

CADGRAPH = OFF/ON/BOTH/FORM – Display the graphical analysis on the model in the Graphics Display window. True position dimensions include BOTH/FORM, depending on whether or not they are using the integrated form option, but all other dimensions only display OFF/ON.

REPORTGRAPH = OFF/ON/BOTH/FORM – Display the graphical analysis on report. True position dimensions include BOTH/FORM, depending on whether or not they are using the integrated form option, but all other dimensions only display OFF/ON.

TEXT = OFF/ON/BOTH/FORM – Display the textual analysis on report. True position dimensions include BOTH/FORM, depending on whether or not they are using the integrated form option, but all other dimensions only display OFF/ON.

MULT = Positive numeric value that scales the graphical analysis in the main cad graphics.

OUTPUT = STATISTICS/REPORT/BOTH/NONE – Include the feature control frame calculations in the xstats11.tmp file, output report, both, or neither.

COMPOSITE = YES/NO. When set to YES, the feature control frame will display the primary and secondary dimension lines as a composite dimension. This is available for true position and profile dimensions.

FIT TO DATUMS = YES/NO. This option is only available for true position FCFs. When set to YES, the calculations will allow a best fit calculation on the datums to find an optimal best fit that minimizes the datum shift.

OUTPUT ALIGNMENT = Datum Reference Frame/Current Alignment. This option is only available for true position FCFs. When Datum Reference Frame is selected, the X, Y, Z positions will be displayed relative to the datum reference frame. When Current Alignment is selected, the X, Y, Z positions will be displayed relative to the current alignment.

UNITS = IN/MM. The units that the FCF will use to display its information.

SIZE TOLERANCES = Represents the top line of the feature control frame. For some FCF types this line is not shown. This line displays the number of features selected, whether or not the diameter symbol is used, nominal size of the feature(s), and size tolerances that will be applied to the nominal value.

PRIMARY DIMENSION or DIMENSION = Represents the second possible line of the FCF, which contains the primary type of FCF. Note that some of the fields are only valid for some FCF types. This line displays the FCF type, whether or not the diameter symbol is used, main tolerance value, material condition applied to the main tolerance, projected tolerance zone symbol, projected tolerance zone value, primary datum, primary datum material condition, secondary datum, secondary datum material condition, tertiary datum, and tertiary datum material condition. If a secondary dimension is not possible for the particular FCF type, then this line just uses the title DIMENSION.

SECONDARY DIMENSION = Represents the third possible line of the FCF, which contains the primary type of FCF. Many FCF types display nothing for the secondary dimension. In addition, some of the fields are only valid for some FCF types. This line displays the feature type, whether or not the diameter symbol is used, main tolerance value, material condition applied to the main tolerance, projected tolerance zone symbol, projected tolerance zone value, primary datum, primary datum material condition, secondary datum, secondary datum material condition, tertiary datum, and tertiary datum material condition. If a secondary dimension is valid, the secondary dimension must follow the rules of practice by the ASME Y14.5 1994 Dimensioning and Tolerancing standard.

NOTE = Represents the final line of the FCF. It displays text notes. For ease of identifying FCFs in the main graphics, this field defaults to display the FCF's ID.

NOMINAL LINES: These fields display the nominals of the dimensions internal to the FCF. First, it displays the nominal position of the resulting pattern feature set, if more than one feature was selected. Second, it displays the nominal positions of the individual features. Finally, it displays the nominal size and tolerances of the datums that have size. In each of these groups it will list the nominals that have been selected for display on the Advanced tab of the GD&T dialog box for the FCF, so each axis to be displayed can be turned on or off. To turn on the display of other nominals in the edit window, toggle the <NEW> line to see axes that are available but not currently displayed.

FEATURE SET

X:NOM=-1

Y:NOM=6.0235

Z:NOM=0

<NEW>

CIR1

X:NOM=-1

Y:NOM=5.07

Z:NOM=0

<NEW>

CIR2

X:NOM=-2

Y:NOM=6.008

Z:NOM=0

<NEW>

CIR3

X:NOM=-1

Y:NOM=7.008

Z:NOM=0

<NEW>

CIR4

X:NOM=0

Y:NOM=6.008

Z:NOM=0

<NEW>

DATUMS

D2:NOM=1,+TOL=0.01,-TOL=0.01


Feature Control Frame Trihedron

If you select a FCF command in the Edit window, and that command uses a datum reference frame, PC-DMIS displays a blue and yellow trihedron to represent the reference frame for your FCF. This differs from the red and green trihedron used to represent your part's current alignment.

The following screen shot shows the alignment's trihedron in red and green and the FCF's trihedron in blue and yellow:

Screen Shot of FCF Trihedron (above) and Alignment Trihedron (below)


Simultaneously Evaluating Feature Control Frames

The Insert | Dimension | Simultaneous Evaluation Display Menu Roadmap menu item lets you create a Simultaneous Evaluation command inside your part program. This command evaluates two or more true position Feature Control Frames (FCFs) or two or more profile (line or surface) FCFs simultaneously.

Example: If you have two sets of holes on a part, and the holes of one set are a different size than the holes of the other set, but you want to evaluate the true position of all the holes as if they were all one set, you can use the Simultaneous Evaluation command. First, create two separate true position FCFs, one for each set of holes. Then create a Simultaneous Evaluation command to evaluate both FCFs together.

The Simultaneous Evaluation menu item displays the Simultaneous Evaluation dialog box.

Simultaneous Evaluation dialog box

Simultaneous Evaluation dialog box

The right-hand list shows all the Feature Control Frame (FCF) commands available for the Simultaneous Evaluation command. It only lists FCFs for true position or profile dimensions. Select items in the right-hand list that you want to include in the Simultaneous Evaluation command. As you select items, the Add button becomes active. You can select multiple items by holding down the CTRL key while selecting the items. Click the Clear button to deselect any highlighted items.

Click the Add button to add the selected items to the left-hand list in the Feature Control Frames area. This second list defines the FCFs that will be evaluated by the Simultaneous Evaluation command.

When you have added items to the left-hand list, you can remove them from this list by selecting the items in the left-hand list and pressing Delete. This removes items from the left-hand list and re-displays them in the right-hand list. When you have added at least two FCFs to the left-hand list, the Create button becomes active. Click Create to create the Simultaneous Evaluation command and insert it into the Edit window. In the Command mode, it looks something like this:

SIMUL1 =SIMULTANEOUS/FCF2,FCF3,FCF4,,

Rules of Simultaneous Evaluation:

  • The FCFs you evaluate must all be the same dimension type. They must all be true position dimensions or all surface profile dimensions or all line profile dimensions. Simultaneous evaluation does not work with orientation dimensions. If you add FCFs of differing types of dimensions to the left-hand list, when you click Create, PC-DMIS will display an error message informing you that your FCFs should all be the same type.

  • All the FCFs you evaluate must have dimensions that reference the same datums in the same order of precedence. If you add two true position FCFs to the left-hand list that use different datums, when you click Create PC-DMIS will display an error message informing you that your FCFs must reference the same datums and use the same precedence.

  • All the datums used must have the same material conditions. If the datums are the same, but there are different material conditions on the datums, when you click Create, PC-DMIS will display an error message informing you that you should use the same material conditions.


Reporting True Position Feature Control Frames

Display Menu Roadmap

The major changes in the reporting format for True Position are that PC-DMIS 4.0 and later now reports the following in the Report window:

  • The deviation of each feature in a set and not just the deviation of the entire set. This will help you better determine which feature is out of tolerance in a pattern of features.

  • The shifted position of the datum as a result of the datum fitting (with datums of size).

  • The total datum shift in X, Y, Z and rotation in U, V, W done by the fitting algorithm.

When reporting a True Position Feature Control Frame (FCF) there is a lot of information available. To avoid confusion, and to see how the FCF affects the calculations, PC-DMIS has split this information into four parts.

  1. Size information. This gets evaluated separately from the position of the feature.

  2. Bonus tolerance information of the main feature or set

  3. Datum information including the datum shift and datum rotation

  4. Feature or set position information.

The additional information is much more useful than in versions prior to 4.0. For example, the datum shift information was not output previously, but it can be a big factor for an out of tolerance True Position dimension. Now, you can tell whether the feature or datum is in the wrong place.

Working with the "Deviation Perpendicular to Centerline" Functionality

By default, the FCF True Position dialog box has the Deviation Perpendicular to Centerline functionality enabled in the background, as this is consistent with the ASME Y14.5 standard.

While a Deviation Perpendicular to Centerline check box was not added to the FCF True Position dialog box (as it is the legacy dimension's True Position dialog box), you can still turn off this option by having your FCF True Position specify a spherical zone (rather than a cylindrical or planar zone). In this case the deviation is calculated from the X, Y, Z axes.

Note: The only time you can select a spherical zone is when applying FCF True Position to a Point or a Sphere.


Creating a Symmetry Feature Control Frame Dimension

The two planes must be nominally parallel. The FCF will use them internally to construct a mid-plane. This mid-plane must nominally lie within the tolerance zone about the locating datum.

PC-DMIS checks the corner points of the mid-plane to verify that they lie within the a planar tolerance zone of two times the maximum deviation of the corner points from the locating datum.

These corner points are calculated by projecting the actual probe hits of each of the two planes onto the mid-plane.

    • The maximum distance of the projected points from the centroid of the mid-plane in the X direction (of the datum reference frame) determines the length of the mid-plane.

    • The maximum distance of the projected points from the centroid of the mid-plane in the Y direction (of the datum reference frame) determines the width of the mid-plane.

The length and width calculate the corner points relative to the centroid of the mid-plane. If there are no actual probe hits to project (for example, the two planes are themselves constructed planes), then only the centroid of the mid-plane is checked to lie within the tolerance zone.

Datum Information

One Datum - This is a plane nominally coplanar with the constructed mid-plane. The vector of the datum plane defines the direction of measurement.

Two Datums - First datum: This is a plane nominally coplanar with the constructed mid-plane. Second datum: This is either a plane nominally coplanar with the constructed mid-plane or an axis type feature whose axis nominally lies in the constructed mid-plane. If a plane, the vector of the secondary datum plane determines the direction of measurement. If an axis type feature, "double-crossing" the vector of the axis datum with the mid-plane vector determines the direction of measurement.

The two lines must be nominally parallel. The FCF will use them internally to construct a mid-line. This mid-line must nominally lie within the tolerance zone about the locating datum.

PC-DMIS checks the endpoints of the mid-line to verify that they lie within the planar tolerance zone of two times the maximum deviation of the endpoints from the locating datum.

These endpoints are calculated by projecting the actual probe hits of the two lines onto the mid-line. The projected points farthest away from the centroid of the mid-line determine the endpoints. If there are no actual probe hits to project (for example, the two lines are themselves constructed lines), then only the centroid of the mid-line is checked to lie within the tolerance zone.

Datum Information

One Datum - This datum is either a plane, nominally perpendicular to the plane of the two lines, that contains the mid-line, or an axis type feature whose axis nominally lies in the plane that is perpendicular to the plane of the two lines and contains the mid-line. If a plane, the vector of the datum plane determines the direction of measurement. If an axis type feature, the direction of measurement is perpendicular to the axis datum in the current workplane.

Two Datums - First Datum: A plane nominally perpendicular to the mid-line. Second Datum: This is either a plane feature or an axis feature which satisfies the same requirements as a single primary datum. If a plane, the vector of the plane determines the direction of measurement. If an axis type feature, the direction of measurement is perpendicular to the axis datum in the current workplane.

Datum Information

One Datum - This datum is either a datum plane which nominally contains the mid-line or an axis type feature whose axis nominally is parallel to the mid-line.

Two Datums - Primary Datum: This is a plane nominally perpendicular to the mid-line. Secondary Datum: This is either a plane or an axis feature which satisfies the same requirements as a single primary datum. The direction of measurement is determined the same way as for case 2 above.

Datum Information

One Datum: You can select either a plane or an axis type feature for your datum. If a plane, it should be nominally perpendicular to the line connecting the two points and containing the mid-point. The vector of the datum plane determines the direction of measurement. If an axis feature, it should line in the plane perpendicular to the line connecting the two points and the mid-point. The direction of measurement is perpendicular to the axis datum in the current workplane.

Datum Information

One Datum: You can specify either a plane that nominally contains the mid-point or an axis type feature. PC-DMIS determines the direction of measurement in the way as case 4 above.

Datum Information

One Datum: You can specify a plane or an axis type feature. The analysis in this case is the same as for the legacy symmetry dimension.

PC-DMIS will compute mid-points from the points inside the two sets in this fashion: mid-point n is calculated from point n of the first set and point n of the second set and so on for each point. The resulting mid-points should be inside the planar tolerance zone about the locating datum. This is the same analysis as case 7 above except that the points are taken from two sets.

Datum Information

One Datum: You can specify a plane or an axis type feature for the primary datum. The analysis in this is the same as described in case 7 above.

Probe points within 1mm of a plane that is perpendicular to the feature axis, belong to the same ”r;circle set”. PC-DMIS solves the points as a 2D circle in a plane perpendicular to the feature axis. The centroids of all the ”r;circle sets” are evaluated for symmetry to see if they all lie within the tolerance zone about the datum. The tolerance zone may be cylindrical or planar depending on the datums used. The reported tolerance value is two times the maximum deviation of the centroids of the ”r;circle sets” from the locating datum.

Datum Information

One Datum - You can select a plane that nominally contains the considered feature's axis or an axis type feature nominally coincident with the axis of the considered feature. If a plane, the tolerance zone is planar and the vector of the plane determines the direction of measurement. If an axis type feature, the tolerance zone is cylindrical.

Two Datums - Primary Datum: This is a plane that nominally perpendicular to the considered feature. Secondary Datum: You can select either a plane nominally containing the considered feature’s axis or an axis type feature nominally coincident with the axis of the considered feature. If you choose a plane, the tolerance zone is planar and the vector of the datum plane determines the direction of measurement. If you choose an axis type feature, the tolerance zone is cylindrical.

The endpoints must all lie within the tolerance zone about the locating datum. The tolerance zone may be cylindrical or planar depending on the datums used. The reported tolerance value shall be two times the maximum deviation of the endpoints from the locating datum.

Datum Information

This is the same as case 9 above.

Creating a Symmetry Feature Control Frame Dimension

Display Menu Roadmap

The Symmetry Feature Control Frame (FCF) dimension has been modified to allow an increased variety of input features and datums than you may find available using legacy symmetry dimensions. These changes in turn give you the ability to more easily create symmetry dimensions that apply to a broader range of dimensioning problems. The GD&T Symmetry dialog box has not been modified in any way. The changes were made only to the internal verification of considered features and datums and the internal tolerance analysis.

You need to use datums to construct a datum reference frame alignment which PC-DMIS will then use to evaluate the symmetry points. You can specify a single primary datum or a primary and secondary datum to impose a perpendicularity constraint.

  • If you specify a single primary datum, it becomes the locating datum and defines the nominal (0 deviation) position of the symmetry dimension.

  • If you specify two datums, it imposes a perpendicularity constraint on the secondary datum. In this case, the secondary datum becomes the locating datum and defines the nominal (0 deviation) position of the symmetry dimension. The datum reference frame alignment solves the secondary datum in a constrained orientation to the primary (as is done with True Position evaluations). If the locating datum is a plane, it may be specified as a compound datum referencing two planar datums, for example, A-B. In this case, the mid-plane of A and B is used as the plane datum. Datums are always specified at RFS.

See the Description column in the table below for specific datum information for the different symmetry input features.

Feature Types for Symmetry FCF Dimensions

PC-DMIS now considers any of the following feature types as valid input features for a Symmetry FCF dimension:

Valid Input Features | Description
1.) Two Planes | These planes must be nominally parallel and will create a mid-plane from which PC-DMIS will determine the symmetry dimension of the two planes. Full Description
2.) A Constructed Mid-Plane | Since you have already constructed a mid-plane so the processing and datum information is the same as case 1 above.
3.) Two Lines | These lines must be nominally parallel and will create a mid-line from which PC-DMIS will determine the symmetry dimension of the two lines. Full Description
4.) A Constructed Mid-Line | With an already constructed mid-line, the internal processing follows what is described in case 3 above. Full Description
5.) Two Points | The FCF will use these two points internally to construct a mid-point that nominally lies within the planar tolerance zone about the locating datum. The reported tolerance value is two times the maximum deviation of the mid-point from the locating datum. Full Description
6.) A Constructed Mid-Point | In this case, the user has already constructed a mid-point and the processing shall be the same as for case 5 above. Full Description
7.) A Point Set | PC-DMIS assumes that the points making up the set alternate on opposite sides of the locating datum, such that the first point and second point have their mid-point inside the planar tolerance zone. This is the same analysis as for the legacy symmetry dimension using a point set. Full Description
8.) Two Point Sets | PC-DMIS assumes that both point sets are the same size, that the points in each set reside on opposite sides of the locating datum, and that the points within each set are opposite one another. Full Description
9.) A Measured or Auto Circle, Cone, or Cylinder | PC-DMIS will calculate a "circle set" (or sets) from the input feature and then evaluates for symmetry the centroids of the sets. Full Description
10.) A Constructed Circle, Cone, or Cylinder | PC-DMIS will check a constructed cone or cylinder feature's endpoints or a constructed circle's centroid for symmetry. Full Description


Feature Control Frame Reporting Tables

PC-DMIS provides you with a variety of reporting tables that can be output when you generate reports for your part program. These report tables look different from how legacy dimensions appear in your report. Legacy dimensions all appear in one table. FCF Reporting tables, by contrast, are divided according to different sections of the FCF, allowing for a cleaner looking report. For example, you might have one table that shows the size portion of the FCF, while another table shows the form information.

As a visual example, consider this legacy True Position dimension in the Report window:

Sample Report of a Legacy True Position Dimension as a Single Table

Now, contrast that with the FCF True Position dimension in the Report window shown here:

Sample Report of a True Position FCF Dimension Showing Multiple Tables

Notice that the FCF True Position is actually contained in distinct tables displaying the following information:

  • Size

  • Position

  • Datum Shift

  • Summary

All of the other FCF dimensions also use a similar reporting style. While these reporting tables differ from the style used for legacy dimensions, they provide a cleaner, easier to read approach to reporting dimensioning information.


Scanning Your Part

Scanning your Part: Introduction

Components of a Scan

Working with CAD Surfaces

Locating Points in a Scan

Common Functions of the Scan Dialog Box

Common Functions of the Basic Scan Dialog Box

Additional Manual Scan Options


Scanning your Part: Introduction

PC-DMIS allows a point measurement to be defined by scanning the surface of the part at specified increments. This provides you with a way to scan and digitize your part's surfaces.

PC-DMIS supports scanning in these supported products:

  • PC-DMIS CMM - Using a touch trigger or analog probe on a CMM

  • PC-DMIS Laser - Using a laser probe

  • PC-DMIS Portable - Using hard probe on a portable arm

For information on the above approaches to scanning, consult the appropriate documentation by clicking on the links below. The documentation for each product will discuss the available scans and procedures to follow within those environments to create those scans.

Contact (PC-DMIS CMM) | Laser (PC-DMIS Laser) | Portable (PC-DMIS Portable)
Advanced Scans
Linear Open Advanced Scan | Linear Open Advanced Scan |
Linear Closed Advanced Scan |  |
Patch Advanced Scan | Patch Advanced Scan |
Perimeter Advanced Scan | Perimeter Advanced Scan |
Section Advanced Scan |  |
Rotary Advanced Scan |  |
Freeform Advanced Scan | Freeform Advanced Scan |
UV Advanced Scan |  |
Perimeter Advanced Scan |  |
Grid Advanced Scan |  |
Basic Scans
Circle Basic Scan |  |
Cylinder Basic Scan |  |
Axis Basic Scan |  |
Center Basic Scan |  |
Line Basic Scan |  |
Manual Scans
Fixed Distance Manual Scan | Manual Laser Scan | Fixed Distance Manual Scan
Fixed Time / Distance Manual Scan |  | Fixed Time / Distance Manual Scan
Fixed Time Manual Scan |  | Fixed Time Manual Scan
Body Axis Manual Scan |  | Body Axis Manual Scan
Multisection Manual Scan |  | Multisection Manual Scan
Freeform Manual Scan |  | Freeform Manual Scan

The main topics in this section discuss information common to scanning in any of the supported applications as well as common functions of the scanning dialog boxes. They do not, however, cover the specifics on how to create a scan, since the methods for doing so depend on your specific application.

The main topics discussed here include:

  • Components of a Scan

  • Working with CAD Surfaces

  • Locating Points in a Scan

  • Common Functions of the Scan Dialog box

  • Common Functions of the Basic Scan Dialog Box

  • Additional Manual Scan Options

Changing Animation Speeds: If you want to modify your offline animation speeds, see "Executing and Debugging Part Programs Off-Line" in "Working in Off-line Mode".


Components of a Scan

Advanced Scans in PC-DMIS are composed of Basic Scans. For example, a PATCH scan is actually made up of rows of data, each row being a Basic Scan. The Basic Scans act as building blocks for the higher level scans like PATCH scans. Advanced Scans and Basic scans are discussed in the PC-DMIS CMM documentation.


Working with CAD Surfaces

When creating scans you often need to select one or more surfaces that you want PC-DMIS to scan. Selected surfaces are shown in a red highlight color:

A Selected Surface

Sometimes you will make a mistake and will need to deselect surfaces as well. Rather than redefining the entire scan because you selected an incorrect surface, you can now deselect the desired CAD elements in the Graphics Display window for any scan that requires you to select surfaces. Previously, you could only do this with Section scans.

To deselect (or select) a desired surface:

  1. Ensure that your part is displaying surface data by selecting the Toggle Graphics Window in Solid icon from the Graphic View toolbar.

  2. Access the appropriate scan dialog box and start defining the scan.

  3. As needed, press the CTRL key, and click the left-mouse button on the desired surface in the Graphics Display window. PC-DMIS will toggle the selection state of the surface.


Locating Points in a Scan

When working with scans, you may find it helpful to be able to locate individual points of a scan in the Edit window.

Follow this procedure:

Note: If needed, set the DrawScansAsPoints registry entry (found in the Option list) to a value of 1 to better identify individual points.

  1. Create a scan.

  2. Enter Summary Mode in the Edit window.

  3. Select the Text Box Mode icon from the Graphics Mode toolbar.

  4. Right-click on a scan point in the Graphics Display window. A shortcut menu appears.

  5. Select the Move Cursor To menu item.

PC-DMIS will move the cursor to the appropriate point in the Edit window. If you decide to do this while in Command mode, it will also go to the appropriate point as long as the SHOW HITS parameter is set to YES.

See a brief demo on inserting and formatting a Text object


Common Functions of the Scan Dialog Box

Many of the functions described below are common to many of the scan dialog boxes used in the supported applications. Options that relate specifically to one scan mode are appropriately indicated.

A Sample Scan dialog box

More:

Scan Type

Basic / Advanced buttons

ID

Measure

Boundary Points area

Direction Technique areas

Scan Construction area (for Perimeter Scan)

Section Location area (for Section Scan)

Initial Vectors area

Select Center (for Rotary Scan)

Center Point and Radius (for Rotary Scan)

IJK (for Rotary Scan)

UV Scan Settings area

Grid Scan Settings area

Execution Tab

Graphics Tab

Control Points Tab

Path Definition Tab

Settings Tab


Scan Type

The Scan Type list lets you easily switch between available scans. Selecting a new scan will change the dialog box to the selected scan type.


Basic / Advanced buttons

The <<Basic and Advanced>> buttons switch between displaying basic scanning options on the scan dialog box or more in-depth, advanced options. Clicking Advanced>> expands the dialog box to include the Execution, Graphics, and Path Definition tabs on the lower section of the dialog box. Each of these tabs contains additional options you can use to define your scan. Clicking <<Basic hides the more advanced items, displaying the basic information you need to create the scan.

Basic items are visible

Advanced items are visible


ID

The ID box displays the ID of the scan to be created.


Measure

If the Measure check box is selected and the Create button clicked, PC-DMIS will start measuring the scan immediately. If the Measure check box is not selected when the Create button is clicked, PC-DMIS will insert a scan object into the Edit window that can be measured later. This allows you to set up a series of scans that can be inserted into the Edit window and measured at a later time.

Note: This check box is available only when PC-DMIS is ONLINE.


Boundary Points area

To define the boundary of a scan, PC-DMIS will allow points to be keyed in, measured, or CAD data to be used.

A sample Boundary Points area

This function is only available for DCC scans.

LINEAROPEN - These scans can also be measured without an End point. Delete the End point and PC-DMIS will keep measuring the scan until you manually stop the scan. The starting point and the direction point can not be deleted.

LINEARCLOSE - These scans need to have the start and direction points. You cannot delete or add boundary points.

PATCH - These scans need to have at least three boundary points to create a triangular patch to work with. Extra points can be added or deleted by using the Add and Delete buttons in the Boundary Point area. It adds a Closed Scan check box to this area.

Use the Closed Patch Scan check box to indicate that you would like to scan a closed feature like a cylinder, cone, slot etc. When this is check marked PC-DMIS reduces the number of boundary points needed to define the scan boundary. You would need to enter only the Start and Direction points and an End point. The End point is used to indicate how far down/up the feature the scan needs to execute. The Start and Direction points together with the Initial Vector define the Cut Plane vector. Usually the Cut Plane vector will be parallel to the axis of the feature being measured.

SECTION - Section scans use this area not only to set the boundary points for the SECTION scan, but also to find holes defined in the CAD data, and toggle between displaying data for holes or for boundary points. Section scans add the Cut Cad and Show Cut buttons to this area for this purpose:

After you define a boundary and click the Cut CAD button, PC-DMIS will automatically search through the CAD data for any hole features along the scan's path. Any hole edges along the scans path will be indicated with a integer for the point followed by a ”H” (i.e. 2H, 3H etc.). The hole edge points will be set at a default distance of 0.0787 inches from the theoretical hole edge.

You can cut CAD with specific, user-selected surfaces. To do this, select the boundary points, select the Select check box, select the desired surfaces, and then click the Cut CAD button. PC-DMIS will then cut only the selected surfaces to find the hole(s).

You don't need to click the Cut CAD button if your CAD does not contain hole features. If you don't use this button, PC-DMIS will scan the part using the given Start and End Boundary points.

When cutting surfaces, PC-DMIS uses only the surfaces that are displayed in the first View (the Blue View). See "Setting up the Screen View" in the "Editing the CAD Display" section. When you have a complex CAD drawing with multiple surfaces you can arrange groups of surfaces into CAD levels. (See "Displaying, Creating, and Manipulating Levels" topic in the "Editing the CAD Display" section). Doing this helps you restrict Section CAD Cut operations to specific portions of the CAD model.

The Show Cut button allows you to switch between displaying boundary or hole data. After a boundary is defined and the Cut CAD button has been selected, click the Show Cut button to switch to the appropriate display.

PERIMETER - These scans works the same as the LINEAROPEN scan.

ROTARY - These scans require you to have at least a start point and a direction point (shown as 1 and D respectively in the Boundary Points list and on the CAD display).

  • If you don't have an end point (shown as 2), PC-DMIS will continue measuring the scan along the specified direction until it returns to the start point.

  • If you have a start point and an end point, PC-DMIS will scan along the specified direction until it reaches the end point.

PC-DMIS defaults to providing you with a start, direction, and end point in the Boundary Points area. While you can easily delete the end point, you cannot delete the start or direction point.

As you define each boundary point (by either clicking on the CAD or typing in the values), PC-DMIS will automatically snap each point to the radius distance from the center point unless you didn't define a radius. In this case, the first boundary point you define will also define the radius.

Note: The Boundary Type area on the Execution tab replaces the Boundary button used in the Boundary Points area prior to version 4.0. The Boundary Type area is only available in DCC mode for Linear Open, Linear Close, Patch, Section, and Rotary scans.

More:

Setting Boundary Points Using the Keyin Method

Setting Boundary Points Using the Measured Point Method

Setting Boundary Points Using the CAD Data Method

Adding and Deleting Boundary Points

Editing Boundary Points

Clearing Boundary Points


Setting Boundary Points Using the Keyin Method

To set the boundary of a scan using the key in method:

  1. Double-click the desired boundary point in the ‘#’ column. This will display the Edit Scan Item dialog box.

Edit Scan Item dialog box

  2. Manually edit the X, Y, or Z value.

  3. Click the OK button to apply the changes.

The Cancel button disregards any changes that have been made and will close the dialog box.

The Next button accepts the changes and then brings up the next boundary point for editing.


Setting Boundary Points Using the Measured Point Method

To set the boundary of the scan using measured points, touch the probe on the part. This will automatically update the value of the Boundary point that is currently selected in the Boundary list. The focus will then move to the next boundary point (if there are any in the list). In the case of a PATCH scan, an extra boundary point will be added automatically if the current point is the last point in the list. The PATCH scan will display the last point (this is the same as the previous point). PC-DMIS will delete this last point when the OK button is selected in the dialog box.


Setting Boundary Points Using the CAD Data Method

PC-DMIS allows the selection of boundary points using both wire frame and surface data.

When using CAD surface data:

  1. Make sure that you have imported solid CAD data.

  2. Make sure that the Draw Surfaces icon [image] is selected.

  3. Select a boundary point by clicking on the desired location in the Graphics Display window.

The selected surface will be highlighted. PC-DMIS will then automatically update the value of the Boundary point that is currently selected in the boundary list. The focus will then move to the next boundary point (if any are available). In the case of a PATCH scan, an extra boundary point will be added automatically if the current point is the last point in the list.

When using CAD wire frame data, there are two modes of selecting Curve elements :

Wire Frame Data Mode 1
Depth Curve

A Depth Curve is used by PC-DMIS during FindNoms operations to form a plane using two curves. Ideally, the Depth Curve is normal to the other Curves selected so that PC-DMIS can cross the two vectors (vector of the Depth Curve and vector of any other selected curve) and form a plane from which it can find the nominals.

To indicate a Depth curve, check the Depth check box and then select a curve. Only one Depth curve is to be selected and this should be done after other curves have been selected.

1. Make sure that the Curve mode icon [image] is selected.

2. Select the Select check box.

3. Select the Depth check box.

4. Select a curve.

5. Indicate the two CAD edges that are normal to each other.

6. Clear the check box.

7. Click on the part.

If a Depth curve is provided, PC-DMIS will form a plane by crossing the vector of each edge with the vector of the depth curve and piercing that plane to create a point.

Wire Frame Data Mode 2
No Depth Curve

1. Check mark the Select check box.

2. Indicate the two CAD edges that are normal to each other.

3. Deselect the check box.

4. Click on the part.

If a depth curve is not selected PC-DMIS simply drops the selected point onto the curve.

Note: Only LINEAROPEN, LINEARCLOSE and PATCH scans can use wire frame data.


Adding and Deleting Boundary Points

The Add and Del buttons allow you to add or delete boundary points to the list of boundary points. There are some restrictions regarding each type of scan. For example, a LINEARCLOSE scan will take only a Start and Direction point. It will not allow you to add more points or delete these two points. Please refer to each scan for specific restrictions.


Editing Boundary Points

Boundary points can be edited by double-clicking the number of the desired point in the ‘#’ column.

This will display the Edit Scan Item dialog box allowing you to edit the X, Y, Z values.

Edit Scan Item dialog boxes depicting Flip button and Point at Hole check box

The column widths of the Boundary Point list can be varied by changing the width of the list display column header. This is done by selecting the right or left edge of a column header with the left mouse button and pulling the edge to the desired size. The width of each list display is individually set and determined by the user. This information is saved in the INI file to be used each time the fields are changed.

Flip:

The Flip button is only available when editing a vector. Clicking this button flips the selected vector.

Point At Hole:

The Point At Hole check box only becomes available when you work with Section scans. It allows you to change a non-hole point to a hole point.

A hole point defines where a linear section scan jumps over a hole that's found in its path. After clicking the Cut Cad button PC-DMIS places hole points on either side of any hole that interrupts the section scan.

Hole points are defined with the letter "H" following the point number (For example 1H, 2H, 3H etc.). These points, like any boundary point, are added to both the Boundary Points list and on the part model in the Graphics Display window.

Note: The Point At Hole check box is only available for non-hole points that you need to change to hole points. If you have a hole point that needs to be changed to a non-hole point, delete the hole point and create a new non-hole point.


Clearing Boundary Points

You can easily clear the Boundary Points list of any of the scan types by right-clicking while the cursor is inside the Boundary Points list. A Reset Boundary Points button appears. Clicking this button will reset all the boundary points to zero and the number of boundary points will be set to the minimum for each scan type.

Note: PC-DMIS doesn't allow you to clear the boundary points while you are using the Cut CAD button available on Section scans. In this case you will need to click the Show Bnd button to show the boundary points again before clearing the boundary points.


Direction Technique areas

The Direction 1 Tech and Direction 2 Tech areas, let you select direction techniques that determine how the scan will take its hits. Most scans only scan in one row or line, so, they only have one set of direction techniques in the Direction 1 Tech list.

Patch scans are unique in that they scan over an area and so have additional rows of points and use a second set of direction techniques in the Direction 2 Tech list. In the Direction 2 Tech list, the selected technique determines the incremental technique that will be applied between rows.

Select the desired technique and PC-DMIS will automatically display the Max / Min or Increment boxes.

More:

Line Technique

Body Axis Technique

Variable Technique

Nullfilter Technique

Max / Min boxes

Increment box


Line Technique

For Linear Open, Section and Patch scans - PC-DMIS determines each hit based on the set increment and the last two measured hits. The approach of the probe is perpendicular to the line between the last two measured hits. The probe will stay on the cut plane. PC-DMIS will start at the first boundary point and continue taking hits at the set increment, stopping when it reaches the end boundary point.

For Linear Closed scans - PC-DMIS determines each hit by the last two hits measured. The approach of the probe is perpendicular to the line between the last two measured hits. The probe will stay on the cut plane. PC-DMIS will not ask for the ending point when using this scanning technique. The scanning process terminates when the probe returns to the starting point.

For Rotary scans - PC-DMIS determines each hit based on the set increment and the last two measured hits. The approach of the probe is perpendicular to the line between the last two measured hits. The probe will always maintain the defined radial distance from the center point, perpendicular to the center point vector. PC-DMIS will start at the first boundary point and continue taking hits at the set increment, stopping when it reaches the end boundary point.


Body Axis Technique

Available to Linear Open, Patch, and Rotary scans

PC-DMIS will take hits at the set increment along the current part's coordinate system. The approach of th [image] e probe is perpendicular to the indicated axis. The probe will stay on the cut plane. The approach vector will be normal to the selected axis and on the cut plane. The BODY AXIS technique uses the same approach for taking each hit (unlike the LINE technique which adjusts the approach to be perpendicular to the line between the previous two hits).


Variable Technique

Available to Linear Open, Linear Closed, Patch, Section, and Rotary scans

The VARIABLE technique allows you to set specific maximum and minimum angle and increment values that will be used in determining where PC-DMIS will take a hit. The probe 's approach is perpendicular to the line between the last two measured hits.

Enter the maximum and minimum values that will be used to determine the increments between hits. You also must enter the desired values for the MAX and MIN angles. PC-DMIS will take three hits using the minimum increment. It will then measure the angle between hit's 1-2 and 2-3.

  • If the measured angle is between the maximum and minimum values defined, PC-DMIS will continue to take hits at the current increment.

  • If the angle is greater than the maximum value, PC-DMIS will erase the last hit and measure it again using one quarter of the current increment value.

  • If the angle is less than the minimum increment, PC-DMIS will take the hit at the minimum increment value.

PC-DMIS will again measure the angle between the newest hit and the two previous hits. It will continue to erase the last hit and drop the increment value to one quarter of the increment until the measured angle is within the range defined, or the minimum value of the increment is reached.

  • If the measured angle is less than the minimum angle, PC-DMIS will double the increment for the next hit.

  • If this is greater than the maximum increment value, it will take the hit at the maximum increment.

PC-DMIS will again measure the angle between the newest hit and the two previous hits. It will continue to double the increment value until the measured angle is within the range defined, or the maximum increment is reached.

If ANGLE > MAX ANG then INC = INC / 4 until MIN INC
If ANGLE < MIN ANG then INC = INC * 2 until MAX INC

Note: Patch scans by default always start each new scan line with the minimum increment. If you would prefer that each new line start with the increment from the previously scanned line you can select the Patch Scans Maintain Last Increment check box found in the General tab of the Setup Options dialog box (see "Patch Scans Maintain Last Increment" in the "Setting Your Preferences" section).


Nullfilter Technique

Available to Linear Open, Linear Close, Patch, Section, and Rotary scans

The NULLFILTER technique does not filter data at all. Whatever data PC-DMIS receives from the machine controller is the data given you. Although Probe Compensation and FindNoms are still applied there is no data reduction. This technique lets you control the increment of the hits by using the OPTIONPROBE command which sets the point increment during a scan. See the "Parameter Settings: Optional Probe tab" topic of the "Setting Your Preferences" section for more information.

PC-DMIS will start at the first boundary point and continue taking hits at the set increment, stopping when it reaches the end boundary point.

NOTE: The NULLFILTER technique only appears in the Direction 1 Tech. list if you're using an analog probe head, such as the SP600.

For Rotary scans, the probe will always maintain the defined radial distance from the center point, perpendicular to the center point vector.


Max / Min boxes

Available to Linear Open, Linear Close, Patch, and Section scans

The Max / Min increment and angle boxes described below are available when using the VARIABLE scanning technique described in the "Direction 1 Technique (Variable Method)" topic. Only the Max Incr box is available for all the scanning techniques.

Max Increment

The Max Incr box allows you to set the maximum increment distance. Even though increments may increase while using the Variable option, the increments will never be greater than this distance.

Min Increment

The Min Incr box allows you to set the minimum increment. Even though increments may decrease using the Variable option, the increments will never be smaller than this distance.

Max Angle

The Max Ang box allows you to set the maximum angle. Even though angles measured may increase while using the Variable option, the angles will never be greater than this value.

Min Angle

The Min Ang box allows you to set the minimum angle. Even though angles measured may decrease while using the Variable option, the angles will never be less than this value.


Increment box

Available to Patch scans

Used with Patch scans, the Increment box allows you to set the incremental distance between rows on the patch scan. For example, if you enter .5 then the scan will set the rows at increments of .5.


Scan Construction

 Increment box CAD Tol box Offset box Offset Tol box Calculate Boundary button Delete button

Scan Construction area (for Perimeter Scan)

Used with the Perimeter Scan

The Scan Construction area of the dialog box allows various options for constructing a Perimeter Scan. These include:

  • Increment

  • CAD Tol

  • Offset

  • Offset Tol (+/-)

  • Calculate Boundary

  • Delete

More:

Increment

CAD Tol

Offset

Offset + /

Calculate Boundary

Delete


Increment for a Perimter Scan

Increment box for a Perimeter scan

The Increment box indicates the distance between each of the hit points on the scan.


CAD Tol

The CAD Tol box is useful in detecting neighboring surfaces. The larger the tolerance, the farther apart the CAD surfaces can be and still be recognized as a neighboring surface.


Offset

The Offset box indicates the distance in from the perimeter where the scan will be created and executed.


Offset + / -

The Offset Tol (+/-) box indicates the amount of allowable deviation from the offset value. It is a user supplied value.


Calculate Boundary

The Calculate Boundary button determines the composite boundary of the input surfaces. The Calculated boundary appears as red dots in the Graphics Display window.


Delete

The Delete button deletes the previously created boundary.


Section Location

Section Location area (for Section Scan)

The box in the Section Location area specifies the initial section at which you would want the scan to start. For example, if you want multiple sections at X = 5, X=5.5, X = 6, etc. you must first specify 5.0 as the initial section. After each scan PC-DMIS will automatically jump to the next section at 5.5 and so on. This value can be edited directly, or it can be set using the first boundary point. The first boundary points ' coordinate value corresponding to the cut axis is the section location. When the first boundary point is defined by either taking a hit, selecting from CAD data or keying in a value, the coordinate value for the cut axis is used.

Example: If the first boundary point is set to 45, 37, 100 and the cut axis is Y, the section location is at 37. If the cut axis is X, the section location is 45.

More:

Axis

Increment


Axis

Axis list

The Axis list allows you to select the axis (X, Y, or Z) where you want multiple sections. The None option is also available. It allows you to select a ‘section line’ on screen. Scans do not usually allow users to work with curve data. However, if None is chosen, a section scan will let you select a graphically displayed section line that will then be used to define the cut plane and scanning path.


Increment for a Section Scan

Increment

The Increment box specifies the jump distance along the section axis after each scan is done.


Initial Vectors

Initial Vectors area

The Initial Vectors area displays a list of vectors that will be used to start and stop a scan. Some scans do not use any initial vectors. These are UV, Grid, Perimeter, and FreeForm scans. The following table shows the available initial vectors, when they are used, and their descriptions.

Vector Type

Used In Scan Type

Description

InitVec

Linear Open, Linear Closed, Section, Patch, Rotary, and Basic scans

Initial Touch Vector. The values that are displayed in the Initial Touch Vector row indicate the surface vector of the first point in the scanning process.

CutVec

Linear Open, Linear Closed, Patch, Section, and several Basic scans

Cut Plane Vector. A cut plane is used internally for DCC scanning calculations. This cut plane is derived differently for each supported scan type.

Linear Open: The Cut Plane vector (CutVec) is the cross product of the Initial Touch vector (InitVec) and the line between the start and end point. If there is no end point, the line between the start point and direction point is used.

Linear Closed: The Cut Plane vector (CutVec) is the cross product of the Initial Touch vector (InitVec) and the line between the start and end point.

Patch Scan: The cut plane vector (CutVec) is derived by crossing the Initial Touch vector (InitVect) and the line between the first and second point. The cut plane vector is then set to the correct direction by using the line between the second and third points. The End Touch vector (EndVec) is the vector used to take the second boundary points and is used to jump to the second row after completing the first row.

Section Scan: The Cut Plane and Initial Touch vectors are used to measure the scan. The Cut Plane vector is the cross product of the Initial Touch vector and the line between the starting and end point. If there is no end point, then the line between start and direction point is used.

EndVec

Linear Open, Patch, Section, Rotary, and Line Basic scan

End Touch Vector. The End Touch vector is the approach vector of the scan at the end of the row. This is used only to stop the scan or to move to the next row (in the case of a Patch scan).

PlaneVec

Linear Open, Linear Closed, Patch, Section, and Rotary

Boundary Plane Vector. The Boundary Plane vector and the End Touch vector are used with the given Boundary Condition to stop the scan. The Boundary Plane Vector has different uses when applied to different Boundary Conditions:

Plane

When used with a Plane Boundary Condition it represents the normal vector of the Plane.

Sphere

It is not used with the Sphere Boundary Condition.

Cylinder

When used with a Cylinder Boundary Condition it represents the Axis of the Cylinder.

Cone

When used with a Cone Boundary Condition it represents the Axis of the Cone.

DirVec

Rotary, Manual, and Line Basic scan

Initial Direction Vector. It represents the direction in which the scan will begin and is used with the Initial Touch vector to derive the Cut Plane vector.

SurfVec

Linear Open and Linear Closed

Top Surface Vector. This appears when you use the Edge hit type. It is the vector of the initial top surface of the edge and is used to start the scan.

vector1

Linear Open and Linear Closed

This row is the surface normal vector of the first surface selected for angle hits. It appears when you use the Angle hit type. This corresponds to the Surf 1 Vec values in the Angle Points tab when creating Auto Features. See "Creating an Auto Angle Point" in the "Creating Auto Features" section.

vector2

Linear Open and Linear Closed

This row is the surface normal vector of the second surface selected for angle hits. It appears when you use the Angle hit type. This corresponds to the Surf 2 Vec values in the Angle Points tab when creating Auto Features. See "Creating an Auto Angle Point" in the "Creating Auto Features" section.

More:

Graphical Representation of Vectors

Editing Vectors


Graphical Representation of Vectors

When setting up the start, direction, and end points of the scan, PC-DMIS allows you to see a graphical representation of the initial touch vector, the direction vector, and the vector that is normal to the boundary plane where the scan will stop.

These vectors are shown as blue, green, and orange colored arrows in the Graphical Display area of your part.

Colored arrows showing vectors

Vector | Graphical Representation
Initial Touch | Blue arrow
Direction | Green arrow
Boundary Plane | Orange arrow


Editing Vectors

You can edit each of these vectors by double-clicking on the vector to edit in the vector column.

This will display the Edit Scan Item dialog box:

Edit Scan Item dialog box

Using the different fields, you can edit the I, J, K values.

  1. Clicking the OK button on the Edit Scan Item dialog box will apply any changes that have been made.

  2. Clicking the Cancel button will close the Edit Scan Item dialog box without applying any changes.

  3. Pressing the Next button cycles through the available vectors in the Initial Vectors list. Some of the initial vectors can be flipped. If so, then the Flip button becomes available on the Edit Scan Item dialog box.

  4. Pressing the Flip button allows you to reverse the direction of the selected vector.


Select Center

Select Center (for Rotary Scan)

Choosing the Select Center check box allows you to click on the CAD to indicate the center point. A surface point or a wire frame point can be selected. PC-DMIS will fill in the Center Point boxes with the XYZ information for the selected point.

When you select this check box, be aware that the boundary points of the scan will not be updated. Only when you deselect this check box will PC-DMIS update the boundary points.


Center Point and Radius

Center Point and Radius (for Rotary Scan)

The X, Y, and Z values of Center define the center point of the ROTARY scan.

You can directly type the center point X, Y, and Z values or you can choose the Select Center check box and click on the CAD drawing to take the center point directly from the CAD model.

R defines the radius. When PC-DMIS executes the scan it will rotate around the center point maintaining this distance as the scan moves from the Start to the End point.


IJK (for Rotary San)

IJK (for Rotary Scan)

The I, J, and K values make up a vector normal to the plane in which the Radius is maintained from the center point. PC-DMIS will follow this vector when performing the scan.


UV Scan Settings

UV Scan Settings area

UV Scan Settings area

The UV Scan Settings area allows you to define your UV scan. It contains the U and V rows and allows you to define the following controls.

  • The Hits values allow you to specify how many hits the scan will take on the surface in the U or V direction.

  • The Start and End values allow positioning of the hit matrix on the surface that is being scanned. These values can be set for both the U and V rows and apply to the scan along the U and V axes. Note that UV space uses numbers between 0.0 and 1.0 to represent the entire surface. So 0.0, 0.0 will be on the opposite diagonal corner from 1.0, 1.0.

  • The non-editable Position fields indicate the probe 's current position along the U and V axes.


Grid Scan Settings area

The Grid Scan Settings area lets you define the number of hits to equally space in the A and B directions of a Grid scan. The A direction is horizontal, B is vertical. For example, if you typed 20 in the A direction and 20 in the B direction, PC-DMIS would attempt to space 20 rows and 20 columns of points on the combined selected surfaces within the rectangular area.

In the screen shot below, only the top surface on the Hexagon block is selected. PC-DMIS will only drop points onto that surface, not the others.

Grid Scan example, showing the A and B directions with 20 points in both directions

Grid Scan example, showing the A and B directions with 20 points in both directions


Execution Tab

Execution tab from a scan dialog box

The options on the Execution tab let you determine what happens when you execute the scan being created. It contains these areas:

  • Exec Controls area

  • Nominals Method area

  • Hit Controls area

  • Display Controls area

  • Boundary Type area


Exec Controls area

The options in this area aren't used for all scan types. For example, manual scans only use a few of these options.

Item

Description

The Execute list

This list lets you determine how PC-DMIS will execute a scan after the scan has been learned.

Normal - PC-DMIS will execute the scan in its 'normal' manner; it will trigger a hit when the probe touches the part.

Example: If a DCC scan is executed, PC-DMIS will take hits at each of the learned locations in stitch scanning mode, storing the newly measured data. The displayed nominals will be the same as when the scan was learned and cannot be re-calculated using a different Nominals mode.

Re-learn - PC-DMIS will execute the scan as though it is learning it. All learned measured data will replace the new measured data. The nominal will be re-calculated depending on the Nominals Mode (see "Nominals Mode")

Example: If a DCC scan is being re-learned, PC-DMIS will relearn the scan from the beginning, instead of taking hits at the learned locations (as it would do in the case of the NORMAL mode).

Defined - PC-DMIS allows the controller to ‘define’ a scan. PC-DMIS gathers all hit locations from the editor and passes them onto the controller for scanning. The controller will then adjust the path allowing the probe to pass through all the points. The data is then reduced according to the increment provided and the new data will replace any old measured data.

When this option is used after Generating the scan Offline, the nominal locations obtained from CAD will be used every time to drive the CMM.

This mode is available only when using analog probe heads that can do continuous contact scanning.

Important: The Defined mode with Perimeter scans does not support hole avoidance. Ensure that there aren't any holes in your scan's pathway with this execution mode; if there are, either adjust your Perimeter scan's path or switch to the Normal execution mode.

ClearPlane check box

The ClearPlane check box inserts a CLEARP MOVE a predetermined distance relative to the current coordinate system and part origin before taking the first hit.

After the last point in the scan is measured, the probe will stay at probe depth until called to the next feature. Using clearance planes reduces programming time because the need to define intermediate moves is reduced. (See "Parameter Settings: Clearplane Tab" in the "Setting Your Preferences" section for additional information on clearance planes.) This option is only available for DCC scans.

Single Point check box

The Single Point check box considers each hit as a single measured point.

If this option is check marked, PC-DMIS will make each hit a measured point and insert it into the part program. This sequence will happen after the manual scan has been reduced. If the scan is in DCC mode, it will take place after the scan has been learned.

Auto Move check box

The Auto Move check box will let you turn on Auto Moves for each scan. Once selected, you can type the distance for the move in the Auto Move box.

LINEAROPEN, LINEARCLOSE, PATCH, SECTION, PERIMETER and BASIC SCAN AXIS

For these scan types PC-DMIS will

  • Generate an automatic move at the distance specified above the scan's start point.

  • Run the scan.

  • Generate another automatic move at the distance specified above the last scan point.

BASIC SCAN CIRCLE, CYLINDER, and CENTER

For these scan types PC-DMIS will

  • Before the scan starts, generate an automatic move above the centroid of the feature at the distance specified.

  • Perform the scan

  • After the scan ends, generate another automatic move above the centroid of the feature at the distance specified.

Probe Comp check box

The Probe Comp check box allows you to determine whether or not PC-DMIS turns on probe compensation for this specific scan.

In most cases you probably don't need to perform this compensation since a scan's FINDNOMS operation automatically does it. However, if you don't have CAD and want to reverse-engineer a part, you should select this check box.

Cad Comp check box

This check box determines whether or not PC-DMIS compensates for each point using the 3D surface vector from the CAD file. If not selected, PC-DMIS uses a 2D cut plane as usual.

This check box becomes available for selection if you select FINDNOMS from the list in the Nominals Method area or if you click on the CAD model in the Graphics Display window.

Inner Bound check box

This check box allows you to determine whether or not PC-DMIS will perform an interior or an exterior perimeter scan.

  • If selected, PC-DMIS will perform an interior perimeter scan.

  • If deselected, PC-DMIS performs an exterior perimeter scan.

For a description of interior or exterior scans see the "Performing a Perimeter Advanced Scan" topic.

Use COP check box

This check box determines whether or not the scanned points also get added to an existing Cloud of Points (COP) command. If you select this check box, you can type the ID for the COP command into which you want to add the newly scanned points. If the COP command doesn't yet exist, PC-DMIS will ask if it should generate it for you.

For information on COP commands, access the PC-DMIS Laser documentation where this command is discussed.


Nominals Method area

When MASTER is selected from the Nominals list, PC-DMIS will consider the measured data obtained the first time the scan is being learned as nominal data. Subsequent executions of this scan will be compared with this measured data. When MASTER is used with a DCC scan and Normal Mode is selected from the Execute list, PC-DMIS will execute a Stitch-type scan using the measured data.

When the FIND NOMS option is selected, PC-DMIS will pierce the CAD model to find the closest location on a CAD surface to the measured point. It will then set the nominals to the location found on the CAD surface.

Note: With the Circle, Cylinder, and Axis types of Basic Scans, there is no need to have CAD data to find the nominals. To execute the Basic Scan, PC-DMIS obtains the nominals from the nominal data you supply. See "Nominals Mode Tab" for more details.

If proper nominals are not found PC-DMIS first asks you to provide a new Find Nominal tolerance.

You can type a new tolerance in the Tolerance box and apply it to only for the current scan or for the whole part program.

    • If the response is Yes, the new tolerance will be used to find nominals.

    • If the response is No, PC-DMIS will do the following:

If proper nominals cannot be found for any hit even after providing a new tolerance, PC-DMIS will ask if the hits can be deleted.

    • If the response is Yes, the hits will be deleted.

    • If the response is No, the hits will remain in the scan.

When NOMINALS is selected from the Nominals list, PC-DMIS will use any measured data the first time it performs the scan as nominal data. This option allows you to relearn the scan without relearning the nominals. The main difference between selecting NOMINALS and MASTER is that the NOMINALS option constructs a nominal curve from the nominal data. PC-DMIS will then compare subsequent executions of the scan against this nominal curve using the value in the Find Noms Tol box.

The Nominals Mode can be used with Relearn Mode in the Execute list in the Exec Controls area. See "Exec Controls area".

Note: If you toggle to NOMINALS in the Edit window from a different mode, the nominal curve will automatically be created from the current theoretical data. This may take some time depending on the amount of data used. Also if the Edit window is set to NOMINALS and you toggle to a different mode the nominal curve gets deleted.

Nominals Method area

This area contains these items:

Item

Description

Nominals list

The Nominals list lets you determine how PC-DMIS will gather nominals for the measured data.

Master Scan

Find Noms

Nominals

Tolerance box

The Tolerance box allows you to set a new nominal tolerance if the proper nominals are not found when using the Find Noms option from the above Nominals list.

Be sure to type a tolerance value that at least compensates for the probe 's radius. If this value is too low, PC-DMIS may display an error message that it cannot find the part when it attempts to generate the scan

Use BestFit check box

The Use BestFit check box performs a temporary BestFit alignment on the scan in order to find better nominals for the measured data. See Find Noms in the Nominals list above for more information.

PC-DMIS follows this sequence for your scan:

  • PC-DMIS performs a FindNoms operation.

  • PC-DMIS internally creates a Best Fit alignment from the found nominal points and the measured data of the scan. If it is a Patch scan, the Best Fit is 3D.

  • PC-DMIS performs a FindNoms operation.

  • PC-DMIS internally creates a Best Fit alignment from the found nominal points and the measured data of the scan. If it is a Patch scan, the Best Fit is 3D.

  • PC-DMIS performs a FindNoms operation.

  • PC-DMIS restores the original alignment.

For parts with large deviations from nominals this check box helps find the nominal data that more accurately represents the part.

For more information on Best Fit alignments, see "Creating a Best Fit Alignment" in the "Creating and Using Alignments" section.

Only Selected check box

When you execute a scan in your part program, and you are searching for the nominal values for the scan's measured points, you can use the Only Selected check box to have PC-DMIS only look for the nominals on the currently selected set of surfaces.

Note: If any of your selected surfaces are already defined as priority surfaces within the Edit CAD Elements dialog box, PC-DMIS maintains their priority over the other selected surfaces in the set (see "Editing CAD" from the "Editing the CAD Display" section).


Hit Controls area

The Hit Controls area contains a list that controls where hits are taken. Other boxes in this area get hidden or displayed depending on the type of hit selected from the hit type list. This area contains these items:

Item

Description

Hit Type list

The Hit Type list contains these hit types:

  • VECTOR - The scan uses vector hits.

  • SURFACE - The scan is taken along a surface and uses surface hit data.

  • EDGE - The scan is taken along an edge. When Edge hits are used and CAD data is available, PC-DMIS will allow you to enter a flush thickness for the nominals. This thickness is applied normal to the edge approach vector when finding the nominals for the scan. (This is contrary to the regular thickness that is applied along the surface normal.)

  • ANGLE - This scan uses ANGLE hit data.

The scan will always do a stitch scan regardless of the probe head type.

Initial box

The Initial box allows you to set how many sample hits are taken before each actual point is measured. These sample hits are taken only the first time a scan is run.

Perm box

The Perm box allows you to set how many sample hits are permanently taken before each actual point is measured. These sample hits are taken each time the scan is run.

Spacer box

The Spacer box allows you to set the distance between sample hits.

Depth box

The Depth box allows you to set the depth from the edge where the sample hits will be taken. This option is only available if EDGE is selected from the Hit Type list.

Indent box

The Indent box allows you to set the indent on the top surface from the edge where the sample hits will be taken. This option is only available if EDGE is selected from the Hit Type list.

Indent 1 box

The Indent 1 box allows you to set the indent on the top surface from the edge where the sample hits will be taken. This option is only available if ANGLE is selected from the Hit Type list.

Indent 2 box

The Indent 2 box allows you to set the indent on the top surface from the edge where the sample hits will be taken. This option is only available if ANGLE is selected from the Hit Type list.

Flush box

The Flush box allows you to enter a flush thickness for the nominals if an Edge or Angle hit type is used and CAD data is available. This thickness is applied normal to the edge approach vector when finding the nominals for the scan. (This differs from the regular thickness which is applied along the surface normal.)


Display Controls area

The Display Controls area lets you determine what kind of information the scan displays in the Edit window. It contains these items:

Item

Description

Show Hits check box

If you select this check box, PC-DMIS displays each scan in the Edit window as a set of the measured hits surrounded by a scan object and an end measured object. If this option is chosen, all of the hits will be displayed in the Edit window. If you don't select it, the hits will not be shown.

Show All check box

If you select this check box, PC-DMIS will display in the Edit window all of the scan parameters, such as:

  • Cut planes

  • Boundary points

  • Direction vector

  • Initial approach vector

If you don't select it, PC-DMIS only displays these data types in the Edit window:

  • Increments

  • Techniques

  • Hit Types


Boundary Type area

The Edit Window command line for the plane boundary type reads:

BOUNDARY/PLANE, x,y,z,PlaneVec=i,j,k, EndVec=i,j,k,Crossings

  • PlaneVec: This vector defines the plane normal vector at the end point.

  • EndVec: The approach vector at the end point

The sphere is located at the End Point but offset from the surface by a probe radius along the approach vector so that the center of ball will pass through the sphere.

The Edit Window command line for the sphere boundary type reads:

BOUNDARY/SPHERE, x,y,z,EndVec=i,j,k,Radius,Crossings

  • Radius: The radius of the sphere.

  • EndVec The approach vector at the end point

The cylinder is located at the End Point but offset from the surface by a probe radius along the approach vector so that the center of ball will pass through the cylinder.

The Edit Window command line for the cylinder boundary type reads:

BOUNDARY/CYLINDER, x,y,z, Axis=i,j,k, EndVec=i,j,k,Radius,Crossings

  • Radius: The radius of the cylinder.

  • AxisVec: This vector defines the axis of the cylinder at the end point.

  • EndVec: The approach vector at the end point

The cone Vertex is at the end point of the scan.

The Edit Window command line for the cone boundary type reads:

BOUNDARY/CONE, x,y,z, Axis=i,j,k, EndVec=i,j,k,HalfAngle,Crossings

  • HalfAngle: The half-angle of the cone.

  • AxisVec: This vector defines the axis of the cone at the vertex.

  • EndVec: The approach vector at the end point

Previous versions of PC-DMIS used a combination of boundary crossings and scan increments to stop the scan. OldStyle is not actually an option that you choose, rather it is an internal setting for scans that were created in earlier versions of PC-DMIS.

When scans from PC-DMIS version 2.3 are read into version 3.0 and higher, they are converted and their respective boundary conditions are tagged as OldType.

The Edit Window command line for the oldstyle boundary type reads:

BOUNDARY/OLDSTYLE, x,y,z,PlaneVec=i,j,k, EndVec=i,j,k

  • PlaneVec: This vector defines the plane normal vector at the end point.

  • EndVec: The approach vector at the end point.

Boundary Type area

The Boundary Type area creates an imaginary feature that acts as a boundary around a scan's end point. By default, this feature is a plane at the end point that when crossed one time stops the scan. However, you can define the end boundary type to be a different type of feature.

Boundary types are only available for Linear Open, Linear Close, Patch, Section, and Rotary scans in DCC mode.

The area contains these items:

Item

Description

The boundary type list lets you choose how a scan ends. Each boundary type uses a value from the Crossings box.

Plane - The scan will stop after the probe crosses the plane at the end point the given number of times.

Sphere - The scan will stop after the probe crosses (breaks) the sphere at the end point the given number of times.

Cylinder - The scan will stop after the probe crosses (breaks) the cylinder at the end point the given number of times. The cylinder is unbounded (i.e. is considered infinite in length).

Cone - The scan would stop after the probe crosses (breaks) the cone at the end point the given number of times. The cone is unbounded (i.e. is considered infinite in length).

OldStyle - (Retained for backwards compatibility)

Crossings box

The Crossings box determines how many times a scan crosses the selected boundary type before stopping the scan. For example, if you specify that the number of crossings is two, the scan will stop once the probe's BallCenter crosses the given condition’s surface (planar, spherical, cylindrical, conical etc.) two times.

Note: Linear Closed scans always require at least two boundary crossings even if the Crossings box specifies a lower number.

Radius box

The Radius box appears when you select either Sphere or Cylinder as your boundary type. It lets you define the radius of that boundary type feature.

Angle box

The Angle box appears when you select Cone as your boundary type. It lets you define the cone's total 'included' angle.

Note: You can change the boundary condition at anytime for a scan. If you choose a new condition for a DCC scan, PC-DMIS applies it to all BasicScans making up the DCC scan. If, however, you chose to change a specific value in a condition, for example, maybe the radius of the sphere boundary type, PC-DMIS does not propagate that change to the BasicScans. You would have to change that value in each BasicScan yourself.


Graphics Tab

Graphics tab from a scan dialog box

The Graphics tab lets you use the on-screen CAD model to aid in creating a scan. This tab contains the Cad Controls area. This area lets you specify the CAD surface/wire frame elements that will be used to find nominals as well as the part's thickness.

In some cases, a scan might start over a certain surface and travel over many other surfaces before completion. In such cases, PC-DMIS does not know which CAD elements are to be used to find nominals. It must therefore search through every surface in the CAD model. If the CAD model has many surfaces it might take a long time before the FINDNOMS operation is successful.

Item

Description

Select check box

Selecting this check box and clicking on surfaces lets you define the exact surfaces to scan. Manually determining the surfaces to scan helps speed up the FINDNOMS process. Once a CAD surface is selected, it will be highlighted in the Graphics Display window. The Status bar will display the number of surfaces that have been selected. If the Select check box isn't selected, PC-DMIS will assume any clicks on the surface to be Boundary Points.

Example: Two edges that are normal to each other must be selected for every surface the scan is going to travel over. If the scan is going over three surfaces, six edges (representing the three surfaces) must be selected in the proper order. The first two edges will indicate surface one. The third and fourth edges will indicate surface two. Edges' five and six will make up the third surface, and so on.

Deselect button

If you select an incorrect surface, click on that surface a second time. This will deselect the surface. Clicking the Deselect button will deselect one surface at a time with each click of the button from a group of highlighted surfaces until all are deselected. Clicking the Deselect All button will deselect all highlighted surfaces at once.

The Deselect button removes one highlighted CAD element at a time from a group of CAD elements that are created using the Select check box.

Deselect All button

The Deselect All button removes all the selected CAD elements that are created using the Select check box.

Depth check box

This check box is used only when selecting Curve elements. You can indicate a particular CAD curve element as a Depth element.

To use the Depth check box:

  1. Select all other CAD elements first.

  2. Select the Depth check box.

  3. Select a CAD element.

The Depth curve is used during FINDNOMS operations. Whenever PC-DMIS has to find nominals from curve elements, it will take the vector of the Depth CAD element, cross it with the vector from the other selected CAD elements to get a plane. It will then pierce the plane to get the proper nominal. If many CAD elements are selected, the closest pierce point is used as the nominal point. When CAD wire frame data is being used, PC-DMIS will look for the wire frame data in pairs.

vector1 check box

The vector1 check box only appears if you select Angle from the Hit Type list and you are using surface data. It allows you to select CAD surfaces that PC-DMIS will use to find the nominal. You can indicate the group of surfaces that PC-DMIS uses to find the angle hit Surf 1 Vec by selecting this check box and then selecting CAD surfaces from the Graphics Display window.

vector2 check box

The vector2 check box only appears if you select Angle from the Hit Type list and you are using surface data. It allows you to select CAD surfaces that PC-DMIS will use to find the nominal. You can indicate the group of surfaces that PC-DMIS uses to find the angle hit Surf 2 Vec by selecting this check box and then selecting CAD surfaces from the Graphics Display window.

Thickness box

The Thickness box allows you to input the part thickness. Positive or negative values can be used. This amount is primarily used for thin parts (plastic or sheet metal) where the CAD data only describes one side. Often with thin parts, the CAD engineer will only draw one side of the part, and then specify the material thickness. PC-DMIS will apply this material thickness automatically when using the CAD surface data.

This thickness will be applied along the surface normal vector when FINDNOMS mode is selected and PC-DMIS pierces the CAD surfaces to get the nominals, even when using Edge hits.


Control Points Tab

Control Points tab

Note: The Control Points tab only appears if you use an analog probe head that allows continuous contact scanning .

The Control Points tab allows you to add control points to your scan. Control points interrupt the normal scan functions and allow you to define specific locations on the scan which alter the scan speed, point density or both. Good continuous scans often require different scan speeds and/or point densities for different parts of the scan.

The ability to add control points has been added to these types of scans:

  • Linear Open

  • Linear Closed

  • Patch

  • Section

  • Line (Basic Scan)

The Control Points tab contains the Control Points Definition area. This area lets you define each control point. It contains these items:

Item

Description

Type list

This defines the type of control point. Available types include:

  1. Plane
    PLANE, X, Y, Z, I, J, K, Num Crossings, Scan Speed, Point Density

  2. Sphere
    SPHERE, X, Y, Z, I, J, K, Num Crossings, Scan Speed, Point Density, Diameter

  3. Cone
    CONE, X, Y, Z, I, J, K, Num Crossings, Scan Speed, Point Density, Angle

  4. Cylinder
    CYLINDER, X, Y, Z, I, J, K, Num Crossings, Scan Speed, Point Density, Diameter

These types are similar to the boundary points.

Number of Crossings box

This box defines the number of times the probe must cross the interrupt boundary before adjusting the specified parameters.

Diameter box

This box defines the diameter of the Cylinder or Sphere control point.

Angle box

This box defines the half angle of the Cone control point.

Point Density box

This box defines the density of the points that are read into the scan data during a continuous contact scan. This is listed as number of points per mm.

Speed box

This box defines the speed of the machine while it traverses the part surface performing scans.

From Manual Hit check box

If you select this check box, you can define the control point's XYZ and IJK location by manually taking a hit with the probe (or by clicking on the part if working in off-line mode).

XYZ boxes

These boxes define the XYZ location of the control point.

IJK boxes

These boxes define the IJK vector of the control point.

Add button

Adds a new, undefined control point.

Delete button

Deletes the current control point.

Next button

Goes to the next control point. The boxes in the area change to show the new point's data.

Prev button

Goes to the previous control point. The boxes in the area change to show the new point's data.

Delete All button

Deletes all the control points in the scan.

Update button

Updates all the control points in the scan with the setting for the current control point.

More:

Adding and Using Control Points

Scanning after Adding Control Points


Adding and Using Control Points

  1. Access the Scan dialog box.

  2. Define your scan. Based on your type of scan, the minimum number of boundary points for the following scan types are automatically defined:

    Plane
    Sphere
    Cone
    Cylinder

  3. Click the Control Points tab.

  4. Add interrupt point locations by one of three available methods:

  • Method 1: Key-in point locations. Click the Add button and then type the required values for each point.

  • Method 2: Select the From Manual Hit check box and then use the machine to touch the locations on the part where you want to have the control points. PC-DMIS adds the information to the Control Points dialog box.

  • Method 3: In the Graphics Display window, left mouse click on the CAD model where you want to have the control points. PC-DMIS adds the information to the Control Points dialog box.

For methods two and three, PC-DMIS automatically snaps the chosen points to the cut plane of the scan for all scan types except Patch scans.

  5. Continue using the methods in step 4 to define all desired control points.

  6. Once your control points are defined, click the Create button. The Scan dialog box will close and create your scan.

  7. If you want to edit, delete, or add additional control points, simply click the Control Points tab at any time and make modifications as needed.


Scanning after Adding Control Points

Once you've defined all the control points and created your scan, during execution, PC-DMIS does the following.

  1. The scan will initially use the globally set Scan Speed and Point Density values.

  2. As it scans along the path and passes within the parameters defined by the control points, the scan behavior changes as directed by the control points.

  3. Once the scan is completed, the Scan Speed and Point Density will return to the globally set values.


Path Definition Tab

Sample Path Definition tab from a Scan that Supports the Spline Path Area

Note: Only some scans support the Spline Path area. These include: Linear Open, Linear Closed, Patch, Section, and Freeform. On other scans the Spline Path area will not appear.

The Path Definition tab has at most two areas, Theoretical Path and Spline Path. You can use these areas to generate a theoretical pathway for your scan, and, on supported scans, you can fit the theoretical data points to a secondary path, called a spline path. This essentially filters the number of theoretical points.

To create a theoretical pathway and fit it to a spline path:

  1. Select a scan type that supports a spline path (Linear Open, Linear Closed, Patch, Section, or Freeform).

  2. Select the Path Definition tab.

  3. Define the theoretical path. In most cases you can use the Read File button to import a preexisting set of theoretical data points, or click the Generate button. The Generate button automatically generates a set of theoretical data points in between your starting point and ending point from the existing CAD data.

Note: In the case of the Freeform scan, the Generate button does not exist, instead you click your mouse on the CAD itself to select the theoretical points.

  4. The points appear sequentially in the list, showing their XYZ, an IJK data. As long as you have more than five points in the Theoretical area, you can fit it to a spline path using the Calculate button in the Spline Path area. You don't have to fit the theoretical path to a spline path, but the initial data in the theoretical list generally may contain many more hits than you need.

  5. Define a spline path to which you will fit the theoretical path. Determine whether or not the theoretical points will form an open or a closed path, whether the path's calculation is interpolated or approximated, whether or not the points have a weight, and whether the spacing of the points is controlled by a defined density or a certain number of hits.

  6. When both areas are filled out click Calculate in the Spline Path area. PC-DMIS changes the theoretical data to fit the parameters specified in the Spline Path. An orange dot will appear in the Graphics Display window on the part for each point. If you have several points, these dots may mesh together to form an orange-colored band.

  7. When you have the points as you like them, click Create to generate the scan.

More:

Theoretical Path Area

Spline Path Area


Theoretical Path Area

The Theoretical Path area contains these items:

Item

Description

Theoretical Path list

This list displays the theoretical pathway your scan will take when executed. It displays the XYZ and IJK data for each point. You can import points from a text file by clicking the Read File button (if using a Freeform scan) or PC-DMIS can automatically generate the theoretical points by clicking Generate. In the case of a Freeform scan, you can create these points by clicking them on the CAD model.

These theoretical points are user editable. To edit the value of the points:

  1. Double-click the appropriate point number in the ‘#’ column. The Edit Theo Data dialog box will appear.

  2. Change the values in the desired X, Y, Z and I, J, K boxes.

  3. Click OK. The change will be updated in the Theoretical Path list.

Clicking the Next button in the Edit Theo Data dialog box will cycle through the points listed in the Theoretical Path list, allowing you to edit them one by one.

Generate button

This button takes information from the CAD model and automatically generates the theoretical pathway within the scan's boundary for these supported scans: Linear Open, Linear Closed, Patch, and Section. This often generates several points.

After you define the scan's boundary and click Generate PC-DMIS hides the dialog box, allowing you to view the scan as the software generates it on screen. After the scan is completed, PC-DMIS will re-display the dialog box. If the Create button is then pressed, a scan with the nominal hit data will be inserted into the part program.

PC-DMIS always uses the Find Nominal Tolerance value indicated in the Setup Options dialog box, General tab when generating nominal data for the scans and when finding the nominals for the learned scan.

Undo button

This button lets you remove the last action taken when importing, generating, or modifying the points in the Theoretical Path list.

Read File button

This button appears when using a Freeform scan. It lets you import points from a text file with a .txt filename extension. The text file should be in a comma delimited format with one point on each line, like this:

X,Y,Z,I,J,K

Jump Holes check box

This check box determines whether or not the theoretical path should jump over holes and other hole-like features in the surface. If selected, point data that does not lie within the selected surface (for example, hole features) will not appear in the Theoretical Path list and will be skipped during scan execution. If deselected, the scan will scan into hole-like features.

This appears on all scans but Perimeter and Freeform. It is not supported in these scans.

Offset box

The Offset box lets you define the minimum distance away from a boundary/edge where scan points are considered valid. Scan points that are closer to the boundary that the specified offset distance will not be allowed. For example, if you set your offset distance to .5 mm, any scan point located within .5 mm of the boundary/edge will not be allowed.

Tol. box

The Tol. box lets you set the tolerance value. PC-DMIS uses this to determine the hole locations in order to detect holes from CAD data.

  • If the distance between any two surface boundary points is less than the tolerance distance, PC-DMIS will consider this a continuous surface and scan into the hole.

  • If the distance is greater than the tolerance, PC-DMIS will assume that there is a hole between the surfaces, and during the learning process it will skip the hole.

This appears on all scans but Perimeter and Freeform. It is not supported in these scans.

Get Nominals button

The Get Nominals button lets you find the nominal after a scan has been learned or executed. PC-DMIS will find the nominals for the scan from the CAD data that is available.

To Points button

The To Points button runs a process whereby the individual points that make up an existing scan can be converted into single points after execution. The scanned set is then deleted.

For example:

  1. Place your cursor on a scan using hit data in the Edit window.

  2. Press the F9 key to display the Scan dialog box.

  3. Select the To Points button.

PC-DMIS will convert all hit data into single points and delete the scan from the Edit window.

Note: This process can also be done by selecting the Single Point check box, clicking the OK button, and executing the scan from the Edit window. PC-DMIS will execute the scan and then convert the hit data into single points.

Flip and Flip All buttons

The Flip button will flip the approach vectors of the theoretical scan point selected from the Theoretical Path list. PC-DMIS will ask if all of the vectors following that point should be flipped.

  • If you select Yes, then the direction of all the vectors, including and following the indicated point, will be reversed.

  • If you select No, then only the indicated vector will be reversed.

Flip All reverses all the vectors for all points in the list.

These only appear when you work with UV or Grid scans.

Delete button

This button will delete any selected points from the Theoretical Path list. It only appears when you work with UV or Grid scans.

This only appears when you work with UV or Grid scans.

Label Hits check box

This check box determines whether or not PC-DMIS should label each hit in the scan. Labeled hits looks something like this:

A UV scan with labeled hits

This only appears when you work with UV or Grid scans.


Spline Path area

Spline Path area

The Spline Path area contains several options that you can use to create a spline path to which your scan's theoretical path will be fitted.

This area does not exist for Perimeter, Rotary, UV, or Grid scans.

Using this area, you can determine whether or not the spline path will form an open or a closed path, whether the path's calculation is interpolated or approximated, whether or not the points have a weight, and whether the spacing of the points is controlled by a defined density or a certain number of hits.

When you finally calculate the spline path, the existing Theoretical Path list gets replaced with any filtered points. These points become the basis of the scan.

This area contains these items:

Item

Description

Curve list

This list contains two options: Open and Closed. An open curve passes through the start, control, and end points and then stops. A closed curve does the same but when the curve passes through the end point, it also returns to the start point.

Calculation list

This list contains two options: Approximate and Interpolated. It determines whether the spline path passes through points in the spline (interpolated) or simply approaches the points (approximate). Interpolated results in sharper curves and approximate results in smoother curves.

Weight list

This list contains two options: Yes and No. What you select determines whether or not PC-DMIS should give the points a weight when constructing the spline path. If set to yes, then PC-DMIS gives them a weight according to how close they are to other points on the curve. The further they are from other points the greater weight they have in the fitting process.

Spacing list

This list contains two options: Density and Hits.

  • If you select Density, PC-DMIS will create the spline path points at a given increment defined by the value in the Density box.

  • If you select Number of Hits, PC-DMIS will create the spline path points using and spacing the number of hits you specify in the Density box.

Density box

This controls the density or number of hits along the scan's path.

  • If you selected Density from Spacing list above, this box holds the increment value that controls the density of hits. The smaller the increment the greater the density.

  • If you selected Number of Hits from the Spacing list above, this box holds the number of hits to space along the theoretical pathway. If you typed "50", for example, PC-DMIS would attempt to fit all fifty points along the scan path.

Calculate button

This button calculates the spline and fits the theoretical data points to the spline, usually filtering out several hits. This button only becomes enabled if you have at least five hits in the Theoretical Path list.


Settings Tab

Note: The Settings tab only appears if you use an analog probe head that allows continuous contact scanning.

This tab contains the Scan Probing Parameters area. Using the items in this area, you can modify these frequently used scan parameters, without having to leave the scan dialog.

These options are also included in the Parameters dialog box¾ Motion tab or the Opt. Probe tab. See the "Parameter Settings: Optional Probe tab" and "Parameter Settings: Motion tab" topics in the "Setting Your Preferences" topic for information.


Common Functions of the BASICSCAN Dialog Box

BASICSCAN dialog box

A sample BASICSCAN dialog box

Many of the functions described in this section are common to Basic Scans. Some of these options are the same as the options in the advanced scans and have already been discussed. (See "Common Functions of the Scan Dialog Box" in this section for additional information). Options that relate specifically to one scan mode are appropriately indicated.

The following options are included on the first tab of each of the Basic scans.

The other tabs on the dialog box help you to define the scan.

More:

[Basic Scan] Tab

Filter Tab

Hit Type Tab

Boundary Tab

Execute Mode Tab

Nominals Mode Tab

General Tab


[Basic Scan] Tab

The [Basic Scan] tab is actually the main tab for each BASICSCAN feature. It is one of these tabs:

  • The Circle tab

  • The Cylinder tab

  • The Axis tab

  • The Center tab

  • The Line tab

Items found on these tabs include:

Dialog Box Item

Description

#,X,Y,Z columns

# - Displays the points used to generate the scan. These include Start Point, Direction Point, End Point, and Centroid.

  • Start Point: Used with AXIS, CENTER, and LINE scans, this point is the start point from which execution will start.

  • End Point: Used with AXIS, CENTER, and LINE scans, this point is the end point at which execution will end.

  • D: Used with a LINE scan, the Direction Point is used to start the scan and calculate the cut plane. The probe will always remain within the cut plane while doing the scan.

  • Centroid: Used with CIRCLE and CYLINDER scans, this point (found in the first list, under the # column) is the center of the circle or cylinder. You can type the center directly or get it from the Machine or CAD. For a cylinder, this is the center from which execution will start.

X,Y,Z - These columns display the coordinates for the item in the # column.

Vector,I,J,K columns

Vector - Displays the type of vector. These include InitVec and CutVec.

  • InitVec: Used with all the basic scans, the initial touch vector indicates the surface vector of the first point in the scanning process.

  • CutVec: Used with the CIRCLE, CYLINDER, CENTER, and LINE scans, the cut plane vector is the cross product of the InitVec and the line between the start and end point. If there is no end point, the line between the start point and direction point is used.

  • EndVec: Used with the LINE scan, the end vector is the approach vector at the end point of the scan.

  • DirVec: Used with the LINE scan, the direction vector is the vector from the start point to the direction point.

I,J,K - Displays the IJK vector information for the vector.

Surface Thick box

Used with all the basic scans, this box allows you to input part thickness. PC-DMIS will apply this material thickness automatically when using CAD surface data. This thickness will be applied along the surface normal vector when FINDNOMS mode is selected and PC-DMIS pierces the CAD surfaces to get the nominals.

Control Points button

Used with the LINE scan, this button displays a Control Points dialog box. This dialog box contains controls with similarities to the Control Points tab. See "Control Points Tab" to find equivalent documentation for the Control Points dialog box.

This button will only appear if you are using a continuous contact probe (analog probe), such as the SP600, and you can select it once you've defined the Start, Direction and End Points of the LINE scan.

Type list

This defines the type of CIRCLE, CYLINDER, or CENTER scan to perform.

When used with CIRCLE and CYLINDER scans, this switches between:

  • IN: Defines the scan as a hole

  • OUT: Defines the scan as a stud

  • PLANE: A plane circle is executed on the plane the circle is lying on.

When used with CENTER scans, this switches between available centering methods:

  • Axis: The Start Point (S) is projected on the defined Axis (A). The resulting point is (SP). The InitVec is projected in the plane defined by the Projected point (SP) and the axial direction (A). The direction (N) thus defined is vertical to the axial direction. Thereafter, as centering is performed, the probe’s center point remains in the plane defined by the axial direction and (SP). Centering takes with / against the direction (N) as an input, and the probe tip is free in the direction defined by the axial direction (A) crossing the direction (N).

S
 = Start Point
A = Defined Axis / Axial direction
SP = Projected Start Point
N = Direction vertical to the axial direction

  • Plane: After probing the point defined by the Start Point, the CMM centers with/against the probe direction while remaining free in the plane defined by the CutVec.

Diameter box

Used with the CIRCLE or CYLINDER scans, this is the diameter value of the feature to scan.

Conical check box

Used with CIRCLE scans, this check box lets you scan more quickly when not perpendicular to the part surface. PC-DMIS continues to monitor the probe force as needed.

Start Angle box

Used with a CIRCLE scan, this defines the start angle (in degrees to scan ) from the start point. Both positive angles and negative angles can be used. Positive angles are considered counterclockwise and negative angles are considered clockwise. The CutVec is considered the axis about which the angle rotates.

End Angle box

Used with a CIRCLE scan, this is the same as the Start Angle box except it defines the ending angle. With Start and End Angles you can define a specific portion of a hole or stud to scan.

Angle box

Used with the CYLINDER scan, this defines how far around the cylinder to scan. For example, if you type 360, it will scan one complete revolutions; if you type 720, it will scan two revolutions, and so forth.

Depth box

Used with the CIRCLE and CYLINDER scans, this is the depth applied against the CutVec direction. Both positive and negative values can be used.

Pitch box

Used with the CYLINDER scan, the Pitch box defines the distance between threads along the axis of the feature. This allows your scan to move in a spiral-like fashion along the cylinder.


Filter Tab

Basic Scan dialog box - Filter Tab

BASICSCAN dialog box - Filter Tab

Available options for the Filter tab are the following:

  • Distance Filter – This does the same thing as the "Line Technique" with a Linear Open scan.

  • Variable Filter – See Linear Open in " Variable Technique ". This scanning technique is only available for the Line scan.

  • Null Filter – See "NullFilter Technique".

  • The Max Increment box in the Filter tab allows you to set the incremental distance between hits on a scan. For example, if .5 is entered then the scan will touch the part at increments of .5.


Hit Type Tab

BASICSCAN dialog box - Hit Type tab

BASICSCAN dialog box - Hit Type Tab

This determines the type of hits used for the scan. Available options for the Hit Type tab are the following:

  • VECTOR

  • SURFACE (Only available for Line scans)

The Hit Type corresponds to the Hit Type in scans defined previously. See Hit Type in "Hit Controls area" in "Common Functions of the Scan Dialog Box".


Boundary Tab

BASICSCAN dialog box - Boundary tab

BASICSCAN dialog box - Boundary tab

Some of the Basic Scans like Circle, Cylinder, Axis, and Center do not need a Boundary condition since they are executed by the controller. Available options for the Boundary are the following:

  • Plane

  • Sphere

  • Cylinder

  • Cone

  • Oldstyle

See "Boundary Type area" for a description of these types.


Execute Tab

Execute Mode Tab

BASICSCAN dialog box - Execute tab

BASICSCAN dialog box - Execute Mode tab

The execute modes available in the Execute Mode tab are the following:

  • NORMAL

  • RE-LEARN

  • DEFINED

See "Exec Controls area" in "Execution Tab" for more information on the Normal, Re-learn, and Defined modes.

  • FEATURE – This execute mode is available only for Analog Probe Heads. When this is selected, PC-DMIS uses the built-in High Speed scanning capability of the controller to execute a scan.

Example: If you selected a Circle scan, PC-DMIS will use a corresponding Circle scanning command in the controller and pass on the parameters to the controller to execute. In this case, PC-DMIS does not control execution of the scans.

The FEATURE execute mode also allows you to use the following check boxes to further customize how PC-DMIS Basic scans are done using this mode. Note that these check boxes only work with controllers using the Leitz interfaces:

Use HSSDAT – If you select this check box, PC-DMIS sends a distinct set of points defining the feature measurement path to the controller. If you don't select this check box, PC-DMIS will send the feature specific parameters to the controller.

Use Start/End delay points – You must also select the Use HSSDAT check box to use this functionality. If you select this check box, PC-DMIS takes the points sent to the controller and discards those points taken during acceleration and deceleration of the probe during the scan, thereby filtering out fluctuation during these machine speed changes and improving the overall accuracy of the scan.

Warning: Be aware that when using Start/End delay points the machine will over travel the defined start angle and end angle by the distance it takes to arrive at full speed when starting the scan. If you aren't careful this could cause a probe crash if there is an obstruction on the circle feature.


Nominals Mode Tab

BASICSCAN dialog box - Nominals Mode tab

BASICSCAN dialog box - Nominals Mode tab

The Nominal Modes available are the following (See Nominals list in the "Nominals Method area"):

  • MASTER – corresponds to Master mode described in the "Nominals Mode" section.

  • FINDNOMS – corresponds to FindNoms mode described in the "Nominals Mode" section. You can type in a FindNoms Tolerance that can be applied when finding nominals for a Basic Scan.

Use Bestfit – This check box causes PC-DMIS to use best fit algorithms on the data found from the original FINDNOMS operation and then repeat the FINDNOMS operation. This finds the nominal data with greater accuracy when the actual part has a lot of error with respect to the CAD data. See "See "Nominals Mode".

Find Noms Only On Selected Surface – This check box causes PC-DMIS to look for nominal values for a scan's measured points on only the selected set of surfaces.

Note: With the Circle, Cylinder, and Axis types of Basic Scans, there is no need to have CAD data to find the nominals. To execute the Basic Scan, PC-DMIS obtains the nominals from the nominal data you supply.

For example, if you typed in nominal data, such as center and diameter , to execute the circle, that data would be used to find the nominals for the Circle scan.


General Tab

BASICSCAN dialog box - General tab

BASICSCAN dialog box - General tab

The options in this dialog box have been described in "Common Functions of the Scan Dialog Box".


Additional Manual Scan Options

In addition to the scanning options detailed in "Common Functions of the Scan Dialog Box", PC-DMIS offers these additional options while doing manual scans.

More:

New Row

Scan Done


New Row

The New Row command button allows you to start a new row for the scan. This button is only available when a manual scan is being learned. It is located in the Execution Mode Options dialog box.

To use the New Row command button:

  1. Press Stop to pause the scan.

  2. Select the New Row button. This will indicate that a new row is about to be scanned.

Or

  1. Select the New Row button first. PC-DMIS will automatically pause the scan.

  2. Move the probe to the next row.

  3. Press the Continue button.

  4. PC-DMIS will begin scanning the new row.


Scan Done

The Scan Done command button alerts PC-DMIS that the scan is complete. This button is only available when a manual scan is being executed (learned). It is located in the Execution Mode Options dialog box. As you execute the scan, data is gathered by PC-DMIS from the CMM. Simultaneously, PC-DMIS filters (reduces) the data according to the method (Fixed Time, Fixed Distance, Fixed Time / Distance etc.) you provide. Data that does not satisfy the criteria (such as Fixed Time or Distance increments) are excluded and data that satisfy the criteria are kept.

In some earlier versions, a Reduce button was available but in this version that is not used. When you press the Scan Done command button, PC-DMIS stops collecting data and processes the data for finding Nominals, Vector compensation etc.


Inserting Move Commands

Ins erting Move Commands: Introduction

Inserting a Move Point Command

Inserting a Move Increment Command

Inserting a Clearance Plane

Inserting a Move Clear Plane Command

Inserting a Move Circular Command

Inserting a Move Sync Command

Inserting a Move Sweep Command

Inserting a Move All Command

Inserting a Move Rotary Table Command

Inserting an Exclusion Zone Command


Inserting Move Commands: Introduction

This section discusses the various move commands that can be placed in your part program. Move commands provide you with the ability to alter the movement of the probe between hits.

The main topics covered in this section reflect the move commands that you can insert from the Insert | Move submenu and any other move commands. These topics include:

  • Inserting a Move Point Command

  • Inserting a Move Increment Command

  • Inserting a Clearance Plane

  • Inserting a Move Clear Plane Command

  • Inserting a Move Circular Command

  • Inserting a Move Sync Command

  • Inserting a Move Sweep Command

  • Inserting a Move All Command

  • Inserting a Move Rotary Table Command

  • Inserting an Exclusion Zone Command

These are discussed below in detail.


Inserting a Move Point Command

The Move Point command allows you to insert a move point into the part program. When PC-DMIS encounters this command the probe will move to that location.

To use this option, select the Insert | Move | Move Point Display Menu Roadmap menu option or the Operation | Move To Display Menu Roadmap menu option. If you selected Move Point, PC-DMIS will automatically insert a move point command at the current probe location and you will need to modify the XYZ values. If you selected Move To, PC-DMIS will display the Move Point dialog box allowing you to fill out the information before the command is inserted.

If you attempt to insert the move point in a location that PC-DMIS doesn't allow, the software will ask you if you want to insert the move point at the next valid location.

The Edit window command line for a sample Move Point would read:
MOVE/POINT tog1,x,y,z

tog1 - This field displays either NORMAL or RELEARN.

x,y,z - These fields display the move point location.

To change the displayed values in the Edit window, select the desired value and type a new value, or press F9 on the command to access the Move point dialog box.

Move Point dialog box

This dialog box provides you with a more user-friendly way of creating or editing the MOVE/POINT command as well as additional options for the move point. These are discussed in the topics listed in the '"More" heading below.

In version 3.5 and later when you insert a MOVE/POINT command, PC-DMIS automatically marks it for execution.

Using Move Points While Animating

If this menu option is selected during probe path animation with the CMM, PC-DMIS will always ask whether the move is to be inserted before or after the current position. The current position will be listed in the status bar.

Inserting Move Points Between Auto Feature Hits

You can insert MOVE/POINT commands between auto features' HIT/BASIC commands. You will need to use the Insert | Move | Move Point menu item to do this. Copying and pasting this command will not work. The Edit window must also be in Command mode.

Inserting Move Points from the Status Bar

The ability to insert a move point can also be accessed while the system is in Program Mode, by placing the cursor on the status bar over the readouts and clicking the left mouse button.

Inserting Move Points from the Jog Box

Pressing the PRINT button on the jog box (on Sharpe32 systems) while in Learn mode will automatically insert a move into the part program. The PrintButton entry of the registry must be set to TRUE for this function to be available.

Note: Selecting the Operation | Move To menu option will display the Move Point dialog box instead of automatically inserting a Move Point into the part program. This allows you to specify the XYZ location the probe should move to. Display Menu Roadmap

More:

XYZ Move

Offset Move

Store Move

OK to Move

Learn During Execution


XYZ Move

The XYZ Move boxes display the X, Y, and Z nominal for the position of the MOVE/POINT or the increment distance of the MOVE/INCREMENT command.

To change the X, Y, or Z values:

  1. Select the field you want to change.

  2. Type a new value.

After a new value is entered, PC-DMIS will draw the animated probe at the new location. This indicates the location of the stored move. When the Create button is clicked, PC-DMIS will insert the Move command and position the CMM to the location specified. If you created an offset move, it will update the values in the XYZ boxes to match the computed offset location.


Offset Move

The Offset Move area lets you create move points offset from a selected CAD point or from a selected feature's centroid.

Offset - This box determines the offset distance from the CAD point or feature centroid. The unit of measurement is the same as your part program. The default is 50 mm or 1.96 inches.

Offset from CAD - This option when you click on the CAD will compute the move point at the selected point on the surface and will offset the move point by the specified distance.

  • If you don't select Offset Along Tip Vector, the move point is created offset away from the surface along surface's normal vector.

  • If you do select it, the move point is created in the direction of the probe tip's vector.

Offset from Feature - This option, if you click on a feature, will compute the move point by the offset distance at the feature's centroid.

  • If you don't select Offset Along Tip Vector, the move point is created offset in the direction of the feature's vector.

  • If you do select it, the move point is created in the direction of the probe tip's vector.

Offset Along Tip Vector - If you select this option, PC-DMIS will offset the move point along the active tip's vector. If you don't select it, PC-DMIS will offset the move point along either the CAD's surface vector or along the feature's vector.

Note: Different feature types have different vectors, when offsetting along a vector of the feature, PC-DMIS will use the vector that gives the best representation of being "outward" from the surface of the part.


Store Move

If the Store Move check box is selected, the appropriate move command (MOVE/POINT or MOVE/INCREMENT) for the given X, Y, Z values will be inserted into the part program.


OK to Move

If the OK to Move check box is selected, PC-DMIS will immediately move the probe to the X, Y, Z position (or by the X,Y,Z increment amount) when you click OK or Create. This allows you to position the CMM without storing the move. This option fills in the X, Y, Z values with the current position of the probe.


Learn During Execution

If you select the Learn During Execution check box, PC-DMIS will move to and relearn the XYZ point location displayed in the dialog box when it executes the part program. You must also select the Store Move check box for this command to work.

The Edit window command line for an move point that PC-DMIS will relearn during program execution, would read:
MOVE/ POINT, RELEARN


Inserting a Move Increment Command

Display Menu Roadmap

The Insert | Move | Move Increment... menu option displays the Move Increment dialog box. You will use this dialog box to define the move increment command before you insert it into your part program.

Move Increment dialog box

When you click OK, PC-DMIS will insert the Move Increment command.

The Edit window command line for a Move Increment would read:
MOVE/INCREMENT, x, y, z

When PC-DMIS encounters this command it moves the probe the indicated XYZ distance (not an XYZ location as in a MOVE/POINT command). You must select the Store Move check box for this command to appear in the Edit window.

More:

XYZ Move

Store Move

OK to Move


Inserting a Clearance Plane

Display Menu Roadmap

The CLEARP command (Insert | Parameter Change | Clearance Planes) allows you to define a clearance plane value for the current working plane. Clearance planes, in essence, create an envelope around a part where the probe will always travel to when moving from one feature to another.

The ClearPlane tab of the Parameters dialog box allows you to turn clearance planes on globally. The CLEARP command only defines the clearance plane for the first hit of a feature. To set additional clearance planes for a feature, open a new line at the desired location and type the command: CLEARP.

For an in depth discussion on defining and working with clearance planes, see "Parameter Settings: ClearPlane tab" in "Setting Your Preferences".


Inserting a Move Clear Plane Command

Display Menu Roadmap

The Insert | Move | Move Clearplane command allows you to insert the MOVE/CLEARPLANE command between blocks and within features.

This command works in conjunction with the CLEARP/ command. Each time a MOVE/CLEARPLANE command is encountered during execution, it will move the probe to the clearance plane defined by the CLEARP/ command. The probe will remain at the clearance plane until a command is encountered the will move the probe away from the clearance plane such as a MEAS, HIT, or MOVE/POINT command. If you want the probe to move to the clearance plane before each hit of a measured circle then a MOVE/CLEARPLANE command must be inserted directly before each HIT/ command.

You can also insert MOVE/CLEARPLANE commands between auto features' HIT/BASIC commands. You will need to use the Insert | Move | Move Clearplane menu item to do this; copying and pasting this command will not work. The Edit window must also be in Command mode.

PC-DMIS will search for the clearance plane definition. For this command to work, the parameters must have already been set.

To set the parameters for a Clearplane command:

  1. Access the Parameter Settings dialog box (Edit | Preferences | Parameters). Display Menu Roadmap

  2. Select the Clear Plane tab.

  3. Type the distance for the Value box in the Active Plane area.

  4. Type the distance for the clearance plane in the Value box of the Pass Through area.

  5. Select the Clearance Planes Active check box.

  6. Click the OK button.

If the parameters have not been set, PC-DMIS will display an error message.

The Edit window command line for a sample Move Clearplane would read:
MOVE/CLEARPLANE

For an in depth discussion on defining and working with clearance planes, see "Parameter Settings: ClearPlane tab" in "Setting Your Preferences".


Inserting a Move Circular Command

The Insert | Move | Move Circular option allows you to insert a MOVE/CIRCULAR command at the cursor's location in the Edit window.

Display Menu Roadmap

When PC-DMIS encounters this command, the probe follows a circular path when taking the next hit. It will move from one point to another in a circular fashion based on the radius of the feature being measured.

By taking a circular path, the probe may avoid colliding with certain features that would otherwise be in the way of the standard straight line path. For example, if you're measuring a hole that has a square pin inside, that pin may block your probe path unless Move Circular is used.

A - Circular path avoids inside feature

B - Normal path collides with inside feature

C - Probe Hits

D - Probe Path

Overall, this command has very specific uses, although using it to measure a pin speeds up measurement somewhat since PC-DMIS doesn't have to move as far away from its last hit.


Inserting a Move Sync Command

Multiple arm part programs have commands that control multiple arms. Each machine executes these commands separately, keeping both arms moving.

The Insert | Move | Move Sync menu option allows you to insert a MOVE/SYNC command into the Edit window.

Display Menu Roadmap

Using this command on dual-arm machines allow you to synchronize the motion of the arms. Whichever arm reaches the MOVE/SYNC command in the part program first will stop and wait until the other arm also arrives before they proceed together with the rest of the part program.


Inserting a Move Sweep Command

Display Menu Roadmap

The Insert | Move | Move Sweep menu item inserts the following sweep block into the Edit window.

SWEEPSTART/

SWEEPEND/

MOVE/SWEEP Movement commands inserted between Sweepstart and Sweepend will cause the probe to move in all five axes simultaneously (three of these axes are the X, Y, and Z axes, used when moving the machine itself. The other two axes refer to the probe's AB angle movement) if using a PHS wrist for a Sharpe32Z controller.

Note: This command will function only with a continuous type wrist (CW43, CW43Light, or PHS) and only with a Renishaw SP600 or Wolf & Beck OTM3 laser probe (probe devices such as those from Perceptron or Metris may also function). However, since SP600s aren't usually sold with infinitely indexing wrist devices, this functionality is very much limited to the OTM3 laser probe.

Movement in these five axes takes place simultaneously. This differs from a PH9 wrist, which must first move the machine in the X, Y, and Z axes. Then, when the machine stops, the probe orientation (AB angles ) moves.

Example: Suppose your current CMM 's position is 10, 10, 10 (in the X, Y, and Z axes), and your wrist's orientation (AB position) is 0, 0. If you wanted to move the CMM to 20, 20, 20 and the probe's orientation to 0, 180, a PHS wrist using Move Sweep commands, could accomplish both movements simultaneously. A PH9 wrist, however, would first move the CMM and then the wrist orientation.

For comparison:

  • A PH9 wrist is able to move between 0º to 110º in the A axis and +180º to -180º in the B axis.

  • A PHS wrist is able to move between -180º and +180º in both the A and B axes at .1 degree increments.

Advantages of using Move Sweep commands include:

  • A much more fluid movement available, making it easier to measure hard to reach features.

  • Time saved since you no longer have to wait for the CMM's ram and arm to move to the X, Y, and Z location before changing the Probe's orientation.

  • Reduced vibration slightly improves accuracy.

Note: PC-DMIS requires at least three MOVE/SWEEP commands between the SWEEPSTART/ and SWEEPEND/ command block. These move commands are essential to generate the elliptical movement path.


Inserting a Move All Command

The MOVE/ALL command will function with any motorized probe head - continuous or
indexing - and any probe combination.

Display Menu Roadmap

The Insert | Move | Move All menu option inserts a MOVE/ALL command into the Edit window.

A MOVE/ALL command is the same as a MOVE/POINT command combined with a TIP / command. This command has the benefit of rotating the probe head together with machine movement.

When using a wrist device (PHS, CW43L, or CW43) this movement is synchronized such that the wrist's AB movement will start and end its motion at the same time that the machine starts and ends the X,Y, and Z movement.

When using this command with an indexable wrist such as a PH10M, this movement cannot be synchronized and will occur at an unspecified time during the machine movement (depending on time delays in the signal processing of the electronic hardware). Because of this, the AB wrist movement may not always complete by the time the machine performs the X, Y, and Z move.

The MOVE/ALL Edit window command looks like this:

MOVE/ALL,X,Y,Z,TIP=T1A0B0, SHANKIJK=0, 0, 1, ANGLE=0

  • X,Y,Z allow you to specify the X, Y, and Z coordinates to which to move the probe.

  • TIP= T1A0B0 shows the AB wrist movement to perform.

  • SHANKIJK = IJK allows you to specify the shank 's vector.

  • ANGLE=0 specifies the theoretical angle.

Note that the probe head angle will usually be a predefined TIP position.


Inserting a Move Rotary Table Command

Display Menu Roadmap

The Insert | Move | Move Rotary Table menu item allows you insert a MOVE/ROTAB command at the cursor's current location. The complete command line in the Edit window is

Command line in the Edit window:
MOVE/ROTAB,angle,DIRECTION

Direction = determines the direction of the table rotation. Available options are:

Clockwise: | Rotates the table in a clockwise direction until it reaches the angle entered in the Rotate Table Angle box.
Counterclockwise: | Rotates the table in a counterclockwise direction until it reaches the angle entered in the Rotate Table Angle box.
Shortest: | Rotates taking the shortest route (either Clockwise or Counterclockwise) until it reaches the angle entered in the Rotate Table Angle box.

Upon encountering this command, PC-DMIS will rotate the table to a position determined by whichever MOVE/ROTAB command is active.

Example: Consider a part program that has multiple different MOVE/ROTAB commands. If you click on a particular portion of the part program and select the Move Rotary Table menu option, PC-DMIS rotates the table to the position determined by whichever MOVE/ROTAB command is active at that point in the part program.

This menu option is only available if your portlock is configured for rotary tables.


Inserting an Exclusion Zone Command

Display Menu Roadmap

The Insert | Move | Exclusion Zone menu option allows you to insert an exclusion zone so that the two arms on a dual arm system don't collide with each other.

Selecting this option opens the Exclusive Move Zone dialog box.

Exclusive Move Zone dialog box

You can use this dialog box to insert a MOVE/EXCLUSIVE_ZONE command into the Edit window.

The MOVE/EXCLUSIVE_ZONE command applies to either the master or the slave arm.

Before PC-DMIS executes this command it makes sure that the arm assigned to the command has not already requested an exclusive move zone that overlaps with the new request.

If there is a conflict of movement, the MOVE/EXCLUSIVE_ZONE command will

  • Wait until the arm assigned to the command has released the commanded volume

  • Proceed to execute the motion commands listed below the MOVE/EXCLUSIVE_ZONE command.

More:

Defining the Exclusion Zone

Exclusion Zones with Iterative Alignments


Defining the Exclusion Zone

There are some things to keep in mind while defining an exclusion zone:

  • There needs to be a MOVE/EXCLUSIVE_ZONE command before each section of motion commands in the part program that commands either arm into the overlapping region of the dual arm volume. The MOVE/EXCLUSIVE_ZONE command should define a 3D box around all the motion that is about to be commanded in the overlapped area of the dual arm CMM.

  • There must be an MOVE/EXCLUSIVE_ZONE=OFF command after the probe has been withdrawn from the overlapped part of the dual arm CMM.

For example if you want each arm to check a common sphere using automatic sphere commands, you should set up the part program like this:

MOVE/EXCLUSIVE_ZONE=ON (for Arm 1)
AUTO/SPHERE(for Arm 1)
MOVE/EXCLUSIVE_ZONE=OFF (for Arm 1)
MOVE/EXCLUSIVE_ZONE=ON (for Arm 2)
AUTO/SPHERE (for Arm 2)
MOVE/EXCLUSIVE_ZONE=OFF (for Arm 2)

The following steps describe how to define the exclusion zone.

More:

Step 1 Turn on Exclusive Move

Step 2 Enter Corner Point Values

Step 3 Click OK


Step 1 Turn on Exclusive Move

Select the Turn exclusive move on check box. This allows you to edit the X, Y, and Z values under the Corner Point 1 and Corner Point 2 options.

Alternately, if you click on an already inserted MOVE/EXCLUSIVE_ZONE command in the Edit window and press the F9 key, the Exclusive Move Zone dialog box opens, and you are able to select or deselect this check box.

  • If this box is selected when you click the OK button, PC-DMIS will display the following command in the Edit window:
    MOVE/EXCLUSIVE_ZONE=ON, CORNER1=x,y,z,CORNER2=x,y,z

  • If this box is not selected when you click the OK button, PC-DMIS will display the following command in the Edit window:
    MOVE/EXCLUSIVE_ZONE=OFF


Step 2 Enter Corner Point Values

Type the X, Y, and Z values for Corner 1 and Corner 2. You can read in the probe's current into the selected corner point by clicking the Read Position button.

Defining two corners sets up the exclusion zone; be sure to select the corner points that will correctly define the exclusion zone. The two points (corner 1 and corner 2) represent two corners that are diagonal from each other.

A rectangular zone can be created in 3D space from two points if you use the current coordinate system to create the sides. A combination of different parts of the two points can construct the eight points needed to form the rectangular area.

Example:

First corner = X1, Y1, Z1
Second corner = X2, Y2, Z2
Third corner = X1, Y1, Z2
Forth corner = X1, Y2, Z1
Fifth corner = X1, Y2, Z2
Sixth corner = X2, Y1, Z1
Seventh corner = X2, Y1, Z2
Eight corner = X2, Y2, Z1


Step 3 Click OK

Finish defining the Exclusion Zone by clicking the OK button. PC-DMIS then places the defined information into the Edit window which reads:
MOVE/EXCLUSIVE_ZONE=TOG1,CORNER1=X,Y,Z,CORNER2=X,Y,Z

TOG1 | This defines whether the exclusion zone is in effect or not. This toggle field switches between ON and OFF.
X,Y,Z | These coordinates define the corner points used to form the exclusion zone.

Clicking the Cancel button closes the dialog box without making any changes to your part program .


Exclusion Zones with Iterative Alignments

If you are using exclusion zones with iterative alignments, PC-DMIS automatically computes the starting and ending lines of the program that are to be re-executed. This means PC-DMIS ends execution at the last feature used as part of the iterative alignment. This could prevent an arm from releasing the exclusion zone to the other arm, thereby stopping the program.

To resolve this, insert a start label for the iterative alignment. PC-DMIS will execute from the label to the command just in front of the iterative alignment, causing arms to release the exclusion zone.

Example of a Stopped Program:

In this example, PNT3 is assigned to ARM 2, all other commands are assigned to ARM 1.

Explanation: Even though point PNT3 is located after the PNT1 and PNT2 and before CIR1 and CIR2, due to PC-DMIS's internal logic and the presence of the exclusion zone, PC-DMIS might measure PNT1, PNT2, CIR1, and CIR2 before PNT3. Because of this, the exclusion zone after CIR2 is not released and blocks the PNT3 ARM 2 measurement.

If you use a start label at the start of your alignment features and then have your iterative alignment command block use that start label, you can get around this problem, like this:

Example of a Working Program:

ee "Start Label" under "Description of the Iterative Alignment Dialog Box" for information on how to use a start label with iterative alignments.


Branching by Using Flow Control

Branching by Using Flow Control: Introduction

Using Control Pairs

Creating Generic Loops

Ending Generic Loops

Creating Labels

Jumping to a Label

Jumping to a Label Based on Conditions

Branching on An Error

Branching with Subroutines

Ending a Part Program


Branching by Using Flow Control: Introduction

Suppose you have a part with many features, but you just want to measure a few features over and over to get a comprehensive statistical set of data for those features. Suppose you want to jump to a particular part in your part program dependent on a response from the user. You can accomplish tasks such as these, and many others, by using flow control commands. By setting up conditions for certain commands, you can control the flow of your part program.

This section will provide you with the information you need to accomplish such tasks. It explains the syntax conditional statements, loops, and subroutines. It also provides many code samples.

Note: When looping or branching occurs in the code samples, indentation has been used for clarity to show statements assigned to a certain condition. In the actual Edit window code, you won't see any indentation.

The main topics covered in this section include the following:

  • Using Control Pairs

  • Creating Generic Loops

  • Ending Generic Loops

  • Creating Labels

  • Jumping to a Label

  • Jumping to a Label Based on Conditions

  • Branching on a CMM Error

  • Branching with Subroutines

  • Ending a Part Program


Using Control Pairs

Display Menu Roadmap

The Insert | Flow Control Command | Control Pairs submenu offers various paired commands that work within the Edit window to govern or "control" the proper flow of the part program. To insert a control pair type command into the Edit window, simply type the command, or choose a command from this submenu.

Important: When using a conditional branching statement to test for a the value of a YES / NO comment, be aware that your test should look for an uppercase "YES" or "NO" value. A lowercase "Yes" or "No" will not work. For information on comments, see the "Inserting Programmer Comments" topic in the "Inserting Report Commands" section.

More:

If / End If

Else If / End Else If

Else / End Else

While / End While

Do / Until

Select / End Select

Case / End Case

Default Case / End Default Case


If / End If

Display Menu Roadmap

The Insert | Flow Control Command | Control Pairs | If / End If menu option allows you to add a conditional block to the part program. The items between the IF and the END IF commands will only execute if the expression for the IF command evaluates to true (nonzero). Otherwise, flow of execution will jump to the first command after the END/IF command.

The Edit window command line for a IF / END IF statement reads:
IF/expression
END_IF/

To insert the If / End If commands:

  1. Place the cursor in the desired location of the Edit window.

  2. Select If / End If from the menu bar. The IF / END IF statement will appear in the Edit window.

More:

Code Sample of If / End If


Code Sample of If / End If

Consider the following example that asks the user if he or she would like measure a point feature.

C1= COMMENT/YESNO,Would you like to measure the point feature, PNT1?

IF/C1.INPUT=="YES"

PNT1=FEAT/POINT,RECT

…

…

ENDMEAS/

END_IF/

Explanation of Sample Code

C1=COMMENT/YESNO
This line takes and stores the YES or NO response from the user.

IF/C1.INPUT=="YES"
This line is the expression. It tests to see if the input of comment 1 is a YES. If it's a YES then the IF statement is TRUE and continues executing the statements after the IF statement, in this case it measures the PNT1 feature. If NO it moves to the END_IF statement.

END_IF
This line ends the execution of commands inside the IF / END IF block of code. Any command following this line is where PC-DMIS will goto if the user clicks No at the comment.


Else If / End Else If

Display Menu Roadmap

The Insert | Flow Control Command | Control Pairs | Else If / End Else If menu option allows you to add a conditional block to the part program. The items between the ELSE IF and the END ELSE IF commands will only execute if the expression for the ELSE IF command evaluates to true (nonzero). The ELSE IF / END ELSE IF block must be positioned directly after an IF / END IF block or another ELSE IF / END ELSE IF block. If all IF / ELSE IF expressions above the current block have evaluated to false, then the expression will be evaluated. If the expression evaluates to false (zero), then execution will jump to the next command following the END ELSE IF command. If any of the if / else if expressions above the current block evaluate to true, all subsequent else if / end else if blocks in this sequence will be skipped.

The Edit window command line for a ELSE IF / END ELSE IF statement reads:
ELSE_IF/expression
END_ELSE_IF/

To insert the Else If / End Else If commands:

  1. Place the cursor in the desired location of the Edit window, after an existing IF/END IF statement or ELSE IF/END ELSE IF statement.

  2. Select Else If / End Else If from the menu bar. The ELSE IF / End ELSE IF statement will appear in the Edit window.

Note: This type of block is only valid when positioned after an IF / END IF or ELSE IF / END ELSE IF block. Invalidly positioned control pairs are shown in red text in the Edit window.

More:

Code Sample of Else If / End Else If


Code Sample of Else If / End Else If

Consider the following example that displays a message notifying the user when any one of the X, Y, or Z values for a measured point exceeds defined tolerances:

PNT2=FEAT/POINT,RECT

…

…

ENDMEAS/

IF/PNT2.X<6.9 OR PNT2.X>7.1

COMMENT/OPER,"The measured X value of PNT2: " + PNT2.X + " is out of tolerance."

END_IF/

ELSE_IF/PNT2.Y<3.3 OR PNT2.Y>3.5

COMMENT/OPER,"The measured Y value for PNT2: " + PNT2.Y + " is out of tolerance."

END_ELSEIF/

ELSE_IF/PNT2.Z<.9 OR PNT2.Z>1.1

COMMENT/OPER,"The measured Z value for PNT2: " + PNT2.Z + " is out of tolerance."

END_ELSEIF/

Explanation of Sample Code

This code first tests the X value of the point. If the condition evaluates to false, then the code tests for the Y value. If the condition for the Y value evaluates to false, then it tests for the Z value.

If any of these conditions evaluates to true, PC-DMIS displays the comment associated with it and skips the remaining conditional statements.

IF/PNT2.X<6.9 OR PNT2.X>7.1
This line is the expression. It tests to see if the measured X value is less than 6.9 or greater than 7.1. If it exceeds either of these boundaries it executes the first comment.

END_IF
This line ends the execution of commands inside the IF / END IF block of code. Any command following this line is where PC-DMIS will go to if the IF THEN condition evaluates to false.

ELSE_IF/PNT2.Y<3.3 or PNT 2.Y>3.5
This line is the expression for the first ELSE_IF command. It only gets executed if the IF / END IF block above it returns false. It tests to see if the measured Y value is less than 3.3 or greater than 3.5. If it exceeds either of these boundaries it executes the second comment.

END_ELSEIF/
This line ends the execution of commands inside the first ELSE IF / END ELSE IF block of code.

ELSE_IF/PNT2.Z<.9 OR PNT2.Z>1.1
This line is the expression for the second ELSE IF command. It only gets executed if the ELSE IF / END ELSE IF block above it returns false. It tests to see if the measured Z value is less than .9 or greater than 1.1. If it exceeds either of these boundaries it executes the third comment

END_ELSEIF/
This line ends the execution of commands inside the second ELSE IF / END ELSE IF block of code.


Else / End Else

Display Menu Roadmap

The Insert | Flow Control Command | Control Pairs | Else / End Else menu option allows you to add a conditional block to the part program. The items between the ELSE and the END ELSE commands will execute only if all other if / end if and else if / end else if blocks above the else block have failed (All evaluated to zero). ELSE / END ELSE blocks must be located at the end of a set of IF / END IF or ELSE IF / END ELSE IF blocks in order to be valid.

The Edit window command line for a ELSE / END ELSE statement reads:
ELSE/
END_ELSE/

To insert Else / End Else commands:

  1. Place the cursor in the desired location of the Edit window. Note that Else / END ELSE blocks must be positioned after a IF / END IF or ELSE IF / END ELSE IF blocks.

  2. Select Else / End Else from the menu bar. The ELSE / End ELSE statement will appear in the Edit window.

More:

Code Sample of Else / End Else


Code Sample of Else / End Else

Consider the following example that asks the user if he or she would like measure a point feature.

C1= COMMENT/YESNO,Would you like to measure the point feature, PNT1? Clicking No measures the next feature.

IF/C1.INPUT=="YES"

PNT1=FEAT/POINT,RECT

…

…

ENDMEAS/

END_IF/

ELSE

PNT2=FEAT/POINT,RECT

…

…

ENDMEAS/

ENDELSE

Explanation of Sample Code

C1=COMMENT/YESNO
This line takes and stores the YES or NO response from the user.

IF/C1.INPUT=="YES"
This line is the expression. It tests to see if the input of comment 1 is a YES. If it's a YES then the IF statement is TRUE and continues executing the statements after the IF statement, in this case it measures the PNT1 feature. If NO it moves to the END_IF statement.

END_IF
This line ends the execution of commands inside the IF / END IF block of code. Any command following this line is where PC-DMIS will go to if the user clicks No at the comment.

ELSE
If the above IF / END IF block evaluates to false then command lines falling after this line and before the ENDELSE line will be executed. In this case, PNT2 gets executed.

ENDELSE
This line ends the execution of commands inside the ELSE / ENDELSE block of code.


While / End While

Display Menu Roadmap

The Insert | Flow Control Command | Control Pairs | While / End While menu option allows you to add a conditional loop to the part program. The items between the WHILE and the END WHILE command will continue to execute in a loop until the condition (or expression ) keeping the loop activated is no longer met, meaning the expression for the while loop evaluates to FALSE (i.e. zero). The WHILE command can be added anywhere in the part program. The expression is tested at the start of each loop.

The Edit window command line for a WHILE / END WHILE statement reads:
WHILE/expression
END_WHILE/

To insert a While / End While option:

  1. Place the cursor in the desired location of the Edit window.

  2. Select While / End While from the menu bar. The While / End While statement will appear in the Edit window.

More:

Code Sample of While / End While


Code Sample of While / End While

Consider the following example that measures a feature an amount specified by the part program user.

C1=COMMENT/INPUT,How many times would you like to measure PNT1? Please type an integer only.

ASSIGN/COUNT = 0

WHILE/COUNT < C1.INPUT

PNT2=FEAT/POINT,RECT

…

…

…

ENDMEAS/

ASSIGN/COUNT = COUNT + 1

COMMENT/OPER,"Measured " + COUNT + " out of " + C1.INPUT + " times."

END_WHILE/

Explanation of Sample Code

C1=COMMENT/INPUT
This line takes and stores the integer input from the user into the variable C1.INPUT.

ASSIGN/COUNT = 0
This line initializes COUNT, a user-defined variable, and gives it an initial value of 0. The code uses this variable to count the number of times PC-DMIS measures the feature inside the loop.

WHILE/COUNT < C1.INPUT
This line is the expression. It tests to if the value of COUNT (initially set to 0) is less than the integer selected by the user. If this tests true, then the statements in following WHILE/ and before END_WHILE/ are executed

ASSIGN/COUNT = COUNT + 1
This line increments the COUNT variable by one so that it eventually exits the loop when it fails the condition test.

COMMENT/OPER,"Measured " + COUNT + " out of " + C1.INPUT + " times."
This line displays a message showing the number of times, out of the total, that the loop is running.

END_WHILE
This line ends the execution of commands inside the WHILE / END WHILE block as long as the condition is false. Other wise when PC-DMIS encounters this command it loops back to the WHILE statement.


Do / Until

Display Menu Roadmap

The Insert | Flow Control Command | Control Pairs | Do / Until menu option allows you to add a conditional loop to the part program. The items between the DO and the UNTIL commands will continue to execute in a loop until the expression of the UNTIL command evaluates to TRUE (nonzero). The DO/ UNTIL commands can be added anywhere in the part program. The expression is tested at the end of each loop.

The Edit window command line for a DO / UNTIL statement reads:
DO/
UNTIL/ expression

To insert DO / UNTIL commands:

  1. Place the cursor in the desired location of the Edit window.

  2. Select Do / Until from the menu bar. The DO / UNTIL statements will appear in the Edit window.

More:

Code Sample of Do / Until


Code Sample of Do / Until

Consider the following example that measures a feature an amount specified by the part program user. This is similar to the example given under the While / End While topic, except that PC-DMIS tests for the condition at the end of the loop instead of at the beginning.

C1= COMMENT/INPUT,Type the number of times PC-DMIS should measure the PNT1 feature:(type an integer only)

ASSIGN/COUNT = 0

DO/

PNT1=FEAT/POINT,RECT

…

…

ENDMEAS/

ASSIGN/COUNT = COUNT + 1

COMMENT/OPER,"Measured " + COUNT + " out of " + C1.INPUT + " times."

UNTIL/COUNT == C1.INPUT

Explanation of Sample Code

C1=COMMENT/INPUT
This line takes and stores the integer input from the user into the variable C1.INPUT.

ASSIGN/COUNT = 0
This line initializes COUNT, a user-defined variable, and gives it an initial value of 0. The code uses this variable to count the number of times PC-DMIS measures the feature inside the loop.

DO/
Begins the DO / UNTIL loop. All statements are executed at least once and program flow exits out of the loop once the expression evaluates to false.

ASSIGN/COUNT = COUNT + 1
This line increments the COUNT variable by one so that it eventually exits the loop when it fails the condition test.

COMMENT/OPER,"Measured " + COUNT + " out of " + C1.INPUT + " times."
This line displays a message showing the number of times, out of the total, that the loop is running.

UNTIL/COUNT == C1.INPUT
This line ends the execution of commands inside the DO / UNTIL loop as long as the condition evaluates to false. Otherwise, when PC-DMIS encounters this command it loops back to the DO statement.


Select / End Select

Display Menu Roadmap

The Insert | Flow Control Command | Control Pairs | Select / End Select menu option allow for the addition of a conditional block that is used in conjunction with the CASE / END CASE and Default Case / End Default Case pairs. The expression for the Select command provides data that is compared against the expression in the Case statements. If the two expressions evaluate to the same thing, then the statements within the Case / End Case Block will execute. The SELECT / END SELECT block surrounds the sets of CASE / END CASE and DEFAULT CASE / END DEFAULT CASE blocks.

The Edit window command line for a SELECT / END SELECT statement reads:
SELECT/expression
END_SELECT/

To insert the Select / End Select commands:

  1. Place the cursor in the desired location of the Edit window.

  2. Choose Select / End Select from the menu bar. The SELECT / End SELECT statements will appear in the Edit window.

More:

Code Sample of Select / End Select


Code Sample of Select / End Select

The pairs, SELECT / END_SELECT, CASE / END_CASE, DEFAULT CASE / END_DEFAULT CASE, all work together evaluate multiple conditions providing a wide range of alternatives.

Suppose you have five circles, labeled CIR1 through CIR5, and you want the operator to be able to measure a circle by simply pressing a key on the keyboard. You could use code similar to the following:

Entire Code

DO/

C1=COMMENT/INPUT,Type a number to measure that circle:

,FOR CIR1 - Type 1

,FOR CIR2 - Type 2

,FOR CIR3 - Type 3

,FOR CIR4 - Type 4

,FOR CIR5 - Type 5

,Any other character exits the loop

SELECT/C1.INPUT

CASE/1

CIR1=FEAT/CIRCLE

…

…

ENDMEAS/

END_CASE

CASE/2

CIR2=FEAT/CIRCLE

…

…

ENDMEAS/

END_CASE

CASE/3

CIR3=FEAT/CIRCLE

…

…

ENDMEAS/

END_CASE

CASE/4

CIR4=FEAT/CIRCLE

…

…

ENDMEAS/

END_CASE

CASE/5

CIR5=FEAT/CIRCLE

…

…

ENDMEAS/

END_CASE

DEFAULT CASE

COMMENT/OPER,Now exiting loop.

END_DEFAULT CASE

END_SELECT

UNTIL C1.INPUT < 1 OR C1.INPUT > 5

Explanation of Sample Code

SELECT/C1.INPUT
This line of code takes a number or string value (in this case a number) typed by the user and determines which CASE/END_CASE block will execute from the input. Notice that SELECT / END_SELECT pair surrounds the entire list of code. All CASE / END_CASE and DEFAULT CASE / END_DEFAULT CASE pairs must reside within these two lines.

END_SELECT
This marks the end of the code held inside the SELECT / END SELECT pair.

CASE/1 through CASE/5
Depending on the value of C1.INPUT, one of the CASE code blocks executes. For example, if C1.INPUT evaluates to 1, the CASE 1 block of code executes, measuring CIR1. If it evaluates to 2, then the CASE 2 block of code executes, measuring CIR2, and so forth.

END_CASE
These lines end the specific case blocks of code.

DEFAULT CASE
If the value of the C1.INPUT doesn’t match any of the defined CASE statements (if the value isn’t a number one through five) then the DEFAULT CASE code block executes. In this case it displays a message letting you know that you are exiting the loop.

Notice how the DO / UNTIL loop surrounds the entire code sample. This allows the user to continue to choose from the menu created from the COMMENT/INPUT line until the user selects a character not recognized by the CASE statements.


Case / End Case

Display Menu Roadmap

The Insert | Flow Control Command | Control Pairs | Case / End Case menu option allows you to add a conditional block to the part program. The items between the CASE and the END CASE commands will execute if the expression for the case statement evaluates to a value equal to the expression of the corresponding SELECT command. Otherwise, the block of statements will be skipped. The CASE / END CASE statement block must be located directly after a SELECT command or an END CASE command of a previous CASE / END CASE block. Also, PC-DMIS cannot compare multiple expressions on a single case statement.

The Edit window command line for a CASE / END CASE statement reads:
CASE/expression
END_CASE/

To insert the Case / End Case option:

  1. Place the cursor in the desired location of the Edit window. Note the positional requirements stated above.

  2. Select Case / End Case from the menu bar. The CASE / End CASe statements will appear in the Edit window.

For a code sample see the "Code Sample of Select / End Select" topic.


Default Case / End Default Case

Display Menu Roadmap

The Insert | Flow Control Command | Control Pairs | Default Case / End Default Case menu option allows you to add a conditional block to the part program. The items between the DEFAULT CASE and the END DEFAULT CASE commands will execute if all other expressions in previous CASE / END CASE blocks within the corresponding SELECT / END SELECT block evaluated to false. Only one DEFAULT CASE / END DEFAULT CASE block is allowed within a SELECT/ END SELECT block. The DEFAULT CASE / END DEFAULT CASE block must be located after all CASE / END CASE blocks within the SELECT / END SELECT block.

The Edit window command line for a DEFAULT CASE / END DEFAULT CASE statement reads:
DEFAULT CASE/
END_DEFAULT_CASE/

To insert DEFAULT CASE/ END DEFAULT CASE commands:

  1. Place the cursor in the desired location of the Edit window noting positional limitations as stated above.

  2. Select Default Case / End Default Case from the menu bar. The DEFAULT CASE / End DEFAULT CASe statements will appear in the Edit window.

For a code sample see the "Code Sample of Select / End Select" topic.


Creating Generic Loops

Looping Parameters dialog box

Display Menu Roadmap

The Insert | Flow Control Command | Looping menu option allows you to repeat the part program (or portions of the part program) with or without any of the offsets. The LOOP command can be added anywhere in the part program, although this function is most useful at the beginning and end of the program.

More:

Uses for Looping

End Number

Start Number

Skip Number

Axes and Angle Offset

Loop Ids

Variable ID

End Loop


Uses for Looping

There are three main uses for the looping option:

  • You have a multiple part fixture that holds a grid of parts. The fixture should use consistent spacing between the rows. The translation / rotation offsets allow you to index from one part to the next in the grid of parts.

  • You have a fixture that holds one part and you want to swap in a new part before each loop of the program. A COMMENT command is helpful to stop the CMM when the part is being replaced with a new one. The command can be at the beginning or end of the loop.

  • You want to use the LOOP option to rotate the part program to measure a different portion of the same part. For example, you could create a part program to measure a complicated hole pattern that was duplicated 10 times on the part. Your part program would only need to measure one of the hole patterns. The LOOP option could be used to offset this part program to measure the other 9 occurrences of the pattern.

Note: If you're using an alignment inside of a loop PC-DMIS 3.6 and above allows you to use the active alignment in the ALIGNMENT/START command line instead of always recalling a previously stored alignment. See the "Using an Alignment Inside Loops" topic in the "Creating and Using Alignments" section.

More:

To Use Looping:


To Use Looping:

  1. Select Insert | Flow Control Command | Looping from the menu bar. The Looping Parameters dialog box will appear. Display Menu Roadmap

  2. Make any necessary changes to the boxes.

  3. Select parameters as needed (i.e. Number of Parts, Start Number, Skip Number, offsets in XY or Z, Angle).

  4. Place the cursor in a location in the Edit window where you want to begin the loop.

  5. Select the OK button.

The Edit window command line for looping reads:

VARNAME = LOOP/START, ID = Y/N, NUMBER = 0, START = 1, SKIP = ,
OFFSET: XAXIS = 0, YAXIS = 0, ZAXIS = 0, ANGLE = 0

Note: To complete the looping procedure, you must have an End Loop command inside the Edit window. PC-DMIS will loop Edit window commands that the LOOP/START and LOOP/END commands encompass. See "End Loop" for more information.


End Number

The End Number box tells PC-DMIS how many times to loop through the part program. This number is usually the same as the number of parts that the fixture holds (or patterns on the part) in the x (y or z) direction. PC-DMIS will also ask for the starting part (pattern) number.

Example: You have 10 parts in the x (y or z) direction, and you want to start with position number 5. Enter 10 (ten) for the End Number box and 5 (five) for in the Start Number box.


Start Number

The Start Number box tells PC-DMIS the starting position number in a series of parts.

Example: You have 10 parts, and you want to start with position number 5, you would enter 10 for the total number of parts and 5 for the starting position.


Skip Number

The Skip Number box repeats a part program the indicated number of times, allowing you to skip a specified increment.

Example: You can set the parameter to skip every third increment of the loop. If the number three is indicated, PC-DMIS will measure the first and second part and then skip to the fourth part.


Axes and Angle Offset

The offset area contains these boxes:

X Axis, Y Axis, and Z Axis boxes. These boxes set up the x, y, or z offset between parts, or patterns on the same part. These will offset the part by the entered distance each time the loop runs. The first offset is based on the part's origin.

The Angle box sets up the angular offset between parts, or patterns on the same part. The first offset is based on the part's origin. PC-DMIS offsets the part by the angle value each time the loop runs.

More:

Looping Offsets and Alignments


Looping Offsets and Alignments

If you have an alignment command inside a loop and the loop is using offsets, you must define all axes for that alignment. Additionally the alignment inside the loop must use features measured inside the loop.


Loop Ids

If this option is selected, PC-DMIS increments the feature ID 's (within the loop) to coincide with the loop increment.

Example: CIR1 will become CIR1[1] on the first loop, CIR1[2] on the second loop, and so on.

More:

Feature IDs in Statistical Databases


Feature IDs in Statistical Databases

If you select the Loop IDs check box and are sending statistical data to a database, PC-DMIS will sometimes remove these loop IDs from the database.

Consider the following:

If you have a STATS/ON command and a STATS/UPDATE command inside a program loop, then loop IDs are not displayed inside the database.

If you have a STATS/ON command outside a program loop and a STATS/UPDATE command inside a program loop, then loop IDs are not displayed inside the database.

If you have a STATS/ON command outside a program loop and a STATS/UPDATE command outside a program loop, then loop IDs are displayed inside the database.

If you have a STATS/ON command inside a program loop and a STATS/UPDATE command outside a program command, then loop IDs are displayed inside the database.


Variable ID

The Variable ID box allows you to define the variable name used to track the loop's current iteration (or current loop within the number of specified loops). During the part program's execution, this variable will be equal to the current iteration number of the loop.


End Loop

The End Loop button completes the looping process. The command LOOP/START must be followed by the command LOOP/END in the Edit window.

The Edit window command line for ending a loop reads:
LOOP/END


Ending Generic Loops

Display Menu Roadmap

The Insert | Flow Control Command | End Loop menu option does the same thing as the End Loop command button in the Loop Parameters dialog box. It inserts a LOOP/END command in the Edit window, thus completing the looping process.


Creating Labels

Display Menu Roadmap

The Insert | Flow Control Command | Label option opens the Edit Label Name dialog box which allows you to create a name identification that can be used with a GOTO or IF statement.

Edit Label Name dialog box

PC-DMIS will allow you to create the ID using up to fifteen characters. The ID will be displayed using all capital letters.

The Edit window command line for the Label option reads:
ID = LABEL/

To create a label:

  1. Select the location in the Edit window.

  2. Select Label from the menu bar.

  3. Type the ID for the label in the New Label Name box.

  4. Click the OK button.

  5. The label ID will appear in the next possible location in the Edit window.

To jump to a created label see the "Jumping to a Label" topic.


Jumping to a Label

GoTo dialog box

Display Menu Roadmap

The Insert | Flow Control Command | Goto option will bring up the GoTo dialog box which allows you to create GOTO statements within your part program. When the program is executed and PC-DMIS encounters a GOTO statement, it will move to the location of the label identification.

The Edit window command line for GOTO reads:
GOTO/label_ID

To create a GOTO Statement in the Edit window:

  1. Select Goto from the submenu.

  2. Select the label you want to use from the Current Labels box.

  3. Click the OK button.

The Goto dialog box also allows you to create new label ID’s that can then be attached to a GOTO statement. To do this:

  1. Select Goto from the submenu.

  2. Type the name of the label you will create in the Goto Label box. The GOTO/label command is entered in the Edit window.

Note: If a label is created within the GoTo dialog box, you must create the label identification using the Label menu option prior to executing the part program.

More:

Goto Label

Current Labels


GoTo Label

The GoTo Label box allows you to type in an existing label that the part program will go to during execution.


Current Labels

The Current Labels box contains a listing of existing labels which you can select with the mouse.


Jumping to a Label Based on Conditions

If Expression dialog box

Display Menu Roadmap

The Insert | Flow Control Command | If Goto option will allow you to create IF GOTO statements within your part program. When the part program is executed and PC-DMIS encounters an IF statement, it will GOTO the location of the label identification if the specified expression evaluates to a non-zero value. See the "Using Expressions and Variables" section for information on creating expressions.

The Edit window command line for an IF_GOTO statement reads:
IF_GOTO/expression, GOTO=Label

More:

Expression

Label


Expression

The Expression button brings up the expression builder. With the expression builder you can create a variety of different expressions that you may need within your part program . See the "Using Expressions and Variables" section for information on using expressions.


Label

The Label box allows you to type in the Label that PC-DMIS will use for the GOTO command. The Label button brings up the Goto dialog box. From this dialog box you can choose the label to be used. The label will appear in the Label box. See "Jumping to a Label".


Branching On an Error

On Error dialog box

Display Menu Roadmap

The Insert | Flow Control Command | On Error command can be used to tell PC-DMIS what action to take in the case that a machine Error occurs.

PC-DMIS tracks these error conditions:

  • Unexpected Probe Hit

  • Missed Probe Hit

  • Reflector Not Found (used with the Tracker in PC-DMIS Portable)

For each of these error conditions, these possible actions can be taken:

  • Jump to a label

  • Set a variable's value to one

  • Do nothing

  • Skip command

By default, all part programs start with the action for both types of errors set to the third option (Do nothing). The action mode for each error type can be changed throughout the program.

Example: If during execution, PC-DMIS encounters an ON ERROR/ Unexpected Hit / Jump To Label command, any unexpected hits that occur after that point in the program will cause execution to jump to the specified label. The action to 'Set a Variable’s value to one causes the variable to be set as soon as the specified error type occurs. This value of the variable can then be tested using an IF statement to cause execution to jump to a new point in the part program.

The Edit window command line for the ON ERROR option reads:
ONERROR/UNEXPECTED_HIT, mode ID
or,
ONERROR/PROBE_MISS, mode ID
or,
ONERROR/REFLECTOR_NOT_FOUND, mode ID

To use the ON ERROR command:

  1. Select On Error. The On Error dialog box will appear.

  2. Select either Unexpected Probe Hit or Missed Probe Hit from the Error Type drop-down list.

  3. Select one of the following Error Mode options to define what action should take place.

  4. Click the OK button to apply the ON ERROR option. The Cancel button will close the On Error dialog box without applying any changes.

More:

Error Type

Error Mode

Supported Interfaces


Error Type

The Error Type drop-down window allows you to choose one of these Error Types:

  • Unexpected Probe Hit

  • Missed Probe Hit

  • Reflector Not Found (used with the Tracker in PC-DMIS Portable)


Error Mode

When an error condition is met, selecting one of these items determines what PC-DMIS will do.

Item | Description
Off option | PC-DMIS to do nothing.
GoTo Label option | Jumps to a defined label.
Set Variable option | Sets a variable's value to one.
Skip Command option | Skips over the current command and moves to the next marked command in the part program.


Supported Interfaces

Not all interfaces support the ON ERROR command. Consult the following table to see if your interface is supported.

  • If your interface is listed, an X indicates what error type is supported by that interface.

  • If your interface isn't listed, then it's not able to use the ON ERROR command.

Supported Interfaces | Unexpected Probe Hit | Missed Probe Hit | Reflector Not Found
B&S Standard | X | X |
Dea |  | X |
Elm | X | X |
Federal/Renault | X | X |
Johansson | X | X |
Leica Tracker |  |  | X
Leitz | X | X |
LK Direct (also known as LKRS232) | X | X |
LK Driver | X | X |
Metrolog | X | X |
Mitutoyo Bright | X | X |
Mitutoyo | X | X |
Mora | X | X |
Omnitech | X | X |
Renishaw | X | X |
Sharpe | X | X |
Sheffield | X | X |
Wenzel | X | X |
Zeiss | X | X |


Ending a Part Program

The Insert | Flow Control Command | End Program menu item inserts a PROGRAM/END command into the Edit window. Whenever PC-DMIS encounters this command during program execution, it will immediately stop part program execution.

This command is useful when you want to end a part program earlier than usual, based on defined conditions.


Branching with Subroutines

Subroutines are blocks of code in your part program or in an external part program that are usually referenced repeatedly, allowing for more concise programming. PC-DMIS allows you to pass information to "arguments" (or local variables) in the subroutine. The types of arguments that can be passed into a subroutine are numeric values, variables, text strings, and feature names.

Hint: Subroutine command blocks are enclosed within SUBROUTINE and ENDSUB commands.

Once you have created a subroutine in your part program you can "call" it from your current part program or from another part program, causing the part program execution flow to go into the specified subroutine, executing commands contained within the subroutine command block. Program flow will then return to the statement immediately following the calling statement.

Hint: Subroutines are called by using the CALLSUB command.

External Subroutines

External subroutines, or subroutines located in a part program outside of the calling part program, do not have access to features, variables, or alignments from the calling program. The subroutine would still have access to items within its own part program. The external part program and the calling part program must use the same units of measurement.

Nesting Subroutines

You can nest subroutines within other subroutines. The only limitation to the number of arguments and nested subroutines is the amount of available memory.

More:

Creating a New Subroutine

Editing an Existing Subroutine

Understanding the Argument Edit Dialog Box

Calling a Subroutine

Subroutine Examples


Creating a New Subroutine

You can insert this command by simply typing SUBROUTINE in the Edit window's Command mode and then pressing TAB. Once the command is inserted, you will need to specify the subroutine's name and any arguments it has. See the subroutine syntax and example below for this information.

Type the ENDSUB command and press TAB to end the command block. Any Edit window commands placed within this command block will be considered part of the subroutine and will be executed when the subroutine is called.

  1. Select Insert | Flow Control Command | Subroutine from the submenu. This brings up the Subroutine Creation dialog box. For information on this dialog box, see the " Understanding the Subroutine Creation Dialog Box" topic.

Subroutine Creation dialog box

  2. Give the subroutine a name by typing it the Name box.

  3. If your subroutine uses arguments, place holders for information passed into the subroutine, add them one by one by clicking the Add Arg button. The Argument Edit dialog box appears. For information on this dialog box, see the "Understanding the Argument Edit Dialog Box" topic.

Argument Edit dialog box

  4. Give your argument a name by typing it in the Name box.

  5. Give your argument a default value by typing it in the Value box. The subroutine will use the default value if no values are passed into the subroutine from the CALLSUB statement. Valid argument values can be numeric values, variables, text strings, and feature names.

  6. If you want to give a description, type it in the Description box.

  7. Click OK in the Argument Edit dialog box to create the argument.

  8. Repeat steps 3 to 7 for each argument you want in your subroutine.

  9. Click the OK button in the Subroutine Creation dialog box to finish creating your subroutine. This subroutine will appear inside the Edit window with any defined arguments.

  10. End your subroutine. Select Insert | Flow Control Command | End Sub menu option. This places an "ENDSUB/" command in the Edit window, completing the subroutine's command block. Any other part program commands you want in your subroutine must be added inside the subroutine's command block, before the ENDSUB command.

The Edit window command line syntax for a sample subroutine command block would read:

SUBROUTINE/<Name>,
<A1> = <Arg1> : <Description>,
<A2> = <Arg2> : <Description>,
=
<Commands>
ENDSUB/

SUBROUTINE/ is the command used to start the subroutine command block.

<Name> = the name of the subroutine.

<A1> = the first argument (or local variable) used in the subroutine. This variable generally cannot be accessed outside of the subroutine.

<A2> = second argument used in the subroutine. This variable generally cannot be accessed outside of the subroutine. Additional arguments can be added as needed.

<Arg1> = the default value for the first argument.

<Arg2> = the default value for the second argument.

<Description> = The description for the argument.

<Commands> = Other Edit window commands can be inserted as needed after the arguments and before the ENDSUB command.

ENDSUB/ is the command used to end the subroutine command block.

For example, a finished subroutine that takes operator data and displays it to the report might look like this:

SUBROUTINE/GET_OPERATOR_INFO,

OPNAME = <Operator> : OPERATOR NAME,

SHIFT = <Shift> : SHIFT TIME,

=

COMMENT/REPT,OPNAME

COMMENT/REPT,SHIFT

ENDSUB/

Creating a New Subroutine

Display Menu Roadmap

Creating a Subroutine by Typing SUBROUTINE

Creating a Subroutine by Using the Subroutine Menu Item

Syntax for a Subroutine Command Block

Example Subroutine Command Block


Understanding the Subroutine Creation Dialog Box

Display Menu Roadmap

Subroutine Creation dialog box

The following table describes the various options available in the Subroutine Creation dialog box.

Dialog Box Item

Description

The Name box defines the your subroutine. This is the name you will use when calling the subroutine later so if you have multiple subroutines in a single part program each name must be unique.

The Number of Arguments list shows the arguments for the subroutine you are creating. Arguments will appear in this area in this form:

<NAME> =<VALUE> :<DESCRIPTION>

So, if one of your arguments was named "Diameter" with a default value of 3, your argument in this list might appear as:

DIAMETER = 3 : The hole's diameter

PC-DMIS will use the default value whenever another value is not passed from the CALLSUB command.

To edit an argument, simply double-click on the argument you want to change. The Argument Edit dialog box will open, allowing you to make the needed changes.

The Add Arg button adds new arguments to your subroutine. Simply click on this button and the Argument Edit dialog box appears. See "Understanding the Argument Edit Dialog Box"

The Delete Arg button allows you to delete arguments from your subroutine. Simply select the argument from the list, and click the Delete Arg button.


Editing an Existing Subroutine

To edit an existing subroutine you can always use the Edit window's Command mode and edit the subroutine directly. Alternately, you can access the Subroutine Creation dialog box by placing your cursor on the subroutine in the Edit window and pressing F9. This brings up the Subroutine Creation dialog box. For information on this dialog box, see the " Understanding the Subroutine Creation Dialog Box " topic.


Understanding the Argument Edit Dialog Box

Argument Edit dialog box

The Argument Edit dialog box appears whenever you choose to create or edit an argument within either the Subroutine Creation dialog box or the Call Subroutine dialog box.

The Argument Edit dialog box can be used in these two contexts:

  • To define a subroutine's arguments and their default values in a SUBROUTINE command block.

  • To define the values that will be passed into the subroutine from a CALLSUB command.

The following table describes the various options available in the Argument Edit dialog box.

Dialog Box Item

Description

In the Name box you enter the name for the argument you are creating or editing.

In the Value box type the value of the argument.

If creating or editing the SUBROUTINE command, this is the default value used if no value is passed into the subroutine by the CALLSUB statement.

If creating or editing the CALLSUB command, this is the value passed into the subroutine.

Valid values can be:

  • Numeric

  • Variable

  • Text String - Text strings must be enclosed in double quotation marks..

  • Feature Name - The feature name must be bounded by curly brackets, for example {F1}.

In the Description box you can enter a description of the argument for the subroutine. This description will appear next to the argument in the Edit window's SUBROUTINE command block.


Calling a Subroutine

You can insert this command by simply typing CALLSUB in the edit window and then pressing TAB where you want the command to appear in the Edit window. Once the command is inserted, you will need to specify the subroutine's name, its location if it's in an external part program, as well as any values to pass to available arguments. See "Passing Arguments into a Subroutine" for examples of passing arguments.

  1. Select the Insert | Flow Control Command | Call Sub option from the submenu. The Call Subroutine dialog box opens. See Understanding the Call Subroutine Dialog Box"" for information on this dialog box.

  2. Click the Select Subroutine button. The Select Subroutine dialog box opens.

  3. Select either the User Directory check box or the Current Directory check box or both. If the part program the subroutine is from resides in the directory specified to be searched for subroutines, select the User Directory check box. If it is from the current directory, mark the Current Directory check box. PC-DMIS lists all the part programs available for selection.

  4. Select the part program which contains the subroutine you want. You will see all subroutines associated with the selected program appear in the Subroutine Name box.

  5. Select the subroutine you want to call.

  6. Click the OK button. The subroutine information you are going to call will appear in the Name and File boxes of the Call Subroutine dialog box.

  7. If you want to pass information into the subroutine, click the Add Arg button, and use the Argument Edit dialog box to define arguments and values to pass. See "Understanding the Argument Edit Dialog Box" for information on this dialog box. See "Passing Arguments into a Subroutine" for examples of passing arguments.

  8. Click the OK button again and the CALLSUB command will appear in the selected location of the Edit window.

Call Subroutine dialog box

Select Subroutine dialog box

The Edit window command line syntax for calling a subroutine is this:

CS1 =CALLSUB/<Name>, <File>:<Arg1>,<Arg2>,

CS1 = the label ID given to the CALLSUB command.

<Name> = the name of the subroutine to be called.

<File> = the full path way to the part program that contains the subroutine to call. If this field is blank, PC-DMIS will look in the current part program for the subroutine.

<Arg1> = the value to be passed to the first argument in the subroutine. If this field is blank, the default value defined for the first argument in the subroutine will be used instead.

<Arg1> = the value to be passed to the second argument in the subroutine. If this field is blank, the default value defined for the second argument in the subroutine will be used instead. This syntax sample shows only two arguments. Other arguments can be passed if needed to your subroutine

Note: In your CALLSUB command you should keep a set of pointers to all of the objects made for the subroutine so that you can easily refer to them afterwards using the subroutine's ID. For more information on pointers, see "Pointers" in the "Using Expressions and Variables" section.

CS1 =CALLSUB/GET_OPERATOR_INFO,D:\PARTPROGRAMS\V42SUBROUTINETEST.PRG:V1,V2,,

This example CALLSUB command, CS1, calls a subroutine named GET_OPERATOR_INFO located within the part program V42SUBROUTINETEXT.PRG located in the D:\PARTPROGRAMS\ directory. It passes two values—in this case the variables V1 and V2—into the subroutine.

Calling a Subroutine

Display Menu Roadmap

To call a subroutine you need to insert a CALLSUB command into your part program to call an existing subroutine from the current part program or a subroutine from an external part program.

Calling a Subroutine by Typing CALLSUB

Calling a Subroutine Using the Call Sub Menu Item

Syntax for the CALLSUB Command

Example CALLSUB Command

More:

Understanding the Call Subroutine Dialog Box

Passing Arguments into a Subroutine

To add a new argument using the Call Subroutine Dialog box:

To edit existing arguments using the Call Subroutine Dialog box:

To delete arguments from a CALLSUB command:

Using CALLSUB Statements in Multiple Arm Mode


Understanding the Call Subroutine Dialog Box

Call Subroutine dialog box

The following topics describe the various options available in the Call Subroutine dialog box.

Dialog Box Item

Description

The Name box contains the name of the subroutine you have selected after using the Select Subroutine button.

The File box contains the directory pathway to the subroutine file you have called.

In the Description box you can enter a description of the argument. This description will appear next to the argument in the Edit window.

The Values box contains a list of the values of each argument associated with the subroutine. These values will get passed into the subroutine when the subroutine is executed.

To change these values, simply double-click on the value you wish to change and the Edit Argument dialog box will appear.

The Select Subroutine button brings up the Select Subroutine dialog box.

Select Subroutine dialog box

This dialog box allows you to call previously created subroutines by searching in the user directory or the current directory. See "Calling a Subroutine" for info on the Select Subroutine dialog box.

This button defines a value to pass to the arguments for the subroutine.

This button will allow you to delete the arguments from the Values box. Simply select the value displayed and click the Delete Arg button. The argument associated with that value is then deleted.


To add a new argument using the Call Subroutine Dialog box:

To add a new argument into your CALLSUB command to pass into the subroutine:

  1. Inside the Call Subroutine dialog box, click the Add Arg button. The Argument Edit dialog box will appear.

  2. Click in the Value box.

  3. Type the value for the argument in the Value box.

  4. Click OK.


To edit existing arguments using the Call Subroutine Dialog box:

To edit an existing argument inside your CALLSUB command:

  1. In the Call Subroutine dialog box, double-click on the value of the argument you want to change. A value box will appear which shows the default value for the called subroutine.

  2. Type a new value.

  3. Click the OK button.

See "Creating a New Subroutine" and "Editing an Existing Subroutine" for additional information on how to edit or create new arguments for a subroutine.


To delete arguments from a CALLSUB command:

  1. Place the cursor on the CALLSUB command.

  2. Press F9 to access the Call Subroutine dialog box.

  3. Select the desired argument(s) from the list.

  4. Click the Delete Arg button.

  5. Click OK.

You can also delete an argument in the Edit window text directly. To do this,

  1. Place PC-DMIS in Command mode.

  2. Place the cursor on the CALLSUB command, and press TAB until you highlight the desired argument.

  3. Type the letters "del". This will delete the argument. Pressing DELETE or BACKSPACE won't work. They merely change the argument to an empty argument.


Using CALLSUB Statements in Multiple Arm Mode

If you mark a CALLSUB statement as Master Only; all of the commands in the subroutine will be marked as Master Only when the subroutine is called.

If you mark a CALLSUB statement as Slave Only; all of the commands in the subroutine will be marked as Slave Only when the subroutine is called.

If you mark a CALLSUB statement for both arms, PC-DMIS leaves the subroutine markings as they were originally set.

If a subroutine contains a MOVE/SYNC command in it, and you mark the CALLSUB statement as Master Only or Slave only, at execution time PC-DMIS displays an error indicating that this is invalid and the subroutine is not called.

For information on assigning a command to execute for a specific arm, see the "Assigning a Command to an Arm" topic in the "Using Multiple Arm Mode" section.


Subroutine Examples

Consider the information in the following topics for some examples of passing arguments and subroutines in general.

  • Passing Arguments into a Subroutine

  • Code Sample of a Subroutine


Passing Arguments into a Subroutine

Example of Passing Variables:

This example shows how a variable's value, used as an argument to a subroutine, is modified and passed back from a subroutine:

The variable V1 is assigned the value 6:

ASSIGN/ V1 = 6.

A subroutine call passes V1 as the first argument:

CS1 =CALLSUB/MYSUB,:V1,,,

The subroutine is defined as follows:

SUBROUTINE/MYSUB,

A1 = 0 : FIRST ARGUMENT,

=

ASSIGN/ A1 = A1 + 1

ENDSUB/

A1 is the name for the first argument so when the call is made, A1 will have the same value that V1 did at the time of the call, 6.

The subroutine contains this one statement:

ASSIGN/ A1 = A1 + 1.

This increments the value of A1 to 7.

Then subroutine ends with the ENDSUB/ command.

Flow of execution returns to the statement directly following the CALLSUB command. As execution jumps back, any variables that were used as arguments, V1 in this case, are updated to the value of the corresponding variables in the subroutine, A1 in this case. So, V1 now has a value of 7. The value was passed back from the subroutine.

Example of Passing Number Values:

This example shows how to pass number values into a subroutine. It passes up to two numbers and then adds them together.

CS1 =CALLSUB/SUM_NUMBERS,:,,,

CS2 =CALLSUB/SUM_NUMBERS,:5,10,,

SUBROUTINE/SUM_NUMBERS,

NUM1 = 1 : FIRST NUMBER,

NUM2 = 1 : SECOND NUMBER,

=

COMMENT/OPER,NO,"The sum of the first number, " + NUM1 + ", plus the second number, " + NUM2 + ", is: "

,NUM1 + NUM2

ENDSUB/

In the first CALLSUB command (CS1) no number values are passed into the subroutine. The default numbers, 1 for NUM1 and 1 for NUM2 are used instead, and the generated sum would be 2.

In the second CALLSUB command (CS2) two number values are passed, 5 and 10. So NUM1 would be 5 and NUM2 would be 10, with a generated sum of 15.

Example of Passing Text Strings:

This example shows how to pass string values into a subroutine. It passes two string values into the two parameters and then displays them in the report:

CS1 =CALLSUB/GET_OPERATOR_INFO,:"BOB JONES","MORNING",,

...

SUBROUTINE/GET_OPERATOR_INFO,

OPNAME = <Operator> : OPERATOR NAME,

SHIFT = <Shift> : SHIFT TIME,

COMMENT/REPT,OPNAME

COMMENT/REPT,SHIFT

ENDSUB/

The first argument, OPNAME, receives the passed value of "BOB JONES" and the second argument, SHIFT, receives "MORNING". The COMMENT commands then send the passed strings to the inspection report.

Example of Passing Feature Names:

This example passes in the PNT1 feature name into the subroutine, giving your subroutine complete access to the feature. If no value is passed then the default feature name of F1 is used. This subroutine then queries you for a new value and changes the theoretical X value for the feature.

CS1 =CALLSUB/CHANGE_THEO_X,:{PNT1},,

SUBROUTINE/CHANGE_THEO_X,

FEAT1 = {F1} : PASSED FEATURE NAME,

=

C1 =COMMENT/INPUT,NO,"PASSED FEATURE:"

,FEAT1

,"The current theo X is: " + FEAT1.TX

,"Type a new theo X value:"

ASSIGN/FEAT1.TX = C1.INPUT

COMMENT/OPER,NO,"Feature updated to " + FEAT1.TX

ENDSUB/

Because the subroutine has access to the passed feature, the statement ASSIGN/FEAT1.TX = C1.INPUT modifies the theoretical X value of the actual PNT1 feature. PNT1 will now permanently have its theoretical X value changed.

Passing Arguments into a Subroutine

The types of arguments that can be passed into a subroutine are numeric values, variables, text strings, and feature names. To pass values into arguments, type the value within the Value box of the Argument Edit dialog box, or directly into an inserted CALLSUB command in Command mode. See "Creating a New Subroutine" for more details.

Passing Variables into a Subroutine

Arguments that can pass data back are variables. When you use a variable as an argument to a subroutine, any changes that occur to the corresponding variable in the subroutine are passed back and become the value of the variable that was passed in.

Example of Passing Variables

Passing Number Values into a Subroutine

Arguments can also take numeric characters.

Example of Passing Number Values

Passing Text Strings into a Subroutine

Arguments can also take a text string. To pass a text string, make sure the alphanumeric characters are placed within double quotation marks.

Example of Passing Text Strings

Passing Feature Names into a Subroutine

Feature names are passed within curly brackets, for example; {F1} would be used to call the feature designated as F1 into the Edit window. Also, when you pass the feature name, the subroutine has full access to that feature.

Example of Passing Feature Names


Code Sample of a Subroutine

The following code sample allows the operator to have a choice of changing the theoretical X, Y, and Z values of a feature after its measurement. Subsequent runs will then use the updated theoretical values.

PNT1=FEAT/POINT,RECT

…

…

ENDMEAS/

C1=COMMENT/YESNO,Do you want to change the theoretical values for PNT1?

IF/C1.INPUT=="YES"

CS1=CALLSUB/CHANGETHEO,:,

END_IF/

COMMENT/OPER,The XYZ theoretical and actual values for PNT1 are:

,"Theo X= " + PNT1.TX

,"Theo Y= " + PNT1.TY

,"Theo Z= " + PNT1.TZ

,- - - - - - - - - - -

,"Actl X= " + PNT1.X

,"Actl Y= " + PNT1.Y

,"Actl Z= " + PNT1.Z

PROGRAM/END

SUBROUTINE /CHANGETHEO,

POINT1 = {PNT1} : ,

=

DIMINFO/;DIMID,FEATID;HEADINGS,GRAPH AXIS ;MEAS,NOM,TOL,DEV,MAXMIN,OUTTOL, , ,

C2=COMMENT/INPUT,Type the new X theo value for PNT 1.

,"It's current value is: " + PNT1.TX

ASSIGN/PNT1.TX = C2.INPUT

C3=COMMENT/INPUT,Type the new Y theo value for PNT 1.

,"It's current value is: " + PNT1.TY

ASSIGN/PNT1.TY = C3.INPUT

C4=COMMENT/INPUT,Type the new Z theo value for PNT 1.

,"It's current value is: " + PNT1.TZ

ASSIGN/PNT1.TZ = C4.INPUT

ENDSUB/

Explanation of Sample Code

C1=COMMENT/YESNO
This line takes and stores the YES or NO response from the user.

IF/C1.INPUT=="YES"
This line is the expression. It tests to see if the input of comment 1 is a YES. If it's a YES then the IF statement is TRUE and continues executing the statements after the IF statement, in this case it measures the PNT1 feature. If NO it moves to the END_IF statement.

CS1=CALLSUB/CHANGETHEO,:,
This line calls the subroutine named CHANGETHEO. The flow of the part program now jumps to the SUBROUTINE/CHANGETHEO line.

SUBROUTINE/CHANGETHEO
This line initializes the CHANGETHEO subroutine. Program flow continues with the execution of code between this line and the ENDSUB/ line.

POINT1 = {PNT1} : ,
This is the only argument of the subroutine. It allows the subroutine to access information from the PNT1 feature.

C2=COMMENT/INPUT, C3=COMMENT/INPUT, C4=COMMENT/INPUT
These input comments all take the new theoretical X, Y, and Z values from the user and store them in C2.INPUT, C3.INPUT, and C4.INPUT respectively.

ASSIGN/PNT1.TX = C2.INPUT
This line takes the theoretical X value from C2.INPUT and assigns it to the PNT1.TX variable. PNT1.TX is a PC-DMIS variable that holds the theoretical X value (denoted by TX) for the point with the ID label of PNT1.

ASSIGN/PNT1.TY = C3.INPUT
This line takes the theoretical Y value from C3.INPUT and assigns it to the PNT1.TY variable. PNT1.TY is a PC-DMIS variable that holds the theoretical Y value (denoted by TY) for the point with the ID label of PNT1.

ASSIGN/PNT1.TZ = C4.INPUT
This line takes the theoretical Z value from C4.INPUT and assigns it to the PNT1.TZ variable. PNT1.TZ is a PC-DMIS variable that holds the theoretical Z value (denoted by TZ) for the point with the ID label of PNT1.

ENDSUB/
This line ends the subroutine, and program flow returns to the line immediately following the subroutine call. In this case the END_IF/ statement. The program flow then continues with the next operator comment which displays the theoretical and actual X, Y, and Z values, and then the part program ends with the PROGRAM/END command.


Tracking Statistical Data

Tracking Statistical Data: Introduction

Using Trace Fields

Sending Current Stats to a File

Using the Statistics Options Dialog Box


Tracking Statistical Data: Introduction

PC-DMIS allows you to track and manage statistical data for your measured parts. Information in any dimension or trace field can be sent to a selected statistical software package by inserting a STATS command before the dimension or trace field.

The main topics in this section include the following:

  • Using Trace Fields

  • Sending Current Stats to a File

  • Using the Statistics Options Dialog Box


Using Trace Fields

Trace Field dialog box

Display Menu Roadmap

The Insert | Statistics Command | Trace Field menu option displays the Trace Field dialog box. This dialog box lets you establish trace fields in the Edit window. This information will be used in the STATS data base (see the XSTATS11.TMP file). With the trace field in the Edit window, the name of a trace field and the current value for that trace field can be changed.

To change the values associated with a Trace Field:

  1. Place your cursor in the box you want changed.

  2. Select the previous value.

  3. Type a new value.

If the Display option is selected, the Trace Field dialog box will appear every time the part program is executed. If the No Display option is selected, it will not appear during execution.

The Edit window command line for a trace field option reads:
TRACEFIELD/ DISPLAYSTATE ; field name : value

DISPLAYSTATE = This toggle field controls whether or not the trace field dialog box is displayed during execution. This field switches between DISPLAY and NO DISPLAY.

field name = This string represents the name of the trace field. There is a 15 character limit.

value = This displays the current value of the trace field. There is a 15 character limit.

Important: The TRACEFIELD command should come after the STATS/ON command.

More:

Options


Options

The Options area controls the options of the trace field :

  • No Display

  • Display

  • Value Limit


No Display

Selecting the No Display option indicates that a dialog box will not be displayed when the trace field is executed. This will allow trace fields to be controlled by variables without requiring input from the user.


Display

Selecting the Display option indicates that a dialog box will be displayed when the trace field is executed. This requires the trace field to have input from the user during execution.

Note: Trace fields that are entered using the Logo.dat will not print when encountered by an execution. They are however, still sent to the stats file.


Value Limit

The Value Limit box determines the maximum number of characters allowed for the trace field's value. So if you specify a Value Limit of 5, you won't be able to type more than five characters into the Value box.


Sending Current Stats to a File

Display Menu Roadmap

The Operation | Send Current Stats To File menu option allows you to send data to a database or the XSTATS11.tmp file without having to execute the part program.

Selecting this option immediately sends all of the dimensions and trace fields that follow a STATS/ON command to the selected database. Statistics only get sent to a database if you have a database registered and have the STATS/ON command marked. Otherwise, PC-DMIS sends statistical data to the XSTATS11.tmp file.


 Stats Options area Database Directories list Database Options area Datapage Variable Name area Read Lock box Write Lock box Membory Pages box Add Directory to List button Delete Current Stats File button Delete Directory from List button Update Database Now button Cancel button

Using the Statistics Options Dialog Box

Statistics Options dialog box

Display Menu Roadmap

The Insert | Statistics Command | Statistics menu option allows you to manage statistical information that is received from measuring a part. This is done by inserting a STATS command in a part program before any desired dimension or trace field commands. This information can then be sent to a selected statistical software package.

More:

Stats Options

Database Options

Update Database Now


Stats Options

The Stats Options area is always available on the Statistics Options dialog box. The Stats Options area allows you to use the following commands.

  • Turn stats off

  • Turn stats on

  • Transfer stats to another directory

  • Update the stats


Stats Off

Selecting the Off option stops statistical information from being sent from your part program . With stats off, Dimension or Trace Field commands will not send statistical information to the database unless you select the Stats On option.


Stats On

Selecting the On option allows statistical information to go from your part program to the database. With stats on, you can send data to the stats file, transfer the information to a different directory, or store the information in a database application.

Any dimensions that follow a STATS/ON command and precede the next STATS/OFF command will be sent to the stats file or database upon execution of the next STATS/TRANSFER, STATS/UPDATE, or final command of the part program. With the STATS/ON command you can send the output information to multiple databases, even within the same part program.

Upon each execution of a part program that includes at least one STATS/ON command, PC-DMIS will ask whether or not to send the output information to any statistical database directories. This prompt can be bypassed by selecting the ALWAYS Update Database check box accessible from the Dimension tab of the Setup Options dialog box. See the "Setup Options: Dimension tab" topic in the "Setting Your Preferences" section.

Note: If you selected DataPage from Database Options, PC-DMIS automatically calls the DPUPDATE.exe executable to insert the data in the XSTATS11.tmp file into any selected DataPage directories.

Turning stats on inside a loop can result in slightly different output to the XSTATS11.tmp file for the dimension and feature IDs.

The Edit window command line for STATS ON reads:
STATS/ON,database option;
directory or DSN,
user ID, read lock, write lock, memory pages, user mode, variable name

database option = This toggle field indicates the database type to which the stats will be sent. This field can be DATAPAGE, DES, or SPC_DATABASE.

Directory or DSN = If the database option is DATAPAGE or DES, this string indicates the database directories to which the statistics will be sent. This must be a valid database directory. If the database option is SPC_DATABASE, this string indicates the DSN name of the database. This DSN name can be created in the ODBC options of the computer’s control panel. This DSN must be created to link to a valid SPC database.

user ID = This nine digit string indicates the port lock serial number. This field is only used for the DataPage database option.

read lock = This field indicates the maximum number of seconds PC-DMIS will wait for database access when reading. The default setting is 10 seconds. This field is only used for the DataPage database option.

write lock = This field indicates the maximum number of seconds PC-DMIS will wait for database access when writing. The default setting is 20 seconds. This field is only used for the DataPage database option.

memory pages = This field indicates the number of 4K pages to reserve for database tables when opening database. This option will affect performance. The minimum number that can be entered is 4 (also default). This field is only used for the DataPage database option.

user mode = This field indicates the user mode setting. Single user mode will only allow a single user access to the database. The value 0 (zero) signifies that single user mode is set. A value of 1 (one) signifies that multi-user mode is on. Single user mode will improve performance. This field is only used for the DataPage database option.

variable name = This field indicates the variable name setting. The value 0 (zero) indicates that dimension names will be displayed. A value of 1 (one) indicates that feature ID's will be displayed. This field is only used for the DataPage database option.


Transfer

The Transfer option allows statistical information from a part program to be transferred to a specified directory upon execution of the STATS/TRANSFER command.

Note: This option may be especially useful with the Auto Update option of DataPage.

To transfer your stats to a different directory:

  1. Click the Transfer option.

  2. In the Transfer Directory box, enter the directory path of the directory to which you will transfer your stats file.


Update

The Update option creates a STATS/UPDATE command that tells PC-DMIS to update the statistical database every time the command is executed. The statistical software application must be installed and ON.

Note: The Always Update Database check box from the Dimension tab of the Setup Options dialog box allows you to bypass the "Update Database Now?" message that PC-DMIS shows at the end of a part program execution that contains a STATS/ON command. See the "Setup Options: Dimension tab" in the "Setting Your Preferences" section.


Database Options

The Database Options allow you specify one of the following statistical software packages to send the measurement information:

  • DataPage

  • DES

  • SPC Database

The Statistics Options dialog will change when one of the Database Options is selected.

More:

DataPage Option

Database Directories

Add Directory to List

Delete Directory from List

Delete Current Stats File

DataPage Variable Name

Do Control Calculations

Read Lock

Write Lock

Memory Pages

DES Option

SPC Database Option

Data Source

View/Edit Database


DataPage Option

When you select the Datapage option, the Statistics Options dialog box changes to add the following:

  • Database Directories list

  • Add Directory To List button

  • Delete Directory From List button

  • Delete Current Stats File button

  • DataPage Variable Name area

  • Do Control Calculations area

  • Read Lock box

· Write Lock box

· Memory Pages box

Statistics Options dialog box – DataPage option


Database Directories

The Database Directories list shows the different directories in which a database application could reside. You can add or delete directories from this list. A maximum of ten directories per STATS/ON command can be selected to which statistical information can be sent.


Add Directory to List

If you want to add a new directory to the Database Directories list:

  1. Click the Add Directory To List button. A box will appear in which you can enter the directory pathway.

  2. Type the directory pathway for the database.

  3. Click the OK button. The directory will now appear in the list.


Delete Directory from List

If you want to delete a database directory from the Database Directories list:

  1. Select the directory you want to delete from the Database Directories list.

  2. Click the Delete Directory from List button. The directory will be deleted from the list.


Delete Current Stats File

If you want to delete your xstats11.tmp file, click the Delete Current Stats File button.


DataPage Variable Name

These options only function with the DataPage statistical database program.

The options in the DataPage Variable Name area indicate whether the dimension name or feature name will be used to identify entries in DataPage. The maximum length of the name is 10 characters.

To choose either the dimension name or the feature name, select the Use Dimension Name option or the Use Feature Name option.


Do Control Calculations

The options in the Do Control Calculations area indicate whether the control calculations that take place within Datapage should be used. Selecting the On option performs the out of tolerance control calculations. Additionally, it commands the DataPage statistics update program (DPUPDATE) to perform the control calculations and set the part/variable and in/out of tolerance/control indicators in the database. You can monitor this database using DataPage's Monitor mode by turning on the part/variables colors (red/yellow/green) based on those calculations. For additional information, see the help file that ships with DataPage's Monitor mode application.

To turn control calculations on or off simply select either the On or the Off option. The default setting is Off.


Read Lock

The Read Lock box allows you to determine the maximum number of seconds that PC-DMIS will wait for database access when reading. The default value is 10 seconds.

To change the number of seconds that PC-DMIS will wait:

  1. Select the current value in the Read Lock box.

  2. Type a new value.

  3. Press the TAB key.

  4. Click OK.


Write Lock

The Write Lock box allows you to determine the maximum number of seconds that PC-DMIS will wait for database access when writing. The default value is 20 seconds.

To change the number of seconds that PC-DMIS will wait:

  1. Select the current value in the Write Lock box.

  2. Type a new value.

  3. Press the TAB key.

  4. Click OK.


Memory Pages

The Memory Pages box allows you to enter in the number of 4K pages to reserve for database tables when opening a database. The minimum (and default) number of pages that can be open is four.

To change the number of Memory Pages:

  1. Select the value in the Memory Pages box.

  2. Type a new value.

  3. Press the TAB key.

  4. Click OK.


DES Option

The DES option only functions with the statistical database program, DES. When you select DES, the Statistics Options dialog box changes so that it only includes the Stats Options area, the Database Options area, and the Update Database Now, OK, and Cancel command buttons.

Statistics Options dialog box – DES option


SPC Database Option

The SPC Database option only functions with PC-DMIS's own statistical database program, SPC. When you select the SPC Database option, the Statistics Options dialog changes to include the following:

  • Data Source box

  • View/Edit Database

Statistics Options dialog box – SPC Database option


Data Source

Use the Data Source list to select a Data Source Name (DSN). A DSN is created initially by using the Open Database Connectivity (ODBC ) options in the computer’s Control Panel.

If you need to create a DSN:

  1. Access the Windows Control Panel.

  2. Select Administrative Tools.

  3. Double-click on the ODBC Data Sources icon.

  4. Follow the instructions in your operating systems Help file to create the DSN.

By using the ODBC, PC-DMIS can pass data directly to the SPC database, and the data can be viewed within a statistical package that supports the SPC database.


View/Edit Database

Display Menu Roadmap

The View/Edit Database button can only be used once a valid Data Source has been selected from the Data Source box. Clicking this button allows the data in the SPC database to be viewed and deleted from the SPC Database dialog box:

SPC Database dialog box

The SPC database can be viewed within PC-DMIS using the following tabs on the dialog box:

  • Part Programs

  • Dimensions

  • Dimension Values

  • Traces

  • Trace Values

You can also view databases using the SPC Database menu option


Update Database Now

The Update Database Now button allows you to update your database application with statistical data gained from your current part program.

To update your database now:

  1. Click the Update Database Now button.

  2. Follow the instructions on screen.

Upon successful execution of a part program, selected Dimension and Trace Field information is stored within a file named XSTATS11.tmp located in the directory to which you installed PC-DMIS (usually the C:\PCDMISW directory). The information in this file can then be transferred to a different directory, printed out, or sent to a database application.

Note: If a database application is unavailable, PC-DMIS will display a message informing you that it couldn't find the update executable (for the DataPage application, this is DPUPDATE.exe) to load XSTATS11.tmp into the database.


Reporting Measurement Results

Reporting Measurement Results: Overview

Reporting Changes

Migrating Legacy (HyperView) Reports

Report Generation Sequence

About the Report Window

Using Standard Reports

Viewing a Legacy Text Only Report

Rearranging Report Pages

Modifying Standard Templates

Modifying your Report's Header

Changing the Report's Text Colors

Adding Notes to a Report

About the Reporting and Form Editors

Creating Templates

Creating Forms

Creating Custom Reports

About Report Expressions

Embedding Reports or Report Templates in a Part Program

Using PC-DMIS ActiveX Controls


Reporting Measurement Results: Overview

New To Reporting?

Follow the reporting tutorials here!

After you measure your part, it's important to be able to communicate your measurement results with others. PC-DMIS, by default, sends your measurement data to a standard textual report, called an inspection report, which includes comprehensive data about each feature measured by your part program. You can print this report to the printer or to a file and later view stored reports by selecting Display Menu Roadmap View | Inspection Report. See "Viewing an Inspection Report" and "Printing the Inspection Report".

For many tasks, the standard inspection report may be exactly what you need. However, in version 4.0 and later, PC-DMIS also gives you some powerful tools to generate your own interactive reports. With these tools you can determine exactly how your reports will look and what information gets included in them by using templates. Also, with these templates you can maintain a consistent look and feel across several reports.

In addition, in version 4.2 and later, you will find the ability to create reports for specific part programs, called "Custom Reports", a useful solution when your reporting needs don't require the use of report templates.

This section covers the following major topics:

  • Reporting Changes

  • Migrating HyperView Reports

  • Report Generation Sequence

  • About the Report Window

  • Using Standard Reports

  • Viewing a Legacy Text Only Report

  • Modifying Standard Templates

  • Modifying your Report's Header

  • Changing the Report's Text Colors

  • About the Reporting and Form Editors

  • Creating Templates

  • Creating Forms

  • Creating Custom Reports

  • About Report Expressions

  • Embedding Reports or Report Templates in a Part Program

  • Using PC-DMIS ActiveX Controls


Reporting Changes

The major reporting changes in PC-DMIS 4.x include a complete overhaul of the HyperView reporting functionality and the inclusion of a powerful template system.

The following items detail the major changes to PC-DMIS reporting since version 3.7:

  • Reporting is no longer a part of the Edit window. A new Reporting window with its own toolbar displays measurement results. See "About the Report Window".

  • Reports now use templates. This means you can plug the same data into different templates thereby generating different reports from the same data, or you can standardize your reports and create a single report template, maintaining the same look and feel across all your reports even though the data comes from several different part programs. See "About Reports and Report Templates".

  • Report templates also utilize Labels to report specific dimension or feature information. You can create your own customized label templates. See "About Labels and Label Templates".

  • The HyperView reporting editor has been reorganized into separate editing environments for different aspects of the new reporting approach:

    1. Report Template Editor

    2. Label Template Editor

    3. Custom Report Editor

    4. Forms Editor

  • The old HyperView Object Bar has been reorganized into the following:

    1. Report Template Editor Object Bar

    2. Label Template Editor Object Bar

    3. Form Editor Object Bar

    4. Custom Report Editor Object Bar

  • The old Feature Text, Point Info, and Dimension Info objects are no longer used. PC-DMIS now uses label templates to perform those and other tasks.

  • Any object's property can be made "user definable" so that when the report is executed or a template is chosen, the user is queried to insert a value for that property. See "Working with User Assigned Properties".

  • Previous HyperView reports still function and can still be executed inside your part program, but they are no longer editable in the new template reporting environment. If you need to edit a HyperView report from a previous version, you will have to use a version earlier than version 4.0. See "Working with Existing HyperView Reports". If you desire, you can also migrate your old HyperView reports to a Custom Report or Forms format. See " Migrating HyperView Reports ".

  • Similar to the old HyperView reporting is the ability to create a report that does not use a report template but is instead specific to a part program. See "Creating Custom Reports".


Migrating HyperView Reports

Migrating Legacy (HyperView) Reports

Since you can no longer edit HyperView reports inside PC-DMIS, the software provides you with the ability to migrate existing HyperView reports into PC-DMIS's new reporting environment so that you can work with them there instead.

To convert an existing HyperView report:

  1. Select Insert | Report Command | Legacy Report... Display Menu Roadmap and use the dialog box to insert your HyperView report inside PC-DMIS. PC-DMIS inserts the appropriate REPORT/LEGACY command and then automatically launches the HyperView report in Run Mode.

  2. Press CTRL + E to exit Run Mode and enter Edit Mode. PC-DMIS will display a message saying it cannot edit legacy reports and it will ask you if you would like to convert the report into either a Custom Report or a Form.

  3. Click either Report or Form.

  • If you click Report, PC-DMIS will convert your HyperView report to work with the Custom Report Editor, displaying all the objects contained in your original HyperView report. See "Creating Custom Reports".

  • If you click Form, PC-DMIS will convert your HyperView report to work with the Forms Editor, displaying all the objects contained in your original HyperView report. See "Creating Forms".

You can then modify the report or form in the appropriate editor. The original HyperView report remains untouched.

Note: Be aware that certain objects that used to appear in the HyperView Report Editor may not be supported by your selected migration route. For example, if your HyperView report contains button objects, and you migrate them into the Custom Report Editor, the buttons will appear in the editor, but they will not function in the Report window.


Report Generation Sequence

Part Program Executes a Command

Data from Command Goes to Report Template

Command Defined in Rule Tree Editor (RTE)?

RTE Calls Label Template or Text Display

Label Template Formats and Displays Passed Data

Nothing Happens

Textual Message Displayed Instead of a Label Template Call

Report Window Displays Information for Command

More Commands to Execute?

END

Yes

No

Text

Label

Report Generation Sequence

This topic describes the process by which the report objects in report templates are bound to measurement data and drawn in the Report window during the report generation process.

  • PC-DMIS executes each command from the part program.

  • Information from each command goes to the report template for possible processing.

  • Report objects on the report template are queried, and if the command from which the information came is defined in the Rule Tree Editor to call a label template, then that label template is called. If not, the information will not be displayed in the final report.

  • Data is sent to any called label templates to be formatted and displayed according to how the GridControlObject and other reporting objects in the label template are defined.

  • The report template finally displays the called label templates with their formatted data and displays its own information and any static elements in the Report window.

Consider this Diagram:

View Flow Chart Diagram


About the Report Window

Display Menu Roadmap Selecting View | Report Window, displays the Report window. This window displays your measurement results. The Report window acts as any other window in the PC-DMIS application and is subject to the operations on the Window menu as well. The Report window's title bar displays the pathway and filename of the current loaded report template. The Report window also has its own toolbar, the Reporting toolbar.

With Report Templates

If using report templates, this window, after part program execution, displays your measurement results and automatically configures the output according to a default report template. You can set any report template as the default report template, but initially PC-DMIS uses the "TEXTONLY.RTP" template.

Report Window showing a standard, text-based report from TEXTONLY.RPT

The report window contains static content based on the selected report template and the current part program. See "Creating Templates"

With Custom Reports

If using a Custom Report, this window does not use a report template to configure or displays its data. Instead it simply loads the information that you've already defined in the stored custom report. See "Creating Custom Reports".

More:

Reporting Toolbar

Using Tooltips in the Report Window

Changing the Report Window's Contents


Reporting Toolbar

Reporting toolbar

The Report window's Reporting toolbar performs these functions:

Icon

Description

Redraw the Report

Redraws the report. If you modify the current report template, label template, or custom report, or your part program changes, click this icon to have your report redrawn and updated to use the newly modified template or new program data.

Template Selection Dialog

Selecting the Template Selection icon displays a dialog box that allows you to manage your templates and select a template from which to generate your report output. See "Applying or Removing a Report Template"

Selecting the Custom Report Selection icon displays a dialog box that allows you to choose what custom report to display. See "Creating Custom Reports".

Print the Report

Prints the report to your default printer.

Set this Report as the Default Report

Sets the currently used template as the new default template for your current part program. PC-DMIS will automatically use the defined default report template whenever you open your part program at a later date. Initially, this default report is set to TEXTONLY.RTP.

Save Layout

Selecting the Save Layout icon, saves the current report template or custom report as a layout. A new saved layout icon will appear on the toolbar with the same name as your template. When you select that icon, the Report window automatically uses the saved template layout to display your report.

View Report Mode

Selecting the Report Mode icon generates the report from the first command to the last command in the part program, regardless of how PC-DMIS last executed the program.

View Last Execution Report Mode

Selecting the Last Execution Report Mode icon will show only those items executed in the most recent part program execution. It also shows the commands in the same order in which they were executed. If commands were executed multiple times due to a loop, it would show those multiple executions as well. The information will only stay in this report as long as the part program remains open. If you close your part program, PC-DMIS clears this report.

Set the Report Magnification

Selecting an item from this drop down list sets the report's magnification in the Report window. The zoom level doesn't affect how the report prints out, but you may find these options helpful when previewing the report or determining what template to use.

  • For small percentages, the pages are laid out side by side horizontally first and then vertically. You can also type in a specific magnification. Using a small percentage makes it easier to rearrange pages. See "Rearranging Report Pages".

  • For large percentages, where you are zoomed in on one portion of the report, you can easily pan the report by either using the scroll bars or by holding CTRL and dragging on the main page of the report (dragging on a label will move that label). PC-DMIS drags the image in the direction that you pull the mouse.

Selecting the Lock the Report icon locks the Report window so that modifications can't be made to any reports in the window. PC-DMIS shows the icon as "pressed" to indicate it is locked:

In addition, with the window locked, the mouse pointer changes to this symbol whenever you move the mouse over the window to indicate that the report is in a locked state and cannot be modified:

You can still scroll, print, and view items in the report window, but you cannot make any modifications to any report until you unlock the window by clicking the icon again.

View Last Execution Report Mode

Standard report layouts that come with PC-DMIS and any custom saved report layouts are shown to the right of the Lock the Report icon. Simply click on them to immediately switch your report between frequently used templates. To remove one of your custom saved layouts, hold down the SHIFT key and then use your mouse to drag the icon off of the toolbar.

Note: The Reporting toolbar only resides within the Report window. You cannot select it from the toolbar area of the main PC-DMIS interface.


Using Tooltips in the Report Window

Example report showing a tooltip with the name of the label being used

By simply moving your mouse over different parts of the Report window, you can get information in the form of a tooltip about what label is being used, or if there is no label, the tooltip will display either the name of the object or the current page number.

  • If the object is a label, the tooltip displays the label template file name.

  • If the object is not a label, for example, if it's a TextReportObject or a CadReportObject, the tooltip displays the object name that is defined in the report template.

  • If you hold the mouse over an empty space on the page, (technically the Page object), the tooltip displays the page number.

These tooltips provide you with a simple way to find out what objects are being used in the report.


Changing the Report Window's Contents

Hint: See the "Shortcut Menus in the Report Window" topic for a list of functions you can quickly and easily access to perform some of the modifications discussed in this topic and its subtopics.

While you can permanently change how and what information appears in your Report window by modifying the underlying templates and the rules used, you can also perform modifications to the objects on a Report window directly within the Report window by using the information provided in these topics below.

More:

Edit Text Reporting

Edit Label Reporting

Edit Label Positioning and Size

Edit CAD Model Reporting

Changing Label Templates on the Fly

Removing Report Window Modifications


Edit Text Reporting

For additional information on this shortcut menu, see the " Shortcut Menus in the Report Window " topic from the " Using Shortcut Keys and Shortcut Menus: Introduction " section.

Unilateral Percentage:

Nominal: 0.0000

Measured:0.0028

Deviation:0.0028

Plus Tol:0.0050

Minus Tol:0.0000

Because this deviation is 56% of the tolerance range, it will be displayed if Unilateral Percentage is less than 56%.

Bilateral Upper Percentage:

Nominal:3.0000

Measured:3.0075

Deviation:0.0075

Plus Tol:0.0100

Minus Tol:0.0100

The percentage is calculated using the Lever Rule:

(measured value – lower limit) / (upper limit – lower limit) * 100.

With this data, it would be:

(3.0075-2.9900) / (3.0100-2.9900) * 100. = 87.5%

This dimension will be displayed in the inspection report if the Bilateral Upper Percentage is greater than 87.5%.

Bilateral Lower Percentage:

Nominal: 3.0000

Measured:2.9925

Deviation:0.0075

Plus Tol: 0.0100

Minus Tol:0.0100

The percentage is calculated using the Lever Rule:

(measured value – lower limit) / (upper limit – lower limit) * 100.

With this data, it would be:

(2.9925-2.9900) / (3.0100-2.9900) * 100. = 12.5.%

This dimension will be displayed in the inspection report if the Bilateral Lower Percentage is less than 12.5%.

Sample Report with "Use Text Mode Dimension Reporting" Selected:

Sample Report with "Use Text Mode Dimension Reporting" Not Selected:

Edit Text Reporting

Report dialog box

Report dialog box

The Report dialog box (available with template reporting) lets you determine the overall information that PC-DMIS will include in the Report window and how it should be displayed. You can access this dialog box in a these ways:

  • Right-click on any text-only reporting text or white space at the end of the Report window and then select the Edit Object... menu item when the shortcut menu appears.

  • Press SHIFT and then right-click on any label object in the Report window, and then select the Edit Object... menu item.

The following check boxes let you show or hide various items:

Show Features | This option displays all feature measurements in your part program. If you are using the default report template, textonly.rtp, and your part program measures a feature with more than the minimum number of points, it also displays a form plot of the feature.
Show Alignments | This option shows alignment changes as they occur during the part program. It will display all alignment changes that occur in the dimension or feature lists.
Show Comments | This option shows any comments that have been added to the part program. (See "Inserting Programmer Comments" in the "Inserting Report Commands" section for additional information.)
Show Header / Footer | This option displays a header and footer in your report by applying the label template defined in the File Header rule of the Rule Tree Editor. By default this is the FILE_HEADER.LBL label template that ships with PC-DMIS.
Show Screen Captures | This option displays any graphics related to DISPLAY/METAFILE and ANALYSISVIEW commands in the report. (See "Using Screen Captures of the Graphics Display Window" in the "Editing the CAD Display" section.)

The Dimensions area allows you to control the display of dimensions in your reports. To display dimensions, select the Show check box. Once selected, the other items in this area become available for selection. These include:

All

Selecting this option acts just as if you had selected both the Out of Tolerance Only and the Dimensions Outside Limits options.

Out of Tolerance Only

If this option is marked, PC-DMIS will only show the out of tolerance dimensions. ("Show Dimensions" must be ON.)

This option is only available when you select Show Dimensions and deselect Show Dimensions Outside Limits.

Dimensions Outside Limits

If you select this option, PC-DMIS will only show the dimensions that lie outside the percentage of the tolerance zone.

When you select the Show Dimensions Outside Limits check box, the tolerance percentages will become editable, allowing one percentage for unilateral tolerances and an upper and lower percentage for bilateral tolerances.

The tolerance zone can be considered as a range between 0 and 100 percent (similar to how dimension colors are applied to tolerance zone regions or how the colored bar graphs are drawn at the end of dimensions). The lower limit (nominal - minus tol) corresponds to 0% and the upper limit (nominal + plus tol) corresponds to 100%. Consider the following chart where A, on the center of the chart, represents the nominal value:

Chart

Dimensions that have deviations outside the tolerance zone will either be less than zero or greater than one hundred percent.

For a unilateral dimension (like roundness, which only has a plus tolerance), the zero deviations are at zero percent, and out of tolerance is anything larger than one hundred percent.

Unilateral Example

For a bilateral dimension (like distance, which has both a plus and minus tolerance), the zero deviations are somewhere in the middle. If the tolerances are equal, the zero deviations will be at the fifty percent position.

B ilateral Upper Example

B ilateral Lower Example

Use Text Mode Dimension Reporting

This check box determines whether PC-DMIS uses formatted text (selected) or uses a graphics table (not selected) for displaying the dimensions.

Important: If PC-DMIS cannot find a specified report template, it will end up using a template named "default.rtp". This generic template provides you with a basic text-based report. Since default.rtp only supports text-based reporting, deselecting this check box will do nothing


Edit Label Reporting

If you right-click on a label and click Edit Object..., the Label Properties dialog box appears.

Label Properties dialog box

Label Properties dialog box

With this dialog box you can change the order of columns and rows, or you can control the visibility state of individual columns and rows.

To change the order - Select a row or column, then click the black up or down arrow.

To hide or show an item - Clear the check box next to the item to hide it. Select the check box to display it.

Once you have made the desired modifications to the label, select one of the option buttons at the bottom to apply the changes to the current label, all similar labels on the current page, or all similar labels in the entire section.

Determine what the label will do whenever you hide or show columns, by selecting an item from the Resize Type list. This list contains these items:

Resize Grid - This retains existing column sizes and resizes the label to fit the new width.

Resize Columns to Fit - This retains the label's existing width and resizes each column equally to fit the existing width.

Hide Text - This doesn't resize the label or the columns. It simply hides the text.

Click OK and PC-DMIS will change the display.


Edit Label Positioning and Size

If your label has leader lines or it is a free label (it isn't part of a TextReportObject), if you press CTRL and then click on a label (or if you drag the mouse to box-select a label), you will see that it becomes selected. Once selected, you can drag it to a new location or re-size it by clicking and then dragging the black square handles that surround the selected label.


Edit CAD Model Reporting

If you double-click on any CADReportObject, it becomes "active". This means you can rotate or zoom the CAD model to how you like it just as you can inside the Graphics Display window. Click outside of the CADReportObject to use the new orientation and zoom level. See "CadReportObject" for information on this.

If you right-click on a CADReportObject in the Report window, and select Edit Object..., PC-DMIS displays the Label Layout Wizard allowing you to quickly modify label positions and the CAD model's location directly within the Report window. See "The Label Layout Wizard" topic under the "CadReportObject" for information on how to use this wizard.

You can size and move the CADReportObject as described in "Edit Label Positioning and Size".


Changing Label Templates on the Fly

PC-DMIS provides you with a way of changing on the fly a label template used in a report.

Changing a Single Label Template

From the Report window, select the label template and then right-click on it and select the Change Template... menu item. You can then select the new template to use from the Open dialog box.

Changing Multiple Labels on the Same Page

To select and replace multiple labels on the same page, hold down CTRL, select multiple templates, and then select the Change Template... menu item. Alternately, you can choose Select Matching Labels to choose all the labels in a CADReportObject that use that same label and are on the same page.

Changing Multiple Labels Across Multiple Pages or Sections

To select and replace some or all the labels associated with a CADReportOject across multiple pages or sections, right-click on the CADReportObject and choose the Select Labels... menu item, use the dialog box to select the desired label template items based on feature type or dimension type, and then select the Change Template... menu item.

The Select Labels dialog box dialog box contains a drop-down list near the top that can limit the labels displayed in the dialog box and a box below it that displays the available dimensions for selection.

Select Labels dialog box

All Commands - This displays all the labels associated with the CADReportObject for all the displayed features and dimensions.

Feature Type - This displays the different feature types used. Selecting a feature type category and clicking OK will select all the underlying labels associated with that feature type and displayed in your CADReportObject.

Command Type - This displays the different dimension commands used. Selecting a dimension command type and clicking OK will select all the underlying labels associated with that dimension command type and displayed in your CADReportObject.


Removing Report Window Modifications

To quickly remove modifications that you have made to a report object (a TextReportObject, CADReportObject, or Label object), right-click on the desired object, and select the Remove Object Modifications menu item. PC-DMIS will return the report object back to its default state.

To quickly remove all object modifications on a report template select the File | Reporting | Clear Template Associated Data menu item.


Using Standard Reports

The default standard report template, TEXTONLY.RTP, is really nothing more than a simple template that plugs measurement data into a TextReportObject to mimic how text-based reports appeared in previous versions of PC-DMIS.

Report Window showing a standard, text-based report

If the default standard report template doesn't work for you, PC-DMIS also ships with additional standard report templates that you may find useful. You can easily change the layout used for the current report by clicking the appropriate icon from the Reporting toolbar.

  • TEXTONLY.RTP: the TextReportObject with some standard labels included.

  • CADONLY.RTP: the CadReportObject with some standard labels included in portrait layout. Since this template supports fewer labels than CADONLY_LANDSCAPE.RTP (up to 10), the labels are larger and more detailed.

  • TEXTANDCAD.RTP: the TextReportObject and the CadReportObject with some standard labels included.

  • GRAPHICALANALYSIS.RTP: This template uses the Analysis Object to provide you with a graphical analysis of each form dimension (such as Flatness, Roundness, and so forth) sent to the report. It will not show an analysis for non-form dimensions. PC-DMIS will graphically display the deviation of each individual hit for the dimensions used. The report displays the error in the form of individual arrows for each hit. These arrows, with their colors and directions, indicate the relative size of the error, as well as its direction.

  • CADONLY_LANDSCAPE: Similar to CADONLY but displays in landscape layout. Since this template supports more labels than CADONLY.RTP (up to 30), the labels are smaller and less detailed.

  • PPAP: This template produces a report that can be used in Production Part Approval Process (PPAP). If this report template doesn't readily appear, you may need to manually apply it. See "Applying or Removing a Report Template" for information on how to apply a new template.

These templates exist in the Report Templates dialog box (or the Reporting sub-directory) by default. See "Applying or Removing a Report Template" for information on using this dialog box.

Note: If you load a part program that uses a report template that does not exist in the specified reporting directory nor in the directory where you installed PC-DMIS, then PC-DMIS will generate a text-only report template on the fly called "default.rtp". This allows you to always see a report in the Report window even if you don't have the specified report template. Remember, default.rtp only displays information in a text-only format. This means you cannot deselect the Use Text Mode Dimension Report check box in the Report dialog box. See "Changing the Report Window's Contents" for information on that dialog box.


Viewing a Legacy Text Only Report

Report Window Showing a Legacy Report

This topic discusses how you can get a legacy (old style) text only report to show up in your Report window in version 4.x and above. This report type was used in versions 3.7 and earlier. Note that you should only use legacy dimensions in your part program if you go this route.

  1. Select View | Report Window to access the Report window. Display Menu Roadmap

  2. Select the Template Selection dialog icon [image] from the Reporting toolbar. The Report Templates dialog box appears.

  3. Click Add and select default.rtp. This is a catch-all, truly text-only, default report template which PC-DMIS falls back on and uses if a part program tries to load a template that isn't on the computer system.

  4. Click Open to add the template into the Report Templates dialog box. Select the template inside the Template Selection dialog box and click Open. PC-DMIS loads the default.rtp template into the Report window.

  5. Click the Add Template To Toolbar icon [image] from the Reporting toolbar. The saved template now appears on the toolbar. So if you only want to load the legacy report only sometimes, you can simply click on the appropriate stored report template icon [image] to load it. If you want it to load this template every time you open up the current part program, you can click the Set this report as the default report icon.

  6. This step is optional. If you will be modifying the finished report inside an RTF editor, you may want to change how RTF files are converted. In the PC-DMIS Settings Editor, expand the Printing section and set DoNotUseAmyUniRTF to 2. Click Save Setting and then click OK. This will make the text for the report print out to RTF files like they used to in 3.7 and before. If this is set to 0 (the default) characters show up inside of text boxes.


Rearranging Report Pages

PC-DMIS provides you with a drag-and-drop approach to rearranging pages in the Report window. To rearrange pages use this procedure:

  1. Size the report magnification to where you can view the pages you want to rearrange, probably somewhere around 25%.

  2. Hover your mouse over any report page. Notice that at the top left of the page a cross-hair icon appears.

  3. Drag the cross-hair icon to drag the current page.

  4. Drag the page on top of an existing page. The target page receives a red highlight and the mouse cursor changes.

  5. Release the mouse. PC-DMIS will arrange the ordering of the report pages according to the direction in which you dragged the report page.

  • If you drag and drop the page to a page earlier in the existing page sequence, the page will be inserted before the page on which it was dropped.

  • If you drag and drop the page to a page later in the existing page sequence, the page will be inserted after the page on which it was dropped.

Example: Suppose you have a sequence of seven pages in your report: p1,p2,p3,p4,p5,p6,p7. If you drag p4 and drop it at p2 (earlier in the sequence), the order will be p1,p4,p2,p3,p5,p6,p7. If you then drag p4 and drop it at p5 (later in the sequence), the order will be: p1,p2,p3,p5,p4,p6,p7

  6. Continue rearranging pages as needed.

See a brief demo on this functionality.


Modifying Standard Templates

You may want to modify the standard reporting and label templates that ship with PC-DMIS. Report or label template files that ship with PC-DMIS are protected with a read-only attribute to prevent any inadvertent modification.

You should make a copy of the Reporting sub-directory and store it in a safe place before modifying them. Then you can easily restore something if your changes happen to cause problems.

Removing the Read-only Attribute

  1. Using Windows Explorer, open the Reporting sub-directory, and navigate to the report or label template you want to modify.

  2. Right-click on it, and select Properties from the menu. The Properties dialog box appears.

  3. Near the bottom of the dialog where it displays Attributes, deselect the Read-only check box.

  4. Click OK. You can now modify your report or label template inside its respective editor.

Changing Properties

To change properties in your report, select the appropriate object in the template editor, right-click on it, and modify its properties in the Properties dialog box. See "About Object Properties".

To change your report's header, see "Modifying your Report's Header".


Modifying your Report's Header

Example showing the button to use to change the report header's graphic

Modifying the Report's Header

Many users want to change the header in some way, usually to modify the default graphic that appears in the default report's header to something more company-specific. You can change the header graphic by following this procedure. You can change other information by similarly modifying the appropriate templates.

Your report template (by default this is TEXTONLY.RTP) calls a label template to display the header information (by default this is FILE_HEADER.LBL). So, this is the file you will need to modify.

  1. Remove the Read-only attribute from the template file.

  2. Open the file in the Label Template editor.

    • Select File | Reporting | Edit | Label Template. An Open dialog box appears.

    • Select the FILE_HEADER.LBL template and click Open.

    • In the Label Template Editor you should now see the edit area filled with a GridControlObject. This object controls all the header data that you see in the report.

  3. Change the graphic.

    • Double-click on the GridControlObject. You will see a hash border around the object. This tells you that you can edit the code or items inside of the header.

    • Right-click on the PC-DMIS graphic and a Grid Properties dialog box appears.

    • In the Cell tab, click Select. An Open dialog box appears.

    • Navigate to the graphic image you want in the header, select it, and click Open. The dialog box closes.

    • Click Apply. The new graphic appears in the cell.

  4. Save and test the modified label template.

    • Once you have things as you like it, click OK, and then select File | Save to save your changed Label Template.

    • Select File | Close to close the Label template editor, returning to your part program.

    • Select View | Report window. If your change doesn't immediately appear, select the Redraw the report icon from the Reporting toolbar.

Converting LOGO.DAT, HEADER.DAT, and ELOGO.DAT Keywords

In versions prior to 4.0, these .DAT files contained # keywords that defined the information that would appear in your report's headers and footers (see "Modifying Headers and Footers" in the "Using the Edit Window: Introduction" section). In versions 4.0 and later, PC-DMIS uses Report Expressions to accomplish the same thing. The following table details the Report Expression—or where applicable the report object—to use and where to use it.

.DAT # Keyword | Functionality | Equivalent Command in Report Template
#DATE | Inserts the current date. | =SYSTEMDATE("MMMM dd, yyyy")
#TIME | Inserts the current time. | =SYSTEMTIME("HH:mm")
#PAGE | Inserts the current page number. | =Page()
#TRn | Inserts the value of trace field n, where n is the trace field number. | =TRACEFIELD(n)
#PARTN | Inserts the part program name. | =PARTNAME( )
#DRWN | Inserts the revision number. | =REVNUM()
#SERIALN | Inserts the serial number. | =SERNUM( )
#SEQUENCE | Inserts the sequence number. | (Not applicable)
#SHRINK | Inserts the scale factor. | =MEASSCALE()
#NMEAS | Inserts the total number of dimensions. | =NUMMEAS()
#NOUT | Inserts the total number of dimensions that are out of tolerance. | =NUMOUTTOL()
#ELAPSTIM | Inserts the time elapsed between start and end of execution. | =ELAPSEDTIME()
#BMP=bitmappath | Inserts a bitmap of the specified full path and name. | Use Bitmap object

See "About Report Expressions" for using other expressions in your report templates.

See "Displaying a Variable's Value" for limitations on using variables inside report headers.


Changing the Report's Text Colors

At times you may want to modify the default text colors used in your report. To change these text colors, access and modify the Color Editor dialog box for your report template's TextOnlyObject:

Remember, if you're modifying one of the standard report templates that ships with PC-DMIS, ensure that you have first cleared the read-only flag for the file. In Window's Explorer, Right-click on the report template file, select Properties, and then clear the Read-Only check box.

  1. Select File | Reporting | Edit | Report Template Display Menu Roadmap .

  2. Select the report template for which you want to change the colors.

  3. In the Report Template editor, select the TextReportObject, and right-click on it to access the Properties dialog box for that object.

  4. Select the Colors property from the Properties dialog box.

  5. The Color Editor appears. This is the same editor as used for the Edit window, but in this case it modifies the TextOnlyObject used in your report template. For information on how to use the Color Editor, see "Defining Edit Window Colors" in the "Setting Your Preferences" section.

  6. Make your changes, and then save the template.

  7. Load the template into the Report window.


Adding Notes to a Report

It's often useful to add your own notes to a report after it has executed. One way to add notes is to use PC-DMIS's standard Comments functionality and allow those to be displayed in the Report window. But this approach has some limitations. Displaying comments really only works on report templates that use the TextReportObject. Besides, standard Comments aren't, by default, very visible, and they only appear within the TextReportObject at the location they were executed. In addition, you aren't able to easily edit them after they're on the report. See "Comments" in the "Using the Edit Window" section.

However, if you want more flexibility, consider the option of adding a note box into which you could type your notes directly onto the final Report. This following steps provide you with a procedure on how to do this:

Step 1: Create the Note Box

To create a note box, create a new label template inside the Label Template Editor, and drag a Text object onto the editing area. Format the object with font size, font color, background color and borders as desired. If you want your note box to be transparent, select the NIL background color. Set the object's Text property to hold this value: "Right-click here and select Edit Object to modify this note text." Save your label template.

A new label template named notes.lbl

Step 2: Tie the Note Box onto the Report Template

Open up a report template inside the Report Template Editor that you can edit. Drag a Label object onto the editing area, and position it generally where you want the note box to appear. You can change its final position in the Report window.

A label object added onto a TextAndCad Report

Step 3: Tell PC-DMIS When to Display the Note Box

Right-click on the label object to access its properties, and then click Rules to bring up the Rules Tree Editor. The new label object does not yet have any rules. Add a rule for the Default item at the top of the tree, and have the rule pull in the label template you saved in Step 1. This will cause the label template containing your note box to show up on every page of the report. Save your changes.

A rule specifying to load notes.lbl assigned to the Default item

Step 4: Test the Report

Access the Report window and load in your modified report template. Notice that your note box appears with the instructions on how to change its default text. Double-click to activate the object and drag it to a new location if desired.

A note box with default text

Step 5: Modify the Note Box Text

To change the text in the note box, right-click on the object and select Edit Object. A Label Properties dialog box appears.

The Label Properties dialog box

Type your new note text in the Change to: box and click OK. PC-DMIS updates your text.

A note box with updated text

And that's all there is to it. Of course, you can modify the note box to better suit your needs. For example, if you wanted a table-like structure in your note box, on Step 1, instead of a single text object in the label template, you could add in a GridControlObject into the label template and then overlay the cells with Text objects.

If you wanted to only show the note box based on certain conditions you could change the rules used in the Rules Tree Editor in Step 3. For example, if you only wanted the note box on the first page of your report, you would use the File Header item instead.


About the Common User Interface

About the Reporting and Form Editors

The Report Template Editor, Label Template Editor , Custom Report Editor, and Form Editor are used to modify existing or create new, templates, custom reports, or forms. These editors share many of the same common user interface elements: the menu bar, the toolbars, the object bar, and so on. While the individual icons or items on these menus may change between editors, the look and feel is essentially the same.

The user interface is discussed in the following topics.

More:

The Menu Bar

The Font Bar

The Object Bar

The Layout Bar


Menu Bar for the Report Template, Label Template, and Form Editors

File | New - Creates a blank template or form.

File | Open - Opens a previously stored report template file or form.

File | Close - Closes the template editor or form.

File | Save As - Saves the current template or form with a new file name.

File | Edit / File | Run - Lets you toggle between the editor's two modes: Edit Mode and Run Mode. Run mode lets you "run" or test a form. Edit mode lets you modify a template or form. (Run mode only works with the Form Editor; it does exist in the Report or Label template editors.)

File | Exit - Exits PC-DMIS. If you have unsaved changes, PC-DMIS will display a message box asking if you would like to save them.

Edit | Layout | Align Objects, Space Evenly, Center in View, Make Same Size - These submenus lets you layout, align, and space objects in the editor. See the "Layout Bar" for additional information.

Edit | Layout | Properties - Displays the property sheet for the currently selected object. If no object is selected, this displays the property sheet for the editing area (called a "Section" or "The Frame/View"). See "Property Sheet" and "About Sections".

Edit | Layout | Check Mnemonics - This menu item ensures that any shortcut keys using the ALT key plus a letter are unique on form or template items that have a text display (such as buttons).

To define a shortcut key for a form or dialog box control, type an ampersand symbol (&) before the character. For example, a button with the text label of "&Continue", would look like "Continue" on the form and would be accessible with ALT + C.

Edit | Layout | Grid Settings - Displays the Grid Settings dialog box. This dialog box lets you display or hide a grid of points on your layout's background. See "Working with the Grid".

Edit | Layout | Objects - Displays the Object Sheet dialog box. Use this dialog box to view or select the objects in the Form and to set their tab order. See "Object Sheet". (Only available in the Form Editor.)

Edit | Order - This submenu lets you move objects behind or in front of other objects that overlap each other.

Edit | Undo - Lets you undo the last action taken in the editor.

Edit | Redo - Lets you redo the last undone action.

Edit | Cut - Cuts the object and stores it for pasting.

Edit | Copy - Copies the object and stores it for pasting.

Edit | Delete - Deletes the selected objects.

Edit | Paste - Pastes the cut or copied object. If from a copied object this often this pastes the object right on top of the copied object, so you will need to drag it to a new location or else it will overlap the object from which it was copied.

Edit | Paste Special - This differs from the standard Paste menu item since it allows you to maintain a link between the pasted item and the source from which it was copied so that if the source changes, the pasted item will also get updated. For Example:

Edit | Set Tab Order - This lets you determine the objects that get selected when a user presses TAB to cycle through objects in Run Mode. (This only works in the Forms Editor.)

Edit | User Assigned Properties - Accesses the User Assigned Properties dialog box, allowing you to manage all your user assigned properties at once. See "Working with User Definable Properties". (Only available in the Report Template Editor.)

Object Sheet dialog box

Object Sheet dialog box

Suppose you want to place a Microsoft Excel chart object in your Hyper Report and you want to keep the chart's data in synch with the data from the Excel file. To do this:

1. In the Microsoft Excel file, copy the chart object.

2. Access your template or form.

3. Select Edit | Paste Special. The Paste Special dialog box appears.

4. Select the Past Link option.

5. Click OK. The chart object appears in your template or form.

Now, if you make changes to the data for your chart object in your Excel file, PC-DMIS will update the chart object in the report or form.

View | Graphics Display Window, Edit Window, Preview Window, Form Editor, Marked Sets Window, Basic Script Editor, Inspection Report, Probe Readouts, Probe Toolbox - Shows or hides these PC-DMIS windows or editors. Most of the time these do not serve any purpose when working in the editor and you can hide them.

View | Object Bar - Displays the editor's Object Bar. See "Object Bar".

View | Layout Bar - Displays the editor's Layout Bar. See "Layout Bar".

View | Font Bar - Displays the editor's Font Bar. See "Font Bar"

View | Ruler Bars - Displays the rulers on the top and left sides of the editor. See "Toggle Ruler"

View | Snap Points - Displays the "snap points" for any of the objects in the editor. See "View Snap Points"

View | Route - This only functions with snap points. On complex pages with a lot of objects, you may find it useful to use the this menu option to see the chain of objects connected to the currently selected object via snap points. This menu option selects all objects connected in some way by snap points to the currently selected object. (Only available in the Form Editor.)

This menu lets you perform standard window manipulations with any of the windows in PC-DMIS. See the "Navigating and Displaying Multiple Windows" section.

Help | Index - Accesses the PC-DMIS Help file.

Help | Using Help - Displays a topic about using the Help file.

Help | About PC-DMIS - Displays the About PC-DMIS dialog box, showing information about your version of PC-DMIS.

Menu Bar for the Form and Reporting Editors

File menu

Edit menu

View menu

Windows menu

Help menu


The Font Bar

The editor's Font Bar lets you modify frequently modified font, color, background or line properties for various objects.

Font Bar Item | Description
 | Changes the object's font if it supports text. Identical to setting the Font property.
 | Changes the object's font size if it supports text. Identical to setting the Font property.
 | Displays your object's text in boldface. Identical to setting the Font property.
 | Displays your object's text in italics. Identical to setting the Font property.
 | Aligns your text to the left side of your object, directly in the center, or to the right side. Identical to setting the Alignment property.
 | Sets the background and foreground colors of your object. Foreground sets any text and border colors. Identical to setting the BackColor and Forecolor properties.
 | Sets the border or line's width. Clicking this multiple times switches between various options. Identical to setting the LineWidth property.
 | Sets the style of a line (does not apply to borders). Clicking this multiple times switches the line style between a solid line and various dotted lines. Identical to setting the LineStyle property.
 | Places arrowheads at the end or ends of a Line object. Clicking this multiple times switches the arrow to different locations on either or both ends of the line. Identical to setting the Arrowhead property.
 | Sets a background pattern, called a "hatch style", on an object that supports hatch styles. Clicking this multiple times switches between the available hatch styles. Identical to setting the HatchStyle property.
 | Sets a shadow under the object, on objects that supports shadows. Clicking this multiple times switches between the available shadow styles. Identical to setting the ShadowStyle property.


 Bitmap Object Analysis Object Pointer Ojbect OLE Object Label Object GridControlObject Dimension Color Key Object TextReportObject CADReportObject ActiveX Object Graph Object Gauge Object Ellipse Object Arc Object Pointer Object Text Object Line Object Leader Line Object Border Object Pointer Object Text Object Graph Object OLE Object TextReportObject ActiveX Object Gauge Object Pointer Ojbect Ellipse Object GridControlObject Bitmap Object Leader Line Object Border Object Arc Object Line Object Analysis Object Dimension Color Key Object Bitmap Object Pointer Ojbect OLE Object Label Object Label Object GridControlObject CADReportObject ActiveX Object Graph Object Gauge Object Ellipse Object Arc Object Pointer Object Text Object Line Object Leader Line Object Border Object Label Object Label Object Label Object Spinner Object Slider Object Multi Edit Box Object Edit Long Box Object Edit Box Object Edit Double Box Frame Object Ellipse Object Arc Object Gauge Object Pointer Ojbect Bitmap Object ActiveX Object Border Object OLE Object OLE Object TextVar Object Line Object Leader Line Object Text Object Pointer Object Check Button Object Button Object Graph Object List Box Object Combo Box Object Radio Button Object

A sample Text object showing handles

The Object Bar

The Object Bar is a toolbar that lets you insert various objects into a template or objects and controls into a form. You can insert text, pictures, multi-media, dialog box controls, special PC-DMIS specific objects, and other items to help you create custom labels, reports, and forms.

This bar appears whenever you enter an editing environment such as the Report Template Editor, the Label Template Editor, the Custom Report Editor, or the Form Editor.

The Object Bar comes in one of these types, one for each editing environment:

Report Template Editor | Label Template Editor | Custom Report Editor | Form Editor
Click on object icons in an Object Bar above to view information about that object.

Adding Objects:

To add an object to a template, custom report, or form:

  1. Inside the appropriate editor, access the Object Bar.

  2. Click on the object you want to insert into your report.

  3. Next, hold down the left mouse button and drag a rectangle on your current section.

  4. Finally, release the mouse button.

  5. Upon creation, the object is selected, as shown by small green squares, called handles, at each corner of the object.

Selecting and Manipulating Objects:

To manipulate an object you have to first select it. To select an object, click on the object so that the green handles are showing.

To drag an object to a new location - Select the object. Click and hold the mouse on top of the object, then drag it to the new location. Release the mouse.

To resize an object - Select the object, move your mouse over one of the green handles until it changes to a resize cursor, a line with two arrows. Then click on the handle and drag the mouse to a new location. Release the mouse. The object expands or shrinks.

To change an object's properties - Select the object, right-click on the object so that the Properties dialog box appears. Select properties and change them as desired.

To align, group, ungroup, and perform other operations - Use the Layout Bar or the Edit | Layout and Edit | Order submenus.

Coding Objects to Change Dynamically

For some objects, you can use BASIC scripting to dynamically change certain properties of those objects. For example, you could use code to automatically populate plotted points on a Graph object, or you might want to use the Gauge object like a bar graph of some sort. For an example of how to do this, see the topic, "Example of Using BASIC Scripting to Dynamically Change the Gauge's Value"


ActiveX Object

The ActiveX Object inserts an ActiveX control into your template or form. Once inserted, a dialog box titled Insert OLE Control will appear.

Insert ActiveX Control dialog box

Insert ActiveX Control dialog box

This dialog box allows you to select the type of control to be inserted from a list of known controls on your computer. The controls in the Object Type list are unique to each computer, based on the programs installed, etc. ActiveX controls expand the possibilities of what you can do in a form or template. For example, you could insert a chart control and then with Visual BASIC code, pass part program data to dynamically create the chart.

PC-DMIS ActiveX Controls

PC-DMIS ships with ActiveX controls most of which are related to feature analysis. The feature analysis controls appear in certain cells of the GridControlObject on some of the standard labels that come with PC-DMIS. In general, the software uses these controls to display graphical analysis information. You can insert these into your own templates or forms from the Insert ActiveX Control dialog box.

The PC-DMIS ActiveX controls related to feature analysis are:

Control | Graphical Example
BFANALYSISACTIVEX | Click for Expanding Graphic
DIMANALYSISACTIVEX | Click for Expanding Graphic
Dimension Report Linear | Click for Expanding Graphic
Dimension Report Linear2 (Surfer NT Style Control) | Click for Expanding Graphic
Dimension Report Radial | Click for Expanding Graphic
FeatureAnalysisActiveX | Click for Expanding Graphic

The PC-DMIS ActiveX controls not related to feature analysis are:

Control | Description
DataFileFormatControl | Allows the interpretation of .dat files (logo.dat, elogo.dat and header.dat) in your template based reports. See "Some PC-DMIS ActiveX Controls" and "Reporting Using .DAT File Keywords".

As with any other object, the PC-DMIS ActiveX object also contains properties, both standard and unique, that you can modify using the Properties dialog box. The topic below contains information on accessing those properties.

More:

Accessing an ActiveX Object’s Methods and Properties from Basic


Accessing an ActiveX Object’s Methods and Properties from Basic

If you have added a control, for example, an ActiveX calendar control and called it MSCAL, you can access its events and properties through the property sheet just like any other object. In this case, since it is an ActiveX object, a new section of properties will appear called ActiveX. It contains a user-accessible list of variables and properties with their default values.

To set properties for the ActiveX control inside the VBS Mini-Editor for an event handler, type the name of the control, in this case, "MSCAL." (with the period). A window appears allowing the variables and methods to be accessible. Select the "X" from the list. Another popup window will appear listing a set of internal editable variables for the ActiveX control.

See "Using PC-DMIS ActiveX Controls" for information on the properties of the different PC-DMIS ActiveX controls.


Arc Object

The Arc object inserts an elliptical arc into the template or form. A default arc doesn't have a fill color and has a beginning angle of 0 degrees and an ending angle of -90 degrees.

Along with the ability to resize the object, add a fill color, add a border color, and change other attributes, the following editable properties are included for arc objects:

Property | Description
PenWidth | This sets the border width in pixels.
PenStyle | This changes the arc's border style to Solid, Dash, Dot, Dash-dot, and Dash-dot-dot.
Angle1 | This number sets the start angle for the arc. The default is 0 degrees.
Angle2 | This number sets the end angle for the arc. The default is -90 degrees.
IsWedge | If set to NO (the default), PC-DMIS draws a filled arc without a wedge, like this: If set to YES, PC-DMIS draws a filled arc with a wedge like this:


Analysis Object

The Analysis object is used to insert a PC-DMIS analysis window into a label template. Then, in the Report Window, PC-DMIS will display a graphical analysis of dimensions that use a report template using the label template with an analysis object in it.

Important: The analysis object will only function with Feature Control Frame dimensions and will not function with Legacy dimensions.

Manipulating the Object

In version 4.1 and above, you can double-click on this object to activate it in the Report window. This lets you manipulate its display in the Report window on the fly. Once activated, you can zoom in or out on the object's graphical display and change its rotation. Double-clicking outside of the object deactivates it. You can also right-click on the object in the Report window to access its the Graphical Analysis Options dialog box described below.

Changing Properties

To determine what this object will display you can modify its many properties. You can also use the (Settings Dialog) property to access the Dimension Analysis Options dialog box inside the template editor. This dialog box lets you quickly and easily set many of the analysis object's properties.

Dimension Analysis Options dialog box

This dialog box is nearly identical to the dialog box already discussed in the "Dimension Options" topic in the "Inserting Report Commands" section. See that topic for information on most of the dialog box options.

One exception is the Show Border check box. This option functions only with an Analysis object, not with the Analysis window. Selecting this check box draws a border around the Analysis object.

The available properties for this object are listed below:

Property | Description
(Settings Dialog) | Displays the Graphical Analysis Options dialog box for the selected Analysis object.
ArrowHeads | Same as the Show Arrow Heads check box in the dialog box.
BackColor | Common Properties
BorderShow | Shows or hides the Analysis object's border.
Bottom | Common Properties
CircularityMaxMinDiameters | Same as the Show Best Fit, Max Inscribed, and Min Circumscribed Diameters check box in the dialog box.
Left | Common Properties
MaxMin | Same as the Show Max/Min Deviations check box in the dialog box.
MultShow | Show or hides the arrow multiplier value as text on the Analysis object. So, if set to YES and you have a multiplier value of 10, it would display "MULT=10."
ProfileMeasured | Same as the Show Lines Between Measured Hits check box in the dialog box.
ProfileNominal | Same as the Show Lines Between Nominals check box in the dialog box.
ProfileOptions | Same as selecting one of the option buttons from the Profile Dimensions area in the dialog box.
ProfileTolerances | Same as the Show Tolerance Lines check box in the dialog box.
Right | Common Properties
Top | Common Properties
TPDiameters | Same as the Show Diameters check box in the dialog box.
Enable | Common Properties
Visible | Common Properties


Border Object

The Border object inserts a rectangular border into the template or form. Along with the ability to resize the object, add a fill color, add a border color, and change other attributes, the following editable properties are included for border objects:

Property | Description
PenWidth | This sets the width of the object's border in pixels.
HatchStyle | This sets the type of pattern (or hash) to use to fill the resulting polygon. Available patterns are: Horizontal Vertical Diagonal Reverse Diagonal Cross Diagonal Cross
ShadowStyle | This sets the location of the 3D shadow on the resulting polygon. Available locations are: Top/Left, Bottom/Right, or None.
HiliteColor | This sets the color used for the BorderStyle property.
BorderStyle | This sets the 3D highlight style of the object's border. Options include Normal, 3D, Sunken and Raised.


Bitmap Object

The Bitmap Object allows you to insert a pre-created bitmap graphic into your template or form. When you click this icon, a dialog box appears.

Bitmap Dialog

  • The OK button allows you to insert a bitmap loaded into the dialog box into the form or template.

  • The Cancel button allows you to close the dialog box without inserting any bitmap.

  • The Copy button allows you to copy a bitmap to the Clipboard that you have already loaded into this dialog box through the Load button.

  • The Paste button allows you to paste a copied bitmap graphic from the Clipboard into the dialog box. After you paste a graphic you can select the RLE check box to compress the graphic when it's saved with the report.

  • The Load button allows you to load a graphic image (bitmap or JPEG file) into the dialog box. After you load the graphic, you can select the Link check box to link the bitmap to the template or form by its directory path. This means if the graphic gets updated, it will appear in its updated form inside the template or form.

  • The Clear button allows you to clear the loaded bitmap out of the dialog box.

  • The Transparent list allows you to specify one color within the bitmap that will be made transparent.

Along with the ability to resize the object and change other attributes, the following editable properties are included for bitmap objects:

Property | Description
Bitmap | This contains the file name for the bitmap.
Layout | Center, Left, or Right is the alignment of the bitmap within the rectangle. Stretch expands or shrinks the graphic to fit the size of the box. Size to Fit automatically expands the rectangle size to fit the size of the graphic.


Button Object

The Button object inserts a button control into a form. You can choose the action the form will take when the button is clicked by modifying the ButtonType property.

Along with the ability to resize the object, change colors, and change other attributes, you can further customize button objects by using these properties:

Property | Description
Default | This determines how buttons will respond when you press the ENTER key. YES - The button responds to a pressed ENTER key even if another button has the focus. NO - If ENTER is pressed only the button that has the focus will respond.
ButtonShape | This determines the look of the button. Options include: 0- Normal: changes shape to a standard button. 1- Property tab Inactive: changes shape to an unselected property sheet tab. 2- Property tab Active: changes shape to a selected property sheet tab.
Text | This determines the text that appears on the button.
Bitmap | This places a bitmap of your choice on top of the button face. It uses the same dialog box and properties as described in the "Bitmap Object".
Layout | This determines the position of the bitmap or text on the button's face. The values include: 0- Center 1- Left 2- Right 3- Top 4- Bottom
ButtonType | This determines the action a button will take when it's clicked. 0- Cancel: closes the form and does nothing. 1- EventClick: executes a C++ or VBScript action. 2- Goto: goes to the Multi Document Interface (MDI ) associated file. 3- Help: invokes the WinHelp() function using the HelpContextID property to open the proper topic. 4- OK: records changes and closes the form. 5- Record: records changes and keeps the form open.
GotoPath | This determines the MDI associated file the form will go to when the button is clicked. This is mostly used to implement property sheet-like controls.


CADImageObject

The CadImageObject lets you display the CAD image inside of a label template or a form. When you select this item and drag a box in the editing environment, PC-DMIS inserts a CADImageObject into the editor, and the object displays a dummy CAD model image.

Label Template Editor showing an inserted CADImageObject

How you size the object in the editing environment determines the size of the object when actually displayed in the Report window or executed form.

The CADImageObject contains these properties:

Property | Description
Standard |
Bottom | Defines the bottom location for the object in pixels from the top of the editor.
Left | Defines the left location for the object in pixels from the left of the editor.
Right | Defines the right location for the object in pixels from the left of the editor.
Show Border | If ON, displays a border around the object. If OFF, no border is drawn.
Top | Defines the top location for the object in pixels from the top of the editor.
Advanced |
(ObjectCode) | Defines the object's unique name.
Enable | Determines whether or not this object is enabled for modification in the form or template. If YES then enabled for modification. If NO, then not enabled for modification.
Visible | Determines whether or not this object is visible in the form or template. If YES then visible. If NO, then hidden.
Events |
EventReportData | This is the event that pulls report data from PC-DMIS into the template or form.

CadImageObject on Labels

You can use the Rules Tree Editor dialog box to display the label template in a report template for a particular dimension or feature. In such a case, the Report window will display the portion of the CAD model that contains that dimension or feature.

Report window showing a CADimageObject next to each displayed dimension

You can scale, scale to fit, rotate or translate this CAD image from the Report window. To do this, double-click on the CAD image to make it editable, and then manipulate the image just as you would the model in the Graphics Display window. To return to the Report window, storing your changes, double-click outside of the object.

CADImageObject on Forms

When it is used on a form, the CadImageObject is bound to the current viewset when PC-DMIS executes the form command. Once you execute the form (CTRL + E) or the part program that calls the form, you cannot modify the CADImageObject.

Form window showing a CADImageObject during program execution

For additional information on forms, see the "About Forms" topic in this section.


CadReportObject

The CadReportObject lets you view your CAD drawing inside a finished report. When you initially drop the CadReportObject into a report template, PC-DMIS automatically launches the Label Layout Wizard. After using this wizard to position the labels you want PC-DMIS to use, you will see a dummy graphic of the Hexagon test block, and if no rules are defined, dummy labels as well. It will look something like this:

A sample CadReportObject inserted into a report template

Remember, these dummy items are simply representations of what you want on your report. In the actual report window, it will show the actual CAD model. The labels display a picture of the label template defined by the first rule in the CadReportObject's rule tree. If the label is not associated, and no rules apply, it draws the dummy label image.

How it Works in the Report Window:

In the Report window, your CAD display will initially appear exactly as shown in your Graphics Display window when it finishes executing your program or at the time you redraw your report, except that it will not zoom in any closer. If you make modifications to a CadReportObject in the Report window, PC-DMIS will retain those changes to the CAD image on the report—even after subsequent part program executions—until you right-click on the CAD view(s) inserted into your report and select Remove Object Modifications or until you select File | Reporting | Clear Template Associated Data.

While your Report window often shows your entire CAD drawing, it only shows labels and leader lines for those features you have specified in the Rule Tree Editor. For example, if your part program has four measured circles and two measured lines, yet in the Rule Tree Editor your CadReportObject displays labels only for the measured circles, then report will only show label information for those circles, even though you may have measured the lines as well in your last execution.

Also, if a CadReportObject is configured to display—using the Label Count list on the Label Layout Wizard—a fewer number of labels than the number of features it is specified to report on in the Rule Tree Editor, then the Report window will display additional instances of your CAD drawing on additional pages in the Report window. These additional images will show leader lines and labels to any remaining features. This is especially helpful if your labels have a lot of information that may make your report look cluttered if you have more than one or two labels around a part drawing.

Viewsets Note: If you're using viewsets, your CAD display will appear exactly as shown in your viewsets. PC-DMIS will insert a new CAD display on a new page of the report for each viewset encountered during execution.

Rotating, Moving, and Zooming the CADReportObject's CAD Image

You can easily change the CAD image's orientation and zoom level in the Report window, or move it to a new location.

  • To rotate the image, double-click on the object to "activate" it. Once activated, press and hold the mousewheel button and keeping the mouse pressed, drag the mouse, or press down CTRL and right-click while dragging the mouse.

  • To zoom in or out of the image, double-click on the object to "active" it. Once activated, click above or below an imaginary horizontal line the cuts across the middle of the CAD model. You can also use a mouse's scroll wheel button to zoom in and out.

  • To move the CADReportObject, right-click on the object to select it. Once selected, click on the object and drag the mouse.

To cancel zoom or rotation changes, press the ESC key. The CadReportObject will be ”deactivated” without applying your changes.

To save zoom or rotation changes, double-click outside of the CadReportObject. The CadReportObject will be ”deactivated” and the CAD image will use the new orientation and zoom level. If you are using the Feature-based label layout on the CadReportObject, the entire report will be reloaded with the new orientation and zoom level applied to the CAD image.

To save movement changes, click outside of the selected object.

Switching Between Solid And Wire Frame Modes

You can easily display your CadReportObject in the Report window as either a solid or wire frame by right clicking on the CadReportObject and selecting the Wireframe option from the shortcut menu. PC-DMIS will toggle between a solid or wire frame.

Selecting Levels to View in the Custom Report Editor

If you select a CadReportObject in the Custom Report Editor, the View Setup icon [image] on the Graphics Modes toolbar becomes available for selection. In this context, you can use this icon to select specific level(s) of CAD elements to be applied to the object. You can also select Edit | CAD Operation | View Setup to do the same thing.

When you click the View Setup icon or menu item, the View Level Selection dialog box appears:

View Level Selection dialog box

This dialog box lets you select any predefined CAD levels from the View Levels list. Once you select the level(s) and click OK, PC-DMIS displays the selected level(s) on the selected CADReportObject.

See "Creating Custom Reports" for information on custom reports.

See "Setting Up the Screen View" for information on defining views and levels.

Mirroring the CAD in the Custom Report Editor

If you select a CadReportObject in the Custom Report Editor, PC-DMIS lets you mirror the CAD image contained in that object. To do this, select Edit | CAD Operation | Mirror. The Mirror CAD dialog box appears:

Mirror CAD dialog box

This dialog box lets you create a mirror image of the part. Select the plane (axis) in which you want to mirror the part, and click OK. PC-DMIS displays the mirrored CAD model on the selected CADReportObject.

See "Transforming a CAD Model" for additional information on Mirroring CAD in the Graphics Display window.

Using Image Caching

PC-DMIS lets you cache your part's image once and use the image cache later in reporting contexts instead of always using your part program's associated .CAD file. You may find this useful in situations where you have a very large .CAD file that takes a long time to load into the Graphics Display window. Once you cache your images for a particular report you won't need your .CAD file to view that report.

To cache your image:

  1. Close PC-DMIS and open the PC-DMIS Settings Editor.

  2. Under the Reporting section, set the UseImageCachingScheme registry entry to 1.

  3. Close the PC-DMIS Settings editor and restart PC-DMIS.

  4. Load the part program and .CAD file as usual.

  5. Open the report window and select a report template that uses the CADReportObject.

  6. Generate the report.

  7. Make any desired modifications to the CADReportObject items used in the report.

  8. Print your report.

This process caches the images used in this particular report. Now if you delete (or rename) your .CAD file to speed up the part program opening process, this same report will use your cached images. Note that other reports that use the CADReportObject will not have been cached however and you will need to load the .CAD file as usual.

Properties:

Property | Description
(Settings Dialog) | This opens the Label Layout Wizard. This lets you quickly layout multiple labels around your CAD drawing. See "The Label Layout Wizard" for more information.
Rules Tree | This opens the Rules Tree Editor dialog box. This dialog box lets you define conditions and actions for this object. See "About the Rule Tree Editor" for more information.
Show Border | This draws or hides a border around the CADReportObject.`
Leader Line Termination | This draws the leader line from the label to either the Measured feature on the CAD or the Nominal feature on the CAD.
Wireframe | This YES/NO property lets you show the CADReportObject in your report in either a wire frame (if set to YES) or solid surface view (if set to NO).

More:

The Label Layout Wizard


The Label Layout Wizard

The Label Layout Wizard is a tool that lets you quickly arrange multiple labels around your CAD drawing in the Report Template Editor and determine how the leader lines are drawn. In the Report Template Editor, this wizard appears automatically whenever you insert a CadReportObject. It also appears when you select the (Settings Dialog) property for a CadReportObject.

In version 4.1 and higher, you can also utilize this wizard in the Report window. To access it, right-click on the CadReportObject in the Report window and select Edit Object.... In the Report window, the wizard displays the real part model used with your part program. In the Report Template Editor, however, it displays the Hexagon test block as a filler model.

Any changes you make inside this wizard will automatically change the appearance of the CadReportObject.

This wizard contains these two main parts:

  • Layout Preview area

  • A settings area

Layout Preview area

The Layout Preview area lets you preview how the layouts will appear around the CadReportObject.

Depending on how you want your labels to appear, you can rotate labels along either a rectangular or an elliptical path by clicking on the square, white handle, located at the center of the rectangle or ellipse and dragging it to a new location. You can click and drag any of the outer white handles to size this rotation path.

If you want to relocate your part drawing, simply click on it and drag it to a new location.

Settings area

Layout Style

The drop-down list lets you control the spacing and rotate paths for the labels in the Layout Preview area. You can choose between these options:

Rectangular - Distributed - This creates a rectangular path that labels rotate around. The labels are distributed equally around the rectangle.

Rectangular - Packed - This creates a rectangular path that labels rotate around. The labels are close together along one side of the rectangle.

Elliptical - Distributed - This creates an elliptical path that labels rotate around. The labels are distributed equally around the ellipse.

Elliptical - Packed - This creates an elliptical path that labels rotate around. The labels are close together along the ellipse.

Feature Based - This setting automatically places in the Report window all the feature labels around the part model in locations close to each feature's location. This is useful when you have, for example, a large amount of edge points and you want to display all their labels in one CAD drawing. Selecting this option disables the Label Count box and enables the Feature Based Option area where you can define the minimum leader line length.

Feature Based - Restricted - This acts the same as Feature Based except that it enables the Label Count box, allowing you to restrict the number of labels that will appear in the object in the Report window. If the object needs to display more labels than you have defined, the extra labels will appear in additional instances of the CAD drawing on new pages.

Leader Line Termination

This area lets you choose where the leader lines from the labels will terminate on the CAD drawing.

Measured - This option terminates the leader line at the measured value's position.

Nominal - This option terminates the leader line at the nominal value's position.

Use Feature Centroid - This check box terminates the leader lines to the centroid of the feature.

At two features for angle - This check box draws a single leader line from the label that then splits into two lines pointing to the two features making up an Angle dimension.

At two features for distance - This check box draws a single line from the label that then splits into two lines pointing to the two features making up a Distance dimension.

Draw Color Ball - This check box draws a colored ball where the leader line terminates. The color of the ball matches the tolerance color band for that feature's value.

Ball Size - This list determines the size of the colored ball drawn where the leader line terminates. It becomes enabled for selection when the Draw Color Ball check box is selected. You can choose between small, medium, and large.

Leader Line Style

This area lets you define what leader lines look like in the report.

Line Style - Defines the line style:

  • Solid

  • Dash

  • Dot

  • Dash-Dot

  • Dash-Dot-Dot

Note: Line styles only work at the default line width of 1. Wider lines will only use the Solid line style.

Line Width - Sets the line width in pixels.

Line Color - Defines the color of the line by setting RGB (Red, Green, Blue) values, consisting by three numbers separated by periods. You can either type in specific values for the colors, or you can select the ... item from the list to access a standard Color dialog box and select your line color from that.

Arrow Head - Defines whether or not the leader lines have Arrow Heads.

  • None - Lines do not have arrow heads.

  • Both - Lines have an arrow head at each end.

Arrow Width - Defines the width of the arrow head in pixels.

Show Border

This check box draws or removes a border around the entire CADReportObject inside the template editor or Report window.

Auto Zoom

This check box will automatically zoom in on the CAD display in the Report window in such a way that it focuses the attention on only that portion of the CAD model for which label objects are currently displayed.

Feature Based Option

This area becomes enabled when you select Feature Based or Feature Based-Restricted. It contains two option buttons, mm and inch, and an Offset box. You can use the Offset box to define the minimum leader line length used with the labels. Depending on available room in the CadReportObject, the leader line length may grow, but it will never go below this minimum value.

Label Count

This changes the maximum number of labels a report's page will display. It becomes disabled when you select Feature Based.

Label Size Options

This area lets you switch between automatic or manual sizing of label objects. To make your label objects a specific size, click on Enable Manual Sizing and type in values in the Width and Height boxes.

Changing the labels sizes affects design purposes only. It does not affect label sizes in the actual Report window.

This area only appears when using the wizard in the Report Template Editor.


CommandTextObject

The CommandTextObject merely acts as a container for a simple string of text that gives an overview of a feature or dimension.

When you use a template with this object with actual report data, PC-DMIS will display a string of text that shows, for a feature, the feature's text label, the feature's type, and how many hits were used to measure the feature. For a dimension, it shows the dimension's name and type and what units of measurement are used in the dimension.

A label that has only the CommandTextObject with actual report data might look something like this when displayed in the Report window:

Example of CommandTextObjects dsiplayed with actual report data

Report of Circle Features Generated from a Label that Uses a CommandTextObject

Property

Description

Colors

Lets you change the colors of the text displayed. By default, PC-DMIS causes this object to use the same colors scheme as used in the Edit window's Command mode, so if you click this property PC-DMIS displays a message box asking if you want to create an independent color set. Clicking Yes accesses the Color Editor dialog box. You can then use this editor to define a new color scheme for the selected CommandTextObject.

See "Defining Edit Window Colors" in "Setting Your Preferences" for information on how to use the Color Editor.


Checkbutton Object

The Checkbutton object inserts a checkbutton object, or check box, into the form. Check boxes, unlike option buttons, are never mutually exclusive. You can select as many check boxes as desired (provided they are enabled for selection).

Along with the ability to resize the object, change colors, and change other attributes, you can further customize check boxes by using these properties:

Property | Description
OwnerDrawn | This specifies how the form should draw the check box. If set to TRUE, the check box gets drawn from a bitmap specified in the Bitmap and Bitmap (Off) properties. If set to FALSE, the check box is drawn normally.
Bitmap | This allows you to specify a bitmap to use if OwnerDrawn is set to TRUE and if the check box is selected. Additionally, the specified bitmap must be the same shape as a standard check box.
BitmapOffState | This allows you to specify a bitmap to use if OwnerDrawn is set to TRUE and if the check box is not selected. Additionally, the specified bitmap must be the same shape as a standard check box.
TriState | Instead of just the TRUE (ON) and FALSE (OFF) states, this property lets your check box have three states: true, false, and partially true, thus allowing you determine whether a portion of a selected option is true.
AlignTextLeft | If set to YES, this moves the text to the left of the check box like this: Text Here [ ] If set to NO, this moves the text to the right of the check box like this: [ ] Text Here
Text | The text specified here gets displayed on the check box control.
HelpHotButton | Selecting YES shows a question mark help button next to the check box. Clicking this button in Run mode launches the PC-DMIS Online Help.
ValueID | This contains the CurPage and NumPages variable. You get and set this property using the control.


ComboBox Object

The ComboBox object inserts a combo list into your form. Using this list you can display options to select when you click the list in Run mode.

Along with the ability to resize the object, change colors, and change other attributes, you can further customize this object by using these properties:

Property

Description

Accelerator

This allows you to define the letter to use in conjunction with the ALT key to create an accelerator for the control.

The letter or symbol defined should be unique from those used for other accelerators (including the accelerators on the menu bar).

UseColors

This determines whether or not this control should use colors specified in BackColor and TextColor properties.

ListItems

This defines the list of items and the associated values (see the description of the List Choices dialog box described in the "Radiobutton Object").

NumDropped

The number specified determines how many list items the form displays when you click on the list in Run mode.

Sort

Selecting YES sorts the list items in alphabetic order.

ComboType

This specifies the type of combo list. You can select either Droplist or Dropdown.

HelpHotButton

Selecting YES, shows a question mark help button next to the check box.

Clicking this help button in Run mode launches the PC-DMIS Online Help.

ValueID

This contains the CurPage and NumPages variable. You get and set these variables using this control.


Dimension Color Key Object

The dimension color key object is used to drop a color key directly into the template. This color key depicts the colors that are used to represent the dimensional tolerance zones for analysis and histogram objects.

To see how these tolerance zones are defined or to change the colors representing each tolerance zone, see "Editing Dimension Colors" in the "Editing the CAD Display" section.

Sample Horizontal Dimension Color Key Object

Sample Vertical Dimension Color Key Object


EditBox Object

The EditBox object inserts an editable box into the form. You can use this object with Visual BASIC scripting to collect information from those running the form.

Along with the ability to resize the object, change colors, and change other attributes, you can further customize this object by using these properties:

Property

Description

Accelerator

This allows you to define the letter to use in conjunction with the ALT key to create an accelerator for the control.

The letter or symbol defined should be unique from those used for other accelerators (including the accelerators on the menu bar).

Alignment

This aligns the text within the object. Available alignments are: Left, Center, and Right.

ReadOnly

Setting this to YES makes the text read-only and therefore not editable when the form is in Run mode.

BorderDrawn

Setting this to YES draws a border around the control.

CaseOrPassword

This sets the style of the text in the box. You can select one of the following:

0 – None: doesn't change the display of the text.

1 - Lower Case: displays the case of the text in the box to all lower case.

2 - Upper Case: displays the case of the text in the box to all upper case.

3 – Password: masks each character of the text with an asterisk.

UseColors

If set to YES then colors specified in BackColor and TextColor are displayed.

HelpHotButton

Selecting YES, shows a question mark help button next to the check box.

Clicking this help button in Run mode launches the PC-DMIS Online Help.

ValueID

This contains the CurPage and NumPages variables. You get and set these variables using this control.


EditDblBox Object

The EditDblBox object inserts an edit box in the from that accepts variables of double types. This has all the properties of the EditBox object (see "EditBox Object") with the addition of MinimumEq and MaximumEq properties:

Property | Description
MinimumEq | Minimum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST
MaximumEq | Maximum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST


EditLongBox Object

The EditLongBox object inserts an edit box in the form that only accepts Long numerical values. This has all the properties of the EditBox object (see "EditBox Object") with the addition of MinimumEq and MaximumEq properties:

Property | Description
MinimumEq | Minimum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST
MaximumEq | Maximum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST


Ellipse Object

The Ellipse object inserts an ellipse into the form or template. The default ellipse is a circle with the same distance from the centroid of the circle to all points along the circumference; however you can easily stretch the circle to form an ellipse.

Along with the ability to resize the object, add a fill color, add a border color, and change other attributes, the following editable properties are included for ellipse objects:

Property | Description
Width | This sets the width of the object's border in pixels.
PenStyle | This changes the line style to Solid, Dash, Dot, Dash-dot, and Dash-dot-dot.
HatchStyle | This sets the type of pattern (or hash) to use to fill the resulting polygon. Available patterns are: Horizontal Vertical Diagonal Reverse Diagonal Cross Diagonal Cross


Frame Object

The Frame object inserts a frame into the form. You'll generally use this object to set off groups of similar options when designing your own dialog boxes inside your form.

Along with the ability to resize the object, add a fill color, add a border color, and change other attributes, the following editable properties are included for frame objects:

Property | Description
BorderColor | This sets the color of the border.
HiliteColor | This sets the color used for the BorderStyle property when you use Raised or Sunken.
BorderStyle | This sets the 3D highlight style of the object's border. Options include Normal, 3D, Sunken and Raised.
BorderWidth | This sets the width of the object's border in pixels.
Text | Text typed here determines the name used for the frame's title.
Alignment | This aligns the text within the object. Available alignments are: Left, Center, and Right.


Gauge Object

The Gauge object inserts a gauge object (or progress bar) into your form or template.

Along with the ability to resize the object, change colors, and change other attributes, you can cause the object's percentile bar to move by using these properties in conjunction with Visual BASIC code:

Property | Description
ValueEq | Value equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST
MinimumEq | Minimum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST
MaximumEq | Maximum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST

Tip: If you change the direction of the gauge, the progress of the gauge will also change to the direction specified.

More:

Example of Using BASIC Scripting to Dynamically Change the Gauge's Value


Example of Using BASIC Scripting to Dynamically Change the

Example of Using BASIC Scripting to Dynamically Change the Gauge's Value

You can also use BASIC code in the VBS Mini-Editor to dynamically change the value of the gauge at a given time. Suppose you want to create a form that moves the gauge from 0 to 100 percent based on how closely a circle's diameter approaches its minimum and maximum allowed tolerances. You can do this by following this procedure:

Step 1 - Create the Form

  1. Create a new form and make sure it's in Edit mode. First, you will need to create a global variable named MYDIAMETER that will take the diameter value of the circle.

  2. Right-click on the grid and make sure The Frame / The View is selected from the object list on the Properties dialog box.

  3. Expand the Advanced heading in the Properties dialog box. Select the value for the LocalVariables property. The Local Variables dialog box appears.

  4. Click the Add button to add a new variable. Select Double from the Type list. In the Name box type MYDIAMETER. Leave the Value as 0.

Local Variables dialog box showing the MYDIAMETER global variable

  5. Click OK to return to the Properties dialog box. The MYDIAMETER variable is now added to the form.

  6. Next, insert a Gauge object into the form.

  7. Select the Gauge object and place and size it as desired. The vertical distance is the total distance the percentile bar can travel.

  8. From the Properties dialog box, ensure that the added Gauge object is selected.

  9. Again, under the Advanced heading on the Properties dialog box, click the MaximumEq property. The VBS Mini-Editor appears; much of it is unavailable for selection.

  10. Select CONST from the list. This value allows you to define the gauge's 100% value.

  11. Type the maximum allowed value for the circle's diameter. This example measures a one inch diameter circle with an allowed tolerance of .010. So the maximum allowed value would be 1.010.

  12. Click OK to return to the Properties dialog box.

  13. Click on the MinimumEq property. The VBS Mini-Editor re-appears. This value allows you to define the gauge's 0% value.

  14. Select CONST from the list.

  15. Type the minimum allowed value for the circle's diameter. Again, since this example measures a one inch diameter circle with an allowed tolerance of .010, the minimum allowed value would be 0.990.

  16. Click OK to return to the Properties dialog box. Now you need to give the actual value of the gauge the diameter of the circle.

  17. With the gauge object still selected from the Properties dialog box, under the Advanced heading, select the ValueEq property. The VBS Mini-Editor appears; much of it is unavailable for selection.

  18. In the list on the left, select + EQ ($).

  19. In the list on the right, select the <MYDIAMETER>.

Using the VBS Mini-Editor to set the value of the gauge object

  21. Click OK to close the VBS Mini-Editor.

  22. Save the form. This example gives the form the name of gaugetest.form.

Step 2 - Create a Generic Circle Feature

  1. You will now create a generic circle feature inside PC-DMIS.

  2. Select PC-DMIS's Edit window and place it in Command mode.

  3. Insert a generic feature by typing GENERIC and pressing TAB. Initially, a generic point feature appears in the Edit window with the feature's ID selected.

  4. Press F9 to access the dialog box for this generic feature.

  5. In the Feature Type area, select Circle.

  6. In the Data Type area, select Nominal Values.

  7. Type a name for the circle in the Feature Name box. This example uses CIR1 for the feature name.

  8. Type the XYZ and IJK values for CIR1.

  9. Select the Diameter option and give CIR1 a nominal diameter value of 1.

  10. Change any other options as desired and then click OK when finished. The generic circle in your Edit window should look something like this:

CIR1 =GENERIC/CIRCLE,DEPENDENT,RECT ,OUT,$

            NOM/XYZ,1,1,0.95,$

MEAS/XYZ,1,1,1,$

NOM/IJK,0,0,1,$

            MEAS/IJK,0,0,1,$

DIAMETER/1,0

Step 3 - Insert an INPUT Comment and Modify Generic Circle

  1. Move your cursor before the CIR1 feature and insert an input comment that will take a measured diameter value (since this example is done in offline mode, the "measured" values are inserted manually). For example:

C1 =COMMENT/INPUT,Please type CIR1's measured diameter:

  2. Now go to the command block for CIR1 and on the last line where it says DIAMETER/1,0 change the second parameter, the measured diameter of 0, to C1.INPUT. This assigns the value from the input comment to CIR1's measured diameter.

DIAMETER/1,C1.INPUT

  3. Now move the cursor after the CIR1 feature and embed the saved form by selecting the Insert | Report Command | Form menu option.

Step 4 - Insert a FORM/FILENAME Command and Execute

  1. Now in the FORM/FILENAME command where it says PARAM/=, place your cursor immediately before the equals sign and type MYDIAMETER. Then move the cursor immediately after the equals sign and type CIR1.DIAMETER. The code to embed your form should look something like this:

CS1 =FORM/FILENAME= C:\PCDMIS35\GAUGETEST.FORM, AUTOPRINT=NO

PARAM/MYDIAMETER=CIR1.DIAMETER

PARAM/=

            ENDFORM/

  2. Mark the newly added commands and then execute the part program. The diameter for CIR1 gets passed as a parameter into the form and the gauge object's percentile dynamically changes depending on the circle's measured diameter.

For example, if the measured diameter for CIR1 was .9987 you would get a form that looks something like this:

Sample Form Showing the Gauge Object Dynamically Linked to a Feature's Measured Diameter


Graph Object

The Graph object inserts a graph into your form or template with the ability to dynamically update its data. The Graph object allows you to store and then display an array of data points. You can use X and Y values to specify the points of data on the graph.

Default Graph object

Along with the ability to resize the object, change colors, and change other attributes, you can cause graph objects to update their data dynamically by using these properties in conjunction with Visual BASIC code:

Property | Description
DataPointColor | This changes the colors used on the X, Y data points and on any lines drawn between points.
Width | This changes the diameter (in pixels) of the data point.
ConnectPoints | Setting this to YES draws lines between the data points on the graph, visually connecting them together.
Clockwise | Setting this to NO reverses the Y axis, making the top negative and the bottom positive.
Xdivisions | This divides the X axis of the graph, essentially adding the specified number of columns.
Ydivisions | This divides the Y axis of the graph, essentially adding the specified number of rows.
EnablePoint | If set to 1, your graph accepts the addition of new data points. If set to 0, your graph rejects the addition of new data points.
ClearAllPoint | If set to 1, all data points are cleared from the graph the next time your form enters Run mode. If set to 0, all data points remain in the graph.
XpointEq | This is the X value for your data point on the graph. You can use a simple equation, or evaluate the data from a VBScript.
YpointEq | This is the Y value for your data point on the graph. You can use a simple equation, or evaluate the data from a VBScript.
XminEq | This is the X axis minimum equation. The value used determines the beginning value making up the X axis. You can use a simple equation, or evaluate the data from a VBScript.
YminEq | This is the Y axis minimum equation. The value used determines the beginning value making up the Y axis. You can use a simple equation, or evaluate the data from a VBScript.
XmaxEq | This is the X axis maximum equation. The value used determines the ending value making up the X axis. You can use a simple equation, or evaluate the data from a VBScript.
YmaxEq | This is the Y axis maximum equation. The value used determines the ending value making up the Y axis. You can use a simple equation, or evaluate the data from a VBScript.

Tip: You can re-scale the Y axis by clicking on the up and down arrows [image] near the graph's origin.


Histogram Object

The histogram object displays in bar graph format, the number of deviations within each of the different tolerance zones.

A Sample Histogram

When a dimension only has a single tolerance value, such as a form dimension, PC-DMIS displays the tolerance band as a range, and not in a fixed location. PC-DMIS will not display -TOL or +TOL in the resulting histogram but will instead show the heading "TOLERANCE ZONE" at the top and include a location for the mean value like this:

A Sample Histogram with a Single Tolerance

Inserting the Histogram Object

Use the Label Template Editor for a new or existing label template and then add and size the Histogram object so that it appears vertically or horizontally as desired in your label template editor's display area. Next, use the Rule Tree Editor dialog box for a new or existing report template to specify under what conditions (for what dimensions) PC-DMIS will call and display that label template. See the "About the Rule Tree Editor" topic in this section for information on how to do this.

Note: Histogram objects are not available for dimensions that are not directly calculated using the individual hits of their features, such as location, true position, and keyin dimensions.

Changing Histogram Colors

To see how these tolerance zones are defined or to change the colors representing each tolerance zone, see ”Editing Dimension Colors” in the "Editing the CAD Display" section.


GridControlObject

The GridControlObject icon inserts a customizable grid of columns and rows into your report or label template.

A Newly Inserted Grid Control Object

A Newly Inserted Grid Control Object

This unique object is more than just a standard table though. In fact, you can program the individual cells, rows, or columns using the reporting expression language to cause PC-DMIS to pull and display specific reporting information from your part program.

As with the other objects, you can easily resize and move this object to a new location. When you resize this object, be aware that PC-DMIS dynamically sizes the columns and rows to fit the new objects size.

Accessing the GridControlObject Editor

Once you insert a GridControlObject, select it, double-click inside any cell, and then right-click to display a tabbed dialog box. This dialog box gives you powerful formatting and editing abilities that let you program each grid cell to your individual specifications.

GridControlObject Editor - Cell tab

Cell tab of the GridControlObject's Editor

See these topics for information on using this editor:

  • GridControlObject Editor - The Cell Tab

  • GridControlObject Editor - The Row Tab

  • GridControlObject Editor - The Column Tab

Properties

Property | Description
NumColumns | Determines the number of columns in the grid.
NumRows | Determines the number of rows in the grid.
TableFormat | Specifies a grid layout name to use. If this property matches the grid layout name in the Rules Tree Editor, then you can use the TABLE/FORMAT Edit window command to directly control row and column order and visibility for your label template.
Transparent | Determines whether or not the grid's background is transparent. If set to Yes the usual white background color becomes transparent; other objects behind this object are then visible through the grid.

Increasing the NumRows property adds new rows to the bottom of available rows. Decreasing them will delete the bottom-most row and work up. Similarly, increasing the NumColumns property adds new columns to the right of the available rows. Decreasing the number of columns will delete the right-most column and work left.


GridControlObject Editor - The Cell Tab

GridControlObject Editor - Cell tab

Cell tab of the GridControlObject's Editor

Cell Type - Lets you configure what you will insert into the specific cell. Options are:

  • Text - This lets you type straight text or an expression command into the Cell Expression box. The evaluated expression or the straight text appears in the cell.

  • Image - This inserts an image into the cell. You can select it using the Select button.

  • ActiveX - This inserts an ActiveX object into the cell. Generally PC-DMIS templates use these to display graphical analysis information. You can select what ActiveX control to add by using the Select button. For more in depth information on ActiveX objects, see the "ActiveX Object" topic and the "Using PC-DMIS ActiveX Controls" topic.

Cell Expression - This box lets you type a reporting expression into the cell. PC-DMIS evaluates the expression when it uses the template to display the actual report data. For example, to display a feature's ID, type =ID into this box. See "About Report Expressions" for a robust listing of expressions you can include.

Cell Height and Width - These boxes let you define the cell's height and width in pixels. Note that if you modify a height, all cells in that row are modified. If you change the width, all cells in that column are modified. If you have varying heights and widths among multiple cells, the Even Width and Even Height buttons even out the height and width among the selected cells

Cell Justification - These buttons let you set the alignment of the text within the cell, either vertically or horizontally. If horizontal, your can align the text to the left, the center, or the right of the cell. If vertical, you can align the text to the top, the middle, or the bottom.

Horizontal Alignment Buttons
 | Left alignment
 | Center alignment
 | Right alignment
Vertical Alignment Buttons
 | Top alignment
 | Middle alignment
 | Bottom alignment

Note that when aligning text within the grid's cell, PC-DMIS uses a default internal value for cell padding. You can use the PC-DMIS Settings Editor to override this default value by modifying the GridCellTopMargin, GridCellBottomMargin, GridCellLeftMargin, and GridCellRightMargin registry entries in the Reporting section as needed. See the PC-DMIS Settings Editor documentation for more information.

Lines area - This area contains a list for each side of the cell. You can set each side of the cell (plus the outside or inside lines of multiple cells) to a particular line type. Options include: None, Thin, Thick, Double, or Dashed.

Font - This button displays a standard Font dialog box allowing you to set a the font, size, style, effects, and color for the selected cell(s).

Colors - This area lets you set the colors for the background, text, or line of the selected cell(s). Clicking one of the buttons displays a standard Color dialog box from which you can select a specific standard color or create a custom color.

Merge Cells - This button merges multiple cells together into one cell.

Unmerge Cells - This button unmerges previously merged cells into their original and previous unmerged state.


GridControlObject Editor - The Row Tab

GridControlObject Editor - Cell tab

Row tab of the GridControlObject's Editor

Repeating Group - This check box enables the Repeat Expression box and tells PC-DMIS that the selected row will continue repeating itself with data from the report until the expression in the Repeat Expression box is satisfied. When you select a cell in the GridControlObject, PC-DMIS indicates any repeating rows in the object by drawing small vertical orange bars on their left and right sides.

Repeat Expression - This box determines how many times PC-DMIS will repeat the row. You will usually put an expression in this box that will evaluate to a counted number of items. For example, to get the number of axes in a dimension, you would use this expression:

=COUNT(AXIS)

Then in each cell of the row, you would need to append this to existing expressions:

:N

This essentially tells PC-DMIS to repeat the row the counted number of times. So, if the Cell Expression box in the Cell tab used =AXIS to list a dimension's axis, and you changed it to read =AXIS:N, PC-DMIS would continue to repeat the row with unique dimension axis data until all axes were reported.

Row Label - The Row Label list lets you define a label for your row to use with the Table Format command. When you access the Table Format command's properties, you will see the row labels you've defined here. Using the Table Format command, you can re-define the order of the rows in the grid, among other things.

Locked Row - This check box locks the row so that you cannot modify it using the Table Format command.


GridControlObject Editor - The Column Tab

GridControlObject Editor - Cell tab

Column tab of the GridControlObject's Editor

Column Label - The Column Label list lets you define a label for your column to use with the Table Format command. When you access the Table Format command's properties, you will see the column labels you've defined here. Using the Table Format command, you can re-define the order of the columns in the grid, among other things.


Label Object

Label Object icon

The Label object icon inserts a Label object into your report template or custom report. Label objects are used to display report data in your report. The Label object behaves differently depending on the context in which it is used. If you use the Label object in the Report Template Editor, it functions differently than using it in the Custom Report Editor.

Using the Label Object within the Report Template Editor

Click and drag on the Report Template Editor to add this object. When you release the mouse button, the inserted Label object looks something like this:

Sample Label Object

A Sample Label Object

A Label object acts just like a TextReportObject or CadReportObject; it doesn't contain any real data and merely acts as a placeholder for a label template. The label template actually controls what data gets pulled from a part program execution. If you don't define what the label object will display, then it doesn't appear in the report.

Assign a Label Template

To give a Label object something to display, you need to assign a label template for it to use. Follow this procedure:

  1. Right-click on the label object. The Properties dialog box appears.

  2. Click Rules from the Rules Tree property. The Rules Tree dialog box appears.

  3. Using the Rules Tree dialog box, select an item from the expandable list of when you want the label to display data.

  4. Click Add to add a rule that uses that item. The Edit Rule dialog box appears.

  5. Select Use Label Template for Report option.

  6. Click the browse button [image], and select a label template file (.lbl filename extension).

  7. Click OK to close the Edit Rule dialog box.

  8. Click OK to close the Rules Tree dialog box. The label object you inserted will now display a picture of the label template defined in the first rule in the Rule Tree dialog box.

  9. Save and test your report template. PC-DMIS will display the selected label when the condition you specified is met.

See "About the Rule Tree Editor" for information about creating rules.

Using the Label Object within the Custom Report Editor

One crucial difference between the Report Template Editor and the Custom Report Editor is that in the Custom Report Editor Label objects do not use their own Rule Tree Editor. Instead, the Page object contains a Rule Tree Editor that defines what label template is used when the different commands and data are inserted into the Custom Report Editor.

Most of the time you will likely simply create your custom report by dragging items from the Edit window's Summary mode into the Custom Report Editor. In this case, PC-DMIS uses the label templates defined in the Page object's Rule Tree Editor for the command you are inserting.

If you do insert a Label object into your custom report, PC-DMIS inserts a blank Label object, similar to how it would appear in the Report Template Editor:

Sample Label Object

A Sample Label Object

In this state, it is merely an empty placeholder, and it won't display any data until you drag and drop a command from the Edit window onto the object. PC-DMIS will then display the label template defined in the Page object's Rule Tree Editor.

See "Creating Custom Reports" for more information.


Leader Line Object

The leader line object lets you draw a connecting line between a Label object and a CADReportObject. To do this, simply select the object, then click and drag it from one object to the other.

If done properly, the leader line will automatically snap between the two objects so that if you later change their locations, the leader line changes size and moves accordingly. For example this figure shows a CADReportObject object with three Label objects around it all with connecting Leader Line objects.

Three Label objects with leader lines objects drawn to a CADReportObject.

Three Label objects with leader lines objects drawn to a CADReportObject.

If it can't detect the two objects, a Leader Line Construction dialog box will appear allowing you to select the two objects between which PC-DMIS should draw the leader line.

Leader Line Construction dialog box

Leader Line Construction dialog box

If you delete the Label or a CADReportObject object, PC-DMIS also deletes the leader line object automatically.

In the actual Report window, depending on the location of the label to the feature, the leader line will attach to either one of the edges or corners of the label. Consider this graphical example. It illustrates that where you position the labels (rectangles) in relationship to the feature (red circle) changes where the leader line connects (green dot) on the label.

Graphical Example of Labels and Leader Line Connection Positions


Line Object

The Line object allows you to quickly insert a standard line into your form or template. You can then right-click on the inserted line and modify its properties.

Common properties used on a line object are:

Property | Description
PenWidth | This sets the width of the line in pixels.
PenStyle | This changes the line style to Solid, Dash, Dot, Dash-dot, and Dash-dot-dot.
Arrowhead | This determines if the line should contain an arrowhead and the direction the arrowhead points. You can choose one of these formats: ----(none) <--- ---> <--->(both)
ArrowheadHeight | This determines the height of the arrowhead in pixels.


ListBox Object

The ListBox object inserts an open list inside the form.

Along with the ability to resize the object, change colors, and change other attributes, you can further customize this object by using these properties:

Property

Description

Accelerator

This allows you to define the letter to use in conjunction with the ALT key to create an accelerator for the control.

The letter or symbol defined should be unique from those used for other accelerators (including the accelerators on the menu bar).

UseColors

This determines whether or not the control should use the colors specified in the BackColor and TextColor properties.

Sort

Selecting YES sorts the list items alphabetically.

HorizontalScroll

Selecting Always places a horizontal scroll bar on the list box even if the text for a list item isn't long enough to cause it to scroll.

Selecting None removes the scroll bar.

VerticalScroll

Selecting Always places a vertical scroll bar on the list box even if there aren't enough list items to cause it to scroll.

Selecting None removes the scroll bar.

UseTabstops

This determines whether or not the list box should use tab stops. If set to YES, pressing TAB in Run mode will eventually make this list box the active control.

WantKeyInput

This determines whether or not the list box should accept keyboard input.

RemoveSelection

Selecting YES removes the selection from the list box (ListID) when recorded.

ListID

This is the ID of the list. You can set or get this by using the control. It should be in this format:

item 1\r\nitem 2\r\nitem 3 and so on.

ValueID

This is the ID of the value. You can set or get this by using the control.


MultiEditBox Object

The MultiEditBox object inserts an edit box that supports more than one line of text. This has all the properties of the EditBox object (see "EditBox Object"), plus the following:

Property

Description

HorizontalScroll

Selecting Always places a horizontal scroll bar on the control even if the text isn't long enough to cause it to scroll.

Selecting None removes the scroll bar.

VerticalScroll

Selecting Always places a vertical scroll bar on the control even if the text isn't long enough to cause it to scroll.

Selecting Automatic places a vertical scroll bar only when the amount of text exceeds the vertical height of the box.

Selecting None removes the scroll bar.


OLE Object

The OLE object embeds or links an object from another application into your template or form. For example, using this object you can insert an editable Microsoft Word file into your template or form, to provide special instructions to the operator.

Once you insert an OLE object, a dialog box titled Insert Object appears.

Insert Object dialog box

This dialog box allows you to select the type of OLE object from a list of objects that are currently available on your computer. The OLE objects in the list are unique to your individual computer depending on what is installed, etc.

If you select the Cancel button nothing is added to the form or template and the dialog closes.

More:

Accessing an OLE Object’s Automation Methods and Properties from Basic


Accessing an OLE Object’s Automation Methods and Properties

Accessing an OLE Object’s Automation Methods and Properties from Basic

If you have added an OLE control, for example the Bitmap control, and called it BITMAP, you may wish to access the OLE object’s automation methods and properties from BASIC. For example, you might wish to add program code to change the bitmap being displayed, populate an embedded Microsoft Excel spreadsheet object with data, or set the text in an embedded Microsoft Word document. In order to access the OLE automation methods and properties for the object named ”BITMAP”, use the following code:

AttachOLE("BITMAP_X")

The object variable BITMAP_X may now be used as follows:

BITMAP_X.{property} = {value}

or

BITMAP_X.{automation method call}.

Note: You must have documentation for the particular OLE object you are using to know what methods and properties are available.


Providing Operator Instructions Using OLE Objects with Forms

Providing Instructions Using a Microsoft Word OLE Object

Perhaps one of the simplest ways to provide instructions to those running your part programs is to simply use something like Microsoft Word.

This topic and the steps below assume you have Microsoft Word installed on your computer.

Step 1 - Create and Save the Instructions as a Word Document

  1. Create your part setup instructions inside of a Word document.

  2. Save the .doc file to a directory on your disk. Feel free to include pictures, tables, and other advanced formatting inside your .doc file. The sample doc file used for this topic looks like this:

Step 2 - Create the Form

  1. Select View | Form Editor. The Form Editor appears.

  2. If the Edit window is open, select View | Edit window to close it giving you more screen space.

  3. Maximize the Form Editor.

  4. Size the form so that it will properly house the contents of your file.

  5. Add any other objects as desired. In the example form used for this topic, a Close Form button was added with the following properties:

    • Text = "Close Form"

    • ButtonType = OK

When clicked, the form automatically closes.

Step 3 - Insert the OLE Object

  1. From the Object Bar, click the OLE Object icon. Drag the object so that it fits the entire form except for a half inch margin on all sides. When you release the mouse button, the Insert Object dialog box appears.

  2. Select the Create from File option.

  3. In the File box, either type the complete pathway to the .doc file, or use the Browse button to locate it.

  4. Select the Link check box. This maintains a link between the OLE object on your form and your .doc file, so that if you later update your instructions PC-DMIS will always use the latest information.

  5. Click OK. The document is embedded into your form like this:

  6. Save the form and give it a name of your choice.

The Insert Object dialog box is the same dialog box that appears if you choose to insert an external object into the Edit window by using Insert | Report Command | External Object. Consult the "Inserting External Objects" topic from the "Inserting Report Commands" section if you need more information on this dialog box.

Step 4 - Insert and Test the Form

  1. Select View | Edit Window to make the Edit window visible.

  2. Select Insert | Report Command | Form. Use the dialog box to select your saved form.

  3. PC-DMIS inserts a FORM/FILENAME command block into your part program with a pathway to the form file.

CS1 =FORM/FILENAME= <Pathway to Form File>

PARAM/=

ENDFORM/

  3. Mark the command block for execution.

  4. Execute the part program. When PC-DMIS reaches the FORM/FILENAME command block, it displays the form:

  5. Click Continue from the Execute Mode Options dialog box to close the form and resume execution.

Providing Instructions Using a Microsoft PowerPoint OLE Object

This topic demonstrates how to use a Microsoft PowerPoint file (.ppt) as an OLE object inside of a form to provide detailed slide-show type instructions to an operator.

This topic and the steps below assume you have Microsoft PowerPoint installed on your computer.

Step 1 - Create and Save the Instructions as a PowerPoint

  1. Create your part setup instructions inside of a PowerPoint file (.ppt).

  2. Save the .ppt file to a directory on your disk.

Step 2 - Create the Form

  1. Select View | Form Editor. The Form Editor appears.

  2. If the Edit window is open, select View | Edit window to close it giving you more screen space.

  3. Maximize the Form Editor.

  4. Size the form so that it will properly house the contents of your file.

  5. Add any other objects as desired. In the example form used for this topic, a Close the Form button was added with the following properties:

    • Text = "Close the Form"

    • ButtonType = OK

When clicked, the form automatically closes.

Step 3 - Insert the OLE Object

  1. From the Object Bar, click the OLE Object icon. Drag the object so that it fits the entire form except for a half inch margin on all sides. When you release the mouse button, the Insert Object dialog box appears.

  2. Select the Create from File option.

  3. In the File box, either type the complete pathway to the .ppt file, or use the Browse button to locate it.

  4. Select the Link check box. This maintains a link between the OLE object on your form and your .ppt file, so that if you later update your instructions PC-DMIS will always use the latest information.

  5. Click OK. The PowerPoint file is embedded into your form.

  6. Save the form and give it a name of your choice.

The Insert Object dialog box is the same dialog box that appears if you choose to insert an external object into the Edit window by using Insert | Report Command | External Object. Consult the "Inserting External Objects" topic from the "Inserting Report Commands" section if you need more information on this dialog box.

Step 4 - Insert and Test the Form

  1. Select View | Edit Window to make the Edit window visible.

  2. Select Insert | Report Command | Form. Use the dialog box to select your saved form.

  3. PC-DMIS inserts a FORM/FILENAME command block into your part program with a pathway to the form file.

CS1 =FORM/FILENAME= <Pathway to Form File>

PARAM/=

ENDFORM/

  3. Mark the command block for execution.

  4. Execute the part program. When PC-DMIS reaches the FORM/FILENAME command block, it displays the form and the embedded PowerPoint presentation.

  5. Double-click on the embedded presentation. The Microsoft PowerPoint software will launch and display the presentation. When it finishes, PowerPoint will close.

  6. Click Continue from the Execute Mode Options dialog box to close the form and resume execution.

Providing Operator Instructions Using OLE Objects with Forms

Using existing tools in conjunction with PC-DMIS can provide you with much desired functionality. For example, suppose you want to provide an operator with detailed instructions regarding part setup or measurement. One way to do this is to embed into a custom form, using the OLE object, an external file containing these instructions. Below are some examples of how to embed instructional files into forms using some common Microsoft Office tools.

These examples demonstrate how to use a Microsoft Word file and Microsoft PowerPoint file as OLE objects inside of a form to provide instructions to an operator during part program execution. They will give you a taste of things you could do with OLE objects inside of your report or form. How you put this knowledge to use for your own situation is up to you.

  • Providing Instructions Using a Microsoft Word OLE Object

  • Providing Instructions Using a Microsoft PowerPoint OLE Object


Pointer Object

The Pointer object inserts a dynamic, movable, colored pointer into the form or template. The color defaults to yellow.

Along with the ability to resize the object, change colors, and change other attributes, you can cause this object to move by using these properties in conjunction with Visual BASIC code:

Property | Description
ValueEq | Value equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST
MinimumEq | Minimum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST
MaximumEq | Maximum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). -$, $, CONST

Tip: If you change the direction of the pointer, the movement of the arrow will also change to the direction specified.


Polyline Object

The Polyline object allows you to link lines together to construct an area. When you click and create the first line, a second line is automatically started at the end point of the first line. Polyline objects contain the same properties as a standard line object with these additions:

Property | Description
PenWidth | This sets the width of the object's border in pixels.
HatchStyle | This sets the type of pattern (or hash) to use to fill the resulting polygon. Available patterns are: Horizontal Vertical Diagonal Reverse Diagonal Cross Diagonal Cross
ShadowStyle | This sets the location of the 3D shadow on the resulting polygon. Available locations are: Top/Left, Bottom/Right, or None.


Radiobutton Object

The Radiobutton object inserts option buttons into the form. Option buttons are mutually exclusive, you can only have one option button selected inside your report at a time. The ListItems property allows you to define a set of option buttons.

Along with the ability to resize the object, change colors, and change other attributes, you can further customize this object by using these properties:

Property | Description
Bitmap | This allows you to specify a bitmap to use for a selected option button. The specified bitmap must be the same shape as a standard check box.
BitmapOffState | This allows you to specify a bitmap to use for a deselected option The specified bitmap must be the same shape as a standard option button.
AlignTextLeft | If set to YES, this moves the text to the left of the option button like this: Text Here ( ) If set to NO, this moves the text to the right of the option button like this: ( ) Text Here
ListItems | This defines a list of option buttons and its associated values (see the description on the List Choices dialog box below).
ValueID | This contains the CurPage and NumPages variable. You get and set this property using the control.

The ListItems property displays the List Choices dialog box.

List Choices dialog box

This dialog box allows you to add, rename, and delete option buttons and assign numerical values. Generally, when adding a new option the value for that option increments automatically, so only one button is selected at a time. However, you can change the numerical values to allow the selection of groups of options with one mouse click when in Run mode.

For example, suppose you have five option buttons that you've named Options A through E, and you change their assigned values to the following:

Option buttons | Value
Option A | 0
Option B | 0
Option C | 1
Option D | 2
Option E | 2

When you enter Run mode and select Option A, both Option A and Option B will be selected. This is because they're assigned the same value. The same is also true if you select Option E, both Option D and Option E will be selected. Only Option C has a unique value, so when you select it, only it is selected.


Select Object

The Select object allows you to select an object already inserted into your template. Simply click on the object in the report and PC-DMIS will surround the object with a border and small green squares. This lets you know the object has been selected. Once selected, you can move, resize, or edit the object.


SectionCutObject

The SectionCutObject lets you define a section cut (cutaway view) of the CAD model. You can insert a SectionCutObject into the Report Template Editor as with other objects, or you can insert it into a final report page on the Report window directly. To insert this object, position the mouse pointer, and drag a box. When you release the mouse, the object appears, and—at least in the Report Template Editor—it will display ”r;No Image!” until you associate the CAD model with the object by modifying its properties.

Changing the Object's Properties

If you insert the SectionCutObject into the Report Template Editor, right-click on it to access the object's Properties dialog box. You can modify the properties directly in the Properties dialog box or select the (Settings Dialog) property, and click the ... button to use the Section Cut Settings dialog box to more easily modify its properties.

If you insert this object on-the-fly into a report page of the Report window, the same Section Cut Settings dialog box appears.

Section Cut Settings dialog box

You can use this dialog box to define a cutaway image of your part model that will later appear in your report.

Defining a Cutaway Image Using the Selection Cut Settings Dialog Box

  1. Fill out the X, Y, and Z boxes to define a point on the CAD model where the clipping plane intersects with the model.

  2. Fill out the I, J, and K boxes to define the direction the plane faces.

  3. Modify the Tolerance value as needed.

  4. Click the Load button to see a live preview the cutaway image in the Section Cut Settings dialog box.

  5. Use the large left and right arrow icons to fine tune the placement of the plane, getting the exact cutaway view that you need. The preview in the dialog box updates to match the placement of the plane.

  6. Reposition the image as desired. Pan the image by right-click dragging. Zoom in or out on the cutaway image by right-clicking above or below the imaginary horizontal line that splits the image view. 2D rotate the part image by holding the CTRL key and right-click dragging.

  7. Finally, place callouts onto the dialog box image by using the Add Tag button.

  8. Click OK to accept your changes.

Section Cut Settings Dialog Box Items

Item

Description

X, Y, and Z boxes

These boxes define a point on the CAD model where the clipping plane will cut the model.

I, J, and K boxes

These boxes define the IJK direction vector of the clipping plane.

Tolerance box

The tolerance parameter is used to:

  1. Check if the polyline is closed. The start and end point distance is less than the tolerance value.

  2. Reduce the polyline.

  3. Merge polylines.

Load button

This previews the section cut line on the CAD image as well as the section cut profile.

Hide Image check box

This hides the section cut profile image on the preview window. If you click the OK button, PC-DMIS also hides the section cut profile image in the Report Template Editor or on the Report window's page.

Move clipping plane along above IJK area

This area contains an edit box and arrow buttons.

The edit box defines the distance that the clipping plane will move when you click the left arrow or right arrow button.

The arrow buttons move the clipping plane along the IJK vector, by the specified distance with each click.

If you have 1,0,0 then the plane will move along the X axis.

If you have 0,1,0 then the plane will move along the Y axis.

If you have 0,0,1 then the plane will move along the Z axis.

Scale Factor area

When you insert a section cut profile the scale of the profile image is the same as the actual part in the Graphics Display window, a 1:1 relationship.

The Scale Factor area lets you view or change this scale. For example, typing .25 would size the section cut to one fourth the size of the actual part.

Add Tag button

This button allows you to place callouts on the cutaway image of the part model.

Clicking this button changes your cursor to a cross-hair icon. You can click and drag a leader line on the cutaway image in the dialog box. When you release the mouse button, a small text box appears allowing you to type the callout text. The number of characters this text box can display is only limited by the size of the text box. Increasing the size of the box will allow it to hold and display more characters.

You should place tags on the image only when the cutaway image has been completely finalized. If not, the tag likely will be deleted with any future modification to image.

OK and Cancel

Clicking OK applies your changes to the section cut profile image and displays the image in the Report Template Editor or Report window. If your report contains a CadReportObject, the section cut line will appear on the CAD image.

Clicking Cancel closes the dialog box without applying your changes. However, if you've added the object on-the-fly into your Report window, the SectionCutObject will still exist. If desired, you can remove it by right-clicking on the object and selecting Remove Object.

Object Properties

Property | Description
(Settings Dialog) | This displays the Section Cut Settings dialog box.
Bottom | Common Properties
Left | Common Properties
Plane Anchor X | See description in table describing dialog box items above.
Plane Anchor Y | See description in table describing dialog box items above.
Plane Anchor Z | See description in table describing dialog box items above.
Plane Vector I | See description in table describing dialog box items above.
Plane Vector J | See description in table describing dialog box items above.
Plane Vector K | See description in table describing dialog box items above.
Right | Common Properties
Tolerance | See description in table describing dialog box items above.
Top | Common Properties
Enable | Common Properties
Font | Common Properties
Hide Image | See description in table describing dialog box items above.
Visible | Common Properties
EventReportData | About Events and Visual Basic Code

Defining On-The-Fly Section Cut Profiles

Perhaps the easiest way to use section cut profiles is to define them using an on-the-fly creation method within the final report in the Report window itself. To do this:

  1. Right-click on the Report window. A short cut menu appears.

  2. Select the Add Object on Page | Section Cut Profile... menu item.

  3. Click and drag a box directly on the Report window the size of the cutaway image you want. When you release the mouse button, the Section Cut Settings dialog box appears.

  4. Use the dialog box to define the cut profile as described above. PC-DMIS inserts the section cut profile into the Report window.

Sample Section Cut Profile

Modifying Section Cut Profiles in the Report Window

Right-click on the object and select Edit Object... from the resulting shortcut menu.


Slider Object

The Slider object inserts a slider into your template. With a slider in your report you can allow users to set a value from a range of continuous possible values.

Along with the ability to resize the object, and change other attributes, you can further customize this object by using these properties:

Property

Description

Accelerator

This allows you to define the letter to use in conjunction with the ALT key to create an accelerator for the control.

The letter or symbol defined should be unique from those used for other accelerators (including the accelerators on the menu bar).

Orientation

This sets the orientation of the slider.

Selecting Horizontal sets the slider to move horizontally, side to side.

Selecting Vertical sets the slider to move vertically, up and down.

TickStyle

This allows you to set how ticks are displayed on a slider.

0 – Both: sets the ticks to above and below the slider (if a horizontal slider) or to the right and left sides (if a vertical slider).

1 - Top/Left: sets the ticks above the slider (if a horizontal slider) or to the left (if a vertical slider).

2 - Bottom/Right: sets the ticks below the slider (if a horizontal slider) or to the right (if a vertical slider).

AutoTicks

Setting this to YES displays ticks on the slider. A tick is a short vertical/horizontal line that is placed at intervals (set by the TickFrequency property) along the range of the slider.

TickFrequency

This value determines the frequency that ticks are displayed. You can set a value between 2 and 200 ticks equally spaced along the range of the slider.

HelpHotButton

Selecting YES, shows a question mark help button next to the slider.

Clicking this help button in Run mode launches the PC-DMIS Online Help.

ValueID

This is the ID of the value. You can set or get this by using the control.

MinimumEq

Minimum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript).

-$, $, CONST

MaximumEq

Maximum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript).

-$, $, CONST

DisplayID

This determines whether or not the DisplayID gets updated when the slider gets adjusted.


Spinner Object

The Spinner object inserts a spinner control into your template. You can set this control to work with an edit box, allowing you to select a numerical value by cycling through a range of numbers. The range of numbers is set using the MinimumEQ and MaximumEQ properties.

Along with the ability to resize the object vertically, and change other attributes, you can further customize this object by using these properties:

Property

Description

Accelerator

This allows you to define the letter to use in conjunction with the ALT key to create an accelerator for the control.

The letter or symbol defined should be unique from those used for other accelerators (including the accelerators on the menu bar).

Orientation

This sets the orientation of the spinner control.

Selecting Horizontal rotates the orientation of the spinner arrows to point horizontally.

Selecting Vertical rotates the orientation of the spinner arrows to point vertically.

WrapAround

If incrementing or decrementing the list of values and you come to the minimum or maximum value, you can set this property to YES, and your report will wrap to the beginning or end of the list.

EditBuddy

Selecting YES, associates the spinner to the edit control immediately preceding the spinner in the tab order. You can view the tab order by selecting an object in Edit mode and pressing SHIFT + ENTER.

DecimalBase

This sets the base of the spinner to either decimal based (select YES) or hexadecimal based (select NO).

IncrAccelerator

This value determines the amount to increment or decrement the spinner each time you click an arrow. The default is 1.

ValueID

This contains the CurPage and NumPages variable . You get and set these variables using this control.

MinimumEq

Minimum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript).

-$, $, CONST

MaximumEq

Maximum equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript).

-$, $, CONST


TextReportObject

The TextReportObject object allows you to insert a container for your textual report data into your report template. When you insert this object, PC-DMIS initially displays a box filled with some sample report data, useful for design purposes. Once your template gets applied to a report, your actual report data is used.

TextReportObject with Sample Report Data

A TextReportObject with Sample Report Data

A sample report window showing actual report data

You can change an inserted TextReportObject's display by selecting the object, right-clicking on it, and editing its properties.

Properties specific to this object include:

Property

Description

Colors

Lets you change the colors of the text displayed. By default, PC-DMIS causes this object to use the same colors scheme as used in the Edit window's Command mode, so if you click this property PC-DMIS displays a message box asking if you want to create an independent color set. Clicking Yes accesses the Color Editor dialog box. You can then use this editor to define a new color scheme for the selected TextReportObject.

See "Defining Edit Window Colors" in "Setting Your Preferences" for information on how to use the Color Editor.

ShowAlignments

Shows or hides alignments in your report.

ShowComments

Shows or hides comments in your report.

ShowDimensions

Determines which dimensions get displayed in your report.

All - Shows all dimensions.

None - None of the dimensions is shown.

Out of Tolerance - Shows only out of tolerance dimensions.

Within Limits - Shows only dimensions within tolerance limits.

ShowFeatures

Shows or hides features in your report.

ShowHeaderFooter

Shows or hides the report's header and footer information.

ShowMoves

Shows or hides move commands in your report.

ShowScreenCaptures

Shows or hides screen captures in your report.

Rules Tree

Accesses the Rules Tree Editor for this object. This allows you to create rules to determine when and how expressions or label templates are used in the object.

Label templates and expressions let you control specifically what report data appears in this object. See "About the Rule Tree Editor"


Text Object

The Text object allows you to insert textual labels, descriptions, and markings into your template. This is helpful in making your report more meaningful. You can change an inserted text object's display by selecting the text object, right-clicking on it, and editing its properties.

The properties for the text object are described in the "Common Properties" topic.


TextVar Object

The TextVar object allows you to insert dynamic, numerical text into your template. This object differs from the Text object by deleting the TEXT property and adding these 2 properties:

Property | Description
ValueEq | Value equation (This value can be a set constant number, a value evaluated from a simple equation, or a returned value from a VBScript). The value is formatted and displayed at run time. -$, $, CONST
Format | This formats the numerical value using 'C' language standards. However, you should use only the numeric portion. For example, the format %5.2lf becomes 5.2, %5d becomes 5. One exception to this is when using BOOLEAN variables, the $ string gets converted into NO or YES.

To use this object edit the ValueEq property so that it's set to display a variable number value.


 Edit Icon Property Sheet Icon Toggle Ruler Icon View Snap Points Icon Toggle Ruler Icon Zoom In or Out Icon Group Icon Ungroup Icon Regroup Icon Align Edges Align Center Space Icon Make Same Size icon To Front or Back Icon Undo Icon Redo Icon

The Layout Bar

The Layout Bar gives you the tools you need to effectively arrange, organize, and display your objects inside the edit mode grid. The following topics discuss the functionality of each icon.

More:

Edit

Property Sheet

Toggle Grid

View Snap Points

Toggle Ruler

Zoom In or Out

Group

Ungroup

Regroup

Align Edges

Align Center

Space

Make Same Size

To Front or Back

Undo the Last Action

Redo the Previously Undone Action


Edit

The Edit icon places the template into Run mode. The Report Template and Label Template editors always remain in Edit mode. This icon only functions when working with the Form Editor.


Property Sheet

The Property Sheet icon displays the properties for the selected object in the Property Sheet dialog box. The Property Sheet dialog box allows you to change the properties for a selected object. You can easily change the object whose properties you're looking at by choosing a different existing object from the list at the top of the Property Sheet dialog box.

For complete information on the available properties, see "About Object Properties".


Toggle Grid

The Toggle Grid icon shows or hides the available grid. Used in Edit mode, the grid is useful for sizing objects precisely since it contains a dot every tenth of an inch. See "Working with the Grid".


View Snap Points

The View Snap Points icon shows the snap points on each object. Snap points are useful in tying objects together with lines. For example, you can create a line between a text box description pointing to an object, such as a circle, by using a line to connect snap points on the text box description and the circle object. Then, like a leader line, when you move the circle to a new location, the attached line stretches and shrinks to accommodate the new position of the circle.

To use snap points as described in the above example,

  1. Create a circle object.

  2. Create a line object.

  3. In edit mode, select the View Snap Points icon from the Layout Bar. You will notice that objects on the grid that have an area will display blue-colored points. These blue points are snap points.

    Sample circle showing five snap points

  4. Select the line and drag one end of it until the end rests directly on the desired snap point of the circle. Try moving the circle object; the line is attached to the circle object's snap point.

  5. Create a text object for a description for the circle and edit it with a brief description.

  6. Select the other end of the line and drag it until it rests on one of the snap points of the text object.

  7. Now select and drag either the text box description or the circle object. Notice that the line object gets longer or shorter and moves so that there's always a straight line between the used snap points of the two objects.

To detach objects attached to a snap point, simply drag the attached end of the object off of the snap point.

Snap Points vs. Leader Line objects

Most of the time you will probably use the Leader Line object instead of snap points. It has nearly all the same functionality as snap points and is easier to use (see the "Leader Line Object" topic). One advantage snap points have over the Leader Line object, is their ability to support more than one line between objects and their ability to fit the connecting line exactly to a snap point. For example, with snap points you can create a more complex shape directly in the edit mode, as shown here:

Sample Cylinder created with two four lines fitted to snap points on the two filled circles.

Supported Objects

Only Line and Polyline objects can attach to objects that have snap points. Below are the objects that have snap points:

  • Text

  • TextVar

  • Border

  • Ellipse

  • Bitmap

  • Dimension Color Key

  • Histogram

  • Feature Text

  • Dimension Info

  • Point Info

Viewing Attached Objects

On complex pages with a lot of objects, you may find it useful to use the View | Route menu option to see the chain of objects connected to the currently selected object. This menu option selects all objects connected in some way by snap points to the currently selected object.


Toggle Ruler

The Toggle Ruler icon allows you to turn on or off the ruler located on the top and left sides of the grid. The ruler shows the size of the grid in inches or centimeters. It also displays your cursor's position along the grid's horizontal axis (top ruler) and vertical axis (side ruler). You can switch between Inches or Centimeters by right-clicking on the ruler and selecting the desired option from the shortcut menu.


Zoom In or Out

These icons allow you to zoom in or out of your Hyper report and then restore the original view:

Zoom in 100% - This zooms in on your report by 100 percent per click. You can click this icon at most five times to get a 500 percent zoom.

Zoom out 100% - This zooms out of your report by 100 percent per click if you're already zoomed in. If you haven't zoomed in at all, you will only be able to zoom out by 100 percent one time.

Zoom to 1:1 - This restores the size of your report to the original 1 to 1 zoom size.

No matter what you zoom to, PC-DMIS restores the original zoom whenever you activate a control that has an "activated" or "deactivated" mode (for example, double-clicking on the CadReportObject or GridControlObject). When you leave these controls and return to the editing environment, the zoom size goes back to what it was.


Group

The Group icon allows you to select multiple objects and group them together. Once grouped, the editor will show the grouped objects as one object.

To group multiple objects, either hold down the SHIFT button, and select all objects in the group, or box-select all objects, and then click the Group icon.


Ungroup

The Ungroup icon restores object in a group to their individual ungrouped states. To do this, select a grouped object and click Ungroup.


Regroup

The Regroup icon regroups the last ungrouped set of objects without your having to reselect the individual objects.


Align Edges

The Align Edges icon provides you with these additional icons that allow you to arrange a set of selected objects along their left, right, top, or bottom edges:

Aligns selected objects along their left edges

Aligns selected objects along their right edges

Aligns selected objects along their top edges

Aligns selected objects along their bottom edges


Align Center

The Align Center icon provides you with these additional icons that allow you to center selected objects either horizontally or vertically:

Centers selected objects along the horizontal axis

Centers selected objects along the vertical axis


Space

The Space icon provides you with these additional icons that allow you to equally space selected objects either horizontally or vertically:

Equally spaces selected objects along the horizontal axis

Equally spaces selected objects along the vertical axis


Make Same Size

The Make Same size icon provides you with these additional icons that allow you to equalize the width, the height, or both the width and height of all selected objects:

Equally sizes the widths of the selected objects

Equally sizes the heights of the selected objects

Equally sizes both the widths and the heights of the selected objects


To Front or Back

The To Front or Back icon provides you with additional icons that allow you to place a selected object (or objects) in front or in back of other objects. This is helpful when you have multiple objects on top of each other and you want certain objects to be visible. The available icons include the following:

Moves the selected object(s) in front of all other objects so that it is shown on top

Moves the selected object(s) behind all other objects so that is shown beneath

Note: Moving objects in front of or behind other objects is subject to an internal drawing level used by the different objects. This means you can only bring objects in front of other objects of the same drawing level. For example, Label and Section Cut objects belong to Level 1. Leader Line and Text objects belong to level 2. CAD Report objects belongs to level 3. All other objects belong to level 4. The display sequence of the levels is level 1, 2, 3, and 4, with objects in level 1 being the top-most objects. You cannot, for example, bring a Text object in front of a Label object as it is limited by its drawing level.


Undo the Last Action

The Undo the Last Action icon will undo the last action you took in the editor.


Working with the Grid

When working in a form or template editor, PC-DMIS can display or hide a grid on the background of your form or template by clicking the Toggle Grid icon from the Layout Bar or by pressing CTRL + G.

You can use this grid as a tool for the accurate placing and/or sizing of objects and how to control a template's margin guidelines.

A - Guidelines

B - Grid markings

Example showing the default grid's markings and guidelines

Select Edit | Layout | Grid Settings to access the Grid Settings dialog box.

Grid Settings dialog box

You can then use this dialog box to customize the grid. For a description of the controls in this dialog box, see the table below:

Dialog Box Control

Description

Show Grid check box

The Show Grid check box toggles the display of the grid.

Snap to Grid check box

The Snap to Grid check box determines whether or not controls placed on the grid get moved, or snapped, to the nearest grid location.

Spacing area

The Spacing area sets the amount of spacing between the grid markings. The smaller you set these numbers, the closer together the grid markings will be.

Guidelines area

The Guidelines area allows you to determine the location of the top, left, right, and bottom margin guidelines for the template editor.

The value in each of these boxes sets the distance in grid markings to where the guideline will be set. Setting the value to zero will remove the guideline completely.

You cannot place objects beyond these guidelines.


Redo the Previously Undone Action

The Redo the Previously Undone Action icon will redo the action that was undone when you clicked the Undo the Last Action icon.


About Properties

About Object Properties

Each object added to a template or form has a set of properties (or attributes) associated with it that control such things as the object’s position, size, colors, font, text, name, and so on. Each object also has associated with it a set of event handler functions that are triggered when certain events take place, such as the clicking or double-clicking the mouse on that object. These properties and event handlers may be viewed and/or modified using the Properties dialog box, also sometimes called a "property sheet".

Accessing an Object's Properties

The Properties dialog box may be viewed by selecting an object (by single-clicking within its boundaries) and then right-clicking. Here's an example property sheet that shows a text object, named Text1, and its various properties:

Properties dialog box

A sample Properties dialog box

Viewing Properties of Available Objects

At the top of the Properties dialog box is a drop-down list. This list box contains an entry for each of the objects in your template or form, as well as some objects that always exist and cannot be deleted, such as the main editing area itself. In the Report editor, the main editing area is called the Page. In the Label Editor and the Form Editor it is called The Frame/The View.

You can view the properties for any of the objects in your form or template by selecting a different object from this drop-down list. If you have a report template with more than one section, this list only shows objects in the current section.

Note: For report templates, an additional object called Report exists that you can only access from this drop-down list. It contains two properties in the Advanced category that allow you to specify your own external executable (a .exe file) to collect user assigned properties. These properties are Template Selection Program and Part Program Execution Program. PC-DMIS runs the specified programs during template selection and during part program execution respectively.

Understanding Property Organization

Properties for each object are divided up into three main categories: Standard, Advanced, and Events. You can collapse or expand each of these categories by clicking the + or - symbol to the left of each category.

In general, Standard properties generally control color, position, and line styles. Advanced properties control such things as whether or not the object is enabled or visible. Events allow you to use the BASIC language to code specific instructions when specified events occur.

Note: ActiveX and OLE objects have an additional section, discussed in their respective topics: "ActiveX Object" and "OLE Object".

For a description of available properties, see the "Common Properties" topic, or if a description isn't found there, view object-specific documentation available from the "The Object Bar" topic. For information on Events, see the "About Events" topic.

Understanding the Name Identifier

When you insert an object to a template or form, a unique name identifier is automatically assigned to the object's ObjectCode property. Subsequent objects of the same type have the same name with an incremented numerical value behind it. For example, the editor automatically names your first Text object "Text1". It names subsequent Text objects "Text2", "Text3", and so on. You can, of course, change this value to a different name. If you do, ensure that you give it a unique name. Any BASIC scripting that makes use of an object's code must also be updated if your modify that object's name identifier.

Changing Property Values

You can modify any property by selecting it, clicking its value, and either selecting a new value if it displays a drop down list, or by typing a new value if it's an edit field.

Expressions as Property Values

Some property values can hold reporting expressions instead of a constant value, just as a cell from a GridControlObject can hold expressions. Remember to preface the expression with an equals sign (=). For example, suppose you have a Text object in a label template and you want it to display the current feature's ID instead of some other text. In the Text property, you would type "=ID". During execution, it would pull the feature's name from PC-DMIS and display it in that Text object.

More:

Common Properties

Page Properties

The Frame/The View Properties

Working with User Assigned Properties

Clearing Template Associated Data

About Events and Visual Basic Code


Common Properties

The following are properties taken from a sample Text object. These properties also make up the core set of properties for many other objects. Properties specific to an object are documented in that object's documentation. Events properties are detailed in the "About Events" topic.

Common Standard and Advanced Properties

Common Properties

Description

(Object Code)

Unique name that identifies an object in a template or form. Whenever you need to access a property or method of an object using the BASIC language, use the following syntax: {Object Code}.{property or method name}

Alignment

Text alignment within the text object’s defining rectangle.

Auto Size

This determines whether or not the object sizes itself automatically based on the length of the text it contains. If set to YES the object and Word Break is set to NO, the text object will automatically adjust its width. If set to YES and Word Break is YES, the text object will automatically adjust its height.

AnchorSnaps

Field which allows you to create, delete or modify snap points by using the Enter Snap Points dialog box. Snap points are found on the ellipse, rectangle, text box, or bitmap image objects.

You can connect Line or Polyline objects to an object's snap points by dragging the tip of the line onto the displayed blue snap point.

Once connected, when you drag the object to a new location, the resulting line remains connected to the snap point, rotating, elongating, and shrinking as necessary. This feature is helpful when you need to create a "leader-line" that constantly points to an object that you'll frequently be moving.

To display snap points, from the Layout toolbar click the View Snap Points icon:

BackColor

Background color of the object. This color is used to fill the object’s defining rectangle.

Nil - This stands for no value. It means the background will be transparent, allowing other colors of objects behind this object to show through. By default, anything with a BackColor property will be set to Nil.

Technically, setting the color to Nil actually defines the color as RGB(255,255,254). That color is then made transparent within the Report window.

If you try to specify a color of RGB(255,255,254), PC-DMIS will automatically set it to RGB(255,255,255), a non-transparent color. This will not affect what you visually see.

Be aware that if your label has a bitmap image that uses the color RGB(255,255,254), that color will be made transparent inside the Report window.

BorderStyle

Style of border drawn around the object.

Bottom

Distance, in pixels, of the bottom of the object’s rectangle from the top of the template or form.

CursorPointer

Cursor displayed when the user drags the mouse over the object.

Enable

Enable or disable the object. A disabled object may still be visible, but will not respond to user input.

Font

Font used for text rendered in the object.

ForeColor

Foreground color of the object. In the case of the text object, specifies the text color.

HatchStyle

Hatch style used in filling the background box of the object.

HelpContextID

This is the context ID of a specific help topic to call. This is often used in conjunction with the Help button type which invokes WinHelp( ).

HiliteColor

(This object not included with PC-DMIS)

Layer

This assigns the current object to the selected layer.

Left

Distance, in pixels, of the left side of the object’s rectangle from the left side of the template or form.

Orientation

Orientation of the text inside the object. Horizontal text flows from left to right. Vertical Up flows from bottom to top. Vertical Down flows from top to bottom.

Padding

This property adds pixels of white space around the text by the given amount.

PenWidth

Width of the pen used to draw the object. In the case of the text object, the pen width only affects the border drawn around the text.

Right

Distance, in pixels, of the right side of the object’s rectangle from the left side of the template or form.

ShadowStyle

Shadow effect used when rendering the object.

Tag

Place holder that stores user-defined data.

Text

Text appearing in the text object. You can also type an ampersand symbol (&) in front of any alphanumeric character in this field to create a shortcut key (shown as an underlined character) that when pressed with the ALT key in Run Mode, causes that control to immediately have the focus. If you plan on using a lot of shortcut keys, you can ensure they are unique by using the Edit | Layout | Check Mnemonics menu item in Edit Mode.

ToolTipText

Text displayed when you move the mouse over the object inside Run mode.

Top

Distance, in pixels, of the top of the object’s rectangle from the top of the template or form.

Visible

Visibility state of the object. A value of 1 corresponds to visible, 0 to hidden.

Word Break

Determines whether or not the text object can hold more than one line of text. If set to YES, then text strings that exceed the width of the object container will wrap within the object container. If set to NO, then text strings remain on a single line.

PC-DMIS Commands

(Appears only for objects added to the Custom Report Editor)

Adds or Removes command references to existing objects in your report. Select an object in your report, and select this property. The PC-DMIS Commands dialog box appears.

PC-DMIS Commands dialog box

All the commands in your part program appear in the expandable and collapsible list on the left. The right-hand list displays all the commands referenced by the object.

  1. Select the commands from the left-hand list that you want the selected object to reference. They will appear in the right-hand list is the object supports taking multiple commands. However, In most cases, you will only be able to select one command.

  2. Click OK. The dialog box closes and PC-DMIS now references the new command in the selected object.

This essentially provides an alternate approach to updating an object to use different data from the part program. See "Dragging and Dropping Information into a Custom Report" for the usual way of updating objects.

For objects that support multiple commands (such as the GridControlObject), this dialog box lets you change the order of referenced commands.

PC-DMIS References

(Appears only for objects added to the Custom Report Editor)

Tracks the commands referenced by the selected reporting object. During report generation, for each command, PC-DMIS checks the command references of each object. If that object indicates that it has a reference to the command being processed, PC-DMIS sends the command data to that object.

Most objects only support one command at a time, but some objects can support data from multiple commands (such as the GridControlObject). If you drag and drop commands into the Custom Report Editor, PC-DMIS takes care of managing the references for you internally. You should only need to use this property if you decide to have manual control over which commands are referenced for some reason.


The Frame/The View Properties

The main editing area in the Label Template Editor and the Form Editor contains a special object called The Frame/The View. This object also contains properties that can be accessed and set just as with any other object.

Property

Used in Label Template Editor or Form Editor

Description

Height

Both

Defines the height, in pixels, of the main editing area.

Width

Both

Defines the width, in pixels, of the main editing area.

LocalDecls

Both

Declares variables with a scope available to your entire form or label.

Page Orientation

Label Template Editor

Sets the label to one of the pre-defined standard orientations, either Portrait or Landscape.

Page Size

Label Template Editor

Sets the label to one of the page sizes available on your default printer. You may see items such as Letter, A4, or one of several other sizes depending on your type of printer.

Supported Command Types

Label Template Editor

Displays the Supported Command Types dialog box. With this dialog box you can define what commands should use this label template. Then in the Report window, when you right-click on a label and select the Change Report... menu item, PC-DMIS will only display those labels that support the selected command type.

Horizontal Positioning

Form Editor

Sets the horizontal position of the form within the window when executed.

LocalVariables

Form Editor

See the ”Declare Global Using the LocalVariables Property” topic.

MaximizeBox

Form Editor

If set to Yes, this displays a Maximize icon in the upper right corner of the form. Clicking this icon run mode or during execution allows you to maximize your form window to fill the available space.

If MaximizeBox is set to Yes but MinimizeBox is set to No, then the Minimize icon will still appear but will be unavailable for selection.

MinimizeBox

Form Editor

If set to Yes, this displays a Minimize icon in the upper right corner of the form. Clicking this icon during run mode or during execution allows you to minimize your form window to the taskbar.

If MinimizeBox is set to Yes but MaximizeBox is set to No, then the Maximize icon will still appear but will be unavailable for selection.

Vertical Positioning

Form Editor

Sets the vertical position of the form within the window when executed.

ToolTipText

Both

Common Properties


Section and Page Properties

The main editing areas in the Report Template Editor and the Custom Report Editor, are special objects called the Section and the Page respectively. These objects contain properties that can be accessed and set just as with any other object.

Property

Description

Height

Defines the height, in pixels, of the main editing area.

Width

Defines the width, in pixels, of the main editing area.

(FormCode)

Defines the name of the Page.

Command Set

Defines how commands get processed within the current section (Page tab).

All Commands - The setting will process the entire command set in the current section (Page tab). This is the default value.

Continue from Previous Section - This setting continues to process the command set from the previous section, continuing where the last section stop processing.

Same as Previous Section - This setting will cause the section (Page tab) to take exactly the same command set as the previous section. The head section and all subsequent sections with this setting will form a mini-group. All subsequent sections in the mini group will create one page with the head page.

LocalDecls

Provides a window for you to declare variables local to this object. Once declared you can use these variables in events that affect the object. This type of declaration lets you give the variable a value in one event and then check that value in a different event. The variable is safe from accidental modification since it is invisible to other objects in the report or form.

Local Variables

See the ”Declare Global Using the LocalVariables Property” topic.

Maximum Number Of Pages

Defines the maximum number of report pages that will use the design of the current Page tab.

For example, if you set this value to 2, but you have easily enough dimensions in your part program to fill five pages, the section will not process commands once the number of pages for that section reaches the specified maximum of two pages. The current process command will need a newly created section (Page tab) in order to display additional information.

The default value of 0 means there is no maximum and so all pages will be displayed.

ToolTipText

Common Properties

Examples of "Command Set" and "Maximum Number of Pages" Properties

In the following examples suppose that your report template has four sections named A, B, C, and D and that each contains a TextReportObject. Additionally, suppose that your part program has enough dimensions to display three pages of dimensions per section. For each example, a table will detail the property settings.

Example 1

Sections | Maximum Number of Pages | Command Set
A | 0 | All Commands
B | 0 | All Commands
C | 0 | All Commands
D | 0 | All Commands

In this example, PC-DMIS would display the pages in the final report like this:

A1,A2,A3,B1,B2,B3,C1,C2,C3,D1,D2,D3

Example 2

Sections | Maximum Number of Pages | Command Set
A | 1 | All Commands
B | 0 | All Commands
C | 0 | All Commands
D | 1 | All Commands

In this example, PC-DMIS would display the pages in the final report like this:

A1,B1,B2,B3,C1,C2,C3,D1

Example 3

Sections | Maximum Number of Pages | Command Set
A | 1 | All Commands
B | 0 | All Commands
C | 0 | Same As Previous Section
D | 1 | All Commands

In this example, PC-DMIS would display the pages in the final report like this:

A1,B1,C1,B2,C2,B3,C3,D1

Example 4

Sections | Maximum Number of Pages | Command Set
A | 1 | All Commands
B | 0 | Continue From Previous Section
C | 0 | Same As Previous Section
D | 1 | All Commands

In this example, PC-DMIS would display the pages in the final report like this:

A1,B2,C2,B3,C3,D1


Working with User Assigned Properties

Sample Property Sheet for a Text object. Notice the user definable check boxes on the left.

Sample Property Sheet for a Text object. Notice the user definable check boxes on the left.

User Assigned Property dialog box

User Assigned Property dialog box

Define User Assigned Properties dialog box

Define User Assigned Properties dialog box

User Assigned Properties dialog box

User Assigned Properties dialog box

Prompt Style list

Delete Property icon

Delete Property icon

Move Property Up Move Property Down

Red Up and Down Arrows

User Assigned Property dialog box

User Assigned Property dialog box

Working with User Assigned Properties

In the Report Template Editor in version 4.0, the Properties dialog box contains a very handy feature, the ability to make a property user definable. This allows you to let program operators change object properties at runtime.

For example, suppose you want your report title to change dynamically according to whatever the current part program operator wants. You can easily add an interactive approach such as this to your reports by using this functionality.

To Make a Property User Assigned:

  1. Select an object in one of the editors. For our example above, you would select a Text object.

  2. Right-click on the object. This causes the property sheet for that object to appear on the right side of the editor. On the left side of the property sheet you will see check boxes next to most properties. These check boxes determine what properties you can make user definable.

  3. Select the check box next to the property you want to make definable. For our example above, you would select the Text property for a Text object. A User Assigned Property dialog box appears asking you to determine the message that will prompt the user for the property value and when the user should be prompted.

  4. In the Prompt box, type the prompt the user will receive, then select from one of the two option buttons when the user will receive the prompt. You can choose to prompt the user either during template selection or part program execution.

  5. Click OK. The User Assigned Property dialog box closes.

  6. Save the report template and return to your part program.

  7. Now to test this, use the Report window, click the Template Selection icon and select the report template from the dialog box, then execute your part program.

  8. At some time during the previous step, PC-DMIS will display the Define User Assigned Properties dialog box to prompt you for the properties' values according to the option button you selected in the User Assigned Property dialog box

To View and Manipulate all Your User Assigned Properties:

  1. Access a report or label template that has user definable properties.

  2. Select Edit | User Assignable Properties. The User Assigned Properties dialog box appears. This dialog box shows those properties that will be presented during template selection or part program execution.

  3. Select an item from the Prompt Style drop-down list to filter what gets displayed in this dialog. The user assigned properties appear in the list box below. The list box tracks all the properties, what objects they belong to, and their prompts.

    • To remove a property, select the property and click the big red X. That object's property will no longer be user definable and will use the default value already defined in the template.

    • To reorder a property, select the property you want to move and then click the red up or down arrows. This will move the selected property up or down in the list.

    • To change a property's prompt or when the prompt should appear, double-click on the property in the Feature column. PC-DMIS displays User Assigned Property dialog box, allowing you to make the change.

Important: If you selected Prompt when user selects template from the User Assigned Property dialog box, PC-DMIS will only prompt you once for any user assigned values. Thereafter, for that part program, PC-DMIS will automatically use the initial property value until you clear out all template associated data. See the "Clearing Template Associated Data" topic in this section.

If you selected Prompt when report is executed, then PC-DMIS will automatically display the Define User Assigned Properties dialog box each time the part program is executed.


Clearing Template Associated Data

Display Menu Roadmap The File | Reporting | Clear Template Associated Data menu item removes the following items used in the current part program with the current selected report template:

  • Any user-assigned property values. By clearing these, PC-DMIS will again prompt you for values to any user assigned properties in the current template.

  • Table customizations on labels.

  • Label placement customizations around CADReportObject objects.

  • Changes to the rotation or zoom factor of any CADReportObject objects.

  • Any other object modifications, additions, or page duplications.

Display Menu Roadmap The File | Reporting | Clear All Template Associated Data menu item does the same as the above menu item but affects all report templates used by this report.

For information, on user defined properties see the "Working with User Assigned Properties" topic in this section.


About Events

About Events and Visual Basic Code

This section assumes that you have at least some background with the Visual Basic programming language. If you need to learn Visual Basic, please consult a book or other external resource on the subject.

The Events section on the Properties dialog box contains a list of event handler functions that your template or form object supports. An event handler function will be called whenever the event implied by the name of the function occurs for the given object. When that function gets called, any Visual Basic code inside that function gets executed.

Available Event Handler Functions

EventClick

Called when the mouse is clicked on the object.

EventDblClick

Called when the mouse is double-clicked on the object.

EventDragDrop

Called when another "draggable" item is dropped onto the object.

EventDragEnter

Called when a draggable item is initially dragged onto the object.

EventDragOver

Called when a draggable item is dragged over the object.

EventInitialize

Called when the form first enters into Run Mode before any other handlers are called on the object.

EventMouseDown

Called when a mouse button is depressed while over the object. Parameters passed to the function indicate which button was pressed, if the SHIFT key was pressed, and the coordinates of the mouse at the moment the mouse button was depressed.

EventMouseMove

Called when the mouse is passed over the object. Parameters passed to the function indicate which button was pressed, if the SHIFT key was pressed, and the coordinates of the mouse when the move event was sent.

EventMouseUp

Called when the mouse button is released over the object. Parameters passed to the function indicate which button was pressed, if the SHIFT key was pressed, and the coordinates of the mouse at the moment the mouse button was released.

EventPumpData

This is perhaps the most widely used handler function in the Form Editor. EventPumpData is called whenever BASIC variables that may affect the object change value. Your code can also force EventPumpData to be called on individual objects (or on all objects in a report) when you wish an object to update itself. Basically, any code that an object needs to reinitialize itself based on variable values or the state of other objects should occur in EventPumpData.

EventTerminate

Called when the report is being closed or when toggling from Run Mode to Edit Mode in the Form editor.

This handler function is only available for the Section editing environments.

EventReportData

This is perhaps the most widely used handler function in the Report and Label Template editors. It gets called whenever report data gets plugged into the current template.

Its primary function is to let you create your own ActiveX controls that get placed into a label. For example, PC-DMIS's best fit and feature analysis controls use this event to sent data to the ActiveX control from the command. To see this, open the label named best_fit_analysis.lbl, click on the ActiveX control inside the label, and then look at the BASIC code inside its event handler. A single line passes data from the command into the control.

With data passed to your own ActiveX control, you can then use Automation commands to extract and manipulate the data. See the Pcdbasic help file for information on PC-DMIS automation.

Important: This event gets called once for each command when applying the report template or during program execution.

Adding Code to Event Handlers

In order to add BASIC language code to any of the event handlers:

  1. Click on the function’s entry from the list of event handlers. A Mini Visual BASIC language editor will appear, with the opening and closing statements of the subroutine already filled in.

  2. Type additional BASIC language statements code into the editor.

  3. Click OK.

  4. Test your code.

    • If you are using the Form Editor, test your form by pressing CTRL + E to enter Run mode.

    • If you are using one of the template editors, test your code by applying the template to a report and redrawing the report using the Redraw Report icon from the Reporting Toolbar.

Note: Since you don't interact with clickable buttons, lists, fields, or other interactive elements when using a report, the only event handler function available is the EventReportData function.

More:

Event Example 1: Calling Code on an EventClick Event

Event Example 2: Modify Object Properties on Triggered Event

Access Object Methods


Event Example: Calling Code on an EventClick Event

Example of a Button Object's Events

Example of a Button Object's Events

Event Example 1: Calling Code on an EventClick Event

This event example uses a Button object. To test this, you will need to use the Form Editor.

  1. Display Menu Roadmap Select View | Form Editor to access the Form Editor.

  2. First, insert a button into your form by clicking on the Button icon on the Object toolbar and then dragging out a rectangle for the button onto the form.

  3. Make sure that the button is selected (highlighted).

  4. Right-click on the button to bring up the dialog showing the button’s properties.

  5. If not expanded, click on the + sign next to the Events section to expand the list. You should see a list of all of the available event handler functions for the button object.

  6. double-click on the EventClick function in the list. A Visual BASIC Editor entitled VBS Mini-Editor opens.

  7. Add the following code to the EventClick function inside the VBS Mini Editor:
    MsgBox ”I've been clicked."    .

  8. Click the OK button in the upper right hand corner of the VBS Mini-Editor. Close the Property Sheet.

  9. Save the report by selecting File | Save. You are now ready to test the report in Run Mode.

  10. Switch to Run Mode (press CTRL + E).

  11. Click on the button you created. A message box with the text I’ve been clicked! should appear.

This simple example illustrates the basics of scriptable forms and event handlers.


Modify Object Properties on Triggered Event

Event Example 2: Modify Object Properties on Triggered Event

This exercise follows the above exercise, you should have completed it first. This example also uses the Form Editor.

Suppose you want to modify the properties of another object (say the text in a text object) when the button has been clicked.

  1. Display Menu Roadmap Select View | Form Editor to access the Form Editor.

  2. Switch back to Edit Mode (press CTRL + E).

  3. Create a new text object.

  4. Open the text object’s properties (select and then right mouse click).

  5. Make sure that the text item’s Object Code property reads ”Text1”. The Object Code property is the name that is used to refer to that object from BASIC code.

  6. If not expanded, click on the + sign next to the Events section to expand the list.

  7. double-click on the EventInitialize handler function. The VBS Mini-Editor opens.

  8. Add the following code to the EventInitialize function:
    Set This = Text1

  9. Press the ENTER key to get to a new line. On the next line type this code:
    This.Text = ”The button has not yet been clicked”

  10. Click the Ok button to close the editor.

  11. Once the object Text1 has been set up as described, open the property sheet for the button object added in the prior exercise.

  12. Click the Events tab.

  13. double-click on the EventClick function.

  14. Replace the basic code you added in the previous example with the following two lines:
    Line 1: MsgBox ”I’ve been clicked, and am about to modify Text1’s text”

    Line 2: Text1.Text = ”The button was clicked!!!”

  15. Click the OK button to close the VBS Mini-Editor.

  16. Close the Property Sheet.

  17. Switch to Run Mode (press CTRL + E). The code you added to Text1’s EventInitialize function will set Text1 to initially read ”The button has not yet been clicked”.

  18. Now try clicking on the button. The ”I’ve been clicked, and am about to modify Text1’s text” message should appear. As soon as you close the message box, Text1’s text should be modified to read ”The button was clicked!!!”.

This example illustrates how the properties of any object in a form may be accessed from Basic code via the ObjectCode.property_name syntax.


Access Object Methods

Many of the objects support various methods in addition to their properties. These methods may be accessed from BASIC code via the ObjectCode.method_name syntax. This means you can see what properties and methods are available for any given object by typing the object’s Object Code in the VBS Mini-Editor followed by a period. As soon as the period is typed, a mini wizard will pop up showing the available methods and properties for that object.

So if you had a text object named "Text1" you could type "Text1" followed by a period and a list of available methods or properties for a text object would appear.

Variables declared within an event handler function (via the BASIC Dim var_name as var_type syntax) are in scope only during that event handler function. There will undoubtedly arise situations when you would like to declare variables, functions, or subroutines that are accessible from all BASIC code in a template or form—variables with global scope for a particular report. The template and form editors provide a place to make these declarations.

More:

Declare Global Variables Using the LocalVariables Property

Declare/Define Variables, Functions, or Subroutines


Declare Global Variables Using the LocalVariables Property

If you wish to declare global variables of any of the standard data types (String, Integer, Double, etc.) and have them show up in the Basic Wizard, you can use the LocalVariables property of The Frame/The View or Section.

To use the LocalVariables property:

  1. Open the Property Sheet for The Frame/The View. Do this by selecting, then right-clicking on an object. The Property Sheet will appear.

  2. Select the Settings tab.

  3. Scroll down to the LocalVariables property.

double-clicking on the LocalVariables property will bring up the Local Variables dialog box.

Local Variables dialog box

The Local Variables dialog box allows local variables of any of the basic types to be added, removed, named, and initial values to be set. Again, these variables are global to this template or form and will be accessible from any of the BASIC code written for this template or form. They will also appear in the Local Variables area of the Script Wizard.

Note: The name ”LocalVariables” is something of a misnomer, since variables declared in the Local Variables dialog box actually have a global scope to that particular template or form. It indicates that the variables declared here are "local" to this particular template or form and cannot be accessed on other forms. Nevertheless, they are set as global variables, available to other routines elsewhere in the template or form they are defined from.


Declare/Define Variables, Functions, or Subroutines

To declare and/or define variables, functions, or subroutines that are to be accessible from all BASIC code in a report, use the LocalDecls property of The Frame/The View found on the PC-DMIS tab of the Property Sheet. To do this:

1. Open the Property Sheet for an object.

2. Select The Frame/The View from the drop-down list.

3. Click on the PC-DMIS tab.

4. double-click on the LocalDecls item on the property sheet. A VBS Mini-Editor appears.

You may add any BASIC code you wish to this window, including variable declarations and function or subroutine definitions. Any variables, functions, or subroutines declared here will be global, but will not appear in the Script Wizard.


Run Mode - This mode only works with the Form Editor. In Run Mode you can run (or execute) your form, testing it for how it would look or behave in an actual part program execution environment.

Edit Mode - This is the default mode for all the reporting editors and is the only mode for the Report and Label template editors.

You can switch between run and edit modes by pressing CTRL + E.

Understanding the Report Template Editor

You can access the Report Template Editor by selecting Display Menu Roadmap File | Reporting | New | Report Template. You can also open an existing report template by selecting Display Menu Roadmap File | Reporting | Edit | Report Template.

PC-DMIS displays the Report Template Editor in a new window.

Report Template Editor

Report Template Editor

The Report Template Editor acts as a work area, allowing you to drag, size, and place various objects and set their properties. You place your objects on top of the white area, called the template or section. If you have worked with legacy (HyperView) reporting in previous versions of PC-DMIS, you will feel at home with this editor since it essentially functions much the same way and contains many of the same user interface elements.

With the new template approach to reporting, you cannot place the Report or Label template editors into Run Mode. They only open in Edit Mode and cannot be switched. Run Mode still functions with the Form Editor.

The editor contains the following elements:

  • The Menu bar

  • The Font Bar (toolbar)

  • The Object Bar (toolbar)

  • The Layout Bar (toolbar)

  • Object Property Sheets

  • Sections

  • Working with the Grid

More:

About Sections


About Sections

Sample Sections

Sections make up the main editing area in a report template. These tabbed, scrollable areas in the Report Template Editor are where you can insert objects into your current report template. Sections give you greater control over when objects appear in your report.

In versions prior to PC-DMIS 4.0, creating and maintaining a multiple page HyperView report where certain objects only appeared on certain pages involved a somewhat cumbersome approach. It required complex coding with a liberal dose of layers to hide and show various objects on various pages. With the new Report Template Editor, you can easily add additional sections to your template and create powerful multi-section reports with ease.

Sections, however, are not the same as pages. Objects inserted into one section will not be displayed in other sections but will be displayed in multiple pages of the same section. This approach lessens the complexity of creating report items like headers and titles that you want to remain static.

For example, you might choose to place a description of the report and author data on the first section of your template, a TextReportObject onto the second section, and a CadReportObject onto the third section. Then, depending on the length of your report data, each section in your report may spawn up to several pages.

Sections are only used in the Report Template Editor. Before version 4.0, the main editing area for HyperView reports was called, "The Frame/The View". This name is still used in the Form Editor and the Label Template Editor where sections are not used. For the Report Template Editor, the editor's "Section" is where you place your reporting objects.

To Add a New Section

  1. Make sure your Report Template Editor window is maximized.

  2. Scroll to the very bottom of your template.

  3. Right-click on the Section1 tab.

  4. Select Insert from the shortcut menu. PC-DMIS inserts a new section, Section2, into your template. Your template should now have two sections, like this:

To Delete a Section

  1. Make sure your Report Template Editor window is maximized.

  2. Scroll to the very bottom of your template.

  3. Right-click on the section tab you want to delete.

  4. Select Delete from the shortcut menu. PC-DMIS deletes the section.

To Modify a Section's Properties

  1. Make sure your Report Template Editor window is maximized.

  2. Scroll to the very bottom of your template.

  3. Right-click on the section itself. The Properties dialog box appears.

  4. Modify the properties as desired. To rename a section, rename the section's FormCode property.

Spanning Command Sets Across Sections to Control Page Layout and Output Collated Pages

Prior to PC-DMIS 4.2 there was no way to span a command set from one report template section to another. Now, two new properties have been added to section (Page) objects that provide this functionality, making it easier to create different pages with different layouts while using the same command set. You can use these properties as well to output the report as collated pages. See the "Page Properties" topic for information and examples on the Command Set and Maximum Number of Pages properties.


Understanding the Label Template Editor

Run Mode - This mode only works with the Form Editor. In Run Mode you can run (or execute) your form, testing it for how it would look or behave in an actual part program execution environment.

Edit Mode - This is the default mode for all the reporting editors and is the only mode for the Report and Label template editors.

You can switch between run and edit modes by pressing CTRL + E.

About the Label Template Editor

You can access the Label Template Editor by selecting Display Menu Roadmap File | Reporting | New | Label Template. You can also open an existing label template by selecting Display Menu Roadmap File | Reporting | Edit | Label Template.

PC-DMIS displays the Label Template Editor in a new window.

Label Template Editor

Label Template Editor

This editor is similar to the Report Template Editor and the Form Editor; with the exception of some differences in its Object Bar, the user interface is essentially the same. While you can technically put any object from the Label Template Editor's Object Bar into a label template, you will generally work with the GridControlObject. The label template, is the white, sizable, box on top of the "LABEL" background.

With the new template approach to reporting, you cannot place the Report or Label template editors into Run Mode. They only open in Edit Mode and cannot be switched. Run Mode still functions with the Form Editor.

The editor contains the following elements:

  • The Menu bar

  • The Font Bar (toolbar)

  • The Object Bar (toolbar)

  • The Layout Bar (toolbar)

  • Object Property Sheets


Understanding the Custom Report Editor

Run Mode - This mode only works with the Form Editor. In Run Mode you can run (or execute) your form, testing it for how it would look or behave in an actual part program execution environment.

Edit Mode - This is the default mode for all the reporting editors and is the only mode for the Report and Label template editors.

You can switch between run and edit modes by pressing CTRL + E.

About the Custom Report Editor

You can access the Custom Report Editor by selecting Display Menu Roadmap File | Reporting | New | Custom Report. You can also open existing custom reports, if any, for your current part program by selecting Display Menu Roadmap File | Reporting | Edit | Custom Report.

PC-DMIS displays the Custom Report Editor in a new window. If the Edit window is open PC-DMIS automatically places it into Summary mode.

Custom Report Editor

Custom Report Editor

This editor is similar to the Report Template Editor, the Label Template Editor, and the Form Editor; with the exception of some differences in its Object Bar, the user interface is essentially the same.

The custom report is the white, sizable, area on top of the "CUSTOM" background. Note that when using this editor, you are not creating a template, but are creating the actual report that will be displayed in the Report window. Usually, you will want to run this editor side by side with the Edit window set in Summary mode so that you can drag the desired objects from Summary mode onto your Custom Report. See "Creating Custom Reports".

With the Custom Report Editor, you cannot place the Report or Label template editors into Run Mode as you did with the HyperView editor. It only opens in Edit Mode and cannot be switched. Run Mode still functions with the Form Editor.

The editor contains the following elements:

  • The Menu bar

  • The Font Bar (toolbar)

  • The Object Bar (toolbar)

  • The Layout Bar (toolbar)

  • Object Property Sheets


Run Mode - This mode only works with the Form Editor. In Run Mode you can run (or execute) your form, testing it for how it would look or behave in an actual part program execution environment.

Edit Mode - This is the default mode for all the reporting editors and is the only mode for the Report and Label template editors.

You can switch between run and edit modes by pressing CTRL + E.

Understanding the Form Editor

Display Menu Roadmap You can access the Form Editor by selecting View | Form Editor. PC-DMIS displays the Form Editor in a new window.

Form Editor

The Form Editor acts as a work area, allowing you to drag, size, and place various interactive form objects, such as buttons, list boxes, edit boxes, and so forth, and to set their properties. Objects get placed on the gray, sizable area, called a form. If you have worked with HyperView reporting in previous versions of PC-DMIS, you will feel at home with this editor since it essentially functions much the same way and contains many of the same user interface elements.

With the new template approach to reporting, only the Form Editor can use the Run Mode capability. The report and label template editors do not use it.

The editor contains the following elements:

  • The Menu bar

  • The Font Bar (toolbar)

  • The Object Bar (toolbar)

  • The Layout Bar (toolbar)

  • Object Property Sheets

  • Object Sheet


Creating Templates

While PC-DMIS comes with some pre-designed templates that fit most users' needs, you can, of course, delve into the powerful template editors to create your own report and label templates. You can also use the Form Editor to create a more interactive approach to execution and reporting.

The following topics discuss how to create your own templates by using the report template and label template editors.

Hint: New to template reporting? Follow the "Creating a Report Template" tutorial and the "Creating Label Templates" tutorial.

More:

About the Common User Interface

About Reports and Report Templates

About Labels and Label Templates

About Forms

About Object Properties

About Report Expressions

About the Rule Tree Editor

Changing a Template's Preview Thumbnail Icon


About Reports and Report Templates

In older versions of PC-DMIS you would have had to create a different report for each part program, but no longer. Now, PC-DMIS uses report templates. A report template is not a report, but a description for a report. The template describes what data PC-DMIS should use to create a report, where it will go, and what it will look like. You can use report templates for more than one part program, letting you quickly and easily standardize the look and feel of several reports.

You create templates inside of the Report Template Editor. Report template files have a .rtp filename extension and are created inside the PC-DMIS report template editor.

You can make report template files as simple or as complex as you like. A simple report template might contain a single TextReportObject, while a complex report template might contain several different objects, bitmap images, shapes, or even items that use the reporting expression language to detail exactly what appears from the report data.

Important: Do not confuse the report template's filename extension, .rtp with the older HyperView report filename extension, .rpt. These are completely different file formats; you cannot open up a HyperView report inside the Report Template Editor. While PC-DMIS 4.0 and later still let you run an embedded HyperView report, you will need a version of PC-DMIS that supports report (.rpt) files in order to edit them.

More:

Understanding the Report Template Editor

Tutorial - Creating a Report Template

Applying or Removing a Report Template

Sharing Report Templates


Creating a Report Template

Create a part program that measures four circles

Create a part program that measures four circles, similar to this.

Clicking these icons will launch demo movies showing how to accomplish certain tasks. When viewing these demo movies, you should maximize the help file viewer or browser window to more easily see what's happening.

  1. Select File | Reporting | New | Report Template to access the Report Template Editor. A blank report template automatically appears.

  2. Hide unused toolbars by right-clicking on the toolbar area and removing toolbars.

  3. Hide unused PC-DMIS windows by selecting the open window from the View menu.

  4. Maximize the template editor by clicking the maximize button the editor's window. You should see the words "REPORT" on the background of the editor and your editor should have a "Section1" tab at the bottom. Your Report Template Editor should now look something like this:

Hint: When working with one of the template editors, you may find it helpful to hide your usual PC-DMIS toolbars and windows, thereby freeing up some screen space. If you work frequently with templates, you may want to create a stored screen layout for your template. For information on layouts, see the "Window Layouts Toolbar" topic in the "Using Toolbars" section.

In addition, you may find it useful to create your own toolbar with the File | Reporting commands on it. For information on creating custom toolbars, see the "Customizing Toolbars" topic in the "Customizing the User Interface" section.

Report Template Editor

Step 1: Report Template Editor

  1. From the Object Bar, click on a Text object.

  2. Insert it into the report by dragging a rectangle onto the current section. When you release the mouse, the object is selected, as shown by small green squares, called handles, at each corner of the object.

  3. Select the Text object you inserted, and drag the green handles so that it has a height of 1 inch and a length of 6 inches. Use the Ruler Bars on the top and left border of the editor as needed. Select View | Ruler Bars if the rulers aren't available.

  4. Right-click on the Text object.

  5. Select the BackColor property and change it to a light blue color (0.255.255).

  6. Click the ForeColor property and change it to a dark blue color (0.0.128).

  7. Select the BorderStyle property and change it to Normal.

  8. Click the LineWidth property and change the value to 5.

  9. Click the Text property and change it to "A Custom Report".

  10. Click the Font property. The Font dialog box appears.

  11. Change the Size to 20, the Font Style to Bold, and the Font to Arial.

  12. Click OK.

You have formatted your text object. It should look similar to this:

See a brief demo on inserting and formatting a Text object

A sample Text object showing handles

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

  1. Select the Text object you created in the previous step.

  2. Right-click on the object. This causes the Properties dialog box for that object to appear on the right side of the editor. On the left side of the dialog box you will see check boxes next to most properties. These check boxes determine what properties you can make user definable.

  3. Select the check box to the left of the Text property. A User Assigned Property dialog box appears asking you to determine the message that will prompt the user for the property value and when the user should be prompted.

  4. In the Prompt box, type "Type Your Report's Title Now".

  5. Select the Prompt when executing Part Program option.

  6. Click OK. The User Assigned Property dialog box closes.

  7. Select the check box to the left of the BackColor property. In the resulting dialog box, type "Choose Your Background Color Now" for the prompt and once more choose the Prompt when report is executed option.

  8. Click OK. The User Assigned Property dialog box closes.

In this step, you selected two properties and made them "user assignable". This means whoever executes your part program will be able to set these properties.

See a brief demo on making properties user assignable.

Sample Property Sheet for a Text object. Notice the user definable check boxes on the left.

Sample Property Sheet for a Text object. Notice the user definable check boxes on the left.

User Assigned Property dialog box

User Assigned Property dialog box

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

  1. From the editor's Object Bar, click on the TextReportObject icon. Your mouse pointer will change from an arrow pointer to a cross.

  2. Add the TextReportObject on the template by dragging a box on your template's section. PC-DMIS automatically adds some default filler report text. When you apply this template to your report, PC-DMIS will use your actual report data. This filler text simply helps you understand what your design will look like. Your object should look something like this:

  3. Size the object so that its close to the width of the Text object you added earlier. You can size the object by clicking and dragging one of the green boxes (or "handles") surrounding the object.

  4. Select the Text object you added earlier. Hold down the SHIFT key and select the TextReportObject. This selects both objects.

  5. With both selected, use the Layout Bar and click the appropriate Make Same Size and Align Center icons to make the objects the same width and to align them so that they are centered in between the left and right sides of the editor.

Your template should now have a TextReportObject on the first section.

See a brief demo on inserting a TextReportObject and on using aspects of the Layout Bar

Text Report Object with Filler Text

Sample TextReportObject

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

  1. Make sure your Report Template Editor window is maximized.

  2. Scroll to the very bottom of your template.

  3. Right-click on the Section1 tab.

  4. Select Insert from the shortcut menu. PC-DMIS inserts a new section, Section2, into your template.

Your template should now have two sections, like this:

See a brief demo on creating new sections.

Example of Two Sections

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

  1. Click on the Section2 tab to make that the active section.

  2. From the editor's Object Bar, click on the CADReportObject icon. Your mouse icon will change from an arrow pointer to a cross.

  3. Add the CADReportObject on the template by dragging a box on your template's section. Size the box so that it measures about 6 inches wide and 4 inches tall. You can size the object by clicking and dragging one of the green boxes surrounding the object.

  4. When you finish drawing the box, PC-DMIS automatically displays the Label Layout Wizard. This wizard shows a fake part surrounded by some fake labels. These dummy items are simply design aids while working in the template editor. You can use this wizards to quickly setup labels around your part. For in-depth information, see the "The Label Layout Wizard" topic. When you apply this template to your report, PC-DMIS will use your actual CAD drawing and label information.

  5. Change the Label Count box number of labels to 4.

  6. Change the Layout Style to Elliptical Packed.

  7. Click on the small, square, white handle in the middle of the CAD drawing, and drag the square clockwise or counterclockwise to rotate the labels along the elliptical path.

  8. Rotate the labels until all four are above the CAD drawing until the Layout Preview area of the Label Layout Wizard looks like this:

  9. Click OK. PC-DMIS inserts the object into Section2.

Your Section2 layout should now contain a CADReportObject looking something like this:

See a brief demo on inserting and using the CADReportObject

Layout Preview area showing four labels elliptically packed above the CAD drawing

Layout Preview area showing four labels elliptically packed above the CAD drawing

Example CAD report object showing the four dummy labels above the dummy part

Example CAD report object showing the four dummy labels above the dummy part

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

  1. Click on the Section1 tab and right-click on the TextReportObject you inserted earlier.

  2. From the Properties dialog box, change these properties:
    ShowAlignments - OFF
    ShowComments - OFF
    ShowDimensions - None
    ShowFeatures - ON
    ShowHeaderFooter - OFF
    ShowMoves - OFF
    ShowScreenCaptures - OFF

  3. Click on the Section2 tab.

  4. Right-click on the CADReportObject you added into Section2. The right part of the screen displays a docked Properties Sheet dialog box. This dialog box contains various properties specific to the selected object.

  5. Click on Rules in the Rules Tree property. The Rule Tree Editor appears:

  6. Expand the Features heading. A list of features appears.

  7. Expand the Circles heading. A list of various circle features appears.

  8. Click the Measured Circle item, and then click the Add button. This tells PC-DMIS you are adding a rule that you want the template to follow. The Edit Rule dialog box appears. This dialog box allows you to make decisions for your report template. In this case, you are telling your report template to do something when it encounters measured circles in the part program's report data.

  9. Select the Use Label Template for Report option. The Label Name box becomes available for edit.

  10. Click the ... button. An Open dialog box appears allowing you to select a specific template file.

  11. Navigate to where you installed PC-DMIS, and open up the Reporting sub-directory. Select the summary.lbl label, and click Open. In the Edit Rule dialog box, PC-DMIS displays the name of the template you selected. See "About Labels and Label Templates" for information and a tutorial on creating labels.

  12. Click OK to close the Edit Rule dialog box and apply the rule. You will notice that the Measured Circle item in the list has a bold font to indicate that a rule exists for that feature type.

  13. Click OK to close the Rule Tree Editor dialog box.

You have created a rule that tells PC-DMIS to use the summary.lbl label template to display summary information about the measured circle feature type.

See a brief demo on determining what information the report template will display.

Rules Tree property

Rule Tree Editor dialog box

Rule Tree Editor dialog box

Edit Rule dialog box

Edit Rule dialog box

A sample Open dialog box showing several available label templates

A sample Open dialog box showing several available label templates

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

  1. Inside the Report Template Editor, select File | Save. In the Save As dialog box save the template as test1.rtp.

  2. Select File | Close to close the Report Template Editor.

  3. Select View | Report window. The Report window appears, showing the default report template.

  4. From the Reporting toolbar on the Report window, click the Template Selection Dialog icon. The Report Templates dialog box appears

  5. Add your report to the Report Templates dialog box by clicking the Add button.

  6. Navigate to and select test1.rtp. Then click Open. PC-DMIS adds a thumbnail view of your report into the Report Templates dialog box.

  7. Select your template's thumbnail icon, and click Open. PC-DMIS opens the Report window using your newly created template. It should look something like this:

  8. Finally, execute your part program. The first time you execute the part program using this report template, PC-DMIS will display a Define User Assigned Properties dialog box asking you to give the report a new title and to set the background color.

  9. Set these properties as desired and click OK. The dialog box closes and PC-DMIS runs your part program.

  10. When execution finishes, PC-DMIS will show the report data with the new template.

Congratulations! You have finished the Custom Report Template tutorial.

See a brief demo on choosing and testing a report template.

Report Templates dialog box showing Test1.rtp

Report Templates dialog box showing Test1.rtp

Report Window Showing Report Data Using the Test1.rtp Report Template

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

Tutorial - Creating a Report Template

This topic walks you through a very basic tutorial that will create a simple report template with a few objects and some labels. This should give you a basic overview of how things work together so that you can create and use your own report templates.

Note: In order to give you a good foundation on how to use the template editors, this tutorial shows how to create a report template from scratch. However, in practical use you will most likely find it much easier to customize one of the standard templates to suit your needs.

Before beginning this tutorial, create a simple part program that can measure four circles on a simple part. This tutorial uses the Hexagon test block (Hexblock_Wireframe_Surface.igs).

Click on the links below to expand or collapse each step of instructions as needed. Most steps will also include a demo of that step. Simply click on blue icons like this one to see the demos:

Step 1: Create a Blank Report Template

Step 2: Insert and Format a Text Object for a Section Title

Step 3: Make Properties User Assignable

Step 4: Add a TextReportObject

Step 5: Add a New Section to the Template

Step 6: Add a CADReportObject

Step 7: Define What Measurement Information Should Appear

Step 8: Save and Test the Template


Applying or Removing a Report Template

  1. Select View | Report Window to access the Report window.

  2. From the Report toolbar on the Report window, click the Template Selection icon Template Selection Dialog. The Report Templates dialog box appears showing available report templates as .rtp files:

Report Templates dialog box

Report Templates dialog box

You can use this dialog box to manage your report templates.

  1. From the Report Templates dialog box, click the Add button. A standard Open dialog box appears.

    Open dialog box
    Open dialog box

  2. Navigate to the report template file, select it, and click Open.

  3. PC-DMIS adds the template to the A thumbnail picture of the template will appear in the Report Templates dialog box.

  4. Your dialog box might contain few or many templates. To resize the dialog box to better suit your needs, drag the dialog box's edge to a new location.

Report Templates dialog box

  1. From the Report Templates dialog box, select a template.

  2. Click the Remove button (to remove all templates, click Remove All).

  3. PC-DMIS removes the report template from the Report Templates dialog box.

Removing report templates doesn't delete them. It merely removes them from this dialog box. You can always add them later using the Add button.

Report Templates dialog box

Applying or Removing a Report Template

To apply a report template to your measurement results, or to remove a report template, you must first access the Report Templates dialog box:

To Access the Report Templates dialog box:

To Add a Report Template:

To Remove a Report Template:

Note: The templates listed in the Report Templates dialog box are different for each user account on the Windows operating system.


Sharing Report Templates

You can easily share a report template with other users. When you save a report template, PC-DMIS automatically saves a copy of any associated label templates into the report template itself. This way, if you want to share a report template, you don't have to worry about sending all the associated label templates along with it. Even so, the report template will always check for the actual label template file in the directory first. If it finds the actual label template file, it will use that. If the actual label template file doesn't exist as expected, then the report template will use the copied version of the label template file that is stored with the report template itself.

Hover your mouse over the following diagram for an example:

Report Template

Report Template

Label Template A

Label Template B

Label Template A

Label Template B

Label Template A

Label Template B


About Labels and Label Templates

Labels are a brand new concept in PC-DMIS reporting. A label template essentially acts like a mini-report template that you associate with a specific command (or commands) in the report. This gives you a lot of freedom with data that you can include in your report. For example you can display labels for dimensions, labels for measured features, for auto features, and so forth.

See a Sample Label:

PC-DMIS ships with several standard labels that you can associate with objects in your Report templates. However, as with Report templates, you can create your own label templates as well. Label templates can contain any object from the Label Template Editor's Object Bar, but they usually contain the GridControlObject or the Graph object.

The Label Template Editor is used to create label templates.

More:

Understanding the Label Template Editor

Tutorial - Creating Label Templates

Using Labels in Reports

Arranging Labels in the Report Window

Using the Table Format Command


Creating Label Templates

  1. Select File | Reporting | New | Label Template to access the Label Template Editor. A blank label template automatically appears.

  2. Hide unused toolbars by right-clicking on the toolbar area and removing toolbars.

  3. Hide unused PC-DMIS windows by selecting the open window from the View menu.

  4. Maximize the template editor by clicking the maximize button the editor's window. You should see the words "LABEL" on the background of the editor.

  5. Size The Frame/The View in the label template editing area to 4 inches wide and 1.5 inches high. You can do this by dragging on the bottom right hand corner of the label template and dragging the mouse. Use the rulers as a guide.

You have created a blank label template. When finished with this step, it should look something like this:

Hint: When working with one of the template editors, you may find it helpful to hide your usual PC-DMIS toolbars and windows, thereby freeing up some screen space. If you work frequently with templates, you may want to create a stored screen layout for your template. For information on layouts, see the "Window Layouts Toolbar" topic in the "Using Toolbars" section.

Label Template Editor

Label Template Editor

  1. Click the CommandTextObject icon. The pointer changes to a cross-hair.

  2. Using the pointer, drag a box so that it stretches about 3 inches wide by .5 inches high. A CommandTextObject gets inserted into your label template. Right-click on it to access the Properties dialog box.

  3. Click the Colors property. If PC-DMIS asks if you want to define a color set independent from the default application colors, click Yes.

  4. The Color Editor appears. PC-DMIS uses this editor to define Edit window colors. However, in this case, it will only affect the current CommandTextObject.

  5. Under Background Color, click Edit. A standard Color dialog box appears.

  6. Give the object's background color a dark blue color. Change the values in the Red, Green, Blue boxes to 0, 0, 128 respectively to do this. Click OK.

  7. In the Unmarked box, click Edit. A standard Color dialog box appears.

  8. Select white, and then click OK. If PC-DMIS asks if you want to change the item's children, click No.

  9. Use a bitmap image of a circle (or use the Ellipse object to draw a circle) and place it in the top right of the canvas.

You have added the CommandTextObject and a static Bitmap or Ellipse object for a circle shape into the label template. At the end of this step, your label template should looks something like this:

Label Template showing the CommandTextObject and a static Bitmap object

  1. Click the GridControlObject icon. The pointer changes to a cross-hair.

  2. With the pointer, drag a box for this object under the previously inserted CommandTextOjbect, so that it has the same width.

  3. Size the height so that it nearly fills the rest of the Frame/The View. When inserted, the grid will show several rows and columns.

  4. Access the object's properties, and then change the Columns and Rows properties to 3 each.

  5. Select the object and select a cell. To do this, double-click on the first cell in the top row. It will highlight the cell in a blue background to show that you have selected it.

  6. Select the entire top row. To do this, with the first cell selected press SHIFT, and click on the last cell in that row to select the entire cell. PC-DMIS highlights the entire row.

  7. Right-click. The object's dialog box appears. This dialog box lets you control the formatting of the selected cells as well as insert text and expressions.

  8. Click the Merge button to merge the selected cells.

  9. Set the background color for the merged cell. Click the Background color button. A Color dialog box appears. Choose a dark blue color and click OK.

  10. Set the text color for the merged cell. Click the Text color button and select white in the same way.

  11. Create headings. Select the first cell in the second row and right-click to bring up the dialog box. In the Cell Expression box, type "Measured X". Close the dialog box and repeat the process on the second cell, typing "Measured Y". Finally. repeat it again for the last cell, typing "Measured Z".

  12. Select the entire second row. Right-click and use the dialog box to select a light green background color.

  13. Under Cell Justification, under Vertical, click the middle button to vertically center the text in their cells.

  14. Click OK to close the dialog box and then deselect the object.

You have inserted a GridControlObject and learned how to change the number of rows and columns. You learned how to add text into a cell and how to format the grid by using this object's special dialog box. When finished with this step, your label template should look something like this:

Label showing the inserted and formatted GridControlObject

The GridControlObject's dialog box

The GridControlObject's dialog box

  1. Select the GridControlObject's first row.

  2. Once it's selected, type "=ID" directly into the cell. This is an expression that tells PC-DMIS you want to display the feature's ID in the cell.

  3. Select the first cell in the third row and type "=MEAS_X"

  4. Select the second cell and type "=MEAS_Y".

  5. Select the third cell and type "=MEAS_Z". These expressions tell PC-DMIS you want to display the feature's X, Y, and Z values. When you deselect the object, PC-DMIS displays the expression values from the filler text used by the object. See "About Report Expressions" for information on expressions.

  6. Use the Border object and draw a border object around the label. You may need to resize the label to close to 4.5 inches wide by 2 inches high.

  7. right-click on the border and give it a line width of 2.

  8. Adjust the location of the contents so they are within the border.

You have added some report expressions into your label template and then drew a border around the template prior to testing it. When you finish this step your template should look something like this:

Label showing the results of the expressions

  1. Select File | Save to save the label template. In the Save As dialog box, name the template "TestLabel.lbl".

  2. Select File | Close to close down this template editor.

  3. Select File | Reporting | Edit | Report Template and then select the Test1.rtp template file you created from the previous tutorial.

  4. Select the TextReportObject you inserted into the first section of the report template and then access its properties.

  5. Use the Rules Tree Editor and the Edit Rule dialog boxes to create a rule that will display TestLabel.lbl in that TextReportObject object for all measured circles. If you can't remember how to create rules, follow the procedure in the "Defining a Rule topic".

  6. Select File | Save to save your report template.

  7. Select File | Close to close it.

  8. Execute the part program and apply the template.

  9. Select View | Report window to display the final report.

After you save and test your label template, it should look something like this:

Report window example showing the label

Report window example showing the newly created label. Notice the measured X,Y, and Z center point data for each circle feature.

So far, your label displays the XYZ of your circles' centers. Suppose, however, you wanted to get individual hit data instead. You can do this using repeating rows.

  1. Select File | Reporting | Edit | Label Template. Select TestLabel.lbl from the dialog box and click Open. PC-DMIS loads the Label Template Editor and displays TestLabel.lbl.

  2. Access the GridControlObject.

  3. Select the first cell in the third row. Once you select it, right-click to bring up the GridControlObject's dialog box.

  4. Click the Row tab.

  5. Select the Repeating Group check box. This tells PC-DMIS that you want to make that row repeatable. The Repeat Expression dialog box becomes available. Notice that the row, at this point contains orange markers on the left and right sides. This indicates that the row is a repeating row.

  6. Type "=N_HITS" in the Repeat Expression box. This tells PC-DMIS to get the total number of hits in the feature and to repeat the row for each available hit.

  7. Click the Cell tab. You should see "=MEAS_X" in the Cell Expression box. Append ":N" to the expression so that it reads, "=MEAS_X:N". This tells PC-DMIS to repeat the expression in that cell for each available hit.

  8. Select the other two cells in the row, and modify them so that they have the ":N" code added as well: "=MEAS_Y:N" and "=MEAS_Z:N".

  9. Because the labels will expand to include all the data passed into the GridControlObject, when the row repeats, you do not need to adjust the label's size for this.

  10. Click OK to close the GridControlObject's dialog box.

  11. Save the label template and access Report window. Click the Redraw the Report icon from the Reporting toolbar to see your latest changes. Notice that instead of displaying the center point data for the circles, PC-DMIS displays individual hits.

You have learned how to create a basic repeating row to count and display several items of data without needing to create different report templates with different row configurations.

Orange bars indicate a repeating row

A row showing orange markers

  1. Access the TestLabel.lbl label template and select the existing GridControlObject.

  2. Select its first row. Once selected, right-click to bring up the GridControlObject's dialog box.

  3. Click the Unmerge Cells button. The single cell making up the first row now becomes three cells.

  4. Delete the "=ID" expression text in the first cell. You don't really need this expression in your final label template because the CommandTextObject displays it automatically.

  5. Use the Background Color and Text Color buttons to change the cell's background color to white and its text to black.

  6. Delete the inside column lines in the first row. To do this, select the first cell, access the dialog box, in the Cell tab, in the Lines area, change the line value of the Right list from Thin to None. Repeat this for the middle cell as well.

  7. Click OK to close the GridControlObject's dialog box. While your label template may appear to have its cells merged, in reality, column lines in those cells are merely hidden.

  8. Select the left cell in the first row and access the dialog box.

  9. Click the Column tab. In the Column list box, type "Measured X". Click OK to close the GridControlObject's dialog box.

  10. Repeat this for the middle and right cells, typing "Measured Y" and "Measured Z" respectively. You will use these column headings to control each columns visibility and ordering later on.

  11. Select the CommandTextObject you added to the template earlier, and drag it down so that it rests on top of the GridControlObject's first row.

  12. Modify the location or size of the Ellipse or circle Bitmap object you created earlier so that it's centered along the right side of the GridControlObject.

  13. Select and then drag the top line of the Border object down so that it's just above the GridControlObject.

  14. Drag a box around all the objects in the label to select them all. Then drag those objects up to the top and to the left as far as they will go on the label's canvas.

  15. Right-click to access the GridControlObject's properties.

  16. Type "TestTableFormat" in the Table Format property, and press TAB.

  17. Save and close your label template.

In this step, you learned how to unmerge cells, set cell line properties, insert column headings, and select and move multiple objects. Defining column headings will let you control the visibility and ordering of your columns on the fly. When you have finished this step, your label template should look something like this:

  1. Open the report template, Test1.rtp, in the Report Template Editor.

  2. Select the TextReportObject and right-click to access the Properties dialog box.

  3. In the Rules Tree property, click Rules to access the Rule Tree Editor dialog box.

  4. Use the Rule Tree Editor and navigate to the rule you created earlier.

  5. Select the rule and click Edit. The Edit Rule dialog box appears.

  6. Click the Grid Format button. The Table Format Properties dialog box appears.

  7. In the New Table Name box, type "TestTableFormat", and click Add Table.

  8. Under the Columns list in the edit box, type "Measured X", and then click Add Column.

  9. Add columns for "Measured Y" and "Measured Z" in this same manner.

  10. Click OK on the various dialog boxes until your return to the Report Template Editor.

  11. Select File | Save to save the report template.

  12. Select File | Close to close the Report Template Editor.

In this step you tied the GridControlObject's columns to the TestTableFormat table in the Table Format Properties dialog box by adding columns with the exact same name and naming the table the same name you gave the Table Format property. Since you haven't changed the order or visibility at this point, the newly created table in the dialog box should look like this:

Table Format Properties dialog box showing the newly created TESTTABLEFORMAT table

Table Format Properties dialog box showing the newly created TestTableFormat table

  1. If not visible, select View | Edit Window to display the Edit window.

  2. Place the Edit window in command mode.

  3. Select Insert | Report Command | Table Format. The Table Format Properties dialog box appears.

  4. From the Table ID list, select the TESTTABLEFORMAT table. The Columns area shows the columns available to this custom table format.

  5. Clear the Measured Z box to hide that column in the final report.

  6. Select Measured Y and click the up arrow icon next to the Columns area to reorder the Measured Y column so that it gets displayed first in the report.

  7. Click OK. PC-DMIS inserts a TABLE/FORMAT command into the Edit window. This command controls the visibility and order of your columns.

  8. Save and execute your part program. When PC-DMIS runs, notice that the order of the Measured X and Measured Y values have changed, and the Z column is hidden

In this final step you learned how to insert and use a TABLE/FORMAT command to define the order and visibility of the columns in the label template. Your finished report should look something like this:

Finished report showing only the Measured Y and X columns

TABLE/FORMAT,TESTTABLEFORMAT

COLUMN/ORDER,MEASURED Y,MEASURED X, ,

ROW/ORDER

Tutorial - Creating Label Templates

This topic walks you through a basic tutorial that will create a simple label template with a few objects and a GridControlObject. This should give you a basic overview of how label templates work so that you can use them to display custom information in your reports.

This tutorial builds on skills you learned in the "Creating a Custom Report Template" tutorial; be sure to complete that section first.

Step 1: Create a Blank Label Template

Step 2: Add a CommandTextObject and Static Information into the Template

Step 3: Insert and Format a GridControlObject

Step 4: Add Expressions Into the GridControlObject

Step 5: Save and Test the Label Template

Step 6: Create a Repeating Row

Step 7: Use the Columns Tab to Define Columns

Step 8: Define a Grid Format Table

Step 9: Use Table/Format Command to Control Column Visibility and Order


Using Labels in Reports

A Sample Report Template with Three Large Labels

Using Labels with Reports

To use labels with your reports, you need to open a report template and add at least one of these objects:

  • Label object

  • TextReportObject

  • CadReportObject

Once an object exists, right-click on it to access its Properties dialog box. Finally, use the Rules Tree Editor to define rules that use one or more label templates.

When you apply your report template, PC-DMIS will follow the rules you specified and use the chosen label templates.

Understanding Standalone Label Ordering

If you use standalone Label objects in your report template, be aware that, by default, PC-DMIS will fill them with measured data in the report in front to back order. To illustrate this, when you add standalone labels, PC-DMIS defines each label by a progressive alphanumeric ID (Label1, Label2 ….LabelN). While label IDs don't control the order in which the labels are filled, they are discussed here to more easily illustrate how ordering takes place. During report creation, assuming you haven't modified the label IDs in any way, LabelN is activated and filled first, while Label1 is activated and filled last.

Note: This only happens with standalone labels, not with labels used within the TextReportObject or CadReportObject.

Changing Standalone Label Ordering

Since PC-DMIS may not initially fill the labels in the order you would like, you can change the drawing order of the labels to determine which labels are filled first by using menu items located on the Edit | Order submenu.

Hint: You can also use the To Front or Back icons on the Layout Bar.

After changing the drawing order, PC-DMIS will fill the top most drawn label first and the bottom most drawn label last. For example, suppose you have three large labels that fill up a single section with Label1 at the top, Label2 in the middle, and Label3 at the bottom. Initially, it fills up Label3 first, then Label2, and then Label1. To guarantee that PC-DMIS displays your data in part program order, you can change the drawing order of the labels, like this:

  1. Select Label1 and choose Edit | Order | Bring to Front.

  2. Select Label2 and choose Edit | Order | Sent to Back.

  3. Select Label3 and choose Edit | Order | Send to Back.


Arranging Labels in the Report Window

When the report template receives part program data, it has to size the labels dynamically to fit that data. So, these labels may not be in the best location or may overlap other labels after part program execution. No worries though, you can easily modify where to put labels, by selecting a label and then dragging it to a new location.


Using the Table Format Command

The TABLE/FORMAT Edit window command lets you control a GridControlObject's column and row ordering and visibility on the fly from within your part program. This means you don't have to use the Label Template Editor to create different variations of the same label template if you only want to reorder or hide certain rows or columns. Instead, you can simply insert this command into your program to determine how to display the GridControlObject in the label template.

Important: For this command to work properly, you must set the value of the GridControlObject's TableFormat property to the exact same table format name defined in the Grid Format button of the Edit Rule dialog box.

Inserting the Command

To insert this command, select Display Menu Roadmap Insert | Report Command | Table Format. The Table Format Properties dialog box appears. This dialog box, like the dialog box used in the Rules Tree Editor, also controls the visibility and ordering of rows and columns for label templates using the GridControlObject. When you finish manipulating the rows and columns, click OK, and PC-DMIS inserts the TABLE/FORMAT command into the Edit window.

An inserted TABLE/FORMAT command takes precedence over any ordering you may have already defined with the Edit Rule dialog box's Grid Format button.


About the Rule Tree Editor

The Rule Tree Editor dialog box lets you define rules–or conditions and responses–that certain objects follow when displaying report information. For example, you may only want to show roundness dimension information for circle features in your report, even though your part program contains many other features. You can do this by using this editor. In your report template, you might add a CadReportObject and then access the Rule Tree Editor for that object. Inside the editor, you can then specify a circle feature type and then select a label template that is programmed to display roundness data.

Supported Objects:

The Rule Tree Editor works with these objects available from the Report Template Editor"

  • TextReportObject

  • CadReportObject

  • Label Object

It also works with Page object available within the Custom Report Editor. Only these objects can access data from a part program using the Rule Tree Editor.

Accessing the Rule Tree Editor:

  1. Insert a supported object into your report template, or select the Page object in the Custom Report Editor.

  2. Right-click on the object.

  3. Click on the RuleTree property. The Rule Tree Editor dialog box appears.

More:

Defining a Rule

Importing and Exporting Rules

Copying and Pasting Rules

Clearing Rules

Using the Table Format Properties Dialog Box


Defining a Rule

Rule Tree Editor dialog box

Edit Rule dialog box

A toolbar at the bottom of this window lets you control the demo. When you finish viewing this demo, click the blue icon again to close this expanded window.

Defining a Rule in the Rule Tree Editor

To define a rule using the Rule Tree Editor dialog box, follow this procedure:

  1. Display Menu Roadmap Select File | Reporting | New | Report Template to access the Report Template Editor.

  2. Add a TextReportObject, CadReportObject, or a Label object onto the template.

  3. Right-click on the object. A Properties dialog box appears.

  4. Select the Rules Tree property from the Properties dialog box. The Rule Tree Editor dialog box appears. You will see a list of various items making up a part program. Many of these items you can expand by clicking on a plus symbol (+) to view more specific items or commands. Some items exists on their own and aren't inside of any expanding lists, these items include:

    • Top of First Page in Section - If you select this item, you can select a label or text expression to display at the top of the first page in the current section of your Report window.

    • Bottom of Last Page in Section - If you select this item, you can select a label or text expression to display at the bottom of the last page of the current section.

    • File Header - If you select this item, you can select a label or text expression to display in the place of the usual report's file header of PART NAME, REV NUMBER, SER NUMBER, and STATS COUNT. The File Header label or text will appear on the first page in the current section of your report.

  5. Define conditions to be met.

    • From the list of items, find an item that you want to define as a condition.

    • Select the item and click Add. The Edit Rule dialog box appears.

    • If you want to define another condition, you can choose either a reporting language expression or a BASIC script as your condition. To do this, select the Use Additional Expression or Script check box, and then in the Conditional area, select either the Expression or Script option.

      • If you selected Expression, type the expression for your condition into the Conditional Expression box. For example, if you are creating a rule for a measured circle, you can test any of the circles data type field values to control whether or not to display a label. Suppose you only want to display a label if the measured circle has less than four hits. In the Conditional Expression box, you would type:

        N_HITS < 4

        Then if this condition evaluated to TRUE, PC-DMIS would use the associated label. Note that you don't need to include the entire IF expression statement. The IF statement is already understood and evaluated in this box.

      • If you selected Script, click the Edit button to create your BASIC script. A VBS Mini-editor appears where you can type your code. Create your script inside this code editor. The script must return TRUE for the condition to be met. When finished, right-click and select Check Syntax. Click OK when finished. PC-DMIS automatically stores the script with the defined rule.

Note: If the rule ever gets deleted, you will lose your script. You should store your script in a separate text file if you are concerned about it getting deleted.

  6. Define a label or expression to display if the condition or conditions defined are met.

    • With the Edit Rule dialog box open, choose either Use Text Expression for Report or Use Label Template for Report.

      • If you chose to use a text expression, type a simple text message or define an expression in the Text Expression box. For example, whenever PC-DMIS measured a circle, you can type static text such as:

        "We just measured a circle!"

        Or, you could use expressions to include information about the circle, such as:

        "We just measured a circle! It had " + N_HITS + " hits!"

      • If you chose to use a label template, select a label template. Note that this field also accepts expressions as long as the expression evaluates to a label template name. Remember, if you use an expression in this field, be sure to precede it with the "=" symbol. If desired, click the Grid Format button to access the Table Format Properties dialog box. Using this dialog box, you can define a grid format for your report. A grid format lets you reorder or hide your columns and rows without creating a brand new label template. Additionally, defining a grid format also lets you use the TABLE/FORMAT Edit window command to control row and column ordering from within the part program. See "Using the Table Format Properties dialog box".

    • When you have filled out the Edit Rule dialog box, click OK. PC-DMIS places the item from the list in a boldface font and inserts the rule for that item at the bottom of the Rule Tree Editor dialog box.

  7. Organize your rules. You can have as many rules as you want for a given command type. If you have more than one rule, PC-DMIS will evaluate the rules in the order that they appear. You can change the evaluation order by selecting a rule and clicking Move Up or Move Down in the Rule Tree Editor dialog box.

    • You can copy and paste rules from one item to another item or to multiple items, or to an entirely different tree by using the Copy and Paste buttons. See "Copying and Pasting Rules".

    • You can remove rules from an individual item by clicking Delete or Clear. If you want to remove the rules for multiple items, you can select them and click Clear. See "Clearing Rules"

  6. Click OK to save changes made to the Rule Tree Editor.

  7. Test the rule.

    • Save the report template.

    • Apply the report template to the report data by using the Reporting toolbar on the Report window.

    • Execute the part program.

Important: Be aware that a rule assigned to a child element always overrules a rule assigned to a parent element. Also, a rule assigned to a parent node applies to each child element of that node that does not contain its own rule.

See a brief demo on determining what information the report template will display.


Importing and Exporting Rules

If you work in a collaborative environment, you will probably want to share rules that are created from different report templates with each other. Using the Rules Tree Editor dialog box, you can easily do this and import someone else's rules by using the Import button, or you can share your own rules with someone else by using the Export button.

A rules file has a ".rul" filename extension.

Importing a Rules File:

  1. Access the Rules Tree Editor dialog box.

  2. Click the Import button. An Open dialog box appears.

  3. Navigate to the directory containing the rules file (.rul) you want to import.

  4. Click Open. PC-DMIS imports the rule file into the Rules Tree Editor.

  5. Click OK to save the imported rule.

Exporting to a Rules File:

  1. Access the Rules Tree Editor dialog box.

  2. Click the Export button. A Save As dialog box appears.

  3. Navigate to the directory where you want to store the rules (.rul) file.

  4. Type a name for the file In the Filename box.

  5. Click Save. All rules associated with that object get exported. Someone else can now import and use your exported rules file.


Copying and Pasting Rules

The Rule Tree Editor contains Copy and Paste buttons so that you can copy and paste rules between the current Rule Tree Editor and a Rules Tree Editor for a different object or to a different item within the same Rule Tree Editor.

Note: A copied rule is not stored in the Windows Clipboard; so you cannot copy and paste a rule outside of the specific context discussed here.

To Copy and Paste Rules:

  1. Select a single item from the Rule Tree Editor. If you select more than one item from the tree editor, the Copy button will never become enabled.

  2. Select one or more rules from the rule list box. The Copy button becomes enabled for selection.

Example of Copying Two Rules

  3. Click Copy.

  4. Select and highlight one or more items from a rule tree. Hold down the CTRL key while clicking to select multiple items. The Paste button becomes available.

Example of Pasting Copied Rules into an Empty Item

  3. Click Paste to paste the copied rule(s) into the selected item(s). Note that if you paste a copied rule or rules into an item that already contains one or more rules, the existing rules are not overwritten by the new rules, but the new rules are instead appended to the existing list. You can click Paste multiple times into several different rule tree items.

  4. Click OK on the Rule Tree Editor to save your changes.


Clearing Rules

The Clear button removes any rules associated with one or more selected items from the rule tree. You can select more than one item by pressing the CTRL key while selecting additional items.

Example of Clearing Rules for a Selected Item


Using the Table Format Properties Dialog Box

The Table Format dialog box works with a GridControlObject's defined column and row names allowing you to control the visibility and order of columns and labels in a GridControlObject in a label template. This dialog box appears once you click the Grid Format button from the Edit Rule dialog box. See "Defining a Rule" for information on the Edit Rule dialog box and the Grid Format button.

Table Format Properties dialog box

Table Format Properties dialog box

This dialog box contains different table formats. A table format simply defines how you want named rows and columns to appear in your final report. This dialog box lets you change the order and visibility state of all existing table formats. You can also use this dialog box to create your own custom table formats.

For the pre-existing table formats the only thing you can modify is their visibility state and the order of their rows or columns. You cannot delete these table formats nor change what rows or columns they have.

In order use table formats, you must first use a label template with a GridControlObject that has its columns or rows already named.

Dialog Box Item | Description
Table ID | Lists all available table formats.
New Table Name | Defines a new table format.
Add Table | Adds the new table format. This button only becomes enabled when you type a name in the New Table Name box.
Delete Table | Deletes the selected custom table format. This button only becomes enabled when you select a custom table from the Table ID list.
Rows | Lists the rows and columns in your table format. You can reorder them by clicking the up and down arrows.
Add Row/Column | Adds a row or column name to the Rows or Columns area. You can only add to custom table formats.
Delete Row/Column | Deletes the selected row or column from the Rows or Columns area. You can only delete items from custom table formats.
Resize Type | Determines what the table will when you show or hide columns. The list contains three items: Resize Grid - This retains existing column sizes and resizes the grid to fit the new width. Resize Columns to Fit - This retains the grid's existing width and resizes each column equally to fit that width. Hide Text - This doesn't resize the grid or the columns. It simply hides the text.
Cancel | Closes the dialog box without applying any changes.
OK | Uses the selected table format for the rule in the Rule Tree Editor or for the TABLE/FORMAT command in the Edit window.

To name a column or row in a GridControlObject:

  1. In the Label Template Editor, select the GridControlObject.

  2. Double-click on the first cell in a column or row.

  3. Right-click to access the property editor.

  4. Click either the Cell or Column tab.

  5. In the Row Label box or Column Label box enter a value. You can select from the list or type a custom value. Custom labels can only show up on custom table formats.

To reorder columns or rows:

  1. Select a table format from the Table ID list.

  2. Its rows or columns already appear.

  3. In the Rows or Columns area, select the row or column you want to reorder, then click the up or down arrow buttons to either send that item either up or down in the list. Items higher in the list get displayed before others.

To show/hide columns or rows:

  1. Select a table format from the Table ID list.

  2. Its rows or columns already appear.

  3. In the Rows or Columns area, clear the check box to the left of the row or column name to hide that item in the label. Select the check box to show it in the label.

To create a custom table format:

  1. In the New Table Name box, type a name.

  2. Click the Add Table button. The custom table appears in the Table ID list and remains until you delete it.

  3. In the Add Row or Add Column box, type a name that matches a row or column label name you gave to the GridControlObject.

  4. Click Add Row or Add Column to add that item to the table.

  5. Continue adding row or columns and deleting or rearranging them as desired until the table format contains the information you want.

Removing your Modifications

To quickly remove a modification, right-click on the desired report object (a TextReportObject, CADReportObject, or Label object), and select the Remove Object Modifications button. PC-DMIS will return the report object back to its default state.


Changing a Template's Preview Thumbnail Icon

Whenever you create a report or label template, PC-DMIS automatically creates a thumbnail-sized preview of that template based on what appears on the template's initial page or section.

This thumbnail preview appears whenever you attempt to edit a template and access the Open dialog box ( Display Menu Roadmap Select File | Reporting | Edit | Report Template or Label Template).

A sample Open dialog box showing several report template preview icons

A sample Open dialog box showing several report template preview icons

If you want to use a custom image file instead of the default generated preview for a template, you can do this within the Open dialog box.

To Change a Template's Preview Thumbnail:

  1. Select the template file from the Open dialog box.

  2. Click the Change Preview button. The Template Image Selection dialog box appears.

  3. Select the Select Image from File option button.

  4. Click OK. Another Open dialog box appears allowing you to select a preexisting image file.

  5. Navigate to the directory containing either a .bmp or .jpeg file, select the image file, and click Open. PC-DMIS uses the selected image for your preview.

An example showing Test1.rtp with a bitmap image

An example showing Test1.rtp with a bitmap preview image


Tutorial - Customizing a Report Template

The first thing you need to do is create copies of all the components used to generate the PPAP report. These include both the report template and the underlying label templates.

  1. In the Report Template Editor open the PPAP.RTP report template.

  2. Select File | Save As.

  3. Name the report template "BALLOON_PPAP.RTP".

  4. Close the Report Template Editor.

  5. In the Label Template Editor open up these templates and select File | Save As on each, saving them with a "BALLOON_" filename prefix as shown in this table:

    Existing Label Template

    Save As Filename

    PPAP_DIMENSION.LBL

    BALLOON_PPAP_DIMENSION.LBL

    PPAP_DIMENSION_TRUE_POSITION.LBL

    BALLOON_PPAP_DIMENSION_TRUE_POSITION.LBL

    PPAP_FCF_POSITION.LBL

    BALLOON_PPAP_FCF_POSITION.LBL

    PPAP_FCF_SIZE.LBL

    BALLOON_PPAP_FCF_SIZE.LBL

    PPAP_FCF_SUMMARY.LBL

    BALLOON_PPAP_FCF_SUMMARY.LBL

You should now have copies of all the report and label templates used with the PPAP report. You will customize these copies in subsequent steps.

Now that you have created copies of the report and label templates you need to modify the rules on the new report template so that the newly saved BALLOON label templates are used instead of the usual PPAP labels.

  1. In the Report Template Editor open the PPAP.RTP report template.

  2. Access TextReportObject1 on the template and right-click on it to access the properties for the object.

  3. From the Properties dialog box, click on Rules to access the Rule Tree Editor.

  4. Expand the Dimensions list in the Rule Tree Editor. You will see several dimensions in bold face font indicating that a rule is applied to that dimension type.

  5. Select each bold face item in the Dimensions list and modify its existing rule or rules so that the corresponding label templates with the "BALLOON_" prefix are used instead.

Existing Label Templates Used | New Label Templates to Use
PPAP_DIMENSION.LBL | BALLOON_PPAP_DIMENSION.LBL
PPAP_DIMENSION_TRUE_POSITION.LBL | BALLOON_PPAP_DIMENSION_TRUE_POSITION.LBL
PPAP_FCF_POSITION.LBL | BALLOON_PPAP_FCF_POSITION.LBL
PPAP_FCF_SIZE.LBL | BALLOON_PPAP_FCF_SIZE.LBL
PPAP_FCF_SUMMARY.LBL | BALLOON_PPAP_FCF_SUMMARY.LBL

Changing Label Template Used

  6. Save the report template.

You have modified your existing rules so that the label templates with the "BALLOON_" prefix will be used to format and display your report data.

Now that rules are modified, the next thing you need to do is insert ASSIGN statements into your part program for each ballooned item. Prior to each dimension in your part program, add ASSIGN statements for each characteristic you will display in that dimension. For example, at the beginning of this topic, we suggested that feature #15 on the print was the X dimension for a hole, feature #30 the Y dimension, and feature #75 the hole's diameter. If you had a LOCATION dimension to display the X,Y, and D values (three characteristics), you would insert these three ASSIGN statements prior to your dimension:

ASSIGN/V1[1] = 15
ASSIGN/V1[2] = 30
ASSIGN/V1[3] = 75

These statements create an array of multiple values for the V1 variable.

Apply similar ASSIGN statements before each dimension in your part program.

  • If your dimension displays only one characteristic, then you would only put one ASSIGN/V1[#] before that dimension statement.

  • If your dimension displays ten characteristics (for example, a TP FCF dimension) then you would need ten ASSIGN statements for the ten elements in your array:

ASSIGN/V1[1] = 2
ASSIGN/V1[2] = 4
ASSIGN/V1[3] = 6
ASSIGN/V1[4] = 24
... and so on until ...
ASSIGN/V1[10] = 76

Important Note: In most cases, you must use the same variable name for all ASSIGN statements for all dimensions. This tutorial uses the variable V1. The exception is for a True Position legacy dimension. For this dimension type you can use V1[1],V1[2] and so on for the XYZ axis. However, for diameters of features and datums and the position callout you should use unique variables, perhaps V2[1],V2[2] and V3[1] respectively. Also be aware that the variable can only take number characters. Alphabet characters will show only zeros in the report.

When you've finished adding in the ASSIGN statements, your part program is finished and ready to execute. The only thing left to do is to modify your label templates to read in the variable's array of values for each dimension.

In this step, you will open up each applicable label template and configure it so that it will read the array of values for the variable.

  1. Inside the Label Template Editor, with the exception of BALLOON_PPAP_DIMENSION_TRUE_POSITION.LBL, open up the other label templates with the "BALLOON_" prefix given earlier.

  2. Access the GridControlObject and access the contents of the first cell.

  3. Modify the expression there to read as follows:

=INT(VARIABLE("V1[" + N + "]", ID:N))

  4. Save each label template.

  5. Finally, open BALLOON_PPAP_DIMENSION_TRUE_POSITION.LBL. Since this template has more than one row in the GridControlObject, you need to specify more than just the V1 variable.

    • For the XYZ axis, you can use the V1 variable in your expression:

=INT(VARIABLE("V1[" + N + "]", ID:N))

    • For diameters of datums and features, you need it to use the unique variable used earlier (such as V2):

=INT(VARIABLE("V2[" + N + "]", ID:N))

    • For the position callout, use another unique variable used earlier (such as V3):

=INT(VARIABLE("V2[" + N + "]", ID:N))

As the report increments through each dimension (using :N) the variable array is called with "V1[" + N + "]" and the Nth element of the V1 array is displayed. You are now ready for the final step, executing and viewing your results.

In this final step you will define the report template to use in the Report window and then execute your part program and view your final results.

  1. Save all your changes made to this point.

  2. Access the Report window and load the BALLOON_PPAP.RPT template.

  3. Execute your part program. You may also need to click the Redraw the Report icon from the Reporting toolbar after execution.

The Report window shows your final report. It should look something like this, displaying the numbered prints inside your PPAP report:

Final Report Showing Custom Numbered Items inside of a PPAP Report

Tutorial - Customizing a Report Template

Most of the time you won't need to create a brand new report template from scratch, but instead will want to create a new template based off an existing template that ships with PC-DMIS.

Suppose, for example, you have ballooned (or numbered) prints, and you want the ballooned numbers to appear in your a final report, such as in the Item column in the PPAP report (as shown in the figure to the right).

Perhaps feature #15 on the print is the X dimension for a hole, feature #30 is the Y dimension, and feature #75 is the hole's diameter. How do you get this information into the Item column of your final report? One way is to configure the PPAP and label templates to pull the information from variables in your part program.

This tutorial shows how to make copies of the PPAP report and label templates and then demonstrates how to modify them so that the information that appears under the Item heading displays variables taken from your part program, instead of the normal sequential list of numbers that appears in the PPAP report.

How do you get ballooned data into the PPAP template?

This tutorial uses skills learned in the "Creating a Report Template" and "Creating Label Templates" tutorials. You should complete those tutorials first so that you have a proper foundation for this tutorial.

Step 1: Copy the PPAP Report and Label Template

Step 2: Modify Rules in the Report Template

Step 3: Add ASSIGN Statements into your Part Program

Step 4: Modify Label Templates to Read Variables

Step 5: Execute and View Results


About Forms

The Form Editor lets you build interactive forms and dialog boxes and activate them when a part program gets executed. These interactive forms are limited only by your imagination and your ability to understand and program the Visual BASIC language. Forms, mixed with good understanding of the Visual BASIC language and PC-DMIS Automation, give even more power and flexibility to your part programs.

In previous versions of PC-DMIS, the ability to create interactive forms was included in the HyperView Report Editor. In version 4.0 and later, interactive forms moved out from under the umbrella of HyperView reporting and into more general uses. However, forms still play an active part in reporting because whenever you use a form to control what gets executed, you indirectly control what ends up in your report.

This section, however, does not attempt to cover everything that you can do with forms. Instead, it will cover how to use create and use forms in general, and in a reporting sense, how to get information from the user and into a report using standard PC-DMIS commands.

Forms can also be used in a non-reporting role, as a way to provide useful instructions to operators. See "Providing Operator Instructions Using OLE Objects with Forms" for some examples on how to do this.

More:

Understanding the Form Editor

Tutorial - Creating Forms

Using Forms in Reports


Creating Forms

  1. In this tutorial you will switch between the Form Editor and the Edit window, so first prepare the Edit window.

      • Right-click on your Edit window and select Docking View from the shortcut menu to undock it.

      • Select the maximize button so that it fills the screen.

      • Place the Edit window into Command mode.

  2. Select View | Form Editor from the menu bar. The Form Editor appears.

  3. Hide any unused toolbars by right-clicking on the toolbar area and removing them.

  4. Hide any unused PC-DMIS windows by selecting the open window from the View menu. Keep the Edit window open.

  5. Maximize the Form Editor by clicking the maximize button in the upper right corner of the editor's window. You should see the words "FORMS" on the background of the editor. Your Form Editor should now look something like this:

Hint: When working with the Form Editor, you may find it helpful to hide your usual PC-DMIS toolbars and windows, thereby freeing up some screen space. If you work frequently with this editor, you may want to create a stored screen layout for your template. For information on layouts, see the "Window Layouts Toolbar" topic in the "Using Toolbars" section.

Form Editor

  1. Drag the TheFrame/TheView's gray background so that it is 5 inches wide by 6 inches tall.

  2. Add a Border object, and drag the border so that it fits just within the form's area. Set the border's properties so that it has a LineWidth value of 3 and a ForeColor of dark blue (0.0.128).

  3. Add a Bitmap object in the top of the form. The Bitmap Dialog appears. Use the Load button to navigate to a bitmap file of your choice, such as a corporate logo. Size and position the bitmap so that it's within the top 1.5 inches of the form.

  4. Add a RadioButton object under the Bitmap object. Access the RadioButton's properties, and click on the ListItems value. The List Choices dialog box appears. This dialog box lets you create a list of option buttons for the object.

    • Select the existing RadioButton1 item from the List Choices box. In the Name box, change the name to "CIRCLE 1". The index Value should already display 0.

    • Click the Add button to add three more items. Then change the newly added items to read "CIRCLE 2", "CIRCLE 3", and "CIRCLE 4". They should have index values of 1, 2, and 3 respectively. The List Choices dialog box, should look like this:

    • Click OK when finished.

  5. Rename the RadioButton object by changing the (ObjectCode) value from "RadioButton1" to "optMeasure".

  6. Add a Frame object and drag it around your RadioButton object. Change the Frame's Text property to read "Select What to Measure".

  7. Add an EditBox object to the right of the RadioButton object, and rename it from "EditBox1" to "txtMeasure".

  8. Add a Text object (Text1) under the RadioButton object, and set its Text property to read "Select User:".

  9. Add a ComboBox to the right of the Text object, and rename it from "ComboBox1" to "cboUsers". This control will contain a list of users.

    • Click on the ListItems value to add the list of users. This accesses the List Choices dialog box again.

    • Click Add. PC-DMIS inserts "(None)" under List Choices.

    • Change the name of the first item in the list from "(None)" to "[Select a User]", and give it an index Value of 0.

    • Continue to use this dialog box as you did before to add five or six user names. This tutorial used "Bob", "Allen", "Mary", "Shelly", "Jared", and "Kurt".

    • Use the Up or Down buttons as desired to change where an item appears in the list. The dialog box, when finished, should look something like this:

    • Click OK. Your ComboBox object now contains those list items.

  10. Add an EditBox object to the right of the ComboBox, and rename it from "EditBox2" to "txtUser".

  11. Add another Text object (Text2) under the object that reads "Select User", and set its Text property to read "Type a Report Description:".

  12. Add another EditBox object to the right of the above Text object, and rename it from "EditBox3" to "txtDescription".

  13. Add a Button object to the bottom of the form, and rename it from "Button1" to "cmdContinue". Change its Text property to read "&Continue". The ampersand symbol lets you define whatever character follows it as a shortcut character to be used with ALT. So, pressing ALT + C on your form in Run Mode will act as if you clicked the Continue button.

  14. Select File | Save to save the form. Give it the name "TestForm.Form" and save it in a directory of your choice.

  15. Press CTRL + E to test your form in Run Mode. There's no code tied to any of the controls so nothing much happens if you click on anything, but you'll add that next. When finished, press CTRL + E again to return to Edit Mode.

In this step, you have completed the basic form, adding various controls and assigning items to lists. It should look something like this:

List Choices dialog box, showing four options with four index values ranging from 0 to 3.

List Choices dialog box showing a list of user names for the ComboBox

List Choices dialog box showing a list of user names for the ComboBox

Form with the various form controls added

Form with the various form controls added

  1. Select the RadioButton object, optMeasure, and access its properties.

  2. Click on the EventChange event. The VBS Mini Editor appears. This small code window lets you type Visual BASIC code statements that will run whenever you select a new value from the list of option buttons.

  3. In the code window, type this code:

Dim intIndex As Integer

intIndex = optMeasure.Index

Select Case intIndex

Case 0

txtMeasure.Text = "Circle 1"

Case 1

txtMeasure.Text = "Circle 2"

Case 2

txtMeasure.Text = "Circle 3"

Case 3

txtMeasure.Text = "Circle 4"

End Select

  4. Click OK. The mini editor closes.

  5. Select File | Save to save the form.

  6. Test your report by pressing CTRL + E and entering Run Mode. Select a feature to measure.

This code runs when you select a feature to measure from the list. It looks at what gets selected from the list of option buttons and sets the Text property of txtMeasure to display a text string of "CIRCLE 1", "CIRCLE 2", and so on. Press CTRL + E to exit Run Mode and return to Edit Mode.

  1. Select the ComboBox object, cboUsers, and access its properties.

  2. Click on the EventChange event. The VBS Mini Editor appears.

  3. In this code window, type this code:

txtUser.Text = cboUsers.TextValue

  4. Click OK. The mini editor closes.

  5. Select File | Save to save the form.

  6. Test your report by pressing CTRL + E and entering Run Mode. Select a feature to measure.

This code runs when you select a user from the list. It looks at the text value of the selected list item and sets the Text property of txtUser to display a text string of the selected user. Press CTRL + E to exit Run Mode and return to Edit Mode.

  1. Select the Button object, cmdContinue, and access its properties.

  2. Click on the EventClick event. The VBS Mini Editor appears.

  3. In this code window, type this code:

If cboUsers.Value >0 And Len (txtDescription.Text) > 0 And Len (txtMeasure.Text ) > 0 Then

TheView.Cancel

Else

MsgBox "Please fill out the entire form before continuing."

End If

  4. Click OK. The mini editor closes.

  5. Select File | Save to save the form.

  6. Test your report by pressing CTRL + E and entering Run Mode. Click the Continue button.

This code runs when you click the Continue button. It checks to make sure the form is all the way filled out, and if it is, it closes the Form Editor. If not, it displays a message telling the user to fill out what's missing.

  • The Len ( ) function tests the length (or the number of characters) for the text string in the edit boxes, making sure something is there.

  • The cboUsers.Value > 0 code checks to make sure a user name gets selected from the list.

Now that you have defined your form, you need a way to pass data back and forth, between the Edit window and the form.

  1. If you haven't already done so, save your form.

  2. From the Window menu select Edit Window to make the Edit window come to the front.

  3. Make sure it is in command mode.

  4. After each circle feature insert a Location dimension for that circle.

  5. Near the top, before the circle features, define variables that you will assign to work with the form, by typing this code in the Edit window before the measured circle features:

ASSIGN/STR_DESCRIPTION = ""

ASSIGN/STR_USER = ""

ASSIGN/STR_MEASURE = ""

  5. Place your cursor immediately after these statements, and select Insert | Report Command | Form. An Insert Form dialog box appears. Navigate to where you stored "TestForm.FORM", select it, and click Open.

  6. PC-DMIS inserts a FORM/FILENAME command block into the Edit window with a pathway to the selected form file. This command, when marked and executed, will run the form. It then waits until the form is closed before continuing execution of the Edit window. More Info

  7. Click just before the left side of the equals sign in the PARAM/= statement, and type "TXTDESCRIPTION.TEXT". Click on the right side of the equals sign, and type "STR_DESCRIPTION". Press ENTER. Another PARAM/= statement appears. More Info

  8. Continue to define parameters in this way for both the STR_USER and STR_MEASURE variables, tying them to the txtUser and txtMeasure objects' Text properties respectively.

  9. Save your changes to the Edit window. When finished, your FORM/FILENAME command block, should look something like this.

CS7 =FORM/FILENAME= D:\PARTPROGRAMS\TESTFORM.FORM

PARAM/TXTDESCRIPTION.TEXT=STR_DESCRIPTION

PARAM/TXTMEASURE.TEXT=STR_MEASURE

PARAM/TXTUSER.TEXT=STR_USER

PARAM/=

ENDFORM/

Notice that this command contains a PARAM/= statement, or a "parameter". These parameters let you pass values back and forth between the PC-DMIS Edit window variable and the form control properties.

Remember that txtDescription is the name you gave the EditBox object in your form that will hold a user-entered description of the report.

During execution, the Text property of txtDescription will initially take the value of whatever STR_DESCRIPTION holds. In this case, it would take an empty string. After you close the form, it passes whatever value the form has back into STR_DESCRIPTION.

When you created your form, you created a list of option buttons (using the RadioButton object) to control what exactly gets measured. You now need to add conditional statements into the Edit window too, so that the proper feature gets measured according to what gets selected from the form.

  1. In the Edit window, place your cursor right before the first CIR1 feature and press ENTER. Your cursor should be in a blank line above the CIR1 feature.

  2. Select Insert | Flow Control Command | Control Pairs | If / End If. PC-DMIS inserts an IF / END IF conditional statement into the Edit window:
    IF/0
    END_IF/

  2. Define the condition. Highlight the default value of 0 and type:
    STR_MEASURE == "Circle 1"

  3. Press ENTER.

  4. Select the entire CIR1 feature and the location dimension following it, and select Edit | Cut. Then select Edit | Paste to move it onto a blank line after the IF/STR_MEASURE == "Circle 1" line but before the END_IF/ line. Your first conditional block should look like this:

IF/STR_MEASURE == "Circle 1"

CIR1 feature goes here...

Location dimension goes here...

END_IF/

  5. Continue repeating the above steps, defining conditional statements for the other circle features as well. When finished, your Edit window code should look something like this:

ASSIGN/STR_DESCRIPTION = ""

ASSIGN/STR_USER = ""

ASSIGN/STR_MEASURE = ""

CS7 =FORM/FILENAME= D:\PARTPROGRAMS\TESTFORM.FORM

PARAM/TXTDESCRIPTION.TEXT=STR_DESCRIPTION

PARAM/TXTMEASURE.TEXT=STR_MEASURE

PARAM/TXTUSER.TEXT=STR_USER

PARAM/=

ENDFORM/

IF/STR_MEASURE == "Circle 1"

CIR1 =FEAT/CIRCLE...

END_IF/

IF/STR_MEASURE == "Circle 2"

CIR2 =FEAT/CIRCLE...

END_IF/

IF/STR_MEASURE == "Circle 3"

CIR3 =FEAT/CIRCLE...

END_IF/

IF/STR_MEASURE == "Circle 4"

CIR4 =FEAT/CIRCLE...

END_IF/

Remember that STR_MEASURE, after execution, will hold the value of the txtMeasure object's Text property. According to the form code, this will be either:

"Circle 1", "Circle 2", "Circle 3", or "Circle 4".

This first line checks the variable value of STR_MEASURE and if it matches the string value of "Circle 1" then it will measure the CIR1 feature. If not, it will skip and go to whatever follows the END_IF/ statement.

Now, you need to apply some finishing touches. First, you need to tell PC-DMIS to send the values of our form to the final report in the Report window by using report comments. Then you need to make some objects invisible on the form.

  1. In the Edit window, type these commands immediately following the FORM/FILENAME command.

COMMENT/REPT,"User: " + STR_USER

COMMENT/REPT,"Report Description:" + STR_DESCRIPTION

COMMENT/REPT,"Measure Routine: " + STR_MEASURE

  2. Select Window | Form Editor to go back to the Form Editor.

  3. Right-click to access the Properties dialog box. Select txtMeasure from the drop-down list. PC-DMIS selects the object.

  4. Click Advanced, and set the Visible property to NO.

  5. Select txtUser from the drop-down list. PC-DMIS selects the object.

  6. Click Advanced, and set the Visible property to NO. Since a user doesn't need to see these values and the only reason we used them was to pass a value back to PC-DMIS, setting this property to NO makes these objects invisible during execution.

  7. Save your form.

  8. Close the Form editor.

  1. Select View | Report Window and use the Template Selection Dialog toolbar icon to set the report to use the default standard report template, TextOnly.rtp.

  2. Return to the Edit window. Mark the entire Edit window, save your part program, and then select File | Execute to test your part program.

  3. When PC-DMIS reaches the FORM/FILENAME command, it will run the form and pause execution until you finish filling it out.

  4. Fill out the form and click the Continue button. PC-DMIS passes the values from the form back into the PC-DMIS variables.

  5. The conditional statements check the value of the STR_MEASURE variable and execute the appropriate circle feature accordingly.

  6. PC-DMIS prints the report comments and the measured results for the measured feature to the Report window.

Tutorial - Creating Forms

This topic walks you through a basic tutorial that will create a simple form with some interactive dialog box controls that, when executed, will allow you to select a user name from a list and then choose to measure only certain features. The information you select will then appear in a final report.

While you can certainly duplicate aspects of this by using certain Edit window commands, this tutorial will give you an idea of what's possible with the Form Editor, some imagination, and a little programming skill.

Important: This tutorial uses files you created in the "Creating a Custom Report Template" and "Creating Label Templates" tutorials. If you haven't already done so, complete those tutorials first.

Step 1: Preparing the Work Environment

Step 2: Create the Form

Step 3: Add Code to the RadioButton Control

Step 4: Add Code to the ComboBox Control

Step 5: Add Code to the Continue button

Step 6: Assign Edit Window Variables to Hold Form Properties

Step 7: Add Edit Window Conditional Code to Control Measurement

Step 8: Add Finishing Touches

Step 9: Execute the Part Program


Using Forms with Reports

Forms usually only modify reports indirectly. For example, you may have a form that controls whether or not certain features get executed. In this case, the final report isn't modified directly, but indirectly because reports always show what gets executed anyway.

You can however use the FORM/FILENAME command to pass parameters back and forth between the Edit window and a form's objects, and use Comments to cause those parameters to appear in a final report. See the "Creating Forms" tutorial and the "Inserting a FORM Command" topic for examples of this type of forms use.

Additionally, after getting the values from a form into the Edit window, you can also use the REPORT/TEMPLATE command to pass parameters from the Edit window into a report template in the same way that you use the FORM/FILENAME command.

Display Menu Roadmap Select Insert | Report Command | Template Report to insert a REPORT/TEMPLATE command, then assign parameter values to modify object properties in the report template. See the "Creating Forms" tutorial on how to do this, using the FORM/FILENAME command as a guide, but instead of selecting a .FORM filename, select a Report Template (.rtp filename). Also, see the "Embedding HyperView Reports or Report Templates in a Part Program" topic.


Creating Custom Reports

Custom Reporting, added to version 4.2, provides a flexible and easy-to-use approach to reporting your measurement results. You will find this most useful when you need to generate a report quickly and simply for a specific part program, but you don't need the power available to the template-based approach. Since it does not use any report template, and instead utilizes your current part program's data directly, Custom Reports are generally easier to create and customize, but they lack the power and scope of template reporting.

Advantages of Custom Reporting:

  • Data can be placed anywhere on the page and in any order.

  • Data from multiple commands can be combined as a single element on the report.

  • The reports are generated by a fast and simple unique drag-and-drop method.

  • The report editor uses the actual data from the part program, not the dummy data. This makes customizing the report much simpler.

Disadvantages of Custom Reporting:

  • You are creating a single report, not a template, and this report is tied to your part program. While you can import the structure of the report to use with other part programs, the reusability is not as great as with report templates designed with specific rules.

  • It isn't as extensible as template reporting. Suppose you add a new feature or dimension later to your part program. For it to show up, you will need to drag and drop the new item into your report editor.

The following topics provide you with a tutorial that walks you through how to create, view, and print your first custom report. Procedural topics will also be provided for quick access should you need them later.

More:

Tutorial - Creating a Custom Report

Custom Report Generation

Dragging and Dropping Information into a Custom Report

Positioning Report Objects

Using Rules

Working with Multiple Pages

Viewing and Printing Custom Reports

Deleting Custom Reports

Using a Custom Report from another Part Program


Tutorial - Creating Custom Reports

Create a part program that measures four circles

Create a part program that measures four circles, similar to this.

Clicking these icons will launch demo movies showing how to accomplish certain tasks. When viewing these demo movies, you should maximize the help file viewer or browser window to more easily see what's happening.

In this tutorial you will use the Edit window in Summary mode along with the Custom Reporting Editor. Set them up so they are both visible as follows:

  1. Access the Edit window.

  2. Place the Edit window into Summary mode.

  2. Select File | Reporting | New | Custom Report from the menu bar. The Custom Report Editor appears.

  3. Hide any unused toolbars by right-clicking on the toolbar area and removing them.

  4. Hide any unused PC-DMIS windows by selecting the open window from the View menu. Keep the Edit window open.

  5. Maximize the Custom Report Editor by clicking the maximize button in the upper right corner of the editor's window. You should see the words "CUSTOM" on the background of the editor.

  6. Drag the Edit window underneath the Custom Report Editor's Object Bar. Your work environment should now look something like this:

Hint: When working with the Custom Report Editor, you may find it helpful to hide your usual PC-DMIS toolbars and windows, thereby freeing up some screen space. If you work frequently with this editor, you may want to create a stored screen layout for it. For information on layouts, see the "Window Layouts Toolbar" topic in the "Using Toolbars" section.

Custom Report Editor

In this step you will drag the report items into the Custom Report Editor.

  1. From the Edit window in Summary mode, select File Header and drag it out onto the editor. You will notice a transparent image of that item's icon as you drag it out onto the work area.

  2. Release the mouse button. PC-DMIS creates a File Header object in the editor.

  3. Drag and drop CIR1 and CIR2 onto your report. Don't worry about positioning them properly. For now, just drop them into any empty space on the first page of the report.

  4. In the Report Editor, select the File Header object already in your report and drag it to a place near the top of the report and center it horizontally on the Page.

  5. Next, select the label object for CIR1 and drag it so that the top edge is just under the bottom edge of the File Header object. Try to align their left sides as well. Drag it slowly until a blue arrow appears. Then release the mouse button. This aligns the dragged object's left side with the object above it.

  6. Repeat this step for CIR2.

  7. Now, drag the CIR3 feature from the Edit window to the bottom of the label used for CIR2. Notice that as you move your mouse over the various labels already in the editor, green handles appear around the labels. When the blue arrow appears just below CIR2, release the mouse. The feature is dropped into the editor below CIR2 and the label object for it becomes automatically aligned with the object above it.

  8. Repeat the above step for CIR4, attaching it just below CIR3.

  9. Select File | Save. A dialog box will appear allowing you to save your report. Choose any name and click Save.

Your Custom Report Editor should look something like this:

In this step you will work with multiple pages. You will add two additional pages and modify one page to support a different page size. Then you will rearrange the pages.

  1. In the Report Editor, at the bottom of the page, right-click on the Page1 tab and select Insert. A new page appears, called Page2.

  2. Right-click on that page and the Properties dialog box appears.

  3. Change Height to 850 and press TAB.

  4. Change Width to 1100 and press TAB. Changing these two properties essentially formats the page for Landscape printing.

  5. Create a third page, Page3.

  6. Right-click on Page2 and click Move Right. Notice how this moves the Page2 tab to the right of Page3.

  7. Right-click on Page3 and click Move Left. Your pages are now reordered to show Page3, followed by Page1, followed by Page2. In this way you can easily rearrange your pages.

  8. Save your report.

Your report now has three pages and their order has been changed.

This step demonstrates how you can replace existing label objects with new label objects and how to use the CADReportObject inside a custom report.

  1. In the Custom Report Editor, select the Page1 tab. To replace any object in your report, simply drag and drop any other item of a similar type on top of it. For example, you can drop any item that uses labels on top of any existing label in your editor.

  2. Select the label in your report for the CIR1 feature. You should already have four Circularity dimensions. If not, create them now, one for each circle feature.

  3. Drag the Circularity dimension for the CIR1 feature from your Edit window and drop it on top of the feature label already in your report editor for CIR1, like this:

    Notice that the label object is updated with a new label object.

  4. If the updated object moved, reposition it.

  5. Drag the other dimensions on top of their respective feature labels in the editor. PC-DMIS updates all the labels accordingly so that they look something like this:

    Report Editor Now Showing the Four Dimension Labels

  6. Now, click on the Page2 tab. Drag a CADReportObject from the Object Bar onto that page, and size it so it fills the page.

  7. Drag the four dimensions one at a time on top of the CADReportObject. For this object, notice PC-DMIS does not replace it with a label object for the dimension. Instead, PC-DMIS automatically creates the appropriate labels and leader-lines on top of the CADReportObject for the dimensions.

  8. Save your report.

Page1 now has dimension labels instead of feature labels and the CADReportObject in Page2 should look like this:

In this step you will insert a GridControlObject and get it ready to display values from the Edit window. You will then drag the measured and nominal values from a feature's data items into the available cells of the object.

  1. Click on the Page3 tab.

  2. Click on the GridControlObject icon and drag the object onto the page.

  3. Access the Properties dialog box and set NumRows to 8 and NumCols to 3.

  4. In the first row, the middle cell, double-click, and then type "Nominal". In the right cell, do the same and type "Measured".

  5. Starting with the first row, and first column, and then moving down through the other rows type "X", "Y", "Z", "I","J" ,"K", and "Diameter". This will fill in rows 2 through 8 in column 1. Your GridControlObject should look like this:

A GridControlObject with Static Text

Note: Remember when typing information into a cell, you must click in another cell or press TAB for the value to actually be displayed.

  6. In the Edit window, click the plus sign next to CIR1, and then click the plus sign next to Theoreticals. You will see a list of data items.

Data Items in the Theoreticals List

  7. Drag the Theoretical X data item and drop it into the Row 2, Column 2.

Dragging the item | Dropping the Item

  8. Double-click on the item you just dropped into the cell. You will see that cell is not really holding static text. Under the hood, the cell actually holds the expression needed to display the data. This means the information is not hard coded and if it changes, your report will be changed as well to match.

Looking at the Data Item's Expression

  9. Continue to drag and drop the remaining data items from the Theoreticals list into the appropriate cells in the Nominal column.

  10. In the Edit window expand the Actuals list for CIR1 and drop the data items into the appropriate cells of the Measured column.

  11. Expand the Settings list for CIR1, and drag and drop the ID data item into the cell at row 1, column 1.

  12. Finally, apply some text and background formatting of your choice to row 1 and column 1, and then save your report. The GridControlObject should look similar to this:

A Sample GridControlObject containing Data Items

  13. Select File | Close to close the Custom Report Editor.

Your values may differ depending on the part and circles measured.

This step demonstrated how to drag and drop data items into a GridControlObject.

Note: Data items don't have to be dropped only onto a GridControlObject; you can also drop them onto the editor's page directly.

This final step explains how to load your custom report into the Report window, how to view it, how to update a report from a part program that changes, and finally how to print it.

  1. Select View | Report Window to access the Report window.

  2. From the Report window toolbar, select the Custom Report Selection Dialog icon. A dialog box appears showing all custom reports.

  3. Select your report and click Open. Your report appears in the Report window.

  4. Next, you will update your report. Select File | Reporting | Edit | Custom Report. A dialog appears showing all the reports you've created for your current part program.

  5. Select your report and click Open. Your report opens inside the Custom Report Editor.

  6. Go ahead and make any change to your report in the editor and then save your report again.

  7. To get the newly updated report to appear in the Report window, simply re-execute your part program, or click the Redraw icon from the Reporting toolbar.

  8. Finally, you need to print your report. Select the File | Printing | Report Window Print Setup... menu item.

  9. Select the Printer check box at the dialog box to send it to your printing device.

  10. From the Report window's Reporting toolbar, click the Print icon. PC-DMIS prints your report.

In this step you've loaded an existing report into the Report window, updated it, and then sent it to your printer.

Congratulations! You've successfully completed the Creating a Custom Report tutorial.

Custom Report Selection Dialog icon

Tutorial - Creating a Custom Report

This topic walks you through a very basic tutorial that will result in you creating a simple custom report. This should give you a basic overview of how Custom Reports are created within the Custom Reporting Editor and how they interact with existing label templates so you can later create and use your own custom reports.

Before beginning this tutorial, create a simple part program that has four measured circles on a simple part and four Circularity dimensions, one for each circle. This tutorial uses the Hexagon test block (Hexblock_Wireframe_Surface.igs).

Click on the links below to expand or collapse each step of instructions as needed. Some steps may also include a demo of that step. Simply click on blue icons like this one to see the demos:

Step 1: Setting up the Work Environment

Step 2: Dragging, Dropping, and Positioning Objects

Step 3: Using Multiple Pages

Step 4: Dropping onto Other Objects

Step 5: Inserting Data Items

Step 6: Viewing, Updating, and Printing your Report


Custom Report Generation

Display Menu Roadmap

To create a custom report, follow these steps:

  1. Select File | Reporting | New | Custom Report. The Custom Report Editor appears.

  2. If the Edit window isn't open, access it, and set it to Summary mode. If it is already open, PC-DMIS will automatically set the Edit window to Summary mode when you access the editor.

  3. Drag items from the Edit window and drop them into the editor. PC-DMIS automatically uses the labels defined by the current Page object's rule set to display the objects. If you drop an object and it doesn't have an associated label, an Open dialog box will appear allowing you to choose a label defined for the dropped item.

  4. Add and configure additional objects from the editor's Object Bar as needed.

  5. Position report elements as desired.

  6. Select File | Save to save your report. A dialog box appears allowing you to specify the name of your report.


Positioning Report Objects

Inside the Custom Report Editor you can easily position objects by dragging objects where you want them or by using the appropriate alignment icons from the editor's Layout Bar.

In addition, PC-DMIS provides a useful tool to essentially snap an object below an object above it. To do this, slowly drag an object so that its top and left edges are more or less aligned with another object's bottom and left edges. Your mouse pointer will change to include a small blue arrow: This arrow indicates that the object's left side you are positioning will be aligned with the object's left side above it.

Aligning Objects Using the Blue Arrow

When this arrow appears, you can release you mouse button, and the object you are dragging will align itself to the other object:

Objects Are Aligned

The blue arrow can also help with dropping an object precisely under another object. Simply drag the object over an existing object until green handles appear around the existing object, then drag the mouse slightly under that object until the blue arrow appears. Release the mouse when it appears, and the dropped object will appear aligned to the other object.

This allows you to create a list of objects without white space in between, useful when aligning a list of labels containing your feature or dimension data.


Dragging and Dropping Information into a Custom Report

As was described in "Custom Report Generation" topic, you can drag features and other items from the Edit window in Summary Mode into the Custom Report Editor.

Example of Dragging a File Header object onto the editing area (the Page object)

When you drop an item into the editor, the appropriate label for that feature, as defined by the Page object's Rule Tree Editor, automatically gets created:

Example of a Dropped File Header object

Replacing Information by Dropping on top of Existing labels

If you drag an item on top of an existing label like this:

Example of Dropping a Dimension on top of an Existing Label

PC-DMIS will replace the label with the dropped item:

Example of the Updated Label

Dropping Data on a CADReportObject

If you drag a feature or dimension on top of a CADReportObject, like this:

Example of Dropping a Dimension on top of a CADReportObject

PC-DMIS will add the appropriate label object and leader-line for the dropped object on top of the CADReportObject. The label displayed depends on the label specified in the CADReportObject's Rule Tree Editor, not the Rule Tree Editor for the Page object.

Example of a Dropped Dimension on top of a CADReportObject

Dropping Data on an Analysis Object

If you drag a dimension on top of a Analysis object, like this:

Example of Dropping a Dimension on top of an Analysis Object

PC-DMIS will display the graphical analysis information for the dropped dimension inside the Analysis object.

Example of a Dropped Dimension on top of an Analysis Object

Dropping Data on a Histogram Object

If you drag a dimension on top of a Histogram object, like this:

Example of Dropping a Dimension on top of a Histogram Object

PC-DMIS will display the histogram information for the dropped dimension inside the Histogram object.

Example of a Dropped Dimension on top of a Histogram Object

Dropping Data Items

If you expand an item's list in the Summary mode to where it displays the different data items, you can drag and drop these data items directly onto the Page object or into a cell of the GridControlObject.

Example of Dropping a Data Item of the Feature's Theoretical X Value into a GridControlObject Cell

PC-DMIS will automatically display the appropriate dropped value:

Example of the Dropped Data Item

If you look under the hood, you can see that PC-DMIS automatically uses the appropriate reporting expression to display the dropped data:

Example of the Data Item's Expression

Using expressions, instead of a hard-coded value means that if this data item changes for some reason, it will automatically get updated in your report when you re-execute or redraw your report.

Invalid Drop Areas

If you try to drop an item on top of an invalid object (for example if you drag a Feature or Dimension on top of a Text object), when you drag the item on top of the object, PC-DMIS will change your mouse icon to display a red "not allowed" icon to show you that you cannot drop that item there.

Example of an Invalid Drop Area for a Dragged Dimension

Using SHIFT and CTRL Keys When Dropping

While performing the drop of a command (such as a feature or dimension), if you hold down the SHIFT or CTRL keys and you release the button, PC-DMIS does the following:

  • SHIFT key - PC-DMIS will insert a CommandTextObject for that item. This lets you display the information for that item in a textual, non-table format.

  • CTRL key - PC-DMIS will display an Open dialog box allowing you to select a different label template for the item.

When performing a drop of a data item, if you hold down the CTRL key PC-DMIS displays not only the evaluated expression for the data item but the descriptive string of text from the Summary mode preceding it as well.

Dropping Multiple Items

You can drag and drop multiple items at once from the Edit window's Summary mode. This is useful if you want to quickly add several items into your report.

  • To select an entire list of consecutive items, click the first item, press SHIFT on the keyboard and click the last item. All items in between are selected.

  • To select or deselect individual items to or from your existing selection, press and hold the CTRL key while clicking on items.

Once you have selected a list of items, simply drag and drop them into the editor.


Using Rules

Like template reports, custom reports use the Rule Tree Editor to determine what label templates should be used in your report. A default set of rules is automatically included, so you only need to change the default rules if you want to load some sort of custom label template.

To work with these rules,

  1. Right-click on the editing area (the Page object) in the Custom Report Editor.

  2. Select Properties from the small popup menu. The Properties dialog box appears.

  3. Click on Rule... in the Rule Tree Editor property. The Rule Tree Editor appears

  4. Modify the rules as desired.

For information on using the Rule Tree Editor, see "About the Rule Tree Editor".


Working with Multiple Pages

When you create a new custom report using the Custom Report Editor, the editing area is blank. No objects exist in the editing area except for the editing area itself. The editing area is actually a Page object, and its properties can be modified as with any other object. Simply right-click on the object and select Properties.

Similar to Section tabs in the Report Template Editor, you can create multiple Page tabs (Page objects) in the Custom Report Editor. To do this, right-click on the tab and select Insert from the popup menu. An additional tab will appear at the bottom of the editing area:

Example of Multiple Page tabs

This will create additional reporting pages that will later appear in the Report window. While similar to Section tabs, Page tabs reflect a single additional page in your final report, whereas a single Section tab may actually end up displaying multiple pages in the final report depending on any defined rules for objects in that section and the length of your part program.

You can size your Page objects to meet different needs. For example, you can modify one page's properties to display its contents in a standard Portrait format and another page's properties to display its information in a Landscape format or to match printer or page settings for a specific locale.

You can easily reorder pages as well. To do this, right-click on a Page tab, and select either Move Right or Move Left. The tabs at the bottom of the Editing area will be reordered accordingly.


Viewing and Printing Custom Reports

Custom reports are viewed and printed using the Report window.

To view your report, Display Menu Roadmap

  1. Access the Report window (select View | Report Window).

  2. From the Report window toolbar, select the Custom Report Selection Dialog icon. A dialog box appears showing all custom reports.

  3. Select your report and click Open. Your report appears in the Report window.

To print your report, Display Menu Roadmap

  1. Define your output using the File | Printing | Report Window Print Setup... menu item.

  2. Either execute your part program, or click the Print icon from the Reporting toolbar.


Deleting Custom Reports

Display Menu Roadmap

Since custom reports are not stored as a real file, but are part of the part program file, they cannot be deleted using Windows Explorer or a Windows dialog box. They must be deleted within PC-DMIS.

To delete Custom Reports:

  1. Select View | Report Window to select the Report window.

  2. In the Report Window, click on the Custom Report Selection Dialog icon.

  3. Select the report to delete.

  4. Press the DELETE key.


Using a Custom Report from another Part Program

Display Menu Roadmap

You can use a Custom Report from another part program in your current part program to a certain extent.

To do this,

  1. Select the File | Reporting | Edit | Custom Report from Other part Program menu item. An Open dialog box appears showing all your part programs.

  2. Select your part program and click Open. A Custom Report dialog box appears. If a report exists for the selected part program, it will show up in this dialog box.

  3. From the dialog box, select the report you want to use and click Open. PC-DMIS loads the report in the Custom Report Editor.

If a feature or item is not found in the part program, the label or object will be blank.


About Report Expressions

Report Expressions are special commands that you place inside of supporting report or label template objects to pull specific data from PC-DMIS and place them into those objects. For example, suppose you wanted to insert a feature ID into a label template. You would simply add an object that supports expressions into your report, such as the GridControlObject. Then, inside of an Expression Cell of the grid, you would type "=ID".

There are four areas where you can insert report expressions:

1) The Rules Tree Editor in the Conditional Expression and Text Expression boxes.

2) The GridControlObject in its grid cells.

3) The GridControlObject in the Repeat Expression box in the Row tab for repeat expressions.

4) Property Sheet Values on edit fields or combo boxes that take text values.

For available expressions, consult "Functions and Operators" and "Using Data Types to Find a Report Expression" for lists of available functions, operators, and data types.

Note: Reporting expressions can also use many normal PC-DMIS expressions, discussed in the "Using Expressions and Variables" section. Simply precede the expressions with the "=" sign when typing them in the cell.

More:

Functions and Operators

Some Reporting Expressions Examples

Using Data Types to Find a Report Expression

Expressions Used in Standard Templates


Functions and Operators

The following are lists of functions and operators available to the Reporting expression language. These work the same as and are also available in the PC-DMIS expression language.

The Reporting expression language does not support variables, structures, or functions like the PC-DMIS expression language does. In place of variables, a new type called DATA_TYPE has been added to the language. See "Using Data Types to Find a Report Expression" for more information. Another new difference in the Reporting language is the addition of a set of constants described in "Predefined Constants".

Note: Remember to precede your expression with an equals sign (=). Also, make sure that the command from which you are getting your data supports the expression you want to use.

Functions for Report Expressions

Operators for Report Expressions

() Parentheses are used to group expressions and determine evaluation order.

More:

Some Reporting Expressions Examples


Functions for Report Expressions

For example, suppose you have the following Location dimension that references a circle named CIR1:

DIM LOC1= LOCATION OF CIRCLE CIR1 UNITS=IN ,$

GRAPH=OFF TEXT=OFF MULT=10.00 OUTPUT=BOTH

...

END OF DIMENSION LOC1

You can use the GetFeatureSetID function inside a rule to automatically determine the label that gets displayed for this dimension depending on whether or not CIR1 exists inside of a feature set.

For example, this rule will automatically use the LEGACY_DIMENSION.LBL label if it cannot find a FEAT/SET command that contains CIR1:

USE TEMPLATE "=GetFeatureSetID("LEGACY_DIMENSION.LBL")"

If there is a FEAT/SET command, you can then change the ID for that command to match the desired label name you want to use (or change a label file name to match the ID) and PC-DMIS will use that label instead.

In this code here, notice that the FEAT/SET references CIR1. It also has its usual label identification changed to "REFERENCE_ID". So that the GetFeatureSetID function will return "REFERENCE_ID.LBL":

REFERENCE_ID=FEAT/SET,CARTESIAN

THEO/<0,0,0>,<0,0,1>

ACTL/<0,0,0>,<0,0,1>

CONSTR/SET,BASIC,CIR1,,

=IsMarkedForArm(1)

would return 1 if the current command is marked for arm 1, otherwise it returns 0.

=IsMarkedForArm(2)

would return 1 if the current command is marked for arm 2, otherwise it returns 0.

=IsMarkedForArm(1) AND IsMarkedForArm(2)

would return 1 if the current command is marked for both arms, otherwise it returns 0.

Functions for Report Expressions

Items preceded with an asterisk symbol (*) are unique to the reporting expression language.

Function

Description

ABS(<expression>)

Returns the absolute value of the input value.

ACOS(<expression>)

Returns the arc-cosine for the input value. Input and result are in radians.

ANGLEBETWEEN(<expression1>, <expression2>)

Returns the angle between the two inputs expression1 and expression2, which should be of type vector. Result is in degrees.

ARRAY(<expression1>,<expression2>, & <expressionN>)

Creates an array out of the input values.

ASIN(<expression>)

Returns the arc-sine for the input value. Input and result are in radians.

ATAN(<expression>)

Returns the arc-tangent for the input value. Input and result are in radians.

CHR(<expression>)

Returns the ASCII character value for the corresponding input value which should be of type integer.

*COLOR(<expression1>, <expression2>)

Makes the text value of expression1 use one of the 4 colors as currently defined in the color tree. 1 = Marked Color 2 = Unmarked Color 3 = Step Mode Color 4 = Error Color. See "Changing a String's Text Color".

*GetTolColor(expression1, expression2, expression3)

This takes three expressions, the deviation, plus tolerance, and the minus tolerance and returns the current tolerance color as type COLORREF based on the deviation.

expression1 is the deviation as a double value, expression2 is the plus tolerance as a double value, and expression3 is the minus deviation as a double value.

You can use this returned color with color properties of objects in reporting such as ForeColor and BackColor to dynamically change the color of the object to reflect the current tolerance value.

These colors are specified in the Edit Dimension Color dialog box. See "Editing Dimension Colors" in the "Editing the CAD Display" section

CONCAT(<expression1>, <expression2>, & <expressionN>)

Concatenates all of the strings specified in expressions 1 through N together into 1 string.

COS(<expression>)

Returns the cosine for the input value. Input and result are in radians.

*COUNT(expression1)

Returns the number of instances of the data type specified in expression1 for the current command.

CROSS(<expression1>, <expression2>)

Returns the cross product of expession1 and expression2 both of which should be of type vector.

*DATAFIELD(<expression1>, <expression2>, <expression3>)

Used only within the Custom Report Editor, this returns information from a specific data field within a feature, dimension, or command. This takes three parameters: expression1 is a string representing the unique id or id of the command, expression2 is a string representing the data type, and expression3 is the typeindex. Normally the typeindex is 0, but in cases where a dtype occurs more than once, it will be 1 or greater.

This expression is automatically created and used when you drag and drop items from the Edit window into your custom report.

DATEVALUE()

Same as in PC-DMIS expression language.

DEG2RAD(<expression>)

Converts the input from degrees to radians.

DELTA(<expression1>, <expression2>, <expression3>)

Output is new point moved along the vector specified in expression2 by the distance specified in expession3 from the point specified in expression1.

DISTANCEFROMEDGE()

Retrieves the distance of the measured centroid of the command's underlying feature from the closest edge on the CAD.

  • If the underlying command is a feature, this uses the measured feature to return the distance.

  • If the underlying command is a dimension, this uses the first feature in the dimension to return the distance.

You can use this function in the Rule Tree Editor to specify different label templates based on distances returned.

DOT(<expression1>, <expression2>)

Returns the dot product of expression1 and expression2. Input values should be of type point.

DOUBLE(<expression>)

Converts the input value from its current type to a double. In the case of a point, the distance of the point from the origin is returned.

*ELAPSEDTIME()

Returns the amount of time taken for execution.

ELEMENT(<expression1>, <expression2>, <expression3>)

Same as in PC-DMIS expression language.

EQUAL(<expression1>, <expression2>)

Tests whether two arrays are identical and returns 1 if they are, otherwise 0.

<expression1> ^ <expression2>

Same as in PC-DMIS expression language.

EXPON(<expression>)

*FILENAME()

Returns the full path and filename of the part program.

FORMAT(<expression1>, <expression2>)

Same as in PC-DMIS expression language.

*GETCOUNT(expression1)

Returns a long value of the number of instances that exist for the ENUM_FIELD_TYPES data type, specified in expression1. For example, a location dimension that reports in X,Y,Z, and D would return 4 for the Axis data type.

GETFEATURESSETID(<expression1>)

During execution, if the current command is a dimension, the function checks to see if the reference feature for this dimension is in a feature set. If it finds the reference feature in a set, it returns that set's ID as a string value with a ".lbl" extension appended to the end of the string. If it does not find a feature set command with the reference feature it returns the default string value supplied in <expression1>. This default value should be a label file name that includes the .lbl extension.

IF(<expression1>, <expression2>, <expression3>)

If expression 1 evaluates to a non-zero value, the value of expression 2 is returned, otherwise, the value of expression 3 is returned.

INDEX(<expression1>, <expression2>)

Same as in PC-DMIS expression language.

INTEGER(<expression>)

ISMARKEDFORARM(<expression>)

Used in multiple arm mode contexts, this function returns 1 if the command is marked for the arm specified in <expression>, otherwise it returns 0. This lets you control what is displayed in the report based on the command's executing arm.

LEFT(<expression1>, <expression2>)

Same as in PC-DMIS expression language.

LEN(<expression>)

For a string, returns the number of characters in the string. For an array, returns the number of elements in the array.

LN(<expression>)

Same as in PC-DMIS expression language.

*LOADSTR(<expression>)

Loads the string using the numerical value from the resource files. A negative numerical value causes the string to be loaded from the strings resources. See "Loading Strings from PC-DMIS" for more information.

LOG(<expression>)

Same as in PC-DMIS expression language.

LOWERCASE(<expression>)

<expression1> < <expression2>

MAX(<expression>)

MAXINDEX( <expression>)

MAXINDICES( <expression>)

*MEASSCALE()

Returns the re-scale factor used when measuring.

MIN(<expression>)

Same as in PC-DMIS expression language.

MININDEX(<expression>)

MININDICES(<expression>)

MID(<expression1>, <expression2>, <expression3>)

MPOINT(<expression1>, <expression2>, <expression3>)

*NUMMEAS()

Displays a number value representing the number of dimensions reported.

*NUMOUTTOL()

Displays the number of reported dimension that were out of tolerance.

ORD(<expression>)

Same as in PC-DMIS expression language.

*PARTNAME()

Displays the part name (the same as what is shown in the file header).

*PAGE()

Displays the current page number.

*PAGES()

Displays the total number of pages.

PAGEDIMCOUNT("CadReportObjectId",Range)

This function takes two parameters. If the first parameter is empty (nothing inside the quote marks), then this returns the number of dimensions in the current page with a max deviation less than Range*Tol. The second parameter, Range, is a floating number. If you include the CadReportObject ID in the first parameter, then this returns the number of dimensions in tolerance associated with the specified CADReportObject. Suppose you want to return the number of out of tolerance dimensions with CADReportObject1. You could use the following code to do this:
=TotalPageDimCount("CadReportObject1") - PageDimCount("CadReportObject1",1.0)
You can also calculate the number of dimensions that contain a specific number of axes by appending ":N" to the ID, where N is a number representing the number of axes. For example, typing =PageDimCount("CadReportObject1:4",1.0) would return the number of dimensions associated with CadReportObject1 that contained at least four axes and that had the fourth axis within the specified tolerance of 1.0. If you do not specify the number of axes, it would return the number of dimensions associated with CadReportObject1 if all of its axes were within the specified tolerance of 1.0.

RAD2DEG(<expression>)

Same as in PC-DMIS expression language.

REAL(<expression>)

Same as in PC-DMIS expression language.

*REGSETTING(<expression1>, <expression2>)

Displays a value of a specific registry setting. This takes these two parameters: expression1 determines the section, and expression2 determines the entry.

REPORTDIMCOUNT("<expression1">, <expression2>)

This function acts like the PageDimCount() function except that instead of displaying the number of out of tolerance dimensions for the current page, it displays the total number of out of tolerance dimensions for the entire report. In addition, for <expression1> you need to use CADReportObject1 as the ID, or leave it empty (with just the quotes).

*REPORTVALUE(<expression1>)

Displays the value of another object's property. It takes one parameter, shown as expression1. This should be a string value of the object's unique ID followed by a period and then the property's name, for example, =REPORTVALUE("text1.text")

*REVNUM()

Displays the revision number (the same as what is shown in the file header).

*RGB(<expression1>, <expression2>, <expression3>, <expression4>)

Colors the string specified in expression 1 to the color specified via the RGB values of expressions 2, 3, and 4. See "Changing a String's Text Color".

RIGHT(<expression1>, <expression2>)

Same as in PC-DMIS expression language.

ROUND(<expression1>, <expression2>)

*SECTION()

Displays the current section number.

*SERNUM()

Displays the serial number (the same as what is shown in the file header).

SIN(<expression>)

Same as in PC-DMIS expression language.

SORTUP(<expression>)

SORTDOWN(<expression>)

SQRT(<expression>)

*STATCOUNT()

Returns the statistics count (same as in the file header).

STR(<expression>)

Same as in PC-DMIS expression language.

STRING(<expression>)

SUM(<expression>)

SYSTIME()

SYSTEMDATE(<expression>)

SYSTEMTIME(<expression>)

*TOGGLESTR(<expression1>, <expression2>)

Pulls the toggle string from the resources base on the resource id value in expression1. Again, a negative number is used for cases where the string should come from the strings resources. The value of expression2 is used to specify which substring of the toggle string is wanted. The result is the substring.

*TOGGLESTRING(DATA_TYPE)

If the specified data type for the given command is of type toggle string, the full toggle string is returned.

*TOGGLEVALUE(DATA_TYPE)

If the specified data type for the given command is of type toggle string, the index number (or toggle value) of the toggle string is returned.

*TOL(<expression1>, <expresion2>, <expression3>, <expression4>)

Expression 1 is the string being colored. Expression 2 is the test value, Expression 3 is the plus tolerance, and Expression 4 is the minus tolerance. If the test value is in tolerance (Between the values for Expression 3 and Expression 4), then the current marked color from the color tree is used. Otherwise, the Error color (usually red) is used as the color for the text.

TOTALPAGEDIMCOUNT("CadReportObjectID")

This function contains one parameter. If it is empty (nothing between the quote marks), this returns the total number of dimensions in the current page. If you type the ID of a CadReportOjbect in the parameter, PC-DMIS returns the total number of dimensions associated with that CadReportObject. For example, if you used this expression =TotalPageDimCount("CadReportObject3") then PC-DMIS would return the total number of dimensions associated with CadReportObject3. You can also calculate the number of dimensions that contain a specific number of axes by appending ":N" to the ID, where N is a number representing the number of axes. For example, typing =TotalPageDimCount("CadReportObject1:4") would return the total number of dimensions associated with CadReportObject1 that contained at least 4 axes.

TOTALREPORTDIMCOUNT("CADREPORTOJECTID")

This function functions like the TotalPageDimCount() function with these important differences: Instead of returning the number of dimensions for the current page, it returns the total number of dimensions for the entire report. However it only works if there's a CADReportObject. If you have an object ID as your parameter, it needs to be named CADReportObject1.

TRACEFIELD(<expression>)

Displays the given tracefield's name and value in the report. The value of the expression is simply a number value representing the order of the listed tracefields from top to bottom in your part program. So to display the first listed tracefield, the code would read: =TRACEFIELD(1)

UNIT(<expression>)

Same as in PC-DMIS expression language.

*VARIABLE(<expression1>,<expression2>)

Displays the defined variable's value. This function takes one or two parameters. Expression1 is the string value representing the variable's ID. Expression 2 is an optional ID of another command ID or UID. See "Displaying a Variable's Value" for more information.

VECX(<expression>)

Same as in PC-DMIS expression language.

VECY(<expression>)

VECZ(<expression>)


Operators for Report Expressions

Operators | Description
<expression1> == <expression2> | Evaluates to 1 if expression1 equals expression2. Otherwise, evaluates to 0.
<expression1> >= <expression2> | Evaluates to 1 if expression1 is greater than or equal to expression 2. Otherwise, evaluates to 0.
<expression1> <= <expression2> | Evaluates to 1 if expression1 is less than or equal to expression 2. Otherwise, evaluates to 0.
<expression1> > <expression2> | Evaluates to 1 if expression 1 is greater than expression2. Otherwise, evaluates to 0.
<expression1> < <expression2> | Evaluates to 1 if expression 1 is less than expression2. Otherwise, evaluates to 0.
<expression1> - <expression2> | Subtracts expression2 from expression1.
<expression1> / <expression2> | Divides expression1 by expression2.
<expression1> % <expression2> | Returns the remainder from expression1 divided by expression2 if any.
<expression1> * <expression2> | Multiplies expression1 by expression2.
<expression1> <> <expression2> | Compares expression1 to expression2, if they don't match it evaluates to 1. If they do match, it evaluates to 0.
-<expression> | The unary minus operator negates the value of the operand in expression.
!<expression> | Logical NOT operator. This inverts the value of the variable or expression. If the <expression> evaluates to TRUE, the !<expression> evaluates to FALSE. If the <expression> evaluates to FALSE, the !<expression> evaluates to TRUE.
<expression1> AND <expression2> | Performs a binary AND operation on two numbers. Otherwise, concatenates strings or numbers together in the case of mixed types.
<expression1> OR <expression2> | Performs a binary OR operation on two numbers.
<expression1> + <expression2> | Adds expression1 and expression2 together.


Some Reporting Expressions Examples

The following topics provide you with a few examples of things you can do with the Reporting expression language:

  • Displaying a Variable's Value

  • Changing a String's Text Color

  • Loading Strings from PC-DMIS

Use the functions and operators in the "Functions and Operators" topic, to create your own Reporting expressions.


Displaying a Variable's Value

Step 1: Remove the header's read-only protection so you can modify your header inside PC-DMIS.

  1. In Windows explorer, access File_Header.lbl from the reporting sub-directory.

  2. Right-click on it and select properties.

  3. Clear the read-only check box.

Step 2: Open the File_Header.lbl file in PC-DMIS and Modify the GridControlobject to hold another row of data.

  1. In PC-DMIS access the label template editor (File | Reporting | Edit | Label Template) and open File_Header.lbl. It will appear in the label template editor. You will see the information is contained inside an object called a GridControlObject.

  2. Select the GridControlObject and right-click on it. The Properties dialog box appears containing the properties making up the GridControlObject. Add another row, by changing NumRows to 3 and pressing TAB. Notice that the background isn't tall enough to support the added row.

  3. From the drop down list on the Properties dialog box, select TheFrame/TheView and change the Height property to 100 and press TAB to accept the change.

Step 3: Add a report expression into the GridControlObject to accept a trace field's information

  1. Select the GridControlObject again.

  2. If the handles (green boxes) do not yet include the newly added row, drag the green handles downward until they do.

  3. Double-click to make the GridControlObject "active". This shows all the behind-the-scenes expressions.

  4. Select the cell that will hold the trace field's value and type: =TRACEFIELD(1) and then press TAB. This expression tells PC-DMIS to put the data for the first trace field in that cell. For example, if you wanted the second trace field's data, you would use =TRACEFIELD(2). (See the attached image file below.)

  5. Play around with the cells and format them as desired. The best way to do this is to select one or more cells within the grid and then right-click on it. The Grid Properties dialog box appears.

  6. Deactivate the GridControlObject by clicking outside of it.

  7. Save your changes.

Step 4: Test your changes.

  1. Execute your part program.

  2. Access the Report window (View | Report Window).

  3. Click the Redraw the Report icon on the Reporting window's toolbar.

  4. The trace field's info should now appear in the header.

Displaying a Variable's Value

PC-DMIS's reporting language lets you display a variable's value in your report by using the Variable() function. This function has the following syntax:

Variable(<varname>, [<optional command id or uid>])

The first parameter, coerced to a string type, represents the name of the variable. The second optional parameter can be used to solve for the variable's value relative to another command.

For example, suppose you this code in your part program:

ASSIGN/V1 = 2

F1 = FEAT/CIRCLE...

ASSIGN/V1 = F1.X

COMMENT/OPER,"Some comment text"

For the purposes of this example, assume that the comment has a unique ID or "UID" of 245.

Now consider the following examples with the code above:

=VARIABLE("V1") - If there are no other statements setting the value to V1 in the report, then the value may be either 0, 2, or the same as the measured centroid x value of feature F1. It all depends on which commands have already executed at the point that the report expression is evaluated and which command is currently being processed for the report.

=VARIABLE("V1", "F1") - If this is the only feature named "F1" in the program, then the result of evaluating this expression should be 2 since V1 is assigned to 2 directly above feature F1.

=VARIABLE("V1", 245) - In this case, the UID is used; so the value of this expression on the report should be the same as F1.X.

Note: Individual cells of a GridControlObject cannot acquire a variable's value from the part program. In most cases you will need to use Text objects.

Variables and Headers

Normally, you cannot display a variable's value inside your report's file header because PC-DMIS evaluates the file header before executing statements in the part program. So, when the file header attempts to reference a variable that hasn't yet been created, PC-DMIS will display a zero value. However, some options do exist to get information from your part program into your header:

Option 1 - Use Trace Fields Instead of Variables

Use trace fields instead of variables in your part program to capture the information and then use the =TRACEFIELD() function inside the desired cell in the GridControlObject of the header's label template to reference it. Trace fields force the template to re-evaluate the report based on the new information causing the trace field to appear.

Advantages / Disadvantages

  • Advantages - Relatively easy to set up.

  • Disadvantages - You aren't actually using variables. Trace fields are used instead and have their own limitations.

Procedure

Option 2 - Embed the Report Template

Embed the report template into your part program sometime after the ASSIGN statements have been defined, and then send the variable's value to the label template as a parameter. Add additional rows or cells as needed, and on top of the added cells, add and size a Text object for each variable you want to display. Finally, modify the Text property through a parameter of the REPORT/TEMPLATE command, like this:

ASSIGN/V1="A String Value to Pass"

CS1 =REPORT/TEMPLATE, FILENAME= TEXTONLY.RTP, AUTOPRINT=NO, Section=-1

PARAM/TEXT1.TEXT=V1

PARAM/=

ENDREPORT/

Because the label template is merged into the report template you can modify certain parameters on the label template by referencing the report template in the above fashion.

Advantages / Disadvantages

  • Advantages - Variables will now appear in your final report's header.

  • Disadvantages - Somewhat difficult to setup as you will need to add a Text objects into your label template in addition to the code to embed the report template into the part program. The main disadvantage to this approach, however, is that the report will be generated twice one after the other. Once from PC-DMIS's default functionality and again from the embedded REPORT/TEMPLATE code block.

Option 3 - Put Header Information Directly into Report

Instead of using a report template that refers to an external label template for the header, such as File_Header.lbl, recreate the GridControlObject from the header's label template directly inside your report template. Add additional rows or cells as needed, and on top of the added cells, add and size a Text object for each variable you want to display. Then for each Text object use the =VARIABLE() function to pull in the variable information. For example, =VARIABLE("V1").

Make these remaining modifications inside the report template:

  1. In the TextReportObject change the rules so that the header label isn't used.

  2. Set these properties for the current section, Section1:

Command Set = All Commands

Maximum Number of Pages = 1

  2. Add a second section, Section2, and give it a TextReportObject as well, again changing its rules so that a header label isn't used.

  3. Set these properties for Section2:

Command Set = Continue From Previous Section

Maximum Number of Pages = 0 (meaning there is no maximum)

Advantages / Disadvantages

  • Advantages - Variables will now appear in your final report's header.

  • Disadvantages - Somewhat difficult to set up since you have to recreate the GridControlObject inside the report template, add Text objects for each variable, and add an additional report section. Additionally, any editing done to the report, such as turning on "Show Feature" or changing Dimensions to "Out of tolerance Only", needs to be done twice, once for page 1 (first section) and once for the other pages (section 2).

Option 4 - Use a Generic Feature to Force Report Regeneration

This option uses an empty Generic feature to force the label template to re-evaluate the report and pull in needed variables values into your final report.

In your part program, create an empty Generic feature and give it a descriptive name such as:

REPORTHEADER=GENERIC/NONE,DEPENDENT,CARTESIAN,OUT,$

Next, modify the header label template, adding additional cells as needed to the GridControlObject, and then on top of the added cells, add and size a Text object for each variable you want to display. Now set the Text property for each Text object to use the =VARIABLE() function to pull in the variable information. In this option, however, you need to refer to the generic feature by using use the extra parameter in the =VARIABLE() function. For example, =VARIABLE("V1","REPORTHEADER")

Advantages / Disadvantages

  • Advantages - Probably the most versatile approach. Variables will now appear in your final report's header. You will not need to edit the final report twice as in Option 2

  • Disadvantages - Somewhat difficult to set up since you will need to include an empty Generic feature in your part program and add Text objects for each variable inside the label template.


Changing a String's Text Color

Using the RGB Function

The Reporting expression language lets you use a RGB function to define an RGB (Red Green Blue) color value and apply it to a string of characters in expression text. This function takes four parameters, a string parameter, followed by comma separated RGB parameters, like this:

=RGB(string,R,G,B)

If you type this function in the Cell Expression box (or cell) of the GridControlObject, click OK, and then click outside of the object, PC-DMIS evaluates the expression and gives the text the specified color value.

Cell Expression box showing the RGB expression

For example, if you type this expression into a cell,

=RGB("Blue Text",0,0,255) + RGB(" Black Text",0,0,0) + RGB(" Yellow Text",255,255,0)

then the words would look like this in a template editor:

Using the Color Function

The Color function takes two parameters. The first, a color parameter, is actually a number that represents one of the principle Edit window colors. The second, is the string value to which PC-DMIS applies the color.

=COLOR(1, "My Text")

The first parameter is a value of 1 to 4 and passes the Edit window color that associated with the following:

1 passes the Marked Color

2 passes the Unmarked Color

3 passes the Step Mode Color

4 passes the Error Color

These colors are defined in the Edit window's Color Editor dialog box. See "Defining Edit Window Colors" in "Setting Your Preferences" for information.


Loading Strings from PC-DMIS

Similar to how you can change the text color for a cell in the "Changing Expression Text Color" topic, the Reporting expression language lets you pull strings from PC-DMIS's current running language by using this expression:

=LOADSTR(<integer expression>)

This string takes a single parameter, an integer number that corresponds to the value of a string located in resource.dll or strings.dll.

  • A positive number pulls the string from the resource.dll file.

  • A negative number pulls the string from the strings.dll file.

If you type this function in the Cell Expression box (or cell) of the GridControlObject, click OK, and then click outside of the object. PC-DMIS evaluates the expression and returns the string assigned to the specified integer value.

Note: This functionality was added primarily so that the label templates that ship with PC-DMIS use string data from your current language.


Using Data Types to Find a Report Expression

When using expressions, you usually use expressions that pull data from PC-DMIS. You need to make sure that the command or feature you associate with the label template to do this has the data you are trying to display. Data Types can help you find the correct expression to use.

For example, suppose you create a label template that has a GridReportObject, and in one of the cells you type this expression to display a feature's measured X data:

=MEAS_X

Now, if you create a report template, add a TextReportObject, and use the Rule Tree Editor to associate your label template with PREHIT commands, in the Report window the cell will not display anything. Why? Because the PREHIT command does not have a measured X field. To use the correct expression, you can view data types for different fields in the Edit window's command mode.

This procedure explains how to turn on and view data types:

  1. Access the Edit window.

  2. Place the Edit window into Command mode.

  3. Right-click on the Edit window. A shortcut menu appears.

  4. Select Change Popup Display | Data Type Information.

  5. Hover your mouse pointer over a field in a command, and PC-DMIS will display a small, yellow popup that shows that field's data type. The first part of the value in parentheses is the data type and an equivalent expression exists in the list of expressions.

Consider this example:

A Data Type Popup

This data type popup shows that THEO_X is a valid expression for this command. If you typed "=THEO_X" into an appropriate location, PC-DMIS would display this feature's theoretical X value.

Using data types you can ensure that your report and label templates are using expressions supported by that command.

More:

A List of Available Data Types

Using a Type Index to Display Specific Data

Using a Prefix Number to Determine a Reference Feature

Predefined Constants


A List of Available Data Types

-A-

Number | Data Type Name | Data Type Description | Index | Value String
481 | ABOVEBELOW_CONFIG |  |  |
409 | ADDITIONAL_CHART | For SPC |  |
153 | ALIGN_LIST | Show alignment in alignment list (Yes / No) |  |
300 | ANGLE_COMP_TOGGLE | Toggle field for complement state of angle dimensions |  |
149 | ANGLE_OFFSET | Angle Offset for loops and rotary tables |  |
373 | ANGULARITY_NOM_ANGLE | The reference angle used, not the dimension's nominal |  |
103 | ANGVEC_I | Angle vector i | 0 | Numeric value
104 | ANGVEC_J | Angle vector j | 0 | Numeric value
105 | ANGVEC_K | Angle vector k | 0 | Numeric value
164 | ARROW_MULTIPLIER | Dimension arrow multiplier value |  |
479 | ARTICULATEDARM_TYPE |  |  |
234 | AUTO_CLEAR_PLANE | Auto clear plane flag |  |
461 | AUTO_ONERROR_TYPE |  |  |
533 | AUTO_PH9 |  |  |
219 | AUTO_PRINT | Auto print flag for hyper report object |  |
295 | AUTOBEEPING | Turn autotrigger beeping on/off |  |
52 | AUTOFIT_CONSTRAINT | Toggle for type of constraint on best fit alignment |  |
298 | AUTOTOLZONE | Tolerance zone for autotrigger |  |
294 | AUTOTRIGGERONOFF | Turn autotrigger on or off. |  |
140 | AVERAGE_ERROR | Flag for iterative alignments |  |
749 | AXIS_DESCRIPTION |  |  |
747 | AXIS_MINUS_TOL |  |  |
132 | AXIS_NOMINAL | Axis |  |
748 | AXIS_NOMINAL |  |  |
746 | AXIS_PLUS_TOL |  |  |

-B-

Number | Data Type Name | Data Type Description | Index | Value String
51 | BF_MATH_TYPE | Math type used to calculate best fit |  |
50 | BOUND_TYPE | Bound / Unbound |  |
360 | BOUNDARY_POINT_X | Boundary Point x |  |
361 | BOUNDARY_POINT_Y | Boundary point y |  |
362 | BOUNDARY_POINT_Z | Boundary point z |  |
476 | BSMETHOD_TYPE |  |  |
207 | BUFFER_SIZE_TYPE | File i/o buffer size |  |

-C-

Number | Data Type Name | Data Type Description | Index | Value String
492 | CAD_COMP |  |  |
237 | CAD_TOLERANCE | CAD tolerance for perimeter scans |  |
471 | CALC_STYLE_FILE |  |  |
413 | CENTER_POINT | For SPC |  |
478 | CENTER_ROTATION_MEAS | Best fit alignments |  |
477 | CENTER_ROTATION_THEO | Best fit alignments |  |
445 | CHART_SUB_TYPE | For SPC |  |
388 | CHART_TYPE | For SPC: charts |  |
42 | CIRC_TYPE | Circular or straight probe motion (circles and cylinders) |  |
614 | CLIP_LEFT_DIST |  |  |
604 | CLIP_LOW_DIST |  |  |
615 | CLIP_RIGHT_DIST |  |  |
603 | CLIP_UP_DIST |  |  |
244 | COL132_TYPE | On / Off setting for column 132 object |  |
701 | COLUMN_HDR |  |  |
296 | COLUMN_ID | Sets the column id for a load or unload column command |  |
245 | COMMAND_STRING | For external command object |  |
189 | COMMENT | Comment text |  |
709 | COMMENT_INPUT | Add new type for comment input value |  |
190 | COMMENT_TYPE | Comment type |  |
724 | COMPOSITE |  |  |
468 | CONE_CONVEX_TYPE |  |  |
60 | CONE_LENGTH_ANGLE_TYPE | For cones: show length or angle |  |
39 | COORD_TYPE | Coordinate System |  |
621 | COP_BOOLEANTYPE |  |  |
618 | COP_COLORMAP |  |  |
619 | COP_COPLEMENT |  |  |
616 | COP_EXPORTFILETYPE |  |  |
543 | COP_FILTER |  |  |
622 | COP_IMPORTFILETYPE |  |  |
617 | COP_SELECTIONTYPE |  |  |
544 | COP_SIZE |  |  |
545 | COP_TYPE |  |  |
425 | CPOINT_DIAM |  |  |
428 | CPOINT_F_SCANSPEED |  |  |
422 | CPOINT_I |  |  |
423 | CPOINT_J |  |  |
424 | CPOINT_K |  |  |
426 | CPOINT_SCAN_CROSS_TOTAL |  |  |
427 | CPOINT_SCAN_DENSITY |  |  |
430 | CPOINT_TYPE |  |  |
419 | CPOINT_X |  |  |
420 | CPOINT_Y |  |  |
421 | CPOINT_Z |  |  |
433 | CREATE_WEIGHTS | For best fit 2D/3D alignments |  |
65 | CURVE_TYPE | For curves - type of curve |  |

-D-

Number | Data Type Name | Data Type Description | Index | Value String
252 | DATA_MEM_PAGES | Database memory pages for statistics object |  |
250 | DATA_READ_LOCK | Database read lock for statistics object |  |
251 | DATA_WRITE_LOCK | Database write lock for statistics object |  |
731 | DATUM1_MODIFIER |  |  |
734 | DATUM1_MODIFIER2 |  |  |
725 | DATUM2 | This is because DATUM and DATUM2 are used in two different groups in summary mode. |  |
732 | DATUM2_MODIFIER |  |  |
735 | DATUM2_MODIFIER2 |  |  |
733 | DATUM3_MODIFIER |  |  |
736 | DATUM3_MODIFIER2 |  |  |
389 | DB_CHART_NAME | For SPC: chart name |  |
386 | DB_QUERY_OP | For SPC |  |
387 | DB_SOURCE_NAME | For SPC |  |
459 | DB_SOURCE_TYPE | For SPC |  |
539 | DELETE_TYPE | FILE/CLOSE, fptr, KEEP | DELETE |  |
203 | DESCRIPTION | Subroutine parameter description |  |
727 | DESCRIPTION2 | This is because DESCRIPTION and DESCRIPTION2 are used in two different groups in summary mode. |  |
133 | DEST_EXPR | Destination expressions (assign, subroutine, hyper report) |  |
353 | DEV_DIAM | Dev diam value |  |
280 | DEV_PERPEN_CENTERLINE |  |  |
350 | DEV_X | Dev x value |  |
351 | DEV_Y | Dev y value |  |
352 | DEV_Z | Dev z value |  |
390 | DEVIATION_ANGLE | Deviation angle |  |
180 | DEVIATION_SYMBOLS | Dimension format dev symbols toggle |  |
737 | DEVPERCENT_NOM |  |  |
739 | DEVPERCENT2 |  |  |
199 | DIGIT_COUNT | Digit count for dmis file read/write command |  |
324 | DIM_BONUS | Dimension bonus |  |
340 | DIM_DEVIATION | Dimension deviation |  |
182 | DIM_HEADING | Dimension format heading item |  |
304 | DIM_ID | For Best Fit 2d Alignments |  |
160 | DIM_INFO_LOC | Dimension info object location axis toggle |  |
159 | DIM_INFO_ORDER | Dimension info order toggle |  |
161 | DIM_INFO_TP_LOC | Dimension info object tp location axis toggle |  |
173 | DIM_LENGTH | Dimension length |  |
754 | DIM_LENGTH2 |  |  |
332 | DIM_MAX | Dimension max value |  |
328 | DIM_MEASURED | Measured dimension value |  |
336 | DIM_MIN | Dimension min value |  |
344 | DIM_OUTTOL | Dimension outtol |  |
703 | DIM_RPT_DATUM |  |  |
705 | DIM_RPT_DEVPERCENT |  |  |
704 | DIM_RPT_GRAPHIC |  |  |
706 | DIM_RPT_ISBILATERAL |  |  |
702 | DIM_RPT_ISDATUM |  |  |
707 | DIM_RPT_NUMZONES |  |  |
177 | DIM_TEXT | Dimension format dim text toggle |  |
178 | DIM_TEXT_OPTIONS | Dimension format dim text options toggle |  |
510 | DISPLAY_ADVANCED_PARAMETERS |  |  |
236 | DISPLAY_HITS | Scan flag (yes / no) for display of scan hits |  |
184 | DISPLAY_ID | Point info show id toggle |  |
607 | DISPLAY_PROBE_PARAMETERS |  |  |
256 | DISPLAY_TRACE | Trace field object yes/no toggle for dialog display |  |
185 | DISPLAY_TYPE | Point info show type toggle |  |
155 | DISTANCE | Distance |  |
676 | DRF_COLUMN_HDR |  |  |
681 | DRF_ROTATIONX |  |  |
682 | DRF_ROTATIONY |  |  |
683 | DRF_ROTATIONZ |  |  |
677 | DRF_SEGNAME |  |  |
678 | DRF_SHIFTX |  |  |
679 | DRF_SHIFTY |  |  |
680 | DRF_SHIFTZ |  |  |
641 | DRF_TBLHDR |  |  |
291 | DTYPE_LEAPFROGFULLPARTIAL | Leapfrog type: Full leapfrog or partial leapfrog |  |
290 | DTYPE_LEAPFROGNUMHITS | Number of hits to be taken during leapfrog procedure |  |
289 | DTYPE_LEAPFROGTYPE | Type of leapfrog being performed |  |

-E-

Number | Data Type Name | Data Type Description | Index | Value String
99 | END_ANG | End angle | 0 | Radian value
144 | END_NUM | End number of loop |  |
787 | END_OFFSET | Ending depth | 0 | Ending depth value
467 | ERROR_LABEL |  |  |
202 | ERROR_MODE | Error mode for on error flow control command |  |
201 | ERROR_TYPE | Error type for on error flow control command |  |
292 | EXCLUSION_ZONE | Exclusion zone command is on or off |  |
293 | EXECUTE | Is the attached program executed (Yes / No) |  |
595 | EXPOSURE |  |  |

-F-

Number | Data Type Name | Data Type Description | Index | Value String
79 | F_AUTOMOVE | Automove distance |  |
85 | F_BOXLENGTH |  |  |
84 | F_BOXWIDTH |  |  |
88 | F_CHECK | The only numeric associated with the CPCDcheck feature |  |
87 | F_CIRCRADIN |  |  |
86 | F_CIRCRADOUT |  |  |
81 | F_CORNER_RADIUS |  |  |
78 | F_DEPTH | Depth of measurements | 0 | Depth value
82 | F_INCREMENT |  |  |
80 | F_INDENT | Measurement offsets for various features | 1 | Offset value
243 | F_LOCATION | Location value for section scans |  |
89 | F_MAXACCELX | Maximum X acceleration |  |
90 | F_MAXACCELY | Maximum Y acceleration |  |
91 | F_MAXACCELZ | Maximum Z acceleration |  |
168 | F_MINUS_TOL | Dimension minus tol value |  |
95 | F_MOVESPEED | Move speed |  |
74 | F_OFFSET | Offset value |  |
76 | F_PITCH | Auto feature pitch |  |
167 | F_PLUS_TOL | Dimension plus tol value |  |
97 | F_SCANSPEED | Scan speed |  |
434 | F_SIZE | for SPC |  |
75 | F_SPACER | Auto feature spacer | 0 | Max distance value
77 | F_THICKNESS | Sheet metal thickness | 0 | Thickness value
593 | F_THICKNESS_EDGE |  |  |
83 | F_TOLERANCE |  |  |
96 | F_TOUCHSPEED | Touch speed |  |
208 | FAIL_ON_EXIST | File i/o fail on exist mode |  |
303 | FEAT_TYPE | Feature Type |  |
198 | FIELD_WIDTH | Field width for dmis file read/write command |  |
206 | FILE_COMMAND_TYPE | File i/o command type |  |
152 | FILE_NAME | File name |  |
197 | FILE_POINTER | File pointer name for file i/o commands |  |
598 | FILTER_NEIGHBOR_NUM |  |  |
606 | FILTER_TOGGLE |  |  |
600 | FILTER_TOL_ABOVE |  |  |
601 | FILTER_TOL_BELOW |  |  |
602 | FILTER_TOL_RIGHT |  |  |
472 | FILTER_TYPE | Basic scan filter type |  |
460 | FIND_HOLE_PERCENT | For the check command and find hole check distance |  |
54 | FIND_NOM_AXIS_TYPE | Selects between X, Y, Z, or user defined nominal axis |  |
233 | FIND_NOMS_TYPE | Type for find noms mode |  |
47 | FINDHOLE_TYPE | Use find hole algorithm (Yes / No) |  |
527 | FINDNOMS_BESTFIT |  |  |
528 | FINDNOMS_ONLYSELECTED |  |  |
452 | FIT |  |  |
465 | FIXTURE_TOL |  |  |
226 | FIXTURE_TYPE | Type for load fixture object |  |
246 | FLY_MODE_TYPE | Fly mode Off/On toggle |  |
560 | FREQUENCY |  |  |

-G-

Number | Data Type Name | Data Type Description | Index | Value String
183 | GAP_ONLY_TYPE | ON / OFF toggle |  |
708 | GDT_SYMBOL |  |  |
730 | GDT_SYMBOL2 |  |  |
64 | GEN_ALIGN_TYPE | Generic feature alignment type (independent / dependent) |  |
63 | GEN_FEAT_TYPE | Generic feature type |  |
162 | GRAPH_ANALYSIS | Use graphical analysis on dimension (yes / no) |  |
785 | GRAPH_ANALYSIS_MINUS_TOL | Auto Feature cad point minus tolerance |  |
784 | GRAPH_ANALYSIS_PLUS_TOL | Auto Feature cad point plus tolerance |  |
783 | GRAPH_ANALYSIS_POINT_SIZE | Auto Feature cad point size |  |
458 | GRAPH_OPTION | Dimension info and point info commands |  |
408 | GRID | For SPC |  |

-H-

Number | Data Type Name | Data Type Description | Index | Value String
483 | HIGH_ACCURACY |  |  |
223 | HIGH_THRESHOLD | High threshold for temp comp object |  |
407 | HISTOGRAM | For SPC |  |
359 | HIT_TYPE | Hit type |  |
68 | HITINT_TYPE | Interior/Exterior measurement flag |  |

-I-

Number | Data Type Name | Data Type Description | Index | Value String
2 | ID | Object id |  |
392 | IGNOREMOTIONERRORS_TYPE | For ignore motion errors command |  |
205 | INDEX_END | Array index end number |  |
204 | INDEX_START | Array index start number |  |
72 | INIT_HITS | Initial hits |  |
40 | INOUT_TYPE | Inside / Outside |  |
596 | INTENSITY |  |  |
150 | INTERNAL_EXTERNAL | Recall Alignment |  |
454 | IOCHANNEL_NUMBER | For IO channel management commands |  |
457 | IOCHANNEL_PULSE_DURATION | No longer used, probably should be removed |  |
456 | IOCHANNEL_PULSE_INTERVAL | No longer used, probably should be removed |  |
455 | IOCHANNEL_PULSE_WIDTH | No longer used, probably should be removed |  |
634 | ISLAND_AI |  |  |
635 | ISLAND_AJ |  |  |
636 | ISLAND_AK |  |  |
638 | ISLAND_CLEARANCEDIST |  |  |
625 | ISLAND_DIAM |  |  |
631 | ISLAND_I |  |  |
632 | ISLAND_J |  |  |
633 | ISLAND_K |  |  |
626 | ISLAND_LENGTH |  |  |
637 | ISLAND_TYPE |  |  |
627 | ISLAND_WIDTH |  |  |
628 | ISLAND_X |  |  |
629 | ISLAND_Y |  |  |
630 | ISLAND_Z |  |  |
138 | ITEM_USED | Best fit item used in calculation of alignment |  |
354 | ITERATE_COLUMNS | Iterate columns setting |  |

-J-

No Entries Available

-K-

No Entries Available

-L-

Number | Data Type Name | Data Type Description | Index | Value String
200 | LABEL_ID | Label field for flow control objects that reference labels |  |
729 | LEADER_LINE_ID |  |  |
480 | LEFTYRIGHTY_CONFIG |  |  |
4 | LEVEL_REF_ID | Ref id for a level feature of an iterative alignment |  |
62 | LIN_POL_FILT_TYPE | Filter object - linear or polar filter |  |
782 | LINE1_BONUS |  |  |
643 | LINE1_CALLOUT |  |  |
644 | LINE1_COLUMN_HDR |  |  |
650 | LINE1_DEV |  |  |
651 | LINE1_DEVPERCENT |  |  |
750 | LINE1_DEVPERCENT_NOM |  |  |
752 | LINE1_DEVPERCENT2 |  |  |
645 | LINE1_FEATNAME |  |  |
652 | LINE1_ISBILATERAL |  |  |
768 | LINE1_MAX |  |  |
647 | LINE1_MEAS |  |  |
769 | LINE1_MIN |  |  |
649 | LINE1_MINUSTOL |  |  |
646 | LINE1_NOMINAL |  |  |
653 | LINE1_NUMZONES |  |  |
765 | LINE1_OUTTOL |  |  |
648 | LINE1_PLUSTOL |  |  |
642 | LINE1_TBLHDR |  |  |
751 | LINE1_USE2DEVIATIONS |  |  |
686 | LINE2_AXIS |  |  |
658 | LINE2_BONUS |  |  |
655 | LINE2_CALLOUT |  |  |
656 | LINE2_COLUMN_HDR |  |  |
660 | LINE2_DATUMSHFT |  |  |
662 | LINE2_DEV |  |  |
663 | LINE2_DEVANG |  |  |
664 | LINE2_DEVPERCENT |  |  |
740 | LINE2_DEVPERCENT_NOM |  |  |
742 | LINE2_DEVPERCENT2 |  |  |
657 | LINE2_FEATNAME |  |  |
697 | LINE2_ISBILATERAL |  |  |
695 | LINE2_MAX |  |  |
688 | LINE2_MEAS |  |  |
696 | LINE2_MIN |  |  |
694 | LINE2_MINUSTOL |  |  |
687 | LINE2_NOMINAL |  |  |
698 | LINE2_NUMZONES |  |  |
766 | LINE2_OUTTOL |  |  |
693 | LINE2_PLUSTOL |  |  |
654 | LINE2_TBLHDR |  |  |
659 | LINE2_TOL |  |  |
661 | LINE2_UNUSEDZONE |  |  |
741 | LINE2_USE2DEVIATIONS |  |  |
669 | LINE3_BONUS |  |  |
666 | LINE3_CALLOUT |  |  |
667 | LINE3_COLUMN_HDR |  |  |
671 | LINE3_DATUMSHFT |  |  |
673 | LINE3_DEV |  |  |
674 | LINE3_DEVANG |  |  |
675 | LINE3_DEVPERCENT |  |  |
743 | LINE3_DEVPERCENT_NOM |  |  |
745 | LINE3_DEVPERCENT2 |  |  |
668 | LINE3_FEATNAME |  |  |
699 | LINE3_ISBILATERAL |  |  |
774 | LINE3_MAX |  |  |
771 | LINE3_MEAS |  |  |
775 | LINE3_MIN |  |  |
773 | LINE3_MINUSTOL |  |  |
770 | LINE3_NOMINAL |  |  |
700 | LINE3_NUMZONES |  |  |
767 | LINE3_OUTTOL |  |  |
772 | LINE3_PLUSTOL |  |  |
665 | LINE3_TBLHDR |  |  |
670 | LINE3_TOL |  |  |
672 | LINE3_UNUSEDZONE |  |  |
744 | LINE3_USE2DEVIATIONS |  |  |
355 | LOAD_TYPE | Load setting |  |
287 | LOCATOR_BMP | Feature Locator BMP On/Off |  |
288 | LOCATOR_WAV | Feature Locator WAV On/Off |  |
210 | LOW_FORCE | Low force for option probe object |  |
224 | LOW_THRESHOLD | Low threshold for temp comp object |  |

-M-

Number | Data Type Name | Data Type Description | Index | Value String
227 | MACHINE_TYPE | Machine type for load machine object |  |
485 | MAGNIFICATION |  |  |
176 | MAN_RETRACT |  |  |
94 | MANUAL_FINE_PROBING | Manual fine probing |  |
534 | MANUAL_PREPOSITION | Whether manual pre-position needed on vision target |  |
221 | MATERIAL_COEFFICIENT | Material coefficient for temp comp object |  |
242 | MAX_ANGLE | Setting for variable technique on scans |  |
209 | MAX_FORCE | Max force for option probe object |  |
240 | MAX_INCREMENT | Setting for variable technique on scans |  |
491 | MEAN |  |  |
569 | MEAS_A |  |  |
612 | MEAS_A2 | For CMT characteristic point 1 |  |
30 | MEAS_ANGLE | Measured angle |  |
721 | MEAS_AREA |  |  |
556 | MEAS_DEPTH |  |  |
29 | MEAS_DIAM | Measured diameter |  |
584 | MEAS_EA |  |  |
585 | MEAS_EH |  |  |
624 | MEAS_END_ANG |  |  |
583 | MEAS_ER |  |  |
313 | MEAS_EX | Measured endpoint x component |  |
314 | MEAS_EY | Measured endpoint y component |  |
315 | MEAS_EZ | Measured endpoint z component |  |
552 | MEAS_FLUSH |  |  |
554 | MEAS_GAP |  |  |
570 | MEAS_H |  |  |
613 | MEAS_H2 | For CMT characteristic point 1 |  |
306 | MEAS_HEIGHT | Measured height |  |
25 | MEAS_I | Measured i |  |
26 | MEAS_J | Measured j |  |
27 | MEAS_K | Measured k |  |
28 | MEAS_LENGTH | Measured length |  |
305 | MEAS_MINOR_AXIS | Measured minor axis (ellipse) |  |
719 | MEAS_PERIMETER |  |  |
568 | MEAS_R |  |  |
611 | MEAS_R2 | For cmt characteristic point 1 |  |
581 | MEAS_SA |  |  |
582 | MEAS_SH |  |  |
307 | MEAS_SLOTVEC_I | Measured slot vector i |  |
308 | MEAS_SLOTVEC_J | Measured slot vector j |  |
309 | MEAS_SLOTVEC_K | Measured slot vector k |  |
580 | MEAS_SR |  |  |
623 | MEAS_START_ANG |  |  |
310 | MEAS_SX | Measured startpoint x component |  |
311 | MEAS_SY | Measured startpoint y component |  |
312 | MEAS_SZ | Measured startpoint z component |  |
316 | MEAS_WIDTH | Measured width |  |
22 | MEAS_X | Hit point measured x | point number | X-Coordinate
396 | MEAS_X2 | For CMT characteristic point 1 |  |
23 | MEAS_Y | Hit point measured y | point number | Y-Coordinate
397 | MEAS_Y2 | For CMT characteristic point 1 |  |
24 | MEAS_Z | Hit point measured z | point number | Z-Coordinate
398 | MEAS_Z2 | For CMT characteristic point 1 |  |
141 | MEASURE_ALL_FEATURES | Flag for iterative alignments |  |
59 | MEASURE_ORDER_TYPE | Measure order for edge feature SURFACE/ EDGE/ BOTH |  |
66 | MEASURED_2D3D_TYPE | Determines plane in which solution will lie or 3D solution |  |
106 | MEASVEC_I | Measure vector i |  |
107 | MEASVEC_J | Measure vector j |  |
108 | MEASVEC_K | Measure vector k |  |
357 | METHOD_TYPE | Scan method type |  |
100 | MIDPOINT_X | Midpoint x |  |
101 | MIDPOINT_Y | Midpoint y |  |
102 | MIDPOINT_Z | Midpoint z |  |
241 | MIN_ANGLE | Setting for variable technique on scans |  |
239 | MIN_INCREMENT | Setting for variable technique on scans |  |
486 | MINOR_WORD_TOGGLE | Used for new vident command but designed to be general enough for any command's minor word toggle. |  |
58 | MODE_TYPE | MANUAL or DCC |  |
45 | MOVE_TYPE | Use auto move (yes / no) |  |

-N-

Number | Data Type Name | Data Type Description | Index | Value String
429 | N_CONTROLPOINTS | Number of control points in a scan |  |
70 | N_HITS | Number of hits per row | 0 | 1 or more
55 | N_INIT_HITS_TYPE | Toggle field for fixed number of init hits |  |
56 | N_PERM_HITS_TYPE | Toggle field for fixed number of perm hits |  |
71 | N_ROWS | Number of rows | 0 | 1 or more
489 | N_SIDES | Number of polygon sides |  |
249 | NEW_STATS_DIR | Empty stats dir field in editor for statistics object |  |
157 | NEW_TIP | New tip in move ph9 offset |  |
0 | NINGUNO_TIPO | No type, default value, used with constants |  |
826 | NO_APPROACH_VECTOR_FLIP | Allow the feature vector to be flipped during optimzation | 0 | "YES" or "NO"
482 | NOFLIPFLIP_CONFIG |  |  |
166 | NOMINAL | Dimension nominal value |  |
321 | NOMINAL_COLOR | Vision Nominal Color |  |
232 | NORM_RELEARN | Normal scan mode or re-learn nominals mode |  |
317 | NUM_CONTROL_POINTS | Number of control points |  |
320 | NUM_FIT_POINTS | Number of points used for fitting surface |  |
356 | NUM_ITERATIONS | Number of iterations |  |
215 | NUM_RETURN_DATA | Return data for option probe object |  |

-O-

Number | Data Type Name | Data Type Description | Index | Value String
61 | OFFSET_LINE_METHOD | method for offset lines |  |
238 | OFFSET_TOLERANCE | offset tolerance for perimeter scans |  |
156 | OLD_TIP | old tip in move ph9 offset |  |
285 | ONOFF_TYPE | Initially implemented for use with IGNOREROTAB but can be used with any ON OFF toggle field |  |
620 | OPERTYPE |  |  |
220 | ORIGIN | Origin data point for temp comp object |  |
6 | ORIGIN_REF_ID | Ref id for an origin feature of an iterative alignment |  |
449 | OUTPUT_DMIS_REPORT | DMO reporting |  |
448 | OUTPUT_FEAT_W_DIMENS | DMO reporting |  |
447 | OUTPUT_FEATURE_NOMS | DMO reporting |  |
165 | OUTPUT_TYPE | Mode of output for dimensions |  |
558 | OVERLAP |  |  |
559 | OVERSCAN |  |  |
446 | OVERWRITE | DMO reporting |  |

-P-

Number | Data Type Name | Data Type Description | Index | Value String
374 | _PRINT_TO_FILE | Prepended with _ to avoid confusion with Edit window constants |  |
375 | _PRINT_TO_PRINTER | Prepended with _ to avoid confusion with Edit window constants |  |
191 | PART_NAME |  |  |
519 | PATTERN_TYPE | Auto plane pattern | 0 | "SQUARE" or "RADIAL"
487 | PERCENTAGE |  |  |
73 | PERM_HITS | Number of Perm (sample) hits | 0 | 0 or more
170 | PERP_PARALLEL_TYPE | Dimension perindicular parallel type |  |
115 | PINVEC_I | Pin vector i |  |
116 | PINVEC_J | Pin vector j |  |
117 | PINVEC_K | Pin vector k |  |
605 | PIXEL_TOGGLE |  |  |
186 | POINT_INFO_HEADING | Point info heading type |  |
380 | POINTINFO_FILTER_DEVIATION | Toggle field for deviation filter state of point info commands |  |
381 | POINTINFO_FILTER_ DEVIATION_NUMBER | Number field associated with deviation filter state of point info commands |  |
301 | POINTINFO_FILTER_INTERVAL | Toggle field for interval filter state of point info commands |  |
302 | POINTINFO_FILTER_ INTERVAL_NUMBER | Number field associated with interval filter state of point info commands |  |
382 | POINTINFO_FILTER_OUTTOL | Toggle field for outtol filter state of point info commands |  |
378 | POINTINFO_FILTER_WORST | Toggle field for worst filter state of point info commands |  |
379 | POINTINFO_FILTER_ WORST_NUMBER | Number field associated with worst filter state of point info commands |  |
218 | POLAR_VECTOR_COMPENSATION | Polar vector compensation object |  |
277 | POS_REPORT_AXIS_X | Positive reporting axis |  |
278 | POS_REPORT_AXIS_Y | Positive reporting axis |  |
279 | POS_REPORT_AXIS_Z | Positive reporting axis |  |
462 | POS_REPT_DISPLAY_OPTION |  |  |
214 | POSITIONAL_ACCURACY | Positional accuracy for option probe object |  |
786 | PPAP_INDEX |  |  |
399 | PPROG | Part program name (used in a database query) |  |
175 | PRECISION | Dimension display precision |  |
377 | PRINT_DELETE_RUNS |  |  |
376 | PRINT_DRAFTMODE |  |  |
213 | PROBE_ACCURACY | Probe accuracy for option probe object |  |
228 | PROBE_COMP | Probe comp (on/off) toggle |  |
299 | PROBING_MODE | Probing mode for option probe |  |
174 | PROFILE_FORM_TYPE | Dimension profile form type toggle |  |
550 | PROFILE_TYPE |  |  |
521 | PROGRAM_GAGE_FEAT_TYPE |  |  |
522 | PROGRAM_GAGE_TYPE |  |  |
118 | PUNCHVEC_I | Punch vector i |  |
119 | PUNCHVEC_J | Punch vector j |  |
120 | PUNCHVEC_K | Punch vector k |  |

-Q-

Number | Data Type Name | Data Type Description | Index | Value String
470 | QUERY_SHOW_GRAPHIC_SETTINGS |  |  |

-R-

Number | Data Type Name | Data Type Description | Index | Value String
171 | RADIUS_TYPE | Dimension 2D Distance radius type |  |
196 | READ_WRITE | Read / Write toggle |  |
46 | READPOS_TYPE | Read Position (yes / no) |  |
3 | REF_ID | ID of object being referred to |  |
222 | REF_TEMP | Reference temperature for temp comp object |  |
412 | REGR | For SPC |  |
142 | REPIERCE_CAD | Flag for iterative alignments |  |
383 | REPORT_SURFVEC_I | Extended sheet metal vector for DCC Edge |  |
384 | REPORT_SURFVEC_J | Extended sheet metal vector for DCC Edge |  |
385 | REPORT_SURFVEC_K | Extended sheet metal vector for DCC Edge |  |
121 | REPORTVEC_I | Report vector i |  |
122 | REPORTVEC_J | Report vector j |  |
123 | REPORTVEC_K | Report vector k |  |
188 | RET_ONLY_TYPE | Retrolinear only on / off toggle |  |
216 | RETURN_SPEED | Return speed for option probe object |  |
192 | REVISION_NUMBER | File header revision number |  |
48 | RMEAS_TYPE | Use relative measures (yes / no) |  |
69 | RMEASFEATID | Name of rmeas feature |  |
524 | RMEASFEATIDX | Referenced feature (X axis) | 0 | Feature lable
525 | RMEASFEATIDY | Referenced feature (Y axis) | 0 | Feature lable
526 | RMEASFEATIDZ | Referenced feature (Z axis) | 0 | Feature lable
5 | ROTATE_REF_ID | Ref id for a rotate feature of an iterative alignment |  |
158 | ROTATION_TYPE | Move rotary table type |  |
286 | ROW_ID |  |  |
639 | RPT_DIMENSION_TABLES |  |  |

-S-

Number | Data Type Name | Data Type Description | Index | Value String
151 | SAVE_ALIGN_CAD_TO_PARTS | Save Align Save Type |  |
92 | SCAN_ACCELERATION | Scan acceleration |  |
265 | SCAN_AXISVEC_I | Axis vector i - for boundary conditions... |  |
266 | SCAN_AXISVEC_J | Axis vector j - for boundary conditions... |  |
267 | SCAN_AXISVEC_K | Axis vector k - for boundary conditions... |  |
432 | SCAN_BNDRY_TYPE |  |  |
274 | SCAN_CROSS_TOTAL | Number of crossings allowed in boundary condition |  |
259 | SCAN_CUTPLANEVEC_I | Cut plane vector i |  |
260 | SCAN_CUTPLANEVEC_J | Cut plane vector j |  |
261 | SCAN_CUTPLANEVEC_K | Cut plane vector k |  |
217 | SCAN_DENSITY | Scan density for option probe object |  |
276 | SCAN_EDGE_THICK | Edge thickness for edge scans |  |
268 | SCAN_ENDVEC_I | End touch vector i |  |
269 | SCAN_ENDVEC_J | End touch vector j |  |
270 | SCAN_ENDVEC_K | End touch vector k |  |
271 | SCAN_INITDIR_I | Unit direction vector i |  |
272 | SCAN_INITDIR_J | Unit direction vector j |  |
273 | SCAN_INITDIR_K | Unit direction vector k |  |
262 | SCAN_INITVEC_I | Initial touch vector i |  |
263 | SCAN_INITVEC_J | Initial touch vector j |  |
264 | SCAN_INITVEC_K | Initial touch vector k |  |
93 | SCAN_OFFSET_FORCE | Scan offset force |  |
358 | SCAN_TECHNIQUE | Scan technique |  |
275 | SCAN_TIME_INCR | Time increment for manual scans |  |
540 | SCREEN_CAPTURE_AUTO_TIME | Screen capture time (always or on error) |  |
536 | SCREEN_CAPTURE_AUTO_TYPE | Screen capture auto type (which gives more options that basic screen capture) |  |
503 | SCREEN_CAPTURE_QUALITY | Screen capture image color depth |  |
502 | SCREEN_CAPTURE_SCALE | Screen capture image size |  |
535 | SCREEN_CAPTURE_TYPE | Screen capture type (can now do Live Image View as well as CAD) |  |
57 | SEARCHMODE_TYPE | Box or circular search mode for hipoint feature |  |
764 | SECTION_INDEX |  |  |
225 | SENSOR_LIST | Sensor list for temp comp object |  |
193 | SERIAL_NUMBER | File header serial number |  |
494 | SHOW_COLUMN |  |  |
136 | SHOW_DETAILS | Display details for alignments and scans |  |
179 | SHOW_HEADINGS | Dimension format headings toggle |  |
135 | SHOW_IDS | Display id for alignments and loops |  |
414 | SHOW_MORE_SPC_CALCS | For SPC |  |
723 | SHOW_NOMS |  |  |
728 | SHOW_OPTIONS |  |  |
187 | SHOW_POINT_INFO | Point info / Show point info |  |
493 | SHOW_ROW |  |  |
402 | SHOW_SPC_CALCS | For SPC |  |
763 | SIMULT_EVAL |  |  |
235 | SINGLE_POINT | Point mode on dcc scan object |  |
145 | SKIP_NUM | Skip number of loop |  |
53 | SLOT_MIN_MAX_TYPE | Measure slot using 5 (NORM) or 6 (MINMAX) hits |  |
297 | SLOT_NUMBER | Sets the column slot number for a column load and unload |  |
563 | SLOT_TYPE |  |  |
109 | SLOTVEC_I | Slot vector i |  |
110 | SLOTVEC_J | Slot vector j |  |
111 | SLOTVEC_K | Slot vector k |  |
43 | SNAP_TYPE | Vector features / Surface features |  |
416 | SOLID | For SPC |  |
403 | SPEC_LIMITS | For SPC |  |
415 | SPEC_OFFSET | For SPC |  |
134 | SRC_EXPR | Source expression (assign, subroutine, call sub, basic script, flow control) |  |
181 | STANDARD_DEVIATION | Dimension format std dev toggle |  |
98 | START_ANG | Start angle | 0 | Radian value
466 | START_LABEL |  |  |
143 | START_NUM | Start number for loop |  |
254 | STAT_CALC_TYPE | Calc type on/off toggle for statistics object |  |
194 | STAT_COUNT | File header statistics count |  |
253 | STAT_NAME_TYPE | Variable name type for statistics object |  |
1 | STATIC_TOGGLE | Used for toggle fields that cannot contain expressions |  |
391 | STATS_DATASOURCE | Datasource for statistics object |  |
453 | STATS_DB_TYPE | For stats command database option |  |
248 | STATS_DIR | Stats directory for statistics object |  |
247 | STATS_TYPE | Stats type for statistics object |  |
405 | STDDEV | For spc |  |
195 | SUB_NAME | Subroutine name |  |
690 | SUMMARY_AXIS |  |  |
781 | SUMMARY_BONUS |  |  |
684 | SUMMARY_COLUMN_HDR |  |  |
640 | SUMMARY_DEV |  |  |
685 | SUMMARY_FEAT |  |  |
779 | SUMMARY_MAX |  |  |
692 | SUMMARY_MEAS |  |  |
780 | SUMMARY_MIN |  |  |
778 | SUMMARY_MINUSTOL |  |  |
691 | SUMMARY_NOMINAL |  |  |
776 | SUMMARY_OUTTOL |  |  |
777 | SUMMARY_PLUSTOL |  |  |
689 | SUMMARY_TBLHDR |  |  |
484 | SURFACE |  |  |
112 | SURFVEC_I | Surface vector i |  |
113 | SURFVEC_J | Surface vector j |  |
114 | SURFVEC_K | Surface vector k |  |
546 | SURFVEC_MEAS_I | Surface vector i meas |  |
547 | SURFVEC_MEAS_J | Surface vector j meas |  |
548 | SURFVEC_MEAS_K | Surface vector k meas |  |

-T-

Number | Data Type Name | Data Type Description | Index | Value String
345 | T_VALUE | T value on hits |  |
572 | TARG_A |  |  |
590 | TARG_EA |  |  |
591 | TARG_EH |  |  |
589 | TARG_ER |  |  |
516 | TARG_EX | Target endpoint x component |  |
517 | TARG_EY | Target endpoint y component |  |
518 | TARG_EZ | Target endpoint z component |  |
573 | TARG_H |  |  |
31 | TARG_I | Target i - vector |  |
32 | TARG_J | Target j - vector |  |
33 | TARG_K | Target k - vector |  |
571 | TARG_R |  |  |
587 | TARG_SA |  |  |
588 | TARG_SH |  |  |
586 | TARG_SR |  |  |
513 | TARG_SX | Target startpoint x component |  |
514 | TARG_SY | Target startpoint y component |  |
515 | TARG_SZ | Target startpoint z component |  |
19 | TARG_X | Target x - centroid |  |
20 | TARG_Y | Target y - centroid |  |
21 | TARG_Z | Target z - centroid |  |
557 | TARGET_BLOB_TYPE |  |  |
282 | TARGET_COLOR | Vision Target Color |  |
474 | TARGET_DIRECTION |  |  |
520 | TARGET_EDGE_ANGLE |  |  |
508 | TARGET_EDGE_DENSITY |  |  |
712 | TARGET_EDGE_EDGEDETECT |  |  |
538 | TARGET_EDGE_EDGENUM |  |  |
537 | TARGET_EDGE_EDGESELECT |  |  |
717 | TARGET_EDGE_GRADIENT |  |  |
711 | TARGET_EDGE_HEIGHT |  |  |
505 | TARGET_EDGE_ILLUM |  |  |
475 | TARGET_EDGE_POLARITY |  |  |
504 | TARGET_EDGE_SIZE |  |  |
507 | TARGET_EDGE_STRENGTH |  |  |
506 | TARGET_EDGE_TOL |  |  |
509 | TARGET_EDGE_TYPE |  |  |
549 | TARGET_EDGE_UNDERSCAN |  |  |
710 | TARGET_EDGE_WIDTH |  |  |
715 | TARGET_FILTER_AREA |  |  |
716 | TARGET_FILTER_AREA_SIZE |  |  |
713 | TARGET_FILTER_CLEAN |  |  |
714 | TARGET_FILTER_CLEAN_STRENGTH |  |  |
561 | TARGET_FILTER_OUTLIER |  |  |
562 | TARGET_FILTER_OUTLIER_ DISTANCE_THRESHOLD |  |  |
599 | TARGET_FILTER_OUTLIER_ STD_DEV_THRESHOLD |  |  |
523 | TARGET_FOCUS |  |  |
722 | TARGET_SURFACE_ CROSSHAIR_HEIGHT |  |  |
499 | TARGET_SURFACE_DURATION |  |  |
497 | TARGET_SURFACE_HEIGHT |  |  |
501 | TARGET_SURFACE_HIACC |  |  |
490 | TARGET_SURFACE_ILLUM |  |  |
500 | TARGET_SURFACE_MODE |  |  |
498 | TARGET_SURFACE_RANGE |  |  |
511 | TARGET_SURFACE_TYPE |  |  |
496 | TARGET_SURFACE_WIDTH |  |  |
564 | TARGET_TYPE |  |  |
124 | TARGSLOT_I | Target slot vector i |  |
125 | TARGSLOT_J | Target slot vector j |  |
126 | TARGSLOT_K | Target slot vector k |  |
532 | TEMPP | Current Part temperature |  |
529 | TEMPX | Current X axis temperature |  |
530 | TEMPY | Current Y axis temperature |  |
531 | TEMPZ | Current Z axis temperature |  |
163 | TEXT_ANALSYIS | Use text analysis on dimension (Yes / No) |  |
761 | TEXTANAL_LABEL_DEV |  |  |
758 | TEXTANAL_LABEL_MEAS_I |  |  |
759 | TEXTANAL_LABEL_MEAS_J |  |  |
760 | TEXTANAL_LABEL_MEAS_K |  |  |
755 | TEXTANAL_LABEL_MEAS_X |  |  |
756 | TEXTANAL_LABEL_MEAS_Y |  |  |
757 | TEXTANAL_LABEL_MEAS_Z |  |  |
762 | TEXTANAL_LABEL_MINMAX |  |  |
566 | THEO_A |  |  |
609 | THEO_A2 | For CMT characteristic point 1 |  |
38 | THEO_ANGLE | Theoretical angle |  |
720 | THEO_AREA |  |  |
555 | THEO_DEPTH |  |  |
34 | THEO_DIAM | Theoretical diameter |  |
578 | THEO_EA |  |  |
579 | THEO_EH |  |  |
284 | THEO_END_ANG | Vision Circle Feature |  |
577 | THEO_ER |  |  |
13 | THEO_EX | Theoretical x - end point |  |
14 | THEO_EY | Theoretical y - end point |  |
15 | THEO_EZ | Theoretical z - end point |  |
551 | THEO_FLUSH |  |  |
553 | THEO_GAP |  |  |
567 | THEO_H |  |  |
610 | THEO_H2 | For CMT characteristic point 1 |  |
37 | THEO_HEIGHT | Theoretical height |  |
16 | THEO_I | Hit point theoretical i - vector | point number | Numeric value
17 | THEO_J | Hit point theoretical j - vector | point number | Numeric value
18 | THEO_K | Hit point theoretical k - vector | point number | Numeric value
36 | THEO_LENGTH | Theoretical length |  |
130 | THEO_MINOR_AXIS | Theoretical minor access |  |
718 | THEO_PERIMETER |  |  |
565 | THEO_R |  |  |
608 | THEO_R2 | For CMT characteristic point 1 |  |
575 | THEO_SA |  |  |
576 | THEO_SH |  |  |
574 | THEO_SR |  |  |
283 | THEO_START_ANG | Vision Circle Feature |  |
10 | THEO_SX | Theoretical x - start point |  |
11 | THEO_SY | Theoretical y - start point |  |
12 | THEO_SZ | Theoretical z - start point |  |
35 | THEO_WIDTH | Theoretical width |  |
7 | THEO_X | Hit point theoretical x - centroid | point number | X-Coordinate
393 | THEO_X2 | For CMT characteristic point 1 |  |
8 | THEO_Y | Hit point theoretical y - centroid | point number | Y-Coordinate
394 | THEO_Y2 | For CMT characteristic point 1 |  |
9 | THEO_Z | Hit point theoretical z - centroid | point number | Z-Coordinate
395 | THEO_Z2 | For CMT characteristic point 1 |  |
49 | THEOBF_TYPE | Use theoretical values for best fit algorithm (yes / no) |  |
41 | THICKNESS_TYPE | Theoretical or actual thickness | 0 | "THICKNESS_ NONE", "THEO_ THICKNESS", or "ACTL_ THICKNESS"
594 | THICKNESS_TYPE_EDGE | Theoretical or actual thickness |  |
67 | THINNING_TOL | Thinning tolerance for curves |  |
488 | THRESHOLD |  |  |
450 | TIME_ARG | For SPC |  |
401 | TIME_FILTER | For SPC: filtering based on time stamps |  |
229 | TIP_I | Tip shank vector i component |  |
230 | TIP_J | Tip shank vector j component |  |
231 | TIP_K | Tip shank vector k component |  |
418 | TITLE | For SPC |  |
349 | TOOL_DIAM | Tool diameter |  |
346 | TOOL_X | Tool x value |  |
347 | TOOL_Y | Tool y value |  |
348 | TOOL_Z | Tool z value |  |
169 | TP_MODIFIER | Dimension True Position modifier |  |
726 | TP_MODIFIER2 | This is because TP_MODIFIER and TP_MODIFIER2 are used in two different groups in summary mode. |  |
400 | TRACE_FILTER | For SPC: filtering based on trace fields |  |
451 | TRACE_FILTER_ARG | For SPC |  |
257 | TRACE_NAME | Trace field name |  |
258 | TRACE_VALUE | Trace field value |  |
473 | TRACE_VALUE_LIMIT | Trace command character limit for the value field |  |
255 | TRANSFER_DIR | Transfer directory for statistics object |  |
212 | TRIGGER_FORCE | Trigger force for option probe object |  |
469 | TRIGGERPLANE |  |  |
463 | TRIGGERTOLERANCE |  |  |
464 | TRIGGERTOLVALUE |  |  |
131 | TWO_D_THREE_D_TYPE | 2d or 3d |  |

-U-

Number | Data Type Name | Data Type Description | Index | Value String
318 | U_HITS | Number of U points for surface |  |
417 | U_L_BOUNDS | For SPC |  |
406 | UCL_LCL | For SPC |  |
172 | UNIT_TYPE | Unit type (inch / mm) |  |
211 | UP_FORCE | Up force for option probe object |  |
127 | UPDATEVEC_I | Update vector i |  |
128 | UPDATEVEC_J | Update vector j |  |
129 | UPDATEVEC_K | Update vector k |  |
431 | USE_3DFILTER |  |  |
139 | USE_AXIS | Flag for iterative alignments and start TP dimension |  |
753 | USE_AXIS2 |  |  |
541 | USE_HSSDAT |  |  |
542 | USE_STARTENDDELAY |  |  |
281 | USE_THEO | BRN added 5/2/2002 |  |
44 | USEPIN_TYPE | Use pin vector or normal vector |  |
738 | USETWODEVIATIONS |  |  |

-V-

Number | Data Type Name | Data Type Description | Index | Value String
319 | V_HITS | Number of V points for surface |  |
363 | VIDEO_GAIN |  |  |
366 | VIDEO_LASERLIGHT1 |  |  |
367 | VIDEO_LASERLIGHT2 |  |  |
365 | VIDEO_LEDLIGHT |  |  |
370 | VIDEO_LSEG |  |  |
364 | VIDEO_OFFSET |  |  |
371 | VIDEO_XSEG |  |  |
369 | VIDEO_YEND |  |  |
368 | VIDEO_YORIGIN |  |  |
372 | VIDEO_YSEG |  |  |
512 | VOID_DETECT | Turn off void detection | 0 | "YES" or "NO"

-W-

Number | Data Type Name | Data Type Description | Index | Value String
322 | WAVE_FILE | Feature Locator Wave File |  |
137 | WEIGHT | Weight value for Best Fit alignments |  |
154 | WORK_PLANE | Workplane |  |

-X-

Number | Data Type Name | Data Type Description | Index | Value String
146 | X_OFFSET | X Offset for loops |  |

-Y-

Number | Data Type Name | Data Type Description | Index | Value String
147 | Y_OFFSET | Y Offset for loops |  |

-Z-

Number | Data Type Name | Data Type Description | Index | Value String
148 | Z_OFFSET | Z Offset for loops |  |
404 | ZONES | For SPC |  |

A List of Available Data Types

This list of data types displays the data type names in alphabetical order, their associated type numbers, descriptions, index values and value strings as appropriate. When using data types inside VB scripts in template events and rules, you may need to use the data type number as not all script locations accept the enumerated data type value. To view the list of items starting with that letter, click on a link below. Some of the categories are quite large and may take a few seconds to load. Click on the same link again to collapse the items for that letter.

[ A | B | C | D | E | F | G | H | I | J | K | L | M | N | O | P | Q | R | S | T | U | V | W | X | Y | Z ]


Using a Type Index to Display Specific Data

Type indexes let you pull in very specific data into your report. For example, if you had a cylinder feature with eight hits, you could use a type index to grab the second hit's measured X value. To use a type index, simply append a colon and a number to the expression to get that hit or that row of dimension data.

Type Indexes to Display Specific Data

To demonstrate how this works, if you typed:

=MEAS_X

PC-DMIS would not use a type index (the type index would default to 0) and PC-DMIS would display the measured X value of the feature's center point.

But, if you typed:

=MEAS_X:1

PC-DMIS would display the measured X value of the first hit.

If you typed:

=MEAS_X:2

PC-DMIS would will retrieve the measured X value of the second hit.

Repeating Rows to Display all Data

Similar to type indexes, In the GridControlObject you can define a row as a "repeating row". With repeating rows, the character "N" evaluates to the current repeat index of the row being drawn. When you define a repeating row, you can also define a repeating row expression that, when evaluated, determines how many times the row repeats.

So, if you wanted to display all of the measured X values for all hits in a feature, you could define a single repeating row with the following expression:

=MEAS_X:N

You could then set the repeating row expression to "=N_HITS" to get the total number of hits. PC-DMIS would continue to repeat the row with subsequent hit data until the total number of hits was displayed.


Using a Prefix Number to Access Reference Feature Data

Previous to version 4.2 you could not access a reference feature's data through report expressions. While the report expression language provided access to practically every data field of the given command, there wasn't an easy way to access data for referred commands. For example, you could not determine if a location dimension was for a circle, a plane, or a line.

Starting with version 4.2 however, a report expression can now take an optional prefix number inside curly brackets to indicate from which reference command the data should be taken.

For example, if you create a label template for a Roundness dimension, and you want to show the measured diameter on the label template, you could use this expression:

={1}MEAS_DIAM()

Notice the {1}. This indicates that the data needs to come from the first reference command (the feature) instead of the command for which the template is being created (the dimension).

If there is more than one reference feature used, the number within the curly braces represents the feature from which PC-DMIS will pull the information. For example, a Distance dimension uses two features to compute the distance. Using {1} would pull information from the first reference feature and {2} would pull it from the second reference feature.


Predefined Constants

The reporting expression language also makes use of some predefined constants for the type indices used with the DIMENSION_TABLES data type.

LINE1_SIZE_TABLE = 1

LINE2_POSITION_TABLE = 2

LINE3_POSITION_TABLE = 3

DATUM_SHIFT_TABLE = 4

SUMMARY_TABLE = 5

LINE2_ORIENTATION_TABLE = 7

LINE3_ORIENTATION_TABLE = 8

LINE2_BASIC_DIMENSION_TABLE = 9

LINE3_BASIC_DIMENSION_TABLE = 10

TRUE_POSITION_TABLE = 11

DIMENSION_TABLE = 12

DIMENSION_WITH_BONUS_TABLE = 13

NEWLINE

NEWLINE is used to add a carriage return to a text expression:

This expression,

=”This is line 1” + “and this is line 2”

would appear as,

This is line 1 and this is line 2

on the report.

The expression,

=”This is line 1” + NEWLINE + “and this is line 2”

would appears as,

This is line 1

and this is line 2

on the report.

N:

When using repeating rows in a grid, N evaluates to the current row count in the repeating rows. This is useful when placing expressions that use a data type more than once in a repeating row.

Below is a sample grid used to show hit values in a table. N is being used in the expressions for the repeating row. When the expressions for the first instance of the repeating row are evaluated, N will equal 1, and so the X, Y, and Z values of the first hit will be shown. When the second row is added, N will equal 2, and so the X, Y, and Z value of the second hit will be shown.


To do this, open feature.lbl inside of the Label Template editor. The label displays showing some formatted sample data:

Next, select the GridControlObject, then double-click on it to activate it, displaying the code behind the displayed information:

Right-click on any cell to view the expression used.

Expressions Used in Standard Templates

In the various standard report and label templates, you will see several reporting expressions used to display different pieces of information or to format the display of information. For example, consider the code behind feature.lbl, a standard label template that ships with PC-DMIS.

In this template, you will see several reporting expressions (=LOADSTR, =DIM_MEASURED, =NOMINAL and so on) that determine what information PC-DMIS should display in the cells.

Common Expressions

The following list describes the most common expressions used in the various standard templates:

Some of these functions are also discussed in the "Functions and Operators" topic.

  • =<Expression>:N - This allows you to display repeated information. See "Using a Type Index to Display Specific Data" and "Predefined Constants" for more information on repeating rows.

  • =AXIS - This displays the current axis name (XAXIS, YAXIS, or ZAXIS).

  • =DIM_MEASURED - This displays the measured value from a dimension.

  • =DEVIATION_ANGLE - This displays a decimal value representing the deviation angle in degrees of a true position dimension. This is used to draw the radial graphic for the true position dimension templates.

  • =DEVPERCENT_NOM - This displays a decimal value representing the percentage of the total tolerance range that marks the 0 deviation (nominal) position on the linear graphic. For a bilateral tolerance where the +/- values are equal this would be 50.0 (percent); the center of linear graphic represents 0 deviation. For a non-bilateral tolerance this would be 0.0; the leftmost side of linear graphic represents 0 deviation.

  • =DEVPERCENT2 - When USETWODEVIATIONS is true (see USETWODEVIATIONS below), this displays a decimal value representing the percentage of the + tolerance used by the max deviation of a bilateral profile reported as form and location. The percentage of the – tolerance used by the min deviation is given by DIM_RPT_DEVPERCENT.

  • =DIM_DEVIATION - This displays how much a dimension deviates from the nominal.

  • =DIM_OUTTOL - This displays the out of tolerance value for a dimension.

  • =DIM_MAX - This displays the maximum value for the given axis among all points related to the input feature.

  • =DIM_MEASURED - This displays a dimension's measured value.

  • =DIM_MIN - This displays the minimum value for the given axis among all points related to the input feature.

  • =DIM_RPT_DEVPERCENT - This displays a decimal value representing the percentage of the total tolerance range that marks the deviation of this dimension.

  • =DIM_RPT_GRAPHIC - This displays an integer value representing the type of graphic control PC-DMIS should display for the dimension.

0 report no graphic control

1 report the linear graphic control

2 report the radial graphic control

  • =DIM_RPT_ISBILATERAL - This expression determines whether or not the linear graphic represents a bilateral tolerance (+/- tolerance value) such as the size of a hole or profile reported as form and location. Examples of tolerances that are not bilateral (single tolerance value) are form tolerances such as circularity, flatness and straightness and profile reported as form only. Values can be ”0” (false) or ”1” (true).

  • =DIM_RPT_NUMZONES - This displays a decimal value indicating the number of tolerance zones (from 0 deviation to the maximum allowed deviation) to be drawn on the linear graphic. You can set this in the Edit Dimension Color dialog box (select Edit | Graphics Display Window | Dimension Color). You can assign each zone a unique color to show by the color of the linear graphic how much of the tolerance was used by the deviation of the dimension.

  • =F_PLUS_TOL - This displays a feature's plus tolerance.

  • =F_MINUS_TOL - This displays a feature's minus tolerance.

  • =ID - This displays the feature or dimension ID.

  • =LOADSTR - This loads a string from a table of stored strings within PC-DMIS. See "Loading Strings from PC-DMIS" for more information.

  • =NOMINAL - This displays the nominal data for a feature.

  • =Page() - This displays the current page number of the Report window.

  • =Pages() - This displays the total number of pages of the Report window.

  • =TOL - This function colors any text or expressions.

  • =UNIT_TYPE - This displays the unit of measurement for the feature or dimension.

  • =USETWODEVIATIONS - This expression determines whether or not the legacy dimension label template's linear graphic uses two deviation values. Bilateral profile reported as form and location displays how much of the + tolerance was used by the max deviation and how much of the – tolerance was used by the min deviation. Values can be either ”0” (false) or ”1” (true)

Combined Expressions

You may also find that expressions can be combined and used together with other expressions, as shown in this code string taken from the Legacy_Dimension_Cad.lbl label template:

=TOL(DIM_DEVIATION:N,DIM_OUTTOL:N,0.0,0.0)

This uses the =TOL function to display the dimension's deviation value and give it the Error color (usually red).

Another example is found in standard report templates in version 4.2 and higher. The Text object at the bottom of those templates uses this combined expression in the Text property to display the current page number along with the total number of pages:

=page() + " Of " + pages()

So page six of a ten page report would read as follows at the bottom of the page in the Report window:

6 Of 10


Embedding Reports or Templates into a Part Program

You can embed a legacy report (HyperView report), a report template, or custom report into your part program. When PC-DMIS executes the embedded code, it launches the report or template allowing you to print it, or view it, and pass values to and from the embedded item.

Important: legacy reports are reports that were created in the HyperView report editor in PC-DMIS versions 3.0, 3.2, 3.25, 3.5, or 3.7. Due to the new template approach to reporting since version 4.0, HyperView reports can only be executed, they cannot be created or edited. To edit or create a HyperView report, you will need to use an older version of PC-DMIS that supports HyperView report creation.

To embed a report or template:

  1. Make sure the Edit window is in Command Mode.

  2. Select Insert | Report Command, and then choose one of these menu items. Display Menu Roadmap

    • Custom Report

    • Template Report

    • Legacy Report

A dialog box appears allowing you to select your report or template.

  3. Select the report or template you want to embed in the Part Program.

  4. Click the Open button to insert the command.

PC-DMIS will insert one of the following commands into the Edit window at the cursor position:

  • REPORT/CUSTOM

  • REPORT/TEMPLATE

  • REPORT/LEGACY

More:

The REPORT Command

Mapping PC-DMIS expressions to Object Properties


The REPORT Command

Display Menu Roadmap

The Report command object is identified with the REPORT command in the Edit window.

The REPORT Command Syntax

A REPORT command will have the following syntax in the Edit window's Command mode:

<ID> =REPORT/<TOG1>, FILENAME= <PATHWAY>, AUTOPRINT=<TOG2>, Section=<NUM1>

PARAM/=

ENDREPORT/

Item

Description

<ID>

This is the ID for the REPORT command.

REPORT/<TOG1>

This changes the type of REPORT command. It can be CUSTOM, LEGACY, or TEMPLATE.

FILNAME=<PATHWAY>

This determines the report or template to load. <PATHWAY> is the full filename pathway pointing to the desired file.

AUTOPRINT =<TOG2>

<TOG2> can switch between PRINT and PDF.

Setting AUTOPRINT=PRINT will cause the report or Report template to be printed to the default printer after it has loaded and executed. The report will close immediately after the print job has been spooled and execution of the part program will resume.

Setting AUTOPRINT=PDF will cause the HyperView Report to be printed to a Portable Document Format (PDF) file. The following rules apply:

  • The name of the generated PDF file will have the same base name as the report or template filename appended by a numerical index and extension.

  • The generated file will be located in the same directory as the Report file.

  • If a file exists with the same name as the generated filename, the index will automatically increment itself until a unique file name is found.

Section=<NUM>

<NUM> determines the section into which the report or template will be inserted.

If you type -1 or a value greater than the number of sections in the default template, the report gets inserted at the end.

PARAM/

The PARAM/ option allows you to map PC-DMIS expressions to a report or a report template's variables or properties. The syntax of the PARAM/ option is:

PARAM/{object or variable name}={PC-DMIS expression}

Example: If you have a Global Variable in a report named ”NumBoltHoles”. The following PARAM/ option would map the PC-DMIS expression to NumBoltHoles:
PARAM/NumBoltHoles=360.0/angle

Changes to the variable in the editor can also change the PC-DMIS variable.

Example: Using the following PARAM/ option, NumBoltHoles is set equal to numBolts. Changes within the HyperView report to the HyperView variable NumBoltHoles will be reflected in the PC-DMIS variable numBolts:
PARAM/NumBoltHoles=numBolts

Important: After execution any objects you changed by passing parameters into a Report template or a HyperView report will revert to what they had been before execution if you redraw or modify the report in any way. This means if you want to retain the results of passing a parameter to your template or report, you will need to first print the report before making modifications. You can do this using the AUTOPRINT parameter or by printing directly from the Report window.

See "Mapping PC-DMIS expressions to properties of HyperView Objects" for additional information on using parameters.

Hint: Pressing F9 on a REPORT/CUSTOM command opens up the custom report in the Custom Report Editor.

REPORT/TEMPLATE Report Generation

PC-DMIS generates the default report as usual until it reaches this command. When it executes this command, PC-DMIS utilizes the specified template and generates a separate report for all the part program commands in a new section within the current report. After PC-DMIS generates this new report section, it switches back to the previous report and continues generating commands in the original report from that point forward.


Mapping PC-DMIS Expressions to Object Properties

PC-DMIS expressions can be mapped to property objects using the PARAM/ command in the Edit window. The syntax for mapping a PC-DMIS expression to an object property is:

PARAM/{object code}.{property name}={PC-DMIS expression}

Example: The following PARAM/ option changes the BorderStyle property of the object, Text1:
PARAM/Text1.BorderStyle=1


Using PC-DMIS ActiveX controls

This series of topics provides an example of how to set up the properties of various PC-DMIS ActiveX controls and use them in a label template to display dimensional information.

  • Adding an ActiveX Control

  • Passing Information to an ActiveX Control

  • Some PC-DMIS ActiveX Controls

The topics discussed focus on the unique ActiveX properties for each of the controls.


Adding an ActiveX Control

You can add an ActiveX control to a label template in the Label Template Editor in two ways:

  • ActiveX Object from Object Bar - An ActiveX control can be added directly to the label template by clicking on the ActiveX icon in the editor's Object Bar and then defining the area where the control will populate. (See the "ActiveX Object" topic.)

  • ActiveX Object from GridControlObject - In a GridControlObject, at the Grid Properties dialog, set the Cell Type to ActiveX. This will activate the Select button. Click Select. (See the "GridControlObject" topic.)

Regardless of what method you use, PC-DMIS displays the Insert ActiveX Control dialog box.

Insert ActiveX Control dialog box

Select the desired control from the list and click OK.

This dialog box lists all the controls on your system, not just those controls added by PC-DMIS. If you want to use a third party control in a label template, you would add it in the same way.


Passing Information to an ActiveX Control

For all of the PC-DMIS ActiveX controls described here, the software passes information into the control using the EventReportData event. PC-DMIS encapsulates the specific dimensional information into an object called ReportData (see the ”ReportData Object Overview” topic in the PCDBASIC documentation for additional information ). For example, if you look at the Rule Tree Editor for the TextOnly.rtp report template, you will find for the Dimension Location item that one of the rules is:

Use Template ”legacy_dimension.lbl”

The Legacy_dimension.lbl label template receives the dimensional information about the location dimension via the ReportData object. The information is now in the label but it has not yet been passed to the ActiveX control.

To understand how this information gets passed:

  1. Open the legacy_dimension.lbl label template in the Label Template Editor. You will see that it contains a GridControlObject named ActiveX12.

  2. Right-click to display the Properties dialog box for the object.

  3. Double-click on one of the cells in this grid control to put it in edit mode.

  4. Click the cell in the lower right corner. This cell uses the Dimension Report Linear control. Notice that the Properties dialog box has four categories of properties (Standard, Advanced, Events, ActiveX). Normally objects only have three categories (Standard, Advanced, Events). This fourth category, ActiveX, is unique to ActiveX controls and is the area we will be concentrating on in the following sections.

  5. Expand the Events section.

  6. Access the EventReportData property. The VBA Mini Editor appears. Notice that the editor contains this line of code:

This.X.EventReportData ReportData

This code is the mechanism that passes ReportData (the dimensional information) to the ActiveX control. Therefore, whenever you add an ActiveX control to a label template, you will need to set the EventReportData property to do the same thing by using that line of code.


Some PC-DMIS ActiveX Controls

Property | Description | Example
AfterColor | The color of the last bar | tbd [defaults to 65280 (Green)]
BeforeColor | The color of the first bar | tbd [defaults to 255 (Blue)]
NumberFeatures | The number of features shown on the X axis. | tbd

AfterColor and BeforeColor take long values representing a color.

They use the following formula:

(Red * 256 * 256) + (Green * 256) + Blue.

So Red would be 16711680; that is (255 * 256 * 256) + (0 * 256) + 0; Green would be 65280; that is (0 * 256 * 256) + (255 * 256) + 0; Blue would be 255; that is, (0 * 256 * 256) + (0 * 256) + 255.

Example Label Template: BFANALYSISACTIVE1 in Best_Fit_Analysis.lbl.

Property | Description | Example
DeviationNominalPercent | See "Expressions Used in Standard Templates" for a description of the example expression. | =DEVPERCENT_NOM:N
DeviationPercent | See "Expressions Used in Standard Templates" for a description of the example expression. | =DIM_RPT_DEVPERCENT:N
DeviationPercent2 | See "Expressions Used in Standard Templates" for a description of the example expression. | =DEVPERCENT2:N
Is Bilateral | See "Expressions Used in Standard Templates" for a description of the example expression. | =DIM_RPT_ISBILATERAL:N
UseTwoDeviations: | See "Expressions Used in Standard Templates" for a description of the example expression. | =USETWODEVIATIONS:N

Example Label Template: Bottom right cell in Legacy_Dimension.lbl.

Property | Description | Example
Deviation: | See "Expressions Used in Standard Templates" for a description of the example expression. | =DIM_DEVIATION:N
Negative Tolerance: | See "Expressions Used in Standard Templates" for a description of the example expression. | =F_PLUS_TOL:N
Positive Tolerance: | See "Expressions Used in Standard Templates" for a description of the example expression. | =F_MINUS_TOL:N

Example Label Template: Not currently used in any standard label template.

Property | Description | Example
Cylindrical Deviation | See "Expressions Used in Standard Templates" for a description of the example expression. | =DIM_RPT_DEVPERCENT:101
Cylindrical Deviation Angle: | See "Expressions Used in Standard Templates" for a description of the example expression. | =DEVIATION_ANGLE:101

Example Label Template: Bottom right cell in Legacy_Dimension_True_Position.lbl.

There are no properties to set up for this control. It uses the data passed to it in ReportData.

Example Label Template: FEATUREANALYSISA1 in Feature.lbl.

Property | Description | Example
DataFileName | The .dat file (logo.dat, elogo.dat, or header.dat) to interpret. If you use a .dat file outside of the PC-DMIS installation directory, include the full pathway to the file. | If you typed logo.dat, PC-DMIS would interpret the keywords inside that .dat file displaying the specified bitmap, date and time and so forth according to the .dat file keywords in the file.

Example Label Template: None. See the "Reporting Using .DAT File Keywords" topic.

Some PC-DMIS ActiveX Controls

The following sections describes some PC-DMIS reporting ActiveX controls and their properties. Note that the DimAnalysisActiveX Control is not discussed here. Although it appears in the ActiveX list, it is used internally by the Analysis object in the Label Template Editor.

BFAnalysisActiveX

Dimension Report Linear

Dimension Report Linear2

Dimension Report Radial

FeatureAnalysisActiveX

DataFileFormatControl


Inserting Report Commands

Inserting Report Commands: Introduction

Inserting Commands Related to the Analysis Window

Inserting Dimension Info Boxes

Inserting Point Info Boxes

Inserting Programmer Comments

Embedding Reports or Templates

Inserting External Objects

Inserting a Print Command

Inserting a Form Feed Command

Working with VIEWSETS

Inserting a FORM Command

Inserting Screen Captures


Inserting Report Commands: Introduction

PC-DMIS allows you to insert a variety of commands into the Edit window that affect how and what information gets displayed in reports. These commands, inserted by selecting menu options from the Insert | Report Command sub menu, allow the programmer to configure, view, print, and otherwise customize the appearance of the Edit window.

The following topics are covered in this section.

  • Inserting Commands Related to the Analysis Window

  • Inserting Dimension Info Boxes

  • Inserting Point Info Boxes

  • Embedding HyperView Reports

  • Inserting Programmer Comments

  • Inserting External Objects

  • Inserting a Print Command

  • Inserting a Form Feed Command

  • Working with Viewsets

  • Inserting a FORM Command

  • Inserting Screen Captures


Inserting Commands Related to the Analysis Window

Analysis dialog box

Display Menu Roadmap

The Insert | Report Command | Analysis menu option brings up the Analysis dialog box which allows you to output the dimensional printout in a format suitable for close examination.

If the Analysis dialog box is open, you can press CTRL and click the left mouse button on a feature in the Graphics Display window and any dimensions using that selected feature will be highlighted in the Dimension List box.

More:

Analysis

Show All Arrows

View Window

File Menu

View Menu

Show Menu

Options Menu


Analysis

The Analysis area of this dialog box allows you to choose to view the dimension(s) selected from the Dimension List box in either a graphical or a textual readout.

By default the check boxes in the Analysis area are not selected. When you select either the Textual or Graphical check box and click Apply, PC-DMIS will show the selected dimensions in a textual format or a graphical image. It will not display any CAD data.

It is helpful to have either the Graphical or Textual Analysis option on when having a problem with a feature whose cause needs to be determined.

Example: Suppose you are inspecting a plane for flatness, and you find it is out of tolerance. Using the Graphical Analysis option will allow you to examine the plane and determine if a specific area is bad or if the entire surface is irregular.

To select Graphical or Textual analysis from within a Dimension dialog box:

  1. Select Dimension from the menu bar.

  2. Select the dimension option you will be using from the menu. A dimension dialog box will appear.

  3. Select either the Graphical or Textual check boxes.

  4. Finish the dimensioning process.

More:

Graphical

Textua l

Multiplier


Graphical

If the Graphical check box is selected, PC-DMIS stores the dimension information in a format to be viewed graphically.


Textual

If the Textual check box is selected, PC-DMIS stores the dimension information in a format to be viewed textually.


Multiplier

The value in the Multiplier box is a scaling factor that magnifies the arrow and tolerance zone for the graphical analysis mode. For example, if a value of 2.0 is entered, PC-DMIS will scale the arrow two times the graphical image.

This option is used for viewing purposes only, and is not reflected in the text printout.


Show All Arrows

The Show All Arrows button shows the graphical analysis arrows used to mark deviation. These graphical analysis arrows can be hidden arrow by arrow. To do this, press CTRL + SHIFT, and click the arrows to hide. Clicking the Show All Arrows button re-displays the arrows. The graphical analysis arrows will then be reset for display purposes.


View Window

The View Window button displays the Analysis window. This window allows the dimensions to be displayed in the most suitable view.

To effectively use the View window:

  1. Select the dimension that needs to be examined in the Analysis window.

  2. Enter a value for the Multiplier box (see "Multiplier").

  3. Press the View window button. PC-DMIS brings up the Analysis window.

Using the menu bar provided with the Analysis window you can alter the graphical image, capture the current graphics screen, or edit the selected dimension colors.

Analysis Window

The menu bar on the Analysis Window provides these menus:

  • File

  • View

  • Show

  • Options

In order to determine the initial view of the graphical analysis in the Analysis Window, PC-DMIS uses either the scan cut vector for profile dimensions of scans or the current workplane for other dimensions. This view can be altered later.


File Menu

The Analysis window's File menu allows you to send the contents of the Graphics Analysis window directly to the printer for printing purposes.


View Menu

The Analysis window's View menu allows you to temporarily alter the graphics displayed for the selected dimension. By rotating, scaling or changing the view you can easily access the necessary dimensions.

Note: This option is especially useful when viewing the profile error of a set of points.

More:

Change

Scale to Fit

Rotate


Change

The View | Change menu option lets you create new views from a CAD file. This function is useful when a 2D IGES file is used that contains several views of a part in one plane and the views need to be associated with their correct orientation in the Graphics Display window. See "Setting Up the Screen View" in the "Editing the CAD Display" section for more information on manipulating views.


Scale to Fit

The View | Scale To Fit menu option re-draws the part image to fit entirely within the Graphics Display window. This function is useful whenever the image becomes too large or small.


Rotate

The View | Rotate menu option displays the Rotate dialog box allowing you to rotate the part image in three dimensions.

The topic "Rotating the Drawing" in the "Editing the CAD Display" section describes rotating in further detail.


Show Menu

Show Options dialog box

The Analysis window's Show | Show Options menu command displays the Show Options dialog box. This dialog box allows you to choose what things you want displayed in the Analysis window.

The Analysis window's Show | Show Dimensions Stats brings up the Edit Dimension Info dialog box. This Dialog box allows you to edit in depth the dimension highlighted. See "Common Dimension Dialog Box Options" in the "Dimensioning Features" section and "Inserting Dimension Info Boxes" in this section for more information.

More:

Show Statistics

Show Histogram

Show Max/Min Deviations


Show Statistics

The Show Statistics check box on the Show Options dialog box displays various statistics in the Analysis window. If the Show Statistics check box is not selected, dimensional information text will not be displayed (for any dimensions). See the Edit Dimension Info menu option to change the format of the statistics displayed in the Analysis window.


Show Histogram

The Show Histogram check box on the Show Options dialog box displays a histogram of the deviations for each point. Histograms can be moved to new locations within the Analysis window.

To move to a new location within the Analysis window:

  1. Click on the desired histogram.

  2. Drag the cursor to the desired location.

  3. Release the mouse button.


Show Max/Min Deviations

The Show Max/Min Deviations check box on the Show Options dialog box allows the maximum and minimum deviations to be indicated with a '*+' or '*-' symbol.


Options Menu

The Analysis window's Options menu allows you to capture the current graphics screen for later use. It also provides access to the Edit Color dialog box and sizing of the Analysis window.

More:

Save Graphics to Report

Create Analysis View Command

Edit Dimension Colors

Dimension Options

Size Options


Create Analysis View Command

The Analysis window's Options | Create Analysis View Command menu option displays the ANALYSISVIEW command in the Edit window. When this command is marked and executed, PC-DMIS will display the list of dimensions in its own analysis level window, with the number of view and rotations selected previously. It will automatically take a screen capture of the Analysis Level window with the listed dimensions. These screen captures are then available to be displayed and printed in the inspection report.

The Edit window command line for this option reads:
ANALYSISVIEW/D1,D2,D3,,

D1,D2,D3 = list of dimensions to be displayed.

There is no limit to the number of dimension parameters that can be used.

Typing "ANALYSISVIEW" in the Edit window also creates an ANALYSISVIEW command. Any dimensions selected for analysis will become parameters for this command.


Save Graphics to Report

The image will remain on the clipboard until another screen is captured, or the part program is closed.

The Analysis window's Options | Save Graphics To Report menu option captures the view in the Analysis window and stores it in a DISPLAY/METAFILE command. When executed this in turn sends the capture into the inspection report.

PC-DMIS does not have the ability to edit or format the captured image. The graphics will be displayed at the cursor's location.

This DISPLAY/METAFILE command differs from the DISPLAY/METAFILE command generated from the main menu in these ways:

  • It takes the screen capture of the view in the Analysis window when you select the menu item, not the Graphics Display window.

  • The screen capture does not get retaken during execution, it is a static image.

See "Create Analysis View Command" for creating a screen capture that automatically updates itself upon execution.

See "Screen Captures" in the "Using the Edit Window" section for additional information on the DISPLAY/METAFILE command.


Edit Dimension Colors

The Analysis window's Options | Edit Dimension Colors menu option allows you to set the color for a specified tolerance range. Selecting this option will display the Edit Dimension Color dialog box.

Edit Dimension Color dialog box

See the "Editing Dimension Colors" topic in the "Editing the CAD Display Options" section for instructions on how to use this dialog box to change dimension colors for a tolerance.


Dimension Options

This Graphical Analysis Options dialog box allows you to determine the information that gets displayed in the Analysis window.

Dimension Analysis Options

To access this option

  1. Select Analysis from the menu. The Analysis dialog box will appear. Display Menu Roadmap

  2. Select the dimension from the list box.

  3. Click the View Window button. The Analysis window will appear.

  4. Select Options | Dimension Options from the Analysis window. The Dimension Analysis Options dialog box opens. Most options are unavailable until you select any dimension in the Analysis dialog box. Relevant options become available for selection.

The following options are available on this dialog box:

Dialog Box Option

Description

Show Arrow Heads

The Show Arrow Heads check box turns the arrow heads on or off of the deviation lines.

Show Lines Between Meas. Hits

The Show Lines Between Measured Hits check box toggles on or off lines between the measured hits.

Show Lines Between Nominals

The Show Lines Between Nominals check box toggles lines drawn between the nominal values.

Show Tolerance Lines

The Show Tolerance Lines check box toggles the display of the acceptable tolerances for the dimension.

Show Max / Min Deviations

The Show Max/Min Deviations check box allows the maximum and minimum deviations to be indicated with a ' *+ ' or ' *- ' symbol.

Show Grid

The Show Grid check box lets you display a 3D grid-like backdrop for the graphical analysis. Enabling the grid may help you better visualize rotated items. It also enables the Grid Options button. Clicking Grid Options opens the Analysis Grid Options dialog box which you can use to define your grid.

Analysis Grid Options dialog box

The dialog box contains these options:

Automatically Size - This automatically sizes the grid based on the number of objects specified in the X, Y, and Z fields.

Specified Size - This enables the Maximum Boundary and Minimum Boundary boxes, letting you type specific sizes for the maximum and minimum boundaries.

Number of Elements - This defines the number of divisions that will be drawn on the analysis grid.

Maximum Boundary - This defines upper limits of the analysis grid coordinates.

Minimum Boundary - This defines the lower limits of the analysis grid coordinates.

Grid Options

The Grid Options button displays the Grid Options dialog box.

Multiplier

The Multiplier box allows you to enter a scaling factor that magnifies the deviation arrows and tolerance zone for the graphical analysis mode. If a value of 2.0 is entered, PC-DMIS will scale the arrows two times the calculated deviation for each feature hit.

This option is used for viewing purposes only, and is not reflected in the text only printout.

Show Diameters

The Show Diameters check box allows you to show the diameters of available True Position dimensions.

Show Best Fit, Max Inscribed, and Min Circumscribed Diameters

This check box allows you to turn on or off the various diameters that may also be drawn with the Circularity dimension. These diameters are those that represent the average, maximum, and minimum deviations for a round feature.

Show Contour Plot

The Show Contour Plot option only works for patch scans and becomes available for Profile dimensions. The contour plot uses the patch scan points to create a mesh and then shades the mesh with the colors related to the profile deviations from each hit.

PC-DMIS also allows you to display the contour plot on the CAD model in the Graphics Display window itself. See "Displaying Profile Contour Plots" in the "Dimensioning Features" section.

Show Color Inter. Between Hits

The Show Color Interpolation Between Hits option allows you to insert colors between hits. This option is available for Profile dimensions.

Show Arrows

The Show Arrows option allows the arrows for deviation lines to be toggled on or off. This option is available for Profile dimensions.


Size Options

Analysis Size Options dialog box

The Analysis Size Options dialog box allows you to determine how the Analysis window will be displayed. These options also allow you to set your ANALYSISVIEW command so that PC-DMIS takes the screen capture in one of these selected modes during execution. (See "Create Analysis View Command".)

You can select the following options:

Portrait | This option sizes the Analysis window so that it matches the standard Portrait page size.
Landscape | This option sizes the Analysis window so that it matches the standard Landscape page size.
Scale to Fit Whole Page | This check box scales the window so it would fit an entire printed page.


 Search ID Dimension List box Select All button Clear button Display Options area Dimension Info Format area Graph Options area Graphic Options area Location Axes area True Position Axes area Delete Infos button Create button

Inserting Dimension Info Boxes

Edit Dimension Info dialog box

Display Menu Roadmap

The Insert | Report Command | Dimension Info menu option brings up the Edit Dimension Info dialog box. This dialog allows you to create a DIMINFO command that displays selected dimensional information in the Graphics Display window. See "DIMINFO Command"for information on editing a DIMINFO command in the Edit Window.

Sample Dimension Info box

The dimension list inside the dialog box will show an asterisk (*) if the dimension already contains a DIMINFO text box and it will show a number sign (#) if the DIMINFO text box is hidden from view in the Graphics Display window.

Sample dimension list showing existing and hidden DIMINFO boxes

The Auto check box (under the Dimension Info Format area of this dialog) automatically determines the appropriate dimension output format to display, based on the type of dimension that was selected. To override this option, select the desired Dimension Info format check box(es). PC-DMIS will indicate the order of the output selections by displaying a number to the left of the check box. This allows the order of the format to be altered to meet individual needs. You can clear a check box by simply selecting it a second time.

If this option is displayed, you can press the CTRL key and while keeping it held, click the left mouse button to select a feature in the Graphics Display window. Any dimensions using that selected feature will be highlighted in the Dimension List box.

This Edit Dimension Info dialog box allows you to edit the dimension information being displayed. The following paragraphs describe the commands and options available to this dialog box.

More:

Dimension Info Creation Rules

Display Options

Graph Options

Graphic Options

Dimension Info Format

Location Axes

True Position Axes

Delete Infos

DIMINFO Command


Dimension Info Creation Rules

When creating a DIMINFO box from the Edit Dimension info dialog box, the Dimension List box only displays those dimensions that exist above the cursor's current position.

When creating DIMINFO boxes using Text Box mode and box selecting inside the Graphics Display window, PC-DMIS will not create a DIMINFO box for every feature selected. It will only create them for features that exist above the cursor's current position.

If the part program has multiple viewsets, the DIMINFO box only appears in the viewset that contains the corresponding dimension and lower. For example, suppose your part program had these commands:

VIEWSET1

F1 = FEAT

VIEWSET2

VIEWSET3

D1 = DIMENSION

VIEWSET4

You could only add a DIMINFO box for feature F1 if the insertion point existed below D1. Once the DIMINFO box gets created, PC-DMIS will show it in VIEWSET3 and 4, but not in VIEWSET1 and 2.


Display Options

The Display Options area allows different display possibilities for each dimension within the Graphics Display window. The following options available are:

Show Icon | This check box toggles the displays the appropriate dimension icon in the header portion of the Dimension Info box.
Show Dimension ID | This check box toggles the ability to display the ID for the dimension within the Graphics Display window.
Show Feature ID | This check box toggles the ability to display the ID for the feature whose dimensions are being measured.
Show Headings | This check box toggles the display of row and column headings in the Dimension Info box.
Show Vertical Lines | This check box toggles the display of the vertical lines between columns inside the Dimension Info box.
Show Horizontal Lines | This check box toggles the display of the horizontal lines between rows inside the Dimension Info box.


Graph Options

The Graph Options area allows for graphical display of the dimension percentage in the Dimension Info box.

More:

No Graph

Graph Worst Axis

Graph Each Axis


No Graph

Select this option if you do not want to display a graph in the Dimension Info box.


Graph Worst Axis

Select this option to display a graph at the top of the Dimension Info box. Only the worst dimension percentage will be used for the graph.


Graph Each Axis

Select this option to display a dimension percentage graph for every axis in the Dimension Info box.

Dimension Info box


Graphic Options

Graphic Options area

The Graphic Options area allows you to determine the background color and line color of the current Point Info box. You can also determine whether or not PC-DMIS displays a shadow around the border of the Point Info box.

To change the graphic options for the Point Info box, select the desired option from this area and click Create or OK.

You can set the default graphic options for newly created Point Info boxes by simply selecting the desired options and then clicking the Default button in the Point Info Format area.


Dimension Info Format

The check boxes in the Dimension Info Format area allow you to select the type of information displayed in the Graphics Display window for each dimension. When the Display check box is selected from within a dimension's dialog box, PC-DMIS displays the information in the Graphics Display window.

Dimensional Data Displayed for Feature CIR1 in the Graphics Display window.

The available check boxes in the Dimension Info area of the dialog box are:

Auto | The Auto check box automatically displays the following information: Measured, Nominal, Tolerances, Deviation, MaxMin, OutTol.
Measured | This check box displays the actual measured dimensions.
Nominal | This check box displays the theoretical values for the dimension.
Tolerances | This check box displays the acceptable tolerance levels either greater than or less than the nominal.
Deviation | This check box displays the deviation of the measured value from the nominal.
MaxMin | This check box displays the maximum and minimum values for the dimension.
OutTol | This check box displays how far out of tolerance the measured value is from the nominal and tolerance values.
Mean | This check box displays the average of all the deviations for the dimension.
StdDev | This check box displays the standard deviation of all the deviations for the dimension.
Number of Points | This check box displays the number of points used to measure the feature of the dimension.

More:

Reset Button


Reset Button

The Reset button clears out any check marked boxes in this section and selects the Auto check box.


Location Axes

This table describes the available Location Axes and their functions that you can choose from while editing dimension information.

Worst | This option uses the axis that gives the worst out of tolerance condition. PC-DMIS searches through the available axes and selects the one that gives the worst case scenario for the dimension.
Use Dim Axes | This option simply uses the axes that were previously defined in the dimension's dialog box.
X | Displays the X axis value.
Y | Displays the Y axis value.
Z | Displays the Z axis value.
Prad | Prad stands for Polar Radius. This option selects Polar coordinates.
Pang | Pang stands for Polar Angle. This option selects Polar coordinates.
D | Displays Diameter value.
R | Displays the Radius (half of Diameter) value.
A | Displays the Angle (for cones) value.
L | Displays the Length (used for cylinders, slots, cones, and ellipses).
H | Displays the height.
V | Displays the vector location.
T | Displays error along approach vector (for points on curved surfaces).
RT | Displays the deviation along the report vector.
S | Displays the deviation along the surface vector.
RS | Displays the deviation along the surface report vector.
PD | Displays the diameter of a circle (perpendicular to the pin vector).
Form | Displays the integrated form dimension for the feature. See "Default Axes for Location Dimensions" in the "Dimensioning Features" section.


True Position Axes

This table describes the available True Position Axes and their functions that you can choose from while editing dimension information.

Worst | This check box uses the axis that gives the worst out of tolerance condition. PC-DMIS searches through the available axes and selects the one that gives the worst case scenario for the dimension.
Use Dim Axes | This check box simply uses the axes that were previously defined in the dimension's dialog box.
X | This check box displays X axis value.
Y | This check box displays Y axis value.
Z | This check box displays Z axis value.
Prad | Prad stands for Polar Radius. This option selects Polar coordinates.
Pang | Pang stands for Polar Angle. This check box selects Polar coordinates.
DF | This check box displays diameter of the feature.
TP | This check box displays the true position tolerance and its associated deviation.
D1 | This check box displays the diameter/width value of the first datum.
D2 | This check box displays the diameter/width value of the second datum.
D3 | This check box displays the diameter/width value of the third datum.
Form | This check box displays the integrated form dimension for the feature. See "Default Axes for True Position Dimensions" in the "Dimensioning Features" section


Delete Infos

The Delete Infos button removes all POINTINFO commands from the part program.


DIMINFO Command

The DIMINFO command is created by the Edit Dimension Info dialog box (Insert | Report Command | Dimension Info).

Display Menu Roadmap

When a DIMINFO command has been inserted in the part program, the dimension data is displayed in the Graphics Display window. The DIMINFO command can be modified in the Edit window. The command line for the DIMINFO command reads:

DIMINFO/Dim ID ;ICON,DIMID,FEATID,VERT,HORIZ; HEADINGS, "GRAPH OPTION";"DIMENSION OUTPUT”, ,$
”AXES OUTPUT”

Dim ID = The ID of the dimension selected to be displayed.

ICON = A toggle string that shows a blank when it is OFF, and ”ICON” when it is ON. When it is ON, the DIMINFO will display the dimension or feature ID with the appropriate icon.

DIMID = A toggle string that shows a blank when it is OFF, and ”DIMID” when it is ON. When it is ON, the DIMINFO will display the dimension ID with the dimensional information.

FEATID = A toggle string that shows a blank when it is OFF, and ”FEATID” when it is ON. When it is ON, the DIMINFO will display the ID of the dimension’s first feature with the dimensional information.

VERT = A toggle string that shows a blank when it is OFF, and ”VERT” when it is ON. When it is ON, the DIMINFO will display with the vertical lines between the columns.

HORIZ = A toggle string that shows a blank when it is OFF, and ”HORIZ” when it is ON. When it is ON, the DIMINFO will display with the horizontal lines between the rows.

HEADINGS = A toggle string that shows a blank when it is OFF and ”HEADINGS” when it is ON. When it is ON, the column and row headers will be displayed in the Dimension Info box.

GRAPH OPTION = The graph option for graphical display of the dimension percentage in the Dimension Info box. Possible toggle values are GRAPH WORST and GRAPH AXIS. When the toggle string shows a blank, no graph will be show in the box.

DIMENSION OUTPUT = The format of the dimension information that will be displayed based on the order of selection. Available output options are MEAS, NOM, TOL, DEV, MAXMIN, OUTTOL, MEAN, STDDEV, and NUMPTS. Options cannot be duplicated.

AXES OUTPUT = The format of the dimension axes that will be displayed based on the order of selection. Available axes depend upon the dimension type and include all location and true position axes. If USEDIM is toggled in the first axis position, the DIMINFO will display the axes that have been specified in the dimension. If WORST is toggled in any axis position, the axis that produced the largest out-of-tolerance value is displayed. This output is not available for dimensions that are not location or true position dimensions. Axes cannot be duplicated.


Inserting Point Info Boxes

Edit Point Info dialog box

Display Menu Roadmap

The Insert | Report Command | Point Info menu option brings up the Edit Point Info dialog box. This dialog creates a POINTINFO command that can be used to display individual point information in the Graphics Display window in a Point Info box. See "POINTINFO Command" for information on editing a POINTINFO command in the Edit Window.

To display individual point information in the Graphics Display window using the Edit Point Info dialog box:

  1. Open the Edit Point Info dialog box by selecting Edit Point Info from the main menu.

  2. You will see that the features appear in the Feature List box and that dimensions appear in the Dimension List box.

  3. Select at least one feature or dimension. The individual points associated with that feature appear in the Hits List box.

  4. Select the point(s) from the Hits List box that you want displayed. If more than one dimension or feature is selected, all points from the dimension or feature will be displayed in the point info.

  5. Make sure the Show Point Info check box is selected.

  6. Click the apply button. Information about the selected hit (s) will appear in a Point Info box in the Graphics Display window.

Point Info box showing the first hit in a circle feature

Each Point Info box may display the hit number, the XYZ position, the IJK vector, and the deviation related to a particular hit.

The formats may be changed, saved, and moved in a similar manner to how the Dimension Info box formats are set and moved.

More:

Point Info Format

Hit List

Feature List Area

Dimension List Area

Delete Infos

POINTINFO Command

Graphic Options

Filters


Point Info Format

This portion of the dialog box allows you to determine the type of information displayed in the Graphic's Display area next to a feature or dimension. The check boxes in this section must be used in conjunction with the Create (Apply when editing) or the OK button to either select or remove information to display.

More:

Hit Number

Point

Vector

Deviation

Show Icon

Show ID

Show Type

Show Headings

Show Graph

Show Vertical Lines

Show Horizontal Lines


Hits Number

The Hits Number check box displays the hit sequence of a point on a feature.

Example: If a circle generally takes four hits, and one of the hits used to measure that circle was selected, this option displays a number (one through four) indicating when that hit was taken in the sequence: 1st, 2nd, 3rd, or 4th.


Point

The Point check box displays the X, Y, and Z point location of the hit selected.


Vector

The Vector check box displays the IJK vector of the hit selected.


Deviation

The Deviation check box displays the deviation of the point from the nominal.

  • For features the point deviation is the distance between the measured hits and the actual hits.

  • For dimensions the point deviation is related to the dimension type and is the same as the deviation displayed for the individual points in the textual analysis of the dimension.


Show Icon

The Show Icon check box displays the feature's icon in the header portion of the Point Info box.


Show ID

The Show ID check box allows you to display the ID of a particular feature or dimension.


Show Type

The Show Type check box allows you to display the type of feature or dimension displayed.


Show Headings

The Show Headings check box allows you to display the row headers in the Point Info box.


Show Graph

The Show Graph check box allows you to display the dimension percentage graph in the Point Info box.


Show Vertical Lines

The Show Vertical Lines check box allows you to display or hide the vertical lines inside the Point Info box.


Show Horizontal Lines

The Show Horizontal Lines check box allows you to display or hide the horizontal lines inside the Point Info box.


Hit List

This section of the dialog box allows you to select a feature's or a dimension's individual hits to be displayed.

More:

List Box


List Box

The Hit List box contains a list of all the hits associated with a particular feature or dimension. Simply select the hits whose information you would like to view.


Feature List Area

This section of the dialog box allows you select an individual feature. The hits associated with that feature will be displayed in the Hit List box.

More:

List box


List box

The Feature List box contains a list of all the features associated with a particular part program. Simply select the feature whose hit information you would like to view.


Dimension List Area

The Dimension List allows you to select an individual dimension. The hits associated with that dimension will be displayed in the Hit List box.

More:

List box


List box

The Dimension List box contains a list of all the dimensions associated with a particular part program. Simply select the dimension whose hit information you would like to view.


Delete Infos

The Delete Infos button removes all DIMINFO commands from the part program.


POINTINFO Command

The POINTINFO command is created by the Edit Point Info dialog box (Insert | Report Command | Edit Point info).

Display Menu Roadmap

When a POINTINFO command has been inserted in the part program, a Point Info box is displayed in the Graphics Display window. The POINTINFO command can be modified in the Edit window. The command line for the POINTINFO command reads:

POINTINFO/Dim ID or Feat ID; FILTER FILTER_TYPE FILTER_NUM;ICON,ID,TYPE,VERT,HORIZ; HEADINGS, GRAPH; ”OUTPUT FORMAT” ,$
”HIT NUMBERS”

Dim ID or Feat ID = The ID of the dimension or feature to be displayed.

FILTER_TYPE = A toggle string that shows the filter option of NONE, INTERVAL, WORST, DEVIATION, or OUTTOL.

FILTER_NUM = A number field available when the filter option is INTERVAL, WORST, or DEVIATION.

ICON = A toggle string that shows a blank when it is OFF, and ”ICON” when it is ON. When it is ON, the POINTINFO will display the dimension or feature ID with the appropriate icon.

ID = A toggle string that shows a blank when it is OFF, and ”ID” when it is ON. When it is ON, the POINTINFO will display the dimension or feature ID with the point information.

TYPE = A toggle string that shows a blank when it is OFF, and ”TYPE” when it is ON. When it is ON, the POINTINFO will display feature or dimension type (i.e. CIRCLE, POINT, ROUNDNESS, LOCATION) with the point information.

VERT = A toggle string that shows a blank when it is OFF, and ”VERT” when it is ON. When it is ON, the POINTINFO will display with the vertical lines between the columns.

HORIZ = A toggle string that shows a blank when it is OFF, and ”HORIZ” when it is ON. When it is ON, the POINTINFO will display with the horizontal lines between the rows.

HEADINGS = A toggle string that shows a blank when it is OFF and ”HEADINGS” when it is ON. When it is ON, the row headers will be displayed in the Point Info box.

GRAPH = A toggle string that shows a blank when it is OFF and ”GRAPH” when it is ON. When it is ON, the dimension percentage will be graphically displayed in the Point Info box.

OUTPUT FORMAT = The format of the point information that will be displayed based on the order of selection. Available output options are HIT, PT, V, and DEV. Options cannot be duplicated.

HIT NUMBERS = The hit numbers are the specific numbered hits that are controlled by this particular POINTINFO command. Multiple hits can be displayed using the same POINTINFO command. Each field in the hit numbers is a toggle string. When a hit is ON, the string in the number position is the hit number (1,2,3, etc.). When a hit is OFF, the toggle string displays a blank.


Graphic Options

The Graphic Options area allows you to determine the background color and line color of the current Dimension Info box displayed in the Graphics Display window. You can also determine whether or not PC-DMIS displays a shadow around the border of the Dimension Info box.

To change the graphic options for the Dimension Info box, select the desired option from this area and click Create or OK.

You can also set the default graphic options for newly created Dimension Info boxes. To do this, select the desired options and then click the Default button in the Dimension Info Format area.


Filters

Filters area

The Filters area allows you to set filter options to be used when displaying individual point information.

More:

Filter: None Used

Filter: Hit Interval

Filter: Worst

Filter: Deviation Above

Filter: Out of Tolerance


Filter: None Used

The None Used option tells PC-DMIS not to use any filtering for the POINTINFO command. All hits selected will be displayed with the POINTINFO command.


Filter: Hit Interval

The Hit Interval option checks the integer value in the box to its right, and only displays the particular hit interval chosen with the POINTINFO command. For example, if 2 were chosen, then every 2nd hit would be displayed, if 3, then every 3rd hit, if 4 then every 4th hit, etc.


Filter: Worst

The Worst option checks the integer value in the box to its right, and only displays the hits that give the worst deviations for the dimension. For example, if you type 3 in the box, the POINTINFO command only displays the three worst deviations.


Filter: Deviation Above

The Deviation Above option checks the number value in the box to its right, and only displays the hits that have deviations larger than this value. For example, if you type 0.01 in the box, the deviations of 0.013 and -0.015 will be displayed, while deviations of 0.003 and –0.005 will not be displayed.


Filter: Out of Tolerance

The Out of Tolerance option only displays the hits that have deviations that are out of tolerance.

For hits related to features (not related to dimensions), only those hits with deviations larger than the Show Deviations Tolerance on the Setup Options dialog box's General tab are displayed. (See "Show Deviations Tolerance" in the "Setting Your Preferences" section.)


Inserting Programmer Comments

Comment dialog box

Display Menu Roadmap

The Insert | Report Command | Comment menu option allows you to add operator notes or instructions into the Edit window that will be displayed in a Comment Text box when the part program is executed or the inspection report is printed. There is no limit to the length of the comment; however, in Command mode only 255 characters will fit per line. When the text reaches the right side of the Edit window, press the ENTER key. (This allows the entire text to be viewed in the Comment Text box.) To create a new line, place the cursor in the desired location of the Comment Text box and press the ENTER key.

To display the Comment dialog box, select Comment from the menu.

Using Variables in Comment Strings

Suppose you want to concatenate, or add, a variable to an existing comment string. You can do this in two ways. First, you can press ENTER, and type the variable on a new comment line, like this:

C1=COMMENT/INPUT,NO,'Type your variable'

ASSIGN/V1= C1.INPUT

COMMENT/OPER,NO,Your V1 variable is

,V1

Second, you can place them on the same line by placing quotation marks around the non-variable string and using the plus sign operator to add the variable to the string, like this:

COMMENT/OPER,NO,"Your V1 variable is " + V1

Changing Comment Color

You may want your comments to stand out more. You can do this by changing your comment color.

  • To change them in the Edit window, see "Defining Edit Window Colors".

  • To change comment colors for comments that appear in the Report window, change the Colors property of the TextReportObject in the in the Report Template Editor.

Hint: Another way to change a comment's color in the report is to insert this special prefix directly in front of the comment text:

~~#

This tells the comment to use the defined text color for Marked, Unmarked, Step Mode, or Error found in the Edit Window Colors dialog box.

For # you would type 1, 2, 3, or 4; these four numbers stand for the Unmarked, Marked, Step Mode, or Error colors respectively.

So, if you want to display some comment text in the text color assigned to Error, your command would look like this:

COMMENT/rept, ~~4 Some Comment Text

More:

Operator

Report

Input

Document

Yes / No

Readout

Enable Report

Comment Text


Operator

This option allows you to display text when executing the part program.

To use Operator option:

  1. Select the Comment menu option. The Comment dialog box appears. Display Menu Roadmap

  2. Select the Operator option.

  3. Type in the desired text in the Comment Text box.

  4. When the comments are completed, click the OK button (or press ENTER) to close the dialog box.

The Edit window command line for this option reads:
COMMENT/OPER,TOG1,comment text

TOG1 = This YES/NO field allows you to specify whether or the comment shows up in the inspection report.

How it Works

When PC-DMIS executes the part program, a message box will display the appropriate comments just under the Execution Mode Options dialog.

A Sample PC-DMIS Message dialog box

PC-DMIS will not allow you to edit this message. Click on the OK button to continue execution. Click Cancel to cancel part program execution.


Report

This option allows you to send text to the inspection report.

To use the Report option:

  1. Select the Comment menu option. The Comment dialog box appears. Display Menu Roadmap

  2. Select the Report option.

  3. Enter in the desired text in the Comment Text box.

  4. When the comments are completed, click the OK button (or press the ENTER key) to close the dialog box.

When PC-DMIS executes the part program, these messages will not be viewed. PC-DMIS will, however, send these comments to the inspection report when it is printed.

The Edit window command line for this option reads:
COMMENT/REPT,comment text

Note: If dashes (or other characters) need to be incorporated underneath text in the inspection report, use a second comment line to create the additional line of characters.
For example:
COMMENT/REPT,Inspection Report Comment
      COMMENT/REPT,-----------------------------------

This set of command lines will create an Inspection Report Comment line in the inspection report.


Document

This option provides you with the ability to add text to the internal program. It is not used for anything except documenting programmers' notes. It is not sent to the inspection report and will not display anything when executed. It simply allows you to have an option for documenting inside the Edit window.

To use the Document option:

  1. Place the cursor where you want the text to be inserted in the Edit window.

  2. Select the Comment menu option. The Comment dialog box appears. Display Menu Roadmap

  3. Select the Document option.

  4. Enter in the desired text in the Comment Text box.

  5. When the comments are completed, click the OK button (or press the ENTER key) to close the dialog box.

The Edit window command line for this option reads:

$$ TOG1, Please Edit Comment Text!

TOG1 = This YES/NO field allows you to specify whether or the comment shows up in the inspection report.

Note: When you open a part program that was saved from a later version into the current version, any commands that are not supported in the current version will show up as DOC comments. See "Save As" in the "Using Basic File Options" section.


Input

The Input option is similar to the Operator option in that it allows you to display text when executing a part program. In addition to displaying a message box with the previously entered text, a comment box will appear. This allows you to enter numerical information that will be written to the inspection report.

This option is extremely helpful to users wishing to enter a part number or serial number while executing the part program.

To use the Input option:

  1. Place the cursor where you want this option to be inserted in the Edit window.

  2. Select the Comment menu option. The Comment dialog box appears. Display Menu Roadmap

  3. Select the Input option.

  4. Enter in the desired text in the Comment Text box.

  5. When the comments are completed, click the OK button (or press the ENTER key) to close the dialog box.

The Edit window command line for this option reads:
comment ID = COMMENT/INPUT, TOG1 comment text

TOG1 = This YES/NO field allows you to specify whether or the comment shows up in the inspection report.

The input is assigned to the variable specified on the left hand side of the command. The variable is coerced to be of type string. This variable can then be used anywhere an expression is allowed by using this syntax <COMMENT ID>.INPUT. For example if your comment ID is C1, you can pass that variable into another variable like this:

C1 = COMMENT/INPUT,NO,"Please enter your name:"

ASSIGN/V1=C1.INPUT

How it Works

The message box will display the prompt to enter the necessary number (i.e., serial number) and then display this number in the inspection report. This prompt will appear on top of the Execution Mode Options dialog box during execution:

A Sample Input Comment dialog box

Type your text in the Operator Input dialog box and click OK to continue part program execution. This information gets stored into the comment's ID.INPUT variable. Clicking Cancel will stop part program execution.


Yes / No

The Yes / No option functions similarly to the "Operator" option in that it allows you to display text when executing a part program. In addition, Yes and No buttons will appear at the bottom of the dialog box allowing the operator to answer YES or NO to simple questions.

To use the Yes / No option:

  1. Place the cursor where you want the COMMENT/YESNO command to be inserted in the Edit window.

  2. Select the Comment menu option. The Comment dialog box appears. Display Menu Roadmap

  3. Select the Yes / No option.

  4. Type the desired text in the Comment Text box.

  5. When the comments are completed, click the OK button (or ENTER key) to close the dialog.

The Edit window command line for this option reads:
comment ID = COMMENT/YESNO,TOG1, comment text

TOG1 = This YES/NO field allows you to specify whether or not the comment shows up in the inspection report.

How it Works

During execution, the PC-DMIS Message dialog box appears just below the Execution Mode Options dialog box, allowing the operator to select YES, NO, or click Cancel.:

A Sample PC-DMIS Message dialog showing YES and NO

Execution pauses until a button is clicked. The answer the operator selects is accessible using expressions with the ID of the comment. For example, if the comment has an ID of C1 and the Yes button is clicked, the expression "C1.INPUT" will have the value 'YES'. If the No button is clicked, the expression "C1.INPUT" will have the value 'NO'. This option is useful to users wishing to branch or loop on a 'Yes' or 'No' response. If the operator clicks Cancel part program execution is canceled.

Important: When using a conditional branching statement to test for the value of a YES / NO comment, be aware that your test should look for an uppercase "YES" or "NO" value. A lowercase "Yes" or "No" will not work. For information on program branching, see the "Branching by Using Flow Control" section.


Readout

The Readout option displays the comment text at the bottom of the Probe Readout window. You must select the Display prompt history check box on the Probe Readout Setup dialog box for this to work.

To use the Yes / No option:

  1. Place the cursor where you want the COMMENT/YESNO command to be inserted in the Edit window.

  2. Select the Comment menu option. The Comment dialog box appears. Display Menu Roadmap

  3. Select the Yes / No option.

  4. Type the desired text in the Comment Text box.

  5. When the comments are completed, click the OK button (or ENTER key) to close the dialog.

The Edit window command line for this option reads:
COMMENT/READOUT,TOG1,comment text

TOG1 = This YES/NO field allows you to specify whether or the comment shows up in the inspection report.

For more information on setting up this option, see "Setting up the Readout Window" in the "Setting Your Preferences" section.

For more information on the Probe Readout window, see "Using the Probe Readout Window" in the "Using Other Windows, Editors, and Tools" section.


Enable Report

This checkbox allows you to determine whether or not your comment and any submitted text (if using an Input comment, for example) appear in the final report generated in the Report window. If selected, the comment's YES/NO toggle field, which specifies whether or not a comment shows up in the report, is set to YES.

The Edit window command line for this option reads:
COMMENT/TOG1,TOG2,comment text

TOG1 = Any comment type except Report.

TOG2 = This YES/NO field allows you to specify whether or the comment shows up in the inspection report.


Comment Text

The Comment Text box contains the text you wish to display in conjunction with the Comment Type options as shown here:

  • Operator

  • Report

  • Input

  • Document

  • Yes / No

  • Readout


Embedding HyperView Reports

Embedding Reports or Templates

To embed a legacy (HyperView) Report, a custom report, or a Report Template into a Part Program, see the "Embedding Reports or Report Templates in a Part Program" topic in the "Reporting Measurement Results" section.


Inserting External Objects

Display Menu Roadmap

To add external objects to your report, select the Insert | Report Command | External Object menu item. See the "Adding External Elements" section for more information.


Inserting a Print Command

PC-DMIS allows you to insert a PRINT/REPORT command into the Edit window that when marked and executed will cause the measurement results to that point to be sent to the defined output destination (printer or file). After PC-DMIS executes the command, it clears the contents of the Report window and only the remaining measurement results will appear in the Report window. However, you can always click the View Report Mode icon on the Reporting toolbar to view the full report.

To insert a PRINT/REPORT command in to the Edit window:

  1. Open the Edit window (View | Edit Window). Display Menu Roadmap

  2. Click the Command Mode icon from the Edit window toolbar, placing PC-DMIS into Command Mode.

  3. Select the Insert | Report Command | Print Command menu option (or type PRINT at the desired location and press TAB). PC-DMIS displays the PRINT/REPORT command as well as the various options you can configure. Display Menu Roadmap

The PRINT/REPORT command is used to control the printing of reports from within the part program. When PC-DMIS reaches this command during part program execution, a report is generated and sent to the specified output destination.

Note: All options available via the File | Printing | Report Setup menu option (with the exception of the DMIS output options) are also available through this command.

For information on printing the Edit window in general see the "Printing from the Edit window" topic in the "Using Basic File Options" section.

More:

Understanding the Syntax for the PRINT/REPORT Command

Editing the PRINT/REPORT Command


Understanding the Syntax for the PRINT/REPORT Command

The syntax of the command is as follows:

PRINT/REPORT,EXEC MODE=END,$

TO_FILE=OFF,TOG1,$

TO_PRINTER=OFF,$

TO_DMIS_REPORT=OFF,FILE_OPTION=OVERWRITE,FILENAME=,$

REPORT_THEORETICALS=ALL,REPORT_FEATURE_WITH_DIMENSIONS=YES,$

PREVIOUS_RUNS=DELETE_INSTANCES

EXEC MODE = Because DMIS and PC-DMIS manage report data differently, this option lets you control how and when the software sends report data to DMIS and PC-DMIS output files. DMIS requires that the output filenames and other printing parameters be defined first before the program is executed. PC-DMIS, on the other hand, waits until after the part program is executed before deciding where to dump the report data. This option allows you to support both formats. It takes one of two values, either START or END.

START
This tells PC-DMIS to begin printing when it either encounters the end of program or another PRINT/REPORT command. If you import a DMIS file, and it has a print report command, it will use START as its initial value.

END
This tells PC-DMIS to print everything already executed up to this PRINT/REPORT command. If you don't import a DMIS file with a print report command, but instead insert your own PRINT/REPORT command from within PC-DMIS, it will have END as its initial value.

Important: If your part program contains more than one PRINT/REPORT command, be aware that PC-DMIS may not print some commands. For example, if your first PRINT/REPORT command uses END and your second print report command uses START, then PC-DMIS will not print everything in between.

Also if a PRINT/REPORT command uses START and then your very next print report command uses END, the second printing will be empty since the first print report command has cleared the report buffer.

TO_FILE= Use this option to indicate whether the printed report should be sent to a file (ON) or not (OFF).

AUTO= Use this option to have PC-DMIS generate the report filename automatically. When the AUTO option is selected, this keyword is followed by a numeric field, for example, AUTO=10. The name of the generated filename will have the same name as the part program appended by the numerical index and a .RTF extension. Also, the generated file will be located in the same directory as the part program. If a file exists with the same name as the generated filename, AUTO will increment the index until a unique filename is found.

TOG1 This value controls the action taken when printing to a file. The options available are APPEND / AUTO / OVERWRITE / PROMPT. Depending on the option selected, different information may appear.

OVERWRITE
Use this option to overwrite report information to the specified filename. When the OVERWRITE option is selected, this keyword is followed by a filename field, for example, OVERWRITE=D:\REPORTS\FILE001.RTF. Note that the complete path must be specified otherwise PC-DMIS will assume the same directory as the part program. Also, if the file does not exist, it will be created when the PRINT/REPORT command is executed.

APPEND
Use this option to append report information to the specified filename. When the APPEND option is selected, this keyword is followed by a filename field, for example, APPEND=D:\REPORTS\FILE001.RTF. Note that the complete path must be specified otherwise PC-DMIS will assume the same directory as the part program. Also, if the file does not exist, it will be created when the PRINT/REPORT command is executed.

PROMPT
Use this option to cause PC-DMIS to query the user, via a Save As dialog box, for the filename to which the report information will be written.

T O_PRINTER= Use this option to indicate whether the printed report should be sent to the printer (ON) or not (OFF).

TO_DMIS_REPORT= Use this option to determine whether or not PC-DMIS will send the report to a DMIS Output file (.dmo) specified in FILENAME. This can be ON or OFF.

FILENAME= Use this option to specify a DMIS output directory location and filename. If TO_DMIS_REPORT is set to ON, then PC-DMIS stores the report data in the file specified. For example, if this field had d:\pcdmisreports\mydmis.dmo, PC-DMIS cause the report data to be saved in that DMIS file in that location.

FILE_OPTION= This option lets you choose one of the following file options for your DMIS file output:

APPEND
This appends the report data to the end of the DMIS file specified in FILENAME.

OVERWRITE
This overwrites the DMIS file specified in FILENAME with the latest report data.

INDEX
This appends to the DMIS filename specified in FILENAME a numerical value that increments on subsequent part program executions. For example, if FILENAME is mydmis.dmo, it would become mydmis001.dmo, then mydmis002.dmo, then mydmis003.dmo, and so forth, similar to the AUTO= option.

REPORT_THEORETICALS= This tells how PC-DMIS reports theoretical values in the DMIS output file.

ALL
PC-DMIS outputs all theoretical values along with the measured values to the output DMIS file.

NONE
No theoretical values are included in the report.

IMPORT_SETTINGS
Only those theoretical values explicitly output by the original DMIS program are output in the report.

REPORT_FEATURE_WITH_DIMENSIONS= This determines whether or not PC-DMIS will keep the measured features and associated tolerances together in the output file. It takes either YES or NO.

YES
In the DMIS report file, PC-DMIS writes the measurement results immediately before their associated tolerance results for each dimension associated to the feature itself. If a feature is not associated with any tolerance, PC-DMIS will not generate any output.

NO
In the DMIS report file, PC-DMIS writes the measurement results exactly when the feature is measured and not later when PC-DMIS executes the associated dimensions.

PREVIOUS_RUNS= This option is particularly useful when using the PRINT/REPORT command from within a loop. When a feature is measured more than once in a single execution, previous instances of that feature's measured data are saved. Use TOG2 to have PC-DMIS delete (DELETE_INSTANCES) or keep (KEEP_INSTANCES) the saved measured data.


Editing the PRINT/REPORT Command

To edit these options in the Print Options dialog box,

  1. Place the cursor over the PRINT/REPORT command line.

  2. Press F9.

  3. Make any changes.

  4. Click OK.

You'll notice that PC-DMIS updates the command to match your changes. Note that this is different than accessing the Print Options dialog box directly from the Edit window's Report menu. Accessing the dialog box directly from the Report menu does not insert a PRINT/REPORT command into the Edit window.

Note: The PRINT/REPORT command may be used more than once in the part program.

Note: The PRINT/REPORT command is a unique instance of the information contained in Print Options dialog box. Therefore, options that are selected from the Print Options dialog box but not using a PRINT/REPORT command are independent of any PRINT/REPORT command and will affect printing when the part program has completed execution.

For information on printing the Edit window in general see the "Printing from the Edit window" topic in the "Using Basic File Options" section.


Inserting a Form Feed Command

PC-DMIS lets you insert a FORMFEED command into the Edit window. This command causes the printed page of a report to be ejected from the printer when the FORMFEED command has been marked and executed. The FORMFEED command has no effect when printing to a file.

To insert a FORMFEED command in to the Edit window:

  1. Open the Edit window (View | Edit Window). Display Menu Roadmap

  2. Click the Command Mode icon from the Edit window toolbar, placing PC-DMIS into Command Mode.

  3. Select the Insert | Report Command | Form Feed menu option (or type FORMFEED at the desired location and press TAB). PC-DMIS displays the FORMFEED command. Display Menu Roadmap


Working with Viewsets

You can create and save different Graphics Display window views (termed "viewsets") that you can later recall by using a command that gets inserted into your part program. Viewsets store the CAD model's orientation, ID label visibility and position, and shading. The Create Viewset menu option allows you to create an unlimited number of viewsets in your part program. You can recall multiple viewsets as often as desired.

To Create a Viewset:

  1. Set up the view as desired. You can do this by using the View Setup dialog box and modifying the zoom and rotation of the part in the Graphics Display window. See "Setting Up the Screen View" in "Editing the CAD Display".

  2. Select the Insert | Report Command | Create Viewset menu option. Display Menu Roadmap A small Viewset dialog box will appear with the prompt "Enter View Name To Save." The dialog box will contain a default name starting with VIEWSET1 and then incrementing the number for subsequent view sets (VIEWSET2, VIEWSET3, and so on):

Viewset dialog box with a default name

  3. In the box, type in the desired name (19-character limit) for the view.

  4. Click the OK button or press the ENTER key. PC-DMIS sets the current viewset equal to the name you chose by inserting a <NAME>=VIEWSET command, where <NAME> is the defined viewset name.

To Recall a Viewset:

You can quickly recall the created viewset by selecting it from the Views list on the Settings toolbar or by using the Recall Viewset menu option. When your cursor is on or under the RECALL/VIEWSET,<NAME> command in the Edit window, PC-DMIS will display the created viewset in the Graphics Display window. If you mark and execute this command, PC-DMIS will display the saved view in the Graphics Display window during program execution as well.

Additionally, recalled viewsets will appear in your final report if the Report Window uses a template or custom report that displays a CADReportObject. Viewsets in reports appear on a new page for each RECALL/VIEWSET command.

To Update a Viewset:

You can also quickly modify an existing viewset. Simply select the RECALL/VIEWSET,<NAME> command in the Edit window, modify the Graphics Display window as desired for that view, and then select the Insert | Report Command | Save Viewset menu option (or select the Save Viewset icon from the Graphics Mode toolbar).

Note: If you just want to change and then save the current viewset without creating a new viewset, select the Save Viewset menu option instead.


Inserting a FORM Command

The Insert | Report Command | Form... menu item lets you insert a predefined .FORM file into your part program. When you select this menu item, an Insert Form dialog box appears.

Navigate to the .FORM file, select it, and click Open. PC-DMIS will insert a FORM/FILENAME command similar to the following into the Edit window:

CS1 =FORM/FILENAME= C:\PCDMIS40RELEASE\REPORTING\TESTFORM.FORM

PARAM/=

ENDFORM/

FILENAME = This defines the location of the .FORM file to load.

PARAM/ - This lets you send information to the form. For example using a PARAM statement of PARAM/Text1.Text = C1.INPUT will send the value of the comment C1.INPUT and send it to the control.

Alternately, you can type FORM and press TAB to insert the FORM/FILENAME command into the part program, and then manually type the pathway load the desired form.

When PC-DMIS executes this command, it will launch the defined form, and then pass any defined parameters to the controls in the form.

Communicating between the FORM and the Part Program

You can pass values to and from a form by using a combination of ASSIGN and PARAM statements. This lets you establish useful two-way communications between the form and the part program.

ASSIGN Statements - You can initialize values for a form's controls through ASSIGN statements. These statements also create variables that can later receive updated values from the form when the form closes.

For example, suppose you have a form that has four unnamed check boxes, like this, but you want the part program to give them names and values dynamically. In the Edit window, you can use the ASSIGN statements to name and initialize the check boxes as follows:

ASSIGN/CHECK1VALUE = 0

ASSIGN/CHECK1TEXT = "Point"

ASSIGN/CHECK2VALUE = 1

ASSIGN/CHECK2TEXT = "Line"

ASSIGN/CHECK3VALUE = 0

ASSIGN/CHECK3TEXT = "Circle"

ASSIGN/CHECK4VALUE = 1

ASSIGN/CHECK4TEXT = "Sphere"

PARAM Statements - Now that you have several variables, you can use the PARAM statements to establish the connection between the variables and the form itself, like this:

CS1 =FORM/FILENAME= C:\PCDMIS40RELEASE\REPORTING\TESTFORM.FORM

PARAM/CHECKBUTTON1.VALUE=CHECK1VALUE

PARAM/CHECKBUTTON1.TEXT=CHECK1TEXT

PARAM/CHECKBUTTON2.VALUE=CHECK2VALUE

PARAM/CHECKBUTTON2.TEXT=CHECK2TEXT

PARAM/CHECKBUTTON3.VALUE=CHECK3VALUE

PARAM/CHECKBUTTON3.TEXT=CHECK3TEXT

PARAM/CHECKBUTTON4.VALUE=CHECK4VALUE

PARAM/CHECKBUTTON4.TEXT=CHECK4TEXT

PARAM/=

ENDFORM/

When the form loads, CHECKBUTTON1 is unchecked and its text label displays "Point", CHECKBUTTON2 is checked and its text label is "Line", CHECKBUTTON3 is unchecked and its text label is "Circle" and CHECKBUTTON4 is checked and its text label is "Sphere", like this.

With the form loaded, you can select or clear the check boxes to something different, and when you close the form, the variables that initially set the state of the checked state (CHECK1VALUE, CHECK2VALUE, CHECK3VALUE and CHECK4VALUE ) now hold the current value of the check boxes.


Screen Captures

Inserting Screen Captures

Display Menu Roadmap

The Insert | Report Command | Screen Capture menu option displays screen captures in your report. Selecting this menu option places a DISPLAY/METAFILE command in the Edit window. When this command is marked and executed, PC-DMIS automatically refreshes the screen capture and displays it in the report.

Command line in the Edit window:
DISPLAY/METAFILE,"___",TOG1,TOG2

___ = This field will allow you to enter a description of the captured screen. The maximum text is 255 characters.

TOG1 = This field determines the size of the screen capture. You can toggle between the following: 25%, 50%, 75%, 100%, TO FIT.

TOG2 = This field determines the quality of the screen capture. You can toggle between the following: HIGH, GOOD, LOW

For this to appear in the Report window, right-click on some text within the Report window, select Edit, and when the Report dialog box appears, select the Show Screen Capture check box.

This command is similar to the ANALYSISVIEW command and the DISPLAY/METAFILE command that are created in the Analysis Window. For more information on the Analysis Window, see "Analysis" in the "Inserting Reporting Commands" section.

Note: Using True Type Font for text in the Graphics Display window will create the best results when capturing the image.


Using File Input / Output

Using File Input / Output: Introduction

Understanding Basic File I/O Concepts

Using the File I/O Dialog Box

Opening a File for Reading or Writing

Closing an Opened File after Reading or Writing

Reading a Character from a File

Reading a Line from a File

Reading a Block of Text from a File

Reading Text up to a Delimiter

Writing a Character to a File

Writing a Line to a File

Writing a Block of Text to a File

Positioning a File Pointer at the Beginning of a File

Saving a File Pointer's Current Position

Recalling a Saved File Pointer's Position

Copying a File

Moving a File

Deleting a File

Checking for a File's Existence

Displaying a File Dialog Box

Checking for the End of a File or the End of a Line


Using File Input / Output: Introduction

This section explains how to input and output information to and from your part programs. The available menu options allow for opening files in read or write mode. Data can then be read from or written to these files. The File I / O commands allow data to be read in from external files that are to be used in a part program . Also, measurement and tolerancing information can be written back out to files using these commands. You can also perform other file operations by using these commands.

This section details these file I/O operations and includes functional examples for each of the various operations. These examples use items discussed in the "Branching by Using Flow Control" section and the "Using Expressions and Variables" section.

Note: When looping or branching occurs in the code samples, indentation has been used for clarity to show statements assigned to a certain condition. In the actual Edit window code, you won't see any indentation.

The main topics described in this topic include:

  • Understanding Basic File I/O Concepts

  • Using the File I/O Dialog Box

  • Opening a File for Reading or Writing

  • Closing an Opened File after Reading or Writing

  • Reading a Character from a File

  • Reading a Line from a File

  • Reading a Block of Text from a File

  • Reading Text up to a Delimiter

  • Writing a Character to a File

  • Writing a Line to a File

  • Writing a Block of Text to a File

  • Positioning a File Pointer at the Beginning of a File

  • Saving a File Pointer's Current Position

  • Recalling a Saved File Pointer's Position

  • Copying a File

  • Moving a File

  • Deleting a File

  • Checking for a File's Existence

  • Displaying a File Dialog Box

  • Checking for the End of a File or the End of a Line


Understanding Basic File I/O Concepts

Checking for File Existence:
For all the file I/O operations you will probably want to first check for the file's existence. This should probably be put in an IF / THEN loop so that if the check fails, you can notify the user. When writing to a file you must first create the file inside the windows environment.

See "Checking for a File's Existence".

Opening and Closing Files:
For operations that read from or write to files you need to first open them to your system's processes. You do this by assigning the file to a variable called a file pointer. When opening a file, you can specify whether the file will be opened for reading, for writing (overwriting), or for appending. Once opened, you can then read from or write to the file. When you're finished working with a file, you should close the file pointer; this closes the file and allows it to be accessed by other system processes. You cannot open files that are already opened by another process.

See "Opening a File for Reading or Writing" and "Closing an Opened File after Reading or Writing".

File Pointers and Positions:
File pointers are variables that point to a file. They store an opened file's name and location and are then used to read from or write to that file. Once a file is opened and set to a file pointer, the pointer behaves like a cursor acts in a word processor. They indicate where you are currently reading from or writing to within the file.

· If you're appending to a file, you will usually want your file pointer to be at the end of the file.

· If you're reading a file or overwriting a file, the file pointer should usually start at the beginning of a file.

Using Delimiters When Writing or Reading

When writing data, consider using delimiters to separate pieces of data. This will make it easier to read the data back into a part program. A delimiter can be any character or string of characters. For example, suppose you have a point, named PNT1 with the X,Y, and Z measured values of 2.5,4.3,6.1. You can easily write these values separated by a comma delimiter into a data file with code similar to the following:

FILE/WRITELINE,FPTR,PNT1.X + "," + PNT1.Y + "," + PNT1.Z

When reading data, you can separate the incoming data based on a specified delimiter and place the data into variables for later manipulation. For example, suppose you want to read in the same X, Y, and Z values listed above. The values should be in a single line of text like this: 2.5,4.3,6.1. You can separate the text at the comma and place those values into corresponding variables using a line of code similar to the following:

V1=FILE/READLINE,FPTR,{ValX}+","+{ValY}+","+{ValZ}

You can then use ValX, ValY, and ValZ as normal variables in your part program. ValX will contain 2.5, ValY will contain 4.3, and ValZ will contain 6.1.


Using the File I/O Dialog Box

All file I/O commands are initially inserted into the part program by selecting the appropriate file I/O menu option (select Insert | File I/O Command). Once a command exists in the Edit window, you can then press F9 on the command to access its associated File I/O dialog box.

A sample File I/O dialog box

This dialog box simply provides a visual way to edit the current file I/O command. Alternately, you can modify a command inside the Edit window by using the techniques discussed in the ”Using the Edit Window” section.

You should not use this dialog box to insert new file I/O commands. That must be done by selecting the appropriate menu option or by typing the commands directly into the Edit window.


Opening a File for Reading or Writing

Display Menu Roadmap

The Insert | File I/O Command | File Open menu option allows you to put a command in the Edit window that will open a disk file during execution of the part program.

Files can be opened simply to view information or to add and save information.

The syntax of this command in the Edit window is:

<filepointername> =File/Open,<filename>,<openmode>

<filepointername> | This is the user chosen ID of the filepointer that is used to access the opened file. This ID is used to refer to the open file in other file I / O commands.
<filename> | This is the filename of the disk file to open.
<openmode> | This is the mode the file should be opened in. Files can be opened in the following modes : Read, Write, or Append.

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Place your cursor on the File Open command.

  3. Press F9.

More:

Sample Code for File Open


Sample Code for File Open

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

This code opens a file named TEST.TXT for reading, writing, and appending and stores the file name to a file pointer named FPTR.

FPTR=FILE/OPEN,C:\PCDMISW\TEST.TXT,READ

FPTR=FILE/OPEN,C:\PCDMISW\TEST.TXT,WRITE

FPTR=FILE/OPEN,C:\PCDMISW\TEST.TXT,APPEND

Be aware that you can use an input comment to take the full pathway as an input and use it in a FILE/OPEN command. You can also do the same thing by using the FILE/DIALOG command. Consider these examples:

C1=COMMENT/INPUT,Type the full pathway and name of the file.

V1=FILE/DIALOG, CHOOSE A FILE TO OPEN

FPTR=FILE/OPEN,C1.INPUT,READ

FPTR=FILE/OPEN,V1,READ

See "Displaying a File Dialog Box".


Closing an Opened File after Reading or Writing

Display Menu Roadmap

The Insert | File I/O Command | File Close menu option allows you to insert a command in the Edit window that will close an opened file when the part program is executed. Closing files frees up resources used when files are open and commits any changes that have been made to the file to disk.

The syntax of this command in the Edit window is:

File/Close, <filepointername>,<closemode>

<filepointername> | This is the ID used to identify the file and is created when the file is opened.
<closemode> | This parameter has two options, KEEP or DELETE. Using KEEP, PC-DMIS simply closes the file defined in the file pointer. Using DELETE, PC-DMIS closes the file and then deletes it.

To access the dialog box associated with this File I / O command:

1. Open the Edit window.

2. Placing your cursor on the File Close command.

3. Press F9.

More:

Sample Code for File Close


Sample Code for File Close

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

This code simply closes the file assigned to the file pointer, FPTR:

FILE/CLOSE,FPTR,KEEP

This code, which uses the DELETE parameter, closes and deletes the file assigned to FPTR:

FILE/CLOSE,FPTR,DELETE


Reading a Character from a File

Display Menu Roadmap

The Insert | File I/O Command | Reading Commands | Read Character menu option places a command in the Edit window which reads a single character from the file specified by the filepointername field (see syntax below) and assigns that character to the variable specified in the variable name field.

The syntax of this command in the Edit window is:

<varname> = File/ReadCharacter,<filepointername>

<filepointername> | This is the ID used to open the file.
<varname> | This is the name of the variable that will hold that character

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the Read Character command.

  3. Press F9.

More:

Sample Code for Read Character


Sample Code for Read Character

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

Consider this example that reads in a line from a data file one character at a time until it encounters a space.

V1=FILE/EXISTS,test.txt

IF/V1<>0

COMMENT/OPER,Able to read from data file. Click OK to continue.

ASSIGN/V3 = ""

FPTR=FILE/OPEN,D:\Program Files\pcdmis35\test.txt,READ

DO/

V2=FILE/READ_CHARACTER,FPTR

ASSIGN/V3 = V3+V2

UNTIL/V2 == " "

FILE/CLOSE,FPTR

COMMENT/OPER,"The first word from a line of text from the file is: " + V3

END_IF/

ELSE/

COMMENT/OPER,Wasn't able to read from data file. Program will now quit.

GOTO/END

END_ELSE/

END=LABEL/

PROGRAM/END

Code Explanation

V1=FILE/EXISTS
This line checks to see if the specified file exists. The file must be placed in the directory where PC-DMIS resides for this code to work, otherwise the line containing the file must also contain the full pathway for the file. V1 receives the result of the file check. It's a non-zero value if it exists; 0 otherwise.

IF/V1<>0
This line takes the value of V1 and checks to see if it evaluates to a non-zero value. If so, then a comment appears signifying that it's ready to begin the read process. If equal to zero then the part program ends.

ASSIGN/V3 = ""
This line creates an empty string and assigns it to V3. The code uses this variable to build a string from the individual read in characters. If you don't create the empty string, then V3 has its default value of 0.

FPTR=FILE/OPEN
This line opens the specified file for reading and assigns it to the default file pointer FPTR.

DO
This line begins a DO / UNTIL loop. It bounds the FILE/READ_CHARACTER code so that characters are continually read in one at a time. The loop exits whenever it reads in a character space.

V2=FILE/READ_CHARACTER,FPTR
This line reads in a character from the open file tied to the file pointer, FPTR. The character is stored in the variable, V2.

ASSIGN/V3 = V3+V2
This line uses the empty V3 variable, concatenates the string V3 with V2, and then reassigns the value to V3. So, with subsequent runs of the DO/UNTIL loop, V3 will get one more character added to it.

UNTIL/V2 == " "
This line ends the DO / UNTIL loop once the FILE/READ_CHARACTER code encounters a space character from the opened file.

FILE/CLOSE,FPTR
This line closes the opened data file, thereby allowing it to be accessed by other system processes. The rest of the code finishes running and displays the first word from the data file in an operator comment.


Reading a Line from a File

Display Menu Roadmap

The Insert | File I/O Command | Reading Commands | Read Line menu option places a command in the Edit window that reads a line from the specified file during execution. This command sets the variable specified by the variable ID to 1 (true) or 0 (false) to indicate success (true) or failure (false) of the call. The expression required by this command can be used to delimit the line read in and to automatically fill up variables and references with data read in from the file. Information is read in from the input file up to the next carriage return character.

The syntax of this command in the Edit window is:

<varname> = File/ReadLine,<filepointername>,<expr>

<varname> | This is the name of the variable that will hold the result indicating success or failure of the ReadLine command. It returns "OK" or "EOF".
<filepointername> | This is the name specified for the file pointer when the file was opened.
<expr> | This is the destination variable(s) for the input data. Input data can be delimited by text to allow for ease in parsing incoming lines of data. Variables and feature references should be surrounded by curly brackets.

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the Read Line command.

  3. Press F9.

More:

Sample Code for Read Line


Sample Code for Read Line

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

Consider this example that reads in a line from a data file one line at a time until the FILE/READ_LINE command encounters an empty line. The part program then displays the resulting block of text and quits.

V1=FILE/EXISTS,test.txt

IF/V1<>0

COMMENT/OPER,Able to read from data file. Click OK to continue.

ASSIGN/V3 = ""

FPTR=FILE/OPEN,D:\Program Files\pcdmis35\test.txt,READ

DO/

V2=FILE/READLINE,FPTR,{LINE}

ASSIGN/V3 = V3 + LINE

COMMENT/OPER,"The current value of variable V3 is:

,V3

UNTIL/V2 == "EOF"

FILE/CLOSE,FPTR

COMMENT/OPER,"The block of text reads as follows: "

,V3

END_IF/

ELSE/

COMMENT/OPER,Wasn't able to read from data file. Program will now quit.

GOTO/END

END_ELSE/

END=LABEL/

PROGRAM/END

Code Explanation

Much of this code is similar to that explained in "Sample Code for Read Character". Only code unique to this example is listed here.

DO
This line begins a DO / UNTIL loop. It bounds the FILE/READ_LINE code so that the lines are continually read in one at a time. The loop exits when it reaches the end of the file.

V2=FILE/READLINE,FPTR,{LINE}
This line reads in all the text until it encounters a carriage return. Instead of storing the text in V2, like FILE/READ_CHARACTER would, however, this code acts differently.

  • V2 in this case returns two values: either "OK" or "EOF". "OK" if there's still a line to read in. "EOF" if the end of the file is reached.

  • The {LINE} code is a user entered variable that stores the actual text. It is enclosed in curly brackets to tell PC-DMIS it's a variable and not a part of any delimiting text. Without the curly brackets, PC-DMIS would look for a string of characters in the file called "LINE" and would return only the text after "LINE" and before the carriage return.

ASSIGN/V3 = V3+LINE
This line uses the empty V3 variable and concatenates the string V3 with LINE, and then reassigns the concatenated value to V3. So, with subsequent runs of the DO/UNTIL loop, V3 will get one more line added to it.

UNTIL/V2 == "EOF"
This line tests for the condition of the DO / UNTIL loop. Once the FILE/READLINE code encounters the end of file, the loop exits. Once the program flow exits the loop, the rest of the code finishes running and displays the entire block of code inside an operator comment.

Other Examples:
The command line:
Result = File/ReadLine,F1, "Part ID :" + {V1} would cause any text appearing in the read in line after the text "Part ID:" to be assigned to V1. The line would be read in from the file opened using F1 as the file pointer name. The result of the read (success or failure) would be stored in the variable Result.

The command lines:
File/ReadLine,F1, "Location:"+{VARX}+ ","+{VARY}+ ","+{VARZ}+ ","+{VARI}+ ","+{VARJ}+ ","+{VARK}
ASSIGN/CIR1.XYZ = MPOINT(VARX, VARY, VARZ)
ASSIGN/CIR1.IJK = MPOINT(VARI, VARJ, VARK)
would read in comma delimited text after the string "Location:" and store the values in the X, Y, Z, and I, J, K values of CIR1.

The command line:
File/ReadLine,F1, "Value # " + loopvar + " : " + {var2} would cause var2 to be filled with the text appearing after the colon. The loopvar variable in this example is not surrounded by curly brackets and as a result contributes to the delimiting text.

Sample Code Dealing with Numbers Containing Preceding Zeros

If the file you are reading contains lines of numbers, you will notice that PC-DMIS ignores preceding zero characters. For example, if your line contained a value of 005450, it would read this value strictly as a number and return the value of 5450, ignoring the two preceding zeros. You may or may not want this.

Suppose you have a text file created by an external barcode reader software and it contains these two lines of data:

290291143;582750;0010

291143;5827;0010

You could use some simple code like this to get the number values in-between the semi-colons:

ASSIGN/FIRST_VALUE=0

ASSIGN/SECOND_VALUE=0

ASSIGN/THIRD_VALUE=0

ASSIGN/LINENUM=1

FPTR =FILE/OPEN,D:\TEMP\CODES.TXT,READ

DO/

INLINE =FILE/READLINE,FPTR,{FIRST_VALUE}+";"+{SECOND_VALUE}+";"+{THIRD_VALUE}

COMMENT/OPER,NO,"LINE NUMBER: " + LINENUM

,"First Value: " + FIRST_VALUE

,"Second Value: " + SECOND_VALUE

,"Third Value: " + THIRD_VALUE

UNTIL/INLINE == "EOF"

FILE/CLOSE,FPTR,KEEP

While this will successfully parse the lines of text and return the number values, it will also remove any preceding zeros for any values it returns. So, the THIRD_VALUE variable would contain a value of 10, instead of 0010.

To keep the preceding zero values, you would need to treat the whole line as a string and instead use the INDEX, LEFT, and MID string functions to locate the positions of semi-colons in a line of text and obtain the number values:

FPTR =FILE/OPEN,D:\TEMP\CODES.TXT,READ

ASSIGN/LINENUM=1

DO/

LINESTATUS =FILE/READLINE,FPTR,{LINESTR}

ASSIGN/LINESTR=STR(LINESTR)

ASSIGN/FIRST_INDEX=INDEX (LINESTR,";")

ASSIGN/FIRST_VALUE=STR(LEFT(LINESTR,FIRST_INDEX-1))

ASSIGN/REMAINSTR=STR(MID(LINESTR,(FIRST_INDEX)))

ASSIGN/SECOND_INDEX=INDEX (REMAINSTR,";")

ASSIGN/SECOND_VALUE=STR(LEFT(REMAINSTR,SECOND_INDEX-1))

ASSIGN/THIRD_VALUE=STR(MID(REMAINSTR,SECOND_INDEX))

COMMENT/OPER,NO,"LINE NUMBER: " + LINENUM

,"First Value: " + FIRST_VALUE

,"Second Value: " + SECOND_VALUE

,"Third Value: " + THIRD_VALUE

ASSIGN/LINENUM=LINENUM+1

UNTIL/LINESTATUS == "EOF"

FILE/CLOSE,FPTR,KEEP

Explanation of Code

Much of this code is similar to what is explained above. Only code explanations unique to the mentioned string functions are listed here.

ASSIGN/FIRST_INDEX=INDEX (LINESTR,";")
This line locates the position of the first semi-colon in the line and assigns that to the FIRST_INDEX variable.

ASSIGN/FIRST_VALUE=STR(LEFT(LINESTR,FIRST_INDEX-1))
This line assigns the FIRST_VALUE variable the string of characters up to, but not including, the first semi-colon in the LINESTR variable. LINESTR contains the entire line of text.

ASSIGN/REMAINSTR=STR(MID(LINESTR,(FIRST_INDEX)))
This line assigns the REMAINSTR variable (standing for "remaining string") the string of left over characters starting from the FIRST_INDEX position (the position of the first semi-colon) until the end of the line.

ASSIGN/SECOND_INDEX=INDEX (REMAINSTR,";")
This searches inside the REMAINSTR variable for another semi-colon (the second semi colon in the line) and assigns the position to the SECOND_INDEX variable.

ASSIGN/SECOND_VALUE=STR(LEFT(REMAINSTR,SECOND_INDEX-1))
This line assigns the SECOND_VALUE variable the string of characters up to, but not including, the first semi colon in the REMAINSTR variable (the second semi-colon in the entire line).

ASSIGN/THIRD_VALUE=STR(MID(REMAINSTR,SECOND_INDEX))
This line assigns the THIRD_VALUE variable the string of characters starting from the SECOND_INDEX position, until the end of the line.


Reading a Block of Text from a File

Display Menu Roadmap

The Insert | File I/O Command | Reading Commands | Read Block menu option places a command in the Edit window that will read in a block of characters from an open file at execution time. The amount of characters read in is indicated by the size parameter.

The syntax of this command in the Edit window is:

<varname>=File/Read_Block,<fptrname>,<size>

<varname> | This is a variable id for the variable that receives the value indicating success or failure of the read block operation.
<fptrname> | This is the name specified for the file pointer when the file was opened.
<size> | This is the number of characters to read

To access the dialog box associated with this File I / O command:

1. Open the Edit window.

2. Placing your cursor on the Read Block command.

3. Press F9.

More:

Sample Code for Read Block


Sample Code for Read Block

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

Suppose you have various external data files that contain miscellaneous part data and the first few characters of each file designate what the file is for. You can use the File/Read_Block command to read only those first few characters before deciding to read in and process every line. Consider this code:

C3=COMMENT/INPUT,Please type the name of the

,file code to search for.

ASSIGN/BLOCKSIZE = LEN(C3.INPUT)

ASSIGN/FILECODE = C3.INPUT

DO/

C1=COMMENT/INPUT,Please type the full pathway,

,filename, and extension to the

,file you want to process.

,Type [Q] to quit.

IF/C1.INPUT== "Q" OR C1.INPUT=="q"

COMMENT/OPER,You've chosen to quit. Program now ending.

GOTO/END

END_IF/

V1=FILE/EXISTS,C1.INPUT

IF/V1<>0

COMMENT/OPER,"Data file [" + C1.INPUT + "] exists. Click OK to continue."

FPTR=FILE/OPEN,C1.INPUT,READ

V2=FILE/READ_BLOCK,FPTR,BLOCKSIZE

FILE/CLOSE,FPTR

IF/V2<>FILECODE

COMMENT/OPER,"The file's code of [" + V2 + "] doesn't match"

,"the FILECODE of [" + FILECODE + "]."

END_IF/

UNTIL/V2==FILECODE

COMMENT/OPER,"File [" + C1.INPUT + "] is a match."

,"The file's code of [" + V2 + "] matches"

,"the FILECODE of [" + FILECODE + "]."

COMMENT/OPER,Program then processes the file.

END_IF/

ELSE/

COMMENT/OPER,"Data file [" + C1.INPUT + "] doesn't exist. Please retry using an existing data file."

GOTO/END

END_ELSE/

END=LABEL/

PROGRAM/END

Code Explanation

Some of this code is similar to that explained in "Sample Code for Read Character"or in "Sample Code for Read Line".

Only explanations unique to this example are given here.

ASSIGN/BLOCKSIZE = LEN(C3.INPUT)
This line uses creates a user defined variable named BLOCKSIZE that contains an integer equal to the number of characters found in C3.INPUT. This will be used as the size of the block of characters to read in.

ASSIGN/FILECODE = C3.INPUT
This line creates the FILECODE variable and gives it the value of C3.INPUT.

C1=COMMENT/INPUT
This comment stores the full pathway entered by the user into the C1.INPUT variable.

V1=FILE/EXISTS,C1.INPUT
This line checks for the existence of the file name defined in the C1 comment.

DO/
This line begins a DO / UNTIL loop. It bounds the block of code that allows the user to specify a file to read from. It will continue looping until the text assigned to FILECODE variable matches the text read from the file.

V2=FILE/READ_BLOCK,FPTR,BLOCKSIZE
This line reads the amount of characters equal to the integer contained in the BLOCKSIZE variable. The text is then stored in V2 variable.

IF/V2<>FILECODE
This line begins an IF / END IF code block that tests to see if the text in the V2 variable matches the text stored in the FILECODE variable. If it does match, then the program continues running. Otherwise it displays a message saying the two codes don't match.

UNTIL/V2==FILECODE
This line checks the condition of the DO / UNTIL loop to see if the text in the V2 variable matches the text in the FILECODE variable. If the statement evaluates to false, the DO loop runs again, allowing the user to choose a different file name. If the statement evaluates to true, then the loop exits and the program displays a message saying it matches. PC-DMIS could then continue to read each line of data from the specified data file.


Reading Text up to a Delimiter

Display Menu Roadmap

The Insert | File I/O Command | Reading Commands | Read Up To menu option places a command in the Edit window that reads all text ‘up to’ one of the given delimiters from the specified file during execution. Any text read by this command is placed in the specified destination variable. The command stops reading text when PC-DMIS encounters the following:

  • Defined delimiters

  • Carriage returns

  • Line feed characters

If the end of the file is reached, the destination variable will be set to "EOF" (End of File).

The syntax of this command in the Edit window is:

<varname> = FILE/READ_UPTO,<fptrname>,<delimiters>

<varname> | This is the name of the destination variable.
<fptrname> | This is the name specified for the file pointer when the file was opened.
<delimiters> | This is a string which contains zero or more delimiter characters.

To access the dialog box associated with this File I / O command:

  1. Select the Edit Window to open the Edit window.

  2. Place your cursor on the FILE/READ command.

  3. Press F9. The File I/O dialog box opens.

Once the dialog box appears:

  1. Type the variable name that will receive the read in information into the Variable ID box.

  2. Type the file pointer name into the File Pointer ID box.

  3. Type the delimiter into the Text box (be sure and use quotation marks around your chosen delimiter).

  4. Click OK.

More:

Sample Code for Read Up To


Sample Code for Read Up To

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

Example: Suppose you have text file named "sample.txt" in your c:\temp directory which contains this information on the first line.

root:x:0:0:root:/root:/bin/bash

To use the Read Up To command on this file:

  1. Insert a FILE/OPEN command in the Edit window.

  2. Use a File Pointer Name of your choice to name your File Open command. This example uses "sample" as the file pointer name.

The File Open command should look something like this:

SAMPLE =FILE/OPEN,C:\TEMP\SAMPLE.TXT,READ

Now, using PC-DMIS Read Up To commands, define some variables that call different segments of data. This example uses the following variables looking for a ":" (without the quotation marks) as the delimiter.

USERNAME =FILE/READ_UPTO,SAMPLE,:

PASSWORD =FILE/READ_UPTO,SAMPLE,:

USER =FILE/READ_UPTO,SAMPLE,:

Thus, when PC-DMIS executes these lines, it sets

username = root

password = x

user = 0

To display this on screen during execution you can use an operator comment such as the one shown here:

COMMENT/OPER,The following text is read in from sample.txt

,Username:

,USERNAME

,Password:

,PASSWORD

,User:

,USER


Writing a Character to a File

Display Menu Roadmap

The Insert | File I/O Command | Writing Commands | Write Character menu option inserts a command into the Edit window that will cause a single character to be output to a disk file upon execution.

The syntax of this command in the Edit window is:

File/Write_Character,<fptrname>,<expr>

<fptrname> | This is the name of the file pointer specified when the file was opened.
<expr> | This is the character to be written to file. If the expression evaluates to more than one character, only the first character is written.

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the Write Character command.

  3. Press F9.

More:

Sample Code for Write Character


Sample Code for Write Character

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

Consider this code that writes a string provided by the user to a data file one character at a time.

C1=COMMENT/INPUT,Type the name of the file to write

,to (include the complete path).

FPTR=FILE/OPEN,C1.INPUT,WRITE

C2=COMMENT/INPUT,Type something to send to the file.

,This will send the string one character

,at a time.

ASSIGN/COUNT = 0

ASSIGN/LENGTH = LEN(C2.INPUT)

DO/

ASSIGN/WRITETHIS = MID(C2.INPUT,COUNT,1)

FILE/WRITE_CHARACTER,FPTR,WRITETHIS

ASSIGN/COUNT = COUNT + 1

UNTIL/COUNT == LENGTH

Code Explanation

Some of this code is similar to that explained in "Sample Code for Read Character" or in "Sample Code for Read Line".

Only explanations unique to this example are given here.

FPTR=FILE/OPEN,C1.INPUT,WRITE
This line opens the file specified in the C1 comment for writing, and assigns it to the file pointer, FPTR. All data in this file will get overwritten as long as the file pointer begins at the start of the data file.

ASSIGN/COUNT = 0
This line assigns a user defined variable COUNT a value of zero. This is used for looping purposes to print the string one character at a time.

ASSIGN/LENGTH = LEN(C2.INPUT)
This line uses the LEN( ) function to return the length of a string. This function takes one parameter, the string. It counts the number of characters in the string (including spaces) and returns an integer value of that amount. In this case the user defined variable, LENGTH holds this value.

DO/
This line begins a DO / UNTIL loop. Code between the DO and the UNTIL statements will be executed until the loop's condition evaluates to true.

ASSIGN/WRITETHIS = MID(C2.INPUT,COUNT,1)
This line creates a user defined variable called WRITETHIS and uses the MID( ) function to return a substring character from the C2.INPUT string and give it to WRITETHIS. MID( ) takes three parameters.

· Parameter 1: is the string from which to get values. In this case C2.INPUT is used.

· Parameter 2: is the position in the string to take the character from. The first character in a string would be position 0, the second position 1, the third position 2 and so forth. In this case, the variable COUNT is used.

· Parameter 3: is how many characters starting from the position of the second parameter to grab. In this case, the value of 1 is used (the sample only writes one character at a time, so there's no reason to get more).

FILE/WRITE_CHARACTER,FPTR,WRITETHIS
This line writes the character stored in the WRITETHIS variable to the file specified by the file pointer, FPTR.

ASSIGN/COUNT = COUNT + 1
This line takes the current COUNT value, increments it by one, and then places the new value back into COUNT.

UNTIL/COUNT == LENGTH
This line tests the condition of the DO / UNTIL loop. In this case, the loop will keep incrementing the COUNT variable until it has the same value as the LENGTH variable. Then the loop will exit, ending the program.


Writing a Line to a File

Display Menu Roadmap

The Insert | File I/O Command | Writing Commands | Write Line menu option inserts a command into the Edit window that will cause a line of text to be output to a disk file upon execution. Use expression syntax to output variables and part program information to file. A carriage return is automatically appended to the text written out.

The syntax of this command in the Edit window is:

File/WriteLine,<fptrname>,<expr>

<fptrname> | This is the name of the file reference specified when the file was opened.
<expr> | This is the text to be written to file. Expressions can be used in this field

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the Write Line command.

  3. Press F9.

More:

Sample Code for Write Line


Sample Code for Write Line

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

Suppose you want to export some measured XYZ values to a data file. The following code allows you to input a feature label and a data file and send the X,Y, and Z data for that feature to a data file.

C1=COMMENT/INPUT,Type the label of the feature.

,to use.

C2=COMMENT/INPUT,Type the name of the file to write

,to (include the complete path).

FPTR=FILE/OPEN,C2.INPUT,APPEND

ASSIGN/FEATNAME = C1.INPUT

ASSIGN/ALLVALS = FEATNAME.X + "," + FEATNAME.Y + "," + FEATNAME.Z

COMMENT/OPER,"Text to write is: " + ALLVALS

FILE/WRITELINE,FPTR,ALLVALS

FILE/CLOSE,FPTR

Code Explanation

Some of this code is similar to that explained in "Sample Code for Read Character" or in "Sample Code for Read Line".

Only explanations unique to this example are given here.

FPTR=FILE/OPEN,C2.INPUT,APPEND
This line opens the file specified in the C2 comment for appending, and assigns it to the file pointer, FPTR. If instead, you change APPEND to WRITE, then existing content in the data file will get overwritten.

ASSIGN/FEATNAME = C1.INPUT
This line assigns the string of the feature label from C1.INPUT to the user defined variable, FEATNAME.

ASSIGN/ALLVALS=FEATNAME.X+","+FEATNAME.Y+","+ FEATNAME.Z
This line gives the user defined variable ALLVALS the value of FEATNAME.X,FEATNAME.Y,FEATNAME.Z, in other words it now holds the X, Y, and Z values of the feature label typed into the C1 input comment.

FILE/WRITELINE,FPTR,ALLVALS
This line writes the values contained in ALLVALS to the file specified by the file pointer, FPTR.


Writing a Block of Text to a File

Display Menu Roadmap

The Insert | File I/O Command | Writing Commands | Write Block menu option inserts a command into the Edit window that will cause a block of text to be output to a disk file upon execution. Use expression syntax to output the variables and part program information to file. Unlike the write line command, write block does not append a carriage return at the end.

The syntax of this command in the Edit window is:

File/WriteBlock,<fptrname>,<expr>

<fptrname> | This is the name of the file reference specified when the file was opened.
<expr> | This is the text to be written to file. Expressions can be used in this field.

Carriage Return and Line Feed: Unlike the write line command, write block does not append a carriage return at the end. However, if you need to place text on a new line inside your text block, you can insert a carriage return and line feed manually by using the CHR(10) code outside of your quoted string, as shown here in this example:

FILE/WRITEBLOCK,FPTR, "CHR(10) inserts text... " + CHR(10) + " ...on a new line."

This would yield this result inside your output file:

CHR(10) inserts text...
...on a new line.

Notice that if CHR(10) is inside the quotation marks the actual text of CHR(10) gets sent to the file.

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the Write Block command.

  3. Press F9.

More:

Sample Code for Write Block


Sample Code for Write Block

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

The following code writes whatever the user inputs into an input comment, appending a colon to be used as a delimiter.

C1=COMMENT/INPUT,Type any string. PC-DMIS will append a colon (for delimiter purposes) and write the string to a file of your choice

C2=COMMENT/INPUT,Type the name of the file to write

,to (include the complete path).

FPTR=FILE/OPEN,C2.INPUT,APPEND

ASSIGN/WRITETHIS = C1.INPUT + ":"

COMMENT/OPER,"Text to write is: " + WRITETHIS

FILE/WRITELINE,FPTR,WRITETHIS

FILE/CLOSE,FPTR

Code Explanation

Some of this code is similar to that explained in "Sample Code for Read Character" or in "Sample Code for Read Line".

Only explanations unique to this example are given here.

FPTR=FILE/OPEN,C2.INPUT,APPEND
This line opens the file specified in the C2 comment for appending, and assigns it to the file pointer, FPTR.

ASSIGN/WRITETHIS = C1.INPUT + ":"
This line appends a colon to the text contained in C1.INPUT and assigns the new string to the user defined variable, WRITETHIS.

FILE/WRITELINE,FPTR,WRITETHIS
This line writes the values contained in WRITETHIS to the file specified by the file pointer, FPTR. You can later read-in text from the file by using the colon as a delimiter.


Positioning a File Pointer at the Beginning of a File

Display Menu Roadmap

The Insert | File I/O Command | Position Commands | Rewind To Start menu option inserts a command into the Edit window that will position the file pointer to the beginning of the file stream.

The syntax of this command in the Edit window is:

File/Rewind,<fptrname>

<fptrname>

This is the name of the file pointer to reposition at the beginning of the file.

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the Rewind to Start command.

  3. Press F9.

More:

Sample Code for Rewind to Start


Sample Code for Rewind to Start

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

Consider this example that reads in data from an external file one line at a time. After each line, you have the option of starting over and reading from the beginning of the file. This illustrates the use of the FILE/REWIND command.

C1=COMMENT/INPUT,Please type a file to read from.

,(include the full path)

V1=FILE/EXISTS,C1.INPUT

IF/V1<>0

DO/

FPTR=FILE/OPEN,C1.INPUT,READ

C2=COMMENT/YESNO,Do you want to read from the beginning?

IF/C2.INPUT == "YES"

FILE/REWIND,FPTR

END_IF/

V2=FILE/READLINE,FPTR,{LINE}

COMMENT/OPER,"The current line is: " + LINE

UNTIL/V2=="EOF"

END_IF/

FILE/CLOSE,FPTR

COMMENT/OPER,Program quitting.

Code Explanation

Some of this code is similar to that explained in "Sample Code for Read Character"or in "Sample Code for Read Line".

Only explanations unique to this example are given here.

C2=COMMENT/YESNO
This line asks if you want to start reading the file from the beginning. It stores the YES/NO response into the variable, C2.INPUT.

IF/C2.INPUT == "YES"
This line begins an IF / END IF block. It tests the condition of C2.INPUT having the value of YES. If the condition is true, then PC-DMIS executes the lines following the IF statement. If the condition is false, then PC-DMIS executes the code following the END_IF statement.

FILE/REWIND,FPTR
This line rewinds the file pointer to the beginning of the data file.

END_IF/
This line quits the IF / END IF code block.


Saving a File Pointer's Current Position

Display Menu Roadmap

The Insert | File I/O Command | Position Commands | Save File Position menu option inserts a command into the Edit window that saves the current position of a file pointer within the file stream. The saved position can later be recalled using the recall file position command.

The syntax of this command in the Edit window is:

File/SavePosition,<fptrname>

<fptrname>

This is the name of the file pointer whose file position is saved.

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the Save File Position command.

  3. Press F9.

More:

Sample Code for Save File Position


Sample Code for Save File Position

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

Consider this example that reads in data from an external file one line at a time. After each line, you have the option of saving the file position for later recall. This illustrates the use of the FILE/SAVE_POSITION command.

C1=COMMENT/INPUT,Please type a file to read from.

,(include the full path)

V1=FILE/EXISTS,C1.INPUT

IF/V1<>0

DO/

FPTR=FILE/OPEN,C1.INPUT,READ

C2=COMMENT/YESNO,Do you want to save the file position and recall it later? The loop will quit.

IF/C2.INPUT == "YES"

FILE/SAVE_POSITION,FPTR

GOTO/QUITLOOP

END_IF/

V2=FILE/READLINE,FPTR,{LINE}

COMMENT/OPER,"The current line is: " + LINE

UNTIL/V2=="EOF"

END_IF/

FILE/CLOSE,FPTR

QUITLOOP=LABEL/

COMMENT/OPER,You've stopped reading.

PROGRAM/END

Code Explanation

This code is similar to that explained in "Sample Code for Rewind to Start".

Only explanations unique to this example are given here.

C2=COMMENT/YESNO
This line asks if you want to store the current file position and exit the loop. It stores the YES/NO response into the variable, C2.INPUT.

FILE/SAVE_POSITION,FPTR
This line stores the file pointer's position in the file stream.

As long as you open the same file with same file pointer name in the same part program, you can recall a stored file position and continue reading where you left off. To continue this example, see the "Sample Code for Recall File Position" topic.


Recalling a Saved File Pointer's Position

Display Menu Roadmap

The Insert | File I/O Command | Position Commands | Recall File Position inserts a command into the Edit window that will recall a previously saved file position. Use the save file position command to save a position within an open file.

The syntax of this command in the Edit window is:

File/RecallPosition, <fptrname>

<fptrname>

This is the name of the file pointer whose position is being recalled.

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the Recall File Position command.

  3. Press F9.

More:

Sample Code for Recall File Position


Sample Code for Recall File Position

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

This example opens a previously closed file, uses a previous file pointer, and recalls the stored file pointer's saved position. It then reads in data from that position. This code illustrates the use of the FILE/RECALL_POSITION command, and it continues the code sample given in the "Sample Code for Save File Position" topic.

COMMENT/OPER,The program will now recall the stored file position.

FPTR=FILE/OPEN,C1.INPUT,READ

FILE/REWIND,FPTR

COMMENT/OPER,To test, file has been rewound.

,The first line will be read in to test the rewind.

V3=FILE/READLINE,FPTR,{LINE}

COMMENT/OPER,The first line is:

,LINE

FILE/REWIND,FPTR

FILE/RECALL_POSITION,FPTR

COMMENT/OPER,Previously stored file position has been recalled.

,Data on the line at the stored position will now print.

V4=FILE/READLINE,FPTR,{STORED}

COMMENT/OPER,The text at the stored position is:

,STORED

Code Explanation

This code is similar to that explained in "Sample Code for Rewind to Start".

Only explanations unique to this example are given here.

FILE/RECALL_POSITION,FPTR
This line recalls the stored file pointer position in the file stream for the file pointer designated as FPTR.

V4=FILE/READLINE,FPTR,{STORED}
This line reads in the next line after the stored file pointer position and assigns it to the user defined variable of STORED. This variable is then printed out in the next operator comment.


Copying a File

Display Menu Roadmap

The Insert | File I/O Command | File Copy menu option inserts a command into the Edit window which will cause a file copy operation to occur upon execution.

The syntax of this command in the Edit window is:

File/Copy,<srcfilename>,<destfilename>,<replacemode>

<srcfilename> | This is the name of the source file (file copied from)
<destfilename> | This is the name of the destination file (file copied to)
<replacemode> | This is the action to take if the destination file already exists. The two modes are overwrite and fail if destination exists.

To access the dialog box associated with this File I / O command:

1. Open the Edit window.

2. Placing your cursor on the File Copy command.

3. Press F9.

More:

Sample Code for File Copy


Sample Code for File Copy

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

The following code asks for a file name to copy and for a destination directory and file to copy to.

C1=COMMENT/INPUT,Please type a file you want to copy.

,(Include full file path)

C2=COMMENT/INPUT,Please type a destination file name.

,(Include full file path)

V1=FILE/EXISTS,C1.INPUT

IF/V1<>0

COMMENT/OPER,File exists to copy. Copying commencing.

FILE/COPY,C1.INPUT,C2.INPUT,FAIL_IF_DEST_EXISTS

V2=FILE/EXISTS,C2.INPUT

IF/V2==0

COMMENT/OPER,"File doesn't exist at: " + C2.INPUT

,Copy ending.

PROGRAM/END

END_IF/

ELSE/

COMMENT/OPER,File copy successful.

PROGRAM/END

END_ELSE/

END_IF/

COMMENT/OPER,File to copy doesn't exist.

Code Explanation

Much of this code is similar to that explained in "Sample Code for Read Character"or in "Sample Code for Read Line".

Only explanations unique to this example are given here.

C1=COMMENT/INPUT
This line takes the full pathway of the file to copy and places it into the C1.INPUT variable .

C2=COMMENT/INPUT
This line takes the full pathway of the destination file and places it into the C2.INPUT variable

FILE/COPY,C1.INPUT,C2.INPUT,FAIL_IF_DEST_EXISTS
This line copies the original file to a destination file. This command takes three parameters.

  • Parameter 1 is C1.INPUT. This is the full path to the file to copy.

  • Parameter 2 is C2.INPUT, or the full path to the destination file.

  • Parameter 3, in this case, aborts the FILE/COPY procedure if it encounters an existing file with the same destination filename. You can set this so that it overwrites existing files of the same name.


Moving a File

Display Menu Roadmap

The Insert | File I/O Command | File Move menu option inserts a command into the Edit window which will cause a file move operation to occur upon execution.

The syntax of this command in the Edit window is:

File/Move,<oldfilename>,<newfilename>

<oldfilename> | This is the location and name of the file
<newfilename> | This is the new location and name of the file

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the File Move command.

  3. Press F9.

More:

Sample Code for File Move


Sample Code for File Move

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

The following code asks for a file name to move and a location directory and file name to move to and then performs the file move operation.

C1=COMMENT/INPUT,Please type a file you want to move.

,(Include full file path)

C2=COMMENT/INPUT,Please type a destination file name.

,(Include full file path)

V1=FILE/EXISTS,C1.INPUT

IF/V1<>0

COMMENT/OPER,File exists to move. File move commencing.

FILE/MOVE,C1.INPUT,C2.INPUT

V2=FILE/EXISTS,C2.INPUT

IF/V2==0

COMMENT/OPER,"File doesn't exist at: " + C2.INPUT

,The MOVE didn't function properly.

PROGRAM/END

END_IF/

ELSE/

COMMENT/OPER,File MOVE successful.

PROGRAM/END

END_ELSE/

END_IF/

COMMENT/OPER,Original file doesn't exist. Try again.

Code Explanation

Much of this code is similar to that explained in "Sample Code for File ".

Only explanations unique to this example are given here.

FILE/MOVE,C1.INPUT,C2.INPUT
This line copies the original file to a destination file. This command takes two parameters.

· Parameter 1 is C1.INPUT. This is the full path to the file to move.

· Parameter 2 is C2.INPUT, or the full path to the destination file.


Deleting a File

Display Menu Roadmap

The Insert | File I/O Command | File Delete menu option inserts a command into the Edit window which will cause a file to be deleted when the command is executed.

The syntax of this command in the Edit window is:

File/Delete,<filename>

<filename>

This is the name of the file to be deleted.

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the File Delete command.

  3. Press F9.

More:

Sample Code for File Delete


Sample Code for File Delete

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

The following code asks for a file name and then deletes the file.

C1=COMMENT/INPUT,Please type a file you want to delete.

,(Include full file path)

V1=FILE/EXISTS,C1.INPUT

IF/V1<>0

COMMENT/OPER,File exists. Ready to delete.

FILE/DELETE,C1.INPUT

V2=FILE/EXISTS,

IF/V2==0

COMMENT/OPER,File deleted successfully

PROGRAM/END

END_IF/

ELSE/

COMMENT/OPER,File still exists

PROGRAM/END

END_ELSE/

END_IF/

COMMENT/OPER,File doesn't exist to delete. Choose a file that exists.

Code Explanation

Much of this code is similar to that explained in "Sample Code for File Move ".

Only explanations unique to this example are given here.

FILE/DELETE,C1.INPUT
This line deletes the file specified. This command takes one parameter, the name of the file to delete. In this case, C1.INPUT.


Checking for a File's Existence

Display Menu Roadmap

The Insert | File I/O Command | File Exists menu option inserts a command into the Edit window which will check for the existence of a file when executed and will set the supplied variable with the result.

The syntax of this command in the Edit window is:

<varname> = File/Exists,<filename>

<filename> | This is the name of the file being checked to see if it exists on disk
<varname> | This is the name of the variable that is set to the result of the check that is performed. The variable will be set to 1 if the file exists and 0 if the file does not exist.

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the File Exists command.

  3. Press F9.

More:

Sample Code for File Exists


Sample Code for File Exists

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

The following code asks for a file name and then checks for the file's existence.

C1=COMMENT/INPUT,Please type a file you want to check.

V1=FILE/EXISTS,C1.INPUT

IF/V1<>0

COMMENT/OPER,File exists.

END_IF/

ELSE/

COMMENT/OPER,File doesn't exist

END_ELSE/

Code Explanation

Much of this code is similar to that explained in "Sample Code for Read Character" or in "Sample Code for Read Line".

Only explanations unique to this example are given here.

V1=FILE/EXISTS,C1.INPUT
This line checks to see if the specified file exists. The file must be placed in the directory where PC-DMIS resides for this code to work, otherwise the line containing the file must also contain the full pathway for the file. V1 receives the result of the file check. It's a non-zero value if it exists; 0 otherwise.


Displaying a File Dialog Box

Display Menu Roadmap

The Insert | File I/O Command | File Dialog menu option inserts a command into the Edit window which will check bring up a file dialog box during execution. This file dialog can be used to allow the part program operator to choose a filename at run time. The name of the file chosen will be stored in the variable specified.

The syntax of this command in the Edit window is:

<varname> = File/Dialog,<expr>

<varname> | This is the name of the variable that will be set to the name of the file chosen by the user in the file dialog.
<expr> | This is the text that will appear on the title bar of the file dialog

To access the dialog box associated with this File I / O command:

  1. Open the Edit window.

  2. Placing your cursor on the File Dialog command.

  3. Press F9.

More:

Sample Code for File Dialog


Sample Code for File Dialog

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

The following code submits a dialog box that allows you to choose a file to delete.

V1=FILE/DIALOG,Choose a file to delete.

V2=FILE/EXISTS,V1

IF/V2<>0

COMMENT/OPER,File exists. Ready to delete.

FILE/DELETE,V1

V3=FILE/EXISTS,

IF/V3==0

COMMENT/OPER,File deleted successfully

PROGRAM/END

END_IF/

ELSE/

COMMENT/OPER,File still exists

PROGRAM/END

END_ELSE/

END_IF/

COMMENT/OPER,File doesn't exist to delete. Choose a file that exists.

Much of this code is similar to that explained in "Sample Code for Read Character" or in "Sample Code for Read Line".

Only explanations unique to this example are given here.

V1=FILE/Dialog,Choose a file to delete
This line displays a dialog box with the title "Choose a file to delete". You can browse to a file and when you click Open, PC-DMIS gives V1 the full pathway to the selected file. The rest of the program deletes the selected file.


Checking for the End of a File or the End of a Line

PC-DMIS allows you to check for the End of a File by using the functions EOF or EOL in a conditional test.

EOF stands for END OF FILE. This function takes a file pointer of type string. When properly placed within a conditional statement, it tests to see if the file pointer has reached the end of the specified file. If it has, then the function returns true.

EOL stands for END OF LINE. This function takes a file pointer of type string. When properly placed within a conditional statement, it tests to see if the file pointer has reached the end of a line in the specified file. If it has, then the function returns true. This works best inside of a loop.

The syntax of this command in the Edit window is:

EOF(<filepointer>) or EOL(<filepointer>)

<filepointer>

This is the name of the file pointer that you're checking.

More:

Sample code for EOF and EOL


Sample code for EOF and EOL

The sample code below should be entered inside the Edit window's Command Mode, not inside the File I/O dialog box.

The following code opens test.txt and reads through the file. As long as the end of file hasn't been reached (designated with the code, WHILE/!EOF), PC-DMIS reads through the file character by character, assigning a character to V1.

If PC-DMIS reaches the end of a line in the file, PC-DMIS shows the last character on that line.

This repeats until PC-DMIS reaches the end of the file. PC-DMIS then shows the text "End of File Reached…".

FPTR=FILE/OPEN,D:\temp\test.txt,READ

WHILE/!EOF("FPTR")

V1=FILE/READ_CHARACTER,FPTR

IF/EOL("FPTR")

COMMENT/OPER,NO,"End of Line Reached. The last character is:"

,V1

END_IF/

END_WHILE/

COMMENT/OPER,NO,"End of File Reached..."


Using Expressions and Variables

Using Expressions and Variables: Introduction

Using Expressions in a Part Program

Creating Expressions with the Expression Builder

Using Variables with Expressions

Understanding Expression Components

Accessing a Report's Object Properties


Using Expressions and Variables: Introduction

An expression is a user defined condition used with PC-DMIS's flow control commands. Using flow control statements you can then test these conditions in your part program and if the condition is met or not, you can determine what action PC-DMIS takes.

Expressions are an important to making PC-DMIS accomplish your specific tasks. Using expressions in conjunction with flow control commands, you can unleash even more of PC-DMIS's powerful functionality.

This section explains what how to create and use expressions inside PC-DMIS's Edit window. When working with expressions, you should place PC-DMIS's Edit window into Command mode. This will allow you to view the Edit window code directly.

The following major topics are covered in this section:

  • Using Expressions in a Part Program

  • Creating Expressions with the Expression Builder

  • Using Variables with Expressions

  • Understanding Expression Components

  • Accessing a Report's Object Properties


Using Expressions in a Part Program

The PC-DMIS Edit window allows expressions in most of its editable fields. Editable fields are usually those fields highlighted in yellow when you press TAB inside the Edit window while in Command mode. Fields that change the type of the feature do not allow expressions.

Example: The box of an auto feature which specifies the type of the auto feature; i.e. Surface point, Auto Circle, Auto Round Slot, etc.; does not allow expressions.

The subtopics under this topic offer a complete reference to available expressions.

More:

Viewing Expression Values

Keeping Expression Values Only

Using Expressions with Branching

Using Expressions with File Input / Output


Viewing Expression Values

To see the value of an expression, position the mouse cursor over the expression and leave it in position for at least one second. The expression will be evaluated and a small yellow pop up window displaying the expression and its current value will appear just below the mouse cursor.


Keeping Expression Values Only

To immediately solve an expression in the Edit window, thus keeping only the value:

  1. Select the expression text in the Edit window.

  2. Precede the expression text with a ` (accent grave) character.

Example: Suppose you type the expression " `1/7 " in a numeric field. The expression will be immediately solved and only the value (0.143) will be placed in the field.


Using Expressions with Branching

The flow control commands use expressions to determine flow of program execution. Please refer to the "Branching by Using Flow Control" section for information on when branching may or may not occur.


Using Expressions with File Input / Output

Writing data to an external data file or reading data from an external data file often uses variables and other expressions to effectively manage and store or display that data. Please refer to the "Using File Input / Output" section for more information.


Creating Expressions with the Expression Builder

Expression Builder dialog box

PC-DMIS allows you to create and add expressions into the Edit window by simply typing them in or by using the friendlier interface of the Expression Builder dialog box. The Edit | Expression menu option displays the Expression Builder dialog box.

Display Menu Roadmap

This dialog box allows you to create an expression and insert it into an editable field. Pressing the F2 key while the cursor is on a field that allows expressions will also bring up the Expression Builder dialog box.

The Expressions Builder dialog lists all of the types of operators and functions available for expressions.

More:

Creating an Expression by Typing

C reating an Expression with the Expression Builder

Expression Element Type

ID

Extension

Second Extension

Add Button

Edit box

Description Area

Checking the Expression for Correctness


Creating an Expression by Typing

To create an expression by typing it directly to the Edit window:

  1. Open the Edit window.

  2. Place the Edit window into command mode.

  3. Press TAB to move your cursor to an editable field where you want to insert the expression. Fields with a yellow highlight are considered "editable".

  4. Type the expression.


Creating an Expression with the Expression Builder

To enter an expression by using the Expression Builder dialog box:

  1. Open the Edit window.

  2. Place the Edit window into command mode.

  3. Move the cursor to an editable field where you want to insert the expression.

  4. Press the F2 key while the cursor is on a field that allows expressions. The Expression Builder dialog box will appear. The Expression Builder dialog box lists all of the types of operators, operands, and functions. The following can be referenced through this dialog box:

  • Available expression types

  • Variables

  • Features

  • Dimensions

  • Alignments

  • Comments

  5. Select the expression element type from the first drop-down list. Depending on your selection, other combo boxes will appear.

  6. Select the desired ID from the ID drop-down list.

  7. Select an extension from the Extension drop-down list.

  8. Select another extension from the Second Extension drop-down list. If the expression is usable, the Add button becomes available.

  9. Click the Add button. The expression appears in an edit box.

  10. Click the OK button. The expression now appears where your cursor is in the Edit window.

Note: You can also open the Expression Builder dialog box from these other dialog boxes:

The If Expression dialog box - Select Insert | Flow Control | If Goto. Click on the Expression button.

The Assignment dialog box - Select Insert | Assignment. Click the Assign To or Assign From button.

Once the expression is created, PC-DMIS automatically inserts the expression at the next legal position in the Edit window.


Checking the Expression for Correctness

When your cursor leaves the field where you added the expression, PC-DMIS attempts to check the expression for correctness. If there is a problem with the expression, an error message indicating an invalid number may appear, or the expression text may turn red. Also, expressions that refer to non-existent objects will show up in red text.

Since the test of expression correctness occurs at the time you leave a field, a field that turned red due to a reference of a nonexistent object, (ex. CIRCLE1.X), will remain red even if the new object, (ex. CIRCLE1), is added. The field remains red until the expression is re-tested for correctness.

To re-test the expression for correctness:

  1. Move your cursor to the field of the expression.

  2. Press the F2 key. The Expression Builder dialog box opens again. Any changes to your expression appear in the edit box.

  3. Press the ENTER key to close the dialog box.


Expression Element Type

The Expression Element Type drop-down list in the Expression Builder dialog box lists the various expression element types available to be placed into expressions. These include:

  • Functions

  • Operators

  • Alignments

  • Comments

  • Dimensions

  • Features

  • Variables


ID

The ID drop-down list of the Expression Builder dialog box lists the set of items available based on the expression element type selected in the Expression Element Type drop-down list.

For Example:

  • When Functions & Operators is chosen from the Expression Element Type drop-down list the ID drop-down list will contain a list of the available functions and operators.

  • When Features is chosen in the Expression Element Type drop-down list, the ID drop-down list displays the IDs of the features in the part program.


Extension

The Extension drop-down list becomes available when the item chosen in ID drop-down list requires the addition of an extension in order to form a useable expression element. The Extension drop-down list displays available extensions based on the item selected in the ID drop-down list.

Example: Suppose you select a feature from the ID drop-down list. The list of possible extensions that can be used to reference data of that feature (such as "X", "Y", "Z", "Diam", "Length", etc.) are then listed in the Extension drop-down list.


Second Extension

The Second Extension drop-down list becomes available only if the item chosen in the Extension drop-down list requires the addition of a second extension in order to form a useable expression element.

Example: Suppose you are referencing the nominal value of the X location axis of a dimension named "D1".

You would:
Choose D1 from the ID drop-down list.
Select X from the Extension drop-down list
Select Nom from the Second Extension drop-down list.


Add Button

Whenever you select a useable or complete expression element using the drop-down lists, the Add button becomes available. When clicked this button displays the text to be added to the expression.

For example, if the following were chosen:

  • Dimensions from the Expression Element Type list

  • D1 from the ID list

  • X from the Extension list

  • Nom from the Second Extension list

Then the Add button would become enabled and would have the following text: Add D1.X.NOM.

Upon clicking the Add button, the text then appears in the edit box at the bottom of the dialog box.

Note: When you click the OK button, the text from the edit box is added to the Edit window, to the expression field where your cursor is. If you select an item from the Edit window's expression field, and the text to be added contains parenthesis, then the selected item would be placed inside of the parenthesis of the added text.


Edit box

At the bottom of the Expression Builder dialog box is an edit box showing the current expression. The expression can be typed directly to this box, or you can use the Add button.


Description Area

The Expression Builder dialog box also contains a Description area which gives information about items selected from the drop-down lists. A field next to the Add button also shows the current value of the expression.

Note: Invalid expressions have a value of 0.


Using Variables with Expressions

Variables are objects that hold values. Variables refer to integer, real, string, or point operands. Variables are essential to using expressions. A variable has a name and a value. The name is used to access the value of the variable. The name is constant, the value can be changed. You assign a value to a variable by using the ASSIGN/ command.

For example, the statement ASSIGN/V1 = 2 creates a variable with a name of V1 and a value of 2. ASSIGN/V2 = V1 + 2 accesses the value of V1. If V1 still had a value of 2 when this assign statement was executed, V2 would then have a value of 4.

For more information on variables, see "Variables".

More:

Assigning Values to Variables by Using the Assignment Dialog Box


Assigning Values to Variables by Using the Assignment Dialog Box

Assignment dialog box

Display Menu Roadmap

The Insert | Assignment menu option displays the Assignment dialog box. This dialog box allows you to assign a value to a variable or data element of a part program feature, dimension, or alignment. Use of the assignment command requires a basic understanding of PC-DMIS expressions.

More:

Assign To

A ssign From

Insert


Assign To

The Assign To button allows you to designate the variable that is receiving the value calculated in the Assign From box. Information chosen using the Assign To button is placed in the Assign To box. This value can be the name of a variable, or a reference to a data element of a feature, dimension, or alignment.


Assign From

The result of solving the mathematical expression for a value is what is meant by the term "evaluated".

The Assign From button allows you to place the value being assigned into the Assign From box. If this box contains an expression, the expression is evaluated at execution time and the result or value of the calculation is assigned to the object specified in the Assign To box.


Insert

The Insert button inserts an assignment command into the part program while keeping the Assignment dialog box open. This button allows you to insert a series of assignment commands without closing the dialog box.


Understanding Expression Components

Expressions have these types of operands :

  • Integers

  • Real Numbers

  • Strings

  • Points

  • Feature Pointers

  • Arrays

  • Functions

These are discussed in detail below.

More:

Operand Types

Literals

References

Variables

Structures

Pointers

Arrays

Operators for Expressions

Precedence

Functions

Operand Coercion

ID Expressions


Operand Types

The operands may exist in the form of:

  • Literals

  • References

  • Variables

  • Structures

  • Pointers


Literals

*Integers: 1, -6, 209

Reals: 1, -6, 2.4, -0.1, 345.6789

Strings: "Hello World", "47", "CIRCLE 1"

Points: A literal representation is not available for points. However, points can be made from other literals using the MPOINT function: MPOINT(0,0,1), MPOINT(2.2, 3.1, 4.0).

Pointer: The name of a feature enclosed in French brackets: {CIR1}, {LIN2}, {F3}

Arrays: A literal representation is not available for arrays. However, arrays can be created from other literals using the ARRAY function: ex. ARRAY(3, 5, 6), ARRAY("Hello", 2.3, 9). These functions create 3 element arrays with the integer elements 3, 5, and 6 in the first example and the string element "Hello", double element 2.3, and integer element 9 in the second example.

Functions: A literal representation is not available for functions. Functions are defined using the FUNCTION keyword and accessed via variable ids. For example, ASSIGN/Add2 = FUNCTION((X), X+2) defines a function that takes one argument and adds 2 to it. The variable Add2 is assigned the function. The function can be called using the variable Add2 as follows. ASSIGN/Result = Add2(5). Result is assigned the value 7.

Note: Numeric Literals are interpreted as real numbers unless the operator or function implies the use of integers. For example, the expression 10 / 8 evaluates to 1.25 instead of 1. Note also that discrete division is also possible via the operand coercion operators. The expression INT(10) / INT(8) does evaluate to 1.


References

References refer to data members of other objects in a part program. References use the ID of an object in the part program followed by a dot and an extension that refers to the data member of the object.

Example: If CIRCLE1 were the name of a measured circle in the part program, CIRCLE1.X would refer to the measured value of the X component of CIRCLE1. All references are evaluated in part coordinates relative to the current alignment.

More:

References of Type Double

References of Type Point

References of Type String


References of Type Double

The following reference expressions are available:

Valid Extensions for Feature References of Type Double by Example

Format: <Feature Id>.<Extension> -> CIRCLE1.X

CIRCLE1.X Measured X Value of CIRCLE1
CIRCLE1.Y Measured Y Value of CIRCLE1
CIRCLE1.Z Measured Z Value of CIRCLE1

CIRCLE1.TX Theoretical (Nominal) X Value of CIRCLE1
CIRCLE1.TY Theoretical (Nominal) Y Value of CIRCLE1
CIRCLE1.TZ Theoretical (Nominal) Z Value of CIRCLE1

LINE1.SX Measured X Value of the Startpoint of LINE1
LINE1.SY
LINE1.SZ

LINE1.TSX Theoretical X Value of the Startpoint of LINE1
LINE1.TSY
LINE1.TSZ

LINE1.EX Measured X Value of the Endpoint of LINE1
LINE1.EY
LINE1.EZ

LINE1.TEX Theoretical X Value of the Endpoint of LINE1
LINE1.TEY
LINE1.TEZ

POINT.I Measured I Component of Vector for POINT
POINT.J
POINT.K

POINT.TI Theoretical I Component of Vector for POINT
POINT.TJ
POINT.TK

FEAT1.TYP The type of the feature (i.e. circle, slot, cone). This can be used to change the type of a generic feature (Assign/ Gen1.TYP = Feat1.TYP).

FEAT1.ALL Refers to all elements of the feature. This is valuable for copying information to a generic feature. (Assign/ Gen1.ALL = Feat1.ALL)

Surface Vector

EDGE.SURFI

EDGE.SURFJ

EDGE.SURFK

EDGE.TSURFI

EDGE.TSURFJ

EDGE.TSURFK

Angle Vector

CIR.ANGI

CIR.ANGJ

CIR.ANGK

CIR.TANGI

CIR.TANGJ

CIR.TANGK

Radius

CIRCLE1.R

CIRCLE1.TR

CIRCLE1.RAD

CIRCLE1.TRAD

CIRCLE1.RADIUS

CIRCLE1.PR – Polar Radius

CIRCLE1.TPR – Theoretical Polar Radius

CIRCLE1.TRADIUS (Only the First Characters are significant)

Diameter

CIRCLE1.D

CIRCLE1.TD

CIRCLE1.DIAM

CIRCLE1.TDIAM

CIRCLE1.DIAMETER

CIRCLE1.TDIAMETER (Only the first characters are significant)

Angle

CONE.A

CONE.TA

CONE.ANG

CONE.TANG

CONE.ANGLE

CONE.TANGLE

CONE.PA – Polar Angle

CONE.TPA – Theoretical Polar Angle (Only the First Characters are significant)

Length

LINE.L

LINE.TL

LINE.LEN

LINE.TLEN

LINE.LENGTH

LINE.TLENGTH (Only the First Characters are significant)

Height

CYLINDER.PH – Polar Height

CYLINDER.TPH – Theoretical Polar Height

Radius, Angle, Height

POINT.RAH – Point with Measured Radius, Angle, and Height

POINT.TRAH – Point with Theoretical Radius, Angle, and Height

Valid Extensions for Dimension Reference of Type Double by Example

Format: <Dimension ID>.<AXIS>.<Dimension Element> -> DIM1.X.NOM

DIM1.X.NOM | The Nominal Value for X Axis Location of DIM1
DIM1.X.MEAS | The Measured Value for the X Axis Location of DIM1
DIM1.X.MAX | The Max Deviation for X Axis Location of DIM1
DIM1.X.MIN | The Min Deviation for X Axis Location of DIM1
DIM1.X.PTOL | The Plus Tolerance Value for the X Axis Location of DIM1
DIM1.X.MTOL | The Minus Tolerance Value for the X Axis Location of DIM1
DIM1.X.DEV | The Deviation on the X Axis Location of DIM1
DIM1.X.OUTTOL | The Out of Tolerance value on the X Axis Location of DIM1
DIM1.Y.NOM | The Nominal Value for the Y Axis Location of DIM1
DIM1.Z.DEV | The Deviation on the Z Axis Location of DIM1
DIM3.PA.MEAS | The Measured Value for the Polar Angle Location of DIM3
DIM4.M.PTOL | The Plus Tolerance Value for the M Axis of DIM4
*DIM4.PTOL | The Plus Tolerance Value for the M Axis of DIM4 (See Note under "Valid Axes " below).
DIM5.BTOL | The Bonus Tolerance Value where DIM5 is a True Position.

Valid Axes:

X, Y, Z, D, R, A, T, V, L, PR, PA, M, PD, RS, RT, S, H, DD, DF, TP

Note: * Dimensions that have only one axis by definition (i.e. roundness, concentricity, etc.) can omit the axis qualifier. If the axis qualifier is used, note that all of these types of dimensions (that have only one axis) use the M Axis qualifier with the exception of 2D and 3D angle dimensions, which use the A Axis qualifier.

Valid Extensions for Alignment References of Type Double by Example:

Format: <Alignment ID>.<Alignment Axis or Origin>.<Alignment Axis or Origin Component> -> A1.ORIGIN.X

A1.ORIGIN.X | X Component of alignment A1’s measured origin
A2.ORIGIN.Y | Y Component of alignment A2’s measured origin
A1.ORIGIN.Z | Z Component of alignment A1’s measured origin
A1.XAXIS.I | I Component of alignment A1’s measured X axis
A1.YAXIS.J | J Component of alignment A1’s measured Y axis
A1.ZAXIS.K | K Component of alignment A1’s measured Z axis
A1.CORIGIN.X | X Component of alignment A1’s origin based on theoretical (C is for CAD) data
A1.CXAXIS.J | J Component of alignment A1’s X axis based on theoretical (C is for CAD) data


References of Type Point

The following reference expressions are available:

Valid Extensions for Feature References of Type Point by Example

Format: <Feature ID>.<Extension> -> CIRCLE1.XYZ

CIRCLE1.XYZ | Measured centroid of CIRCLE1
CIRCLE1.TXYZ | Theoretical centroid of CIRCLE1
LINE1.SXYZ | Measured start point of LINE1
LINE1.TSXYZ | Theoretical start point of LINE1
LINE1.EXYZ | Measured end point of LINE1
LINE1.TEXYZ | Theoretical end point of LINE1
CIRCLE1.IJK | Measured Vector of CIRCLE1
CIRCLE1.TIJK | Theoretical Vector of CIRCLE1
EDGE.SURFIJK | Measured Surface Vector of EDGE
EDGE.TSURFIJK | Theoretical Surface Vector of EDGE
AUTOCIR1.ANGIJK | Measured Angle Vector of AUTOCIR1
AUTOCIR1.TANGIJK | Theoretical Angle Vector of AUTOCIR1

Valid Extensions for Alignment Reference of Type Point by Example

Format: <Alignment ID>.<Alignment Axis or Origin> -> A1.XAXIS

A1.ORIGIN | Measured origin of alignment A1
A1.XAXIS | Measured X axis of alignment A1
A1.YAXIS | Measured Y axis of alignment A1
A1.ZAXIS | Measured Z axis of alignment A1
A1.CORIGIN | Theoretical origin of alignment A1
A1.CXAXIS | Theoretical X axis of alignment A1
A1.CYAXIS | Theoretical Y axis of alignment A1
A1.CZAXIS | Theoretical Z axis of alignment A1


References of Type String

References to comments are the only object types that are of type string. Only INPUT comments or YES/NO comments can be referred to via references. These comment types have an ID which can be used to identify the comment.

Format: <Comment ID>.INPUT -> C1.INPUT

C1.INPUT - The input value (from the operator) for comment C1

YES/NO comment types set the input to the appropriate yes or no string based on the current language of PC-DMIS. In the English version of PC-DMIS if the operator presses the yes button, the string is set to "YES", if the operator presses the no button, the string is set to "NO". When comparing strings to test for "YES" or "NO", the comparison is case sensitive. Thus, comparing against "yes" or "no" will always fail even if the YES/NO comment input is set to "YES" or "NO".


Variables

Variables can be of any of the seven operand types: integer, real, string, point, feature pointer , array, or function. Variables come into existence and receive their value and type via the ASSIGN statement. The variable ID can be any alphanumeric string that does not begin with a numeric character. Underscores can also be used in the variable id provided that the underscore is not the first character.

Variable values are saved between execution runs. This means if program execution stops and re-starts, the values the variables have when execution stops will be the same values when execution starts again.

Note: If the Edit window is active, PC-DMIS will indicate the current value of the variable whenever the cursor is placed in the field. During execution, variable values will change based on flow of execution. Position the mouse pointer over the desired variable to find out its current value.

ASSIGN/ V1 = 2.2+2 | Variable V1 is a real number with the value of 4.2
ASSIGN/ VAR1 = CIRCLE1.X | Variable VAR1 is a real number with a value equal to the measured value of CIRCLE1.X at the time of assignment.
ASSIGN/ MYVAR = LINE1.XYZ | Variable MYVAR is a point with the same value of the measured centroid of LINE1 at the time of assignment.
ASSIGN/ SVAR = "Hello World" | Variable SVAR is a string with the value "Hello World"

In these examples, variables are being assigned values. Once a variable has been assigned a value, the variable can be used as an operand in any expression field.

Example of V1 being used in a numeric field:
ASSIGN/V1 = 1/3
PREHIT / V1

Here, V1 is used as the prehit value of the prehit command.

Note: Since expressions can be used in most editable fields, the following expression is also legal and has the same effect: PREHIT / 1/3.

The components of variables of type point can be referred to individually using the dot extension notation used for references.

ASSIGN/ V1 = MPOINT(3, 4, 5) | V1 is of type point with value of 3, 4, 5
ASSIGN/ XVAR = V1.X | XVAR is of type double with the value of 3
ASSIGN/ YVAR = V1.Y | YVAR is of type double with the value of 4
ASSIGN/ IVAR = V1.I | IVAR is of type double with the value of 3
ASSIGN/ REDUNVAR = V1.XYZ | REDUNVAR is of type point with the value of 3, 4, 5

The following extensions are equivalent to each other. Both are provided to clarify the meaning of an expression in a part program .

Given that V1 is of type point.

V1.X is the same as V1.I
V1.Y is the same as V1.J
V1.Z is the same as V1.K

V1.XYZ is the same as V1.IJK and V1 without any extension.

If a variable of type string has a string value equal to the name of the id of a feature, dimension, or alignment, the variable can be used as a reference object.

Example:
ASSIGN/ V1 = "CIRCLE1"

The following operands are possible and valid provided a feature with the name CIRCLE1 exists.

V1.X - The measured X value of CIRCLE1
V1.TX - The theoretical X value of CIRCLE1
V1.Diameter - The measured diameter of CIRCLE1
V1.Radius - The measured radius of CIRCLE1

This type of indirection available on string variables is only available to one level of indirection. The following will not work.

ASSIGN/ V1 = "CIRCLE1"
ASSIGN/ V2 = "V1"
V2.X - This will evaluate to 0 instead of the current measured value of CIRCLE1.X.

Note: The reference V2.X will not be flagged as an error with red text even though an expression above it sets its type to a string. The reason it cannot be flagged as an error is because the flow of execution of the part program is not known until execute time.

However, if you use curly brackets the following does work:

ASSIGN/ V1 = {CIRCLE1}
ASSIGN/ V2 = {V1}
V2.X - This will give you the value of CIRCLE1.X.

Consider the following example:

ASSIGN/ V1 = "CIRCLE1"
ASSIGN/ V2 = "V1"
IF / CIRCLE1.X > CIRCLE1.TX, GOTO, L2
L1 = LABEL /
ASSIGN/ V3 = V2.X
GOTO / LABEL, L3
L2 = LABEL /
ASSIGN/ V2 = MPOINT( 2, 5, 7)
GOTO / LABEL, L1
L3 = LABEL /

If during program execution the value of CIRCLE1.X is greater than the value of CIRCLE1.TX, then the expression V2.X will be valid and will evaluate to 2. Otherwise, the expression V2.X will evaluate to 0 since the value of V2 at the time of the ASSIGN for V3 is the string "V1". It is the responsibility of the part programmer to ensure that expressions will do as expected in these cases.

Additional note on the Assign Statement: Almost all of the feature references can be used on the left-hand side of the assignment statement to put a value into a measured or theoretical data member of a feature. The only exception is the single I, J, K components of vectors. To assign to vectors, the complete vector must be assigned at once using an expression that evaluates to a point. Vector data is normalized as it is input into the feature’s vector data members.

Example:

ASSIGN/ CIRCLE1.I = 2 - illegal
ASSIGN/ CIRCLE1.IJK = MPOINT(2, 0, 0)-legal (vector is normalized to 1, 0, 0)

For information on using variables within dimensions, see the "Dimensioning Variables" topic in the "Dimensioning Features" section.


Structures

With version 3.5 and later you can use a new variable type called structures. Structures allow you to place extensions on a variable to identify sub-element of that variable. Consider this example:

Example:

ASSIGN/V1.HEIGHT = 6
ASSIGN/V1.WIDTH = 4.3
ASSIGN/V1.MODE = "CIRCULAR"
ASSIGN/V1.POINT = MPOINT(100.3, 37.5, 63.1)

In this example,

· V1 is the structure.

· HEIGHT, WIDTH, MODE, and POINT are sub-elements of the structure.

More:

Rules for Structures

Structures with Variables of Type Point


Rules for Structures

  • Like Variables, Structures do not need to be declared.

  • Sub-elements of a structure can be any of these variable types:

q Integer

q Double

q Point

q Feature Pointer

q Function

q Array

q Structure

For example, it is possible to have structure elements that are arrays and array elements that are structures. This makes the following example expressions valid:

Example

ASSIGN/CAR.LEFTSIDE.DOOR[2].QUADRANT[3].JOINT[5].HIT [4] = MPOINT(558.89, 910.12, 42.45)

COMMENT/OPER,"Current Z Position: " + CAR.LEFTSIDE.DOOR[2].QUADRANT[3].JOINT[5].HIT[4].Z

ASSIGN/CURRENTJOINT = LEFTSIDE.DOOR[2].QUADRANT[3].JOINT[5]

COMMENT/OPER,"Next Hit: " + CURRENTJOINT.HIT[4]


Structures with Variables of Type Point

If a variable is of type point, the user can still use the .X, .Y, .Z, .I, .J, and .K extensions to get at individual items of the point. The user can also use any of the extensions from this example in their structures without being forced to use them as point elements .

Example:

ASSIGN/V1.X = "Some string"
ASSIGN/V1.Y = ARRAY(1,3,5,9,7)
ASSIGN/V1.Z = MPOINT(3,5,7)

COMMENT/REPT,V1.X | Output is "Some string"
COMMENT/REPT,V1.Y[2] | Output is 3, the second element of the array.
COMMENT/REPT,V1.Z.Y | Output is 5, the Y value of the MPOINT.

By combining structures with the function capability of the PC-DMIS expression language, it is possible to have dynamic structure references as shown here:

(example continued)

ASSIGN/DYNAMICSTRUCT = FUNCTION((X,Y), X.Y)
C1 =COMMENT/INPUT,Please enter in item
ASSIGN/TESTSTR = C1.INPUT
ASSIGN/FRONT = LEFT(TESTSTR, INDEX(TESTSTR, ".")-1)
ASSIGN/BACK = MID(TESTSTR, INDEX(TESTSTR, "."))
ASSIGN/RESULT = DYNAMICSTRUCT(FRONT, BACK)

This portion of the example asks you to input a variable reference, splits the reference at the first '.', and then assigns RESULT to be equal to that reference by using the function DYNAMICSTRUCT.

So, if from you had typed V1.Y[4] for the C1.INPUT variable, RESULT would end up with the value of 9 (the fourth element of the array assigned to V1.Y).

The learn time evaluation of expressions has been enhanced to accurately show all elements of a structure or an array.


Pointers

Pointers are also known as "Feature Pointers ". See the Glossary term "Feature Pointers" for more information.

Pointers provide a simple way to reference a feature via a variable or to pass objects using the call sub command. Pointers are similar to indirection via string names. However, the advantage of using pointers is with subroutines . Pointers, unlike strings, when passed in as arguments of a subroutine, allow for direct modification of the object pointed to by the subroutine. Pointers are not used in complex expressions . If it is used in a complex expression the pointer will evaluate to zero.

Consider the following examples:

Pointer Use Example:

ASSIGN/ V1 = {CIR1} | V1 is now a pointer that points to CIR1.
ASSIGN/ DIST = DOUBLE(V1.XYZ) | Dist = distance of CIR1 from origin.
You can also put an expression between curly brackets in order to obtain a feature pointer. In versions prior to version 3.5 this was invalid. Now the following examples are all legal ways to get the pointer to feature CIR1:
ASSIGN/FEATCOUNT = 1 ASSIGN/V1={"CIR" + FEATCOUNT} | Assigns expression "CIR1" to V1.
ASSIGN/V2="CIR1" ASSIGN/V3={V2} | Assigns expression "CIR1" from variable V2 to variable V3
C1=COMMENT/INPUT, Please type a feature name. ASSIGN/V4={C1.INPUT} | This takes the feature name of C1.INPUT and places it into variable, V4.

Subroutine Example:

In the calling program:

CS1 = CALLSUB/SUB.PRG,CHANGEX, {CIR1}

In the subroutine program

GEN1 = GENERIC/FEATURE
SUBROUTINE/CHANGEX, ARG1 = {GEN1}

(When CIR1 is passed in it takes the place of GEN1)

ARG1.X = 5

(Sets the measured X value of CIR1 to 5)

END/SUBROUTINE

Complex Expression Example:

ASSIGN/ V1 = {CIR1} + 2

{CIR1} evaluates to zero and so entire expression evaluates to 2.


Arrays

Three types of arrays are available: Feature arrays, hit arrays, and variable Arrays.

Important: Even though multi-dimensional arrays are displayed as multi-dimensional in the software, you can really only use them as single dimensional arrays until you precede the arrays with an ARRAY INDICES command (see the "Array Indices Object:" topic).

More:

Feature Arrays:

Array Indices Object:

Hit Arrays:

Variable Arrays:


Feature Arrays:

When a feature is measured more than once during program execution, a feature array is automatically created. The number of elements in the feature array is equal to the number of times the feature has been executed.

Example: If a measured circle object were located in a while loop that executed five times, then an array of five measured circles would exist. If the id of the measured circle were "Circle1", then an array expression could be used to access individual instances of the measured circle object. Square brackets are used to indicate the instance desired.

Assign/V1 = Circle1[3].x

V1 is assigned the measured x value of the third instance of Circle1.

Note: When a feature array exists for a given feature but array notation is not used in a reference to that feature. The most recent instance is used. From the above example, the reference Circle1.x would be the same as Circle1[5].x since the fifth instance would be the most recent instance of the object.

Expressions can be used within the square brackets of an array expression. Circle1[3].x and Circle1[2+1].x would therefore be equivalent. The following example uses a loop to print out the measured centroid of the five circles from the examples above.

Example:

Assign/V1 = 1
While/V1 < 6
Comment/Rept, "Centroid of instance #" + V1 + " of Circle1:  " + Circle1[V1].XYZ
Assign/V1 = V1 + 1
End/While

Possible output from the above example:

Centroid of instance #1 of Circle1: 3.4, 2.6, 1.43

Centroid of instance #2 of Circle1: 4.4, 3.6, 2.43

Centroid of instance #3 of Circle1: 5.4, 4.6, 3.43

Centroid of instance #4 of Circle1: 6.4, 5.6, 4.43

Centroid of instance #5 of Circle1: 7.5, 6.6, 5.43

Arrays also exist on dimensions and alignments that have been executed multiple times in a given execution run. Thus, Dim1[2].Nom and Align1[4].Origin would be available given that the Dimension "Dim1" has executed at least twice and the alignment "Align1" has executed at least four times.

If a feature array reference is out of bounds (i.e., the user asks for Circle1[2.5] or > Circle1["Hello, World"]) the upper or lower bound item is returned. If Circle1 had 3 instances, than Circle1[4] and above would return Circle1[3] and Circle[0] and below would return Circle1[1]. All expressions between square brackets are coerced to integer, thus 2.5 would become 2 and "Hello World" would become 0.


Array Indices Object:

Display Menu Roadmap

By default, feature arrays are always one-dimensional arrays. If it is more convenient to treat a feature array as a multi-dimensional array, this can be done by using the array indices object.

The array indices object allows you to specify upper and lower bounds for multiple array dimensions.

  • By setting the upper and lower bounds of the first dimension a two dimensional array is created where the first dimension is bound and the second dimension is unbound.

  • By setting the upper and lower bounds of the first two dimensions of an array, a three dimensional array is created. The last dimension is always unbound.

Example:

Feature F1 is located inside a nested WHILE loop. The inner WHILE loop executes five times and the outer WHILE loop executes three times. At completion of execution, F1 has been executed 15 times and so 15 instances of F1 exist.

Consider the following example part program segment:

ARRAY_INDICES/1..5,..
ASSIGN/V1 = 1
WHILE/V1<=3
ASSIGN/V2 = 1
WHILE/V2<=5
F1=FEAT/POINT,RECT
THEO/V2,V1,0,0,0,1
ACTL/1,1,0,0,0,1
MEAS/POINT,1
HIT/BASIC,V2,V1,0,0,0,1,1,1,0
ENDMEAS/
ASSIGN/V2 = V2+1
COMMENT/REPT,"Location of F1[" + V2 + "," + V1 + "] :" + F1[V2,V1].XYZ
END_WHILE/
ASSIGN/V1 = V1+1
END_WHILE/

This code segment creates a 3 X 5 grid of 15 measured points.

The array indices command has limited the first dimension of the feature array to be between 1 and 5 inclusively. Thus on the inspection report, instead of appearing as F1[1] – F1[15], the objects will appear as F1[1, 1] – F1[5, 3], more consistent with the layout of the features. Notice that the comment also refers to the feature array using a two dimensional array syntax.

To insert an array_indices object in a part program:

  1. Using the keyboard, type "Array" on an empty line in the Edit window.

  2. Press the TAB key.

Note: If the Display Brackets for Feature Arrays check box has been cleared, the feature will not appear with the bracketed name. See "Display Brackets for Feature Arrays" in the "Setting Your Preferences" section.


Hit Arrays:

The hits of a given feature are available as an array and can be accessed via expressions using array syntax of the form <FeatID>.Hit[<Array Expression>].<Extension> or the form <FeatID>.RawHit[<Array Expression>].<Extension>. Hit returns probe compensated data when probe compensation is on. RawHit always return uncompensated data. Valid extensions are X, Y, Z, I, J, K, TX, TY, TZ, TI, TJ, TK, XYZ, TXYZ, IJK, and TIJK

Circle1.Hit[1].XYZ | The measured centroid (probe compensated) of hit 1 of "Circle1".
Circle1.Hit[2].IJK | The measured vector of hit 2 of "Circle1"

Hit data is available for all objects that have hits, whether the actual hits are displayed in the edit window or not. Thus, hits can be obtained for scans and auto features.

The following topics describe some additional array functions that are useful for finding the minimum or maximum points in a scan:

Assigning a Range of Hits to an Array

You can also assign a range of hits to an array by using this syntax:

<Feature Id>.<Hittype>[<Startnum>..<Endnum>].<Extension>

where

<Feature Id> is the name of the feature

<Hittype> can be either the word "HIT" for compensated data or "RAWHIT" for uncompensated data. If probe compensation if turned off, the returns values are always uncompensated.

<Startnum> is an expression that identifies the first index value of the range of hits

<Endnum> is an expression that identifies the second index value of the range of hits

<Extension> identifies the type of data. Possible extensions include these measured or theoretical data types:

  • X – Measured X values of the hits

  • Y – Measured Y values of the hits

  • Z – Measured Z values of the hits

  • XYZ – Measured XYZ values of the hits

  • I – Measured I values of the hits

  • J – Measured J values of the hits

  • K – Measured K values of the hits

  • IJK – Measured IJK values of the hits

  • TX – Theoretical X values of the hits

  • TY – Theoretical Y values of the hits

  • TZ – Theoretical Z values of the hits

  • TXYZ – Theoretical XYZ values of the hits

  • TI – Theoretical I values of the hits

  • TJ – Theoretical J values of the hits

  • TK – Theoretical K values of the hits

  • TIJK – Theoretical IJK values of the hits

For example,

ASSIGN/V1 = SCAN1.HIT[1..10].X | V1 is assigned to an array of 10 values which are the measured X values from the first 10 hits of SCAN1.
ASSIGN/V2 = SCAN1.HIT[1..SCAN1.NUMHITS].XYZ | V2 is assigned to an array of points from each of the centroids of the hits in the scan.

Sorting Arrays

PC-DMIS allows you to sort arrays in either ascending or descending order. The following two expressions take an array and return a sorted array:

To sort in ascending order use:
SORTUP(<array>)

To sort in descending order use:
SORTDOWN(<array>)

For example,

ASSIGN/V1 = ARRAY(5,8,3,9,2,6,1,7) | V1 is assigned the array of "5,8,3,9,2,6,1,7"
ASSIGN/V2 = SORTUP(V1) | V2 will hold the array values sorted in ascending order: "1,2,3,5,6,7,8,9"
ASSIGN/V3 = SORTDOWN(V1) | V3 will hold the array values sorted in descending order: "9,8,7,6,5,3,2,1"

Returning the Greatest or Least Index Values from an Array:

You can input an array into a function and return the index number of the element that has the greatest or the least value by using these functions:

To return the index value of the element with the greatest value, use:
MAXINDEX(<array>)

To return the index value of the element with the least value, use:
MININDEX(<array>)

For example,

ASSIGN/V1 = ARRAY(5,8,3,9,2,6,1,7) | V1 is assigned the array of "5,8,3,9,2,6,1,7"
ASSIGN/V2 = MAXINDEX(V1) | V2 will hold the array's index value of 4. The actual value of that array element is 9
ASSIGN/V3 = MININDEX(V1) | V3 will hold the array's index value of 7. The actual value of that array element is 1

You can then use returned index values to get the actual array element value.

Returning Sorted Index Values from an Array

You can input an array into a function, sort the array's values in ascending or descending order and then return the index values by using these functions:

To return the array's index positions in order of their values sorted from greatest to least use:
MAXINDICES(<array>)

To return the array's index positions in order of their values sorted from least to greatest use:
MINIDICES(<array>)

For example,

ASSIGN/V1 = ARRAY(4,8,2,9,5,7) | V1 is assigned the array of "4,8,2,9,5,7"
ASSIGN/V2 = MAXINDICES(V1) | V2 will hold an array with these values: "4,2,6,5,1,3"
ASSIGN/V3 = MININDICES(V1) | V3 will hold an array with these values: "3,1,5,6,2,4"

Example of Using Array Functions to Find the Minimum and Maximum Points in a Scan

The main purpose of the hit array functions discussed above is to give you an easy way to find the minimum and maximum points in a scan.

To dimension the point from SCAN1 that has the greatest measured X value, you could use this expression:

ASSIGN/MAXPTINDEX = MAXINDEX(SCAN1.HIT[1..SCAN1.NUMHITS].X)

D1 = LOCATION OF FEATURE SCAN1.HIT[MAXPTINDEX]

To find the three highest points in the Z axis of SCAN2, you could use this expression:

ASSIGN/MI = MAXINDICES(SCAN2.HIT[1..SCAN2.NUMHITS].Z)

ASSIGN/THREEPOINTS = ARRAY(SCAN2.HIT[MI[1]].XYZ, SCAN2.HIT(MI[2]].XYZ, SCAN2.HIT[MI[3]].XYZ)


Variable Arrays:

Variable arrays do not need to be declared. Variable arrays come into existence via the assign statement when the expression on the right hand side of the assign statement evaluates to an array or when the left hand side of the assign statement refers to an element in a variable array.

Assign/V1 = Array(3, 4, 5, 6, 7) | Create 5 element array and assigns it to V1
Assign/V2 = V1[3] | Assigns V2 the value of the third element in array V1: 5
Assign/V1[4] = 23 | Assigns 4th element of array V1 to 23

Arrays are created and allocated dynamically. Thus an array can be created by using an array reference on the left hand side of an assign statement.

Assign/V3[5] = 8

Dynamically creates array with 5th element set equal to 8

When referencing an array element that has never received a value, the array expression will evaluate to 0.

Assign/V3[5] = 8 |
Assign/V4 = V3[5] | V4 is set equal to the value 8
Assign/V5 = V3[6] | If the sixth element of V3 has never been set, V5 is set equal to 0.

Like other array types, expressions can be used within the square brackets.

Assign/V3[5] = 8 |
Assign/V4 = V3[2+3] | V4 is set equal to the value 8

Variable arrays can have multiple dimensions.

Assign/V6 = Array( Array(4, 7, 2), Array(9, 2, 6)) | V6 is set to a 2 by 3 dimensional array where V6[1, 1] equals 4, V6[1, 2] equals 7, V6[1, 3] equals 2, V6[2, 1] equals 9, V6[2,2] equals 2, and V6[2,3] equals 6.
Assign/V7 = V6[2,1] | V7 is set to the value 9

Variable arrays can have negative indexes:

Assign/V8[-3] = 5

The –3rd index of array V8 is set to 5.

Array assignment will overwrite previous values:

Assign/V8 = "Hello" | The variable V8 is equal to the string "Hello"
Assign/V8[2] = 5 | V8 is no longer of type string, but of type array, the second element of which has a value of 5.
Assign/V8 = 9 | V8 is no longer an array, but an integer of value 9.

Arrays can be made up of multiple types:

Assign/V9 = Array("Hello", 3, 2.9, {FEAT1})

Creates array V9 with 4 elements. The first element is a string, the second element is an integer, the third element is a real number, and the fourth element is a pointer to FEAT1.


Operators for Expressions

The following basic operators are available inside PC-DMIS:

+ Addition: <Expression> + <Expression>
Adds the two expressions together. In the case of strings, strings are concatenated.

- Subtraction: <Expression> - <Expression>
Subtracts the first expression from the second expression.

* Multiplication: <Expression> * <Expression>
Multiplies the two expressions.

/ Division: <Expression> / <Expression>
Divides first expression by the second expression.

^ Exponentiation: <Expression> ^ <Expression>
Raises the first expression to the power of the second expression.

% Modulo: <Expression> % <Expression>
Returns the remainder of one expression divided by the other.

- Additive Inverse -<Expression>
Returns the additive inverse of the expression.

! Logical Not: !<Expression>
Returns the logical not of the expression.

== Equal To: <Expression> == <Expression>
Evaluates to 1 if expressions are equal. Otherwise, it evaluates to 0. ( Two equal signs are used to distinguish from the assignment operator = in the assignment statement).

<> Not Equal To: <Expression> <> <Expression>
Evaluates to 1 if expression are not equal. Otherwise, it evaluates to 0.

> Greater Than: <Expression> > <Expression>
Evaluates to 1 if first expression is greater than second expression. Otherwise, it evaluates to 0.

>= Greater Than or Equal To: <Expression> >= <Expression>
Evaluates to 1 if the first expression is greater than or equal to the second expression. Otherwise, it evaluates to 0.

< Less Than: <Expression> < <Expression>
Evaluates to 1 if first expression is less than the second expression. Otherwise, it evaluates to 0.

<= Less Than or Equal To: <Expression> <= <Expression>
Evaluates to 1 if the first expression is less than or equal to the second expression. Otherwise, it evaluates to 0.

AND Logical And: <Expression> AND <Expression>
Evaluates to 1 if both expressions does not evaluate to 0. Otherwise, it evaluates to 0.

OR Logical Or: <Expression> OR <Expression> Evaluates to 1 if either expressions does not evaluate to 0. Otherwise, it evaluates to 0.

() Parenthesis: ( <Expression> )
Gives evaluation to precedence to expression inside of parenthesis.


Precedence

Expressions are evaluated with the precedence shown below (listed from highest precedence to lowest precedence).

Highest Precedence

  • Operands

  • (unary minus), !, (), functions (i.e. ABS, COS, STR, LEN, CROSS, etc.)

  • ^

  • *, /, %

  • +, -

  • ==, <>, <, <=, >, >=

  • AND

  • OR

Lowest Precedence


Functions

Functions are PC-DMIS specific expressions or user defined expressions that take parameters and return results. The parameters are substituted into the expression before the expression is evaluated.

More:

Available Functions

String Functions

Mathematical Functions

Point Functions

Pointer Functions

Array Functions

Miscellaneous Functions

Function Examples

Example of a Line Feature Created from a Scan Segment


Functions List

The following alphabetical list contains all the functions available to PC-DMIS's expression language. Clicking on an item will display a specific sub topic with more information and/or examples.

  • ABS (mathematical)

  • ACOS (mathematical)

  • ANGLEBETWEEN (point)

  • ARCSEGMENTENDINDEX (miscellaneous)

  • ARCSEGMENTSTARTINDEX (miscellaneous)

  • ARRAY (array)

  • ASIN (mathematical)

  • ATAN (mathematical)

  • CHR (string)

  • COS (mathematical)

  • CROSS (point)

  • DEG2RAD (mathematical)

  • DELTA (point)

  • DIST2D (pointer)

  • DIST3D (pointer)

  • DOT (point)

  • ELEMENT (string)

  • EOF (miscellaneous)

  • EOL (miscellaneous)

  • EQUAL (array)

  • EQUAL (string)

  • EXP (mathematical)

  • FORMAT (string)

  • FUNCTION (function)

  • GETCOMMAND (pointer)

  • GETSETTING (string)

  • GETTEXT (string)

  • IF (miscellaneous)

  • INDEX (string)

  • ISIOCHANNELSET (miscellaneous)

  • LEFT (string)

  • LEN (array)

  • LEN (pointer)

  • LEN (string)

  • LINESEGMENTENDINDEX (miscellaneous)

  • LINESEGMENTSTARTINDEX (miscellaneous)

  • LN (mathematical)

  • LOG (mathematical)

  • LOWERCASE (string)

  • MAX (array)

  • MID (string)

  • MIN (array)

  • ORD (string)

  • PROBEDATA (miscellaneous)

  • QUALTOOLDATA (miscellaneous)

  • RAD2DEG (mathematical)

  • RIGHT (string)

  • ROUND (mathematical)

  • SIN (mathematical)

  • SQRT (mathematical)

  • SYSTEMDATE (string)

  • SYSTEMTIME (string)

  • SYSTIME (string)

  • TAN (mathematical)

  • TUTORELEMENT (miscellaneous)

  • UNIT (point)

  • UPPERCASE (string)


String Functions

CHR Character Conversion: CHR(<Integer>)
Returns a string, which consists of the character corresponding to the ASCII decimal value.

ELEMENT Delimited substring location: ELEMENT(<Integer>, <String1>, <String2>)

Returns the nth substring (element) from string2 using string1 as the delimiting text that divides the elements in string2. For example, if string2 is "6, 12, 8, 4, 5" and string1 is ","; then the 5 elements that can be individually retrieved with the element command are "6", "12", "8", "4", and "5".

EQUAL Case-insensitive string comparison: EQUAL(<String>, <String>)

Compares two strings (ignoring case) to determine if they are identical. Returns and integer set to 1 if the strings are the same, and 0 if they are not.

FORMAT Format: FORMAT(<String>,<Integer,double,or point>)

This function takes two expressions and returns a formatted string, similar to using the sprintf function inside C++.

    • Expression 1 should be a string type and contains one or three format specifiers. If it is a different type, the expression evaluator attempts to coerce it to a string. The string should contain one format specifier if Expression 2 is an integer or double types and three format specifiers (see paragraphs below) if Expression 2 is a point type.

    • Expression 2 is expected to be of type integer, double, or point. If a different type is used, the value of the expression is 0.

Format Specifier for Format Function:

The format specifier should have the same syntax as a format specifier used in the sprintf function used in the C++ programming language.

A format specifier consists of optional and required fields, and has the following syntax:

%[flags] [width] [.precision] type

Each field of the format specifier is either a single character or a number signifying a particular format option. The simplest format specifier uses only the percent sign and a type character (for example, %d). If a percent sign is followed by a character that has no meaning as a format field, the character is copied to STDOUT. For example, to print a percent-sign character, use %%.

The optional flag, width, and precision fields, which appear before the type character, control other aspects of the formatting. These are described below:

flags These optional characters control output justification and the printing of signs, blanks, decimal points, and octal / hexadecimal prefixes. More than one flag can appear in a format specifier.

Here are the possible flags:

–
Meaning: Left align the result within the given field width.
Default: Right align.

+
Meaning: Prefix the output value with a sign (+ or –) if the output value is of a signed type.
Default: Sign appears only for negative signed values (–).

0
Meaning: If width is prefixed with 0, zeros are added until the minimum width is reached. If 0 and – appear, the 0 is ignored. If 0 is specified with an integer format (i, u, x, X, o, d) the 0 is ignored.
Default: No padding.

blank (' ')
Meaning: Prefix the output value with a blank if the output value is signed and positive; the blank is ignored if both the blank and + flags appear.
Default: No blank appears.

#
Meaning 1: When used with the o, x, or X type, the # flag prefixes any nonzero output value with 0, 0x, or 0X, respectively.
Default 1: No prefix appears.
Meaning 2: When used with the e, E, or f type, the # flag forces the output value to contain a decimal point in all cases.
Default 2: Decimal point appears only if digits follow it.
Meaning 3: When used with the g or G format, the # flag forces the output value to contain a decimal point in all cases and prevents the truncation of trailing zeros.
Default 3: Decimal point appears only if digits follow it. Trailing zeros are truncated.
Note: Ignored when used with d, i, or u.

width This second optional field, or argument, controls the minimum number of characters printed. It is a non-negative decimal integer.

    • If the number of characters in the output value is less than the specified width, blanks are added to the left or the right of the values — depending on whether the – flag (for left alignment) is specified — until the minimum width is reached.

    • If width is prefixed with 0, zeros are added until the minimum width is reached (not useful for left-aligned numbers).

    • The width specification never causes a value to be truncated. If the number of characters in the output value is greater than the specified width, or if width is not given, all characters of the value are printed (subject to the precision specification listed below).

precision This third optional field, or argument, specifies the number of characters to be printed, the number of decimal places, or the number of significant digits. Unlike the width specification, the precision specification can cause either truncation of the output value or rounding of a floating-point value. It is a non-negative decimal integer, preceded by a period (.)

type This required character determines whether the associated argument is an integer, a double, or a point. The list of available types includes:

d - signed decimal integer

i - signed decimal integer

o - unsigned octal integer

u - unsigned decimal integer

x - unsigned hexadecimal integer, using "abcdef"

X - unsigned hexadecimal integer, using "ABCDEF"

e - double in exponential form [-]d.dddd e [sign]ddd

E - same as e except uses E to introduce exponent

f - double with the form [-]dddd.dddd

g - formats to either the e or f format depending on which is more compact

G - same as g except and E is used when introducing the exponent

FORMAT Example:

This example shows several statements using the FORMAT function inside a part program:

ASSIGN/V1 = PROBEDATA("OFFSET") | V1 becomes type point representing the Offsets of the current probe. Using the values from the part program used for this example, V1 becomes: <-1.8898, 1.8898, 5.704>
ASSIGN/V3 = FORMAT("%.5f, %.5f, %.5f", V1) | V3 becomes type string. The string is formatted using the point object of variable V1. V3 now has: -1.88976, 1.88976, 5.70403
ASSIGN/V4 = 1.123456789 | V4 becomes type double.
ASSIGN/V5 = FORMAT("%.5f ", V4) + FORMAT("%.6f ", V4) + FORMAT("%.7f ", V4) + FORMAT("%.8f", V4) | V5 becomes type string with this value: 1.12346 1.123457 1.1234568 1.12345679
ASSIGN/V6A = "The value of V4 is: " + FORMAT("%.8f", V4) | V6A becomes type string with value of: The value of V4 is: 1.12345679
ASSIGN/V6B = FORMAT("The value of V4 is: %.8f", V4) | The expression result remains the same for same as V6A above.
ASSIGN/V7 = 4444 | V7 becomes type double since all numbers are assumed double unless coerced to an integer.
ASSIGN/V8 = FORMAT("%o", INT(V7)) | V8 becomes type string with this value: 10534
ASSIGN/V9 = FORMAT("%u", INT(-1)) | V9 becomes type string with this value: 4294967295
ASSIGN/V10 = FORMAT("%x", INT(2143)) | V10 becomes type string with this value: 85f
ASSIGN/V11 = FORMAT("%X", INT(9567)) | V11 becomes type string with this value: 255F
ASSIGN/V12 = FORMAT("%e", 0.0005432) | V12 becomes type string with this value: 5.432000e-004
ASSIGN/V13 = FORMAT("%E", 145.3421) | V13 becomes type string with this value: 1.453421E+002
ASSIGN/V14 = FORMAT(",%6d,", INT(1)) | V14 becomes type string with this value: , 1,
ASSIGN/V15 = FORMAT(",%-6d,", INT(1)) | V15 becomes type string with this value: ,1 ,

GETSETTING This allows you to return various settings of PC-DMIS depending on the string parameter inserted.

GETSETTING(<String>)

You can use these string parameters:

    • "DCC Mode" – Returns a 1 if PC-DMIS is in DCC Mode, 0 otherwise.

    • "Manual Mode" – Returns a 1 if P-DMIS is in Manual Mode, 0 otherwise.

    • "Current Alignment" – Returns a string of the current alignment.

    • "Current Workplane" – Returns a string of the current workplane.

    • "Workplane Value" – Returns a numerical value of the current workplane.

    • "PreHit" – Returns he current prehit value as a double precision number.

    • "Retract" – Returns the current retract value as a double precision number.

    • "Check" – Returns the current check value as a double precision number.

    • "Touch Speed" – Returns the current Touch Speed value as a double precision number.

    • "Move Speed" – Returns the current Move Speed value as a double precision number.

    • "Fly Mode " – Returns a 1 if PC-DMIS uses the Fly Mode, 0 otherwise.

    • "Ph9 present" – Returns a 1 if the Ph9/Ph10 is present, 0 otherwise.

    • "Manual CMM " – Returns 1 if the CMM is a manual CMM, 0 otherwise.

    • "LangStr(<Number or ID>)" – Returns a string from PC-DMIS's resources in the current language from a resource ID number or from one of these IDs:
      "Yes", "No", "Oper", "Rept", "Input", "Doc", "YesNo", "Readout", "Internal", "External", "Rect ", "Polr ", "Out", "In", "Least_Sqr", "Min_Sep", "Max_Insc", "Min_CircSc", "Fixed_Rad", "Workplane", "Xaxis", "YAxis", "ZAxis", "Xplus", "Xminus", "YPlus", "YMinus", "ZPlus", "ZMinus", "Point", "Plane", "Line", "Circle", "Sphere", "Cylinder", "Round_Slot", "Square_slot", "Cone", or "None".

      If the value you use is a positive number, PC-DMIS pulls the string from its resource.dll file. If you use a negative number, PC-DMIS pulls the string from its strings.dll file (the strings table).

    • "Extended Sheet Metal" – Returns a 1 if the Show Extended Sheet Metal Options check box is selected inside the SetUp Options dialog box, 0 otherwise.

    • "LastHitMove(X)" – Returns the X value of the most recent HIT /BASIC or MOVE/POINT command. PC-DMIS must be in DCC mode for this to work.

    • "LastHitMove(Y)" – Returns the Y value of the most recent HIT/BASIC or MOVE/POINT command. PC-DMIS must be in DCC mode for this to work.

    • "LastHitMove(Z)" – Returns the Z value of the most recent HIT/BASIC or MOVE/POINT command. PC-DMIS must be in DCC mode for this to work.

To determine whether PC-DMIS is in MANUAL or DCC mode, consider this example of using the GETSETTING function:

Example:
ASSIGN/DCCMODEVAR = GETSETTING("DCC Mode")
gives the variable DCCMODEVAR the value of 1 if PC-DMIS is in DCC Mode, otherwise 0.
ASSIGN/MANMODEVAR = GETSETTING("Manual Mode")
gives the variable MANMODEVAR the value of 1 if PC-DMIS is in Manual Mode, otherwise 0.

To determine the current workplane, consider this example:

Example:
ASSIGN/WORKPLANE_ID = GETSETTING("Current Workplane")
gives the variable WORKPLANE_ID the string value of the current workplane (ZPLUS, ZMINUS etc.).
ASSIGN/WORKPLANE_VALUE = GETSETTING("Workplane Value")
gives the variable WORKPLANE_VALUE a numerical value representing the workplane. The workplanes have these values associated with them: ZPLUS = 0, ZMINUS = 3, XPLUS = 1, XMINUS = 4, YPLUS = 2, or YMINUS = 5.

GETTEXT Returns the current text from the specified data field: GETTEXT(<String or Integer>, <Integer>, <Pointer>)

This function has three fields.

First Field—Data Field Number or Description

The first field can be either a string (which is the description of the data field) or the data field number.

To obtain these values:

1. Place PC-DMIS in Command Mode. Right-click anywhere in the Edit window. A shortcut menu appears.

2. From the shortcut menu, select Change Pop-up Display and then Data Type Information.

3. Position the mouse over a data field in the Edit window. The type description, type number and the type index for that data item are displayed.

Note: Since the type description may be different for different languages, use the type number if you're using the part program under a language other than the current one.

Second Field—Type Index

The second field is the type index. This field is usually zero. The correct value for this field can be obtained in the same manner as described for the first field.

Third Field—Command Pointer

The third field is a command pointer. It points to the command containing the field from which the text is being obtained. This field can be specified either by using command pointer notation (i.e. {F15}) or by using the GetCommand expression as shown in this example.

Example:
ASSIGN/V1 = GETTEXT("Best Fit Math Type", 0, {F15})
This command assigns V1 the current value of the best fit math type toggle of feature F15.
ASSIGN/V2 = GETCOMMAND("Comment", "TOP", 1)
ASSIGN/V3 = GETTEXT("Comment Type", 1, V2)
V2 is assigned a pointer to the first comment from the top of the part program.
V3 is assigned the value of the Comment Type toggle field. If the first comment in the part program is a comment to be displayed to the operator, the value of V3 will be the string "OPER".

See the "Pointer Functions" for information on setting a pointer to a command.

INDEX Substring Location: INDEX(<String>, <String>)
Returns the location of the second string within the first string. The first letter of string is 1. A return value of zero indicates that the sub string is not found in the string.

For a simple example of this function, see the "Sample Code for Read Line" topic in the "Using File Input / Output" section.

LEFT Left n characters of string: LEFT(<String>, <String>)
Returns a string consisting of the n leftmost characters specified by the second expression from the string specified in the first expression. First expression coerced to type string, second expression coerced to type integer.

For a simple example of this function, see the "Sample Code for Read Line" topic in the "Using File Input / Output" section.

LEN Length of string: LEN(<String>)
Returns the number of characters of the string.

LOWERCASE Create lowercase string: LOWERCASE(<String>)

Returns a string that is the lowercase equivalent of string.

MID Middle n characters of a string: MID(<String>, <Integer>, <Optional Integer>)
Returns a substring consisting of the characters of the string specified in the first parameter starting at the position specified by the second parameter for a length of n characters as specified by the third parameter. If the third parameter is not supplied, the rest of the string is returned.

For a simple example of this function, see the "Sample Code for Read Line" topic in the "Using File Input / Output" section.

ORD Ordinal Conversion: ORD(<String>)
Returns the integer ASCII value of first letter of the string. (0-255).

RIGHT Right n characters of string: RIGHT(<String>, <Integer>)
Returns a string consisting of the n rightmost characters specified by integer from the string.

SYSTEMDATE System Date: SYSTEMDATE(<Date Format String>)

Returns the date formatted string with the current date details filled in. For example, the command SYSTEMDATE("MM’/’dd’/’yy") will return the string "03/15/99" if the current date is March 15, 1999.

Use the following string elements to create the date string. Elements must be in the same case as shown below (MM instead of mm). Non-date characters (such as spaces) appearing between date format string elements will appear in the output string in the same location as the input string. Characters in the input string delimited by single quotes will appear in the same location in the output string without the single quotes.

d - Day of the month as digits. No leading-zero for single-digit dates.

dd – Day of the month as digits. Leading zero used for single-digit dates.

ddd – Three letter abbreviation for the day of the week.

dddd – Full name for the current day of the week.

M – Month as digits with no leading zeros for single-digit months.

MM – Month as digits with leading zero for single-digit months.

MMM – Month as three-letter abbreviation.

MMMM – Full name of Month.

y – Year as digits with no leading zeros for single-digit years.

yy – Year as digits with leading zero for single-digit years.

yyyy – Year represented by four digits.

SYSTEMTIME Formatted System Time: SYSTEMTIME(<Time Format String>)

Returns the time formatted string with the current time details filled in. For example, the command SYSTEMTIME("hh:mm:ss tt") will return the string "11:29:40 PM" if that is the current time.

Use the following string elements to create the time string. Elements must be in the same case as shown below (tt instead of TT). Non-time characters (such as spaces) appearing between time format string elements will appear in the output string in the same location as the input string. Characters in the input string delimited by single quotes will appear in the same location in the output string without the single quotes.

h - Hours with no leading zero for single-digit hours; 12-hour clock

hh – Hours with leading zero for single-digit hours; 12-hour clock

H – Hours with no leading zero for single-digit hours; 24-hour clock

HH – Hours with loading zero for single-digit hours; 24-hour clock

m – Minutes with no leading zero for single-digit minutes

mm – Minutes with leading zero for single-digit minutes

s – Seconds with no leading zero for single-digit seconds

ss – Seconds with leading zero for single-digit seconds

t – One character time marker string, such as A or P

tt – Multi-character time marker string, such as AM or PM

SYSTIME System Time: SYSTIME()
Returns a string with the current system time. This function differs from the SYSTEMTIME function described above. It automatically returns the day, the date, the time, followed by the year.
Example: "Fri May 02 13:50:21 1997"

Note: The returned string, showing current system time, is adjusted to local time zone settings.

UPPERCASE Creates uppercase string: UPPERCASE(<String>)

Returns a string that is the uppercase equivalent of string.

String Functions

The following functions are used with text strings.

CHR

ELEMENT

EQUAL

FORMAT

GETSETTING

GETTEXT

INDEX

LEFT

LEN

LOWERCASE

MID

ORD

RIGHT

SYSTEMDATE

SYSTEMTIME

SYSTIME

UPPERCASE


Mathematical Functions

ABS Absolute Value: ABS(<Double>)
Returns absolute value of input.

EXP Exponential: EXP(<Double>)
Returns the exponential of the expression.

LOG Log Base 10: LOG(<Double>)
Returns the log base 10 of the expression.

LN Natural Log: LN(<Double>)
Returns the natural logarithm of the expression.

ROUND Rounding: ROUND(<Double>)
Returns the input rounded to the nearest integer.

SQRT Square Root: SQRT(<Double>)
Returns the square root of the input.

ACOS ArcCosine: ACOS(<Double>)
Returns the arc cosine of the expression. For example, ACOS(5.0) returns 0. In general, ACOS(<expression>) returns the arc cosine of the value of the expression.

ASIN ArcSine: ASIN(<Double>)
Returns the arc sine of the input.

ATAN ArcTangent: ATAN(<Double>)
Returns the arc tangent of the input.

COS Cosine: COS(<Double>)
Returns the cosine of the input.

DEG2RAD Degrees to Radians: DEG2RAD(<Double>)
Returns the input divided by 360 and multiplied by 2p. Converts from degrees to radians.

RAD2DEG Radians to Degrees: RAD2DEG(<Double>)
Returns the input multiplied by 360 and divided by 2p. Converts from radians to degrees.

SIN Sine: SIN(<Double> )
Returns the sine of the input.

TAN Tangent: TAN(<Double>)
Returns the tangent of the input.

Mathematical Functions

ABS

EXP

LOG

LN

ROUND

SQRT

Trigonometry Functions

Important: Each of the trigonometry functions by default takes and returns radians. If you want values in degrees, use the RAD2DEG function described below.

ACOS

ASIN

ATAN

COS

DEG2RAD

RAD2DEG

SIN

TAN

Note: Functions where the input is out of range (i.e., for ACOS, ASIN, LOG, LN, SQRT etc. that would cause the computer to crash) return 0.


Point Functions

ANGLEBETWEEN Angle Between: ANGLEBETWEEN( <Point>, <Point>)
Returns the angle between the two vectors in degrees.

CROSS Cross Product: CROSS(<Point>, <Point>)
Return value is of type point and is the cross product of first and second expressions .

DELTA Vector Offset: DELTA(<Point>, <Point>, <Double>)
The function takes the first expression (point) and calculates a new point in the direction of the second expression (vector) at an offset of the third expression. For example, DELTA(MPOINT(0,0,0), MPOINT(1,0,0), 10) returns the point 10,0,0.

DOT Dot Product: DOT(<Point>, <Point>)
Returns the dot product of the two points (vectors).

UNIT: Unit Vector: UNIT(<Point>)
Returns the point divided by its length. For example, UNIT(MPOINT(0,0,0)) returns the point 0,0,1.

Point Functions

ANGLEBETWEEN

CROSS

DELTA

DOT

UNIT


Pointer Functions

DIST2D: 2d Distance: DIST2D(<FEAT1>, <FEAT2>, <FEAT3>)
Calculates the 2d distance between Feat1 and Feat2 after projecting them onto Feat3.

DIST3D: 3D Distance: DIST3D(<FEAT1>, <FEAT2>)
Calculates the 3D distance between Feat1 and Feat2.

GETCOMMAND: Obtains a pointer to the command specified by the parameters: GETCOMMAND(<Integer or String>, <String>, <Integer>

First Parameter—Command Info Field

The first parameter is the command info field. It specifies the command type for which to search. The following can be passed in:

    • A command description string

    • A command type number

    • The unique number identifier

If the unique id of the command is passed in, no other arguments are necessary.

To obtain the command description string, the command type number, and the command’s unique number identifier:

    1. Right-click in the Edit window

    2. Choose Change Pop-up Display | Command Information (PC-DMIS must be in Command Mode).

    3. Position the mouse over the desired command. The command description, type number, and unique number identifier for that command will be displayed in the pop-up.

Second Parameter—Search Direction

The second parameter is the search direction. Legal values include:

Value | Description
UP | This value signifies the search should start at the current command and proceed upwards
DOWN | This value signifies the search should start at the current command and proceed downwards.
TOP | This value signifies that the search should begin at the beginning of the part program in a downwards direction
BOTTOM | This value signifies that the search should begin with the last object in the part program in an upwards direction

Third Parameter – Which Instance to Find

The third parameter indicates which instance of the command should be found.

Example: If the part program has four instances of a Set/Active tip and you would like to obtain a pointer to the second instance from the top, "2" would be passed in as the third parameter and "TOP" would be passed in as the second parameter as shown here.

ASSIGN/V1 = GETCOMMAND("Set Active Tip", "TOP", 2)

The GETCOMMAND function can be used to supply the third parameter to the GETTEXT string function. See "String Functions" for information on GETTEXT.

LEN: Pointer loop count: LEN(<POINTER>)
Returns the number of times a pointer has been in a loop. For example, if feature CIR1 is in a loop that iterates 10 times, you can store how many times CIR1 has been measured in a variable, by using an ASSIGN statement like this: ASSIGN/V1=LEN({CIR1})

Pointer Functions

DIST2D

DIST3D

GETCOMMAND

LEN


Array Functions

ARRAY: Create Array: ARRAY(<EXPRESSION1>, <EXPRESSION2>, <EXPRESSION3>, …)
Creates an array object with array elements indicated by expression parameters. The array elements are numbered with a base index of 1.

EQUAL: Element by Element Array Comparison: EQUAL(<ARRAY>, <ARRAY>)
Compares the two arrays element by element to determine if the arrays hold the same elements. If the two arrays are not the same size or if any of the elements in one array do not match the corresponding element in the other array, the function returns 0. Otherwise, the function returns 1.

LEN: Array element count: LEN(<ARRAY>)
Returns the number of elements in the array.

MAX: Largest array element: MAX(<ARRAY>)
Returns the largest element in the array. Items in the array are compared numerically or alphabetically.

MIN: Smallest array element: MIN(<ARRAY>)
Returns the smallest element in the array. Items in the array are compared numerically or alphabetically.

Array Functions

ARRAY

EQUAL

LEN

MAX

MIN


Miscellaneous Functions

ARCSEGMENTENDINDEX: This returns the index number of the ending point of a specified arc segment from a scan: ARCSEGMENTENDINDEX(<ID>, <index>,<tol1>,<tol2>)

<ID> – The first parameter is a string value of the ID of the scan on which this function pulls out the index number of the ending point for the arc. This can either be the ID in quotation marks or any expression that when coerced to type string ends up being the ID of a scan.

<index> – The second parameter is the index number for the arc from which you want to get the ending point number. This is a one based value. For example, the arc index number would be 3 if you want the ending point number for the third arc in the scan.

<tol1> – The third parameter is the general feature tolerance. It is a maximum form error used to break up the scan into lines and arcs.

<tol2> – The fourth parameter is the refine tolerance. Generally, this tighter tolerance is used to drop points from either end of the feature until the form error of the segment is within this tolerance.

Once you have the Start and End indices for an arc, you can use these points inside a constructed feature to construct a separate arc feature. See "Example of a Line Feature Created from a Scan Segment" for a similar example.

ARCSEGMENTSTARTINDEX: This returns the index number of the starting point of a specified arc segment from a scan: ARCSEGMENTSTARTINDEX(<ID>, <index>,<tol1>,<tol2>).

<ID> – The first parameter is a string value of the ID of the scan on which this function pulls out the index number of the start point for the arc. This can either be the ID in quotation marks or any expression that when coerced to type string ends up being the ID of a scan.

<index> – The second parameter is the index number for the arc from which you want to get the start point number. This is a one based value. For example, the arc index number would be 3 if you want the start point number for the third arc in the scan.

<tol1> – The third parameter is the general feature tolerance. It is a maximum form error used to break up the scan into lines and arcs.

<tol2> – The fourth parameter is the refine tolerance. Generally, this tighter tolerance is used to drop points from either end of the feature until the form error of the segment is within this tolerance.

There are two additional parameters, which control whether an identified arc segment in a scan is acceptable. These can only be changed with the PC-DMIS Settings Editor . Any arc segment with a radius less than MinimumArcSegmentRadiusInMM is rejected. The default value for this parameter is 2 mm. Similarly, any arc segment with a radius greater than MaximumArcSegmentRadiusInMM is rejected. The default value for this parameter is 2000 mm (it should not be necessary to change this value).

Once you have the Start and End indices for an arc, you can use these points inside a constructed feature to construct a separate arc feature. See "Example of a Line Feature Created from a Scan Segment" for a similar example.

EOF and EOL: For information on these functions, see "Checking for the End of a File or the End of a Line" in the "Using File Input / Output" section.

FUNCTION: Creates a function: FUNCTION((<PARAM1>, <PARAM2>…), <EXPRESSION>)
Creates a function that takes the number of parameters indicated by the parameter list and substitutes those parameters into the expression.

    • The first item when using the FUNCTION keyword is the parameter list.

    • This list consists of parameter names separated by commas.

    • The parameter list is also surrounded by parenthesis.

    • The second item is the expression.

    • The expression will contain the parameter names where the parameters should be substituted when the function is called.

See the "Generic Function Example" topic for an example.

GETROTABDATA: This returns the data from the current rotary table: GETROTABDATA(<Parameter>)

<Parameter> - This can be either "Center" or "Angle".

"Center" - Returns the table's XYZ center.

"Angle" - Returns the table's current angle.

Examples:

ASSIGN/V1 = GETROTABDATA("CENTER") | V1 is set to the rotary table's XYZ center value.
ASSIGN/V2 = GETROTABDATA("ANGLE") | V2 is set to the rotary table's current angle value.

IF: Conditional expression evaluation: IF(<EXPRESSION1>, <EXPRESSION2>, <EXPRESSION3>)

If expression1 evaluates to true (non-zero) then this function returns the value of expression2; otherwise, this function returns the value of expression3.

ISIOCHANNELSET: This expression takes two parameters. The first parameter indicates which I/O channel will be checked (the range of numbers that is available is based on the machine being used). The second parameter determines whether the software will query the master or slave machine. If the second parameter is set to 1 (one) it will query the slave controller. If the second parameter is not present (or is set to zero), then the IO Channel will query the master controller. The master controller is your only option if you are not in multiple arm mode.

Note: If an invalid probe data type, tip id, probe file name, or channel number is supplied, the expression will evaluate to 0.

Example:

ASSIGN/V4 = ISIOCHANNELSET(3, 0)

V4 will equal 1 (evaluate to true) when the channel is set, otherwise it will equal 0 (evaluate to false).

LINESEGMENTENDINDEX: This returns the index number of the ending point of a specified line segment from a scan: ARCSEGMENTSTARTINDEX(<ID>, <index>,<tol1>,<tol2>).

<ID> – The first parameter is a string value of the ID of the scan on which this function pulls out the index number of the ending point for the line segment. This can either be the ID in quotation marks or any expression that when coerced to type string ends up being the ID of a scan.

<index> – The second parameter is the index number for the line segment from which you want to get the end point number. This is a one based value. For example, the line segment index number would be 3 if you want the end point number for the third line in the scan.

<tol1> – The third parameter is the general feature tolerance. It is a maximum form error used to break up the scan into lines and arcs.

<tol2> – The fourth parameter is the refine tolerance. Generally, this tighter tolerance is used to drop points from either end of the feature until the form error of the segment is within this tolerance.

Once you have the Start and End indices for a line segment, you can use these points inside a constructed feature to construct a separate line feature. See "Example of a Line Feature Created from a Scan Segment" for an example.

LINESEGMENTSTARTINDEX: This returns the index number of the starting point of a specified line segment from a scan: ARCSEGMENTSTARTINDEX(<ID>, <index>,<tol1>,<tol2>).

<ID> – The first parameter is a string value of the ID of the scan on which this function pulls out the index number of the start point for the line segment. This can either be the ID in quotation marks or any expression that when coerced to type string ends up being the ID of a scan.

<index> – The second parameter is the index number for the line segment from which you want to get the start point number. This is a one based value. For example, the line segment index number would be 3 if you want the start point number for the third line in the scan.

<tol1> – The third parameter is the general feature tolerance. It is a maximum form error used to break up the scan into lines and arcs.

<tol2> – The fourth parameter is the refine tolerance. Generally, this tighter tolerance is used to drop points from either end of the feature until the form error of the segment is within this tolerance.

There is an additional parameter, which controls whether an identified line segment in a scan is acceptable. This can only be changed with the PC-DMIS Settings Editor . Any line segment of length less than MinimumLineSegmentLengthInMM is rejected. The default value for this parameter is 2 mm.

Once you have the Start and End indices for a line segment, you can use these points inside a constructed feature to construct a separate line feature. See "Example of a Line Feature Created from a Scan Segment" for an example.

PROBEDATA: Returns data about the current or specified probe : PROBEDATA(<OPTPROBEDATATYPE>, <OPTTIPID>, <OPTPROBEFILENAME>)

This function takes up to three optional parameters. You only need to provide commas between parameters if you use more than one parameter. You do not need to use commas between empty parameters. For example, to obtain the current probe's diameter you would simply use ASSIGN/V1 = PROBEDATA("DIAM").

OPTPROBEDATATYPE: Optional parameter which specifies what probe data the expression should return. If this parameter is not supplied, the current tip ID is returned. This parameter is of type string. Any expression that evaluates to a valid string expression can be put in the first expression slot. Valid string expressions (not case sensitive) for the first parameter include the following. These are string expressions and should be inside double quotation marks:

"Offset" – Measured tip X,Y,Z offset. Returns type point.

"Vector" – Tip Vector. Returns type point.

"A" - Tip A Angle. Returns type double.

"B" – Tip B Angle. Returns type double.

"Diam(eter)" – Measured tip diameter. The first four letters are required "Diam", but could include more letters up to the full name. Returns type double.

"Thick(ness)" – Measured tip thickness. The first five letters are required "Thick", but could include more letters up to the full name. Returns type double.

"Date" – Date the tip was last qualified. Returns type string.

"Time" – Time the tip was last qualified. Returns type string.

"ID" – Tip ID. Default parameter. Returns type string.

"PrbRdv" – The probes radial deviation. Returns type double.

"Standarddeviation" – The probes standard deviation. Returns type double.

"C" - The C angle of a CW43 light probe head. Returns type integer.

Note: Adding a "T" in front of "Offset", "Diameter", or "Thickness" will return the theoretical information (i.e. TOFFSET, TDIAMETER, and TTHICKNESS).

OPTTIPID: This optional parameter specifies the tip to be used when obtaining the probe data specified in the first expression. If not supplied, the current tip is used. This parameter should be type string.

OPTPROBEFILENAME: This optional parameter specifies the probe filename to be used in obtaining the probe data. If not supplied, the current probe file is used.

Examples:

ASSIGN/V1 = PROBEDATA() | V1 is set to current tip id (i.e. "T1A0B0")
ASSIGN/V2 = PROBEDATA("TOFFSET", "T1A45B0") | V2 is set to the theoretical probe offset for the tip T1A45B0
ASSIGN/V3 = PROBEDATA("Date", "T1A90B90", "MYPROB") | V3 is set to a string representing the date tip T1A90B90of the probe file MYPROB was last qualified.

TUTORELEMENT: With the addition of the Tutor translator, PC-DMIS version 3.5 and above supports the new intrinsic TutorElement function. This function takes one argument, either a number or a string (a string would be the ID of a feature).

This function works with the variable type, Structures. See "Structures" for explanations of structure and sub-elements.

Examples:

ASSIGN/E = TUTORELEMENT(1) | Creates a single Tutor Element Structure
ASSIGN/WM = TUTORELEMENT(n) | For any number over 1, creates an array of n Tutor Element Structures
ASSIGN/CIR1E = TUTORELEMENT("CIR1") | Copies Data from feature CIR1 into the Tutor Element Structures.

The TutorElement structure currently has the following sub-elements:

Sub-Element | Description
ID | String of the Feature's ID
TYPE | INTEGER (FTYPE)
X, Y, Z | X, Y, and Z coordinate values
PR | Polar Radius
PA | Polar Angle
CX | I
CY | J
CZ | K
DM | Diameter 1
DM2 | Diameter 2
DS | Distance from the origin
A | Angle
AXY | Angle in the XY plane
AYZ | Angle in the YZ plane
AZX | Angle in the ZX plane
F | Form Error
SDEV | Standard Deviation
TP | True Position

QUALTOOLDATA: This function returns data about the current or specified calibration tool. It has this syntax:

QUALTOOLDATA(<TOOLINFO>, <TOOLID>, <FACENUMBER>)

This function takes up to three parameters. It needs at least one parameter to return any data:

The first parameter, <TOOLINFO>, is a string that specifies the type of information to return about the calibration tool. If you don't pass this parameter, this function returns the name of the current or specified calibration tool.

· "DIAM" – This returns the diameter of the tool as a double value.

· "ID " – This returns the name of the tool as a string value.

· "LENGTH" – This acts the same as "DIAM". It also returns the diameter of the tool as a double value.

· "OVERRIDEIJK" – This returns the search override IJK vector as a point value.

· "POLYDIAM" – This returns the diameter of the specified polyhedral face as a double value.

· "POLYIJK" – This returns the IJK vector of the specified polyhedral face as a point value.

· "POLYXYZ" – This returns the XYZ center of the specified polyhedral face as a point value.

· "SHANKIJK" – This returns the IJK vector of the shank as a point value.

· "TYPE" – This returns the type of tool as an integer value (0 for a sphere, 1 for a slave sphere, 2 for a polyhedral, 3 for a slave polyhedral).

· "WIDTH" – This parameter is no longer used.

· "XYZ" – This returns the XYZ location of the tool as a point value.

The second parameter, <TOOLID>, is a string that specifies the name for the calibration tool for which the user would like to receive information. If you don't pass this parameter, PC-DMIS assumes you want information from the current calibration tool. The string is not case sensitive.

The third parameter, <FACENUMBER>, you only need when working with a polyhedral calibration tool and only when the first parameter is "POLYXYZ", "POLYIJK", or "POLYDIAM". This is an integer value that specifies the face of the polyhedral tool to use in order to obtain data.

Examples:

ASSIGN/VDIAM = QUALTOOLDATA("DIAM","SPHERE_1_IN") | Gives the variable VDIAM the diameter of the tool SPHERE_1_IN.
ASSIGN/VID = QUALTOOLDATA("ID") | Gives the variable VID the current tool's name.
ASSIGN/VTYPE = QUALTOOLDATA("TYPE") | Gives the variable VTYPE the current tool's type.
ASSIGN/VPOLYDIAM = QUALTOOLDATA("POLYDIAM","POLYTEST",3) | Gives the variable VPOLYDIAM the diameter of face 3 on the polyhedral tool, POLYTEST.

Miscellaneous Functions

ARCSEGMENTENDINDEX

ARCSEGMENTSTARTINDEX

EOF and EOL

FUNCTION

GETROTABDATA

IF

ISIOCHANNELSET

LINESEGMENTENDINDEX

LINESEGMENTSTARTINDEX

PROBEDATA

TUTORELEMENT

QUALTOOLDATA


Function Examples

Below are some different examples of functions that may help you in creating and using your own functions:

  • Generic Function Example

  • Functions Passed as Variables Example

  • Function with Multiple Parameters Example

  • Functions Creating Other Functions Example

  • Functions As Members of an Array Example

  • Functions Defined Recursively Example


Generic Function Example

Assign/MYFUNC = FUNCTION((X,Y,Z), X*3 + Y*2 + Z) | Creates a user-defined function and assigns it to the variable MYFUNC. The function takes three parameters, X,Y, and Z. X is multiplied by 3. Y is multiplied by 2. Z simply holds the passed value. The total of X + Y + Z is what gets returned.
Assign/V1 = MYFUNC(7,2,5) | Assigns V1 the value 30 by evaluating the parameters passed into the function MYFUNC(7,2,5). 7 is the parameter and is substituted where X occurs in the expression portion of the function definition. Thus, X*3 becomes 7*3, or 21. 2 is substituted where Y occurs, thus Y*2 becomes 2*2, or 4. 5 is substituted where Z occurs. The values are then all added together (21 + 4 + 5) and passed to V1.


Functions Passed as Variables Example

Functions can be passed as variables. The following example builds on the Generic Function Example above:

Assign/NEWFUNC = MYFUNC | Sets the variable NEWFUNC to have the same function that MYFUNC has.
Assign/V3 = NEWFUNC(12,2,3) | Assigns V3 to have the value 43 from the evaluated expressions within the function (36 + 4 + 3).


Function with Multiple Parameters Example

Functions can have multiple parameters:

Assign/ADDANDDOUBLE = FUNCTION((A,B), 2*(A+B)) | Creates a function and assigns it to the function ADDANDDOUBLE. The function takes two parameters, adds them together and then multiplies the result by 2.
Assign/V2 = ADDANDDOUBLE(4, 5) | Assigns V2 the value 18. The parameters 4 and 5 are substituted into the expression portion of the function, thus becoming 2*(4+5).


Functions Creating Other Functions Example

Functions can create other functions.

Assign/COMPOSE = FUNCTION((F, G), FUNCTION((X), G(F(X)) )) | Assigns COMPOSE to be a function that takes two functions as parameters and creates a new function using the two functions.
Assign/ADD2 = FUNCTION((X), X+2) | Assigns ADD2 to be a function that adds two to the parameter passed in.
Assign/ADD3 = FUNCTION((X), X+3) | Assigns ADD3 to be a function that adds three to the parameter passed in.
Assign/ADD5 = COMPOSE(ADD2, ADD3) | Assigns ADD5 to be a function composed of the functions ADD2 and ADD3.
Assign/V5 = ADD5(3) | Assigns V5 to have the value V8.


Functions As Members of an Array Example

Functions can be members of an array.

Assign/ANARRAY = ARRAY(3, FACTORIAL, "Hello World", ADD5) | Assigns ANARRAY to be an array of 4 elements : a number (3), a function (FACTORIAL), a string, ("Hello World"), and a function (Add5).
Assign/V6 = ANARRAY[2](4) | The second element of ANARRAY is the function FACTORIAL. The parameter 4 is passed in to this function and the result of 24 is assigned to V6.
Assign/V7 = ANARRAY[2](ANARRAY[4] (ANARRAY[1])) | From the inside out: The first element of ANARRAY (3) is passed to the function of the fourth array element (Add5). The result, 8, is passed to the function of the second array element (FACTORIAL) and assigned to V7. V7 receives a value of 40320.


Functions Defined Recursively Example

Functions can be defined recursively (i.e. they can be defined to call themselves).

Assign/FACTORIAL = FUNCTION((X), IF(X<=1, 1, X*FACTORIAL(X-1)) | Creates a function called factorial that takes one parameter. If the parameter is less than or equal to 1 it evaluates to 1, otherwise it evaluates to X multiplied by the FACTORIAL of X-1.
Assign/V4 = FACTORIAL(5) | Assigns V4 the value of 120 (5*4*3*2*1).


Example of a Line Feature Created from a Scan Segment

This topic provides an example of how to use PC-DMIS expression language, specifically the line segment functions, to export start and end point numbers for line segments within a scan and then to create your own line feature by using the extracted points within a constructed feature. You can use the same principles covered in this example to create an arc segment from a scan as well.

Suppose your part program has a scan feature named SCN1 that looks like this:

SCN1 =FEAT/SCAN,LINEAROPEN,SHOW HITS=NO,SHOWALLPARAMS=YES

EXEC MODE=RELEARN, NOMS MODE=FIND NOMS,CLEARPLANE=NO,SINGLE POINT=NO,THICKNESS=0

FINDNOMS=5,SELECTEDONLY=NO,USEBESTFIT=NO,PROBECOMP=YES,AVOIDANCE MOVE=NO,DISTANCE=0,CAD Compensation=NO

DIR1=VARIABLE,

HITTYPE=VECTOR

INITVEC=0,-1,0

DIRVEC=1,0,0

CUTVEC=0,0,1

ENDVEC=0,-1,0

PLANEVEC=-1,0,0

POINT1=100,0,-5

POINT2=70,0,-5

MEAS/SCAN

BASICSCAN/LINE,SHOW HITS=NO,SHOWALLPARAMS=YES

<100,0,-5>,<70,0,-5>,CutVec=0,0,1,DirVec=1,0,0

InitVec=0,-1,0,EndVec=0,-1,0,THICKNESS=0

FILTER/NULLFILTER,

EXEC MODE=RELEARN

BOUNDARY/PLANE,<70,0,-5>,PlaneVec=-1,0,0,Crossings=2

HITTYPE/VECTOR

NOMS MODE=FINDNOMS,5

ENDSCAN

ENDMEAS/

To create a line from this scan you will need to use the LINESEGMENTSTARTINDEX and LINESEGMENTENDINDEX functions to pull out the data, like this:

ASSIGN/LINESTARTINDEX = LINESEGMENTSTARTINDEX("SCN1", 1, 0.4,0.1)

ASSIGN/LINEENDINDEX = LINESEGMENTENDINDEX("SCN1", 1, 0.4, 0.1)

This tells PC-DMIS to go to the scan named "SCN1", and from its first line segment pull out the starting and ending index values that fall within the defined tolerances. It then assigns those index values to variables named LINESTARTINDEX and LINEENDINDEX.

Once you have the start and ending index values for the line segment assigned to variables, you can use those variables within a constructed line, like this:

LIN4 =FEAT/LINE,RECT,UNBND

THEO/100.225,0,-5.011,1,0,0

ACTL/100.225,-0.005,-5.011,1,-0.0000388,0

CONSTR/LINE,BF,2D,SCN1.HIT[LINESTARTINDEX..LINEENDINDEX],,

OUTLIER_REMOVAL/OFF,3

FILTER/OFF,WAVELENGTH=0

Notice that in the highlighted code from the line feature above, PC-DMIS uses the starting and ending numbers you pulled out of the scan to create the feature: SCN1.HIT[LINESTARTINDEX..LINEENDINDEX]


Operand Coercion

Operands can be coerced to other types using any of the coercion operators:

More:

Integer Coercion

Double Coercion

String Coercion

Point Coercion

Operand Coercion and Mixed Type Expressions


Integer Coercion

INT(<Expression>) - Coerces value of expression to type integer

INT(4) | Evaluates to 4
INT(4.5) | Evaluates to 4
INT("Hello World") | Evaluates to 0
INT("2") | Evaluates to 2
INT("2.2") | Evaluates 2
INT("3 Blind Mice") | Evaluates to 3
INT("The 3 Blind Mice") | Evaluates to 0
INT("3, 4, 5") | Evaluates to 3
INT(MPOINT(0, 0, 1)) | Evaluates to the distance of the point from the origin, in this case 1
INT(MPOINT(3, 4, 5)) | Distance evaluates to 7.0711, this expression evaluates to 7


Double Coercion

DOUBLE(<Expression>) - Coerces value of expression to type double

DOUBLE(4) | Evaluates to 4.0
DOUBLE(4.5) | Evaluates to 4.5
DOUBLE("A String") | Evaluates to 0.0
DOUBLE("3.5") | Evaluates to 3.5
DOUBLE("3.5 inches") | Evaluates to 3.5
DOUBLE("The circle measures 3.5 inches in diameter ") | Evaluates to 0.0
DOUBLE(MPOINT(0,0,1)) | Evaluates to 1.0
DOUBLE(MPOINT(3,4,5)) | Evaluates to 7.0711


String Coercion

STR(<Expression>) - Coerces value of expression to type string

STR(4) | Evaluates to "4"
STR(4.5) | Evaluates to "4.5"
STR("Hello World") | Evaluates to "Hello World"
STR(MPOINT(3,4,5)) | Evaluates to "3, 4, 5"


Point Coercion

MPOINT(<Expression1>, <Expression2>, <Expression3>) - Coerces values of expressions to type point after coercing each expression to type double.

MPOINT( 1, 1, 1) | Evaluates to point 1.0,1.0,1.0
MPOINT( 1.1, 1.1, 1.1) | Evaluates to point 1.1, 1.1, 1.1
MPOINT("1", "1", "1") | Evaluates to point 1.0,1.0,1.0
MPOINT( 3, 4.5, "5.6") | Evaluates to point 3.0, 4.5, 5.6
MPOINT( MPOINT(1, 0, 0), MPOINT(0,1,0), MPOINT(3,4,5) ) | Evaluates to 1.0, 1.0, 7.0711


Operand Coercion and Mixed Type Expressions

The expression evaluator automatically coerces variables in mixed type expressions. If the result of an expression is not what is expected because of automatic coercion, use of the coercion operators in some cases will yield the desired result. The following are examples of automatic coercions in mixed type expressions.

"CIR" + 1 | Evaluates to "CIR1"
"2" + 2 | Evaluates to 4
"The Value of 2+2 is " + 2 + 2 | Evaluates to "The Value of 2+2 is 22" (Since expressions are evaluated left to right)
"The Value of 2+2 is " + (2 + 2) | Evaluates to "The Value of 2+2 is 4"
LINE1.XYZ > 2 | Evaluates to 1 if the distance of the centroid of LINE1 from the origin is greater than 2
LINE1.XYZ > LINE2.XYZ | Evaluates to 1 if the centroid of LINE1 is further from the origin than the centroid of LINE2
LINE1.XYZ = LINE2.XYZ | Evaluates to 1 if the centroids of LINE1 and LINE2 are the same (no coercion occurs in this case)
DOUBLE(LINE1.XYZ) = DOUBLE(LINE2.XYZ) | Evaluates to 1 if the centroids are the same distance from the origin
11% 3.1 | Evaluates to 2 (% is the modulo operator designed to work with integers. It returns the remainder from discrete division. 11%3 = 2. )
CIRCLE1.HIT [3.2].X | Evaluates to measured X value of third hit of Circle1. The argument 3.2 is automatically coerced to an integer with a value of 3.


ID Expressions

Many of the PC-DMIS commands use feature IDs as parameters. For example, constructed features use IDs to indicate which features are to be used as inputs for the constructed feature. ID expressions allow the user to refer to a specific instance of a feature, a group of similarly named features, an instance of a feature inside a call to a subroutine, or a feature in an external part program.

More:

Feature Array ID

ID Wild Cards

IDs for features within subroutines, basic scripts, or external programs

ID Expression Combinations


Feature Array ID

Use a feature array id to refer to a specific instance of a feature or to a range of feature instances. For example, if the feature "Circle1" were located in a while loop that looped five times, then five instances of the circle would exist upon exiting the loop. To refer to an individual instance of the five instances of "Circle1", use feature array syntax as described under "Feature Arrays:" where "Circle1[1]" would refer to the first instance, "Circle1[2]" would refer to the second instance, etc.

To refer to a range of instances use the .. notation. "Circle1[1..3]" refers to the 1st through 3rd instances of Circle1. "Circle[3..5] refers to the 3rd through 5th instances of Circle1. "Circle[1..5]" would refer to the 1st through 5th instances of Circle1. When a range of feature is referred to, the set is treated and behaves as a constructed set.


ID Wild Cards

Use ID Wild Cards to refer to a set of similarly named features. The two wild card characters are "*" and "?". (See "Selecting Features Using Meta-character matching" in the "Editing the CAD Display" section for additional information.)

The asterisk ‘*’ character is used to refer to 0 or more instances of any character. To refer to the set of all feature that start with the letters "CIR", use the expression ID "CIR*". This syntax will create a set of features that include all features with Ids that with "CIR", such as "CIRCLE1", "CIRCLE2", "CIR3", or "CIR".

Note: If CIR3 has several executions only the most recent measurement is used. To get the different instances of the executions, the following expression could be used: CIR?[1..3]

The question mark ‘?’ character is used to refer to a single instance of any character.

Example: The ID expression "MY???1" would create a set of features that are six characters long, begin with "MY" and end with "1", such as "MYCIR1", "MYCON1", "MYLIN1", or "MYFT21".


IDs for features within subroutines, basic scripts, or external

IDs for features within subroutines, basic scripts, or external programs

Subroutines can be located within the current part program or in an external part program. When the subroutine is located in the same program as the call to the subroutine, the feature array ID syntax explained under "Feature Arrays:" can be used to refer to individual instances of a feature created in the subroutine. However, when the subroutine is located in an external part program, the following syntax can be used to refer to any features created in the subroutine: "<Call Sub ID>:<FeatID>". For example, if a feature named "F1" were located in an external subroutine that was called from a Call Sub command with the id "CS1", then the ID expression "CS1:F1" could be used to refer to that feature.

Example: This example merely illustrates the use of the syntax CS1.F1 and is not intended to use.

Program 1: PLUS1.PRG

SUBROUTINE/PLUS1, A1 = 0, A2 = 0, A3 = 0
F1 =FEAT/POINT,RECT
THEO /A1+1,A2+1,A3+1,0,0,1
ACTL/3,1,1,0,0,1
MEAS/POINT,1
HIT /BASIC,A1+1,A2+1,A3+1,0,0,1,0,0,0
ENDMEAS/
ENDSUB/

Program 2: TEST.PRG

CS1 =CALLSUB/PLUS1,D:\V30\WINDEBUG\PLUS1.PRG: 3,3,3,,
DIM D1= LOCATION OF POINT CS1:F1 UNITS=IN,$
GRAPH=OFF TEXT=OFF MULT=10.00 OUTPUT=BOTH
AX NOMINAL +TOL -TOL MEAS MAX MIN DEV OUTTOL
X 3.0000 0.0000 0.0000 3.0000 3.0000 3.0000 0.0000 0.0000
----#----
END OF DIMENSION D1

Basic scripts create and delete objects dynamically. Use the syntax "<Basic Script ID>:<Feat ID>" to refer to a feature created by a basic script. For example, if a basic script with ID "BS1" creates a feature with ID "F2", use the ID expression "BS1:F2" to refer to that feature.

External programs can be attached to PC-DMIS using the attach command. To refer to features in the attached program use the following syntax: "<Attach Prog ID>:<Feat ID>". To refer to feature "F3" in the attached part program with ID "GEAR1", use the expression, "GEAR1:F3". (See "Attaching an External Part Program" in the "Adding External Elements" section for more information.)


ID Expression Combinations

Array ID Expressions , Wild Card ID Expressions, and external subroutine, basic script, and external part program ID Expressions can be used in combination. For example, to refer to the third instance of all features that start with the letters "CIR" in an external part program attached with the ID "BOLTPAT" use the ID expression "BOLTPAT:CIR*[3]".

Also, ID Expressions can be used in regular expressions. Thus, the measured centroid of the above set of features could be assigned to variable with the following expression:

ASSIGN/V1 = BOLTPAT:CIR*[3].XYZ

Also, ID Expressions can be used in regular expressions. Thus, the measured centroid of the above set of features could be assigned to variable with the following expression:

ASSIGN/V1 = BOLTPAT:CIR*[3].XYZ


Accessing a Report's Object Properties

PC-DMIS versions 4.0 and above support the ability to create your own custom report and label templates which PC-DMIS uses to display report data inside a Report window (see View | Report Window). These templates are created using template editors which utilize a Visual Basic-like interface which lets you insert, relocate, and size special components called "objects".

Each object consists of "properties" that define how it will be displayed and what information it holds. Some of these properties are in common with all other objects, some are in common with only related objects, and others are unique to that specific object.

The PC-DMIS Expression Language can query the current loaded Report and store property values of a particular object in a variable. It can obtain values of type String, Integer, and Real by using this syntax:

Property Query Syntax

Assign/V1 = Report.<Object Name>.<Property Name>

Report is a reference to the currently loaded report. <Object Name> is the object's unique name and <Property Name> is a valid property name for that object.

A Simple Example

Suppose, for example, that your report template has a text object called "Text1" that you want to use in the final report to display the operator's name. The actual string of characters representing the operator's name will be stored in the Text property of the object. By default, the text property (displayed text) initially has the value of "Text1" (see the figure below). Because this is a user-assigned property, this will change when the operator types in the name during execution.

Properties dialog box, showing a selected object and the property to query

To use the Expression Language code to query this Text object's "Text" property and obtain the keyed-in data, you would use the following command:

Assign/V1 = Report.Text1.Text

In this code, "Report" tells the code to look at the report loaded in the Report window. "Text1" tells it to look for the object named "Text1". "Text" tells it to look for the "Text" property within that object. The value of the "Text" property then gets passed into the V1 variable which you could then further manipulate or display using the PC-DMIS Expression Language.

Finding Properties

You can find what properties are associated with a particular object by accessing the Report template in the Report template editor (File | Reporting | Edit | Report Template), selecting the object, and then right-clicking on the object to display its property sheet.

The property sheet for a Text object

The property sheet contains two columns. The left column displays the property name, and the right column displays the current value. Be sure to use the exact property name in your expression code.

Important: When querying property values, you may find that some properties return a seemingly useless numerical value. Generally this happens when the property has a set list of available options, and PC-DMIS returns an internal value for the selected property that doesn't relate to the displayed property.

For example, the Text object has an Orientation property with these values:
0 - Horizontal
1 - Vertical up
2 - Vertical down

However, if you obtain the value using PC-DMIS expression language, the software will instead return the following:
0 (for Horizontal)
900 (for Vertical up)
-900 (for Vertical down)

It may require some trial and error to determine what returned values correspond with the value displayed on the property sheet.


Adding External Elements

Adding External Elements: Introduction

Inserting an External Command

Inserting BASIC Scripts

Attaching an External Part Program

Inserting External Objects


Adding External Elements: Introduction

This section discusses various external elements you can insert into your part programs. These include external applications, BASIC scripts, part programs, and other objects that will further enhance your part program 's capability.

The main topics discussed in this section include:

  • Inserting an External Command

  • Inserting BASIC Scripts

  • Attaching an External Part Program

  • Inserting External Objects


Inserting an External Command

External Command dialog box

Display Menu Roadmap

The Insert | External Command menu option allows you to insert a command into the Edit window that, when marked and executed, runs an external executable or batch file from the part program.

  • Normal DOS commands can be executed if they are put into a batch file.

  • The command must be marked in the Edit window for PC-DMIS to execute the external command.

  • A valid path and file name must be used.

  • PC-DMIS will halt the execution of the program and display a message when it encounters an EXTERNALCOMMAND/DISPLAY command during execution. Click OK to continue part program execution.

More:

To insert an External Command:

Display option

No Display option

Wait and No Wait options

. . . button

Creating an External Command as a Menu Item or Toolbar Item

Example - Using the External Command to Display a File


To insert an External Command:

Select the External Command menu option. The External Command dialog box appears.

  1. Specify an external command in the dialog box. You can do this by either typing the complete pathway for the file into the available box or by finding the file using the . . . button.

  2. Choose either Display or No Display.

  3. Click OK. The command gets inserted into the Edit window.

The Edit window command line for this option reads:

EXTERNALCOMMAND/DISPLAYSTATE ; path name

DISPLAYSTATE = This toggle field controls whether or not PC-DMIS pauses execution and displays a message notifying you of an external execution. This field switches between DISPLAY and NO DISPLAY.

path name = This string represents the path and file name of the executable or batch file.


Display option

Selecting the Display option displays a message that lets you know that program execution is paused in order to run the external command. PC-DMIS pauses execution until you click OK on the displayed message. Note that this message only appears if you have turned it on inside the Warnings Display Options dialog box.

To get this message to appear,

  1. Press F5 to access the Setup Options dialog box.

  2. From the General tab, click the Warnings button. The Warnings Display Options dialog box appears.

  3. Select the check box that reads OK Execution paused in order to spawn a process. Select OK to continue execution.


No Display option

Selecting the No Display option runs the specified external command without displaying any sort of message. PC-DMIS will continue execution while the executable or batch file runs simultaneously.


Wait and No Wait options

These options remain unavailable until you select the No Display option.

The Wait option pauses part program execution until the external command finishes its operation.

The No Wait option continues part program execution even if the external command hasn't finished its operation.


. . . button

The . . . button on the dialog box opens an Open dialog box. It allows you to select the file name for the external command. Once you open the file, PC-DMIS inserts the full path into the External Command dialog box.


Creating an External Command as a Menu Item or Toolbar Item

PC-DMIS allows you to customize toolbars and menus to accept new menu items tied to .EXE, .BAT, or .BAS files. For information on how to do this, see the "Customizing the User Interface" topic in the "Navigating the User Interface" section.


Example - Using the External Command to Display a File

This example shows how to create a batch file (an external program) that works with the EXTERNALCOMMAND to open and display a file. For example, suppose you want to display an image file, but you don't want to use the Insert | Report Command | External Object menu option, you can use a command-line (or DOS) prompt inside of a batch file to do this.

Note: The advantage or disadvantage (depending on your needs) to this approach is that the image will not appear in the report at the end of part program execution.

First, create a batch file to display the image:

  1. Open a text editor, such as Notepad, and on the first line put in this command:

start <PATHWAY>

where <PATHWAY> is the complete pathway to the picture (for example, start d:\temp\mypart.gif).

This command tells Windows to open the image file using its default image viewer application.

  2. Save the file and give it a .bat filename extension.

Second, link the External Command dialog box to the batch file:

  1. Select Insert | External Command. The External Command dialog box appears.

  2. Click the ... button. An Open dialog box appears.

  3. Under Files of Type list at the bottom of the Open dialog box, change the type to BAT Files (*.bat).

  4. Navigate to and select your batch file.

  5. Click the Open button. The Open dialog closes, and the External Command dialog box now contains the pathway to the batch (.bat) file.

Third, control what happens, and insert the command:

  1. Choose either to display or not display a message that pauses the execution of the part program by selecting the Display or the No Display option from the External Command dialog box.

  2. Click OK and the EXTERNALCOMMAND gets inserted into the Edit window.
    EXTERNALCOMMAND/DISPLAY ; E:\BATCH\TEST.BAT

Fourth, execute the program:

  1. Mark the resulting command line in the Edit window.

  2. Execute your part program.

  3. PC-DMIS will run the specified batch program, displaying the picture and, depending on what you selected on the External Command dialog box, will either pause or continue the part program while you view the picture.


Inserting BASIC Scripts

Display Menu Roadmap

The Basic Language Extension to PC-DMIS provides a powerful extension to the software’s functionality. Basic language scripts or applications may be written from within PC-DMIS (or imported from elsewhere) and linked to a button on a user definable toolbar, allowing the simple execution of powerful macros. The version of Basic featured in PC-DMIS provides all of the features of a high level language, including custom dialogs (created using the built in Dialog Editor), ODBC support and OLE support. These options are only available as an added option to the basic PC-DMIS geometric software package.

The Edit window command line for a sample script reads:
SCRIPT/FILENAME = C:\PCDMISW\sample.bas
FUNCTION/Main,SHOW=YES,,
ENDSCRIPT/

The FILENAME= field lets you specify the pathway to the BASIC file (.bas filename extension) that you want to insert and execute with the part program.

The FUNCTION/Main field runs the "Main" subroutine. You can change this to specify a different subroutine or function in the BASIC file to run.

The SHOW= field lets you determine whether or not commands automatically generated by your Basic Script appear in your part program after execution.

  • When you set SHOW=NO, generated commands will not appear in Summary mode, Command mode, or DMIS mode (commands still appear in the inspection report, however). Also, PC-DMIS will not save any generated commands with the part program.

  • When you set SHOW=YES, then generated commands appear in the part program and PC-DMIS will save generated commands with the part program. The default is SHOW=YES for part program compatibility from previous versions.

The PC-DMIS Manual Basic Language Help File completely describes this add on package. If you did not receive a copy of the help file with your Basic Language package, please contact your PC-DMIS software support representative.

More:

To Insert a Basic Script as a Command

To Insert a Basic Script as a Menu or Toolbar Item

Passing Variables To and From BASIC Scripts

Using the Basic Script Editor


To Insert a Basic Script as a Command

The Insert | Basic Script menu option brings up the Insert Basic Script dialog box.

Display Menu Roadmap

This dialog box allows you to add a basic script object to the part program. Basic script objects contain the name of the basic script that should be executed when the basic script object is executed. Execution of the part program does not continue until the basic script has executed. If the basic script creates any objects while executing, those objects will be inserted into the part program and executed. Objects inserted by Basic Scripts are highlighted in a different color than other objects to indicate that the basic script created them. For more information on Basic Scripts, see the PC-DMIS BASIC online Help .


To Insert a Basic Script as a Menu or Toolbar Item

PC-DMIS allows you to customize toolbars and menus to accept new menu items tied to .EXE, .BAT, or .BAS files. For information on how to do this, see the "Customizing the User Interface" topic in the "Navigating the User Interface" section.


Passing Variables To and From BASIC Scripts

From PC-DMIS code, variables can only be passed to BASIC scripts, not from BASIC scripts.

The only supported variable types that can be passed into BASIC scripts from PC-DMIS are:

  • Integer

  • String

  • Double

Consider these examples:

Note: PC-DMIS variables only hold values during part program execution; at learn time, PC-DMIS variables will always have a value of zero.

More:

Example 1: Using the Function Line to Pass Variables

Example 2: Using the GetVariableValueand SetVariableValueMethods to Pass Variables


Example 1: Using the Function Line to Pass Variables

The following command will execute a BASIC script named TEST.BAS. It will also, upon execution, pass the variables defined from the FUNCTION/ line into the TEST.BAS script:

CS2=SCRIPT/FILENAME= D:\PROGRAM FILES\PCDMIS35\TEST.BAS
FUNCTION/ShowVars,3,"Hello",2.5,,
STARTSCRIPT/

Now here's the TEST.BAS script; on execution it will display the passed in variables in their respective message boxes:

Sub ShowVars(IntVar As Integer, StrVar As String, DoubleVar As Double)

msgbox "The passed integer variable is " & IntVar

msgbox "The passed string variable is " & StrVar

msgbox "The passed double variable is " & DoubleVar

End Sub


Example 2: Using the GetVariableValue and SetVariableValue

Example 2: Using the GetVariableValue and SetVariableValue Methods to Pass Variables

The following example first uses PC-DMIS code to receive an integer value from the user and assigns it to the V1 variable.

C1=COMMENT/INPUT,Please type an integer value.
ASSIGN/V1 = INT(C1.INPUT)
COMMENT/OPER,BEFORE SCRIPT: Variable is:
,V1

It then calls a BASIC script named TEST2.BAS.

CS1=SCRIPT/FILENAME= D:\PROGRAM FILES\PCDMIS35\TEST2.BAS
FUNCTION/Main,,
STARTSCRIPT/
ENDSCRIPT/

Here is TEST2.BAS:

Sub Main
Dim App As Object
Set App = CreateObject ("PCDLRN.Application")
Dim Part As Object
Set Part = App.ActivePartProgram
Dim Var As Object
Set Var = Part.GetVariableValue ("V1")
Dim I As Object
If Not Var Is Nothing Then
Var.LongValue = Var.LongValue + 1
Part.SetVariableValue "V1", Var
MsgBox "V1 is now: " & Var
Else
Msgbox "Could Not find variable"
End If
End Sub

This script takes V1 variable and, using the GetVariableValue and SetVariableValue automation methods, increments the V1 by one and then sets the new value for V1 in the part program.

PC-DMIS then displays the changed variable in an operator comment.

COMMENT/OPER,AFTER SCRIPT: Variable is now
,V1


Attaching an External Part Program

Display Menu Roadmap

The Insert | Attach Part Program class opens the Attach External Part Program dialog box. You can use this dialog box to attach a part program to the current part program. This does not mean that PC-DMIS will actually attach and execute all the command in the specified part program. Instead, it attaches a pointer to the part program, allowing you to access its dimensional and feature data. See "Using a Pointer to Reference Data".

Attach External Part Program dialog box

This dialog box contains the following options:

Option | Description
External part program file name | This box allows you to type the pathway for the part program you are going to attach. If you prefer, you can use the Browse button which will also place the filename pathway into the box.
Equate Program Alignments | This area allows you to share alignments between two part programs by selecting them from the available lists. See "Equating an Alignment" in the "Creating and Using Alignments" section for additional information.

The Attach Part Program menu option is especially useful when working in multiple arm mode. With this option you can attach a part program from the "Slave" arm onto the part program of the "Master" arm. Attaching the part program allows the sharing of data so that both "Master" and "Slave" arms can run off the same alignment, pass feature data from one part program to another for calculations, and generally work in a cooperative manner. (See the "Using Multiple Arm Mode" section, for more information on multiple arm mode.)

More:

Using a Pointer to Reference Data


Using a Pointer to Reference Data

Often when you access an attached part program, you will want to use data from that part program. When referencing this data you must reference the pointer (or variable ) that contains the location of your part program.

Consider an example:

Suppose you're attaching TEST_A.prg to your current part program. Your attach command would look something like this:

CS1=ATTACH/C:\PCDMISW\TEST_A.PRG, Machine=

EQUATE/LOCAL ALIGNMENT = A1, ATTACHED ALIGNMENT = A1

Notice the pointer, CS1. You will use this pointer to extract data from the attached part program.

Now, suppose you wanted to display the measured X value for feature F1 from TEST_A.prg inside your current part program. You would use a statement like this.

COMMENT/OPER,"The X value for F1 from the attached part program is:"

,CS1:F1.X

The code, CS1:F1.X, essentially tells PC-DMIS to look at TEST_A.prg, find feature F1, and display the X value. This is the way pointers are referenced inside PC-DMIS.

PC-DMIS also lists features from an attached part program in the Construction or Dimension dialog box. PC-DMIS will display the attached part program’s ID pointer within the Feature List box. A plus sign (+) appears to the left of the pointer. Clicking this plus sign expands or collapses a view of all the features in the attached part program. After you expand the view to show all the features of the attached part program, you can select any of those features to use in the construction or dimension process.

Note: You can not select the attached program’s pointer. Only the expanded IDs associated with that pointer can be selected.


Inserting External Objects

Insert Object dialog box

Display Menu Roadmap

The Insert | Report Command | External Object menu option allows you to enter various types of objects from other applications on your system into the Edit window. Types of objects that can be inserted depend on the applications installed on the computer system. Examples of objects that can be inserted include graphics, sound clips, movie clips, midi clips, documents, worksheets, database tables, etc. Use external objects to import an instructional video, audio instructions or written instructions into your part program.

Important: Be sure to place the Edit window in command mode [image] when working with external objects.

More:

Create New

Create from File

Display as Icon

Object Type List

Marking External Objects for Execution

Displaying Files in a Different Way


Create New

The Create New option allows you to create a new file of a particular object type at a specified location in the Edit window. The object types are chosen from the Object Type list. Objects can only be placed just after or just before a feature in the part program.

To create a new object and place it in the Edit window:

  1. Select the Create New option.

  2. Select the desired object type from the Object Type list. The object will appear in a box, bounded by small rectangular points within your Edit window. Using your mouse you can drag the box to another location or resize the box using the small rectangles.

  3. Double-click within the object. You will see that the application that runs that particular object will open in the Edit window.

  4. Modify the object by using the tools specific to the inserted application.

  5. When you are done, click on the portion of the Edit window that is outside of the inserted object.

Example: If you want to include a new word document in the Edit window:

  1. Select the Create New option.

  2. Select a word document object from the Object Type list.

  3. Drag the object box with the mouse to a desired location within the Edit window.

  4. Resize the box to the desired size.

  5. Type the information within the word document object.

  6. Click outside of the object to return to normal PC-DMIS Edit window functions. The word document will remain in the Edit window.

Example of a word document created in the Edit window. Notice how the Edit window menus and toolbars are replaced with the menus and toolbars of the application that corresponds to the object you are creating.


Create from File

The Create from File option allows you to insert previously created file as an object into the Edit window.

To insert a previously created object:

  1. Select the Create from File option.

  2. Type the directory path that contains the file you want to place as an object. Or use the Browse button to navigate to the correct directory.

  3. Select the file to insert as an object.

  4. Click the OK button. The object will now appear in the Edit window. Using your mouse you can drag the box to another location or resize the box using the small rectangles.

Example: If you want to insert a previously written word document into the Edit window that includes a set of instructions about operating the CMM, select the Create from File option, navigate to the directory that contains the document, click the OK button. The document appears within the object box in the Edit window. Using the mouse, move the object box to where you want it in the Edit window and resize it.

More:

Link


Link

When you select the Create from File option you have the opportunity to "link" your object to the Edit window. When you link your object back to its original file, any changes made to the original file will also be updated within the Edit window.


Display as Icon

The Display as Icon check box allows you to display the imbedded object as an icon, instead of displaying the information out right. Once you double-click on the icon within the Edit window, it will then activate.

Example: Suppose you place a word document in the Edit window and select the Display As Icon check box. The word document will appear as an icon. However, if you double-click on the icon, the imbedded application opens, displaying the information contained in the word document.

Example of a word document object displayed as an icon


Object Type List

Sample Object Type list

The Object Type list contains the object types available on your computer system. These will vary from computer to computer depending on what application programs you have installed on your hard drive.

To choose an object type:

  1. Use the scroll bar or UP ARROW and DOWN ARROW keys to find the object.

  2. Select the object.

  3. Click the OK button.


Marking External Objects for Execution

By default, external objects print and do not execute when executing a part program. However, with some objects, the desired action may be to execute and not print.

Example: When embedding a graphic, the desired action may be to print the graphic to the report; while when embedding a sound or movie clip, the desired action may be to execute the object to play the clip at execution time.

External objects have four modes of execution:

  1. Print – Don’t execute

  2. Don’t print – Don’t execute

  3. Don’t Print – Execute

  4. Print – Execute

To switch between the different modes, press F3 while the insertion point is on the same line as the external object in the Edit window. PC-DMIS will use hash lines and borders to indicate the objects current mode of execution. See the examples below.

  • Hash lines¾diagonal lines that cross the graphic. When there are hash lines the object will not print to the report.

  • Hashed borders¾diagonal lines that cross the border around the graphic. When a hashed border outlines the object, the object will execute.

Example

Behavior

No Hash Lines - No Hashed Border

  • Print

  • Don't Execute

Hash Lines - No Hashed Border

  • Don't Print

  • Don't Execute

Hash Lines - Hashed Border

  • Don't Print

  • Execute

No Hash Lines - Hashed Border

  • Print

  • Execute

Note: The execute action is always the same action that occurs when an external object is double-clicked. For media clips, this default action is usually play. For most other objects, the default action is edit.
Play Sound clips will play sound. Movie clips will play their movie, etc.

Edit Objects that have a default action of edit will usually not be objects that would need to be executed. However, some application objects also have the ability to run custom basic scripts upon being activated. A word document or excel spreadsheet are examples of this type of external object. With these types of objects and the PC-DMIS automation commands, it is possible to change the object using data from the part program. For example, an excel graph could be inserted inside a part program that has a basic script that, when activated, would pull data out of the part program using the PC-DMIS automation commands and adjust the graph accordingly before it was printed on the inspection report.


Displaying Files in a Different Way

An alternate way to display files is by using PC-DMIS's EXTERNALCOMMAND Edit window command. See "Example - Using the External Command to Display a File" for information.


Using Multiple Arm Mode

Using Multiple Arm Mode: Introduction

Setting up a Multiple Arm CMM

Creating a Part Program Using Multiple Arm Mode

Running a Master Part Program on the Slave Arm


Using Multiple Arm Mode: Introduction

The Multiple Arm mode was created to drive multiple arm CMMs. The Multiple Arm mode is available as an add-on package. Currently, this version only supports a multiple arm mode of two arms. The two arms must be connected to separate computers with a version of PC-DMIS and a portlock on each computer. These arms will share a common alignment.

Later versions of PC-DMIS, will allow you to drive up to four machine arms from one version of PC-DMIS, using any combination of one to four computers.

While the measurement process for multiple arms is comparable to single arm units, PC-DMIS must be able to distinguish the arm that is taking the measurement when using a multiple arm system. The topics in this section will explain how to do this.

The main topics in this section describe how to setup a Multiple Arm CMM, how to create part programs using multiple arms, and how to run a 'master' part program on a 'slave' arm. These topics are:

  • Setting up a Multiple Arm CMM

  • Creating a Part Program Using Multiple Arm Mode

  • Running a Master Part Program on the Slave Arm

  • Dialog and Message Boxes in Multiple Arm Mode

Note: PC-DMIS must be installed on all systems prior to running in multiple arm mode.


Setting up a Multiple Arm CMM

To setup a multiple arm CMM, follow these steps:

More:

Step 1: Install PC-DMIS on All Computers

Step 2: Determine the Master System

Step 3: Match the CMM Axes for Each Arm

Step 4: Configure Probe Head Mount Orientation

Step 5: Setup the Master and Slave

Step 6: Connect the Computers

Step 7: Enter Multiple Arm Mode

Step 8: Calibrate the Multiple Arm System

Step 9: Calibrate the Multiple Arm Probe Files

Step 10: Set the Multiple Arm Origin


Step 1: Install PC-DMIS on All Computers

The first step needed, to make this option accessible, is to install PC-DMIS on all the computers that will drive the multiple arms. (See the documentation on software installation procedures if necessary.)

The Multiple Arm option must be programmed in all port locks. To verify this:

  1. Select Help | About PC-DMIS For Windows. The About PC-DMIS for Windows dialog box opens displaying information about the developers and modules installed.

  2. Pull down the Modules drop-down list and look for Multiple Arm. If it is listed, then it is turned on for the current port lock.

This should be available on all computers.

Next Step


Step 2: Determine the Master System

Determine the master system. In most cases, any arm controller can be used. However, if the multiple arm system has a rotary table, then the master must be the controller that controls the rotary table.

Label the master and slave arms in some way. Most users usually call the master arm "ARM1" and the slave arm "ARM2".

Next Step


Step 3: Match the CMM Axes for Each Arm

The CMM axes for each arm must match. That is the X+, Y+, and Z+ axes for all arms must go in the same direction.

If you need to change the axes assignments and directions:

Display Menu Roadmap

  1. Make sure you're running PC-DMIS in Online mode.

  2. On the slave computer, select Edit | Preferences | Machine Interface Setup. The Machine Options dialog box will appear.

  3. Select the Axes tab. This will show the X,Y, and Z axes combination boxes.

  4. Using the X, Y, or Z lists, reassign the axes of the connected CMM so that they match the axes of the master arm. Usually only the X and Y axes will need modification.

  5. Click Apply to keep the changes.

  6. Once the dialog box closes, exit PC-DMIS.

  7. Restart PC-DMIS, and verify that the changes are correct by moving the axes for both arms in the same directions. Make sure the axis counters increment accordingly.

Note: The numerical values in the counters will not match until you complete the Master / Slave Calibration.)

Next Step


Step 4: Configure Probe Head Mount Orientation

Once PC-DMIS is loaded on all systems, and the axes match for both arms, configure your probe head mount orientation:

  1. Select Edit | Preferences | Setup to bring up the SetUp Options dialog box. Display Menu Roadmap

  2. Select the Part/Machine tab.

  3. Click the Probe Head Orientation button. The Probe Head Wrist Angle Configuration dialog box appears.

Probe Head Wrist Angle Configuration dialog box

  4. Change the mount orientation as needed for each CMM arm.

Next Step

More:

This computer (slave) relays commands from the main computer

This computer (master) drives all arms

This computer is not used in a multiple arm setting


Step 5: Setup the Master and Slave

The next step is to set up the multiple arm mode for the current computer. Select the Edit | Preferences | Multiple Arm Setup menu option. This menu option displays the Multiple Arm Setup dialog box.

Display Menu Roadmap

Multiple Arm Setup dialog box

Use this dialog box to determine whether the current computer is the master computer and sends commands to the slave arms, or if the current computer is a slave computer that relays commands from the master computer.

When you finish making changes to this dialog box and click OK, PC-DMIS displays a warning message that says you will need to restart PC-DMIS in order for your changes to take effect.

  • This computer (slave) relays commands from the main computer

  • This computer (master) drives all arms

  • This computer is not used in a multiple arm setting

Next Step


This computer (slave) relays commands from the main computer

The 'This computer (slave) relays commands from the main computer' option allows the computer to be used only with a slave arm and relays commands from the main computer. You can choose to connect using a TCPIP Port.


This computer (master) drives all arms

The 'This computer (master) drives all arms' option allows the computer to be the master computer that drives all the arms. You can choose to connect the computer to the other arms using either a Direct Connection or a Remote Connection.

If you select the Remote Connection option, you can connect to the other arms. To do this:

  1. Select the arm from the Connection Settings for Arm list.

  2. Type the IP address in the box next to Remote Connection. Type the IP address' port number in the Port Number box.

  3. Specify the TCPIP connection delay in the Delay for TCPIP connection in milliseconds box. This value is the number of milliseconds that PC-DMIS will delay before attempting a TCPIP connection to the current arm to the current computer.


This computer is not used in a multiple arm setting

If the computer is not used in a multiple arm setup, select the 'This computer is not used in a multiple arm setting' option.


Step 6: Connect the Computers

Now, you need to connect the computers so they can communicate with each other. You can either use a null modem serial cable between the computers, or if the computers are connected to a network, you can use the network to communicate between them. The "Step 5: Setup the Master and Slave" topic allows you to configure these communication settings.

Once the computers are connected,

  1. Start up PC-DMIS on the Slave systems. Do not create a new part program or activate a program. The Slave systems are now ready.

  2. Start up PC-DMIS on the Master system. Create a new part program (or activate one that is already available). If you are creating a new part program, PC-DMIS automatically opens the Probe Utilities dialog box.

  3. Either select or create a probe file that describes a probe on the master arm. Make sure that you add an AB angle for the tip you plan to use to calibrate the relationship between the two arms. Don't calibrate the probe at this time.

Next Step


Step 7: Enter Multiple Arm Mode

Once you have setup the computers, and are in a part program, the Operation | Enter Multiple Arm Mode menu option becomes selectable from the master computer. Select the Enter Multiple Arm Mode option.

Display Menu Roadmap

PC-DMIS displays a check mark to the left of the Operation | Enter Multiple Arm Mode option in the menu. PC-DMIS also displays the Active Arms toolbar

When PC-DMIS enters multiple arm mode it attempts to establish a link between the multiple computer systems. This link coordinates the activities of all the arms.

Troubleshooting

If PC-DMIS cannot establish the link among the computers after entering multiple arm mode, you will get an error message informing you of the arm that isn't responding. The following may cause this communication problem:

  • PC-DMIS is not running on a computer

  • An on-line part program is active on a slave computer

  • The cable connections (or other network connections) between the computers are not functioning

  • Settings entered in the Multiple Arm Setup dialog box are incorrect

Once you have a link established between the multiple computers, you can calibrate the relationship between the arms.

Note: Exiting the active part program, also removes PC-DMIS from multiple arm mode.

Next Step


Step 8: Calibrate the Multiple Arm System

The step walks you through the calibration of the multiple arm system.

Prior to calibration and after PC-DMIS has been started on the computer systems, you must define any probes that will be used in the measurement process. PC-DMIS uses the theoretical data from the probes to calibrate the multiple arm system.

Important: Do not calibrate the probes at this time, only ensure they are properly defined and that you add an AB angle for the tip you plan on using to calibrate the multiple arm system.

In your part program, you should have multiple LOADPROBE commands, one for each arm.

Caution: If you've attempted a multiple arm calibration previously, then PC-DMIS has created armtoarm.dat files located where you installed PC-DMIS on both the master and slave computers. You should delete or rename these files before proceeding so that data from previous calibration attempts doesn't negatively affect your current calibration process.

Follow these calibration procedures:

  • Part 1 of Calibration Procedure

  • Part 2 of Calibration Procedure

  • Performing an Automatic Calibration

Next Step:


Part 1 of Calibration Procedure

Multiple Arm Calibration dialog box

  1. Select the Operation | Calibrate/Edit | Multiple Arm Mode menu option (only available in on-line mode). Display Menu Roadmap This will display the Multiple Arm Calibration dialog box.

  2. Ensure that the correct probe files and tips are selected from the arm lists in the dialog box.

  3. Ensure that the calibration tool you will be using is available from the List of Available Tools list. You will only need the tool if you selected the Both arms measure tool option.

  4. Choose what you want to calibrate by selecting either the Orientation and origin option, or the Origin only option.

  • Selecting the Orientation and origin option creates a 3D transformation between the two arms to compensate for any out-of-squareness between the two arms. You must do this at least once (normally this is done periodically every few months).

  • Selecting Origin only corrects only the origin between the two arms. You should do this type of calibration more frequently, based on probe calibration procedures. When calibrating your probe, PC-DMIS asks if you moved your tool. If you normally indicate to PC-DMIS that you haven't moved the tool, then you don't have to adjust your arm to arm origin. If you answer that you have moved the tool, then after calibrating your probe tips you should return to this dialog box and choose the Origin only type of arm to arm calibration.

Important: When selecting to calibrate the Origin only, make sure you are using calibrated tips.

  5. Choose how you want to perform the calibration by selecting either Manual Calibration or DCC Calibration.

  • If you selected the Manual Calibration option, PC-DMIS will prompt you to measure each sphere position using the CMM 's jog box. Once you have taken the first hit on the top of the sphere, PC-DMIS will take the rest of hits in DCC mode.

  • If you selected the DCC Calibration option, PC-DMIS will allow you to supply the sphere positions and it will do all the motion under computer control. Click the Edit Positions button to change the location of each sphere position by typing the X, Y and Z coordinates. You may find it helpful to read the position of the active arm to fill in these three values. Be aware that clicking the Done button on your jog box can read the arm's current position

Important: You must first do at least one origin arm to arm calibration in Manual mode to establish the basic relationship between the two arms. When you complete an arm to arm calibration, PC-DMIS generates an armarm.results file stored in the directory defined through the Set Search Path menu option (see the "Specifying External Directories to Search" topic in the "Setting your Preferences" section. This text file is viewable using any text editor. It shows how beneficial the spheres where once you have done the initial fit. In particular it displays the "fitment error". This information may help to show the overall accuracy of the calibration..

  6. Type a number in the Number of spheres to measure box. The value determines how many spheres PC-DMIS will measure for each arm. If you type a number of spheres greater than 1, PC-DMIS will average the measurements to create the origin.

  • If you're using the Manual Calibration option, PC-DMIS will prompt you to manually measure these positions.

  • If you're using the DCC Calibration option, PC-DMIS will automatically drive each arm to measure these positions. The minimum number of spheres is three.

Caution: Ensure that the spheres aren't in the same position. Otherwise calibration will finish with incorrect results.

  7. Using the available options below, determine how the arms are used to measure the tools.

Both arms measure tool

      • If you select this option while using Manual Calibration, PC-DMIS will prompt you to measure each sphere position with both arms.

      • If you select this option while using DCC Calibration, PC-DMIS will drive both arms to measure a sphere at each of the positions defined in the Edit Calibration Positions dialog box. Be sure to have the desired number of sphere positions actually present on the CMM since there will not be enough time to physically move the sphere around in between measurements.

First arm holds tool and second arm measures

      • If you select this option while using Manual Calibration, PC-DMIS will prompt you to move the master arm to each position and then measure the spherical tool with the slave arm

      • If you select this option while using DCC Calibration, PC-DMIS will move the Master arm to each of the given calibration positions and then command the Slave arm to measure the sphere at that position. For this option, you will need a special sphere mounted into the end of the arm.

Second arm holds tool and first arm measures

      • If you select this option while using Manual Calibration, PC-DMIS will prompt you to move the slave arm to each position and then measure the spherical tool with the master arm.

      • If you select this option while using DCC Calibration, PC-DMIS will move the slave arm to each of the given calibration positions and then command the master arm to measure the sphere at that position. For this option, you will need a special sphere mounted into the end of the arm.

  8. Click Calibrate once this button becomes enabled. It remains disabled until you select all needed calibration parameters.

If you select Both arms measure tool, you must provide the following items before the Calibrate button will become available:

    • A valid Arm1 probe file name and tip angle.

    • A valid Arm2 probe file name and tip angle.

    • A valid Tool specified in the List of Available Tools.

If you select First arm holds tool and second arm measures, you must provide the following items before the Calibrate button will become available:

    • A valid Arm1 probe file name and tip angle.

    • A valid Arm2 probe file name and tip angle.

    • The Arm1 tip type must be of type FIXEDBALL as specified in the probe.dat.

If you select Second arm holds tool and first arm measures, you must provide the following items before the Calibrate button will become available:

    • A valid Arm1 probe file name and tip angle.

    • A valid Arm2 probe file name and tip angle.

    • The Arm2 tip type must be of type FIXEDBALL as specified in the probe.dat.

9. Once you click this button PC-DMIS will begin the calibration that you have requested. This creates an alignment between the master and the slave arm, by leveling, rotating, and setting the origin.

  • If you selected the Manual Calibration option, you will begin by taking one point on the top of the tool. PC-DMIS will then automatically measure the rest of the points. Once you have measured the tool in the current position, PC-DMIS will prompt you to move it to a new location on the table.

  • If you selected the DCC Calibration option, PC-DMIS will just measure each of the given calibration sphere positions. Make sure the tool locations on the table are not co-linear (in a line). Position the tool locations as far as possible from each other, with at least one of the positions, being raised up in the Z axis.

Note: An alternate way to calibrate DCC machines involves performing a Manual Origin only calibration followed by a DCC Orientation and origin calibration. This method is useful on larger machines where it is reasonable to assume that the X and Z axes are relatively parallel. This would then be followed with probe calibration and then an Origin only calibration.

Next Part of Procedure


Part 2 of Calibration Procedure

Once you have completed the calibration described in Part 1, you need to calibrate the master and slave probe files on the same calibration tool. This resets the origin relationship between the two tips. It doesn't change the level or the rotate of the alignment, only the origin. If you are using a PHS wrist, you need to do a wrist calibration with both arms on the common tool.

Follow this procedure:

  1. Click the Arm 1 Active button on the Active Arms toolbar. Most users assign this button to the Master computer.

  2. Access the Probe Utilities dialog box (Insert | Hardware Definition | Probe). Display Menu Roadmap

  3. If PC-DMIS asks you if you want to load a new probe file, click No.

  4. Calibrate the master probe (or do a wrist calibration if you are using a PHS). PC-DMIS will ask if the tool has been moved.

  5. Click Yes.

  6. When you complete the calibration, then exit the Probe Utilities dialog box.

  7. Click the Arm 2 Active button on the Active Arms toolbar. Most users assign this button to the Slave computer.

  8. Access the Probe Utilities dialog box to calibrate the slave probe (or do a wrist calibration if you are using a PHS).

  9. This time when PC-DMIS asks you if the tool has been moved, click No.

Once you have calibrated both probe files in multiple arm mode, you are done with the calibration of the multiple arms. PC-DMIS will copy the slave probe file, the tool data, and the arm-to-arm transformation data to the slave computer. This allows you to run the slave arm on its own as if it were an extension of the master coordinate system or you can always run them together in multiple arm mode.

Viewing Calibration Results

If needed, you can access the calibration results by clicking on the Results button of the Probe Utilities dialog box. This displays the Calibration Results dialog box which will display information about the calibrated tips of the related probe file. With version 4.3 and higher, you can view the slave calibration results in this same way on your Arm 2 computer.


Performing an Automatic Calibration

In addition to the usual multiple arm calibration, PC-DMIS allows you to perform an automatic calibration of the arms.

PC-DMIS provides a command that automatically calibrates the current probe during part program execution. PC-DMIS will begin the calibration routine once it executes the command.

To insert this command, select the Insert | Calibrate | AutoCalibrate Multiple Arm menu option.

Display Menu Roadmap

The following command block is inserted into the Edit window:

AUTOCALIBRATE/MULTIPLEARM, ARM_THAT_MEASURES=BOTH, CALIBRATION_MODE=DCC , QUALTOOL_ID=cal_m, MEASURE_AT_CENTER=0,0,0

A description of the items in this command block is given here:

Item | Description
ARM_THAT_MEASURES= | Indicates which arm will perform the measurement (not which arm will hold the tool). Choices are BOTH, ARM2 or ARM1.
CALIBRATION_MODE= | Indicates whether you will perform the calibration in MANUAL or DCC mode.
QUALTOOL_ID= | Specifies the name of the qualification tool used.
MEASURE_AT_CENTER= | The X, Y, Z location to be used for measurement when using CALIBRATION_MODE=DCC. This will not be present on the command is using CALIBRATION_MODE=MANUAL

Pressing F9 accesses the AutoCalibrate Multiple Arms dialog box.

AutoCalibrate Multiple Arm dialog box

Most of the items in this dialog box are the same as those used in the Multiple Arm Calibration dialog box. Below are two significant differences.

First, PC-DMIS currently only supports the Origin Only calibration type for this command. Therefore, Origin Only and the number of spheres cannot be changed. Since PC-DMIS only supports one sphere for this command, there isn't a separate button for editing all the sphere locations. You can specify the one sphere location in this dialog box, using the X, Y, and Z Center boxes. They specify the X, Y, and Z coordinates for the one sphere location when using DCC Calibration.

Second, you cannot specify the probe and tip for the master or slave. They are shown in the lists on this dialog box for information purposes only. The AUTOCALIBRATE/MULTIPLEARM command will get them from the content of the program in which the command is used.

Master Probe | For display only. This is determined by the LOADPROBE command for the Master Arm that precedes the AUTOCALIBRATE/MULTIPLEARM command
Master Tip | For display only. This is determined by the TIP command for the Master Arm that precedes the AUTOCALIBRATE/MULTIPLEARM command
Slave Probe | For display only. This is determined by the LOADPROBE command for the Slave Arm that precedes the AUTOCALIBRATE/MULTIPLEARM command
Slave Tip | For display only. This is determined by the TIP command for the Slave Arm that precedes the AUTOCALIBRATE/MULTIPLEARM command


Step 9: Calibrate the Multiple Arm Probe Files

Display Menu Roadmap

Now that the system has been calibrated, you will need to calibrate the multiple arm probe files.

For this calibration, you can:

  • Calibrate any arm in any order.

  • Use different calibration tools to calibrate the different arms.

  • Calibrate the slave arm from the slave computer and the master arm from the master computer.

  • Calibrate the slave probe on the same calibration tool as the master probe.

  • Only calibrate one arm at a time.

After this calibration, PC-DMIS synchronizes the probe files from the multiple computers the next time you enter multiple arm mode on the Master computer.

  • Arm 1 (Master) Probe File Calibration

  • Arm 2 (Slave) Probe File Calibration

Next Step


Master Probe File Calibration

Arm1 (Master) Probe File Calibration

If you want to calibrate the master probe file,

  1. Select the Arm 1 Active icon from the Active Arms toolbar.

  2. Access the Probe Utilities dialog box (Insert | Hardware Definition | Probe). Display Menu Roadmap

  3. Follow existing procedures in the "Measure" topic of the "Defining Hardware" section for information on how to calibrate probe files.


Slave Probe File Calibration

If you want to calibrate the slave probe file,

  1. Select one of the slave arm icons from the Active Arms toolbar (Arm 2 Active).

  2. Access the Probe Utilities dialog box. Display Menu Roadmap

  3. Follow existing procedures in the "Measure" topic of the "Defining Hardware" section for information on how to calibrate probe files.

If you want to use a calibration tool different from the one used for the master probe file, select the SLAVESPHERE tool during slave probe calibration.

To select the SLAVESPHERE tool:

  1. Select Insert | Hardware Definition | Probe from the menu bar. Display Menu Roadmap

  2. Click Measure. The Measure Probe dialog box appears.

  3. Click Edit Tool. The Edit Tool dialog box appears.

  4. Select SLAVESPHERE from the Tool Type list.

  5. Click OK to confirm your choice. The SLAVESPHERE information appears in the bottom of the Measure Probe dialog box.


Step 10: Set the Multiple Arm Origin

The final step in calibrating the multiple arm system is to set the origin between the two arms. This should be done with calibrated probe files on both the master and slave arms.

To set the multiple arm origin:

  1. Access Multiple Arm Calibration dialog box (Operation | Calibrate/Edit | Multiple Arm Mode). Display Menu Roadmap

Multiple Arm Calibration dialog box

  2. Select the Origin only option.

  3. In the Number of spheres to measure box, type the number of spheres you want to measure to establish the origin. If more than one sphere position is measured, PC-DMIS will average the positions to establish the origin.

  4. Select the Both arms measure tool option.

  5. Select the correct probe files and tips.

  6. Select either the DCC Calibration or Manual Calibration options. If you selected DCC Calibration, make sure you define the correct sphere position using the Edit Calibration Positions dialog box.

  7. From the List of Available Tools, select a tool that defines the correct diameter and orientation of the calibration tool to be measured.

  8. Click the OK button.

  • If you selected the Manual Calibration option, PC-DMIS will ask you to measure a single point on the sphere with the multiple arms. It will then measure the rest of the points in DCC mode around the sphere.

  • If you selected the DCC Calibration option, PC-DMIS will drive the arms to the sphere positions that are defined in the Edit Calibration Positions dialog box.

Once you have calibrated all the probe files in multiple arm mode and set the arm to arm origin, the calibration process is complete.

Important: After you finish your multiple arm calibration and perform a wrist calibration (see "Wrist Calibration" in the "Using a Wrist Device" section), you need to repeat the Origin Only wrist operation as discussed early on in the "Step 8: Calibrate the Multiple Arm System".

PC-DMIS will copy the slave probe file, the tool data, and the arm to arm transformation data to the slave computer. This allows you to run the slave arm on its own as if it were an extension of the master coordinate system. You also have the option of running them together in multiple arm mode. Each time you enter multiple arm mode (by selecting Operation | Enter Multiple Arm Mode), PC-DMIS will synchronize the following between the two computers:

  • Probe file changes

  • Wrist calibration changes

  • Error map data changes

  • Probe changer data

  • Calibration tool data changes


Creating a Part Program Using Multiple Arm Mode

Once the probes have been defined and calibrated, the part program can be created. You create a multiple arm part program like any other part program with some differences. Mainly, in a multiple arm part program, you need to assign specific arms to execute different commands and define exclusion zones so that the arms don't collide. The topics below describe how to do this:

More:

Assigning a Command to An Arm

Multiple Arm Program Execution

Setting Start Points for Multiple Arms

Causing an Arm to Wait to Prevent Collision

Using Temperature Compensation with Multiple Arm Calibration


Assigning a Command to An Arm

By default PC-DMIS assigns new commands to the current active arm. You can use the Active Arms toolbar to switch the current active arm or to execute only those commands tied to a specific arm.

Active Arms toolbar

Arm 1 (Master Mode)

Arm 2 (Slave Mode)

Execute on Arm 1

Execute on Arm 2

The Active Arms toolbar contains multiple arm icons with corresponding color coded check mark icons. Each arm icon corresponds to an arm on the machine.

The arm icons allow you to switch the current active arm.

The execute icons (those with check marks) allow you to execute only those commands associated with a specific arm.

After you entering into multiple arm mode, PC-DMIS inserts colored vertical lines into the left margin of the Edit window's command mode to show what arm will use the selected command. (In Summary Mode PC-DMIS indicates commands assigned to a slave arm with bold text.):

Edit window with green (feature CIR1) and red (feature LIN1) lines designating arm 2 and arm 1 portions respectively

  • Features assigned to arm 1 (the master arm) are indicated using the red line.

  • Features assigned to arm 2 (the slave arm) are indicated using the green line.

  • Features assigned to multiple arms are indicated using multiple colored lines.

Colored horizontal bars (instead of vertical) signify that the commands affect both arms and neither arm will be allowed to execute this command until both arms have executed all prior commands. This type of command (usually a branching or alignment command) is executed by both arms at the same time.

More:

Assigning Existing Commands to a New Arm


Assigning Existing Commands to a New Arm

The Toggle Multiple Arm Markings menu item is only available on systems that have entered into multiple arm mode.

If you have commands assigned to a particular arm and you want to assign them to a different arm, do the following.

  1. Place the Edit window into Command mode.

  2. Select the Edit window command you want to add.

  3. Select the Operation | Toggle Multiple Arm Markings menu item from the menu bar. Display Menu Roadmap

When you select this option, PC-DMIS will connect all of the highlighted commands to the other arm.

  • If you don't highlight any commands, then PC-DMIS will connect the command where the cursor resides in the Edit window.

  • You can connect most commands to the master arm, the slave arm, or both arms. For example, you could create a PREHIT or ALIGNMENT command that applies to both the master and the slave arm, or to just one of the arms.

  • You cannot assign certain commands to multiple arms. These include features, hits, dimensions, and probe commands.


Multiple Arm Program Execution

Unless you choose to execute just the commands assigned to a particular arm, when you execute the part program, the program flow continues as it normally does from the top of the Edit window to the bottom, and each arm executes the commands assigned to it.

Note: When executing in multiple arm mode, the slave arm will always run a little behind the master arm. This type of delay is normal.


Setting Start Points for Multiple Arms

PC-DMIS allows you to assign start points for the current arm by selecting the Set Start Point icon from the Edit window toolbar or by right-clicking in the Edit window in Command mode and selecting it from the shortcut menu.

To set multiple start points, change the current learn arm before clicking on the Set Start Point toolbar icon.

A special start point arrow will appear in the left margin of the Edit window in a color that corresponds to the active arm color on the Active Arms toolbar.

The screen capture to the left shows that Arm 1, in red, will begin execution at CIR3 while Arm 2, in green, will begin execution at CIR2.

If you cancel execution, PC-DMIS will automatically move the start points for each arm to the command where execution was cancelled for each arm.

Start points tell PC-DMIS to begin the program's execution at that point when you select the File | Partial Execution | Execute From Start Points menu option. For information on using Start Points, see the "Setting Start Points" topic in the "Editing a Part Program" section.

Important: Be aware that if the current tip for that location in the program does not match the current orientation of the probe head, PC-DMIS will not try and go back to execute the tip command above it in order to change the tip orientation.


Causing an Arm to Wait to Prevent Collision

Some times you may want one arm to wait until the other arm has finished measuring in an area that is overlapping. This is usually to prevent a collision between the arms. There are two different commands to prevent this.

More:

Using a Move Sync Command

Using a Move Exclusive Command


Using a Move Sync Command

You can put MOVE/SYNC commands at the beginning and end of a measurement sequence where you want to make sure that only one arm is moving. See "Inserting a Move Sync Command" in the "Inserting Move Commands" section for additional information.


Using a Move Exclusive Command

You can use the MOVE/EXCLUSIVE_ZONE command.

  • The advantage of using this method is that PC-DMIS will only make one of the arms wait if the other arm is in its zone.

  • The disadvantage is that you need to put MOVE/EXCLUSIVE_ZONE commands around all the blocks of commands that command an arm into the overlapped area in the middle of the dual arm volume.

To use this command:

  1. Find the sequence of commands that cause one of the arms to enter into an overlapped portion of the CMM volume.

  2. Place a MOVE/EXCLUSIVE_ZONE=ON command at the start of the sequence.

  3. Place a MOVE/EXCLUSIVE_ZONE=OFF at the end of the sequence.

The MOVE/EXCLUSIVE_ZONE=ON allows you to specify two corner points that form a 3D zone. This zone will be reserved for the arm that is assigned the command. If the other arm is already in the requested zone, then PC-DMIS will wait until the first arm is out of the way and exits the contested space with a MOVE/EXCLUSIVE_ZONE=OFF command. See "Inserting an Exclusion Zone Command" in the "Inserting Move Commands" section for additional information.


Using Temperature Compensation with Multiple Arm Calibration

A thermocouple is a thermoelectric couple that measures temperature differences.

If you're compensating for temperature on the CMMs, you will need to insert two temperature compensation commands into the program—one command for the master arm (ARM 1) and another command for the slave arm (ARM 2). Also, only the thermocouple for the part which is attached to the master controller will be used for recording the part temperature.

In addition to having the STP file (Serv1.stp) in the appropriate directory on the slave arm's computer, you must also ensure that another STP file for the slave arm (named Serv1s.stp) resides in the corresponding directory on the master arm's computer. To do this, copy Serv1.stp from the slave arm's computer, rename it to Serv1s.stp and place it on the master arm's computer.

Synchronizing Arms for TEMPCOMP Commands

Once you have the TEMPCOMP commands inserted, you will need to ensure that the arms are synchronized. To do this, insert two MOVE/SYNC commands, one before and one after the TEMPCOMP command assigned to ARM 2, as shown here:

The highlighted items in this graphic show the two MOVE/SYNC commands around the TEMPCOMP command for ARM 2

  • The first MOVE/SYNC command provides the correct sequence for writing temperature values to the report. This ensures that temperature values are displayed for ARM 1 first.

  • The second MOVE/SYNC command prevents AMR 2 from measuring until ARM 1 finishes obtaining the part's temperature.

For more information on MOVE/SYNC, see "Inserting a Move Sync Command" in the "Inserting Move Commands" section.

For more information on Temperature Compensation, see the "Compensating for Temperature" topic in the "Setting Your Preferences" section.


Running a Master Part Program on the Slave Arm

If you need to run your master part program on a slave arm, you can run PC-DMIS in Reverse Axes mode. This mode internally reverses the sign of the X and Y axes, making the Y axis positive towards the center of the machine and the X axis opposite the master arm's X axis.

All existing probe files, wrist maps, tool changers, and other calibration and error comp files will be usable in this mode without any change.

Note: Calibrations done in either normal or Reverse Axes mode will be correct and usable in either mode.

More:

To add an icon that runs PC-DMIS in Reverse Axes mode:


To add an icon that runs PC-DMIS in Reverse Axes mode:

  1. Using Explorer, navigate to the directory where you want to add the icon.

  2. From Explorer's File menu, select New | shortcut. A Create Shortcut wizard appears asking you to enter the pathway to the program.

  3. In the Command Line box, either type the complete pathway to the PC-DMIS executable file, or use the Browse button to navigate to and select the file. The default pathway is "C:\Pcdmisw\Pcdlrn.exe".

  4. Once you have the pathway in the Command Line box, place your cursor at the end of the pathway, type a space, and then type /r or -r. This tells PC-DMIS to run in Reverse Axes mode. You can also combine this with Operator mode by adding a –o or /o to the command line.

  5. Click Next.

  6. In the Select a Name for the Shortcut box, type something like "PC-DMIS Reverse Axes Mode".

  7. Click Finish. The new icon appears.


Dialog and Message Boxes in Multiple Arm Mode

Once you have enabled Multiple Arm mode for your part program, any dialog boxes or message boxes that are related to a specific arm will contain an "Arm 1" or "Arm 2" identifier in their captions, like these Execute Mode Options dialog boxes:

Dialog and Message boxes that are affected include:

  • The Execution Mode Options dialog box

  • The Probe Changer dialog box

  • The Select Probe File dialog box

  • Info messages

  • Warning messages

  • Error messages


Navigating and Displaying Multiple Windows

Navigating and Displaying Multiple Windows: Introduction

Switching Between Open Part Programs

Arranging Open Windows

Giving Open Windows the Program Focus


Navigating and Displaying Multiple Windows: Introduction

This section describes how to easily navigate between and view multiple open part programs by using the Window menu.

The main topics in this section include:

  • Switching Between Open Part Programs

  • Arranging Open Windows

  • Giving Open Windows the Program Focus


Switching Between Open Part Programs

Display Menu Roadmap
Display Menu Roadmap

Here are some ways you can easily switch between open part programs:

Clicking the Next or Previous Options: Select the Next or Previous menu options to switch to the next or previous part program in a range of open part programs. When you've reached the end of all the open part programs, selecting the Next again will not do anything.

Clicking on a List of Open Part Programs: at the very bottom of the Windows menu, PC-DMIS displays a list of all open part programs. You can easily select which part program you want to have the focus by selecting the part program's name from the list.

Clicking on a Title Bar: If a part program's Edit window or Graphics Display window title bar is showing, simply click on the title bar to switch to that part program.


Arranging Open Windows

Display Menu Roadmap

The following menu options allow you to arrange all open windows. These menu options will not affect the Edit window until you remove the Edit window from its docked position by right-clicking on the Edit window and deselecting the Docking View menu option.

Icon | Menu Option | Description
 | Cascade | Stacks the windows one on top of the other with just the title bars showing, placing the window with the focus on the top of the stack.
 | Tile Horizontally | Tiles the windows horizontally, placing window with the focus on the top.
 | Tile Vertically | Tiles the windows vertically, placing the window with the focus on the left.
 | Activate Next Window | Activates the next open window.


Giving Open Windows the Program Focus

Display Menu Roadmap

Sample Window menu

  • A - This section shows the list of open windows for the current part program.

  • B - This section shows the list of open part programs.

Above the list of part programs, PC-DMIS also lists all open windows in the Window menu. Simply selecting the windows from this menu will give that window the program focus.


Working in Off-line Mode

Working in Off-line Mode: Introduction

Prerequisites

Off-line Probes

Setting Probe Depth

Measuring Features Off-line

Executing and Debugging Part Programs Off-Line


Working in Off-line Mode: Introduction

The off-line version of PC-DMIS is designed to allow the user to prepare and debug part programs without using a CMM. The ability to program off-line has become increasingly important over the last several years. Users of CMM's have become more aware of the fact that, in order to fully realize their investments in CMMs, their equipment must be used to measure parts, not write programs to measure parts.

CMM manufacturers' first attempts at adding off-line programming capabilities involved cumbersome, specialized text editors. These products, although of limited use, spurred user interest in off-line programming. Driven by this interest, several CAD vendors developed products that allowed users to generate part programs using CAD models.

Although these products were vastly superior to text editors, they had one major disadvantage --cost. Since each CMM vendor has their own specific measurement language or languages, which were constantly changing or in some cases being replaced, the expense of developing and maintaining these products put them out of the reach of all but a few well-financed users.

This situation brought about the development of the DMIS specification, a generic CMM language. DMIS allowed CAD vendors to develop part programming packages that were targeted toward a single language instead of many, greatly reducing their costs. These savings were passed on to their customers and off-line part programming became a viable option for a large group of CMM users. However, there was still one problem. What about CMM users whose CAD vendors did not support and did not plan to support off-line part programming?

Although many main frame CAD vendors, driven by major customers, have introduced DMIS extensions to their products, PC based CAD vendors with their diverse customer bases have shown little interest in this area. Many CMM users, particularly small shops, use PC based CAD systems exclusively. PC-DMIS brings off-line programming capabilities to this group.

With PC-DMIS, programmers using standard IGES models, which are supported by virtually every CAD vendor, can generate part programs on an inexpensive PC or PC clone without going near a CMM. These part programs can then be used to drive any CMM either running PC-DMIS or supporting the DMIS specification.

The techniques for programming off-line are much the same as those used for programming on-line. However, as might be expected, the methods used for qualifying probes, taking measurements and debugging programs differ from those used in the on-line version. This section describes PC-DMIS'S off-line programming techniques.

The main topics in this section include:

  • Prerequisites

  • Off-line Probes

  • Setting Probe Depth

  • Measuring Features Off-line

  • Executing and Debugging Part Programs Off-Line


Prerequisites

To use PC-DMIS off-line, CAD data, in the form of an IGES model, a DES file, a DXF file, or X,Y,Z,I,J,K data must be available. The "Importing CAD or Program Data" topic of the "Using Advanced File Options" section has information on importing these files into the PC-DMIS system.

More:

IGES Entities Supported

DXF Input

DES Input

XYZ ASCII File


IGES Entities Supported

IGES Entity | Description
100 | CIRCLE/ARC
102 | COMPOSITE CURVE
104 | CONIC ARC
106 | COPIOUS DATA (multiple point line)
108 | PLANE
110 | LINE
112 | PARAMETRIC SPLINE CURVE (with curves and surfaces option)
114 | PARAMETRIC SPLINE SURFACE (with curves and surfaces option)
116 | POINT
118 | RULED SURFACE (with curves and surfaces option)
120 | SURFACE OF REVOLUTION (with curves and surfaces option)
122 | TABULATED CYLINDER (with curves and surfaces option)
124 | TRANSFORMATION MATRIX
126 | RATIONAL B-SPLINE CURVE (with curves and surfaces option)
128 | RATIONAL B-SPLINE SURFACE (with curves and surfaces option)
140 | OFFSET SURFACE
144/142 | TRIMMED SURFACE (with curves and surfaces option)
402 | ASSOCIATIVITY INSTANCE
408/308 | SUBFIGURE
410 | VIEW

More:

IGES Compatibility


IGES Compatibility

PC-DMIS is compatible with IGES 3.0, 4.0, and 5.1.


DXF Input

PC-DMIS will read in a DXF (Drawing Interchange File) file as CAD data to be used to create part programs. This file format will not support text. The only type of data that is supported is feature data.

This option is not part of PC-DMIS'S standard module. Please contact your PC-DMIS software representative if you are interested in purchasing this add-on package.


DES Input

PC-DMIS will read in a DES (Data Exchange Standard) file as CAD data to be used to create part programs. The data can come in as feature or fixture data. If it is feature data, you have the option to use the feature label to define the type of feature. By selecting the DES point from the PC-DMIS display, the correct DCC feature dialog is displayed with the values filled in from the DES point.

The DES feature type is defined by the fifth position of the feature label. This is the fifteenth (15) column of the data type LINE in the DES file. The character and feature type follow.

CHAR | DES Type | PC-DMIS Sheet Metal Type
S | Surface | Surface Point
T | Trim | Edge Point
H | Hem Edge | Edge Point
X | Hole | Circle (in)
Y | Stud | Circle (out)
Z | Slot | Round Slot


XYZ ASCII File

PC-DMIS will read in any ASCII file that contains XYZ (and possibly IJK) data. The file should contain the nominal (theoretical) inspection points that need to be measured.

For detailed information on XYZ ASCII files, see "Importing an XYZIJK File" in the "Using Advanced File Options" section.


Off-line Probes

With the off-line version, all the probe definition and calibration capabilities as defined in the on-line version can be used. However, values can only be keyed in. Measurements cannot be made. (For example, you cannot actually measure a calibration artifact to find the diameter of a probe.)

See "Defining Probes" in the "Defining Hardware" section for information on defining a probe.

Note: It is suggested (but not mandatory) that the probe used to create the off-line part program be the same as the probe that will be used to execute the part program on-line.


Setting Probe Depth

To program measurements off-line, it is important to set the depth of the probe at a specified distance (in relation to the surface of the current working plane ). PC-DMIS offers several methods for setting the probe’s depth.

Note: It is necessary to be in Program Mode to use any of these techniques. Verify that the STATE button displays PROG.

More:

Setting Approximate Probe Depth

Setting Probe Depth on a Feature

Setting Probe Depth on a Sphere

Setting Probe Depth on a Cone

Keying in Probe Depth


Setting Approximate Probe Depth

In most circumstances it is only necessary to set an approximate probe depth to properly measure a feature. To do this using off-line PC-DMIS

  1. Position the mouse cursor on the drawing at the desired depth for hit taking.

  2. Right-click at the current location. PC-DMIS will then redraw the probe in its new position.

Setting Probe Depth


Setting Probe Depth on a Feature

To position the probe on a specific feature (i.e., a plane):

  1. Move the cursor close to the feature.

  2. Hold down the right mouse button.

  3. Release the mouse button.

When the button is released, PC-DMIS will ”snap” the probe to the closest CAD element and display the message: "Precise Depth Set on".

The status bar displays the current number of hits and the probe’s location.

Setting Probe Depth on a Feature


Setting Probe Depth on a Sphere

PC-DMIS offers two procedures that allow you to set the probe depth on a sphere. Depending where the probe is located in relation to the centerline of the drawing determines where the hit will be taken on the sphere. If the probe is below the centerline, PC-DMIS will take the hit on the bottom of the sphere. To take a hit on the top of the sphere, the probe depth must be set above the centerline. See "Measuring Features Off-line" for additional information on the following procedures.

Three-Dimensional Procedure

To set the precise depth on a three-dimensional spherical surface:

  1. Move the animated probe to the desired circle.

  2. Hold down the right mouse button.

  3. Release the mouse button. The precise depth will be set on the sphere.

PC-DMIS will position the probe on the side of the feature where the mouse button was first held. This determines the type of feature that will be measured. If the probe snaps to the outside of a circular CAD element, the hits will be placed outside the circle. If the probe snaps to the inside of the same element, the hits will be placed inside the circle. The circle’s three-dimensional origin must be the same location as the sphere’s center.

Once the precise depth has been set, all the points that are generated will snap on to the spherical surface.

Two-Dimensional Procedure

When using a two-dimensional drawing, PC-DMIS requires at least two views of the sphere. The sphere should be visible as a circle (or arc) in both views.

  1. Set the precise depth for two of the axes using one of the views. (See "Setting Probe Depth on a Feature" for setting precise depth.) PC-DMIS will display the message: ”Precise Depth Set on."

  2. Using the second view, set the precise depth for the third axis. PC-DMIS displays the message: ”Precise Depth set on Sphere.” This procedure finds the true three-dimensional center point of the sphere.

Once the precise depth has been set, all the points that are generated will snap on to the spherical surface.


Setting Probe Depth on a Cone

PC-DMIS offers two procedures that allow you to set the probe depth on a cone. See "Measuring Features Off-line" for additional information on the following procedures.

Three-Dimensional Procedure

To set the precise depth on a conical surface, PC-DMIS requires that two CAD circles (or arcs) on the cone be displayed. It is suggested that two views of the surface be used for this procedure, but it is not required. (Isometric views are also a viable way of setting probe depth on a cone.)

  1. Set the precise depth for one end of the cone using one of the circles. PC-DMIS displays this message: ”Precise Depth Set on.”

  2. Next, set the precise depth for the other end of the cone using the second circle. PC-DMIS displays this message: ”Precise Depth set on Cone.”

Once the precise depth is set, all the points that are generated will snap on to the conical surface. Single hits can be taken on cones by holding down the left mouse button. Clicking the left mouse button prompts PC-DMIS to take equally spaced hits around the cone.

Two-Dimensional Procedure

To set the precise depth on a conical surface in two-dimensional drawings, PC-DMIS requires that the length between the two circles (as described above) be defined. Because these circles are at the same depth, it is necessary to also define the precise depth of a line. This can be either a straight line, or a line on the edge of the cone. After setting the precise depth on the circles, hold down the right mouse button next to the line that will be used for the length.

Once the precise depth is set, all the points that are generated will snap on to the conical surface. Single hits can be taken on cones by holding down the left mouse button. Clicking the left mouse button prompts PC-DMIS to take equally spaced hits around the cone.


Keying in Probe Depth

It is sometimes necessary to set the probe at some specific location in space. To do this:

  1. Click on the X, Y, Z portion of the status bar while in PROGRAM mode (or select the Operation | Move To option described in the "Inserting Move Commands"section ). Display Menu Roadmap

  2. The Auto Move Point dialog box will appear. The default setting indicates the probe's current location.

  3. Change the X, Y, Z to the desired values. By selecting the Store Move check box, the MOVE POINT command can be added to the program. You also have the ability to select the Increment moves check box and the OK to Move check box.

  4. Once the new X, Y, or Z values are entered, click on Done and PC-DMIS will move the animated probe to the new position.


Measuring Features Off-line

PC-DMIS offers several methods for programming measurement routines off-line. A hit is taken by holding down the left mouse button. The ALT + ”-” (minus) key combination allows you to remove a specified number of hits as long as the measurement process isn't complete. (Press ALT + ”-” minus for each hit that is to be removed.) The END key allows you to complete the measurement process.

Note: Press the END key to terminate the measurement process. PC-DMIS will continue to accumulate hits in the hits buffer until the END key is pressed.

More:

Automatic Measurements

Discrete Measurements

Ending a Measurement


Automatic Measurements

Based upon the IGES definition of circular and linear feature types, PC-DMIS can make some assumptions about the way they should be measured. Take advantage of these assumptions to speed up the part programming process.

More:

Circular Features

Linear Features

Surface Features


Circular Features

The default number of hits PC-DMIS generates on a circular feature is a system option. To change this value, access the Setup Options dialog box (Edit | Preferences | Setup), and then click the General tab. Type the new default number in the Auto Circle Hits edit box.

PC-DMIS can automatically generate hits for circles, cylinders and arcs. To do this:

  1. Move the cursor close to the circumference of the feature.

  2. Click the left mouse button. (The STATE icons must be set to Program mode.) PC-DMIS will then generate equally spaced hits on the feature at the current probe depth. (See "Setup Options: General Tab" in the "Setting Your Preferences" section for setting the number of hits for circles.)

Follow these measurement rules for circular features.

  • For an inside diameter (ID ), place the cursor just inside the feature.

  • For an outside diameter (OD), place the cursor just outside the feature.

  • To automatically program cylinders, take at least two sets of hits at different probe depths.

  • When programming an arc, PC-DMIS will space the hits along the length of the arc.

  • To measure a sphere or a cone, first set precise depth on the sphere or cone before generating any hits. See "Setting Probe Depth on a Sphere" and "Setting Probe Depth on a Cone".


Linear Features

The default number of hits PC-DMIS generates on a linear feature is a system option. To change this value, access the Setup Options dialog box (Edit | Preferences | Setup), and then click the General tab. Type the new default value in the Auto Line Hits edit box.

PC-DMIS can automatically generate hits for lines and planes. To do this:

  1. Move the cursor close to the line.

  2. Click the left mouse button. (The STATE icons must be set to Program mode.)

Follow these rules for measuring linear features:

  • PC-DMIS will generate equally spaced hits along the length of the line at the current probe depth. (See "Setup Options: General Tab" in the "Setting Your Preferences" section for setting the number of hits for lines.)

  • The cursor must be placed on the side of the line where the hits are to be taken.

  • To automatically program planes, at least two sets of hits at different probe depths must be taken.


Surface Features

UV scan can be used to automatically place points on a surface along the UV direction of the surface. In Program mode and Surface Select mode, press the left mouse button inside the surface to be selected. A dialog box will appear allowing the input of the start and end UV values, as well as the number of points along each UV direction.


Discrete Measurements

Automatic measurements speed up the programming process, but it is sometimes necessary due to either part geometry or feature type to precisely place hits on a feature. There are two techniques for placing hits.

More:

Placing Hits on a Surface

Placing Hits on a Feature


Placing Hits on a Surface

In many instances it is necessary to precisely position the hits on a surface (i.e., plane, sphere or cone measurement). To do this:

  1. Move the cursor to the position where you wish to take the hit.

  2. Hold down the left mouse button (do not move the mouse).

  3. Release the button. PC-DMIS will program the hit at that point.

The cursor must be held in one position while holding down the button. Otherwise, PC-DMIS will misinterpret your intention. If the probe tip snaps on to a feature after the button is released, then the mouse was moved during the process. Press the ALT + "-" (minus) key combination to remove the hit and begin again.

Note: Precise depth must be set before placing discreet hits on a cone, sphere, or plane.


Placing Hits on a Feature

In many instances it is necessary to precisely position hits on a feature other than a plane. To do this:

  1. Move the cursor close to the position where you wish to take the hits.

  2. Hold down the left mouse button.

  3. Move the probe towards the position where you want to take the hit. (the probe must be moved at least 1/8" on the screen).

  4. Release the button.

PC-DMIS will "snap" the hit on the feature. PC-DMIS will locate the hit on the side of the feature where the cursor was positioned when you first held down the mouse.


Ending a Measurement

To end a measurement in the off-line mode, press the END key.


Executing and Debugging Part Programs Off-Line

This value is in milliseconds and represents the frequency of Windows::OnTimer events for online mode. The default is 50 milliseconds.

This value is in milliseconds and represents the frequency of Windows::OnTimer events for offline mode. The default is 1 millisecond.

This value is a percentage of the number of RedrawFast Graphics calls made during probe animation when the program is executed.

A value of 100 indicates all RedrawFast drawing calls are done.

A value of 0 indicates no RedrawFast drawing calls are done.

The default is 50 percent.

Located in the Performance section, this value is a percentage of the number of RedrawFast Graphics calls made during probe animation when the program is executed using collision detection.

A value of 100 indicates all RedrawFast drawing calls are done.

A value of 0 indicates no RedrawFast drawing calls are done.

The default is 50 percent.

This value defines the duration between redrawn views of the animated virtual machine. This value is in milliseconds. Increasing this value causes fewer animation steps to be drawn.

The default value is 0.

This value represents the frequency that a scan updates the animation points and logic associated with probe movement during execution. The default is 50 points.

This value represents the frequency that a scan updates the animation points and logic associated with probe movement during collision detection. The default is 1 point.

Executing and Debugging Part Programs Off-Line

The execution of part programs in off-line PC-DMIS is the same as in on-line PC-DMIS. The Edit window provides immediate access to all of the commands in a part program, making it as easy to fine tune an off-line part program as a program done on a CMM.

Please see the "Editing a Part Program" section for an overview of the many edit options in PC-DMIS.

It is the programmer's responsibility to pay careful attention to the probe animation to detect collisions and misplaced hits. The best way to do this is to use PC-DMIS's probe path and collision detection functionality to determine collision points between the probe and the part.

The Collision Detection menu option Display Menu Roadmap provides an animated graphical representation of the probe's path along the part. This option is a powerful tool for probe path editing and is very helpful in the off-line measurement procedure. To access this option:

  1. Mark the features that will be used for the probe path editing in the Edit window of the applicable part program. (See "Marking Commands for Execution" in the "Editing a Part Program" section.)

  2. Select the View | Path Lines option Display Menu Roadmap . PC-DMIS will display the path lines of the probe that were created during the learning portion of the part program.

  3. Select Operations | Graphics Display Window | Collision Detection. PC-DMIS will begin moving an animated probe along the path lines showing any collisions in red on the part and in the Collision Detection dialog box. One execution has finished, a Collision List dialog box will display showing locations where collisions occurred. The "Showing and Animating Path Lines" topic from the "Editing the CAD Display" section has additional information on using path lines and detecting collisions.

Manipulating Animation and Execution Speeds

You may also find it helpful to manipulate animation and execution speeds while debugging part programs. Several registry entries exist so that you can fine tune these speeds to meet your needs.

The applicable entries located in the Performance section include:

OnlineTimerMillisecondExecuteNext

OfflineTimerMillisecondExecuteNext

ExecutionPercentageAnimation

CollisionDetectionPercentageAnimation

The applicable entries located in the Option section include:

MaxAnimationSpeed

ScanAnimnateEveryNPts

ScanAnimateEveryNPtsCollisionDetection

See the "Modifying Registry Entries" section for information on modifying registry entries using the PC-DMIS Settings Editor.


Translating DOS/AVAIL into PC-DMIS

Translating a Part Program into PC-DMIS:

Introduction

Translate a Part Program File

Importing a Part Program File


Translating DOS/AVAIL into PC-DMIS: Introduction

PC-DMIS will allow a user to take part programs that were created in DOS or Avail and translate them to run in PC-DMIS for Windows. The original part program must have been created using Avail or PC-DMIS (DOS). The original part program must have been created using Avail or PC-DMIS (DOS) version 3.2 or higher in order for the translation process to be available.

Note: Importing Tutor for Windows part programs will not be available in this release.

The main topics in this section include:

  • Introduction

  • Translate a Part Program File

  • Importing a Part Program File


Translate a Part Program File

To translate a file, the following procedure must be followed:

More:

DOS to Windows

Avail/MMIV to Windows


DOS to Windows

  1. Using DOS, start up PC-DMIS for DOS. The Active Parts list will be displayed.

  2. Click the POST button from the menu list.

  3. Select the part program to be translated. PC-DMIS will display the Post Options menu.

  4. Select the DIMS CMDS button (DIMS commands) from the menu list. PC-DMIS will ask for the Output File name.

  5. Type the appropriate file name, followed by the three-character extension. It is suggested (but not mandatory) to use the extension ".dim".

  6. When PC-DMIS is post processing the part program, it will ask you to enter the name of a PC-DMIS for Windows Probe File. Type the appropriate name.

  7. Make sure that it is a probe file being used for Windows.

  8. Press the ENTER key.

  9. When the post processing is complete, PC-DMIS will display a message asking you to press any key to continue. PC-DMIS will then return to the Active Parts list.

  10. Exit out of PC-DMIS for DOS.


Avail/MMIV to Windows

Avail/MMIV files need to be translated in order to run in PC-DMIS for Windows. It is recommended (but not necessary) that the files are saved with a LLF*.* file name. Simply follow the instructions located in "Importing a Part Program File".


Importing a Part Program File

The following procedure should be followed when importing a part program file. The process is the same regardless of the file type.

More:

DOS, Avail and MMIV Files


DOS, Avail and MMIV Files

  1. Start PC-DMIS for Windows by double-clicking on the appropriate desktop icon (or by selecting the desktop's Start Button | Program Files | PC-DMIS For Windows). PC-DMIS will load and show the Open File dialog box.

  2. Click the Cancel button to close the dialog box.

  3. Select the File | New menu option to create a new part program. The New Part Program dialog box will appear. Display Menu Roadmap

  4. Type a new part program file name and other information as needed.

  5. Click the OK button. The dialog will close and PC-DMIS will open the Probe Utilities dialog box.

  6. Click the Cancel button to close the Probe Utilities dialog box.

  7. Select the File | Import submenu. Display Menu Roadmap

  8. Select the appropriate input data type (DIMS, AVAIL, or MMIV ). An Open dialog box appears

  9. Select the correct file. If it was saved with a .DIM / .LLF*.* extension, PC-DMIS will automatically display all available files with the appropriate extension. If necessary, change to the correct directory.

  10. Click the Import button. If CAD data already exists for your part program, you can choose to either Merge or Replace the existing CAD data with the imported CAD data. The Choose Translation Option dialog box appears with these translation options:

  • Translate main program and all called subroutines into one DIMS part program.

  • Translate specified file only. Include subroutine calls but do not translate subroutine files.

  • Translate main program and called subroutines into separate DIMS part programs.

  11. Select one of the available translation methods.

  12. Click the OK button (or press the ENTER key).

PC-DMIS will translate the DIMS/AVAIL/MMIV data and return to the part program.

q For each TOOLCHANGE you will be prompted to select a PC-DMIS probe file.

q For each TIPCHANGE you will be prompted to select a PC-DMIS probe.

Your part program is now ready to run in PC-DMIS for Windows.

Important: When importing an AVAIL part programs that contains an IFTEST keyword or a GOTO/LABEL command inside of a feature block, or an MMIV part programs containing a BRANCH/TEST keyword or a BRANCH/LABEL command inside of a feature block, PC-DMIS will move its respective IF and GOTO commands before the feature block. This will be corrected in future versions of PC-DMIS.

More:

Understanding the MOVE/PH9_OFFSET Command for Imported DOS Part Programs


Understanding the MOVE/PH9_OFFSET Command for Imported DOS Part

Understanding the MOVE/PH9_OFFSET Command for Imported DOS Part Programs

In the DOS version, the software rotated the PH9 to the new angles and then made an automatic move so that the tip would end up where it was prior to the angle change. However in the PC-DMIS for Windows when rotating the PH9 to new angles, the software doesn't make this extra move. So, for translated and imported DOS part programs, PC-DMIS for Windows automatically inserts MOVE/PH9_OFFSET commands to facilitate the translation from the DOS version of PC-DMIS to PC-DMIS for Windows.

This command has this syntax and takes two inputs:

MOVE/PH9_OFFSET,INPUT1,INPUT2

INPUT1 is the old tip angle.

INPUT2 is the new tip angle.

Note: You won't need to use this command in a normal PC-DMIS for Windows part programs and you can't select it from any of the menus.


Using a Wrist Device

Using a Wrist Device: Introduction

Installation

Tip Calibration

Calibrate the Unit

Qualification Check

Home the Unit

Using the Wrist in a Part Program


Using a Wrist Device: Introduction

PC-DMIS provides complete support for calibrating and using infinitely indexable wrist devices such as the Renishaw PHS, the DEA CW43, and the DEA CW43L as well as devices provided by other manufacturers.

The main topics in this section include:

  • Installation

  • Tip Calibration

  • Calibrate the Unit

  • Qualification Check

  • Home the Unit

  • Using the Wrist in a Part Program

  • Calibrating and Using a CJoint Device


Installation

If a wrist is installed on your CMM, PC-DMIS will add A and B axes to the X, Y, and Z readouts that are normally displayed. The wrist option must be turned on in the port lock for PC-DMIS to enable the wrist support. Because of the variety of infinite wrists and interfaces supported, you should consult with your software vendor for specifics on what PC-DMIS registry entries need to be changed (see the "Modifying Registry Entries" section for information on using the PC-DMIS Settings Editor to modify registry entries).

PC-DMIS will automatically query the controller and determine that the wrist is present.

More:

Notes for Renishaw PHS with Leitz Interface


Notes for Renishaw PHS with Leitz Interface

When you are using the kinematics mount for the Renishaw wrist, you need to modify the "RenishawKinematicMount=1" registry entry in the [Option] section of the PC-DMIS Settings Editor. For information on modifying registry entries, please view the "Modifying Registry Entries" section.

PC-DMIS will ask (upon startup of the system) if the PHS Wrist is mounted on the CMM . PC-DMIS will only ask this question when the controller has just been powered on. Once you inform PC-DMIS what is on the end of the arm, it will not ask the question again until it senses the controller has been shut down and restarted. When you have the wrist mounted, PC-DMIS will add A and B axes to the readouts. This is in addition to the X, Y, Z axis readouts that are normally displayed.

Note: The readout display will not reflect the value changes until you run PC-DMIS after responding favorably to the question regarding the PHS Wrist


Tip Calibration

Tip calibration assumes that you have already calibrated the wrist. It does not need to be done for the tip that is used to calibrate the wrist. Tip calibration is done automatically for the tip used to calibrate the wrist.

The purpose of tip calibration is to calculate the distance from the last (A joint) joint's center point to the tip center. Theoretically, measuring one tip A,B combination will be sufficient to compute this distance once the wrist is calibrated. However, it is a good idea to measure more than one A,B combination so that PC-DMIS can average the tip offsets computed. This will result in better accuracy.

More:

New Probe File


New Probe File

Once you have calibrated the wrist, you can change the tip attached to the wrist and do a tip calibration. To calibrate a new tip on the wrist:

  1. Access the Probe Utilities dialog box by selecting the Insert | Hardware Definition | Probe menu option. Display Menu Roadmap

  2. Make sure the probe description matches the new tip that you have loaded.

  3. Select one or more A,B combination(s) from the Active Tip list that correspond to this new tip. If a desired A,B combination is not in the list, you can add it by selecting the Add Angles button. You must select at least one A,B combination from the tip list in order to calibrate the tip. If you select more than one, PC-DMIS will average the results to get a more accurate tip offset.

  4. When you have the desired tips selected, press the Measure button. This will display the Measure Probe dialog box. This allows you to set the number of hits, prehit / retract, and speeds.

  5. Select the Calibrate Tips option button from the Options To Calibrate

  6. Set the desired parameters.

  7. Click the Measure button.

PC-DMIS will begin to measure the sphere with the selected A,B angle combinations.


Calibrate the Unit for Infinite Wrist Devices

When you have an indexable wrist on the CMM, PC-DMIS will allow you to access the Calibrate the Unit and Home the Unit options in the Type of Operation area of the Measure Probe dialog box.

Measure Probe dialog box

Type of Operation area showing the Calibrate the Unit option enabled

Note: This wrist calibration is only done with a single stylus—not star probes. After PC-DMIS completes this calibration, any angular position of the wrist may be utilized in new probe files by calibrating a minimum of one probe angle. For additional information, see "Calibrate the Unit" under the "Type of Operation area" topic. See the "Measure" topic in the "Defining Hardware" section for general information about calibrating probes.

The Calibrate the Unit option allows you to calibrate the wrist. This procedure allows you to measure several angles on a sphere to determine the internal distances within the wrist itself. Once this information is calculated, PC-DMIS will use it to accurately predict the tip position at any A, B angle pair. This allows you to use any A, B angle in your part program without calibrating each individual position.

Note: Be sure you type your desired measurement values in the Measure Probe dialog box for the sphere measurement, and select the qualification tool before measuring with the Calibrate the Unit option selected. You can set the number of hits, the probe prehit and retract distances, and various speeds used in the measurement process from the Measure dialog box. See ”Measure” in the ”Defining Hardware” section.

More:

Wrist Calibration


Wrist Calibration

In order to calibrate the wrist, you need to measure at least three A angle positions and at least three B angle positions for a total of nine sphere measurements (each A angle position must be measured at every B position). The Wrist Calibration Angle Setup area of the Measure Probe dialog box gives you the ability to specify the angles for calibrating both the A and the B axes . The first three options are for calibrating the A joint.

For information on using the Wrist Calibration Angle Setup area to define the AB angle positions, see the "Wrist Calibration Angle Setup" topic in the "Defining Hardware" section.

Note: When using a Renishaw PHS, every time there’s an interruption in electrical power to the PHS controller, you must either perform a wrist calibration or select Home the Unit from the Type of Operation area of the Measure Probe dialog box and click Measure again.

Caution When Using SP600 Probes

For most probe types on an infinite wrist, the wrist device calibrates a zone of angles and approximates the rest. However, if you have an SP600 probe on an infinite wrist, the SP600 probe needs its own deflection matrix. You must, therefore, calibrate each AB tip angle that wasn't part of the original mapping process or suffer inaccurate results in your measurements.

More:

Calculate Error Map


Calculate Error Map

Normally, wrist devices are calibrated at relatively small increments (e.g. 20 degrees). When you calibrate an infinitely indexable wrist, with the Calibrate the Unit check box selected, PC-DMIS automatically creates a wrist error compensation file named abcomp.dat that it uses to correct for angular errors in the wrist. Creating an error map will increase the accuracy of the wrist when used to measure at positions not previously calibrated by allowing PC-DMIS to interpolate the probing offsets.

After calculating the error map, the results are stored on your computer’s hard drive so that any time you use the wrist, it will take advantage of the improved angular accuracy. You should only calculate the error map periodically (once a week or less), or as necessary. When calculating the error map, PC-DMIS also performs a valid wrist and tip calibration for the currently loaded probe file.

Note: You should do a wrist calibration each time the mounting of the wrist changes. Also, you should refer to your hardware and vendor information for all appropriate times to map a wrist since this can change based on device construction and manufacturer recommendations.

Once the infinitely indexable wrist device is calibrated and a wrist error map file exists, you should then tell PC-DMIS to use the error map file. To do this, select the Use Wrist Map If Available check box from the Probe Utilities dialog box (see the "Use Wrist Map If Available check box" topic in the "Defining Hardware" section). You can then create and use any position of new probe files with a minimum of calibrations.

To do this, simply create a new probe file and perform a normal tip calibration using at least one probe position on the qualification tool that maintains a link to probe file used during the Calibrate the Unit process. However, it is important that you use more then one probe position for this calibration since a better ”fitting” of the probe offset data to the wrist error matrix will occur. This is especially true if several wrist positions will be utilized in the new probe file.

Note: Failure to maintain a link to the probe file used during wrist mapping will result in measurement errors.


Qualification Check

Type of Operation area showing Qualification Check option

After you calibrate the unit, a qualification check is recommended, but not required. Performing a qualification check will provide you with information regarding the general accuracy of the wrist calibration and future measurements. A qualification check can also be used to check the errors of new tips added to new probe files.

To perform a qualification check:

  1. Access the Probe Utilities dialog box by selecting the Insert | Hardware Definition | Probe menu option. Display Menu Roadmap

  2. Select the angles you wish to use for the qualification check from the Active Tip List. It’s recommended that you select probe angles both used and not used in the wrist calibration.

  3. Click the Measure button. The Measure Probe dialog box appears.

  4. Provide the parameters you wish to use during the calibration check including selecting the appropriate calibration tool.

  5. Select the Qualification Check option from the Type of Operation area.

  6. Click the Measure button.

  7. Follow any on-screen instructions.


Home the Unit

Type of Operation area showing the Home the Unit option

Some wrist devices¾such as the Renishaw PHS¾do not have predefined zero positions and use potentiometers instead of scales to position the wrist. These types of wrist devices need to have the zero redefined every time power to the probe head controller is interrupted. In order to redefine the wrist zero position, you may choose the Calibrate the Unit option (see ”Tip Calibration”) or the Home the Unit option.

Selecting Home the Unit will calculate the angular error offset from the previously calculated wrist zero position by qualifying one or more probe angles on a previously calibrated sphere position. The advantage to this is you can use a minimum of one probe tip angle making the process much faster than a wrist calibration.

It is recommended that you use more than one probe angle to accomplish Home the Unit since PC-DMIS will average the errors of the homing procedure to provide a more accurate adjustment to the wrist error map.

To perform a Home the Unit:

  1. Access the Probe Utilities dialog box by selecting the Insert | Hardware Definition | Probe menu option. Display Menu Roadmap

  2. Select the same probe file that was used to calibrate the unit.

  3. Select the angles you wish to use for the calibration check from the Active Tip List.

  4. Click the Measure button. The Measure Probe dialog box appears.

  5. Provide the parameters you wish to use during the calibration check including selecting the same calibration tool used during Calibrate the Unit.

  6. Select the Home the Unit option from the Type of Operation area.

  7. Click the Measure button.

Note: After calibrating the unit and prior to homing the unit, you shouldn’t move the calibration sphere. If it is moved, you must re-calibrate the unit (see ”Tip Calibration”).


Using the Wrist in a Part Program

On machines that support it, PC-DMIS will automatically sense when the wrist has been rotated with the jog box. The tip offsets will dynamically be updated based on the current A,B angles. That is, the XYZ readout will display the current tip position as it is being rotated. There are four ways (discussed below) to add a new A,B tip combination into a part program.

Once you have added a new A,B tip combination into your part program by using one of the options below, PC-DMIS displays the active tip as programmed in the part program in the Active tip drop-down list on the toolbar. This is the prior TIP/ command above where the cursor is in the Edit window. In order to move the wrist to this A,B angle combination, pull down and close the Tip List box. PC-DMIS will ask if you want to rotate the probe. A Yes response will rotate the wrist to the desired position. This is useful when you want to go back and insert measurements and moves into the part program.

More:

Option 1

Option 2

Option 3

Option 4


Option 1

In the Probe Utilities dialog box, select the Add Angles option. This will allow you to key in new A,B angle pairs to the probe file. If the tip has already been calibrated, then the new A,B combinations will also be calibrated and ready to use. Once you leave the Probe Utilities dialog box, you can use these new A,B combinations by selecting them from the Tip List box located on the toolbar.


Option 2

Manually jog the wrist to the desired A,B angles using the jog box. When you reach the desired position, press the Store Move button on the jog box, or take a manual probing. The current A,B angles will be read automatically. If the A or B angles have changed by more than the PH9 warning delta (see the "Wrist Warning Delta" topic in the "Setting your Preferences" section), then PC-DMIS will automatically add the current A,B angles to the Tip List and insert a TIP/ command in the part program. The new TIP/ command will be added to the part program before the stored move or manual probing. When the part program is then executed, PC-DMIS will first change the tip before moving to the programmed location.


Option 3

Type in a TIP / command in the Edit window. Once you finish editing the vector, PC-DMIS will calculate the best A,B combinations that put the tip shank parallel to that vector. PC-DMIS will display these angles in the Wrist Angles Matching Requested Vector dialog box.

Wrist Angles Matching Requested Vector

There are often two or more A,B combinations that put the shank in the requested orientation. These will be displayed in the dialog, and the A,B combination that is closest to the current A,B combination on the wrist will be the default choice. If the desired vector can be obtained by an infinite A or B axis position, PC-DMIS will mark this entry with the words ”any angle”. PC-DMIS will default this entry to the current value on this axis. You can key in a different value if required. Once you click OK on this dialog, PC-DMIS will add the selected A,B combination to the tip list for the active probe, and change the TIP/ command to use this new tip.


Option 4

In the Auto Features dialog box, each tab entry has a check box for Auto PH9 . When this option is checked, PC-DMIS will take the definition of the feature to determine the best tip shank vector to measure the current feature. It will then use this tip shank vector to calculate the best A,B combinations. These will be displayed in the Wrist Angles Matching Requested Vector dialog box described in "Option 3".


Calibrating and Using a CJoint Device

PC-DMIS provides complete support for calibrating and using a three continuous axes wrist obtained by mounting a CJoint device on the DEA CW43L wrist.

If a CJOINT is installed on your DEA CW43L wrist, PC-DMIS will add A, B, and C axes to the X, Y, and Z readouts that are normally displayed.

The following sub topics are available to help you calibrate your CJoint device.

  • Tip Calibration Information

  • CJoint Calibration Procedure for Infinite Third Axis Wrist Devices

  • Calculate Error Map for CJoint


Tip Calibration Information

The purpose of tip calibration is to calculate the distance from the second joint's center point (the A joint’s center) to the star probe’s tip center. You may want to measure more than one A,B combination so that PC-DMIS can average the star tip offsets computed, resulting in better accuracy in reaching the sphere when the CJoint calibration cycle will be performed.

Before Proceeding:

  • You should already have calibrated the A,B wrist device; and the files named acomp(s).dat and wrist(m)(s).dat should exist on your computer’s hard drive.

  • You need to mount a star probe on the CJoint device with the tip pointing in the X+ direction. PC-DMIS uses this tip to calibrate the CJoint. Tip calibration in this case does need to be done.

Note: You can also obtain the A,B calibration map with the CJoint mounted on the wrist. This will increase the accuracy of angle position computations for any A,B, and C angle combinations.


CJoint Calibration Procedure for Infinite Third Axis Wrist Devices

The Calibrate CJoint option allows you to calibrate the third axis of the wrist. Once this information is calculated, PC-DMIS will use it together with the A,B calibration data, to predict the tip position at any A, B, and C angle combinations for a probe that needs to be installed on a CJoint device, such as a Perceptron probe.

Type of Operation area showing the Calibrate CJoint option selected

To Calibrate using the CJoint Option

  1. Ensure that you have already performed the preliminary steps discussed in the "Tip Calibration Information" topic.

  2. Select the Calibrate CJoint option from the Type of Operation area. Selecting this item enables the Wrist Calibration area if the appropriate wrist entries (DEAWrist or RENISHAWWrist) from the Option section in the PC-DMIS Settings Editor to 1

  3. Ensure that you have a star probe configuration connected, with a tip pointing in the X+ direction.

  4. Select a sphere qualification tool from the Available Tools list.

  5. Type the desired measurement values in the Measure Probe dialog box for the sphere qualification.

  6. Set the number of hits, the probe pre-hit and retract distances, and various speeds from the Measure Probe dialog box.

  7. Fill out the Wrist Calibration area. In order to calibrate the C joint, you will need to measure at least three C angle positions. This gives you the ability to specify the angles for calibrating the A, B and C axes. The Start, Increment, and Angle boxes for the C row are for calibrating the C joint.

      • C Angle Start defines provides the starting C angle used for the calibration of your wrist's C joint. The default value is -180.

      • C Angle End defines provides the ending C angle used for the calibration of your C joint. The default value is 180.

      • C Angle Increment defines the angle increment between the starting and ending C angles. Angles will be calibrated for your C joint device for the starting, ending, and additional angles as determined by the increment value. For example, an increment angle of 10 degrees would add angles for calibration every 10 degrees between the starting and ending angle. Default value is 10.

Note: Be sure that Wrist A Angle Start and Wrist B Angle Start are set to 0 when you calibrate C joint device.

  7. When all this is done, click the Measure button to start the calibration process.


Calculate Error Map for CJoint

Normally, wrist devices are calibrated at relatively small angle increments (such as 20 degrees). When you calibrate a continuous third axis of a wrist, with the Calibrate CJoint option selected, PC-DMIS automatically creates a wrist error compensation file named ccomp(s).dat that it uses, together with abcomp(s).dat, to correct for angular errors in the three axes wrist.

After calculating the error map, the results are stored on your computer’s hard drive so that any time you use the wrist, it will take advantage of the improved angular accuracy.

Recalculating the Error Map

Generally, you should only need to calculate the error map periodically (once a week or less). However, you should perform a wrist calibration each time the mounting of the wrist changes and at other times recommended by hardware and vendor information. This varies based on device construction and manufacturer recommendations


Working in Operator Mode

Working in Operator Mode: Introduction

File Open Options

Operator Mode Menu Options

Using the Marked Sets Window in Operator Mode


Working in Operator Mode: Introduction

The Operator Mode limits the options that will be available when operating PC-DMIS. Once the restrictions are in place, the operator can only open and execute the part program.

To start PC-DMIS in Operator Mode, from the Start menu, select Programs | PC-DMIS for Windows | Operator Mode.

When PC-DMIS launches in Operator Mode, only the options necessary to run the part program will be available.

The main topics in this section include:

  • File Open Options

  • Operator Mode Menu Options

  • Using the Marked Sets Window in Operator Mode


File Open Options

Open dialog box

The Open dialog box is a standard Windows file open dialog. You can activate a part program in Operator Mode by double-clicking on the part program file name or by selecting the part program file name and clicking the Open button.

The following options have been disabled from this dialog box in Operator Mode:

  • Importing to PC-DMIS, accessible when not in Operator Mode by right mouse clicking on a part program and selecting Import to PC-DMIS from the pop-up list.

  • Exporting from PC-DMIS, accessible when not in Operator Mode by right mouse clicking on a part program and selecting Export from PC-DMIS from the pop-up list.

  • Editing the Part Name, Serial Number, or Revision Number on the part program’s PC-DMIS property page, accessible when not in Operator Mode by right mouse clicking on a part program and selecting Properties from the pop-up list.


Operator Mode Menu Options

Once a part program has been activated, the main PC-DMIS screen will be displayed with the following menu options.

Graphics Display window in Operator Mode

More:

File

Edit

View

Window

Help


File

The File menu allows you to open an existing part program, close the current part program, export the current part program, or exit the software.

More:

Open

Close

Quit

Export

Exit


Open

Display Menu Roadmap

The File | Open menu option allows you to switch between part programs anytime by invoking the Open dialog box and allowing you to select a different part program. If the part program you select is different from the currently executing part, PC-DMIS will automatically save and close the active part program before loading the newly selected part program. If however, you try to select and initiate the active part program a second time from the Open dialog box, PC-DMIS offers two choices:

  • Discard all changes made to the active part program since the last Save operation and reload the selected part program without the changes.

  • Cancel the entire operation and return to the Open dialog box.

You can only have one part program open at a given time in Operator Mode.


Close

Display Menu Roadmap

Selecting File | Close closes the part program and saves the measurement values of any executed marked sets.


Quit

Display Menu Roadmap

Selecting File | Quit closes the current part program without saving any recently taken measurement values from executed marked sets. Only pre-existing data will be retrievable.


Export

Display Menu Roadmap

To export your current part program, choose the File | Export menu option. This will display the Export Data dialog box. Select the data type to export as, and a directory location, and then click OK. For more information on exporting, see "Exporting CAD Data" in the "Using Advanced File Options" section.


Exit

To quit PC-DMIS, all other programs, and log off the computer, choose the File | Exit menu option. PC-DMIS automatically saves the current part program before exiting.


Edit

Display Menu Roadmap

The Edit menu option allows you to access the Probe Readout Setup dialog box. You can setup how information is displayed using this dialog box. See "Setting up the Readout Window" topic in the "Setting your Preferences" section for information.


View

This menu allows you to view or hide the following windows while in Operator Mode:

Graphics Display window – Selecting this option shows and hides the Graphics Display window. See "The Graphics Display Window" in the "Navigating the User Interface" section.

Preview Window – Selecting this option shows and hides the Preview window. See "Using the Preview window" in the "Using Other Windows, Editors, and Tools" section.

Probe Readouts – Selecting this option shows and hides the Probe Readout window. See "Using the Preview window" in the "Using Other Windows, Editors, and Tools" section.

Marked Sets Window – Selecting this option shows and hides the Marked Sets window. See "Using the Marked Sets window" in the "Using Other Windows, Editors, and Tools" section. See "Using the Marked Sets Window in Operator Mode".


Window

The Window menu provides operations to manage multiple open part programs and windows. See the "Navigating and Displaying Multiple Windows" section


Help

The Help menu provides all the menu items as in PC-DMIS's standard mode of operation.


Using the Marked Sets Window in Operator Mode

Marked Sets window

As soon as you open a part program, the Marked Sets window automatically launches. The following options are available to the Marked Sets window in Operator Mode:

  • Exit to File Manager

  • Print full Report

  • Calibrate Tips

  • Any Predefined Marked Sets

More:

Exit to File Manager

Print Full Report

Calibrate Tips


Exit to File Manager

Selecting Exit to File Manager will access the Open dialog box, allowing you to select part programs to open.


Print Full Report

The Print full report icon prints the complete report to the output source that was setup in the 'learning' portion of the part program.

If the output is sent to a file, it will be saved in a RTF format. If this is the first inspection report to be saved since powering up the system, PC-DMIS will require a value to be entered in the New File # box. If Auto is checked, after the initial file is saved PC-DMIS will save all future files incrementally from the initial number that was entered (as long as the system has not been powered down). The displayed number can be changed at any time simply by entering another value.

If the Draft Mode check box was marked during the learn mode, PC-DMIS will change the Edit window fonts to a draft mode type for printing purposes. Any colors used in the report (to distinguish tolerances, modes, etc.) will be changed to black. These alterations will greatly improve the speed of printing.

To print the current Edit report, choose the Print Full Report button (or press F4). The Edit window output will be sent to the printer and/or a pre-selected file.


Calibrate Tips

The Calibrate Tips button calibrates all tip angles for all probes in the current part program. This process will tell PC-DMIS the location and diameter of each probe tip.

Note: PC-DMIS does not track the calibration of probes. It is therefore necessary that you verify that a probe is re-calibrated if it is changed in any way.


Predefined Marked Sets

Predefined marked sets may also appear in your Marked Sets window. These are features that have been programmed and marked for execution by the part programmer and are combined into a set for the operator to execute.

An example of some predefined marked sets

To execute and measure features in a marked set, simply click on the set from the Marked Sets window and follow any instructions provided by PC-DMIS.


Using Shortcut Keys and Shortcut Menus

Using Shortcut Keys and Shortcut Menus: Introduction

Shortcut Keys Reference

Shortcut Menus Reference


Shortcut Keys Reference

This table provides an easy reference of the available shortcut keys. If the description of a shortcut key is preceded by italicized text, the item in italicized text must be the active window or focused item for the shortcut key to function properly. For specific information regarding the function of each option, please see the appropriate section of the online help.

Key | Description | Key | Description | Key | Description
F1 | Accesses online Help. | CTRL + A | Edit window: Selects all text. Form and Report Editors: Selects all the objects. | CTRL + F1 | Places PC-DMIS into Translate Mode.
F2 | Edit window: Opens the Expression Builder dialog box if cursor is on a line that allows expressions. | CTRL + C | Edit window: Copies selected text. Form and Report Editors: Copies selected objects. | CTRL + F2 | Places PC-DMIS into Rotate 2D Mode.
F3 | Edit Window: Marks / unmarks the command for execution. If your cursor resides on an External Object, F3 switches between print and execute modes. | CTRL + D | Deletes the current feature. | CTRL + F3 | Places PC-DMIS into Rotate 3D Mode and opens Rotate dialog box.
F4 | Edit window: Prints contents of the Edit window. | CTRL + E | Executes the selected feature. | CTRL + F4 | Places PC-DMIS into Program Mode.
F5 | Accesses the Setup Options dialog box. | CTRL + F | Opens the Auto Features dialog box. | CTRL + F5 | Places PC-DMIS into Text Box Mode.
F7 | Edit window: Within a selected toggle field, cycles forward to next alphabetical entry. | CTRL + G | Inserts a READPOINT/ command into the Edit window. | CTRL + TAB | Minimizes or restores the Edit window.
F8 | Edit window: Within a selected toggle field, cycles backwards to last alphabetical entry. | CTRL + J | Edit window: Jumps to a referenced command. | CTRL + SHIFT | Hides selected graphical analysis arrow.
F9 | Edit window: Opens the dialog box associated with the command at cursor's position. | CTRL + K | Saves the selected dimension in the Edit report. | CTRL + END | Edit window: Moves cursor to the end of the current part program.
F10 | Opens the Parameter Settings dialog box. | CTRL + L | Executes the currently selected block of commands. | CTRL + HOME | Edit window: Moves cursor to the beginning of the current part program.
F12 | Opens the Fixturing Setup dialog box. | CTRL + M | Inserts a MovePoint command. | CTRL + ALT + A | Opens the Alignment dialog box.
SHIFT + Right-click | Opens the Scale Drawing dialog box. | CTRL + N | Creates a New Part Program. | CTRL + ALT + P | Opens the Probe Utilities dialog box.
SHIFT + TAB | Edit window: Moves cursor backwards to the previous user-editable field. | CTRL + O | Opens a Part Program. | CTRL + Left-click | In Text Box mode, performing this action on a feature or label ID in the Graphics Display window will move your cursor to that feature in the Edit window. Performing this action with the Analysis dialog box open, it selects any associated dimensions.
SHIFT + ARROW | Highlights all text as cursor moves. | CTRL + P | Prints the Graphics Display window. | CTRL + Right-click (Also click and drag center mousewheel button) | Rotates the CAD model in 3D in the Graphics Display window when dragging the mouse.
SHIFT + F5 | Edit window: Changes a dimension's hit display between cartesian and polar coordinates. A 'P' character indicates polar display mode. | CTRL + Q | Edit window: Executes the current part program. | UP ARROW | Edit window: Moves cursor to next available element above the current position.
SHIFT + F10 | Edit window: Accesses the Jump To dialog box. | CTRL + R | Opens Rotate dialog box. | DOWN ARROW | Edit window: Moves cursor to next available element below the current position.
END | Ends measurement of a feature. Edit window: Moves cursor to the end of the present line. | CTRL + S | Saves the current part program. | RIGHT ARROW | Edit window: Moves cursor to next available element to the right of the current position. In Summary Mode this expands a collapsed list.
HOME | Edit window: Moves cursor to the beginning of the present line. | CTRL + T | Edit window: Assigns the current command (or selected commands) to the Master arm, Slave arm, or both arms. | LEFT ARROW | Edit window: Moves cursor to next available element to the left of the current position. In Summary Mode this collapses an expanded list.
TAB | Edit window: Moves cursor forward to the next user-editable field. | CTRL + V | Edit window: Pastes clipboard contents. Form and Report Editors: Pastes copied objects. | ALT + H | Accesses the Help menu.
ESC | Aborts any process (other than data entry) if pressed prior to pressing the ENTER key. | CTRL + X | Edit window: Cuts selected text. Form and Report Editors: Cuts selected objects. | ALT + J | Edit Window: Jumps back from a referenced command.
DELETE | Edit window: See 'Backspace'. | CTRL + Y | Edit window: Executes the part program from the cursor's location. | ALT + F3 | Edit window: Opens the Find dialog box.
BACKSPACE | Edit window: Deletes any highlighted characters. If nothing is highlighted, then functions as in a normal editor. If item can not be deleted, an error message will be displayed. | CTRL + Z | Activates the Scale to Fit function. | ALT + BACKSPACE | Edit window: Undoes the last action taken in the Edit window.
ALT + "-" (minus) | Pressing ALT and then the minus key deletes the last hit in the hit buffer. | CTRL + ENTER or RETURN | Edit window: In Summary Mode this keyboard shortcut allows you to select a command to add to the Edit window. | SHIFT + BACKSPACE | Edit window: Redoes the last undone action in the Edit window.
ENTER or RETURN | Edit window: Creates a new line. Line will automatically be deleted if not completed before cursor is moved from line. Selects a command. | CTRL + Left-Mouse Click | With a dialog box open that supports multiple selection of surfaces, this selects an unselected surface or clears the selected surface. | SHIFT + Right-Click | Report Window Label Object: Displays the Report dialog box.
 |  | CTRL + Left-Mouse Click | Graphics Display: Jumps to the nearest feature in the Edit window. | ALT + Right-Click | Rotates the CAD model in 2D in the Graphics Display window when dragging the mouse.
 |  | CTRL + Left-Mouse Drag | Makes the dialog box or toolbar drag without docking into the interface when you release the mouse. |  |


Using Shortcut Keys and Shortcut Menus: Introduction

This section covers shortcuts to many of the menu options, dialog boxes, and commands used in PC-DMIS. Using shortcuts will speed up your programming time and increase productivity and efficiency.

The main topics covered in this section are:

  • Shortcut Keys Reference

  • Shortcut Menus Reference


Shortcut Menus Reference

Shortcut menus allow you to do common commands at the simple click of a mouse button. This section explains how to access the various shortcut menus and what the various menu options do. Shortcut menus exist when the program activates these locations.

More:

Shortcut Menus in Standard Windows Dialog Boxes

Shortcut Menus on the Toolbar Area

Shortcut Menus in the Graphics Display Window

Shortcut Menus for Auto Feature Path Lines

Shortcut Menus in the Edit Window

Shortcut Menus in the Report Window


Shortcut Menus in Standard Windows Dialog Boxes

Beyond the standard commands that exist in Windows based dialog boxes, PC-DMIS, in certain circumstances, adds additional functionality to shortcut menus. Many of these are explained in the "Using Basic File Options" and "Using Advanced File Options" section.

When opening, saving, or using other file operations, right-click on the part program file name listed in the dialog box to bring up these shortcut menu options.

Option | Description
PC-DMIS Import | Imports data from an input file into the selected part program. See "Importing CAD Data" in the "Using Advanced File Options" section.
PC-DMIS Export | Exports data to an output file from the selected part program. See "Exporting CAD Data" in the "Using Advanced File Options" section.
Open | Opens a part program. See "Opening Existing Part Programs" in the "Using Basic File Options" section
Cut | Cuts a part program and moves it to the Clipboard; this is used with Windows Paste command to place the cut file into another folder.
Copy | Copies a part program to the Clipboard; this is used with the Paste command to place the copied file into another folder. See "Performing File Operations" in the "Using Basic File Options" section
Rename | Renames a part program.
Delete | Deletes a part program. See "Performing File Operations" in the "Using Basic File Options" section
Properties | PC-DMIS tab | Displays part program's file information. You can view or modify a part program's name, serial number, or revision number. See "Opening Existing Part Programs" in the "Using Basic File Options" section.


Shortcut Menus on the Toolbar

Shortcut Menus on the Toolbar Area

When right-clicking on the Toolbar area, PC-DMIS displays a list of the toolbars and other options that you can instantly access. These include:

Option | Description
File Operations | Adds or removes the File Operations toolbar to and from the toolbar area.
Graphics Modes | Adds or removes the Graphics Modes toolbar to and from the toolbar area
Edit Window | Adds or removes the Edit Window toolbar to and from the toolbar area.
Quick Start | Adds or removes the Quick Start toolbar to and from the toolbar area.
Window Layouts | Adds or removes the Window Layouts toolbar to and from the toolbar area.
Macro Play/Record | Adds or removes the Macro Play/Record toolbar to and from the toolbar area.
Auto Features | Adds or removes the Auto Features toolbar to and from the toolbar area.
Measured Features | Adds or removes the Measured Features toolbar to and from the toolbar area.
Constructed Features | Adds or removes the Constructed Features toolbar to and from the toolbar area.
Dimension | Adds or removes the Dimension toolbar to and from the toolbar area
Settings | Adds or removes the Settings toolbar to and from the toolbar area
Probe Mode | Adds or removes the Probe Mode toolbar to and from the toolbar area
Active Arms | Adds or removes the Active Arms toolbar to and from the toolbar area.
Active Rotary Table | Adds or removes the Active Rotary Table toolbar to and from the toolbar area.
Wizards | Adds or removes the Wizards toolbar to and from the toolbar area.
Customize | Customizes the toolbars and the menus to meet specific needs. See "Customizing the User Interface" in the "Navigating the User Interface" section.

These toolbars are discussed in detail in the "Using Toolbars" section.


Shortcut Menus in the Graphics Display Window

The following shortcut menus are available inside the Graphics Display window. Access them by right-clicking on specific areas. Some require that PC-DMIS be in specific modes (see the "Graphics Modes Toolbar" topic in the "Using Toolbars" section). Depending on what mode you are in, PC-DMIS presents you with different menu options.

More:

Feature Shortcut Menu

Box-Select Shortcut Menu

Quick Fixture Shortcut Menu

Auto Feature Path Lines Shortcut Menu


Feature Shortcut Menu

To access this shortcut menu, right-click on a feature ID label, a Diminfo box, or a Pointinfo box inside the Graphics Display window.

Option

Description

Hide ID

This menu option hides a single ID label in the Graphics Display window. A hidden label still exists; it's merely hidden from view.

Hide ID in View

This hides the selected feature's ID label only in the current view. In other views it remains visible.

Show IDs, Hide IDs

These submenus let you show or hide the different feature ID labels. You can choose to show or hide these types of ID labels:

  • All

  • Feature Labels

  • Feature Labels visible in view - Only those IDs for features visible on the screen are displayed or hidden.

  • Dimension Infos

  • Point Infos

  • Feature Control Frames

If you choose to hide the ID labels the ID labels still exist and are merely hidden from view.

Show ID in All Views

This shows the selected feature's ID label in all views.

Label Processing

This submenu contains the Automatic Label Positioning option. This menu option allows you to perform a one time automatic positioning of feature ID labels inside the current view.

Hide Feature

This option hides a single feature, removing it from the Graphics Display window. The feature still exists and is merely hidden from view.

Hide All Features

This option hides all features on a part, removing them from the Graphics Display window. The features still exist and are merely hidden from view.

Show All Features

This option displays all previously hidden features in the Graphics Display window.

Reset ID

This option moves a single ID label back to its original location next to the feature.

Reset All IDs

This option moves all ID labels back to their original locations next to their respective features.

Move Cursor To

Select this menu option to move the Edit window's cursor to this feature's command line in the Edit window. This only affects the location of the cursor in the Edit window; the location of the probe in the Graphics Display window remains unchanged.

Change Background Color…

This option displays the Change Label Options dialog box. You can use this dialog box to change the background color for the feature's ID label. You can choose to change all feature labels to this new color or just the current label type. There are three different label types: feature ID labels, Diminfo boxes, and Pointinfo boxes.

You can make your changes the default settings by clicking the Default button.

This does not function with Feature Control Frames.

Change Line Color…

This option displays the Change Label Options dialog box. You can use this dialog box to change the border color for the feature's ID label. You can choose to change all feature label borders to this new color or just the current label type. There are three different label types: feature ID labels, Diminfo boxes, and Pointinfo boxes.

You can make your changes the default settings by clicking the Default button.

This does not function with Feature Control Frames.

Show Shadow…

This option displays the Change Label Options dialog box. You can use this dialog box to display or hide a small shadow under the feature's ID label. You can choose to add a shadow to all label types or to just the current label type. There are three different label types: feature ID labels, Diminfo boxes, and Pointinfo boxes.

You can make your changes the default settings by clicking the Default button.

This does not function with Feature Control Frames.

Feature Shortcut Menu Additions in Text Box Mode

PC-DMIS adds these additional options to the standard Feature Short Cut menu when in Text Box Mode. These include:

Option

Description

Create Feature Control Frame...

This option creates a True Position Feature Control Frame (FCF) dimension from the selected feature. The GD&T dialog box appears. For information on how to create FCF dimensions, see "Using Feature Control Frames".

Create Dim Info Box...

This option creates a Dimension Information text box from the highlighted feature. An Edit Dim Info dialog box appears, showing the available dimensions from which you can create the Dimension info text box.

If no dimensions are associated with the feature, PC-DMIS automatically creates a default Location dimension for the feature (see "Dimensioning Location" in the "Dimensioning Features" section). For information on how to use the Edit Dimension Info dialog box, see "Inserting Dimension Info Boxes" in the "Inserting Report Commands" section.

Create Point Info Box…

This menu option creates a Point Info text box from the highlighted feature. An Edit Point Info dialog box appears, showing the feature (and any available dimensions ) from which you can create the Point Info text box. For information on how to use the Edit Point Info dialog box to create a Point Info text box, see "Inserting Point Info Boxes" in the "Inserting Report Commands" section.

To access these new options:

  1. Select the Text Box Mode icon (see "Text Box Mode" in the "Editing the CAD Display" section).

  2. Right-click on a feature or feature's ID label in the Graphics Display window to display the shortcut menu.

Dimension/Point Info Menu in Text Box Mode

When in text box mode, if you right-click on a Dim Info box or Point Info box, PC-DMIS adds these two options to the standard Feature Shortcut Menu:

Option

Description

Edit…

This option allows you to edit the selected Dimension Info or Point Info text box. A slightly modified Edit Dimension Info or Edit Point Info dialog box opens. In addition to the standard buttons along the bottom of the dialog box, an additional Apply To All button is available:

Click Apply To All to have any changes made in the dialog box apply to all Dimension Info or Point Info boxes:
Note: Only the changes made from the original to the modified info box will be applied across all Dim Info or Point Info boxes. Settings on the original info box that already differ from other info boxes will not be applied to the other info boxes.

For additional information see "Inserting Dimension Info Boxes" in the "Inserting Report Commands" section.

Delete

Select this menu option to delete the selected dimension or point info text box. The corresponding POINTINFO or DIMINFO command in the Edit window will also be deleted.

To access these new options:

  1. Select the Text Box Mode icon (see "Text Box Mode" in the "Editing the CAD Display" section).

  2. Right-click on a Dim Info or Point Info box in the Graphics Display window.


Box-Select Shortcut Menu

This shortcut menu only works in Text Box Mode. To access this menu:

  1. Select the Text Box Mode icon (see "Text Box Mode" in the "Editing the CAD Display" section).

  2. Box-select one or more features. PC-DMIS selects all graphical features or feature ID labels inside the box.

A shortcut with these options appears:

Option

Description

Create Feature Control Frame...

This option creates a True Position Feature Control Frame (FCF) dimension from the selected feature. The GD&T dialog box appears. For information on how to create FCF dimensions, see "Using Feature Control Frames".

Create Dim Info Boxes…

This menu option creates Dimension Info text boxes from the selected features.

An Edit Dimension Info dialog box appears for one of the highlighted features, showing the available dimensions from which you can create the first Dimension Info box.

Once you’ve selected the desired options in the Edit Dimension Info dialog box, click either the OK or Create button (Apply button when editing) to create the Dim Info boxes.

The first Dim Info box will be created from the selected dimension(s) in the Edit Dimension Info dialog box.

Subsequent info boxes will be created from all dimensions associated with each feature.

If no dimensions are associated with any of the features, a default Location dimension will automatically be created for that feature (see "Dimensioning Location" in the "Dimensioning Features" section). For information on how to use the Edit Dimension Info dialog box, see "Inserting Dimension Info Boxes" in the "Inserting Report Commands" section.

Create Point Info Boxes…

Select this menu option to create Point Info text boxes from the highlighted features. An Edit Point Info dialog box appears for one of the highlighted features, showing the feature (and any available dimensions ) from which you can create the Point Info text box.

Once you’ve selected the desired options in the Edit Point Info dialog, select the OK or Create button (Apply button when editing) to create the info boxes.

The first info box will be created from the selected feature or dimension(s) in the Edit Point Info dialog box. Subsequent Point Info boxes will be created from all dimensions associated with each feature and the feature itself. A Point Info box will be created for all dimension and feature hits. For information on how to use the Edit Point Info dialog box to create a Point Info text box, see "Inserting Point Info Boxes" in the "Inserting Report Commands" section.

Show IDs, Hide Ids

Select one of these menu options to show or hide all the selected features' ID labels. If you choose to hide the ID labels the ID labels still exist and are merely hidden from view.

Show IDs in All Views

This option shows all the selected ID labels in all of the available Graphics Display window view panes.

Hide IDs in View

This option hides all the selected ID labels in the current Graphics Display window view pane.

Hide Features

This option hides all selected features on a part, removing them from the Graphics Display window. The features still exist and are merely hidden from view.

Reset Ids

This option moves all selected ID labels back to their original locations next to their respective features.


Quick Fixture Shortcut Menu

This shortcut menu only works in Quick Fixture Mode (see "Inserting Quick Fixtures" in the "Defining Hardware" section). To access this menu:

  1. Select the Quick Fixture Mode icon from the Graphics Modes toolbar.

  2. Right-click on a quick fixture object that you have already inserted into the Graphics Display window.

A shortcut with these options appears:

Option | Description
Drop object | This drops the selected quick fixture onto whatever lies below it in the Graphics Display window. If there is nothing in the -Z direction, then nothing happens. If there is, then the fixture drops down until it touches the object(s) below.
Level object | This takes the normal surface vector of where you just right-clicked and squares that up with the machine coordinate system.
Rotate object | This takes the point where you just right-clicked and drops it on to the closest edge. It then squares up the vector that is tangent to the curve at the drop point. The rotate is a 2D squaring, looking down the current view normal.
Square up | This squares up the selected quick fixture so that its axes are parallel to the CAD axes (minimal change)
Link Fixture Components | This groups all on-screen fixture components together so that dragging or rotating one fixture drags or rotates them all together.
Unlink Fixture Components | This unlinks fixture components, allowing you to manipulate them individually.
Fix Component in Place | If you have linked fixture components, you can use this selection to fix the location of the selected component in the set of linked components. That component will remain fixed at its current location, even if you then move other components of the linked set.
Save Fixture | Selecting this menu items brings up a Save As dialog box that lets you save any on-screen fixture elements. If you have more than one fixture on the screen, then PC-DMIS saves them all as a single set. Saved fixtures get stored in the expandable USER tree in the QuickFix dialog box for later use.
X move only | Selecting this menu item and dragging the fixture will move it along the X axis only.
Y move only | Selecting this menu item and dragging the fixture will move it along the Y axis only.
Z move only | Selecting this menu item and dragging the fixture will move it along the Z axis only.
XY move only | Selecting this menu item and dragging the fixture will move it along the X and Y axes only.
YZ move only | Selecting this menu item and dragging the fixture will move it along the Y and Z axes only.
ZX move only | Selecting this menu item and dragging the fixture will move it along the Z and X axes only.
XY rotate only | Selecting this menu item causes the rotation to take place only in the XY plane. You can rotate by pressing CTRL and dragging the fixture. Select again to clear this option.
YZ rotate only | Selecting this menu item causes the rotation to take place only in the YZ plane. You can rotate by pressing CTRL and dragging the fixture. Select again to clear this option.
ZX rotate only | Selecting this menu item causes the rotation to take place only in the ZX plane. You can rotate by pressing CTRL and dragging the fixture. Select again to clear this option.


Auto Feature Path Lines Shortcut Menu

To access this shortcut menu, select the Show Path Toggle button [image] inside an Auto Feature dialog box.

Option

Description

Insert Hit

Inserts an additional hit into the auto feature.

Delete Hit

Deletes the selected hit from the auto feature.

Insert Sample Hit

Inserts a sample hit for the auto feature.

Delete Sample Hit

Deletes the selected sample hit from the auto feature.

Insert Row

When working with a feature that uses multiple rows of hits, such as a cylinder or cone, this inserts another row of hits.

Delete Row

When working with a feature that uses multiple rows of hits, such as a cylinder or cone, this deletes the selected row of hits.

User Defined Hits

This menu option becomes automatically selected whenever you manually make a change to a hit or path using the mouse.

If you then deselect this menu option, PC-DMIS reverts your change back to what it was before.

Additionally, if you have this option selected for a hit and then change to the feature's perpendicular view, using View Perpendicular, you can adjust the depth or height for that specific hit.

View Normal

This changes the CAD view of the feature to a top-down view.

View Perpendicular

This changes the CAD view of the feature to a side view, ideal for defining a feature's depth or adding additional levels of hits.


Shortcut Menus in the Edit Window

PC-DMIS's Edit window contains the following shortcut menus depending on what Edit window mode is selected.

More:

Summary Mode Command Shortcut Menu

Data Item Shortcut Menu

Command Mode Shortcut Menu


Summary Mode Command Shortcut Menu

When you select a command item in the Edit window's Summary Mode (see "Working in Summary Mode" in the "Using the Edit Window" section) and right-click on the command item, the command shortcut menu appears. This menu has the following options:

Option

Description

Edit

This option causes the dialog for the current object to be displayed.

Mark

This option toggles the mark state of the object for execution.

Delete

This option deletes the selected command and any sub-commands out of the part program.

Copy

This option copies the selected command to the Clipboard.

Cut

This option cuts the selected command to the Clipboard and removes the command from the part program.

Paste

This option pastes a command that was previously cut or copied from the Clipboard and places it below the selected command.

Collapse Groups

This option collapses all expanded user-defined groups. Other expanded items remain expanded.

Collapse All

This option collapses all expanded items.

Expand Command

This option expands the current command line and displays any data or group items associated with the selected command.

Add Command

This option allows you to add a command to the Edit window from an alphabetized scrollable list.

STEP 1: Navigate through the list by typing the first few letters of the command. PC-DMIS automatically goes to that command.

STEP 2: Select the command from the list.

STEP 3: Press either CTRL + ENTER or ENTER to place the new command into the Edit window.

Pressing CTRL + ENTER places the command after the command block used to open the shortcut menu..

Pressing ENTER places the command inside the command block used to open the shortcut menu. Using the ENTER key only functions in this manner if the command you are adding is a type of command that PC-DMIS allows to be inserted into another command block. Otherwise PC-DMIS inserts it after the current command.

Docking View

This menu option determines whether or not the Edit window is docked or undocked.

If you deselect this option, the Edit window behaves like it did in previous versions of PC-DMIS, floating over the Graphics Display window.

If you select this option, you will be able to dock the Edit window to the sides or top or bottom of the Graphics Display window.

Optimize Path

This menu option lets you perform a run the path optimization routine if you are using the Inspection Planner module, otherwise this option is not accessible. See the Inspection Planner documentation on how to use this.

Test <Feature>

This menu option only appears when right-clicking on an auto feature.

It performs a test execution of the selected auto feature. This functions the same as the Test button in the Auto Feature dialog box.

Note: Care should be taken when using this option as a probe collision may occur due to ignored clearance planes.

Move To <Feature>

This menu option only appears when right-clicking on an auto feature.

It moves the probe to the center of the selected auto feature. This functions the same as the Move To button in the Auto Feature dialog box.

Note: Care should be taken when using this option as a probe collision may occur due to ignored clearance planes.


Data Item Shortcut Menu

The data item shortcut menu appears when right-clicking on a data item in the Edit window's Summary Mode (see "Working in Summary Mode" in the "Using the Edit Window" section). This shortcut menu has the following options:

Option | Description
Edit | The submenu for this item includes Value / Expression Text and Use Expression Builder.
Value /Expression Text: | Allows you to edit the current item if the item can be edited. If the data item is a toggle item, a toggle list will appear, otherwise a box for editing the current value will appear.
Use Expression Builder: | If the item can be edited, brings up the Expression Builder dialog box allowing you to create expressions for the selected field.
Copy | Copies one of three text options to the Clipboard for the selected data item.
Value Text: | Copies the current value of the data item to the Clipboard.
Expression Text: | Copies the current expression text to the Clipboard if an expression exists for the data item.
Description Text: | Copies the current data item description to the Clipboard.
Paste | This pastes a copied value, expression text, or item description to a new location.
Docking View | See description given in the "Summary Mode Command Shortcut Menu"


Command Mode Shortcut Menu

The following shortcut menu options are available when PC-DMIS is in Command Mode. For information on these modes, see "Working in Command Mode" in the "Using the Edit Window" section.

Option

Description

Select Command

Highlights the command that the mouse is positioned over

Select Block

If the mouse is over a start or end block object, selects the entire block.

Execute From Command

This option starts execution from the current location of the insertion point in the edit window.

Execute Block

This option executes the currently marked block of commands.

Jump To <Feature>

This option jumps from the current command to the referenced feature ID.

Jump Back

This option jumps back to the command you were at before you selected the Jump To option.

Edit

This opens up the dialog box that allows you to edit the command that the cursor resides on.

Mark

This option toggles the mark state of the object for execution. For more information on marking, see "Mark" in the "Editing a Part Program" section.

Group

This option inserts the list of contiguous selected commands into a user-defined group.

Collapse Group

This option collapses all expanded user-defined groups. Other expanded items remain expanded.

Set as Start Point

This option determines the starting location at which part program execution begins when you select the File | Partial Execution | Execute From Start Points menu option. See "Setting Start Points" in the "Editing a Part Program" section.

Breakpoint

This option inserts a breakpoint at the cursor's location. For more information on breakpoints, see "Using Breakpoints" in the "Editing a Part Program" section.

Bookmark

This option inserts a bookmark at the cursor's location. For more information on bookmarks, see "Using Bookmarks" in the "Editing a Part Program" section.

Override FindNoms

This option overrides the default FindNoms behavior of PC-DMIS during Learn Mode and Execute mode. For more information, see "Overriding Found Nominals" in the "Editing a Part Program" section.

Copy

This option copies the selected Edit window text to the Clipboard. For more information on copying in the Edit window, see "Copy" in the "Editing a Part Program" section.

Cut

This option cuts the selected Edit window text to the Clipboard. For more information on cutting in the Edit window, see "Cut" in the "Editing a Part Program" section.

Paste

This option pastes text from the Clipboard into the Edit window at the cursor's location. For more information on pasting in the Edit window, see "Paste" in the "Editing a Part Program" section.

Docking View

See description given in the "Summary Mode Command Shortcut Menu"

Change Pop-up Display

Expression Value

  1. Select Expression Value.

  2. Let your cursor rest over an expression.

  3. A small pop-up window appears, displaying the current value of the expression.

Data Type Information

  1. Select Data Type Information.

  2. Let your cursor rest over a data field.

  3. A small pop-up window appears, displaying information about that data field including the data type description, the data type number, and the type index.

The information displayed in this pop-up window can be used with the GETTEXT expression. See the "Using Expressions and Variables" section.

Command Information

  1. Select Command Information.

  2. Let your cursor rest over any Edit window command.

A small pop-up window appears, displaying command description information and the command type number. The information displayed in this pop-up window can be used with the GETCOMMAND expression. See the "Using Expressions and Variables" section.

Object

This menu option remains unavailable for selection until you insert an external object into the Edit window. See "Inserting External Objects" in the "Adding External Elements" section for information on how to do this.

Once you select the inserted external object in the Edit window and then right-click on it, this menu changes to reflect options unique to that particular object. These may include options such as opening the object, editing the object, or simply modifying the object's properties.

Test <Feature>

This menu option only appears when right-clicking on an auto feature.

It performs a test execution of the selected auto feature. This functions the same as the Test button in the Auto Feature dialog box.

Care should be taken when using this option as a probe collision may occur due to ignored clearance planes.

Move To <Feature>

This menu option only appears when right-clicking on an auto feature.

It moves the probe to the center of the selected auto feature. This functions the same as the Move To button in the Auto Feature dialog box.

Care should be taken when using this option as a probe collision may occur due to ignored clearance planes.


Shortcut Menus in the Report Window

If you right-click in the Report window, PC-DMIS displays a shortcut menu with menu items that affect how objects are displayed in the Report window. Certain menu items only appear if you right-click on specific underlying objects in the Report window. The various menu items you can access from the Report window's shortcut menu are discussed in the table below:

Option

Description

Edit Object...

This option allows you to modify the current object in the Report window from its default state.

  • If you right-clicked on a label object in the Report window, the Label Properties dialog box appears, allowing you to modify that label.

  • If you right-clicked on the TextReportObject (essentially any white space text at the end of your report or any non table-like reporting text), the Report dialog box appears allowing you to determine what gets included in your report.

Hint: Pressing SHIFT and right-clicking on any label object will display the Report dialog box.

For more information see "Changing the Report Window's Contents" in the "Reporting Measurement Results" section.

Edit Color Ball

This allows you to change certain properties of the color ball terminator at the end of a label's leader line.

For more information see "Changing Label Line Color Ball Properties"

Hide Selected Labels

This option hides any selected labels used with the CADReportObject.

Select the labels you want to hide and then right-click on one of the selected labels for this menu item to appear.

You can select multiple labels at a time by dragging a box around the desired labels with the mouse or by holding down the CTRL key and clicking on the desired labels.

Show Hidden Labels

This option shows all hidden labels. Right-click on the CADReportObject for this menu item to appear.

Remove Object

This option removes a selected label object or section cut profile object that you added using the Add Object on Page sub-menu.

You should not use the DELETE key when attempting to remove selected objects; doing so deletes selected commands in the Edit window instead.

Remove Object Modifications

This option returns the object you right-clicked on to its original state, removing any modifications you may have made using the Edit Object... menu item or made resizing or repositioning supported objects. If more than one modification is made, a Remove Modifications dialog box appears, containing check boxes for each modification made on the object. Using this interface you can select which modifications you want to remove.

Change Template...

This option displays an Open dialog box, allowing you to change the template used to display and format the data from the underlying command. Only those templates specified to work with the command will appear in the dialog box.

If you have multiple labels selected when you use this option (such as after using the Select Matching Labels menu item), PC-DMIS applies the label change to all the selected labels.

Select Matching Labels

This option appears when you right-click on a label. This option selects all labels on the current page that use the same label template as the label on which you clicked.

Duplicate Page

This option creates an identical page of the one on which you right-clicked immediately following the current page. You may find this helpful in organizing labels that can't fit on one page across multiple pages.

You can remove a duplicated page by right-clicking on it and selecting Remove Duplicated Page.

Remove Duplicated page

This option only appears in the menu when you right-click on a previously duplicated page. Selecting it removes the duplicated page from the report.

Add Object on Page > Section Cut Profile

This option inserts a section cut profile of your part model into the report.

After selecting this option, use your mouse and drag a box in the Report window to insert the section cut profile. See the information in the "SectionCutObject" topic in the "Reporting Measurement Results" section for detailed information.

Using this method you can insert multiple cutaway views into your report.

Add Object on Page > Custom Label...

This menu item lets you insert a custom label object on the fly into the active report. This type of label insertion process is not tied in any way to the Rule Tree Editor.

Select this menu item and then drag a box in the Report window. An Open dialog box appears, allowing you to insert a selected label template on the fly into the current page of the report.

Select Labels...

This menu item allows you to easily select multiple labels across different sections in your report.

When you select this item, PC-DMIS displays the Select Labels dialog box. This dialog box displays the labels in your report that are tied to a CADReportObject. Select any labels from this dialog and when you click OK on the dialog box, PC-DMIS selects the corresponding labels in the report.

You can limit the labels displayed in the dialog box by feature type, dimension type, or by all commands.

For more information see "Changing the Report Window's Contents" in the "Reporting Measurement Results" section.

Wireframe

This menu item toggles the display of the selected CADReportObject by displaying the model as either a wire frame or a solid. This menu item only appears if you right-click on a CadReportObject in your report.

Modify Rules...

This menu item brings up a simplified version of the Rule Tree Editor dialog box. You can use the Disable or Enable options on this dialog to turn rules on or off.


Errors Codes

Error Codes

Error codes are used to alert the operator of warnings and error conditions that occur within the Coordinate Measuring System (CMS). The CMS consists of a coordinate measurement machine (CMM ), the CMM electronics, and a personal computer (PC) running MeasureMax+ or MaxLite.

The error codes in this section are specific to the Sheffield components which includes the CMM electronics and Measurement Library (MLB) commands.

Error codes are denoted by a group name, a hyphen and a number. A few examples are MP-523, MLB-010, and TempComp-200.

The error groups are:

  • MLB

  • MP

  • DCC

  • RCU

  • TempComp


MLB Error Information

An MLB error is generated by an MLB command that cannot be processed. It can occur when a part program is running, when a part is being measured, or when a part program is being edited within QuickTeach or MaxLite. MLB errors do not include errors detected by Visual Basic. Refer to the VB help for assistance with VB errors.

Some examples of MLB errors are:

  1. A resource is not available, such as MLB-090 for 'DCC not available', or RCU-050 for 'RCU not available'.

  2. Command syntax is invalid, such as MLB-020 for 'improper parameter', or MLB-010 for 'unidentified function command string'.

  3. CMM cannot complete the motion, such as MLB-168 for 'unexpected touch', or MLB-169 for 'unexpected end-of-travel'.

  4. Data cannot be processed, such as MLB-038 for 'cannot intersect line parallel with cylinder axis ', or MLB-070 for 'reference not saved'.

MLB errors are displayed at the PC, typically in a dialog box.

The MLB error codes are listed in this table:

MLB-001 | MLB-026 | MLB-062 | MLB-114 | MLB-168
MLB-003 | MLB-027 | MLB-063 | MLB-115 | MLB-169
MLB-004 | MLB-028 | MLB-064 | MLB-116 | MLB-170
MLB-005 | MLB-029 | MLB-070 | MLB-120 | MLB-173
MLB-006 | MLB-030 | MLB-071 | MLB-130 | MLB-190
MLB-007 | MLB-031 | MLB-072 | MLB-131 | MLB-191
MLB-010 | MLB-032 | MLB-080 | MLB-132 | MLB-505
MLB-011 | MLB-033 | MLB-088 | MLB-140 |
MLB-012 | MLB-034 | MLB-089 | MLB-150 |
MLB-013 | MLB-035 | MLB-090 | MLB-151 |
MLB-014 | MLB-036 | MLB-091 | MLB-152 |
MLB-015 | MLB-037 | MLB-092 | MLB-153 |
MLB-016 | MLB-038 | MLB-093 | MLB-154 |
MLB-017 | MLB-040 | MLB-094 | MLB-155 |
MLB-018 | MLB-041 | MLB-095 | MLB-156 |
MLB-019 | MLB-042 | MLB-096 | MLB-157 |
MLB-020 | MLB-043 | MLB-100 | MLB-158 |
MLB-021 | MLB-044 | MLB-101 | MLB-160 |
MLB-022 | MLB-045 | MLB-110 | MLB-161 |
MLB-023 | MLB-050 | MLB-111 | MLB-162 |
MLB-024 | MLB-060 | MLB-112 | MLB-164 |
MLB-025 | MLB-061 | MLB-113 | MLB-166 |


MLB-001 MP Internal syntax error

A system error internal to the Measurement Processor (MP) occurred.

Effect

Command is aborted. Further part program operations may be impossible.

W hat you should do

  1. Reset system.

  2. If the error reoccurs, contact your Giddings & Lewis service representative.


MLB-003 Communications error

This is generally caused by a required system resource that is not present or is not functional. This is an MP internal system error.

Effect

Command is aborted. Further system operations may not be possible.

W hat you should do

  1. Reset system.

  2. If the error reoccurs, contact your Giddings & Lewis service representative.


MLB-004 Numeric error

A condition exists that prevents a valid result from an arithmetic operation, e.g., an attempted division by zero. This is an MP internal system error.

Effect

Command is not executed.

W hat you should do

  1. Ensure the points being measured define a feature of the type that is being inspected or that the attempted feature construction operation makes sense.

  2. If no cause can be determined for the error, contact your Giddings & Lewis service representative.


MLB-005 Communications error

IO command had communication errors with the MP. This is an MP internal system error.

Effect

The I/O bits cannot be read or written properly.

W hat you should do

  1. Reset system.

  2. If the error reoccurs, contact your Giddings & Lewis service representative.


MLB-006 Output mask logical translation error

IO command had error translating output mask logical. This is an MP internal system error.

Effect

Command is not executed.

What you should do

  1. Correct the output mask logical format and rerun the program.

  2. Reset system.

  3. If the error reoccurs, contact your Giddings & Lewis service representative.


MLB-007 Output unavailable

IO command determined output unavailable using output mask logical. This is an MP internal system error.

Effect

Command is not executed.

What you should do

  1. Change the output port number and rerun the program.

  2. Reset system.

  3. If the error reoccurs, contact your Giddings & Lewis service representative.


MLB-010 Unidentified FCS

The specified Function Command String (FCS) did not correspond to any defined MLB command.

Effect

Command is not executed.

What you should do

  1. Correct the part program to use the correct FCS identifier.


MLB-011 First record in skip file is invalid

The first line of the skip file must be either "Type=SKIP" or "Type=EXEC".

Effect

Skip file is ignored and normal part program operation will occur if you continue.

W hat you should do

  1. Correct the contents of the skip file.


MLB-012 Invalid record in skip file

A line in the skip file did not correspond to either a comment or a validly formatted code block name.

Effect

Invalid line is ignored.

W hat you should do

  1. Correct the contents of the skip file.


MLB-013 Skip file access error

An error occurred while reading the skip file.

Effect

Skip file is ignored.

W hat you should do

  1. Check the skip file and skip file media for errors.


MLB-014 Nested code blocks

Part program contains nested named code blocks. The beginning (BB) of a second code block occurred before the end (EB) of the preceding code block

Effect

Command is not executed.

W hat you should do

  1. Correct the part program.


MLB-015 Missing begin block

An end block (EB) command was encountered without a matching begin block (BB) command.

Effect

Command is not executed.

W hat you should do

  1. Correct the part program.


MLB-016 Nested skip sequence

Part program contains nested skip sequence. A second begin skip command was encountered without an intervening end skip statement.

Effect

Command is not executed.

What you should do

  1. Correct the part program.


MLB-017 Invalid end skip block function

An end skip sequence command was found without a matching begin skip sequence command.

Effect

Command is not executed.

W hat you should do

  1. Correct the part program.


MLB-018 Improper tolerancing mode

Bolt circle or rectangular pattern function cannot be called when in limit tolerancing mode.

Effect

Command is not executed.

W hat you should do

  1. Correct the part program.


MLB-019 Improper parameter

Too many or not enough parameters specified, or an invalid parameter was specified.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-020 No parameter permitted

The specified command does not allow any parameters but a parameter was specified.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-021 First parameter invalid

The first parameter specified was not valid for this function.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-022 Second parameter invalid

The second parameter specified was not valid for this function.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-023 Third parameter invalid

The third parameter specified was not valid for this function.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-024 Fourth parameter invalid

The fourth parameter specified was not valid for this function.

Effect

Command is not executed.

What you should do

  1. Check the command's definition and correct the part program.


MLB-025 Invalid parameter specified

One of the parameters specified was not valid for this function.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-026 Invalid tip specified

The specified tip has not been calibrated, or the tip number is out of range.

Effect

Command is not executed.

W hat you should do

  1. Check the specified tip and either correct the name, calibrate the tip, or select the correct probe tip file.


MLB-027 Excessive angular deviation

An attempt has been made to compute parallelism between two features that are almost perpendicular or to compute perpendicularity between two features that are almost parallel.

Effect

Command is not executed.

W hat you should do

  1. Correct the part program to specify the correct features or the correct command.


MLB-028 Insufficient number of parameters

A required parameter has not been specified for this function.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-029 Dimensional array values out of range

Data in the Dimensional Array is too large or too small to be used as specified for this function.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the Dimensional Array data.


MLB-030 Feature stack does not contain required features

One of the following conditions exist:

  1. Feature register is empty;

  2. Specified or required feature position is empty;

  3. Feature stack does not contain two features;

  4. Feature stack does not contain the required features;

  5. Feature stack does not contain the required number of points to define the feature.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program to get the proper data into the feature stack.


MLB-031 First parameter specifies invalid type

The feature specified by the first function parameter is not the correct type for the function. Note that this error may occur if no parameter is specified and the function defaults to using the data in the Feature Register and the type of that feature is incorrect.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-032 Second parameter specifies invalid type

The feature specified by the second function parameter is not the correct type for the function. Note that this error may occur if no parameter is specified and the function defaults to using the data in the first feature stack position (F1) and the type of that feature is incorrect.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-033 Plane is invalid type

The specified feature is a plane and a plane type feature is not valid for the function.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-034 Cannot intersect concentric circles

The circles specified for the computation of an intersection point were concentric and do not intersect.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-035 Line perpendicular to working plane

The function operation required that the specified line be projected into the active working plane but the line was perpendicular to that plane and could not be projected.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-036 Invalid (null) feature addressed

The specified feature is of type 'null', indicating that it is the result of a skipped operation, but this function cannot be executed with a 'null' feature.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-037 Invalid feature type

The type of the feature selected for this function is not valid.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-038 Cannot intersect line parallel with cylinder axis

Execution of the command required computing a line with a cylindrical surface but the specified line is parallel to the cylinder's axis and does not insect the cylindrical surface.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-040 Summation array does not contain enough features

The number of points required for this command are not contained in the summation array.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-041 Points do not define the feature

One of the following conditions exist:

  1. The points do not define the feature (circle, line in the working plane, line in space, or a plane).

  2. The features do not define an offset angle.

  3. Either the line is perpendicular to the measurement plane, or the points are equal when projected onto the measurement plane. The offset angle is not changed.

  4. The features are parallel.

  5. The features are perpendicular.

  6. The features are identical.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-042 Summations invalid

The specified summation array is invalid due to a preceding operation.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-043 Segmentation in progress

The command cannot be executed while a segmented measurement is in progress.

Effect

Command is not executed.

W hat you should do

  1. Correct the part program.


MLB-044 Segmentation not initialized

An attempt was made to execute a 'next segment' command when a segmented measurement sequence had not been properly initialized.

Effect

Command is not executed.

W hat you should do

  1. Correct the part program.


MLB-045 Command cannot be skipped

An MLB command which may not be skipped was included within a skipped block of code.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-050 RCU not available

The command requires an RCU to be present when no RCU is available.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-060 Rotary table not available

The command requires a rotary table to be present when no rotary table is available.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-061 Rotary table counter not available

The command requires a rotary table with a counter to be present.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-062 Not allowed on rotary table with counter

The command is not valid if the system contains a rotary table with a counter.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-063 Not allowed on error-corrected rotary table

The command is not valid if the system contains an error-corrected rotary table.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-064 Not allowed on a Hirth coupling table

MLB 064 - Not allowed on a Hirth coupling table

The command is not supported for a Hirth coupled table.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-070 Reference not saved

The command attempted to recall a reference frame that had not been saved.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-071 Feature storage overflow

The system does not have enough storage available to save another feature.

Effect

Command is not executed.

W hat you should do

  1. Check the system specifications and correct the part program. Previously saved features may need to be deleted.


MLB-072 Feature not found

The command attempted to recall or delete a feature that had not been saved.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.


MLB-080 Improper probe installed

The function is not compatible with the type of probe installed; for example, a sweep function is not valid when a touch probe is installed. This error may also occur on a system with a probe changer if the system is powered up with a probe mounted or a probe is manually mounted when the system believes that no probe is installed.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.

  2. Adjust the installed equipment to correct the problem.


MLB-088 RCU Drive button used with QU

The QU command was terminated by the Drive key on the RCU-II.


MLB-089 RCU Return-to-screen button used with QU

The QU command was terminated by the Return-to-screen key on the RCU-II.


MLB-090 DCC not available

The command requires DCC functionality when DCC operations are not currently available in the system.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.

  2. Adjust the installed equipment to correct the problem.

  3. Correct any problem which is preventing DCC operations.


MLB-091 Contact not made with part

During an attempted DCC touch, the probe has traveled to the target plus the overdrive distance and the part has not been contacted.

Effect

Point data is not recorded. It may not be possible to continue the part program.

W hat you should do

  1. Determine the cause of the problem. Either correct the program or correctly position the part.


MLB-092 Insufficient clearance

The specified probe diameter and clearance does not allow the probe to enter a bore.

Effect

Command is not executed.

W hat you should do

  1. Determine the cause of the problem. Either correct the specified bore size, reduce the allowed clearance or use a smaller probe.


MLB-093 Remote auto not configured

The command to select automatic mode has been executed on a system that is not properly configured to support this operation.

Effect

Command is not executed.

W hat you should do

  1. Determine the cause of the problem. Either correct the program or correctly configure the system.

  2. If the error reoccurs and it is supposed to support this operation, contact your Giddings & Lewis service representative.


MLB-094 Remote auto interlock not engaged

The command to select automatic mode has been executed but the remote auto hardware interlock is not engaged.

Effect

Command is not executed.

W hat you should do

  1. Determine the cause of the problem. Either correct the program or engage the remote auto interlock. Manually select AUTO mode to continue the part program .

  2. If the error reoccurs and it is supposed to support this operation, contact your Giddings & Lewis service representative.


MLB-095 Servo power failed to engage

The command to select automatic mode has been executed but the system was unable to turn on servo power.

Effect

Command is not executed.

W hat you should do

  1. Determine the cause of the problem. Either correct the program or eliminate the hardware problem that is preventing servo power from engaging. Manually turn on servo power and select AUTO mode to continue the part program .

  2. If the error reoccurs and it is supposed to support this operation, contact your Giddings & Lewis service representative.


MLB-096 Unable to select Auto mode

The command to select automatic mode has been executed but the system was unable to select Auto mode.

Effect

Command is not executed.

W hat you should do

  1. Determine the cause of the problem. Either correct the program or eliminate the hardware problem that is preventing Auto mode. Manually select Auto mode to continue the part program.

  2. If the error reoccurs and it is supposed to support this operation, contact your Giddings & Lewis service representative.


MLB-100 Probe head datum error

The PH9 or PH10 2-axis probe did not seat properly after a move and is not locked in position.

Effect

Command is not executed.

W hat you should do

  1. Reseat the 2-axis probe head and continue.


MLB-101 Probe head obstruct error

MLB-101 Probe head obstruction error

The PH9 or PH10 probe head did not complete the move into position due to an obstruction.

Effect

Command is not executed.

W hat you should do

  1. Reseat the 2-axis probe head and continue.


MLB-110 Tip 0 not calibrated

An attempt was made to calibrate a tip other than the master tip (tip #0) when the calibration fixture's location relative to tip 0 was unknown. Tip 0 must be calibrated before any other tip can be calibrated. Note that this error may occur if a tip 0 calibration operation was started and then aborted.

Effect

Command is not executed.

W hat you should do

  1. Calibrate tip 0.


MLB-111 Spherical calibration fixture required

Automatic calibration attempted after execution of an MLB command that specified the calibration fixture was a cone rather than a sphere.

Effect

Command is not executed.

W hat you should do

  1. Correct the part program.


MLB-112 Temperature change invalidated tip 0 calibration

On a system with automatic temperature sensors, the temperature has changed enough since tip 0 was calibrated so that additional tips cannot be calibrated accurately.

Effect

Command is not executed.

W hat you should do

  1. Re-calibrate tip 0 before calibrating additional tips.


MLB-113 Negative probe diameter invalidated calibration

A probe calibration operation resulted in computing a negative probe diameter. This is typically caused by specifying the wrong size for the calibration sphere or having the wrong measurement units active when specifying the calibration sphere size.

Effect

Command is not executed.

W hat you should do

  1. Correct the problem and recalibrate the probe.


MLB-114 Excessive probe offsets invalidated calibration

A probe calibration operation resulted in computing probe offsets that were obviously invalid. This is typically caused by specifying that the calibration sphere is at the MEA position when it is not or by moving the calibration sphere after calibrating tip 0 without then executing the 'locate sphere' function.

Effect

Command is not executed.

W hat you should do

  1. Correct the problem and recalibrate the probe.


MLB-115 File error on feature or probe storage operation

Feature or probe data could not be stored in the host disk data storage. Disk may be write protected or full.

Effect

Command is not executed.

W hat you should do

  1. Correct the problem and rerun the program.


MLB-116 Not on circle at beginning of circular move

The CMM is not positioned within the move tolerance of the commanded circle at the beginning of a circular move command.

Effect

Command is not executed. SMP is put into manual mode.

W hat you should do

  1. Check the move commands immediately before the circular move.


MLB-120 Part improperly aligned or scaled

Part not aligned with machine or scaled differently for rectangular scan, or part not level or scaled differently for Polar scan.

Effect

Command is not executed.

W hat you should do

  1. Correct the program to correctly align and/or scale the part.


MLB-130 Operator abort

The operation was aborted due to an operator selection.

Effect

Command is not executed.

W hat you should do

  1. Acknowledge the error message and either continue or abort the part program as appropriate.


MLB-131 Electronic level not available

A command to read the electronic level was executed and the electronic level is not available.

Effect

Command is not executed.

W hat you should do

  1. Verify that the electronic level is available in this system and is not functional.


MLB-132 Electronic level interface timeout

A command to read the electronic level was executed and the electronic level timed out.

Effect

Command is not executed.

W hat you should do

  1. Verify that the electronic level is functional.


MLB-140 Point not available

The specified data point is not in the summation array. The program did not store the point.

Effect

Command is not executed.

W hat you should do

  1. Correct the part program.


MLB-150 APC rack not connected

The cable that should connect the automatic probe changer rack to the ACU is not attached to the rack and/or the ACU.

Effect

Command is not executed.

W hat you should do

  1. If you have an automatic probe changer (APC) rack, connect it.

  2. If you do not have an APC rack, use an alternate MLB command that does not require an APC rack.


MLB-151 APC firmware or interface not present

You have requested an automatic probe changer (APC) rack function, but the APC or support firmware is not available.

Effect

Command is not executed.

W hat you should do

  1. Use an alternate function that does not require the APC.


MLB-152 APC rack not calibrated

You are trying to run a part program using the automatic probe changer (APC) rack, but it has not been calibrated.

Effect

Command is not executed.

W hat you should do

  1. Calibrate the automatic probe changer rack.


MLB-153 APC/MP communication error

The communications between the automatic probe changer rack and the MP are down.

Effect

The MP cannot communicate with the automatic probe changer rack.

W hat you should do

  1. Reset the MP and the automatic probe changer rack.

  2. If the error reoccurs, contact your Giddings & Lewis service representative.


MLB-154 APC rack timeout or lock failure

The time allotted for a probe transaction was exceeded or an adapter failed to lock.

Effect

Command is aborted.

W hat you should do

  1. Reset the automatic probe changer rack.


MLB-155 APC rack overtravel

Excess motion of the automatic probe changer rack assembly.

Effect

Command is not executed.

W hat you should do

  1. Recalibrate the automatic probe changer rack.


MLB-156 Safe position not defined

A safe PH9A rotation position has not been defined.

Effect

You cannot use the automatic probe changer rack.

W hat you should do

  1. Define a safe PH9A rotation position.


MLB-157 No extensions loaded

You are trying to assemble a multi-station probe, when there are no extensions in the automatic probe changer rack.

Effect

Command is not executed.

W hat you should do

  1. Load and calibrate the necessary extensions.


MLB-158 Too many extensions loaded

You tried to load more than three extensions on the probe.

Effect

Command is not executed.

W hat you should do

  1. Make sure the last automatic probe changer station specified in a probe configuration contains a stylus.


MLB-160 Firmware entity not found

There is a bad ROM or CPU board in the MP.

Effect

System is inoperable.

W hat you should do

  1. Contact your Giddings & Lewis service representative.


MLB-161 APC rack could not be lowered

APC rack could not be lowered.

Effect

A command was executed which required the APC rack to be lowered and it could not be lowered.

W hat you should do

  1. Check the command's definition and correct the part program.

  2. Correct problem with the APC rack lower / raise capability.

  3. If the error reoccurs, contact your Giddings & Lewis service representative.


MLB-162 APC rack could not be raised

A command was executed which required that the APC rack be raised and it could not be raised.

Effect

Command is not executed.

W hat you should do

  1. Check the command's definition and correct the part program.

  2. Correct problem with the APC rack lower / raise capability.

  3. If the error reoccurs, contact your Giddings & Lewis service representative.


MLB-164 Insufficient analog probe deflection

The analog probe is deflected less than one half of its nominal deflection at the beginning of an AS command.

Effect

Command is not executed.

W hat you should do

  1. Check the move commands immediately before the AS command. The nominal analog probe deflection can be read using the KD command.


MLB-166 Not a circle

Cause

The CMM is not positioned within the move tolerance of the commanded circle at the beginning of a circular move command.

Effect

Command not executed, SMP put into manual mode.

User Action

Check the move command immediately before the circular move command.

Manager Action

None.


MLB-168 Unexpected touch

Touch probe was deflected while in auto mode other than during a touch or seek command. This typically happens during a DCC motion that was presumed to be over a clear path.

Effect

Machine is placed in manual mode.

W hat you should do

  1. Remove obstruction and put the machine back in auto mode or reprogram the machine motion instructions.


MLB-169 Unexpected end-of-travel

Machine motion was prevented by a physical obstruction. Typically this happens as a result of attempting to drive beyond the physical limits of one or more axes.

Effect

Machine is placed in manual mode.

W hat you should do

  1. Determine the cause of the problem. Remove the physical obstruction or correct the part program.


MLB-170 Touch probe will not rearm

In auto mode, the touch probe was deflected and failed to rearm after backing away from the surface. This may happen because of an obstruction or an internal problem.

Effect

Machine is placed in manual mode.

W hat you should do

  1. Free the probe if it is obstructed or check and adjust the probe tension.

  2. Put the system back into auto once the probe is rearmed to allow the program to continue.


MLB-173 PH9 probe overload

The PH9 or PH10 has experienced enough force on one of its axes to cause it to lose its programmed position.

Effect

Machine is placed in manual mode.

W hat you should do

  1. Reset the PH9 via the RCU, if possible. After the probe head has been reseated, place the system back into AUTO mode to allow the part program to continue.


MLB-190 Too much probe deflection

The analog probe is over-deflected during a scan move command.

Effect

SMP is put into manual mode when:

  • TrapScanDeflectStatus = False (System Default). The command is temporarily halted until SMP is put into automatic mode.

  • TrapScanDeflectStatus = True. The command is not executed. The variable ScanDeflectStatus equals 2.

What you should do

  1. Check part surface.

  2. Check current soft probe deflection value.

  3. Initiate user-generated scan error recovery routine.


MLB-191 Came off surface

The analog probe is under-deflected during a scan move command.

Effect

SMP is put into manual mode when:

  • TrapScanDeflectStatus = False (System Default). The command is temporarily halted until SMP is put into automatic mode.

  • TrapScanDeflectStatus = True. The command is not executed. The variable ScanDeflectStatus equals 0.

What you should do

  1. Check part surface.

  2. Check current soft probe deflection value.

  3. Initiate user-generated scan error recovery routine.


MLB-505 User Key Unknown

The UK command specifies a user key that is not defined.

Effect

Command is not executed.

What you should do

  1. Check the command's definition and correct the part program.

  2. Add the user key to the database labels in MeasureMax+.


MP Error Information

An MP error is associated with the CMM electronics. The error numbers are categorized into the following groups:

Group | Range | Description
MP | 1-199 | Diagnostic errors
TempComp | 200-299 | Temperature compensation
MP | 300-399 | Stand-alone operation using MP front panel on MP-30/35
MP | 500-599 | MP power-up
MP | 600-699 | DCC power-up
RCU | 700-799 | RCU power-up

MP error numbers are typically displayed on the fourth row of the XYZ Display at the PC. XYZ Display is a monitor that can be displayed as a window in MeasureMax+ and STI. On MaxLite systems, it is displayed in the lower-right corner. If you have an MP-30/35 system with a front panel, then the error is also shown in the W-axis display of the MP front panel.

For memory errors, additional information is shown in the Z-axis of the XYZ Display (or MP front panel, if available). The hexadecimal address and bit information allows the Giddings & Lewis service representative to diagnose the source of the error. Memory errors are displayed in the format "AAAAA C", where "AAAAA" is the address and "C" is the bit.

  • In the case of MP RAM, "C" is the bit location where the error occurred. For MP ROM, DCC RAM and ROM errors, "C" is the byte where the error occurred.

  • If the error number is 500-599, the address and bit information pertains to the MP CPU board.

  • If the error number is 600-699, the address and bit (or chip) information pertains to the DCC board.

If error MP-160 occurs during power-up, check the DCC board LED, cycle power and watch the LED. A sequence of characters flashes on the LED as testing takes place. Each character represents a test of a specific system component or of communication between components. If one of these tests fails, the character representing that test remains on the LED. The DCC Led sequence is:

A | Testing shared RAM memory cells
B | Testing DCC to MP interrupt
C | Testing MP interrupt acknowledge
D | Testing MP to DCC interrupt
E | Testing DCC ROM and RAM
F | All tests passed - waiting for first MP interrupt

If the DCC board fails after the system is on, error MP-060 or MP-151 occurs. These errors indicate that the MP is unable to communicate with the DCC board. Check the DCC board LED for the following numbers:

1 | 32 ms since last D/A update
2 | 32 ms since last MP update
3 | DCC to MP interrupt not acknowledged for 32 ms
8 | System running normally
9 | Waiting for initial MP shared RAM sync-up

On the DCC board LED, a decimal point before the error number means the CPU is inactive. A decimal point after the error number means the hardware detected a failure to update D/A for 32 milliseconds.

For MP power-up failures (error number 500-599), it may not be able to transmit an error message to the computer. On an MP-30/35 system with a front panel, the error is shown in the W-axis display of the MP front panel. On an SMP system, the error is shown in the diagnostic LED.

The following table contains the available MP error codes:

MP-001 | MP-047 | MP-124 | MP-176 | MP-522 | MP-561
MP-002 | MP-048 | MP-127 | MP-177 | MP-523 | MP-562
MP-003 | MP-055 | MP-129 | MP-178 | MP-524 | MP-563
MP-004 | MP-059 | MP-130 | MP-179 | MP-525 | MP-564
MP-007 | MP-060 | MP-131 | MP-180 | MP-526 | MP-565
MP-008 | MP-064 | MP-142 | MP-181 | MP-527 | MP-566
MP-013 | MP-077 | MP-143 | MP-182 | MP-528 | MP-601
MP-015 | MP-078 | MP-146 | MP-183 | MP-529 | MP-619
MP-018 | MP-079 | MP-147 | MP-184 | MP-530 | MP-621
MP-019 | MP-080 | MP-148 | MP-186 | MP-531 | MP-650
MP-021 | MP-081 | MP-149 | MP-310 | MP-532 | MP-651
MP-022 | MP-082 | MP-151 | MP-320 | MP-533 | MP-697
MP-023 | MP-083 | MP-158 | MP-330 | MP-534 | MP-698
MP-024 | MP-090 | MP-159 | MP-340 | MP-535 |
MP-025 | MP-091 | MP-160 | MP-501 | MP-536 |
MP-026 | MP-092 | MP-161 | MP-502 | MP-537 |
MP-027 | MP-093 | MP-162 | MP-503 | MP-538 |
MP-028 | MP-094 | MP-163 | MP-504 | MP-539 |
MP-029 | MP-095 | MP-164 | MP-505 | MP-540 |
MP-030 | MP-105 | MP-165 | MP-506 | MP-541 |
MP-031 | MP-108 | MP-166 | MP-507 | MP-542 |
MP-032 | MP-109 | MP-167 | MP-508 | MP-543 |
MP-033 | MP-111 | MP-168 | MP-510 | MP-544 |
MP-034 | MP-117 | MP-169 | MP-511 | MP-545 |
MP-035 | MP-118 | MP-170 | MP-512 | MP-546 |
MP-036 | MP-119 | MP-171 | MP-515 | MP-547 |
MP-042 | MP-120 | MP-172 | MP-516 | MP-548 |
MP-043 | MP-121 | MP-173 | MP-517 | MP-550 |
MP-045 | MP-122 | MP-174 | MP-519 | MP-551 |
MP-046 | MP-123 | MP-175 | MP-521 | MP-560 |


MP-001 Bad command message syntax error

One of the following conditions has deemed the command message invalid:

  1. The MP, DCC, or RCU could not understand a message it received from another component in the system.

  2. On MP-30 system the required expansion ROM is bad or not installed correctly.

  3. On MP-30 system the PH9 scan or probe changer options have been configured into the system, and the expansion ROMs are not on the MP CPU board.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-002 Destination not present or MP runtime system error

The communications system received a message to send to a non-existent task. Possible explanations are :

  1. Internal MP firmware error.

  2. On MP-30 system the required expansion ROM is bad or not installed correctly.

  3. On MP-30 the PH9, scan, or probe changer options have been configured into the system, and the expansion ROMs are not on the MP CPU board.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-003 Resource shortage

The MP cannot execute a proper command because a required resource is not available. The software cannot access the required piece of hardware.

What you should do

  1. To clear the error, power the MP down.

  2. Make sure all required equipment is correctly and firmly connected.

  3. Power the MP back up.

  4. If you find no problem and the error reoccurs, call your Giddings & Lewis service representative.


MP-004 Numeric error

A numeric error indicates an internal MP firmware problem.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-007 CPU EPROM checksum error

A checksum error has been detected for the MP-30 CPU board EPROMs or the SMP400 code segment memory. This checksum is continuously recalculated while the MP is on. This error indicates that the CPU board is no longer functioning reliably. Refer to MP Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-008 CPU EPROM checksum error

A checksum error has been detected for the MP-30 DCC board EPROMs. The checksum is continuously recalculated while the MP is on. This error indicates that the DCC board is no longer functioning reliably. Refer to MP Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-013 MP-to-Host buffer overflow

The MP-to-Host message buffer has overflowed. It can store a maximum of ten messages.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-015 MP foreground-to-background buffer overflow

The internal buffer used by the MP foreground to transmit status information to the status monitor has overflowed.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-018 MP internal counter error

The low byte of one of the software X/Y/Z counters differs from the low byte of the corresponding hardware counter. This error indicates a probable CPU board failure, not a counter board failure. Refer to MP Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-019 MP and DCC firmware incompatibility

The version number of the DCC firmware is incompatible with the MP-30 CPU board firmware. Refer to MP Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative. Either the DCC or the CPU board firmware must be updated.


MP-021 Atlas Y2 counter fault

The amp/check/divide board detected a Y2-axis counter fault. Possible causes are:

  1. The laser beam is blocked.

  2. The laser beam is not properly aligned in the interferometer.

  3. There is too much DC offset in the OPD Lissajous.

  4. There is not sufficient amplitude in the OPD Lissajous.

  5. The axis is moving too fast (over 25 in/sec. for laser machines).

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-022 Atlas Y3 counter fault

The amp/check/divide board detected a Y3-axis counter fault. Possible causes are:

  1. The laser beam is blocked.

  2. The laser beam is not properly aligned in the interferometer.

  3. There is too much DC offset in the OPD Lissajous.

  4. There is not sufficient amplitude in the OPD Lissajous.

  5. The axis is moving too fast (over 25 in/sec. for laser machines).

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-023 Atlas Y2 beam block error

There is a beam block, probably caused by an optical misalignment or a cable in the beam path.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-024 Atlas Y3 beam block error

There is a beam block, probably caused by an optical misalignment or a cable in the beam path.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-025 Auxiliary X-axis A/D conversion error

An A/D conversion error has been reported for the X-axis on the auxiliary three-axis counter board.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-026 Auxiliary Y-axis A/D conversion error

An A/D conversion error has been reported for the Y-axis on the auxiliary three-axis counter board.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-027 Auxiliary Z-axis A/D conversion error

An A/D conversion error has been reported for the Z-axis on the auxiliary three-axis counter board.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-028 SP600 +12 volt fuse blown

An error has been reported by the SP600 interface card in the SMP400. This error can be caused by a defective PH10 articulating head or a blown fuse on the SP600 interface card. The most likely source of the error is the PH10 articulating probe head.

What you should do

  1. This is not a clearable error. The problem must be corrected by replacing the PH10 articulating probe head or the interface card.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-029 SP600 -12 volt fuse blown

An error has been reported by the SP600 interface card in the SMP400. This error can be caused by a defective PH10 articulating head or a blown fuse on the SP600 interface card. The most likely source of the error is the PH10 articulating probe head.

What you should do

  1. This is not a clearable error. The problem must be corrected by replacing the PH10 articulating probe head or the interface card.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-030 SP600 +5 volt fuse blown

An error has been reported by the SP600 interface card in the SMP400. This error can be caused by a defective PH10 articulating head or a blown fuse on the SP600 interface card. The most likely source of the error is the PH10 articulating probe head.

What you should do

  1. This is not a clearable error. The problem must be corrected by replacing the PH10 articulating probe head or the interface card.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-031 Probe overtravel fault

(MP30) Bit 5, I/O address 39(hex) = 1.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-032 Counter hardware/configuration mismatch

The system has been configured as a laser system, but has standard 12-bit counter boards rather than the 16-bit counter boards required.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-033 W-axis counter fault

The amp/check/divide board detected a W-axis counter fault. Possible causes are:

  1. The gratings are dirty.

  2. There is too much DC offset.

  3. There is not sufficient amplitude in the read head signals.

  4. The read head skew angle is improper.

  5. The axis is moving too fast (rotary table is moving faster than48 /sec).

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Clean the gratings using a soft, lint-free cloth and isopropyl or denatured alcohol..

  3. Check to make sure the DC offset, amplitude, read head skew, and axis speed are within allowable limits.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


MP-034 X-axis counter fault

The amp/check/divide board detected an X-axis counter fault. If the X-axis uses a scale and reading head, then possible causes are:

  1. The gratings are dirty.

  2. There is too much DC offset in the Amp Check Board Lissajous.

  3. There is not sufficient amplitude in the read head signals in the Amp Check Board Lissajous.

  4. The read head skew angle is improper, as viewed on the Amp Check Board Lissajous.

  5. The axis is moving too fast (over 40 in/sec. for standard machines and over 25 in/sec. for laser machines or over 15 in/sec. on some Discovery machines).

If the X-axis uses a laser interferometer, then possible causes are:

  1. The laser beam is blocked.

  2. The laser beam is not properly aligned in the interferometer.

  3. There is too much DC offset in the OPD Lissajous.

  4. There is not sufficient amplitude in the OPD Lissajous.

  5. The axis is moving too fast (over 25 in/sec. for laser machines).

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the axis uses a scale and reading head,

  3. Clean the gratings using a soft, lint-free cloth and isopropyl or denatured alcohol.

  4. Check to make sure the DC offset, amplitude, read head skew, and axis speed are within allowable limits.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-035 Y-axis counter fault

The amp/check/divide board detected a Y-axis counter fault. If the Y-axis uses a scale and reading head, then possible causes are :

- The gratings are dirty.
- There is too much DC offset.
- There is not sufficient amplitude in the read head signals.
- The read head skew angle is improper.
- The axis is moving too fast (over 40 in/sec.)

If the Y-axis uses a laser interferometer, then possible causes are :
- The laser beam is blocked.
- The laser beam is not properly aligned in the interferometer.
- There is too much DC offset in the OPD lissajous.
- There is not sufficient amplitude in the OPD lissajous.
- The axis is moving too fast (over 25 in/sec.)

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the axis uses a scale and reading head,

  3. Clean the gratings using a soft, lint-free cloth and isopropyl or denatured alcohol.

  4. Check to make sure the DC offset, amplitude, read head skew, and axis speed are within allowable limits.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-036 Z-axis counter fault

The amp/check/divide board detected a Z-axis counter fault. Possible causes are :

If the axis uses a scale and reading head, then possible causes are :
- The gratings are dirty.
- There is too much DC offset.
- There is not sufficient amplitude in the read head signals.
- The read head skew angle is improper.
- The axis is moving too fast (over 40 in/sec.)

If the axis uses a laser interferometer, then possible causes are :
- The laser beam is blocked.
- The laser beam is not properly aligned in the interferometer.
- There is too much DC offset in the OPD lissajous.
- There is not sufficient amplitude in the OPD lissajous.
- The axis is moving too fast (over 25 in/sec.)

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the axis uses a scale and reading head,

  3. Clean the gratings using a soft, lint-free cloth and isopropyl or denatured alcohol.

  4. Check to make sure the DC offset, amplitude, read head skew, and axis speed are within allowable limits.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-042 Temperature Compensation hardware absent

The system is configured for Temperature Compensation, but the Temperature Compensation board is not present.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Obtain necessary Temperature Compensation hardware.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-043 Temperature Compensation hardware failure

The system is configured for Temperature Compensation. The Temperature Compensation board is present, but an invalid A/D value occurred for a required input.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-045 Excessive MP hardware temperatures

Temperature in MP electronics enclosure is too high.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error immediately reoccurs, turn power to the MP off and allow it to cool down before turning it back on.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-046 Temperature Compensation or Digital I/O board failure

A read after write to digital outputs does not match actual written value. May also indicate a watchdog timer failure on the Temperature Compensation board.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-047 Temperature Compensation D/A failure

A D/A conversion on the Temperature Compensation board failed to complete within the allotted time of 32 milliseconds.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-048 TempComp or Laser system configuration error

Temperature Compensation configuration is incomplete, wrong, or inconsistent. Possible causes are:

  1. X, Y, or Z temperature inputs are not defined.

  2. No part thermistors have been defined.

  3. No probe thermistors have been defined.

  4. Pressure or humidity inputs have not been defined on a laser system.

  5. An internal inconsistency exists in the configuration data (e.g., a reference to a nonexistent thermistor).

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, attempt to correct the problem by restoring the system configuration data from either the CONFG diskette or a saved host file.

  3. If the error persists, call your Giddings & Lewis service representative.


MP-055 SP600 interface card A/D conversion failure

While the SP600 analog probe was in use the Renishaw AC2 interface card was commanded to perform an A/D conversion but that conversion was not complete within 200 microseconds. This error indicates a critical failure of the interface card.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-059 Renishaw emergency stop error

The Renishaw PI7, PI12, or PI200 probecontroller is turned off, an SCR200 over-travel error has occurred or the Renishaw hardware has requested an emergency stop.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-060 DCC to MP acknowledge timeout

The MP-35 DCC board did not respond to an MP-to-DCC interrupt within 32 milliseconds. The DCC board is incorrectly seated or faulty. Checking the DCC board LED may provide additional information.

What you should do

  1. Check the DCC LED to determine the state of the DCC processor.

  2. To clear the error, power the MP down.

  3. Reseat the DCC board.

  4. Power the MP back up.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-064 APL checksum error

An APL control EPROM appears to be present on the Temperature Compensation board, but the computed checksum failed to agree with the memory. This may occur at power-up or during any system initialization.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-077 W-axis beam block error

On a laser system, there is a beam block, probably caused by an optical misalignment or a cable in the beam path. On a scale system with a divide by 256 board this error indicates an A/D conversion error.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-078 X-axis beam block error

On a laser system, there is a beam block, probably caused by an optical misalignment or a cable in the beam path. On a scale system with a divide by 256 board this error indicates an A/D conversion error.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-079 Y-axis beam block error

On a laser system, there is a beam block, probably caused by an optical misalignment or a cable in the beam path. On a scale system with a divide by 256 board this error indicates an A/D conversion error.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-080 Z-axis beam block error

On a laser system, there is a beam block, probably caused by an optical misalignment or a cable in the beam path. On a scale system with a divide by 256 board this error indicates an A/D conversion error.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-081 Laser off or total beam block error

There is a beam block, probably because power to the laser head is off.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-082 Laser lock error

The laser's frequency has become unstable. This error may indicate that the laser beam has been momentarily reflected back to the source by some obstruction.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, take off the covers and check the status lights at the back of each laser to determine which laser is at fault.

  4. If the error persists, call your Giddings & Lewis service representative.


MP-083 Laser not stable after warm-up time limit

The laser tube has not warmed up within the allowable time.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, take off the covers and check the status lights at the back of each laser to determine which laser is at fault.

  4. If the error persists, call your Giddings & Lewis service representative.


MP-090 APC UART input error

An RS232 data transmission error (such as character overrun) has occurred on the APC to SMP400 communication line.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-091 APC data input buffer overflow

The APC has sent characters to the SMP-400 faster than they could be processed.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-092 APC GO message timeout

The APC reported that the probe changer screw failed to turn within the allowed time.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-093 APC lock error

The APC has reported a probe lock failure.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-094 APC lid timeout error

The APC has reported that a station lid was in the open position for an excessive amount of time.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-095 APC excessive entry speed

The APC controller has reported that the probe quill entered the rack at too high a speed.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-105 Host to MP communication interrupted

The MP received what appeared to be the start of a host message over the RS-232 communication line but the message was not properly terminated and at least ten (10) seconds have elapsed since the last character was received. This may have been caused by one of the following:

  1. a loose RS-232 connection,

  2. cycling power on the host computer,

  3. a host software failure, or

  4. an electrically noisy environment.

Refer to MP Error Codes for additional information.

What you should do

  1. Check and tighten both ends of the host to MP RS-232 cable.

  2. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  3. If the error occurred while executing a part program, then assume that the part program operation has been seriously disrupted. Abort the part program.

  4. If the error reoccurs, call your Giddings & Lewis service representative (Exception: See note below).

Note: If the error occurred shortly after turning on the host computer, then it is almost certainly the result of this since it is normal for some random character to be generated over the RS-232 line when the PC power is cycled. In this case, the error can be cleared and ignored.


MP-108 MP to RCU communications error

The MP improperly transmitted a message to the RCU.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-109 RCU to MP communications error

The RCU improperly transmitted a message to the MP.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-111 Host to MP communication error

The MP detected an error during data transmission from the host computer. If the host-to-MP communication link is RS-232, possible errors are:

  1. Overrun error,

  2. Parity error,

  3. Framing error,

  4. Overflow of the 256-byte input buffer.

The most probable causes of the first three errors are incompatibilities between the MP and the host in baud rate, character length, parity selection and checking, or number of stop bits.

What you should do

  1. To clear the error, power the MP down.

  2. On an MP-30 make sure the RS-232 switch settings on the MP control board and quad serial board are correct.

  3. On an SMP-400 make sure that the host RS-232 settings agree with the SMP-400 internal switch settings.

  4. Power the MP back up.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-117 W-axis servo amplifier overheat

This error applies only to 1000 and 2000 Series DCC machines with 22"-high servo chassis. The W-axis servo amplifier overheated and shut down.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Allow the servos to cool before you proceed.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-118 X-axis servo amplifier overheat

Where Error is Displayed

This error applies only to 1000 and 2000 Series DCC machines with 22"-high servo chassis. The X-axis servo amplifier overheated and shut down.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Allow the servos to cool before you proceed.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-119 Y-axis servo amplifier overheat

This error applies only to 1000 and 2000 Series DCC machines with 22"-high servo chassis. The Y-axis servo amplifier overheated and shut down.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Allow the servos to cool before you proceed.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-120 Z-axis servo amplifier overheat

This error applies only to 1000 and 2000 Series DCC machines with 22"-high servo chassis. The Z-axis servo amplifier overheated and shut down.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Allow the servos to cool before you proceed.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-121 W-axis servo amplifier fault

LED on the servo amplifier PC board on the servo control unit (SCU) chassis indicates one of the following faults:

  1. Excess current,

  2. Servo amp overheated,

  3. Equipment improperly grounded,

  4. Sudden surge in current, or

  5. Voltage too high or too low.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Allow the servos to cool before you proceed.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-122 X-axis servo amplifier fault

LED on the servo amplifier PC board on the servo control unit (SCU) chassis indicates one of the following faults:

  1. Excess current,

  2. Servo amp overheated,

  3. Equipment improperly grounded,

  4. Sudden surge in current, or

  5. Voltage too high or too low.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Allow the servos to cool before you proceed.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-123 Y-axis servo amplifier fault

LED on the servo amplifier PC board on the servo control unit (SCU) chassis indicates one of the following faults:

  1. Excess current,

  2. Servo amp overheated,

  3. Equipment improperly grounded,

  4. Sudden surge in current, or

  5. Voltage too high or too low.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Allow the servos to cool before you proceed.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-124 Z-axis servo amplifier fault

LED on the servo amplifier PC board on the servo control unit (SCU) chassis indicates one of the following faults:

  1. Excess current,

  2. Servo amp overheated,

  3. Equipment improperly grounded,

  4. Sudden surge in current, or

  5. Voltage too high or too low.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Allow the servos to cool before you proceed.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-127 Piezo touch error

The system has attempted to make a programmed touch five consecutive times with a false touch reported one each attempt. This error can only occur when using a TP7, TP12, or TP200. This may be the result of an excessively slow touch speed, a dirty part, or a bad probe assembly.

Effect

The system drops into Manual mode until the error is acknowledged.

What you should do

  1. Acknowledge the error report.

  2. Check the probe assembly for any obvious problems (loose probe tip, etc.).

  3. Put the system back into Auto mode. This will allow the system to automatically re-attempt the commanded touch.

  4. If the touch continues to fail, abort the command and the part program. Change probe assemblies and recalibrate, then try again.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-129 W-axis Hirth coupling lock failure

The Hirth coupling on the W-axis rotary table failed to lock after a move.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Verify that the table coupling has the correct air pressure.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-130 Operator abort

The operation was aborted due to an operator selection.

Effect

Command not executed.

What you should do

  1. Acknowledge the error message and either continue or abort the part program as appropriate.


MP-131 W-axis Hirth coupling unlock failure

The Hirth coupling on the W-axis rotary table failed to unlock before a move.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Verify that the table coupling has the correct air pressure.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-142 W-axis bound

MP-142 W-axis is bound

A W-axis DCC move was attempted, but the W-axis would not move. Possible causes are:

  1. There is insufficient air pressure.

  2. The drive nut is too tight.

  3. There is a counter failure.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. Check the air pressure to make sure it is set correctly.

  4. Check the drive nut, and loosen it if necessary.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-143 Servo chassis power supply fault

There is a +60v DC power supply failure on the servo control unit (SCU) chassis. It could be caused by a blown fuse in the 60v power supply PC board on the SCU chassis.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Determine what caused the loss of power supply. If it was caused by a blown fuse, change the fuse.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-146 W-axis runaway

The firmware detected excessive lag for the W-axis. Possible causes are:

  1. The servo motor is not working properly, or is not receiving adequate power from the servo control unit (SCU) chassis.

  2. The drive (drive belt or rolex nut and rod) is not working properly.

  3. Something is preventing the axis from moving.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-147 X-axis runaway

The firmware detected excessive lag for the X-axis. Possible causes are:

  1. The servo motor is not working properly, or is not receiving adequate power from the servo control unit (SCU) chassis.

  2. Drive mechanism (drive belt or rolex nut and rod) is not working properly.

  3. Something is preventing the axis from moving.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-148 Y-axis runaway

The firmware detected excessive lag for the Y-axis. Possible causes are:

  1. The servo motor is not working properly, or is not receiving adequate power from the servo control unit (SCU) chassis.

  2. Drive mechanism (drive belt or rolex nut and rod) is not working properly.

  3. Something is preventing the axis from moving.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-149 Z-axis runaway

The firmware detected excessive lag for the Z-axis. Possible causes are:

  1. The servo motor is not working properly, or is not receiving adequate power from the servo control unit (SCU) chassis.

  2. The drive mechanism (drive belt or rolex nut and rod) is not working properly.

  3. Something is preventing the axis from moving.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-151 D/A updates were late or missing

On an MP-35, the MP has not sent the DCC board new axis position coordinates in the last 32 milliseconds. The digital/analog (D/A) board failed.

On an SMP-400, the servo D/A's have not been updated for at least 8 milliseconds.

Refer to DCC Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-158 X-axis excessive bias

X-axis bias value is higher than 25% of total D/A dynamic range.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-159 X-axis bound up

DCC has detected an end-of-travel condition and has made three unsuccessful attempts to move away from the obstruction.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-160 DCC board inoperative

On an MP-30, the DCC board failed its startup diagnostics.

On an SMP-400, the DCC board was not present though the SMP-400 was configured for DCC operations or the DCC board failed to function properly. In the latter case a previous error report defined the cause of the failure.

Refer to DCC Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. Use the configuration data program to configure the MP correctly.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


MP-161 RCU inoperative

The RCU is not communicating with the MP. Possible causes are:

  1. The RCU is present but cannot run because of a power-up diagnostic error.

  2. The RCU is not receiving power.

  3. The RCU is not plugged into the MP properly.

Refer to RCU Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Check the power cord to the RCU to make sure it is receiving power.

  3. Make sure the cable from the RCU is connected properly to the MP.

  4. Power the MP back up.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-162 Y-axis excessive bias

Y-axis bias value is higher than 25% of total D/A dynamic range.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-163 Y-axis bound up

DCC has detected an end-of-travel condition and has made three unsuccessful attempts to move away from the obstruction.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-164 W-axis overspeed

The DCC board W-axis overspeed sense has detected a tachometer voltage greater than should be required for normal DCC command velocity. Possible causes are:

  1. Excessive tachometer commutation noise voltage spikes.

  2. The servo drive is slipping during acceleration and overspeeds during its constant velocity move command to "catch up'' to the commanded position.

  3. The speed sense potentiometer on the DCC board for the W-axis is set too low.

  4. There is a short circuit in the power output driver of the W-axis servo amplifier on the servo control unit (SCU) chassis. It is causing full 60V DC power to be sent to the motor.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Make sure that the servo tachometer is operating properly.

  3. Make sure that the drive mechanism is operating properly.

  4. Make sure that the DCC board overspeed sense potentiometer reference voltage is set high enough.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-165 X-axis overspeed

The DCC board X-axis overspeed sense circuit has detected a tachometer voltage greater than should be required for normal DCC command velocity. Possible causes are:

  1. Excessive tachometer commutation noise voltage spikes.

  2. The servo drive is slipping during acceleration and overspeeds during its constant velocity move command to "catch up'' to the commanded position.

  3. The speed sense potentiometer on the DCC board for the X-axis is set too low.

  4. There is a short circuit in the power output driver of the X-axis servo amplifier on the servo control unit (SCU) chassis. It is causing full 60V DC power to be sent to the motor.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Make sure that the servo tachometer is operating properly.

  3. Make sure that the drive mechanism is operating properly.

  4. Make sure that the DCC board overspeed sense potentiometer reference voltage is set high enough.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-166 Y-axis overspeed

The DCC board Y-axis overspeed sense circuit has detected a tachometer voltage greater than should be required for DCC normal command velocity. Possible causes are:

  1. Excessive tachometer commutation noise voltage spikes.

  2. The servo drive is slipping during acceleration and overspeeds during its constant velocity move command to "catch up'' to the commanded position.

  3. The speed sense potentiometer on the DCC board for the Y-axis is set too low.

  4. There is a short circuit in the power output driver of the Y-axis servo amplifier on the servo control unit (SCU) chassis. It is causing full 60V DC power to be sent to the motor.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Make sure that the servo tachometer is operating properly.

  3. Make sure that the drive mechanism is operating properly.

  4. Make sure that the DCC board overspeed sense potentiometer reference voltage is set high enough.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-167 Z-axis overspeed

The DCC board Z-axis overspeed sense circuit has detected a tachometer voltage greater than should be required for normal DCC command velocity. Possible causes are:

  1. Excessive tachometer commutation noise voltage spikes. The servo drive is slipping during acceleration and overspeeds during its constant velocity move command to "catch up'' to the commanded position.

  2. The speed sense potentiometer on the DCC board for the Z-axis is set too low.

  3. There is a short circuit in the power output driver of the Z-axis servo amplifier on the servo control unit (SCU) chassis. It is causing full 60V DC power to be sent to the motor.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Make sure that the servo tachometer is operating properly.

  3. Make sure that the drive mechanism is operating properly.

  4. Make sure that the DCC board overspeed sense potentiometer reference voltage is set high enough.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-168 Unexpected touch

Touch probe was deflected while in auto mode other than during a touch or seek command. This typically happens during a DCC motion that was presumed to be over a clear path.

Effect

Machine is placed in manual mode.

What you should do

  1. Remove obstruction and put the machine back in auto mode or reprogram the machine motion instructions.


MP-169 Unexpected end-of-travel

Machine motion was prevented by a physical obstruction. Typically this happens as a result of attempting to drive beyond the physical limits of one or more axes.

Effect

Machine is placed in manual mode.

What you should do

  1. Determine the cause of the problem. Remove the physical obstruction or correct the part program.

  2. If the problem persists when the machine motion is not obviously restricted, call your Giddings & Lewis service representative.


MP-170 Touch probe will not rearm

In auto mode, the touch probe was deflected and failed to rearm after backing away from the surface. This may happen because of an obstruction or an internal problem.

Effect

The system goes into manual mode.

What you should do

  1. Free the probe if it is obstructed or check and adjust the probe tension. Put the system back into auto once the probe is rearmed to allow the program to continue.


MP-171 MP to PH9/PH10 communication error

The PH9/PH10 controller detected an error in a message transmitted from the MP to the PH9/PH10. The PH9/PH10 controller then transmitted a message to the MP reporting this error.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-172 PH9/PH10 to MP communication error

The PH9/PH10 improperly transmitted a message to the MP.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-173 PH9 probe overload

The PH9 or PH10 has experienced enough force on one of its axes to cause it to lose its programmed position.

Effect

Machine is placed in manual mode.

What you should do

  1. Reset the PH9 via the RCU, if possible. After the probe head has been reseated, place the system back into auto mode to allow the part program to continue.


MP-174 PH9/PH10 to MP buffer overflow

The PH9/PH10 sent more messages to the MP than the MP's message buffer can hold.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-175 Z-axis excessive bias

Z-axis bias value is higher than 25% of total D/A dynamic range.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-176 Z-axis bound up

DCC has detected an end-of-travel condition and has made three unsuccessful attempts to move away from the obstruction.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Check to see that nothing is preventing axis movement.

  3. Check the servo motor's tachometer and drive mechanism.

  4. Check to see that the servo control unit (SCU) chassis is powering the motor properly.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-177 MP front panel keyboard error

A key is stuck on the front panel of an MP-30/35. The key was pressed when the MP was turned on.

What you should do

  1. To clear the error, power the MP down.

  2. Power the MP back up.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-178 MP configuration data checksum error

Invalid system configuration information is stored in the EEPROM.

What you should do

  1. Reload the configuration data with the correct configuration information from the CONFG disk.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-179 Probe checksum error

Invalid probecalibration data is stored in the EEPROM.

What you should do

  1. Delete data for all probe tips.

  2. Power the MP down.

  3. Power the MP back up.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


MP-180 Microprocessor Enhanced Accuracy (MEA) checksum error

Invalid MEA data is stored in the EEPROM.

What you should do

  1. Reload the configuration data with the correct configuration information from the CONFG disk.

  2. Cycle power on the MP.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-181 Invalid MEA data

MEA data has not been collected for this machine.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Reload the configuration data with the correct configuration information from the CONFG disk.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-182 Optional interface error

A power-up diagnostic error was detected in one of the optional interfaces (PH9 /PH10, probe changer, soft probe, or host computer RS-232 interface). The actual interface is identified in the previous error:

  • MP-30 only: Error MP-522 Soft probe D/A interface board failure.

  • Error MP-523 Host Interface rs-232 board failure.

  • Error MP-524 PH9/PH10 RS-232 board failure.

  • Error MP-525 Probe changer RS-232 board failure.

What you should do

  1. Follow the steps for the related error listed above.


MP-183 Probe changer rack disconnected

The probe changer control unit and the probe changer rack are not connected to one another.

What you should do

  1. Connect the probe changer control unit to the probe changer rack.

  2. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-184 Probe changer overtravel error

The CMM has approached a station incorrectly when loading or unloading a probe.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Recalibrate the automatic probe changer (APC) rack.

  3. Recalibrate the stations.


MP-186 Invalid W-axis MEA data

MEA data has not been collected for this machine's W-axis or the W-axis MEA data in EEPROM has been corrupted.

What you should do

  1. To clear the error, click Clear error in the XYZ Display window. To clear it using an RCU-II, press and hold down the Servo Power Off button and then press the Joy button twice.

  2. Collect W-axis MEA data using AutoCal or reload the configuration data with the correct configuration information from the CONFG disk.

  3. If the error reoccurs, call your Giddings & Lewis service representative.


MP-310 Invalid front panel keystroke combination

The MP does not recognize the command. An illegal command was entered through the MP front panel keypad on an MP-30/35 system.

This error only occurs when the MP front panel on an MP-30/35 system is used.

What you should do

  1. To clear the error, press the MP CLEAR key on the MP front panel.

  2. Enter a valid command. The mistake may be caused by operator input.

  3. If the system gives the error message again, confirming that the function is illegal, use a legal function.


MP-320 Invalid function selected

The MP cannot process the requested function in stand-alone operation. You may have entered a function that cannot be used in stand-alone operation.

This error only occurs when the MP front panel on an MP-30/35 system is used.

What you should do

  1. To clear the error, press the MP CLEAR key on the MP front panel.

  2. Enter a valid command. The mistake may be caused by operator input.


MP-330 Keystroke buffer overflow

The MP cannot process more than 41 keystrokes before you press the [ENTER] key on the MP front panel. Use fewer than 41 keystrokes before you press the [ENTER] key.

This error only occurs when the MP front panel on an MP-30/35 system is used.

What you should do

  1. To clear the error, press the MP CLEAR key on the MP front panel.

  2. Enter a valid command. The mistake may be caused by operator input.


MP-340 Offset angle error

The MP cannot process an establish offset command. Less than 2 points may be recorded, or the points may be recorded less than 2 mm apart.

This error only occurs when the MP front panel on an MP-30/35 system is used.

What you should do

  1. To clear the error, press the MP CLEAR key on the MP front panel.

  2. Record more points at least 2 mm apart.

  3. Enter the offset command again.


MP-501 MP CPU Board RAM failure

On an MP-30 system a RAM chip is bad.

On an SMP system either the DRAM SIMM on the processor board or the processor board itself has failed.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the address and location display on the MP.

  2. Call your Giddings & Lewis service representative.


MP-502 CPU Interrupt chip failure

The interrupt controller chip is bad.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-503 Non-existent I/O device or RAM failure

On an MP-30 system the system tried to read from a non-existent I/O device. No default data was supplied.

On an SMP system either the DRAM SIMM on the processor board or the processor board itself has failed.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-504 Real time clock failure

The real time (2 millisecond interrupt) clock is not working.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-505 Two millisecond clock interrupt failure

The two millisecond clock interrupt did not occur even though the timer is operating. The interrupt controller chip is bad.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-506 Control board read/write failure

On an MP-30 system the counting pattern read from the control board did not match the counting pattern written.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-507 Control board RCU interface UART failure

RCU UART initialization failed. The RCU serial UART on the MP-30 control board or the SMP DCC board is bad.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-508 Control board RCU interface UART interrupt failure

The required interrupt from UART is not pending.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-510 Interrupts not operating

On an MP-30 system the two-millisecond clock interrupt and control UART interrupt are both pending but neither occurs.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-511 Control board RCU interface interrupt fail

On an MP-30 system the required control board UART interrupt is not pending.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-512 Interrupt priority fail

On an MP-30 system the UART interrupt has been given priority over the two-millisecond clock.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-515 IEEE 488 initialization failure

On an MP-30 system there is an IEEE addressing or transmission error. There is a faulty IEEE chip or control board. It has failed to:

  • Set up a talk address or a listen address, or

  • Put the chip in talker-only, listener-only, talker-active, or listener-active modes.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-516 Front panel decode fail

A receiving or transmitting information error occurred at the front panel. The keypad entry returns to non-zero even though the entry is cleared. The cables to the front panel may not be connected properly.

Refer to MP Error Codes for additional information.

What you should do

  1. Make sure the cables to the front panel are connected properly.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-517 MP panel switch stuck

On an MP-30 system a key on the MP front panel is stuck. The cables to the front panel may not be connected properly, or the panel may be bad.

Refer to MP Error Codes for additional information.

What you should do

  1. Make sure the cables to the front panel are connected properly.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-519 EPROM checksum error

On an MP-30 system the checksum generated from EPROM contents did not match stored checksum. Possible causes are:

  • EPROM chip failure.

  • CPU board failure (data lines, address, decoding, etc.).

Refer to MP Error Codes for additional information.

What you should do

  1. Note the address and location display on the MP.

  2. If the error reoccurs, call your Giddings & Lewis service representative.


MP-521 EPROM directory error

On an MP-30 system the error may be caused by:

  • EPROM chip failure.

  • CPU board failure (data lines, address, decoding, etc.).

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-522 D/A board conversion failure

There was a failure while the digital/analog (D/A) board used for high-grade scanning was being initialized. The board may have failed or may not be installed in the MP.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-523 RS-232 host interface failure

On an MP-30 system, diagnostics on the MP RS-232 interface board port 3 failed. The board may have failed or may not be installed in the MP.

On an SMP system, diagnostics on the host RS-232 interface on the amp/check/divide card has failed.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-524 RS-232 PH9/PH10 interface failure

Diagnostics on the MP RS-232 interface board port 0 failed. The board may have failed or may not be installed in the MP.

On an MP-30 system, diagnostics on the MP RS-232 interface board port 0 failed. The board may have failed or may not be installed in the MP.

On an SMP system, diagnostics on the PH9/PH10 RS232 interface on the DCC card has failed.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-525 RS-232 Probe changer interface failure

Diagnostics on the MP RS-232 interface board port 2 failed. The board may have failed or may not be installed in the MP.

On an MP-30 system, diagnostics on the MP RS-232 interface board port 2 failed. The board may have failed or may not be installed in the MP.

On an SMP system, diagnostics on the probe changer RS-232 interface on the DCC card has failed.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-526 RS-232 electronic level interface failure

On an MP-30 system, diagnostics on the MP RS-232 interface board port 1 failed. The board may have failed or may not be installed in the MP.

On an SMP system, diagnostics on the electronic level RS-232 interface on the DCC card has failed.

Diagnostics on the MP RS-232 interface board port 1 failed. The board may have failed or may not be installed in the MP.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-527 SMP-400 FLASH memory error

On an SMP-400 system, invalid record marker found in FLASH memory.

Refer to MP Error Codes for additional information.

What you should do

  1. Reload the SMP-400 operating system code from the installation disk.

  2. If error persists, call your Giddings & Lewis service representative.


MP-528 SMP-400 FLASH memory error

On an SMP-400 system, invalid record type found in FLASH memory.

Refer to MP Error Codes for additional information.

What you should do

  1. Reload the SMP-400 operating system code from the installation disk.

  2. If error persists, call your Giddings & Lewis service representative.


MP-529 SMP-400 FLASH memory error

On an SMP-400 system, invalid record checksum found in FLASH memory.

Refer to MP Error Codes for additional information.

What you should do

  1. Reload the SMP-400 operating system code from the installation disk.

  2. If error persists, call your Giddings & Lewis service representative.


MP-530 SMP-400 FLASH memory error

On an SMP-400 system, no starting address record found in FLASH memory.

Refer to MP Error Codes for additional information.

What you should do

  1. Reload the SMP-400 operating system code from the installation disk.

  2. If error persists, call your Giddings & Lewis service representative.


MP-531 SMP-400 RAM memory error

On an SMP-400 system, either the DRAM SIMM on the processor board or the processor board itself has failed.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-532 SMP-400 RAM memory error

On an SMP-400 system, either the DRAM SIMM on the processor board or the processor board itself has failed.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-533 No amp/check/divide board present

The SMP-400 requires that an amp/check/divide card be present at the base address. The amp/check/divide card may have failed or may be set to the wrong address.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-534 Amp/check/divide board failure

On an SMP-400 system, a write/read error occurred while writing to or reading from one of the registers internal to U23 on the amp-check card.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-535 No DCC board present

On an SMP-400 system, read at address 170(hex) did not return a valid DCC board ID. The ID is read from U30 on the DCC board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-536 DCC board failure

On an SMP-400 system, a write/read error occurred while writing to or reading from the X-axis D/A converter U6 on the DCC board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-537 DCC board failure

On an SMP-400 system, a write/read error occurred while writing to or reading from the Y-axis D/A converter U7 on the DCC board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-538 DCC board failure

On an SMP-400 system, a write/read error occurred while writing to or reading from the Z-axis D/A converter U11 on the DCC board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-539 DCC board failure

On an SMP-400 system, a write/read error occurred while writing to or reading from the W-axis D/A converter U12 on the DCC board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-540 No TempComp board present

On an SMP-400 system, read at address 1CE(hex) did not return a valid TempComp board ID. The ID is read from U18 on the TempComp board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-541 TempComp board failure

On an SMP-400 system, a write/read error occurred while writing to or reading from the A/D multiplexor register on the TempComp board. The register is internal to U18.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-542 TempComp board failure

On an SMP-400 system, A/D conversion failure on the TempComp board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-543 TempComp board failure

On an SMP-400, offset number one on the TempComp board was read incorrectly.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-544 TempComp board failure

On an SMP-400 system, gain number one on the TempComp board was read incorrectly.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-545 TempComp board failure

On an SMP-400 system, offset number two on the TempComp board was read incorrectly.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-546 TempComp board failure

On an SMP-400 system, gain number two on the TempComp board was read incorrectly.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-547 Processor board failure

On an SMP-400 system, interrupt generated on host UART but not received by the interrupt controller chip on the processor board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-548 Processor board failure

On an SMP-400 system, unable to clear host UART interrupt in the interrupt controller chip on the processor board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-550 Insufficient RAM

There was insufficient memory space to start the system. The RAM is bad.

On an MP-30 system, a RAM chip is bad.

On an SMP-400 system, either the DRAM SIMM on the processor board or the processor board itself has failed.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-551 Too many soft rate groups

There are more rate groups than the system can handle. May indicate an MP operating system software failure.

On an MP-30 system, a RAM chip is bad.

On an SMP-400 system, either the DRAM SIMM on the processor board or the processor board itself has failed.

Refer to MP Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-560 Processor board failure

On an SMP-400 system, unable to clear the RCU UART interrupt in the interrupt controller chip on the processor board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 internal diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-561 UART interrupt failure

On an SMP-400 system, interrupt generated on PH9/PH10 UART but not received by the interrupt controller chip on the processor board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 internal diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-562 UART interrupt failure

On an SMP-400 system, unable to clear the PH9/PH10 UART interrupt in the interrupt controller chip on the processor board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 internal diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-563 UART interrupt failure

On an SMP-400 system, interrupt generated on probe changer UART but not received by the interrupt controller chip on the processor board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 internal diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-564 UART interrupt failure

On an SMP-400 system, unable to clear the probe changer UART interrupt in the interrupt controller chip on the processor board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 internal diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-565 UART interrupt failure

On an SMP-400 system, interrupt generated on electronic level UART but not received by the interrupt controller chip on the processor board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 internal diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-566 UART interrupt failure

On an SMP-400 system, unable to clear the electronic level UART interrupt in the interrupt controller chip on the processor board.

Refer to MP Error Codes for additional information.

What you should do

  1. Note the error data displayed on the SMP-400 internal diagnostic LED.

  2. Call your Giddings & Lewis service representative.


MP-601 DCC RAM failure

The pattern read from the DCC board RAM did not match the pattern written. The RAM is bad.

Refer to DCC Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-619 DCC EPROM checksum error

Checksum generated from DCC EPROM contents did not match stored checksum.

Refer to DCC Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-621 DCC EPROM directory error

The first word in an EPROM chip set was not read as 4140 hex. This word is at 0F0000(hex).

Refer to DCC Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-650 Insufficient DCC RAM

There is insufficient RAM for the DCCcontroller to operate.

Refer to DCC Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-651 Too many DCC software rate groups present

There are too many DCC software rate groups.

Refer to DCC Error Codes for additional information.

What you should do

  1. Call your Giddings & Lewis service representative.


MP-697 Servo off pushbutton stuck

The servo off button is stuck. The button may have been pressed when the system was turned on.

Refer to DCC Error Codes for additional information.

What you should do

  1. To clear the error, power MP down.

  2. Power MP back up.

  3. Check the servo off button to see if it is open.

  4. Check the connections between the control panel located at the top of the MP console and the servo chassis, and between the servo chassis and DCC board. Make sure all the connections are secure.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


MP-698 E-stop circuit open

The emergency stop (E-stop) circuit was open at power up.

Refer to DCC Error Codes for additional information.

What you should do

  1. Some systems have console E-stop buttons that lock when pressed. If locked, twist knob clockwise to release.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. Check all E-stop buttons and the circuit to see if any are open.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


DCC Error Information

DCC errors are displayed on the DCC board LED.

If error MP-160 occurs during startup, check the DCC board LED, cycle power and watch the LED. A sequence of characters flashes on the LED as testing takes place. Each character represents a test of a specific system component or of communication between components. If one of these tests fails, the character representing that test remains on the LED. The DCC Led sequence is:

A | Testing shared RAM memory cells
B | Testing DCC to MP interrupt
C | Testing MP interrupt acknowledge
D | Testing MP to DCC interrupt
E | Testing DCC ROM and RAM
F | All tests passed - waiting for first MP interrupt

If the DCC board fails after the system is on, error MP-060 or MP-151 occurs. These errors indicate that the MP is unable to communicate with the DCC board. Check the DCC board LED for the following numbers:

1 | 32 ms since last D/A update
2 | 32 ms since last MP update
3 | DCC to MP interrupt not acknowledged for 32 ms
8 | System running normally
9 | Waiting for initial MP shared RAM sync-up

On the DCC board LED, a decimal point before the error number means the CPU is inactive. A decimal point after the error number means the hardware detected a failure to update the D/A for 32 milliseconds.

The following table contains the available DCC error codes:

DCC-001

DCC-002

DCC-003


DCC-1 32 milliseconds since last D/A update

The digital/analog (D/A) converters on the DCC board have not been updated for at least 32 milliseconds. Refer to DCC Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Reseat the DCC board.

  3. Power the MP back up.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


DCC-2 32 milliseconds since last MP update

The DCC has not been updated for at least 32 milliseconds. Refer to DCC Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Reseat the DCC board.

  3. Power the MP back up.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


DCC-3 DCC to MP interrupt not acknowledged for 32 milliseconds

The DCC sent an interrupt to the MP. The MP has not acknowledged the interrupt in the last 32 milliseconds. Refer to DCC Error Codes for additional information.

What you should do

  1. To clear the error, power the MP down.

  2. Reseat the DCC board.

  3. Reseat the MP CPU board.

  4. Power the MP back up.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


RCU Error Information

An RCU error is generated only by the older Remote Control Unit RCU-I. RCU error numbers appear in the scrolling display on the RCU-I.

An RCU error number is followed by a three-digit number representing the version numbers of the three EPROMs in the RCU at location F8, F10 and R12. You can see the version number by pressing the DISPLAY key on the RCU-I.

The following table contains the available RCU error codes:

RCU - 003

RCU - 700

RCU - 701

RCU - 702

RCU - 703

RCU - 704

RCU - 705

RCU - 706

RCU - 707

RCU - 708


RCU-003 Resource shortage

User tried to reposition non-existent PH9 or rotary table, or tried to command a rotary table move with servo power off.

Refer to RCU Error Codes for additional information.

What you should do

  1. Press the CLEAR key on the RCU-I.

  2. If you are trying to move rotary table, turn on servo power.

  3. If you are trying to move PH9 or rotary table with servo power on, make sure your system has the required hardware and is properly configured.


RCU-700 RCU RAM failure

RCU onboard RAM has at least 1 bad memory bit.

Refer to RCU Error Codes for additional information.

What you should do

  1. Note the display on the MP.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


RCU-701 RCU 6802 RAM address failure

RCU on-chip RAM has failed.

Refer to RCU Error Codes for additional information.

What you should do

  1. Note the display on the MP.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


RCU-702 RCU 2114 RAM failure

RCU on-board RAM has at least 1 bad memory bit.

Refer to RCU Error Codes for additional information.

What you should do

  1. Note the display on the MP.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


RCU-703 RCU 2114 RAM address failure

RCU RAM chip has failed.

Refer to RCU Error Codes for additional information.

What you should do

  1. Note the display on the MP.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


RCU-704 RCU EPROM checksum or version # error

There is an RCU checksum error.

Refer to RCU Error Codes for additional information.

What you should do

  1. Note the display on the MP.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


RCU-705 Stuck key error

A key is stuck on the RCU.

Refer to RCU Error Codes for additional information.

What you should do

  1. Note the display on the MP.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. If the error reoccurs, call your Giddings & Lewis service representative.


RCU-706 RCU EPROM A checksum error

There is a checksum error in EPROM at board position F8.

Refer to RCU Error Codes for additional information.

What you should do

  1. Note the display on the MP.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. Reseat the 2716 chip at board position F8.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


RCU-707 RCU EPROM B checksum error

There is a checksum error in EPROM at board position F10.

Refer to RCU Error Codes for additional information.

What you should do

  1. Note the display on the MP.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. Reseat the 2716 chip at board position F10.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


RCU-708 RCU EPROM C checksum error

There is a checksum error in EPROM at board position F11.

Refer to RCU Error Codes for additional information.

What you should do

  1. Note the display on the MP.

  2. To clear the error, power MP down.

  3. Power MP back up.

  4. Reseat the 2716 chip at board position F11.

  5. If the error reoccurs, call your Giddings & Lewis service representative.


TempComp Error Information

A TempComp error is generated by the temperature compensation feature on systems that support this option. TempComp errors are appended to the Inspection Report and displayed in the Prompt Monitor.

The following table contains the available TempComp error codes:

TempComp-200

TempComp-201

TempComp-202

TempComp-203

TempComp-204

TempComp-205

TempComp-206


TempComp-200 TempComp not available

Temperature compensation has been requested but is currently not available. The message displayed includes a number in parentheses at the end that indicates the specific reason as follows:

  • -2 -> No part thermistors are available

  • -1 -> Temperature compensation has been disabled by a previously reported error.

  • 0 -> Temperature compensation is not properly configured.

  • 1-28 -> The indicated thermistor has failed.

Refer to TempComp Error Codes for additional information.

What you should do

  1. If possible, correct the identified problem.

  2. If the warning reoccurs, call your Giddings & Lewis service representative.


TempComp-201 Absolute temperature limit exceeded

Temperature compensation has been requested but a thermistor currently indicates a temperature that exceeds the configured system absolute temperature limits. Temperature compensation is active but system conditions may preclude achieving the desired system accuracy. The message includes the thermistor number and recorded temperature that caused the warning.

Refer to TempComp Error Codes for additional information.

What you should do

  1. If possible, correct the identified problem.

  2. If the warning reoccurs and cannot be explained by the environmental conditions, call your Giddings & Lewis service representative.


TempComp-202 Gradient temperature limit exceeded

Temperature compensation has been requested but the difference in temperature between a pair or thermistors indicates a temperature gradient that exceeds the configured system limits. Temperature compensation is active but system conditions may preclude achieving the desired system accuracy. The message includes the thermistor numbers and recorded temperatures that caused the warning.

Refer to TempComp Error Codes for additional information.

What you should do

  1. If possible, correct the identified problem.

  2. If the warning reoccurs and cannot be explained by the environmental conditions, call your Giddings & Lewis service representative.


TempComp-203 Transient temperature limit exceeded

Temperature compensation has been requested but the record of temperatures recorded by a thermistor indicates a temperature change (transient) that exceeds the configured system limits. Temperature compensation is active but system conditions may preclude achieving the desired system accuracy. The message includes the thermistor number and recorded high and low temperatures that caused the warning.

Refer to TempComp Error Codes for additional information.

What you should do

  1. If possible, correct the identified problem.

  2. If the warning reoccurs and cannot be explained by the environmental conditions, call your Giddings & Lewis service representative.


TempComp-204 Laser compensation is inactive

On a laser system a hardware failure has occurred that prevents proper compensation of the laser measurements for environmental conditions. The system is operational but cannot achieve desired system accuracies.

Refer to TempComp Error Codes for additional information.

What you should do

  1. If possible, correct the identified problem.

  2. If the warning recurs, call your Giddings & Lewis service representative.


TempComp-205 Probe calibration data may be invalid

Temperature compensation has been requested but either the probes have not been calibrated since power up or the temperature change since probecalibration exceeds the configured system limit. The value displayed with the message indicates whether the first (1) or the second (2) condition caused the warning.

Refer to TempComp Error Codes for additional information.

What you should do

  1. Recalibrate probes to ensure highest system accuracy.


TempComp-206 Rotary table calibration may be invalid

Temperature compensation has been requested but the temperature change since rotary table center calibration exceeds the configured system limit. The rotary table center should be recalibrated to ensure the highest degree of system accuracy.

Refer to TempComp Error Codes for additional information.

What you should do

  1. Recalibrate the rotary table center to ensure highest system accuracy.


AK - Automatic Tracking

The AD command directs the system to enable automatic tracking.

Command Format

MLString "AK p1,p2"

Example

  1. MLString "AK Y"

    Automatically track a surface in the active part reference frame.

  2. MLString "AK -Z"

    Automatically track a surface in the active part reference frame.

  3. MLString "AK"

    Disable

  4. MLString "AK 1,1,0"

    Automatically track a surface. The probe is to move initially in part coordinate direction (1,1,0) until the surface is contacted.

  5. MLString "AK 1,1,0,C"

    Automatically track a surface. The probe is to move initially in part coordinate direction (1,1,0) until the surface is contacted. When the surface is contacted, the probe will continue to travel until the probe self centers along the specified vector

Input

  • p1 = signed part axis or part coordinate direction vector (String; optional)

  • p2 = "C" (String; optional)

The optional parameter p1 specifies as either a signed part axis designator (e.g., +X or -Z) or as a numeric XYZ part coordinate direction vector. If a numeric vector is specified then it must be non-zero. It may be a unit vector but this is not required. If p1 is not specified then tracking is disabled.

The optional parameter p2 may only be the letter "C".

In the first example, Y is the p1 argument. It indicates to automatically track a surface in the machine Y-axis. The surface lies in the positive Y direction from the probe center.

In the second example, -Z is the p1 argument. It indicates to automatically track a surface nominally perpendicular to the machine Z-axis. The surface lies in the negative Z direction from the probe center.

In the third example there is no argument. It indicates to disable automatic mode for soft probe tracking.

In the fourth example, the part direction vector (1,1,0) is the p1 argument. It indicates to automatically track along the direction vector (1,1,0) (e.g., i=1, j=1, and k=0).

Results

This command is added to the DCC command queue. When executed, the system begins tracking. If the soft probe is not in surface contact when this command is executed then the probe is moved in the specified direction until in surface contact. The touch mode of the soft probe is disabled if active (see TF command) and the soft probe is activated (see BR command). The soft probe must have been calibrated prior to execution of this command.

Note that machine velocity is restricted to tracking speed (see KS command).

Skip Action

Ignored; not executed if part of a skip block.

Error Messages

  • MLB-090 DCC is not available.


AS - Automatic Scanning

The AS command sets up controls for an automatic scanning / data collection operation. Be aware that it has been redefined for SMP-400, version 104.0 and later.

Command Format

MLString "AS p1,p2,p3,p4,p5,p6"

Example

  1. MLString "AS Y,S55.6,I10"

    Perform an automatic scan, collecting samples as a function of Y position beginning at Y equal to 55.6 and collecting a data point every 10 units. Data points are accumulated only in the scan data array.

  2. MLString "AS A,C12.3,-5.75,S0,I1,USER"

    Perform an automatic scan, collecting samples as a function of polar angle relative to the working plane point (12.3, -5.75), beginning at zero degrees and collecting a data point every degree. Data points are accumulated in the scan data array and in the User Summation Array. Data returned to the host with the RN command is in Radius / Angle / Height format.

Input

  • p1 = Independent axis for scan (String; required)

  • p2 = Center point for polar scan (String / numeric; optional)

  • p3 = Starting value for independent axis (String; optional)

  • p4 = Interval between successive targets (String or numeric; optional)

  • p5 = 'USER' or 'INTERNAL' to select summation array (String; optional)

  • p6 = Number of points to collect (String or numeric; optional)

The required parameter p1 specifies the independent "axis" for the scan. This can only be A, P, S, X, Y, or Z. A specifies a polar scan with data returned in R, A, H (radius, angle, height) format. P specifies a polar scan with data returned in normal X, Y, Z format. S indicates that targets are to be spaced along the surface with the initial probe location to be treated as 0.0. X, Y, and Z indicate a part axis to be used as the independent axis.

The optional parameter p2 is the letter 'C' followed by two coordinate values. This parameter has meaning only for polar scans and defines the working plane nominal center of the scanned surface. The values specified in order correspond to X and Y for the XY plane; Y and Z for the YZ plane; and Z and X for the ZX plane. For polar scans when p2 is not specified the center point is assumed to be at (0, 0).

The optional parameter p3 is the letter 'S' followed by the independent axis starting coordinate. If p4 (below) is specified without p3 then data is collected beginning at the current probe position. Note that p3 cannot be specified without p4.

The optional parameter p4 is the letter 'I' followed by the incremental displacement between targets. If p3 and p4 are both omitted then it is assumed that the scan targets are absolute rather than incremental and have been previously communicated using the SB command.

The optional string parameter p5 can be "USER" or "INTERNAL". If p5 is specified then the scan data is accumulated in the specified Summation Array as well as in the scan data buffer.

The optional parameter p6 is the letter 'N' followed by the number of points to be collected. If not specified, data collection continues until an RN command is executed.

Results

The AS command puts the SMP into a data collection mode. Before this command is executed tracking should be enabled (see AK command) and the probe should be positioned ahead of the first target if doing closed loop scanning or the probe should be positioned to its nominal deflection if doing open loop scanning. Following the execution of this command, appropriate move commands are executed to move the probe through the target area. Finally, the command RN is executed to terminate data collection and/or to return the collected scan data to the host.

Skip Action

Ignored; not executed if part of a skip block.

Error Messages

  • MLB-080 The soft probe is not enabled or tracking is not turned on.

  • MLB-090 DCC is not available.

  • MLB-164 Insufficient analog probe deflection.


BB - Begin Block

The BB command marks the beginning of a code block that is used with Skip Action.

Format of MLB Command | Format of Sheffield Routine
MLString "BB p1" | BeginBlock "p1"

Example of MLB Command | Example of Sheffield Routine
Example #1
MLString "BB FRONTFACE" | BeginBlock "FRONTFACE"

Input

  • p1 = Maximum of 10 characters (String; required)

p1 gives an identifying name to the program block. The name can be 10 or fewer alphanumeric characters.

Results

The function sets the internal flags that indicate the beginning of a block.

Skip Action

An error occurs if this command occurs within a block of code being skipped.

Error Messages

  • MLB-014 There is a nested code block.


BeginBlock

The BeginBlock routine marks the beginning of a code block that is used with Skip Action.

For more information on the BeginBlock routine, see the MLB command BB.


BF - Turn Soft Probe Off

The BF command disables the soft probe. If a three-axis analog probe (e.g., the Renishaw SP-600) is in use, then the touch probe is enabled.

Command Format

MLString "BF"

Example

  1. MLString "BF"

Input

None.

Results

The system disables the soft probe and stops including soft probe deflections as part of the tip position coordinate data.

Skip Action

Ignored.

Error Messages

None.


BR - Turn Soft Probe On

The BR command enables the soft probe. The touch probe is disabled when this command is executed.

Command Format

MLString "BR"

Example

  1. MLString "BR"

Input

None.

Results

The system enables the soft probe and starts including soft probe deflections as part of the tip position coordinate data.

Skip Action

Executes even when inside a skip block.

Error Messages

  • MLB-080 The soft probe has not been calibrated.


EB - End Block

The EB command marks the end of a code block that started with a BB command.

Format of MLB Command | Format of Sheffield Routine
MLString "EB" | EndBlock

Example of MLB Command | Example of Sheffield Routine
Example #1
MLString "EB" | EndBlock

Input

None.

Results

The command marks the end of the block of code that began with the previous BB command.

Skip Action

Executes even when inside a skip block.

Error Messages

  • MLB-015 There is no matching block beginning.


EndBlock

The EndBlock routine marks the end of a code block that started with a BB command.

For more information on the EndBlock routine, see the MLB command EB.


IL - Initialize Library

The IL command initializes the Measurement Library. Flags and variables revert to the default state at system initialization. This function does not clear system errors caused by a fault in the system hardware. Separate corrective action must be taken for such errors.

Command Format

MLString "IL"

Examples

  1. MLString "IL"

Input

None.

Results

The system:

  • Deletes all measured features,

  • Resets the part and machine scale ratios to 1:1,

  • Cancels axis translations and rotations,

  • Sets the feature number and sequence number to zero,

  • Reverts to the default values for measurement units and the working plane, and

  • Clears all other variables or sets them to the default values.

This function does not affect:

  • Selected tip or Probe diameter,

  • Calibration of any probe tips,

  • Calibration of the rotary table, or

  • Saved reference frames 1 through 48. Other reference frames are deleted

Skip Action

This function may not occur in a section of code to be skipped. Error.

Error Messages

None.


IO - IOStat

The IO command allows testing of one of the input (read-only or read-write) bits or changing the status of one of the output (write-only or read-write) bits.

Command Format

MLString "IO p1,p2"

Examples

  1. MLString "IO 3,1"

  2. MLString "IO 2"

Input

  • p1 = 0 through 67 (Numeric; required)

  • p2 = 0 or 1 (Numeric; optional)

p1 is a number which corresponds to the input or output bit whose status is being viewed or changed. p1 must be a digit from 0 through 67. Some bits are read only, some are write only, and others are both read and write. Consult Giddings & Lewis for details.

If p2 is specified, p1 identifies an output (write-only or read-write) bit. p2 may not be specified with a read-only bit. p2 indicates the state to which the output bit identified by p1 is to be changed. p2 must be either a zero (0) or a one (1).

The output bits are like switches which may be opened or closed. For the Control Board, when p2 is zero (0), the switch is closed, and when p2 is one (1), the switch is open. On the Auxiliary Digital Input Output Board and the Temperature Compensation Board, the switch is opened when p2 is zero (0), and the switch is closed when p2 is one (1). In the first example, the state of the write/only bit number 3 is being changed to one.

If p2 is not specified, p1 identifies an input (read-only, read-write) bit. The programmer can only view the status of a bit which has been identified as an input bit. The status of an input bit cannot be changed. In the second example, the bit whose status is to be viewed is the read-only bit #2 on the Control Board.

Results

If p2 is not specified, the current status of the input bit identified by p1 is stored in the variable S7. The variable S7 must be checked immediately after executing this function to verify the status of the input bit. If S7 is zero (0), there is no current flow into the input bit. If S7 is one (1), there is current flow into the bit. This is true for the Control Board and the Auxiliary Digital Input Output Boards. For the Temperature Compensation Board, if S7 is zero, the input bit is an open circuit (+V). If S7 is one, the input bit is ground (OV). For the read-write input bits, S7 contains the last value written to the output bit.

If p2 is specified in the IO command, the value of S7 is meaningless. Note that all input bits and/or output bits may not be available to the user. Availability is dependent on the MP configuration purchased.

Skip Action

Executes even when inside a skip block.

Error Messages

  • MLB-005 Communication error.

  • MLB-006 Output mask logical translation error.

  • MLB-007 Output unavailable.

  • MLB-021 First Parameter Invalid.

  • MLB-022 Second Parameter Invalid.


KD - Set nominal soft probe deflection

The KD command sets the nominal soft probe deflection to be used.

Command Format

MLString "KD p1"

Examples

  1. MLString "KD 0.05" -

    Set the nominal soft probe deflection to 0.05 units.

Input

  • p1 = nominal soft probe deflection (Numeric; optional)

The optional numeric parameter p1 specifies the nominal soft probe deflection in current units. This value must be positive.

If p1 is not specified then the current setting for nominal soft probe deflection is returned. The default value after initialization (IL) is 0.05".

Results

If a value is specified, the nominal soft probe deflection is set to this value except as noted above. If a value is not specified then the current value is returned to variable S7.

Skip Action

Executed normally.

Error Messages

  • MLB-090 DCC is not available.


KS - Set Tracking Speed

KS - Set Tracking / Scanning Speed

The KS command sets the probe speed to be used during DCC moves while tracking or scanning.

Command Format

MLString "KS p1,p2"

Examples

  1. MLString "KS 0.5"

    Set the tracking / scanning move speed to 0.5 units per second.

Input

  • p1 = tracking / scanning move speed (Numeric; optional)

  • p2 = tracking / scanning move speed (Numeric; optional)

The optional numeric parameters p1 and p2 specify the desired tracking / scanning move speed in current units per second. This value must be positive. If the specified value exceeds the machine-allowed maximum then that will be used rather than the specified value.

If only p1 is specified, the p1 value is used for both open loop and closed loop scan. If both p1 and p2 are specified, p1 is used for open loop scan and p2 is used for closed loop scan.

If no is specified then the current settings for tracking / scanning move speed are returned. The default values after initialization (IL) are 0.1" (or 2.54 mm) per second.

Results

If a value is specified, the tracking / scanning move speed is set to this value except as noted above. If a value is not specified then the current open loop value is returned to variable S7 and the closed loop value is returned to variable S8. The system uses this as the maximum velocity whenever a DCC or joystick move is commanded while tracking a surface with a soft probe or scanning with a soft probe.

Skip Action

Executed normally.

Error Messages

  • MLB-090 DCC is not available.


RN - Return Scan Data

The RN command terminates collection of scan data and/or returns collected scan data to MeasureMax+.

Command Format

MLString "RN p1"

Examples

  1. MLString "RN"

    If scanning is active wait for the DCC queue to become empty and the final move to be in-tolerance, then terminate scanning. Return the number of data points to the host.

  2. MLString "RN 0"

    If scanning is active wait for the DCC queue to become empty and the final move to be in-tolerance, then terminate scanning. Return the collected data points (beginning with point number 0) and the number of data points to the host.

Input

  • p1 = point index (Numeric; optional)

The optional numeric parameter p1 cannot be a negative number. If specified, p1 requests that scan data points be returned to the host beginning with point #p1. Note that the first point collected has index 0 (zero). If p1 is not specified the collected data is not to be returned to the host computer.

Results

The RN command completes a scan data collection operation initiated by the AS command. If scanning is active it will be terminated when the DCC queue becomes empty and the final move to be in-tolerance. If p1 is specified the collected data points are returned from the scan buffer to the host computer and stored in the S9 array. For all scan types except A (see AS command), the point data is stored in the S9 array in normal X, Y, Z order; that is, the X coordinate data values are stored in S9(*, 0), Y values in S9(*, 1), and Z values in S9(*, 2). For a scan of type A, polar radius values are stored in S9(*, 0), polar angle values are stored in S9(*, 1), and third axis values (height) are stored in S9(*, 2).

The number of collected data points is returned to variable S7.

Skip Action

Ignored.

Error Messages

None.


SB - Scan Target

The SB command transmits the independent axis targets from the scan buffer S9(*,0) to the MP, so that they can be used in the next scan. The part program must execute the SB command before it executes the SN command if it uses absolute targets.

Command Format

MLString "SB p1"

Examples

  1. MLString "SB 100"

Input

  • p1 = Number of targets to transmit (Numeric;required)

p1 specifies the number of independent axis targets to transmit. p1 must be an integer equal to or greater than 1. In the example, p1 is 100. The probe scans 100 targets for this measurement. The first target is in the scan buffer location S9(0,0). If you are scanning in several phases, transfer all targets at once. S9 is a real array, so the number of digits that make up the target coordinate value is not restricted.

Results

Targets are sent to the MP starting at S9(0,0). If the program transmits 100 targets, the last target sent is at S9(99,0).

Skip Action

Ignored; not executed if part of a skipped block.

Error Messages

None.


SN - Scan

The SN command is used to initiate a surface scan. This is for MeasureMax version 1.03 systems only.

Warning

The SN command is not supported by current MeasureMax+ systems.

Command Format

MLString "SN p1,p2,p3,p4,p5"

Examples

  1. MLString "SN 1,XY,400,12,.1"

  2. MLString "SN XY,400"

Input

  • p1 = Column in scan buffer (Numeric; optional)

  • p2 = Dependent and independent axes (String; required)

  • p3 = Number of targets to scan (Numeric; required)

  • p4 = Starting position (Numeric; optional)

  • p5 = Interval between successive targets (Numeric; optional)

The optional numeric parameter p1 is the index of the column in the S9 scan data array to be used for dependent axis scan results. If p1 is not specified then scan results are stored in column zero (0).

The required string parameter p2 defines the dependent and independent axes for the scan. The first letter identifies the dependent axis. Valid settings for p2 are XY, XZ, YX, YZ, ZX, ZY, XW, YW, ZW, and RA.

The required numeric parameter p3 must be a value from 1 to 1000 and specifies the number of targets to be scanned.

The optional numeric parameters p4 and p5 define the first independent axis scan target and the spacing between targets for an incremental scan. If p4 and p5 are not specified then targets are absolute and must have been previously transmitted to the MP (see SB command).

The user must have the probe in position before the first scan target before this command is executed. When this command is executed the WAIT light on the MP comes on. The user then moves the probe along the scan path to collect data. After the first target is passed the WAIT light will flash until all scan targets have been collected, then go out.

The first example scans 400 targets along Y collecting X data in column 1 of the S9 array. The first target is at a Y reading of 12 and subsequent targets are spaced at a 0.1 interval in the positive direction.

The second example scans 400 targets along Y collecting X data in column 0 (default) of the S9 array. The Y-axis targets have been previously sent with the SB command.

Results

The system collects the scanned data and stores the results in the S9 array.

Skip Action

Ignored; not executed if part of a skipped block.

Error Messages

  • MLB-080 Improper probe installed. Either a hard probe or an analog probe is required.


TF - Touch Mode Off

The TF command prevents the system from sensing deflection of the touch probe except during commanded touches or seeks. In this mode, the system can ignore touches resulting from the vibration experienced by a long probe that is traveling at a high velocity. Because damage can result if the probe contacts a surface with force, use extreme caution when using this function.

Whenever this command is used in a part program the TN command should be used to re-enable the touch probe before terminating the part program.

Command Format

MLString "TF"

Example

  1. MLString "TF"

Input

None.

Results

After this command is executed the system does not recognize touch probe hits except during programmed DCC touch operations. Recognition of touch probe hits can be re-enabled by the TN command or by a part program initialization.

Skip Action

Executes even when inside a skipped block.

Error Messages

  • MLB-090 DCC is not available.


TN - Enable Touch Probe

The TN command sets the touch mode to on, re-enabling the touch probe previously disabled with the TF command. If a three-axis analog probe (e.g., the Renishaw SP-600) is in use, then the soft probe is disabled (see the BF command).

Command Format

MLString "TN"

Example

  1. MLString "TN"

Input

None.

Results

The touch probe is enabled during all moves.

Skip Action

Executes even when inside a skipped block.

Error Messages

  • MLB-090 DCC is not available.


Modifying Registry Entries

The PC-DMIS Settings Editor application lets you change registry entries that control various PC-DMIS settings.

To launch the PC-DMIS Settings Editor, make sure you have closed PC-DMIS, then access the Settings Editor shortcut from the program group where you installed PC-DMIS. To access the help file associated with the PC-DMIS Settings Editor, either launch the Settings Editor and press F1 or select the " PC-DMIS Settings Editor " help file from this help file's Contents tab.


DoesNotExist

Documentation Project Does Not Exist

The documentation project you selected does not exist in this documentation set, is included in a separate piece of software, or is not yet completed.

  • PC-DMIS DataPage/RT - Documentation exists within the PC-DMIS DataPage/RT Software.

  • PC-DMIS Web Reporter - Documentation does not exist because Web Reporter is not yet completed.


Download Updated Help Files

Clicking this link takes you to the ftp directory where updated help files for this version of PC-DMIS are stored. Compare the files in the ftp directory against the help files already installed (files with a .chm filename extension). If the files on the ftp site are more recent, copy the files you need into the directory where you installed PC-DMIS. Before copying them into your installation directory, be sure to close down PC-DMIS. When you restart PC-DMIS, it will automatically use the updated help files.

Your computer must have an active internet connection.

To Properly Copy a Help File

When you click on the FTP link, your computer will open up the FTP site inside your Internet Explorer browser:

  1. Once the site loads in your browser, from the toolbar, point to the Page menu, and select Open FTP Site in Windows Explorer. A Windows Explorer window will appear displaying the FTP site.

  2. Right click on the .chm you want to download and select Copy to Folder... from the shortcut menu. A Browse For Folder dialog box appears.

  3. Navigate to the folder where you want to copy the help file.

  4. Click OK. The file will be copied from the FTP server to your computer.

If you do not follow the above instructions, the .chm file will still download, but the individual topic pages will likely not display their contents.


Mirror Machine Position Example

Original - No Mirror | Y Mirrored - Mirror Machine Position in Y | Y Mirrored - Mirror Machine Position in X | Y Mirrored - Mirror Machine Position in Z


Axis Selection

The Axis Selection list allows you to determine the coordinate system axis used for the model you are importing.


Cad Import icon


DMIS Extension Margin Note

Extensions may include non-standard commands or added / modified parameters of standard DMIS commands.


Dmis Margin Note

DMIS data is posted into the part program in PC-DMIS format, eliminating the need for a separate file.


Importing a CATIA5 File

  1. Display Menu Roadmap Select the File | Import | CATIA5... menu option. The File Open dialog box appears.

  2. Browse through your hard drive, and select a CATIA 5 file.

  3. Click the Import button. The CATIA 5 Import dialog box appears.

Catia Import dialog box
Catia 5 Import dialog box

  4. In the Processing Options area, select the entity types that you want to import. Click the Process All Entities check box to process all of the available entities. Select the OK button to import the model file into PC-DMIS. The imported model is ready to be used with PC-DMIS.


Importing STEP, VDAFS, and DXF/DWG Files

Display Menu Roadmap

1. Select the File | Import menu option and then select STEP, VDAFS, DXF, or DWG. An Open dialog box appears.

2. Select the data type you want to import from the Files of Type list.

3. Navigate to the directory containing the file to import.

4. Click Import when ready to import the file. PC-DMIS will display the STEP Import dialog box.

STEP Import dialog box

Note: The import dialog boxes for the file types discussed in this topic are essentially the same as the STEP Import dialog box.

More:

Process Independent Entities

Reverse U-V Patch Order for Spline Surfaces


Model Section

If your CATIA files have more than one model, the Model Selection list allows you to specify the model to import.


Processing Options

The Processing Options area allows you to filter the imported entities. Use the lists in this area to control which entities from the model will be imported. There are three filters: the entity type, the entity color, and the entity layer. You can combine these filters together and successively limit the entities you will import.

Example: Suppose you have a file composed of numerous entity types and colors on various layers. Out of all the entities to import, you can select a specific type, such a curve. From the resulting list of curves, you can then filter by a specific entity color, such as blue. From the new list of blue curves you can then filter by entity layer, such as 15. This will import any blue curves, residing on layer 15.

Process All Entities

Select this check box to import all entity types. To filter which entity types are imported, deselect this check box, and select the entity types from the list that you want to import. You can select multiple items by holding down the CTRL key while selecting the items.

Process All Colors

Select this check box to import entities with any assigned color. To filter which colors are imported, deselect this check box, and select the colors from the list that you want to import.

Process All Layers

Select this check box to import all layers in the model. To filter which layers are imported, deselect this check box, and select the layers from the list that you want to import.

Process Hidden Entities

Select this check box to import hidden entities. To not import hidden entities, deselect this check box.


Processing Options

The Processing Options area allows you to select which types of entities to import.

Process Solid Surfaces

Select this check box to import solid surface entities.

Process All Datums

Select this check box to import all datum entities. To filter which specific datums are imported, deselect this check box, and select the datum entity types from the list that you want to import.


Trim Preference

The Trim Preference area determines how trimmed surfaces should be represented inside PC-DMIS.

Select the UV Trim option to trim the surfaces in the parameter-space of the surfaces.

Select the XYZ Trim option to trim the surfaces in model-space.

In theory, the resulting translated model should be the same regardless of the selected trim option. However, if you’re importing poorly defined models, the option selected often makes a difference in the results. In general, selecting UV Trim will produce the best results.


XYZ Margin Note

XYZIJK Files have a .xyz extension. You can view the values contained in a .xyz file by using any standard text editor.


Feature Tooltips Example

When you finish viewing this demo, click outside this popup window.

click to play ../displaying_feature_tooltips.avi


Accessing the Probe Readouts Window

Probe Readout icon

To access the Probe Readouts window from the Probe Toolbox, click the Probe Readout icon. For information on the Probe Readouts window, see the "Using the Probe Readout window".


Changing the Current Probe

To change the part program's current probe by using the Probe Toolbox,

  1. Select the Probes list.

  2. Select a new probe.

PC-DMIS inserts a LOADPROBE command for the selected probe into the part program.


Changing the Current Probe Tip

To change the part program's current probe by using the Probe Toolbox,

  1. Select the Probe Tips list.

  2. Select a new probe.

PC-DMIS inserts the LOADPROBE command for the selected probe into the part program.


Locking Axes

To prevent probe movement in one or more axes, select the appropriate axis locking icons from the Probe Toolbox.

For example, if you want to lock the probe's Z axis from moving, select the Lock Z Axis icon. You can then click anywhere on the CAD and the probe will be able to move freely in the XY plane, but motion in the Z direction won't take place.

Note that on a Vision DCC machine, moving the graphical probe also moves the FOV (Field of View).

Note: These items are grayed out and unavailable for selection unless you have the Vision or Laser module programmed in your hardware key (portlock). See the PC-DMIS Laser or PC-DMIS Vision help files for more information on using the Probe Toolbox.


Placing the Probe into Readouts and Hits Mode

Some interfaces require that you toggle between Readouts and Hits Modes since these modes must operate exclusively from each other. This is due to the operation of these interfaces being in either a receiving state (Hits Mode - waiting for a hit signal) or a sending state (Readouts Mode - sending probe location data to the Probe Readout window. An LK-RS232 interface is an example of this type of interface.

Icon |  | Description
 | Readouts Mode | If you have an LK interface, you can use the Readouts Mode icon to places the probe into readouts mode.
 | Hits Mode | If you have an LK interface, you can use the Hits Mode icon to places the probe into hits mode.


Taking and Deleting Hits

Take a Hit icon

To take a hit at the current probe's location, click the Take a Hit icon. PC-DMIS adds the hit into the hit buffer. This icon only becomes enabled when you use a defined hard probe.

Remove a Hit icon

To delete a hit from the hit buffer by using the Probe Toolbox, click the Remove a Hit icon. If you have the Probe Readouts window open, you'll notice the hit being deleted from the Hits portion of the window. See the "Erasing or Deleting Hits" topic in the "Getting Started: A Simple Tutorial" section for additional information.


Viewing Hits in the Hits Buffer

Viewing the Last Hit

In the Probe Position tab, PC-DMIS displays the most recent hit stored in the hits buffer or the probe's current position. If you use a Vision or Laser module these items become editable.

Most Recent Hit Information

Viewing all the Hits

To view all the hits in the hits buffer, click the Hit Targets tab. PC-DMIS displays the XYZ and IJK data for each hit in the buffer.

Probe Toolbox - Hit Targets tab

Hit Targets tab showing several hits in the hits buffer

Once you press END on your keyboard or DONE on your jog box and accept the current feature you are probing, PC-DMIS removes the hits from the buffer and empties this list.


Working with Contact Auto Move Properties

Contact Auto Move Properties tab

This tab becomes visible when you have the Auto Feature dialog box open and a contact probe is enabled.

The Contact Auto Move Properties tab contains items that allow you to change Auto Move properties for Auto Features that use contact probes.

Auto Moves are special moves added to your feature's path lines to help PC-DMIS avoid driving the probe through your feature when it actually measures it.

This tab contains the following items:

Item

Description

Avoidance Move

This list lets you choose the type of Avoidance Move for your current Auto Feature.

This list contains these items:

NO - There will be no Avoidance Moves used for the current feature.

BEFORE - Before PC-DMIS measures the first hit on the current feature, it will first move to the specified distance above the first hit. View Demo

AFTER - After PC-DMIS measures the last hit on the current feature, it will move to the specified distance above the last hit. View Demo

BOTH - Applies the Avoidance Move distance to the path lines both before and after PC-DMIS measures the feature.

Distance

This specifies the distance above the first probing or last probing to which the probe will move during execution.


Working with Contact Find Hole Properties

  • If the hole is found: PC-DMIS will move to the down to the ”check distance” depth and proceed to take three hits equally spaced around the hole to determine the general location of the hole. Following this general adjustment PC-DMIS will then measure the hole using the parameters defined by the user in the tab for the feature. This includes Sample hits etc. This is the same as the CENTER item describe above.

  • If the hole is not found: PC-DMIS will back away from the surface and start a circular search pattern that is (feature radius – probe radius) out from the theoretical feature center. The search will try (2 * PI * feature radius/(feature radius – probe radius)) locations around the search circle. If the hole is still not found the search radius will be increased by (feature radius – probe radius) and will continue until the search radius is equal to the prehit distance. If the prehit is smaller than (feature radius – probe radius) only one search pattern will be completed.

  • If the hole is never found: PC-DMIS will move the probe to a position of a prehit above the theoretical center of the feature and prompt the user to do a ”Read Position”. (See "Read Pos / Read Position button".)

  • Adjustments along the surface normal: As PC-DMIS searches and finds a surface instead of the hole it will continually update the search height based on the found surfaces. Once the hole is found, it will update the depth of measurement of the hole based on the last surface found. If the hole is found the first time, no adjustments are made.

  • Adjustments with RMEAS: If you supply an RMEAS feature (or features) PC-DMIS assumes you desire to use the feature(s) as the reference for both the search height and the depth of the hole measurement. Therefore, there will be no adjustment along the surface normal other than the RMEAS adjustment.

  • If the hole is found: PC-DMIS will move down to the ”check distance” depth and measure one hit on each of four the sides of the slot. It will adjust for the center of the four hits and measure two hits on one of the long sides to adjust for the slot rotation. After a general location and orientation of the slot is calculated, the Slot will be measured using the parameters defined in the tab for the feature.

  • If the hole is not found: PC-DMIS will back away from the surface and start a circular search pattern that is (feature radius – probe radius) out from the theoretical feature center. The search will try (2 * PI * feature radius/(feature radius – probe radius)) locations around the search circle. If the hole is still not found the search radius will be increased by (feature radius – probe radius) and will continue until the search radius is equal to the prehit distance. If the prehit is smaller than (feature radius – probe radius) only one search pattern will be completed.

  • If the hole is never found: PC-DMIS will move the probe to a position of a prehit above the theoretical center of the feature and prompt the user to do a ”Read Position”. (See "Read Pos / Read Position button".)

  • Adjustments along the surface normal: As PC-DMIS searches and finds a surface instead of the hole it will continually update the search height based on the found surfaces. Once the hole is found, it will update the depth of measurement of the hole based on the last surface found. If the hole is found the first time, no adjustments are made.

  • Adjustments with RMEAS: If you supply an RMEAS feature (or features) PC-DMIS assumes you desire to use the feature(s) as the reference for both the search height and the depth of the hole measurement. Therefore, there will be no adjustment along the surface normal other than the RMEAS adjustment.

  • If the hole is found: PC-DMIS will move down to the ”check distance” depth to measure the hole's depth, and then to measure the hole.

  • If the hole is not found: PC-DMIS will back away from the surface and start a search pattern. The pattern is circular and is adjusted out one half the width from the theoretical feature center (which for notches, is the center of the inside edge.). The search will try eight locations around that location. If the hole is found, the probe will move to the depth to measure the hole's depth, and then to measure the hole.

  • If the hole is never found: PC-DMIS will move the probe to a position of a prehit above the theoretical center of the feature and prompt the user to do a ”Read Position”. (See "Read Pos / Read Position button".)

If you respond by clicking the Yes button, PC-DMIS will require you to place the probe in a cylindrical zone above the circle.

Placing the Probe in the Cylindrical Zone: You only need to place the probe in the center of the imaginary 3D cylinder of the hole. The depth and orientation of the measurement will then be automatically determined by one of the following:

  • RMEAS feature: If you provide an RMEAS feature, PC-DMIS assumes you want to measure the hole with respect to that feature (or features). Therefore, the feature(s) will be used to define the surface normal and depth of measurement, while the Read Pos will be used to determine the other two axes of translation.

  • Find Hole: If Find Hole is used and the surface around the hole is touched at least one time, then PC-DMIS will adjust all three axes. Two of the axes are based on the location of the probe once it has found the hole and the third axis, along the surface normal, is based on the last surface touched. Find Hole will not override an RMEAS feature.

  • Sample Hits: If sample hits are used they are always the top priority on determining both the orientation and depth of measurement of the hole.

  • None of the above: If none of the above options are used, PC-DMIS will probe the hole based on the provided target and depth values, adjusted by the probe placement within the cylindrical zone.

Working with Contact Find Hole Properties

Contact Find Hole Properties Tab

This tab becomes visible when you have the Auto Feature dialog box open and a contact probe is enabled. The items become available for selection if PC-DMIS is in DCC mode.

The Contact Find Hole Properties tab contains items that allow you to change Find Hole properties for Auto Features that use contact probes.

General Find Hole Process

Once you select a routine from the Find Hole list (NOCENTER, SINGLE HIT, or CENTER) and execute your part program, PC-DMIS positions the probe a Prehit Distance above the theoretical center of the feature, then drives normal to the feature surface vector searching for the hole at touch speed. The search will continue until either the surface is touched (indicating that the hole is not there) or until the check distance is reached (indicating that the hole is present). See "Check Distance" in the "Setting Your Preferences" section.

If Find Hole fails, PC-DMIS displays the Read Position dialog box. This gives you the choice to either read a new position from which to continue searching for the hole (click Yes), or to skip this feature and move on to the next feature (click No).

  • If you choose Yes, you can then use your jog box to move the probe to the new location.

  • If you choose No, PC-DMIS moves the probe away from the hole by the distance specified for an Avoidance Move (see "Working with Contact Auto Move Properties") and continues running the part program. This movement helps to prevent a possible probe collision.

Additionally, you can set PC-DMIS to automatically continue executing the part program when the hole can't be found. See "Auto Continue Execution if FindHole Fails" in the "Setting Your Preferences" section.

Tab Items

Depending on the type of feature in the Auto Feature dialog box, this tab may change to contain one or more of the following items:

Item

Supported Auto Features

Description

Find Hole

  • Circle

  • Round Slot

  • Square Slot

  • Notch Slot

  • Polygon

  • Cylinder

This list contains these list options. They determine how PC-DMIS proceeds when attempting to find a hole.

DISABLED - No Find Hole operation is performed.

NOCENTER - This item acts as the CENTER item except the probe doesn't take the three hits to find the rough estimate of the hole's center. It merely begins measuring the circle using existing parameters set in the specific auto feature dialog box.

SINGLE HIT - This setting tells the probe to take one single hit. If it hits the surface and doesn't find the hole, then it automatically switches to the "If the hole is not found" case described below. If the probe finds the hole proceeds using the NOCENTER option.

CENTER - This item first causes the probe to move down to the ”check distance” depth to make sure it doesn't encounter any material. It then moves to either the feature's depth or to the Check Distance * Percent to search inside the hole for a rough estimate of the hole's center (see "Registry Items" below). The probe does this by taking three hits equally spaced around the hole. Once the probe has the hole's general location, it then proceeds to measure the hole using the parameters set in the specific auto feature dialog box. Unless NOCENTER or SINGLE HIT is selected, this is the default procedure that PC-DMIS follows if the hole is found.

Note: A Find Hole registry entry gives you greater control over the depth of the centering process. By default, the centering process’s Z component is determined by the feature’s depth. This is often used in conjunction with an Rmeas (plane) feature. However, sometimes when you don't use an Rmeas feature, and the surface of the part varies greatly in Z, the centering process will never find the hole because the part’s surface lies below the search depth. In this case, you can instead have the Find Hole centering process execute at the Check Distance * Percent, by setting the FHCenteringAtChkDistTimesPercentInsteadOfDepth registry entry to TRUE in the PC-DMIS Settings Editor. This entry is located in the USER_AutoFeatures section. See "Parameter Settings: Motion tab" to set the Check Distance and Percent values.

Find Hole Specifics for a Circle or a Cylinder

Find Hole Specifics for a Square Slot or Round Slot

Find Hole Specifics for a Notch Slot

Supported Interfaces

All the DCC interfaces support the Find Hole functionality. If you experience a problem with a specific interface, please contact technical support and we will investigate the issue.

On Hit Error

  • Edge Point

  • Angle Point

  • Corner Point

  • Circle

  • Ellipse

  • Round Slot

  • Square Slot

  • Notch Slot

  • Polygon

  • Cylinder

  • Cone

The On Hit Error check box allows improved error checking when PC-DMIS detects an unexpected or missed hit.

If you select this check box, PC-DMIS will:

  • Automatically take a Read Position (see "Read Position" below) whenever an unexpected probe hit or missed probe hit takes place during the measurement cycle.

  • Measure the entire feature with the new location obtained from the Read Position.

The Edit window command line for this option would read:

ONERROR = TOG

TOG: This toggle field switches between YES (on) and NO (off).

For additional information on what options you have when PC-DMIS detects unexpected or missed hits, see "Branching On a CMM Error" in the "Branching by Using Flow Control" section.

Note: By default, when PC-DMIS performs a read position operation (such as used in Read Pos, Find Hole, or On Error) it only returns the X and Y values. However two registry entries give you further control over returning the Z axis value as well. These are: ReadPosUpdatesXYZ and ReadPosUpdatesXYZEvenIfRMeas.
If these registry entries are set to FALSE, the location found by the read position is snapped to the feature's normal vector and stored as the target. However, since Edge Point, Angle Point, and Corner Point features do not have a normal vector, but are instead defined by a combination of vectors, for these feature types PC-DMIS will not snap the read position location to a feature vector as it did in versions prior to v43. Instead, PC-DMIS ignores the above registry entries and assigns the target (TARG field) the XYZ of the read position.

Supported Interfaces

All the DCC interfaces support the On Error functionality. If you experience a problem with a specific interface, please contact technical support and we will investigate the issue.

Read Position

  • Circle

  • Ellipse

  • Round Slot

  • Square Slot

  • Notch Slot

  • Polygon

  • Cylinder

  • Cone

Selecting this check box causes PC-DMIS to pause execution above the surface feature and to display a message asking if you want to use the current data.

  • If you respond by clicking the No button, PC-DMIS will require you to move the probe to the desired location before the measurement process can continue.

  • If you respond by clicking the Yes button, PC-DMIS will measure the feature and will use the current probe data.

Read Position Specifics for a Circle

Note: By default, when PC-DMIS performs a read position operation (such as used with the Read Position check box, Find Hole list or the On Hit Error check box), it only returns the X and Y values. However, two registry entries give you further control over returning the Z axis value as well. These are: ReadPosUpdatesXYZ and ReadPosUpdatesXYZEvenIfRMeas.


Working with Contact Path Properties

Circle or Ellipse

If the start and end angles are the same, or differ by a multiple of 360°, then only one hit will be taken at the mutual starting and ending point.

Location of Hits

A - Starting Angle

Round Slot

If an odd number of hits is entered, PC-DMIS will automatically add one to the value. This allows for an even number of hits in the measurement of the slot. Half of the hits will be taken on the semi-circle at each end of the slot. A minimum of six hits is required.

Plane

The minimum number of hits needed to measure a plane is three. However, the total number of hits for the plane feature is generated by the product of the values in the Hits and Levels boxes. Therefore, a value of 2 in the Hits box with a 3 in the Levels box would generate a total of six hits.

Line

You can type any number of hits. Depending on the type of line and the value entered, PC-DMIS does the following:

If you are creating a bounded line, then PC-DMIS uses the calculated length of the line and spaces the number of hits equally along the line so that the first and last hits are at the Start and End points.

If it is an unbounded line, then PC-DMIS uses the typed length value and spaces the number of hits equally along the line's direction vector.

Note: If you don't type a length value (or the value is zero), PC-DMIS uses the current probe tip's diameter as the distance between points.

Edge Point, Notch Slot

If one, two, or three sample hits are indicated, then the depth value will be applied from the measured surface value.

Depth for Edge Point

A - Target hit

B - Sample hit

C - Depth

Circle, Ellipse, Round Slot, Square Slot, Polygon

This distance is applied as a positive value along the centerline vector from the center point of the feature.

For an internal feature, such as a hole, this is the distance below the surface. For an external feature, such as a stud, this is the distance from the bottom of the feature.

Note: PC-DMIS expects the X, Y, Z nominal of the stud to be at the base. If the center point is at the top of the stud, set the depth to a negative value.

Line

The distance is applied as a positive value along the perpendicular vector to the line vector and edge vector.

The line's depth depends on the direction of the hits in relation to the current coordinate system. For example, if you have a typical orientation (X/Right, Y/Back, and Z/Up), and you take your first and second hits from left to right on the model, then you need to use a positive depth value. However, if you take your first and second hits from right to left on the model, then you need to use a negative depth value.

Circle

In order to follow a standard (clockwise) thread pattern, you need to reverse the starting and ending angles (i.e. 720 - 0) and in order to cause the measurement to reverse from a rising pitch to a falling pitch (up/down), you need to negate the value of the pitch.

Example: If measuring a circle with four hits equally spaced around the circle, the first hit will be at the starting angle at the input depth. The second hit will be at a 90 degree rotation to the first and a depth of (depth – ((hitnum-1)/tothits * pitch)). The third hit would be 180 degree rotation from the first hit with a depth of (depth – ((hitnum-1)/tothits * pitch)). The remaining hits follow this same pattern.

Cylinder

Example: If measuring a cylinder with two levels of four hits equally spaced around the cylinder, the first hit in each level will be at the starting angle at the input depth. The second hit will be at a 90 degree rotation to the first hit and a depth of (Depth - (hitnum-1)/# hits per level * pitch). The third hit would be 180 degree rotation from the first hit with a depth of (Depth - (hitnum-1)/# hits per level * pitch). The remaining hits follow this same pattern.

For a cylinder or cone, the levels will be equally spaced between the Starting Depth and Ending Depth of the feature.

For a sphere, the levels will be equally spaced between the Start Angle 2 and End Angle 2 value in the Auto Feature dialog box.

For a plane, the number of levels and the number of hits are used to determine how many total hits will be used to generate the auto plane.

Working with Contact Path Properties

Contact Path Properties tab

This tab becomes visible when you have the Auto Feature dialog box open and a contact probe is enabled.

The Contact Path Properties tab contains several items that allow you to change various hit properties for a number of supported Auto Features that use contact probes.

Depending on the type of feature in the Auto Feature dialog box, this tab may change to contain one or more of the following items:

Item

Supported Auto Features

Description

Hits

Line, Plane, Circle, Ellipse, Round Slot

This defines the number of hits that will be used to measure the feature. The number of hits specified will be equally spaced between the starting and ending angle indicated.

Hits (Total)

Sphere

This is the same as described in Hits except that this defines the total number of hits that will be used to measure the feature among all available levels. You need at least four hits to measure a sphere.

Depth

Edge Point, Line, Circle, Ellipse, Round Slot, Square Slot, Notch Slot, Polygon

This defines where PC-DMIS will take hits on the feature itself and its surrounding sample hits.

Starting Depth

Cylinder, Cone

For features with multiple levels, this defines the starting depth of the first level of hits. It is an offset from the top of the feature. All other levels will be equally spaced between the Starting Depth and Ending Depth. View Demo

Ending Depth

Cylinder, Cone

For features with multiple levels, this defines the ending depth of the last level of hits. It is an offset from the bottom of the feature. All other levels will be equally spaced between the Starting Depth and Ending Depth.

Pitch

Circle, Cylinder

For threaded holes and studs, the Pitch value (also known as "threads per inch") defines the distance between threads along the axis of the feature. This allows for more accurate measurements of threaded holes and studs. If the value is anything other than zero, PC-DMIS staggers the feature's hits along the feature's theoretical axis, spacing them around the feature using the Start Angle and End Angle values in the Auto Feature dialog box.

Hits Per Level

Cylinder, Cone

This defines the number of hits per level that will be used to measure the feature. A value of four would mean four hits per level.

Note: At least six hits and two levels are necessary to measure a cylinder or cone (three hits at each level).

Levels

Cylinder, Cone, Sphere

This defines the number of levels that will be used to measure the feature. Any integer greater than one can be used. The first level of hits will be placed at the Starting Depth. The last level of hits will be placed at the Ending Depth.

Hits Per Side

Polygon

This defines the number of hits taken per side on a Polygon feature.


Working with Contact Sample Hits Properties

Auto Feature

Sample Hits Description

Surface Point

PC-DMIS will measure the point depending on the selected value. For example, if you select:

  • 0, PC-DMIS will measure the point at the nominal approach vector specified.

  • 3, PC-DMIS will measure a plane around the nominal point location and use the surface normal vector from the three hits measured to approach the nominal point location.

Edge Point

PC-DMIS will measure the point depending on the selected value. For example, if you select:

  • 0, then PC-DMIS will measure the point at the nominal approach and normal vectors specified.

  • 1, then PC-DMIS will measure a point on the normal surface. The edge measurement will then be projected into the nominal surface through this point. Any DEPTH = values will be offset from the point.

  • 2, then PC-DMIS will take two sample hits on the edge along the nominal approach direction specified. PC-DMIS will then use these hits to calculate a new approach vector for the actual point measurement along the edge.

  • 3, then PC-DMIS will measure the point with the combined methods of using one and two sample hits respectively. This measurement method is commonly known as a "Flush and Gap" measurement point.

  • 4, then PC-DMIS will measure the three sample hits on the normal surface and adjust the surface normal vector. The edge measurement will then be projected into this new nominal surface. Any DEPTH = values will be offset from the point. Finally, the point will be measured along the approach vector.

  • 5, then PC-DMIS will measure the point by taking three hits on the normal surface and two hits on the edge along the nominal approach direction specified. This method of measurement is considered the most accurate.

Various Sample Hits for Edge Points

A - Target hit

B - Sample hits

C - Indent

D - Spacer

E - Indent + Spacer

Angle Point

The sample hits will be used on each surface. PC-DMIS will measure the point depending on the selected value. For example, if you select:

  • 2, the hits will be taken in a line perpendicular to the edge vector.

  • 3, the hits will form a plane on each surface as indicated in the drawing.

Two and three Sample Hits for an Angle Point

Circle, Cylinder, or Cone

The defined sample hits will be used to measure the surface normal to the feature. The number of hits specified will be equally spaced between the starting and ending angle indicated.

PC-DMIS will measure the point depending on the selected value:

  • If Type = HOLE, and you select 0, PC-DMIS will not take any sample hits.

  • If Type = STUD, you select 0, PC-DMIS will not take any sample hits. PC-DMIS then treats the Height value as if the feature were a HOLE instead of a STUD.

  • If Type = HOLE, and you select 1, PC-DMIS will take the hit on the outside of the feature.

  • If TYPE = STUD, and you select 1, PC-DMIS will measure the point on the top of the stud.

  • If you select 3, PC-DMIS will measure the surface at three equally spaced hits starting from the starting angle. The sample hits will be relative to the measured plane, and any values will be offset from these points.

A - Start Angle and End Angle

A - Start Angle

B - End Angle

Note: PC-DMIS expects the X, Y, Z nominal of the stud to be at the base. If the center point is at the top of the stud, set the depth and spacer to a negative value.

Sphere

For a sphere, you can only select one sample hit. When you select this sample hit, PC-DMIS follows this procedure once you execute the part program:

  1. Automatic measurement stops prior to measuring the sphere.

  2. PC-DMIS requests that you take one hit normal to the direction the sphere should be measured.

  3. After you take the sample hit, click the Continue button

  4. PC-DMIS then takes three more hits on the sphere in an area determined by the spacer.

PC-DMIS takes these four hits and uses the calculated sphere location to measure the sphere with the given number of hits, rows, and angles.

Square Slot or Round Slot

The measured plane will be used as the centerline vector for projection and measurement depth purposes.

PC-DMIS will measure the slot depending on the entered value. For example, if you select:

  • 0, PC-DMIS will measure the indicated slot. No sample hits will be taken.

  • 1, PC-DMIS will measure the surface at the center of the slot. The slot hit will be to the right of the vector.

  • 3, PC-DMIS will measure the surface at three equally spaced hits starting from SLOT A. The slot hits will be relative to the measured plane, and any values will be offset from these points.

Sample Hits of three hits on a Square Slot (on left) and Round Slot (on right)

Note: To take the hits on the opposite side of the slot, reverse the centerline vector.

Ellipse

The only values that will be accepted are zero, one, and three. The measured plane will be used as the centerline vector for projection and measurement depth purposes.

PC-DMIS will measure the ellipse depending on the entered value. For example, if you selected:

  • 0, PC-DMIS will measure the indicated ellipse. No sample hits will be taken.

  • 1, PC-DMIS will take a single sample hit at the location where the ANGLE VEC points to (i.e. 0° + SPACER), not at the center of the ellipse (being particularly difficult should the ellipse be a hole).

  • 3, PC-DMIS will measure the surface at points outside (or inside) the ellipse an indicated distance from the outer edge (Spacer value). The first hit will be at the indicated start angle. Hit number two will be halfway between the start angle and end angle. The last hit will be at the end angle. The hits will be relative to the measured plane, and any values will be offset from these points.

Note: To take the hit on the opposite side of the ellipse, reverse the centerline vector.

Notch Slot

The sample hits also define the edge for the angle vector and width. The only values that will be accepted are zero through five. The measured plane will be used as the centerline vector for projection and measurement depth purposes.

PC-DMIS will measure the notch depending on the entered value. For example, if you selected:

  • 0, PC-DMIS will measure the indicated notch. No sample hits will be taken.

  • 1, PC-DMIS will measure the surface at the edge of the notch.

  • 2, PC-DMIS will measure the edge along the open side of the notch. This will define the angle vector and will be used to find the width of the notch.

  • 3, PC-DMIS will measure the surface at one end of the notch with two hits and one hit at the other end of the notch. The notch hits will be relative to the measured plane, any values will be offset from these points.

  • 4, PC-DMIS will measure the surface the same as three sample hits. A fourth hit will be taken on the edge along the open side to be used in finding the width of the notch.

  • 5, PC-DMIS will measure the surface the same as three sample hits. It will also measure the edge along the open side in the same manner as two sample hits.

Polygon

PC-DMIS will measure the polygon depending on the selected value. For example, if you select:

  • 0, PC-DMIS will measure the indicated polygon. No sample hits will be taken.

  • 1, PC-DMIS will take a single sample hit at the location to which the Angle vector points (i.e. 0° + SPACER).

Example Polygon Feature (hexagon) with one sample hit

  • 3, PC-DMIS will take the three sample hits in a triangular position on the surface around the polygon, if an internal polygon or on the surface of the polygon itself, if an external polygon. The first hit will always be at the location to which the Angle vector points.

Example Polygon Feature (hexagon) with three sample hits

Auto Feature

Spacer Description

Surface Point

The Spacer box defines the radius of the circle on which the nominal (A) and the sample points (B) lie.

Edge Point

The Spacer box defines the radius of an imaginary circle on which the nominal and the sample points lie.

A - Target Hit

B - Sample Hits

C - Spacer Distance

Angle Point

The Spacer box defines the offset distance between the points on each side of the bend.

A - Indent

B - Spacer

C - Indent + Spacer

Corner point

The Spacer box defines the distance from the radius of the first hit to the other hits.

A - Target Corner

B - Spacer

Circle, Cylinder, or Cone

The Spacer box defines the distance from the circumference of the circle to the sample hits.

Note: Clearance planes are not used when taking sample hits. When measuring studs, it is important to set the spacer value to a distance that will allow the probe to move around the stud.

A - Sample Hits

B - Spacer

Note: PC-DMIS expects the X, Y, Z nominal of the stud to be at the base. If the center point is at the top of the stud, set the depth and spacer to a negative value.

Square Slot, Round Slot, or Ellipse

The Spacer box defines the distance from the outer edge of the feature to the sample hit(s).

Spacer for a Square Slot or Notch (top)

A - Sample Hits

B - Spacer

Spacer for a Round Slot

Plane

The Spacer box defines the distance between the hits making up the plane.

Notch Slot

The Spacer box defines the distance from the edges of the notch where the sample hits will be taken.

Spacer (dotted lines) for a Notch Slot with two sample hits.

Polygon

The Spacer box defines the distance from the edges of the polygon where the sample hits will be taken.

Spacer (dotted lines) for a Polygon with three sample hits (larger dots).

Auto Feature

Indent Description

Edge Point

The Indent box displays the minimum offset distance from the point location to the first hit on each side of the bend (or edge).

Offset Distance from Edge

A - Target hit

B - Sample hits

C - Indent

Angle Point

PC-DMIS allows you to use two indent boxes, Indent 1 and Indent 2, in order to set the offset distances from the point location to the sample hits on each of the two surfaces of the bend in an angle point.

Indent in an Angle Point

A - Indent

B - Spacer

C - Indent + Spacer

  • The Indent 1 box allows you to set the offset distance from the point location to the sample hits on the first surface of the bend.

  • The Indent 2 box allows you to set the offset distance from the point location for the sample hits on the second surface of the bend.

Corner Point

PC-DMIS allows you to use three indent boxes, Indent 1 and Indent 2, and Indent 3 in order to set the offset distances from the point location to the sample hits on each of the three surfaces of the bend in a corner point.

  • The Indent 1 box allows you to set the offset distance from the point location to the sample hits on the first of the three planes.

  • The Indent 2 box allows you to set the offset distance from the point location to the sample hits on the second of the three planes.

  • The Indent 3 box allows you to set the offset distance from the point location to the sample hits on the third of the three planes.

Indent for a Corner Point. For one of the surfaces, 1 shows the indent point, 2 and 3 are the sample hits

A - Target Corner

B - Indent

Notch Slot

The Indent box defines where along the two parallel sides of the notch PC-DMIS will take the hits. It is the distance from the closed side of the notch, moving towards the open side.

Indent for a Notch Slot (dotted lines)

Working with Contact Sample Hits Properties

Contact Sample Hits Properties tab

This tab becomes visible when you have the Auto Feature dialog box open and a contact probe is enabled.

The Contact Sample Hits Properties tab contains items that allow you to change the sample hits properties for a number of supported Auto Features that use contact probes.

Depending on the type of feature in the Auto Feature dialog box, this tab may change to contain one or more of the following items:

Item

Supported Auto Features

Description

Sample Hits

Surface Point, Edge Point, Angle Point, Circle, Ellipse, Round Slot, Square Slot, Notch Slot, Polygon, Cylinder, Cone, Sphere

This list allows you to select the number of sample hits taken for the auto feature. These hits are used to measure the plane around the nominal point location, providing a sampling of the surrounding material. These are permanent sample hits.

For more information on sample hits, see "Sample Hits - Feature Specific Information" below.

Sample Hits Init

As Above

By default this list does not appear in the user interface because initial sample hits are used so infrequently. You can turn it back on using the PTPSupportsSampleHitsInit entry in the PC-DMIS Settings Editor.

It allows you to specify initial sample hits. The Initial sample hits are taken only on the initial measurement of the feature during execution of the part program.

Spacer

Surface Point, Edge Point, Angle Point, Corner Point, Plane, Circle, Ellipse, Round Slot, Square Slot, Notch Slot, Polygon, Cylinder, Cone

This box defines the distance from the nominal point location that PC-DMIS will use to measure a plane if sample hits are specified. For more information, see "Spacer - Feature Specific Information" below.

Indent

Edge Point, Notch Slot

For an Edge Point, this box defines the minimum offset distance from the point location to the first sample hit. For a Notch Slot it defines the distance from the closed side of the notch (opposite the open edge). See "Indent - Feature Specific Information" below.

Indent 1

Angle Point, Corner Point

This defines minimum offset distance from the feature's center location to the first of two or three sample hits. See "Indent - Feature Specific Information" below.

Indent 2

Angle Point, Corner Point

This defines minimum offset distance from the feature's center location to the second of two or three sample hits. See "Indent - Feature Specific Information" below.

Indent 3

Corner Point

This defines minimum offset distance from the feature's center location to the third of three sample hits. See "Indent - Feature Specific Information" below.

Sample Hits - Feature Specific Information

Spacer - Feature Specific Information

Indent - Feature Specific Information


Extended Sheet Metal Features Note

A red bullet in the column below indicates that this field only appears in the Edit window if you have enabled the Show Extended Sheet Metal Options check box found on the General tab of the SetUp Options dialog box (press F5 to access the dialog box). See "Show Extended Sheet Metal Options".


Scan_Links

Contact

Linear Open Advanced Scan

Patch Advanced Scan

Perimeter Advanced Scan

Freeform Advanced Scan

Circle Basic Scan

Cylinder Basic Scan

Axis Basic Scan

Center Basic Scan

Line Basic Scan

Fixed Distance Manual Scan

Fixed Time / Distance Manual Scan

Fixed Time Manual Scan

Body Axis Manual Scan

Multisection Manual Scan

Freeform Manual Scan

Laser

Linear Open Advanced Scan

Patch Advanced Scan

Perimeter Advanced Scan

Freeform Advanced Scan

Manual Laser Scan

Portable

Fixed Distance Manual Scan

Fixed Time / Distance Manual Scan

Fixed Time Manual Scan

Body Axis Manual Scan

Multisection Manual Scan

Freeform Manual Scan


Path

Display Menu Roadmap

The Operation | Graphics Display Window | Path Lines menu option provides a graphical representation of the probes path along the part. This option is a powerful tool for probe path editing and is very helpful in the off-line measurement procedure. To access this option:

  • Mark the features that will be used for the probe path editing in the Edit window of the applicable part program. (See "Marking Commands for Execution" in the "Editing a Part Program" section.)

  • Select the View | Path Lines option. PC-DMIS will display the path lines of the probe that were created during the learning portion of the part program. The "Showing and Animating Path Lines" topic from the "Editing the CAD Display" section has additional information on using path lines.


Object Sheet

The Form Editor's Edit | Layout | Objects menu item displays the Object Sheet dialog box.

Object Sheet dialog box

You can use this dialog box to set the tab order for objects and controls typically used on dialog boxes by simply changing the order an object appears in this dialog box.

When you press TAB in run mode, PC-DMIS will jump to the next object defined in this dialog box, giving it the focus. Only some objects are affected by the TAB key. Pressing TAB only works on those objects that have a number to the left of them in the Object Sheet dialog box.


predesigned templates

These are located in your Reporting sub directory. There are 4 report templates (.rtp) and 22 label templates (.lbl) that ship with PC-DMIS. See "Using Standard Reports".


Reporting Tutorials

This topic provides links to available reporting tutorials. If you are new to PC-DMIS's template-based reporting functionality (available in version 4.0 and above), you should go through these tutorials in order to better understand how reporting is currently handled.

The tutorials are displayed in the order that they appear in the overall documentation structure of the "Reporting Measurement Results" section of the help file. You may want to also go through that section from the beginning to understand how the documentation topics are structured contextually.

Tip: To get the most out of the screen captures and videos that are provided in many tutorial steps, you should hide the Navigation pane on the left and then maximize your help viewer.

  • Tutorial - Creating a Report Template

  • Tutorial - Creating Label Templates

  • Tutorial - Customizing a Report Template

  • Tutorial - Creating Forms

  • Tutorial - Creating a Custom Report

Additionally, here are some common reporting topics and procedures that you may find useful:

  • Viewing a Legacy Text Only Report

  • Modifying your Report's Header

  • Modifying Standard Templates

  • Changing the Report Window's Contents

Remember that the links provided in this topic may result in topics seeming out-of-context. You may want to view the surrounding topics to get a better understanding of the concepts discussed. See "Searching the Help by Browsing Contents and Topics" for information on using the help viewer's Locate button to do this.


Working with Existing HyperView Reports

PC-DMIS lets you execute existing HyperView reports inside of part programs. You can optionally execute a default HyperView report at the end of every part program or you can insert a custom HyperView report in the body of a part program.

Additionally, the HyperView report can interact with a part program by mapping global variables and property elements to PC-DMIS variables.

Important: HyperView reports are reports that were created in the HyperView report editor in PC-DMIS versions 3.0, 3.2, 3.25, 3.5, or 3.7. Due to the new template approach to reporting since version 4.0, HyperView reports can only be executed, they cannot be created or edited. To edit or create a HyperView report, you will need to use an older version of PC-DMIS that supports HyperView report creation.

More:

Embedding HyperView Reports in a Part Program